MODULE eA_hadron
  USE eA_hadron_global
  USE MC_VEGAS
  USE eA_hadron_ME
  USE plot_eA_hadron
  USE nuclearAZ
  USE nFFKretzer_interface
  IMPLICIT NONE
  INTEGER::nprint
  INTEGER::varnum,nunwei
  REAL(KIND(1d0))::EBMUP1,EBMUP2
  INTEGER::NPRUP=0,lwmax
  INTEGER,PARAMETER::maxprint=8
  SAVE
CONTAINS
  SUBROUTINE calc_eA_hadron
    IMPLICIT NONE
    CHARACTER(len=10),DIMENSION(20)::char
    INTEGER::i,i1,j1,k1,s1x
    INTEGER::nh,innum,outnum
    REAL(KIND(1d0))::w0,ptp,pqp,wme
    INTEGER::ioerror,icase=0
    REAL(KIND(1d0)),DIMENSION(3)::rslt
    INTEGER::itmxn,ncalln
    REAL(KIND(1d0)),DIMENSION(4)::pmomtemp
    LOGICAL::lexist
    SAVE icase
    WRITE(*,*)'                     THE BEGINNING OF HELAC-Onia'
    WRITE(*,*)'    AddOn Process: '
    WRITE(*,*)'    hadron yields in electron-nucleus collisions '
    WRITE(*,*)'======================================================================='
    WRITE(*,*)'======================================================================='
    WRITE(*,*)' '
    INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdf_data",EXIST=lexist)
    IF(lexist)THEN
       OPEN(UNIT=30333,FILE=TRIM(input_dir)//"paths/lhapdf_data")
       READ(30333,'(A)')LHAPath
       CLOSE(UNIT=30333)
    ELSE
       INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdfpath",EXIST=lexist)
       IF(lexist)THEN
          OPEN(UNIT=30333,FILE=TRIM(input_dir)//"paths/lhapdfpath")
          READ(30333,'(A)')LHAPath
          CLOSE(UNIT=30333)
          i=LEN_TRIM(LHAPath)
          LHAPath=LHAPath(1:i-13)
       ENDIF
    ENDIF
    WRITE(*,*)'Use LHAPDF ?',lexist
    IF(.NOT.lexist)THEN
       WRITE(*,*)"ERROR: You cannot run it without LHAPDF !"
       STOP
    ENDIF
    ! some necesarry initialization
    OPEN(UNIT=12115,FILE="./input/state.inp")
    READ(12115,*)hadron_istate
    CLOSE(UNIT=12115)
    IF(ABS(hadron_istate).GT.6)THEN
       WRITE(*,*)"ERROR:Unknown the state = ",hadron_istate
       WRITE(*,*)"INFO:Please set +-1(pi+-) or +-2(K+-) or +-3(K0,K0bar)"
       WRITE(*,*)"INFO: or 4(pi0) or 5(proton) or 6(neutron)"
       STOP
    ELSEIF(hadron_istate.EQ.1)THEN
       ! pi+
       PDG_hadron=211
       Mhadron=Mpipm
    ELSEIF(hadron_istate.EQ.-1)THEN
       ! pi-
       PDG_hadron=-211
       Mhadron=Mpipm
    ELSEIF(hadron_istate.EQ.2)THEN
       ! K+
       PDG_hadron=321
       Mhadron=MKpm
    ELSEIF(hadron_istate.EQ.-2)THEN
       ! K-
       PDG_hadron=-321
       Mhadron=MKpm
    ELSEIF(hadron_istate.EQ.3)THEN
       ! K0
       PDG_hadron=311
       Mhadron=MK0
    ELSEIF(hadron_istate.EQ.-3)THEN
       ! K0bar
       PDG_hadron=-311
       Mhadron=MK0
    ELSEIF(hadron_istate.EQ.4)THEN
       ! pi0
       PDG_hadron=111
       Mhadron=Mpi0
    ELSEIF(hadron_istate.EQ.5)THEN
       ! proton
       PDG_hadron=2212
       Mhadron=Mproton
    ELSEIF(hadron_istate.EQ.6)THEN
       ! neutron
       PDG_hadron=2112
       Mhadron=Mneutron
    ELSEIF(hadron_istate.EQ.0)THEN
       ! inclusive
       PDG_hadron=0
       Mhadron=Mn
    ELSE
       WRITE(*,*)"ERROR:unknown hadron state = ",hadron_istate
       WRITE(*,*)"INFO:Please set +-1(pi+-) or +-2(K+-) or +-3(K0,K0bar)"
       WRITE(*,*)"INFO: or 4(pi0) or 5(proton) or 6(neutron)"
       STOP
    ENDIF
    OPEN(UNIT=12115,FILE="./input/FFKretzer.inp")
    READ(12115,*)ifforder,iffset
    CLOSE(UNIT=12115)
    OPEN(UNIT=12115,FILE="./input/collision.inp")
    READ(12115,*)ele_energy,nuclearA,nf_eA_hadron
    CLOSE(UNIT=12115)
    IF(nf_eA_hadron.LE.0)THEN
       WRITE(*,*)"ERROR:number of light flavor cannot be <= 0"
       WRITE(*,*)"nf = ",nf_eA_hadron
       STOP
    ENDIF
    rnuclearA=DBLE(nuclearA)
    IF(ABS(nuclearA).GT.2)THEN
       CALL GetNuclearZ(nuclearA,nuclearZ)
       rnuclearZ=DBLE(nuclearZ)
       randbeam1=rnuclearZ/nuclearA
    ELSEIF(ABS(nuclearA).EQ.2)THEN
       ! deutron
       nuclearZ=1
       rnuclearZ=1d0
       randbeam1=0.5d0
    ELSE
       ! proton
       nuclearZ=1
       rnuclearZ=1d0
       randbeam1=1d0
    ENDIF
    IF(nPDF_id.EQ.0.AND.ABS(nuclearA).GT.2)THEN
       WRITE(*,*)"WARNING:you are using normal proton PDF for nuclear"
    ENDIF
    IF(nPDF_id.NE.0.AND.ABS(nuclearA).GT.2)THEN
       lnuclearPDF=.TRUE.
    ELSE
       lnuclearPDF=.FALSE.
    ENDIF
    S_en=2d0*ele_energy*Mn
    x_pdf_min=Mhadron/DSQRT(S_en)
    IF(x_pdf_min.GT.1d0)THEN
       WRITE(*,*)"ERROR: the energy of electron is too small !"
       WRITE(*,*)"INFO: the minimal energy of electron should be =",&
            Mhadron**2/2d0/Mn
       STOP
    ENDIF
    z_FF_min=MAX(min_z_ffkretzer,x_pdf_min)
    v_gamma_max=S_en/2d0/Mn
    ! requirement of Q^2 >> Mn^2
    ! 2*Mn*v*x > Mn**2
    v_gamma_min=Mn/2d0
    IF(v_gamma_max.LE.v_gamma_min)THEN
       WRITE(*,*)"ERROR: the energy of electron is too small # 2!"
       WRITE(*,*)"INFO: the minimal energy of electron should be =",&
            Mn/2d0
       STOP
    ENDIF
    OPEN(UNIT=12115,FILE="./input/LHAPDF.inp")
    READ(12115,*)lhapdf,nPDF_id
    CLOSE(UNIT=12115)
    ! incoming electron
    parton_pmom(1,4)=ele_energy
    parton_pmom(1,3)=ele_energy
    parton_pmom(1,1:2)=0d0
    OPEN(UNIT=12115,FILE="./input/jetquenching.inp")
    READ(12115,*)jetquenching_method,jetquenching_as,jetquenching_qhat,jetquenching_t0,&
         medium_length,wc_estimate,string_tension
    CLOSE(UNIT=12115)
    jetquenchingQ=jetquenching_method.NE.0.AND.(nuclearA.GT.2).AND.ABS(PDG_hadron).GT.0
    as_FF=jetquenching_as
    SELECT CASE(wc_estimate)
    CASE(1)
       wc_FF=0.5d0*jetquenching_qhat*medium_length**2
    CASE(2)
       CALL average_wc_QGP(jetquenching_t0,jetquenching_qhat,medium_length,1d0,&
            1d99,0.5d0,string_tension,wc_FF)
    END SELECT
    IF(nunit1.NE.6)THEN
       OPEN(UNIT=nunit1,FILE=TRIM(output_dir)//"RESULT_eA_hadron.out")
    ENDIF
    nunit2=32
    CLOSE(nunit2)
    OPEN(nunit2,FILE=TRIM(output_dir)//'kine_eA_hadron.out')
    nunit3=30
    CLOSE(nunit3)
    OPEN(nunit3,FILE=TRIM(tmp_dir)//'even_eA_hadron.out',FORM='unformatted')
    ! for LHA
    CLOSE(200)
    OPEN(200,FILE=TRIM(tmp_dir)//'sample_eA_hadron.init')
    itmxn=1
    ncalln=200000
    WRITE(*,*)' '
    CALL Helac_mtime()
    WRITE(*,*)' '
    CALL eA_hadron_VEGAS(rslt,itmxn,ncalln)
    WRITE(nunit1,*)"sigma(nb)                   sd"
    WRITE(nunit1,*)rslt(1),rslt(2)
    WRITE(*,*)' '
    CALL Helac_mtime()
    CLOSE(nunit2)
    CLOSE(nunit3)
    CLOSE(21)
    CLOSE(200)
  END SUBROUTINE calc_eA_hadron

  SUBROUTINE eA_hadron_VEGAS(rslt,itmxn,ncalln)
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(3),INTENT(OUT)::rslt
    INTEGER,INTENT(IN),OPTIONAL::itmxn,ncalln
    REAL(KIND(1d0))::vfes,sd,chi2a
    INTEGER::ncalm,nc,ii
    CHARACTER(len=4),DIMENSION(20)::chchar
    INTEGER::iday0,ihr0,imin0,isec0,i100th0,iday1,ihr1,imin1,isec1,i100th1,iyr0,iyr1,imon0,imon1
    INTEGER::IDBMUP1,IDBMUP2,IDWTUP
    lwmax=0
    NPRN=-1
    IF(PDG_hadron.EQ.0)THEN
       varnum=3
    ELSE
       IF(ABS(PDG_hadron).GT.0.AND.jetquenchingQ.AND.ABS(nuclearA).GT.2)THEN
          varnum=5
       ELSE
          varnum=4
       ENDIF
    ENDIF
    DO ii=1,varnum
       XL(ii)=0.0d0
       XU(ii)=1.0d0
    ENDDO
    IF(PRESENT(itmxn))THEN
       ITMX=itmxn
    ELSE
       ITMX=5
    ENDIF
    ITMX=1
    IF(PRESENT(ncalln))THEN
       ncalm=ncalln
    ELSE
       ncalm=5000
    ENDIF
    chchar(1)="40K"
    chchar(2)="80K"
    chchar(3)="160K"
    chchar(4)="320K"
    chchar(5)="640K"
    chchar(6)="1M"
    chchar(7)="2M"
    chchar(8)="4M"
    chchar(9)="8M"
    chchar(10)="16M"
    chchar(11)='32M'
    chchar(12)='64M'
    chchar(13)='120M'
    chchar(14)='240M'
    chchar(15)='480M'
    chchar(16)='960M'
    chchar(17)='2G'
    chchar(18)='4G'
    chchar(19)='8G'
    chchar(20)='16G'
    nprint=10000
    NCALL=20000
    CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
    CALL initplot_eA_hadron
    CALL VEGAS(varnum,eA_hadron_fxn,vfes,sd,chi2a)
    CALL plotout_eA_hadron
    WRITE(*,*)' '
    WRITE(*,*)"====================NCALL=20K==========================="
    WRITE(*,*)" "
    CALL Helac_mtime()
    WRITE(*,*)" "
    ii=1
    WRITE(*,*)"ITERATION ",ii,":"
    WRITE(*,*)vfes,"+\-",sd
    WRITE(*,*)"precision:",sd/vfes
    DO ii=2,10
       CALL initplot_eA_hadron
       CALL VEGAS(varnum,eA_hadron_fxn,vfes,sd,chi2a,1)
       CALL plotout_eA_hadron
       WRITE(*,*)"ITERATION ",ii,":"
       WRITE(*,*)vfes,"+\-",sd
       WRITE(*,*)"precision:",sd/vfes
    ENDDO
    CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
    iday1=iday1-iday0
    ihr1=ihr1-ihr0
    imin1=imin1-imin0
    isec1=isec1-isec0
    i100th1=i100th1-i100th0
    CALL Vegas_speed(10*NCALL,iday1,ihr1,imin1,isec1,i100th1)
    WRITE(*,*)' '
    WRITE(*,*)' '
    ii=1
    DO
       nc=2*NCALL
       IF(nc.GT.ncalm)EXIT
       NCALL=nc
       IF(NCALL/maxprint.GT.nprint)nprint=NCALL/maxprint
         CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
         WRITE(*,*)"====================NCALL="//chchar(ii)//"==========================="
         WRITE(*,*)" "
         CALL Helac_mtime()
         WRITE(*,*)" "
         CALL initplot_eA_hadron
         CALL VEGAS(varnum,eA_hadron_fxn,vfes,sd,chi2a,1)
         CALL plotout_eA_hadron
         WRITE(*,*)vfes,"+\-",sd
         WRITE(*,*)"precision:",sd/vfes
         CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
         iday1=iday1-iday0
         ihr1=ihr1-ihr0
         imin1=imin1-imin0
         isec1=isec1-isec0
         i100th1=i100th1-i100th0
         CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
         WRITE(*,*)" "
         ii=ii+1
      ENDDO
      rslt(1)=vfes
      rslt(2)=sd
      rslt(3)=chi2a
      RETURN
5100  FORMAT(1P,2I8,2E14.6,6I8)
5200  FORMAT(1P,3E20.10,I6)
    END SUBROUTINE eA_hadron_VEGAS

    FUNCTION eA_hadron_fxn(x,wgt)
      REAL(KIND(1d0)),DIMENSION(varnum),INTENT(IN)::x
      REAL(KIND(1d0)),INTENT(IN)::wgt
      REAL(KIND(1d0))::eA_hadron_fxn,wme,wsf
      REAL(KIND(1d0)),PARAMETER::pipi=3.1415926535897932385d0
      INTEGER::nnntot=0,nnn=0
      SAVE nnntot,nnn
      REAL(KIND(1d0))::wjac,w1,recmax,recmin
      SAVE recmax,recmin
      REAL(KIND(1d0))::new_x_PDF_min
      REAL(KIND(1d0))::Q2_gamma,costh_gamma,sinth_gamma,gamma_phi
      nnntot=nnntot+1
      wjac=1d0
      v_gamma=(v_gamma_max-v_gamma_min)*x(1)+v_gamma_min
      wjac=wjac*(v_gamma_max-v_gamma_min)
      new_x_PDF_min=MAX(x_PDF_min,Mn/v_gamma/2d0)
      x_PDF=(1d0-new_x_PDF_min)*x(2)+new_x_PDF_min
      wjac=wjac*(1d0-new_x_PDF_min)
      Q2_gamma=2d0*Mn*v_gamma*x_PDF
      IF(Q2_gamma.LT.min_Q2_ffkretzer.OR.Q2_gamma.GT.max_Q2_ffkretzer)THEN
         eA_hadron_fxn=0d0
         RETURN
      ENDIF
      scale=DSQRT(Q2_gamma)
      ! incoming quark
      parton_pmom(2,4)=Mn*x_PDF
      parton_pmom(2,1:3)=0d0
      ! virtual gamma
      gamma_pmom(4)=v_gamma
      costh_gamma=-Q2_gamma/2d0/ele_energy/DSQRT(Q2_gamma+v_gamma**2)
      IF(DABS(costh_gamma).GT.1d0)THEN
         eA_hadron_fxn=0d0
         RETURN
      ENDIF
      sinth_gamma=DSQRT(1d0-costh_gamma**2)
      gamma_pmom(3)=DSQRT(Q2_gamma+v_gamma**2)*costh_gamma
      gamma_phi=2d0*pipi*x(3)
      gamma_pmom(1)=DSQRT(Q2_gamma+v_gamma**2)*sinth_gamma*DCOS(gamma_phi)
      gamma_pmom(2)=DSQRT(Q2_gamma+v_gamma**2)*sinth_gamma*DSIN(gamma_phi)
      ! outgoing electron
      parton_pmom(3,1:4)=parton_pmom(1,1:4)-gamma_pmom(1:4)
      ! outgoing quark
      parton_pmom(4,1:4)=gamma_pmom(1:4)+parton_pmom(2,1:4)
      CALL sigma_gammaq(wme)
      IF(wme.EQ.0d0)THEN
         eA_hadron_fxn=0d0
         RETURN
      ENDIF
      IF(PDG_hadron.EQ.0)THEN
         z_FF=1d0
      ELSE
         z_FF=(1d0-z_FF_min)*x(4)+z_FF_min
         wjac=wjac*(1d0-z_FF_min)
      ENDIF
      ! hadron momentum
      hadron_pmom(1:3)=z_FF*parton_pmom(4,1:3)
      hadron_pmom(4)=DSQRT(hadron_pmom(1)**2+hadron_pmom(2)**2&
           +hadron_pmom(3)**2+Mhadron**2)
      IF(v_gamma.LT.hadron_pmom(4))THEN
         eA_hadron_fxn=0d0
         RETURN
      ENDIF
      IF(ABS(PDG_hadron).GT.0.AND.jetquenchingQ.AND.ABS(nuclearA).GT.2)THEN
        IF(wc_estimate.EQ.3)THEN
            CALL average_wc_QGP(jetquenching_t0,jetquenching_qhat,medium_length,1d0,&
                 v_gamma,0.5d0,string_tension,wc_FF)
         ENDIF
         eps_FF=MIN(v_gamma-hadron_pmom(4),wc_FF)*x(5)
         wjac=wjac*MIN(v_gamma-hadron_pmom(4),wc_FF)
      ELSE
         eps_FF=0d0
      ENDIF
      CALL strf_pdf_eA_hadron(wsf)
      IF(wsf.EQ.0d0)THEN
         eA_hadron_fxn=0d0
         RETURN
      ENDIF
      
      eA_hadron_fxn=wsf*wjac*wme*3.8937966d5 ! 3.8938573d5   
      w1=eA_hadron_fxn*wgt
      CALL outfun_eA_hadron(w1)
      nnn=nnn+1
      IF(recmax.LT.eA_hadron_fxn)recmax=eA_hadron_fxn
      IF(recmin.GT.eA_hadron_fxn)recmin=eA_hadron_fxn
      IF(MOD(nnn,nprint).EQ.0)THEN
         PRINT *,"max=",recmax
         PRINT *,"min=",recmin
         PRINT *, "      n_pass,     n_total"
         PRINT *,nnn,nnntot
      ENDIF
    END FUNCTION eA_hadron_fxn

    SUBROUTINE strf_pdf_eA_hadron(wsf)
      ! it will include the fragmentation function as well
      ! it will also taken into account the ef**2 (ef is the charge of quarks)
      IMPLICIT NONE
      INTEGER::ipp=1
      INTEGER::ih=1 ! ih=1 no photon PDF, ih=2, photon from proton/anti-proton, ih=3 phton from electron/positron
      REAL(KIND(1d0)),INTENT(OUT)::wsf
      INTEGER::init=0
      REAL(KIND(1d0)),DIMENSION(-7:7)::pdflist
      SAVE init,ipp
      INCLUDE "../lhapdf/call_strf_lhapdf"

      IF(init.EQ.0)init=1
    END SUBROUTINE strf_pdf_eA_hadron

    SUBROUTINE Helac_mtime()
      CHARACTER(len=13)::cd0, ct0, cz0
      INTEGER,DIMENSION(8)::iv0
      CALL DATE_AND_TIME(cd0,ct0,cz0,iv0)
      WRITE(*,*)'TIME:'
      WRITE(*,*)'YEAR',iv0(1),', MONTH',iv0(2),', DAY',iv0(3)
      WRITE(*,*)'HOUR',iv0(5),', MINUTE',iv0(6),', SECOND',iv0(7)
      WRITE(*,*)'MILLISECOND',iv0(8)
    END SUBROUTINE Helac_mtime

    SUBROUTINE DAYTIME(iy,im,id,ih,imin,isec,imilsec)
      INTEGER,INTENT(OUT)::iy,im,id,ih,imin,isec,imilsec
      INTEGER,DIMENSION(8)::timevalues
      ! GETDAY and GETTIM can only be used in ifort (not gfortran)
      CALL DATE_AND_TIME(VALUES=timevalues)
      iy=timevalues(1)
      im=timevalues(2)
      id=timevalues(3)
      ih=timevalues(5)
      imin=timevalues(6)
      isec=timevalues(7)
      imilsec=timevalues(8)
    END SUBROUTINE DAYTIME

    SUBROUTINE Vegas_speed(nmc,iday,ihr,imin,isec,i100th)
      INTEGER,INTENT(IN)::nmc
      INTEGER,INTENT(INOUT)::iday,ihr,imin,isec,i100th
      INTEGER::iigg,h1
      REAL::te
      iigg=i100th+100*(isec+60*(imin+60*(ihr+24*iday)))
      te=DBLE(iigg*10**4)/DBLE(nmc)
      WRITE(*,*)" "
      IF(te.LT.1000)THEN
         WRITE(*,*)"speed=",te,"us/point"
      ELSEIF(te.GE.1000.AND.te.LT.10**6)THEN
         WRITE(*,*)"speed=",te/1000,"ms/point"
      ELSEIF(te.GE.10**6.AND.te.LT.10**9)THEN
         WRITE(*,*),"speed=",te/10**6,"s/point"
      ENDIF
      h1=MOD(iigg,100*60*60*24)
      iday=(iigg-h1)/(100*60*60*24)
      iigg=h1
      h1=MOD(iigg,360000)
      ihr=(iigg-h1)/360000
      iigg=h1
      h1=MOD(iigg,6000)
      imin=(iigg-h1)/6000
      iigg=h1
      h1=MOD(iigg,100)
      isec=(iigg-h1)/100
      i100th=h1
      WRITE(*,*)"total time:"
      WRITE(*,*)iday,"d ;",ihr,"h ;",imin,"m ;",isec,"s ;",i100th,"cms "
      WRITE(*,*)" "
    END SUBROUTINE Vegas_speed

  END MODULE eA_hadron
