SUBROUTINE strf_lhapdf_eA_hadron(wsf)
! it will include the fragmentation function as well
! it will also taken into account the ef**2 (ef is the charge of quarks)
USE eA_hadron_global
USE FFKretzer_interface 
USE nFFKretzer_interface
INTEGER::ipp=1  ! ipp=1 ppbar ; ipp=2 pp
INTEGER::ih=1   ! ih=1 no photon PDF,ih=2, photon from proton/anti-proton,ih=3 photon from electron/positron 
REAL(KIND(1d0)),INTENT(OUT)::wsf          
CHARACTER(len=20),DIMENSION(20)::parm
REAL(KIND(1d0)),DIMENSION(20)::val
REAL(KIND(1d0)),DIMENSION(-7:7)::pdflist
LOGICAL::neutronQ=.FALSE.
INTEGER::init=0      
SAVE init,ipp,ih
REAL(KIND(1d0))::u1_ct,d1_ct,s1_ct,c1_ct,b1_ct,ub1_ct,db1_ct,sb1_ct,cb1_ct,bb1_ct,sf_ct
REAL(KIND(1d0)),DIMENSION(-5:5)::dff
REAL(KIND(1d0))::wsf1,wsf2
       
IF(init.EQ.0)THEN
   CALL lhapdfwrap
   IF(lnuclearPDF)THEN
      CALL init_nPDF(nPDF_id,nuclearPDF_param)
   ENDIF
   ipp=2
   init=1
ENDIF

neutronQ=.FALSE.
IF(lnuclearPDF.AND.DABS(rnuclearA).GT.2d0)THEN
   CALL pftonpdglha(ih,x_PDF,scale,rnuclearA,pdflist(-7:7))
   neutronQ=rand().GT.randbeam1
ELSE
   CALL pftopdglha(ih,x_PDF,scale,pdflist(-7:7))
   neutronQ=rand().GT.randbeam1
ENDIF
IF(neutronQ)THEN
   u1_ct   = x_PDF*pdflist(1)*(2d0/3d0)**2
   d1_ct   = x_PDF*pdflist(2)*(1d0/3d0)**2
   s1_ct   = x_PDF*pdflist(3)*(1d0/3d0)**2
   c1_ct   = x_PDF*pdflist(4)*(2d0/3d0)**2
   b1_ct   = x_PDF*pdflist(5)*(1d0/3d0)**2
   ub1_ct  = x_PDF*pdflist(-1)*(2d0/3d0)**2
   db1_ct  = x_PDF*pdflist(-2)*(1d0/3d0)**2
   sb1_ct  = x_PDF*pdflist(-3)*(1d0/3d0)**2
   cb1_ct  = x_PDF*pdflist(-4)*(2d0/3d0)**2
   bb1_ct  = x_PDF*pdflist(-5)*(1d0/3d0)**2
ELSE
   u1_ct   = x_PDF*pdflist(2)*(2d0/3d0)**2
   d1_ct   = x_PDF*pdflist(1)*(1d0/3d0)**2
   s1_ct   = x_PDF*pdflist(3)*(1d0/3d0)**2
   c1_ct   = x_PDF*pdflist(4)*(2d0/3d0)**2
   b1_ct   = x_PDF*pdflist(5)*(1d0/3d0)**2
   ub1_ct  = x_PDF*pdflist(-2)*(2d0/3d0)**2
   db1_ct  = x_PDF*pdflist(-1)*(1d0/3d0)**2
   sb1_ct  = x_PDF*pdflist(-3)*(1d0/3d0)**2
   cb1_ct  = x_PDF*pdflist(-4)*(2d0/3d0)**2
   bb1_ct  = x_PDF*pdflist(-5)*(1d0/3d0)**2
ENDIF
IF(ABS(hadron_istate).GT.0)THEN
   wsf1=0d0
   IF(nf_eA_hadron.GE.1)THEN
      wsf1=wsf1+u1_ct+ub1_ct
   ENDIF
   IF(nf_eA_hadron.GE.2)THEN
      wsf1=wsf1+d1_ct+db1_ct
   ENDIF
   IF(nf_eA_hadron.GE.3)THEN
      wsf1=wsf1+s1_ct+sb1_ct
   ENDIF
   IF(nf_eA_hadron.GE.4)THEN
      wsf1=wsf1+c1_ct+cb1_ct
   ENDIF
   IF(nf_eA_hadron.GE.5)THEN
      wsf1=wsf1+b1_ct+bb1_ct
   ENDIF
   IF(jetquenchingQ.AND.DABS(rnuclearA).GT.2d0)THEN
      CALL CallingnFFKretzer(z_FF,eps_FF,v_gamma,scale,PDG_hadron,ifforder,&
           iffset,dff(-5:5))
   ELSE
      CALL CallingFFKretzer(z_FF,scale,PDG_hadron,ifforder,iffset,dff(-5:5))
   ENDIF
   u1_ct   = u1_ct*dff(1)
   d1_ct   = d1_ct*dff(2)
   s1_ct   = s1_ct*dff(3)
   c1_ct   = c1_ct*dff(4)
   b1_ct   = b1_ct*dff(5)
   ub1_ct  = ub1_ct*dff(-1)
   db1_ct  = db1_ct*dff(-2)
   sb1_ct  = sb1_ct*dff(-3)
   cb1_ct  = cb1_ct*dff(-4)
   bb1_ct  = bb1_ct*dff(-5)
   wsf2=0d0
   IF(nf_eA_hadron.GE.1)THEN
      wsf2=wsf2+u1_ct+ub1_ct
   ENDIF
   IF(nf_eA_hadron.GE.2)THEN
      wsf2=wsf2+d1_ct+db1_ct
   ENDIF
   IF(nf_eA_hadron.GE.3)THEN
      wsf2=wsf2+s1_ct+sb1_ct
   ENDIF
   IF(nf_eA_hadron.GE.4)THEN
      wsf2=wsf2+c1_ct+cb1_ct
   ENDIF
   IF(nf_eA_hadron.GE.5)THEN
      wsf2=wsf2+b1_ct+bb1_ct
   ENDIF
   IF(wsf1.EQ.0d0)THEN
      wgt_FF=1d0
   ELSE
      wgt_FF=wsf2/wsf1*(1d0-z_FF_min)
      !IF(jetquenchingQ.AND.DABS(rnuclearA).GT.2d0)THEN
      !   wgt_FF=wgt_FF*MIN(v_gamma-hadron_pmom(4),wc_FF)/wc_FF
      !ENDIF
   ENDIF
ELSE
   wgt_FF=1d0
ENDIF

wsf=0d0
IF(nf_eA_hadron.GE.1)THEN
   wsf=wsf+u1_ct+ub1_ct
ENDIF
IF(nf_eA_hadron.GE.2)THEN
   wsf=wsf+d1_ct+db1_ct
ENDIF
IF(nf_eA_hadron.GE.3)THEN
   wsf=wsf+s1_ct+sb1_ct
ENDIF
IF(nf_eA_hadron.GE.4)THEN
   wsf=wsf+c1_ct+cb1_ct
ENDIF
IF(nf_eA_hadron.GE.5)THEN
   wsf=wsf+b1_ct+bb1_ct
ENDIF

wsf=wsf/x_PDF

IF(init.EQ.0)init=1
       
END SUBROUTINE strf_lhapdf_eA_hadron

SUBROUTINE pftonpdglha(ih,x,q,a,pdf)
!***************************************************************************
!     Wrapper for calling the nuclear pdf from lhapdf
!***************************************************************************
  IMPLICIT NONE
  REAL(KIND(1d0)),INTENT(IN)::x,q,a
  REAL(KIND(1d0)),DIMENSION(-7:7),INTENT(OUT)::pdf
  REAL(KIND(1d0)),DIMENSION(-6:6)::f ! nuclear PDF*x
  INTEGER,INTENT(IN)::IH !
  INTEGER::I
  REAL(KIND(1d0))::photon

  IF(ABS(ih).EQ.1)THEN
     pdf(-7)=0d0
     pdf(7)=0d0
     CALL evolvePDFa(x,q,a,f)
     DO i=-6,6
        pdf(i)=f(i)/x
     ENDDO
  ELSE
     WRITE(*,*) 'beam type is not supported in lhadpf'
     DO i=-7,7
        pdf(i)=0d0
     ENDDO
  ENDIF

  RETURN
END SUBROUTINE pftonpdglha

SUBROUTINE init_nPDF(nPDF,lparm)
  IMPLICIT NONE
  INTEGER,INTENT(IN)::nPDF
  CHARACTER(len=20),INTENT(OUT)::lparm
  CHARACTER(len=20)::cnum
  SELECT CASE(nPDF)
  CASE(1)
     lparm='EPS08'
  CASE(2)
     lparm='EPS09'
  CASE(3)
     lparm='EPS09LO'
  CASE(301:331)
     lparm='EPS09LO,'
     WRITE(cnum,*)(nPDF-300)
     lparm=ADJUSTL(TRIM(lparm))//ADJUSTL(TRIM(cnum))
  CASE(4)
     lparm='EPS09NLO'
  CASE(401:431)
     lparm='EPS09NLO,'
     WRITE(cnum,*)(nPDF-400)
     lparm=ADJUSTL(TRIM(lparm))//ADJUSTL(TRIM(cnum))
  CASE(5)
     lparm='EKS98'
  CASE DEFAULT
     WRITE(*,*)"ERROR:Unknown nuclear PDF nPDF=",nPDF
     STOP
  END SELECT
  ! internal LHAPDF function
  CALL setlhaparm(ADJUSTL(TRIM(lparm)))
  RETURN
END SUBROUTINE init_nPDF

SUBROUTINE lhapdfwrap
  USE eA_hadron_global
  REAL(KIND(1d0)),PARAMETER::zmass=91.188d0
  CHARACTER(len=20),DIMENSION(20)::parm
  REAL(KIND(1d0)),DIMENSION(20)::value
  REAL(KIND(1d0)),EXTERNAL::alphasPDF ! the lhapdf internal function
  ! initialize the pdf set
  CALL FindPDFPath(LHAPath)
  CALL SetPDFPath(LHAPath) ! Location of the LHAPDF library of PDFs
  ! they are defined in share/lhapdf/PDFsets.index
  value(1)=lhapdf
  parm(1)='DEFAULT'
  CALL pdfset(parm,value) ! PDFSET is a function by using lhaglue interface
  CALL GetOrderAs(nloop)
  nloop=nloop+1 ! nloop=1:LO; nloop=2:NLO
  alphaQCD2=alphasPDF(zmass) ! internal function of LHAPDF
  RETURN
END SUBROUTINE lhapdfwrap


SUBROUTINE FindPDFPath(LHAPath)
!********************************************************************
! generic subroutine to open the table files in the right directories
!********************************************************************
  IMPLICIT NONE
  CHARACTER(len=150),INTENT(INOUT)::LHAPath
  CHARACTER(len=3)::up='../'
  LOGICAL::exists
  INTEGER::i
  ! try in the LHAPath first
  INQUIRE(File=LHAPath,exist=exists)
  IF(exists)RETURN
  !first try in the current directory
  
  LHAPath='PDFsets'
  INQUIRE(File=LHAPath, exist=exists)
  IF(exists)RETURN
  ! then try one directory up

  LHAPath=up//LHAPath
  INQUIRE(File=LHAPath, exist=exists)
  IF(exists)RETURN
  ! finally try in the lib directory 

  LHAPath='lib/PDFsets'
  INQUIRE(File=LHAPath, exist=exists)
  IF(exists)RETURN
  DO i=1,6
     LHAPath=up//LHAPath
     INQUIRE(File=LHAPath, exist=exists)
     IF(exists)RETURN
  ENDDO
  PRINT *,'ERROR:Could not find PDFsets directory in LHAPDF, quitting'
  STOP

  RETURN
END SUBROUTINE FindPDFPath

SUBROUTINE pftopdglha(ih,x,q,pdf)
!***************************************************************************
! Wrapper for calling the pdf from lhapdf
!***************************************************************************
  IMPLICIT NONE
  REAL(KIND(1d0)),INTENT(IN)::x,q
  REAL(KIND(1d0)),DIMENSION(-7:7),INTENT(OUT)::pdf
  REAL(KIND(1d0)),DIMENSION(-6:6)::f ! momentum density x*PDF
  INTEGER,INTENT(IN)::IH
  INTEGER::I
  REAL(KIND(1d0))::photon  
  LOGICAL,EXTERNAL::has_photon ! the lhapdf internal function

  IF(ABS(ih).EQ.1)THEN
     pdf(-7)=0d0
     IF(has_photon())THEN
        CALL evolvePDFphoton(x, q, f, photon)
        pdf(7)= photon
     ELSE
        pdf(7) = 0d0
        CALL evolvePDF(x, q, f)
     ENDIF
     DO i=-6,6
        pdf(i)=f(i)/x
     ENDDO
  ELSE
     WRITE(*,*) 'beam type is not supported in lhadpf'     
     DO i=-7,7
        pdf(i)=0d0
     ENDDO
  ENDIF

  RETURN
END SUBROUTINE pftopdglha
