MODULE eA_hadron_ME
  USE eA_hadron_global
  IMPLICIT NONE
CONTAINS
  ! Eq.(5.3) in hep-ph/0210104
  ! correct as to be aem
  ! It has included the phase space and initial average factor
  ! However, it drops ef**2 (ef=2/3 for up-type quark, ef=-1/3 for down-type quark)
  SUBROUTINE sigma_gammaq(wme)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(OUT)::wme
    INTEGER::init=0
    REAL(KIND(1d0)),PARAMETER::pipi=3.1415926535897932385d0
    REAL(KIND(1d0))::Q2_gamma
    SAVE init
    IF(init.EQ.0)THEN
       init=1
    ENDIF
    Q2_gamma=2d0*v_gamma*Mn*x_pdf
    wme=4d0*pipi*aem**2*Mn*x_pdf/Q2_gamma**2*(1d0&
         +(1d0-Q2_gamma/x_pdf/S_en)**2)
    RETURN
  END SUBROUTINE sigma_gammaq
END MODULE eA_hadron_ME
