MODULE eA_hadron_global
  IMPLICIT NONE
  INTEGER::hadron_istate ! 1:pi+, -1: pi-, 2: K+, 2-:K-, +-3: K0,K0bar
                         ! 4: pi0, 5: proton, 6: neutron, 0: no FF
  REAL(KIND(1d0)),PARAMETER::Mn=938.27d-3 ! the mass of proton
  REAL(KIND(1d0)),PARAMETER::Mproton=938.27d-3
  REAL(KIND(1d0)),PARAMETER::Mneutron=939.49d-3
  REAL(KIND(1d0)),PARAMETER::Mpipm=139.57018d-3
  REAL(KIND(1d0)),PARAMETER::Mpi0=134.9766d-3
  REAL(KIND(1d0)),PARAMETER::MKpm=493.677d-3
  REAL(KIND(1d0)),PARAMETER::MK0=487.611d-3
  REAL(KIND(1d0))::Mhadron
  REAL(KIND(1d0))::aem=1d0/137d0
  REAL(KIND(1d0))::x_pdf,z_FF
  REAL(KIND(1d0))::x_pdf_min,z_FF_min
  REAL(KIND(1d0))::v_gamma ! energy in the lab frame 
  REAL(KIND(1d0))::v_gamma_max,v_gamma_min
  REAL(KIND(1d0))::S_en, ele_energy
  CHARACTER(len=150)::LHAPath=""
  CHARACTER(len=24),PARAMETER::input_dir="./input/"
  CHARACTER(len=24),PARAMETER::tmp_dir="./tmp/"
  INTEGER,PUBLIC::nunit1=6,nunit2,nunit3
  ! it is the fixed target mode
  ! the proton in A is (Mn,0,0,0)
  REAL(KIND(1d0)),DIMENSION(4,4)::parton_pmom
  REAL(KIND(1d0)),DIMENSION(4)::gamma_pmom
  REAL(KIND(1d0)),DIMENSION(4)::hadron_pmom
  INTEGER::nuclearA,nuclearZ
  ! the parameters for calling Kretzer FF
  INTEGER::PDG_hadron,PDG_parton
  INTEGER::ifforder
  INTEGER::iffset
  INTEGER::nf_eA_hadron ! number of quark flavor taken into account
  REAL(KIND(1d0)),PARAMETER::min_z_ffkretzer=0.01d0
  ! Q2 is between 1.0    and  1.D6 (GeV^2)
  REAL(KIND(1d0)),PARAMETER::min_Q2_ffkretzer=1d0
  REAL(KIND(1d0)),PARAMETER::max_Q2_ffkretzer=1d6
  REAL(KIND(1d0))::eps_FF
  ! the parameter for PDF
  INTEGER::lhapdf
  REAL(KIND(1d0))::scale
  REAL(KIND(1d0))::alphaQCD2
  INTEGER::nloop
  LOGICAL::lnuclearPDF=.FALSE.
  ! nuclear PDF variables
  ! 1: EPS08, 2: EPS09, 3: EPS09LO, 4: EPS09NLO, 5: EKS98
  ! 301-331: EPS09LO,n, 401-431: EPS09NLO,n
  INTEGER::nPDF_id=0
  REAL(KIND(1d0))::randbeam1=1d0
  REAL(KIND(1d0))::rnuclearA,rnuclearZ
  CHARACTER(len=20)::nuclearPDF_param='EPS09NLO'
  ! accumulated wgt
  REAL(KIND(1d0))::wgt_Ntot,wgt_Ne,wgt_FF
  SAVE wgt_Ntot,wgt_Ne,wgt_FF
  ! jet quenching related
  LOGICAL::jetquenchingQ=.FALSE.
  INTEGER::jetquenching_method=0
  REAL(KIND(1d0))::jetquenching_as=0.5d0
  REAL(KIND(1d0))::jetquenching_qhat=0.25d0
  REAL(KIND(1d0))::jetquenching_t0=1d0
  REAL(KIND(1d0))::medium_length=5d0
  REAL(KIND(1d0))::string_tension=1d0
  INTEGER::wc_estimate=1
END MODULE eA_hadron_global
