      ! redefine my scale function
      CALL Higgs_scale(scale)
      scale=scale*muR_over_ref
      Lcut=DLOG(H_pTveto**2/scale**2)
      IF(Higgs_state.EQ.1)THEN
         ! Higgs
         LS=two*DLOG(MH**2/scale**2)
         LMH=CDLOG(DCMPLX(-MH**2/scale**2))
         LMT=CDLOG(DCMPLX(scale**2/MT**2))
      ELSE
         ! quarkonium
         LS=two*DLOG(MetaQ**2/scale**2)
         LMetaQ=CDLOG(DCMPLX(-MetaQ**2/scale**2))
	 LmuNRQCD=CDLOG(DCMPLX(MetaQ**2/onium_muNRQCD**2))
      ENDIF
      as_real=ALPHAS(scale)
      aso2pi=as_real/TWOPI
      ! start to get the LDME RG running
      ! it will use the fixed scale and will not change phase space point by phase space point
      IF(nnn.EQ.0.AND.Higgs_state.NE.1.AND.LDME_RG_RUN)THEN
         as_MQ=ALPHAS(onium_muNRQCD0)
         IF(onium_muNRQCD.NE.onium_muNRQCD0)THEN
            ! we need to update the central value of LDME first
            ! use two-loop running, i;e., beta0, beta1, beta2
            as_muNRQCD=ALPHAS(onium_muNRQCD)
            LDMEetaQ=LDME_RG_RUNNING(2,as_MQ,as_muNRQCD,LDMEetaQ_MQ)
	 ENDIF
         IF(reweight_muNRQCD)THEN
	    ! evaluate LDMEetaQ_up and LDMEetaQ_down
            as_muNRQCD_up=ALPHAS(onium_muNRQCD*rw_muNRQCD_up)
	    as_muNRQCD_down=ALPHAS(onium_muNRQCD*rw_muNRQCD_down)
	    LDMEetaQ_up=LDME_RG_RUNNING(2,as_MQ,as_muNRQCD_up,LDMEetaQ_MQ)
	    LDMEetaQ_down=LDME_RG_RUNNING(2,as_MQ,as_muNRQCD_down,LDMEetaQ_MQ)
         ELSE
            LDMEetaQ_up=LDMEetaQ
            LDMEetaQ_down=LDMEetaQ
	 ENDIF
      ENDIF
      !Higgs_muR=scale
      !Higgs_muF=scale
      ! get all beam*soft*beam functions according to the cuts
      CALL call_gg_Higgs_NNLO_BSB(za,zb,xp1_born,xp2_born,Lcut,LS,aso2pi,MEorder,icut,me_bsb)
      IF(Higgs_state.EQ.1)THEN
        ! Higgs
        ! get Born partonic cross section
        CALL call_gg_Higgs_Born(vev,aso2pi,me_born)
        ! get Hard function
        CALL call_gg_Higgs_NNLO_HardFunction(MEorder,aso2pi,LMH,LMT,me_hard)
      ELSE
        ! quarkonium
        ! get Born partonic cross section
        CALL call_gg_etaQ_Born(LDMEetaQ,aso2pi,me_born)
        ! get Hard function
        CALL call_gg_etaQ_NNLO_HardFunction(MEorder,aso2pi,LMetaQ,LmuNRQCD,me_hard)
      ENDIF
      ! combine me's
      ! me_order is used for reweighting renormalisation/factorisation scales
      CALL combine_me_by_order(MEorder,me_born,me_hard,me_bsb,me,me_order)
      ! initialize the PDF's
      DO j=1,4
         wsf11_done(j)=.FALSE.
         wsf10_done(j)=.FALSE.
         wsf01_done(j)=.FALSE.
         wsf00_done(j)=.FALSE.
	 wsf11(j)=0d0
	 wsf10(j)=0d0
	 wsf01(j)=0d0
	 wsf00(j)=0d0
      ENDDO
      force_initial_reweight_scale=.TRUE.
      force_initial_reweight_pdf=.TRUE.
      force_initial_reweight_npdf=.TRUE.
      force_initial_reweight_ref=.TRUE.
      force_initial_reweight_muNRQCD=.TRUE.
      IF(icut(1).EQ.1)THEN
         ! there are double real emissions
         ! 6<=ss_piece<=9
         ! ibody=1: (n+2)-body contribution
         ! ibody=2: (n+1)-body contribution (excluding R)
         ! ibody=3: (n+1)-body contribution (R only)
         ! ibody=4: n-body contribution (excluding Born and V,i.e., VV)
         ! ibody=5: n-body contribution (V only)
         ! ibody=6: Born contribution
         ibody=1
         Higgs_pmom(1:5,1:4)=Higgs_pmom_real_real(1:5,1:4)
         ! j: 1: gg; 2: gq+gqbar; 3: qg+qbarg; 4: qq'
	 DO j=1,4
            IF(me(j,6).NE.0d0.OR.me(j,7).NE.0d0.OR.me(j,8).NE.0d0.OR.me(j,9).NE.0d0)THEN
               IF(j.EQ.1)THEN
                  iflh(1:2)=35
                  iflh(4)=35
                  iflh(5)=35
               ELSEIF(j.EQ.2)THEN
                  iflh(1)=35
                  iflh(2)=3
                  iflh(4)=35
                  iflh(5)=3
               ELSEIF(j.EQ.3)THEN
                  iflh(1)=3
                  iflh(2)=35
                  iflh(4)=3
                  iflh(5)=35
               ELSE
                  iflh(1)=3
                  iflh(2)=-3
                  iflh(4)=3
                  iflh(5)=-3
               ENDIF
               IF(.NOT.wsf11_done(j))THEN
                  xp1=xp1_real
                  xp2=xp2_real
                  CALL strf_pdf_gg_Higgs_NNLO(wsf11(j),j)
                  wsf11_done(j)=.TRUE.
               ENDIF
	       IF(me(j,6).NE.0d0.OR.me(j,8).NE.0d0)THEN
                  IF(.NOT.wsf10_done(j))THEN
                     xp1=xp1_real
                     xp2=xp2_born
                     CALL strf_pdf_gg_Higgs_NNLO(wsf10(j),j)
                     wsf10_done(j)=.TRUE.
                  ENDIF
               ENDIF
               IF(me(j,6).NE.0d0.OR.me(j,7).NE.0d0)THEN
                  IF(.NOT.wsf01_done(j))THEN
                     xp1=xp1_born
                     xp2=xp2_real
                     CALL strf_pdf_gg_Higgs_NNLO(wsf01(j),j)
                     wsf01_done(j)=.TRUE.
                  ENDIF
               ENDIF
               IF(me(j,6).NE.0d0)THEN
                  IF(.NOT.wsf00_done(j))THEN
                     xp1=xp1_born
                     xp2=xp2_born
                     CALL strf_pdf_gg_Higgs_NNLO(wsf00(j),j)
                     wsf00_done(j)=.TRUE.
                  ENDIF
               ENDIF
	       ! rearrange the following terms according to PDFs
	       ! wsf11
	       !wme=(me(j,6)+me(j,7)+me(j,8)+me(j,9))
	       wme=get_wme_gg_Higgs_NNLO(j,1,1,me)
	       IF(reweight_scale.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_scale(j,1,1,wsf11(j),wme,me,me_order)
	       IF(reweight_muNRQCD.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_muNRQCD(j,1,1,wme,me_born,me_bsb)
	       wme=wme*wsf11(j)/zab
               wthis=wme*z0*Jyy*Jza*Jzb*3.8937966d5 ! 3.8938573d5 ! in unit of nb
               IF(reweight_pdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_pdf(wsf11(j),j,1)
               IF(reweight_npdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_npdf(wsf11(j),j,1)
               IF(reweight_ref.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_ref(wsf11(j),j,1)
               IF(plot_output.AND.wthis.NE.0d0)THEN
                  w1=wthis*wgt
                  CALL outfun_gg_Higgs_NNLO(w1,ibody)
               ENDIF
               wtotal=wtotal+wthis
	       ! wsf10
	       !wme=-(me(j,6)+me(j,8))
	       wme=get_wme_gg_Higgs_NNLO(j,2,1,me)
	       IF(reweight_scale.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_scale(j,2,1,wsf10(j),wme,me,me_order)
	       IF(reweight_muNRQCD.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_muNRQCD(j,2,1,wme,me_born,me_bsb)
	       wme=wme*wsf10(j)/za
               wthis=wme*z0*Jyy*Jza*Jzb*3.8937966d5 ! 3.8938573d5 ! in unit of nb
               IF(reweight_pdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_pdf(wsf10(j),j,2)
               IF(reweight_npdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_npdf(wsf10(j),j,2)
               IF(reweight_ref.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_ref(wsf10(j),j,2)
               IF(plot_output.AND.wthis.NE.0d0)THEN
                  w1=wthis*wgt
                  CALL outfun_gg_Higgs_NNLO(w1,ibody)
               ENDIF
	       wtotal=wtotal+wthis
	       ! wsf01
	       !wme=-(me(j,6)+me(j,7))
	       wme=get_wme_gg_Higgs_NNLO(j,3,1,me)
	       IF(reweight_scale.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_scale(j,3,1,wsf01(j),wme,me,me_order)
	       IF(reweight_muNRQCD.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_muNRQCD(j,3,1,wme,me_born,me_bsb)
	       wme=wme*wsf01(j)/zb
               wthis=wme*z0*Jyy*Jza*Jzb*3.8937966d5 ! 3.8938573d5 ! in unit of nb
               IF(reweight_pdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_pdf(wsf01(j),j,3)
               IF(reweight_npdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_npdf(wsf01(j),j,3)
               IF(reweight_ref.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_ref(wsf01(j),j,3)
               IF(plot_output.AND.wthis.NE.0d0)THEN	       
                  w1=wthis*wgt
                  CALL outfun_gg_Higgs_NNLO(w1,ibody)
               ENDIF
               wtotal=wtotal+wthis
	       ! wsf00
	       !wme=me(j,6)
	       wme=get_wme_gg_Higgs_NNLO(j,4,1,me)
	       IF(reweight_scale.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_scale(j,4,1,wsf00(j),wme,me,me_order)
	       IF(reweight_muNRQCD.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_muNRQCD(j,4,1,wme,me_born,me_bsb)
	       wme=wme*wsf00(j)
               wthis=wme*z0*Jyy*Jza*Jzb*3.8937966d5 ! 3.8938573d5 ! in unit of nb
               IF(reweight_pdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_pdf(wsf00(j),j,4)
               IF(reweight_npdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_npdf(wsf00(j),j,4)
               IF(reweight_ref.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_ref(wsf00(j),j,4)
               IF(plot_output.AND.wthis.NE.0d0)THEN
                  w1=wthis*wgt
                  CALL outfun_gg_Higgs_NNLO(w1,ibody)
               ENDIF
               wtotal=wtotal+wthis

	       !wme=me(j,6)*(wsf11(j)/zab-wsf10(j)/za-wsf01(j)/zb+wsf00(j))
               !wme=wme+me(j,7)*(wsf11(j)/zab-wsf01(j)/zb)
               !wme=wme+me(j,8)*(wsf11(j)/zab-wsf10(j)/za)
               !wme=wme+me(j,9)*wsf11(j)/zab
               !wthis=wme*z0*Jyy*Jza*Jzb*3.8937966d5 ! 3.8938573d5 ! in unit of nb
               !IF(.FALSE..AND.reweight_scale.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_scale(wsf,wme,j,ibody)
               !IF(reweight_pdf.AND.wthis.NE.0d0)&
               !     CALL gg_Higgs_NNLO_reweight_xsec_pdf(me(j,1:9),wsf11(j),wsf10(j),wsf01(j),wsf00(j),j)
               !IF(reweight_npdf.AND.wthis.NE.0d0)&
               !     CALL gg_Higgs_NNLO_reweight_xsec_npdf(me(j,1:9),wsf11(j),wsf10(j),wsf01(j),wsf00(j),j)
               !IF(reweight_ref.AND.wthis.NE.0d0)&
               !     CALL gg_Higgs_NNLO_reweight_xsec_ref(me(j,1:9),wsf11(j),wsf10(j),wsf01(j),wsf00(j),j)
               !IF(plot_output.AND.wthis.NE.0d0)THEN
               !   w1=wthis*wgt
               !   CALL outfun_gg_Higgs_NNLO(w1,ibody)
               !ENDIF
               !wtotal=wtotal+wthis
          ENDIF
       ENDDO
    ENDIF
    IF(icut(2).EQ.1)THEN
       ! there are real born emissions
       ! ss_piece = 3,5
       ! ibody=1: (n+2)-body contribution
       ! ibody=2: (n+1)-body contribution (excluding R)
       ! ibody=3: (n+1)-body contribution (R only)
       ! ibody=4: n-body contribution (excluding Born and V,i.e., VV)
       ! ibody=5: n-body contribution (V only)
       ! ibody=6: Born contribution
       ibody=3
       Higgs_pmom(1:5,1:4)=Higgs_pmom_real_born(1:5,1:4)
       ! j: 1: gg; 2: gq+gqbar; 3: qg+qbarg; 4: qq'
       !CALL Higgs_scale(scale)
       !scale=scale*muR_over_ref
       !IF(scale.NE.Higgs_muR)THEN
       !   Higgs_muR=scale
       !   Higgs_muF=scale
       !   CALL call_NLO_pp_oniumX(zz,as_real,onium_state,me,.TRUE.)
       !ENDIF
       !as_other=ALPHAS(scale)
       DO j=1,4
          IF(me(j,3).NE.0d0.OR.me(j,5).NE.0d0)THEN
             IF(j.EQ.1)THEN
                iflh(1:2)=35
                iflh(4)=35
                iflh(5)=35
             ELSEIF(j.EQ.2)THEN
                iflh(1)=35
                iflh(2)=3
                iflh(4)=35
                iflh(5)=3
             ELSEIF(j.EQ.3)THEN
                iflh(1)=3
                iflh(2)=35
                iflh(4)=35
                iflh(5)=3
             ELSE
                iflh(1)=3
                iflh(2)=-3
                iflh(4)=3
                iflh(5)=-3
             ENDIF
             IF(.NOT.wsf10_done(j))THEN
                xp1=xp1_real
                xp2=xp2_born
                CALL strf_pdf_gg_Higgs_NNLO(wsf10(j),j)
                wsf10_done(j)=.TRUE.
             ENDIF
	     IF(me(j,3).NE.0d0)THEN
                IF(.NOT.wsf00_done(j))THEN
                   xp1=xp1_born
                   xp2=xp2_born
                   CALL strf_pdf_gg_Higgs_NNLO(wsf00(j),j)
                   wsf00_done(j)=.TRUE.
                ENDIF
             ENDIF
             ! rearrange the following terms according to PDFs
             ! wsf10
	     !wme=(me(j,3)+me(j,5))
	     wme=get_wme_gg_Higgs_NNLO(j,2,2,me)
	     IF(reweight_scale.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_scale(j,2,2,wsf10(j),wme,me,me_order)
	     IF(reweight_muNRQCD.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_muNRQCD(j,2,2,wme,me_born,me_bsb)
             wme=wme*wsf10(j)/za
             wthis=wme*z0*Jyy*Jza*3.8937966d5 ! 3.8938573d5 ! in unit of nb
             IF(reweight_pdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_pdf(wsf10(j),j,2)
             IF(reweight_npdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_npdf(wsf10(j),j,2)
             IF(reweight_ref.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_ref(wsf10(j),j,2)
             IF(plot_output.AND.wthis.NE.0d0)THEN
                w1=wthis*wgt
                CALL outfun_gg_Higgs_NNLO(w1,ibody)
             ENDIF
             wtotal=wtotal+wthis
             ! wsf00
	     !wme=-me(j,3)
	     wme=get_wme_gg_Higgs_NNLO(j,4,2,me)
	     IF(reweight_scale.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_scale(j,4,2,wsf00(j),wme,me,me_order)
	     IF(reweight_muNRQCD.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_muNRQCD(j,4,2,wme,me_born,me_bsb)
             wme=wme*wsf00(j)
             wthis=wme*z0*Jyy*Jza*3.8937966d5 ! 3.8938573d5 ! in unit of nb
             IF(reweight_pdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_pdf(wsf00(j),j,4)
             IF(reweight_npdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_npdf(wsf00(j),j,4)
             IF(reweight_ref.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_ref(wsf00(j),j,4)
             IF(plot_output.AND.wthis.NE.0d0)THEN
                w1=wthis*wgt
                CALL outfun_gg_Higgs_NNLO(w1,ibody)
             ENDIF
             wtotal=wtotal+wthis

	     !wme=me(j,3)*(wsf10(j)/za-wsf00(j))
             !wme=wme+me(j,5)*(wsf10(j)/za)
             !wthis=wme*z0*Jyy*Jza*3.8937966d5 ! 3.8938573d5 ! in unit of nb
             !IF(reweight_scale.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_scale(wsf,wme,j,ibody)
             !IF(reweight_pdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_pdf(wsf,j)
             !IF(reweight_npdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_npdf(wsf,j)
             !IF(reweight_ref.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_ref(wsf,j)
             !IF(plot_output.AND.wthis.NE.0d0)THEN
             !   w1=wthis*wgt
             !   CALL outfun_gg_Higgs_NNLO(w1,ibody)
	     !ENDIF
             !wtotal=wtotal+wthis
          ENDIF
       ENDDO
    ENDIF
    IF(icut(3).EQ.1)THEN
       ! there are born real emissions
       ! ss_piece = 2,4
       ! ibody=1: (n+2)-body contribution
       ! ibody=2: (n+1)-body contribution (excluding R)
       ! ibody=3: (n+1)-body contribution (R only)
       ! ibody=4: n-body contribution (excluding Born and V,i.e., VV)
       ! ibody=5: n-body contribution (V only)
       ! ibody=6: Born contribution
       ibody=3
       Higgs_pmom(1:5,1:4)=Higgs_pmom_born_real(1:5,1:4)
       ! j: 1: gg; 2: gq+gqbar; 3: qg+qbarg; 4: qq'
       !CALL Higgs_scale(scale)
       !scale=scale*muR_over_ref
       !IF(scale.NE.Higgs_muR)THEN
       !   Higgs_muR=scale
       !   Higgs_muF=scale
       !   CALL call_NLO_pp_oniumX(zz,as_real,onium_state,me,.TRUE.)
       !ENDIF
       !as_other=ALPHAS(scale)
       DO j=1,4
          IF(me(j,2).NE.0d0.OR.me(j,4).NE.0d0)THEN
             IF(j.EQ.1)THEN
                iflh(1:2)=35
                iflh(4)=35
                iflh(5)=35
             ELSEIF(j.EQ.2)THEN
                iflh(1)=35
                iflh(2)=3
                iflh(4)=35
                iflh(5)=3
             ELSEIF(j.EQ.3)THEN
	     iflh(1)=3
                iflh(2)=35
                iflh(4)=35
                iflh(5)=3
             ELSE
                iflh(1)=3
                iflh(2)=-3
                iflh(4)=3
                iflh(5)=-3
             ENDIF
             IF(.NOT.wsf01_done(j))THEN
                xp1=xp1_born
                xp2=xp2_real
                CALL strf_pdf_gg_Higgs_NNLO(wsf01(j),j)
                wsf01_done(j)=.TRUE.
             ENDIF
             IF(me(j,2).NE.0d0)THEN
                IF(.NOT.wsf00_done(j))THEN
                   xp1=xp1_born
                   xp2=xp2_born
                   CALL strf_pdf_gg_Higgs_NNLO(wsf00(j),j)
                   wsf00_done(j)=.TRUE.
                ENDIF
             ENDIF
             ! rearrange the following terms according to PDFs
             ! wsf01
	     !wme=(me(j,2)+me(j,4))
	     wme=get_wme_gg_Higgs_NNLO(j,3,3,me)
	     IF(reweight_scale.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_scale(j,3,3,wsf01(j),wme,me,me_order)
	     IF(reweight_muNRQCD.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_muNRQCD(j,3,3,wme,me_born,me_bsb)
             wme=wme*wsf01(j)/zb
             wthis=wme*z0*Jyy*Jzb*3.8937966d5 ! 3.8938573d5 ! in unit of nb
             IF(reweight_pdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_pdf(wsf01(j),j,3)
             IF(reweight_npdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_npdf(wsf01(j),j,3)
             IF(reweight_ref.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_ref(wsf01(j),j,3)
             IF(plot_output.AND.wthis.NE.0d0)THEN
                w1=wthis*wgt
                CALL outfun_gg_Higgs_NNLO(w1,ibody)
             ENDIF
             wtotal=wtotal+wthis
             ! wsf00
	     !wme=-me(j,2)
             wme=get_wme_gg_Higgs_NNLO(j,4,3,me)
	     IF(reweight_scale.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_scale(j,4,3,wsf00(j),wme,me,me_order)
	     IF(reweight_muNRQCD.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_muNRQCD(j,4,3,wme,me_born,me_bsb)
             wme=wme*wsf00(j)
             wthis=wme*z0*Jyy*Jzb*3.8937966d5 ! 3.8938573d5 ! in unit of nb
             IF(reweight_pdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_pdf(wsf00(j),j,4)
             IF(reweight_npdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_npdf(wsf00(j),j,4)
             IF(reweight_ref.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_ref(wsf00(j),j,4)
             IF(plot_output.AND.wthis.NE.0d0)THEN
                w1=wthis*wgt
                CALL outfun_gg_Higgs_NNLO(w1,ibody)
             ENDIF
             wtotal=wtotal+wthis

             !wme=me(j,2)*(wsf01(j)/zb-wsf00(j))
             !wme=wme+me(j,4)*(wsf01(j)/zb)
             !wthis=wme*z0*Jyy*Jzb*3.8937966d5 ! 3.8938573d5 ! in unit of nb
             !IF(reweight_scale.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_scale(wsf,wme,j,ibody)
             !IF(reweight_pdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_pdf(wsf,j)
             !IF(reweight_npdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_npdf(wsf,j)
             !IF(reweight_ref.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_ref(wsf,j)
             !IF(plot_output.AND.wthis.NE.0d0)THEN
             !   w1=wthis*wgt
             !   CALL outfun_gg_Higgs_NNLO(w1,ibody)
             !ENDIF
             !wtotal=wtotal+wthis
          ENDIF
       ENDDO
    ENDIF
    IF(icut(4).EQ.1)THEN
       ! there are born born emissions
       ! ss_piece = 1
       ! ibody=1: (n+2)-body contribution
       ! ibody=2: (n+1)-body contribution (excluding R)
       ! ibody=3: (n+1)-body contribution (R only)
       ! ibody=4: n-body contribution (excluding Born and V,i.e., VV)
       ! ibody=5: n-body contribution (V only)
       ! ibody=6: Born contribution
       ibody=6
       Higgs_pmom(1:5,1:4)=Higgs_pmom_born_born(1:5,1:4)
       ! j: 1: gg; 2: gq+gqbar; 3: qg+qbarg; 4: qq'
       !CALL Higgs_scale(scale)
       !scale=scale*muR_over_ref
       !IF(scale.NE.Higgs_muR)THEN
       !   Higgs_muR=scale
       !   Higgs_muF=scale
       !   CALL call_NLO_pp_oniumX(zz,as_real,onium_state,me,.TRUE.)
       !ENDIF
       !as_other=ALPHAS(scale)
       DO j=1,4
          IF(me(j,1).NE.0d0)THEN
             IF(j.EQ.1)THEN
                iflh(1:2)=35
                iflh(4)=35
                iflh(5)=35
             ELSEIF(j.EQ.2)THEN
                iflh(1)=35
                iflh(2)=3
                iflh(4)=35
                iflh(5)=3
             ELSEIF(j.EQ.3)THEN
                iflh(1)=3
                iflh(2)=35
                iflh(4)=35
                iflh(5)=3
             ELSE
                iflh(1)=3
                iflh(2)=-3
                iflh(4)=3
                iflh(5)=-3
             ENDIF
             IF(.NOT.wsf00_done(j))THEN
                xp1=xp1_born
                xp2=xp2_born
                CALL strf_pdf_gg_Higgs_NNLO(wsf00(j),j)
                wsf00_done(j)=.TRUE.
             ENDIF
	     !wme=me(j,1)
	     wme=get_wme_gg_Higgs_NNLO(j,4,4,me)
	     IF(reweight_scale.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_scale(j,4,4,wsf00(j),wme,me,me_order)
	     IF(reweight_muNRQCD.AND.wme.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_muNRQCD(j,4,4,wme,me_born,me_bsb)
             wme=wme*(wsf00(j))
             wthis=wme*z0*Jyy*3.8937966d5 ! 3.8938573d5 ! in unit of nb
             IF(reweight_pdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_pdf(wsf00(j),j,4)
             IF(reweight_npdf.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_npdf(wsf00(j),j,4)
             IF(reweight_ref.AND.wthis.NE.0d0)CALL gg_Higgs_NNLO_reweight_xsec_ref(wsf00(j),j,4)
	     IF(plot_output.AND.wthis.NE.0d0)THEN
                w1=wthis*wgt
                CALL outfun_gg_Higgs_NNLO(w1,ibody)
             ENDIF
             wtotal=wtotal+wthis
          ENDIF
       ENDDO
    ENDIF