MODULE gg_Higgs_NNLO_Global
  IMPLICIT NONE
  ! 0: LO; 1: NLO; 2: NNLO
  INTEGER::MEorder=2
  REAL(KIND(1d0))::MH,MT,vev,GF
  REAL(KIND(1d0))::MB,lamhhh
  ! LDMEetaQ_MQ is the LDME at onium_muNRQCD0=MQ
  ! LDMEetaQ is the LDME at muNRQCD=onium_muNRQCD
  ! LDMEetaQ_up and LDMEetaQ_down is for the up/down value of LDMEetaQ at muNRQCD=onium_muNRQCD*rw_muNRQCD_up/down
  REAL(KIND(1d0))::MetaQ,onium_muNRQCD,onium_muNRQCD0
  REAL(KIND(1d0))::LDMEetaQ_MQ,LDMEetaQ,LDMEetaQ_up,LDMEetaQ_down
  ! Just Higgs or eta_c or eta_b
  INTEGER::Higgs_state=1
  ! number of light quarks
  INTEGER::nlq=5
  ! momenta of external legs
  REAL(KIND(1d0)),DIMENSION(5,4)::Higgs_pmom
  REAL(KIND(1d0)),DIMENSION(5,4)::Higgs_pmom_real_born,Higgs_pmom_born_real
  REAL(KIND(1d0)),DIMENSION(5,4)::Higgs_pmom_real_real
  REAL(KIND(1d0)),DIMENSION(5,4)::Higgs_pmom_born_born
  ! the pT veto for Higgs
  REAL(KIND(1d0))::H_pTveto
  ! as values
  REAL(KIND(1d0))::as_real,as_born,as_MQ,as_muNRQCD,as_muNRQCD_up,as_muNRQCD_down
  ! scale reweight stuff
  REAL(KIND(1d0)),DIMENSION(3)::rw_Rscales,rw_Fscales,rw_Mscales
  ! xa,xb
  REAL(KIND(1d0))::xp1_real,xp2_real,xp1_born,xp2_born
  ! QCD colour factors
  REAL(KIND(1d0)),PARAMETER::ggH_QCD_CA=3d0,ggH_QCD_CF=1.333333333333333333333333333333d0,ggH_QCD_TF=0.5d0
  ! integrator
  INTEGER::integrator
  ! order of alpha_s at Born
  INTEGER::bpower
  ! phase space cuts
  INTEGER,DIMENSION(4)::phase_space_cut
  ! process information
  INTEGER,PARAMETER::max_process=20
  INTEGER::n_process
  INTEGER,DIMENSION(max_process)::process_ID
  CHARACTER(len=200),DIMENSION(max_process)::process_info
  CHARACTER(len=2),DIMENSION(max_process)::process_status
END MODULE gg_Higgs_NNLO_Global
