SUBROUTINE strf_lhapdf_gg_Higgs_NNLO(wsf,inum)
  USE Helac_Global
  USE gg_Higgs_NNLO_Global
  USE gg_Higgs_NNLO_setscale
  INTEGER::ipp=1  ! ipp=1 ppbar ; ipp=2 pp
  INTEGER::ih=1   ! ih=1 no photon PDF,ih=2, photon from proton/anti-proton,ih=3 photon from electron/positron
  REAL(KIND(1d0)),INTENT(OUT)::wsf
  INTEGER,INTENT(IN)::inum ! inum = 1: gg; inum=2: gq+gqbar; inum=3: qg+qbarg; inum=4: qqbar+qbarq+qq'
  CHARACTER(len=20),DIMENSION(20)::parm
  REAL(KIND(1d0)),DIMENSION(20)::val
  REAL(KIND(1d0)),DIMENSION(-7:7)::pdflist
  LOGICAL::neutronQ=.FALSE.
  INTEGER::init=0,ijij      
  SAVE init,ipp,ih
  REAL(KIND(1d0))::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
       ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct
  REAL(KIND(1d0))::quarks1,quarks2

  IF(init.EQ.0)THEN
     IF(.NOT.lhapdfwrapinit)THEN
        CALL lhapdfwrap
        lhapdfwrapinit=.TRUE.
     ENDIF
     INCLUDE "../../../input/lhapdf/call_initnpdf"
     IF(Coll_Type.EQ.1)THEN
        ipp=2
     ELSE
        ipp=1
     ENDIF
     init=1
  ENDIF
  
  CALL Higgs_scale(scale)
  scale=scale*muF_over_ref
  IF(reweight_scale)THEN
     IF(reweight_Fscale_phase.EQ.1)THEN
        scale=scale*rw_Fscale_up
     ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
        scale=scale*rw_Fscale_down
     ENDIF
  ENDIF

  IF(lnuclearPDF.AND.rnuclearA_beam1.NE.0d0.AND.(.NOT.PureProton1))THEN
     INCLUDE "../../../input/lhapdf/call_strf_lhanpdf1"
  ELSE
     INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_proton"
     CALL pftopdglha(ih,xp1,scale,pdflist(-7:7))
     INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_00"
  ENDIF
  
  !CALL pftopdglha(ih,xp1,scale,pdflist(-7:7))
  glu1_ct = xp1*pdflist(0)
  u1_ct   = xp1*pdflist(2)
  d1_ct   = xp1*pdflist(1)
  s1_ct   = xp1*pdflist(3)
  c1_ct   = xp1*pdflist(4)
  b1_ct   = xp1*pdflist(5)
  ub1_ct  = xp1*pdflist(-2)
  db1_ct  = xp1*pdflist(-1)
  sb1_ct  = xp1*pdflist(-3)
  cb1_ct  = xp1*pdflist(-4)
  bb1_ct  = xp1*pdflist(-5)
  !CALL pftopdglha(ih,xp2,scale,pdflist(-7:7))

  IF(lnuclearPDF.AND.rnuclearA_beam2.NE.0d0.AND.(.NOT.PureProton2))THEN
     INCLUDE "../../../input/lhapdf/call_strf_lhanpdf2"
  ELSE
     INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_proton"
     CALL pftopdglha(ih,xp2,scale,pdflist(-7:7))
     INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_00"
  ENDIF

  glu2_ct = xp2*pdflist(0)
  u2_ct   = xp2*pdflist(2)
  d2_ct   = xp2*pdflist(1)
  s2_ct   = xp2*pdflist(3)
  c2_ct   = xp2*pdflist(4)
  b2_ct   = xp2*pdflist(5)
  ub2_ct  = xp2*pdflist(-2)
  db2_ct  = xp2*pdflist(-1)
  sb2_ct  = xp2*pdflist(-3)
  cb2_ct  = xp2*pdflist(-4)
  bb2_ct  = xp2*pdflist(-5)

  ! recover it
  IF(reweight_scale)THEN
     IF(reweight_Fscale_phase.EQ.1)THEN
        scale=scale/rw_Fscale_up
     ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
        scale=scale/rw_Fscale_down
     ENDIF
  ENDIF
  
  IF(inum.EQ.1)THEN
     ! gg
     wsf=glu1_ct*glu2_ct*wjac/xp1/xp2
  ELSEIF(inum.EQ.2)THEN
     ! gq+gqbar
     wsf=glu1_ct*(u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct)
     IF(nlq.GT.3)THEN
        wsf=wsf+glu1_ct*(c2_ct+cb2_ct)
     ENDIF
     IF(nlq.GT.4)THEN
        wsf=wsf+glu1_ct*(b2_ct+bb2_ct)
     ENDIF
     wsf=wsf*wjac/xp1/xp2
  ELSEIF(inum.EQ.3)THEN
     ! qg+qbarg
     wsf=glu2_ct*(u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct)
     IF(nlq.GT.3)THEN
        wsf=wsf+glu2_ct*(c1_ct+cb1_ct)
     ENDIF
     IF(nlq.GT.4)THEN
        wsf=wsf+glu2_ct*(b1_ct+bb1_ct)
     ENDIF
     wsf=wsf*wjac/xp1/xp2
  ELSEIF(inum.EQ.4)THEN
     ! qq' (all two (ani-)quark combinations)
     quarks1=u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct
     quarks2=u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct
     IF(nlq.GT.3)THEN
        quarks1=quarks1+c1_ct+cb1_ct
        quarks2=quarks2+c2_ct+cb2_ct
     ENDIF
     IF(nlq.GT.4)THEN
        quarks1=quarks1+b1_ct+bb1_ct
        quarks2=quarks2+b2_ct+bb2_ct
     ENDIF
     wsf=quarks1*quarks2
     wsf=wsf*wjac/xp1/xp2
  ENDIF

  IF(init.EQ.0)init=1
END SUBROUTINE strf_lhapdf_gg_Higgs_NNLO
