MODULE gg_Higgs_NNLO_setscale
  IMPLICIT NONE
CONTAINS
  SUBROUTINE Higgs_scale(scale0)
    USE Helac_Global
    USE gg_Higgs_NNLO_Global
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(OUT)::scale0
    REAL(KIND(1d0))::px,py,ptw2,mas
    INTEGER::ij
    SELECT CASE(nscheme)
    CASE(0)
       scale0=fschemevalue
    CASE(1,2)
       ptw2=Higgs_pmom(3,1)**2+Higgs_pmom(3,2)**2
       scale0=DSQRT(MH**2+ptw2)
    CASE(4,5)
       ! HT/2
       ptw2=Higgs_pmom(3,1)**2+Higgs_pmom(3,2)**2
       scale0=DSQRT(MH**2+ptw2)
       ptw2=DSQRT(Higgs_pmom(4,1)**2+Higgs_pmom(4,2)**2)
       scale0=scale0+ptw2
       scale0=scale0/2d0
    CASE DEFAULT
       WRITE(*,*)"ERROR: Do not understand the scale scheme=",nscheme
       STOP
    END SELECT
    scale0=MAX(scale0,1d0)
    scale0=scale0*scalefactor
    RETURN
  END SUBROUTINE Higgs_scale
END MODULE gg_Higgs_NNLO_setscale
