HODIR=
FC=
objdir=$(HODIR)/addon/gg_Higgs_NNLO/obj/
moddir=$(HODIR)/addon/gg_Higgs_NNLO/mod/
srcdir=$(HODIR)/src/
thissrcdir=$(HODIR)/addon/gg_Higgs_NNLO/src/
decaydir=$(HODIR)/decay/
nucdir=$(HODIR)/nuclear/
qcddir=$(HODIR)/qcdtools/
fundir=$(HODIR)/specialfuns/
libdir=$(HODIR)/lib/
showerdir=$(HODIR)/shower/interface/
# uncomment the following line to use gdb to debug
# FFLAGS=-ggdb -g -fbounds-check -ffpe-trap=invalid,zero,overflow,underflow,denormal -Wall
lhapdfobj=
obj=$(objdir)Helac_Global.o $(objdir)Helac_Func_1.o  $(objdir)Constants.o $(objdir)CTEQ6PDF.o $(objdir)Kinetic_Func.o $(objdir)Structf_PDFs.o $(objdir)photon_PDFs.o $(objdir)MC_VEGAS.o $(lhapdfobj) $(objdir)plot_gg_Higgs_NNLO.o $(objdir)gg_Higgs_NNLO.o $(objdir)ggH_NNLO_hard_function.o $(objdir)ggetaQ_NNLO_hard_function.o $(objdir)alfas_functions.o $(objdir)gg_Higgs_NNLO_Global.o $(objdir)Main_gg_Higgs_NNLO.o $(objdir)gg_Higgs_NNLO_setscale.o $(objdir)setscale.o $(objdir)hplog.o $(objdir)qcd_tmd_beamsoftbeam_functions_expinas.o $(objdir)qcd_setup.o $(objdir)qcd_constants.o $(objdir)convolution_communicator.o $(objdir)global_constants.o $(objdir)nintlib.o $(objdir)tbessk.o $(objdir)tbessj.o $(objdir)nielsen_generalized_polylog.o $(objdir)interpolation.o $(objdir)OpticalGlauber_Geometry.o $(objdir)ElasticPhotonPhotonFlux.o
mod = $(moddir)*.mod
exe = $(HODIR)/bin/HO_gg_Higgs_NNLO
linkexe = $(HODIR)/addon/gg_Higgs_NNLO/bin/HO_gg_Higgs_NNLO
EXLIBS = 

all :   clean $(exe)
	ln -s $(exe) $(linkexe)

$(exe): $(obj)
	@cp *.o $(objdir)
	@cp *.mod $(moddir)
	@rm *.o *.mod
	$(FC) -o $(exe) $(obj) -L$(libdir) -lpdf -lhbook $(EXLIBS)

$(objdir)Main_gg_Higgs_NNLO.o : $(thissrcdir)Main_gg_Higgs_NNLO.f90 $(moddir)gg_Higgs_NNLO.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)gg_Higgs_NNLO_Global.o $(moddir)gg_Higgs_NNLO_Global.mod: $(thissrcdir)gg_Higgs_NNLO_Global.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Helac_Global.o $(moddir)Helac_Global.mod : $(srcdir)Helac_Global.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)global_constants.o $(moddir)global_constants.mod : $(qcddir)global_constants.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)qcd_constants.o $(moddir)qcd_constants.mod : $(qcddir)qcd_constants.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)qcd_setup.o $(moddir)qcd_setup.mod : $(qcddir)qcd_setup.f90 $(moddir)qcd_constants.mod $(moddir)global_constants.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)convolution_communicator.o $(moddir)convolution_communicator.mod : $(qcddir)convolution_communicator.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)hplog.o $(moddir)hplog_module.mod : $(fundir)hplog.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)qcd_tmd_beamsoftbeam_functions_expinas.o $(moddir)qcd_tmd_beamsoftbeam_functions_expinas.mod : $(qcddir)qcd_tmd_beamsoftbeam_functions_expinas.f90 $(moddir)convolution_communicator.mod $(moddir)global_constants.mod $(moddir)qcd_constants.mod $(moddir)hplog_module.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Helac_Func_1.o $(moddir)Helac_Func_1.mod : $(srcdir)Helac_Func_1.f90 $(moddir)Helac_Global.mod $(moddir)alfas_functions.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Constants.o $(moddir)Constants.mod: $(srcdir)Constants.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_PDFs.o $(moddir)Structf_PDFs.mod:$(srcdir)Structf_PDFs.f90 $(moddir)Helac_Global.mod $(moddir)CTEQ6PDF.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod $(moddir)ElasticPhotonPhotonFlux.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)CTEQ6PDF.o $(moddir)CTEQ6PDF.mod: $(srcdir)CTEQ6PDF.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Kinetic_Func.o $(moddir)Kinetic_Func.mod: $(srcdir)Kinetic_Func.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)MC_VEGAS.o $(moddir)MC_VEGAS.mod: $(srcdir)MC_VEGAS.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)alfas_functions.o $(moddir)alfas_functions.mod: $(srcdir)alfas_functions.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)gg_Higgs_NNLO_setscale.o $(moddir)gg_Higgs_NNLO_setscale.mod: $(thissrcdir)gg_Higgs_NNLO_setscale.f90 $(moddir)Helac_Global.mod $(moddir)gg_Higgs_NNLO_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)ggH_NNLO_hard_function.o $(moddir)ggH_NNLO_hard_function.mod : $(thissrcdir)ggH_NNLO_hard_function.f90 $(moddir)qcd_constants.mod $(moddir)global_constants.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)ggetaQ_NNLO_hard_function.o $(moddir)ggetaQ_NNLO_hard_function.mod : $(thissrcdir)ggetaQ_NNLO_hard_function.f90 $(moddir)qcd_constants.mod $(moddir)global_constants.mod $(moddir)gg_Higgs_NNLO_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)plot_gg_Higgs_NNLO.o $(moddir)plot_gg_Higgs_NNLO.mod : $(thissrcdir)plot_gg_Higgs_NNLO.f90 $(moddir)Helac_Global.mod $(moddir)Kinetic_Func.mod $(moddir)MC_VEGAS.mod $(moddir)gg_Higgs_NNLO_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)gg_Higgs_NNLO.o $(moddir)gg_Higgs_NNLO.mod : $(thissrcdir)gg_Higgs_NNLO.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod $(moddir)Kinetic_Func.mod $(moddir)MC_VEGAS.mod $(moddir)Constants.mod $(moddir)plot_gg_Higgs_NNLO.mod $(moddir)CTEQ6PDF.mod $(moddir)gg_Higgs_NNLO_setscale.mod $(moddir)Structf_PDFs.mod $(moddir)gg_Higgs_NNLO_Global.mod $(moddir)qcd_setup.mod $(moddir)global_constants.mod $(moddir)convolution_communicator.mod $(moddir)qcd_tmd_beamsoftbeam_functions_expinas.mod $(moddir)ggH_NNLO_hard_function.mod $(moddir)ggetaQ_NNLO_hard_function.mod $(moddir)nintlib.mod $(moddir)qcd_constants.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)nintlib.o $(moddir)nintlib.mod : $(nucdir)nintlib.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)gg_Higgs_NNLO_LHAPDFs.o : $(thissrcdir)gg_Higgs_NNLO_LHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)gg_Higgs_NNLO_Global.mod $(moddir)gg_Higgs_NNLO_setscale.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)gg_Higgs_NNLO_MLHAPDFs.o : $(thissrcdir)gg_Higgs_NNLO_MLHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)gg_Higgs_NNLO_Global.mod $(moddir)gg_Higgs_NNLO_setscale.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_LHAPDFs.o : $(srcdir)Structf_LHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)ElasticPhotonPhotonFlux.o $(moddir)ElasticPhotonPhotonFlux.mod:$(nucdir)ElasticPhotonPhotonFlux.f90 $(moddir)OpticalGlauber_Geometry.mod $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)tbessk.o : $(fundir)tbessk.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)tbessj.o : $(fundir)tbessj.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)nielsen_generalized_polylog.o $(moddir)nielsen_generalized_polylog.mod : $(fundir)nielsen_generalized_polylog.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)OpticalGlauber_Geometry.o $(moddir)OpticalGlauber_Geometry.mod: $(nucdir)OpticalGlauber_Geometry.f90 $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)nielsen_generalized_polylog.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)interpolation.o $(moddir)interpolation.mod: $(nucdir)interpolation.f90
	$(FC) -c $< $(FFLAGS)	
$(objdir)photon_PDFs.o $(moddir)photon_PDFs.mod : $(srcdir)photon_PDFs.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_LHAnPDFs.o : $(srcdir)Structf_LHAnPDFs.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_MLHAPDFs.o : $(srcdir)Structf_MLHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)setscale.o $(moddir)setscale.mod: $(srcdir)setscale.f90
	$(FC) -c $< $(FFLAGS)
clean:
	rm -rf $(obj) $(mod) $(exe) $(linkexe) $(HODIR)/tmp/* *~ $(HODIR)/input/*~ $(HODIR)/src/*~ $(thissrcdir)*~ $(HODIR)/output/* fort.*
end
