MODULE plot_lhapdf_rwgt
  USE Helac_Global
  USE lhapdf_rwgt_global
CONTAINS

  SUBROUTINE GNUPLOT_PDF_ERROR(y_min,y_max)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::y_min,y_max
    REAL(KIND(1d0))::x_min,x_max
    CHARACTER(len=2)::tag,stag
    INTEGER::nuclearA,i
    IF(nuclearA_beam1.NE.0)THEN
       nuclearA=nuclearA_beam1
    ELSEIF(nuclearA_beam2.NE.0)THEN
       nuclearA=nuclearA_beam2
    ELSE
       nuclearA=0
    ENDIF
    CALL nuclear_tag(nuclearA,tag)
    stag="\\"
    x_min=(10d0)**min_ixp
    x_max=(10d0)**max_ixp
    OPEN(UNIT=12335,FILE="./output/result_PDF_ERROR.gnuplot")
    WRITE(12335,105)y_min,y_max,x_min,x_max,(TRIM(tag),i=0,10),scale,(stag,i=1,10)
    CLOSE(UNIT=12335)

105 FORMAT(/1X,&
         'y_min=',E15.7,/1X,&
         'y_max=',E15.7,/1X,&
         'x_min=',E15.7,/1X,&
         'x_max=',E15.7,/2X,&
         'check_y_min(a) = (a < y_min ? y_min : a)',/1X,&
         'check_y_max(a) = (a > y_max ? y_max : a)',/1X,&
         'divide(a,b) = (b == 0.0 ? y_min : check_y_max(check_y_min(a/b)))',/2X,&
         "aGet(name, i) = value(sprintf('_%s_%i',name,i))",/1X,&
         "aSetStr(name,i,value) = sprintf('_%s_%i = ",'"%s"',"', name, i, value)",/2X,&
         'eval aSetStr("file",0,"gl")',/1X,&
         'eval aSetStr("file",1,"dq")',/1X,&
         'eval aSetStr("file",6,"db")',/1X,&
         'eval aSetStr("file",2,"uq")',/1X,&
         'eval aSetStr("file",7,"ub")',/1X,&
         'eval aSetStr("file",3,"sq")',/1X,&
         'eval aSetStr("file",8,"sb")',/1X,&
         'eval aSetStr("file",4,"cq")',/1X,&
         'eval aSetStr("file",9,"cb")',/1X,&
         'eval aSetStr("file",5,"bq")',/1X,&
         'eval aSetStr("file",10,"bb")',/2X,&
         'eval aSetStr("ylabel",0,"g^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",1,"d^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",6,"~d{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",2,"u^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",7,"~u{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",3,"s^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",8,"~s{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",4,"c^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",9,"~c{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",5,"b^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",10,"~b{.5-}^{',A,'}(x)")',/2X,&
         'set terminal postscript portrait enhanced mono dashed lw 1.0 "Helvetica,22"',/3X,&
         'set output "result_PDF_ERROR.ps"',/2X,&
         'do for [i=0:10] {',/1X,&
         'reset',/1X,&
         'set lmargin 5.0',/1X,&
         'set rmargin 0.0',/2X,&
         'set style line 1 lt 1 lc rgb "black" lw 1.8 pt 7 ps 0.8',/1X,&
         'set style line 2 lt 1 lc rgb "red" lw 1.8 pt 7 ps 0.5',/1X,&
         'set style line 3 lt 1 lc rgb "forest-green" lw 1.8',/1X,&
         'set style line 4 lt 1 lc rgb "blue" lw 1.8',/1X,&
         'set style line 100 lt 2 lc rgb "black" lw 1',/1X,&
         'set style data histeps',/1X,&
         'set tics front',/2X,&
         'set xlabel "x"',/1X,&
         "set ylabel 'relative uncer. [%]'",/1X,&
         'set label aGet("ylabel",i) font "Helvetica, 18" at graph 0.8, graph 0.9',/1X,&
         'set label "Q=',E9.3,' GeV" font "Helvetica, 18" at graph 0.2, graph 0.1',/1X,&
         'set label front "HELAC-ONIA" font "Helvetica, 15" rotate by 90 at graph 1.02, graph 0.4',/1X,&
         'set key at graph 0.5, graph 0.9 noautotitles spacing 2.4 width -4.5 vertical font ",14" maxrows 1 samplen 0.5',/1X,&
         'set xrange [x_min:x_max]',/1X,&
         'set yrange [y_min:y_max]',/1X,&
         'set mytics 10',/1X,&
         'set origin 0.00, 0.2',/1X,&
         'set size 1, 0.7',/1X,&
         'set logscale x',/1X,&
         'set format x "10^{%T}"',/1X,&
         'plot ',A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(100*(divide($3,$2)-1)) with lines ls 2 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(100*(divide($4,$2)-1)) with lines ls 2 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(100*(divide($3,$2)-1)):",&
         "(100*(divide($4,$2)-1)) with filledcurve ls 2 fs transparent pattern 4 title 'pdf',",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(100*(divide($6,$5)-1)) with lines ls 3 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(100*(divide($7,$5)-1)) with lines ls 3 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(100*(divide($6,$5)-1)):",&
         "(100*(divide($7,$5)-1)) with filledcurve ls 3 fs transparent pattern 5 title 'replica',",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(100*(divide($9,$8)-1)) with lines ls 4 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(100*(divide($10,$8)-1)) with lines ls 4 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(100*(divide($9,$8)-1)):",&
         "(100*(divide($10,$8)-1)) with filledcurve ls 4 fs transparent pattern 6 title 'rwgt',",A1,/1X,&
         '1 ls 100',/2X,&
         '}',/2X,&
         '!open "result_PDF_ERROR.ps"')
  END SUBROUTINE GNUPLOT_PDF_ERROR

  SUBROUTINE GNUPLOT_RPDF(y_min,y_max)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::y_min,y_max
    REAL(KIND(1d0))::x_min,x_max
    CHARACTER(len=2)::tag,stag
    INTEGER::nuclearA,i
    IF(nuclearA_beam1.NE.0)THEN
       nuclearA=nuclearA_beam1
    ELSEIF(nuclearA_beam2.NE.0)THEN
       nuclearA=nuclearA_beam2
    ELSE
       nuclearA=0
    ENDIF
    CALL nuclear_tag(nuclearA,tag)
    stag="\\"
    x_min=(10d0)**min_ixp
    x_max=(10d0)**max_ixp
    OPEN(UNIT=12335,FILE="./output/result_RPDF.gnuplot")
    WRITE(12335,106)y_min,y_max,x_min,x_max,(TRIM(tag),i=0,10),scale,(stag,i=1,10)
    CLOSE(UNIT=12335)

106 FORMAT(/1X,&
         'y_min=',E15.7,/1X,&
         'y_max=',E15.7,/1X,&
         'x_min=',E15.7,/1X,&
         'x_max=',E15.7,/2X,&
         'check_y_min(a) = (a < y_min ? y_min : a)',/1X,&
         'check_y_max(a) = (a > y_max ? y_max : a)',/1X,&
         'divide(a,b) = (b == 0.0 ? y_min : check_y_max(check_y_min(a/b)))',/2X,&
         "aGet(name, i) = value(sprintf('_%s_%i',name,i))",/1X,&
         "aSetStr(name,i,value) = sprintf('_%s_%i = ",'"%s"',"', name, i, value)",/2X,&
         'eval aSetStr("file",0,"gl")',/1X,&
         'eval aSetStr("file",1,"dq")',/1X,&
         'eval aSetStr("file",6,"db")',/1X,&
         'eval aSetStr("file",2,"uq")',/1X,&
         'eval aSetStr("file",7,"ub")',/1X,&
         'eval aSetStr("file",3,"sq")',/1X,&
         'eval aSetStr("file",8,"sb")',/1X,&
         'eval aSetStr("file",4,"cq")',/1X,&
         'eval aSetStr("file",9,"cb")',/1X,&
         'eval aSetStr("file",5,"bq")',/1X,&
         'eval aSetStr("file",10,"bb")',/2X,&
         'eval aSetStr("ylabel",0,"g^{',A,'}(x)/g^{p}(x)")',/1X,&
         'eval aSetStr("ylabel",1,"d^{',A,'}(x)/d^{p}(x)")',/1X,&
         'eval aSetStr("ylabel",6,"~d{.5-}^{',A,'}(x)/~d{.5-}^{p}(x)")',/1X,&
         'eval aSetStr("ylabel",2,"u^{',A,'}(x)/u^{p}(x)")',/1X,&
         'eval aSetStr("ylabel",7,"~u{.5-}^{',A,'}(x)/~u{.5-}^{p}(x)")',/1X,&
         'eval aSetStr("ylabel",3,"s^{',A,'}(x)/s^{p}(x)")',/1X,&
         'eval aSetStr("ylabel",8,"~s{.5-}^{',A,'}(x)/~s{.5-}^{p}(x)")',/1X,&
         'eval aSetStr("ylabel",4,"c^{',A,'}(x)/c^{p}(x)")',/1X,&
         'eval aSetStr("ylabel",9,"~c{.5-}^{',A,'}(x)/~c{.5-}^{p}(x)")',/1X,&
         'eval aSetStr("ylabel",5,"b^{',A,'}(x)/b^{p}(x)")',/1X,&
         'eval aSetStr("ylabel",10,"~b{.5-}^{',A,'}(x)/~b{.5-}^{p}(x)")',/2X,&
         'set terminal postscript portrait enhanced mono dashed lw 1.0 "Helvetica,22"',/3X,&
         'set output "result_RPDF.ps"',/2X,&
         'do for [i=0:10] {',/1X,&
         'reset',/1X,&
         'set lmargin 5.0',/1X,&
         'set rmargin 0.0',/2X,&
         'set style line 1 lt 1 lc rgb "black" lw 1.8 pt 7 ps 0.8',/1X,&
         'set style line 2 lt 1 lc rgb "red" lw 1.8 pt 7 ps 0.5',/1X,&
         'set style line 3 lt 1 lc rgb "forest-green" lw 1.8',/1X,&
         'set style line 4 lt 1 lc rgb "blue" lw 1.8',/1X,&
         'set style line 100 lt 2 lc rgb "black" lw 1',/1X,&
         'set style data histeps',/1X,&
         'set tics front',/2X,&
         'set xlabel "x"',/1X,&
         'set ylabel aGet("ylabel",i)',/1X,&
         'set label "Q=',E9.3,' GeV" font "Helvetica, 18" at graph 0.2, graph 0.1',/1X,&
         'set label front "HELAC-ONIA" font "Helvetica, 15" rotate by 90 at graph 1.02, graph 0.4',/1X,&
         'set key at graph 0.5, graph 0.9 noautotitles spacing 2.4 width -4.5 vertical font ",14" maxrows 1 samplen 0.5',/1X,&
         'set xrange [x_min:x_max]',/1X,&
         'set yrange [y_min:y_max]',/1X,&
         'set mytics 10',/1X,&
         'set origin 0.00, 0.2',/1X,&
         'set size 1, 0.7',/1X,&
         'set logscale x',/1X,&
         'set format x "10^{%T}"',/1X,&
         'plot ',A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(divide($3,$11)) with lines ls 2 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(divide($4,$11)) with lines ls 2 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(divide($3,$11)):",&
         "(divide($4,$11)) with filledcurve ls 2 fs transparent pattern 4 title 'pdf',",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(divide($6,$11)) with lines ls 3 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(divide($7,$11)) with lines ls 3 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(divide($6,$11)):",&
         "(divide($7,$11)) with filledcurve ls 3 fs transparent pattern 5 title 'replica',",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(divide($9,$11)) with lines ls 4 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(divide($10,$11)) with lines ls 4 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(divide($9,$11)):",&
         "(divide($10,$11)) with filledcurve ls 4 fs transparent pattern 6 title 'rwgt',",A1,/1X,&
         '1 ls 100',/2X,&
         '}',/2X,&
         '!open "result_RPDF.ps"')
  END SUBROUTINE GNUPLOT_RPDF

  SUBROUTINE GNUPLOT_REPLICAoPDF(y_min,y_max)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::y_min,y_max
    REAL(KIND(1d0))::x_min,x_max
    INTEGER::nuclearA,i
    CHARACTER(len=2)::tag,stag
    IF(nuclearA_beam1.NE.0)THEN
       nuclearA=nuclearA_beam1
    ELSEIF(nuclearA_beam2.NE.0)THEN
       nuclearA=nuclearA_beam2
    ELSE
       nuclearA=0
    ENDIF
    CALL nuclear_tag(nuclearA,tag)
    stag="\\"
    x_min=(10d0)**min_ixp
    x_max=(10d0)**max_ixp
    OPEN(UNIT=12335,FILE="./output/result_REPLICAoPDF.gnuplot")
    WRITE(12335,107)y_min,y_max,x_min,x_max,(TRIM(tag),i=0,10),scale,(stag,i=1,2)
    CLOSE(UNIT=12335)

107 FORMAT(/1X,&
         'y_min=',E15.7,/1X,&
         'y_max=',E15.7,/1X,&
         'x_min=',E15.7,/1X,&
         'x_max=',E15.7,/2X,&
         'check_y_min(a) = (a < y_min ? y_min : a)',/1X,&
         'check_y_max(a) = (a > y_max ? y_max : a)',/1X,&
         'divide(a,b) = (b == 0.0 ? y_min : check_y_max(check_y_min(a/b)))',/2X,&
         "aGet(name, i) = value(sprintf('_%s_%i',name,i))",/1X,&
         "aSetStr(name,i,value) = sprintf('_%s_%i = ",'"%s"',"', name, i, value)",/2X,&
         'eval aSetStr("file",0,"gl")',/1X,&
         'eval aSetStr("file",1,"dq")',/1X,&
         'eval aSetStr("file",6,"db")',/1X,&
         'eval aSetStr("file",2,"uq")',/1X,&
         'eval aSetStr("file",7,"ub")',/1X,&
         'eval aSetStr("file",3,"sq")',/1X,&
         'eval aSetStr("file",8,"sb")',/1X,&
         'eval aSetStr("file",4,"cq")',/1X,&
         'eval aSetStr("file",9,"cb")',/1X,&
         'eval aSetStr("file",5,"bq")',/1X,&
         'eval aSetStr("file",10,"bb")',/2X,&
         'eval aSetStr("ylabel",0,"g^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",1,"d^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",6,"~d{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",2,"u^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",7,"~u{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",3,"s^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",8,"~s{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",4,"c^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",9,"~c{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",5,"b^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",10,"~b{.5-}^{',A,'}(x)")',/2X,&
         'set terminal postscript portrait enhanced mono dashed lw 1.0 "Helvetica,22"',/3X,&
         'set output "result_REPLICAoPDF.ps"',/2X,&
         'do for [i=0:10] {',/1X,&
         'reset',/1X,&
         'set lmargin 5.0',/1X,&
         'set rmargin 0.0',/2X,&
         'set style line 1 lt 1 lc rgb "black" lw 1.8 pt 7 ps 0.8',/1X,&
         'set style line 2 lt 1 lc rgb "red" lw 1.8 pt 7 ps 0.5',/1X,&
         'set style line 3 lt 1 lc rgb "forest-green" lw 1.8',/1X,&
         'set style line 4 lt 1 lc rgb "blue" lw 1.8',/1X,&
         'set style line 100 lt 2 lc rgb "black" lw 1',/1X,&
         'set style data histeps',/1X,&
         'set tics front',/2X,&
         'set xlabel "x"',/1X,&
         'set label aGet("ylabel",i) font "Helvetica, 18" at graph 0.8, graph 0.9',/1X,&
         'set label "Q=',E9.3,' GeV" font "Helvetica, 18" at graph 0.2, graph 0.1',/1X,&
         'set label front "HELAC-ONIA" font "Helvetica, 15" rotate by 90 at graph 1.02, graph 0.4',/1X,&
         'set key at graph 0.5, graph 0.9 noautotitles spacing 2.4 width -4.5 vertical font ",14" maxrows 1 samplen 0.5',/1X,&
         'set xrange [x_min:x_max]',/1X,&
         'set yrange [y_min:y_max]',/1X,&
         'set mytics 10',/1X,&
         'set origin 0.00, 0.2',/1X,&
         'set size 1, 0.7',/1X,&
         'set logscale x',/1X,&
         'set format x "10^{%T}"',/1X,&
         'plot ',A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:(divide($5,$2)) with lines ls 2 title 'replica/pdf',",A1,/1X,&
         '1 ls 100',/2X,&
         '}',/2X,&
         '!open "result_REPLICAoPDF.ps"')
  END SUBROUTINE GNUPLOT_REPLICAoPDF

  SUBROUTINE GNUPLOT_xPDF(y_min,y_max)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::y_min,y_max
    REAL(KIND(1d0))::x_min,x_max
    CHARACTER(len=2)::tag,stag
    INTEGER::nuclearA,i
    IF(nuclearA_beam1.NE.0)THEN
       nuclearA=nuclearA_beam1
    ELSEIF(nuclearA_beam2.NE.0)THEN
       nuclearA=nuclearA_beam2
    ELSE
       nuclearA=0
    ENDIF
    CALL nuclear_tag(nuclearA,tag)
    stag="\\"
    x_min=(10d0)**min_ixp
    x_max=(10d0)**max_ixp
    OPEN(UNIT=12335,FILE="./output/result_xPDF.gnuplot")
    WRITE(12335,108)y_min,y_max,x_min,x_max,(TRIM(tag),i=0,10),scale,(stag,i=1,9)
    CLOSE(UNIT=12335)

108 FORMAT(/1X,&
         'y_min=',E15.7,/1X,&
         'y_max=',E15.7,/1X,&
         'x_min=',E15.7,/1X,&
         'x_max=',E15.7,/2X,&
         'check_y_min(a) = (a < y_min ? y_min : a)',/1X,&
         'check_y_max(a) = (a > y_max ? y_max : a)',/1X,&
         'divide(a,b) = (b == 0.0 ? y_min : check_y_max(check_y_min(a/b)))',/2X,&
         "aGet(name, i) = value(sprintf('_%s_%i',name,i))",/1X,&
         "aSetStr(name,i,value) = sprintf('_%s_%i = ",'"%s"',"', name, i, value)",/2X,&
         'eval aSetStr("file",0,"gl")',/1X,&
         'eval aSetStr("file",1,"dq")',/1X,&
         'eval aSetStr("file",6,"db")',/1X,&
         'eval aSetStr("file",2,"uq")',/1X,&
         'eval aSetStr("file",7,"ub")',/1X,&
         'eval aSetStr("file",3,"sq")',/1X,&
         'eval aSetStr("file",8,"sb")',/1X,&
         'eval aSetStr("file",4,"cq")',/1X,&
         'eval aSetStr("file",9,"cb")',/1X,&
         'eval aSetStr("file",5,"bq")',/1X,&
         'eval aSetStr("file",10,"bb")',/2X,&
         'eval aSetStr("ylabel",0,"xg^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",1,"xd^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",6,"x~d{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",2,"xu^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",7,"x~u{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",3,"xs^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",8,"x~s{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",4,"xc^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",9,"x~c{.5-}^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",5,"xb^{',A,'}(x)")',/1X,&
         'eval aSetStr("ylabel",10,"x~b{.5-}^{',A,'}(x)")',/2X,&
         'set terminal postscript portrait enhanced mono dashed lw 1.0 "Helvetica,22"',/3X,&
         'set output "result_xPDF.ps"',/2X,&
         'do for [i=0:10] {',/1X,&
         'reset',/1X,&
         'set lmargin 5.0',/1X,&
         'set rmargin 0.0',/2X,&
         'set style line 1 lt 1 lc rgb "black" lw 1.8 pt 7 ps 0.8',/1X,&
         'set style line 2 lt 1 lc rgb "red" lw 1.8 pt 7 ps 0.5',/1X,&
         'set style line 3 lt 1 lc rgb "forest-green" lw 1.8',/1X,&
         'set style line 4 lt 1 lc rgb "blue" lw 1.8',/1X,&
         'set style line 100 lt 2 lc rgb "black" lw 1',/1X,&
         'set style data histeps',/1X,&
         'set tics front',/2X,&
         'set xlabel "x"',/1X,&
         "set ylabel aGet('ylabel',i)",/1X,&
         'set label "Q=',E9.3,' GeV" font "Helvetica, 18" at graph 0.2, graph 0.1',/1X,&
         'set label front "HELAC-ONIA" font "Helvetica, 15" rotate by 90 at graph 1.02, graph 0.4',/1X,&
         'set key at graph 0.9, graph 0.9 noautotitles spacing 2.4 width -4.5 vertical font ",14" maxrows 1 samplen 0.5',/1X,&
         'set xrange [x_min:x_max]',/1X,&
         'set mytics 10',/1X,&
         'set origin 0.00, 0.2',/1X,&
         'set size 1, 0.7',/1X,&
         'set logscale x',/1X,&
         'set format x "10^{%T}"',/1X,&
         'plot ',A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:($1*$3) with lines ls 2 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:($1*$4) with lines ls 2 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:($1*$3):",&
         "($1*$4) with filledcurve ls 2 fs transparent pattern 4 title 'pdf',",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:($1*$6) with lines ls 3 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:($1*$7) with lines ls 3 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:($1*$6):",&
         "($1*$7) with filledcurve ls 3 fs transparent pattern 5 title 'replica',",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:($1*$9) with lines ls 4 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:($1*$10) with lines ls 4 notitle,",A1,/1X,&
         "'result_'.aGet('file',i).'.dat' using 1:($1*$9):",&
         "($1*$10) with filledcurve ls 4 fs transparent pattern 6 title 'rwgt'",/2X,&
         '}',/2X,&
         '!open "result_xPDF.ps"')
  END SUBROUTINE GNUPLOT_xPDF

  SUBROUTINE nuclear_tag(nuclearA,tag)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::nuclearA
    CHARACTER(len=2),INTENT(OUT)::tag
    SELECT CASE(nuclearA)
    CASE(0)
       tag='p '
    CASE(1)
       tag='H '
    CASE(4)
       tag='He'
    CASE(6)
       tag='Li'
    CASE(9)
       tag='Be'
    CASE(10)
       tag='B '
    CASE(12)
       tag='C '
    CASE(14)
       tag='N '
    CASE(16)
       tag='O '
    CASE(19)
       tag='F '
    CASE(20)
       tag='Ne'
    CASE(23)
       tag='Na'
    CASE(24)
       tag='Mg'
    CASE(27)
       tag='Al'
    CASE(28)
       tag='Si'
    CASE(31)
       tag='P '
    CASE(32)
       tag='S '
    CASE(35)
       tag='Cl'
    CASE(38)
       tag='Ar'
    CASE(39)
       tag='K '
    CASE(40)
       tag='Ca'
    CASE(45)
       tag='Sc'
    CASE(48)
       tag='Ti'
    CASE(51)
       tag='V '
    CASE(52)
       tag='Cr'
    CASE(55)
       tag='Mn'
    CASE(56)
       tag='Fe'
    CASE(58)
       tag='Co'
    CASE(59)
       tag='Ni'
    CASE(64)
       tag='Cu'
    CASE(65)
       tag='Zn'
    CASE(70)
       tag='Ga'
    CASE(73)
       tag='Ge'
    CASE(75)
       tag='As'
    CASE(79)
       tag='Se'
    CASE(80)
       tag='Br'
    CASE(84)
       tag='Kr'
    CASE(85)
       tag='Rb'
    CASE(88)
       tag='Sr'
    CASE(89)
       tag='Y '
    CASE(91)
       tag='Zr'
    CASE(93)
       tag='Nb'
    CASE(96)
       tag='Mo'
    CASE(98)
       tag='Te'
    CASE(101)
       tag='Ru'
    CASE(103)
       tag='Rh'
    CASE(106)
       tag='Pd'
    CASE(108)
       tag='Ag'
    CASE(112)
       tag='Cd'
    CASE(115)
       tag='In'
    CASE(117)
       tag='Sn'
    CASE(122)
       tag='Sb'
    CASE(128)
       tag='Te'
    CASE(127)
       tag='I '
    CASE(131)
       tag='Xe'
    CASE(133)
       tag='Cs'
    CASE(137)
       tag='Ba'
    CASE(178)
       tag='Hf'
    CASE(181)
       tag='Ta'
    CASE(184)
       tag='W '
    CASE(186)
       tag='Ke'
    CASE(190)
       tag='Os'
    CASE(192)
       tag='Ir'
    CASE(195)
       tag='Pt'
    CASE(197)
       tag='Au'
    CASE(201)
       tag='Hg'
    CASE(204)
       tag='Tl'
    CASE(208)
       tag='Pb'
    CASE(209)
       tag='Bi'
    CASE(210)
       tag='Po'
    CASE(211)
       tag='At'
    CASE(222)
       tag='Rn'
    CASE(223)
       tag='Fr'
    CASE(226)
       tag='Ra'
    CASE(261)
       tag='Rf'
    CASE(262)
       tag='Db'
    CASE(266)
       tag='Sg'
    CASE(238)
       tag='U '
    CASE DEFAULT
       WRITE(*,*)"ERROR:Unknown the A of nuclear = ",nuclearA
       STOP
    END SELECT
    RETURN
  END SUBROUTINE nuclear_tag
END MODULE plot_lhapdf_rwgt
