HODIR=
FC=
objdir=$(HODIR)/addon/lhapdf_rwgt/obj/
moddir=$(HODIR)/addon/lhapdf_rwgt/mod/
srcdir=$(HODIR)/src/
thissrcdir=$(HODIR)/addon/lhapdf_rwgt/src/
nucdir=$(HODIR)/nuclear/
fundir=$(HODIR)/specialfuns/
decaydir=$(HODIR)/decay/
libdir=$(HODIR)/lib/
showerdir=$(HODIR)/shower/interface/
lhapdfobj=
obj=$(objdir)Helac_Global.o $(objdir)Helac_Func_1.o $(objdir)CTEQ6PDF.o $(objdir)setscale.o $(objdir)Structf_PDFs.o $(objdir)photon_PDFs.o $(objdir)alfas_functions.o $(lhapdfobj) $(objdir)lhapdf_rwgt.o $(objdir)lhapdf_rwgt_global.o $(objdir)Main_lhapdf_rwgt.o $(objdir)Constants.o $(objdir)plot_lhapdf_rwgt.o $(objdir)tbessk.o $(objdir)tbessj.o $(objdir)nielsen_generalized_polylog.o $(objdir)nintlib.o $(objdir)interpolation.o $(objdir)OpticalGlauber_Geometry.o $(objdir)ElasticPhotonPhotonFlux.o
mod = $(moddir)*.mod
exe = $(HODIR)/bin/HO_lhapdf_rwgt
linkexe = $(HODIR)/addon/lhapdf_rwgt/bin/HO_lhapdf_rwgt
EXLIBS = 
all :   clean $(exe)
	ln -s $(exe) $(linkexe)

$(exe): $(obj)
	@cp *.o $(objdir)
	@cp *.mod $(moddir)
	@rm *.o *.mod
	$(FC) -o $(exe) $(obj) -L$(libdir) -lpdf $(EXLIBS)

$(objdir)Main_lhapdf_rwgt.o : $(thissrcdir)Main_lhapdf_rwgt.f90 $(moddir)lhapdf_rwgt.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)lhapdf_rwgt_global.o $(moddir)lhapdf_rwgt_global.mod: $(thissrcdir)lhapdf_rwgt_global.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Helac_Global.o $(moddir)Helac_Global.mod : $(srcdir)Helac_Global.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Helac_Func_1.o $(moddir)Helac_Func_1.mod : $(srcdir)Helac_Func_1.f90 $(moddir)Helac_Global.mod $(moddir)alfas_functions.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_PDFs.o $(moddir)Structf_PDFs.mod : $(srcdir)Structf_PDFs.f90 $(moddir)Helac_Global.mod $(moddir)CTEQ6PDF.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod $(moddir)ElasticPhotonPhotonFlux.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)ElasticPhotonPhotonFlux.o $(moddir)ElasticPhotonPhotonFlux.mod:$(nucdir)ElasticPhotonPhotonFlux.f90 $(moddir)OpticalGlauber_Geometry.mod $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)nintlib.o $(moddir)nintlib.mod: $(nucdir)nintlib.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)tbessk.o : $(fundir)tbessk.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)tbessj.o : $(fundir)tbessj.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)nielsen_generalized_polylog.o $(moddir)nielsen_generalized_polylog.mod : $(fundir)nielsen_generalized_polylog.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)OpticalGlauber_Geometry.o $(moddir)OpticalGlauber_Geometry.mod: $(nucdir)OpticalGlauber_Geometry.f90 $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)nielsen_generalized_polylog.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)interpolation.o $(moddir)interpolation.mod: $(nucdir)interpolation.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)CTEQ6PDF.o $(moddir)CTEQ6PDF.mod: $(srcdir)CTEQ6PDF.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)alfas_functions.o $(moddir)alfas_functions.mod: $(srcdir)alfas_functions.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)setscale.o $(moddir)setscale.mod: $(srcdir)setscale.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)lhapdf_rwgt.o $(moddir)lhapdf_rwgt.mod : $(thissrcdir)lhapdf_rwgt.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod $(moddir)Structf_PDFs.mod $(moddir)lhapdf_rwgt_global.mod $(moddir)Constants.mod $(moddir)plot_lhapdf_rwgt.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)lhapdf_rwgt_LHAPDFs.o : $(thissrcdir)lhapdf_rwgt_LHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)lhapdf_rwgt_global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Constants.o $(moddir)Constants.mod: $(srcdir)Constants.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_LHAPDFs.o : $(srcdir)Structf_LHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)photon_PDFs.o $(moddir)photon_PDFs.mod : $(srcdir)photon_PDFs.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_LHAnPDFs.o : $(srcdir)Structf_LHAnPDFs.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_MLHAPDFs.o : $(srcdir)Structf_MLHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)plot_lhapdf_rwgt.o $(moddir)plot_lhapdf_rwgt.mod: $(thissrcdir)plot_lhapdf_rwgt.f90 $(moddir)Helac_Global.mod $(moddir)lhapdf_rwgt_global.mod
	$(FC) -c $< $(FFLAGS)
clean:
	rm -rf $(obj) $(mod) $(exe) $(linkexe) $(HODIR)/tmp/* *~ $(HODIR)/input/*~ $(HODIR)/src/*~ $(thissrcdir)*~ $(HODIR)/output/* fort.*
end
