SUBROUTINE strf_lhapdf_pp_NOnia_mps(ipip,wsf)
USE Helac_Global
USE pp_NOnia_mps_global
INTEGER,INTENT(IN)::ipip
INTEGER::ipp=1  ! ipp=1 ppbar ; ipp=2 pp
INTEGER::ih=1   ! ih=1 no photon PDF,ih=2, photon from proton/anti-proton,ih=3 photon from electron/positron 
REAL(KIND=DBL),INTENT(OUT)::wsf          
CHARACTER(len=20),DIMENSION(20)::parm
REAL(KIND=DBL),DIMENSION(20)::val
REAL(KIND=DBL),DIMENSION(-7:7)::pdflist
INTEGER::init=0      
SAVE init,ipp,ih
REAL(KIND=DBL)::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
                ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct

IF((COLL_TYPE.GE.15.AND.COLL_TYPE.LE.16).OR.&
     (COLL_TYPE.GE.19.AND.COLL_TYPE.LE.20))THEN
   CALL strf_resolvedphoton_lhapdf_pp_NOnia_mps(ipip,wsf)
   RETURN
ENDIF
IF(init.EQ.0)THEN
   IF(.NOT.lhapdfwrapinit)THEN
      CALL lhapdfwrap
      lhapdfwrapinit=.TRUE.
   ENDIF
   IF(Coll_Type.EQ.1)THEN
      ipp=2
   ELSE
      ipp=1
   ENDIF
   init=1
ENDIF

scale=mps_pmom(ipip,3,1)**2+mps_pmom(ipip,3,2)**2+mpsi(ipip)**2
scale=DSQRT(scale)

CALL pftopdglha(ih,xp1,scale,pdflist(-7:7))
glu1_ct = xp1*pdflist(0)
u1_ct   = xp1*pdflist(2)
d1_ct   = xp1*pdflist(1)
s1_ct   = xp1*pdflist(3)
c1_ct   = xp1*pdflist(4)
b1_ct   = xp1*pdflist(5)
ub1_ct  = xp1*pdflist(-2)
db1_ct  = xp1*pdflist(-1)
sb1_ct  = xp1*pdflist(-3)
cb1_ct  = xp1*pdflist(-4)
bb1_ct  = xp1*pdflist(-5)
CALL pftopdglha(ih,xp2,scale,pdflist(-7:7))
glu2_ct = xp2*pdflist(0)
u2_ct   = xp2*pdflist(2)
d2_ct   = xp2*pdflist(1)
s2_ct   = xp2*pdflist(3)
c2_ct   = xp2*pdflist(4)
b2_ct   = xp2*pdflist(5)
ub2_ct  = xp2*pdflist(-2)
db2_ct  = xp2*pdflist(-1)
sb2_ct  = xp2*pdflist(-3)
cb2_ct  = xp2*pdflist(-4)
bb2_ct  = xp2*pdflist(-5)

wsf=glu1_ct*glu2_ct*wjac/xp1/xp2
IF(mps_includeqq)THEN
   wsf=wsf+(u1_ct*ub2_ct+d1_ct*db2_ct+s1_ct*sb2_ct+c1_ct*cb2_ct+&
        ub1_ct*u2_ct+db1_ct*d2_ct+sb1_ct*s2_ct+cb1_ct*c2_ct)*wjac/xp1/xp2
ENDIF
IF(init.EQ.0)init=1
       
END SUBROUTINE strf_lhapdf_pp_NOnia_mps

SUBROUTINE strf_resolvedphoton_lhapdf_pp_NOnia_mps(ipip,wsf)
  USE Helac_Global
  USE pp_NOnia_mps_global
  IMPLICIT NONE
  INTEGER,INTENT(IN)::ipip
  INTEGER::ipp=1  ! ipp=1 ppbar ; ipp=2 pp
  INTEGER::ih=1   ! ih=1 no photon PDF,ih=2, photon from proton/anti-proton,ih=3 photon from electron/positron
  REAL(KIND(1d0)),INTENT(OUT)::wsf          
  CHARACTER(len=20),DIMENSION(20)::parm
  REAL(KIND(1d0)),DIMENSION(20)::val
  REAL(KIND(1d0)),DIMENSION(-7:7)::pdflist
  INTEGER::init=0      
  SAVE init,ipp,ih
  REAL(KIND(1d0))::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
       ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct
  REAL(KIND(1d0))::scale_square,q2max,alpha

  REAL(KIND(1d0)),EXTERNAL::GRVGL,GRVUL,GRVDL,GRVSL,GRVCL,GRVBL
  REAL(KIND(1d0)),EXTERNAL::GRVGH,GRVUH,GRVDH,GRVSH,GRVCH,GRVBH

  IF(init.EQ.0)THEN
     IF(.NOT.lhapdfwrapinit)THEN
        CALL lhapdfwrap
        lhapdfwrapinit=.TRUE.
     ENDIF
     IF(COLL_TYPE.EQ.15.OR.COLL_TYPE.EQ.19)THEN
        ! proton
        ipp=2
     ELSEIF(COLL_TYPE.EQ.16.OR.COLL_TYPE.EQ.20)THEN
        ! antiproton
        ipp=1
     ELSE
        WRITE(*,*)"Unknown COLL_TYPE in strf_resolvedphoton_lhapdf_pp_NOnia_mps"
        STOP
     ENDIF
     init=1
  ENDIF
  
  scale=mps_pmom(ipip,3,1)**2+mps_pmom(ipip,3,2)**2+mpsi(ipip)**2
  scale=DSQRT(scale)
  
  scale_square=scale**2
  IF(alphaem_elasticphoton.LT.0d0)THEN
     alpha = 0.0072992701d0
  ELSE
     alpha=alphaem_elasticphoton
  ENDIF
  ! GRV*L (LO) and GRV*H (NLO) are defined in pdf/grv.f
  IF(Resolved_photon_type.EQ.1)THEN
     glu1_ct = xp1*GRVGL(xp1,scale_square)*alpha
     u1_ct   = xp1*GRVUL(xp1,scale_square)*alpha
     d1_ct   = xp1*GRVDL(xp1,scale_square)*alpha
     s1_ct   = xp1*GRVSL(xp1,scale_square)*alpha
     c1_ct   = xp1*GRVCL(xp1,scale_square)*alpha
     b1_ct   = xp1*GRVBL(xp1,scale_square)*alpha
     ub1_ct  = u1_ct
     db1_ct  = d1_ct
     sb1_ct  = s1_ct
     cb1_ct  = c1_ct
     bb1_ct  = b1_ct
  ELSE
     glu1_ct = xp1*GRVGH(xp1,scale_square)*alpha
     u1_ct   = xp1*GRVUH(xp1,scale_square)*alpha
     d1_ct   = xp1*GRVDH(xp1,scale_square)*alpha
     s1_ct   = xp1*GRVSH(xp1,scale_square)*alpha
     c1_ct   = xp1*GRVCH(xp1,scale_square)*alpha
     b1_ct   = xp1*GRVBH(xp1,scale_square)*alpha
     ub1_ct  = u1_ct
     db1_ct  = d1_ct
     sb1_ct  = s1_ct
     cb1_ct  = c1_ct
     bb1_ct  = b1_ct
  ENDIF

  CALL pftopdglha(ih,xp2,scale,pdflist(-7:7))
  glu2_ct = xp2*pdflist(0)
  u2_ct   = xp2*pdflist(2)
  d2_ct   = xp2*pdflist(1)
  s2_ct   = xp2*pdflist(3)
  c2_ct   = xp2*pdflist(4)
  b2_ct   = xp2*pdflist(5)
  ub2_ct  = xp2*pdflist(-2)
  db2_ct  = xp2*pdflist(-1)
  sb2_ct  = xp2*pdflist(-3)
  cb2_ct  = xp2*pdflist(-4)
  bb2_ct  = xp2*pdflist(-5)
  
  wsf=glu1_ct*glu2_ct*wjac/xp1/xp2
  IF(mps_includeqq)THEN
     wsf=wsf+(u1_ct*ub2_ct+d1_ct*db2_ct+s1_ct*sb2_ct+c1_ct*cb2_ct+&
          ub1_ct*u2_ct+db1_ct*d2_ct+sb1_ct*s2_ct+cb1_ct*c2_ct)*wjac/xp1/xp2
  ENDIF
  IF(init.EQ.0)init=1
END SUBROUTINE strf_resolvedphoton_lhapdf_pp_NOnia_mps
