MODULE pp_NOnia_MPS_ME
  USE pp_NOnia_mps_global
  USE Helac_Global
  IMPLICIT NONE
CONTAINS
  ! Eq.(4) in arXiv:1105.4186
  SUBROUTINE crystalball_gg_psiX(ipsi,wme)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(OUT)::wme
    INTEGER,INTENT(IN)::ipsi
    REAL(KIND(1d0))::KK,pt
    INTEGER::init=0
    INTEGER::nn=2,i
    REAL(KIND(1d0))::ptavg=4.5d0
    REAL(KIND(1d0))::shat
    SAVE init
    IF(init.EQ.0)THEN
       DO i=1,mps_number
          icol_un(2*i-1,1)=1+3*(i-1)
          icol_un(2*i+2*mps_number,2)=1+3*(i-1)
          icol_un(2*i+2*mps_number,1)=2+3*(i-1)
          icol_un(2*i,2)=2+3*(i-1)
          icol_un(2*i,1)=3+3*(i-1)
          icol_un(2*i-1,2)=3+3*(i-1)
          icol_un(2*i-1+2*mps_number,1)=0
          icol_un(2*i-1+2*mps_number,2)=0
       ENDDO
       AQEDUP=1d0/137d0
       AQCDUP=0.118d0
       init=1
    ENDIF
    KK=mps_lam(ipsi)**2*mps_kapa(ipsi)/mpsi(ipsi)**2
    nn=mps_n(ipsi)
    ptavg=mps_ptavg(ipsi)
    pt=DSQRT(mps_pmom(ipsi,3,1)**2+mps_pmom(ipsi,3,2)**2)
    shat=(mps_pmom(ipsi,1,1)+mps_pmom(ipsi,2,1))**2&
         +(mps_pmom(ipsi,1,2)+mps_pmom(ipsi,2,2))**2&
         +(mps_pmom(ipsi,1,3)+mps_pmom(ipsi,2,3))**2
    shat=(mps_pmom(ipsi,1,4)+mps_pmom(ipsi,2,4))**2-shat
    IF(pt.LE.ptavg)THEN
       wme=KK*shat*DEXP(-mps_kapa(ipsi)*pt**2/mpsi(ipsi)**2)
    ELSE
       wme=KK*shat*DEXP(-mps_kapa(ipsi)*ptavg**2/mpsi(ipsi)**2)&
            *1d0/(1d0+mps_kapa(ipsi)/nn*(pt**2-ptavg**2)/mpsi(ipsi)**2)**nn
    ENDIF
    RETURN
  END SUBROUTINE crystalball_gg_psiX
END MODULE pp_NOnia_MPS_ME
