  SUBROUTINE reweight_xsec_pdf_pp_oniumquark_dps(ip,wsf0)
    IMPLICIT NONE
    INTEGER::init=0,i
    INTEGER,INTENT(IN)::ip ! ip = 1 or 2
    REAL(KIND(1d0)),INTENT(IN)::wsf0
    REAL(KIND(1d0))::wsfw
    SAVE init
    IF(.NOT.reweight_pdf)THEN
       WRITE(*,*)"ERROR:Please set reweight_pdf to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(MOD(ho_npdf,2).NE.0)THEN
          WRITE(*,*)'The number of error sets must be even',ho_npdf
          STOP
       ENDIF
       IF(MOD(ho_npdf2,2).NE.0)THEN
          WRITE(*,*)'The number of error sets for beam 2 must be even',ho_npdf2
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecpdf))THEN
          DEALLOCATE(wgtxsecpdf)
       ENDIF
       ALLOCATE(wgtxsecpdf(ho_npdf+ho_npdf2))
       IF(ho_npdf.GT.0)THEN
          IF(ALLOCATED(idpdf))THEN
             DEALLOCATE(idpdf)
          ENDIF
          ALLOCATE(idpdf(0:ho_npdf))
          idpdf(0)=iPDFSUP1
          idpdf(1)=ipdf_set_min
          IF(ipdf_set_max-ipdf_set_min+1.NE.ho_npdf)THEN
             WRITE(*,*)'Incorrect the number of error pdf',ho_npdf,ipdf_set_min,ipdf_set_max
             STOP
          ENDIF
          DO i=2,ho_npdf
             idpdf(i)=idpdf(1)+i-1
          ENDDO
          WRITE(*,*) 'Doing PDF reweight:'
          WRITE(*,*) 'Central set id: ',idpdf(0)
          WRITE(*,*) 'Min error set id: ',idpdf(1)
          WRITE(*,*) 'Max error set id: ',idpdf(ho_npdf)
       ENDIF
       IF(ho_npdf2.GT.0)THEN
          IF(ALLOCATED(idpdf2))THEN
             DEALLOCATE(idpdf2)
          ENDIF
          ALLOCATE(idpdf2(0:ho_npdf2))
          idpdf2(0)=iPDFSUP2
          idpdf2(1)=ipdf2_set_min
          IF(ipdf2_set_max-ipdf2_set_min+1.NE.ho_npdf2)THEN
             WRITE(*,*)'Incorrect the number of error pdf2',ho_npdf2,ipdf2_set_min,ipdf2_set_max
             STOP
          ENDIF
          DO i=2,ho_npdf2
             idpdf2(i)=idpdf2(1)+i-1
          ENDDO
	  WRITE(*,*) 'Doing PDF Beam 2 reweight:'
	  WRITE(*,*) 'Central set id: ',idpdf2(0)
	  WRITE(*,*) 'Min error set id: ',idpdf2(1)
       	  WRITE(*,*) 'Max error set id: ',idpdf2(ho_npdf2)
       ENDIF
       init=1
    ENDIF
    IF(.NOT.multipdfloading)THEN
       DO i=1,ho_npdf
          INCLUDE "../../../input/lhapdf/call_initpdf"
          CALL strf_pdf_pp_oniumquark_dps(ip,wsfw)
	  IF(ip.EQ.1)THEN
            wgtxsecpdf(i)=wsfw/wsf0
	  ELSE
            wgtxsecpdf(i)=wgtxsecpdf(i)*wsfw/wsf0
          ENDIF
       ENDDO
    ELSE
       IF(.NOT.beams_pdf_correlation)THEN
          DO i=1,ho_npdf
             INCLUDE "../../../input/lhapdf/call_initmpdf1"
             CALL strf_pdf_pp_oniumquark_dps(ip,wsfw)
             IF(ip.EQ.1)THEN
               wgtxsecpdf(i)=wsfw/wsf0
             ELSE
               wgtxsecpdf(i)=wgtxsecpdf(i)*wsfw/wsf0
             ENDIF
          ENDDO
          INCLUDE "../../../input/lhapdf/call_initmpdf10"
          DO i=1,ho_npdf2
             INCLUDE "../../../input/lhapdf/call_initmpdf2"
             CALL strf_pdf_pp_oniumquark_dps(ip,wsfw)
             IF(ip.EQ.1)THEN
               wgtxsecpdf(i+ho_npdf)=wsfw/wsf0
             ELSE
               wgtxsecpdf(i+ho_npdf)=wgtxsecpdf(i+ho_npdf)*wsfw/wsf0
             ENDIF
          ENDDO
          INCLUDE "../../../input/lhapdf/call_initmpdf20"
       ELSE
          ! it is correlated for two beams
          DO i=1,ho_npdf
             INCLUDE "../../../input/lhapdf/call_initmpdf1"
             INCLUDE "../../../input/lhapdf/call_initmpdf2"
             CALL strf_pdf_pp_oniumquark_dps(ip,wsfw)
             IF(ip.EQ.1)THEN
               wgtxsecpdf(i)=wsfw/wsf0
             ELSE
               wgtxsecpdf(i)=wgtxsecpdf(i)*wsfw/wsf0
             ENDIF
          ENDDO
          INCLUDE "../../../input/lhapdf/call_initmpdf10"
          INCLUDE "../../../input/lhapdf/call_initmpdf20"
       ENDIF
       RETURN
    ENDIF
    ! recover it
    INCLUDE "../../../input/lhapdf/call_initpdf0"
    RETURN
  END SUBROUTINE reweight_xsec_pdf_pp_oniumquark_dps

  SUBROUTINE reweight_xsec_npdf_pp_oniumquark_dps(ip,wsf0)
    IMPLICIT NONE
    INTEGER::init=0,i
    INTEGER,INTENT(IN)::ip
    REAL(KIND(1d0)),INTENT(IN)::wsf0
    REAL(KIND(1d0))::wsfw
    SAVE init
    IF(.NOT.reweight_npdf)THEN
       WRITE(*,*)"ERROR:Please set reweight_npdf to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(MOD(ho_nnpdf,2).NE.0)THEN
          WRITE(*,*)'The number of error sets must be even',ho_nnpdf
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecnpdf))THEN
          DEALLOCATE(wgtxsecnpdf)
       ENDIF
       ALLOCATE(wgtxsecnpdf(ho_nnpdf))
       IF(ALLOCATED(idnpdf))THEN
          DEALLOCATE(idnpdf)
       ENDIF
       ALLOCATE(idnpdf(0:ho_nnpdf))
       IF(nPDF_id.NE.1000)THEN
          idnpdf(0)=nPDF_id
          idnpdf(1)=inpdf_set_min
       ELSE
          idnpdf(0)=iPDFSUP1
          idnpdf(1)=inpdf_set_min-1000+iPDFSUP1
       ENDIF
       IF(inpdf_set_max-inpdf_set_min+1.NE.ho_nnpdf)THEN
          WRITE(*,*)'Incorrect the number of error npdf',ho_nnpdf,inpdf_set_min,inpdf_set_max
          STOP
       ENDIF
       DO i=2,ho_nnpdf
          idnpdf(i)=idnpdf(1)+i-1
       ENDDO
       WRITE(*,*) 'Doing nPDF reweight:'
       WRITE(*,*) 'Central set id: ',idnpdf(0)
       WRITE(*,*) 'Min error set id: ',idnpdf(1)
       WRITE(*,*) 'Max error set id: ',idnpdf(ho_nnpdf)
       init=1
    ENDIF
    DO i=1,ho_nnpdf
       use_neutron_rand=.TRUE.
       INCLUDE "../../../input/lhapdf/call_initnpdfi"
       INCLUDE "../../../input/lhapdf/call_initnpdfi_lhapdf6"
       CALL strf_pdf_pp_oniumquark_dps(ip,wsfw)
       IF(ip.EQ.1)THEN
         wgtxsecnpdf(i)=wsfw/wsf0
       ELSE
         wgtxsecnpdf(i)=wgtxsecnpdf(i)*wsfw/wsf0
       ENDIF
    ENDDO
    ! recover it
    use_neutron_rand=.FALSE.
    INCLUDE "../../../input/lhapdf/call_initnpdf"
    INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_0"
    RETURN
  END SUBROUTINE reweight_xsec_npdf_pp_oniumquark_dps

  SUBROUTINE reweight_xsec_ref_pp_oniumquark_dps(ip,wsf0)
    IMPLICIT NONE
    INTEGER::init=0,i
    INTEGER,INTENT(IN)::ip
    REAL(KIND(1d0)),INTENT(IN)::wsf0
    REAL(KIND(1d0))::wsfw
    SAVE init
    IF(.NOT.reweight_ref)THEN
       WRITE(*,*)"ERROR:Please set reweight_ref to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(ho_nref.NE.1.AND.ho_nref.NE.3.AND.ho_nref.NE.15)THEN
          WRITE(*,*)'Incorrect the number of references #1:',ho_nref
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecref))THEN
          DEALLOCATE(wgtxsecref)
       ENDIF
       ALLOCATE(wgtxsecref(ho_nref))
       IF(ALLOCATED(idref))THEN
          DEALLOCATE(idref)
       ENDIF
       ALLOCATE(idref(0:ho_nref))
       idref(0)=0
       idref(1)=iref_set_max
       IF(iref_set_max-iref_set_min+1.NE.ho_nref)THEN
          WRITE(*,*)'Incorrect the number of references #2:',ho_nref,iref_set_min,iref_set_max
          STOP
       ENDIF
       DO i=2,ho_nref
          idref(i)=idref(1)+i-1
       ENDDO
       WRITE(*,*) 'Doing reference reweight'
       init=1
    END IF
    ! reference: pp collision
    use_neutron_rand=.TRUE.
    INCLUDE "../../../input/lhapdf/call_initnpdf"
    PureProton1=.TRUE.
    PureProton2=.TRUE.
    CALL strf_pdf_pp_oniumquark_dps(ip,wsfw)
    IF(ip.EQ.1)THEN
      wgtxsecref(1)=wsfw/wsf0
      IF(ho_nref.GE.3)THEN
         wgtxsecref(3)=wgtxsecref(1)
         IF(ho_nref.EQ.15)THEN
	    wgtxsecref(9)=wgtxsecref(1)
            wgtxsecref(11)=wgtxsecref(1)
	 ENDIF
      ENDIF
    ELSE
      wgtxsecref(1)=wgtxsecref(1)*wsfw/wsf0
      IF(ho_nref.GE.3)THEN
         wgtxsecref(2)=wgtxsecref(2)*wsfw/wsf0
         IF(ho_nref.EQ.15)THEN
            wgtxsecref(5)=wgtxsecref(5)*wsfw/wsf0
	    wgtxsecref(6)=wgtxsecref(6)*wsfw/wsf0
         ENDIF
      ENDIF
    ENDIF
    IF(ho_nref.LE.1)THEN
       use_neutron_rand=.FALSE.
       PureProton1=.FALSE.
       PureProton2=.FALSE.
       RETURN
    ENDIF
    IF(lnuclearPDF.AND.rnuclearA_beam1.NE.0d0)THEN
       ! A p
       PureProton1=.FALSE.
       PureProton2=.TRUE.
       CALL strf_pdf_pp_oniumquark_dps(ip,wsfw)
       IF(ip.EQ.1)THEN
          wgtxsecref(2)=wsfw/wsf0
          IF(ho_nref.EQ.15)THEN
            wgtxsecref(4)=wsfw/wsf0
            wgtxsecref(10)=wsfw/wsf0
            wgtxsecref(12)=wsfw/wsf0
          ENDIF
       ELSE
          wgtxsecref(3)=wgtxsecref(3)*wsfw/wsf0
          IF(ho_nref.EQ.15)THEN
            wgtxsecref(4)=wgtxsecref(4)*wsfw/wsf0
            wgtxsecref(7)=wgtxsecref(7)*wsfw/wsf0
            wgtxsecref(8)=wgtxsecref(8)*wsfw/wsf0
          ENDIF          
       ENDIF
       IF(lnuclearPDF.AND.rnuclearA_beam2.NE.0d0.AND.ho_nref.EQ.15)THEN
          ! A B
          PureProton1=.FALSE.
          PureProton2=.FALSE.
          CALL strf_pdf_pp_oniumquark_dps(ip,wsfw)
          IF(ip.EQ.1)THEN
            wgtxsecref(6)=wsfw/wsf0
            wgtxsecref(8)=wsfw/wsf0
            wgtxsecref(14)=wsfw/wsf0
          ELSE
            wgtxsecref(11)=wgtxsecref(11)*wsfw/wsf0
            wgtxsecref(12)=wgtxsecref(12)*wsfw/wsf0
            wgtxsecref(15)=wgtxsecref(15)*wsfw/wsf0
	  ENDIF
       ENDIF
    ENDIF
    IF(lnuclearPDF.AND.rnuclearA_beam2.NE.0d0)THEN
       ! p B
       PureProton1=.TRUE.
       PureProton2=.FALSE.
       CALL strf_pdf_pp_oniumquark_dps(ip,wsfw)
       IF(ho_nref.EQ.3)THEN
          IF(ip.EQ.1)THEN
            wgtxsecref(2)=wsfw/wsf0
          ELSE
            wgtxsecref(3)=wgtxsecref(3)*wsfw/wsf0
          ENDIF
       ELSEIF(ho_nref.EQ.15)THEN
          IF(ip.EQ.1)THEN
            wgtxsecref(5)=wsfw/wsf0
            wgtxsecref(7)=wsfw/wsf0
            wgtxsecref(13)=wsfw/wsf0
            wgtxsecref(15)=wsfw/wsf0
          ELSE
            wgtxsecref(9)=wgtxsecref(9)*wsfw/wsf0
            wgtxsecref(10)=wgtxsecref(10)*wsfw/wsf0
	    wgtxsecref(13)=wgtxsecref(13)*wsfw/wsf0
            wgtxsecref(14)=wgtxsecref(14)*wsfw/wsf0
          ENDIF
       ENDIF
    ENDIF

    use_neutron_rand=.FALSE.
    PureProton1=.FALSE.
    PureProton2=.FALSE.
    RETURN
  END SUBROUTINE reweight_xsec_ref_pp_oniumquark_dps
