MODULE pp_oniumX
  USE Helac_Global
  USE MC_VEGAS
  USE pp_oniumX_Global
  USE Helac_Func_1
  USE plot_pp_oniumX
  USE Constants
  USE Kinetic_Func
  USE pp_oniumX_setscale
  IMPLICIT NONE
  INTEGER::nprint
  INTEGER::varnum,nunwei
  LOGICAL::lunwei2
  REAL(KIND(1d0))::EBMUP1,EBMUP2
  INTEGER::NPRUP=0,lwmax
  INTEGER,PARAMETER::maxprint=8
  SAVE
CONTAINS
  SUBROUTINE calc_pp_oniumX
    IMPLICIT NONE
    CHARACTER(len=2)::quark_tag
    INTEGER::i,i1,j1,k1,s1x
    INTEGER::nh,innum,outnum
    INTEGER::ioerror,icase=0
    LOGICAL::lunwei=.FALSE.,lhewgt=.FALSE.
    REAL(KIND(1d0)),DIMENSION(3)::rslt
    INTEGER::itmxn,ncalln
    REAL(KIND(1d0)),DIMENSION(4)::pmomtemp
    LOGICAL::lexist
    SAVE lunwei,lhewgt,icase
    REAL(KIND(1d0))::temp
    INTEGER::beam1_pdf,beam2_pdf
    WRITE(*,*)'                     THE BEGINNING OF HELAC-Onia'
    WRITE(*,*)'    AddOn Process: '
    WRITE(*,*)'    p p > quarkonium + X up to O(alpha_s**3)'
    WRITE(*,*)'======================================================='
    WRITE(*,*)'======================================================='
    WRITE(*,*)' '
    CALL ReadElem_integer('colpar',Coll_Type)
    lunwei=.FALSE.
    lhewgt=.FALSE.
    CALL ReadElem_logic('topdrawer_output',topdrawer_output)
    CALL ReadElem_logic('gnuplot_output',gnuplot_output)
    CALL ReadElem_logic('root_output',root_output)
    CALL ReadElem_logic('hwu_output',hwufile_output)
    plot_output=topdrawer_output.OR.gnuplot_output.OR.root_output.OR.hwufile_output
    CALL ReadElem_integer('literature',literature_cutoffs)
    CALL ReadElem_logic('fixtarget',fixtarget)
    IF(fixtarget.AND.Coll_Type.EQ.3)THEN
       WRITE(*,*)"ERROR: Cannot treat fixed-target experiment in e+e- collisions"
       STOP
    ENDIF
    CALL ReadElem_logic("useMCFMrun",useMCFMrun)
    CALL ReadElem_logic('lhapdf',uselhapdf)
    INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdf_data",EXIST=lexist)
    IF(lexist)THEN
       OPEN(UNIT=30333,FILE=TRIM(input_dir)//"paths/lhapdf_data")
       READ(30333,'(A)')LHAPath
       CLOSE(UNIT=30333)
    ELSE
       INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdfpath",EXIST=lexist)
       IF(lexist)THEN
          OPEN(UNIT=30333,FILE=TRIM(input_dir)//"paths/lhapdfpath")
          READ(30333,'(A)')LHAPath
          CLOSE(UNIT=30333)
          i=LEN_TRIM(LHAPath)
          LHAPath=LHAPath(1:i-13)
       ENDIF
    ENDIF
    uselhapdf=uselhapdf.AND.lexist
    WRITE(*,*)'Use LHAPDF ?',uselhapdf
    CALL ReadElem_logic("absoluterap",absrap)
    ! some necesarry initialization
    OPEN(UNIT=12321,FILE="./input/states.inp")
    READ(12321,*)onium_state
    CLOSE(UNIT=12321)
    IF((onium_state.LT.1.OR.onium_state.GT.12))THEN
       WRITE(*,*)"ERROR:Unknown the state = ",onium_state
       WRITE(*,*)"INFO:Please set 1-12 in states.inp"
       STOP
    ENDIF
    OPEN(UNIT=12321,FILE="./input/quark.inp")
    READ(12321,*)IQUARK
    CLOSE(UNIT=12321)
    IF(IQUARK.LT.4.OR.IQUARK.GT.5)THEN
       WRITE(*,*)"ERROR:Unknown the heavy quark = ",IQUARK
       WRITE(*,*)"INFO:Please set 4 (charm) or 5 (bottom) in quark.inp"
       STOP
    ELSEIF(IQUARK.EQ.4)THEN
       CALL ReadElem_real('cmass',MQ)
       quark_tag="cc"
       nlq=3
    ELSE
       CALL ReadElem_real('bmass',MQ)
       quark_tag="bb"
       nlq=4
    ENDIF
    MQQ=2d0*MQ
    nhad=4
    iflh(1)=35
    iflh(2)=35
    iflh(3)=state2hoid(onium_state)
    iflh(4)=35
    !CALL ReadDecayInfo
    SELECT CASE(iflh(3))
    CASE(441001,551001)
       CALL ReadElem_real('LDME'//quark_tag//'1S01',LDME_onium)
       LDME_onium=LDME_onium*6d0
    CASE(441008,551008)
       CALL ReadElem_real('LDME'//quark_tag//'1S08',LDME_onium)
       LDME_onium=LDME_onium*8d0
    CASE(443011,553011)
       CALL ReadElem_real('LDME'//quark_tag//'3S11',LDME_onium)
       LDME_onium=LDME_onium*6d0*3d0
    CASE(443018,553018)
       CALL ReadElem_real('LDME'//quark_tag//'3S18',LDME_onium)
       LDME_onium=LDME_onium*8d0*3d0
    CASE(443101,553101)
       CALL ReadElem_real('LDME'//quark_tag//'3P01',LDME_onium)
       LDME_onium=LDME_onium*6d0
    CASE(443111,553111)
       CALL ReadElem_real('LDME'//quark_tag//'3P11',LDME_onium)
       LDME_onium=LDME_onium*6d0*3d0
    CASE(443121,553121)
       CALL ReadElem_real('LDME'//quark_tag//'3P21',LDME_onium)
       LDME_onium=LDME_onium*6d0*5d0
    CASE(443108,553108)
       CALL ReadElem_real('LDME'//quark_tag//'3P08',LDME_onium)
       LDME_onium=LDME_onium*8d0
    CASE(443118,553118)
       CALL ReadElem_real('LDME'//quark_tag//'3P18',LDME_onium)
       LDME_onium=LDME_onium*8d0*3d0
    CASE(443128,553128)
       CALL ReadElem_real('LDME'//quark_tag//'3P28',LDME_onium)
       LDME_onium=LDME_onium*8d0*5d0
    CASE(441111,551111)
       CALL ReadElem_real('LDME'//quark_tag//'1P11',LDME_onium)
       LDME_onium=LDME_onium*6d0*3d0
    CASE(441118,551118)
       CALL ReadElem_real('LDME'//quark_tag//'1P18',LDME_onium)
       LDME_onium=LDME_onium*8d0*3d0
    CASE DEFAULT
       WRITE(*,*)"ERROR: Do not know the state=",iflh(3)
       STOP
    END SELECT
    IF(nunit1.NE.6)THEN
       OPEN(UNIT=nunit1,FILE=TRIM(output_dir)//"RESULT_pp_oniumX.out")
    ENDIF
    nunit2=32
    CLOSE(nunit2)
    OPEN(nunit2,FILE=TRIM(output_dir)//'kine_pp_oniumX.out')
    nunit3=30
    CLOSE(nunit3)
    OPEN(nunit3,FILE=TRIM(tmp_dir)//'even_pp_oniumX.out',FORM='unformatted')
    ! for LHA
    CLOSE(200)
    OPEN(200,FILE=TRIM(tmp_dir)//'sample_pp_oniumX.init')
    ! Multiple PDFs and special nPDFs
    CALL ReadElem_integer('pdf',beam1_pdf)
    CALL ReadElem_integer('beam2_pdf',beam2_pdf)
    CALL ReadElem_integer('nPDF_id',nPDF_id)
    CALL ReadElem_integer('nuclearA_beam1',nuclearA_beam1)
    CALL ReadElem_integer('nuclearA_beam2',nuclearA_beam2)
    CALL ReadElem_integer('nuclearZ_beam1',nuclearZ_beam1)
    CALL ReadElem_integer('nuclearZ_beam2',nuclearZ_beam2)
    lnuclearPDF=.FALSE.
    multipdfloading=uselhapdf.AND.beam2_pdf.NE.beam1_pdf.AND.beam2_pdf.GT.0
    IF(.NOT.multipdfloading)THEN
       IF(nPDF_id.NE.0.AND.(nuclearA_beam1.NE.0.or.nuclearA_beam2.NE.0)&
            .AND.(.NOT.uselhapdf))THEN
          WRITE(*,*)"nuclear PDF can only be used with LHAPDF"
          WRITE(*,*)"nPDF_id=",nPDF_id
          WRITE(*,*)"nuclearA_beam1=",nuclearA_beam1
          WRITE(*,*)"nuclearA_beam2=",nuclearA_beam2
          WRITE(*,*)"Please set lhapdf=T and set the correct path of lhapdf in ho_configuration.txt before ./config"
          STOP
       ENDIF
       rnuclearA_beam1=DBLE(nuclearA_beam1)
       rnuclearA_beam2=DBLE(nuclearA_beam2)
       rnuclearZ_beam1=DBLE(nuclearZ_beam1)
       rnuclearZ_beam2=DBLE(nuclearZ_beam2)
       IF(nPDF_id.EQ.0.AND.(nuclearA_beam1.NE.0.or.nuclearA_beam2.NE.0))THEN
          WRITE(*,*)"WARNING:you are using normal proton PDF for nuclear"
       ENDIF
       IF(nPDF_id.NE.0.AND.(nuclearA_beam1.NE.0.or.nuclearA_beam2.NE.0))THEN
          lnuclearPDF=.TRUE.
       ENDIF
    ELSE
       ! multiple PDF loading already allow one to use nuclear PDFs
       ! no need the tricks for nuclear PDFs
       rnuclearA_beam1=0d0
       rnuclearA_beam2=0d0
       nuclearA_beam1=0
       nuclearA_beam2=0
       rnuclearZ_beam1=0d0
       rnuclearZ_beam2=0d0
       nuclearZ_beam1=0
       nuclearZ_beam2=0
       lnuclearPDF=.FALSE.
    ENDIF
    ! Scale scheme
    CALL ReadElem_integer('Scale',nscheme)
    CALL ReadElem_real('FScaleValue',fschemevalue)
    CALL ReadELem_real('ScaleFactor',scalefactor)
    CALL ReadElem_real('muR_over_ref',muR_over_ref)
    CALL ReadElem_real('muF_over_ref',muF_over_ref)
    ! reweighting stuff
    reweight_pdf=.FALSE.
    reweight_npdf=.FALSE.
    reweight_ref=.FALSE.
    IF(uselhapdf)THEN
       CALL ReadElem_logic('reweight_pdf',reweight_pdf)
       IF(reweight_pdf.AND.lnuclearPDF.AND.nPDF_id.EQ.1000)THEN
          WRITE(*,*)"WARNING:reweight proton PDF are not allowed when nPDF_id=1000 in PA"
          reweight_pdf=.FALSE.
       ENDIF
       IF(reweight_pdf)THEN
          CALL ReadElem_logic('beams_pdf_correlation',beams_pdf_correlation)
       ENDIF
       IF(reweight_pdf)THEN
          CALL ReadElem_integer('pdf_min',ipdf_set_min)
          CALL ReadElem_integer('pdf_max',ipdf_set_max)
          IF(multipdfloading)THEN
             CALL ReadElem_integer('beam2_pdf_min',ipdf2_set_min)
             CALL ReadElem_integer('beam2_pdf_max',ipdf2_set_max)
             IF(ipdf2_set_min.GT.0.AND.ipdf2_set_max.GT.0)THEN
                IF(beams_pdf_correlation.AND.&
                     (ipdf2_set_max-ipdf2_set_min).NE.&
                     (ipdf_set_max-ipdf_set_min))THEN
                   WRITE(*,*)"ERROR: The numbers of error PDFs for two beams are different"
                   WRITE(*,*)"ERROR: The two beams cannot be fully correlated "
                   STOP
                ENDIF
             ENDIF
          ELSE
             ipdf2_set_min=-1
             ipdf2_set_max=-1
          ENDIF
          IF(ipdf_set_max.LT.0.AND.ipdf_set_min.LT.0)THEN
             ho_npdf=0
          ELSE
             ho_npdf=ipdf_set_max-ipdf_set_min+1
          ENDIF
          IF(multipdfloading.AND..NOT.beams_pdf_correlation.AND.&
               (ipdf2_set_min.GT.0.AND.ipdf2_set_max.GT.0))THEN
             ho_npdf2=ipdf2_set_max-ipdf2_set_min+1
          ELSE
             ho_npdf2=0
          ENDIF
       ENDIF
       ho_npdf=MAX(ho_npdf,0)
       ho_npdf2=MAX(ho_npdf2,0)
       IF(ho_npdf.LE.0.AND.ho_npdf2.LE.0)THEN
          ho_npdf=0
          ho_npdf2=0
          reweight_pdf=.FALSE.
       ENDIF
       IF(ho_npdf.GT.0)THEN
          tot_nrwgt=tot_nrwgt+ho_npdf+1
       ENDIF
       IF(ho_npdf2.GT.0)THEN
          tot_nrwgt=tot_nrwgt+ho_npdf2+1
       ENDIF
       IF(lnuclearPDF)THEN
          CALL ReadElem_logic('reweight_npdf',reweight_npdf)
          IF(reweight_pdf.AND.ho_npdf.GE.2.AND.nPDF_id.LE.500)THEN
             WRITE(*,*)"ERROR: Cannot perform proton PDF reweighting for EPS09"
             STOP
          ENDIF
          IF(reweight_npdf)THEN
             CALL ReadElem_integer('npdf_min',inpdf_set_min)
             CALL ReadElem_integer('npdf_max',inpdf_set_max)
             ho_nnpdf=inpdf_set_max-inpdf_set_min+1
             tot_nrwgt=tot_nrwgt+ho_nnpdf+1
          ENDIF
          INCLUDE '../../../input/lhapdf/check_npdf_set_min'
          CALL ReadElem_logic('include_ref',reweight_ref)
          IF(reweight_ref)THEN
             IF(nuclearA_beam1*nuclearA_beam2.NE.0.AND.COLL_TYPE.LE.2)THEN
                ! heavy ion collision, AB or AA
                ho_nref=3
                iref_set_min=1
                iref_set_max=3
             ELSE
                ! pA or Ap or eA collisions
                ho_nref=1
                iref_set_min=1
                iref_set_max=1
             ENDIF
          ENDIF
          tot_nrwgt=tot_nrwgt+ho_nref+1
       ENDIF
    ENDIF
    CALL ReadElem_integer('alphasrun',irun)
    CALL ReadElem_logic('reweight_Scale',reweight_scale)
    reweight_scale=reweight_scale.AND.(irun.EQ.1)
    IF(reweight_scale)THEN
       CALL ReadElem_real('rw_RScale_down',rw_Rscale_down)
       CALL ReadElem_real('rw_RScale_up',rw_Rscale_up)
       CALL ReadElem_real('rw_FScale_down',rw_Fscale_down)
       CALL ReadElem_real('rw_FScale_up',rw_Fscale_up)
       ho_nscale=8
       IF(rw_Rscale_down.LE.0d0.OR.rw_Rscale_up.LE.0d0.OR.&
            rw_Fscale_down.LE.0d0.OR.rw_Fscale_up.LE.0d0)THEN
          reweight_scale=.FALSE.
          ho_nscale=0
          WRITE(*,*)"WARNING:Scale reweighting is off."
          WRITE(*,*)"WARNING:Please make sure rw_Rscale_up, rw_Rscale_down, rw_Fscale_up, rw_Fscale_down are larger than 0."
       ENDIF
       IF(reweight_scale.AND.rw_Rscale_down.GT.rw_Rscale_up)THEN
          temp=rw_Rscale_down
          rw_Rscale_down=rw_Rscale_up
          rw_Rscale_up=temp
       ENDIF
       IF(reweight_scale.AND.rw_Fscale_down.GT.rw_Fscale_up)THEN
          temp=rw_Fscale_down
          rw_Fscale_down=rw_Fscale_up
          rw_Fscale_up=temp
       ENDIF
       rw_Rscales(1)=1d0
       rw_Rscales(2)=rw_Rscale_up
       rw_Rscales(3)=rw_Rscale_down
       rw_Fscales(1)=1d0
       rw_Fscales(2)=rw_Fscale_up
       rw_Fscales(3)=rw_Fscale_down
    ENDIF
    IF(reweight_scale)THEN
       tot_nrwgt=tot_nrwgt+ho_nscale+1
    ENDIF
    ! rwgt_values are used for LHE event file
    !IF(reweight_scale.OR.reweight_pdf.OR.reweight_npdf.OR.reweight_ref)THEN
    !   IF(ALLOCATED(rwgt_values))THEN
    !      DEALLOCATE(rwgt_values)
    !   ENDIF
    !   ALLOCATE(rwgt_values(tot_nrwgt))
    !ENDIF
    CALL ReadElem_integer("itmax",itmxn)
    CALL ReadElem_integer("nmc",ncalln)
    WRITE(*,*)' '
    CALL Helac_mtime()
    WRITE(*,*)' '
    CALL pp_oniumX_VEGAS(rslt,itmxn,ncalln)
    WRITE(nunit1,*)"sigma(nb)                   sd"
    WRITE(nunit1,*)rslt(1),rslt(2)
    WRITE(*,*)' '
    CALL Helac_mtime()
    CLOSE(nunit2)
    CLOSE(nunit3)
    CLOSE(21)
    CLOSE(200)
    !IF(lunwei)CALL Generate_lhe_pp_psipsi_dps(nhad,Nevents,icase)
  END SUBROUTINE calc_pp_oniumX

  SUBROUTINE pp_oniumX_VEGAS(rslt,itmxn,ncalln)
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(3),INTENT(OUT)::rslt
    INTEGER,INTENT(IN),OPTIONAL::itmxn,ncalln
    REAL(KIND(1d0))::vfes,sd,chi2a
    INTEGER::ncalm,nc,ii
    CHARACTER(len=4),DIMENSION(20)::chchar
    INTEGER::iday0,ihr0,imin0,isec0,i100th0,iday1,ihr1,imin1,isec1,i100th1,iyr0,iyr1,imon0,imon1
    INTEGER::IDBMUP1,IDBMUP2,IDWTUP
    CALL ReadElem_logic('unwgt',lunwei2)
    CALL ReadElem_integer('preunw',nunwei)
    lwmax=0
    NPRN=-1
    varnum=2
    ! varnum=2*varnum+NDecayIflh
    DO ii=1,varnum
       XL(ii)=0.0d0
       XU(ii)=1.0d0
    ENDDO
    IF(PRESENT(itmxn))THEN
       ITMX=itmxn
    ELSE
       ITMX=5
    ENDIF
    ITMX=1
    IF(PRESENT(ncalln))THEN
       ncalm=ncalln
    ELSE
       ncalm=5000
    ENDIF
    chchar(1)="40K"
    chchar(2)="80K"
    chchar(3)="160K"
    chchar(4)="320K"
    chchar(5)="640K"
    chchar(6)="1M"
    chchar(7)="2M"
    chchar(8)="4M"
    chchar(9)="8M"
    chchar(10)="16M"
    chchar(11)='32M'
    chchar(12)='64M'
    chchar(13)='120M'
    chchar(14)='240M'
    chchar(15)='480M'
    chchar(16)='960M'
    chchar(17)='2G'
    chchar(18)='4G'
    chchar(19)='8G'
    chchar(20)='16G'
    nprint=10000
    NCALL=20000
    CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
    IF(plot_output)CALL initplot_pp_oniumX
    CALL VEGAS(varnum,pp_oniumX_fxn,vfes,sd,chi2a)
    IF(plot_output)CALL plotout_pp_oniumX
    WRITE(*,*)' '
    WRITE(*,*)"====================NCALL=20K==========================="
    WRITE(*,*)" "
    CALL Helac_mtime()
    WRITE(*,*)" "
    ii=1
    WRITE(*,*)"ITERATION ",ii,":"
    WRITE(*,*)vfes,"+\-",sd
    WRITE(*,*)"precision:",sd/vfes
    DO ii=2,10
       IF(plot_output)CALL initplot_pp_oniumX
       CALL VEGAS(varnum,pp_oniumX_fxn,vfes,sd,chi2a,1)
       IF(plot_output)CALL plotout_pp_oniumX
       WRITE(*,*)"ITERATION ",ii,":"
       WRITE(*,*)vfes,"+\-",sd
       WRITE(*,*)"precision:",sd/vfes
    ENDDO
    CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
    iday1=iday1-iday0
    ihr1=ihr1-ihr0
    imin1=imin1-imin0
    isec1=isec1-isec0
    i100th1=i100th1-i100th0
    CALL Vegas_speed(10*NCALL,iday1,ihr1,imin1,isec1,i100th1)
    WRITE(*,*)' '
    WRITE(*,*)' '
    ii=1
    DO
       nc=2*NCALL
       IF(nc.GT.ncalm)EXIT
       IF(2*nc.GT.ncalm.AND.lunwei2.AND.lwmax.EQ.0)THEN
          lwmax=1
       ENDIF
       NCALL=nc
       IF(NCALL/maxprint.GT.nprint)nprint=NCALL/maxprint
         CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
         WRITE(*,*)"====================NCALL="//chchar(ii)//"==========================="
         WRITE(*,*)" "
         CALL Helac_mtime()
         WRITE(*,*)" "
         IF(plot_output)CALL initplot_pp_oniumX
         CALL VEGAS(varnum,pp_oniumX_fxn,vfes,sd,chi2a,1)
         IF(plot_output)CALL plotout_pp_oniumX
         WRITE(*,*)vfes,"+\-",sd
         WRITE(*,*)"precision:",sd/vfes
         CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
         iday1=iday1-iday0
         ihr1=ihr1-ihr0
         imin1=imin1-imin0
         isec1=isec1-isec0
         i100th1=i100th1-i100th0
         CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
         WRITE(*,*)" "
         ii=ii+1
      ENDDO
      SELECT CASE(COLL_TYPE)
      CASE(1)
         IDBMUP1=2212
         IDBMUP2=2212
      CASE(2)
         IDBMUP1=2212
         IDBMUP2=-2212
      CASE DEFAULT
         IDBMUP1=11
         IDBMUP2=-11
      END SELECT
      IDWTUP=1
      NPRUP=NPRUP+1
      WRITE(200,5100) IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,&
           iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
      WRITE(200,5200) vfes*10d0**3,sd*10d0**3,1d0, 82
      rslt(1)=vfes
      rslt(2)=sd
      rslt(3)=chi2a
      RETURN
5100  FORMAT(1P,2I8,2E14.6,6I8)
5200  FORMAT(1P,3E20.10,I6)
  END SUBROUTINE pp_oniumX_VEGAS

  FUNCTION pp_oniumX_fxn(x,wgt)
    USE NLO_pp_oniumX
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(varnum),INTENT(IN)::x
    REAL(KIND(1d0)),INTENT(IN)::wgt
    REAL(KIND(1d0))::pp_oniumX_fxn
    REAL(KIND(1d0))::phi,costh,sinth
    REAL(KIND(1d0)),DIMENSION(4)::pmom
    REAL(KIND(1d0)),DIMENSION(3,0:6)::me_real,me_other
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
    INTEGER::init=0,nwarn,nwmax,nwri,nwri_tot,icut1,icut2,nnn=0,nnntot=0,&
           pdfnumpdf,pdfnumpdf2,ivarnum
    SAVE init,nwarn,nwmax,nwri,nwri_tot,nnn,nnntot,pdfnumpdf,pdfnumpdf2,ivarnum
    REAL(KIND(1d0))::sqs,sq,pt1c,maxpt1c,y1cup,y1clow,ycollcm,ymax0,yy,zz,QQ
    SAVE sqs,sq,ycollcm,ymax0,pt1c,maxpt1c,y1cup,y1clow
    REAL(KIND(1d0)),DIMENSION(4)::PBOO
    REAL(KIND(1d0))::wtotal,wsf,wme,wthis,w1
    REAL(KIND(1d0)),DIMENSION(3)::wsfs_real,wsfs_other
    ! ibody=1: (n+1)-body contribution
    ! ibody=2: n-body contribution (excluding Born)
    ! ibody=3: Born contribution
    INTEGER::ibody
    REAL(KIND(1d0))::exp1,exp2,Jyy,zmin,Jzz,tau,pp
    REAL(KIND(1d0))::recmax=0,recmin=0
    SAVE Jyy
    INTEGER::j
    IF(init.EQ.0)THEN
         wjac=1
         nwmax=0
         nwarn=0
         nwri=0
         CALL ReadElem_integer('unwevt',nwri_tot)
         CALL ReadElem_real('energy_beam1',sqs)
         ebeam(1)=ABS(sqs)
         CALL ReadElem_real('energy_beam2',sqs)
         ebeam(2)=ABS(sqs)
         IF(ABS(ebeam(1)-ebeam(2))/MAX(ebeam(1)+ebeam(2),1d-17).LT.1d-8)THEN
            absrap=absrap
            labeqcoll=.TRUE.
         ELSE
            absrap=.FALSE.
            labeqcoll=.FALSE.
         ENDIF
         sqs=2d0*DSQRT(ebeam(1)*ebeam(2)) ! we always neglect the mass of initial states
         IF(fixtarget)sqs=sqs/DSQRT(2d0)
         EBMUP1=ebeam(1)
         EBMUP2=ebeam(2)
         IF(.NOT.fixtarget)THEN
            ycollcm=DLOG(ABS(ebeam(1))/ABS(ebeam(2)))/2d0
         ELSE
            IF(ABS(ebeam(1)).GT.ABS(ebeam(2)))THEN
               fixtargetrev=.FALSE.
               ycollcm=DLOG(1d0+2d0*ABS(ebeam(1))/ABS(ebeam(2)))/2d0
               FT_M=ebeam(2)
               FT_E1=ebeam(1)
               sqs=DSQRT(sqs**2+FT_M**2)
            ELSE
               fixtargetrev=.TRUE.
               ycollcm=-DLOG(1d0+2d0*ABS(ebeam(2))/ABS(ebeam(1)))/2d0
               FT_M=ebeam(1)
               FT_E1=ebeam(2)
               sqs=DSQRT(sqs**2+FT_M**2)
            ENDIF
         ENDIF
         IF(fixtarget)THEN
            ! for fixed target, I used the fake lab frame (note it is not the true lab frame of fixed target but close to)
            IF(.NOT.fixtargetrev)THEN
              ! beam1 = (beam(1)+FT_M/2,0,0,beam(1)+FT_M/2)
              ! beam2 = (FT_M/2,0,0,-FT_M/2), FT_M=beam(2)
              EBMUP1=ebeam(1)+FT_M/2d0
              EBMUP2=ebeam(2)/2d0
           ELSE
              ! beam1 = (FT_M/2,0,0,FT_M/2),FT_M=beam(1)
              ! beam2 = (beam(2)+FT_M/2,0,0,-beam(2)-FT_M/2)
              EBMUP1=ebeam(1)/2d0
              EBMUP2=ebeam(2)+FT_M/2d0
           ENDIF
         ENDIF
         pt1c=0d0
         maxpt1c=-1d0
         y1cup=30d0
         y1clow=-30d0
         CALL ReadElem_integer('pdf',pdfnumpdf)
         CALL ReadElem_integer('beam2_pdf',pdfnumpdf2)
         ptc(3:20)=0
         maxptc(3:20)=-1d0
         drc(3:20,3:20)=0
         etac(3:20)=20
         ec(3:20)=0
         c1(3:20)=1
         c2(3:20)=1
         cc(3:20,3:20)=1
         yycut(3:20)=1d9
         IF(absrap)THEN
            yycutlow(3:20)=0d0
         ELSE
            yycutlow(3:20)=-1d9
         ENDIF
         xFcut(3:20)=1d0
         xFcutlow(3:20)=-1d0
         gmas(3:20,3:20)=0
         gbeammass(1:2,3:20)=0
         parmas(0)=0
         parwid(0)=-1
         iPDFSUP1=pdfnumpdf
         IF(pdfnumpdf.EQ.0.OR.COLL_TYPE.EQ.3)THEN
            istruc=0
         ELSE
            istruc=1
         ENDIF
         IF(istruc.EQ.1)THEN
            iPDFGUP1=0
            iPDFGUP2=0
            iPDFSUP1=pdfnumpdf
            IF(pdfnumpdf2.LE.0.OR..NOT.uselhapdf)THEN
               iPDFSUP2=pdfnumpdf
            ELSE
               iPDFSUP2=pdfnumpdf2
            ENDIF
         ELSE
            iPDFGUP1=-1
            iPDFGUP2=-1
            iPDFSUP1=-1
            iPDFSUP2=-1
         ENDIF
         xp1=1
         xp2=1
         IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
            CALL readcuts_pp_oniumX
            y1cup=MIN(y1cup,yycut(3))
            y1clow=MAX(y1clow,yycutlow(3))
            IF(absrap)y1cup=ABS(y1cup)
            IF(absrap)y1clow=ABS(y1clow)
         ENDIF
         !IF(NDecayChains.GT.0)CALL readcuts_Decay
         sq=sqs*sqs
         z0=MQQ**2/sq
         ymax0=-0.5d0*DLOG(z0)
         Jyy=2d0*ymax0
         ! read the NRQCD scale
         CALL ReadElem_real('muNRQCD',muNRQCD)
         onium_muNRQCD=muNRQCD
         ivarnum=2
         init=1
      ENDIF
      nnntot=nnntot+1
      wtotal=0d0
      yy=2d0*ymax0*x(1)-ymax0
      zmin=z0*DEXP(2d0*DABS(yy))
      Jzz=(1d0-zmin)
      zz=Jzz*x(2)+zmin
      onium_z=zz
      onium_zmin=zmin
      tau=z0/zz
      xp1_real=DSQRT(tau)*DEXP(yy)
      xp2_real=DSQRT(tau)*DEXP(-yy)
      ! real emission terms
      onium_pmom_real(1,1:2)=0d0
      onium_pmom_real(1,3)=xp1_real*sqs/2d0
      onium_pmom_real(1,4)=xp1_real*sqs/2d0
      onium_pmom_real(2,1:2)=0d0
      onium_pmom_real(2,3)=-xp2_real*sqs/2d0
      onium_pmom_real(2,4)=xp2_real*sqs/2d0
      ! first step: in the rest frame of the initial partons
      pp=MQQ/2d0*(1d0-zz)/DSQRT(zz) ! momentum
      onium_pmom_real(3,4)=MQQ/2d0*(1d0+zz)/DSQRT(zz)
      costh=2d0*rand()-1d0
      sinth=DSQRT(ABS(1d0-costh**2))
      phi=2d0*pi*rand()
      onium_pmom_real(3,3)=pp*costh
      onium_pmom_real(3,1)=pp*sinth*DCOS(phi)
      onium_pmom_real(3,2)=pp*sinth*DSIN(phi)
      onium_pmom_real(4,4)=pp
      DO j=1,3
         onium_pmom_real(4,j)=-onium_pmom_real(3,j)
      ENDDO
      ! second step: boost to the hadron-hadron collision frame
      QQ=MQQ/DSQRT(zz)
      PBOO(4)=onium_pmom_real(1,4)+onium_pmom_real(2,4)
      PBOO(3)=onium_pmom_real(1,3)+onium_pmom_real(2,3)
      PBOO(1:2)=0d0
      CALL BOOSTL(QQ,PBOO,onium_pmom_real(3,1:4))
      CALL BOOSTL(QQ,PBOO,onium_pmom_real(4,1:4))
      ! dirac delta terms
      xp1_other=DSQRT(z0)*DEXP(yy)
      xp2_other=DSQRT(z0)*DEXP(-yy)
      onium_pmom_other(1,1:2)=0d0
      onium_pmom_other(1,3)=xp1_other*sqs/2d0
      onium_pmom_other(1,4)=xp1_other*sqs/2d0
      onium_pmom_other(2,3)=-xp2_other*sqs/2d0
      onium_pmom_other(2,4)=xp2_other*sqs/2d0
      onium_pmom_other(4,1:4)=0d0
      onium_pmom_other(3,1:2)=0d0
      onium_pmom_other(3,3)=onium_pmom_other(1,3)+onium_pmom_other(2,3)
      onium_pmom_other(3,4)=onium_pmom_other(1,4)+onium_pmom_other(2,4)
      Momenta_Frame=1
      ! boost from collision frame to lab frame
      IF(.NOT.fixtarget)THEN
         pmom(3)=ebeam(1)-ebeam(2)
         pmom(4)=ebeam(1)+ebeam(2)
      ELSE
         IF(.NOT.fixtargetrev)THEN
            pmom(3)=ebeam(1)
            pmom(4)=ebeam(1)+ebeam(2)
         ELSE
            pmom(3)=-ebeam(2)
            pmom(4)=ebeam(1)+ebeam(2)
         ENDIF
      ENDIF
      pmom(1:2)=0
      IF(.NOT.labeqcoll)THEN
         DO j=1,4
            CALL Boostl(sqs,pmom,onium_pmom_real(j,1:4))
            IF(j.LT.4)THEN
               CALL Boostl(sqs,pmom,onium_pmom_other(j,1:4))
            ENDIF
         ENDDO
      ENDIF
      ! check the cuts
      icut1=1
      CALL Cuts_pp_oniumX(icut1,1) ! second argument 1 means real, 2 means other (dirac delta term)
      icut2=1
      CALL Cuts_pp_oniumX(icut2,2)
      IF(icut1.EQ.0.AND.icut2.EQ.0)THEN
         pp_oniumX_fxn=0d0
         RETURN
      ENDIF
      ! scale and me's and pdf's from real kinematics
      onium_pmom(1:4,1:4)=onium_pmom_real(1:4,1:4)
      ! redefine my scale function
      CALL onium_scale(scale_real)
      scale_real=scale_real*muR_over_ref
      as_real=ALPHAS(scale_real)
      onium_muR=scale_real
      onium_muF=scale_real
      CALL call_NLO_pp_oniumX(zz,as_real,onium_state,me_real)
      xp1=xp1_real
      xp2=xp2_real
      DO j=1,3
         CALL strf_pdf_pp_oniumX(wsfs_real(j),j)
      ENDDO
      ! scale and me's and pdf's from born kinematics
      onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
      CALL onium_scale(scale_other)
      scale_other=scale_other*muR_over_ref
      as_other=ALPHAS(scale_other)
      IF(icut2.EQ.1)THEN
         IF(scale_other.NE.scale_real)THEN
            onium_muR=scale_other
            onium_muF=scale_other
            CALL call_NLO_pp_oniumX(zz,as_real,onium_state,me_other,.TRUE.)
            DO j=1,3
               me_other(j,1:6)=me_other(j,1:6)*(as_other/as_real)**3
               me_other(j,0)=me_other(j,0)*(as_other/as_real)**2
            ENDDO
         ELSE
            me_other(1:3,0:6)=me_real(1:3,0:6)
         ENDIF
         xp1=xp1_other
         xp2=xp2_other
         DO j=1,3
            CALL strf_pdf_pp_oniumX(wsfs_other(j),j)
         ENDDO
      ELSE
         me_other(1:3,0:6)=0d0
         wsfs_other(1:3)=0d0
      ENDIF
      IF(icut1.EQ.1)THEN
         ! ibody=1: (n+1)-body contribution
         ! ibody=2: n-body contribution (excluding Born)
         ! ibody=3: Born contribution
         ibody=1
         DO j=1,3
            IF(me_real(j,2).NE.0d0.OR.me_real(j,4).NE.0d0.OR.me_real(j,6).NE.0d0)THEN
               IF(j.EQ.1)THEN
                  iflh(1:2)=35
                  iflh(4)=35
               ELSEIF(j.EQ.2)THEN
                  iflh(1)=35
                  iflh(2)=3
                  iflh(4)=3
               ELSE
                  iflh(1)=3
                  iflh(2)=-3
                  iflh(4)=35
               ENDIF
               IF(wsfs_real(j).NE.0d0.OR.wsfs_other(j).NE.0d0)THEN
                  wme=(me_real(j,2)/zz**2*wsfs_real(j)-me_other(j,3)*wsfs_other(j))/(1d0-zz)&
                       +(me_real(j,4)/zz**2*wsfs_real(j)-me_other(j,5)*wsfs_other(j))*DLOG(1d0-zz)/(1d0-zz)&
                       +me_real(j,6)/zz**2*wsfs_real(j)
               ELSE
                  wme=0d0
               ENDIF
!               IF(wme.NE.0d0)THEN
!                  CALL strf_pdf_pp_oniumX(wsf,j)
!               ELSE
!                  wsf=0d0
!               ENDIF
!               wthis=wme*wsf*z0*Jyy*Jzz*3.8937966d5 ! 3.8938573d5 ! in unit of nb
               wthis=wme*z0*Jyy*Jzz*3.8937966d5 ! 3.8938573d5 ! in unit of nb
               IF(reweight_scale.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_scale(wsfs_real(j),wsfs_other(j),&
                    wme,j,ibody)
               IF(reweight_pdf.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_pdf(me_real(j,0:6),me_other(j,0:6),&
                    wsfs_real(j),wsfs_other(j),wme,j,ibody)
               IF(reweight_npdf.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_npdf(me_real(j,0:6),me_other(j,0:6),&
                    wsfs_real(j),wsfs_other(j),wme,j,ibody)
               IF(reweight_ref.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_ref(me_real(j,0:6),me_other(j,0:6),&
                    wsfs_real(j),wsfs_other(j),wme,j,ibody)
               IF(plot_output.AND.wthis.NE.0d0)THEN
                  w1=wthis*wgt
                  CALL outfun_pp_oniumX(w1,ibody)
               ENDIF
               wtotal=wtotal+wthis
            ENDIF
         ENDDO
      ENDIF
      IF(icut2.EQ.1)THEN
!         onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
!         CALL onium_scale(scale)
!         scale=scale*muR_over_ref
!         IF(scale.NE.onium_muR)THEN
!            onium_muR=scale
!            onium_muF=scale
!            CALL call_NLO_pp_oniumX(zz,as_real,onium_state,me,.TRUE.)
!         ENDIF
!         as_other=ALPHAS(scale)
         ! there are n-body contributions
!         xp1=xp1_other
!         xp2=xp2_other
         onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
         DO j=1,3
            IF(me_other(j,1).NE.0d0.OR.me_other(j,3).NE.0d0.OR.me_other(j,5).NE.0d0)THEN
               IF(j.EQ.1)THEN
                  iflh(1:2)=35
                  iflh(4)=35
               ELSEIF(j.EQ.2)THEN
                  iflh(1)=35
                  iflh(2)=3
                  iflh(4)=3
               ELSE
                  iflh(1)=3
                  iflh(2)=-3
                  iflh(4)=35
               ENDIF
               ! Jzz=1d0-zmin
               wme=me_other(j,3)*DLOG(Jzz/(1d0-z0))&
                    +me_other(j,5)*0.5d0*(DLOG(Jzz)**2-DLOG(1d0-z0)**2)&
                    +me_other(j,1)
               wme=wme*wsfs_other(j)
!               wme=wme*(as_other/as_real)**3
!               IF(wme.NE.0d0)THEN
!                  CALL strf_pdf_pp_oniumX(wsf,j)
!               ELSE
!                  wsf=0d0
!               ENDIF
               ! remove 1/zz as zz=1, tau=z0
               wthis=wme*z0*Jyy*3.8937966d5 ! 3.8938573d5 ! in unit of nb
               ibody=2
               IF(reweight_scale.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_scale(wsfs_real(j),wsfs_other(j),&
                    wme,j,ibody)
               IF(reweight_pdf.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_pdf(me_real(j,0:6),me_other(j,0:6),&
                    wsfs_real(j),wsfs_other(j),wme,j,ibody)
               IF(reweight_npdf.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_npdf(me_real(j,0:6),me_other(j,0:6),&
                    wsfs_real(j),wsfs_other(j),wme,j,ibody)
               IF(reweight_ref.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_ref(me_real(j,0:6),me_other(j,0:6),&
                    wsfs_real(j),wsfs_other(j),wme,j,ibody)
               IF(plot_output.AND.wthis.NE.0d0)THEN
                  w1=wthis*wgt
                  CALL outfun_pp_oniumX(w1,ibody)
               ENDIF
               wtotal=wtotal+wthis
            ENDIF
            IF(me_other(j,0).NE.0d0)THEN
               IF(j.EQ.1)THEN
                  iflh(1:2)=35
                  iflh(4)=35
               ELSEIF(j.EQ.2)THEN
                  iflh(1)=35
                  iflh(2)=3
                  iflh(4)=3
               ELSE
                  iflh(1)=3
                  iflh(2)=-3
                  iflh(4)=35
               ENDIF
               ! Jzz=1d0-zmin
               wme=me_other(j,0)
               wme=wme*wsfs_other(j)
!               wme=wme*(as_other/as_real)**2
!               IF(wme.NE.0d0)THEN
!                  CALL strf_pdf_pp_oniumX(wsf,j)
!               ELSE
!                  wsf=0d0
!               ENDIF
               ! remove 1/zz as zz=1 and tau=z0
               wthis=wme*z0*Jyy*3.8937966d5 ! 3.8938573d5 ! in unit of nb
               ibody=3
               IF(reweight_scale.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_scale(wsfs_real(j),wsfs_other(j),&
                    wme,j,ibody)
               IF(reweight_pdf.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_pdf(me_real(j,0:6),me_other(j,0:6),&
                    wsfs_real(j),wsfs_other(j),wme,j,ibody)
               IF(reweight_npdf.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_npdf(me_real(j,0:6),me_other(j,0:6),&
                    wsfs_real(j),wsfs_other(j),wme,j,ibody)
               IF(reweight_ref.AND.wthis.NE.0d0)CALL pp_oniumX_reweight_xsec_ref(me_real(j,0:6),me_other(j,0:6),&
                    wsfs_real(j),wsfs_other(j),wme,j,ibody)
               IF(plot_output.AND.wthis.NE.0d0)THEN
                  w1=wthis*wgt
                  CALL outfun_pp_oniumX(w1,ibody)
               ENDIF
               wtotal=wtotal+wthis
            ENDIF
         ENDDO
      ENDIF
      pp_oniumX_fxn=wtotal
      nnn=nnn+1
      IF(recmax.LT.pp_oniumX_fxn)recmax=pp_oniumX_fxn
      IF(recmin.GT.pp_oniumX_fxn)recmin=pp_oniumX_fxn
      IF(MOD(nnn,nprint).EQ.0)THEN
         PRINT *,"max=",recmax
         PRINT *,"min=",recmin
         !IF(lunwei2.AND.lwmax.GT.1)THEN
         !   PRINT *,"      n_event,    n_pass,    n_total"
         !   PRINT *,nwri,nnn,nnntot
         !ELSE
         PRINT *, "      n_pass,     n_total"
         PRINT *,nnn,nnntot
         !ENDIF
      ENDIF
      RETURN
  END FUNCTION pp_oniumX_fxn

  SUBROUTINE pp_oniumX_reweight_xsec_scale(wsf0_real,wsf0_other,wme0,inum,ibody)
    USE NLO_pp_oniumX
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::wsf0_real,wsf0_other,wme0
    INTEGER,INTENT(IN)::inum,ibody
    ! inum: 1,gg; 2, qg+gq+qbarg+gqbar; 3, qqbar+qbarq
    ! ibody=1: (n+1)-body contribution
    ! ibody=2: n-body contribution (excluding Born)
    ! ibody=3: Born contribution
    REAL(KIND(1d0))::alphasc_real=1d0,alphasu_real=1d0,alphasd_real=1d0
    REAL(KIND(1d0))::alphasc_other=1d0,alphasu_other=1d0,alphasd_other=1d0
    REAL(KIND(1d0)),DIMENSION(3)::R_alphas_real,R_pdf_real
    REAL(KIND(1d0)),DIMENSION(3)::R_alphas_other,R_pdf_other
    REAL(KIND(1d0))::wsfw,wmew
    REAL(KIND(1d0)),DIMENSION(0:6)::me_real,me_other
    INTEGER::i,j,ipow
    IF(.NOT.reweight_scale)THEN
       WRITE(*,*)"ERROR:Please set reweight_scale to be T first !"
       STOP
    ENDIF
    ! reweighting for alpha_s
    IF(ibody.EQ.3)THEN
       ipow=2
    ELSE
       ipow=3
    ENDIF
!    CALL onium_scale(scale)
!    scale=scale*muR_over_ref
    IF(ibody.EQ.1)THEN
       alphasc_real=ALPHAS(scale_real)
       alphasu_real=ALPHAS(scale_real*rw_Rscale_up)
       alphasd_real=ALPHAS(scale_real*rw_Rscale_down)
       R_alphas_real(1)=1d0
       R_alphas_real(2)=(alphasu_real/alphasc_real)**ipow
       R_alphas_real(3)=(alphasd_real/alphasc_real)**ipow
    ELSE
       R_alphas_real(1:3)=1d0
    ENDIF
    alphasc_other=ALPHAS(scale_other)
    alphasu_other=ALPHAS(scale_other*rw_Rscale_up)
    alphasd_other=ALPHAS(scale_other*rw_Rscale_down)
    R_alphas_other(1)=1d0
    R_alphas_other(2)=(alphasu_other/alphasc_other)**ipow
    R_alphas_other(3)=(alphasd_other/alphasc_other)**ipow
    R_pdf_real(1)=wsf0_real
    R_pdf_other(1)=wsf0_other
    IF(istruc.EQ.1)THEN
       IF(ibody.EQ.1)THEN
          xp1=xp1_real
          xp2=xp2_real
          onium_pmom(1:4,1:4)=onium_pmom_real(1:4,1:4)
          reweight_Fscale_phase=1 ! 1: multiply central scale * rw_Fscale_up
          CALL strf_pdf_pp_oniumX(wsfw,inum)
          R_pdf_real(2)=wsfw
          reweight_Fscale_phase=-1 ! -1: mutliply central scale * rw_Fscale_down
          CALL strf_pdf_pp_oniumX(wsfw,inum)
          R_pdf_real(3)=wsfw
          ! recover it
          reweight_Fscale_phase=0
       ELSE
          R_pdf_real(2:3)=wsf0_real
       ENDIF
       xp1=xp1_other
       xp2=xp2_other
       onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
       reweight_Fscale_phase=1 ! 1: multiply central scale * rw_Fscale_up
       CALL strf_pdf_pp_oniumX(wsfw,inum)
       R_pdf_other(2)=wsfw
       reweight_Fscale_phase=-1 ! -1: mutliply central scale * rw_Fscale_down
       CALL strf_pdf_pp_oniumX(wsfw,inum)
       R_pdf_other(3)=wsfw
       ! recover it
       reweight_Fscale_phase=0
    ELSE
       R_pdf_real(1:3)=1d0
       R_pdf_other(1:3)=1d0
    ENDIF
    wgtxsecmu(1:3,1:3)=1d0
    DO i=1,3
       DO j=1,3
          IF(ibody.EQ.1)THEN
             onium_muR=scale_real*rw_Rscales(i)
             onium_muF=scale_real*rw_Fscales(j)
             CALL call_NLO_pp_oniumX_subprocess(onium_z,as_real,onium_state,inum,me_real,.TRUE.)
          ELSE
             me_real(0:6)=0d0
          ENDIF
          onium_muR=scale_other*rw_Rscales(i)
          onium_muF=scale_other*rw_Fscales(j)
          CALL call_NLO_pp_oniumX_subprocess(onium_z,as_real,onium_state,inum,me_other,.TRUE.)
          me_other(0)=me_other(0)*(as_other/as_real)**2
          me_other(1:6)=me_other(1:6)*(as_other/as_real)**3
          SELECT CASE(ibody)
          CASE(1)
             ! (n+1) body
             wmew=(me_real(2)/onium_z**2*R_pdf_real(j)*R_alphas_real(i)&
                  -me_other(3)*R_pdf_other(j)*R_alphas_other(i))/(1d0-onium_z)&
                  +(me_real(4)/onium_z**2*R_pdf_real(j)*R_alphas_real(i)&
                  -me_other(5)*R_pdf_other(j)*R_alphas_other(i))&
                  *DLOG(1d0-onium_z)/(1d0-onium_z)&
                  +me_real(6)/onium_z**2*R_pdf_real(j)*R_alphas_real(i)
          CASE(2)
             ! n body (excluding Born)
             wmew=me_other(3)*DLOG((1d0-onium_zmin)/(1d0-z0))&
                    +me_other(5)*0.5d0*(DLOG(1d0-onium_zmin)**2-DLOG(1d0-z0)**2)&
                    +me_other(1)
             wmew=wmew*R_pdf_other(j)*R_alphas_other(i)
          CASE(3)
             ! Born
             wmew=me_other(0)
             wmew=wmew*R_pdf_other(j)*R_alphas_other(i)
          END SELECT
          wgtxsecmu(i,j)=wmew/wme0
       ENDDO
    END DO
    RETURN
  END SUBROUTINE pp_oniumX_reweight_xsec_scale

  SUBROUTINE pp_oniumX_reweight_xsec_pdf(me0_real,me0_other,wsf0_real,wsf0_other,wme0,inum,ibody)
    IMPLICIT NONE
    INTEGER::init=0,i,k,kk
    REAL(KIND(1d0)),INTENT(IN)::wsf0_real,wsf0_other,wme0
    REAL(KIND(1d0)),DIMENSION(0:6),INTENT(IN)::me0_real,me0_other
    ! inum: 1,gg; 2, qg+gq+qbarg+gqbar; 3, qqbar+qbarq
    ! ibody=1: (n+1)-body contribution
    ! ibody=2: n-body contribution (excluding Born)
    ! ibody=3: Born contribution
    INTEGER,INTENT(IN)::inum,ibody
    REAL(KIND(1d0))::wsfw_real,wsfw_other
    REAL(KIND(1d0))::wmew
    SAVE init
    LOGICAL::lexist
    IF(.NOT.reweight_pdf)THEN
       WRITE(*,*)"ERROR:Please set reweight_pdf to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(MOD(ho_npdf,2).NE.0)THEN
          WRITE(*,*)'The number of error sets must be even',ho_npdf
          STOP
       ENDIF
       IF(MOD(ho_npdf2,2).NE.0)THEN
          WRITE(*,*)'The number of error sets for beam 2 must be even',ho_npdf2
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecpdf))THEN
          DEALLOCATE(wgtxsecpdf)
       ENDIF
       ALLOCATE(wgtxsecpdf(ho_npdf+ho_npdf2))
       IF(ho_npdf.GT.0)THEN
          IF(ALLOCATED(idpdf))THEN
             DEALLOCATE(idpdf)
          ENDIF
          ALLOCATE(idpdf(0:ho_npdf))
          idpdf(0)=iPDFSUP1
          idpdf(1)=ipdf_set_min
          IF(ipdf_set_max-ipdf_set_min+1.NE.ho_npdf)THEN
             WRITE(*,*)'Incorrect the number of error pdf',ho_npdf,ipdf_set_min,ipdf_set_max
             STOP
          ENDIF
          DO i=2,ho_npdf
             idpdf(i)=idpdf(1)+i-1
          ENDDO
          WRITE(*,*) 'Doing PDF reweight:'
          WRITE(*,*) 'Central set id: ',idpdf(0)
          WRITE(*,*) 'Min error set id: ',idpdf(1)
          WRITE(*,*) 'Max error set id: ',idpdf(ho_npdf)
       ENDIF
       IF(ho_npdf2.GT.0)THEN
          IF(ALLOCATED(idpdf2))THEN
             DEALLOCATE(idpdf2)
          ENDIF
          ALLOCATE(idpdf2(0:ho_npdf2))
          idpdf2(0)=iPDFSUP2
          idpdf2(1)=ipdf2_set_min
          IF(ipdf2_set_max-ipdf2_set_min+1.NE.ho_npdf2)THEN
             WRITE(*,*)'Incorrect the number of error pdf2',ho_npdf2,ipdf2_set_min,ipdf2_set_max
             STOP
          ENDIF
          DO i=2,ho_npdf2
             idpdf2(i)=idpdf2(1)+i-1
          ENDDO
          WRITE(*,*) 'Doing PDF Beam 2 reweight:'
          WRITE(*,*) 'Central set id: ',idpdf2(0)
          WRITE(*,*) 'Min error set id: ',idpdf2(1)
          WRITE(*,*) 'Max error set id: ',idpdf2(ho_npdf2)
       ENDIF
       init=1
    ENDIF
    IF(.NOT.multipdfloading)THEN
       DO i=1,ho_npdf
          INCLUDE "../../../input/lhapdf/call_initpdf"
          IF(istruc.EQ.1)THEN
             IF(ibody.EQ.1)THEN
                xp1=xp1_real
                xp2=xp2_real
                onium_pmom(1:4,1:4)=onium_pmom_real(1:4,1:4)
                CALL strf_pdf_pp_oniumX(wsfw_real,inum)
             ELSE
                wsfw_real=0d0
             ENDIF
             xp1=xp1_other
             xp2=xp2_other
             onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
             CALL strf_pdf_pp_oniumX(wsfw_other,inum)
          ELSE
             WRITE(*,*)"ERROR: do not know the meaning of istruc with reweighting PDF"
             STOP
          ENDIF
          IF(ibody.EQ.1)THEN
             ! (n+1) body
             wmew=(me0_real(2)/onium_z**2*wsfw_real-me0_other(3)*wsfw_other)/(1d0-onium_z)&
                  +(me0_real(4)/onium_z**2*wsfw_real-me0_other(5)*wsfw_other)&
                  *DLOG(1d0-onium_z)/(1d0-onium_z)&
                  +me0_real(6)/onium_z**2*wsfw_real
             wgtxsecpdf(i)=wmew/wme0
          ELSE
             wgtxsecpdf(i)=wsfw_other/wsf0_other
          ENDIF
       ENDDO
    ELSE
       IF(.NOT.beams_pdf_correlation)THEN
          DO i=1,ho_npdf
             INCLUDE "../../../input/lhapdf/call_initmpdf1"
             IF(ibody.EQ.1)THEN
                xp1=xp1_real
                xp2=xp2_real
                onium_pmom(1:4,1:4)=onium_pmom_real(1:4,1:4)
                CALL strf_pdf_pp_oniumX(wsfw_real,inum)
             ELSE
                wsfw_real=0d0
             ENDIF
             xp1=xp1_other
             xp2=xp2_other
             onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
             CALL strf_pdf_pp_oniumX(wsfw_other,inum)
             IF(ibody.EQ.1)THEN
                ! (n+1) body
                wmew=(me0_real(2)/onium_z**2*wsfw_real-me0_other(3)*wsfw_other)/(1d0-onium_z)&
                     +(me0_real(4)/onium_z**2*wsfw_real-me0_other(5)*wsfw_other)&
                     *DLOG(1d0-onium_z)/(1d0-onium_z)&
                     +me0_real(6)/onium_z**2*wsfw_real
                wgtxsecpdf(i)=wmew/wme0
             ELSE
                wgtxsecpdf(i)=wsfw_other/wsf0_other
             ENDIF
          ENDDO
          INCLUDE "../../../input/lhapdf/call_initmpdf10"
          DO i=1,ho_npdf2
             INCLUDE "../../../input/lhapdf/call_initmpdf2"
             IF(ibody.EQ.1)THEN
                xp1=xp1_real
                xp2=xp2_real
                onium_pmom(1:4,1:4)=onium_pmom_real(1:4,1:4)
                CALL strf_pdf_pp_oniumX(wsfw_real,inum)
             ELSE
                wsfw_real=0d0
             ENDIF
             xp1=xp1_other
             xp2=xp2_other
             onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
             CALL strf_pdf_pp_oniumX(wsfw_other,inum)
             IF(ibody.EQ.1)THEN
                ! (n+1) body
                wmew=(me0_real(2)/onium_z**2*wsfw_real-me0_other(3)*wsfw_other)/(1d0-onium_z)&
                     +(me0_real(4)/onium_z**2*wsfw_real-me0_other(5)*wsfw_other)&
                     *DLOG(1d0-onium_z)/(1d0-onium_z)&
                     +me0_real(6)/onium_z**2*wsfw_real
                wgtxsecpdf(i+ho_npdf)=wmew/wme0
             ELSE
                wgtxsecpdf(i+ho_npdf)=wsfw_other/wsf0_other
             ENDIF
          ENDDO
          INCLUDE "../../../input/lhapdf/call_initmpdf20"
       ELSE
          ! it is correlated for two beams
          DO i=1,ho_npdf
             INCLUDE "../../../input/lhapdf/call_initmpdf1"
             INCLUDE "../../../input/lhapdf/call_initmpdf2"
             IF(ibody.EQ.1)THEN
                xp1=xp1_real
                xp2=xp2_real
                onium_pmom(1:4,1:4)=onium_pmom_real(1:4,1:4)
                CALL strf_pdf_pp_oniumX(wsfw_real,inum)
             ELSE
                wsfw_real=0d0
             ENDIF
             xp1=xp1_other
             xp2=xp2_other
             onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
             CALL strf_pdf_pp_oniumX(wsfw_other,inum)
             IF(ibody.EQ.1)THEN
                ! (n+1) body
                wmew=(me0_real(2)/onium_z**2*wsfw_real-me0_other(3)*wsfw_other)/(1d0-onium_z)&
                     +(me0_real(4)/onium_z**2*wsfw_real-me0_other(5)*wsfw_other)&
                     *DLOG(1d0-onium_z)/(1d0-onium_z)&
                     +me0_real(6)/onium_z**2*wsfw_real
                wgtxsecpdf(i)=wmew/wme0
             ELSE
                wgtxsecpdf(i)=wsfw_other/wsf0_other
             ENDIF
          ENDDO
          INCLUDE "../../../input/lhapdf/call_initmpdf10"
          INCLUDE "../../../input/lhapdf/call_initmpdf20"
       ENDIF
       RETURN
    ENDIF
    ! recover it
    INCLUDE "../../../input/lhapdf/call_initpdf0"
    RETURN
  END SUBROUTINE pp_oniumX_reweight_xsec_pdf

  SUBROUTINE pp_oniumX_reweight_xsec_npdf(me0_real,me0_other,wsf0_real,wsf0_other,wme0,inum,ibody)
    IMPLICIT NONE
    INTEGER::init=0,i,k,kk
    INTEGER,DIMENSION(2)::icase
    ! inum: 1,gg; 2, qg+gq+qbarg+gqbar; 3, qqbar+qbarq
    ! ibody=1: (n+1)-body contribution
    ! ibody=2: n-body contribution (excluding Born)
    ! ibody=3: Born contribution
    INTEGER,INTENT(IN)::inum,ibody
    REAL(KIND(1d0)),INTENT(IN)::wsf0_real,wsf0_other,wme0
    REAL(KIND(1d0)),DIMENSION(0:6),INTENT(IN)::me0_real,me0_other
    REAL(KIND(1d0))::wsfw_real,wsfw_other
    REAL(KIND(1d0))::wmew
    SAVE init
    INTEGER::icheck=0
    SAVE icheck
    LOGICAL::lexist
    IF(.NOT.reweight_npdf)THEN
       WRITE(*,*)"ERROR:Please set reweight_npdf to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(MOD(ho_nnpdf,2).NE.0)THEN
          WRITE(*,*)'The number of error sets must be even',ho_nnpdf
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecnpdf))THEN
          DEALLOCATE(wgtxsecnpdf)
       ENDIF
       ALLOCATE(wgtxsecnpdf(ho_nnpdf))
       IF(ALLOCATED(idnpdf))THEN
          DEALLOCATE(idnpdf)
       ENDIF
       ALLOCATE(idnpdf(0:ho_nnpdf))
       IF(nPDF_id.NE.1000)THEN
          idnpdf(0)=nPDF_id
          idnpdf(1)=inpdf_set_min
       ELSE
          idnpdf(0)=iPDFSUP1
          idnpdf(1)=inpdf_set_min-1000+iPDFSUP1
       ENDIF
       IF(inpdf_set_max-inpdf_set_min+1.NE.ho_nnpdf)THEN
          WRITE(*,*)'Incorrect the number of error npdf',ho_nnpdf,inpdf_set_min,inpdf_set_max
          STOP
       ENDIF
       DO i=2,ho_nnpdf
          idnpdf(i)=idnpdf(1)+i-1
       ENDDO
       WRITE(*,*) 'Doing nPDF reweight:'
       WRITE(*,*) 'Central set id: ',idnpdf(0)
       WRITE(*,*) 'Min error set id: ',idnpdf(1)
       WRITE(*,*) 'Max error set id: ',idnpdf(ho_nnpdf)
       init=1
    ENDIF
    DO i=1,ho_nnpdf
       use_neutron_rand=.TRUE.
       INCLUDE "../../../input/lhapdf/call_initnpdfi"
       INCLUDE "../../../input/lhapdf/call_initnpdfi_lhapdf6"
       IF(istruc.EQ.1)THEN
          IF(ibody.EQ.1)THEN
             xp1=xp1_real
             xp2=xp2_real
             onium_pmom(1:4,1:4)=onium_pmom_real(1:4,1:4)
             CALL strf_pdf_pp_oniumX(wsfw_real,inum)
          ELSE
             wsfw_real=0d0
          ENDIF
          xp1=xp1_other
          xp2=xp2_other
          onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
          CALL strf_pdf_pp_oniumX(wsfw_other,inum)
       ELSE
          WRITE(*,*)"ERROR: cannot understand the value of istruc within pp_oniumX_reweigt_xsec_npdf"
          STOP
       ENDIF
       IF(ibody.EQ.1)THEN
          ! (n+1) body
          wmew=(me0_real(2)/onium_z**2*wsfw_real-me0_other(3)*wsfw_other)/(1d0-onium_z)&
               +(me0_real(4)/onium_z**2*wsfw_real-me0_other(5)*wsfw_other)&
               *DLOG(1d0-onium_z)/(1d0-onium_z)&
               +me0_real(6)/onium_z**2*wsfw_real
          wgtxsecnpdf(i)=wmew/wme0
       ELSE
          wgtxsecnpdf(i)=wsfw_other/wsf0_other
       ENDIF
!       wgtxsecnpdf(i)=wsfw/wsf0
    ENDDO
    ! recover it
    INCLUDE "../../../input/lhapdf/call_initnpdf"
    INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_0"
    RETURN
  END SUBROUTINE pp_oniumX_reweight_xsec_npdf

  SUBROUTINE pp_oniumX_reweight_xsec_ref(me0_real,me0_other,wsf0_real,wsf0_other,wme0,inum,ibody)
    IMPLICIT NONE
    INTEGER::init=0,i
    REAL(KIND(1d0)),INTENT(IN)::wsf0_real,wsf0_other,wme0
    REAL(KIND(1d0)),DIMENSION(0:6),INTENT(IN)::me0_real,me0_other
    ! inum: 1,gg; 2, qg+gq+qbarg+gqbar; 3, qqbar+qbarq
    ! ibody=1: (n+1)-body contribution
    ! ibody=2: n-body contribution (excluding Born)
    ! ibody=3: Born contribution
    INTEGER,INTENT(IN)::inum,ibody
    REAL(KIND(1d0))::wsfw_real,wsfw_other
    REAL(KIND(1d0))::wmew
    SAVE init
    IF(.NOT.reweight_ref)THEN
       WRITE(*,*)"ERROR:Please set reweight_ref to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(ho_nref.NE.1.AND.ho_nref.NE.3)THEN
          WRITE(*,*)'Incorrect the number of references #1:',ho_nref
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecref))THEN
          DEALLOCATE(wgtxsecref)
       ENDIF
       ALLOCATE(wgtxsecref(ho_nref))
       IF(ALLOCATED(idref))THEN
          DEALLOCATE(idref)
       ENDIF
       ALLOCATE(idref(0:ho_nref))
       idref(0)=0
       idref(1)=iref_set_max
       IF(iref_set_max-iref_set_min+1.NE.ho_nref)THEN
          WRITE(*,*)'Incorrect the number of references #2:',ho_nref,iref_set_min,iref_set_max
          STOP
       ENDIF
       DO i=2,ho_nref
          idref(i)=idref(1)+i-1
       ENDDO
       WRITE(*,*) 'Doing reference reweight'
       init=1
    END IF
    ! reference: pp
    INCLUDE "../../../input/lhapdf/call_initnpdf"
    PureProton1=.TRUE.
    PureProton2=.TRUE.
    IF(istruc.EQ.1)THEN
       IF(ibody.EQ.1)THEN
          xp1=xp1_real
          xp2=xp2_real
          onium_pmom(1:4,1:4)=onium_pmom_real(1:4,1:4)
          CALL strf_pdf_pp_oniumX(wsfw_real,inum)
       ELSE
          wsfw_real=0d0
       ENDIF
       xp1=xp1_other
       xp2=xp2_other
       onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
       CALL strf_pdf_pp_oniumX(wsfw_other,inum)
    ELSE
       WRITE(*,*)"Erraor: unknow the value of istruc in pp_oniumX_reweight_xsec_ref # 1"
       STOP
    ENDIF
    IF(ibody.EQ.1)THEN
       ! (n+1) body
       wmew=(me0_real(2)/onium_z**2*wsfw_real-me0_other(3)*wsfw_other)/(1d0-onium_z)&
            +(me0_real(4)/onium_z**2*wsfw_real-me0_other(5)*wsfw_other)&
            *DLOG(1d0-onium_z)/(1d0-onium_z)&
            +me0_real(6)/onium_z**2*wsfw_real
       wgtxsecref(1)=wmew/wme0
    ELSE
       wgtxsecref(1)=wsfw_other/wsf0_other
    ENDIF
    IF(ho_nref.LE.1)THEN
       PureProton1=.FALSE.
       PureProton2=.FALSE.
       RETURN
    ENDIF
    ! reference: pB collision for AB
    PureProton2=.FALSE.
    IF(ibody.EQ.1)THEN
       xp1=xp1_real
       xp2=xp2_real
       onium_pmom(1:4,1:4)=onium_pmom_real(1:4,1:4)
       CALL strf_pdf_pp_oniumX(wsfw_real,inum)
    ELSE
       wsfw_real=0d0
    ENDIF
    xp1=xp1_other
    xp2=xp2_other
    onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
    CALL strf_pdf_pp_oniumX(wsfw_other,inum)
    IF(ibody.EQ.1)THEN
       ! (n+1) body
       wmew=(me0_real(2)/onium_z**2*wsfw_real-me0_other(3)*wsfw_other)/(1d0-onium_z)&
            +(me0_real(4)/onium_z**2*wsfw_real-me0_other(5)*wsfw_other)&
            *DLOG(1d0-onium_z)/(1d0-onium_z)&
            +me0_real(6)/onium_z**2*wsfw_real
       wgtxsecref(2)=wmew/wme0
    ELSE
       wgtxsecref(2)=wsfw_other/wsf0_other
    ENDIF
    ! reference: Ap collision for AB
    PureProton2=.TRUE.
    PureProton1=.FALSE.
    IF(ibody.EQ.1)THEN
       xp1=xp1_real
       xp2=xp2_real
       onium_pmom(1:4,1:4)=onium_pmom_real(1:4,1:4)
       CALL strf_pdf_pp_oniumX(wsfw_real,inum)
    ELSE
       wsfw_real=0d0
    ENDIF
    xp1=xp1_other
    xp2=xp2_other
    onium_pmom(1:4,1:4)=onium_pmom_other(1:4,1:4)
    CALL strf_pdf_pp_oniumX(wsfw_other,inum)
    IF(ibody.EQ.1)THEN
       ! (n+1) body
       wmew=(me0_real(2)/onium_z**2*wsfw_real-me0_other(3)*wsfw_other)/(1d0-onium_z)&
            +(me0_real(4)/onium_z**2*wsfw_real-me0_other(5)*wsfw_other)&
            *DLOG(1d0-onium_z)/(1d0-onium_z)&
            +me0_real(6)/onium_z**2*wsfw_real
       wgtxsecref(3)=wmew/wme0
    ELSE
       wgtxsecref(3)=wsfw_other/wsf0_other
    ENDIF

    PureProton1=.FALSE.
    PureProton2=.FALSE.
    RETURN
  END SUBROUTINE pp_oniumX_reweight_xsec_ref

  SUBROUTINE strf_pdf_pp_oniumX(wsf,inum)
    USE CTEQ6PDF
    USE Structf_PDFs
    IMPLICIT NONE
    INTEGER::ipp=1
    INTEGER::ih=1 ! ih=1 no photon PDF, ih=2, photon from proton/anti-proton, ih=3 phton from electron/positron
    REAL(KIND(1d0)),INTENT(OUT)::wsf
    INTEGER,INTENT(IN)::inum ! inum = 1: gg; inum=2: gq+qg+gqbar+qbarg; inum=3: qqbar+qbarq
    INTEGER::init=0
    LOGICAL::use_cteq6_f90=.TRUE.
    REAL(KIND=DBL),DIMENSION(-7:7)::pdflist
    SAVE init,ipp,use_cteq6_f90
    REAL(KIND(1d0))::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
         ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct
    IF(iPDFSUP1.EQ.iPDFSUP2)THEN
       INCLUDE "../lhapdf/call_strf_lhapdf"
    ELSE
       INCLUDE "../lhapdf/call_strf_mlhapdf"
    ENDIF
    IF(init.EQ.0)THEN
       SELECT CASE(iPDFSUP1)
       CASE(10000)
          CALL SetCtq6f90(1)
          pdlabel='cteq6_m'
          nloop=2
          alphaQCD2=0.118d0
          use_cteq6_f90=.TRUE.
       CASE(10041)
          CALL SetCtq6f90(3)
          pdlabel='cteq6_l'
          nloop=2
          alphaQCD2=0.118d0
          use_cteq6_f90=.TRUE.
       CASE(10042)
          CALL SetCtq6f90(4)
          pdlabel='cteq6l1'
          nloop=1
          alphaQCD2=0.130d0
          use_cteq6_f90=.TRUE.
       CASE DEFAULT
          CALL pdfset_internal
          use_cteq6_f90=.FALSE.
       END SELECT
       IF(COLL_TYPE.EQ.1)THEN
          ipp=2
       ELSE
          ipp=1
       ENDIF
       init=1
    ENDIF
    
    CALL onium_scale(scale)
    scale=muF_over_ref*scale
    IF(reweight_scale)THEN
       IF(reweight_Fscale_phase.EQ.1)THEN
          scale=scale*rw_Fscale_up
       ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
          scale=scale*rw_Fscale_down
       ENDIF
    ENDIF
    
    IF(use_cteq6_f90)THEN
       glu1_ct = xp1*Ctq6Pdf_f90(0,xp1,scale)
       glu2_ct = xp2*Ctq6Pdf_f90(0,xp2,scale)
       u1_ct   = xp1*Ctq6Pdf_f90(1,xp1,scale)
       u2_ct   = xp2*Ctq6Pdf_f90(1,xp2,scale)
       d1_ct   = xp1*Ctq6Pdf_f90(2,xp1,scale)
       d2_ct   = xp2*Ctq6Pdf_f90(2,xp2,scale)
       s1_ct   = xp1*Ctq6Pdf_f90(3,xp1,scale)
       s2_ct   = xp2*Ctq6Pdf_f90(3,xp2,scale)
       c1_ct   = xp1*Ctq6Pdf_f90(4,xp1,scale)
       c2_ct   = xp2*Ctq6Pdf_f90(4,xp2,scale)
       b1_ct   = xp1*Ctq6Pdf_f90(5,xp1,scale)
       b2_ct   = xp2*Ctq6Pdf_f90(5,xp2,scale)
       ub1_ct  = xp1*Ctq6Pdf_f90(-1,xp1,scale)
       ub2_ct  = xp2*Ctq6Pdf_f90(-1,xp2,scale)
       db1_ct  = xp1*Ctq6Pdf_f90(-2,xp1,scale)
       db2_ct  = xp2*Ctq6Pdf_f90(-2,xp2,scale)
       sb1_ct  = xp1*Ctq6Pdf_f90(-3,xp1,scale)
       sb2_ct  = xp2*Ctq6Pdf_f90(-3,xp2,scale)
       cb1_ct  = xp1*Ctq6Pdf_f90(-4,xp1,scale)
       cb2_ct  = xp2*Ctq6Pdf_f90(-4,xp2,scale)
       bb1_ct  = xp1*Ctq6Pdf_f90(-5,xp1,scale)
       bb2_ct  = xp2*Ctq6Pdf_f90(-5,xp2,scale)
    ELSE
       CALL fdist(ih,xp1,scale,pdflist(-7:7))
       glu1_ct = xp1*pdflist(0)
       u1_ct   = xp1*pdflist(2)
       d1_ct   = xp1*pdflist(1)
       s1_ct   = xp1*pdflist(3)
       c1_ct   = xp1*pdflist(4)
       b1_ct   = xp1*pdflist(5)
       ub1_ct  = xp1*pdflist(-2)
       db1_ct  = xp1*pdflist(-1)
       sb1_ct  = xp1*pdflist(-3)
       cb1_ct  = xp1*pdflist(-4)
       bb1_ct  = xp1*pdflist(-5)
       CALL fdist(ih,xp2,scale,pdflist(-7:7))
       glu2_ct = xp2*pdflist(0)
       u2_ct   = xp2*pdflist(2)
       d2_ct   = xp2*pdflist(1)
       s2_ct   = xp2*pdflist(3)
       c2_ct   = xp2*pdflist(4)
       b2_ct   = xp2*pdflist(5)
       ub2_ct  = xp2*pdflist(-2)
       db2_ct  = xp2*pdflist(-1)
       sb2_ct  = xp2*pdflist(-3)
       cb2_ct  = xp2*pdflist(-4)
       bb2_ct  = xp2*pdflist(-5)
    ENDIF
    ! recover it
    IF(reweight_scale)THEN
       IF(reweight_Fscale_phase.EQ.1)THEN
          scale=scale/rw_Fscale_up
       ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
          scale=scale/rw_Fscale_down
       ENDIF
    ENDIF
    IF(inum.EQ.1)THEN
       ! gg
       wsf=glu1_ct*glu2_ct*wjac/xp1/xp2
    ELSEIF(inum.EQ.2)THEN
       ! gq+qg+gqbar+qbarg
       wsf=glu1_ct*(u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct)
       wsf=wsf+(u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct)*glu2_ct
       IF(IQUARK.GT.4)THEN
          wsf=wsf+glu1_ct*(c2_ct+cb2_ct)+(c1_ct+cb1_ct)*glu2_ct
       ENDIF
       wsf=wsf*wjac/xp1/xp2
    ELSEIF(inum.EQ.3)THEN
       ! qqbar+qbarq
       wsf=(u1_ct*ub2_ct+ub1_ct*u2_ct+d1_ct*db2_ct+db1_ct*d2_ct&
            +s1_ct*sb2_ct+sb1_ct*s2_ct)
       IF(IQUARK.GT.4)THEN
          wsf=wsf+(c1_ct*cb2_ct+cb1_ct*c2_ct)
       ENDIF
       wsf=wsf*wjac/xp1/xp2
    ENDIF
    IF(init.EQ.0)init=1
  END SUBROUTINE strf_pdf_pp_oniumX

  SUBROUTINE readcuts_pp_oniumX
    IMPLICIT NONE
    CHARACTER(len=24)::file
    LOGICAL::lexist
    INTEGER::iounit,flag=0,i,i1,j,j1
    REAL(KIND(1d0))::ptq,ptcharm,ptconia,etaq,ycq,ycqlow,etaconia,ycconia,ycconialow
    REAL(KIND(1d0))::cutoff,ptbonia,etabonia,ycbonia,ycbonialow
    REAL(KIND(1d0))::xFcq,xFcqlow,xFcconia,xFcconialow,xFcbonia,xFcbonialow
    REAL(KIND(1d0))::gbeamq,drqq,gqq,maxptq,maxptcharm,maxptconia,maxptbonia
    ! open default input file
    INQUIRE(FILE=TRIM(input_dir)//"default.inp",EXIST=lexist)
    IF(.NOT.lexist)THEN
       PRINT *,"Warning: the file default.inp does not exist ! STOP !"
       STOP
    ENDIF
    INQUIRE(FILE=TRIM(input_dir)//"default.inp",OPENED=lexist)
    IF(lexist)THEN
       INQUIRE(FILE=TRIM(input_dir)//"default.inp",NUMBER=iounit)
       IF(iounit.NE.udefault)THEN
          PRINT *,"WARNING: the default.inp has been linked with another unit ! Close and reopen !"
          CLOSE(UNIT=iounit)
          OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
       ENDIF
    ELSE
       OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
    ENDIF
    ! open user's input file
    IF(TRIM(Input_File)/="default.inp")THEN
       INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),EXIST=lexist)
       IF(.NOT.lexist)THEN
          PRINT *,"Warning: the file "//TRIM(Input_File)//" does not exist ! STOP !"
          STOP
       ENDIF
       INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),OPENED=lexist)
       IF(lexist)THEN
          INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),NUMBER=iounit)
          IF(iounit.NE.uinput)THEN
             PRINT *,"WARNING: the "//TRIM(Input_File)//" has been linked with another unit ! Close and reopen !"
             CLOSE(UNIT=iounit)
             OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
          ENDIF
       ELSE
          OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
       ENDIF
    ELSE
       flag=1
    ENDIF
    cutoff=readvalue_r("cutoffp",flag)
    ptc(3:20)=cutoff
    maxptc(3:20)=-1d0
    drc(3:20,3:20)=0
    etac(3:20)=20
    yycut(3:20)=1d9
    IF(absrap)THEN
       yycutlow(3:20)=0d0
    ELSE
       yycutlow(3:20)=-1d9
    ENDIF
    xFcut(3:20)=1d0
    xFcutlow(3:20)=-1d0
    xFcutflag=.FALSE.
    ec(3:20)=cutoff
    c1(3:20)=1d0
    c2(3:20)=1d0
    cc(3:20,3:20)=1d0
    gmas(3:20,3:20)=cutoff
    gbeammass(1:2,3:20)=0d0
    y1cup=30d0
    y1clow=0d0
    y1cup=readvalue_r("maxy1c",flag)
    y1clow=readvalue_r("miny1c",flag)
    ! minimum quark pt
    ptq=readvalue_r("minptq",flag)
    ! maximum quark pt
    maxptq=readvalue_r("maxptq",flag)
    ! minimum charm pt
    ptcharm=readvalue_r("minptc",flag)
    ! maximum charm pt
    maxptcharm=readvalue_r("maxptc",flag)
    ! minimum charmonia pt
    ptconia=readvalue_r("minptconia",flag)
    ! maximum charmonia pt
    maxptconia=readvalue_r("maxptconia",flag)
    ! minimum bottomonia pt
    ptbonia=readvalue_r("minptbonia",flag)
    ! maximum bottomonia pt
    maxptbonia=readvalue_r("maxptbonia",flag)
    ! maximum rapidity quark
    etaq=readvalue_r("maxrapq",flag)
    ! maximum y rapidity quark
    ycq=readvalue_r("maxyrapq",flag)
    ! minimum y rapidity quark
    ycqlow=readvalue_r("minyrapq",flag)
    ! maximum Feynman parameter xF
    xFcq=readvalue_r("maxxFq",flag)
    ! minimum Feynman parameter xF
    xFcqlow=readvalue_r("minxFq",flag)
    ! maximum rapidity charmonium
    etaconia=readvalue_r("maxrapconia",flag)
    ! maximum y rapidity charmonium
    ycconia=readvalue_r("maxyrapconia",flag)
    ! minimum y rapidity charmonium
    ycconialow=readvalue_r("minyrapconia",flag)
    ! maximum Feynman parameter xF
    xFcconia=readvalue_r("maxxFconia",flag)
    ! minimum Feynman parameter xF
    xFcconialow=readvalue_r("minxFconia",flag)
    ! maxmimum rapidity bottomonia
    etabonia=readvalue_r("maxrapbonia",flag)
    ! maximum y rapidity bottomonia
    ycbonia=readvalue_r("maxyrapbonia",flag)
    ! minimum y rapidity bottomonia
    ycbonialow=readvalue_r("minyrapbonia",flag)
    ! maximum Feynman parameter xF
    xFcbonia=readvalue_r("maxxFbonia",flag)
    ! minimum Feynman parameter xF
    xFcbonialow=readvalue_r("minxFbonia",flag)
    ! minimum DR quark with quark
    drqq=readvalue_r("mindrqq",flag)
    ! minimum mass quark with quark
    gqq=readvalue_r("minmqqp",flag)
    ! minimum mass u,d,s quarks and gluon  with partonic beam
    gbeamq=readvalue_r("minmqbeam",flag)
    CLOSE(UNIT=udefault)
    CLOSE(UNIT=uinput)
    ! gluon as 2nd final particle
    ptc(4)=ptq
    IF(maxptq.GE.0d0)maxptc(4)=maxptq
    etac(4)=etaq
    yycut(4)=ycq
    yycutlow(4)=ycqlow
    xFcut(4)=xFcq
    xFcutlow(4)=xFcqlow
    ! quarkonium as 1st final particle
    IF(iflh(3).GE.440000.AND.iflh(3).LE.449999)THEN
       ptc(3)=ptconia
       IF(maxptconia.GE.0d0)maxptc(3)=maxptconia
       etac(3)=etaconia
       yycut(3)=ycconia
       yycutlow(3)=ycconialow
       xFcut(3)=xFcconia
       xFcutlow(3)=xFcconialow
    ELSE
       ptc(3)=ptbonia
       IF(maxptbonia.GE.0d0)maxptc(3)=maxptbonia
       etac(3)=etabonia
       yycut(3)=ycbonia
       yycutlow(3)=ycbonialow
       xFcut(3)=xFcbonia
       xFcutlow(3)=xFcbonialow
    ENDIF
    WRITE(*,*)'WARNING: the cuts may be incorrect as it is only applicable to inclusive cross section !'
    DO i=3,4
       WRITE(*,*)'pt     of  ',i,'   particle   ',ptc(i)
       IF(maxptc(i).GE.0d0)THEN
          WRITE(*,*)'max pt of  ',i,'   particle   ',maxptc(i)
          IF(maxptc(i).LE.ptc(i))THEN
             WRITE(*,*)"ERROR: One final state ",i," was cut off by pt cut"
             STOP
          ENDIF
       ELSE
          WRITE(*,*)'no max pt cut of  ',i,'   particle   '
       ENDIF
       WRITE(*,*)'rapidity of  ',i,'   particle   ',etac(i)
       WRITE(*,*)'max y rapidity of ',i,'   particle   ',yycut(i)
       WRITE(*,*)'min y rapidity of ',i,'   particle   ',yycutlow(i)
       IF(yycut(i).LE.yycutlow(i))THEN
          WRITE(*,*)"ERROR:One final state ",i," was cut off by y rapidity"
          STOP
       ENDIF
    ENDDO
    RETURN
  END SUBROUTINE readcuts_pp_oniumX

  SUBROUTINE Cuts_pp_oniumX(icut,inum)
    IMPLICIT NONE
    INTEGER,INTENT(OUT)::icut
    INTEGER,INTENT(IN)::inum ! 1: (n+1) body; 2: n body
    INTEGER::l,l1,l2,flag
    REAL(KIND(1d0))::s,d1,d2,dr,pt,eta,aaa,bbb,ptcut
    REAL(KIND(1d0)),DIMENSION(4)::ponia,pboo2
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
    REAL(KIND(1d0))::e,q
    REAL(KIND(1d0)),DIMENSION(3:4,4)::pmom_temp
    INTEGER::lmax
    icut=0
    flag=0
    IF(inum.EQ.1)THEN
       pmom_temp(3,1:4)=onium_pmom_real(3,1:4)
       pmom_temp(4,1:4)=onium_pmom_real(4,1:4)
       lmax=4
    ELSE
       pmom_temp(3,1:4)=onium_pmom_other(3,1:4)
       pmom_temp(4,1:4)=onium_pmom_other(4,1:4)
       lmax=3
    ENDIF
    DO l=3,lmax
       pt=SQRT(pmom_temp(l,1)**2+pmom_temp(l,2)**2)
       IF(lmax.EQ.3)pt=MAX(pt,1D-10)
       IF(pt.LT.ptc(l))THEN
          flag=1
          EXIT
       ENDIF
       IF(maxptc(l).GE.0d0)THEN
          IF(pt.GT.maxptc(l))THEN
             flag=1
             EXIT
          ENDIF
       ENDIF
       eta=prapidity(pmom_temp(l,1:4))
       IF(ABS(eta).GT.etac(l))THEN
          flag=1
          EXIT
       ENDIF
       eta=rapidity(pmom_temp(l,1:4))
       IF(absrap)eta=ABS(eta)
       IF(eta.GT.yycut(l).OR.eta.LT.yycutlow(l))THEN
          flag=1
          EXIT
       ENDIF
       ! special for the first particle , which can be used to calculate the y distribution
       IF(l.EQ.3)THEN
          IF(eta.GT.y1cup.OR.eta.LT.y1clow)THEN
             flag=1
             EXIT
          ENDIF
       ENDIF
    ENDDO
    IF(flag.EQ.0)icut=1
    ! treat xF cut
    ! it shoule be done in the collision frame
    IF(xFcutflag.AND.icut.EQ.1.AND.flag.EQ.0)THEN
       STOP "Error: cannot reach here !"
       q=ehat
       e=q/SQRT(xp1*xp2)
       IF(.NOT.labeqcoll)THEN
          IF(.NOT.fixtarget)THEN
             pboo2(4)=(ebeam(1)+ebeam(2))
             pboo2(3)=-(ebeam(1)-ebeam(2))
          ELSE
             IF(.NOT.fixtargetrev)THEN
                pboo2(4)=(ebeam(1)+ebeam(2))
                pboo2(3)=-ebeam(1)
             ELSE
                pboo2(4)=(ebeam(1)+ebeam(2))
                pboo2(3)=ebeam(2)
             ENDIF
          ENDIF
          pboo2(1:2)=0
          ! boost from the lab frame to the collision frame
          DO l=3,lmax
             CALL boostl(e,pboo2,pmom_temp(l,1:4))
          ENDDO
       ENDIF
       DO l=3,lmax
          eta=xFeynman(pmom_temp(l,1:4),e)
          IF(eta.GT.xFcut(l).OR.eta.LT.xFcutlow(l))THEN
             icut=0
             EXIT
          ENDIF
       ENDDO
       IF(.NOT.labeqcoll)THEN
          pboo2(3)=-pboo2(3)
          ! boost back to the lab frame
          DO l=3,lmax
             CALL boostl(e,pboo2,pmom_temp(l,1:4))
          ENDDO
       ENDIF
    ENDIF
    RETURN
  END SUBROUTINE Cuts_pp_oniumX

  SUBROUTINE call_NLO_pp_oniumX_subprocess(z,as,istate,inum,me,change_mu_only)
    USE NLO_pp_oniumX
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z
    INTEGER,INTENT(IN)::istate,inum
    REAL(KIND(1d0)),DIMENSION(0:6),INTENT(OUT)::me
    LOGICAL,INTENT(IN),OPTIONAL::change_mu_only
    LOGICAL::change_mu
    REAL(KIND(1d0)),INTENT(IN)::as
    IF(inum.LT.1.OR.inum.GT.3)THEN
       WRITE(*,*)"ERROR: inum should be in 1 to 3 !"
       STOP
    ENDIF
    IF(.NOT.PRESENT(change_mu_only))THEN
       change_mu=.FALSE.
    ELSE
       change_mu=change_mu_only
    ENDIF
    SELECT CASE(istate)
    CASE(1)
       ! 1S01
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_1S01X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2)
          CALL NLO_gq_1S01X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(3)
          CALL NLO_qq_1S01X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       END SELECT
    CASE(2)
       ! 1S08
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_1S01X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2)
          CALL NLO_gq_1S01X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(3)
          CALL NLO_qq_1S01X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       END SELECT
    CASE(3)
       ! 3S11
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_3S11X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2,3)
          me(0:6)=0d0
       END SELECT
    CASE(4)
       ! 3S18
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_3S18X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2)
          CALL NLO_gq_3S18X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(3)
          CALL NLO_qq_3S18X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       END SELECT
    CASE(5)
       ! 3P01
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_3P01X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2)
          CALL NLO_gq_3P01X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(3)
          CALL NLO_qq_3P01X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       END SELECT
    CASE(6)
       ! 3P11
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_3P11X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2)
          CALL NLO_gq_3P11X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(3)
          CALL NLO_qq_3P11X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       END SELECT
    CASE(7)
       ! 3P21
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_3P21X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2)
          CALL NLO_gq_3P21X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(3)
          CALL NLO_qq_3P21X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       END SELECT
    CASE(8)
       ! 3P08
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_3P08X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2)
          CALL NLO_gq_3P08X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(3)
          CALL NLO_qq_3P08X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       END SELECT
    CASE(9)
       ! 3P18
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_3P18X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2)
          CALL NLO_gq_3P18X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(3)
          CALL NLO_qq_3P18X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       END SELECT
    CASE(10)
       ! 3P28
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_3P28X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2)
          CALL NLO_gq_3P28X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(3)
          CALL NLO_qq_3P28X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       END SELECT
    CASE(11)
       ! 1P11
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_1P11X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2,3)
          me(0:6)=0d0
       END SELECT
    CASE(12)
       ! 1P18
       SELECT CASE(inum)
       CASE(1)
          CALL NLO_gg_1P18X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(2)
          CALL NLO_gq_1P18X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       CASE(3)
          CALL NLO_qq_1P18X(z,as,MQQ,LDME_onium,me(0:6),change_mu)
       END SELECT
    CASE DEFAULT
       WRITE(*,*)"ERROR: Do not known istate=",istate
       STOP
    END SELECT
    RETURN
  END SUBROUTINE call_NLO_pp_oniumX_subprocess
          
  SUBROUTINE call_NLO_pp_oniumX(z,as,istate,me,change_mu_only)
    USE NLO_pp_oniumX
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z
    INTEGER,INTENT(IN)::istate
    REAL(KIND(1d0)),DIMENSION(3,0:6),INTENT(OUT)::me
    LOGICAL,INTENT(IN),OPTIONAL::change_mu_only
    LOGICAL::change_mu
    REAL(KIND(1d0)),INTENT(IN)::as
    IF(.NOT.PRESENT(change_mu_only))THEN
       change_mu=.FALSE.
    ELSE
       change_mu=change_mu_only
    ENDIF
    SELECT CASE(istate)
    CASE(1)
       ! 1S01
       CALL NLO_gg_1S01X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       CALL NLO_gq_1S01X(z,as,MQQ,LDME_onium,me(2,0:6),change_mu)
       CALL NLO_qq_1S01X(z,as,MQQ,LDME_onium,me(3,0:6),change_mu)
    CASE(2)
       ! 1S08
       CALL NLO_gg_1S01X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       CALL NLO_gq_1S01X(z,as,MQQ,LDME_onium,me(2,0:6),change_mu)
       CALL NLO_qq_1S01X(z,as,MQQ,LDME_onium,me(3,0:6),change_mu)
    CASE(3)
       ! 3S11
       CALL NLO_gg_3S11X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       me(2:3,0:6)=0d0
    CASE(4)
       ! 3S18
       CALL NLO_gg_3S18X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       CALL NLO_gq_3S18X(z,as,MQQ,LDME_onium,me(2,0:6),change_mu)
       CALL NLO_qq_3S18X(z,as,MQQ,LDME_onium,me(3,0:6),change_mu)
    CASE(5)
       ! 3P01
       CALL NLO_gg_3P01X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       CALL NLO_gq_3P01X(z,as,MQQ,LDME_onium,me(2,0:6),change_mu)
       CALL NLO_qq_3P01X(z,as,MQQ,LDME_onium,me(3,0:6),change_mu)
    CASE(6)
       ! 3P11
       CALL NLO_gg_3P11X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       CALL NLO_gq_3P11X(z,as,MQQ,LDME_onium,me(2,0:6),change_mu)
       CALL NLO_qq_3P11X(z,as,MQQ,LDME_onium,me(3,0:6),change_mu)
    CASE(7)
       ! 3P21
       CALL NLO_gg_3P21X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       CALL NLO_gq_3P21X(z,as,MQQ,LDME_onium,me(2,0:6),change_mu)
       CALL NLO_qq_3P21X(z,as,MQQ,LDME_onium,me(3,0:6),change_mu)
    CASE(8)
       ! 3P08
       CALL NLO_gg_3P08X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       CALL NLO_gq_3P08X(z,as,MQQ,LDME_onium,me(2,0:6),change_mu)
       CALL NLO_qq_3P08X(z,as,MQQ,LDME_onium,me(3,0:6),change_mu)
    CASE(9)
       ! 3P18
       CALL NLO_gg_3P18X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       CALL NLO_gq_3P18X(z,as,MQQ,LDME_onium,me(2,0:6),change_mu)
       CALL NLO_qq_3P18X(z,as,MQQ,LDME_onium,me(3,0:6),change_mu)
    CASE(10)
       ! 3P28
       CALL NLO_gg_3P28X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       CALL NLO_gq_3P28X(z,as,MQQ,LDME_onium,me(2,0:6),change_mu)
       CALL NLO_qq_3P28X(z,as,MQQ,LDME_onium,me(3,0:6),change_mu)
    CASE(11)
       ! 1P11
       CALL NLO_gg_1P11X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       me(2:3,0:6)=0d0
    CASE(12)
       ! 1P18
       CALL NLO_gg_1P18X(z,as,MQQ,LDME_onium,me(1,0:6),change_mu)
       CALL NLO_gq_1P18X(z,as,MQQ,LDME_onium,me(2,0:6),change_mu)
       CALL NLO_qq_1P18X(z,as,MQQ,LDME_onium,me(3,0:6),change_mu)
    CASE DEFAULT
       WRITE(*,*)"ERROR: Do not known istate=",istate
       STOP
    END SELECT
    RETURN
  END SUBROUTINE call_NLO_pp_oniumX

  FUNCTION state2hoid(istate) RESULT(ho_id)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::istate
    INTEGER::ho_id
    ho_id=IQUARK*110000
    SELECT CASE(istate)
    CASE(1)
       ! 1S01
       ho_id=ho_id+1001
    CASE(2)
       ! 1S08
       ho_id=ho_id+1008
    CASE(3)
       ! 3S11
       ho_id=ho_id+3011
    CASE(4)
       ! 3S18
       ho_id=ho_id+3018
    CASE(5)
       ! 3P01
       ho_id=ho_id+3101
    CASE(6)
       ! 3P11
       ho_id=ho_id+3111
    CASE(7)
       ! 3P21
       ho_id=ho_id+3121
    CASE(8)
       ! 3P08
       ho_id=ho_id+3108
    CASE(9)
       ! 3P18
       ho_id=ho_id+3118
    CASE(10)
       ! 3P28
       ho_id=ho_id+3128
    CASE(11)
       ! 1P11
       ho_id=ho_id+1111
    CASE(12)
       ! 1P18
       ho_id=ho_id+1118
    CASE DEFAULT
       WRITE(*,*)"ERROR: do not know the state=",istate
       STOP
    END SELECT
    RETURN
  END FUNCTION state2hoid
  
END MODULE pp_oniumX
