HODIR=
FC=
objdir=$(HODIR)/addon/pp_oniumX/obj/
moddir=$(HODIR)/addon/pp_oniumX/mod/
srcdir=$(HODIR)/src/
nucdir=$(HODIR)/nuclear/
fundir=$(HODIR)/specialfuns/
thissrcdir=$(HODIR)/addon/pp_oniumX/src/
decaydir=$(HODIR)/decay/
libdir=$(HODIR)/lib/
showerdir=$(HODIR)/shower/interface/
# uncomment the following line to use gdb to debug
# FFLAGS=-ggdb -g -fbounds-check -ffpe-trap=invalid,zero,overflow,underflow,denormal -Wall
lhapdfobj=
obj=$(objdir)Helac_Global.o $(objdir)Helac_Func_1.o  $(objdir)Constants.o $(objdir)CTEQ6PDF.o $(objdir)Kinetic_Func.o $(objdir)Structf_PDFs.o $(objdir)photon_PDFs.o $(objdir)MC_VEGAS.o $(lhapdfobj) $(objdir)plot_pp_oniumX.o $(objdir)pp_oniumX.o $(objdir)NLO_pp_oniumX.o $(objdir)alfas_functions.o $(objdir)pp_oniumX_Global.o $(objdir)Main_pp_oniumX.o $(objdir)pp_oniumX_setscale.o $(objdir)setscale.o $(objdir)tbessk.o $(objdir)tbessj.o $(objdir)nielsen_generalized_polylog.o $(objdir)nintlib.o $(objdir)interpolation.o $(objdir)OpticalGlauber_Geometry.o $(objdir)ElasticPhotonPhotonFlux.o
mod = $(moddir)*.mod
exe = $(HODIR)/bin/HO_pp_oniumX
linkexe = $(HODIR)/addon/pp_oniumX/bin/HO_pp_oniumX
EXLIBS = 

all :   clean $(exe)
	ln -s $(exe) $(linkexe)

$(exe): $(obj)
	@cp *.o $(objdir)
	@cp *.mod $(moddir)
	@rm *.o *.mod
	$(FC) -o $(exe) $(obj) -L$(libdir) -lpdf -lhbook $(EXLIBS)

$(objdir)Main_pp_oniumX.o : $(thissrcdir)Main_pp_oniumX.f90 $(moddir)pp_oniumX.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)pp_oniumX_Global.o $(moddir)pp_oniumX_Global.mod: $(thissrcdir)pp_oniumX_Global.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Helac_Global.o $(moddir)Helac_Global.mod : $(srcdir)Helac_Global.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Helac_Func_1.o $(moddir)Helac_Func_1.mod : $(srcdir)Helac_Func_1.f90 $(moddir)Helac_Global.mod $(moddir)alfas_functions.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Constants.o $(moddir)Constants.mod: $(srcdir)Constants.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_PDFs.o $(moddir)Structf_PDFs.mod:$(srcdir)Structf_PDFs.f90 $(moddir)Helac_Global.mod $(moddir)CTEQ6PDF.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod $(moddir)ElasticPhotonPhotonFlux.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)ElasticPhotonPhotonFlux.o $(moddir)ElasticPhotonPhotonFlux.mod:$(nucdir)ElasticPhotonPhotonFlux.f90 $(moddir)OpticalGlauber_Geometry.mod $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)nintlib.o $(moddir)nintlib.mod: $(nucdir)nintlib.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)tbessk.o : $(fundir)tbessk.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)tbessj.o : $(fundir)tbessj.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)nielsen_generalized_polylog.o $(moddir)nielsen_generalized_polylog.mod : $(fundir)nielsen_generalized_polylog.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)OpticalGlauber_Geometry.o $(moddir)OpticalGlauber_Geometry.mod: $(nucdir)OpticalGlauber_Geometry.f90 $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)nielsen_generalized_polylog.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)interpolation.o $(moddir)interpolation.mod: $(nucdir)interpolation.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)CTEQ6PDF.o $(moddir)CTEQ6PDF.mod: $(srcdir)CTEQ6PDF.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Kinetic_Func.o $(moddir)Kinetic_Func.mod: $(srcdir)Kinetic_Func.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)MC_VEGAS.o $(moddir)MC_VEGAS.mod: $(srcdir)MC_VEGAS.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)alfas_functions.o $(moddir)alfas_functions.mod: $(srcdir)alfas_functions.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)pp_oniumX_setscale.o $(moddir)pp_oniumX_setscale.mod: $(thissrcdir)pp_oniumX_setscale.f90 $(moddir)Helac_Global.mod $(moddir)pp_oniumX_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)NLO_pp_oniumX.o $(moddir)NLO_pp_oniumX.mod : $(thissrcdir)NLO_pp_oniumX.f90 $(moddir)pp_oniumX_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)plot_pp_oniumX.o $(moddir)plot_pp_oniumX.mod : $(thissrcdir)plot_pp_oniumX.f90 $(moddir)Helac_Global.mod $(moddir)Kinetic_Func.mod $(moddir)MC_VEGAS.mod $(moddir)pp_oniumX_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)pp_oniumX.o $(moddir)pp_oniumX.mod : $(thissrcdir)pp_oniumX.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod $(moddir)Kinetic_Func.mod $(moddir)MC_VEGAS.mod $(moddir)Constants.mod $(moddir)NLO_pp_oniumX.mod $(moddir)plot_pp_oniumX.mod $(moddir)CTEQ6PDF.mod $(moddir)pp_oniumX_setscale.mod $(moddir)Structf_PDFs.mod $(moddir)pp_oniumX_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)pp_oniumX_LHAPDFs.o : $(thissrcdir)pp_oniumX_LHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)pp_oniumX_Global.mod $(moddir)pp_oniumX_setscale.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)pp_oniumX_MLHAPDFs.o : $(thissrcdir)pp_oniumX_MLHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)pp_oniumX_Global.mod $(moddir)pp_oniumX_setscale.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_LHAPDFs.o : $(srcdir)Structf_LHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)photon_PDFs.o $(moddir)photon_PDFs.mod : $(srcdir)photon_PDFs.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_LHAnPDFs.o : $(srcdir)Structf_LHAnPDFs.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_MLHAPDFs.o : $(srcdir)Structf_MLHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)setscale.o $(moddir)setscale.mod: $(srcdir)setscale.f90
	$(FC) -c $< $(FFLAGS)
clean:
	rm -rf $(obj) $(mod) $(exe) $(linkexe) $(HODIR)/tmp/* *~ $(HODIR)/input/*~ $(HODIR)/src/*~ $(thissrcdir)*~ $(HODIR)/output/* fort.*
end
