      ! redefine my scale function
      CALL oniumjet_scale(scale)
      MUR=scale*muF_over_ref ! set the explict mu as muF
      MP_MUR=REAL(MUR,KIND=16)
      scale=scale*muR_over_ref
      MUR4aS=scale
      as_born=ALPHAS(scale) ! only set the scale in alpha_s as muR
      aso2pi=as_born/TWOPI
      G=DSQRT(as_born*FOUR*PI)
      MP_G=SQRT(REAL(as_born,KIND=16)*MP_FOUR*MP_PI)
      logrmu=DLOG(MUR**2/MC2)
      logrs=DLOG(4d0)
      ! start to get the LDME RG running
      ! it will use the fixed scale and will not change phase space point by phase space point
      IF(nnn.EQ.0.AND.LDME_RG_RUN)THEN
         as_MQ=ALPHAS(onium_muNRQCD0)
         IF(onium_muNRQCD.NE.onium_muNRQCD0)THEN
            ! we need to update the central value of LDME first
            ! use two-loop running, i.e., beta0, beta1, beta2
            as_muNRQCD=ALPHAS(onium_muNRQCD)
            LDMEetaQ=LDME_RG_RUNNING(2,as_MQ,as_muNRQCD,LDMEetaQ_MQ)
	    LDME1S01=LDMEetaQ
	    MP_LDME1S01=REAL(LDMEetaQ,KIND=16)
	 ENDIF
         IF(reweight_muNRQCD)THEN
	    ! evaluate LDMEetaQ_up and LDMEetaQ_down
            as_muNRQCD_up=ALPHAS(onium_muNRQCD*rw_muNRQCD_up)
	    as_muNRQCD_down=ALPHAS(onium_muNRQCD*rw_muNRQCD_down)
	    LDMEetaQ_up=LDME_RG_RUNNING(2,as_MQ,as_muNRQCD_up,LDMEetaQ_MQ)
	    LDMEetaQ_down=LDME_RG_RUNNING(2,as_MQ,as_muNRQCD_down,LDMEetaQ_MQ)
         ELSE
            LDMEetaQ_up=LDMEetaQ
            LDMEetaQ_down=LDMEetaQ
	 ENDIF
      ENDIF
      ! initialize the PDF's
      gg_wsf=zero
      force_initial_reweight_scale=.TRUE.
      force_initial_reweight_pdf=.TRUE.
      force_initial_reweight_npdf=.TRUE.
      force_initial_reweight_ref=.TRUE.
      force_initial_reweight_muNRQCD=.TRUE.
      force_update_mp_phasespace=.TRUE.
      ! first to evaluate the borns
      ! which are necessary for the reweighting scale
      CALL sbornmatrix(ponium_born(0:3,1:(nexternal-2)),born_wgts(1))
      born_wgts(2:4)=zero

      ! ibody=1: (n+1)-body contribution
      ! ibody=2: n-body contribution (excluding Born)
      ! ibody=3: n-body Born contribution

      DO iorder=1,6
	 wzz=one
	 P0=zero
	 P1=zero
	 P2=zero
         ! underlying born: g g > eta_Q
         iflh(1)=35
         iflh(2)=35
         iflh(4)=35
         iflh(5)=35
         IF(iorder.EQ.1)THEN
           ibody=3
           born_wgt=born_wgts(1)
           me_wgt=born_wgt
           xp1=xp1_born
           xp2=xp2_born
           inum=1
           CALL strf_pdf_pp_oniumjet_NLO(gg_wsf,inum)
           wsf=gg_wsf
         ELSEIF(iorder.EQ.2)THEN
           IF(calculation_type.NE.0.AND.calculation_type.NE.2.AND.calculation_type.NE.3)CYCLE
           ibody=2
           IF(calculation_type.EQ.0.OR.calculation_type.EQ.2)THEN
              CALL sloopmatrix(ponium_born(0:3,1:(nexternal-2)),virt_wgts)
           ELSE
              virt_wgts(1:3)=0d0
           ENDIF
           IF(calculation_type.EQ.0.OR.calculation_type.EQ.3)THEN
              CALL softmatrix(ponium_born(0:3,1:(nexternal-2)), soft_wgts)
              CALL coll_matrix(ponium_born(0:3,1:(nexternal-2)),xp1_born,xp2_born, coll_wgts)
           ELSE
              soft_wgts(1:3)=0d0
              coll_wgts(1:3)=0d0
           ENDIF
           me_wgt=virt_wgts(1)+soft_wgts(1)+coll_wgts(1)
           ! include the renormalisation scale dependent term (see Eqs.(H.2,H3) in my DGLAPSolver.pdf)
	   ! born_wgt has been evaluated
           IF(calculation_type.EQ.0.OR.calculation_type.EQ.2)THEN
             me_wgt=me_wgt+bpower*beta0*born_wgt*DLOG(MUR4aS**2/MUR**2)*aso2pi
           ENDIF
           xp1=xp1_born
           xp2=xp2_born
           inum=1
           ! gg_wsf has been evaluated in Born
           !CALL strf_pdf_pp_oniumjet_NLO(gg_wsf,inum)
           wsf=gg_wsf
         ELSE
           IF(calculation_type.NE.0.AND.calculation_type.NE.4)CYCLE
           ibody=2
           ! born_wgt has been evaluated
           me_wgt=born_wgt*aso2pi
           IF(iorder.EQ.3)THEN
             ! g -> g1 g
             IF(zzA.GT.onemds)CYCLE
             me_wgt=me_wgt/zzA
             colllog=logdc-logrmu+logrs+DLOG((one-zzA)/zzA)
             xp1=xp1_realA
             xp2=xp2_realA
             inum=1
             CALL strf_pdf_pp_oniumjet_NLO(real_wsf,inum)
             P0=Pgg0(zzA)
             P1=Pgg1(zzA)
             P2=two*ca/(one-zzA)
             wsf=real_wsf*(P0*colllog-P1)
             wsf=wsf-gg_wsf*P2*colllog
             wzz=JzzA
           ELSEIF(iorder.EQ.4)THEN
             ! g -> g2 g
             IF(zzB.GT.onemds)CYCLE
             me_wgt=me_wgt/zzB
             colllog=logdc-logrmu+logrs+DLOG((one-zzB)/zzB)
             xp1=xp1_realB
             xp2=xp2_realB
             P0=Pgg0(zzB)
             P1=Pgg1(zzB)
             P2=two*ca/(one-zzB)
             inum=1
             CALL strf_pdf_pp_oniumjet_NLO(real_wsf,inum)
             wsf=real_wsf*(P0*colllog-P1)
             wsf=wsf-gg_wsf*P2*colllog
             wzz=JzzB
           ELSEIF(iorder.EQ.5)THEN
             ! q -> g1 q
             iflh(1)=3
             iflh(4)=3
             me_wgt=me_wgt/zzA
             colllog=logdc-logrmu+logrs+DLOG((one-zzA)/zzA)
             xp1=xp1_realA
             xp2=xp2_realA
             P0=Pgq0(zzA)
             P1=Pgq1(zzA)
             P2=zero
             inum=3
             CALL strf_pdf_pp_oniumjet_NLO(real_wsf,inum)
             wsf=real_wsf*(P0*colllog-P1)
             wzz=JzzA
           ELSE
             ! q -> g2 q
             iflh(2)=3
             iflh(4)=3
             me_wgt=me_wgt/zzB
             colllog=logdc-logrmu+logrs+DLOG((one-zzB)/zzB)
             xp1=xp1_realB
             xp2=xp2_realB
             P0=Pgq0(zzB)
             P1=Pgq1(zzB)
             P2=zero
             inum=2
             CALL strf_pdf_pp_oniumjet_NLO(real_wsf,inum)
             wsf=real_wsf*(P0*colllog-P1)
             wzz=JzzB
           ENDIF 
         ENDIF
         wme=me_wgt*wsf
         IF(reweight_scale.AND.wme.NE.0d0)CALL pp_oniumjet_NLO_reweight_xsec_scale(1,iorder,inum,&
	        me_wgt,wsf,P0,P1,P2,colllog,born_wgts)
         IF(reweight_muNRQCD.AND.wme.NE.0d0)CALL pp_oniumjet_NLO_reweight_xsec_muNRQCD(me_wgt)
         wme=wme*wzz
         wthis=wme*Jy*3.8937966d5 ! 3.8938573d5 ! in unit of nb
         IF(reweight_pdf.AND.wthis.NE.0d0)CALL pp_oniumjet_NLO_reweight_xsec_pdf(iorder,inum,wsf,P0,P1,P2,colllog)
         IF(reweight_npdf.AND.wthis.NE.0d0)CALL pp_oniumjet_NLO_reweight_xsec_npdf(iorder,inum,wsf,P0,P1,P2,colllog)
         IF(reweight_ref.AND.wthis.NE.0d0)CALL pp_oniumjet_NLO_reweight_xsec_ref(iorder,inum,wsf,P0,P1,P2,colllog)
         ! do not fill the Born that should be not taken into account
         ! which is only used for recycling
         IF(iorder.EQ.1.AND.(calculation_type.NE.0.AND.calculation_type.NE.1))CYCLE
         IF(plot_output.AND.wthis.NE.0d0)THEN
            w1=wthis*wgt
            CALL outfun_pp_oniumjet_NLO(w1,ibody)
         ENDIF
         wtotal=wtotal+wthis
      ENDDO