      IF(.NOT.ptQ)THEN
         ! total cross section
         pt=(temp1-pt1c)*x(3)+pt1c
	 mt1=DSQRT(pt*pt+m1r*m1r)
         mt2=DSQRT(pt*pt+m2r*m2r)
         IF(absrap)THEN
            temp2=MIN(ACosh_p((sq+m12-m22)/(2d0*sqs*mt1)),y1cup)
	    IF(temp2.LT.y1clow)THEN
              pp_oniumjet_NLO_fxn=0d0
              RETURN
           ENDIF
	   y1=(2d0*x(1)-1d0)*(temp2-y1clow)+SIGN(1d0,x(1)-0.5d0)*y1clow
         ELSE
           temp2=MIN(ACosh_p((sq+m12-m22)/(2d0*sqs*mt1)),y1cup-ycollcm)
           temp21=MAX(-ACosh_p((sq+m12-m22)/(2d0*sqs*mt1)),y1clow-ycollcm)
           IF(temp2.LT.temp21)THEN
              pp_oniumjet_NLO_fxn=0d0
              RETURN
           ENDIF
           y1=(temp2-temp21)*x(1)+temp21 ! in collision frame
         ENDIF
         temp3=DLOG((-DEXP(-y1)*mt1 +sqs)/mt2)
         temp4=temp3+DLOG((-DEXP(y1)*mt1 + sqs)/mt2)
         y2= -temp3 +temp4*x(2) ! in collision frame
         phi=TWOPI*x(4)
         ! Jacobi Determinations
         Jpt2=TWO*pt*(temp1-pt1c)
         IF(absrap)THEN
            Jy1=TWO*(temp2-y1clow)
         ELSE
            Jy1=temp2-temp21
         ENDIF
         Jy2=temp4
      ELSE
         ! pt distribution
         mt1=DSQRT(pt*pt+m1r*m1r)
         mt2=DSQRT(pt*pt+m2r*m2r)
         IF(absrap)THEN
            temp2=MIN(ACosh_p((sq+m12-m22)/(2d0*sqs*mt1)),y1cup)
            IF(temp2.LT.y1clow)THEN
               pp_oniumjet_NLO_fxn=0d0
               RETURN
            ENDIF
            y1=(2d0*x(1)-1d0)*(temp2-y1clow)+SIGN(1d0,x(1)-0.5d0)*y1clow
         ELSE
            temp2=MIN(ACosh_p((sq+m12-m22)/(2d0*sqs*mt1)),y1cup-ycollcm)
            temp21=MAX(-ACosh_p((sq+m12-m22)/(2d0*sqs*mt1)),y1clow-ycollcm)
            IF(temp2.LT.temp21)THEN
              pp_oniumjet_NLO_fxn=0d0
              RETURN
           ENDIF
           y1=(temp2-temp21)*x(1)+temp21 ! in collision frame
         ENDIF
         temp3=DLOG((-DEXP(-y1)*mt1 +sqs)/mt2)
         temp4=temp3+DLOG((-DEXP(y1)*mt1 + sqs)/mt2)
         y2= -temp3 +temp4*x(2) ! in collision frame
         phi=TWOPI*x(3)
         ! Jacobi Determinations
         Jpt2=TWO*pt
         IF(absrap)THEN
           Jy1=2d0*(temp2-y1clow)
         ELSE
           Jy1=(temp2-temp21)
         ENDIF
         Jy2=temp4
      ENDIF
      ! The substitution of original variations
      IF(ycollcm.EQ.0d0)THEN
         xp1=(DEXP(y1)*mt1+DEXP(y2)*mt2)/sqs ! xp1,xp2 are same in collision frame and lab frame
         xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/sqs
      ELSE
         IF(.NOT.fixtarget)THEN
            xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2)/(TWO*ebeam(1))
            xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/(TWO*ebeam(2))
         ELSE
            IF(.NOT.fixtargetrev)THEN
               xp1=(DSINH(y1)*mt1 + DSINH(y2)*mt2)/(ebeam(1))
               xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/(ebeam(2))
            ELSE
               xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2)/(ebeam(1))
               xp2=(DSINH(-y1)*mt1+DSINH(-y2)*mt2)/(ebeam(2))
            ENDIF
         ENDIF
      ENDIF
      IF(xp1.GT.ONE.OR.xp1.LT.ZERO)THEN
         WRITE(*,*)"ERROR: 0<xp1<1"
         STOP
      ENDIF
      IF(xp2.GT.ONE.OR.xp2.LT.ZERO)THEN
         WRITE(*,*)"ERROR: 0<xp2<1"
         STOP
      ENDIF
      IF(calculation_type.EQ.0.OR.calculation_type.EQ.4)THEN
        JzzA=ONE-xp1
        JzzB=ONE-xp2
        zzA=JzzA*x(ivarnum)+xp1
        zzB=JzzB*x(ivarnum)+xp2
      ELSE
        JzzA=ONE
        JzzB=ONE
	zzA=ONE
        zzB=ONE
      ENDIF
      xp1_born=xp1
      xp2_born=xp2
      xp1_realA=xp1/zzA
      xp2_realA=xp2
      xp1_realB=xp1
      xp2_realB=xp2/zzB
      ehat=DSQRT(xp1*xp2*sq)
      exp1=xp1*ebeam(1)
      exp2=xp2*ebeam(2)
      IF(fixtarget)THEN
         IF(.NOT.fixtargetrev)THEN
            exp1=exp1+FT_M*xp1/TWO
            exp2=exp2/TWO
         ELSE
            exp1=exp1/TWO
            exp2=exp2+FT_M*xp2/TWO
         ENDIF
      ENDIF
      ! Generate the born momenta of external legs
      ! initial state
      onium_pmom_born(1,1:2)=0d0
      onium_pmom_born(1,3)=xp1*sqs/TWO
      onium_pmom_born(1,4)=xp1*sqs/TWO
      onium_pmom_born(2,1:2)=0d0
      onium_pmom_born(2,3)=-xp2*sqs/TWO
      onium_pmom_born(2,4)=xp2*sqs/TWO
      ! final state
      ! two heavy quarks forming the onium
      onium_pmom_born(3,1)=pt*DCOS(phi)/TWO
      onium_pmom_born(3,2)=pt*DSIN(phi)/TWO
      onium_pmom_born(3,3)=mt1*DSINH(y1)/TWO
      onium_pmom_born(3,4)=mt1*DCOSH(y1)/TWO
      DO j=1,4
       onium_pmom_born(4,j)=onium_pmom_born(3,j)
      ENDDO
      ! jet at Born
      onium_pmom_born(5,1)=-pt*DCOS(phi)
      onium_pmom_born(5,2)=-pt*DSIN(phi)
      onium_pmom_born(5,3)=mt2*DSINH(y2)
      onium_pmom_born(5,4)=mt2*DCOSH(y2)
      ! boost from collision frame to lab frame
      Momenta_Frame=1
      IF(.NOT.fixtarget)THEN
         pmom(3)=ebeam(1)-ebeam(2)
         pmom(4)=ebeam(1)+ebeam(2)
      ELSE
         IF(.NOT.fixtargetrev)THEN
            pmom(3)=ebeam(1)
            pmom(4)=ebeam(1)+ebeam(2)
         ELSE
            pmom(3)=-ebeam(2)
            pmom(4)=ebeam(1)+ebeam(2)
         ENDIF
      ENDIF
      pmom(1:2)=0
      IF(.NOT.labeqcoll)THEN
         DO j=1,nexternal-1
            CALL Boostl(sqs,pmom,onium_pmom_born(j,1:4))
         ENDDO
      ENDIF
      CALL pp_oniumjet_NLO_hadronmom
      DO j=1,nexternal-1
         ponium_born(0,j)=onium_pmom_born(j,4)
	 ponium_born(1,j)=onium_pmom_born(j,1)
	 ponium_born(2,j)=onium_pmom_born(j,2)
	 ponium_born(3,j)=onium_pmom_born(j,3)
      ENDDO
      ! check the cuts
      ! imposing the cuts only on the underlying Born
      icut=0
      CALL Cuts_pp_oniumjet_NLO(icut)