MODULE pp_oniumjet_NLO
  USE Helac_Global
  USE pp_oniumjet_NLO_Global
  USE Helac_Func_1
  USE plot_pp_oniumjet_NLO
  USE Constants
  USE Kinetic_Func
  USE pp_oniumjet_NLO_setscale
  USE func_psi_2
  IMPLICIT NONE
  INTEGER::nprint
  INTEGER::varnum,nunwei
  LOGICAL::ptQ,lunwei2
  REAL(KIND(1d0))::EBMUP1,EBMUP2
  INTEGER::NPRUP=0,lwmax
  INTEGER,PARAMETER::maxprint=8
  LOGICAL::force_initial_reweight_scale=.FALSE.
  LOGICAL::force_initial_reweight_pdf=.FALSE.
  LOGICAL::force_initial_reweight_npdf=.FALSE.
  LOGICAL::force_initial_reweight_ref=.FALSE.
  LOGICAL::force_initial_reweight_muNRQCD=.FALSE.
  SAVE
CONTAINS
  SUBROUTINE calc_pp_oniumjet_NLO
    IMPLICIT NONE
    CHARACTER(len=2)::quark_tag
    INTEGER::i,i1,j1,k1,s1x
    INTEGER::nh,innum,outnum
    INTEGER::ioerror,icase=0
    LOGICAL::lunwei=.FALSE.,lhewgt=.FALSE.
    REAL(KIND(1d0)),DIMENSION(3)::rslt
    INTEGER::itmxn,ncalln
    REAL(KIND(1d0)),DIMENSION(4)::pmomtemp
    LOGICAL::lexist
    SAVE lunwei,lhewgt,icase
    REAL(KIND(1d0))::temp
    INTEGER::beam1_pdf,beam2_pdf
    WRITE(*,*)'                     THE BEGINNING OF HELAC-Onia'
    WRITE(*,*)'    AddOn Process: '
    WRITE(*,*)'    p p > Eta(Q) + jet + X up to O(alpha_s**4)'
    WRITE(*,*)'======================================================='
    WRITE(*,*)'======================================================='
    WRITE(*,*)' '
    CALL ReadElem_integer('colpar',Coll_Type)
    lunwei=.FALSE.
    lhewgt=.FALSE.
    CALL ReadElem_logic('topdrawer_output',topdrawer_output)
    CALL ReadElem_logic('gnuplot_output',gnuplot_output)
    CALL ReadElem_logic('root_output',root_output)
    CALL ReadElem_logic('hwu_output',hwufile_output)
    plot_output=topdrawer_output.OR.gnuplot_output.OR.root_output.OR.hwufile_output
    CALL ReadElem_integer('literature',literature_cutoffs)
    CALL ReadElem_logic('fixtarget',fixtarget)
    IF(fixtarget.AND.Coll_Type.EQ.3)THEN
       WRITE(*,*)"ERROR: Cannot treat fixed-target experiment in e+e- collisions"
       STOP
    ENDIF
    CALL ReadElem_logic("useMCFMrun",useMCFMrun)
    CALL ReadElem_logic('lhapdf',uselhapdf)
    INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdf_data",EXIST=lexist)
    IF(lexist)THEN
       OPEN(UNIT=30333,FILE=TRIM(input_dir)//"paths/lhapdf_data")
       READ(30333,'(A)')LHAPath
       CLOSE(UNIT=30333)
    ELSE
       INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdfpath",EXIST=lexist)
       IF(lexist)THEN
          OPEN(UNIT=30333,FILE=TRIM(input_dir)//"paths/lhapdfpath")
          READ(30333,'(A)')LHAPath
          CLOSE(UNIT=30333)
          i=LEN_TRIM(LHAPath)
          LHAPath=LHAPath(1:i-13)
       ENDIF
    ENDIF
    uselhapdf=uselhapdf.AND.lexist
    WRITE(*,*)'Use LHAPDF ?',uselhapdf
    CALL ReadElem_logic("absoluterap",absrap)
    ! some necesarry initialization
    OPEN(UNIT=12321,FILE="./input/states.inp")
    READ(12321,*)onium_state
    CLOSE(UNIT=12321)
    IF((onium_state.LT.0.OR.onium_state.GT.2))THEN
       WRITE(*,*)"ERROR:Unknown the state = ",onium_state
       WRITE(*,*)"INFO:Please set 0-2 in states.inp"
       STOP
    ENDIF
    OPEN(UNIT=12321,FILE="./input/calculation_type.inp")
    READ(12321,*)calculation_type
    CLOSE(UNIT=12321)
    IF((calculation_type.LT.0.OR.calculation_type.GT.4))THEN
       WRITE(*,*)"ERROR:Unknown the calculation type = ",calculation_type
       WRITE(*,*)"INFO:Please set 0-4 in calculation_type.inp"
       STOP
    ENDIF
    CALL ReadElem_real('twocutoff_slicing_ds',delta_s)
    CALL ReadElem_real('twocutoff_slicing_dc',delta_c)
    IF(delta_s.LE.0d0.OR.delta_c.LE.0d0)THEN
       WRITE(*,*)"ERROR:the two cutoff slicing parameters should be larger than 0"
       STOP
    ENDIF
    IF(delta_s.GE.1d0)THEN
       WRITE(*,*)"ERROR: the two cutoff slicing parameters should be smaller than 1"
       STOP
    ENDIF
    logds=DLOG(delta_s)
    logdc=DLOG(delta_c)
    onemds=ONE-delta_s
    logonemds=DLOG(onemds)
    logdso1ds=DLOG(delta_s/onemds)
    OPEN(UNIT=12724,FILE="./input/stability_check.inp")
    READ(12724,*)stability_check,quadrupole_precision,stable_threshold,stable_unbounded,stable_rsmax
    CLOSE(UNIT=12724)
    IF(onium_state.GT.0)THEN
       nhad=5
       iflh(1)=35
       iflh(2)=35
       iflh(3)=state2hoid(onium_state)
       iflh(4)=35
       iflh(5)=35
       bpower=3
    ELSE
       nhad=4
       iflh(1)=35
       iflh(2)=35
       iflh(3)=state2hoid(onium_state)
       iflh(4)=35
       bpower=2
    ENDIF
    SELECT CASE(onium_state)
    CASE(0,1)
       ! eta_c
       nlq=3
       ! the input parameters
       CALL ReadElem_real('cmass',MC)
       onium_muNRQCD0=MC ! the initial NRQCD scale is MQ
       MetaQ=2d0*MC
       ! this is LDME at mu0=mQ
       CALL ReadElem_real('LDMEcc1S01',LDMEetaQ_MQ)
       LDMEetaQ_MQ=6d0*LDMEetaQ_MQ ! convert to the normal convention
       LDMEetaQ=LDMEetaQ_MQ
       LDMEetaQ_up=LDMEetaQ
       LDMEetaQ_down=LDMEetaQ
       LDME1S01=LDMEetaQ
    CASE(2)
       ! eta_b
       nlq=4
       CALL ReadElem_real('bmass',MC)
       onium_muNRQCD0=MC ! the initial NRQCD scale is MQ
       MetaQ=2d0*MC
       CALL ReadElem_real('LDMEbb1S01',LDMEetaQ_MQ)
       LDMEetaQ_MQ=6d0*LDMEetaQ_MQ ! convert to the normal convention
       LDMEetaQ=LDMEetaQ_MQ
       LDMEetaQ_up=LDMEetaQ
       LDMEetaQ_down=LDMEetaQ
       LDME1S01=LDMEetaQ
    CASE DEFAULT
       WRITE(*,*)"ERROR:Unknown the state = ",onium_state
       WRITE(*,*)"INFO:Please set 0-2 in states.inp"
       STOP
    END SELECT
    rnlq=DBLE(nlq)
    MC2=MC**2
    MC3=MC**3
    MC4=MC**4
    ! quadrupole precision
    mp_rnlq=REAL(nlq,KIND=16)
    MP_MC=REAL(MC,KIND=16)
    MP_MC2=MP_MC**2
    MP_MC3=MP_MC**3
    MP_MC4=MP_MC**4
    ! update the beta functions
    CALL SET_QCD_NF(nlq)
    ! the decay information will be implemented later
    !CALL ReadDecayInfo
    NDecayChains=0
    IF(nunit1.NE.6)THEN
       OPEN(UNIT=nunit1,FILE=TRIM(output_dir)//"RESULT_pp_oniumjet_NLO.out")
    ENDIF
    nunit2=32
    CLOSE(nunit2)
    OPEN(nunit2,FILE=TRIM(output_dir)//'kine_pp_oniumjet_NLO.out')
    nunit3=30
    CLOSE(nunit3)
    OPEN(nunit3,FILE=TRIM(tmp_dir)//'even_pp_oniumjet_NLO.out',FORM='unformatted')
    ! for LHA
    CLOSE(200)
    OPEN(200,FILE=TRIM(tmp_dir)//'sample_pp_oniumjet_NLO.init')
    ! Multiple PDFs and special nPDFs
    CALL ReadElem_integer('pdf',beam1_pdf)
    CALL ReadElem_integer('beam2_pdf',beam2_pdf)
    CALL ReadElem_integer('nPDF_id',nPDF_id)
    CALL ReadElem_integer('nuclearA_beam1',nuclearA_beam1)
    CALL ReadElem_integer('nuclearA_beam2',nuclearA_beam2)
    CALL ReadElem_integer('nuclearZ_beam1',nuclearZ_beam1)
    CALL ReadElem_integer('nuclearZ_beam2',nuclearZ_beam2)
    lnuclearPDF=.FALSE.
    multipdfloading=uselhapdf.AND.beam2_pdf.NE.beam1_pdf.AND.beam2_pdf.GT.0
    IF(.NOT.multipdfloading)THEN
       IF(nPDF_id.NE.0.AND.(nuclearA_beam1.NE.0.or.nuclearA_beam2.NE.0)&
            .AND.(.NOT.uselhapdf))THEN
          WRITE(*,*)"nuclear PDF can only be used with LHAPDF"
          WRITE(*,*)"nPDF_id=",nPDF_id
          WRITE(*,*)"nuclearA_beam1=",nuclearA_beam1
          WRITE(*,*)"nuclearA_beam2=",nuclearA_beam2
          WRITE(*,*)"Please set lhapdf=T and set the correct path of lhapdf in ho_configuration.txt before ./config"
          STOP
       ENDIF
       rnuclearA_beam1=DBLE(nuclearA_beam1)
       rnuclearA_beam2=DBLE(nuclearA_beam2)
       rnuclearZ_beam1=DBLE(nuclearZ_beam1)
       rnuclearZ_beam2=DBLE(nuclearZ_beam2)
       IF(nPDF_id.EQ.0.AND.(nuclearA_beam1.NE.0.or.nuclearA_beam2.NE.0))THEN
          WRITE(*,*)"WARNING:you are using normal proton PDF for nuclear"
       ENDIF
       IF(nPDF_id.NE.0.AND.(nuclearA_beam1.NE.0.or.nuclearA_beam2.NE.0))THEN
          lnuclearPDF=.TRUE.
       ENDIF
    ELSE
       ! multiple PDF loading already allow one to use nuclear PDFs
       ! no need the tricks for nuclear PDFs
       rnuclearA_beam1=0d0
       rnuclearA_beam2=0d0
       nuclearA_beam1=0
       nuclearA_beam2=0
       rnuclearZ_beam1=0d0
       rnuclearZ_beam2=0d0
       nuclearZ_beam1=0
       nuclearZ_beam2=0
       lnuclearPDF=.FALSE.
    ENDIF
    ! Scale scheme
    CALL ReadElem_integer('Scale',nscheme)
    CALL ReadElem_real('FScaleValue',fschemevalue)
    CALL ReadELem_real('ScaleFactor',scalefactor)
    CALL ReadElem_real('muR_over_ref',muR_over_ref)
    CALL ReadElem_real('muF_over_ref',muF_over_ref)
    IF(muF_over_ref.NE.muR_over_ref)THEN
       WRITE(*,*)"WARNING: muR_over_ref =!= muF_over_ref is not allowed"
       muF_over_ref=muR_over_ref
    ENDIF
    ! reweighting stuff
    reweight_pdf=.FALSE.
    reweight_npdf=.FALSE.
    reweight_ref=.FALSE.
    IF(uselhapdf)THEN
       CALL ReadElem_logic('reweight_pdf',reweight_pdf)
       IF(reweight_pdf.AND.lnuclearPDF.AND.nPDF_id.EQ.1000)THEN
          WRITE(*,*)"WARNING:reweight proton PDF are not allowed when nPDF_id=1000 in PA"
          reweight_pdf=.FALSE.
       ENDIF
       IF(reweight_pdf)THEN
          CALL ReadElem_logic('beams_pdf_correlation',beams_pdf_correlation)
       ENDIF
       IF(reweight_pdf)THEN
          CALL ReadElem_integer('pdf_min',ipdf_set_min)
          CALL ReadElem_integer('pdf_max',ipdf_set_max)
          IF(multipdfloading)THEN
             CALL ReadElem_integer('beam2_pdf_min',ipdf2_set_min)
             CALL ReadElem_integer('beam2_pdf_max',ipdf2_set_max)
             IF(ipdf2_set_min.GT.0.AND.ipdf2_set_max.GT.0)THEN
                IF(beams_pdf_correlation.AND.&
                     (ipdf2_set_max-ipdf2_set_min).NE.&
                     (ipdf_set_max-ipdf_set_min))THEN
                   WRITE(*,*)"ERROR: The numbers of error PDFs for two beams are different"
                   WRITE(*,*)"ERROR: The two beams cannot be fully correlated "
                   STOP
                ENDIF
             ENDIF
          ELSE
             ipdf2_set_min=-1
             ipdf2_set_max=-1
          ENDIF
          IF(ipdf_set_max.LT.0.AND.ipdf_set_min.LT.0)THEN
             ho_npdf=0
          ELSE
             ho_npdf=ipdf_set_max-ipdf_set_min+1
          ENDIF
          IF(multipdfloading.AND..NOT.beams_pdf_correlation.AND.&
               (ipdf2_set_min.GT.0.AND.ipdf2_set_max.GT.0))THEN
             ho_npdf2=ipdf2_set_max-ipdf2_set_min+1
          ELSE
             ho_npdf2=0
          ENDIF
       ENDIF
       ho_npdf=MAX(ho_npdf,0)
       ho_npdf2=MAX(ho_npdf2,0)
       IF(ho_npdf.LE.0.AND.ho_npdf2.LE.0)THEN
          ho_npdf=0
          ho_npdf2=0
          reweight_pdf=.FALSE.
       ENDIF
       IF(ho_npdf.GT.0)THEN
          tot_nrwgt=tot_nrwgt+ho_npdf+1
       ENDIF
       IF(ho_npdf2.GT.0)THEN
          tot_nrwgt=tot_nrwgt+ho_npdf2+1
       ENDIF
       IF(lnuclearPDF)THEN
          CALL ReadElem_logic('reweight_npdf',reweight_npdf)
          IF(reweight_pdf.AND.ho_npdf.GE.2.AND.nPDF_id.LE.500)THEN
             WRITE(*,*)"ERROR: Cannot perform proton PDF reweighting for EPS09"
             STOP
          ENDIF
          IF(reweight_npdf)THEN
             CALL ReadElem_integer('npdf_min',inpdf_set_min)
             CALL ReadElem_integer('npdf_max',inpdf_set_max)
             ho_nnpdf=inpdf_set_max-inpdf_set_min+1
             tot_nrwgt=tot_nrwgt+ho_nnpdf+1
          ENDIF
          INCLUDE '../../../input/lhapdf/check_npdf_set_min'
          CALL ReadElem_logic('include_ref',reweight_ref)
          IF(reweight_ref)THEN
             IF(nuclearA_beam1*nuclearA_beam2.NE.0.AND.COLL_TYPE.LE.2)THEN
                ! heavy ion collision, AB or AA
                ho_nref=3
                iref_set_min=1
                iref_set_max=3
             ELSE
                ! pA or Ap or eA collisions
                ho_nref=1
                iref_set_min=1
                iref_set_max=1
             ENDIF
          ENDIF
          tot_nrwgt=tot_nrwgt+ho_nref+1
       ENDIF
    ENDIF
    CALL ReadElem_integer('alphasrun',irun)
    CALL ReadElem_logic('reweight_Scale',reweight_scale)
    CALL ReadElem_logic('reweight_muNRQCD',reweight_muNRQCD)
    CALL ReadElem_logic('muNRQCD_eq_QMass',muNRQCD_eq_QMass)
    reweight_scale=reweight_scale.AND.(irun.EQ.1)
    ! for RG running of LDMEs
    CALL ReadElem_logic('LDME_RG_RUN',LDME_RG_RUN)
    LDME_RG_RUN=LDME_RG_RUN.AND.(irun.EQ.1)
    reweight_muNRQCD=reweight_muNRQCD.AND.LDME_RG_RUN
    IF(reweight_scale)THEN
       CALL ReadElem_real('rw_RScale_down',rw_Rscale_down)
       CALL ReadElem_real('rw_RScale_up',rw_Rscale_up)
       CALL ReadElem_real('rw_FScale_down',rw_Fscale_down)
       CALL ReadElem_real('rw_FScale_up',rw_Fscale_up)
       ho_nscale=8
       IF(rw_Rscale_down.LE.0d0.OR.rw_Rscale_up.LE.0d0.OR.&
            rw_Fscale_down.LE.0d0.OR.rw_Fscale_up.LE.0d0)THEN
          reweight_scale=.FALSE.
          ho_nscale=0
          WRITE(*,*)"WARNING:Scale reweighting is off."
          WRITE(*,*)"WARNING:Please make sure rw_Rscale_up, rw_Rscale_down, rw_Fscale_up, rw_Fscale_down are larger than 0."
       ENDIF
       IF(reweight_scale.AND.rw_Rscale_down.GT.rw_Rscale_up)THEN
          temp=rw_Rscale_down
          rw_Rscale_down=rw_Rscale_up
          rw_Rscale_up=temp
       ENDIF
       IF(reweight_scale.AND.rw_Fscale_down.GT.rw_Fscale_up)THEN
          temp=rw_Fscale_down
          rw_Fscale_down=rw_Fscale_up
          rw_Fscale_up=temp
       ENDIF
       rw_Rscales(1)=1d0
       rw_Rscales(2)=rw_Rscale_up
       rw_Rscales(3)=rw_Rscale_down
       rw_Fscales(1)=1d0
       rw_Fscales(2)=rw_Fscale_up
       rw_Fscales(3)=rw_Fscale_down
    ENDIF
    IF(reweight_scale)THEN
       tot_nrwgt=tot_nrwgt+ho_nscale+1
    ENDIF
    IF(reweight_muNRQCD)THEN
       CALL ReadElem_real('rw_muNRQCD_down',rw_muNRQCD_down)
       CALL ReadElem_real('rw_muNRQCD_up',rw_muNRQCD_up)
       ho_nmuNRQCD=2
       IF(rw_muNRQCD_down.LE.0d0.OR.rw_muNRQCD_up.LE.0d0)THEN
          reweight_muNRQCD=.FALSE.
          ho_nmuNRQCD=0
          WRITE(*,*)"WARNING:NRQCD scale reweighting is off."
          WRITE(*,*)"WARNING:Please make sure rw_muNRQCD_up, rw_muNRQCD_down are larger than 0."
       ENDIF
       IF(reweight_muNRQCD.AND.rw_muNRQCD_down.GT.rw_muNRQCD_up)THEN
          temp=rw_muNRQCD_down
          rw_muNRQCD_down=rw_muNRQCD_up
          rw_muNRQCD_up=temp
       ENDIF
       rw_Mscales(1)=1d0
       rw_Mscales(2)=rw_muNRQCD_up
       rw_Mscales(3)=rw_muNRQCD_down
    ENDIF
    IF(reweight_muNRQCD)THEN
       tot_nrwgt=tot_nrwgt+ho_nmuNRQCD+1
    ENDIF
    ! rwgt_values are used for LHE event file
    !IF(reweight_scale.OR.reweight_pdf.OR.reweight_npdf.OR.reweight_ref)THEN
    !   IF(ALLOCATED(rwgt_values))THEN
    !      DEALLOCATE(rwgt_values)
    !   ENDIF
    !   ALLOCATE(rwgt_values(tot_nrwgt))
    !ENDIF
    CALL ReadElem_integer("itmax",itmxn)
    CALL ReadElem_integer("nmc",ncalln)
    WRITE(*,*)' '
    CALL Helac_mtime()
    WRITE(*,*)' '
    CALL pp_oniumjet_NLO_VEGAS(rslt,itmxn,ncalln)
    WRITE(nunit1,*)"sigma(nb)                   sd"
    WRITE(nunit1,*)rslt(1),rslt(2)
    WRITE(*,*)' '
    CALL Helac_mtime()
    CLOSE(nunit2)
    CLOSE(nunit3)
    CLOSE(21)
    CLOSE(200)
    !IF(lunwei)CALL Generate_lhe_pp_psipsi_dps(nhad,Nevents,icase)
  END SUBROUTINE calc_pp_oniumjet_NLO

  SUBROUTINE pp_oniumjet_NLO_VEGAS(rslt,itmxn,ncalln)
    USE MC_VEGAS
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(3),INTENT(OUT)::rslt
    INTEGER,INTENT(IN),OPTIONAL::itmxn,ncalln
    REAL(KIND(1d0))::vfes,sd,chi2a
    INTEGER::ncalm,nc,ii
    CHARACTER(len=4),DIMENSION(20)::chchar
    INTEGER::iday0,ihr0,imin0,isec0,i100th0,iday1,ihr1,imin1,isec1,i100th1,iyr0,iyr1,imon0,imon1
    INTEGER::IDBMUP1,IDBMUP2,IDWTUP
    INCLUDE "../../../src/RANDA_init.inc"
    CALL ReadElem_logic("ptdisQ",ptQ)
    CALL ReadElem_logic('unwgt',lunwei2)
    CALL ReadElem_integer('preunw',nunwei)
    lwmax=0
    NPRN=-1
    IF(onium_state.GT.0)THEN
       ! maximal 5 fold of finite integrals
       IF(ptQ)THEN
          ! calculate at a given pt for dsigma/dpt
          varnum=4
       ELSE
          varnum=5
       ENDIF
    ELSE
       ! maximal 2 fold of finite integrals
       ! for 2 -> 1 underlying Born
       varnum=2
    ENDIF
    IF(calculation_type.NE.0.AND.calculation_type.NE.4)varnum=varnum-1
    DO ii=1,varnum
       XL(ii)=0.0d0
       XU(ii)=1.0d0
    ENDDO
    IF(PRESENT(itmxn))THEN
       ITMX=itmxn
    ELSE
       ITMX=5
    ENDIF
    ITMX=1
    IF(PRESENT(ncalln))THEN
       ncalm=ncalln
    ELSE
       ncalm=5000
    ENDIF
    chchar(1)="40K"
    chchar(2)="80K"
    chchar(3)="160K"
    chchar(4)="320K"
    chchar(5)="640K"
    chchar(6)="1M"
    chchar(7)="2M"
    chchar(8)="4M"
    chchar(9)="8M"
    chchar(10)="16M"
    chchar(11)='32M'
    chchar(12)='64M'
    chchar(13)='120M'
    chchar(14)='240M'
    chchar(15)='480M'
    chchar(16)='960M'
    chchar(17)='2G'
    chchar(18)='4G'
    chchar(19)='8G'
    chchar(20)='16G'
    nprint=10000
    NCALL=20000
    IF(stability_check)THEN
       OPEN(UNIT=20456,FILE=TRIM(output_dir)//"UPS.log")
    ENDIF
    CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
    IF(stability_check)THEN
       unstable_ps=0
       total_ps=0
    ENDIF
    IF(plot_output)CALL initplot_pp_oniumjet_NLO
    IF(onium_state.GT.0)THEN
       CALL VEGAS(varnum,pp_oniumjet_NLO_fxn,vfes,sd,chi2a)
    ELSE
       CALL VEGAS(varnum,pp_onium_NLO_fxn,vfes,sd,chi2a)
    ENDIF
    IF(plot_output)CALL plotout_pp_oniumjet_NLO
    WRITE(*,*)' '
    WRITE(*,*)"====================NCALL=20K==========================="
    WRITE(*,*)" "
    CALL Helac_mtime()
    WRITE(*,*)" "
    ii=1
    WRITE(*,*)"ITERATION ",ii,":"
    WRITE(*,*)vfes,"+\-",sd
    WRITE(*,*)"precision:",sd/vfes
    IF(stability_check.AND.total_ps.GT.0)THEN
       WRITE(*,*)"UPS fraction:",DBLE(unstable_ps)/DBLE(total_ps)
    ENDIF
    DO ii=2,10
       IF(stability_check)THEN
          unstable_ps=0
          total_ps=0
       ENDIF
       IF(plot_output)CALL initplot_pp_oniumjet_NLO
       IF(onium_state.GT.0)THEN
          CALL VEGAS(varnum,pp_oniumjet_NLO_fxn,vfes,sd,chi2a,1)
       ELSE
          CALL VEGAS(varnum,pp_onium_NLO_fxn,vfes,sd,chi2a,1)
       ENDIF
       IF(plot_output)CALL plotout_pp_oniumjet_NLO
       WRITE(*,*)"ITERATION ",ii,":"
       WRITE(*,*)vfes,"+\-",sd
       WRITE(*,*)"precision:",sd/vfes
       IF(stability_check.AND.total_ps.GT.0)THEN
          WRITE(*,*)"UPS fraction:",DBLE(unstable_ps)/DBLE(total_ps)
       ENDIF
    ENDDO
    CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
    iday1=iday1-iday0
    ihr1=ihr1-ihr0
    imin1=imin1-imin0
    isec1=isec1-isec0
    i100th1=i100th1-i100th0
    CALL Vegas_speed(10*NCALL,iday1,ihr1,imin1,isec1,i100th1)
    WRITE(*,*)' '
    WRITE(*,*)' '
    ii=1
    DO
       nc=2*NCALL
       IF(nc.GT.ncalm)EXIT
       IF(2*nc.GT.ncalm.AND.lunwei2.AND.lwmax.EQ.0)THEN
          lwmax=1
       ENDIF
       NCALL=nc
       IF(NCALL/maxprint.GT.nprint)nprint=NCALL/maxprint
         CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
         WRITE(*,*)"====================NCALL="//chchar(ii)//"==========================="
         WRITE(*,*)" "
         CALL Helac_mtime()
         WRITE(*,*)" "
         IF(stability_check)THEN
            unstable_ps=0
            total_ps=0
         ENDIF
         IF(plot_output)CALL initplot_pp_oniumjet_NLO
         IF(onium_state.GT.0)THEN
            CALL VEGAS(varnum,pp_oniumjet_NLO_fxn,vfes,sd,chi2a,1)
         ELSE
            CALL VEGAS(varnum,pp_onium_NLO_fxn,vfes,sd,chi2a,1)
         ENDIF
         IF(plot_output)CALL plotout_pp_oniumjet_NLO
         WRITE(*,*)vfes,"+\-",sd
         WRITE(*,*)"precision:",sd/vfes
         IF(stability_check.AND.total_ps.GT.0)THEN
            WRITE(*,*)"UPS fraction:",DBLE(unstable_ps)/DBLE(total_ps)
         ENDIF
         CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
         iday1=iday1-iday0
         ihr1=ihr1-ihr0
         imin1=imin1-imin0
         isec1=isec1-isec0
         i100th1=i100th1-i100th0
         CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
         WRITE(*,*)" "
         ii=ii+1
      ENDDO
      SELECT CASE(COLL_TYPE)
      CASE(1)
         IDBMUP1=2212
         IDBMUP2=2212
      CASE(2)
         IDBMUP1=2212
         IDBMUP2=-2212
      CASE DEFAULT
         IDBMUP1=11
         IDBMUP2=-11
      END SELECT
      IDWTUP=1
      NPRUP=NPRUP+1
      WRITE(200,5100) IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,&
           iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
      WRITE(200,5200) vfes*10d0**3,sd*10d0**3,1d0, 82
      IF(stability_check)THEN
         CLOSE(UNIT=20456)
      ENDIF
      rslt(1)=vfes
      rslt(2)=sd
      rslt(3)=chi2a
      RETURN
5100  FORMAT(1P,2I8,2E14.6,6I8)
5200  FORMAT(1P,3E20.10,I6)
    END SUBROUTINE pp_oniumjet_NLO_VEGAS

    FUNCTION pp_onium_NLO_fxn(x,wgt)
      use mpmodule
      IMPLICIT NONE
      REAL(KIND(1d0)),DIMENSION(varnum),INTENT(IN)::x
      REAL(KIND(1d0)),INTENT(IN)::wgt
      REAL(KIND(1d0))::pp_onium_NLO_fxn
      REAL(KIND(1d0))::phi,costh,sinth
      REAL(KIND(1d0)),DIMENSION(4)::pmom
      INCLUDE "fxn_args0.inc"
      INCLUDE "fxn_init0.inc"
      nnntot=nnntot+1
      wtotal=0d0
      INCLUDE "fxn_phasespace_cuts0.inc"
      IF(icut.EQ.0)THEN
         pp_onium_NLO_fxn=0d0
         RETURN
      ENDIF
      !onium_pmom(1:nexternal-1,1:4)=onium_pmom_real(1:nexternal-1,1:4)
      INCLUDE "fxn_evaluate0.inc"
      pp_onium_NLO_fxn=wtotal
      IF(stability_check)THEN
         IF(nnn.GE.starting_untolerence.AND.&
              ((MAX(DABS(recmax),DABS(recmin))*untolerence_factor).LT.DABS(pp_onium_NLO_fxn)))THEN
            WRITE(20456,*)"Warning:find a weird big phase space point"
            WRITE(20456,*)"(weight,previous max weight,min weight)=",pp_onium_NLO_fxn,recmax,recmin
            WRITE(20456,*)xp1_born,xp2_born,Jy,JzzA,JzzB
            WRITE(20456,*)"======Big Weight Phase Space Point=========="
            DO j=1,nexternal-2
               WRITE(20456,*)j,ponium_born(0:3,j)
            ENDDO
            WRITE(20456,*)"============================================"
         ENDIF
      ENDIF
      nnn=nnn+1
      IF(recmax.LT.pp_onium_NLO_fxn)recmax=pp_onium_NLO_fxn
      IF(recmin.GT.pp_onium_NLO_fxn)recmin=pp_onium_NLO_fxn
      IF(MOD(nnn,nprint).EQ.0)THEN
         PRINT *,"max=",recmax
         PRINT *,"min=",recmin
         !IF(lunwei2.AND.lwmax.GT.1)THEN
         !   PRINT *,"      n_event,    n_pass,    n_total"
         !   PRINT *,nwri,nnn,nnntot
         !ELSE
         PRINT *, "      n_pass,     n_total"
         PRINT *,nnn,nnntot
         !ENDIF
      ENDIF
      RETURN
    END FUNCTION pp_onium_NLO_fxn

  FUNCTION pp_oniumjet_NLO_fxn(x,wgt)
    use mpmodule
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(varnum),INTENT(IN)::x
    REAL(KIND(1d0)),INTENT(IN)::wgt
    REAL(KIND(1d0))::pp_oniumjet_NLO_fxn
    REAL(KIND(1d0))::phi,costh,sinth
    REAL(KIND(1d0)),DIMENSION(4)::pmom
    INCLUDE "fxn_args.inc"
    INCLUDE "fxn_init.inc"
    nnntot=nnntot+1
    wtotal=0d0
    INCLUDE "fxn_phasespace_cuts.inc"
    IF(icut.EQ.0)THEN
       pp_oniumjet_NLO_fxn=0d0
       RETURN
    ENDIF
    !onium_pmom(1:nexternal-1,1:4)=onium_pmom_real(1:nexternal-1,1:4)
    INCLUDE "fxn_evaluate.inc"
    pp_oniumjet_NLO_fxn=wtotal
    IF(stability_check)THEN
       IF(nnn.GE.starting_untolerence.AND.&
            ((MAX(DABS(recmax),DABS(recmin))*untolerence_factor).LT.DABS(pp_oniumjet_NLO_fxn)))THEN
          WRITE(20456,*)"Warning:find a weird big phase space point"
          WRITE(20456,*)"(weight,previous max weight,min weight)=",pp_oniumjet_NLO_fxn,recmax,recmin
          WRITE(20456,*)xp1_born,xp2_born,Jpt2,Jy1,Jy2,JzzA,JzzB
          WRITE(20456,*)"======Big Weight Phase Space Point=========="
          DO j=1,nexternal-1
             WRITE(20456,*)j,ponium_born(0:3,j)
          ENDDO
          WRITE(20456,*)"============================================"
       ENDIF
    ENDIF
    nnn=nnn+1
    IF(recmax.LT.pp_oniumjet_NLO_fxn)recmax=pp_oniumjet_NLO_fxn
    IF(recmin.GT.pp_oniumjet_NLO_fxn)recmin=pp_oniumjet_NLO_fxn
    IF(MOD(nnn,nprint).EQ.0)THEN
       PRINT *,"max=",recmax
       PRINT *,"min=",recmin
       !IF(lunwei2.AND.lwmax.GT.1)THEN
       !   PRINT *,"      n_event,    n_pass,    n_total"
       !   PRINT *,nwri,nnn,nnntot
       !ELSE
       PRINT *, "      n_pass,     n_total"
       PRINT *,nnn,nnntot
       !ENDIF
    ENDIF
    RETURN
  END FUNCTION pp_oniumjet_NLO_fxn

  SUBROUTINE pp_oniumjet_NLO_hadronmom
    IMPLICIT NONE
    INTEGER::i,j
    DO i=1,2
       DO j=1,4
          onium_pmom_born_hadron(i,j)=onium_pmom_born(i,j)
       ENDDO
    ENDDO
    DO j=1,4
       onium_pmom_born_hadron(3,j)=onium_pmom_born(3,j)+onium_pmom_born(4,j)
       onium_pmom_born_hadron(4,j)=onium_pmom_born(5,j)
    ENDDO
    RETURN
  END SUBROUTINE pp_oniumjet_NLO_hadronmom

  SUBROUTINE pp_oniumjet_NLO_reweight_xsec_scale(iborn,iorder,inum,wme0,wsf0,P0,P1,P2,colllog,born_wgts)
    IMPLICIT NONE
    ! iborn: underlying born process
    ! 1 : g g  -> eta_Q g
    ! 2 : g q  -> eta_Q q
    ! 3 : q g  -> eta_Q q
    ! 4 : q q~ -> eta_Q g
    INTEGER,INTENT(IN)::iborn
    ! iorder:
    ! 1: born
    ! 2: soft+virtual+delta coll
    ! 3-6: collinear splitting
    INTEGER,INTENT(IN)::iorder
    ! inum:
    ! 1: gg; 2: gq; 3:qg; 4: Sum(qqbar); 5: qq'
    INTEGER,INTENT(IN)::inum
    ! this are borns for muR/muR0=1 and muF/muF0=1
    ! that have been evaluated
    REAL(KIND(1d0)),INTENT(IN)::wme0,wsf0,P0,P1,P2,colllog
    REAL(KIND(1d0)),DIMENSION(4),INTENT(IN)::born_wgts
    REAL(KIND(1d0))::alphasc=1d0,alphasu=1d0,alphasd=1d0
    REAL(KIND(1d0)),DIMENSION(3)::R_pdf
    REAL(KIND(1d0))::born_wsf0
    SAVE R_pdf,born_wsf0
    REAL(KIND(1d0)),DIMENSION(3)::muR_scales,logmuR2,logmuF2
    REAL(KIND(1d0)),DIMENSION(3)::aso2pimuR
    SAVE aso2pimuR
    REAL(KIND(1d0))::wsfw,wmew
    REAL(KIND(1d0))::muFwgt,muRwgt
    INTEGER::i,j
    INTEGER::init=0
    SAVE init,logmuR2,logmuF2
    IF(.NOT.reweight_scale)THEN
       WRITE(*,*)"ERROR:Please set reweight_scale to be T first !"
       STOP
    ENDIF
    IF(force_initial_reweight_scale)THEN
       IF(nscheme.NE.0.OR.(init.EQ.0.AND.nscheme.EQ.0))THEN
          ! force to update phase space point by phase space point when using dynamical scale
          ! if use fixed scale, only the first time evaluation is necessary
          CALL oniumjet_scale(scale)
          scale=scale*muR_over_ref
          muR_scales(1)=scale
          muR_scales(2)=scale*rw_Rscale_up
          muR_scales(3)=scale*rw_Rscale_down
          logmuR2(1)=0d0
          logmuR2(2)=DLOG(rw_Rscale_up**2)
          logmuR2(3)=DLOG(rw_Rscale_down**2)
          logmuF2(1)=0d0
          logmuF2(2)=DLOG(rw_Fscale_up**2)
          logmuF2(3)=DLOG(rw_Fscale_down**2)
          alphasc=ALPHAS(muR_scales(1))
          aso2pimuR(1)=alphasc/TWOPI
          alphasu=ALPHAS(muR_scales(2))
          aso2pimuR(2)=alphasu/TWOPI
          alphasd=ALPHAS(muR_scales(3))
          aso2pimuR(3)=alphasd/TWOPI
       ENDIF
       ! the following must be updated phase space point by phase space point
       
       force_initial_reweight_scale=.FALSE.
    ENDIF

    IF(iorder.EQ.1)THEN
       ! born only
       xp1=xp1_born
       xp2=xp2_born
       born_wsf0=wsf0
       R_pdf(1)=1d0
       IF(istruc.EQ.1)THEN
          reweight_Fscale_phase=1 ! 1: multiply central scale * rw_Fscale_up
          CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
          R_pdf(2)=wsfw/wsf0
          reweight_Fscale_phase=-1 ! -1: mutliply central scale * rw_Fscale_down
          CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
          R_pdf(3)=wsfw/wsf0
          ! recover it
          reweight_Fscale_phase=0
       ELSE
          R_pdf(2:3)=1d0
       ENDIF
       wgtxsecmu(1:3,1:3)=1d0
       DO i=1,3
          ! cycle for muR
          DO j=1,3
             ! cycle for muF
             wgtxsecmu(i,j)=R_pdf(j)*(aso2pimuR(i)/aso2pimuR(1))**bpower
          ENDDO
       END DO
    ELSEIF(iorder.EQ.2)THEN
       ! soft+virtual+coll dirac delta part
       ! R_pdf has been calculated from iorder=1
       ! Eq.(H.7) in my DGLAPSolver.pdf
       IF(calculation_type.EQ.0.OR.calculation_type.EQ.3)THEN
          CALL get_muF_dep_wgt_delta(iborn,born_wgts,muFwgt)
       ELSE
          muFwgt=0d0
       ENDIF
       IF(calculation_type.EQ.0.OR.calculation_type.EQ.2)THEN
          muRwgt=bpower*beta0*born_wgts(iborn)
       ELSE
          muRwgt=0d0
       ENDIF
       wgtxsecmu(1:3,1:3)=1d0
       DO i=1,3
          ! cycle for muR
          DO j=1,3
             ! cycle for muF
             wmew=(wme0+muRwgt*logmuR2(i)*aso2pimuR(1)&
                  -logmuF2(j)*aso2pimuR(1)*muFwgt)&
                  *(aso2pimuR(i)/aso2pimuR(1))**(bpower+1)
             wgtxsecmu(i,j)=R_pdf(j)*wmew/wme0
          ENDDO
       END DO
    ELSE
       ! initial splitting terms
       IF(iorder.EQ.3.OR.iorder.EQ.5)THEN
          xp1=xp1_realA
          xp2=xp2_realA
       ELSE
          xp1=xp1_realB
          xp2=xp2_realB
       ENDIF
       R_pdf(1)=1d0
       IF(istruc.EQ.1)THEN
          reweight_Fscale_phase=1 ! 1: multiply central scale * rw_Fscale_up
          CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
          R_pdf(2)=wsfw*(P0*(colllog-logmuF2(2))-P1)-born_wsf0*P2*(colllog-logmuF2(2))
          R_pdf(2)=R_pdf(2)/wsf0
          reweight_Fscale_phase=-1 ! -1: mutliply central scale * rw_Fscale_down
          CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
          R_pdf(3)=wsfw*(P0*(colllog-logmuF2(3))-P1)-born_wsf0*P2*(colllog-logmuF2(3))
          R_pdf(3)=R_pdf(3)/wsf0
          ! recover it
          reweight_Fscale_phase=0
       ELSE
          R_pdf(2:3)=1d0
       ENDIF
       wgtxsecmu(1:3,1:3)=1d0
       DO i=1,3
          ! cycle for muR
          DO j=1,3
             ! cycle for muF
             wgtxsecmu(i,j)=R_pdf(j)*(aso2pimuR(i)/aso2pimuR(1))**(bpower+1)
          ENDDO
       END DO
    ENDIF
    
    IF(init.EQ.0)init=1
    RETURN
  END SUBROUTINE pp_oniumjet_NLO_reweight_xsec_scale

  SUBROUTINE get_muF_dep_wgt_delta(iborn,born_wgts,muFwgt)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::iborn
    REAL(KIND(1d0)),DIMENSION(4),INTENT(IN)::born_wgts
    REAL(KIND(1d0)),INTENT(OUT)::muFwgt
    SELECT CASE(iborn)
    CASE(1)
       ! gg
       muFwgt=(Pgg0_delta(xp1_born)+Pgg0_delta(xp2_born)+four*ca*logonemds)*born_wgts(1)
    CASE(2)
       ! gq
       muFwgt=(Pgg0_delta(xp1_born)+Pqq0_delta(xp2_born)+two*(ca+cf)*logonemds)*born_wgts(2)
    CASE(3)
       ! qg
       muFwgt=(Pqq0_delta(xp1_born)+Pgg0_delta(xp2_born)+two*(ca+cf)*logonemds)*born_wgts(3)
    CASE(4)
       ! qq
       muFwgt=(Pqq0_delta(xp1_born)+Pqq0_delta(xp2_born)+four*cf*logonemds)*born_wgts(4)
    CASE DEFAULT
       WRITE(*,*)"ERROR: cannot reach here !"
       STOP
    END SELECT
    RETURN
  END SUBROUTINE GET_MUF_DEP_WGT_DELTA

  SUBROUTINE pp_oniumjet_NLO_reweight_xsec_muNRQCD(wme0)
    IMPLICIT NONE
    ! there is no explicit dependence of muNRQCD for NLO S-wave
    ! therefore, it is just a global rescaling
    ! the following two are for onium_muNRQCD (central value)
    ! that have been evaluated
    REAL(KIND(1d0)),INTENT(IN)::wme0
    INTEGER::i,j
    INTEGER::init=0
    REAL(KIND(1d0)),DIMENSION(3)::muNRQCD_scales,LDMEetaQ_rwgt
    SAVE init,muNRQCD_scales,LDMEetaQ_rwgt
    IF(.NOT.reweight_muNRQCD)THEN
       WRITE(*,*)"ERROR:Please set reweight_muNRQCD to be T first !"
       STOP
    ENDIF
    IF(force_initial_reweight_muNRQCD)THEN
       IF(init.EQ.0)THEN
          ! Only the first time evaluation is necessary
          muNRQCD_scales(1)=onium_muNRQCD
          muNRQCD_scales(2)=onium_muNRQCD*rw_muNRQCD_up
          muNRQCD_scales(3)=onium_muNRQCD*rw_muNRQCD_down
          LDMEetaQ_rwgt(1)=1d0
          LDMEetaQ_rwgt(2)=LDMEetaQ_up/LDMEetaQ
          LDMEetaQ_rwgt(3)=LDMEetaQ_down/LDMEetaQ
       ENDIF
       ! the following must be updated phase space point by phase space point

       force_initial_reweight_muNRQCD=.FALSE.
    ENDIF
    
    wgtxsecmuNRQCD(1:3)=1d0
    DO i=2,3
       wgtxsecmuNRQCD(i)=LDMEetaQ_rwgt(i)
    ENDDO
    IF(init.EQ.0)init=1
    RETURN
  END SUBROUTINE pp_oniumjet_NLO_reweight_xsec_muNRQCD

  SUBROUTINE pp_oniumjet_NLO_reweight_xsec_pdf(iorder,inum,wsf0,P0,P1,P2,colllog)
    IMPLICIT NONE
    INTEGER::init=0,i,k,kk
    SAVE init
    REAL(KIND(1d0)),INTENT(IN)::wsf0,P0,P1,P2,colllog
    ! iorder:
    ! 1: born
    ! 2: soft+virtual+delta coll
    ! 3-6: collinear splitting
    INTEGER,INTENT(IN)::iorder
    ! inum: 1,gg; 2, gq+gqbar; 3, qg+qbarg; 4, Sum(qqbar+qbarq); 5, qq'
    INTEGER,INTENT(IN)::inum
    REAL(KIND(1d0))::wsfw,wsf_real
    REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::born_wsfs_save
    SAVE born_wsfs_save
    
    IF(.NOT.reweight_pdf)THEN
       WRITE(*,*)"ERROR:Please set reweight_pdf to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(MOD(ho_npdf,2).NE.0)THEN
          WRITE(*,*)'The number of error sets must be even',ho_npdf
          STOP
       ENDIF
       IF(MOD(ho_npdf2,2).NE.0)THEN
          WRITE(*,*)'The number of error sets for beam 2 must be even',ho_npdf2
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecpdf))THEN
          DEALLOCATE(wgtxsecpdf)
       ENDIF
       ALLOCATE(wgtxsecpdf(ho_npdf+ho_npdf2))
       IF(ALLOCATED(born_wsfs_save))THEN
          DEALLOCATE(born_wsfs_save)
       ENDIF
       ALLOCATE(born_wsfs_save(ho_npdf+ho_npdf2))
       IF(ho_npdf.GT.0)THEN
          IF(ALLOCATED(idpdf))THEN
             DEALLOCATE(idpdf)
          ENDIF
          ALLOCATE(idpdf(0:ho_npdf))
          idpdf(0)=iPDFSUP1
          idpdf(1)=ipdf_set_min
          IF(ipdf_set_max-ipdf_set_min+1.NE.ho_npdf)THEN
             WRITE(*,*)'Incorrect the number of error pdf',ho_npdf,ipdf_set_min,ipdf_set_max
             STOP
          ENDIF
          DO i=2,ho_npdf
             idpdf(i)=idpdf(1)+i-1
          ENDDO
          WRITE(*,*) 'Doing PDF reweight:'
          WRITE(*,*) 'Central set id: ',idpdf(0)
          WRITE(*,*) 'Min error set id: ',idpdf(1)
          WRITE(*,*) 'Max error set id: ',idpdf(ho_npdf)
       ENDIF
       IF(ho_npdf2.GT.0)THEN
          IF(ALLOCATED(idpdf2))THEN
             DEALLOCATE(idpdf2)
          ENDIF
          ALLOCATE(idpdf2(0:ho_npdf2))
          idpdf2(0)=iPDFSUP2
          idpdf2(1)=ipdf2_set_min
          IF(ipdf2_set_max-ipdf2_set_min+1.NE.ho_npdf2)THEN
             WRITE(*,*)'Incorrect the number of error pdf2',ho_npdf2,ipdf2_set_min,ipdf2_set_max
             STOP
          ENDIF
          DO i=2,ho_npdf2
             idpdf2(i)=idpdf2(1)+i-1
          ENDDO
          WRITE(*,*) 'Doing PDF Beam 2 reweight:'
          WRITE(*,*) 'Central set id: ',idpdf2(0)
          WRITE(*,*) 'Min error set id: ',idpdf2(1)
          WRITE(*,*) 'Max error set id: ',idpdf2(ho_npdf2)
       ENDIF
       init=1
    ENDIF
    IF(force_initial_reweight_pdf)THEN
       ! force to update the wsf saved values
       force_initial_reweight_pdf=.FALSE.
    ENDIF
    IF(iorder.EQ.1)THEN
       ! born only
       ! always start first for each underlying born process
       xp1=xp1_born
       xp2=xp2_born       
       IF(.NOT.multipdfloading)THEN
          DO i=1,ho_npdf
             INCLUDE "../../../input/lhapdf/call_initpdf"
             IF(istruc.EQ.1)THEN
                CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
             ELSE
                WRITE(*,*)"ERROR: do not know the meaning of istruc with reweighting PDF"
                STOP
             ENDIF
             born_wsfs_save(i)=wsfw
             wgtxsecpdf(i)=wsfw/wsf0
          ENDDO
          ! recover it
          INCLUDE "../../../input/lhapdf/call_initpdf0"
       ELSE
          IF(.NOT.beams_pdf_correlation)THEN
             DO i=1,ho_npdf
                INCLUDE "../../../input/lhapdf/call_initmpdf1"
                CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
                born_wsfs_save(i)=wsfw
                wgtxsecpdf(i)=wsfw/wsf0
             ENDDO
             INCLUDE "../../../input/lhapdf/call_initmpdf10"
             DO i=1,ho_npdf2
                INCLUDE "../../../input/lhapdf/call_initmpdf2"
                CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
                born_wsfs_save(i+ho_npdf)=wsfw
                wgtxsecpdf(i+ho_npdf)=wsfw/wsf0
             ENDDO
             INCLUDE "../../../input/lhapdf/call_initmpdf20"
          ELSE
             ! it is correlated for two beams
             DO i=1,ho_npdf
                INCLUDE "../../../input/lhapdf/call_initmpdf1"
                INCLUDE "../../../input/lhapdf/call_initmpdf2"
                CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
                born_wsfs_save(i)=wsfw
                wgtxsecpdf(i)=wsfw/wsf0
             ENDDO
             INCLUDE "../../../input/lhapdf/call_initmpdf10"
             INCLUDE "../../../input/lhapdf/call_initmpdf20"
          ENDIF
       ENDIF
    ELSEIF(iorder.EQ.2)THEN
       ! soft+virtual+coll dirac delta part
       ! born PDFs have been evaluated
       ! we can recycle with iorder=1
       RETURN
    ELSE
       ! initial splitting terms
       IF(iorder.EQ.3.OR.iorder.EQ.5)THEN
          xp1=xp1_realA
          xp2=xp2_realA
       ELSE
          xp1=xp1_realB
          xp2=xp2_realB
       ENDIF
       IF(.NOT.multipdfloading)THEN
          DO i=1,ho_npdf
             INCLUDE "../../../input/lhapdf/call_initpdf"
             IF(istruc.EQ.1)THEN
                CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
             ELSE
                WRITE(*,*)"ERROR: do not know the meaning of istruc with reweighting PDF"
                STOP
             ENDIF
             wsf_real=wsfw*(P0*colllog-P1)-born_wsfs_save(i)*P2*colllog
             wgtxsecpdf(i)=wsf_real/wsf0
          ENDDO
          ! recover it
          INCLUDE "../../../input/lhapdf/call_initpdf0"
       ELSE
          IF(.NOT.beams_pdf_correlation)THEN
             DO i=1,ho_npdf
                INCLUDE "../../../input/lhapdf/call_initmpdf1"
                CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
                wsf_real=wsfw*(P0*colllog-P1)-born_wsfs_save(i)*P2*colllog
                wgtxsecpdf(i)=wsf_real/wsf0
             ENDDO
             INCLUDE "../../../input/lhapdf/call_initmpdf10"
             DO i=1,ho_npdf2
                INCLUDE "../../../input/lhapdf/call_initmpdf2"
                CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
                wsf_real=wsfw*(P0*colllog-P1)-born_wsfs_save(i+ho_npdf)*P2*colllog
                wgtxsecpdf(i+ho_npdf)=wsf_real/wsf0
             ENDDO
             INCLUDE "../../../input/lhapdf/call_initmpdf20"
          ELSE
             ! it is correlated for two beams
             DO i=1,ho_npdf
                INCLUDE "../../../input/lhapdf/call_initmpdf1"
                INCLUDE "../../../input/lhapdf/call_initmpdf2"
                CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
                wsf_real=wsfw*(P0*colllog-P1)-born_wsfs_save(i)*P2*colllog
                wgtxsecpdf(i)=wsf_real/wsf0
             ENDDO
             INCLUDE "../../../input/lhapdf/call_initmpdf10"
             INCLUDE "../../../input/lhapdf/call_initmpdf20"
          ENDIF
       ENDIF
    ENDIF
    RETURN
  END SUBROUTINE pp_oniumjet_NLO_reweight_xsec_pdf

  SUBROUTINE pp_oniumjet_NLO_reweight_xsec_npdf(iorder,inum,wsf0,P0,P1,P2,colllog)
    IMPLICIT NONE
    INTEGER::init=0,i,k,kk
    SAVE init
    ! iorder:
    ! 1: born
    ! 2: soft+virtual+delta coll
    ! 3-6: collinear splitting
    INTEGER,INTENT(IN)::iorder
    ! inum: 1,gg; 2, gq+gqbar; 3, qg+qbarg; 4, Sum(qqbar+qbarq); 5, qq'
    INTEGER,INTENT(IN)::inum
    REAL(KIND(1d0)),INTENT(IN)::wsf0,P0,P1,P2,colllog
    REAL(KIND(1d0))::wsfw,wsf_real
    REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::born_wsfsn_save
    SAVE born_wsfsn_save

    IF(.NOT.reweight_npdf)THEN
       WRITE(*,*)"ERROR:Please set reweight_npdf to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(MOD(ho_nnpdf,2).NE.0)THEN
          WRITE(*,*)'The number of error sets must be even',ho_nnpdf
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecnpdf))THEN
          DEALLOCATE(wgtxsecnpdf)
       ENDIF
       ALLOCATE(wgtxsecnpdf(ho_nnpdf))
       IF(ALLOCATED(born_wsfsn_save))THEN
          DEALLOCATE(born_wsfsn_save)
       ENDIF
       ALLOCATE(born_wsfsn_save(ho_nnpdf))
       IF(ALLOCATED(idnpdf))THEN
          DEALLOCATE(idnpdf)
       ENDIF
       ALLOCATE(idnpdf(0:ho_nnpdf))
       IF(nPDF_id.NE.1000)THEN
          idnpdf(0)=nPDF_id
          idnpdf(1)=inpdf_set_min
       ELSE
          idnpdf(0)=iPDFSUP1
          idnpdf(1)=inpdf_set_min-1000+iPDFSUP1
       ENDIF
       IF(inpdf_set_max-inpdf_set_min+1.NE.ho_nnpdf)THEN
          WRITE(*,*)'Incorrect the number of error npdf',ho_nnpdf,inpdf_set_min,inpdf_set_max
          STOP
       ENDIF
       DO i=2,ho_nnpdf
          idnpdf(i)=idnpdf(1)+i-1
       ENDDO
       WRITE(*,*) 'Doing nPDF reweight:'
       WRITE(*,*) 'Central set id: ',idnpdf(0)
       WRITE(*,*) 'Min error set id: ',idnpdf(1)
       WRITE(*,*) 'Max error set id: ',idnpdf(ho_nnpdf)
       init=1
    ENDIF
    IF(force_initial_reweight_npdf)THEN
       ! force to update the wsf saved values
       force_initial_reweight_npdf=.FALSE.
    ENDIF
    IF(iorder.EQ.1)THEN
       ! born only
       ! always start first for each underlying born process
       xp1=xp1_born
       xp2=xp2_born
       DO i=1,ho_nnpdf
          use_neutron_rand=.TRUE.
          INCLUDE "../../../input/lhapdf/call_initnpdfi"
          INCLUDE "../../../input/lhapdf/call_initnpdfi_lhapdf6"
          IF(istruc.EQ.1)THEN
             CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
          ELSE
             WRITE(*,*)"ERROR: cannot understand the value of istruc within pp_oniumjet_NLO_reweigt_xsec_npdf"
             STOP
          ENDIF
          born_wsfsn_save(i)=wsfw
          wgtxsecnpdf(i)=wsfw/wsf0
       ENDDO
       ! recover it
       INCLUDE "../../../input/lhapdf/call_initnpdf"
       INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_0"
    ELSEIF(iorder.EQ.2)THEN
       ! soft+virtual+coll dirac delta part
       ! born PDFs have been evaluated
       ! we can recycle with iorder=1
       RETURN
    ELSE
       ! initial splitting terms
       IF(iorder.EQ.3.OR.iorder.EQ.5)THEN
          xp1=xp1_realA
          xp2=xp2_realA
       ELSE
          xp1=xp1_realB
          xp2=xp2_realB
       ENDIF
       DO i=1,ho_nnpdf
          use_neutron_rand=.TRUE.
          INCLUDE "../../../input/lhapdf/call_initnpdfi"
          INCLUDE "../../../input/lhapdf/call_initnpdfi_lhapdf6"
          IF(istruc.EQ.1)THEN
             CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
          ELSE
             WRITE(*,*)"ERROR: cannot understand the value of istruc within pp_oniumjet_NLO_reweigt_xsec_npdf"
             STOP
          ENDIF
          wsf_real=wsfw*(P0*colllog-P1)-born_wsfsn_save(i)*P2*colllog
          wgtxsecnpdf(i)=wsf_real/wsf0
       ENDDO
       ! recover it
       INCLUDE "../../../input/lhapdf/call_initnpdf"
       INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_0"
    ENDIF
    RETURN
  END SUBROUTINE pp_oniumjet_NLO_reweight_xsec_npdf

  SUBROUTINE pp_oniumjet_NLO_reweight_xsec_ref(iorder,inum,wsf0,P0,P1,P2,colllog)
    IMPLICIT NONE
    INTEGER::init=0,i
    SAVE init
    ! iorder:
    ! 1: born
    ! 2: soft+virtual+delta coll
    ! 3-6: collinear splitting
    INTEGER,INTENT(IN)::iorder
    ! inum: 1,gg; 2, gq+gqbar; 3, qg+qbarg; 4, Sum(qqbar+qbarq); 5, qq'
    INTEGER,INTENT(IN)::inum
    REAL(KIND(1d0)),INTENT(IN)::wsf0,P0,P1,P2,colllog
    REAL(KIND(1d0))::wsfw,wsf_real
    REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::born_wsfr_save
    SAVE born_wsfr_save

    IF(.NOT.reweight_ref)THEN
       WRITE(*,*)"ERROR:Please set reweight_ref to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(ho_nref.NE.1.AND.ho_nref.NE.3)THEN
          WRITE(*,*)'Incorrect the number of references #1:',ho_nref
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecref))THEN
          DEALLOCATE(wgtxsecref)
       ENDIF
       ALLOCATE(wgtxsecref(ho_nref))
       IF(ALLOCATED(born_wsfr_save))THEN
          DEALLOCATE(born_wsfr_save)
       ENDIF
       ALLOCATE(born_wsfr_save(ho_nref))
       IF(ALLOCATED(idref))THEN
          DEALLOCATE(idref)
       ENDIF
       ALLOCATE(idref(0:ho_nref))
       idref(0)=0
       idref(1)=iref_set_max
       IF(iref_set_max-iref_set_min+1.NE.ho_nref)THEN
          WRITE(*,*)'Incorrect the number of references #2:',ho_nref,iref_set_min,iref_set_max
          STOP
       ENDIF
       DO i=2,ho_nref
          idref(i)=idref(1)+i-1
       ENDDO
       WRITE(*,*) 'Doing reference reweight'
       init=1
    END IF
    IF(force_initial_reweight_ref)THEN
       ! force to update the wsf saved values
       force_initial_reweight_ref=.FALSE.
    ENDIF

    IF(iorder.EQ.1)THEN
       ! born only
       ! always start first for each underlying born process
       xp1=xp1_born
       xp2=xp2_born
       ! reference: pp
       INCLUDE "../../../input/lhapdf/call_initnpdf"
       PureProton1=.TRUE.
       PureProton2=.TRUE.
       IF(istruc.EQ.1)THEN
          CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
       ELSE
          WRITE(*,*)"Erraor: unknow the value of istruc in pp_oniumX_reweight_xsec_ref # 1"
          STOP
       ENDIF
       born_wsfr_save(1)=wsfw
       wgtxsecref(1)=wsfw/wsf0
       IF(ho_nref.LE.1)THEN
          PureProton1=.FALSE.
          PureProton2=.FALSE.
          RETURN
       ENDIF
       ! reference: pB collision for AB
       PureProton2=.FALSE.
       CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
       born_wsfr_save(2)=wsfw
       wgtxsecref(2)=wsfw/wsf0
       ! reference: Ap collision for AB
       PureProton2=.TRUE.
       PureProton1=.FALSE.
       CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
       born_wsfr_save(3)=wsfw
       wgtxsecref(3)=wsfw/wsf0
    
       PureProton1=.FALSE.
       PureProton2=.FALSE.
    ELSEIF(iorder.EQ.2)THEN
       ! soft+virtual+coll dirac delta part
       ! born PDFs have been evaluated
       ! we can recycle with iorder=1
       RETURN
    ELSE
       ! initial splitting terms
       IF(iorder.EQ.3.OR.iorder.EQ.5)THEN
          xp1=xp1_realA
          xp2=xp2_realA
       ELSE
          xp1=xp1_realB
          xp2=xp2_realB
       ENDIF
       ! reference: pp
       INCLUDE "../../../input/lhapdf/call_initnpdf"
       PureProton1=.TRUE.
       PureProton2=.TRUE.
       IF(istruc.EQ.1)THEN
          CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
       ELSE
          WRITE(*,*)"Erraor: unknow the value of istruc in pp_oniumX_reweight_xsec_ref # 1"
          STOP
       ENDIF
       wsf_real=wsfw*(P0*colllog-P1)-born_wsfr_save(1)*P2*colllog
       wgtxsecref(1)=wsf_real/wsf0
       IF(ho_nref.LE.1)THEN
          PureProton1=.FALSE.
          PureProton2=.FALSE.
          RETURN
       ENDIF
       ! reference: pB collision for AB
       PureProton2=.FALSE.
       CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
       wsf_real=wsfw*(P0*colllog-P1)-born_wsfr_save(2)*P2*colllog
       wgtxsecref(2)=wsf_real/wsf0
       ! reference: Ap collision for AB
       PureProton2=.TRUE.
       PureProton1=.FALSE.
       CALL strf_pdf_pp_oniumjet_NLO(wsfw,inum)
       wsf_real=wsfw*(P0*colllog-P1)-born_wsfr_save(3)*P2*colllog
       wgtxsecref(3)=wsf_real/wsf0

       PureProton1=.FALSE.
       PureProton2=.FALSE.
    ENDIF

    RETURN
  END SUBROUTINE pp_oniumjet_NLO_reweight_xsec_ref

  SUBROUTINE strf_pdf_pp_oniumjet_NLO(wsf,inum)
    USE CTEQ6PDF
    USE Structf_PDFs
    IMPLICIT NONE
    INTEGER::ipp=1
    INTEGER::ih=1 ! ih=1 no photon PDF, ih=2, photon from proton/anti-proton, ih=3 phton from electron/positron
    REAL(KIND(1d0)),INTENT(OUT)::wsf
    INTEGER,INTENT(IN)::inum ! inum = 1: gg; inum=2: gq+gqbar; inum=3: qg+qbarg; inum=4: Sum(qqbar+qbarq); inum=5: qqbar+qbarq+qq'
    INTEGER::init=0
    LOGICAL::use_cteq6_f90=.TRUE.
    REAL(KIND=DBL),DIMENSION(-7:7)::pdflist
    SAVE init,ipp,use_cteq6_f90
    REAL(KIND(1d0))::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
         ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct
    REAL(KIND(1d0))::quarks1,quarks2
    IF(iPDFSUP1.EQ.iPDFSUP2)THEN
       INCLUDE "../lhapdf/call_strf_lhapdf"
    ELSE
       INCLUDE "../lhapdf/call_strf_mlhapdf"
    ENDIF
    IF(init.EQ.0)THEN
       SELECT CASE(iPDFSUP1)
       CASE(10000)
          CALL SetCtq6f90(1)
          pdlabel='cteq6_m'
          nloop=2
          alphaQCD2=0.118d0
          use_cteq6_f90=.TRUE.
       CASE(10041)
          CALL SetCtq6f90(3)
          pdlabel='cteq6_l'
          nloop=2
          alphaQCD2=0.118d0
          use_cteq6_f90=.TRUE.
       CASE(10042)
          CALL SetCtq6f90(4)
          pdlabel='cteq6l1'
          nloop=1
          alphaQCD2=0.130d0
          use_cteq6_f90=.TRUE.
       CASE DEFAULT
          CALL pdfset_internal
          use_cteq6_f90=.FALSE.
       END SELECT
       IF(COLL_TYPE.EQ.1)THEN
          ipp=2
       ELSE
          ipp=1
       ENDIF
       init=1
    ENDIF
    
    CALL oniumjet_scale(scale)
    scale=muF_over_ref*scale
    IF(reweight_scale)THEN
       IF(reweight_Fscale_phase.EQ.1)THEN
          scale=scale*rw_Fscale_up
       ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
          scale=scale*rw_Fscale_down
       ENDIF
    ENDIF
    
    IF(use_cteq6_f90)THEN
       glu1_ct = xp1*Ctq6Pdf_f90(0,xp1,scale)
       glu2_ct = xp2*Ctq6Pdf_f90(0,xp2,scale)
       u1_ct   = xp1*Ctq6Pdf_f90(1,xp1,scale)
       u2_ct   = xp2*Ctq6Pdf_f90(1,xp2,scale)
       d1_ct   = xp1*Ctq6Pdf_f90(2,xp1,scale)
       d2_ct   = xp2*Ctq6Pdf_f90(2,xp2,scale)
       s1_ct   = xp1*Ctq6Pdf_f90(3,xp1,scale)
       s2_ct   = xp2*Ctq6Pdf_f90(3,xp2,scale)
       c1_ct   = xp1*Ctq6Pdf_f90(4,xp1,scale)
       c2_ct   = xp2*Ctq6Pdf_f90(4,xp2,scale)
       b1_ct   = xp1*Ctq6Pdf_f90(5,xp1,scale)
       b2_ct   = xp2*Ctq6Pdf_f90(5,xp2,scale)
       ub1_ct  = xp1*Ctq6Pdf_f90(-1,xp1,scale)
       ub2_ct  = xp2*Ctq6Pdf_f90(-1,xp2,scale)
       db1_ct  = xp1*Ctq6Pdf_f90(-2,xp1,scale)
       db2_ct  = xp2*Ctq6Pdf_f90(-2,xp2,scale)
       sb1_ct  = xp1*Ctq6Pdf_f90(-3,xp1,scale)
       sb2_ct  = xp2*Ctq6Pdf_f90(-3,xp2,scale)
       cb1_ct  = xp1*Ctq6Pdf_f90(-4,xp1,scale)
       cb2_ct  = xp2*Ctq6Pdf_f90(-4,xp2,scale)
       bb1_ct  = xp1*Ctq6Pdf_f90(-5,xp1,scale)
       bb2_ct  = xp2*Ctq6Pdf_f90(-5,xp2,scale)
    ELSE
       CALL fdist(ih,xp1,scale,pdflist(-7:7))
       glu1_ct = xp1*pdflist(0)
       u1_ct   = xp1*pdflist(2)
       d1_ct   = xp1*pdflist(1)
       s1_ct   = xp1*pdflist(3)
       c1_ct   = xp1*pdflist(4)
       b1_ct   = xp1*pdflist(5)
       ub1_ct  = xp1*pdflist(-2)
       db1_ct  = xp1*pdflist(-1)
       sb1_ct  = xp1*pdflist(-3)
       cb1_ct  = xp1*pdflist(-4)
       bb1_ct  = xp1*pdflist(-5)
       CALL fdist(ih,xp2,scale,pdflist(-7:7))
       glu2_ct = xp2*pdflist(0)
       u2_ct   = xp2*pdflist(2)
       d2_ct   = xp2*pdflist(1)
       s2_ct   = xp2*pdflist(3)
       c2_ct   = xp2*pdflist(4)
       b2_ct   = xp2*pdflist(5)
       ub2_ct  = xp2*pdflist(-2)
       db2_ct  = xp2*pdflist(-1)
       sb2_ct  = xp2*pdflist(-3)
       cb2_ct  = xp2*pdflist(-4)
       bb2_ct  = xp2*pdflist(-5)
    ENDIF
    ! recover it
    IF(reweight_scale)THEN
       IF(reweight_Fscale_phase.EQ.1)THEN
          scale=scale/rw_Fscale_up
       ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
          scale=scale/rw_Fscale_down
       ENDIF
    ENDIF
    IF(inum.EQ.1)THEN
       ! gg
       wsf=glu1_ct*glu2_ct*wjac/xp1/xp2
    ELSEIF(inum.EQ.2)THEN
       ! gq+gqbar
       wsf=glu1_ct*(u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct)
       IF(nlq.GT.3)THEN
          wsf=wsf+glu1_ct*(c2_ct+cb2_ct)
       ENDIF
       IF(nlq.GT.4)THEN
          wsf=wsf+glu1_ct*(b2_ct+bb2_ct)
       ENDIF
       wsf=wsf*wjac/xp1/xp2
    ELSEIF(inum.EQ.3)THEN
       ! qg+qbarg
       wsf=glu2_ct*(u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct)
       IF(nlq.GT.3)THEN
          wsf=wsf+glu2_ct*(c1_ct+cb1_ct)
       ENDIF
       IF(nlq.GT.4)THEN
          wsf=wsf+glu2_ct*(b1_ct+bb1_ct)
       ENDIF
       wsf=wsf*wjac/xp1/xp2
    ELSEIF(inum.EQ.4)THEN
       ! Sum(qqbar+qbarq)
       wsf=u1_ct*ub2_ct+ub1_ct*u2_ct
       wsf=wsf+d1_ct*db2_ct+db1_ct*d2_ct
       wsf=wsf+s1_ct*sb2_ct+sb1_ct*s2_ct
       IF(nlq.GT.3)THEN
          wsf=wsf+c1_ct*cb2_ct+cb1_ct*c2_ct
       ENDIF
       IF(nlq.GT.4)THEN
          wsf=wsf+b1_ct*bb2_ct+bb1_ct*b2_ct
       ENDIF
       wsf=wsf*wjac/xp1/xp2
    ELSEIF(inum.EQ.5)THEN
       ! qq' (all two (ani-)quark combinations)
       quarks1=u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct
       quarks2=u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct
       IF(nlq.GT.3)THEN
          quarks1=quarks1+c1_ct+cb1_ct
          quarks2=quarks2+c2_ct+cb2_ct
       ENDIF
       IF(nlq.GT.4)THEN
          quarks1=quarks1+b1_ct+bb1_ct
          quarks2=quarks2+b2_ct+bb2_ct
       ENDIF
       wsf=quarks1*quarks2
       wsf=wsf*wjac/xp1/xp2
    ENDIF
    IF(init.EQ.0)init=1
  END SUBROUTINE strf_pdf_pp_oniumjet_NLO

  SUBROUTINE readcuts_pp_oniumjet_NLO
    IMPLICIT NONE
    CHARACTER(len=24)::file
    LOGICAL::lexist
    INTEGER::iounit,flag=0,i,i1,j,j1
    REAL(KIND(1d0))::ptq,ptcharm,ptconia,etaq,ycq,ycqlow,etaconia,ycconia,ycconialow
    REAL(KIND(1d0))::cutoff,ptbonia,etabonia,ycbonia,ycbonialow
    REAL(KIND(1d0))::xFcq,xFcqlow,xFcconia,xFcconialow,xFcbonia,xFcbonialow
    REAL(KIND(1d0))::gbeamq,drqq,gqq,maxptq,maxptcharm,maxptconia,maxptbonia
    ! open default input file
    INQUIRE(FILE=TRIM(input_dir)//"default.inp",EXIST=lexist)
    IF(.NOT.lexist)THEN
       PRINT *,"Warning: the file default.inp does not exist ! STOP !"
       STOP
    ENDIF
    INQUIRE(FILE=TRIM(input_dir)//"default.inp",OPENED=lexist)
    IF(lexist)THEN
       INQUIRE(FILE=TRIM(input_dir)//"default.inp",NUMBER=iounit)
       IF(iounit.NE.udefault)THEN
          PRINT *,"WARNING: the default.inp has been linked with another unit ! Close and reopen !"
          CLOSE(UNIT=iounit)
          OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
       ENDIF
    ELSE
       OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
    ENDIF
    ! open user's input file
    IF(TRIM(Input_File)/="default.inp")THEN
       INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),EXIST=lexist)
       IF(.NOT.lexist)THEN
          PRINT *,"Warning: the file "//TRIM(Input_File)//" does not exist ! STOP !"
          STOP
       ENDIF
       INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),OPENED=lexist)
       IF(lexist)THEN
          INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),NUMBER=iounit)
          IF(iounit.NE.uinput)THEN
             PRINT *,"WARNING: the "//TRIM(Input_File)//" has been linked with another unit ! Close and reopen !"
             CLOSE(UNIT=iounit)
             OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
          ENDIF
       ELSE
          OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
       ENDIF
    ELSE
       flag=1
    ENDIF
    cutoff=readvalue_r("cutoffp",flag)
    ptc(3:20)=cutoff
    maxptc(3:20)=-1d0
    drc(3:20,3:20)=0
    etac(3:20)=20
    yycut(3:20)=1d9
    IF(absrap)THEN
       yycutlow(3:20)=0d0
    ELSE
       yycutlow(3:20)=-1d9
    ENDIF
    xFcut(3:20)=1d0
    xFcutlow(3:20)=-1d0
    xFcutflag=.FALSE.
    ec(3:20)=cutoff
    c1(3:20)=1d0
    c2(3:20)=1d0
    cc(3:20,3:20)=1d0
    gmas(3:20,3:20)=cutoff
    gbeammass(1:2,3:20)=0d0
    y1cup=30d0
    y1clow=0d0
    y1cup=readvalue_r("maxy1c",flag)
    y1clow=readvalue_r("miny1c",flag)
    ! minimum quark pt
    ptq=readvalue_r("minptq",flag)
    ! maximum quark pt
    maxptq=readvalue_r("maxptq",flag)
    ! minimum charm pt
    ptcharm=readvalue_r("minptc",flag)
    ! maximum charm pt
    maxptcharm=readvalue_r("maxptc",flag)
    ! minimum charmonia pt
    ptconia=readvalue_r("minptconia",flag)
    ! maximum charmonia pt
    maxptconia=readvalue_r("maxptconia",flag)
    ! minimum bottomonia pt
    ptbonia=readvalue_r("minptbonia",flag)
    ! maximum bottomonia pt
    maxptbonia=readvalue_r("maxptbonia",flag)
    ! maximum rapidity quark
    etaq=readvalue_r("maxrapq",flag)
    ! maximum y rapidity quark
    ycq=readvalue_r("maxyrapq",flag)
    ! minimum y rapidity quark
    ycqlow=readvalue_r("minyrapq",flag)
    ! maximum Feynman parameter xF
    xFcq=readvalue_r("maxxFq",flag)
    ! minimum Feynman parameter xF
    xFcqlow=readvalue_r("minxFq",flag)
    ! maximum rapidity charmonium
    etaconia=readvalue_r("maxrapconia",flag)
    ! maximum y rapidity charmonium
    ycconia=readvalue_r("maxyrapconia",flag)
    ! minimum y rapidity charmonium
    ycconialow=readvalue_r("minyrapconia",flag)
    ! maximum Feynman parameter xF
    xFcconia=readvalue_r("maxxFconia",flag)
    ! minimum Feynman parameter xF
    xFcconialow=readvalue_r("minxFconia",flag)
    ! maxmimum rapidity bottomonia
    etabonia=readvalue_r("maxrapbonia",flag)
    ! maximum y rapidity bottomonia
    ycbonia=readvalue_r("maxyrapbonia",flag)
    ! minimum y rapidity bottomonia
    ycbonialow=readvalue_r("minyrapbonia",flag)
    ! maximum Feynman parameter xF
    xFcbonia=readvalue_r("maxxFbonia",flag)
    ! minimum Feynman parameter xF
    xFcbonialow=readvalue_r("minxFbonia",flag)
    ! minimum DR quark with quark
    drqq=readvalue_r("mindrqq",flag)
    ! minimum mass quark with quark
    gqq=readvalue_r("minmqqp",flag)
    ! minimum mass u,d,s quarks and gluon  with partonic beam
    gbeamq=readvalue_r("minmqbeam",flag)
    CLOSE(UNIT=udefault)
    CLOSE(UNIT=uinput)
    ! gluon as 2nd final particle
    ptc(4)=ptq
    IF(maxptq.GE.0d0)maxptc(4)=maxptq
    etac(4)=etaq
    yycut(4)=ycq
    yycutlow(4)=ycqlow
    xFcut(4)=xFcq
    xFcutlow(4)=xFcqlow
    ! Higgs or quarkonium as 1st final particle
    IF(iflh(3).GE.440000.AND.iflh(3).LE.449999)THEN
       ptc(3)=ptconia
       IF(maxptconia.GE.0d0)maxptc(3)=maxptconia
       etac(3)=etaconia
       yycut(3)=ycconia
       yycutlow(3)=ycconialow
       xFcut(3)=xFcconia
       xFcutlow(3)=xFcconialow
    ELSEIF(iflh(3).GE.550000.AND.iflh(3).LE.559999)THEN
       ptc(3)=ptbonia
       IF(maxptbonia.GE.0d0)maxptc(3)=maxptbonia
       etac(3)=etabonia
       yycut(3)=ycbonia
       yycutlow(3)=ycbonialow
       xFcut(3)=xFcbonia
       xFcutlow(3)=xFcbonialow
    ELSE
       ! Higgs otherwise
       WRITE(*,*)"ERROR: Cannot arrive here !"
       STOP
    ENDIF
    WRITE(*,*)'---------------------------------------------------'
    WRITE(*,*)'        the cuts        '
    IF(onium_state.GT.0)THEN
       DO i=3,4
          WRITE(*,*)'pt     of  ',i,'   particle   ',ptc(i)
          IF(maxptc(i).GE.0d0)THEN
             WRITE(*,*)'max pt of  ',i,'   particle   ',maxptc(i)
             IF(maxptc(i).LE.ptc(i))THEN
                WRITE(*,*)"ERROR: One final state ",i," was cut off by pt cut"
                STOP
             ENDIF
          ELSE
             WRITE(*,*)'no max pt cut of  ',i,'   particle   '
          ENDIF
          WRITE(*,*)'rapidity of  ',i,'   particle   ',etac(i)
          WRITE(*,*)'max y rapidity of ',i,'   particle   ',yycut(i)
          WRITE(*,*)'min y rapidity of ',i,'   particle   ',yycutlow(i)
          IF(yycut(i).LE.yycutlow(i))THEN
             WRITE(*,*)"ERROR:One final state ",i," was cut off by y rapidity"
             STOP
          ENDIF
       ENDDO
    ELSE
       DO i=3,3
          WRITE(*,*)'rapidity of  ',i,'   particle   ',etac(i)
          WRITE(*,*)'max y rapidity of ',i,'   particle   ',yycut(i)
          WRITE(*,*)'min y rapidity of ',i,'   particle   ',yycutlow(i)
          IF(yycut(i).LE.yycutlow(i))THEN
             WRITE(*,*)"ERROR:One final state ",i," was cut off by y rapidity"
             STOP
          ENDIF
       ENDDO
    ENDIF
    RETURN
  END SUBROUTINE readcuts_pp_oniumjet_NLO

  SUBROUTINE Cuts_pp_oniumjet_NLO(icut)
    IMPLICIT NONE
    INTEGER,INTENT(OUT)::icut
    INTEGER::l,l1,l2,flag
    REAL(KIND(1d0))::s,d1,d2,dr,pt,eta,aaa,bbb,ptcut
    REAL(KIND(1d0)),DIMENSION(4)::ponia,pboo2
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
    REAL(KIND(1d0))::e,q
    INTEGER::lmax
    icut=0
    flag=0
    ! let us assume only impose cuts on Higgs boson
    ! redefine lmax
    DO l=3,nhad-1
       IF(nhad.GE.5)THEN
          pt=DSQRT(onium_pmom_born_hadron(l,1)**2+onium_pmom_born_hadron(l,2)**2)
          IF(pt.LT.ptc(l))THEN
             flag=1
             EXIT
          ENDIF
          IF(maxptc(l).GE.0d0)THEN
             IF(pt.GT.maxptc(l))THEN
                flag=1
                EXIT
             ENDIF
          ENDIF
       ENDIF
       eta=prapidity(onium_pmom_born_hadron(l,1:4))
       IF(ABS(eta).GT.etac(l))THEN
          flag=1
          EXIT
       ENDIF
       eta=rapidity(onium_pmom_born_hadron(l,1:4))
       IF(absrap)eta=ABS(eta)
       IF(eta.GT.yycut(l).OR.eta.LT.yycutlow(l))THEN
          flag=1
          EXIT
       ENDIF
       ! special for the first particle , which can be used to calculate the y distribution
       IF(l.EQ.3)THEN
          IF(eta.GT.y1cup.OR.eta.LT.y1clow)THEN
             flag=1
             EXIT
          ENDIF
       ENDIF
    ENDDO
    IF(flag.EQ.0)icut=1
    ! treat xF cut
    ! it shoule be done in the collision frame
    IF(xFcutflag.AND.icut.EQ.1.AND.flag.EQ.0)THEN
       STOP "cannot reach here !"
       q=ehat
       e=q/SQRT(xp1*xp2)
       IF(.NOT.labeqcoll)THEN
          IF(.NOT.fixtarget)THEN
             pboo2(4)=(ebeam(1)+ebeam(2))
             pboo2(3)=-(ebeam(1)-ebeam(2))
          ELSE
             IF(.NOT.fixtargetrev)THEN
                pboo2(4)=(ebeam(1)+ebeam(2))
                pboo2(3)=-ebeam(1)
             ELSE
                pboo2(4)=(ebeam(1)+ebeam(2))
                pboo2(3)=ebeam(2)
             ENDIF
          ENDIF
          pboo2(1:2)=0
          ! boost from the lab frame to the collision frame
          DO l=3,nhad-1
             CALL boostl(e,pboo2,onium_pmom_born_hadron(l,1:4))
          ENDDO
       ENDIF
       DO l=3,nhad-1
          eta=xFeynman(onium_pmom_born_hadron(l,1:4),e)
          IF(eta.GT.xFcut(l).OR.eta.LT.xFcutlow(l))THEN
             icut=0
             EXIT
          ENDIF
       ENDDO
       IF(.NOT.labeqcoll)THEN
          pboo2(3)=-pboo2(3)
          ! boost back to the lab frame
          DO l=3,nhad-1
             CALL boostl(e,pboo2,onium_pmom_born_hadron(l,1:4))
          ENDDO
       ENDIF
    ENDIF
    RETURN
  END SUBROUTINE Cuts_pp_oniumjet_NLO

  FUNCTION state2hoid(istate) RESULT(ho_id)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::istate
    INTEGER::ho_id
    SELECT CASE(istate)
    CASE(1,0)
       ! eta_c
       ho_id=441001
    CASE(2)
       ! eta_b
       ho_id=551001
    CASE DEFAULT
       WRITE(*,*)"ERROR: do not know the state=",istate
       STOP
    END SELECT
    RETURN
  END FUNCTION state2hoid

  ! according to Eq.(2.5) in 2007.01737
  ! note that is at the amplitude level
  ! here we should take at the amplitude square level
  FUNCTION LDME_RG_RUNNING(nloop,as0,asmuNRQCD,LDME0) RESULT(res)
    IMPLICIT NONE
    ! nloop: 0 (only beta0), 1 (+beta1), 2 (+beta2)
    INTEGER,INTENT(IN)::nloop
    REAL(KIND(1d0)),INTENT(IN)::as0,asmuNRQCD,LDME0
    REAL(KIND(1d0))::res,logterm,atanterm1,atanterm2,DELTA
    INTEGER::init=0
    SAVE init
    SELECT CASE(nloop)
    CASE(0)
       IF(init.EQ.0)THEN
          IF(beta0.EQ.0d0)THEN
             WRITE(*,*)"Error: Please update beta functions first"
             STOP
          ENDIF
       ENDIF
       res=TWOPI*CF*(CF+CA*0.5d0)/beta0*(as0-asmuNRQCD)
       res=DEXP(res)*LDME0
    CASE(1)
       IF(init.EQ.0)THEN
          IF(beta0.EQ.0d0.OR.beta1.EQ.0d0)THEN
             WRITE(*,*)"Error: Please update beta functions first"
             STOP
          ENDIF
       ENDIF
       logterm=(beta1*as0/TWOPI+beta0)/(beta1*asmuNRQCD/TWOPI+beta0)
       IF(logterm.LE.0d0)THEN
          WRITE(*,*)"Error: the argument of log is negative"
          STOP
       ENDIF
       logterm=DLOG(logterm)
       res=TWOPI2*CF*(CF+CA*0.5d0)/beta1&
            *logterm
       res=DEXP(res)*LDME0
    CASE DEFAULT
       IF(init.EQ.0)THEN
          IF(beta0.EQ.0d0.OR.beta1.EQ.0d0.OR.beta2.EQ.0d0)THEN
             WRITE(*,*)"Error: Please update beta functions first"
             STOP
          ENDIF
       ENDIF
       DELTA=four*beta0*beta2-beta1**2
       IF(DELTA.LE.0d0)THEN
          WRITE(*,*)"Error: the delta term is zero"
          STOP
       ENDIF
       DELTA=DSQRT(DELTA)
       atanterm1=(beta2/PI*as0+beta1)/DELTA
       atanterm2=(beta2/PI*asmuNRQCD+beta1)/DELTA
       atanterm1=DATAN(atanterm1)
       atanterm2=DATAN(atanterm2)
       res=TWO*TWOPI2*CF*(CF+CA*0.5d0)/DELTA*(atanterm1-atanterm2)
       res=DEXP(res)*LDME0
    END SELECT
    IF(init.EQ.0)init=1
    RETURN
  END FUNCTION LDME_RG_RUNNING
  
  SUBROUTINE SET_QCD_NF(nf_in)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::nf_in
    nf = nf_in
    rnf = DBLE(nf_in)
    nf_up = nf_in/2
    nf_down = (nf_in+1)/2
    nfTF = rnf*TF
    CALL SET_QCD_BETA(4)
    RETURN
  END SUBROUTINE SET_QCD_NF

  SUBROUTINE SET_QCD_BETA(n)
    ! Set QCD beta functions up to beta_n (n+1 loop) in MSbar scheme
    ! beta_i is the coefficeints of the beta function expansion in terms of as/2pi
    ! das(t)/dt = beta(as(t)) = -as(t)(beta_0*as(t)/2pi+beta_1*(as(t)/2pi)**2+...)
    ! where t=log(Q**2)
    ! IN:
    ! n - get beta_i, i=0,...,n (max n <= 4)
    ! OUT:
    ! beta0=beta_0, beta1=beta_1,...
    IMPLICIT NONE
    INTEGER,INTENT(IN)::n
    REAL(KIND(1d0))::dAdA,dFdA,dFdF
    beta0=(11d0*CA-4d0*nfTF)/6d0
    IF(n.LE.0)RETURN
    beta1=(17d0*CA**2-nfTF*(6d0*CF+10d0*CA))/6d0
    IF(n.LE.1)RETURN
    beta2=(2857d0*CA**3-nfTF*(2830d0*CA**2+1230d0*CA*CF-108d0*CF**2)+&
         nfTF**2*(316d0*CA+264d0*CF))/432d0
    IF(n.LE.2)RETURN
    ! Eq.(8) in hep-ph/9701390
    beta3=(CA**4*(173448d0*zeta3+143993d0)+2592d0*CA**3*CF*(5d0-132d0*zeta3))&
         +nfTF*(-6d0*CA**3*(9432d0*zeta3+37799d0)+46d0*CA**2*CF*(2160d0*zeta3+7d0)&
                +72d0*CA*CF**2*(264d0*zeta3-1051d0)+22356d0*CF**3)&
         +nfTF**2*(12d0*CA**2*(4752d0*zeta3+2249d0)-64d0*CA*CF*(2862d0*zeta3-2021d0)&
                   +144d0*CF**2*(1464d0*zeta3-623d0))+16d0*nfTF**3*(53d0*CA+154d0*CF)
    beta3=beta3/7776d0
    IF(n.LE.3)RETURN
    ! Eq.(2.14) in arXiv:1701.01404
    dAdA=-3D0*CA**3*CF+37D0/24D0*CA**4
    dFdA=(CA**3*7D0/24D0+CA**2*CF*(-1D0/2D0))/2D0
    dFdF=(CA**2*13D0/24D0+CA*CF*(-5D0/2D0)+CF**2*3D0)/4D0
    ! Eq.(3.5) in arXiv:1701.01404
    beta4=CA**5*(8296235D0/3888D0-1630D0/81D0*zeta3+121D0/6D0*zeta4-1045D0/9D0*zeta5)&
         +CA*dAdA*(-514D0/3D0+18716D0/3D0*zeta3-968D0*zeta4-15400D0/3D0*zeta5)&
         +CA**4*nfTF*(-5048959D0/972D0+10505D0/81D0*zeta3-583D0/3D0*zeta4+1230D0*zeta5)&
         +CA**3*CF*nfTF*(8141995D0/1944D0+146D0*zeta3+902D0/3D0*zeta4-8720D0/3D0*zeta5)&
         +CA**2*CF**2*nfTF*(-548732D0/81D0-50581D0/27D0*zeta3-484D0/3D0*zeta4+12820D0/3D0*zeta5)&
         +CA*CF**3*nfTF*(3717D0+5696D0/3D0*zeta3-7480D0/3D0*zeta5)&
         -CF**4*nfTF*(4157D0/6D0+128D0*zeta3)&
         +dAdA*nfTF*(904D0/9D0-20752D0/9D0*zeta3+352D0*zeta4+4000D0/9D0*zeta5)&
         +2D0*dFdA*CA*nfTF*(11312D0/9D0-127736D0/9D0*zeta3+2288D0*zeta4+67520D0/9D0*zeta5)&
         +2D0*dFdA*CF*nfTF*(-320D0+1280D0/3D0*zeta3+6400D0/3D0*zeta5)&
         +CA**3*nfTF**2*(843067D0/486D0+18446D0/27D0*zeta3-104D0/3D0*zeta4-2200D0/3D0*zeta5)&
         +CA**2*CF*nfTF**2*(5701D0/162D0+26452D0/27D0*zeta3-944D0/3D0*zeta4+1600D0/3D0*zeta5)&
         +CF**2*CA*nfTF**2*(31583D0/18D0-28628D0/27D0*zeta3+1144D0/3D0*zeta4-4400D0/3D0*zeta5)&
         +CF**3*nfTF**2*(-5018D0/9D0-2144D0/3D0*zeta3+4640D0/3D0*zeta5)&
         +2D0*dFdA*nfTF**2*(-3680D0/9D0+40160D0/9D0*zeta3-832D0*zeta4-1280D0/9D0*zeta5)&
         +4D0*dFdF*CA*nfTF**2*(-7184D0/3D0+40336D0/9D0*zeta3-704D0*zeta4+2240D0/9D0*zeta5)&
         +4D0*dFdF*CF*nfTF**2*(4160D0/3D0+5120D0/3D0*zeta3-12800D0/3D0*zeta5)&
         +CA**2*nfTF**3*(-2077D0/27D0-9736D0/81D0*zeta3+112D0/3D0*zeta4+320D0/9D0*zeta5)&
         +CA*CF*nfTF**3*(-736D0/81D0-5680D0/27D0*zeta3+224D0/3D0*zeta4)&
         +CF**2*nfTF**3*(-9922D0/81D0+7616D0/27D0*zeta3-352D0/3D0*zeta4)&
         +4D0*dFdF*nfTF**3*(3520D0/9D0-2624D0/3D0*zeta3+256D0*zeta4+1280D0/3D0*zeta5)&
         +CA*nfTF**4*(916D0/243D0-640D0/81D0*zeta3)&
         -CF*nfTF**4*(856D0/243D0+128D0/27D0*zeta3)
    beta4=beta4/32D0
    IF(n.LE.4)RETURN
    WRITE(*,*)"ERROR: beta function is only available with n<=4"
    STOP
    RETURN
  END SUBROUTINE SET_QCD_BETA

  FUNCTION Pgg0(z)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z
    REAL(KIND(1d0))::Pgg0
    Pgg0=TWO*CA*(z/(one-z)+(one-z)/z+z*(one-z))
    RETURN
  END FUNCTION Pgg0

  FUNCTION Pgg1(z)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z
    REAL(KIND(1d0))::Pgg1
    Pgg1=zero
    RETURN
  END FUNCTION Pgg1

  FUNCTION Pqg0(z)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z
    REAL(KIND(1d0))::Pqg0
    Pqg0=TF*(z**2+(one-z)**2)
    RETURN
  END FUNCTION Pqg0

  FUNCTION Pqg1(z)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z
    REAL(KIND(1d0))::Pqg1
    Pqg1=-z*(one-z)
    RETURN
  END FUNCTION Pqg1

  FUNCTION Pgq0(z)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z
    REAL(KIND(1d0))::Pgq0
    Pgq0=CF*(one+(one-z)**2)/z
    RETURN
  END FUNCTION Pgq0

  FUNCTION Pgq1(z)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z
    REAL(KIND(1d0))::Pgq1
    Pgq1=-CF*z
    RETURN
  END FUNCTION Pgq1

  FUNCTION Pqq0(z)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z
    REAL(KIND(1d0))::Pqq0
    Pqq0=CF*(one+z**2)/(one-z)
    RETURN
  END FUNCTION Pqq0

  FUNCTION Pqq1(z)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z
    REAL(KIND(1d0))::Pqq1
    Pqq1=-CF*(one-z)
    RETURN
  END FUNCTION Pqq1

  ! these are the coefficients in front of the Dirac Delta function
  ! for the regularised LO splitting functions
  ! we have also used 1/(1-z)_+ to 1/((1-z)z)_z0+*z+Log[(1-z0)/z0]*DiracDelta[1-z]
  FUNCTION Pgg0_delta(z0)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z0
    REAL(KIND(1d0))::Pgg0_delta
    Pgg0_delta=beta0+two*ca*DLOG((one-z0)/z0)
    RETURN
  END FUNCTION Pgg0_delta

  FUNCTION Pqq0_delta(z0)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::z0
    REAL(KIND(1d0))::Pqq0_delta
    Pqq0_delta=three/two*cf+two*cf*DLOG((one-z0)/z0)
    RETURN
  END FUNCTION Pqq0_delta
END MODULE pp_oniumjet_NLO
