MODULE pp_oniumjet_NLO_Global
  IMPLICIT NONE
  ! number of external legs in real with onium breaking into heavy quarks
  INTEGER,PARAMETER::NEXTERNAL=6
  ! parameters
  REAL(KIND(1d0))::MC,MC2,MC3,MC4,MUR,MUR4aS
  REAL(KIND(1E0_16))::MP_MC,MP_MC2,MP_MC3,MP_MC4,MP_MUR
  ! LDMEetaQ_MQ is the LDME at onium_muNRQCD0=MQ
  ! LDMEetaQ is the LDME at muNRQCD=onium_muNRQCD
  ! LDMEetaQ_up and LDMEetaQ_down is for the up/down value of LDMEetaQ at muNRQCD=onium_muNRQCD*rw_muNRQCD_up/down
  REAL(KIND(1d0))::MetaQ,onium_muNRQCD,onium_muNRQCD0
  REAL(KIND(1d0))::LDMEetaQ_MQ,LDMEetaQ,LDMEetaQ_up,LDMEetaQ_down
  REAL(KIND(1d0))::LDME1S01=0.386667D0
  REAL(KIND(1E0_16))::MP_LDME1S01=0.386667E0_16
  ! Just eta_c or eta_b
  INTEGER::onium_state=1
  ! number of light quarks
  INTEGER::nlq=3
  REAL(KIND(1d0))::rnlq=3d0
  REAL(KIND(1E0_16))::mp_rnlq=3e0_16
  ! momenta of external legs
  !REAL(KIND(1d0)),DIMENSION(nexternal  ,4)::onium_pmom
  !REAL(KIND(1d0)),DIMENSION(nexternal  ,4)::onium_pmom_realA
  !REAL(KIND(1d0)),DIMENSION(nexternal  ,4)::onium_pmom_realB
  REAL(KIND(1d0)),DIMENSION(nexternal-1,4)::onium_pmom_born
  REAL(KIND(1d0)),DIMENSION(nexternal-2,4)::onium_pmom_born_hadron
  REAL(KIND(1d0)),DIMENSION(0:3,nexternal-1)::ponium_born
  REAL(KIND(1E0_16)),DIMENSION(0:3,nexternal-1)::mp_ponium_born
  !REAL(KIND(1d0)),DIMENSION(nexternal-1,4)::onium_pmom_realA_hadron
  !REAL(KIND(1d0)),DIMENSION(nexternal-1,4)::onium_pmom_realB_hadron
  ! as values
  REAL(KIND(1d0))::as_real,as_born,as_MQ,as_muNRQCD,as_muNRQCD_up,as_muNRQCD_down
  ! G=Gstrong
  REAL(KIND(1d0))::G
  REAL(KIND(1E0_16))::MP_G
  ! scale reweight stuff
  REAL(KIND(1d0)),DIMENSION(3)::rw_Rscales,rw_Fscales,rw_Mscales
  ! xa,xb
  REAL(KIND(1d0))::xp1_realA,xp2_realA,xp1_realB,xp2_realB,xp1_born,xp2_born
  ! order of alpha_s at Born
  INTEGER::bpower=3
  ! two cutoff slicing parameters
  REAL(KIND(1d0))::delta_s,delta_c
  ! 1-delta_s, Log(1-delta_s)
  REAL(KIND(1d0))::onemds,logonemds
  ! Log[delta_s]=Log[1e-5]
  ! Log[delta_c]=Log[1e-3]
  REAL(KIND(1d0))::logds,logdc
  ! Log[delta_s/(1-delta_s)]
  REAL(KIND(1d0))::logdso1ds
  ! stability test for loops
  LOGICAL::stability_check=.FALSE.
  LOGICAL::quadrupole_precision=.FALSE.
  REAL(KIND(1d0)),PARAMETER::mass_rescaling=100d0
  REAL(KIND(1E0_16)),PARAMETER::mp_mass_rescaling=100e0_16
  REAL(KIND(1d0))::stable_threshold=1d-2
  REAL(KIND(1d0))::stable_unbounded=1d6
  REAL(KIND(1d0))::stable_rsmax=6400d0
  INTEGER,PARAMETER::MAX_WRITE_UPS=100
  INTEGER::unstable_ps=0,total_ps=0
  REAL(KIND(1d0)),PARAMETER::untolerence_factor=10d0
  INTEGER,PARAMETER::starting_untolerence=50000
  ! Constants
  REAL(KIND(1d0)),PARAMETER::ZERO=0d0,ONE=1d0,TWO=2d0,THREE=3d0,FOUR=4d0,HALF=0.5d0
  COMPLEX(KIND(1d0)),PARAMETER::ipi2=(0d0,9.8696044010893586188344909998761511353136994d0)
  REAL(KIND(1d0)),PARAMETER::TWOPI=6.283185307179586476925286766559005768394d0
  REAL(KIND(1d0)),PARAMETER::TWOPI2=39.47841760435743447533796399950460454125d0
  REAL(KIND(1d0)),PARAMETER::PI=3.141592653589793238462643383279502884197d0
  REAL(KIND(1d0)),PARAMETER::PI2=9.8696044010893586188344909998761511353136994d0
  REAL(KIND(1d0)),PARAMETER::PI4=97.40909103400243723644033268870511124972758567d0
  REAL(KIND(1d0)),PARAMETER::eg=0.577215664901532860606512090082402431042d0
  REAL(KIND(1d0)),PARAMETER::logtwo=0.693147180559945309417232121458176568076d0
  REAL(KIND(1d0)),PARAMETER:: ZETA2 = 1.644934066848226436472415166646025189219d0
  REAL(KIND(1d0)),PARAMETER:: ZETA3 = 1.202056903159594285399738161511449990765d0
  REAL(KIND(1d0)),PARAMETER:: ZETA4 = 1.082323233711138191516003696541167902775d0
  REAL(KIND(1d0)),PARAMETER:: ZETA5 = 1.036927755143369926331365486457034168057d0
  REAL(KIND(1d0)),PARAMETER:: ZETA6 = 1.017343061984449139714517929790920527902d0
  REAL(KIND(1E0_16)),PARAMETER::MP_ZERO=0E0_16,MP_ONE=1E0_16,MP_TWO=2E0_16,MP_THREE=3E0_16
  REAL(KIND(1E0_16)),PARAMETER::MP_FOUR=4E0_16,MP_HALF=0.5E0_16
  COMPLEX(KIND(1E0_16)),PARAMETER::MP_ipi2=CMPLX(0E0_16,9.8696044010893586188344909998761511353136994E0_16,KIND=16)
  REAL(KIND(1E0_16)),PARAMETER::MP_PI=3.141592653589793238462643383279502884197E0_16
  REAL(KIND(1E0_16)),PARAMETER::MP_PI2=9.8696044010893586188344909998761511353136994E0_16
  REAL(KIND(1E0_16)),PARAMETER::MP_PI4=97.40909103400243723644033268870511124972758567E0_16
  REAL(KIND(1E0_16)),PARAMETER::MP_logtwo=0.69314718055994530941723212145817656807550013436025525412E0_16
  ! constants in QCD
  ! default values
  INTEGER, PARAMETER:: nf_default = 5
  REAL(KIND(1d0)),PARAMETER:: CA=3d0
  REAL(KIND(1d0)),PARAMETER:: CF=4d0/3d0
  REAL(KIND(1d0)),PARAMETER:: TF=0.5d0
  REAL(KIND(1d0)),PARAMETER:: nfTF_default = nf_default*TF
  ! the used value
  REAL(KIND(1d0)):: nfTF = nfTF_default
  
  INTEGER:: nf = nf_default
  INTEGER:: nf_up = nf_default/2
  INTEGER:: nf_down = (nf_default+1)/2
  REAL(KIND(1d0)):: rnf = DBLE(nf_default)

  ! beta functions in terms of as/2/pi expansion
  ! should be evaluated by routine GET_QCD_BETA
  REAL(KIND(1d0)):: beta0, beta1, beta2, beta3, beta4

  ! Improve Phase space point in quadruple precision
  ! otherwise, quadruple precision is pointless
  ! 1 :: This methods imitates what is done in PSMC, namely
  !      a) Set the space-like momentum of the last external particle to be the
  !         opposite of the sum of the others (with a minus sign for the initial states).
  !      b) Rescale all final state space-like momenta by a fixed value x computed such
  !         that energy is conserved when particles are put exactly onshell. This value
  !         is determined numericaly via Ralph-Newton's method.
  !      c) Set all energies to have particles exactly onshell.
  ! 2 :: This method applies a shift to the energy and the x and y components of the first
  !      initial state momentum in order to restore exact energy momentum conservation after
  !      particles have been put exactly onshell via a shift of the z component of their
  !      momenta.
  INTEGER::ImprovePSPoint=2
  LOGICAL::force_update_mp_phasespace=.FALSE.
  ! calculation type
  ! 0: Sum; 1: Born; 2: Virtual; 3: Soft; 4: Collinear
  INTEGER::calculation_type=0
END MODULE pp_oniumjet_NLO_Global
