MODULE pp_oniumjet_NLO_setscale
  IMPLICIT NONE
CONTAINS
  SUBROUTINE oniumjet_scale(scale0)
    USE Helac_Global
    USE pp_oniumjet_NLO_Global
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(OUT)::scale0
    REAL(KIND(1d0))::px,py,ptw2,mas
    INTEGER::ij
    SELECT CASE(nscheme)
    CASE(0)
       scale0=fschemevalue
    CASE(1,2)
       ptw2=onium_pmom_born_hadron(3,1)**2+onium_pmom_born_hadron(3,2)**2
       scale0=DSQRT(MetaQ**2+ptw2)
    CASE(4,5)
       ! HT/2
       ptw2=onium_pmom_born_hadron(3,1)**2+onium_pmom_born_hadron(3,2)**2
       scale0=DSQRT(MetaQ**2+ptw2)
       ptw2=DSQRT(onium_pmom_born_hadron(4,1)**2+onium_pmom_born_hadron(4,2)**2)
       scale0=scale0+ptw2
       scale0=scale0/2d0
    CASE DEFAULT
       WRITE(*,*)"ERROR: Do not understand the scale scheme=",nscheme
       STOP
    END SELECT
    scale0=MAX(scale0,1d0)
    scale0=scale0*scalefactor
    RETURN
  END SUBROUTINE Oniumjet_scale
END MODULE pp_oniumjet_NLO_setscale
