HODIR=
FC=
objdir=$(HODIR)/addon/pp_oniumjet_NLO/obj/
moddir=$(HODIR)/addon/pp_oniumjet_NLO/mod/
srcdir=$(HODIR)/src/
thissrcdir=$(HODIR)/addon/pp_oniumjet_NLO/src/
decaydir=$(HODIR)/decay/
nucdir=$(HODIR)/nuclear/
fundir=$(HODIR)/specialfuns/
libdir=$(HODIR)/lib/
showerdir=$(HODIR)/shower/interface/
lhapdfobj=
AVHDIR=$(HODIR)/vendor/oneloop
MPMODDIR=$(HODIR)/vendor/mpfun90
# uncomment the following line to use gdb to debug
FFLAGS=-ggdb -g -fbounds-check -ffpe-trap=invalid,zero,overflow,underflow,denormal -Wall -I$(AVHDIR) -I$(MPMODDIR)
# FFLAGS=-I$(AVHDIR) -I$(MPMODDIR)
AVHLIBS=-L$(AVHDIR) -lavh_olo -L$(MPMODDIR) -lmpfun90
obj=$(objdir)Helac_Global.o $(objdir)use_func.o $(objdir)Func_PSI_2.o $(objdir)mp_virtual.o $(objdir)virtual.o $(objdir)mp_loopbasis.o $(objdir)loopbasis.o $(objdir)softme.o $(objdir)born.o $(objdir)collinearme.o $(objdir)Helac_Func_1.o  $(objdir)Constants.o $(objdir)CTEQ6PDF.o $(objdir)Kinetic_Func.o $(objdir)Structf_PDFs.o $(objdir)photon_PDFs.o $(objdir)MC_VEGAS.o $(lhapdfobj) $(objdir)plot_pp_oniumjet_NLO.o $(objdir)pp_oniumjet_NLO.o $(objdir)alfas_functions.o $(objdir)pp_oniumjet_NLO_Global.o $(objdir)Main_pp_oniumjet_NLO.o $(objdir)pp_oniumjet_NLO_setscale.o $(objdir)setscale.o $(objdir)tbessk.o $(objdir)tbessj.o $(objdir)nielsen_generalized_polylog.o $(objdir)nintlib.o $(objdir)interpolation.o $(objdir)OpticalGlauber_Geometry.o $(objdir)ElasticPhotonPhotonFlux.o
mod = $(moddir)*.mod
exe = $(HODIR)/bin/HO_pp_oniumjet_NLO
linkexe = $(HODIR)/addon/pp_oniumjet_NLO/bin/HO_pp_oniumjet_NLO
EXLIBS = 

ifneq ("$(wildcard $(HODIR)/vendor/oneloop/libavh_olo.a)","")
      makeoneloop =
else
      makeoneloop = makefile_oneloop
endif

all :   clean $(exe)
	ln -s $(exe) $(linkexe)

$(exe): $(makeoneloop) $(obj)
	@cp *.o $(objdir)
	@cp *.mod $(moddir)
	@rm *.o *.mod
	$(FC) -o $(exe) $(obj) -L$(libdir) -lpdf -lhbook $(EXLIBS) $(AVHLIBS)

$(objdir)mp_virtual.o : $(thissrcdir)mp_virtual.f $(moddir)Func_PSI_2.mod $(moddir)pp_oniumjet_NLO_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)virtual.o : $(thissrcdir)virtual.f $(moddir)Func_PSI_2.mod $(moddir)pp_oniumjet_NLO_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)softme.o : $(thissrcdir)softme.f $(moddir)Func_PSI_2.mod $(moddir)pp_oniumjet_NLO_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)born.o : $(thissrcdir)born.f $(moddir)Func_PSI_2.mod $(moddir)pp_oniumjet_NLO_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)collinearme.o : $(thissrcdir)collinearme.f $(moddir)Func_PSI_2.mod $(moddir)pp_oniumjet_NLO_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)loopbasis.o : $(thissrcdir)loopbasis.f $(moddir)pp_oniumjet_NLO_Global.mod $(AVHDIR)/avh_olo.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)mp_loopbasis.o : $(thissrcdir)mp_loopbasis.f $(moddir)pp_oniumjet_NLO_Global.mod $(AVHDIR)/avh_olo.mod
	$(FC) -c $< $(FFLAGS)

.F.o:
	$(FC) $(FFLAGS) -c $*.F

.f.o:
	$(FC) $(FFLAGS) -c $*.f

$(objdir)Main_pp_oniumjet_NLO.o : $(thissrcdir)Main_pp_oniumjet_NLO.f90 $(moddir)pp_oniumjet_NLO.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)pp_oniumjet_NLO_Global.o $(moddir)pp_oniumjet_NLO_Global.mod: $(thissrcdir)pp_oniumjet_NLO_Global.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Helac_Global.o $(moddir)Helac_Global.mod : $(srcdir)Helac_Global.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Func_PSI_2.o $(moddir)Func_PSI_2.mod : $(thissrcdir)Func_PSI_2.f90 $(moddir)use_func.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)use_func.o $(moddir)use_func.mod : $(thissrcdir)use_func.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Helac_Func_1.o $(moddir)Helac_Func_1.mod : $(srcdir)Helac_Func_1.f90 $(moddir)Helac_Global.mod $(moddir)alfas_functions.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Constants.o $(moddir)Constants.mod: $(srcdir)Constants.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_PDFs.o $(moddir)Structf_PDFs.mod:$(srcdir)Structf_PDFs.f90 $(moddir)Helac_Global.mod $(moddir)CTEQ6PDF.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod $(moddir)ElasticPhotonPhotonFlux.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)ElasticPhotonPhotonFlux.o $(moddir)ElasticPhotonPhotonFlux.mod:$(nucdir)ElasticPhotonPhotonFlux.f90 $(moddir)OpticalGlauber_Geometry.mod $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)nintlib.o $(moddir)nintlib.mod: $(nucdir)nintlib.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)tbessk.o : $(fundir)tbessk.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)tbessj.o : $(fundir)tbessj.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)nielsen_generalized_polylog.o $(moddir)nielsen_generalized_polylog.mod : $(fundir)nielsen_generalized_polylog.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)OpticalGlauber_Geometry.o $(moddir)OpticalGlauber_Geometry.mod: $(nucdir)OpticalGlauber_Geometry.f90 $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)nielsen_generalized_polylog.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)interpolation.o $(moddir)interpolation.mod: $(nucdir)interpolation.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)CTEQ6PDF.o $(moddir)CTEQ6PDF.mod: $(srcdir)CTEQ6PDF.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Kinetic_Func.o $(moddir)Kinetic_Func.mod: $(srcdir)Kinetic_Func.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)MC_VEGAS.o $(moddir)MC_VEGAS.mod: $(srcdir)MC_VEGAS.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)alfas_functions.o $(moddir)alfas_functions.mod: $(srcdir)alfas_functions.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)pp_oniumjet_NLO_setscale.o $(moddir)pp_oniumjet_NLO_setscale.mod: $(thissrcdir)pp_oniumjet_NLO_setscale.f90 $(moddir)Helac_Global.mod $(moddir)pp_oniumjet_NLO_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)plot_pp_oniumjet_NLO.o $(moddir)plot_pp_oniumjet_NLO.mod : $(thissrcdir)plot_pp_oniumjet_NLO.f90 $(moddir)Helac_Global.mod $(moddir)Kinetic_Func.mod $(moddir)MC_VEGAS.mod $(moddir)pp_oniumjet_NLO_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)pp_oniumjet_NLO.o $(moddir)pp_oniumjet_NLO.mod : $(thissrcdir)pp_oniumjet_NLO.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod $(moddir)Kinetic_Func.mod $(moddir)MC_VEGAS.mod $(moddir)Constants.mod $(moddir)plot_pp_oniumjet_NLO.mod $(moddir)CTEQ6PDF.mod $(moddir)pp_oniumjet_NLO_setscale.mod $(moddir)Structf_PDFs.mod $(moddir)pp_oniumjet_NLO_Global.mod $(moddir)Func_PSI_2.mod $(MPMODDIR)/mpmodule.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)pp_oniumjet_NLO_LHAPDFs.o : $(thissrcdir)pp_oniumjet_NLO_LHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)pp_oniumjet_NLO_Global.mod $(moddir)pp_oniumjet_NLO_setscale.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)pp_oniumjet_NLO_MLHAPDFs.o : $(thissrcdir)pp_oniumjet_NLO_MLHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)pp_oniumjet_NLO_Global.mod $(moddir)pp_oniumjet_NLO_setscale.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_LHAPDFs.o : $(srcdir)Structf_LHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)photon_PDFs.o $(moddir)photon_PDFs.mod : $(srcdir)photon_PDFs.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_LHAnPDFs.o : $(srcdir)Structf_LHAnPDFs.f90
	$(FC) -c $< $(FFLAGS)
$(objdir)Structf_MLHAPDFs.o : $(srcdir)Structf_MLHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod
	$(FC) -c $< $(FFLAGS)
$(objdir)setscale.o $(moddir)setscale.mod: $(srcdir)setscale.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

makefile_oneloop:
	(cd $(HODIR)/vendor/mpfun90; make clean; make; cd $(HODIR)/vendor/oneloop ; bash clean.sh ; python create.py)

clean:
	rm -rf $(obj) $(mod) $(exe) $(linkexe) $(HODIR)/tmp/* *~ $(HODIR)/input/*~ $(HODIR)/src/*~ $(thissrcdir)*~ $(HODIR)/output/* fort.*
end
