  SUBROUTINE reweight_xsec_pdf_cb(wsf0)
    IMPLICIT NONE
    INTEGER::init=0,i,k,kk
    REAL(KIND(1d0)),INTENT(IN)::wsf0
    REAL(KIND(1d0))::wsfw
    SAVE init
    LOGICAL::lexist
    IF(.NOT.reweight_pdf)THEN
       WRITE(*,*)"ERROR:Please set reweight_pdf to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(MOD(ho_npdf,2).NE.0)THEN
          WRITE(*,*)'The number of error sets must be even',ho_npdf
          STOP
       ENDIF
       IF(MOD(ho_npdf2,2).NE.0)THEN
          WRITE(*,*)'The number of error sets for beam 2 must be even',ho_npdf2
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecpdf))THEN
          DEALLOCATE(wgtxsecpdf)
       ENDIF
       IF(PDF_Hessian2MC.AND.Way_Hessian2MC.EQ.1)THEN
          ALLOCATE(wgtxsecpdf(N_MCPDFs))
          IF(ALLOCATED(PDF_Rki))THEN
             DEALLOCATE(PDF_Rki)
          ENDIF
          ALLOCATE(PDF_Rki(N_MCPDFs,ho_npdf/2))
          IF(ALLOCATED(Hessian_PDFs))THEN
             DEALLOCATE(Hessian_PDFs)
          ENDIF
          ALLOCATE(Hessian_PDFs(2,-5:5,0:ho_npdf))
          IF(ALLOCATED(MC_PDFs))THEN
             DEALLOCATE(MC_PDFs)
          ENDIF
          ALLOCATE(MC_PDFs(2,-5:5,N_MCPDFs))
          INQUIRE(FILE=TRIM(input_dir)//"PDF_Rki.dat",EXIST=lexist)
          IF(.NOT.lexist)THEN
             OPEN(UNIT=307654,FILE=TRIM(input_dir)//"PDF_Rki.dat",STATUS="NEW")
             WRITE(307654,*)N_MCPDFs,ho_npdf/2
             DO k=1,N_MCPDFs
                DO i=1,ho_npdf/2
                   PDF_Rki(k,i)=NormalRandom()
                ENDDO
                WRITE(307654,*)(PDF_Rki(k,i),i=1,ho_npdf/2)
             ENDDO
             CLOSE(UNIT=307654,STATUS="KEEP")
          ELSE
             OPEN(UNIT=307654,FILE=TRIM(input_dir)//"PDF_Rki.dat",STATUS="OLD",ACTION='READ')
             READ(307654,*)k,i
             IF(k.EQ.N_MCPDFs.AND.i.EQ.(ho_npdf/2))THEN
                ! read it from the file
                DO k=1,N_MCPDFs
                   READ(307654,*)(PDF_Rki(k,i),i=1,ho_npdf/2)
                ENDDO
                CLOSE(UNIT=307654)
             ELSE
                ! one should regenerate the file
                CLOSE(UNIT=307654)
                OPEN(UNIT=307654,FILE=TRIM(input_dir)//"PDF_Rki.dat",STATUS="REPLACE")
                WRITE(307654,*)N_MCPDFs,ho_npdf/2
                DO k=1,N_MCPDFs
                   DO i=1,ho_npdf/2
                      PDF_Rki(k,i)=NormalRandom()
                   ENDDO
                   WRITE(307654,*)(PDF_Rki(k,i),i=1,ho_npdf/2)
                ENDDO
                CLOSE(UNIT=307654,STATUS="KEEP")
             ENDIF
          ENDIF
       ELSE
          ALLOCATE(wgtxsecpdf(ho_npdf+ho_npdf2))
       ENDIF
       IF(ho_npdf.GT.0)THEN
          IF(ALLOCATED(idpdf))THEN
             DEALLOCATE(idpdf)
          ENDIF
          ALLOCATE(idpdf(0:ho_npdf))
          idpdf(0)=iPDFSUP1
          idpdf(1)=ipdf_set_min
          IF(ipdf_set_max-ipdf_set_min+1.NE.ho_npdf)THEN
             WRITE(*,*)'Incorrect the number of error pdf',ho_npdf,ipdf_set_min,ipdf_set_max
             STOP
          ENDIF
          DO i=2,ho_npdf
             idpdf(i)=idpdf(1)+i-1
          ENDDO
          WRITE(*,*) 'Doing PDF reweight:'
          WRITE(*,*) 'Central set id: ',idpdf(0)
          WRITE(*,*) 'Min error set id: ',idpdf(1)
          WRITE(*,*) 'Max error set id: ',idpdf(ho_npdf)
       ENDIF
       IF(ho_npdf2.GT.0)THEN
          IF(ALLOCATED(idpdf2))THEN
             DEALLOCATE(idpdf2)
          ENDIF
          ALLOCATE(idpdf2(0:ho_npdf2))
          idpdf2(0)=iPDFSUP2
          idpdf2(1)=ipdf2_set_min
          IF(ipdf2_set_max-ipdf2_set_min+1.NE.ho_npdf2)THEN
             WRITE(*,*)'Incorrect the number of error pdf2',ho_npdf2,ipdf2_set_min,ipdf2_set_max
             STOP
          ENDIF
          DO i=2,ho_npdf2
             idpdf2(i)=idpdf2(1)+i-1
          ENDDO
          WRITE(*,*) 'Doing PDF Beam 2 reweight:'
          WRITE(*,*) 'Central set id: ',idpdf2(0)
          WRITE(*,*) 'Min error set id: ',idpdf2(1)
          WRITE(*,*) 'Max error set id: ',idpdf2(ho_npdf2)
        ENDIF
       init=1
    ENDIF
    IF(PDF_Hessian2MC.AND.Way_Hessian2MC.EQ.1)THEN
       ! Save all the Hessian PDFs
       SAVE_HessianPDFs_ONLY=.TRUE.
       DO i=0,ho_npdf
          INCLUDE "../../../input/lhapdf/call_initpdf"
          SAVE_HessianPDF_Index=i
          CALL strf_pdf_pp_psiX_cb(wsfw)
          SAVE_HessianPDF_Index=-1
       ENDDO
       SAVE_HessianPDFs_ONLY=.FALSE.
       ! generate MC PDFs from Hessian PDFs
       DO i=1,N_MCPDFs
          DO k=-5,5
             MC_PDFs(1,k,i)=Hessian_PDFs(1,k,0)
             MC_PDFs(2,k,i)=Hessian_PDFs(2,k,0)
             DO kk=1,ho_npdf/2
                MC_PDFs(1,k,i)=MC_PDFs(1,k,i)+(Hessian_PDFs(1,k,2*kk-1)&
                     -Hessian_PDFs(1,k,2*kk))/2d0*PDF_Rki(i,kk)
                MC_PDFs(2,k,i)=MC_PDFs(2,k,i)+(Hessian_PDFs(2,k,2*kk-1)&
                     -Hessian_PDFs(2,k,2*kk))/2d0*PDF_Rki(i,kk)
             ENDDO
          ENDDO
       ENDDO
       ! get the reweighting factors with the generated MC PDFs
       REPLACE_HessianByMC=.TRUE.
       DO i=1,N_MCPDFs
          Use_MCPDF_Index=i
          CALL strf_pdf_pp_psiX_cb(wsfw)
          Use_MCPDF_Index=-1
          wgtxsecpdf(i)=wsfw/wsf0
       ENDDO
       REPLACE_HessianByMC=.FALSE.
    ELSE
       IF(.NOT.multipdfloading)THEN             
          DO i=1,ho_npdf
             INCLUDE "../../../input/lhapdf/call_initpdf"
             CALL strf_pdf_pp_psiX_cb(wsfw)
             wgtxsecpdf(i)=wsfw/wsf0
          ENDDO
       ELSE
          IF(.NOT.beams_pdf_correlation)THEN
             DO i=1,ho_npdf
                INCLUDE "../../../input/lhapdf/call_initmpdf1"
                CALL strf_pdf_pp_psiX_cb(wsfw)
                wgtxsecpdf(i)=wsfw/wsf0
             ENDDO
             INCLUDE "../../../input/lhapdf/call_initmpdf10"
             DO i=1,ho_npdf2
                INCLUDE "../../../input/lhapdf/call_initmpdf2"
                CALL strf_pdf_pp_psiX_cb(wsfw)
                wgtxsecpdf(i+ho_npdf)=wsfw/wsf0
             ENDDO
             INCLUDE "../../../input/lhapdf/call_initmpdf20"
          ELSE
             ! it is correlated for two beams
             DO i=1,ho_npdf
                INCLUDE "../../../input/lhapdf/call_initmpdf1"
                INCLUDE "../../../input/lhapdf/call_initmpdf2"
                CALL strf_pdf_pp_psiX_cb(wsfw)
                wgtxsecpdf(i)=wsfw/wsf0
             ENDDO
             INCLUDE "../../../input/lhapdf/call_initmpdf10"
             INCLUDE "../../../input/lhapdf/call_initmpdf20"
          ENDIF
          RETURN
       ENDIF 
    ENDIF
    ! recover it
    INCLUDE "../../../input/lhapdf/call_initpdf0"
    RETURN
  END SUBROUTINE reweight_xsec_pdf_cb

  SUBROUTINE reweight_xsec_npdf_cb(wsf0)
    IMPLICIT NONE
    INTEGER::init=0,i,k,kk
    INTEGER,DIMENSION(2)::icase
    REAL(KIND(1d0)),INTENT(IN)::wsf0
    REAL(KIND(1d0))::wsfw
    SAVE init
    INTEGER::icheck=0
    SAVE icheck
    LOGICAL::lexist
    IF(.NOT.reweight_npdf)THEN
       WRITE(*,*)"ERROR:Please set reweight_npdf to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(MOD(ho_nnpdf,2).NE.0)THEN
          WRITE(*,*)'The number of error sets must be even',ho_nnpdf
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecnpdf))THEN
          DEALLOCATE(wgtxsecnpdf)
       ENDIF
       IF(PDF_Hessian2MC.AND.Way_Hessian2MC.EQ.1)THEN
          ALLOCATE(wgtxsecnpdf(N_MCPDFs))
          IF(ALLOCATED(PDF_Rki))THEN
             DEALLOCATE(PDF_Rki)
          ENDIF
          ALLOCATE(PDF_Rki(N_MCPDFs,ho_nnpdf/2))
          IF(ALLOCATED(Hessian_PDFs))THEN
             DEALLOCATE(Hessian_PDFs)
          ENDIF
          ALLOCATE(Hessian_PDFs(2,-5:5,0:ho_nnpdf))
          IF(ALLOCATED(MC_PDFs))THEN
             DEALLOCATE(MC_PDFs)
          ENDIF
          ALLOCATE(MC_PDFs(2,-5:5,N_MCPDFs))
          INQUIRE(FILE=TRIM(input_dir)//"PDF_Rki.dat",EXIST=lexist)
          IF(.NOT.lexist)THEN
             OPEN(UNIT=307654,FILE=TRIM(input_dir)//"PDF_Rki.dat",STATUS="NEW")
             WRITE(307654,*)N_MCPDFs,ho_nnpdf/2
             DO k=1,N_MCPDFs
                DO i=1,ho_nnpdf/2
                   PDF_Rki(k,i)=NormalRandom()
                ENDDO
                WRITE(307654,*)(PDF_Rki(k,i),i=1,ho_nnpdf/2)
             ENDDO
             CLOSE(UNIT=307654,STATUS="KEEP")
          ELSE
             OPEN(UNIT=307654,FILE=TRIM(input_dir)//"PDF_Rki.dat",STATUS="OLD",ACTION='READ')
             READ(307654,*)k,i
             IF(k.EQ.N_MCPDFs.AND.i.EQ.(ho_nnpdf/2))THEN
                ! read it from the file
                DO k=1,N_MCPDFs
                   READ(307654,*)(PDF_Rki(k,i),i=1,ho_nnpdf/2)
                ENDDO
                CLOSE(UNIT=307654)
             ELSE
                ! one should regenerate the file
                CLOSE(UNIT=307654)
                OPEN(UNIT=307654,FILE=TRIM(input_dir)//"PDF_Rki.dat",STATUS="REPLACE")
                WRITE(307654,*)N_MCPDFs,ho_nnpdf/2
                DO k=1,N_MCPDFs
                   DO i=1,ho_nnpdf/2
                      PDF_Rki(k,i)=NormalRandom()
                   ENDDO
                   WRITE(307654,*)(PDF_Rki(k,i),i=1,ho_nnpdf/2)
                ENDDO
                CLOSE(UNIT=307654,STATUS="KEEP")
             ENDIF
          ENDIF
       ELSE
          ALLOCATE(wgtxsecnpdf(ho_nnpdf))
       ENDIF
       IF(ALLOCATED(idnpdf))THEN
          DEALLOCATE(idnpdf)
       ENDIF
       ALLOCATE(idnpdf(0:ho_nnpdf))
       IF(nPDF_id.NE.1000)THEN
          idnpdf(0)=nPDF_id
          idnpdf(1)=inpdf_set_min
       ELSE
          idnpdf(0)=iPDFSUP1
          idnpdf(1)=inpdf_set_min-1000+iPDFSUP1
       ENDIF
       IF(inpdf_set_max-inpdf_set_min+1.NE.ho_nnpdf)THEN
          WRITE(*,*)'Incorrect the number of error npdf',ho_nnpdf,inpdf_set_min,inpdf_set_max
          STOP
       ENDIF
       DO i=2,ho_nnpdf
          idnpdf(i)=idnpdf(1)+i-1
       ENDDO
       WRITE(*,*) 'Doing nPDF reweight:'
       WRITE(*,*) 'Central set id: ',idnpdf(0)
       WRITE(*,*) 'Min error set id: ',idnpdf(1)
       WRITE(*,*) 'Max error set id: ',idnpdf(ho_nnpdf)
       init=1
    ENDIF
    IF(PDF_Hessian2MC.AND.Way_Hessian2MC.EQ.1)THEN
       ! Save all the Hessian (n)PDFs
       SAVE_HessianPDFs_ONLY=.TRUE.
       DO i=0,ho_nnpdf
          use_neutron_rand=.TRUE.
          IF(i.EQ.0)THEN
             INCLUDE "../../../input/lhapdf/call_initnpdf"
             INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_0"
          ELSE
             INCLUDE "../../../input/lhapdf/call_initnpdfi"
             INCLUDE "../../../input/lhapdf/call_initnpdfi_lhapdf6"
          ENDIF
          SAVE_HessianPDF_Index=i
          CALL strf_pdf_pp_psiX_cb(wsfw)
          SAVE_HessianPDF_Index=-1
       ENDDO
       SAVE_HessianPDFs_ONLY=.FALSE.
       ! generate MC PDFs from Hessian PDFs 
       icase(1:2)=0
       IF(lnuclearPDF.AND.rnuclearA_beam1.NE.0d0)THEN
          icase(1)=1
       ELSEIF(icheck.LT.10)THEN
          DO kk=1,ho_nnpdf
             DO k=-5,5
                IF(DABS(Hessian_PDFs(1,k,0)-Hessian_PDFs(1,k,kk))&
                     /MAX(DABS(Hessian_PDFs(1,k,0)+Hessian_PDFs(1,k,kk))&
                     ,1D-99).GT.1D-6)THEN
                   WRITE(*,*)"ERROR: proton PDFs are not same !"
                   WRITE(*,*)"ERROR: (1,",k,",0)="
                   WRITE(*,*)"ERROR:",Hessian_PDFs(1,k,0)
                   WRITE(*,*)"ERROR: (1,",k,",",kk,")="
                   WRITE(*,*)"ERROR:",Hessian_PDFs(1,k,kk)
                   STOP
                ENDIF
             ENDDO
          ENDDO
          icheck=icheck+1
       ENDIF
       IF(lnuclearPDF.AND.rnuclearA_beam2.NE.0d0)THEN
          icase(2)=1
       ELSEIF(icheck.LT.10)THEN
          DO kk=1,ho_nnpdf
             DO k=-5,5
                IF(DABS(Hessian_PDFs(2,k,0)-Hessian_PDFs(2,k,kk))&
                     /MAX(DABS(Hessian_PDFs(2,k,0)+Hessian_PDFs(2,k,kk))&
                     ,1D-99).GT.1D-6)THEN
                   WRITE(*,*)"ERROR: proton PDFs are not same !"
                   WRITE(*,*)"ERROR: (2,",k,",0)="
                   WRITE(*,*)"ERROR:",Hessian_PDFs(2,k,0)
                   WRITE(*,*)"ERROR: (2,",k,",",kk,")="
                   WRITE(*,*)"ERROR:",Hessian_PDFs(2,k,kk)
                   STOP
                ENDIF
             ENDDO
          ENDDO
          icheck=icheck+1
       ENDIF
       DO i=1,N_MCPDFs
          DO k=-5,5
             MC_PDFs(1,k,i)=Hessian_PDFs(1,k,0)
             MC_PDFs(2,k,i)=Hessian_PDFs(2,k,0)
             DO kk=1,ho_nnpdf/2
                IF(icase(1).EQ.1)THEN
                   MC_PDFs(1,k,i)=MC_PDFs(1,k,i)+(Hessian_PDFs(1,k,2*kk-1)&
                        -Hessian_PDFs(1,k,2*kk))/2d0*PDF_Rki(i,kk)
                ENDIF
                IF(icase(2).EQ.1)THEN
                   MC_PDFs(2,k,i)=MC_PDFs(2,k,i)+(Hessian_PDFs(2,k,2*kk-1)&
                        -Hessian_PDFs(2,k,2*kk))/2d0*PDF_Rki(i,kk)
                ENDIF
             ENDDO
          ENDDO
       ENDDO
       ! get the reweighting factors with the generated MC PDFs
       REPLACE_HessianByMC=.TRUE.
       DO i=1,N_MCPDFs
          Use_MCPDF_Index=i
          CALL strf_pdf_pp_psiX_cb(wsfw)
          Use_MCPDF_Index=-1
          wgtxsecnpdf(i)=wsfw/wsf0
       ENDDO
       REPLACE_HessianByMC=.FALSE.
    ELSE
       DO i=1,ho_nnpdf
          use_neutron_rand=.TRUE.
          INCLUDE "../../../input/lhapdf/call_initnpdfi"
          INCLUDE "../../../input/lhapdf/call_initnpdfi_lhapdf6"
          CALL strf_pdf_pp_psiX_cb(wsfw)
          wgtxsecnpdf(i)=wsfw/wsf0
       ENDDO
    ENDIF
    ! recover it
    use_neutron_rand=.FALSE.
    INCLUDE "../../../input/lhapdf/call_initnpdf"
    INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_0"
    RETURN
  END SUBROUTINE reweight_xsec_npdf_cb

  SUBROUTINE reweight_xsec_ref_cb(wsf0)
    IMPLICIT NONE
    INTEGER::init=0,i
    REAL(KIND(1d0)),INTENT(IN)::wsf0
    REAL(KIND(1d0))::wsfw
    SAVE init
    IF(.NOT.reweight_ref)THEN
       WRITE(*,*)"ERROR:Please set reweight_ref to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(ho_nref.NE.1.AND.ho_nref.NE.3)THEN
          WRITE(*,*)'Incorrect the number of references #1:',ho_nref
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecref))THEN
          DEALLOCATE(wgtxsecref)
       ENDIF
       ALLOCATE(wgtxsecref(ho_nref))
       IF(ALLOCATED(idref))THEN
          DEALLOCATE(idref)
       ENDIF
       ALLOCATE(idref(0:ho_nref))
       idref(0)=0
       idref(1)=iref_set_max
       IF(iref_set_max-iref_set_min+1.NE.ho_nref)THEN
          WRITE(*,*)'Incorrect the number of references #2:',ho_nref,iref_set_min,iref_set_max
          STOP
       ENDIF
       DO i=2,ho_nref
          idref(i)=idref(1)+i-1
       ENDDO
       WRITE(*,*) 'Doing reference reweight'
       init=1
    END IF
    ! reference: pp collision
    use_neutron_rand=.TRUE.
    INCLUDE "../../../input/lhapdf/call_initnpdf"
    PureProton1=.TRUE.
    PureProton2=.TRUE.
    CALL strf_pdf_pp_psiX_cb(wsfw)
    wgtxsecref(1)=wsfw/wsf0
    IF(ho_nref.LE.1)THEN
       use_neutron_rand=.FALSE.
       PureProton1=.FALSE.
       PureProton2=.FALSE.
       RETURN
    ENDIF
    ! reference: pB collision for AB
    PureProton2=.FALSE.
    CALL strf_pdf_pp_psiX_cb(wsfw)
    wgtxsecref(2)=wsfw/wsf0
    ! reference: Ap collision for AB
    PureProton2=.TRUE.
    PureProton1=.FALSE.
    CALL strf_pdf_pp_psiX_cb(wsfw)
    wgtxsecref(3)=wsfw/wsf0

    use_neutron_rand=.FALSE.
    PureProton1=.FALSE.
    PureProton2=.FALSE.
    RETURN
  END SUBROUTINE reweight_xsec_ref_cb
