MODULE plot_pp_psiY_sps
  USE HELAC_Global
  USE pp_psiY_global
  USE Kinetic_Func 
  IMPLICIT NONE
  !INTEGER::max_weight=1
  INTEGER::nwgt_analysis
  INTEGER::num_plots=33
  INTEGER,PARAMETER::n_width=1,n_height=1
CONTAINS
  SUBROUTINE initplot_pp_psiY_sps
    IMPLICIT NONE
    INTEGER::nwgt
    !CHARACTER(len=15),DIMENSION(max_weight)::weights_info
    CHARACTER(len=15),DIMENSION(:),ALLOCATABLE::weights_info
    INTEGER::i
    INTEGER::max_weight=1
    max_weight=1+ho_nscale+ho_npdf+ho_npdf2
    IF(ALLOCATED(weights_info))THEN
       DEALLOCATE(weights_info)
    ENDIF
    ALLOCATE(weights_info(max_weight))
    nwgt=1
    weights_info(nwgt)="central value "
    IF(reweight_scale)THEN
       nwgt=nwgt+ho_nscale
       IF(ho_nscale.NE.8)THEN
          WRITE(*,*) 'ERROR #1 in initplot_pp_psiY_sps:',ho_nscale
          STOP
       ENDIF
       WRITE(weights_info(nwgt-7),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",1.0,"muF=",rw_Fscale_up
       WRITE(weights_info(nwgt-6),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",1.0,"muF=",rw_Fscale_down
       WRITE(weights_info(nwgt-5),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_up,"muF=",1d0
       WRITE(weights_info(nwgt-4),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_up,"muF=",rw_Fscale_up
       WRITE(weights_info(nwgt-3),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_up,"muF=",rw_Fscale_down
       WRITE(weights_info(nwgt-2),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_down,"muF=",1d0
       WRITE(weights_info(nwgt-1),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_down,"muF=",rw_Fscale_up
       WRITE(weights_info(nwgt  ),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_down,"muF=",rw_Fscale_down
    END IF
    IF(reweight_pdf)THEN
       DO i=1,ho_npdf
          WRITE(weights_info(nwgt+i),'(a4,i8,a3)')&
               'PDF=',ipdf_set_min-1+i,'   '
       ENDDO
       nwgt=nwgt+ho_npdf
       IF(ho_npdf2.GT.0)THEN
          DO i=1,ho_npdf2
             WRITE(weights_info(nwgt+i),'(a5,i8,a2)')&
                  'PDF2=',ipdf2_set_min-1+i,'  '
          ENDDO
          nwgt=nwgt+ho_npdf2
       ENDIF
    ENDIF
    ! output plot files
    CALL plot_begin_pp_psiY_sps(nwgt,max_weight,weights_info)
    RETURN
  END SUBROUTINE initplot_pp_psiY_sps

  SUBROUTINE plotout_pp_psiY_sps
    USE MC_VEGAS
    IMPLICIT NONE
    LOGICAL::usexinteg=.FALSE.,mint=.FALSE. ! I have not implemented MINT 
    LOGICAL::useitmax=.TRUE.
    REAL(KIND(1d0))::xnorm
    xnorm=1.d0
    IF(useitmax.AND.gener.EQ.3)xnorm=xnorm/float(itmx) ! use vegas with itmax
    ! output plot files  
    CALL plot_end_pp_psiY_sps(xnorm)
    RETURN
  END SUBROUTINE plotout_pp_psiY_sps

  SUBROUTINE outfun_pp_psiY_sps(www)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::www
    INTEGER::i,j
    INTEGER::nwgt
    REAL(KIND(1d0))::alphasc,alphasu,alphasd
    !REAL(KIND(1d0)),DIMENSION(max_weight)::wgts,wgtden
    REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::wgts
    INTEGER::init=0
    INTEGER::max_weight
    SAVE init,wgts
    IF(init.EQ.0)THEN
       max_weight=1+ho_nscale+ho_npdf+ho_npdf2
       IF(ALLOCATED(wgts))THEN
          DEALLOCATE(wgts)
       ENDIF
       ALLOCATE(wgts(max_weight))
       init=1
    ENDIF
    nwgt=1
    wgts(1)=www
    IF(reweight_scale)THEN
       DO i=1,3
          DO j=1,3
             IF(i.EQ.1.AND.j.EQ.1)CYCLE
             nwgt=nwgt+1
             wgts(nwgt)=www*wgtxsecmu(i,j)
          ENDDO
       ENDDO
    ENDIF
    IF(reweight_pdf)THEN
       DO i=1,ho_npdf+ho_npdf2
          nwgt=nwgt+1
          wgts(nwgt)=www*wgtxsecpdf(i)
       ENDDO
    ENDIF
    ! output plot file 
    CALL plot_fill_pp_psiY_sps(wgts)
    RETURN
  END SUBROUTINE outfun_pp_psiY_sps

  SUBROUTINE plot_begin_pp_psiY_sps(nwgt,max_weight,weights_info)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::nwgt,max_weight
    CHARACTER(len=*),DIMENSION(max_weight),INTENT(IN)::weights_info
    INTEGER::i,kk,l
    INCLUDE '../../../analysis/hbook/dbookf90.inc'
    INCLUDE '../../../analysis/hbook/histogram_common90.inc'
    top_yes=topdrawer_output
    gnu_yes=gnuplot_output
    root_yes=root_output
    hwu_yes=hwufile_output
    CALL HISTOGRAM_INIT(nwgt,weights_info)
    nwgt_analysis=nwgt
    IF(nwgt_analysis*16.GT.nplots/4)THEN
       WRITE(*,*) 'error in plot_begin_pp_psiY_sps: ',&
            nwgt_analysis*num_plots*4 ! 4 is internal in dbook
       STOP
    ENDIF
    l=0
    CALL histogram_book(l+ 1,'total rate    ',&
         5,0.5d0,5.5d0,.FALSE.)
    CALL histogram_book(l+ 2,'|Delta y|  ',&
         100,0d0,5d0,.TRUE.)
    CALL histogram_book(l+ 3,'|Delta phi| ',&
         100,-0.0001d0,3.1416d0,.TRUE.)
    CALL histogram_book(l+ 4,'psi Y inv. mass ',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 5,'psi Y trans mom ',&
         100,0d0,100d0,.TRUE.)
    ! q12^2 = (Ejpsi1+Ejpsi2)^2-(pvecjpsi1+pvecjpsi2)^2-(2mjpsi)^2
    CALL histogram_book(l+ 6,'q12 ',&
         100,0d0,50d0,.TRUE.)
    ! alpha is the angle between the decay planes of Jpsi in the Di-Jpsi rest frame
    CALL histogram_book(l+ 7,'Cos(alpha) ',&
         100,0d0,1d0,.FALSE.)
    CALL histogram_book(l+ 8,'|Delta eta| ',&
         100,0d0,4d0,.TRUE.)
    CALL histogram_book(l+ 9,'psi Pt ',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 10,'Y Pt ',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 11,'leading Pt ',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 12,'subleading Pt ',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 13,'Pt diff ',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 14,'|Pt1-Pt2| ',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book3d(l+ 15,'Cos(th1)-Cos(th2) ',&
         100,-1d0,1d0,100,-1d0,1d0,.FALSE.)
    CALL histogram_book3d(l+ 16,'|Delta y| vs. Pt(psi-Y)',&
         100,0d0,5d0,100,0d0,100d0,.TRUE.)
    CALL histogram_book3d(l+ 17,'|Delta y| vs. |Delta phi|',&
         100,0d0,5d0,100,-0.0001d0,3.1416d0,.FALSE.)
    CALL histogram_book(l+ 18,'psi Y trans mom + sm 0.5',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 19,'psi Y trans mom + sm 1.0',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 20,'psi Y trans mom + sm 2.0',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 21,'psi Y trans mom + sm 3.0',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 22,'|Delta phi| + sm 0.5',&
         100,-0.0001d0,3.1416d0,.TRUE.)
    CALL histogram_book(l+ 23,'|Delta phi| + sm 1.0',&
         100,-0.0001d0,3.1416d0,.TRUE.)
    CALL histogram_book(l+ 24,'|Delta phi| + sm 2.0',&
         100,-0.0001d0,3.1416d0,.TRUE.)
    CALL histogram_book(l+ 25,'|Delta phi| + sm 3.0',&
         100,-0.0001d0,3.1416d0,.TRUE.)
    CALL histogram_book(l+ 26,'|Delta y| + sm 0.5',&
         100,0d0,5d0,.TRUE.)
    CALL histogram_book(l+ 27,'|Delta y| + sm 1.0',&
         100,0d0,5d0,.TRUE.)
    CALL histogram_book(l+ 28,'|Delta y| + sm 2.0',&
         100,0d0,5d0,.TRUE.)
    CALL histogram_book(l+ 29,'|Delta y| + sm 3.0',&
         100,0d0,5d0,.TRUE.)
    CALL histogram_book(l+ 30,'psi Y inv. mass + sm 0.5',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 31,'psi Y inv. mass + sm 1.0',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 32,'psi Y inv. mass + sm 2.0',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 33,'psi Y inv. mass + sm 3.0',&
         100,0d0,100d0,.TRUE.)

    CALL HISTOGRAM_BOOK_FINISH
    RETURN
  END SUBROUTINE plot_begin_pp_psiY_sps

  SUBROUTINE plot_end_pp_psiY_sps(xnorm)
    USE Helac_Global
    IMPLICIT NONE
    CHARACTER(len=14)::ytit
    REAL(KIND(1d0)),INTENT(IN)::xnorm
    INTEGER::i
    INTEGER::kk,l
    INCLUDE '../../../analysis/hbook/dbookf90.inc'
    CHARACTER(len=400)::psfile,rootfile
    IF(topdrawer_output.OR.gnuplot_output.OR.root_output)THEN
       CALL mclear
       CALL mclear_3d
       DO i=1,NPLOTS
          CALL mopera(i,'+',i,i,xnorm,0.d0)
          CALL mfinal(i)
          CALL mopera_3d(i,'+',i,i,xnorm,0.d0)
          CALL mfinal_3d(i)
       ENDDO
    ENDIF
    ytit='sigma per bin '
    IF(topdrawer_output)THEN
       CALL open_topdrawer_file_pp_psiY_sps
       CALL HISTOGRAM_END(1,ytit,' ',' ')
       CALL close_topdrawer_file_pp_psiY_sps
    ENDIF
    IF(gnuplot_output)THEN
       CALL open_gnuplot_file_pp_psiY_sps
       psfile="pp_psiY_sps.ps"
       CALL HISTOGRAM_END(2,ytit,psfile,' ')
       CALL close_gnuplot_file_pp_psiY_sps
    ENDIF
    IF(root_output)THEN
       CALL open_root_file_pp_psiY_sps
       rootfile="pp_psiY_sps.root"
       CALL HISTOGRAM_END(3,ytit,' ',rootfile)
       ! wirte the end of the .C file for root
       WRITE (96, 100)
100    FORMAT(/1X,&
            ' hohisto -> cd();',/1X,&
            ' if (histos -> GetEntries() > 0 ) then {',/1X,&
            '  histos->Write();',/1X,&
            '  hohisto -> Close();',/1X,&
            ' }',/1X,'}')
       CALL close_root_file_pp_psiY_sps
    ENDIF
    IF(hwufile_output)THEN
       CALL HISTOGRAM_END(4,ytit,' ',' ')
       CALL HwU_write_file_pp_psiY_sps
    ENDIF
    RETURN
  END SUBROUTINE plot_end_pp_psiY_sps

  SUBROUTINE plot_fill_pp_psiY_sps(wgts)
    USE Helac_Global
    IMPLICIT NONE
    !INCLUDE "pp_psipsi_dps.inc"
    REAL(KIND(1d0)),DIMENSION(4)::pboo,pini
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    REAL(KIND(1d0))::wgt,var,q,e
    REAL(KIND(1d0))::exp1,exp2
    INTEGER::i,kk,l
    REAL(KIND(1d0))::www,yftot
    IF(NDecayChains.GT.0)THEN
       CALL plot_fill_Decay_pp_psiY_sps(wgts)
       RETURN
    ENDIF
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !                                                                                                   
    ! DEFINE OBSERVABLES                                                                                
    !                                                                                                   
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
    var=1.0d0 ! total cross section
    pini(1:4)=sps_pmom(1,1:4)+sps_pmom(2,1:4) ! (px,py,pz,E)
    yftot=rapidity(pini)
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!                                               
    !                                                                                                   
    ! START TO FILL HISTOGRAM                                                                           
    !                                                                                                   
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    l=0
    CALL HISTOGRAM_FILL(l+1,var,wgts)
    CALL HISTOGRAM_FILL(l+2,yftot,wgts)
    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    ! boost back to c.m. frame
    RETURN
  END SUBROUTINE plot_fill_pp_psiY_sps

  SUBROUTINE HwU_write_file_pp_psiY_sps
    USE Helac_Global
    IMPLICIT NONE
    REAL(KIND(1d0))::xnorm
    OPEN(unit=599,file=TRIM(output_dir)//'pp_psiY_sps.HwU',&
         status='unknown')
    xnorm=1d0
    CALL HwU_output(599,xnorm)
    CLOSE(599)
    RETURN  
  END SUBROUTINE HwU_write_file_pp_psiY_sps

  SUBROUTINE open_topdrawer_file_pp_psiY_sps
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=99,FILE=TRIM(output_dir)//'pp_psiY_sps.top',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_topdrawer_file_pp_psiY_sps

  SUBROUTINE close_topdrawer_file_pp_psiY_sps
    IMPLICIT NONE
    CLOSE(99)
    RETURN
  END SUBROUTINE close_topdrawer_file_pp_psiY_sps

  SUBROUTINE open_gnuplot_file_pp_psiY_sps
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=97,FILE=TRIM(output_dir)//'pp_psiY_sps.gnu',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_gnuplot_file_pp_psiY_sps

  SUBROUTINE close_gnuplot_file_pp_psiY_sps
    IMPLICIT NONE
    CLOSE(97)
    RETURN
  END SUBROUTINE close_gnuplot_file_pp_psiY_sps

  SUBROUTINE open_root_file_pp_psiY_sps
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=96,FILE=TRIM(output_dir)//'pp_psiY_sps.C',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_root_file_pp_psiY_sps

  SUBROUTINE close_root_file_pp_psiY_sps
    IMPLICIT NONE
    CLOSE(96)
    RETURN
  END SUBROUTINE close_root_file_pp_psiY_sps

  SUBROUTINE plot_fill_Decay_pp_psiY_sps(wgts)
    USE Helac_Func_1
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    INCLUDE "stdhep_pp_psiY_sps.inc"
    REAL(KIND(1d0))::var,Q,www,dy_psipsi,dphi_psipsi,M_psipsi,Pt_psipsi,Pt1Pt2_psipsi,deta_psipsi
    REAL(KIND(1d0))::q12_psipsi,cosalpha,ptpsi1,ptpsi2,ptpsimax,ptpsimin,ptpsidiff
    REAL(KIND(1d0))::Pt_psipsi_sm05,Pt_psipsi_sm10,Pt_psipsi_sm20,Pt_psipsi_sm30
    REAL(KIND(1d0))::dy_psipsi_sm05,dy_psipsi_sm10,dy_psipsi_sm20,dy_psipsi_sm30
    REAL(KIND(1d0))::dphi_psipsi_sm05,dphi_psipsi_sm10,dphi_psipsi_sm20,dphi_psipsi_sm30
    REAL(KIND(1d0))::M_psipsi_sm05,M_psipsi_sm10,M_psipsi_sm20,M_psipsi_sm30
    INTEGER::i,m,l,kk
    REAL(KIND(1d0)),DIMENSION(4,NMXHEP)::PHEPSM05,PHEPSM10,PHEPSM20,PHEPSM30
    REAL(KIND(1d0)),DIMENSION(4)::PBOO
    REAL(KIND(1d0)),DIMENSION(2,4)::PJpsi,PJpsiCMS,PJpsiSM05,PJpsiSM10,PJpsiSM20,PJpsiSM30
    REAL(KIND(1d0)),DIMENSION(4,4)::Plep
    REAL(KIND(1d0)),DIMENSION(4)::plep1,Plep2
    REAL(KIND(1d0)),DIMENSION(3)::Pplain1,Pplain2
    REAL(KIND(1d0)),DIMENSION(3)::Plepvec1,Plepvec2
    REAL(KIND(1d0)),DIMENSION(2,3)::PJpsi1l,PJpsi2l
    REAL(KIND(1d0))::PP1,PP2
    REAL(KIND(1d0))::costh1,costh2
    INTEGER,DIMENSION(4)::lep2jpsi
    INTEGER,DIMENSION(2)::newmoth
    INTEGER::i_jpsi,i_lep,kk1,kk2
    INTEGER::definemoth
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!                                               
    !                                                                                                   
    ! DEFINE OBSERVABLES                                                                                
    !                                                                                                   
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    var=1.0d0 ! total cross section
    ! select the first four decayed stable lepton 
    i_jpsi=0
    i_lep=0
    lep2jpsi(1:4)=0
    newmoth(1:2)=0
    CALL InitKtSmearing(NHEP,PHEP(1:4,1:NHEP),PHEPSM05(1:4,1:NHEP),0.5d0,2)
    CALL InitKtSmearing(NHEP,PHEP(1:4,1:NHEP),PHEPSM10(1:4,1:NHEP),1d0,2)
    CALL InitKtSmearing(NHEP,PHEP(1:4,1:NHEP),PHEPSM20(1:4,1:NHEP),2d0,2)
    CALL InitKtSmearing(NHEP,PHEP(1:4,1:NHEP),PHEPSM30(1:4,1:NHEP),3d0,2)
    DO i=1,NHEP
       IF(ISHEP(i).EQ.-1)CYCLE
       IF(ISTHEP(i).EQ.1)CYCLE
       IF(JMOHEP(1,i).LE.0.OR.JMOHEP(1,i).GT.NHEP)CYCLE
       IF(ISTHEP(JMOHEP(1,i)).NE.1.OR.ISHEP(JMOHEP(1,i)).EQ.-1)CYCLE
       IF(.NOT.lepton_pdg(IDHEP(i)))CYCLE
       i_lep=i_lep+1
       Plep(i_lep,1:4)=PHEP(1:4,i)
       m=JMOHEP(1,i)
       definemoth=0
       DO kk=1,i_jpsi
          IF(newmoth(kk).EQ.m)THEN
             definemoth=kk
             EXIT
          END IF
       ENDDO
       IF(definemoth.NE.0)THEN
          ! the mother has been defined
          lep2jpsi(i_lep)=definemoth
       ELSE
          ! create the new mother
          i_jpsi=i_jpsi+1
          PJpsi(i_jpsi,1:4)=PHEP(1:4,m)
          PJpsiSM05(i_jpsi,1:4)=PHEPSM05(1:4,m)
          PJpsiSM10(i_jpsi,1:4)=PHEPSM10(1:4,m)
          PJpsiSM20(i_jpsi,1:4)=PHEPSM20(1:4,m)
          PJpsiSM30(i_jpsi,1:4)=PHEPSM30(1:4,m)
          newmoth(i_jpsi)=m
          lep2jpsi(i_lep)=i_jpsi
          IF(i_lep.EQ.4)EXIT
       ENDIF
    ENDDO
    dy_psipsi=DABS(rapidity(PJpsi(1,1:4))-rapidity(PJpsi(2,1:4)))
    dy_psipsi_sm05=DABS(rapidity(PJpsiSM05(1,1:4))-rapidity(PJpsiSM05(2,1:4)))
    IF(isnan(dy_psipsi_sm05))THEN
       WRITE(*,*)"ERROR:dy_psipsi_sm05 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM05(1,1:4)=",PJpsiSM05(1,1:4)
       WRITE(*,*)"PJpsiSM05(2,1:4)=",PJpsiSM05(2,1:4)
       STOP
    ENDIF
    dy_psipsi_sm10=DABS(rapidity(PJpsiSM10(1,1:4))-rapidity(PJpsiSM10(2,1:4)))
    IF(isnan(dy_psipsi_sm10))THEN
       WRITE(*,*)"ERROR:dy_psipsi_sm10 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM10(1,1:4)=",PJpsiSM10(1,1:4)
       WRITE(*,*)"PJpsiSM10(2,1:4)=",PJpsiSM10(2,1:4)
       STOP
    ENDIF
    dy_psipsi_sm20=DABS(rapidity(PJpsiSM20(1,1:4))-rapidity(PJpsiSM20(2,1:4)))
    IF(isnan(dy_psipsi_sm20))THEN
       WRITE(*,*)"ERROR:dy_psipsi_sm20 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM20(1,1:4)=",PJpsiSM20(1,1:4)
       WRITE(*,*)"PJpsiSM20(2,1:4)=",PJpsiSM20(2,1:4)
       STOP
    ENDIF
    dy_psipsi_sm30=DABS(rapidity(PJpsiSM30(1,1:4))-rapidity(PJpsiSM30(2,1:4)))
    IF(isnan(dy_psipsi_sm30))THEN
       WRITE(*,*)"ERROR:dy_psipsi_sm30 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM30(1,1:4)=",PJpsiSM30(1,1:4)
       WRITE(*,*)"PJpsiSM30(2,1:4)=",PJpsiSM30(2,1:4)
       STOP
    ENDIF
    deta_psipsi=DABS(prapidity(PJpsi(1,1:4))-prapidity(PJpsi(2,1:4)))
    dphi_psipsi=ph4(PJpsi(1,1),PJpsi(1,2),PJpsi(1,3))
    dphi_psipsi=dphi_psipsi-ph4(PJpsi(2,1),PJpsi(2,2),PJpsi(2,3))
    dphi_psipsi=DABS(dphi_psipsi)
    IF(dphi_psipsi.GT.pi)dphi_psipsi=2*pi-dphi_psipsi
    dphi_psipsi_sm05=ph4(PJpsiSM05(1,1),PJpsiSM05(1,2),PJpsiSM05(1,3))
    dphi_psipsi_sm05=dphi_psipsi_sm05-ph4(PJpsiSM05(2,1),PJpsiSM05(2,2),PJpsiSM05(2,3))
    dphi_psipsi_sm05=DABS(dphi_psipsi_sm05)
    IF(dphi_psipsi_sm05.GT.pi)dphi_psipsi_sm05=2*pi-dphi_psipsi_sm05
    IF(isnan(dphi_psipsi_sm05))THEN
       WRITE(*,*)"ERROR:dphi_psipsi_sm05 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM05(1,1:4)=",PJpsiSM05(1,1:4)
       WRITE(*,*)"PJpsiSM05(2,1:4)=",PJpsiSM05(2,1:4)
       STOP
    ENDIF
    dphi_psipsi_sm10=ph4(PJpsiSM10(1,1),PJpsiSM10(1,2),PJpsiSM10(1,3))
    dphi_psipsi_sm10=dphi_psipsi_sm10-ph4(PJpsiSM10(2,1),PJpsiSM10(2,2),PJpsiSM10(2,3))
    dphi_psipsi_sm10=DABS(dphi_psipsi_sm10)
    IF(dphi_psipsi_sm10.GT.pi)dphi_psipsi_sm10=2*pi-dphi_psipsi_sm10
    IF(isnan(dphi_psipsi_sm10))THEN
       WRITE(*,*)"ERROR:dphi_psipsi_sm10 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM10(1,1:4)=",PJpsiSM10(1,1:4)
       WRITE(*,*)"PJpsiSM10(2,1:4)=",PJpsiSM10(2,1:4)
       STOP
    ENDIF
    dphi_psipsi_sm20=ph4(PJpsiSM20(1,1),PJpsiSM20(1,2),PJpsiSM20(1,3))
    dphi_psipsi_sm20=dphi_psipsi_sm20-ph4(PJpsiSM20(2,1),PJpsiSM20(2,2),PJpsiSM20(2,3))
    dphi_psipsi_sm20=DABS(dphi_psipsi_sm20)
    IF(dphi_psipsi_sm20.GT.pi)dphi_psipsi_sm20=2*pi-dphi_psipsi_sm20
    IF(isnan(dphi_psipsi_sm20))THEN
       WRITE(*,*)"ERROR:dphi_psipsi_sm20 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM20(1,1:4)=",PJpsiSM20(1,1:4)
       WRITE(*,*)"PJpsiSM20(2,1:4)=",PJpsiSM20(2,1:4)
       STOP
    ENDIF
    dphi_psipsi_sm30=ph4(PJpsiSM30(1,1),PJpsiSM30(1,2),PJpsiSM30(1,3))
    dphi_psipsi_sm30=dphi_psipsi_sm30-ph4(PJpsiSM30(2,1),PJpsiSM30(2,2),PJpsiSM30(2,3))
    dphi_psipsi_sm30=DABS(dphi_psipsi_sm30)
    IF(dphi_psipsi_sm30.GT.pi)dphi_psipsi_sm30=2*pi-dphi_psipsi_sm30
    IF(isnan(dphi_psipsi_sm30))THEN
       WRITE(*,*)"ERROR:dphi_psipsi_sm30 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM30(1,1:4)=",PJpsiSM30(1,1:4)
       WRITE(*,*)"PJpsiSM30(2,1:4)=",PJpsiSM30(2,1:4)
       STOP
    ENDIF
    M_psipsi=scalar_product(PJpsi(1,1:4)+PJpsi(2,1:4),PJpsi(1,1:4)+PJpsi(2,1:4))
    M_psipsi=DSQRT(M_psipsi)
    M_psipsi_sm05=scalar_product(PJpsiSM05(1,1:4)+PJpsiSM05(2,1:4),&
         PJpsiSM05(1,1:4)+PJpsiSM05(2,1:4))
    M_psipsi_sm05=DSQRT(M_psipsi_sm05)
    IF(isnan(M_psipsi_sm05))THEN
       WRITE(*,*)"ERROR:M_psipsi_sm05 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM05(1,1:4)=",PJpsiSM05(1,1:4)
       WRITE(*,*)"PJpsiSM05(2,1:4)=",PJpsiSM05(2,1:4)
       STOP
    ENDIF
    M_psipsi_sm10=scalar_product(PJpsiSM10(1,1:4)+PJpsiSM10(2,1:4),&
         PJpsiSM10(1,1:4)+PJpsiSM10(2,1:4))
    M_psipsi_sm10=DSQRT(M_psipsi_sm10)
    IF(isnan(M_psipsi_sm10))THEN
       WRITE(*,*)"ERROR:M_psipsi_sm10 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM10(1,1:4)=",PJpsiSM10(1,1:4)
       WRITE(*,*)"PJpsiSM10(2,1:4)=",PJpsiSM10(2,1:4)
       STOP
    ENDIF
    M_psipsi_sm20=scalar_product(PJpsiSM20(1,1:4)+PJpsiSM20(2,1:4),&
         PJpsiSM20(1,1:4)+PJpsiSM20(2,1:4))
    M_psipsi_sm20=DSQRT(M_psipsi_sm20)
    IF(isnan(M_psipsi_sm20))THEN
       WRITE(*,*)"ERROR:M_psipsi_sm20 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM20(1,1:4)=",PJpsiSM20(1,1:4)
       WRITE(*,*)"PJpsiSM20(2,1:4)=",PJpsiSM20(2,1:4)
       STOP
    ENDIF
    M_psipsi_sm30=scalar_product(PJpsiSM30(1,1:4)+PJpsiSM30(2,1:4),&
         PJpsiSM30(1,1:4)+PJpsiSM30(2,1:4))
    M_psipsi_sm30=DSQRT(M_psipsi_sm30)
    IF(isnan(M_psipsi_sm30))THEN
       WRITE(*,*)"ERROR:M_psipsi_sm30 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM30(1,1:4)=",PJpsiSM30(1,1:4)
       WRITE(*,*)"PJpsiSM30(2,1:4)=",PJpsiSM30(2,1:4)
       STOP
    ENDIF    
    Q=scalar_product(PJpsi(1,1:4),PJpsi(1,1:4))
    Q=DSQRT(Q)
    ptpsi1=transverse(PJpsi(1,1:4))
    ptpsi2=transverse(PJpsi(2,1:4))
    ptpsimax=MAX(ptpsi1,ptpsi2)
    ptpsimin=MIN(ptpsi1,ptpsi2)
    ptpsidiff=ptpsimax-ptpsimin
    Pt_psipsi=transverse(PJpsi(1,1:4)+PJpsi(2,1:4))
    Pt_psipsi_sm05=transverse(PJpsiSM05(1,1:4)+PJpsiSM05(2,1:4))
    IF(isnan(Pt_psipsi_sm05))THEN
       WRITE(*,*)"ERROR:Pt_psipsi_sm05 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM05(1,1:4)=",PJpsiSM05(1,1:4)
       WRITE(*,*)"PJpsiSM05(2,1:4)=",PJpsiSM05(2,1:4)
       STOP
    ENDIF
    Pt_psipsi_sm10=transverse(PJpsiSM10(1,1:4)+PJpsiSM10(2,1:4))
    IF(isnan(Pt_psipsi_sm10))THEN
       WRITE(*,*)"ERROR:Pt_psipsi_sm10 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM10(1,1:4)=",PJpsiSM10(1,1:4)
       WRITE(*,*)"PJpsiSM10(2,1:4)=",PJpsiSM10(2,1:4)
       STOP
    ENDIF
    Pt_psipsi_sm20=transverse(PJpsiSM20(1,1:4)+PJpsiSM20(2,1:4))
    IF(isnan(Pt_psipsi_sm20))THEN
       WRITE(*,*)"ERROR:Pt_psipsi_sm20 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM20(1,1:4)=",PJpsiSM20(1,1:4)
       WRITE(*,*)"PJpsiSM20(2,1:4)=",PJpsiSM20(2,1:4)
       STOP
    ENDIF
    Pt_psipsi_sm30=transverse(PJpsiSM30(1,1:4)+PJpsiSM30(2,1:4))
    IF(isnan(Pt_psipsi_sm30))THEN
       WRITE(*,*)"ERROR:Pt_psipsi_sm30 is NaN !"
       WRITE(*,*)"wgt=",wgts(1),i_jpsi,NHEP
       DO i=1,NHEP
          WRITE(*,*)i,IDHEP(i),PHEP(1:4,i)
       ENDDO
       WRITE(*,*)"PJpsi(1,1:4)=",PJpsi(1,1:4)
       WRITE(*,*)"PJpsi(2,1:4)=",PJpsi(2,1:4)
       WRITE(*,*)"PJpsiSM30(1,1:4)=",PJpsiSM30(1,1:4)
       WRITE(*,*)"PJpsiSM30(2,1:4)=",PJpsiSM30(2,1:4)
       STOP
    ENDIF
    Pt1Pt2_psipsi=transverse(PJpsi(1,1:4)-PJpsi(2,1:4))
    q12_psipsi=M_psipsi**2-4*Q**2
    q12_psipsi=DSQRT(DABS(q12_psipsi))
    PBOO(1:3)=-PJpsi(1,1:3)-PJpsi(2,1:3)
    PBOO(4)=PJpsi(1,4)+PJpsi(2,4)
    DO i=1,4
       CALL BOOSTL(M_psipsi,PBOO,Plep(i,1:4))
    ENDDO
    DO i=1,2
       PJpsiCMS(i,1:4)=PJpsi(i,1:4)
       CALL BOOSTL(M_psipsi,PBOO,PJpsiCMS(i,1:4))
    ENDDO
    kk1=0
    kk2=0
    DO i=1,4
       IF(lep2jpsi(i).EQ.1)THEN
          kk1=kk1+1
          PJpsi1l(kk1,1:3)=Plep(i,1:3)
          IF(kk1.EQ.1)THEN
             Plep1(1:4)=Plep(i,1:4)
          ENDIF
       ELSEIF(lep2jpsi(i).EQ.2)THEN
          kk2=kk2+1
          PJpsi2l(kk2,1:3)=Plep(i,1:3)
          IF(kk2.EQ.1)THEN
             Plep2(1:4)=Plep(i,1:4)
          ENDIF
       ENDIF
    ENDDO
    Pplain1(1:3)=vec_crossprod(PJpsi1l(1,1:3),PJpsi1l(2,1:3))
    Pplain2(1:3)=vec_crossprod(PJpsi2l(1,1:3),PJpsi2l(2,1:3))
    PP1=Pplain1(1)**2+Pplain1(2)**2+Pplain1(3)**2
    PP1=DSQRT(PP1)
    PP2=Pplain2(1)**2+Pplain2(2)**2+Pplain2(3)**2
    PP2=DSQRT(PP2)
    IF(PP1*PP2.EQ.0d0)THEN
       cosalpha=0d0
    ELSE
       cosalpha=Pplain1(1)*Pplain2(1)+Pplain1(2)*Pplain2(2) &
            +Pplain1(3)*Pplain2(3)
       cosalpha=DABS(cosalpha/(PP1*PP2))
    ENDIF
    ! costh1
    Q=scalar_product(PJpsiCMS(1,1:4),PJpsiCMS(1,1:4))
    Q=DSQRT(Q)
    PBOO(1:3)=-PJpsiCMS(1,1:3)
    PBOO(4)=PJpsiCMS(1,4)
    CALL BOOSTL(Q,PBOO,Plep1)
    costh1=cosij(Plep1(1:3),PJpsiCMS(1,1:3))
    ! costh2
    Q=scalar_product(PJpsiCMS(2,1:4),PJpsiCMS(2,1:4))
    Q=DSQRT(Q)
    PBOO(1:3)=-PJpsiCMS(2,1:3)
    PBOO(4)=PJpsiCMS(2,4)
    CALL BOOSTL(Q,PBOO,Plep2)
    costh2=cosij(Plep2(1:3),PJpsiCMS(2,1:3))
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! START TO FILL HISTOGRAM
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    l=0
    CALL HISTOGRAM_FILL(l+1,var,wgts)
    CALL HISTOGRAM_FILL(l+2,dy_psipsi,wgts)
    CALL HISTOGRAM_FILL(l+3,dphi_psipsi,wgts)
    CALL HISTOGRAM_FILL(l+4,M_psipsi,wgts)
    CALL HISTOGRAM_FILL(l+5,Pt_psipsi,wgts)
    CALL HISTOGRAM_FILL(l+6,q12_psipsi,wgts)
    CALL HISTOGRAM_FILL(l+7,cosalpha,wgts)
    CALL HISTOGRAM_FILL(l+8,deta_psipsi,wgts)
    CALL HISTOGRAM_FILL(l+9,ptpsi1,wgts)
    CALL HISTOGRAM_FILL(l+10,ptpsi2,wgts)
    CALL HISTOGRAM_FILL(l+11,ptpsimax,wgts)
    CALL HISTOGRAM_FILL(l+12,ptpsimin,wgts)
    CALL HISTOGRAM_FILL(l+13,ptpsidiff,wgts)
    CALL HISTOGRAM_FILL(l+14,Pt1Pt2_psipsi,wgts)
    CALL HISTOGRAM_FILL3D(l+15,costh1,costh2,wgts)
    CALL HISTOGRAM_FILL3D(l+16,dy_psipsi,Pt_psipsi,wgts)
    CALL HISTOGRAM_FILL3D(l+17,dy_psipsi,dphi_psipsi,wgts)
    CALL HISTOGRAM_FILL(l+18,Pt_psipsi_sm05,wgts)
    CALL HISTOGRAM_FILL(l+19,Pt_psipsi_sm10,wgts)
    CALL HISTOGRAM_FILL(l+20,Pt_psipsi_sm20,wgts)
    CALL HISTOGRAM_FILL(l+21,Pt_psipsi_sm30,wgts)
    CALL HISTOGRAM_FILL(l+22,dphi_psipsi_sm05,wgts)
    CALL HISTOGRAM_FILL(l+23,dphi_psipsi_sm10,wgts)
    CALL HISTOGRAM_FILL(l+24,dphi_psipsi_sm20,wgts)
    CALL HISTOGRAM_FILL(l+25,dphi_psipsi_sm30,wgts)
    CALL HISTOGRAM_FILL(l+26,dy_psipsi_sm05,wgts)
    CALL HISTOGRAM_FILL(l+27,dy_psipsi_sm10,wgts)
    CALL HISTOGRAM_FILL(l+28,dy_psipsi_sm20,wgts)
    CALL HISTOGRAM_FILL(l+29,dy_psipsi_sm30,wgts)
    CALL HISTOGRAM_FILL(l+30,M_psipsi_sm05,wgts)
    CALL HISTOGRAM_FILL(l+31,M_psipsi_sm10,wgts)
    CALL HISTOGRAM_FILL(l+32,M_psipsi_sm20,wgts)
    CALL HISTOGRAM_FILL(l+33,M_psipsi_sm30,wgts)
    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    RETURN
  END SUBROUTINE plot_fill_Decay_pp_psiY_sps
END MODULE plot_pp_psiY_sps
