MODULE pp_psiY_SPS
  USE Helac_Global
  USE pp_psiY_global
  USE Helac_Func_1
  USE Kinetic_Func
  USE MC_VEGAS
  USE Constants
  USE Decay_interface
  USE pp_psiY_loop
  USE plot_pp_psiY_sps
  USE DecayInfo
  USE Func_PSI
  IMPLICIT NONE
  INTEGER::nprint
  INTEGER::varnum,nunwei
  LOGICAL::lunwei2
  REAL(KIND(1d0))::EBMUP1,EBMUP2
  INTEGER::NPRUP=0,lwmax
  INTEGER,PARAMETER::maxprint=8
  SAVE
CONTAINS
  SUBROUTINE calc_pp_psiY_SPS
    IMPLICIT NONE
    CHARACTER(len=10),DIMENSION(20)::char
    INTEGER::i,i1,j1,k1,s1x
    INTEGER::nh,innum,outnum
    REAL(KIND(1d0))::w0,ptp,pqp,wme,charmmass,bottommass
    INTEGER::ioerror,icase=0
    LOGICAL::lunwei=.FALSE.,lhewgt=.FALSE.
    REAL(KIND(1d0)),DIMENSION(3)::rslt
    INTEGER::itmxn,ncalln
    REAL(KIND(1d0)),DIMENSION(4)::pmomtemp
    LOGICAL::lexist
    REAL(KIND(1d0))::rsw2,alpha
    SAVE lunwei,lhewgt,icase
    REAL(KIND(1d0)),PARAMETER::pipi=3.1415926535897932385d0
    INTEGER::beam1_pdf,beam2_pdf
    INCLUDE "pdfreweight_common.inc"
    INCLUDE "pdf2reweight_common.inc"
    WRITE(*,*)'                     THE BEGINNING OF HELAC-Onia'
    WRITE(*,*)'    AddOn Process: '
    WRITE(*,*)'    Double Patron Scattering for p p > psi + Upsilon via loop-induced '
    WRITE(*,*)'======================================================================='
    WRITE(*,*)'======================================================================='
    WRITE(*,*)' '
    CALL ReadElem_integer('colpar',Coll_Type)
    CALL ReadElem_integer('ranhel',iranhel_psiY)
    IF(iranhel_psiY.EQ.4)THEN
       MCoHelicity_psiY=.TRUE.
    ELSE
       MCoHelicity_psiY=.FALSE.
    ENDIF
    CALL ReadElem_logic('unwgt',lunwei)
    CALL ReadElem_logic('lhewgtup',lhewgt)
    CALL ReadElem_logic('topdrawer_output',topdrawer_output)
    CALL ReadElem_logic('gnuplot_output',gnuplot_output)
    CALL ReadElem_logic('root_output',root_output)
    CALL ReadElem_logic('hwu_output',hwufile_output)
    plot_output=topdrawer_output.OR.gnuplot_output.OR.root_output.OR.hwufile_output
    CALL ReadElem_integer('literature',literature_cutoffs)
    CALL ReadElem_logic('fixtarget',fixtarget)
    IF(fixtarget.AND.Coll_Type.EQ.3)THEN
       WRITE(*,*)"ERROR: Cannot treat fixed-target experiment in e+e- collisions"
       STOP
    ENDIF
    IF(lunwei.AND.lhewgt)icase=1
    CALL ReadElem_logic("useMCFMrun",useMCFMrun)
    CALL ReadElem_logic('lhapdf',uselhapdf)
    INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdf_data",EXIST=lexist)
    IF(lexist)THEN
       OPEN(UNIT=30538,FILE=TRIM(input_dir)//"paths/lhapdf_data")
       READ(30538,'(A)')LHAPath
       CLOSE(UNIT=30538)
    ELSE
       INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdfpath",EXIST=lexist)
       IF(lexist)THEN
          OPEN(UNIT=30538,FILE=TRIM(input_dir)//"paths/lhapdfpath")
          READ(30538,'(A)')LHAPath
          CLOSE(UNIT=30538)
          i=LEN_TRIM(LHAPath)
          LHAPath=LHAPath(1:i-13)
       ENDIF
    ENDIF
    uselhapdf=uselhapdf.AND.lexist
    WRITE(*,*)'Use LHAPDF ?',uselhapdf
    CALL ReadElem_integer('pdf',beam1_pdf)
    CALL ReadElem_integer('beam2_pdf',beam2_pdf)
    multipdfloading=uselhapdf.AND.beam2_pdf.NE.beam1_pdf.AND.beam2_pdf.GT.0
    multipdfloading=multipdfloading.AND.COLL_TYPE.LE.2
    reweight_pdf=.FALSE.
    reweight_npdf=.FALSE.
    IF(uselhapdf)THEN
       CALL ReadElem_logic('reweight_pdf',reweight_pdf)
       IF(reweight_pdf)THEN
          CALL ReadElem_logic('beams_pdf_correlation',beams_pdf_correlation)
       ENDIF
       pdf_reweight_common=reweight_pdf
       IF(reweight_pdf)THEN
          CALL ReadElem_integer('pdf_min',ipdf_set_min)
          pdf_set_min_common=ipdf_set_min
          CALL ReadElem_integer('pdf_max',ipdf_set_max)
          pdf_set_max_common=ipdf_set_max
          IF(multipdfloading)THEN
             CALL ReadElem_integer('beam2_pdf_min',ipdf2_set_min)
             CALL ReadElem_integer('beam2_pdf_max',ipdf2_set_max)
             IF(ipdf2_set_min.GT.0.AND.ipdf2_set_max.GT.0)THEN
                IF(beams_pdf_correlation.AND.&
                     (ipdf2_set_max-ipdf2_set_min).NE.&
                     (ipdf_set_max-ipdf_set_min))THEN
                   WRITE(*,*)"ERROR: The numbers of error PDFs for two beams are different"
                   WRITE(*,*)"ERROR: The two beams cannot be fully correlated "
                   STOP
                ENDIF
             ENDIF
          ELSE
             ipdf2_set_min=-1
             ipdf2_set_max=-1
          ENDIF
          IF(ipdf_set_max.LT.0.AND.ipdf_set_min.LT.0)THEN
             ho_npdf=0
          ELSE
             ho_npdf=ipdf_set_max-ipdf_set_min+1
          ENDIF
          IF(multipdfloading.AND..NOT.beams_pdf_correlation.AND.&
               (ipdf2_set_min.GT.0.AND.ipdf2_set_max.GT.0))THEN
             pdf2_reweight_common=.TRUE.
             pdf2_set_min_common=ipdf2_set_min
             pdf2_set_max_common=ipdf2_set_max
             ho_npdf2=ipdf2_set_max-ipdf2_set_min+1
          ELSE
             ho_npdf2=0
             pdf2_reweight_common=.FALSE.
          ENDIF
          ho_npdf=MAX(ho_npdf,0)
          ho_npdf2=MAX(ho_npdf2,0)
          IF(ho_npdf.LE.0.AND.ho_npdf2.LE.0)THEN
             ho_npdf=0
             ho_npdf2=0
             reweight_pdf=.FALSE.
             pdf_reweight_common=.FALSE.
             pdf2_reweight_common=.FALSE.
          ENDIF
          IF(pdf_reweight_common.AND.ho_npdf.GT.0)THEN
             tot_nrwgt=tot_nrwgt+ho_npdf+1
          ENDIF
          IF(pdf2_reweight_common.AND.ho_npdf2.GT.0)THEN
             tot_nrwgt=tot_nrwgt+ho_npdf2+1
          ENDIF
       ENDIF
    ELSE
       pdf_reweight_common=.FALSE.
       pdf2_reweight_common=.FALSE.
    ENDIF
    CALL ReadElem_logic("absoluterap",absrap)
    CALL ReadElem_integer('alphasrun',irun)
    !CALL ReadElem_real('alphaem',alphapsiY)
    CALL ReadElem_real('ktsmearing',psiY_ktavg)
    CALL ReadElem_real('LDMEcc3S11',RJ0Square)
    RJ0Square=RJ0Square*4d0*pipi
    CALL ReadElem_real('LDMEbb3S11',RU0Square)
    RU0Square=RU0Square*4d0*pipi
    ! some necesarry initialization
    OPEN(UNIT=12523,FILE="./input/states.inp")
    READ(12523,*)psiY_istate(1),psiY_istate(2)
    CLOSE(UNIT=12523)
    IF((psiY_istate(1).LT.1.OR.psiY_istate(1).GT.5).OR.&
         (psiY_istate(2).LT.1.OR.psiY_istate(2).GT.5))THEN
       WRITE(*,*)"ERROR:Unknown the states = ",psiY_istate(1),psiY_istate(2)
       WRITE(*,*)"INFO:Please set 1(J/psi) or 2(psi(2S)) or 3-4 (Y(1S-3S) in states.inp"
       !WRITE(*,*)"INFO:Make sure the first one is psi and the second one is Y"
       STOP
    ELSEIF((psiY_istate(1).GE.1.AND.psiY_istate(1).LE.2).AND.&
         (psiY_istate(2).GE.1.OR.psiY_istate(2).LE.2))THEN
       WRITE(*,*)"WARNING: Only subset of the diagrams are chosen for double charmonium production"
       RU0Square=RJ0Square
    ELSEIF((psiY_istate(1).GE.3.AND.psiY_istate(1).LE.5).AND.&
         (psiY_istate(2).GE.3.OR.psiY_istate(2).LE.5))THEN
       WRITE(*,*)"WARNING: Only subset of the diagrams are chosen for double bottomonium production"
       RJ0Square=RU0Square
    ENDIF
    ! itype: 0, |QED amplitude+loop amplitude|^2
    ! itype: 1, |loop amplitude|^2
    ! itype: 2, |QED amplitudue|^2
    ! itype: 3, QED amplitude*loop amplitude
    ! itype: 4, |loop amplitude|^2+QED amplitude*loop amplitude
    ! itype: 5, |QED amplitude|^2+QED amplitude*loop amplitude
    ! itype: 6, |loop amplitude|^2+|QED amplitudue|^2
    OPEN(UNIT=12523,FILE="./input/calculation_type.inp")
    READ(12523,*)psiY_type
    CLOSE(UNIT=12523)
    IF(psiY_type.LT.0.OR.psiY_type.GT.6)THEN
       WRITE(*,*)"ERROR:Unknown the type = ",psiY_type
       WRITE(*,*)"INFO:Please set 0-6 in input/calculation_type.inp"
       STOP
    ENDIF
    CALL ReadElem_real('cmass',charmmass)
    CALL ReadElem_real('bmass',bottommass)
    OPEN(UNIT=12724,FILE="./input/scale.inp")
    READ(12724,*)dynamical_scale_choice
    CLOSE(UNIT=12724)
    OPEN(UNIT=12724,FILE="./input/stability_check.inp")
    READ(12724,*)stability_check
    CLOSE(UNIT=12724)
    IF(psiY_istate(1).GE.1.AND.psiY_istate(1).LE.2)THEN
       mpsi(1)=2d0*charmmass
       mcpsiY=charmmass
    ELSEIF(psiY_istate(1).GE.3.AND.psiY_istate(1).LE.5)THEN
       mpsi(1)=2d0*bottommass
       mcpsiY=bottommass
    ENDIF
    !CALL ReadElem_real('bmass',bottommass)
    IF(psiY_istate(2).GE.1.AND.psiY_istate(2).LE.2)THEN
       mpsi(2)=2d0*charmmass
       mbpsiY=charmmass
    ELSEIF(psiY_istate(2).GE.3.AND.psiY_istate(2).LE.4)THEN
       mpsi(2)=2d0*bottommass
       mbpsiY=bottommass
    ENDIF
    mc2psiY=mcpsiY**2
    mb2psiY=mbpsiY**2
    ! special treatment for double charmonium or double bottomonium
    ! as there seems to be numerical instability
    IF(mcpsiY.EQ.mbpsiY)THEN
       mbpsiY=mbpsiY*1.01D0
       mpsi(2)=2D0*mbpsiY
       mb2psiY=mbpsiY**2
    ENDIF
    ! end of the special treatment
    iflh(1)=35
    iflh(2)=35
    IF(psiY_istate(1).GE.1.AND.psiY_istate(1).LE.2)THEN
       iflh(3)=443011
    ELSEIF(psiY_istate(1).GE.3.AND.psiY_istate(1).LE.5)THEN
       iflh(3)=553011
    ENDIF
    IF(psiY_istate(2).GE.1.AND.psiY_istate(2).LE.2)THEN
       iflh(4)=443011
    ELSEIF(psiY_istate(2).GE.3.AND.psiY_istate(2).LE.5)THEN
       iflh(4)=553011
    ENDIF
    nhad=4
    CALL ReadConst
    IF(alphaem.EQ.-1)THEN
       rsw2=1d0-rwm**2/rzm**2
       alpha=DSQRT(dnou(2))*gfermi*rwm*rwm*rsw2/pi
    ELSE
       alpha=alphaem
    ENDIF
    AQEDUP=alpha
    alphapsiY=alpha
    CALL ReadDecayInfo
    CALL set_colorflow_pp_psiY
    IF(nunit1.NE.6)THEN
       OPEN(UNIT=nunit1,FILE=TRIM(output_dir)//"RESULT_pp_psiY_sps.out")
    ENDIF
    nunit2=32
    CLOSE(nunit2)
    OPEN(nunit2,FILE=TRIM(output_dir)//'kine_pp_psiY_sps.out')
    nunit3=30
    CLOSE(nunit3)
    OPEN(nunit3,FILE=TRIM(tmp_dir)//'even_pp_psiY_sps.out',FORM='unformatted')
    nunit30=300
    CLOSE(nunit30)
    OPEN(nunit30,FILE=TRIM(tmp_dir)//'even_rwgt_pp_psiY_sps.out',FORM='unformatted')
    ! for LHA
    CLOSE(200)
    OPEN(200,FILE=TRIM(tmp_dir)//'sample_pp_psiY_sps.init')
    CALL ReadElem_integer("itmax",itmxn)
    CALL ReadElem_integer("nmc",ncalln)
    WRITE(*,*)' '
    CALL Helac_mtime()
    WRITE(*,*)' '
    CALL pp_psiY_SPS_VEGAS(rslt,itmxn,ncalln)
    WRITE(nunit1,*)"sigma(nb)                   sd"
    WRITE(nunit1,*)rslt(1),rslt(2)
    WRITE(*,*)' '
    CALL Helac_mtime()
    CLOSE(nunit2)
    CLOSE(nunit3)
    CLOSE(nunit30)
    CLOSE(21)
    CLOSE(200)
    IF(lunwei)CALL Generate_lhe_pp_psiY_sps(nhad,Nevents,icase)
  END SUBROUTINE calc_pp_psiY_SPS

  SUBROUTINE pp_psiY_SPS_VEGAS(rslt,itmxn,ncalln)
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(3),INTENT(OUT)::rslt
    INTEGER,INTENT(IN),OPTIONAL::itmxn,ncalln
    REAL(KIND(1d0))::vfes,sd,chi2a
    INTEGER::ncalm,nc,ii
    CHARACTER(len=4),DIMENSION(20)::chchar
    INTEGER::iday0,ihr0,imin0,isec0,i100th0,iday1,ihr1,imin1,isec1,i100th1,iyr0,iyr1,imon0,imon1
    INTEGER::IDBMUP1,IDBMUP2,IDWTUP
    INTEGER::iseed,ililil
    REAL(KIND(1d0)),DIMENSION(1)::ranrrr
    ! read the random seed
    OPEN(777,FILE=TRIM(input_dir)//'seed.input',status='OLD')
    READ(777,*)iseed
    WRITE(*,*)'Random number seed',iseed
    CLOSE(777)
    ! randomly RANDA
    IF(iseed.GT.0)THEN
       DO ililil=1,iseed
          CALL RANDA(1,ranrrr)
       ENDDO
    ENDIF
    CALL ReadElem_logic('unwgt',lunwei2)
    CALL ReadElem_integer('preunw',nunwei)
    lwmax=0
    NPRN=-1
    varnum=3
    varnum=varnum+1
    IF(MCoHelicity_psiY)varnum=varnum+1
    varnum=varnum+NDecayIflh
    DO ii=1,varnum
       XL(ii)=0.0d0
       XU(ii)=1.0d0
    ENDDO
    IF(PRESENT(itmxn))THEN
       ITMX=itmxn
    ELSE
       ITMX=5
    ENDIF
    ITMX=1
    IF(PRESENT(ncalln))THEN
       ncalm=ncalln
    ELSE
       ncalm=5000
    ENDIF
    chchar(1)="40K"
    chchar(2)="80K"
    chchar(3)="160K"
    chchar(4)="320K"
    chchar(5)="640K"
    chchar(6)="1M"
    chchar(7)="2M"
    chchar(8)="4M"
    chchar(9)="8M"
    chchar(10)="16M"
    chchar(11)='32M'
    chchar(12)='64M'
    chchar(13)='120M'
    chchar(14)='240M'
    chchar(15)='480M'
    chchar(16)='960M'
    chchar(17)='2G'
    chchar(18)='4G'
    chchar(19)='8G'
    chchar(20)='16G'
    nprint=10000
    NCALL=20000
    IF(stability_check)THEN
       OPEN(UNIT=20456,FILE=TRIM(output_dir)//"UPS.log")
    ENDIF
    CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
    IF(stability_check)THEN
       unstable_ps=0
       total_ps=0
    ENDIF
    IF(plot_output)CALL initplot_pp_psiY_SPS
    CALL VEGAS(varnum,pp_psiY_SPS_fxn,vfes,sd,chi2a)
    IF(plot_output)CALL plotout_pp_psiY_SPS
    WRITE(*,*)' '
    WRITE(*,*)"====================NCALL=20K==========================="
    WRITE(*,*)" "
    CALL Helac_mtime()
    WRITE(*,*)" "
    ii=1
    WRITE(*,*)"ITERATION ",ii,":"
    WRITE(*,*)vfes,"+\-",sd
    WRITE(*,*)"precision:",sd/vfes
    IF(stability_check.AND.total_ps.GT.0)THEN
       WRITE(*,*)"UPS fraction:",DBLE(unstable_ps)/DBLE(total_ps)
    ENDIF
    DO ii=2,10
       IF(stability_check)THEN
          unstable_ps=0
          total_ps=0
       ENDIF
       IF(plot_output)CALL initplot_pp_psiY_SPS
       CALL VEGAS(varnum,pp_psiY_SPS_fxn,vfes,sd,chi2a,1)
       IF(plot_output)CALL plotout_pp_psiY_SPS
       WRITE(*,*)"ITERATION ",ii,":"
       WRITE(*,*)vfes,"+\-",sd
       WRITE(*,*)"precision:",sd/vfes
       IF(stability_check.AND.total_ps.GT.0)THEN
          WRITE(*,*)"UPS fraction:",DBLE(unstable_ps)/DBLE(total_ps)
       ENDIF
    ENDDO
    CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
    iday1=iday1-iday0
    ihr1=ihr1-ihr0
    imin1=imin1-imin0
    isec1=isec1-isec0
    i100th1=i100th1-i100th0
    CALL Vegas_speed(10*NCALL,iday1,ihr1,imin1,isec1,i100th1)
    WRITE(*,*)' '
    WRITE(*,*)' '
    ii=1
    DO
       nc=2*NCALL
       IF(nc.GT.ncalm)EXIT
       IF(2*nc.GT.ncalm.AND.lunwei2.AND.lwmax.EQ.0)THEN
          lwmax=1
       ENDIF
       NCALL=nc
       IF(NCALL/maxprint.GT.nprint)nprint=NCALL/maxprint
         CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
         WRITE(*,*)"====================NCALL="//chchar(ii)//"==========================="
         WRITE(*,*)" "
         CALL Helac_mtime()
         WRITE(*,*)" "
         IF(plot_output)CALL initplot_pp_psiY_SPS
         IF(stability_check)THEN
            unstable_ps=0
            total_ps=0
         ENDIF
         CALL VEGAS(varnum,pp_psiY_SPS_fxn,vfes,sd,chi2a,1)
         IF(plot_output)CALL plotout_pp_psiY_SPS
         WRITE(*,*)vfes,"+\-",sd
         WRITE(*,*)"precision:",sd/vfes
         IF(stability_check.AND.total_ps.GT.0)THEN
            WRITE(*,*)"UPS fraction:",DBLE(unstable_ps)/DBLE(total_ps)
         ENDIF
         CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
         iday1=iday1-iday0
         ihr1=ihr1-ihr0
         imin1=imin1-imin0
         isec1=isec1-isec0
         i100th1=i100th1-i100th0
         CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
         WRITE(*,*)" "
         ii=ii+1
      ENDDO
      IF(lunwei2.AND.lwmax.EQ.1)THEN
         lwmax=2
         WRITE(*,*)"START UNWEIGHTING"
         NCALL=nc/2
         CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
         WRITE(*,*)"====================NCALL="//chchar(ii-1)//"==========================="
         WRITE(*,*)" "
         CALL Helac_mtime()
         WRITE(*,*)" "
         IF(stability_check)THEN
            unstable_ps=0
            total_ps=0
         ENDIF
         IF(plot_output)CALL initplot_pp_psiY_SPS
         CALL VEGAS(varnum,pp_psiY_SPS_fxn,vfes,sd,chi2a,1)
         IF(plot_output)CALL plotout_pp_psiY_SPS
         WRITE(*,*)vfes,"+\-",sd
         WRITE(*,*)"precision:",sd/vfes
         IF(stability_check.AND.total_ps.GT.0)THEN
            WRITE(*,*)"UPS fraction:",DBLE(unstable_ps)/DBLE(total_ps)
         ENDIF
         CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
         iday1=iday1-iday0
         ihr1=ihr1-ihr0
         imin1=imin1-imin0
         isec1=isec1-isec0
         i100th1=i100th1-i100th0
         CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
         WRITE(*,*)" "
      ENDIF
      SELECT CASE(COLL_TYPE)
      CASE(1)
         IDBMUP1=2212
         IDBMUP2=2212
      CASE(2)
         IDBMUP1=2212
         IDBMUP2=-2212
      CASE DEFAULT
         WRITE(*,*)"ERROR: Cannot understand COLL_TYPE=",COLL_TYPE
         STOP
         IDBMUP1=11
         IDBMUP2=-11
      END SELECT
      IF(lunwei2)THEN
         IDWTUP=3
      ELSE
         IDWTUP=1
      ENDIF
      NPRUP=NPRUP+1
      WRITE(200,5100) IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,&
           iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
      WRITE(200,5200) vfes*10d0**3,sd*10d0**3,1d0, 82
      IF(stability_check)THEN
         CLOSE(UNIT=20456)
      ENDIF
      rslt(1)=vfes
      rslt(2)=sd
      rslt(3)=chi2a
      IF(lunwei2)PRINT *,"number of events",Nevents
      RETURN
5100  FORMAT(1P,2I8,2E14.6,6I8)
5200  FORMAT(1P,3E20.10,I6)
    END SUBROUTINE pp_psiY_SPS_VEGAS

    FUNCTION pp_psiY_SPS_fxn(x,wgt)
      REAL(KIND(1d0)),DIMENSION(varnum),INTENT(IN)::x
      REAL(KIND(1d0)),INTENT(IN)::wgt
      REAL(KIND(1d0))::pp_psiY_SPS_fxn
      REAL(KIND(1d0))::y1,y2,phi,w1
      REAL(KIND(1d0)),DIMENSION(4)::pmom
      REAL(KIND(1d0)),DIMENSION(4,4)::temp_pmom
      REAL(KIND(1d0)),DIMENSION(4,0:3)::PS_PP2PSIY
      REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
      INTEGER::init=0,nwarn,nwmax,nwri,nwri_tot,icut,nnn=0,nnntot=0,&
           pdfnumpdf,pdfnumpdf2,ivarnum
      SAVE init,nwarn,nwmax,nwri,nwri_tot,nnn,nnntot,pdfnumpdf,pdfnumpdf2,ivarnum
      REAL(KIND(1d0))::sqs,sq,pt1c,maxpt1c,y1cup,y1clow,ycollcm,mt1,mt2,pt
      SAVE sqs,sq,pt1c,maxpt1c,y1cup,y1clow,ycollcm
      REAL(KIND(1d0))::wdps,wsf,wme,wgtbr,temp1,temp2,temp21,temp3,temp4
      REAL(KIND(1d0))::exp1,exp2,Jpt2,Jy1,Jy2,xp11,xp21,scale1,scale2
      REAL(KIND(1d0))::recmax=0,recmin=0
      SAVE temp1
      INTEGER::ipip,ioffset,j
      REAL(KIND(1d0))::swapt
      LOGICAL::stable
      INCLUDE 'scalereweight_common.inc'
      !INCLUDE "pp_psipsi_dps.inc"
      IF(init.EQ.0)THEN
         wjac=1
         nwmax=0
         nwarn=0
         nwri=0
         CALL ReadElem_integer('unwevt',nwri_tot)
         CALL ReadElem_real('energy_beam1',sqs)
         ebeam(1)=ABS(sqs)
         CALL ReadElem_real('energy_beam2',sqs)
         ebeam(2)=ABS(sqs)
         IF(ABS(ebeam(1)-ebeam(2))/MAX(ebeam(1)+ebeam(2),1d-17).LT.1d-8)THEN
            absrap=absrap
            labeqcoll=.TRUE.
         ELSE
            absrap=.FALSE.
            labeqcoll=.FALSE.
         ENDIF
         sqs=2d0*DSQRT(ebeam(1)*ebeam(2)) ! we always neglect the mass of initial states
         IF(fixtarget)sqs=sqs/DSQRT(2d0)
         EBMUP1=ebeam(1)
         EBMUP2=ebeam(2)
         IF(.NOT.fixtarget)THEN
            ycollcm=DLOG(ABS(ebeam(1))/ABS(ebeam(2)))/2d0
         ELSE
            IF(ABS(ebeam(1)).GT.ABS(ebeam(2)))THEN
               fixtargetrev=.FALSE.
               ycollcm=DLOG(1d0+2d0*ABS(ebeam(1))/ABS(ebeam(2)))/2d0
               FT_M=ebeam(2)
               FT_E1=ebeam(1)
               sqs=DSQRT(sqs**2+FT_M**2)
            ELSE
               fixtargetrev=.TRUE.
               ycollcm=-DLOG(1d0+2d0*ABS(ebeam(2))/ABS(ebeam(1)))/2d0
               FT_M=ebeam(1)
               FT_E1=ebeam(2)
               sqs=DSQRT(sqs**2+FT_M**2)
            ENDIF
         ENDIF
         IF(fixtarget)THEN
           ! for fixed target, I used the fake lab frame (note it is not the true lab frame of fixed target but close to)
            IF(.NOT.fixtargetrev)THEN
               ! beam1 = (beam(1)+FT_M/2,0,0,beam(1)+FT_M/2)
               ! beam2 = (FT_M/2,0,0,-FT_M/2), FT_M=beam(2)
               EBMUP1=ebeam(1)+FT_M/2d0
               EBMUP2=ebeam(2)/2d0
            ELSE
               ! beam1 = (FT_M/2,0,0,FT_M/2),FT_M=beam(1)
               ! beam2 = (beam(2)+FT_M/2,0,0,-beam(2)-FT_M/2)
               EBMUP1=ebeam(1)/2d0
               EBMUP2=ebeam(2)+FT_M/2d0
            ENDIF
         ENDIF
         CALL ReadElem_real('minpt1c',pt1c)
         IF(psiY_ktavg.GT.0d0)THEN
            pt1c=0d0
         ENDIF
         CALL ReadElem_real('maxpt1c',maxpt1c)
         IF(psiY_ktavg.GT.0d0)THEN
            maxpt1c=-1d0
         ENDIF
         IF(maxpt1c.LT.0d0)THEN
            maxpt1c=-1d0
         ELSE
            IF(maxpt1c.LE.pt1c)THEN
               WRITE(*,*)"ERROR: the first final state was cut off by pt cut (pt1c,maxpt1c)"
               STOP
            ENDIF
         ENDIF
         CALL ReadElem_real('maxy1c',y1cup)
         IF(psiY_ktavg.GT.0d0)THEN
            y1cup=1d9
         ENDIF
         CALL ReadElem_real('miny1c',y1clow)
         IF(psiY_ktavg.GT.0d0)THEN
            y1clow=-1d9
         ENDIF
         CALL ReadElem_integer('pdf',pdfnumpdf)
         CALL ReadElem_integer('beam2_pdf',pdfnumpdf2)
         ptc(3:20)=0
         maxptc(3:20)=-1d0
         drc(3:20,3:20)=0
         etac(3:20)=20
         ec(3:20)=0
         c1(3:20)=1
         c2(3:20)=1
         cc(3:20,3:20)=1
         yycut(3:20)=1d9
         IF(absrap)THEN
            yycutlow(3:20)=0d0
         ELSE
            yycutlow(3:20)=-1d9
         ENDIF
         xFcut(3:20)=1d0
         xFcutlow(3:20)=-1d0
         gmas(3:20,3:20)=0
         gbeammass(1:2,3:20)=0
         
         parmas(0)=0
         parwid(0)=-1
         iPDFSUP1=pdfnumpdf
         IF(pdfnumpdf.EQ.0.OR.COLL_TYPE.EQ.3)THEN
            istruc=0
         ELSE
            istruc=1
         ENDIF
         IF(istruc.EQ.1)THEN
            iPDFGUP1=0
            iPDFGUP2=0
            iPDFSUP1=pdfnumpdf
            IF(pdfnumpdf2.LE.0.OR..NOT.uselhapdf)THEN
               iPDFSUP2=pdfnumpdf
            ELSE
               iPDFSUP2=pdfnumpdf2
            ENDIF
         ELSE
            iPDFGUP1=-1
            iPDFGUP2=-1
            iPDFSUP1=-1
            iPDFSUP2=-1
            reweight_pdf=.FALSE.
            ho_npdf=0
            ho_npdf2=0
         ENDIF
         IF(psiY_type.EQ.1)THEN
            alphas_power=6 ! as^6
         ELSEIF(psiY_type.EQ.2)THEN
            alphas_power=2 ! as^2*alpha^2
         ELSEIF(psiY_type.EQ.3)THEN
            alphas_power=4 ! as^4*alpha
         ELSE
            alphas_power=0 ! the mixed orders
         ENDIF
         CALL ReadElem_logic('reweight_Scale',reweight_scale)
         scale_reweight_common=reweight_scale
         IF(reweight_scale)THEN
            CALL ReadElem_real('rw_RScale_down',rw_Rscale_down)
            CALL ReadElem_real('rw_RScale_up',rw_Rscale_up)
            CALL ReadElem_real('rw_FScale_down',rw_Fscale_down)
            CALL ReadElem_real('rw_FScale_up',rw_Fscale_up)
            ho_nscale=8
            IF(rw_Rscale_down.LE.0d0.OR.rw_Rscale_up.LE.0d0.OR.&
                 rw_Fscale_down.LE.0d0.OR.rw_Fscale_up.LE.0d0)THEN
               reweight_scale=.FALSE.
               scale_reweight_common=reweight_scale
               ho_nscale=0
               WRITE(*,*)"WARNING:Scale reweighting is off."
               WRITE(*,*)"WARNING:Please make sure rw_Rscale_up, rw_Rscale_down, rw_Fscale_up, rw_Fscale_down are larger than 0."
            ENDIF
            IF(reweight_scale.AND.rw_Rscale_down.GT.rw_Rscale_up)THEN
               swapt=rw_Rscale_down
               rw_Rscale_down=rw_Rscale_up
               rw_Rscale_up=swapt
            ENDIF
            IF(reweight_scale.AND.rw_Fscale_down.GT.rw_Fscale_up)THEN
               swapt=rw_Fscale_down
               rw_Fscale_down=rw_Fscale_up
               rw_Fscale_up=swapt
            ENDIF
            rw_RScale_down_common=rw_Rscale_down
            rw_RScale_up_common=rw_Rscale_up
            rw_FScale_down_common=rw_Fscale_down
            rw_FScale_up_common=rw_Fscale_up
         ENDIF
         IF(reweight_scale)THEN
            tot_nrwgt=tot_nrwgt+ho_nscale+1
         ENDIF
         IF(reweight_scale.OR.reweight_pdf)THEN
            IF(ALLOCATED(rwgt_values))THEN
               DEALLOCATE(rwgt_values)
            ENDIF
            ALLOCATE(rwgt_values(tot_nrwgt))
         ENDIF
         IF(reweight_scale.AND.alphas_power.EQ.0)THEN
            WRITE(*,*)"WARNING:the renormalization scale reweighting it turned off"
            WRITE(*,*)"WARNING:because of the mixed orders with type = ",psiY_type
         ENDIF
         xp1=1
         xp2=1
         IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
            CALL readcuts_pp_psiY_sps
            y1cup=MIN(y1cup,yycut(3))
            y1clow=MAX(y1clow,yycutlow(3))
            IF(absrap)y1cup=ABS(y1cup)
            IF(absrap)y1clow=ABS(y1clow)
         ENDIF
         IF(NDecayChains.GT.0)CALL readcuts_Decay
         sq=sqs*sqs
         temp1=DSQRT(lamda_func(sq,mpsi(1)**2,mpsi(2)**2))/(2d0*sqs)
         IF(maxpt1c.GE.0d0)THEN
            temp1=MIN(temp1,maxpt1c)
         ENDIF
         ivarnum=3
         ivarnum=ivarnum+1
         init=1
      ENDIF
      nnntot=nnntot+1
      wdps=1d0
      pt=(temp1-pt1c)*x(3)+pt1c
      mt1=DSQRT(pt**2+mpsi(1)**2)
      mt2=DSQRT(pt**2+mpsi(2)**2)
      IF(absrap)THEN
         temp2=MIN(ACosh_p((sq+mpsi(1)**2-mpsi(2)**2)/(2d0*sqs*mt1)),y1cup)
         IF(temp2.LT.y1clow)THEN
            pp_psiY_SPS_fxn=0d0
            RETURN
         ENDIF
         y1=(2d0*x(1)-1d0)*(temp2-y1clow)+SIGN(1d0,x(1)-0.5d0)*y1clow
      ELSE
         temp2=MIN(ACosh_p((sq+mpsi(1)**2-mpsi(2)**2)/(2d0*sqs*mt1)),y1cup-ycollcm)
         temp21=MAX(-ACosh_p((sq+mpsi(1)**2-mpsi(2)**2)/(2d0*sqs*mt1)),y1clow-ycollcm)
         IF(temp2.LT.temp21)THEN
            pp_psiY_SPS_fxn=0d0
            RETURN
         ENDIF
         y1=(temp2-temp21)*x(1)+temp21 ! in collision frame
      ENDIF
      temp3=DLOG((-DEXP(-y1)*mt1+sqs)/mt2)
      temp4=temp3+DLOG((-DEXP(y1)*mt1+sqs)/mt2)
      y2=-temp3+temp4*x(2) ! in collision frame
      Jpt2=2d0*pt*(temp1-pt1c)
      IF(absrap)THEN
         Jy1=2d0*(temp2-y1clow)
      ELSE
         Jy1=temp2-temp21
      ENDIF
      Jy2=temp4
      ! The substitution of original variations
      IF(ycollcm.EQ.0d0)THEN
         xp1=(DEXP(y1)*mt1+DEXP(y2)*mt2)/sqs
         xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/sqs
      ELSE
         IF(.NOT.fixtarget)THEN
            xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2)/(2d0*ebeam(1))
            xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/(2d0*ebeam(2))
         ELSE
            IF(.NOT.fixtargetrev)THEN
               xp1=(DSINH(y1)*mt1 + DSINH(y2)*mt2)/(ebeam(1))
               xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/(ebeam(2))
            ELSE
               xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2)/(ebeam(1))
               xp2=(DSINH(-y1)*mt1+DSINH(-y2)*mt2)/(ebeam(2))
            ENDIF
         ENDIF
      ENDIF
      IF(xp1.GT.1d0.OR.xp1.LT.0d0)THEN
         WRITE(*,*)"ERROR: 0<xp1<1"
         STOP
      ENDIF
      IF(xp2.GT.1d0.OR.xp2.LT.0d0)THEN
         WRITE(*,*)"ERROR: 0<xp2<1"
         STOP
      ENDIF
      ehat=DSQRT(xp1*xp2*sq)
      wdps=wdps*xp1*xp2*Jpt2*Jy1*Jy2*3.8937966d5/(16d0*pi*ehat**4)
      exp1=xp1*ebeam(1)
      exp2=xp2*ebeam(2)
      IF(fixtarget)THEN
         IF(.NOT.fixtargetrev)THEN
            exp1=exp1+FT_M*xp1/2d0
            exp2=exp2/2d0
         ELSE
            exp2=exp2+FT_M*xp2/2d0
            exp1=exp1/2d0
         ENDIF
      ENDIF
      ! Generate the momenta of external legs
      sps_pmom(1,1:2)=0
      sps_pmom(1,3)=xp1*sqs/2d0
      sps_pmom(1,4)=xp1*sqs/2d0
      sps_pmom(2,1:2)=0
      sps_pmom(2,3)=-xp2*sqs/2d0
      sps_pmom(2,4)=xp2*sqs/2d0
      phi=2d0*pi*x(4)
      ! we choose phi=0
      !IF(lunwei2)THEN
      !   phi=2*pi*x(4)
      !ELSE
      !   phi=0d0
      !ENDIF
      sps_pmom(3,1)=pt*DCOS(phi)
      sps_pmom(3,2)=pt*DSIN(phi)
      sps_pmom(3,3)=mt1*DSINH(y1)
      sps_pmom(3,4)=mt1*DCOSH(y1)
      sps_pmom(4,1)=-pt*DCOS(phi)
      sps_pmom(4,2)=-pt*DSIN(phi)
      sps_pmom(4,3)=mt2*DSINH(y2)
      sps_pmom(4,4)=mt2*DCOSH(y2)
      ! boost from collision frame to partonic center-of-mass frame
      pmom(1:2)=0d0
      pmom(3)=-(exp1-exp2)
      pmom(4)=(exp1+exp2)
      DO j=1,4
         parton_sps_pmom(j,1:4)=sps_pmom(j,1:4)
         CALL pp_psiY_BOOSTL2(ehat,pmom,parton_sps_pmom(j,1:4))
      ENDDO
      pmom_cms_coll(1:2)=0d0
      pmom_cms_coll(3)=(exp1-exp2)
      pmom_cms_coll(4)=(exp1+exp2)
      Qval_cms_coll=ehat
      Momenta_Frame=1
      ! boost from collision frame to lab frame
      IF(.NOT.fixtarget)THEN
         pmom(3)=ebeam(1)-ebeam(2)
         pmom(4)=ebeam(1)+ebeam(2)
      ELSE
         IF(.NOT.fixtargetrev)THEN
            pmom(3)=ebeam(1)
            pmom(4)=ebeam(1)+ebeam(2)
         ELSE
            pmom(3)=-ebeam(2)
            pmom(4)=ebeam(1)+ebeam(2)
         ENDIF
      ENDIF
      pmom(1:2)=0
      IF(.NOT.labeqcoll)THEN
         pmom_coll_lab(1:4)=pmom(1:4)
         Qval_coll_lab=sqs
         DO j=1,4
            CALL Boostl(sqs,pmom,sps_pmom(j,1:4))
         ENDDO
      ELSE
         Qval_coll_lab=0d0
      ENDIF
      PS_PP2PSIY(1:4,1:3)=sps_pmom(1:4,1:3)
      PS_PP2PSIY(1:4,0)=sps_pmom(1:4,4)
      IF(psiY_ktavg.GT.0d0)THEN
         ! kt smearing
         temp_pmom(1:4,1:4)=sps_pmom(1:4,1:4)
         CALL InitKtSmearing_psiY(4,temp_pmom(1:4,1:4),sps_pmom(1:4,1:4),&
              psiY_ktavg,2)
      ENDIF
      CALL strf_pdf_pp_psiY_sps(wsf)
      wdps=wdps*wsf
      IF(wdps.LE.0d0.AND.psiY_type.LE.2)THEN
         pp_psiY_SPS_fxn=0d0
         RETURN
      ELSEIF(wdps.EQ.0d0)THEN
         pp_psiY_SPS_fxn=0d0
         RETURN
      ENDIF
      !PS_PP2PSIY(1:4,1:3)=sps_pmom(1:4,1:3)
      !PS_PP2PSIY(1:4,0)=sps_pmom(1:4,4)
      icut=1
      CALL Cuts_pp_psiY_sps(icut)
      IF(icut.EQ.0)THEN
         pp_psiY_SPS_fxn=0d0
         RETURN
      ENDIF
      CALL generate_var_fromPS(4,PS_PP2PSIY)
      IF(irun.EQ.1)THEN
         ! running of alpha_s
         CALL RunAlphas            
      ENDIF
      IF(.NOT.MCoHelicity_psiY)THEN
         DO j=ivarnum+1,varnum
            Decayran(j-ivarnum)=x(j)
         ENDDO
      ELSE
         RMCoH_psiY=x(ivarnum+1)
         DO j=ivarnum+2,varnum
            Decayran(j-ivarnum-1)=x(j)
         ENDDO
      ENDIF
      IF(.NOT.MCoHelicity_psiY)THEN
         IF(NDecayChains.GT.0)THEN
            CALL HO_Decay_pp_psiY_sps(weight_br)
            IF(weight_br.LE.0d0)THEN
               pp_psiY_SPS_fxn=0d0
               RETURN
            ENDIF
            CALL cuts_Decay_pp_psiY_sps(icut)
            IF(icut.EQ.0)THEN
               pp_psiY_SPS_fxn=0d0
               RETURN
            ENDIF
            wdps=wdps*weight_br
         ENDIF
         CALL LoopQEDME2_pp_psiY(psiY_type,wme,stable)
         IF(stability_check)THEN
            IF(.NOT.stable)THEN
               unstable_ps=unstable_ps+1
            ENDIF
            total_ps=total_ps+1
         ENDIF
      ELSE
         CALL MCoHelicity_helicitychoose_pp_psiY(psiY_type)
         IF(NDecayChains.GT.0)THEN
            CALL HO_Decay_pp_psiY_sps(weight_br)
            IF(weight_br.LE.0d0)THEN
               pp_psiY_SPS_fxn=0d0
               RETURN
            ENDIF
            CALL cuts_Decay_pp_psiY_sps(icut)
            IF(icut.EQ.0)THEN
               pp_psiY_SPS_fxn=0d0
               RETURN
            ENDIF
            wdps=wdps*weight_br
         ENDIF
         CALL MCoHelicity_loopQEDME2_pp_psiY(psiY_type,wme,stable)         
         IF(stability_check)THEN
            IF(.NOT.stable)THEN
               unstable_ps=unstable_ps+1
            ENDIF
            total_ps=total_ps+1
         ENDIF
      ENDIF
      !IF(stability_check)THEN
      !   CALL call_LoopME2_pp_psiY(wme,stable)
      !   IF(.NOT.stable)THEN
      !      unstable_ps=unstable_ps+1
      !   ENDIF
      !   total_ps=total_ps+1
      !ELSE
      !   CALL LoopME2_pp_psiY(wme)
      !ENDIF
      wdps=wdps*wme
      IF(psiY_istate(1).EQ.psiY_istate(2))THEN
         ! symmetry factor if two of them are identical
         wdps=wdps/2d0
      ENDIF
      IF(wdps.LE.0d0.AND.psiY_type.LE.2)THEN
         pp_psiY_SPS_fxn=0d0
         RETURN
      ELSEIF(wdps.EQ.0d0)THEN
         pp_psiY_SPS_fxn=0d0
         RETURN
      ENDIF
      IF(reweight_scale)THEN
         CALL pp_psiY_reweight_xsec_scale(wsf)
      ENDIF
      IF(reweight_pdf)THEN
         CALL pp_psiY_reweight_xsec_pdf(wsf)
      ENDIF
      pp_psiY_SPS_fxn=wdps
      IF(stability_check)THEN
         IF(nnn.GE.starting_untolerence.AND.&
              recmax*untolerence_factor.LT.pp_psiY_SPS_fxn)THEN
            WRITE(20456,*)"Warning:find a weird big phase space point"
            WRITE(20456,*)"(weight,previous max weight)=",pp_psiY_SPS_fxn,recmax
            WRITE(20456,*)xp1,xp2,Jpt2,Jy1,Jy2,wsf,wme,weight_br
            WRITE(20456,*)"======Big Weight Phase Space Point=========="
            DO j=1,4
               WRITE(20456,*)j,sps_pmom(j,4),sps_pmom(j,1:3)
            ENDDO
            WRITE(20456,*)"============================================"
         ENDIF
      ENDIF
      IF(lunwei2.AND.lwmax.GT.0)THEN
         w1=pp_psiY_SPS_fxn*wgt ! multiply VEGAS weight
         CALL unwei_procedure_pp_psiY_sps(w1,nwri,nwmax,nwarn)
      ENDIF
      IF(plot_output)THEN
         w1=pp_psiY_SPS_fxn*wgt
         CALL outfun_pp_psiY_sps(w1)
      ENDIF
      nnn=nnn+1
      IF(recmax.LT.pp_psiY_SPS_fxn)recmax=pp_psiY_SPS_fxn
      IF(recmin.GT.pp_psiY_SPS_fxn)recmin=pp_psiY_SPS_fxn
      IF(MOD(nnn,nprint).EQ.0)THEN
         PRINT *,"max=",recmax
         PRINT *,"min=",recmin
         IF(lunwei2.AND.lwmax.GT.1)THEN
            PRINT *,"      n_event,    n_pass,    n_total"
            PRINT *,nwri,nnn,nnntot
         ELSE
            PRINT *, "      n_pass,     n_total"
            PRINT *,nnn,nnntot
         ENDIF
      ENDIF
    END FUNCTION pp_psiY_SPS_fxn

    SUBROUTINE strf_pdf_pp_psiY_sps(wsf)
      USE CTEQ6PDF
      USE Structf_PDFs
      IMPLICIT NONE
      INTEGER::ipp=1
      INTEGER::ih=1 ! ih=1 no photon PDF, ih=2, photon from proton/anti-proton, ih=3 phton from electron/positron
      REAL(KIND(1d0)),INTENT(OUT)::wsf
      INTEGER::init=0
      LOGICAL::use_cteq6_f90=.TRUE.
      REAL(KIND=DBL),DIMENSION(-7:7)::pdflist
      SAVE init,ipp,use_cteq6_f90
      REAL(KIND(1d0))::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
                ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct
      IF(COLL_TYPE.LE.2)THEN
         IF(iPDFSUP1.EQ.iPDFSUP2)THEN
            INCLUDE "../lhapdf/call_strf_lhapdf"
         ELSE
            INCLUDE "../lhapdf/call_strf_mlhapdf"
         ENDIF
      ELSE
         WRITE(*,*)"ERROR: Cannot be here in strf_pdf_pp_psiY_sps"
         WRITE(*,*)"COLL_TYPE=",COLL_TYPE
         STOP
      ENDIF
      IF(init.EQ.0)THEN
         SELECT CASE(iPDFSUP1)
         CASE(10000)
            CALL SetCtq6f90(1)
            pdlabel='cteq6_m'
            nloop=2
            alphaQCD2=0.118d0
            use_cteq6_f90=.TRUE.
         CASE(10041)
            CALL SetCtq6f90(3)
            pdlabel='cteq6_l'
            nloop=2
            alphaQCD2=0.118d0
            use_cteq6_f90=.TRUE.
         CASE(10042)
            CALL SetCtq6f90(4)
            pdlabel='cteq6l1'
            nloop=1
            alphaQCD2=0.130d0
            use_cteq6_f90=.TRUE.
         CASE DEFAULT
            CALL pdfset_internal
            use_cteq6_f90=.FALSE.
         END SELECT
         IF(COLL_TYPE.EQ.1)THEN
            ipp=2
         ELSE
            ipp=1
         ENDIF
         init=1
      ENDIF

      call pp_psiY_setscale(scale)

      IF(reweight_scale)THEN
         IF(reweight_Fscale_phase.EQ.1)THEN
            scale=scale*rw_Fscale_up
         ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
            scale=scale*rw_Fscale_down
         ENDIF
      ENDIF

      IF(use_cteq6_f90)THEN
         glu1_ct = xp1*Ctq6Pdf_f90(0,xp1,scale)
         glu2_ct = xp2*Ctq6Pdf_f90(0,xp2,scale)
         u1_ct   = xp1*Ctq6Pdf_f90(1,xp1,scale)
         u2_ct   = xp2*Ctq6Pdf_f90(1,xp2,scale)
         d1_ct   = xp1*Ctq6Pdf_f90(2,xp1,scale)
         d2_ct   = xp2*Ctq6Pdf_f90(2,xp2,scale)
         s1_ct   = xp1*Ctq6Pdf_f90(3,xp1,scale)
         s2_ct   = xp2*Ctq6Pdf_f90(3,xp2,scale)
         c1_ct   = xp1*Ctq6Pdf_f90(4,xp1,scale)
         c2_ct   = xp2*Ctq6Pdf_f90(4,xp2,scale)
         b1_ct   = xp1*Ctq6Pdf_f90(5,xp1,scale)
         b2_ct   = xp2*Ctq6Pdf_f90(5,xp2,scale)
         ub1_ct  = xp1*Ctq6Pdf_f90(-1,xp1,scale)
         ub2_ct  = xp2*Ctq6Pdf_f90(-1,xp2,scale)
         db1_ct  = xp1*Ctq6Pdf_f90(-2,xp1,scale)
         db2_ct  = xp2*Ctq6Pdf_f90(-2,xp2,scale)
         sb1_ct  = xp1*Ctq6Pdf_f90(-3,xp1,scale)
         sb2_ct  = xp2*Ctq6Pdf_f90(-3,xp2,scale)
         cb1_ct  = xp1*Ctq6Pdf_f90(-4,xp1,scale)
         cb2_ct  = xp2*Ctq6Pdf_f90(-4,xp2,scale)
         bb1_ct  = xp1*Ctq6Pdf_f90(-5,xp1,scale)
         bb2_ct  = xp2*Ctq6Pdf_f90(-5,xp2,scale)
      ELSE
         CALL fdist(ih,xp1,scale,pdflist(-7:7))
         glu1_ct = xp1*pdflist(0)
         u1_ct   = xp1*pdflist(2)
         d1_ct   = xp1*pdflist(1)
         s1_ct   = xp1*pdflist(3)
         c1_ct   = xp1*pdflist(4)
         b1_ct   = xp1*pdflist(5)
         ub1_ct  = xp1*pdflist(-2)
         db1_ct  = xp1*pdflist(-1)
         sb1_ct  = xp1*pdflist(-3)
         cb1_ct  = xp1*pdflist(-4)
         bb1_ct  = xp1*pdflist(-5)
         CALL fdist(ih,xp2,scale,pdflist(-7:7))
         glu2_ct = xp2*pdflist(0)
         u2_ct   = xp2*pdflist(2)
         d2_ct   = xp2*pdflist(1)
         s2_ct   = xp2*pdflist(3)
         c2_ct   = xp2*pdflist(4)
         b2_ct   = xp2*pdflist(5)
         ub2_ct  = xp2*pdflist(-2)
         db2_ct  = xp2*pdflist(-1)
         sb2_ct  = xp2*pdflist(-3)
         cb2_ct  = xp2*pdflist(-4)
         bb2_ct  = xp2*pdflist(-5)
      ENDIF
      ! recover it
      IF(reweight_scale)THEN
         IF(reweight_Fscale_phase.EQ.1)THEN
            scale=scale/rw_Fscale_up
         ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
            scale=scale/rw_Fscale_down
         ENDIF
      ENDIF
      wsf=glu1_ct*glu2_ct*wjac/xp1/xp2
      IF(init.EQ.0)init=1
    END SUBROUTINE strf_pdf_pp_psiY_sps

    SUBROUTINE readcuts_pp_psiY_sps
      IMPLICIT NONE
      CHARACTER(len=24)::file
      LOGICAL::lexist
      INTEGER::iounit,flag=0,i,i1,j,j1
      REAL(KIND(1d0))::ptq,ptcharm,ptconia,ptbonia,etaq,ycq,ycqlow,etaconia,ycconia,ycconialow,ycbonia,ycbonialow
      REAL(KIND(1d0))::cutoff,xFcq,xFcqlow,xFcconia,xFcconialow,xFcbonia,xFcbonialow,etabonia
      REAL(KIND(1d0))::gbeamq,drqq,gqq,maxptq,maxptcharm,maxptconia,maxptbonia
      ! open default input file
      INQUIRE(FILE=TRIM(input_dir)//"default.inp",EXIST=lexist)
      IF(.NOT.lexist)THEN
         PRINT *,"Warning: the file default.inp does not exist ! STOP !"
         STOP
      ENDIF
      INQUIRE(FILE=TRIM(input_dir)//"default.inp",OPENED=lexist)
      IF(lexist)THEN
         INQUIRE(FILE=TRIM(input_dir)//"default.inp",NUMBER=iounit)
         IF(iounit.NE.udefault)THEN
            PRINT *,"WARNING: the default.inp has been linked with another unit ! Close and reopen !"
            CLOSE(UNIT=iounit)
            OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
         ENDIF
      ELSE
         OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
      ENDIF
      ! open user's input file
      IF(TRIM(Input_File)/="default.inp")THEN
         INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),EXIST=lexist)
         IF(.NOT.lexist)THEN
            PRINT *,"Warning: the file "//TRIM(Input_File)//" does not exist ! STOP !"
            STOP
         ENDIF
         INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),OPENED=lexist)
         IF(lexist)THEN
            INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),NUMBER=iounit)
            IF(iounit.NE.uinput)THEN
               PRINT *,"WARNING: the "//TRIM(Input_File)//" has been linked with another unit ! Close and reopen !"
               CLOSE(UNIT=iounit)
               OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
            ENDIF
         ELSE
            OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
         ENDIF
      ELSE
         flag=1
      ENDIF
      cutoff=readvalue_r("cutoffp",flag)
      PRINT *,"WARNING CUTOFF SET:",cutoff
      ptc(3:20)=cutoff
      maxptc(3:20)=-1d0
      drc(3:20,3:20)=0
      etac(3:20)=20
      yycut(3:20)=1d9
      IF(absrap)THEN
         yycutlow(3:20)=0d0
      ELSE
         yycutlow(3:20)=-1d9
      ENDIF
      xFcut(3:20)=1d0
      xFcutlow(3:20)=1d0
      xFcutflag=.FALSE.
      ec(3:20)=cutoff
      c1(3:20)=1d0
      c2(3:20)=1d0
      cc(3:20,3:20)=1d0
      gmas(3:20,3:20)=cutoff
      gbeammass(1:2,3:20)=0d0
      y1cup=30d0
      y1clow=0d0
      y1cup=readvalue_r("maxy1c",flag)
      y1clow=readvalue_r("miny1c",flag)
      ! minimum quark pt
      ptq=readvalue_r("minptq",flag)
      ! maximum quark pt
      maxptq=readvalue_r("maxptq",flag)
      ! minimum charm pt
      ptcharm=readvalue_r("minptc",flag)
      ! maximum charm pt
      maxptcharm=readvalue_r("maxptc",flag)
      ! minimum charmonia pt
      ptconia=readvalue_r("minptconia",flag)
      ! maximum charmonia pt
      maxptconia=readvalue_r("maxptconia",flag)
      ! minimum bottonia pt
      ptbonia=readvalue_r("minptbonia",flag)
      ! maximum bottonia pt
      maxptbonia=readvalue_r("maxptbonia",flag)
      ! maximum rapidity quark 
      etaq=readvalue_r("maxrapq",flag)
      ! maximum y rapidity quark
      ycq=readvalue_r("maxyrapq",flag)
      ! minimum y rapidity quark
      ycqlow=readvalue_r("minyrapq",flag)
      ! maximum Feynman parameter xF
      xFcq=readvalue_r("maxxFq",flag)
      ! minimum Feynman parameter xF
      xFcqlow=readvalue_r("minxFq",flag)
      ! maximum rapidity charmonium
      etaconia=readvalue_r("maxrapconia",flag)
      ! maximum y rapidity charmonium
      ycconia=readvalue_r("maxyrapconia",flag)
      ! minimum y rapidity charmonium
      ycconialow=readvalue_r("minyrapconia",flag)
      ! maximum Feynman parameter xF
      xFcconia=readvalue_r("maxxFconia",flag)
      ! minimum Feynman parameter xF
      xFcconialow=readvalue_r("minxFconia",flag)
      ! maximum rapidity bottomonia
      etabonia=readvalue_r("maxrapbonia",flag)
      ! maximum y rapidity bottomonia
      ycbonia=readvalue_r("maxyrapbonia",flag)
      ! minimum y rapidity bottomonia
      ycbonialow=readvalue_r("minyrapbonia",flag)
      ! maximum Feynman parameter xF
      xFcbonia=readvalue_r("maxxFbonia",flag)
      ! minimum Feynman parameter xF
      xFcbonialow=readvalue_r("minxFbonia",flag)
      ! minimum DR quark with quark
      drqq=readvalue_r("mindrqq",flag)
      ! minimum mass quark with quark
      gqq=readvalue_r("minmqqp",flag)
      ! minimum mass u,d,s quarks and gluon  with partonic beam
      gbeamq=readvalue_r("minmqbeam",flag)
      CLOSE(UNIT=udefault)
      CLOSE(UNIT=uinput)
      DO i=3,nhad
         i1=iflh(i)
         IF(iflh(i).EQ.35)i1=0
         IF(i1.EQ.0)THEN
            ptc(i)=ptq
            IF(maxptq.GE.0d0)maxptc(i)=maxptq
            etac(i)=etaq
            yycut(i)=ycq
            yycutlow(i)=ycqlow
            xFcut(i)=xFcq
            xFcutlow(i)=xFcqlow
         ELSEIF(i1.GE.440000.AND.i1.LE.449999)THEN
            ptc(i)=ptconia
            IF(maxptconia.GE.0d0)maxptc(i)=maxptconia
            etac(i)=etaconia
            yycut(i)=ycconia
            yycutlow(i)=ycconialow
            xFcut(i)=xFcconia
            xFcutlow(i)=xFcconialow
         ELSE
            ptc(i)=ptbonia
            IF(maxptbonia.GE.0d0)maxptc(i)=maxptbonia
            etac(i)=etabonia
            yycut(i)=ycbonia
            yycutlow(i)=ycbonialow
            xFcut(i)=xFcbonia
            xFcutlow(i)=xFcbonialow
         ENDIF
      ENDDO
      DO i=3,nhad-1
         i1=iflh(i)
         IF(i1.EQ.35)i1=0
         DO j=i+1,nhad
            j1=iflh(j)
            IF(j1.EQ.35)j1=0
            IF(i1.EQ.0.AND.j1.EQ.0)THEN
               drc(i,j)=drqq
               gmas(i,j)=MAX(gqq,gmas(i,j))
            ENDIF
         ENDDO
      ENDDO
      DO i=3,nhad-1
         DO j=i+1,nhad
            gmas(i,j)=MAX(gmas(i,j),DSQRT(2*ptc(i)*ptc(j)*(1-COS(drc(i,j)))))
         ENDDO
      ENDDO
      DO i=4,nhad
         DO j=3,i-1
            drc(i,j)=drc(j,i)
            gmas(i,j)=gmas(j,i)
         ENDDO
      ENDDO
      WRITE(*,*)'---------------------------------------------------'
      WRITE(*,*)'    the cuts for p p > psi Upsilon '
      WRITE(*,*)'    with loop-induced process '
      DO i=3,nhad
         WRITE(*,*)'pt     of  ',i,'   particle   ',ptc(i)
         IF(maxptc(i).GE.0d0)THEN
            WRITE(*,*)'max pt     of  ',i,'   particle   ',maxptc(i)
            IF(maxptc(i).LE.ptc(i))THEN
               WRITE(*,*)"ERROR: One of the final state ",i," was cut off by pt cut"
               STOP
            ENDIF
         ELSE
            WRITE(*,*)'no max pt cut of  ',i,'   particle  '
         ENDIF
         WRITE(*,*)'energy of  ',i,'   particle   ',ec(i)
         WRITE(*,*)'rapidity of  ',i,'   particle   ',etac(i)
         WRITE(*,*)'max y rapidity of ',i,'   particle   ',yycut(i)
         WRITE(*,*)'min y rapidity of ',i,'   particle   ',yycutlow(i)
         IF(yycut(i).LE.yycutlow(i))THEN
            WRITE(*,*)"ERROR: One of the final state ",i," was cut off by y rapidity cut"
            STOP
         ENDIF
         WRITE(*,*)'max Feynman parameter xF of ',i,' particle ',xFcut(i)
         IF(xFcut(i).LT.1d0)xFcutflag=.TRUE.
         WRITE(*,*)'min Feynman parameter xF of ',i,' particle ',xFcutlow(i)
         IF(xFcutlow(i).GT.-1d0)xFcutflag=.TRUE.
      ENDDO
      WRITE(*,*)'The maxrapidity of the first particle',y1cup
      WRITE(*,*)'The minrapidity of the first particle',y1clow
      DO i=3,nhad-1
         DO j=i+1,nhad
            WRITE(*,*)'DR     ',i,'  with  ',j,drc(i,j)
            WRITE(*,*)'mass of ',i,'  with  ',j,gmas(i,j)
         ENDDO
      ENDDO
      WRITE(*,*)'---------------------------------------------------'
    END SUBROUTINE readcuts_pp_psiY_sps

    SUBROUTINE Cuts_pp_psiY_sps(icut)
      IMPLICIT NONE
      INTEGER,INTENT(OUT)::icut
      INTEGER::l,l1,l2,flag
      REAL(KIND(1d0))::s,d1,d2,dr,pt,eta,aaa,bbb,ptcut
      REAL(KIND(1d0)),DIMENSION(4)::ponia,pboo2
      REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
      REAL(KIND(1d0))::e,q
      !INCLUDE "pp_psipsi_dps.inc"
      icut=0
      ! invariant mass cuts
      DO l1=3,nhad-1
         DO l2=l1+1,nhad
            s=2*scalar_product(sps_pmom(l1,1:4),sps_pmom(l2,1:4))&
                 +scalar_product(sps_pmom(l1,1:4),sps_pmom(l1,1:4))&
                 +scalar_product(sps_pmom(l2,1:4),sps_pmom(l2,1:4))
            IF(s.LT.gmas(l1,l2)**2)RETURN
         ENDDO
      ENDDO
      flag=0
      DO l=3,nhad
         pt=SQRT(sps_pmom(l,1)**2+sps_pmom(l,2)**2)
         IF(pt.LT.ptc(l))THEN
            flag=1
            EXIT
         ENDIF
         IF(maxptc(l).GE.0d0)THEN
            IF(pt.GT.maxptc(l))THEN
               flag=1
               EXIT
            ENDIF
         ENDIF
         eta=prapidity(sps_pmom(l,1:4))
         IF(ABS(eta).GT.etac(l))THEN
            flag=1
            EXIT
         ENDIF
         eta=rapidity(sps_pmom(l,1:4))
         IF(absrap)eta=ABS(eta)
         IF(eta.GT.yycut(l).OR.eta.LT.yycutlow(l))THEN
            flag=1
            EXIT
         ENDIF
         ! special for the first particle , which can be used to calculate the y distribution  
         IF(l.EQ.3)THEN
            IF(eta.GT.y1cup.OR.eta.LT.y1clow)THEN
               flag=1
               EXIT
            ENDIF
         ENDIF
      ENDDO
      IF(flag.EQ.0)THEN
         DO l1=3,nhad-1
            DO l2=l1+1,nhad
               d1=prapidity(sps_pmom(l1,1:4))-prapidity(sps_pmom(l2,1:4))
               d2=ph4(sps_pmom(l1,1),sps_pmom(l1,2),sps_pmom(l1,3))&
                    -ph4(sps_pmom(l2,1),sps_pmom(l2,2),sps_pmom(l2,3))
               d2=MIN(DABS(d2),2*pi-DABS(d2))
               IF(d2/pi.GT.1d0)WRITE(*,*)d2/pi
               dr=SQRT(d1**2+d2**2)
               IF(dr.LT.drc(l1,l2))THEN
                  flag=1
                  EXIT
               ENDIF
            ENDDO
            IF(flag.EQ.1)EXIT
         ENDDO
         IF(flag.EQ.0)icut=1
      ENDIF
      ! special cutoffs in the literature
      IF(icut.EQ.1.AND.flag.EQ.0)THEN
         IF(literature_cutoffs.EQ.14060484.OR.literature_cutoffs.EQ.15090000)THEN
            l1=3
            DO l=3,nhad
               IF(iflh(l).GT.440001.AND.iflh(l).LT.449999)THEN
                  ! charmonia
                  ponia(1:4)=sps_pmom(l,1:4)
                  eta=rapidity(ponia(1:4))
                  IF(ABS(eta).LT.1.2d0)THEN
                     pt=SQRT(ponia(1)**2+ponia(2)**2)
                     IF(pt.LE.6.5d0)THEN
                        icut=0
                        EXIT
                     ENDIF
                  ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.1.43d0)THEN
                     pt=SQRT(ponia(1)**2+ponia(2)**2)
                     aaa=-8.695652173913045d0
                     bbb=16.934782608695656d0
                     ptcut=aaa*ABS(eta)+bbb
                     IF(pt.LE.ptcut)THEN
                        icut=0
                        EXIT
                     ENDIF
                  ELSEIF(ABS(eta).GT.1.43d0.AND.ABS(eta).LT.2.2d0)THEN
                     pt=SQRT(ponia(1)**2+ponia(2)**2)
                     IF(pt.LE.4.5d0)THEN
                        icut=0
                        EXIT
                     ENDIF
                  ELSE
                     icut=0
                     EXIT
                  ENDIF
                  l1=l1+2
               ELSEIF(ABS(iflh(l)).GT.100)THEN
                  l1=l1+2
               ELSE
                  l1=l1+1
               ENDIF
            ENDDO
         ELSEIF(literature_cutoffs.GE.160700001.AND.literature_cutoffs.LE.160700100)THEN
            ! special for the LHCb cutoff
            ! it is asked to compare with arXiv:1606.06767
            l1=3
            ponia(1:4)=0d0
            DO l=3,min(nhad,4)
               IF(ABS(iflh(l)).GT.100)THEN
                  ! quarkonium
                  ponia(1:4)=ponia(1:4)+sps_pmom(l,1:4)
                  l1=l1+2
               ELSE
                  ponia(1:4)=ponia(1:4)+sps_pmom(l,1:4)
                  l1=l1+1
               ENDIF
            ENDDO
            pt=SQRT(ponia(1)**2+ponia(2)**2)
            aaa=DBLE(literature_cutoffs-160700000)
            IF(pt.LT.aaa)THEN
               icut=0
            ENDIF
         ENDIF
      ENDIF
      IF(xFcutflag.AND.icut.EQ.1.AND.flag.EQ.0.AND.psiY_ktavg.LE.0d0)THEN
         q=ehat
         e=q/SQRT(xp1*xp2)
         IF(.NOT.labeqcoll)THEN
            IF(.NOT.fixtarget)THEN
               pboo2(4)=(ebeam(1)+ebeam(2))
               pboo2(3)=-(ebeam(1)-ebeam(2))
            ELSE
               IF(.NOT.fixtargetrev)THEN
                  pboo2(4)=(ebeam(1)+ebeam(2))
                  pboo2(3)=-ebeam(1)
               ELSE
                  pboo2(4)=(ebeam(1)+ebeam(2))
                  pboo2(3)=ebeam(2)
               ENDIF
            ENDIF
            pboo2(1:2)=0
            ! boost from the lab frame to the collision frame 
            DO l=3,nhad
               CALL boostl(e,pboo2,sps_pmom(l,1:4))
            ENDDO
         ENDIF
         DO l=3,nhad
            eta=xFeynman(sps_pmom(l,1:4),e)
            IF(eta.GT.xFcut(l).OR.eta.LT.xFcutlow(l))THEN
               icut=0
               EXIT
            ENDIF
         ENDDO
         IF(.NOT.labeqcoll)THEN
            pboo2(3)=-pboo2(3)
            ! boost back to the lab frame 
            DO l=3,nhad
               CALL boostl(e,pboo2,sps_pmom(l,1:4))
            ENDDO
         ENDIF
      ENDIF
    END SUBROUTINE Cuts_pp_psiY_sps

    SUBROUTINE HO_Decay_pp_psiY_sps(wgtbr)
      IMPLICIT NONE
      INCLUDE "stdhep_pp_psiY_sps.inc"
      INTEGER::i,j,k,kk,m,ndecay
      REAL(KIND(1d0)),INTENT(OUT)::wgtbr
      REAL(KIND(1d0))::br,r
      REAL(KIND(1d0)),DIMENSION(MAX_DecayChain)::braccum
      INTEGER::ipip
      !INCLUDE "pp_psipsi_dps.inc"
      wgtbr=1d0
      ndecay=0
      NEVHEP=1
      NHEP=nhad
      DO i=1,nhad
         ISTHEP(i)=0
         IDHEP(i)=pdgt(iflh(i))
         IF(i.GT.2.AND.i.LE.nhad)THEN
            ISHEP(i)=1
            JMOHEP(1,i)=1
            JMOHEP(2,i)=2
            JDAHEP(1,i)=0
            JDAHEP(2,i)=0
         ELSE
            ISHEP(i)=-1
            JMOHEP(1,i)=0
            JMOHEP(2,i)=0
            JDAHEP(1,i)=3
            JDAHEP(2,i)=4
         ENDIF
         PHEP(1:4,i)=sps_pmom(i,1:4)
         IF(i.EQ.3)THEN
            PHEP(5,i)=mpsi(1)
         ELSEIF(i.EQ.4)THEN
            PHEP(5,i)=mpsi(2)
         ELSE
            PHEP(5,i)=0d0
         ENDIF
         VHEP(1:4,i)=0d0
      ENDDO
      DO i=1,nhad
         j=iflh2DecayChains(i,0)
         IF(j.GT.0)THEN
            br=0d0
            braccum(1:MAX_DecayChain)=0d0
            DO k=1,j
               m=iflh2DecayChains(i,k)
               br=br+DecayBR(m)
               braccum(k)=br
            ENDDO
            ! randomly select the decay process
            IF(j.EQ.1)THEN
               kk=1
            ELSE
               ndecay=ndecay+1
               r=Decayran(ndecay)*br
               DO k=1,j
                  IF(braccum(k).GT.r)THEN
                     kk=k
                     EXIT
                  ELSEIF(k.EQ.j)THEN
                     kk=j
                     EXIT
                  ENDIF
               ENDDO
            ENDIF
            m=iflh2DecayChains(i,kk)
            CALL HO_One_Decay_pp_psiY_sps(i,m)
            wgtbr=wgtbr*br
         ENDIF
      ENDDO
      RETURN
    END SUBROUTINE HO_Decay_pp_psiY_sps

    SUBROUTINE HO_One_Decay_pp_psiY_sps(imoth,idecay)
      USE HOVll
      USE Helac_ranmar_mod
      IMPLICIT NONE
      INTEGER,INTENT(IN)::imoth,idecay
      INTEGER,PARAMETER::available_ndecay=1
      CHARACTER(len=20),DIMENSION(available_ndecay)::available_decay
      INTEGER::i,iipol
      INTEGER::lavail
      REAL(KIND(1d0)),DIMENSION(3)::svec
      REAL(KIND(1d0)),DIMENSION(0:3)::PM,PD1,PD2
      REAL(KIND(1d0)),DIMENSION(4)::PDTEMP,PDTEMP_NEW
      REAL(KIND(1d0))::probT
      INCLUDE "stdhep_pp_psiY_sps.inc"
      !INCLUDE "pp_psipsi_dps.inc"
      CALL HO_judge_avail_decay(imoth,idecay,lavail)
      IF(lavail.GT.0)THEN
         SELECT CASE(lavail)
         CASE(1)
            ! 3S11 > l+ l-
            IF(.NOT.MCoHelicity_psiY)THEN
               PM(0)=sps_pmom(imoth,4)
               PM(1:3)=sps_pmom(imoth,1:3)
               svec(1:3)=PM(1:3)
               ! unpolarized in any frame
               IF(sps_lambdath.EQ.0d0)THEN
                  CALL HO_Vll_unpolarized(PM,PD1,PD2)
               ELSEIF(sps_lambdath.GE.1d0)THEN
                  CALL HO_Vll11(PM,svec,PD1,PD2)
               ELSEIF(sps_lambdath.LE.-1d0)THEN
                  CALL HO_Vll00(PM,svec,PD1,PD2)
               ELSE
                  probT=2d0*(1d0+sps_lambdath)/(3d0+sps_lambdath)
                  IF(Helac_rnmy(0).LT.probT)THEN
                     CALL HO_Vll11(PM,svec,PD1,PD2)
                  ELSE
                     CALL HO_Vll00(PM,svec,PD1,PD2)
                  ENDIF
               ENDIF
               !IPOLHEP(JMOHEP(1,NHEP+1))=99
            ELSE
               PM(0)=parton_sps_pmom(imoth,4)
               PM(1:3)=parton_sps_pmom(imoth,1:3)
               svec(1:3)=PM(1:3)
               iipol=GOODHEL_PROJ_psiY(current_hel_psiY,imoth)
               IF(iipol.EQ.3)THEN
                  ! it is long
                  CALL HO_Vll00(PM,svec,PD1,PD2)
                  !IPOLHEP(JMOHEP(1,NHEP+1))=0
               ELSE
                  ! it is transverse
                  CALL HO_Vll11(PM,svec,PD1,PD2)
                  !IF(iipol.EQ.1)THEN
                  !   IPOLHEP(JMOHEP(1,NHEP+1))=1
                  !ELSE
                  !   IPOLHEP(JMOHEP(1,NHEP+1))=-1
                  !ENDIF
               ENDIF
               ! boost from cms to lab frame
               PDTEMP(1:3)=PD1(1:3)
               PDTEMP(4)=PD1(0)
               CALL BOOST(Qval_cms_coll,pmom_cms_coll,PDTEMP(1:4),&
                    PDTEMP_NEW(1:4))
               PD1(0)=PDTEMP_NEW(4)
               PD1(1:3)=PDTEMP_NEW(1:3)
               PDTEMP(1:3)=PD2(1:3)
               PDTEMP(4)=PD2(0)
               CALL BOOST(Qval_cms_coll,pmom_cms_coll,PDTEMP(1:4),&
                    PDTEMP_NEW(1:4))
               PD2(0)=PDTEMP_NEW(4)
               PD2(1:3)=PDTEMP_NEW(1:3)
               ! boost from collision frame to lab frame
               IF(Qval_coll_lab.GT.0d0)THEN
                  PDTEMP(1:3)=PD1(1:3)
                  PDTEMP(4)=PD1(0)
                  CALL BOOST(Qval_coll_lab,pmom_coll_lab,PDTEMP(1:4),&
                       PDTEMP_NEW(1:4))
                  PD1(0)=PDTEMP_NEW(4)
                  PD1(1:3)=PDTEMP_NEW(1:3)
                  PDTEMP(1:3)=PD2(1:3)
                  PDTEMP(4)=PD2(0)
                  CALL BOOST(Qval_coll_lab,pmom_coll_lab,PDTEMP(1:4),&
                       PDTEMP_NEW(1:4))
                  PD2(0)=PDTEMP_NEW(4)
                  PD2(1:3)=PDTEMP_NEW(1:3)
               ENDIF
               ! kt smearing
               IF(psiY_ktavg.GT.0d0)THEN
                  PDTEMP(1:3)=PD1(1:3)
                  PDTEMP(4)=PD1(0)
                  CALL BOOST(Qval_ktsmearing,pmom_ktsmearing,PDTEMP(1:4),&
                       PDTEMP_NEW(1:4))
                  PD1(0)=PDTEMP_NEW(4)
                  PD1(1:3)=PDTEMP_NEW(1:3)
                  PDTEMP(1:3)=PD2(1:3)
                  PDTEMP(4)=PD2(0)
                  CALL BOOST(Qval_ktsmearing,pmom_ktsmearing,PDTEMP(1:4),&
                       PDTEMP_NEW(1:4))
                  PD2(0)=PDTEMP_NEW(4)
                  PD2(1:3)=PDTEMP_NEW(1:3)
               ENDIF
            ENDIF
            ISTHEP(imoth)=1
            ISHEP(NHEP+1)=1
            ISHEP(NHEP+2)=1
            ISTHEP(NHEP+1)=0
            ISTHEP(NHEP+2)=0
            IDHEP(NHEP+1)=pdgt(DecayChains(idecay,1))
            IDHEP(NHEP+2)=pdgt(DecayChains(idecay,2))
            JMOHEP(1,NHEP+1:NHEP+2)=imoth
            JMOHEP(2,NHEP+1:NHEP+2)=0
            JDAHEP(1,imoth)=NHEP+1
            JDAHEP(2,imoth)=NHEP+2
            PHEP(5,NHEP+1:NHEP+2)=0d0
            PHEP(1:3,NHEP+1)=PD1(1:3)
            PHEP(1:3,NHEP+2)=PD2(1:3)
            PHEP(4,NHEP+1)=PD1(0)
            PHEP(4,NHEP+2)=PD2(0)
            NHEP=NHEP+2
         END SELECT
      ELSE
         CALL HO_avail_decays(available_ndecay,available_decay)
         PRINT *,"Only the following decay processes are available in HELAC-Onia"
         DO i=1,available_ndecay
            PRINT *,available_decay(i)
         ENDDO
         STOP
      ENDIF
      RETURN
    END SUBROUTINE HO_One_Decay_pp_psiY_sps

    SUBROUTINE cuts_Decay_pp_psiY_sps(icut)
      ! only cut on the decay particles
      IMPLICIT NONE
      INTEGER,INTENT(OUT)::icut
      INTEGER::i,kk
      REAL(KIND(1d0))::eta,pt,c
      REAL(KIND(1d0))::ptminmuon
      INTEGER::flag
      INTEGER::muon4psiATLAS,nmuonpass1,nmuonpass2
      INCLUDE "stdhep_pp_psiY_sps.inc"
      icut=0
      flag=0
      DO i=1,NHEP
         IF(ISHEP(i).EQ.-1)CYCLE ! only cut on the final state
         IF(ISTHEP(i).EQ.1)CYCLE ! exclude the mother particles, which have been cutted before
         IF(JMOHEP(1,i).LE.0.OR.JMOHEP(1,i).GT.NHEP)CYCLE
         IF(ISTHEP(JMOHEP(1,i)).NE.1.OR.ISHEP(JMOHEP(1,i)).EQ.-1)CYCLE
         ! cut is only applied on the decay particles
         IF(lepton_pdg(IDHEP(i)))THEN
            ! cut on the leptons
            pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
            IF(pt.LT.ho_dptcl)THEN
               flag=1
               EXIT
            ENDIF
            eta=prapidity(PHEP(1:4,i))
            IF(ABS(eta).GT.ho_detacl)THEN
               flag=2
               EXIT
            ENDIF
            eta=rapidity(PHEP(1:4,i))
            IF(absrap)eta=ABS(eta)
            IF(eta.GT.ho_dycl.OR.eta.LT.ho_dycllow)THEN
               flag=3
               EXIT
            ENDIF
            IF(PHEP(4,i).LT.ho_decl)THEN
               flag=4
               EXIT
            ENDIF
            c=PHEP(3,i)/PHEP(4,i)
            IF(ABS(c).GT.ho_dcl)THEN
               flag=5
               EXIT
            ENDIF
            ! special cutoffs
            IF(literature_cutoffs.EQ.14062380)THEN
            ! DZero (arXiv:1406.2380) special cutoffs
               eta=prapidity(PHEP(1:4,i))
               IF(ABS(eta).LT.1.35d0)THEN
                  pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
                  IF(pt.LE.2d0)THEN
                     flag=6
                     EXIT
                  ENDIF
               ELSEIF(ABS(eta).LT.2d0.AND.ABS(eta).GT.1.35d0)THEN
                  IF(PHEP(4,i).LE.4d0)THEN
                     flag=7
                     EXIT
                  ENDIF
               ELSE
                  flag=8
                  EXIT
               ENDIF
            ELSEIF(literature_cutoffs.EQ.14060000)THEN
               ! ATLAS condition, speical cutoffs
               ! there is no arXiv number now
               ! At least one of the Jpsi must have two muons with pT>4 GeV each
               ! muon pT>2.5 GeV and muon |eta|<2.3
               eta=prapidity(PHEP(1:4,i))
               IF(ABS(eta).GE.2.3d0)THEN
                  flag=9
                  EXIT
               ENDIF
               pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
               IF(pt.LE.2.5d0)THEN
                  flag=10
                  EXIT
               ENDIF
               IF(IDHEP(JMOHEP(1,i)).EQ.443.AND.muon4psiATLAS.LT.2)THEN
                  IF(pt.GT.4d0)THEN
                     muon4psiATLAS=muon4psiATLAS+1
                  ELSE
                     muon4psiATLAS=muon4psiATLAS-1
                  ENDIF
               ENDIF
               IF(muon4psiATLAS.EQ.-2)muon4psiATLAS=0
            ELSEIF(literature_cutoffs.EQ.14070000)THEN
               ! CMS condition (from Junquan Tao for psi+psi) 
               eta=prapidity(PHEP(1:4,i))
               IF(ABS(eta).LT.1.2d0)THEN
                  pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
                  IF(pt.LE.3.5d0)THEN
                     flag=12
                     EXIT
                  ENDIF
               ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.1.6d0)THEN
                  ptminmuon=3.5d0-(ABS(eta)-1.2d0)*1.5d0/0.4d0
                  pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
                  IF(pt.LE.ptminmuon)THEN
                     flag=13
                     EXIT
                  ENDIF
               ELSEIF(ABS(eta).GT.1.6d0.AND.ABS(eta).LT.2.4d0)THEN
                  pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
                  IF(pt.LE.2.0d0)THEN
                     flag=14
                     EXIT
                  ENDIF
               ELSE
                  flag=15
                  EXIT
               ENDIF
            ELSEIF(literature_cutoffs.EQ.15090000)THEN
               ! the fidicuial region for CMS from
               ! Ben Weinert
               ! follow http://arxiv.org/pdf/1406.0484
               ! 3 out of 4 muons have
               ! pT(mu) >3.5 GeV/c  if |eta(mu)|<1.2
               ! pT(mu) >3.5 --> 2.0 GeV/c if 1.2< |eta(mu)|<1.6 
               ! pT(mu) >2.0 GeV/c  if 1.6<|eta(mu)|<2.4
               ! The other muon has: 
               ! pT(mu) >3.0 GeV/c  if |eta(mu)|<1.2
               ! p(mu) >3.0 GeV/c  if 1.2<|eta(mu)|<2.4
               ! The J/psi cuts F.V.:
               ! pT(J/psi) > 6.5 GeV if |y(J/psi)|<1.2
               ! pT(J/psi) > 6.5 --> 4.5 GeV if   1.2<|y(J/psi)|<1.43
               ! pT(J/psi) > 4.5 GeV if   1.43<|y(J/psi)|<2.2
               IF(IDHEP(JMOHEP(1,i)).EQ.443)THEN
                  eta=prapidity(PHEP(1:4,i))
                  pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
                  ptminmuon=3.5d0-(ABS(eta)-1.2d0)*1.5d0/0.4d0
                  IF(ABS(eta).LT.1.2d0.AND.pt.GT.3.5d0)THEN
                     nmuonpass1=nmuonpass1+1
                  ELSEIF(ABS(eta).GT.1.6d0.AND.ABS(eta).LT.2.4d0&
                       .AND.pt.GT.2.0d0)THEN
                     nmuonpass1=nmuonpass1+1
                  ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.1.6d0&
                       .AND.pt.GT.ptminmuon)THEN
                     nmuonpass1=nmuonpass1+1
                  ELSEIF(ABS(eta).LT.1.2d0.AND.pt.GT.3.0d0)THEN
                     nmuonpass2=nmuonpass2+1
                  ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.2.4d0)THEN
                     pt=SQRT(pt**2+PHEP(3,i)**2) ! it is p
                     IF(pt.GT.3d0)THEN
                        nmuonpass2=nmuonpass2+1
                     ENDIF
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
      ENDDO
       IF(flag.EQ.0)THEN
         icut=1
      ENDIF
      RETURN
    END SUBROUTINE cuts_Decay_pp_psiY_sps

    SUBROUTINE unwei_procedure_pp_psiY_sps(w1,nwri,nwmax,nwarn)
      IMPLICIT NONE
      REAL(KIND(1d0)),INTENT(IN)::w1
      INTEGER,INTENT(INOUT)::nwri,nwmax,nwarn
      REAL(KIND(1d0)),DIMENSION(1)::ranr
      REAL(KIND=DBL)::vtime,vspin,scale1,scalup,xwgtup,px,py,pz,p0,pmass,umax,umax1
      INTEGER::init=0,i,j,iij
      INTEGER::idup,idprup,istup,imothup1,imothup2,icol1,icol2
      LOGICAL::llwri
      !INCLUDE "pp_psipsi_dps.inc"
      SAVE init,umax,umax1
      IF(init.EQ.0)THEN
         umax=0d0
         umax1=0d0
         init=1
      ENDIF
      IF(lwmax.EQ.1)THEN
         IF(umax.LT.w1)THEN
            umax=w1
         ENDIF
         nwmax=nwmax+1
         umax1=umax
      ENDIF
      IF(lwmax.EQ.2)THEN
         IF(w1.GT.umax1)THEN
            umax1=w1
            WRITE(*,*)'WARNING:umax1,umax',umax1,umax
         ENDIF
         llwri=.FALSE.
         CALL RANDA(1,ranr)
         IF(umax*ranr(1).LT.w1)llwri=.TRUE.
         IF(umax.LT.w1)nwarn=nwarn+1
         IF(llwri)THEN
            nwri=nwri+1
            IF(NDecayChains.GT.0)THEN
               CALL unwei_writer_Decay_pp_psiY_sps
               Nevents=nwri
               RETURN
            ENDIF
            idprup=85 ! id for the process 
            xwgtup=1 !w1*10**3 !1 
            CALL pp_psiY_setscale(scalup)
            AQCDUP=alphaspsiY
            !AQEDUP=alphapsiY
            WRITE(nunit3)nhad,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
            DO i=1,nhad
               idup=pdgt(iflh(i))
               IF(i.LE.2)THEN
                  istup=-1
               ELSE
                  istup=1
               ENDIF
               imothup1=0
               imothup2=0
               IF(i.EQ.3.OR.i.EQ.4)THEN
                  imothup1=1
                  imothup2=2
               ENDIF
               IF(i.LE.2)THEN
                  icol1=icol_un(i,1)+100
                  IF(icol1.EQ.100)icol1=0
                  icol2=icol_un(i,2)+100
                  IF(icol2.EQ.100)icol2=0
               ELSE
                  icol1=icol_un(i,2)+100
                  IF(icol1.EQ.100)icol1=0
                  icol2=icol_un(i,1)+100
                  IF(icol2.EQ.100)icol2=0
               ENDIF
               px=sps_pmom(i,1)
               py=sps_pmom(i,2)
               pz=sps_pmom(i,3)
               p0=sps_pmom(i,4)
               IF(i.EQ.3)THEN
                  pmass=mpsi(1)
               ELSEIF(i.EQ.4)THEN
                  pmass=mpsi(2)
               ELSE
                  pmass=0d0
               ENDIF
               vtime=0
               vspin=9

               WRITE(nunit3)idup,istup,imothup1,imothup2,icol1,icol2&
                    ,px,py,pz,p0,pmass,vtime,vspin
            ENDDO
            IF(reweight_scale.OR.reweight_pdf)THEN
               iij=0
               IF(reweight_scale)THEN
                  DO i=1,3
                     DO j=1,3
                        iij=iij+1
                        rwgt_values(iij)=wgtxsecmu(i,j)*XWGTUP
                     ENDDO
                  ENDDO
               ENDIF
               IF(reweight_pdf)THEN
                  IF(ho_npdf.GT.0)THEN
                     DO i=0,ho_npdf
                        iij=iij+1
                        IF(i.EQ.0)THEN
                           rwgt_values(iij)=XWGTUP
                        ELSE
                           rwgt_values(iij)=XWGTUP*wgtxsecpdf(i)
                        ENDIF
                     ENDDO
                  ENDIF
                  IF(ho_npdf2.GT.0)THEN
                     DO i=0,ho_npdf2
                        iij=iij+1
                        IF(i.EQ.0)THEN
                           rwgt_values(iij)=XWGTUP
                        ELSE
                           rwgt_values(iij)=XWGTUP*wgtxsecpdf(ho_npdf+i)
                        ENDIF
                     ENDDO
                  ENDIF
               ENDIF
               IF(iij.NE.tot_nrwgt)THEN
                  WRITE(*,*)"ERROR:inconsistence for the reweigts #0 !"
                  WRITE(*,*)"tot_nrwgt=",tot_nrwgt
                  WRITE(*,*)"couting nrwgt=",iij
                  STOP
               ENDIF
               WRITE(nunit30)(rwgt_values(i),i=1,tot_nrwgt)
            ENDIF
         ENDIF
      ENDIF
      Nevents=nwri
    END SUBROUTINE unwei_procedure_pp_psiY_sps

    SUBROUTINE unwei_writer_Decay_pp_psiY_sps
      IMPLICIT NONE
      INCLUDE "stdhep_pp_psiY_sps.inc"
      INTEGER::icol1,icol2,idup,idprup,istup,imothup1,imothup2
      REAL(KIND(1d0))::px,py,pz,p0,pmass,scalup,vtime,vspin,xwgtup
      INTEGER::i,j,iij
      !INCLUDE "pp_psipsi_dps.inc"
      idprup = 85
      xwgtup=1
      call pp_psiY_setscale(scalup)
      WRITE(nunit3)NHEP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
      DO i=1,NHEP
         idup=IDHEP(i)
         istup=ISHEP(i)
         IF(ISTHEP(i).EQ.1.AND.ISHEP(i).EQ.1)THEN
            istup=2
         ENDIF
         imothup1=JMOHEP(1,i)
         imothup2=JMOHEP(2,i)
         IF(i.GT.nhad)THEN
            ! no hadronic decay
            icol1=0
            icol2=0
         ELSE
            IF(istup.LT.0)THEN
               icol1=icol_un(i,1)+100
               IF(icol1.EQ.100)icol1=0
               icol2=icol_un(i,2)+100
               IF(icol2.EQ.100)icol2=0
            ELSE
               icol1=icol_un(i,2)+100
               IF(icol1.EQ.100)icol1=0
               icol2=icol_un(i,1)+100
               IF(icol2.EQ.100)icol2=0
            ENDIF
         ENDIF
         px=PHEP(1,i)
         py=PHEP(2,i)
         pz=PHEP(3,i)
         p0=PHEP(4,i)
         pmass=PHEP(5,i)
         vtime=0
         vspin=9
         WRITE(nunit3)idup,istup,imothup1,imothup2,icol1,icol2,&
              px,py,pz,p0,pmass,vtime,vspin
      ENDDO
      IF(reweight_scale.OR.reweight_pdf)THEN
         iij=0
         IF(reweight_scale)THEN
            DO i=1,3
               DO j=1,3
                  iij=iij+1
                  rwgt_values(iij)=wgtxsecmu(i,j)*XWGTUP
               ENDDO
            ENDDO
         ENDIF
         IF(reweight_pdf)THEN
            IF(ho_npdf.GT.0)THEN
               DO i=0,ho_npdf
                  iij=iij+1
                  IF(i.EQ.0)THEN
                     rwgt_values(iij)=XWGTUP
                  ELSE
                     rwgt_values(iij)=XWGTUP*wgtxsecpdf(i)
                  ENDIF
               ENDDO
            ENDIF
            IF(ho_npdf2.GT.0)THEN
               DO i=0,ho_npdf2
                  iij=iij+1
                  IF(i.EQ.0)THEN
                     rwgt_values(iij)=XWGTUP
                  ELSE
                     rwgt_values(iij)=XWGTUP*wgtxsecpdf(ho_npdf+i)
                  ENDIF
               ENDDO
            ENDIF
         ENDIF
         IF(iij.NE.tot_nrwgt)THEN
            WRITE(*,*)"ERROR:inconsistence for the reweigts #1 !"
            WRITE(*,*)"tot_nrwgt=",tot_nrwgt
            WRITE(*,*)"couting nrwgt=",iij
            STOP
         ENDIF
         WRITE(nunit30)(rwgt_values(i),i=1,tot_nrwgt)
      ENDIF
    END SUBROUTINE unwei_writer_Decay_pp_psiY_sps

    SUBROUTINE Generate_lhe_pp_psiY_sps(n1,nevent,icase,lheversion)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::n1,nevent,icase
      CHARACTER(len=24),PARAMETER::tmp_dir="./tmp/",output_dir="./output/"
      INTEGER::i,jj,nunit4,nunit5,nunit3,nunit30
      INTEGER,INTENT(IN),OPTIONAL::lheversion
      INTEGER::used_lhever
      INTEGER,DIMENSION(:),ALLOCATABLE::rwgt_ids
      REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::rwgt_vals
      REAL(KIND(1d0)),DIMENSION(3)::Rscaleupdown,Fscaleupdown
      INTEGER::irwgt=0,irwgt2
      REAL(KIND(1d0))::xxwgt_old
      INTEGER::istop,k
      REAL(KIND(1d0))::p0,px,py,pz,SPINUP,EBMUP1,EBMUP2,XSECUP1,XSECUP2,XERRUP1,XMAXUP1,&
           XWGTUP,VTIMUP,SCALUP,PM0,AQEDUP,AQCDUP,XWGTUP2
      INTEGER::IDBMUP1,IDBMUP2,IDWTUP,NPRUP,IDPRUP,NUP,IDUP,ISTUP,IMOTHUP1,IMOTHUP2,&
           ICOLUP1,ICOLUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,LPRUP1
      INTEGER::ipip
      INCLUDE 'pdfreweight_common.inc'
      INCLUDE 'pdf2reweight_common.inc'
      INCLUDE 'scalereweight_common.inc'
      IF(PRESENT(lheversion))THEN
         IF(lheversion.GT.3.OR.lheversion.LT.0)THEN
            WRITE(*,*)"WARNING:the lhe version is not valid, lheversion=",lheversion
            WRITE(*,*)"WARNING:using the lheversion=1 !"
            used_lhever=1
         ELSE
            used_lhever=lheversion
         ENDIF
      ELSE
         used_lhever=1
      ENDIF
      nunit3=30
      CLOSE(nunit3)
      OPEN(nunit3,FILE=TRIM(tmp_dir)//'even_pp_psiY_sps.out',FORM='unformatted')
      nunit4=31
      CLOSE(nunit4)
      OPEN(nunit4,FILE=TRIM(tmp_dir)//'sample_pp_psiY_sps.init')
      nunit5=32
      CLOSE(nunit5)
      IF(scale_reweight_common.OR.pdf_reweight_common.OR.pdf2_reweight_common)THEN
         nunit30=300
         CLOSE(nunit30)
         OPEN(nunit30,FILE=TRIM(tmp_dir)//'even_rwgt_pp_psiY_sps.out',FORM='unformatted')
      ENDIF
      OPEN(nunit5,FILE=TRIM(output_dir)//'sample_pp_psiY_sps.lhe')
      SELECT CASE(used_lhever)
      CASE(1)
         WRITE(nunit5,'(A)') '<LesHouchesEvents version="1.0">'
      CASE(2)
         WRITE(nunit5,'(A)') '<LesHouchesEvents version="2.0">'
      CASE(3)
         WRITE(nunit5,'(A)') '<LesHouchesEvents version="3.0">'
      CASE DEFAULT
         WRITE(*,*)"ERROR:Unknown LHE version, ",used_lhever
         STOP
      END SELECT
      !WRITE(nunit5,'(A)') '<LesHouchesEvents version="1.0">'
      WRITE(nunit5,'(A)') '<!--'
      WRITE(nunit5,'(A)') 'File generated with HELAC-ONIA '
      WRITE(nunit5,'(A)') '-->'
      IF(scale_reweight_common.OR.pdf_reweight_common.OR.pdf2_reweight_common)THEN
         irwgt=0
         IF(scale_reweight_common)THEN
            irwgt=irwgt+9
         ENDIF
         IF(pdf_reweight_common)THEN
            irwgt=irwgt+pdf_set_max_common-pdf_set_min_common+2
         ENDIF
         IF(pdf2_reweight_common)THEN
            irwgt=irwgt+pdf2_set_max_common-pdf2_set_min_common+2
         ENDIF
         IF(ALLOCATED(rwgt_ids))THEN
            DEALLOCATE(rwgt_ids)
         ENDIF
         ALLOCATE(rwgt_ids(irwgt))
         IF(ALLOCATED(rwgt_vals))THEN
            DEALLOCATE(rwgt_vals)
         ENDIF
         ALLOCATE(rwgt_vals(irwgt))

         WRITE(nunit5,'(A)') '  <header>'
         WRITE(nunit5,'(A)') '  <initrwgt>'
         irwgt2=0
         IF(scale_reweight_common)THEN
            WRITE(nunit5,'(A)') "    <weightgroup type='scale_variation' combine='envelope'>"
            Rscaleupdown(1)=1d0
            Rscaleupdown(2)=rw_RScale_up_common
            Rscaleupdown(3)=rw_RScale_down_common
            Fscaleupdown(1)=1d0
            Fscaleupdown(2)=rw_FScale_up_common
            Fscaleupdown(3)=rw_FScale_down_common
            k=1000
            DO i=1,3
               DO jj=1,3
                  k=k+1
                  irwgt2=irwgt2+1
                  rwgt_ids(irwgt2)=k
                  WRITE(nunit5,6100)k,Rscaleupdown(i),Fscaleupdown(jj)
               ENDDO
            ENDDO
            WRITE(nunit5,'(A)') "    </weightgroup>"
         ENDIF
         IF(pdf_reweight_common)THEN
            WRITE(nunit5,'(A)') "    <weightgroup type='PDF_variation' combine='lhapdf'>"
            k=1999
            DO i=pdf_set_min_common-1,pdf_set_max_common
               k=k+1
               irwgt2=irwgt2+1
               rwgt_ids(irwgt2)=k
               WRITE(nunit5,6200)k,i
            ENDDO
            WRITE(nunit5,'(A)') "    </weightgroup>"
         ENDIF
         IF(pdf2_reweight_common)THEN
            WRITE(nunit5,'(A)') "    <weightgroup type='PDF2_variation' combine='lhapdf'>"
            k=4999
            DO i=pdf2_set_min_common-1,pdf2_set_max_common
               k=k+1
               irwgt2=irwgt2+1
               rwgt_ids(irwgt2)=k
               WRITE(nunit5,6400)k,i
            ENDDO
            WRITE(nunit5,'(A)') "    </weightgroup>"
         ENDIF
         WRITE(nunit5,'(A)') '  </initrwgt>'
         WRITE(nunit5,'(A)') '  </header>'
         IF(irwgt2.NE.irwgt)THEN
            WRITE(*,*)"ERROR:inconsistece of the number of reweights"
            WRITE(*,*)"irwgt=",irwgt
            WRITE(*,*)"irwgt2=",irwgt2
            STOP
         ENDIF
      ENDIF
      WRITE(nunit5,'(A)') '<init>'
      READ(nunit4,*)IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
      READ(nunit4,*)XSECUP1,XERRUP1,XMAXUP1,LPRUP1
      WRITE(nunit5,5000)IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
      WRITE(nunit5,5100)XSECUP1,XERRUP1,XMAXUP1,LPRUP1
      WRITE(nunit5,'(A)') '</init>'
      istop=1
      k=0
      XWGTUP2=XSECUP1/nevent
      DO WHILE(istop.EQ.1)
         k=k+1
         READ(nunit3,END=100) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
         IF(icase.EQ.1)XWGTUP=XWGTUP2
         WRITE(nunit5,'(A)') '<event>'
         WRITE(nunit5,5200) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
         ipip=1
         DO i=1,NUP
            READ(nunit3)IDUP,ISTUP,iMOTHUP1,iMOTHUP2,ICOLUP1,ICOLUP2,px,py,pz,p0,pm0,VTIMUP,SPINUP
            IF(IDUP.EQ.443.OR.IDUP.EQ.553)THEN
               IF(ipip.GT.2)THEN
                  WRITE(*,*)"ERROR:Too many psi(Upsilon) found (>2) !"
                  STOP
               ENDIF
               IF(psiY_istate(ipip).EQ.2)THEN
                  IDUP=100443 ! psi(2S)
               ELSEIF(psiY_istate(ipip).EQ.4)THEN
                  IDUP=100553 ! Y(2S)
               ELSEIF(psiY_istate(ipip).EQ.5)THEN
                  IDUP=200553 ! Y(3S)
               ENDIF
               ipip=ipip+1
            ENDIF
            WRITE(nunit5,5300)IDUP,ISTUP,iMOTHUP1,iMOTHUP2,ICOLUP1,ICOLUP2,px,py,pz,p0,pm0,VTIMUP,SPINUP
         ENDDO
         IF(irwgt.GT.0.AND.(scale_reweight_common.OR.pdf_reweight_common.OR.pdf2_reweight_common))THEN
            ! filling the rwgt
            WRITE(nunit5,'(A)') '  <rwgt>'
            READ(nunit30)(rwgt_vals(i),i=1,irwgt)
            IF(icase.EQ.1)THEN
               xxwgt_old=rwgt_vals(1)
               IF(xxwgt_old.EQ.0d0)THEN
                  xxwgt_old=1d0
               ENDIF
               DO i=1,irwgt
                  rwgt_vals(i)=rwgt_vals(i)*XWGTUP2/xxwgt_old
               ENDDO
            ENDIF
            DO i=1,irwgt
               WRITE(nunit5,6300)rwgt_ids(i),rwgt_vals(i)
            ENDDO
            WRITE(nunit5,'(A)') '  </rwgt>'
         ENDIF
         WRITE(nunit5,'(A)') '</event>'
      ENDDO
100   CONTINUE
      IF(icase.EQ.1.AND.k.NE.nevent+1)THEN
         WRITE(*,*)"WARNING:mismatching of the unweighted lhe events number ",k-1,nevent
      ENDIF
      WRITE(nunit5,'(A)') '</LesHouchesEvents>'
      CLOSE(nunit3,STATUS='delete')
      IF(scale_reweight_common.OR.pdf_reweight_common.OR.pdf2_reweight_common)THEN
         CLOSE(nunit30,STATUS='delete')
      ENDIF
      CLOSE(nunit4,STATUS='delete')
5200  FORMAT(1P,2I6,4E14.6)
5300  FORMAT(1P,I8,5I5,5E18.10,E14.6,E12.4)
5000  FORMAT(1P,2I8,2E14.6,6I8)
5100  FORMAT(1P,3E20.10,I6)
      CLOSE(nunit5,STATUS='keep')
6100  FORMAT(6x,"<weight id='",I4,"'>",1x,&
           "muR=",E11.5,1x,"muF=",E11.5,1x,'</weight>')
6200  FORMAT(6x,"<weight id='",I4,"'>",1x,&
           "pdfset=",I6,1x,"</weight>")
6300  FORMAT(4x,"<wgt id='",I4,"'>",1x,&
           E11.5,1x,"</wgt>")
6400 FORMAT(6x,"<weight id='",I4,"'>",1x,&
          "pdf2set=",I6,1x,"</weight>")
      RETURN
    END SUBROUTINE Generate_lhe_pp_psiY_sps

    SUBROUTINE RunAlphas
      IMPLICIT NONE
      REAL(KIND(1d0))::scale
      call pp_psiY_setscale(scale)
      alphaspsiY=ALPHAS(scale)
    END SUBROUTINE RunAlphas

    SUBROUTINE pp_psiY_reweight_xsec_scale(wsf0)
      IMPLICIT NONE
      REAL(KIND(1d0)),INTENT(IN)::wsf0
      REAL(KIND(1d0))::alphasc=1d0,alphasu=1d0,alphasd=1d0
      REAL(KIND(1d0)),DIMENSION(3)::R_alphas,R_pdf
      REAL(KIND(1d0))::wsfw
      INTEGER::i,j
      IF(.NOT.reweight_scale)THEN
         WRITE(*,*)"ERROR:Please set pp_psiY_reweight_scale to be T first !"
         STOP
      ENDIF
    ! reweighting for alpha_s
    IF(alphas_power.EQ.0)THEN
       alphasc=1d0
       alphasu=1d0
       alphasd=1d0
    ELSE
       CALL pp_psiY_setscale(scale)
       alphasc=ALPHAS(scale)
       alphasu=ALPHAS(scale*rw_Rscale_up)
       alphasd=ALPHAS(scale*rw_Rscale_down)
    ENDIF
    R_alphas(1)=1d0
    R_alphas(2)=(alphasu/alphasc)**alphas_power
    R_alphas(3)=(alphasd/alphasc)**alphas_power
    R_pdf(1)=1d0
    IF(istruc.EQ.1)THEN
       reweight_Fscale_phase=1 ! 1: multiply central scale * rw_Fscale_up
       CALL strf_pdf_pp_psiY_sps(wsfw)
       R_pdf(2)=wsfw/wsf0
       reweight_Fscale_phase=-1 ! -1: mutliply central scale * rw_Fscale_down
       CALL strf_pdf_pp_psiY_sps(wsfw)
       R_pdf(3)=wsfw/wsf0
       ! recover it
       reweight_Fscale_phase=0
    ELSE
       R_pdf(2:3)=1d0
    ENDIF
    wgtxsecmu(1:3,1:3)=1d0
    DO i=1,3
       wgtxsecmu(i,1:3)=R_alphas(i)
       DO j=1,3
          wgtxsecmu(i,j)=wgtxsecmu(i,j)*R_pdf(j)
       ENDDO
    END DO
    RETURN
  END SUBROUTINE pp_psiY_reweight_xsec_scale

  SUBROUTINE pp_psiY_reweight_xsec_pdf(wsf0)
    IMPLICIT NONE
    INTEGER::init=0,i
    REAL(KIND(1d0)),INTENT(IN)::wsf0
    REAL(KIND(1d0))::wsfw
    SAVE init
    IF(.NOT.reweight_pdf)THEN
       WRITE(*,*)"ERROR:Please set pp_psiY_reweight_pdf to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(MOD(ho_npdf,2).NE.0)THEN
          WRITE(*,*)'The number of error sets must be even',ho_npdf
          STOP
       ENDIF
       IF(MOD(ho_npdf2,2).NE.0)THEN
          WRITE(*,*)'The number of error sets for beam 2 must be even',ho_npdf2
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecpdf))THEN
          DEALLOCATE(wgtxsecpdf)
       ENDIF
       ALLOCATE(wgtxsecpdf(ho_npdf+ho_npdf2))
       IF(ho_npdf.GT.0)THEN
          IF(ALLOCATED(idpdf))THEN
             DEALLOCATE(idpdf)
          ENDIF
          ALLOCATE(idpdf(0:ho_npdf))
          idpdf(0)=iPDFSUP1
          idpdf(1)=ipdf_set_min
          IF(ipdf_set_max-ipdf_set_min+1.NE.ho_npdf)THEN
             WRITE(*,*)'Incorrect the number of error pdf',ho_npdf,ipdf_set_min,ipdf_set_max
             STOP
          ENDIF
          DO i=2,ho_npdf
             idpdf(i)=idpdf(1)+i-1
          ENDDO
          WRITE(*,*) 'Doing PDF reweight:'
          WRITE(*,*) 'Central set id: ',idpdf(0)
          WRITE(*,*) 'Min error set id: ',idpdf(1)
          WRITE(*,*) 'Max error set id: ',idpdf(ho_npdf)
       ENDIF
       IF(ho_npdf2.GT.0)THEN
          IF(ALLOCATED(idpdf2))THEN
             DEALLOCATE(idpdf2)
          ENDIF
          ALLOCATE(idpdf2(0:ho_npdf2))
          idpdf2(0)=iPDFSUP2
          idpdf2(1)=ipdf2_set_min
          IF(ipdf2_set_max-ipdf2_set_min+1.NE.ho_npdf2)THEN
             WRITE(*,*)'Incorrect the number of error pdf2',ho_npdf2,ipdf2_set_min,ipdf2_set_max
             STOP
          ENDIF
          DO i=2,ho_npdf2
             idpdf2(i)=idpdf2(1)+i-1
          ENDDO
          WRITE(*,*) 'Doing PDF Beam 2 reweight:'
          WRITE(*,*) 'Central set id: ',idpdf2(0)
          WRITE(*,*) 'Min error set id: ',idpdf2(1)
          WRITE(*,*) 'Max error set id: ',idpdf2(ho_npdf2)
       ENDIF
       init=1
    ENDIF
    IF(.NOT.multipdfloading)THEN
       DO i=1,ho_npdf
          INCLUDE "../../../input/lhapdf/call_initpdf"
          CALL strf_pdf_pp_psiY_sps(wsfw)
          wgtxsecpdf(i)=wsfw/wsf0
       ENDDO
    ELSE
       IF(.NOT.beams_pdf_correlation)THEN
          DO i=1,ho_npdf
             INCLUDE "../../../input/lhapdf/call_initmpdf1"
             CALL strf_pdf_pp_psiY_sps(wsfw)
             wgtxsecpdf(i)=wsfw/wsf0
          ENDDO
          INCLUDE "../../../input/lhapdf/call_initmpdf10"
          DO i=1,ho_npdf2
             INCLUDE "../../../input/lhapdf/call_initmpdf2"
             CALL strf_pdf_pp_psiY_sps(wsfw)
             wgtxsecpdf(i+ho_npdf)=wsfw/wsf0
          ENDDO
          INCLUDE "../../../input/lhapdf/call_initmpdf20"
       ELSE
          ! it is correlated for two beams
          DO i=1,ho_npdf
             INCLUDE "../../../input/lhapdf/call_initmpdf1"
             INCLUDE "../../../input/lhapdf/call_initmpdf2"
             CALL strf_pdf_pp_psiY_sps(wsfw)
             wgtxsecpdf(i)=wsfw/wsf0
          ENDDO
          INCLUDE "../../../input/lhapdf/call_initmpdf10"
          INCLUDE "../../../input/lhapdf/call_initmpdf20"
       ENDIF
       RETURN
    ENDIF
    ! recover it
    INCLUDE "../../../input/lhapdf/call_initpdf0"
    RETURN
  END SUBROUTINE pp_psiY_reweight_xsec_pdf

  SUBROUTINE pp_psiY_BOOSTL2(Q,PBOO,P)
    ! momentums are in normal representation with fourth comp is the zero comp
    ! Boost P via PBOO(PBOO^2=Q^2) to PLB,and set to P
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::Q
    REAL(KIND(1d0)),DIMENSION(4),INTENT(IN)::PBOO
    REAL(KIND(1d0)),DIMENSION(4),INTENT(INOUT)::P
    REAL(KIND(1d0)),DIMENSION(4)::PCM,PLB
    REAL(KIND(1d0))::FACT
    INTEGER::J
    PCM(1:4)=P(1:4)
    PLB(4)=(PBOO(4)*PCM(4)+PBOO(3)*PCM(3)+PBOO(2)*PCM(2)+PBOO(1)*PCM(1))/Q
    FACT=(PLB(4)+PCM(4))/(Q+PBOO(4))
    DO J=1,3
       PLB(J)=PCM(J)+FACT*PBOO(J)
    ENDDO
    P(1:4)=PLB(1:4)
  END SUBROUTINE PP_PSIY_BOOSTL2

  SUBROUTINE InitKtSmearing_psiY(NP,POLD,PNEW,ktavg,imeth)
    ! performing initial kt smearing
    IMPLICIT NONE
    INTEGER,INTENT(IN)::NP
    REAL(KIND(1d0)),DIMENSION(4,NP),INTENT(IN)::POLD
    REAL(KIND(1d0)),DIMENSION(4,NP),INTENT(OUT)::PNEW
    REAL(KIND(1d0)),INTENT(IN)::ktavg
    INTEGER,INTENT(IN)::imeth
    REAL(KIND(1d0))::wmax,val,rrr,phi,kt2,Pkt2,Etot,Ptot,ktx,kty
    REAL(KIND(1d0))::boostpx,boostpy,boostE,boostpz
    REAL(KIND(1d0)),PARAMETER::boostm = 10d0
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
    INTEGER::jj,kk
    REAL(KIND(1d0)),DIMENSION(4)::PBOO
    IF(ktavg.LE.0d0.OR.NP.LE.2)THEN
       PNEW(1:4,1:NP)=POLD(1:4,1:NP)
       RETURN
    ENDIF
    Etot=POLD(4,1)+POLD(4,2)
    IF(Etot.LE.0d0)THEN
       PNEW(1:4,1:NP)=POLD(1:4,1:NP)
       RETURN
    ENDIF
    ! Method -> 1 : Wmax*r <= W; 2 : directly,
    ! in this case one should know the analytically dG (kt) = P (kt) dkt
    val=64d0*ktavg**4-pi**2
    IF(val.GT.0d0)THEN
       wmax=16d0*ktavg**2*(8d0*ktavg**2+DSQRT(val))/pi**2
       wmax=wmax*DEXP(-1d0-DSQRT(val)/8d0/ktavg**2)
    ELSE
       wmax=1d0
    ENDIF
    ! P[kt2_] := Exp[-kt2*Pi/8/kav^2]*(1 + kt2^2)
    ! InvP[r_] := -8 kav^2/Pi *Log[r]
    boostpz=0d0
    IF(imeth.EQ.1)THEN
       jj=0
       DO WHILE(jj.LT.1)
          ! rand is an internal random generator of Fortran
          phi=2d0*pi*rand()
          kt2=DTAN(pi/2d0*rand())
          Pkt2=DEXP(-kt2*pi/8d0/ktavg**2)*(1d0+kt2**2)
          rrr=rand()
          IF(wmax*rrr.LT.Pkt2)THEN
             ptot=POLD(3,1)+POLD(3,2)
             jj=jj+1
             ktx=DSQRT(kt2)*DCOS(phi)
             kty=DSQRT(kt2)*DSIN(phi)
             boostpx=ktx/Etot*boostm
             boostpy=kty/Etot*boostm
             boostE=DSQRT(boostm**2+boostpx**2+boostpy**2+boostpz**2)
             PBOO(4)=boostE
             PBOO(1)=boostpx
             PBOO(2)=boostpy
             PBOO(3)=boostpz
             pmom_ktsmearing(1:4)=PBOO(1:4)
             Qval_ktsmearing=boostm
             DO kk=1, NP
                CALL BOOST(boostm,PBOO,POLD(1:4,kk),PNEW(1:4,kk))
             ENDDO
          ENDIF
       END DO
    ELSE
       phi=2d0*pi*rand()
       rrr=rand()
       DO WHILE(rrr.LE.0d0)
          rrr=rand()
       ENDDO
       kt2=-8d0*ktavg**2/pi*DLOG(rrr)
       ptot=POLD(3,1)+POLD(3,2)
       ktx=DSQRT(kt2)*DCOS(phi)
       kty=DSQRT(kt2)*DSIN(phi)
       boostpx=ktx/Etot*boostm
       boostpy=kty/Etot*boostm
       boostE=DSQRT(boostm**2+boostpx**2+boostpy**2+boostpz**2)
       PBOO(4)=boostE
       PBOO(1)=boostpx
       PBOO(2)=boostpy
       PBOO(3)=boostpz
       pmom_ktsmearing(1:4)=PBOO(1:4)
       Qval_ktsmearing=boostm
       DO kk=1, NP
          CALL BOOST(boostm,PBOO,POLD(1:4,kk),PNEW(1:4,kk))
       ENDDO
    ENDIF
    RETURN
  END SUBROUTINE InitKtSmearing_psiY
  END MODULE pp_psiY_SPS
