MODULE pp_psiY_global
  IMPLICIT NONE
  ! energy of charm quark
  REAL(KIND(1d0)),PUBLIC::ecpsiY
  ! energy of bottom quark
  REAL(KIND(1d0)),PUBLIC::ebpsiY
  ! maginitude of three momentum of charm quark
  REAL(KIND(1d0)),PUBLIC::pc3psiY
  ! angle between charm and gluon1 in the center of mass system of 
  ! gluon1+gluon2
  REAL(KIND(1d0)),PUBLIC::thpsiY
  ! Sqrt[s] where s the invariant mass of gluon1+gluon2
  REAL(KIND(1d0)),PUBLIC::sspsiY,shatpsiY
  ! mass of charm quark
  REAL(KIND(1d0)),PUBLIC::mcpsiY=1.55d0,mc2psiY
  ! mass of bottom quark
  REAL(KIND(1d0)),PUBLIC::mbpsiY=4.73d0,mb2psiY
  ! t,u
  REAL(KIND(1d0)),PUBLIC::tpsiY,upsiY
  ! gP
  REAL(KIND(1d0)),PUBLIC::gP11psiY,gP13psiY,gP12psiY,gP2psiY
  ! JP
  REAL(KIND(1d0)),PUBLIC::JP31psiY,JP33psiY,JP11psiY,JP12psiY,JP13psiY
  ! alpha_s
  REAL(KIND(1d0)),PUBLIC::alphaspsiY=0.2d0
  ! alpha
  REAL(KIND(1d0)),PUBLIC::alphapsiY=1d0/137d0
  ! WF@Orig
  REAL(KIND(1d0)),PUBLIC::RJ0Square=1.01d0,RU0Square=9d0
  ! gluon mass^2 with gluon mass regularization
  REAL(KIND(1d0)),PUBLIC::mg2psiY=1d-10
  ! muR
  REAL(KIND(1d0)),PUBLIC::murefpsiY=10d0
  REAL(KIND(1d0)),DIMENSION(4,4),PUBLIC::sps_pmom
  REAL(KIND(1d0)),DIMENSION(4,4),PUBLIC::parton_sps_pmom
  ! scale choice
  INTEGER,PUBLIC::dynamical_scale_choice=-1
  REAL(KIND(1d0)),PUBLIC::sps_lambdath=0d0
  INTEGER,PUBLIC::iranhel_psiY=0
  LOGICAL,PUBLIC::MCoHelicity_psiY=.FALSE.
  REAL(KIND(1d0)),DIMENSION(2),PUBLIC::mpsi
  INTEGER,DIMENSION(2),PUBLIC::psiY_istate
  ! stability test
  ! 1: every mass scale multiplied rescaling_factor=10
  ! -1: every mass scale divided by rescaling_factor=10
  LOGICAL::stability_check=.FALSE.
  INTEGER::mass_rescaling=0
  REAL(KIND(1d0)),PARAMETER::rescaling_factor=100d0
  REAL(KIND(1d0)),PARAMETER::stable_threshold=1d-3
  INTEGER::unstable_ps=0,total_ps=0
  REAL(KIND(1d0)),PARAMETER::untolerence_factor=10d0
  INTEGER,PARAMETER::starting_untolerence=50000
  ! calculation type
  INTEGER,PUBLIC::psiY_type=1
  ! 0, |QED amplitude+loop amplitude|^2
  ! 1, |loop amplitude|^2
  ! 2, |QED amplitudue|^2
  ! 3, QED amplitude*loop amplitude
  ! 4, |loop amplitude|^2+QED amplitude*loop amplitude
  ! 5, |QED amplitude|^2+QED amplitude*loop amplitude
  ! 6, |loop amplitude|^2+|QED amplitudue|^2
  ! kt smearing
  REAL(KIND(1d0))::psiY_ktavg=0d0
  ! MC over helicity
  LOGICAL,DIMENSION(2,2,3,3)::GoodHel_psiY
  INTEGER::NGOODHEL_psiY
  INTEGER,DIMENSION(36,4)::GOODHEL_PROJ_psiY
  REAL(KIND(1d0))::RMCoH_psiY
  INTEGER::current_hel_psiY=0
  ! BOOST FROM CMS to collision frame
  REAL(KIND(1d0)),DIMENSION(4)::pmom_cms_coll
  REAL(KIND(1d0))::Qval_cms_coll
  ! BOOST FROM collision frame to lab frame
  REAL(KIND(1d0)),DIMENSION(4)::pmom_coll_lab
  REAL(KIND(1d0))::Qval_coll_lab
  ! SMEARING
  REAL(KIND(1d0)),DIMENSION(4)::pmom_ktsmearing
  REAL(KIND(1d0))::Qval_ktsmearing
END MODULE pp_psiY_global
