MODULE pp_psiY_loop
  IMPLICIT NONE
CONTAINS
  SUBROUTINE generate_var_fromPS(NEXTERNAL,PS)
    USE pp_psiY_global
    IMPLICIT NONE
    INTEGER,INTENT(IN)::NEXTERNAL
    REAL(KIND(1d0)),DIMENSION(NEXTERNAL,0:3),INTENT(IN)::PS
    REAL(KIND(1d0))::dcosth,dcotth,dsinth,pgluon1pcharm
    REAL(KIND(1d0)),DIMENSION(0:3)::PSINIT,PSCHARM
    INTEGER::I
    PSINIT(0:3)=PS(1,0:3)+PS(2,0:3)
    PSCHARM(0:3)=0.5d0*PS(3,0:3)
    pgluon1pcharm=PSCHARM(0)*PS(1,0)-PSCHARM(1)*PS(1,1)&
         -PSCHARM(2)*PS(1,2)-PSCHARM(3)*PS(1,3)
    shatpsiY=PSINIT(0)**2-PSINIT(1)**2-PSINIT(2)**2-PSINIT(3)**2
    sspsiY=DSQRT(DABS(shatpsiY))
    ecpsiY=0.5d0*(sspsiY**2-4d0*mbpsiY**2+4d0*mcpsiY**2)/2d0/sspsiY
    ebpsiY=0.5d0*(sspsiY**2+4d0*mbpsiY**2-4d0*mcpsiY**2)/2d0/sspsiY
    pc3psiY=0.5d0*(sspsiY**2-4d0*mbpsiY**2+4d0*mcpsiY**2)/2d0/sspsiY
    pc3psiY=pc3psiY**2-mcpsiY**2
    IF(pc3psiY.LT.0d0)THEN
       WRITE(*,*)"The wrong setup because of shat is too small"
       WRITE(*,*)"shat=",shatpsiY
       WRITE(*,*)"MB=",mbpsiY
       WRITE(*,*)"MC=",mcpsiY
       WRITE(*,*)"================THE MOMENTA==========="
       DO I=1,4
          WRITE(*,*)I,PS(I,0:3)
       ENDDO
       WRITE(*,*)"======================================"
       STOP
    ENDIF
    pc3psiY=DSQRT(pc3psiY)
    dcosth=(ecpsiY*sspsiY-2d0*pgluon1pcharm)/sspsiY/pc3psiY
    !dcosth=DCOS(thpsiY)
    thpsiY=DACOS(dcosth)
    dcotth=1d0/DTAN(thpsiY)
    dsinth=DSIN(thpsiY)
    tpsiY=4d0*mcpsiY**2-2d0*ecpsiY*sspsiY+2d0*pc3psiY*sspsiY*dcosth
    upsiY=-2d0*(-2d0*mbpsiY**2+ebpsiY*sspsiY+pc3psiY*sspsiY*dcosth)
    gP11psiY=-2d0*pc3psiY*dcotth+2d0*ebpsiY/dsinth
    gP11psiY=gP11psiY/pc3psiY/sspsiY
    gP12psiY=2d0*dcotth/sspsiY
    gP13psiY=-2d0/pc3psiY/sspsiY*(ecpsiY+pc3psiY*dcosth)/dsinth
    gP2psiY=4d0/dsinth/pc3psiY/sspsiY**2
    JP31psiY=2d0*(ebpsiY*ecpsiY+pc3psiY**2)/mcpsiY/pc3psiY/sspsiY
    JP33psiY=-2d0*mcpsiY/pc3psiY/sspsiY
    JP11psiY=2d0*(pc3psiY-ebpsiY*dcosth)/dsinth/pc3psiY/sspsiY
    JP12psiY=-2d0/sspsiY/dsinth
    JP13psiY=2d0*(pc3psiY+ecpsiY*dcosth)/dsinth/pc3psiY/sspsiY
    RETURN
  END SUBROUTINE generate_var_fromPS

  SUBROUTINE rescaling_masses_test
    USE pp_psiY_global
    IMPLICIT NONE
    IF(mass_rescaling.EQ.0)RETURN
    IF(mass_rescaling.EQ.1)THEN
       mbpsiY=mbpsiY*rescaling_factor
       mcpsiY=mcpsiY*rescaling_factor
       mc2psiY=mc2psiY*rescaling_factor**2
       mb2psiY=mb2psiY*rescaling_factor**2
       shatpsiY=shatpsiY*rescaling_factor**2
       sspsiY=sspsiY*rescaling_factor
       ecpsiY=ecpsiY*rescaling_factor
       ebpsiY=ebpsiY*rescaling_factor
       pc3psiY=pc3psiY*rescaling_factor
       tpsiY=tpsiY*rescaling_factor**2
       upsiY=upsiY*rescaling_factor**2
       gP11psiY=gP11psiY/rescaling_factor
       gP12psiY=gP12psiY/rescaling_factor
       gP13psiY=gP13psiY/rescaling_factor
       gP2psiY=gP2psiY/rescaling_factor**3
       JP31psiY=JP31psiY/rescaling_factor
       JP33psiY=JP33psiY/rescaling_factor
       JP11psiY=JP11psiY/rescaling_factor
       JP12psiY=JP12psiY/rescaling_factor
       JP13psiY=JP13psiY/rescaling_factor
       mg2psiY=mg2psiY*rescaling_factor**2
       murefpsiY=murefpsiY*rescaling_factor
       RJ0Square=RJ0Square*rescaling_factor**3
       RU0Square=RU0Square*rescaling_factor**3
    ELSE
       mbpsiY=mbpsiY/rescaling_factor
       mcpsiY=mcpsiY/rescaling_factor
       mc2psiY=mc2psiY/rescaling_factor**2
       mb2psiY=mb2psiY/rescaling_factor**2
       shatpsiY=shatpsiY/rescaling_factor**2
       sspsiY=sspsiY/rescaling_factor
       ecpsiY=ecpsiY/rescaling_factor
       ebpsiY=ebpsiY/rescaling_factor
       pc3psiY=pc3psiY/rescaling_factor
       tpsiY=tpsiY/rescaling_factor**2
       upsiY=upsiY/rescaling_factor**2
       gP11psiY=gP11psiY*rescaling_factor
       gP12psiY=gP12psiY*rescaling_factor
       gP13psiY=gP13psiY*rescaling_factor
       gP2psiY=gP2psiY*rescaling_factor**3
       JP31psiY=JP31psiY*rescaling_factor
       JP33psiY=JP33psiY*rescaling_factor
       JP11psiY=JP11psiY*rescaling_factor
       JP12psiY=JP12psiY*rescaling_factor
       JP13psiY=JP13psiY*rescaling_factor
       mg2psiY=mg2psiY/rescaling_factor**2
       murefpsiY=murefpsiY/rescaling_factor
       RJ0Square=RJ0Square/rescaling_factor**3
       RU0Square=RU0Square/rescaling_factor**3       
    ENDIF
    RETURN
  END SUBROUTINE rescaling_masses_test

  SUBROUTINE MCoHelicity_loopQEDME2_pp_psiY(itype,me2,stable)
    USE pp_psiY_global
    IMPLICIT NONE
    LOGICAL,INTENT(OUT)::stable
    INTEGER,INTENT(IN)::itype
    REAL(KIND(1d0)),INTENT(OUT)::me2
    INTEGER::hg1,hg2,hJ,hU
    hg1=GOODHEL_PROJ_psiY(current_hel_psiY,1)
    hg2=GOODHEL_PROJ_psiY(current_hel_psiY,2)
    hJ=GOODHEL_PROJ_psiY(current_hel_psiY,3)
    hU=GOODHEL_PROJ_psiY(current_hel_psiY,4)
    CALL LoopQEDHelME2_pp_psiY(hg1,hg2,hJ,hU,itype,me2,stable)
    me2=me2*DBLE(NGOODHEL_psiY)
    RETURN
  END SUBROUTINE MCoHelicity_loopQEDME2_pp_psiY

  SUBROUTINE MCoHelicity_helicitychoose_pp_psiY(itype)
    USE pp_psiY_global
    IMPLICIT NONE
    INTEGER,INTENT(IN)::itype
    LOGICAL::stable
    !REAL(KIND(1d0)),INTENT(OUT)::me2
    INTEGER::init=0
    REAL(KIND(1d0))::wme
    SAVE init
    INTEGER::hg1,hg2,hJ,hU
    IF(init.EQ.0)THEN
       NGOODHEL_psiY=0
       DO hg1=1,2
          DO hg2=1,2
             DO hJ=1,3
                DO hU=1,3
                   GoodHel_psiY(hg1,hg2,hJ,hU)=.TRUE.
                   CALL LoopQEDHelME2_pp_psiY(hg1,hg2,hJ,hU,itype,wme,stable)
                   IF(wme.EQ.0d0)THEN
                      GoodHel_psiY(hg1,hg2,hJ,hU)=.FALSE.
                   ELSE
                      NGOODHEL_psiY=NGOODHEL_psiY+1
                      GOODHEL_PROJ_psiY(NGOODHEL_psiY,1)=hg1
                      GOODHEL_PROJ_psiY(NGOODHEL_psiY,2)=hg2
                      GOODHEL_PROJ_psiY(NGOODHEL_psiY,3)=hJ
                      GOODHEL_PROJ_psiY(NGOODHEL_psiY,4)=hU
                   ENDIF
                ENDDO
             ENDDO
          ENDDO
       ENDDO
       init=1
    ENDIF
    current_hel_psiY=INT(RMCoH_psiY*NGOODHEL_psiY)+1
    !hg1=GOODHEL_PROJ_psiY(current_hel_psiY,1)
    !hg2=GOODHEL_PROJ_psiY(current_hel_psiY,2)
    !hJ=GOODHEL_PROJ_psiY(current_hel_psiY,3)
    !hU=GOODHEL_PROJ_psiY(current_hel_psiY,4)
    !CALL LoopQEDHelME2_pp_psiY(hg1,hg2,hJ,hU,itype,me2)
    !me2=me2*DBLE(NGOODHEL_psiY)
    RETURN
  END SUBROUTINE MCoHelicity_helicitychoose_pp_psiY

  SUBROUTINE LoopQEDHelME2_pp_psiY(hg1,hg2,hJ,hU,itype,me2,stable)
    ! It has been multiplied with the initial color and spin average factor 
    ! g g > psi + Y at QED amplitude*loop amplitude 
    ! itype: 0, |QED amplitude+loop amplitude|^2
    ! itype: 1, |loop amplitude|^2 
    ! itype: 2, |QED amplitudue|^2
    ! itype: 3, QED amplitude*loop amplitude
    ! itype: 4, |loop amplitude|^2+QED amplitude*loop amplitude
    ! itype: 5, |QED amplitude|^2+QED amplitude*loop amplitude
    ! itype: 6, |loop amplitude|^2+|QED amplitudue|^2
    USE pp_psiY_global
    IMPLICIT NONE
    LOGICAL,INTENT(OUT)::stable
    REAL(KIND(1d0)),INTENT(OUT)::me2
    INTEGER,INTENT(IN)::itype
    REAL(KIND(1d0))::temp_me2
    INTEGER,PARAMETER::DDBL=SELECTED_REAL_KIND(p=13)
    COMPLEX(KIND=DDBL)::qedamps,loopamps
    INTEGER,INTENT(IN)::hg1,hg2,hJ,hU
    REAL(KIND(1d0))::AmptotFactor_QED,AmptotFactor_loop
    REAL(KIND(1d0))::ampSquareFactor_QED2,ampSquareFactor_loop2,ampSquareFactor_QEDloop
    REAL(KIND(1d0)),PARAMETER::pipi=3.1415926535897932385d0
    IF(itype.EQ.1)THEN
       IF(stability_check)THEN
          CALL call_LoopHelME2_pp_psiY(hg1,hg2,hJ,hU,me2,stable)
       ELSE
          CALL LoopHelME2_pp_psiY(hg1,hg2,hJ,hU,me2)
          stable=.TRUE.
       ENDIF
       RETURN
    ENDIF
    IF(itype.EQ.2)THEN
       CALL QEDHelME2_pp_psiY(hg1,hg2,hJ,hU,me2)
       stable=.TRUE.
       RETURN
    ENDIF
    stable=.TRUE.
    call QEDAmpHel(hg1,hg2,hJ,hU,qedamps)
    call LoopAmpHel(hg1,hg2,hJ,hU,loopamps)
    AmptotFactor_QED=16d0*DSQRT(2d0)*pipi**2*alphaspsiY*alphapsiY
    AmptotFactor_loop=10d0/9d0*DSQRT(2d0)*pipi*alphaspsiY**3*mbpsiY*mcpsiY
    ampSquareFactor_QED2=AmptotFactor_QED**2*RJ0Square*RU0Square/(4d0*pipi)**2&
         /(64d0*mcpsiY**3*mbpsiY**3)/64d0/4d0
    ampSquareFactor_loop2=AmptotFactor_loop**2*RJ0Square*RU0Square/(4d0*pipi)**2&
         /(64d0*mcpsiY**3*mbpsiY**3)/64d0/4d0
    ampSquareFactor_QEDloop=AmptotFactor_QED*AmptotFactor_loop*RJ0Square*RU0Square/(4d0*pipi)**2&
         /(64d0*mcpsiY**3*mbpsiY**3)/64d0/4d0
    me2=0d0
    IF(itype.EQ.0.OR.itype.EQ.5.OR.itype.EQ.6)THEN
       temp_me2=qedamps*DCONJG(qedamps)
       me2=me2+temp_me2*ampSquareFactor_QED2
    ENDIF
    IF(itype.EQ.0.OR.itype.EQ.4.OR.itype.EQ.6)THEN
       temp_me2=loopamps*DCONJG(loopamps)
       me2=me2+temp_me2*ampSquareFactor_loop2
       IF(itype.EQ.6)RETURN
    ENDIF
    IF(itype.EQ.0.OR.itype.EQ.3.OR.itype.EQ.4.OR.itype.EQ.6)THEN
       temp_me2=2d0*DBLE(qedamps*DCONJG(loopamps))
       me2=me2+temp_me2*ampSquareFactor_QEDloop
       RETURN
    ENDIF
    WRITE(*,*)"ERROR:Unknown itype=",itype
    STOP
  END SUBROUTINE LoopQEDHelME2_pp_psiY

  SUBROUTINE LoopQEDME2_pp_psiY(itype,me2,stable)
    ! It has been multiplied with the initial color and spin average factor
    ! g g > psi + Y at QED amplitude*loop amplitude
    ! itype: 0, |QED amplitude+loop amplitude|^2
    ! itype: 1, |loop amplitude|^2
    ! itype: 2, |QED amplitudue|^2
    ! itype: 3, QED amplitude*loop amplitude
    ! itype: 4, |loop amplitude|^2+QED amplitude*loop amplitude
    ! itype: 5, |QED amplitude|^2+QED amplitude*loop amplitude
    ! itype: 6, |loop amplitude|^2+|QED amplitudue|^2
    USE pp_psiY_global
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(OUT)::me2
    LOGICAL,INTENT(OUT)::stable
    INTEGER,INTENT(IN)::itype
    REAL(KIND(1d0))::temp_me2
    INTEGER,PARAMETER::DDBL=SELECTED_REAL_KIND(p=13)
    COMPLEX(KIND=DDBL),DIMENSION(2,2,3,3)::qedamps,loopamps
    INTEGER::hg1,hg2,hJ,hU
    REAL(KIND(1d0))::AmptotFactor_QED,AmptotFactor_loop
    REAL(KIND(1d0))::ampSquareFactor_QED2,ampSquareFactor_loop2,ampSquareFactor_QEDloop
    REAL(KIND(1d0)),PARAMETER::pipi=3.1415926535897932385d0
    IF(itype.EQ.1)THEN
       IF(stability_check)THEN
          CALL call_LoopME2_pp_psiY(me2,stable)
          RETURN
       ELSE
          CALL LoopME2_pp_psiY(me2)
          stable=.TRUE.
          RETURN
       ENDIF
    ENDIF
    IF(itype.EQ.2)THEN
       stable=.TRUE.
       CALL QEDME2_pp_psiY(me2)
       RETURN
    ENDIF
    ! I decide not to perform the stability check
    ! for the not loop-induced only
    stable=.TRUE.
    call QEDAmp(qedamps)
    call LoopAmp(loopamps)
    AmptotFactor_QED=16d0*DSQRT(2d0)*pipi**2*alphaspsiY*alphapsiY
    AmptotFactor_loop=10d0/9d0*DSQRT(2d0)*pipi*alphaspsiY**3*mbpsiY*mcpsiY
    ampSquareFactor_QED2=AmptotFactor_QED**2*RJ0Square*RU0Square/(4d0*pipi)**2&
         /(64d0*mcpsiY**3*mbpsiY**3)/64d0/4d0
    ampSquareFactor_loop2=AmptotFactor_loop**2*RJ0Square*RU0Square/(4d0*pipi)**2&
         /(64d0*mcpsiY**3*mbpsiY**3)/64d0/4d0
    ampSquareFactor_QEDloop=AmptotFactor_QED*AmptotFactor_loop*RJ0Square*RU0Square/(4d0*pipi)**2&
         /(64d0*mcpsiY**3*mbpsiY**3)/64d0/4d0
    me2=0d0
    IF(itype.EQ.0.OR.itype.EQ.5.OR.itype.EQ.6)THEN
       temp_me2=0d0
       DO hg1=1,2
          DO hg2=1,2
             DO hJ=1,3
                DO hU=1,3
                   temp_me2=temp_me2+qedamps(hg1,hg2,hJ,hU)&
                        *DCONJG(qedamps(hg1,hg2,hJ,hU))
                ENDDO
             ENDDO
          ENDDO
       ENDDO
       me2=me2+temp_me2*ampSquareFactor_QED2
    ENDIF
    IF(itype.EQ.0.OR.itype.EQ.4.OR.itype.EQ.6)THEN
       temp_me2=0d0
       DO hg1=1,2
          DO hg2=1,2
             DO hJ=1,3
                DO hU=1,3
                   temp_me2=temp_me2+loopamps(hg1,hg2,hJ,hU)&
                        *DCONJG(loopamps(hg1,hg2,hJ,hU))
                ENDDO
             ENDDO
          ENDDO
       ENDDO
       me2=me2+temp_me2*ampSquareFactor_loop2
       IF(itype.EQ.6)RETURN
    ENDIF
    IF(itype.EQ.0.OR.itype.EQ.3.OR.itype.EQ.4.OR.itype.EQ.6)THEN
       temp_me2=0d0
       DO hg1=1,2
          DO hg2=1,2
             DO hJ=1,3
                DO hU=1,3
                   temp_me2=temp_me2+2d0*DBLE(qedamps(hg1,hg2,hJ,hU)&
                        *DCONJG(loopamps(hg1,hg2,hJ,hU)))
                ENDDO
             ENDDO
          ENDDO
       ENDDO
       me2=me2+temp_me2*ampSquareFactor_QEDloop
       RETURN
    ENDIF
    WRITE(*,*)"ERROR:Unknown itype=",itype
    STOP
  END SUBROUTINE LoopQEDME2_pp_psiY

  SUBROUTINE QEDME2_pp_psiY(qedme2)
    ! It has been multiplied with the initial color and spin average factor
    ! g g > psi + Y at |QED amplitude|**2
    USE pp_psiY_global
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(OUT)::qedme2
    INTEGER,PARAMETER::DDBL=SELECTED_REAL_KIND(p=13)
    COMPLEX(KIND=DDBL),DIMENSION(2,2,3,3)::qedamps
    INTEGER::hg1,hg2,hJ,hU
    REAL(KIND(1d0))::AmptotFactor,ampSquareFactor
    REAL(KIND(1d0)),PARAMETER::pipi=3.1415926535897932385d0
    call QEDAmp(qedamps)
    qedme2=0d0
    DO hg1=1,2
       DO hg2=1,2
          DO hJ=1,3
             DO hU=1,3
                qedme2=qedme2+qedamps(hg1,hg2,hJ,hU)&
                     *DCONJG(qedamps(hg1,hg2,hJ,hU))
             ENDDO
          ENDDO
       ENDDO
    ENDDO
    ! there are two factors should be multiplied
    AmptotFactor=16d0*DSQRT(2d0)*pipi**2*alphaspsiY*alphapsiY
    ampSquareFactor=AmptotFactor**2*RJ0Square*RU0Square/(4d0*pipi)**2&
         /(64d0*mcpsiY**3*mbpsiY**3)/64d0/4d0
    qedme2=qedme2*ampSquareFactor
    RETURN
  END SUBROUTINE QEDME2_pp_psiY

  SUBROUTINE QEDHelME2_pp_psiY(hg1,hg2,hJ,hU,qedme2)
    ! It has been multipled with the initial color and spin average factor
    ! g g > psi + Y at QED amplitude with one helicity configuration
    USE pp_psiY_global
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(OUT)::qedme2
    INTEGER,PARAMETER::DDBL=SELECTED_REAL_KIND(p=13)
    COMPLEX(KIND=DDBL)::qedamps
    INTEGER,INTENT(IN)::hg1,hg2,hJ,hU
    REAL(KIND(1d0))::AmptotFactor,ampSquareFactor
    REAL(KIND(1d0)),PARAMETER::pipi=3.1415926535897932385d0
    call QEDAmpHel(hg1,hg2,hJ,hU,qedamps)
    qedme2=qedamps*DCONJG(qedamps)
    ! there are two factors should be multiplied
    AmptotFactor=16d0*DSQRT(2d0)*pipi**2*alphaspsiY*alphapsiY
    ampSquareFactor=AmptotFactor**2*RJ0Square*RU0Square/(4d0*pipi)**2&
         /(64d0*mcpsiY**3*mbpsiY**3)/64d0/4d0
    qedme2=qedme2*ampSquareFactor
    RETURN
  END SUBROUTINE QEDHelME2_pp_psiY

  SUBROUTINE LoopME2_pp_psiY(loopme2)
    ! It has been multipled with the initial color and spin average factor
    ! g g > psi + Y at one loop level
    USE pp_psiY_global
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(OUT)::loopme2
    INTEGER,PARAMETER::DDBL=SELECTED_REAL_KIND(p=13)
    COMPLEX(KIND=DDBL),DIMENSION(2,2,3,3)::loopamps
    INTEGER::hg1,hg2,hJ,hU
    REAL(KIND(1d0))::AmptotFactor,ampSquareFactor
    REAL(KIND(1d0)),PARAMETER::pipi=3.1415926535897932385d0
    !INCLUDE "print_inv.inc"
    call LoopAmp(loopamps)
    loopme2=0d0
    DO hg1=1,2
       DO hg2=1,2
          DO hJ=1,3
             DO hU=1,3
               loopme2=loopme2+loopamps(hg1,hg2,hJ,hU)&
                    *DCONJG(loopamps(hg1,hg2,hJ,hU)) 
             ENDDO
          ENDDO
       ENDDO
    ENDDO
    ! there are two factors should be multiplied
    AmptotFactor=10d0/9d0*DSQRT(2d0)*pipi*alphaspsiY**3*mbpsiY*mcpsiY
    ampSquareFactor=AmptotFactor**2*RJ0Square*RU0Square/(4d0*pipi)**2&
         /(64d0*mcpsiY**3*mbpsiY**3)/64d0/4d0
    !PRINT *, "ampSquareFactor=",ampSquareFactor
    loopme2=loopme2*ampSquareFactor
    RETURN
  END SUBROUTINE LoopME2_pp_psiY

  SUBROUTINE call_loopME2_pp_psiY(loopme2,stable)
    USE pp_psiY_global
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(OUT)::loopme2
    LOGICAL,INTENT(OUT)::stable
    REAL(KIND(1d0)),DIMENSION(2)::loopme2_tmp
    REAL(KIND(1d0))::denom,diff
    INTEGER::i
    CALL LoopME2_pp_psiY(loopme2_tmp(1))
    mass_rescaling=1
    CALL rescaling_masses_test
    CALL LoopME2_pp_psiY(loopme2_tmp(2))
    mass_rescaling=-1
    CALL rescaling_masses_test
    denom=MAX(DABS(loopme2_tmp(1)),DABS(loopme2_tmp(2)))
    denom=MAX(denom,1D-99)
    diff=DABS(loopme2_tmp(1)-loopme2_tmp(2))
    IF(diff/denom.GT.stable_threshold)THEN
       stable=.FALSE.
       WRITE(20456,*)"Warning:find an unstable phase space point"
       WRITE(20456,*)"loop ME2=",loopme2_tmp(1),loopme2_tmp(2)
       WRITE(20456,*)"======Unstable Phase Space Point=========="
       DO i=1,4
          WRITE(20456,*)i,sps_pmom(i,4),sps_pmom(i,1:3)
       ENDDO
       WRITE(20456,*)"=========================================="
       loopme2=0d0
    ELSE
       stable=.TRUE.
       loopme2=loopme2_tmp(1)
    ENDIF
    RETURN
  END SUBROUTINE call_loopME2_pp_psiY

  SUBROUTINE LoopHelME2_pp_psiY(hg1,hg2,hJ,hU,loopme2)
    ! It has been multipled with the initial color and spin average factor
    ! g g > psi + Y at one loop level with one helicity configuration
    USE pp_psiY_global
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(OUT)::loopme2
    INTEGER,PARAMETER::DDBL=SELECTED_REAL_KIND(p=13)
    COMPLEX(KIND=DDBL)::loopamps
    INTEGER,INTENT(IN)::hg1,hg2,hJ,hU
    REAL(KIND(1d0))::AmptotFactor,ampSquareFactor
    REAL(KIND(1d0)),PARAMETER::pipi=3.1415926535897932385d0
    call LoopAmpHel(hg1,hg2,hJ,hU,loopamps)
    loopme2=loopamps*DCONJG(loopamps)
    ! there are two factors should be multiplied
    AmptotFactor=10d0/9d0*DSQRT(2d0)*pipi*alphaspsiY**3*mbpsiY*mcpsiY
    ampSquareFactor=AmptotFactor**2*RJ0Square*RU0Square/(4d0*pipi)**2&
         /(64d0*mcpsiY**3*mbpsiY**3)/64d0/4d0
    loopme2=loopme2*ampSquareFactor
    RETURN
  END SUBROUTINE LoopHelME2_pp_psiY

  SUBROUTINE call_LoopHelME2_pp_psiY(hg1,hg2,hJ,hU,loopme2,stable)
    ! It has been multipled with the initial color and spin average factor
    ! g g > psi + Y at one loop level with one helicity configuration
    USE pp_psiY_global
    IMPLICIT NONE
    LOGICAL,INTENT(OUT)::stable
    REAL(KIND(1d0)),INTENT(OUT)::loopme2
    INTEGER,INTENT(IN)::hg1,hg2,hJ,hU
    REAL(KIND(1d0)),DIMENSION(2)::loopme2_tmp
    REAL(KIND(1d0))::denom,diff
    INTEGER::i
    CALL LoopHelME2_pp_psiY(hg1,hg2,hJ,hU,loopme2_tmp(1))
    mass_rescaling=1
    CALL rescaling_masses_test
    CALL LoopHelME2_pp_psiY(hg1,hg2,hJ,hU,loopme2_tmp(2))
    mass_rescaling=-1
    CALL rescaling_masses_test
    denom=MAX(DABS(loopme2_tmp(1)),DABS(loopme2_tmp(2)))
    denom=MAX(denom,1D-99)
    diff=DABS(loopme2_tmp(1)-loopme2_tmp(2))
    IF(diff/denom.GT.stable_threshold)THEN
       stable=.FALSE.
       WRITE(20456,*)"Warning:find an unstable phase space point"
       WRITE(20456,*)"loop ME2=",loopme2_tmp(1),loopme2_tmp(2)
       WRITE(20456,*)"======Unstable Phase Space Point=========="
       DO i=1,4
          WRITE(20456,*)i,sps_pmom(i,4),sps_pmom(i,1:3)
       ENDDO
       WRITE(20456,*)"=========================================="
       loopme2=0d0
    ELSE
       stable=.TRUE.
       loopme2=loopme2_tmp(1)
    ENDIF
    RETURN
  END SUBROUTINE Call_LoopHelME2_pp_psiY

  SUBROUTINE set_colorflow_pp_psiY
    USE Helac_Global
    IMPLICIT NONE
    icol_un(1,1)=1
    icol_un(1,2)=2
    icol_un(2,1)=2
    icol_un(2,2)=1
    icol_un(3:4,1:2)=0
    RETURN
  END SUBROUTINE set_colorflow_pp_psiY
END MODULE pp_psiY_loop
