HODIR=
FC=
objdir=$(HODIR)/addon/pp_psiY_SPS/obj/
moddir=$(HODIR)/addon/pp_psiY_SPS/mod/
srcdir=$(HODIR)/src/
nucdir=$(HODIR)/nuclear/
fundir=$(HODIR)/specialfuns/
thissrcdir=$(HODIR)/addon/pp_psiY_SPS/src/
decaydir=$(HODIR)/decay/
libdir=$(HODIR)/lib/
showerdir=$(HODIR)/shower/interface/
lhapdfobj=
FFDIR=$(HODIR)/vendor/looptools/install
#FFLAGS=-g -fbounds-check -ffpe-trap=invalid,zero,overflow,underflow,denormal -Wall
FFLAGS=-I$(FFDIR)/include
FFLIBS=-L$(FFDIR)/lib -looptools
obj=$(objdir)Helac_Global.o $(objdir)Helac_Func_1.o $(objdir)Constants.o $(objdir)CTEQ6PDF.o $(objdir)Kinetic_Func.o $(objdir)Structf_PDFs.o $(objdir)tbessk.o $(objdir)tbessj.o $(objdir)nielsen_generalized_polylog.o $(objdir)nintlib.o $(objdir)interpolation.o $(objdir)OpticalGlauber_Geometry.o $(objdir)ElasticPhotonPhotonFlux.o $(objdir)photon_PDFs.o $(objdir)MC_VEGAS.o $(lhapdfobj) $(objdir)DecayInfo.o $(objdir)HOVll.o $(objdir)Decay_interface.o $(objdir)alfas_functions.o $(objdir)setscale.o $(objdir)Helac_ranmar.o $(objdir)QEDPS_interface.o $(objdir)Func_PSI.o $(objdir)HO_t2bw.o $(objdir)HO_chi2psia.o pp_psiY_setscale.o pp_psiY_newfun.o pp_psiY_global.o pp_psiY_loop.o loopbasis.o helAmpCoef1111.o helAmpCoef1112.o helAmpCoef1113.o helAmpCoef1121.o helAmpCoef1122.o helAmpCoef1123.o helAmpCoef1131.o helAmpCoef1132.o helAmpCoef1133.o helAmpCoef1211.o helAmpCoef1212.o helAmpCoef1213.o helAmpCoef1221.o helAmpCoef1222.o helAmpCoef1223.o helAmpCoef1231.o helAmpCoef1232.o helAmpCoef1233.o helAmpCoef2111.o helAmpCoef2112.o helAmpCoef2113.o helAmpCoef2121.o helAmpCoef2122.o helAmpCoef2123.o helAmpCoef2131.o helAmpCoef2132.o helAmpCoef2133.o helAmpCoef2211.o helAmpCoef2212.o helAmpCoef2213.o helAmpCoef2221.o helAmpCoef2222.o helAmpCoef2223.o helAmpCoef2231.o helAmpCoef2232.o helAmpCoef2233.o LoopAmp.o LoopAmpHel.o pp_psiY_SPS.o plot_pp_psiY_sps.o  QEDhelAmp1111.o QEDhelAmp1112.o QEDhelAmp1113.o QEDhelAmp1121.o QEDhelAmp1122.o QEDhelAmp1123.o QEDhelAmp1131.o QEDhelAmp1132.o QEDhelAmp1133.o QEDhelAmp1211.o QEDhelAmp1212.o QEDhelAmp1213.o QEDhelAmp1221.o QEDhelAmp1222.o QEDhelAmp1223.o QEDhelAmp1231.o QEDhelAmp1232.o QEDhelAmp1233.o QEDhelAmp2111.o QEDhelAmp2112.o QEDhelAmp2113.o QEDhelAmp2121.o QEDhelAmp2122.o QEDhelAmp2123.o QEDhelAmp2131.o QEDhelAmp2132.o QEDhelAmp2133.o QEDhelAmp2211.o QEDhelAmp2212.o QEDhelAmp2213.o QEDhelAmp2221.o QEDhelAmp2222.o QEDhelAmp2223.o QEDhelAmp2231.o QEDhelAmp2232.o QEDhelAmp2233.o QEDAmpHel.o QEDAmp.o
mod = $(moddir)*.mod
exe = $(HODIR)/bin/HO_pp_psiY_SPS
linkexe = $(HODIR)/addon/pp_psiY_SPS/bin/HO_pp_psiY_SPS
check = $(HODIR)/bin/check_pp_psiY_SPS
linkcheck = $(HODIR)/addon/pp_psiY_SPS/bin/check_pp_psiY_SPS
EXLIBS = 

ifneq ("$(wildcard $(HODIR)/vendor/looptools/install/lib/libooptools.a)","")
      makelooptools = 
else
      makelooptools = makefile_looptools
endif 

all:    clean $(exe)
	ln -s $(exe) $(linkexe)

$(exe): $(makelooptools) $(obj) Main_pp_psiY_SPS.o
	@cp *.o $(objdir)
	@cp *.mod $(moddir)
	@$(FC) -o $(exe) $(obj) Main_pp_psiY_SPS.o -L$(libdir) -lpdf -lhbook -lqedps -lminuit $(EXLIBS) $(FFLIBS)
	@rm *.o *.mod

check:  clean $(check)
	ln -s $(check) $(linkcheck)

$(check): $(makelooptools) $(obj) pp_psiY_check.o
	  @cp *.o $(objdir)
	  @cp *.mod $(moddir)
	  @$(FC) -o $(check) $(obj) pp_psiY_check.o -L$(libdir) -lpdf -lhbook -lqedps -lminuit $(EXLIBS) $(FFLIBS)
	  @rm *.o *.mod

pp_psiY_setscale.o: $(thissrcdir)pp_psiY_setscale.f pp_psiY_global.mod
	$(FC) $(FFLAGS) -c $<

.F.o:
	$(FC) $(FFLAGS) -c $*.F

.f.o:
	$(FC) $(FFLAGS) -c $*.f


Main_pp_psiY_SPS.o: $(thissrcdir)Main_pp_psiY_SPS.f90 pp_psiY_SPS.mod
	$(FC) $(FFLAGS) -c $<

pp_psiY_check.o: $(thissrcdir)pp_psiY_check.f90 pp_psiY_global.mod pp_psiY_loop.mod
	$(FC) $(FFLAGS) -c $<

pp_psiY_loop.o pp_psiY_loop.mod: $(thissrcdir)pp_psiY_loop.f90 pp_psiY_global.mod $(moddir)Helac_Global.mod
	$(FC) $(FFLAGS) -c $<

pp_psiY_global.o pp_psiY_global.mod: $(thissrcdir)pp_psiY_global.f90
	$(FC) $(FFLAGS) -c $<

$(objdir)Helac_Global.o $(moddir)Helac_Global.mod : $(srcdir)Helac_Global.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)Helac_Func_1.o $(moddir)Helac_Func_1.mod : $(srcdir)Helac_Func_1.f90 $(moddir)Helac_Global.mod $(moddir)alfas_functions.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)Constants.o $(moddir)Constants.mod: $(srcdir)Constants.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)Helac_ranmar.o $(moddir)Helac_ranmar.mod: $(srcdir)Helac_ranmar.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)Func_PSI.o $(moddir)Func_PSI.mod: $(srcdir)Func_PSI.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)Structf_PDFs.o $(moddir)Structf_PDFs.mod:$(srcdir)Structf_PDFs.f90 $(moddir)Helac_Global.mod $(moddir)CTEQ6PDF.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod $(moddir)ElasticPhotonPhotonFlux.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)ElasticPhotonPhotonFlux.o $(moddir)ElasticPhotonPhotonFlux.mod:$(nucdir)ElasticPhotonPhotonFlux.f90 $(moddir)OpticalGlauber_Geometry.mod $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)nintlib.o $(moddir)nintlib.mod: $(nucdir)nintlib.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)tbessk.o : $(fundir)tbessk.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)tbessj.o : $(fundir)tbessj.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)nielsen_generalized_polylog.o $(moddir)nielsen_generalized_polylog.mod : $(fundir)nielsen_generalized_polylog.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)OpticalGlauber_Geometry.o $(moddir)OpticalGlauber_Geometry.mod: $(nucdir)OpticalGlauber_Geometry.f90 $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)nielsen_generalized_polylog.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)interpolation.o $(moddir)interpolation.mod: $(nucdir)interpolation.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)CTEQ6PDF.o $(moddir)CTEQ6PDF.mod: $(srcdir)CTEQ6PDF.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)Kinetic_Func.o $(moddir)Kinetic_Func.mod: $(srcdir)Kinetic_Func.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)MC_VEGAS.o $(moddir)MC_VEGAS.mod: $(srcdir)MC_VEGAS.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)alfas_functions.o $(moddir)alfas_functions.mod: $(srcdir)alfas_functions.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)setscale.o $(moddir)setscale.mod: $(srcdir)setscale.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)DecayInfo.o $(moddir)DecayInfo.mod : $(decaydir)DecayInfo.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)HOVll.o $(moddir)HOVll.mod : $(decaydir)HOVll.f90 $(moddir)Helac_ranmar.mod $(moddir)Kinetic_Func.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)Decay_interface.o $(moddir)Decay_interface.mod : $(decaydir)Decay_interface.f90 $(moddir)Helac_Global.mod $(moddir)HOVll.mod $(moddir)Helac_Func_1.mod $(moddir)Kinetic_Func.mod $(moddir)QEDPS_interface.mod $(moddir)Constants.mod $(moddir)HO_t2bw.mod $(moddir)HO_chi2psia.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)QEDPS_interface.o $(moddir)QEDPS_interface.mod : $(showerdir)QEDPS_interface.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod $(moddir)Kinetic_Func.mod $(moddir)setscale.mod
	$(FC) -c $< $(FFLAGS)

plot_pp_psiY_sps.o plot_pp_psiY_sps.mod : $(thissrcdir)plot_pp_psiY_sps.f90 $(moddir)Helac_Global.mod $(moddir)Kinetic_Func.mod $(moddir)MC_VEGAS.mod $(moddir)Helac_Func_1.mod pp_psiY_global.mod
	$(FC) -c $< $(FFLAGS)

pp_psiY_SPS.o pp_psiY_SPS.mod : $(thissrcdir)pp_psiY_SPS.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod $(moddir)Kinetic_Func.mod $(moddir)MC_VEGAS.mod $(moddir)Constants.mod $(moddir)Decay_interface.mod pp_psiY_loop.mod plot_pp_psiY_sps.mod $(moddir)DecayInfo.mod $(moddir)CTEQ6PDF.mod $(moddir)Structf_PDFs.mod $(moddir)HOVll.mod pp_psiY_global.mod $(moddir)Func_PSI.mod $(moddir)Helac_ranmar.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)pp_psiY_SPS_LHAPDFs.o : $(thissrcdir)pp_psiY_SPS_LHAPDFs.f90 $(moddir)Helac_Global.mod pp_psiY_global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)pp_psiY_SPS_MLHAPDFs.o : $(thissrcdir)pp_psiY_SPS_MLHAPDFs.f90 $(moddir)Helac_Global.mod pp_psiY_global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)Structf_LHAPDFs.o : $(srcdir)Structf_LHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)photon_PDFs.o $(moddir)photon_PDFs.mod : $(srcdir)photon_PDFs.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)Structf_LHAnPDFs.o : $(srcdir)Structf_LHAnPDFs.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)Structf_MLHAPDFs.o : $(srcdir)Structf_MLHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)HO_t2bw.o $(moddir)HO_t2bw.mod : $(decaydir)HO_t2bw.f90 $(moddir)Helac_ranmar.mod $(moddir)Kinetic_Func.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)HO_chi2psia.o $(moddir)HO_chi2psia.mod : $(decaydir)HO_chi2psia.f90 $(moddir)Helac_ranmar.mod $(moddir)Kinetic_Func.mod $(moddir)HOVll.mod
	$(FC) -c $< $(FFLAGS)

makefile_looptools:
	(cd $(HODIR)/vendor/looptools ; make clean ; make )

clean:
	rm -rf $(obj) $(mod) $(exe) $(linkexe) $(check) $(linkcheck) $(HODIR)/tmp/* *~ $(HODIR)/input/*~ $(HODIR)/src/*~ $(thissrcdir)*~ $(HODIR)/output/* fort.* Main_pp_psiY_SPS.o pp_psiY_check.o
end
