MODULE gggg2etac8cc_fermionchains
  USE pp_psicc_dps2_functions
  IMPLICIT NONE
CONTAINS

  SUBROUTINE GET_FERMIONCHAINS_1S08(ubar,v,&
  ga5,gs_eps_1,gs_eps_2,gs_eps_3,gs_eps_4,gs_p_1,gs_p_3,gs_k_1,fclist)
  COMPLEX(KIND(1d0)),DIMENSION(4),INTENT(IN)::ubar,v
  COMPLEX(KIND(1d0)),DIMENSION(4,4),INTENT(IN)::ga5
  COMPLEX(KIND(1d0)),DIMENSION(4,4),INTENT(IN)::gs_eps_1
  COMPLEX(KIND(1d0)),DIMENSION(4,4),INTENT(IN)::gs_eps_2
  COMPLEX(KIND(1d0)),DIMENSION(4,4),INTENT(IN)::gs_eps_3
  COMPLEX(KIND(1d0)),DIMENSION(4,4),INTENT(IN)::gs_eps_4
  COMPLEX(KIND(1d0)),DIMENSION(4,4),INTENT(IN)::gs_p_1
  COMPLEX(KIND(1d0)),DIMENSION(4,4),INTENT(IN)::gs_p_3
  COMPLEX(KIND(1d0)),DIMENSION(4,4),INTENT(IN)::gs_k_1
  COMPLEX(KIND(1d0)),DIMENSION(84),INTENT(OUT)::fclist
  COMPLEX(KIND(1d0)),DIMENSION(171,4)::recycle_ubar
  CALL DiracDot(ubar,ga5,recycle_ubar(1,1:4))
  CALL FermionContract(recycle_ubar(1,1:4),v,fclist(1))
  CALL DiracDot(ubar,gs_eps_1,recycle_ubar(2,1:4))
  CALL DiracDot(recycle_ubar(2,1:4),ga5,recycle_ubar(3,1:4))
  CALL FermionContract(recycle_ubar(3,1:4),v,fclist(2))
  CALL DiracDot(ubar,gs_eps_2,recycle_ubar(4,1:4))
  CALL DiracDot(recycle_ubar(4,1:4),ga5,recycle_ubar(5,1:4))
  CALL FermionContract(recycle_ubar(5,1:4),v,fclist(3))
  CALL DiracDot(ubar,gs_eps_3,recycle_ubar(6,1:4))
  CALL DiracDot(recycle_ubar(6,1:4),ga5,recycle_ubar(7,1:4))
  CALL FermionContract(recycle_ubar(7,1:4),v,fclist(4))
  CALL DiracDot(ubar,gs_eps_4,recycle_ubar(8,1:4))
  CALL DiracDot(recycle_ubar(8,1:4),ga5,recycle_ubar(9,1:4))
  CALL FermionContract(recycle_ubar(9,1:4),v,fclist(5))
  CALL DiracDot(ubar,gs_p_1,recycle_ubar(10,1:4))
  CALL DiracDot(recycle_ubar(10,1:4),ga5,recycle_ubar(11,1:4))
  CALL FermionContract(recycle_ubar(11,1:4),v,fclist(6))
  CALL DiracDot(ubar,gs_p_3,recycle_ubar(12,1:4))
  CALL DiracDot(recycle_ubar(12,1:4),ga5,recycle_ubar(13,1:4))
  CALL FermionContract(recycle_ubar(13,1:4),v,fclist(7))
  CALL DiracDot(ubar,gs_k_1,recycle_ubar(14,1:4))
  CALL DiracDot(recycle_ubar(14,1:4),ga5,recycle_ubar(15,1:4))
  CALL FermionContract(recycle_ubar(15,1:4),v,fclist(8))
  CALL DiracDot(recycle_ubar(2,1:4),gs_eps_3,recycle_ubar(16,1:4))
  CALL DiracDot(recycle_ubar(16,1:4),ga5,recycle_ubar(17,1:4))
  CALL FermionContract(recycle_ubar(17,1:4),v,fclist(9))
  CALL DiracDot(recycle_ubar(2,1:4),gs_eps_4,recycle_ubar(18,1:4))
  CALL DiracDot(recycle_ubar(18,1:4),ga5,recycle_ubar(19,1:4))
  CALL FermionContract(recycle_ubar(19,1:4),v,fclist(10))
  CALL DiracDot(recycle_ubar(2,1:4),gs_p_1,recycle_ubar(20,1:4))
  CALL DiracDot(recycle_ubar(20,1:4),ga5,recycle_ubar(21,1:4))
  CALL FermionContract(recycle_ubar(21,1:4),v,fclist(11))
  CALL DiracDot(recycle_ubar(2,1:4),gs_p_3,recycle_ubar(22,1:4))
  CALL DiracDot(recycle_ubar(22,1:4),ga5,recycle_ubar(23,1:4))
  CALL FermionContract(recycle_ubar(23,1:4),v,fclist(12))
  CALL DiracDot(recycle_ubar(4,1:4),gs_eps_3,recycle_ubar(24,1:4))
  CALL DiracDot(recycle_ubar(24,1:4),ga5,recycle_ubar(25,1:4))
  CALL FermionContract(recycle_ubar(25,1:4),v,fclist(13))
  CALL DiracDot(recycle_ubar(4,1:4),gs_eps_4,recycle_ubar(26,1:4))
  CALL DiracDot(recycle_ubar(26,1:4),ga5,recycle_ubar(27,1:4))
  CALL FermionContract(recycle_ubar(27,1:4),v,fclist(14))
  CALL DiracDot(recycle_ubar(4,1:4),gs_p_1,recycle_ubar(28,1:4))
  CALL DiracDot(recycle_ubar(28,1:4),ga5,recycle_ubar(29,1:4))
  CALL FermionContract(recycle_ubar(29,1:4),v,fclist(15))
  CALL DiracDot(recycle_ubar(4,1:4),gs_p_3,recycle_ubar(30,1:4))
  CALL DiracDot(recycle_ubar(30,1:4),ga5,recycle_ubar(31,1:4))
  CALL FermionContract(recycle_ubar(31,1:4),v,fclist(16))
  CALL DiracDot(recycle_ubar(6,1:4),gs_eps_4,recycle_ubar(32,1:4))
  CALL DiracDot(recycle_ubar(32,1:4),ga5,recycle_ubar(33,1:4))
  CALL FermionContract(recycle_ubar(33,1:4),v,fclist(17))
  CALL DiracDot(recycle_ubar(6,1:4),gs_p_1,recycle_ubar(34,1:4))
  CALL DiracDot(recycle_ubar(34,1:4),ga5,recycle_ubar(35,1:4))
  CALL FermionContract(recycle_ubar(35,1:4),v,fclist(18))
  CALL DiracDot(recycle_ubar(6,1:4),gs_p_3,recycle_ubar(36,1:4))
  CALL DiracDot(recycle_ubar(36,1:4),ga5,recycle_ubar(37,1:4))
  CALL FermionContract(recycle_ubar(37,1:4),v,fclist(19))
  CALL DiracDot(recycle_ubar(8,1:4),gs_p_1,recycle_ubar(38,1:4))
  CALL DiracDot(recycle_ubar(38,1:4),ga5,recycle_ubar(39,1:4))
  CALL FermionContract(recycle_ubar(39,1:4),v,fclist(20))
  CALL DiracDot(recycle_ubar(8,1:4),gs_p_3,recycle_ubar(40,1:4))
  CALL DiracDot(recycle_ubar(40,1:4),ga5,recycle_ubar(41,1:4))
  CALL FermionContract(recycle_ubar(41,1:4),v,fclist(21))
  CALL DiracDot(recycle_ubar(10,1:4),gs_p_3,recycle_ubar(42,1:4))
  CALL DiracDot(recycle_ubar(42,1:4),ga5,recycle_ubar(43,1:4))
  CALL FermionContract(recycle_ubar(43,1:4),v,fclist(22))
  CALL DiracDot(recycle_ubar(2,1:4),gs_eps_2,recycle_ubar(44,1:4))
  CALL DiracDot(recycle_ubar(44,1:4),gs_eps_3,recycle_ubar(45,1:4))
  CALL DiracDot(recycle_ubar(45,1:4),ga5,recycle_ubar(46,1:4))
  CALL FermionContract(recycle_ubar(46,1:4),v,fclist(23))
  CALL DiracDot(recycle_ubar(44,1:4),gs_eps_4,recycle_ubar(47,1:4))
  CALL DiracDot(recycle_ubar(47,1:4),ga5,recycle_ubar(48,1:4))
  CALL FermionContract(recycle_ubar(48,1:4),v,fclist(24))
  CALL DiracDot(recycle_ubar(44,1:4),gs_p_3,recycle_ubar(49,1:4))
  CALL DiracDot(recycle_ubar(49,1:4),ga5,recycle_ubar(50,1:4))
  CALL FermionContract(recycle_ubar(50,1:4),v,fclist(25))
  CALL DiracDot(recycle_ubar(16,1:4),gs_eps_4,recycle_ubar(51,1:4))
  CALL DiracDot(recycle_ubar(51,1:4),ga5,recycle_ubar(52,1:4))
  CALL FermionContract(recycle_ubar(52,1:4),v,fclist(26))
  CALL DiracDot(recycle_ubar(16,1:4),gs_p_1,recycle_ubar(53,1:4))
  CALL DiracDot(recycle_ubar(53,1:4),ga5,recycle_ubar(54,1:4))
  CALL FermionContract(recycle_ubar(54,1:4),v,fclist(27))
  CALL DiracDot(recycle_ubar(16,1:4),gs_p_3,recycle_ubar(55,1:4))
  CALL DiracDot(recycle_ubar(55,1:4),ga5,recycle_ubar(56,1:4))
  CALL FermionContract(recycle_ubar(56,1:4),v,fclist(28))
  CALL DiracDot(recycle_ubar(16,1:4),gs_k_1,recycle_ubar(57,1:4))
  CALL DiracDot(recycle_ubar(57,1:4),ga5,recycle_ubar(58,1:4))
  CALL FermionContract(recycle_ubar(58,1:4),v,fclist(29))
  CALL DiracDot(recycle_ubar(18,1:4),gs_p_1,recycle_ubar(59,1:4))
  CALL DiracDot(recycle_ubar(59,1:4),ga5,recycle_ubar(60,1:4))
  CALL FermionContract(recycle_ubar(60,1:4),v,fclist(30))
  CALL DiracDot(recycle_ubar(18,1:4),gs_p_3,recycle_ubar(61,1:4))
  CALL DiracDot(recycle_ubar(61,1:4),ga5,recycle_ubar(62,1:4))
  CALL FermionContract(recycle_ubar(62,1:4),v,fclist(31))
  CALL DiracDot(recycle_ubar(18,1:4),gs_k_1,recycle_ubar(63,1:4))
  CALL DiracDot(recycle_ubar(63,1:4),ga5,recycle_ubar(64,1:4))
  CALL FermionContract(recycle_ubar(64,1:4),v,fclist(32))
  CALL DiracDot(recycle_ubar(20,1:4),gs_p_3,recycle_ubar(65,1:4))
  CALL DiracDot(recycle_ubar(65,1:4),ga5,recycle_ubar(66,1:4))
  CALL FermionContract(recycle_ubar(66,1:4),v,fclist(33))
  CALL DiracDot(recycle_ubar(20,1:4),gs_k_1,recycle_ubar(67,1:4))
  CALL DiracDot(recycle_ubar(67,1:4),ga5,recycle_ubar(68,1:4))
  CALL FermionContract(recycle_ubar(68,1:4),v,fclist(34))
  CALL DiracDot(recycle_ubar(22,1:4),gs_k_1,recycle_ubar(69,1:4))
  CALL DiracDot(recycle_ubar(69,1:4),ga5,recycle_ubar(70,1:4))
  CALL FermionContract(recycle_ubar(70,1:4),v,fclist(35))
  CALL DiracDot(recycle_ubar(24,1:4),gs_eps_4,recycle_ubar(71,1:4))
  CALL DiracDot(recycle_ubar(71,1:4),ga5,recycle_ubar(72,1:4))
  CALL FermionContract(recycle_ubar(72,1:4),v,fclist(36))
  CALL DiracDot(recycle_ubar(24,1:4),gs_p_1,recycle_ubar(73,1:4))
  CALL DiracDot(recycle_ubar(73,1:4),ga5,recycle_ubar(74,1:4))
  CALL FermionContract(recycle_ubar(74,1:4),v,fclist(37))
  CALL DiracDot(recycle_ubar(24,1:4),gs_p_3,recycle_ubar(75,1:4))
  CALL DiracDot(recycle_ubar(75,1:4),ga5,recycle_ubar(76,1:4))
  CALL FermionContract(recycle_ubar(76,1:4),v,fclist(38))
  CALL DiracDot(recycle_ubar(24,1:4),gs_k_1,recycle_ubar(77,1:4))
  CALL DiracDot(recycle_ubar(77,1:4),ga5,recycle_ubar(78,1:4))
  CALL FermionContract(recycle_ubar(78,1:4),v,fclist(39))
  CALL DiracDot(recycle_ubar(26,1:4),gs_p_1,recycle_ubar(79,1:4))
  CALL DiracDot(recycle_ubar(79,1:4),ga5,recycle_ubar(80,1:4))
  CALL FermionContract(recycle_ubar(80,1:4),v,fclist(40))
  CALL DiracDot(recycle_ubar(26,1:4),gs_p_3,recycle_ubar(81,1:4))
  CALL DiracDot(recycle_ubar(81,1:4),ga5,recycle_ubar(82,1:4))
  CALL FermionContract(recycle_ubar(82,1:4),v,fclist(41))
  CALL DiracDot(recycle_ubar(26,1:4),gs_k_1,recycle_ubar(83,1:4))
  CALL DiracDot(recycle_ubar(83,1:4),ga5,recycle_ubar(84,1:4))
  CALL FermionContract(recycle_ubar(84,1:4),v,fclist(42))
  CALL DiracDot(recycle_ubar(28,1:4),gs_p_3,recycle_ubar(85,1:4))
  CALL DiracDot(recycle_ubar(85,1:4),ga5,recycle_ubar(86,1:4))
  CALL FermionContract(recycle_ubar(86,1:4),v,fclist(43))
  CALL DiracDot(recycle_ubar(28,1:4),gs_k_1,recycle_ubar(87,1:4))
  CALL DiracDot(recycle_ubar(87,1:4),ga5,recycle_ubar(88,1:4))
  CALL FermionContract(recycle_ubar(88,1:4),v,fclist(44))
  CALL DiracDot(recycle_ubar(30,1:4),gs_k_1,recycle_ubar(89,1:4))
  CALL DiracDot(recycle_ubar(89,1:4),ga5,recycle_ubar(90,1:4))
  CALL FermionContract(recycle_ubar(90,1:4),v,fclist(45))
  CALL DiracDot(recycle_ubar(32,1:4),gs_p_1,recycle_ubar(91,1:4))
  CALL DiracDot(recycle_ubar(91,1:4),ga5,recycle_ubar(92,1:4))
  CALL FermionContract(recycle_ubar(92,1:4),v,fclist(46))
  CALL DiracDot(recycle_ubar(32,1:4),gs_p_3,recycle_ubar(93,1:4))
  CALL DiracDot(recycle_ubar(93,1:4),ga5,recycle_ubar(94,1:4))
  CALL FermionContract(recycle_ubar(94,1:4),v,fclist(47))
  CALL DiracDot(recycle_ubar(32,1:4),gs_k_1,recycle_ubar(95,1:4))
  CALL DiracDot(recycle_ubar(95,1:4),ga5,recycle_ubar(96,1:4))
  CALL FermionContract(recycle_ubar(96,1:4),v,fclist(48))
  CALL DiracDot(recycle_ubar(34,1:4),gs_p_3,recycle_ubar(97,1:4))
  CALL DiracDot(recycle_ubar(97,1:4),ga5,recycle_ubar(98,1:4))
  CALL FermionContract(recycle_ubar(98,1:4),v,fclist(49))
  CALL DiracDot(recycle_ubar(34,1:4),gs_k_1,recycle_ubar(99,1:4))
  CALL DiracDot(recycle_ubar(99,1:4),ga5,recycle_ubar(100,1:4))
  CALL FermionContract(recycle_ubar(100,1:4),v,fclist(50))
  CALL DiracDot(recycle_ubar(36,1:4),gs_k_1,recycle_ubar(101,1:4))
  CALL DiracDot(recycle_ubar(101,1:4),ga5,recycle_ubar(102,1:4))
  CALL FermionContract(recycle_ubar(102,1:4),v,fclist(51))
  CALL DiracDot(recycle_ubar(38,1:4),gs_p_3,recycle_ubar(103,1:4))
  CALL DiracDot(recycle_ubar(103,1:4),ga5,recycle_ubar(104,1:4))
  CALL FermionContract(recycle_ubar(104,1:4),v,fclist(52))
  CALL DiracDot(recycle_ubar(38,1:4),gs_k_1,recycle_ubar(105,1:4))
  CALL DiracDot(recycle_ubar(105,1:4),ga5,recycle_ubar(106,1:4))
  CALL FermionContract(recycle_ubar(106,1:4),v,fclist(53))
  CALL DiracDot(recycle_ubar(40,1:4),gs_k_1,recycle_ubar(107,1:4))
  CALL DiracDot(recycle_ubar(107,1:4),ga5,recycle_ubar(108,1:4))
  CALL FermionContract(recycle_ubar(108,1:4),v,fclist(54))
  CALL DiracDot(recycle_ubar(42,1:4),gs_k_1,recycle_ubar(109,1:4))
  CALL DiracDot(recycle_ubar(109,1:4),ga5,recycle_ubar(110,1:4))
  CALL FermionContract(recycle_ubar(110,1:4),v,fclist(55))
  CALL DiracDot(recycle_ubar(45,1:4),gs_p_1,recycle_ubar(111,1:4))
  CALL DiracDot(recycle_ubar(111,1:4),ga5,recycle_ubar(112,1:4))
  CALL FermionContract(recycle_ubar(112,1:4),v,fclist(56))
  CALL DiracDot(recycle_ubar(47,1:4),gs_p_1,recycle_ubar(113,1:4))
  CALL DiracDot(recycle_ubar(113,1:4),ga5,recycle_ubar(114,1:4))
  CALL FermionContract(recycle_ubar(114,1:4),v,fclist(57))
  CALL DiracDot(recycle_ubar(44,1:4),gs_p_1,recycle_ubar(115,1:4))
  CALL DiracDot(recycle_ubar(115,1:4),gs_p_3,recycle_ubar(116,1:4))
  CALL DiracDot(recycle_ubar(116,1:4),ga5,recycle_ubar(117,1:4))
  CALL FermionContract(recycle_ubar(117,1:4),v,fclist(58))
  CALL DiracDot(recycle_ubar(51,1:4),gs_p_1,recycle_ubar(118,1:4))
  CALL DiracDot(recycle_ubar(118,1:4),ga5,recycle_ubar(119,1:4))
  CALL FermionContract(recycle_ubar(119,1:4),v,fclist(59))
  CALL DiracDot(recycle_ubar(51,1:4),gs_p_3,recycle_ubar(120,1:4))
  CALL DiracDot(recycle_ubar(120,1:4),ga5,recycle_ubar(121,1:4))
  CALL FermionContract(recycle_ubar(121,1:4),v,fclist(60))
  CALL DiracDot(recycle_ubar(53,1:4),gs_p_3,recycle_ubar(122,1:4))
  CALL DiracDot(recycle_ubar(122,1:4),ga5,recycle_ubar(123,1:4))
  CALL FermionContract(recycle_ubar(123,1:4),v,fclist(61))
  CALL DiracDot(recycle_ubar(59,1:4),gs_p_3,recycle_ubar(124,1:4))
  CALL DiracDot(recycle_ubar(124,1:4),ga5,recycle_ubar(125,1:4))
  CALL FermionContract(recycle_ubar(125,1:4),v,fclist(62))
  CALL DiracDot(recycle_ubar(71,1:4),gs_p_1,recycle_ubar(126,1:4))
  CALL DiracDot(recycle_ubar(126,1:4),ga5,recycle_ubar(127,1:4))
  CALL FermionContract(recycle_ubar(127,1:4),v,fclist(63))
  CALL DiracDot(recycle_ubar(71,1:4),gs_p_3,recycle_ubar(128,1:4))
  CALL DiracDot(recycle_ubar(128,1:4),ga5,recycle_ubar(129,1:4))
  CALL FermionContract(recycle_ubar(129,1:4),v,fclist(64))
  CALL DiracDot(recycle_ubar(73,1:4),gs_p_3,recycle_ubar(130,1:4))
  CALL DiracDot(recycle_ubar(130,1:4),ga5,recycle_ubar(131,1:4))
  CALL FermionContract(recycle_ubar(131,1:4),v,fclist(65))
  CALL DiracDot(recycle_ubar(79,1:4),gs_p_3,recycle_ubar(132,1:4))
  CALL DiracDot(recycle_ubar(132,1:4),ga5,recycle_ubar(133,1:4))
  CALL FermionContract(recycle_ubar(133,1:4),v,fclist(66))
  CALL DiracDot(recycle_ubar(91,1:4),gs_p_3,recycle_ubar(134,1:4))
  CALL DiracDot(recycle_ubar(134,1:4),ga5,recycle_ubar(135,1:4))
  CALL FermionContract(recycle_ubar(135,1:4),v,fclist(67))
  CALL DiracDot(recycle_ubar(45,1:4),gs_eps_4,recycle_ubar(136,1:4))
  CALL DiracDot(recycle_ubar(136,1:4),gs_p_3,recycle_ubar(137,1:4))
  CALL DiracDot(recycle_ubar(137,1:4),ga5,recycle_ubar(138,1:4))
  CALL FermionContract(recycle_ubar(138,1:4),v,fclist(68))
  CALL DiracDot(recycle_ubar(111,1:4),gs_k_1,recycle_ubar(139,1:4))
  CALL DiracDot(recycle_ubar(139,1:4),ga5,recycle_ubar(140,1:4))
  CALL FermionContract(recycle_ubar(140,1:4),v,fclist(69))
  CALL DiracDot(recycle_ubar(113,1:4),gs_k_1,recycle_ubar(141,1:4))
  CALL DiracDot(recycle_ubar(141,1:4),ga5,recycle_ubar(142,1:4))
  CALL FermionContract(recycle_ubar(142,1:4),v,fclist(70))
  CALL DiracDot(recycle_ubar(116,1:4),gs_k_1,recycle_ubar(143,1:4))
  CALL DiracDot(recycle_ubar(143,1:4),ga5,recycle_ubar(144,1:4))
  CALL FermionContract(recycle_ubar(144,1:4),v,fclist(71))
  CALL DiracDot(recycle_ubar(118,1:4),gs_p_3,recycle_ubar(145,1:4))
  CALL DiracDot(recycle_ubar(145,1:4),ga5,recycle_ubar(146,1:4))
  CALL FermionContract(recycle_ubar(146,1:4),v,fclist(72))
  CALL DiracDot(recycle_ubar(118,1:4),gs_k_1,recycle_ubar(147,1:4))
  CALL DiracDot(recycle_ubar(147,1:4),ga5,recycle_ubar(148,1:4))
  CALL FermionContract(recycle_ubar(148,1:4),v,fclist(73))
  CALL DiracDot(recycle_ubar(120,1:4),gs_k_1,recycle_ubar(149,1:4))
  CALL DiracDot(recycle_ubar(149,1:4),ga5,recycle_ubar(150,1:4))
  CALL FermionContract(recycle_ubar(150,1:4),v,fclist(74))
  CALL DiracDot(recycle_ubar(122,1:4),gs_k_1,recycle_ubar(151,1:4))
  CALL DiracDot(recycle_ubar(151,1:4),ga5,recycle_ubar(152,1:4))
  CALL FermionContract(recycle_ubar(152,1:4),v,fclist(75))
  CALL DiracDot(recycle_ubar(124,1:4),gs_k_1,recycle_ubar(153,1:4))
  CALL DiracDot(recycle_ubar(153,1:4),ga5,recycle_ubar(154,1:4))
  CALL FermionContract(recycle_ubar(154,1:4),v,fclist(76))
  CALL DiracDot(recycle_ubar(126,1:4),gs_p_3,recycle_ubar(155,1:4))
  CALL DiracDot(recycle_ubar(155,1:4),ga5,recycle_ubar(156,1:4))
  CALL FermionContract(recycle_ubar(156,1:4),v,fclist(77))
  CALL DiracDot(recycle_ubar(126,1:4),gs_k_1,recycle_ubar(157,1:4))
  CALL DiracDot(recycle_ubar(157,1:4),ga5,recycle_ubar(158,1:4))
  CALL FermionContract(recycle_ubar(158,1:4),v,fclist(78))
  CALL DiracDot(recycle_ubar(128,1:4),gs_k_1,recycle_ubar(159,1:4))
  CALL DiracDot(recycle_ubar(159,1:4),ga5,recycle_ubar(160,1:4))
  CALL FermionContract(recycle_ubar(160,1:4),v,fclist(79))
  CALL DiracDot(recycle_ubar(130,1:4),gs_k_1,recycle_ubar(161,1:4))
  CALL DiracDot(recycle_ubar(161,1:4),ga5,recycle_ubar(162,1:4))
  CALL FermionContract(recycle_ubar(162,1:4),v,fclist(80))
  CALL DiracDot(recycle_ubar(132,1:4),gs_k_1,recycle_ubar(163,1:4))
  CALL DiracDot(recycle_ubar(163,1:4),ga5,recycle_ubar(164,1:4))
  CALL FermionContract(recycle_ubar(164,1:4),v,fclist(81))
  CALL DiracDot(recycle_ubar(134,1:4),gs_k_1,recycle_ubar(165,1:4))
  CALL DiracDot(recycle_ubar(165,1:4),ga5,recycle_ubar(166,1:4))
  CALL FermionContract(recycle_ubar(166,1:4),v,fclist(82))
  CALL DiracDot(recycle_ubar(136,1:4),gs_p_1,recycle_ubar(167,1:4))
  CALL DiracDot(recycle_ubar(167,1:4),gs_p_3,recycle_ubar(168,1:4))
  CALL DiracDot(recycle_ubar(168,1:4),ga5,recycle_ubar(169,1:4))
  CALL FermionContract(recycle_ubar(169,1:4),v,fclist(83))
  CALL DiracDot(recycle_ubar(168,1:4),gs_k_1,recycle_ubar(170,1:4))
  CALL DiracDot(recycle_ubar(170,1:4),ga5,recycle_ubar(171,1:4))
  CALL FermionContract(recycle_ubar(171,1:4),v,fclist(84))

    RETURN
  END SUBROUTINE GET_FERMIONCHAINS_1S08
END MODULE gggg2etac8cc_fermionchains
