MODULE plot_pp_psicc_dps2
  USE HELAC_Global
  USE pp_psicc_dps2_global
  USE Kinetic_Func 
  IMPLICIT NONE
  INTEGER::max_weight=1
  INTEGER::nwgt_analysis
  INTEGER::num_plots=60
  INTEGER,PARAMETER::n_width=1,n_height=1
  SAVE
CONTAINS
  SUBROUTINE initplot_pp_psicc_dps2
    IMPLICIT NONE
    INTEGER::nwgt
    CHARACTER(len=15),DIMENSION(:),ALLOCATABLE::weights_info
    INTEGER::i
    max_weight=1+ho_nscale+ho_npdf+ho_npdf2+ho_nnpdf+ho_nref
    IF(ALLOCATED(weights_info))THEN
      DEALLOCATE(weights_info)
    ENDIF
    ALLOCATE(weights_info(max_weight)) 
    nwgt=1
    weights_info(nwgt)="central value  "
    IF(reweight_scale)THEN
       nwgt=nwgt+ho_nscale
       IF(ho_nscale.NE.8)THEN
          WRITE(*,*) 'ERROR #1 in initplot:',ho_nscale
          STOP
       ENDIF
       WRITE(weights_info(nwgt-7),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",1.0,"muF=",rw_Fscale_up
       WRITE(weights_info(nwgt-6),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",1.0,"muF=",rw_Fscale_down
       WRITE(weights_info(nwgt-5),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_up,"muF=",1d0
       WRITE(weights_info(nwgt-4),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_up,"muF=",rw_Fscale_up
       WRITE(weights_info(nwgt-3),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_up,"muF=",rw_Fscale_down
       WRITE(weights_info(nwgt-2),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_down,"muF=",1d0
       WRITE(weights_info(nwgt-1),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_down,"muF=",rw_Fscale_up
       WRITE(weights_info(nwgt  ),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_down,"muF=",rw_Fscale_down
    END IF
    IF(reweight_pdf)THEN
       DO i=1,ho_npdf
          WRITE(weights_info(nwgt+i),'(a4,i8,a3)')&
               'PDF=',ipdf_set_min-1+i,'   '
       ENDDO
       nwgt=nwgt+ho_npdf
       IF(ho_npdf2.GT.0)THEN
          DO i=1,ho_npdf2
             WRITE(weights_info(nwgt+i),'(a5,i8,a2)')&
                  'PDF2=',ipdf2_set_min-1+i,'  '
          ENDDO
          nwgt=nwgt+ho_npdf2
       ENDIF
    ENDIF
    IF(reweight_npdf)THEN
       IF(nPDF_id.EQ.1000)THEN
          DO i=1,ho_nnpdf
             WRITE(weights_info(nwgt+i),'(a5,i8,a2)')&
                  'NPDF=',inpdf_set_min+i-1-1000+iPDFSUP1,'  '
          ENDDO
       ELSE
          DO i=1,ho_nnpdf
             WRITE(weights_info(nwgt+i),'(a5,i8,a2)')&
                  'NPDF=',inpdf_set_min-1+i,'  '
          ENDDO
       ENDIF
       nwgt=nwgt+ho_nnpdf
    ENDIF
    IF(reweight_ref)THEN
       DO i=1,ho_nref
          WRITE(weights_info(nwgt+i),'(a4,i8,a3)')&
               'REF=',iref_set_min-1+i,'   '
       ENDDO
       nwgt=nwgt+ho_nref
    ENDIF
    ! output plot files
    CALL plot_begin_pp_psicc_dps2(nwgt,max_weight,weights_info)
    RETURN
  END SUBROUTINE initplot_pp_psicc_dps2

  SUBROUTINE plotout_pp_psicc_dps2
    USE MC_VEGAS
    IMPLICIT NONE
    LOGICAL::usexinteg=.FALSE.,mint=.FALSE. ! I have not implemented MINT 
    LOGICAL::useitmax=.TRUE.
    REAL(KIND(1d0))::xnorm
    xnorm=1.d0
    IF(useitmax.AND.gener.EQ.3)xnorm=xnorm/float(itmx) ! use vegas with itmax
    ! output plot files  
    CALL plot_end_pp_psicc_dps2(xnorm)
    RETURN
  END SUBROUTINE plotout_pp_psicc_dps2

  SUBROUTINE outfun_pp_psicc_dps2(www)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::www
    INTEGER::i,j
    INTEGER::nwgt
    REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::wgts
    INTEGER::init=0
    SAVE init,wgts
    IF(www.EQ.0d0)RETURN
    IF(init.EQ.0)THEN
       max_weight=1+ho_nscale+ho_npdf+ho_npdf2+ho_nnpdf+ho_nref
       IF(ALLOCATED(wgts))THEN
          DEALLOCATE(wgts)
       ENDIF
       ALLOCATE(wgts(max_weight))
       init=1
    ENDIF
    nwgt=1
    wgts(1)=www
    IF(reweight_scale)THEN
       DO i=1,3
          DO j=1,3
             IF(i.EQ.1.AND.j.EQ.1)CYCLE
             nwgt=nwgt+1
             wgts(nwgt)=www*wgtxsecmu(i,j)
          ENDDO
       ENDDO
    ENDIF
    IF(reweight_pdf)THEN
       DO i=1,ho_npdf+ho_npdf2
          nwgt=nwgt+1
          wgts(nwgt)=www*wgtxsecpdf(i)
       ENDDO
    ENDIF
    IF(reweight_npdf)THEN
       DO i=1,ho_nnpdf
          nwgt=nwgt+1
          wgts(nwgt)=www*wgtxsecnpdf(i)
       ENDDO
    ENDIF
    IF(reweight_ref)THEN
       DO i=1,ho_nref
          nwgt=nwgt+1
          wgts(nwgt)=www*wgtxsecref(i)
       ENDDO
    ENDIF
    ! output plot file 
    CALL plot_fill_pp_psicc_dps2(wgts)
    RETURN
  END SUBROUTINE outfun_pp_psicc_dps2

  SUBROUTINE plot_begin_pp_psicc_dps2(nwgt,max_weight,weights_info)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::nwgt,max_weight
    CHARACTER(len=*),DIMENSION(max_weight),INTENT(IN)::weights_info
    INTEGER::i,kk,l
    CHARACTER(len=5),DIMENSION(10)::smears=(/'     ','sm0.5','sm1.0',&
         'sm2.0','sm3.0','sm4.0','sm5.0','sm6.0','sm7.0','sm8.0'/)
    INCLUDE '../../../analysis/hbook/dbookf90.inc'
    INCLUDE '../../../analysis/hbook/histogram_common90.inc'
    top_yes=topdrawer_output
    gnu_yes=gnuplot_output
    root_yes=root_output
    hwu_yes=hwufile_output
    CALL HISTOGRAM_INIT(nwgt,weights_info)
    nwgt_analysis=nwgt
    IF(nwgt_analysis*16.GT.nplots/4)THEN
       WRITE(*,*) 'error in plot_begin_pp_psicc_dps2: ',&
            nwgt_analysis*num_plots*4 ! 4 is internal in dbook
       STOP
    ENDIF
    l=0
    DO i=1,10
       l=(i-1)*6
       CALL histogram_book(l+ 1,'total rate '//smears(i),&
            5,0.5d0,5.5d0,.FALSE.)
       CALL histogram_book(l+ 2,'J/psi pT '//smears(i),&
            100,0d0,50d0,.TRUE.)
       CALL histogram_book(l+ 3,'C pT '//smears(i),&
            100,0d0,25d0,.TRUE.)
       CALL histogram_book(l+ 4,'|Delta phi(J/psi,C)| '//smears(i),&
            100,-0.0001d0,3.1416d0,.TRUE.)
       CALL histogram_book(l+ 5,'Delta y(J/psi,C) '//smears(i),&
            100,-2.5d0,2.5d0,.TRUE.)
       CALL histogram_book(l+ 6,'m(J/psi,C) '//smears(i),&
            100,0d0,50d0,.TRUE.)
    ENDDO
    CALL HISTOGRAM_BOOK_FINISH
    RETURN
  END SUBROUTINE plot_begin_pp_psicc_dps2

  SUBROUTINE plot_end_pp_psicc_dps2(xnorm)
    USE Helac_Global
    IMPLICIT NONE
    CHARACTER(len=14)::ytit
    REAL(KIND(1d0)),INTENT(IN)::xnorm
    INTEGER::i
    INTEGER::kk,l
    INCLUDE '../../../analysis/hbook/dbookf90.inc'
    CHARACTER(len=400)::psfile,rootfile
    IF(topdrawer_output.OR.gnuplot_output.OR.root_output)THEN
       CALL mclear
       CALL mclear_3d
       DO i=1,NPLOTS
          CALL mopera(i,'+',i,i,xnorm,0.d0)
          CALL mfinal(i)
          CALL mopera_3d(i,'+',i,i,xnorm,0.d0)
          CALL mfinal_3d(i)
       ENDDO
    ENDIF
    ytit='sigma per bin '
    IF(topdrawer_output)THEN
       CALL open_topdrawer_file_pp_psicc_dps2
       CALL HISTOGRAM_END(1,ytit,' ',' ')
       CALL close_topdrawer_file_pp_psicc_dps2
    ENDIF
    IF(gnuplot_output)THEN
       CALL open_gnuplot_file_pp_psicc_dps2
       psfile="pp_psicc_dps2.ps"
       CALL HISTOGRAM_END(2,ytit,psfile,' ')
       CALL close_gnuplot_file_pp_psicc_dps2
    ENDIF
    IF(root_output)THEN
       CALL open_root_file_pp_psicc_dps2
       rootfile="pp_psicc_dps2.root"
       CALL HISTOGRAM_END(3,ytit,' ',rootfile)
       ! wirte the end of the .C file for root
       WRITE (96, 100)
100    FORMAT(/1X,&
            ' hohisto -> cd();',/1X,&
            ' if (histos -> GetEntries() > 0 ) then {',/1X,&
            '  histos->Write();',/1X,&
            '  hohisto -> Close();',/1X,&
            ' }',/1X,'}')
       CALL close_root_file_pp_psicc_dps2
    ENDIF
    IF(hwufile_output)THEN
       CALL HISTOGRAM_END(4,ytit,' ',' ')
       CALL HwU_write_file_pp_psicc_dps2
    ENDIF
    RETURN
  END SUBROUTINE plot_end_pp_psicc_dps2

  SUBROUTINE plot_fill_pp_psicc_dps2(wgts)
    USE Helac_Global
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(4)::p_jpsi,p_C,p_psiC,p_Cbar
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    REAL(KIND(1d0))::wgt,var,q,e
    REAL(KIND(1d0))::exp1,exp2
    INTEGER::i,kk,l
    REAL(KIND(1d0)),PARAMETER::pipi=3.1415926535897932384626433832795d0
    REAL(KIND(1d0))::www,pt_jpsi,pt_C,y_psi,y_C,pt_Cbar,y_Cbar
    REAL(KIND(1d0))::M_psiC,dy_psiC,dphi_psiC
    REAL(KIND(1d0)),DIMENSION(2:10)::smear_value
    REAL(KIND(1d0)),DIMENSION(4,20)::phep_psi,phep_psi_sm
    IF(NDecayChains.GT.0)THEN
       CALL plot_fill_Decay_pp_psicc_dps2(wgts)
       RETURN
    ENDIF
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! DEFINE OBSERVABLES
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    var=1.0d0 ! total cross section
    smear_value(2)=0.5d0
    smear_value(3)=1d0
    smear_value(4)=2d0
    smear_value(5)=3d0
    smear_value(6)=4d0
    smear_value(7)=5d0
    smear_value(8)=6d0
    smear_value(9)=7d0
    smear_value(10)=8d0
    DO i=1,nhad
       phep_psi(1:4,i)=dps_hadron_pmom(i,1:4)
    ENDDO
    DO i=1,10
       IF(i.EQ.1)THEN
          p_jpsi(1:4)=dps_hadron_pmom(5,1:4)
          p_Cbar(1:4)=dps_hadron_pmom(6,1:4)
          p_C(1:4)=dps_hadron_pmom(7,1:4)
       ELSE
          CALL InitKtSmearing(nhad,phep_psi(1:4,1:nhad),phep_psi_sm(1:4,1:nhad),&
               smear_value(i),2)
          p_jpsi(1:4)=phep_psi_sm(1:4,5)
          p_Cbar(1:4)=phep_psi_sm(1:4,6)
          p_C(1:4)=phep_psi_sm(1:4,7)
       ENDIF
       y_psi=rapidity(p_jpsi(1:4))
       pt_jpsi=DSQRT(p_jpsi(1)**2+p_jpsi(2)**2)
       ! LHCb cuts in arXiv:1205.0975
       IF(y_psi.LT.2d0.OR.y_psi.GT.4d0)CYCLE
       IF(pt_jpsi.GT.12d0)CYCLE
       y_C=rapidity(p_C(1:4))
       y_Cbar=rapidity(p_Cbar(1:4))
       pt_C=DSQRT(p_C(1)**2+p_C(2)**2)
       pt_Cbar=DSQRT(p_Cbar(1)**2+p_Cbar(2)**2)
       ! LHCb cuts in arXiv:1205.0975
       IF(y_C.GE.2d0.AND.y_C.LE.4d0.AND.pt_C.GE.3d0.AND.pt_C.LE.12d0)THEN
          p_psiC(1:4)=p_jpsi(1:4)+p_C(1:4)
          M_psiC=DSQRT(p_psiC(4)**2-p_psiC(1)**2-p_psiC(2)**2-p_psiC(3)**2)
          dy_psiC=y_psi-y_C
          dphi_psiC=ph4(p_jpsi(1),p_jpsi(2),p_jpsi(3))
          dphi_psiC=dphi_psiC-ph4(p_C(1),p_C(2),p_C(3))
          dphi_psiC=DABS(dphi_psiC)
          IF(dphi_psiC.GT.pipi)dphi_psiC=2D0*pipi-dphi_psiC
       ELSEIF(y_Cbar.GE.2d0.AND.y_Cbar.LE.4d0.AND.pt_Cbar.GE.3d0.AND.pt_Cbar.LE.12d0)THEN
          p_psiC(1:4)=p_jpsi(1:4)+p_Cbar(1:4)
          M_psiC=DSQRT(p_psiC(4)**2-p_psiC(1)**2-p_psiC(2)**2-p_psiC(3)**2)
          dy_psiC=y_psi-y_Cbar
          dphi_psiC=ph4(p_jpsi(1),p_jpsi(2),p_jpsi(3))
          dphi_psiC=dphi_psiC-ph4(p_Cbar(1),p_Cbar(2),p_Cbar(3))
          dphi_psiC=DABS(dphi_psiC)
          IF(dphi_psiC.GT.pipi)dphi_psiC=2D0*pipi-dphi_psiC
          pt_C=pt_Cbar ! fill l+3
       ELSE
          CYCLE
       ENDIF
       !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!                                               
       !                                                                                                   
       ! START TO FILL HISTOGRAM                                                                           
       !                                                                                                   
       !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       l=(i-1)*6
       CALL HISTOGRAM_FILL(l+1,var,wgts)
       CALL HISTOGRAM_FILL(l+2,pt_jpsi,wgts)
       CALL HISTOGRAM_FILL(l+3,pt_C,wgts)
       CALL HISTOGRAM_FILL(l+4,dphi_psiC,wgts)
       CALL HISTOGRAM_FILL(l+5,dy_psiC,wgts)
       CALL HISTOGRAM_FILL(l+6,M_psiC,wgts)
    ENDDO
    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    ! boost back to c.m. frame
    RETURN
  END SUBROUTINE plot_fill_pp_psicc_dps2

  SUBROUTINE HwU_write_file_pp_psicc_dps2
    USE Helac_Global
    IMPLICIT NONE
    REAL(KIND(1d0))::xnorm
    OPEN(unit=599,file=TRIM(output_dir)//'pp_psicc_dps2.HwU',&
         status='unknown')
    xnorm=1d0
    CALL HwU_output(599,xnorm)
    CLOSE(599)
    RETURN
  END SUBROUTINE HwU_write_file_pp_psicc_dps2

  SUBROUTINE open_topdrawer_file_pp_psicc_dps2
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=99,FILE=TRIM(output_dir)//'pp_psicc_dps2.top',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_topdrawer_file_pp_psicc_dps2

  SUBROUTINE close_topdrawer_file_pp_psicc_dps2
    IMPLICIT NONE
    CLOSE(99)
    RETURN
  END SUBROUTINE close_topdrawer_file_pp_psicc_dps2

  SUBROUTINE open_gnuplot_file_pp_psicc_dps2
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=97,FILE=TRIM(output_dir)//'pp_psicc_dps2.gnu',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_gnuplot_file_pp_psicc_dps2

  SUBROUTINE close_gnuplot_file_pp_psicc_dps2
    IMPLICIT NONE
    CLOSE(97)
    RETURN
  END SUBROUTINE close_gnuplot_file_pp_psicc_dps2

  SUBROUTINE open_root_file_pp_psicc_dps2
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=96,FILE=TRIM(output_dir)//'pp_psicc_dps2.C',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_root_file_pp_psicc_dps2

  SUBROUTINE close_root_file_pp_psicc_dps2
    IMPLICIT NONE
    CLOSE(96)
    RETURN
  END SUBROUTINE close_root_file_pp_psicc_dps2

  SUBROUTINE plot_fill_Decay_pp_psicc_dps2(wgts)
    USE Helac_Func_1
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    INCLUDE "stdhep_pp_psicc_dps2.inc"
    REAL(KIND(1d0))::var,Q,www
    REAL(KIND(1d0))::pt_psi,pt_C,pt_Cbar,y_psi,y_C,y_Cbar,M_psiC,dy_psiC,dphi_psiC
    INTEGER::i,m,l,kk,ism
    REAL(KIND(1d0)),DIMENSION(4)::PJpsi,PJpsiCMS,PCharm,PAntiCharm,P_psiC
    REAL(KIND(1d0)),DIMENSION(4,4)::Plep
    REAL(KIND(1d0)),DIMENSION(4)::plep1,Plep2
    REAL(KIND(1d0))::PP1,PP2
    REAL(KIND(1d0))::costh1,costh2
    INTEGER,DIMENSION(4)::lep2jpsi
    INTEGER,DIMENSION(2)::newmoth
    INTEGER::i_jpsi,i_lep,i_C,i_Cbar,kk1,kk2
    INTEGER::definemoth
    REAL(KIND(1d0)),DIMENSION(2:10)::smear_value
    REAL(KIND(1d0)),DIMENSION(4,nmxhep)::phep_sm
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! DEFINE OBSERVABLES
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    var=1.0d0 ! total cross section
    smear_value(2)=0.5d0
    smear_value(3)=1d0
    smear_value(4)=2d0
    smear_value(5)=3d0
    smear_value(6)=4d0
    smear_value(7)=5d0
    smear_value(8)=6d0
    smear_value(9)=7d0
    smear_value(10)=8d0
    ! select the first four decayed stable lepton
    DO ism=1,10
       IF(ism.EQ.1)THEN
          DO i=1,NHEP
             phep_sm(1:4,i)=PHEP(1:4,i)
          ENDDO
       ELSE
          CALL InitKtSmearing(NHEP,PHEP(1:4,1:NHEP),phep_sm(1:4,1:NHEP),&
               smear_value(ism),2)
       ENDIF
       i_jpsi=0
       i_C=0
       i_Cbar=0
       i_lep=0
       lep2jpsi(1:4)=0
       newmoth(1:2)=0
       DO i=1,NHEP
          IF(ISHEP(i).EQ.-1)CYCLE
          IF(ISTHEP(i).EQ.1)CYCLE
          IF(JMOHEP(1,i).LE.0.OR.JMOHEP(1,i).GT.NHEP)CYCLE
          IF(IDHEP(i).EQ.411.OR.IDHEP(i).EQ.413.OR.IDHEP(i).EQ.421&
               .OR.IDHEP(i).EQ.431.OR.IDHEP(i).EQ.4122.OR.IDHEP(i).EQ.4)THEN
             ! charm quark, charm meson or charm baryon
             i_C=i_C+1
             PCharm(1:4)=PHEP(1:4,i)
          ELSEIF(IDHEP(i).EQ.-411.OR.IDHEP(i).EQ.-413.OR.IDHEP(i).EQ.-421&
               .OR.IDHEP(i).EQ.-431.OR.IDHEP(i).EQ.-4122.OR.IDHEP(i).EQ.-4)THEN
             ! anticharm quark, anticharm meson or anticharm baryon
             i_Cbar=i_Cbar+1
             PAntiCharm(1:4)=PHEP(1:4,i)
          ELSE
             ! looking for the leptons from J/psi decay
             IF(ISTHEP(JMOHEP(1,i)).NE.1.OR.ISHEP(JMOHEP(1,i)).EQ.-1)CYCLE
             IF(.NOT.lepton_pdg(IDHEP(i)))CYCLE
             i_lep=i_lep+1
             Plep(i_lep,1:4)=PHEP(1:4,i)
             m=JMOHEP(1,i)
             definemoth=0
             DO kk=1,i_jpsi
                IF(newmoth(kk).EQ.m)THEN
                   definemoth=kk
                   EXIT
                END IF
             ENDDO
             IF(definemoth.NE.0)THEN
                ! the mother has been defined
                lep2jpsi(i_lep)=definemoth
             ELSE
                ! create the new mother
                i_jpsi=i_jpsi+1
                PJpsi(1:4)=PHEP(1:4,m)
                newmoth(i_jpsi)=m
                lep2jpsi(i_lep)=i_jpsi
             ENDIF
          ENDIF
       ENDDO
       IF(i_jpsi.NE.1)THEN
          WRITE(*,*)"ERROR: the number of J/psi =/= 1. N_Jpsi=",i_jpsi
          STOP
       ENDIF
       IF(i_C.NE.1)THEN
          WRITE(*,*)"ERROR: the number of charm quark/meson/baryon =/= 1. N_C=",i_C
          STOP
       ENDIF
       IF(i_Cbar.NE.1)THEN
          WRITE(*,*)"ERROR: the number of anticharm quark/meson/baryon =/= 1. N_Cbar=",i_Cbar
          STOP
       ENDIF
       ! LHCb cuts arXiv:1205.0975
       pt_psi=transverse(PJpsi(1:4))
       IF(pt_psi.GT.12d0)CYCLE
       y_psi=rapidity(PJpsi(1:4))
       IF(y_psi.LT.2d0.OR.y_psi.GT.4d0)CYCLE
       pt_C=transverse(PCharm(1:4))
       pt_Cbar=transverse(PAntiCharm(1:4))
       y_C=rapidity(PCharm(1:4))
       y_Cbar=rapidity(PAntiCharm(1:4))
       ! LHCb cuts in arXiv:1205.0975
       IF(y_C.GE.2d0.AND.y_C.LE.4d0.AND.pt_C.GE.3d0.AND.pt_C.LE.12d0)THEN
          p_psiC(1:4)=PJpsi(1:4)+PCharm(1:4)
          M_psiC=DSQRT(p_psiC(4)**2-p_psiC(1)**2-p_psiC(2)**2-p_psiC(3)**2)
          dy_psiC=y_psi-y_C
          dphi_psiC=ph4(PJpsi(1),PJpsi(2),PJpsi(3))
          dphi_psiC=dphi_psiC-ph4(PCharm(1),PCharm(2),PCharm(3))
          dphi_psiC=DABS(dphi_psiC)
          IF(dphi_psiC.GT.pi)dphi_psiC=2D0*pi-dphi_psiC
       ELSEIF(y_Cbar.GE.2d0.AND.y_Cbar.LE.4d0.AND.pt_Cbar.GE.3d0.AND.pt_Cbar.LE.12d0)THEN
          p_psiC(1:4)=PJpsi(1:4)+PAntiCharm(1:4)
          M_psiC=DSQRT(p_psiC(4)**2-p_psiC(1)**2-p_psiC(2)**2-p_psiC(3)**2)
          dy_psiC=y_psi-y_Cbar
          dphi_psiC=ph4(PJpsi(1),PJpsi(2),PJpsi(3))
          dphi_psiC=dphi_psiC-ph4(PAntiCharm(1),PAntiCharm(2),PAntiCharm(3))
          dphi_psiC=DABS(dphi_psiC)
          IF(dphi_psiC.GT.pi)dphi_psiC=2D0*pi-dphi_psiC
          pt_C=pt_Cbar ! fill l+3
       ELSE
          CYCLE
       ENDIF
       
       !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       !
       ! START TO FILL HISTOGRAM
       !
       !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       l=(ism-1)*6
       CALL HISTOGRAM_FILL(l+1,var,wgts)
       CALL HISTOGRAM_FILL(l+2,pt_psi,wgts)
       CALL HISTOGRAM_FILL(l+3,pt_C,wgts)
       CALL HISTOGRAM_FILL(l+4,dphi_psiC,wgts)
       CALL HISTOGRAM_FILL(l+5,dy_psiC,wgts)
       CALL HISTOGRAM_FILL(l+6,M_psiC,wgts)
    ENDDO
    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    RETURN
  END SUBROUTINE plot_fill_Decay_pp_psicc_dps2
END MODULE plot_pp_psicc_dps2
