SUBROUTINE strf_lhapdf_pp_psicc_dps2(wsf)
USE Helac_Global
USE pp_psicc_dps2_global
USE pp_psicc_DPS2_setscale
INTEGER::ipp=1  ! ipp=1 ppbar ; ipp=2 pp
INTEGER::ih=1   ! ih=1 no photon PDF,ih=2, photon from proton/anti-proton,ih=3 photon from electron/positron 
REAL(KIND=DBL),INTENT(OUT)::wsf          
CHARACTER(len=20),DIMENSION(20)::parm
REAL(KIND=DBL),DIMENSION(20)::val
REAL(KIND=DBL),DIMENSION(-7:7)::pdflist
LOGICAL::neutronQ1=.FALSE.,neutronQ2=.FALSE.
REAL(KIND=DBL)::xp1save,xp2save
INTEGER::init=0      
SAVE init,ipp,ih
REAL(KIND=DBL)::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
                ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct
REAL(KIND=DBL)::glu3_ct,glu4_ct,u3_ct,u4_ct,d3_ct,d4_ct,s3_ct,s4_ct,c3_ct,c4_ct,b3_ct,b4_ct,&
                ub3_ct,ub4_ct,db3_ct,db4_ct,sb3_ct,sb4_ct,cb3_ct,cb4_ct,bb3_ct,bb4_ct
       
IF(init.EQ.0)THEN
   IF(.NOT.lhapdfwrapinit)THEN
      CALL lhapdfwrap
      lhapdfwrapinit=.TRUE.
   ENDIF
   INCLUDE "../../../input/lhapdf/call_initnpdf"
   IF(Coll_Type.EQ.1)THEN
      ipp=2
   ELSE
      ipp=1
   ENDIF
   init=1
ENDIF

CALL pp_psicc_DPS2_qcdscale(scale)
scale=scale*muF_over_ref
IF(reweight_scale)THEN
   IF(reweight_Fscale_phase.EQ.1)THEN
      scale=scale*rw_Fscale_up
   ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
      scale=scale*rw_Fscale_down
   ENDIF
ENDIF

neutronQ1=.FALSE.
IF(lnuclearPDF.AND.rnuclearA_beam1.NE.0d0.AND.(.NOT.PureProton11))THEN
   ! set xp1=xBj1
   xp1save=xp1
   xp1=xBj1
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf1"
   ! recover xp1
   xp1=xp1save
   IF(.NOT.use_neutron_rand)THEN
      neutron_rand(1)=rand()
   ENDIF
   neutronQ1=neutron_rand(1).GT.randbeam1.AND.dPN
ELSE
   ! set xp1=xBj1
   xp1save=xp1
   xp1=xBj1
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_proton"
   CALL pftopdglha(ih,xp1,scale,pdflist(-7:7))
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_00"
   ! recover xp1
   xp1=xp1save
ENDIF

glu1_ct = xBj1*pdflist(0)
IF(neutronQ1)THEN
   ! PDF for neutron
   ! swap u <-> d
   u1_ct   = xBj1*pdflist(1)
   d1_ct   = xBj1*pdflist(2)
   s1_ct   = xBj1*pdflist(3)
   c1_ct   = xBj1*pdflist(4)
   b1_ct   = xBj1*pdflist(5)
   ub1_ct  = xBj1*pdflist(-1)
   db1_ct  = xBj1*pdflist(-2)
   sb1_ct  = xBj1*pdflist(-3)
   cb1_ct  = xBj1*pdflist(-4)
   bb1_ct  = xBj1*pdflist(-5)
ELSE
   u1_ct   = xBj1*pdflist(2)
   d1_ct   = xBj1*pdflist(1)
   s1_ct   = xBj1*pdflist(3)
   c1_ct   = xBj1*pdflist(4)
   b1_ct   = xBj1*pdflist(5)
   ub1_ct  = xBj1*pdflist(-2)
   db1_ct  = xBj1*pdflist(-1)
   sb1_ct  = xBj1*pdflist(-3)
   cb1_ct  = xBj1*pdflist(-4)
   bb1_ct  = xBj1*pdflist(-5)
ENDIF

neutronQ2=.FALSE.
IF(lnuclearPDF.AND.rnuclearA_beam2.NE.0d0.AND.(.NOT.PureProton21))THEN
   ! set xp2=xBj2
   xp2save=xp2
   xp2=xBj2
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf2"
   ! recover xp2
   xp2=xp2save
   IF(.NOT.use_neutron_rand)THEN
      neutron_rand(2)=rand()
   ENDIF
   neutronQ2=neutron_rand(2).GT.randbeam2.AND.dPN
ELSE
   ! set xp2=xBj2
   xp2save=xp2
   xp2=xBj2
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_proton"
   CALL pftopdglha(ih,xp2,scale,pdflist(-7:7))
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_00"
   ! recover xp2
   xp2=xp2save
ENDIF

glu2_ct = xBj2*pdflist(0)
IF(neutronQ2)THEN
   ! PDF for neutron
   ! swap u <-> d
   u2_ct   = xBj2*pdflist(1)
   d2_ct   = xBj2*pdflist(2)
   s2_ct   = xBj2*pdflist(3)
   c2_ct   = xBj2*pdflist(4)
   b2_ct   = xBj2*pdflist(5)
   ub2_ct  = xBj2*pdflist(-1)
   db2_ct  = xBj2*pdflist(-2)
   sb2_ct  = xBj2*pdflist(-3)
   cb2_ct  = xBj2*pdflist(-4)
   bb2_ct  = xBj2*pdflist(-5)
ELSE
   u2_ct   = xBj2*pdflist(2)
   d2_ct   = xBj2*pdflist(1)
   s2_ct   = xBj2*pdflist(3)
   c2_ct   = xBj2*pdflist(4)
   b2_ct   = xBj2*pdflist(5)
   ub2_ct  = xBj2*pdflist(-2)
   db2_ct  = xBj2*pdflist(-1)
   sb2_ct  = xBj2*pdflist(-3)
   cb2_ct  = xBj2*pdflist(-4)
   bb2_ct  = xBj2*pdflist(-5)
ENDIF

IF(lnuclearPDF.AND.rnuclearA_beam1.NE.0d0.AND.(.NOT.PureProton12))THEN
   ! set xp1=xBj1p
   xp1save=xp1
   xp1=xBj1p
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf1"
   ! recover xp1
   xp1=xp1save
   IF(PureProton11)THEN
      neutronQ1=.FALSE.
      IF(.NOT.use_neutron_rand)THEN
         neutron_rand(1)=rand()
      ENDIF
      neutronQ1=neutron_rand(1).GT.randbeam1.AND.dPN
   ENDIF
ELSE
   ! set xp1=xBj1p
   xp1save=xp1
   xp1=xBj1p
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_proton"
   CALL pftopdglha(ih,xp1,scale,pdflist(-7:7))
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_00"
   ! recover xp1
   xp1=xp1save
   neutronQ1=.FALSE.
ENDIF

glu3_ct = xBj1p*pdflist(0)
IF(neutronQ1)THEN
   ! PDF for neutron
   ! swap u <-> d
   u3_ct   = xBj1p*pdflist(1)
   d3_ct   = xBj1p*pdflist(2)
   s3_ct   = xBj1p*pdflist(3)
   c3_ct   = xBj1p*pdflist(4)
   b3_ct   = xBj1p*pdflist(5)
   ub3_ct  = xBj1p*pdflist(-1)
   db3_ct  = xBj1p*pdflist(-2)
   sb3_ct  = xBj1p*pdflist(-3)
   cb3_ct  = xBj1p*pdflist(-4)
   bb3_ct  = xBj1p*pdflist(-5)
ELSE
   u3_ct   = xBj1p*pdflist(2)
   d3_ct   = xBj1p*pdflist(1)
   s3_ct   = xBj1p*pdflist(3)
   c3_ct   = xBj1p*pdflist(4)
   b3_ct   = xBj1p*pdflist(5)
   ub3_ct  = xBj1p*pdflist(-2)
   db3_ct  = xBj1p*pdflist(-1)
   sb3_ct  = xBj1p*pdflist(-3)
   cb3_ct  = xBj1p*pdflist(-4)
   bb3_ct  = xBj1p*pdflist(-5)
ENDIF

IF(lnuclearPDF.AND.rnuclearA_beam2.NE.0d0.AND.(.NOT.PureProton22))THEN
   ! set xp2=xBj2p
   xp2save=xp2
   xp2=xBj2p
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf2"
   ! recover xp2
   xp2=xp2save
   IF(PureProton21)THEN
      neutronQ2=.FALSE.
      IF(.NOT.use_neutron_rand)THEN
         neutron_rand(2)=rand()
      ENDIF
      neutronQ2=neutron_rand(2).GT.randbeam2.AND.dPN
   ENDIF
ELSE
   ! set xp2=xBj2p
   xp2save=xp2
   xp2=xBj2p
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_proton"
   CALL pftopdglha(ih,xp2,scale,pdflist(-7:7))
   INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_00"
   ! recover xp2
   xp2=xp2save
   neutronQ2=.FALSE.
ENDIF

glu4_ct = xBj2p*pdflist(0)
IF(neutronQ2)THEN
   ! PDF for neutron
   ! swap u <-> d
   u4_ct   = xBj2p*pdflist(1)
   d4_ct   = xBj2p*pdflist(2)
   s4_ct   = xBj2p*pdflist(3)
   c4_ct   = xBj2p*pdflist(4)
   b4_ct   = xBj2p*pdflist(5)
   ub4_ct  = xBj2p*pdflist(-1)
   db4_ct  = xBj2p*pdflist(-2)
   sb4_ct  = xBj2p*pdflist(-3)
   cb4_ct  = xBj2p*pdflist(-4)
   bb4_ct  = xBj2p*pdflist(-5)
ELSE
   u4_ct   = xBj2p*pdflist(2)
   d4_ct   = xBj2p*pdflist(1)
   s4_ct   = xBj2p*pdflist(3)
   c4_ct   = xBj2p*pdflist(4)
   b4_ct   = xBj2p*pdflist(5)
   ub4_ct  = xBj2p*pdflist(-2)
   db4_ct  = xBj2p*pdflist(-1)
   sb4_ct  = xBj2p*pdflist(-3)
   cb4_ct  = xBj2p*pdflist(-4)
   bb4_ct  = xBj2p*pdflist(-5)
ENDIF

! recover it
IF(reweight_scale)THEN
   IF(reweight_Fscale_phase.EQ.1)THEN
      scale=scale/rw_Fscale_up
   ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
      scale=scale/rw_Fscale_down
   ENDIF
ENDIF

IF(dps2_channel.EQ.1.OR.dps2_channel.EQ.2.OR.&
     dps2_channel.EQ.3.OR.dps2_channel.EQ.4.OR.&
     dps2_channel.EQ.5.OR.dps2_channel.EQ.6.OR.&
     dps2_channel.EQ.7.OR.dps2_channel.EQ.8)THEN
   wsf=glu1_ct*glu2_ct*glu3_ct*glu4_ct*wjac/xBj1/xBj2/xBj1p/xBj2p
ELSE
   wsf=0d0
ENDIF
IF(init.EQ.0)init=1
       
END SUBROUTINE strf_lhapdf_pp_psicc_dps2
