HODIR=
FC=
objdir=$(HODIR)/addon/pp_psicc_DPS2/obj/
moddir=$(HODIR)/addon/pp_psicc_DPS2/mod/
srcdir=$(HODIR)/src/
nucdir=$(HODIR)/nuclear/
fundir=$(HODIR)/specialfuns/
thissrcdir=$(HODIR)/addon/pp_psicc_DPS2/src/
decaydir=$(HODIR)/decay/
libdir=$(HODIR)/lib/
showerdir=$(HODIR)/shower/interface/
lhapdfobj=
obj=$(objdir)Helac_Global.o $(objdir)Helac_Func_1.o  $(objdir)Helac_wavef.o $(objdir)Constants.o $(objdir)CTEQ6PDF.o $(objdir)Kinetic_Func.o $(objdir)Structf_PDFs.o $(objdir)photon_PDFs.o $(objdir)MC_VEGAS.o $(lhapdfobj) $(objdir)DecayInfo.o $(objdir)HOVll.o $(objdir)Decay_interface.o $(objdir)plot_pp_psicc_dps2.o $(objdir)pp_psicc_DPS2.o $(objdir)gggg2psicc_matrixelement.o $(objdir)gggg2psicc_fermionchains.o $(objdir)gggg2psicc_amplitude.o $(objdir)alfas_functions.o $(objdir)setscale.o $(objdir)pp_psicc_DPS2_setscale.o $(objdir)Helac_ranmar.o $(objdir)QEDPS_interface.o $(objdir)pp_psicc_dps2_global.o $(objdir)Main_pp_psicc_DPS2.o $(objdir)Func_PSI.o $(objdir)HO_t2bw.o $(objdir)HO_chi2psia.o $(objdir)pp_psicc_dps2_functions.o $(objdir)gggg2psi8cc_matrixelement.o $(objdir)gggg2psi8cc_fermionchains.o $(objdir)gggg2psi8cc_amplitude.o $(objdir)gggg2etac8cc_matrixelement.o $(objdir)gggg2etac8cc_fermionchains.o $(objdir)gggg2etac8cc_amplitude.o $(objdir)gggg2etaccc_matrixelement.o $(objdir)gggg2etaccc_fermionchains.o $(objdir)gggg2etaccc_amplitude.o $(objdir)tbessk.o $(objdir)tbessj.o $(objdir)nielsen_generalized_polylog.o $(objdir)nintlib.o $(objdir)interpolation.o $(objdir)OpticalGlauber_Geometry.o $(objdir)ElasticPhotonPhotonFlux.o
mod = $(moddir)*.mod
exe = $(HODIR)/bin/HO_pp_psicc_DPS2
linkexe = $(HODIR)/addon/pp_psicc_DPS2/bin/HO_pp_psicc_DPS2
EXLIBS = 

ifneq ("$(wildcard $(HODIR)/lib/libgsdpdf.a)","")
      makegsdpdf =
else
      makegsdpdf = makefile_gsdpdf
endif

all :   clean $(exe)
	ln -s $(exe) $(linkexe)

$(exe): $(makegsdpdf) $(obj)
	@cp *.o $(objdir)
	@cp *.mod $(moddir)
	@rm *.o *.mod
	$(FC) -o $(exe) $(obj) -L$(libdir) -lpdf -lgsdpdf -lhbook -lqedps -lminuit $(EXLIBS)

$(objdir)Main_pp_psicc_DPS2.o : $(thissrcdir)Main_pp_psicc_DPS2.f90 $(moddir)pp_psicc_DPS2.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)pp_psicc_dps2_global.o $(moddir)pp_psicc_dps2_global.mod: $(thissrcdir)pp_psicc_dps2_global.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)Helac_Global.o $(moddir)Helac_Global.mod : $(srcdir)Helac_Global.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)Helac_Func_1.o $(moddir)Helac_Func_1.mod : $(srcdir)Helac_Func_1.f90 $(moddir)Helac_Global.mod $(moddir)alfas_functions.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)Constants.o $(moddir)Constants.mod: $(srcdir)Constants.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)Helac_ranmar.o $(moddir)Helac_ranmar.mod: $(srcdir)Helac_ranmar.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)Func_PSI.o $(moddir)Func_PSI.mod: $(srcdir)Func_PSI.f90
	$(FC) -c $< $(FFLAGS)
			   
$(objdir)Structf_PDFs.o $(moddir)Structf_PDFs.mod:$(srcdir)Structf_PDFs.f90 $(moddir)Helac_Global.mod $(moddir)CTEQ6PDF.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod $(moddir)ElasticPhotonPhotonFlux.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)ElasticPhotonPhotonFlux.o $(moddir)ElasticPhotonPhotonFlux.mod:$(nucdir)ElasticPhotonPhotonFlux.f90 $(moddir)OpticalGlauber_Geometry.mod $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)nintlib.o $(moddir)nintlib.mod: $(nucdir)nintlib.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)tbessk.o : $(fundir)tbessk.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)tbessj.o : $(fundir)tbessj.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)nielsen_generalized_polylog.o $(moddir)nielsen_generalized_polylog.mod : $(fundir)nielsen_generalized_polylog.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)OpticalGlauber_Geometry.o $(moddir)OpticalGlauber_Geometry.mod: $(nucdir)OpticalGlauber_Geometry.f90 $(moddir)nintlib.mod $(moddir)interpolation.mod $(moddir)nielsen_generalized_polylog.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)interpolation.o $(moddir)interpolation.mod: $(nucdir)interpolation.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)CTEQ6PDF.o $(moddir)CTEQ6PDF.mod: $(srcdir)CTEQ6PDF.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)Kinetic_Func.o $(moddir)Kinetic_Func.mod: $(srcdir)Kinetic_Func.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)MC_VEGAS.o $(moddir)MC_VEGAS.mod: $(srcdir)MC_VEGAS.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)alfas_functions.o $(moddir)alfas_functions.mod: $(srcdir)alfas_functions.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)setscale.o $(moddir)setscale.mod: $(srcdir)setscale.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)pp_psicc_DPS2_setscale.o $(moddir)pp_psicc_DPS2_setscale.mod: $(thissrcdir)pp_psicc_DPS2_setscale.f90 $(moddir)Helac_Global.mod $(moddir)pp_psicc_dps2_global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)DecayInfo.o $(moddir)DecayInfo.mod : $(decaydir)DecayInfo.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)HOVll.o $(moddir)HOVll.mod : $(decaydir)HOVll.f90 $(moddir)Helac_ranmar.mod $(moddir)Kinetic_Func.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)Helac_wavef.o $(moddir)Helac_wavef.mod : $(srcdir)Helac_wavef.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)Decay_interface.o $(moddir)Decay_interface.mod : $(decaydir)Decay_interface.f90 $(moddir)Helac_Global.mod $(moddir)HOVll.mod $(moddir)Helac_Func_1.mod $(moddir)Kinetic_Func.mod $(moddir)QEDPS_interface.mod $(moddir)Constants.mod $(moddir)HO_t2bw.mod $(moddir)HO_chi2psia.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)QEDPS_interface.o $(moddir)QEDPS_interface.mod : $(showerdir)QEDPS_interface.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod $(moddir)Kinetic_Func.mod $(moddir)setscale.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2psicc_fermionchains.o $(moddir)gggg2psicc_fermionchains.mod : $(thissrcdir)gggg2psicc_fermionchains.f90 $(moddir)pp_psicc_dps2_functions.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2psi8cc_fermionchains.o $(moddir)gggg2psi8cc_fermionchains.mod : $(thissrcdir)gggg2psi8cc_fermionchains.f90 $(moddir)pp_psicc_dps2_functions.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2etac8cc_fermionchains.o $(moddir)gggg2etac8cc_fermionchains.mod : $(thissrcdir)gggg2etac8cc_fermionchains.f90 $(moddir)pp_psicc_dps2_functions.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2etaccc_fermionchains.o $(moddir)gggg2etaccc_fermionchains.mod : $(thissrcdir)gggg2etaccc_fermionchains.f90 $(moddir)pp_psicc_dps2_functions.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2psicc_amplitude.o : $(thissrcdir)gggg2psicc_amplitude.f
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2psi8cc_amplitude.o : $(thissrcdir)gggg2psi8cc_amplitude.f
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2etac8cc_amplitude.o : $(thissrcdir)gggg2etac8cc_amplitude.f
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2etaccc_amplitude.o : $(thissrcdir)gggg2etaccc_amplitude.f
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2psicc_matrixelement.o $(moddir)gggg2psicc_matrixelement.mod : $(thissrcdir)gggg2psicc_matrixelement.f90 $(moddir)Helac_wavef.mod $(moddir)gggg2psicc_fermionchains.mod $(moddir)pp_psicc_dps2_global.mod $(moddir)Helac_Global.mod $(moddir)pp_psicc_dps2_functions.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2psi8cc_matrixelement.o $(moddir)gggg2psi8cc_matrixelement.mod : $(thissrcdir)gggg2psi8cc_matrixelement.f90 $(moddir)Helac_wavef.mod $(moddir)gggg2psi8cc_fermionchains.mod $(moddir)pp_psicc_dps2_global.mod $(moddir)Helac_Global.mod $(moddir)pp_psicc_dps2_functions.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2etac8cc_matrixelement.o $(moddir)gggg2etac8cc_matrixelement.mod : $(thissrcdir)gggg2etac8cc_matrixelement.f90 $(moddir)Helac_wavef.mod $(moddir)gggg2etac8cc_fermionchains.mod $(moddir)pp_psicc_dps2_global.mod $(moddir)Helac_Global.mod $(moddir)pp_psicc_dps2_functions.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)gggg2etaccc_matrixelement.o $(moddir)gggg2etaccc_matrixelement.mod : $(thissrcdir)gggg2etaccc_matrixelement.f90 $(moddir)Helac_wavef.mod $(moddir)gggg2etaccc_fermionchains.mod $(moddir)pp_psicc_dps2_global.mod $(moddir)Helac_Global.mod $(moddir)pp_psicc_dps2_functions.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)pp_psicc_dps2_functions.o $(moddir)pp_psicc_dps2_functions.mod : $(thissrcdir)pp_psicc_dps2_functions.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)plot_pp_psicc_dps2.o $(moddir)plot_pp_psicc_dps2.mod : $(thissrcdir)plot_pp_psicc_dps2.f90 $(moddir)Helac_Global.mod $(moddir)Kinetic_Func.mod $(moddir)MC_VEGAS.mod $(moddir)Helac_Func_1.mod $(moddir)pp_psicc_dps2_global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)pp_psicc_DPS2.o $(moddir)pp_psicc_DPS2.mod : $(thissrcdir)pp_psicc_DPS2.f90 $(moddir)Helac_Global.mod $(moddir)Helac_Func_1.mod $(moddir)Kinetic_Func.mod $(moddir)MC_VEGAS.mod $(moddir)Constants.mod $(moddir)Decay_interface.mod $(moddir)gggg2psicc_matrixelement.mod $(moddir)gggg2psi8cc_matrixelement.mod $(moddir)gggg2etac8cc_matrixelement.mod $(moddir)gggg2etaccc_matrixelement.mod $(moddir)plot_pp_psicc_dps2.mod $(moddir)DecayInfo.mod $(moddir)CTEQ6PDF.mod $(moddir)Structf_PDFs.mod $(moddir)HOVll.mod $(moddir)pp_psicc_dps2_global.mod $(moddir)Func_PSI.mod $(moddir)Helac_ranmar.mod $(moddir)pp_psicc_DPS2_setscale.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)pp_psicc_DPS2_LHAPDFs.o : $(thissrcdir)pp_psicc_DPS2_LHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)pp_psicc_dps2_global.mod $(moddir)pp_psicc_DPS2_setscale.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)pp_psicc_DPS2_MLHAPDFs.o : $(thissrcdir)pp_psicc_DPS2_MLHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)pp_psicc_dps2_global.mod $(moddir)pp_psicc_DPS2_setscale.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)Structf_LHAPDFs.o : $(srcdir)Structf_LHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod $(moddir)photon_PDFs.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)photon_PDFs.o $(moddir)photon_PDFs.mod : $(srcdir)photon_PDFs.f90 $(moddir)Helac_Global.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)Structf_LHAnPDFs.o : $(srcdir)Structf_LHAnPDFs.f90
	$(FC) -c $< $(FFLAGS)

$(objdir)Structf_MLHAPDFs.o : $(srcdir)Structf_MLHAPDFs.f90 $(moddir)Helac_Global.mod $(moddir)setscale.mod
	$(FC) -c $< $(FFLAGS)

$(objdir)HO_t2bw.o $(moddir)HO_t2bw.mod : $(decaydir)HO_t2bw.f90 $(moddir)Helac_ranmar.mod $(moddir)Kinetic_Func.mod
        $(FC) -c $< $(FFLAGS)

$(objdir)HO_chi2psia.o $(moddir)HO_chi2psia.mod : $(decaydir)HO_chi2psia.f90 $(moddir)Helac_ranmar.mod $(moddir)Kinetic_Func.mod $(moddir)HOVll.mod
	$(FC) -c $< $(FFLAGS)

makefile_gsdpdf:
	(cd ./pdf/gsdpdf ; make clean -f makefile_gsdpdf ; make -f makefile_gsdpdf ; cd ../)
clean:
	rm -rf $(obj) $(mod) $(exe) $(linkexe) $(HODIR)/tmp/* *~ $(HODIR)/input/*~ $(HODIR)/src/*~ $(thissrcdir)*~ $(HODIR)/output/* fort.*
end
