MODULE pp_psipsi_DPS2
  USE Helac_Global
  USE pp_psipsi_dps2_global
  USE Helac_Func_1
  USE Kinetic_Func
  USE MC_VEGAS
  USE Constants
  USE Decay_interface
  USE gggg2psipsi_matrixelement
  USE plot_pp_psipsi_dps2
  USE DecayInfo
  USE Func_PSI
  USE pp_psipsi_DPS2_setscale
  IMPLICIT NONE
  INTEGER::nprint
  INTEGER::varnum,nunwei
  LOGICAL::lunwei2
  REAL(KIND(1d0))::EBMUP1,EBMUP2
  INTEGER::NPRUP=0,lwmax
  INTEGER,PARAMETER::maxprint=8
  SAVE
CONTAINS
  SUBROUTINE calc_pp_psipsi_DPS2
    IMPLICIT NONE
    CHARACTER(len=10),DIMENSION(20)::char
    INTEGER::i,i1,j1,k1,s1x
    INTEGER::nh,innum,outnum
    REAL(KIND(1d0))::w0,ptp,pqp,wme,temp
    INTEGER::ioerror,icase=0
    LOGICAL::lunwei=.FALSE.,lhewgt=.FALSE.
    REAL(KIND(1d0)),DIMENSION(3)::rslt
    INTEGER::itmxn,ncalln
    REAL(KIND(1d0)),DIMENSION(4)::pmomtemp
    LOGICAL::lexist
    SAVE lunwei,lhewgt,icase
    INTEGER::beam1_pdf,beam2_pdf
    INCLUDE "../../../src/pdfreweight_common.inc"
    INCLUDE "../../../src/pdf2reweight_common.inc"
    INCLUDE "../../../src/npdfreweight_common.inc"
    INCLUDE "../../../src/ref_reweight_common.inc"
    INCLUDE '../../../src/scalereweight_common.inc'
    WRITE(*,*)'                     THE BEGINNING OF HELAC-Onia'
    WRITE(*,*)'    AddOn Process: '
    WRITE(*,*)'    Double Patron Scattering Cross Talk (DPS2) for p p > psi(Upsilon) psi(Upsilon) + X '
    WRITE(*,*)'======================================================================='
    WRITE(*,*)'======================================================================='
    WRITE(*,*)' '
    CALL ReadElem_integer('ranhel',iranhel)
    CALL ReadElem_integer('colpar',Coll_Type)
    CALL ReadElem_integer('gridpack',gridpack)
    CALL ReadElem_logic('unwgt',lunwei)
    CALL ReadElem_logic('lhewgtup',lhewgt)
    ! nuclear effect related
    CALL ReadElem_integer('nuclearA_beam1',nuclearA_beam1)
    CALL ReadElem_integer('nuclearA_beam2',nuclearA_beam2)
    CALL ReadElem_integer('nuclearZ_beam1',nuclearZ_beam1)
    CALL ReadElem_integer('nuclearZ_beam2',nuclearZ_beam2)
    CALL ReadElem_integer('nPDF_id',nPDF_id)
    CALL ReadElem_logic('topdrawer_output',topdrawer_output)
    CALL ReadElem_logic('gnuplot_output',gnuplot_output)
    CALL ReadElem_logic('root_output',root_output)
    CALL ReadElem_logic('hwu_output',hwufile_output)
    plot_output=topdrawer_output.OR.gnuplot_output.OR.root_output.OR.hwufile_output
    CALL ReadElem_integer('literature',literature_cutoffs)
    CALL ReadElem_logic('fixtarget',fixtarget)
    IF(fixtarget.AND.Coll_Type.EQ.3)THEN
       WRITE(*,*)"ERROR: Cannot treat fixed-target experiment in e+e- collisions"
       STOP
    ENDIF
    IF(lunwei.AND.lhewgt)icase=1
    CALL ReadElem_logic("useMCFMrun",useMCFMrun)
    CALL ReadElem_logic('lhapdf',uselhapdf)
    CALL ReadElem_integer('fqnum',fqnum)
    INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdf_data",EXIST=lexist)
    IF(lexist)THEN
       OPEN(UNIT=30333,FILE=TRIM(input_dir)//"paths/lhapdf_data")
       READ(30333,'(A)')LHAPath
       CLOSE(UNIT=30333)
    ELSE
       INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdfpath",EXIST=lexist)
       IF(lexist)THEN
          OPEN(UNIT=30333,FILE=TRIM(input_dir)//"paths/lhapdfpath")
          READ(30333,'(A)')LHAPath
          CLOSE(UNIT=30333)
          i=LEN_TRIM(LHAPath)
          LHAPath=LHAPath(1:i-13)
       ENDIF
    ENDIF
    uselhapdf=uselhapdf.AND.lexist
    WRITE(*,*)'Use LHAPDF ?',uselhapdf
    CALL ReadElem_integer('pdf',beam1_pdf)
    CALL ReadElem_integer('beam2_pdf',beam2_pdf)
    multipdfloading=uselhapdf.AND.beam2_pdf.NE.beam1_pdf.AND.beam2_pdf.GT.0
    multipdfloading=multipdfloading.AND.COLL_TYPE.LE.2
    lnuclearPDF=.FALSE.
    IF(.NOT.multipdfloading)THEN
       IF(nPDF_id.NE.0.AND.(nuclearA_beam1.NE.0.OR.nuclearA_beam2.NE.0)&
            .AND.(.NOT.uselhapdf))THEN
          WRITE(*,*)"nuclear PDF can only be used with LHAPDF"
          WRITE(*,*)"nPDF_id=",nPDF_id
          WRITE(*,*)"nuclearA_beam1=",nuclearA_beam1
          WRITE(*,*)"nuclearA_beam2=",nuclearA_beam2
          WRITE(*,*)"Please set lhapdf=T and set the correct path of lhapdf in ho_configuration.txt before ./config"
          STOP
       ENDIF
       rnuclearA_beam1=DBLE(nuclearA_beam1)
       rnuclearA_beam2=DBLE(nuclearA_beam2)
       rnuclearZ_beam1=DBLE(nuclearZ_beam1)
       rnuclearZ_beam2=DBLE(nuclearZ_beam2)
       IF(nPDF_id.EQ.0.AND.(nuclearA_beam1.NE.0.or.nuclearA_beam2.NE.0))THEN
          WRITE(*,*)"WARNING:you are using normal proton PDF for nuclear"
       ENDIF
       IF(nPDF_id.NE.0.AND.(nuclearA_beam1.NE.0.or.nuclearA_beam2.NE.0))THEN
          lnuclearPDF=.TRUE.
       ENDIF
    ELSE ! multipdfloading==.TRUE.
       ! multiple PDF loading already allow one to use nuclear PDFs
       ! no need the tricks for nuclear PDFs
       rnuclearA_beam1=0d0
       rnuclearA_beam2=0d0
       nuclearA_beam1=0
       nuclearA_beam2=0
       rnuclearZ_beam1=0d0
       rnuclearZ_beam2=0d0
       nuclearZ_beam1=0
       nuclearZ_beam2=0
       lnuclearPDF=.FALSE.
    ENDIF ! end of if(.not.multipdfloading)
    reweight_pdf=.FALSE.
    reweight_npdf=.FALSE.
    IF(uselhapdf)THEN
       CALL ReadElem_logic('reweight_pdf',reweight_pdf)
       IF(reweight_pdf.AND.lnuclearPDF.AND.nPDF_id.EQ.1000)THEN
          WRITE(*,*)"WARNING:reweight proton PDF are not allowed when nPDF_id=1000 in PA"
          reweight_pdf=.FALSE.
       ENDIF
       IF(reweight_pdf)THEN
          CALL ReadElem_logic('beams_pdf_correlation',beams_pdf_correlation)
       ENDIF
       pdf_reweight_common=reweight_pdf
       IF(reweight_pdf)THEN
          CALL ReadElem_integer('pdf_min',ipdf_set_min)
          pdf_set_min_common=ipdf_set_min
          CALL ReadElem_integer('pdf_max',ipdf_set_max)
          pdf_set_max_common=ipdf_set_max
          IF(multipdfloading)THEN
             CALL ReadElem_integer('beam2_pdf_min',ipdf2_set_min)
             CALL ReadElem_integer('beam2_pdf_max',ipdf2_set_max)
             IF(ipdf2_set_min.GT.0.AND.ipdf2_set_max.GT.0)THEN
                IF(beams_pdf_correlation.AND.&
                     (ipdf2_set_max-ipdf2_set_min).NE.&
                     (ipdf_set_max-ipdf_set_min))THEN
                   WRITE(*,*)"ERROR: The numbers of error PDFs for two beams are different"
                   WRITE(*,*)"ERROR: The two beams cannot be fully correlated "
                   STOP
                ENDIF
             ENDIF
          ELSE
             ipdf2_set_min=-1
             ipdf2_set_max=-1
          ENDIF
          IF(ipdf_set_max.LT.0.AND.ipdf_set_min.LT.0)THEN
             ho_npdf=0
          ELSE
             ho_npdf=ipdf_set_max-ipdf_set_min+1
          ENDIF
          IF(multipdfloading.AND..NOT.beams_pdf_correlation.AND.&
               (ipdf2_set_min.GT.0.AND.ipdf2_set_max.GT.0))THEN
             ho_npdf2=ipdf2_set_max-ipdf2_set_min+1
             pdf2_reweight_common=.TRUE.
             pdf2_set_min_common=ipdf2_set_min
             pdf2_set_max_common=ipdf2_set_max
          ELSE
             ho_npdf2=0
             pdf2_reweight_common=.FALSE.
          ENDIF
          ho_npdf=MAX(ho_npdf,0)
          ho_npdf2=MAX(ho_npdf2,0)
          IF(ho_npdf.LE.0.AND.ho_npdf2.LE.0)THEN
             ho_npdf=0
             ho_npdf2=0
             pdf_reweight_common=.FALSE.
             pdf2_reweight_common=.FALSE.
             reweight_pdf=.FALSE.
          ENDIF
          IF(pdf_reweight_common.AND.ho_npdf.GT.0)THEN
             tot_nrwgt=tot_nrwgt+ho_npdf+1
          ENDIF
          IF(pdf2_reweight_common.AND.ho_npdf2.GT.0)THEN
             tot_nrwgt=tot_nrwgt+ho_npdf2+1
          ENDIF
       ENDIF
       IF(lnuclearPDF)THEN
          INCLUDE '../../../input/lhapdf/check_nPDF_id'
          CALL ReadElem_logic('npdf_isospin',dPN)
          CALL ReadElem_logic('reweight_npdf',reweight_npdf)
          npdf_reweight_common=reweight_npdf
          IF(reweight_pdf.AND.ho_npdf.GE.2.AND.nPDF_id.LE.500)THEN
             WRITE(*,*)"ERROR: Cannot perform proton PDF reweighting for EPS09"
             STOP
          ENDIF
          IF(reweight_npdf)THEN
             CALL ReadElem_integer('npdf_min',inpdf_set_min)
             npdf_set_min_common=inpdf_set_min
             CALL ReadElem_integer('npdf_max',inpdf_set_max)
             npdf_set_max_common=inpdf_set_max
             ho_nnpdf=inpdf_set_max-inpdf_set_min+1
             tot_nrwgt=tot_nrwgt+ho_nnpdf+1
          ENDIF
          INCLUDE '../../../input/lhapdf/check_npdf_set_min'
          CALL ReadElem_logic('include_ref',reweight_ref)
          REF_reweight_common=reweight_ref
          IF(reweight_ref)THEN
             IF(nuclearA_beam1*nuclearA_beam2.NE.0.AND.COLL_TYPE.LE.2)THEN
                ! heavy ion collision, AB or AA
                ! (ij from first beam and kl from second beam)
                ! 1: i/p j/p k/p l/p
                ! 2: i/A j/p k/p l/p
                ! 3: i/p j/A k/p l/p
                ! 4: i/A j/A k/p l/p
                ! 5: i/p j/p k/B l/p
                ! 6: i/A j/p k/B l/p
                ! 7: i/p j/A k/B l/p
                ! 8: i/A j/A k/B l/p
                ! 9: i/p j/p k/p l/B
                !10: i/A j/p k/p l/B
                !11: i/p j/A k/p l/B
                !12: i/A j/A k/p l/B
                !13: i/p j/p k/B l/B
                !14: i/A j/p k/B l/B
                !15: i/p j/A k/B l/B
                !default: i/A j/A k/B l/B
                ! these are necessary from arXiv:2001.04256
                ho_nref=15
                iref_set_min=1
                iref_set_max=15
                ref_set_min_common=1
                ref_set_min_common=15
             ELSE
                ! pA or Ap collisions
                ! assuming it is pA (ij from first beam and kl from second beam)
                ! 1: i/p j/p k/p l/p
                ! 2: i/p j/p k/A l/p
                ! 3: i/p j/p k/p l/A
                ! default is: i/p j/p k/A l/A
                ! these are necessary from arXiv:2001.04256
                ho_nref=3
                iref_set_min=1
                iref_set_max=3
                ref_set_min_common=1
                ref_set_max_common=3
             ENDIF
          ENDIF
          tot_nrwgt=tot_nrwgt+ho_nref+1
       ELSE
          npdf_reweight_common=.FALSE.
          REF_reweight_common=.FALSE.
       ENDIF
    ELSE
       pdf_reweight_common=.FALSE.
       pdf2_reweight_common=.FALSE.
       npdf_reweight_common=.FALSE.
       REF_reweight_common=.FALSE.
    ENDIF
    IF(reweight_pdf.OR.reweight_npdf.OR.reweight_ref)THEN
       IF(ALLOCATED(rwgt_values))THEN
          DEALLOCATE(rwgt_values)
       ENDIF
       ALLOCATE(rwgt_values(tot_nrwgt))
    ENDIF
    
    CALL ReadElem_logic('quarksumQ',qsumQ)
    WRITE(*,*)'Sum quark ?',qsumQ
    IF(qsumQ)THEN
       CALL ReadElem_integer('iqnum',iqnum)
       WRITE(*,*)'number of flavor in initial state:',iqnum
    ENDIF
    CALL ReadElem_logic("absoluterap",absrap)
    ! some necesarry initialization
    OPEN(UNIT=12321,FILE="./input/channel.inp")
    READ(12321,*)dps2_channel
    CLOSE(UNIT=12321)
    IF((dps2_channel.LT.1.OR.dps2_channel.GT.2))THEN
       WRITE(*,*)"ERROR:Unknown the channel = ",dps2_channel
       WRITE(*,*)"INFO:Please set 1 (g g g g > cc~(3s11)+cc~(3s11))"
       WRITE(*,*)"INFO:        or 2 (g g g g > bb~(3s11)+bb~(3s11)) in channel.inp"
       STOP
    ENDIF
    MC=1.5d0
    LDMEwt=1d0
    IF(dps2_channel.EQ.1)THEN
       CALL ReadElem_real('cmass',MC)
       CALL ReadElem_real('LDMEcc3S11',LDME443011)
       nhad=6
       iflh(1)=35
       iflh(2)=35
       iflh(3)=35
       iflh(4)=35
       iflh(5)=443011
       iflh(6)=443011
       LDMEwt=LDMEwt*(LDME443011/MC)**2
       alphas_power=4 ! the power of alphas in ME2
    ELSEIF(dps2_channel.EQ.2)THEN
       CALL ReadElem_real('bmass',MC)
       CALL ReadElem_real('LDMEbb3S11',LDME553011)
       nhad=6
       iflh(1)=35
       iflh(2)=35
       iflh(3)=35
       iflh(4)=35
       iflh(5)=553011
       iflh(6)=553011
       LDMEwt=LDMEwt*(LDME553011/MC)**2
       alphas_power=4 ! the power of alphas in ME2
    ENDIF

    OPEN(UNIT=12321,FILE="./input/sigma_eff.inp")
    READ(12321,*)dps_sigmaeff
    CLOSE(UNIT=12321)
    ! convert mb to nb
    dps_sigmaeff=dps_sigmaeff*1d6
    
    OPEN(UNIT=12321,FILE="./input/gauss_kt2avg.inp")
    READ(12321,*)g_kt2avg ! in unit of GeV**2
    CLOSE(UNIT=12321)

    CALL ReadDecayInfo
    MCoHelicity=.FALSE.
    IF(iranhel.EQ.4)THEN
       iranhel=0
       MCoHelicity=.TRUE.
    ELSEIF(NDecayChains.GT.0)THEN
       WRITE(*,*)"WARNING:You are not setting iranhel = 4 when you want to decay final state"
       WRITE(*,*)"WARNING:It will use the zero polarized decay !"
    ENDIF
    IF(iranhel.LE.3)iranhel=0 ! only allowing iranhel=0 (helicity sum) or iranhel=4 (MC over helicity)

    CALL ReadElem_integer('alphasrun',irun)
    IF(irun.EQ.0)THEN
       CALL ReadElem_real('alphas2',aqcdup)
       Gstrong=DSQRT(4d0*aqcdup*3.14159265358979323846264338328d0)
    ENDIF
    CALL ReadElem_real('alphaem',aqedup)
    IF(aqedup.LT.0d0)aqedup=1d0/1.37035999d2
    CALL ReadElem_logic('reweight_Scale',reweight_scale)
    reweight_scale=reweight_scale.AND.(irun.EQ.1)
    scale_reweight_common=reweight_scale
    IF(reweight_scale)THEN
       CALL ReadElem_real('rw_RScale_down',rw_Rscale_down)
       CALL ReadElem_real('rw_RScale_up',rw_Rscale_up)
       CALL ReadElem_real('rw_FScale_down',rw_Fscale_down)
       CALL ReadElem_real('rw_FScale_up',rw_Fscale_up)
       ho_nscale=8
       IF(rw_Rscale_down.LE.0d0.OR.rw_Rscale_up.LE.0d0.OR.&
            rw_Fscale_down.LE.0d0.OR.rw_Fscale_up.LE.0d0)THEN
          reweight_scale=.FALSE.
          scale_reweight_common=reweight_scale
          ho_nscale=0
          WRITE(*,*)"WARNING:Scale reweighting is off."
          WRITE(*,*)"WARNING:Please make sure rw_Rscale_up, rw_Rscale_down, rw_Fscale_up, rw_Fscale_down are larger than 0."
       ENDIF
       IF(reweight_scale.AND.rw_Rscale_down.GT.rw_Rscale_up)THEN
          temp=rw_Rscale_down
          rw_Rscale_down=rw_Rscale_up
          rw_Rscale_up=temp
       ENDIF
       IF(reweight_scale.AND.rw_Fscale_down.GT.rw_Fscale_up)THEN
          temp=rw_Fscale_down
          rw_Fscale_down=rw_Fscale_up
          rw_Fscale_up=temp
       ENDIF
       rw_RScale_down_common=rw_Rscale_down
       rw_RScale_up_common=rw_Rscale_up
       rw_FScale_down_common=rw_Fscale_down
       rw_FScale_up_common=rw_Fscale_up
    ENDIF
    IF(reweight_scale)THEN
       tot_nrwgt=tot_nrwgt+ho_nscale+1
    ENDIF
    IF(reweight_scale.OR.reweight_pdf)THEN
       IF(ALLOCATED(rwgt_values))THEN
          DEALLOCATE(rwgt_values)
       ENDIF
       ALLOCATE(rwgt_values(tot_nrwgt))
    ENDIF
    DO i=1,nhad
       IF(i.LE.4)THEN
          ioh(i)=1   ! the first four are incoming particles
       ELSE
          ioh(i)=-1   ! the rest are outgoing particles
       ENDIF
    ENDDO

    IF(nunit1.NE.6)THEN
       OPEN(UNIT=nunit1,FILE=TRIM(output_dir)//"RESULT_pp_psipsi_dps2.out")
    ENDIF
    nunit2=32
    CLOSE(nunit2)
    OPEN(nunit2,FILE=TRIM(output_dir)//'kine_pp_psipsi_dps2.out')
    nunit3=30
    CLOSE(nunit3)
    OPEN(nunit3,FILE=TRIM(tmp_dir)//'even_pp_psipsi_dps2.out',FORM='unformatted')
    nunit30=300
    CLOSE(nunit30)
    OPEN(nunit30,FILE=TRIM(tmp_dir)//'even_rwgt_pp_psipsi_dps2.out',FORM='unformatted')
    ! for LHA
    CLOSE(200)
    OPEN(200,FILE=TRIM(tmp_dir)//'sample_pp_psipsi_dps2.init')

    ! Scale scheme
    CALL ReadElem_integer('Scale',nscheme)
    CALL ReadElem_real('FScaleValue',fschemevalue)
    CALL ReadELem_real('ScaleFactor',scalefactor)
    CALL ReadElem_real('muR_over_ref',muR_over_ref)
    CALL ReadElem_real('muF_over_ref',muF_over_ref)
    CALL ReadElem_real('muNRQCD',muNRQCD)

    CALL ReadElem_integer("itmax",itmxn)
    CALL ReadElem_integer("nmc",ncalln)
    WRITE(*,*)' '
    CALL Helac_mtime()
    WRITE(*,*)' '
    CALL pp_psipsi_DPS2_VEGAS(rslt,itmxn,ncalln)
    WRITE(nunit1,*)"sigma(nb)                   sd"
    WRITE(nunit1,*)rslt(1),rslt(2)
    WRITE(*,*)' '
    CALL Helac_mtime()
    CLOSE(nunit2)
    CLOSE(nunit3)
    CLOSE(21)
    CLOSE(200)
    IF(lunwei)CALL Generate_lhe_pp_psipsi_dps2(nhad,Nevents,icase)
  END SUBROUTINE calc_pp_psipsi_DPS2
  
  SUBROUTINE pp_psipsi_DPS2_VEGAS(rslt,itmxn,ncalln)
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(3),INTENT(OUT)::rslt
    INTEGER,INTENT(IN),OPTIONAL::itmxn,ncalln
    REAL(KIND(1d0))::vfes,sd,chi2a
    LOGICAL::lexist
    INTEGER::ND_check,NDIM_check
    INTEGER::ncalm,nc,ii
    CHARACTER(len=4),DIMENSION(20)::chchar
    INTEGER::iday0,ihr0,imin0,isec0,i100th0,iday1,ihr1,imin1,isec1,i100th1,iyr0,iyr1,imon0,imon1
    INTEGER::IDBMUP1,IDBMUP2,IDWTUP
    INCLUDE "../../../src/RANDA_init.inc"
    CALL ReadElem_logic('unwgt',lunwei2)
    CALL ReadElem_integer('preunw',nunwei)
    lwmax=0
    NPRN=-1
    varnum=10
    varnum=varnum+NDecayIflh
    IF(MCoHelicity)varnum=varnum+1
    DO ii=1,varnum
       XL(ii)=0.0d0
       XU(ii)=1.0d0
    ENDDO
    IF(PRESENT(itmxn))THEN
       ITMX=itmxn
    ELSE
       ITMX=5
    ENDIF
    ITMX=1
    IF(PRESENT(ncalln))THEN
       ncalm=ncalln
    ELSE
       ncalm=5000
    ENDIF
    chchar(1)="40K"
    chchar(2)="80K"
    chchar(3)="160K"
    chchar(4)="320K"
    chchar(5)="640K"
    chchar(6)="1M"
    chchar(7)="2M"
    chchar(8)="4M"
    chchar(9)="8M"
    chchar(10)="16M"
    chchar(11)='32M'
    chchar(12)='64M'
    chchar(13)='120M'
    chchar(14)='240M'
    chchar(15)='480M'
    chchar(16)='960M'
    chchar(17)='2G'
    chchar(18)='4G'
    chchar(19)='8G'
    chchar(20)='16G'
    nprint=10000
    NCALL=20000
    CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
    vegas_grid_stage=gridpack
    IF(vegas_grid_stage.EQ.2)THEN
       ! check the grid file first
       INCLUDE "../../../src/check_vegas_grid.inc"
    ENDIF
    IF(vegas_grid_stage.LE.1)THEN
       IF(plot_output)CALL initplot_pp_psipsi_DPS2
       CALL VEGAS(varnum,pp_psipsi_DPS2_fxn,vfes,sd,chi2a)
       IF(plot_output)CALL plotout_pp_psipsi_DPS2
       WRITE(*,*)' '
       WRITE(*,*)"====================NCALL=20K==========================="
       WRITE(*,*)" "
       CALL Helac_mtime()
       WRITE(*,*)" "
       ii=1
       WRITE(*,*)"ITERATION ",ii,":"
       WRITE(*,*)vfes,"+\-",sd
       WRITE(*,*)"precision:",sd/vfes
       DO ii=2,10
          IF(plot_output)CALL initplot_pp_psipsi_DPS2
          CALL VEGAS(varnum,pp_psipsi_DPS2_fxn,vfes,sd,chi2a,1)
          IF(plot_output)CALL plotout_pp_psipsi_DPS2
          WRITE(*,*)"ITERATION ",ii,":"
          WRITE(*,*)vfes,"+\-",sd
          WRITE(*,*)"precision:",sd/vfes
       ENDDO
       CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
       iday1=iday1-iday0
       ihr1=ihr1-ihr0
       imin1=imin1-imin0
       isec1=isec1-isec0
       i100th1=i100th1-i100th0
       CALL Vegas_speed(10*NCALL,iday1,ihr1,imin1,isec1,i100th1)
       WRITE(*,*)' '
       WRITE(*,*)' '
    ENDIF
    IF(vegas_grid_stage.LE.1)THEN
       ii=1
       DO
          nc=2*NCALL
          IF(nc.GT.ncalm)EXIT
          IF(2*nc.GT.ncalm.AND.lunwei2.AND.lwmax.EQ.0)THEN
             lwmax=1
          ENDIF
          NCALL=nc
          IF(NCALL/maxprint.GT.nprint)nprint=NCALL/maxprint
          CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
          WRITE(*,*)"====================NCALL="//chchar(ii)//"==========================="
          WRITE(*,*)" "
          CALL Helac_mtime()
          WRITE(*,*)" "
          IF(plot_output)CALL initplot_pp_psipsi_DPS2
          CALL VEGAS(varnum,pp_psipsi_DPS2_fxn,vfes,sd,chi2a,1)
          IF(plot_output)CALL plotout_pp_psipsi_DPS2
          WRITE(*,*)vfes,"+\-",sd
          WRITE(*,*)"precision:",sd/vfes
          CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
          iday1=iday1-iday0
          ihr1=ihr1-ihr0
          imin1=imin1-imin0
          isec1=isec1-isec0
          i100th1=i100th1-i100th0
          CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
          WRITE(*,*)" "
          ii=ii+1
       ENDDO
    ELSEIF(vegas_grid_stage.EQ.2)THEN
       ii=1
       DO
          nc=2*NCALL
          IF(nc.GT.ncalm)EXIT
          NCALL=nc
          ii=ii+1
       ENDDO
       nc=nc/2
       IF(lunwei2.AND.lwmax.EQ.0)THEN
          lwmax=1
       ENDIF
       NCALL=nc
       IF(NCALL/maxprint.GT.nprint)nprint=NCALL/maxprint
       CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
       WRITE(*,*)"====================NCALL="//chchar(ii)//"==========================="
       WRITE(*,*)" "
       CALL Helac_mtime()
       WRITE(*,*)" "
       IF(plot_output)CALL initplot_pp_psipsi_DPS2
       CALL VEGAS(varnum,pp_psipsi_DPS2_fxn,vfes,sd,chi2a,1)
       IF(plot_output)CALL plotout_pp_psipsi_DPS2
       WRITE(*,*)vfes,"+\-",sd
       WRITE(*,*)"precision:",sd/vfes
       CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
       iday1=iday1-iday0
       ihr1=ihr1-ihr0
       imin1=imin1-imin0
       isec1=isec1-isec0
       i100th1=i100th1-i100th0
       CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
       WRITE(*,*)" "
       vegas_grid_stage=0
       nc=nc*2
    ENDIF
    IF(lunwei2.AND.lwmax.EQ.1)THEN
       lwmax=2
       WRITE(*,*)"START UNWEIGHTING"
       NCALL=nc/2
       CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
       WRITE(*,*)"====================NCALL="//chchar(ii-1)//"==========================="
       WRITE(*,*)" "
       CALL Helac_mtime()
       WRITE(*,*)" "
       IF(plot_output)CALL initplot_pp_psipsi_DPS2
       CALL VEGAS(varnum,pp_psipsi_DPS2_fxn,vfes,sd,chi2a,1)
       IF(plot_output)CALL plotout_pp_psipsi_DPS2
       WRITE(*,*)vfes,"+\-",sd
       WRITE(*,*)"precision:",sd/vfes
       CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
       iday1=iday1-iday0
       ihr1=ihr1-ihr0
       imin1=imin1-imin0
       isec1=isec1-isec0
       i100th1=i100th1-i100th0
       CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
       WRITE(*,*)" "
    ENDIF
    SELECT CASE(COLL_TYPE)
    CASE(1)
       IDBMUP1=2212
       IDBMUP2=2212
    CASE(2)
       IDBMUP1=2212
       IDBMUP2=-2212
    CASE DEFAULT
       IDBMUP1=11
       IDBMUP2=-11
    END SELECT
    IF(lunwei2)THEN
       IDWTUP=3
    ELSE
       IDWTUP=1
    ENDIF
    NPRUP=NPRUP+1
    WRITE(200,5100) IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,&
         iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
    WRITE(200,5200) vfes*10d0**3,sd*10d0**3,1d0, 82
    rslt(1)=vfes
    rslt(2)=sd
    rslt(3)=chi2a
    IF(lunwei2)PRINT *,"number of events",Nevents
    RETURN
5100 FORMAT(1P,2I8,2E14.6,6I8)
5200 FORMAT(1P,3E20.10,I6)
  END SUBROUTINE pp_psipsi_DPS2_VEGAS

  FUNCTION pp_psipsi_DPS2_fxn(x,wgt)
      REAL(KIND(1d0)),DIMENSION(varnum),INTENT(IN)::x
      REAL(KIND(1d0)),INTENT(IN)::wgt
      REAL(KIND(1d0))::pp_psipsi_DPS2_fxn
      REAL(KIND(1d0))::y1,y2,w1,sik,sjl
      REAL(KIND(1d0)),DIMENSION(4)::pmom,pmom2
      REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
      REAL(KIND(1d0)),PARAMETER::twopi=6.28318530717958647692528676656d0
      INTEGER::init=0,nwarn,nwmax,nwri,nwri_tot,icut,nnn=0,nnntot=0,&
           pdfnumpdf,pdfnumpdf2,ivarnum
      SAVE init,nwarn,nwmax,nwri,nwri_tot,nnn,nnntot,pdfnumpdf,pdfnumpdf2,ivarnum
      REAL(KIND(1d0))::sqs,sq,pt1c,maxpt1c,y1cup,y1clow,ycollcm,mt1,mt2,mt12,pt
      SAVE sqs,sq,pt1c,maxpt1c,y1cup,y1clow,ycollcm
      REAL(KIND(1d0))::wdps,wsf,wme,wkt,gkt,wgtbr,temp1,temp2,temp21,temp3,temp4,lamfact
      REAL(KIND(1d0))::exp1,exp2,Jpt2,Jy1,Jy2,xp11,xp21,scale1,scale2
      REAL(KIND(1d0))::recmax=0,recmin=0,phi
      SAVE temp1
      INTEGER::ioffset,j,kk,iii
      REAL(KIND(1d0)),DIMENSION(4)::pt_init,phi_init
      REAL(KIND(1d0))::Jpt_init
      REAL(KIND(1d0)),DIMENSION(0:3)::pik
      REAL(KIND(1d0)),PARAMETER::ktoff=0d0
      IF(init.EQ.0)THEN
         wjac=1
         nwmax=0
         nwarn=0
         nwri=0
         CALL ReadElem_integer('unwevt',nwri_tot)
         CALL ReadElem_real('energy_beam1',sqs)
         ebeam(1)=ABS(sqs)
         CALL ReadElem_real('energy_beam2',sqs)
         ebeam(2)=ABS(sqs)
         IF(ABS(ebeam(1)-ebeam(2))/MAX(ebeam(1)+ebeam(2),1d-17).LT.1d-8)THEN
            absrap=absrap
            labeqcoll=.TRUE.
         ELSE
            absrap=.FALSE.
            labeqcoll=.FALSE.
         ENDIF
         sqs=2d0*DSQRT(ebeam(1)*ebeam(2)) ! we always neglect the mass of initial states
         IF(fixtarget)sqs=sqs/DSQRT(2d0)
         EBMUP1=ebeam(1)
         EBMUP2=ebeam(2)
         IF(.NOT.fixtarget)THEN
            ycollcm=DLOG(ABS(ebeam(1))/ABS(ebeam(2)))/2d0
         ELSE
            IF(ABS(ebeam(1)).GT.ABS(ebeam(2)))THEN
               fixtargetrev=.FALSE.
               ycollcm=DLOG(1d0+2d0*ABS(ebeam(1))/ABS(ebeam(2)))/2d0
               FT_M=ebeam(2)
               FT_E1=ebeam(1)
               sqs=DSQRT(sqs**2+FT_M**2)
            ELSE
               fixtargetrev=.TRUE.
               ycollcm=-DLOG(1d0+2d0*ABS(ebeam(2))/ABS(ebeam(1)))/2d0
               FT_M=ebeam(1)
               FT_E1=ebeam(2)
               sqs=DSQRT(sqs**2+FT_M**2)
            ENDIF
         ENDIF
         IF(fixtarget)THEN
            ! for fixed target, I used the fake lab frame (note it is not the true lab frame of fixed target but close to)
            IF(.NOT.fixtargetrev)THEN
               ! beam1 = (beam(1)+FT_M/2,0,0,beam(1)+FT_M/2)
               ! beam2 = (FT_M/2,0,0,-FT_M/2), FT_M=beam(2)
               EBMUP1=ebeam(1)+FT_M/2d0
               EBMUP2=ebeam(2)/2d0
            ELSE
               ! beam1 = (FT_M/2,0,0,FT_M/2),FT_M=beam(1)
               ! beam2 = (beam(2)+FT_M/2,0,0,-beam(2)-FT_M/2)
               EBMUP1=ebeam(1)/2d0
               EBMUP2=ebeam(2)+FT_M/2d0
            ENDIF
         ENDIF
         CALL ReadElem_real('minpt1c',pt1c)
         CALL ReadElem_real('maxpt1c',maxpt1c)
         pt1c=MAX(pt1c,0d0)
         IF(maxpt1c.LT.0d0)THEN
            maxpt1c=-1d0
         ELSE
            IF(maxpt1c.LE.pt1c)THEN
               WRITE(*,*)"ERROR: the first final state was cut off by pt cut (pt1c,maxpt1c)"
               STOP
            ENDIF
         ENDIF
         CALL ReadElem_real('maxy1c',y1cup)
         CALL ReadElem_real('miny1c',y1clow)
         CALL ReadElem_integer('pdf',pdfnumpdf)
         CALL ReadElem_integer('beam2_pdf',pdfnumpdf2)
         ptc(3:20)=0
         maxptc(3:20)=-1d0
         drc(3:20,3:20)=0
         etac(3:20)=20
         ec(3:20)=0
         c1(3:20)=1
         c2(3:20)=1
         cc(3:20,3:20)=1
         yycut(3:20)=1d9
         IF(absrap)THEN
            yycutlow(3:20)=0d0
         ELSE
            yycutlow(3:20)=-1d9
         ENDIF
         xFcut(3:20)=1d0
         xFcutlow(3:20)=-1d0
         gmas(3:20,3:20)=0
         gbeammass(1:2,3:20)=0
         
         parmas(0)=0
         parwid(0)=-1
         iPDFSUP1=pdfnumpdf
         IF(pdfnumpdf.EQ.0.OR.COLL_TYPE.EQ.3)THEN
            istruc=0
         ELSE
            istruc=1
         ENDIF
         IF(istruc.EQ.1)THEN
            iPDFGUP1=0
            iPDFGUP2=0
            iPDFSUP1=pdfnumpdf
            IF(pdfnumpdf2.LE.0.OR..NOT.uselhapdf)THEN
               iPDFSUP2=pdfnumpdf
            ELSE
               iPDFSUP2=pdfnumpdf2
            ENDIF
         ELSE
            iPDFGUP1=-1
            iPDFGUP2=-1
            iPDFSUP1=-1
            iPDFSUP2=-1
            reweight_pdf=.FALSE.
            reweight_npdf=.FALSE.
            reweight_ref=.FALSE.
            ho_npdf=0
            ho_npdf2=0
            ho_nnpdf=0
            ho_nref=0
         ENDIF
         xp1=1D0
         xp2=1D0
         xBj1=1D0
         xBj2=1D0
         xBj1p=1D0
         xBj2p=1D0
         IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
            CALL readcuts_pp_psipsi_dps2
            y1cup=MIN(y1cup,yycut(3))
            y1clow=MAX(y1clow,yycutlow(3))
            IF(absrap)y1cup=ABS(y1cup)
            IF(absrap)y1clow=ABS(y1clow)
         ENDIF
         IF(NDecayChains.GT.0)CALL readcuts_Decay
         sq=sqs*sqs
         temp1=(sqs-2d0*MC)**2-4d0*MC**2
         IF(temp1.LE.0d0)THEN
            WRITE(*,*)"Error: the beam energies are too low to produce two onia !"
            STOP
         ENDIF
         temp1=DSQRT(temp1)
         IF(maxpt1c.GE.0d0)THEN
            temp1=MIN(temp1,maxpt1c)
         ENDIF
         ivarnum=10
         init=1
      ENDIF
      nnntot=nnntot+1
      wdps=1d0
      ! let us first generate the transverse momenta of the initial partons
      ! note that the initial parton has the transverse momentum distribution
      ! like 1/<ktavg2>/pi*exp(-kt**2/<ktavg2>)
      Jpt_init=1d0
      DO iii=1,3
         phi_init(iii)=x(2*iii-1)*twopi
         pt_init(iii)=-DLOG(x(2*iii)*(1d0-ktoff)+ktoff)*(g_kt2avg)
         pt_init(iii)=DSQRT(pt_init(iii))
         dps_p_born(iii,1)=pt_init(iii)*DCOS(phi_init(iii))
         dps_p_born(iii,2)=pt_init(iii)*DSIN(phi_init(iii))
         Jpt_init=Jpt_init*g_kt2avg/(x(2*iii)+ktoff/(1d0-ktoff))*pi
      ENDDO
      DO iii=1,2
         dps_p_born(4,iii)=dps_p_born(1,iii)+dps_p_born(2,iii)-dps_p_born(3,iii)
      ENDDO
      pt_init(4)=dps_p_born(4,1)**2+dps_p_born(4,2)**2
      pt_init(4)=DSQRT(pt_init(4))

      pt=(temp1-pt1c)*x(7)+pt1c
      Jpt2=pt*(temp1-pt1c)
      mt1=DSQRT(pt**2+4D0*MC**2)
      phi=twopi*x(8)
      dps_p_born(5,1)=pt*DCOS(phi)
      dps_p_born(5,2)=pt*DSIN(phi)

      DO iii=1,2
         dps_p_born(6,iii)=dps_p_born(1,iii)+dps_p_born(2,iii)&
              +dps_p_born(3,iii)+dps_p_born(4,iii)-dps_p_born(5,iii)
      ENDDO
      mt2=DSQRT(dps_p_born(6,1)**2+dps_p_born(6,2)**2+4D0*MC**2)
      IF(sqs.LT.mt1+mt2)THEN
         pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF

      IF(absrap)THEN
         temp2=MIN(ACosh_p((sqs-mt2)/mt1),y1cup)
         IF(temp2.LE.y1clow)THEN
            pp_psipsi_DPS2_fxn=0d0
            RETURN
         ENDIF
         y1=(2d0*x(9)-1d0)*(temp2-y1clow)+SIGN(1d0,x(9)-0.5d0)*y1clow
      ELSE
         temp2=MIN(ACosh_p((sqs-mt2)/mt1),y1cup-ycollcm)
         temp21=MAX(-ACosh_p((sqs-mt2)/mt1),y1clow-ycollcm)
         IF(temp2.LT.temp21)THEN
            pp_psipsi_DPS2_fxn=0d0
            RETURN
         ENDIF
         y1=(temp2-temp21)*x(9)+temp21 ! in collision frame
      ENDIF
      IF(absrap)THEN
         Jy1=2d0*(temp2-y1clow)
      ELSE
         Jy1=temp2-temp21
      ENDIF
      IF(sqs.LT.mt1*DCOSH(y1)+mt2)THEN
         pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF

      temp2=ACosh_p((sqs-mt1*DCOSH(y1))/mt2)
      y2=(2d0*x(10)-1d0)*temp2
      Jy2=2d0*temp2

      mt12=mt1**2+mt2**2+2d0*mt1*mt2*DCOSH(y1-y2)
      mt12=DSQRT(mt12)
      IF(mt12.LT.2d0*(pt_init(1)+pt_init(2)).AND.&
           mt12.GT.2d0*DABS(pt_init(1)-pt_init(2)))THEN
         pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF
      IF(mt12.LT.2d0*(pt_init(3)+pt_init(4)).AND.&
           mt12.GT.2d0*DABS(pt_init(3)-pt_init(4)))THEN
         pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF

!      IF(ycollcm.EQ.0d0)THEN
      ! xp1,xp2 is the same in collision frame and lab frame
      lamfact=mt12**4+16d0*pt_init(1)**4+16d0*pt_init(2)**4-8d0*mt12**2*pt_init(1)**2&
           -8d0*mt12**2*pt_init(2)**2-32d0*pt_init(1)**2*pt_init(2)**2
      lamfact=DSQRT(lamfact)
      temp2=(mt1*DCOSH(y1)+mt2*DCOSH(y2))*lamfact
      temp21=(mt1*DSINH(y1)+mt2*DSINH(y2))
      xBj1=(temp2+temp21*(mt12**2+4d0*pt_init(1)**2-4d0*pt_init(2)**2))/(2d0*sqs*mt12**2)
      xBj2=(temp2-temp21*(mt12**2+4d0*pt_init(2)**2-4d0*pt_init(1)**2))/(2d0*sqs*mt12**2)
      IF(xBj1.GE.1d0.OR.xBj1.LE.0d0.OR.xBj2.GE.1d0.OR.xBj2.LE.0d0)THEN
         pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF

      lamfact=mt12**4+16d0*pt_init(3)**4+16d0*pt_init(4)**4-8d0*mt12**2*pt_init(3)**2&
           -8d0*mt12**2*pt_init(4)**2-32d0*pt_init(3)**2*pt_init(4)**2
      lamfact=DSQRT(lamfact)
      temp2=(mt1*DCOSH(y1)+mt2*DCOSH(y2))*lamfact
      temp21=(mt1*DSINH(y1)+mt2*DSINH(y2))
      xBj1p=(temp2+temp21*(mt12**2+4d0*pt_init(3)**2-4d0*pt_init(4)**2))/(2d0*sqs*mt12**2)
      xBj2p=(temp2-temp21*(mt12**2+4d0*pt_init(4)**2-4d0*pt_init(3)**2))/(2d0*sqs*mt12**2)
      IF(xBj1p.GE.1d0.OR.xBj1p.LE.0d0.OR.xBj2p.GE.1d0.OR.xBj2p.LE.0d0)THEN
          pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF

      ! Generate the momenta of external legs in hadron-hadron collision frame
      dps_p_born(1,3)=xBj1*sqs/2d0
      dps_p_born(2,3)=-xBj2*sqs/2d0
      dps_p_born(3,3)=xBj1p*sqs/2d0
      dps_p_born(4,3)=-xBj2p*sqs/2d0
      DO iii=1,4
         dps_p_born(iii,0)=DSQRT(pt_init(iii)**2+dps_p_born(iii,3)**2)
      ENDDO
      IF(dps_p_born(1,0)+dps_p_born(3,0).GE.sqs/2d0)THEN
         pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF
      IF(dps_p_born(2,0)+dps_p_born(4,0).GE.sqs/2d0)THEN
          pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF
      dps_p_born(5,0)=mt1*DCOSH(y1)
      dps_p_born(5,3)=mt1*DSINH(y1)
      dps_p_born(6,0)=mt2*DCOSH(y2)
      dps_p_born(6,3)=mt2*DSINH(y2)

      xp1=xBj1+xBj1p
      xp2=xBj2+xBj2p

      DO iii=0,3
         pik(iii)=dps_p_born(1,iii)+dps_p_born(2,iii)
      ENDDO
      sik=pik(0)**2-pik(1)**2-pik(2)**2-pik(3)**2
      DO iii=0,3
         pik(iii)=dps_p_born(3,iii)+dps_p_born(4,iii)
      ENDDO
      sjl=pik(0)**2-pik(1)**2-pik(2)**2-pik(3)**2

      temp2=(xBj1/DSQRT(4d0*pt_init(1)**2/sq+xBj1**2)&
           +xBj2/DSQRT(4d0*pt_init(2)**2/sq+xBj2**2))
      temp2=temp2*(xBj1p/DSQRT(4d0*pt_init(3)**2/sq+xBj1p**2)&
           +xBj2p/DSQRT(4d0*pt_init(4)**2/sq+xBj2p**2))
      temp2=1d0/temp2*16d0/sq**2*twopi**3

      wdps=wdps/(4d0*sik*sjl)*temp2*Jpt_init*Jpt2*Jy1*Jy2*3.8937966d5 ! 3.8938573d5

      exp1=xBj1*ebeam(1)
      exp2=xBj2*ebeam(2)
      IF(fixtarget)THEN
         IF(.NOT.fixtargetrev)THEN
            exp1=exp1+FT_M*xBj1/2d0
            exp2=exp2/2d0
         ELSE
            exp2=exp2+FT_M*xBj2/2d0
            exp1=exp1/2d0
         ENDIF
      ENDIF
      Momenta_Frame=1
      ! boost from collision frame to lab frame
      IF(.NOT.fixtarget)THEN
         pmom(3)=ebeam(1)-ebeam(2)
         pmom(4)=ebeam(1)+ebeam(2)
      ELSE
         IF(.NOT.fixtargetrev)THEN
            pmom(3)=ebeam(1)
            pmom(4)=ebeam(1)+ebeam(2)
         ELSE
            pmom(3)=-ebeam(2)
            pmom(4)=ebeam(1)+ebeam(2)
         ENDIF
      ENDIF
      pmom(1:2)=0D0
      IF(.NOT.labeqcoll)THEN
         DO j=1,6
            pmom2(1:3)=dps_p_born(j,1:3)
            pmom2(4)=dps_p_born(j,0)
            CALL Boostl(sqs,pmom,pmom2)
            dps_p_born(j,1:3)=pmom2(1:3)
            dps_p_born(j,0)=pmom2(4)
         ENDDO
      ENDIF

      ! call the collinear PDFs
      CALL strf_pdf_pp_psipsi_dps2(wsf)
      !wsf=1d0
      
      wdps=wdps*wsf
      IF(wdps.LE.0d0)THEN
         pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF

      ! call the kT dependent PDFs
      ! assume factorisation wrt the collinear PDFs
      wkt=1d0
      DO iii=1,4         
         CALL gBeamKtGaussFactor(g_kt2avg,dps_p_born(iii,1),dps_p_born(iii,2),gkt)
         wkt=wkt*gkt
      ENDDO
      wdps=wdps*wkt
      IF(wdps.LE.0d0)THEN
         pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF

      CALL pp_psipsi_dps2_hadronmom

      icut=1
      CALL Cuts_pp_psipsi_dps2(icut)
      IF(icut.EQ.0)THEN
         pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF

      kk=ivarnum
      IF(MCoHelicity)THEN
         kk=kk+1
         RMCoH=x(kk)
      ENDIF

      DO j=kk+1,varnum
         Decayran(j-kk)=x(j)
      ENDDO

      ! calling the alphas
      CALL UPDATE_AS()

      reweight_scale_phase=.FALSE.
      IF(dps2_channel.EQ.1.OR.dps2_channel.EQ.2)THEN
         IF(.NOT.MCoHelicity)THEN
            CALL gggg2psipsi_ME2(-1,dps_p_born,wme)
         ELSE
            IF(nnn.EQ.0)THEN
               CALL gggg2psipsi_ME2(-1,dps_p_born,wme)
            ENDIF
            kk=INT(RMCoH*n_good_hel)+1
            kk=kk+hel_offset
            CALL gggg2psipsi_ME2(kk,dps_p_born,wme)
            wme=wme*DBLE(n_good_hel)
         ENDIF
      ELSE
         wme=0d0
      ENDIF
      wdps=wdps*wme
      IF(wdps.LE.0d0)THEN
         pp_psipsi_DPS2_fxn=0d0
         RETURN
      ENDIF
      wdps=wdps*LDMEwt

      IF(NDecayChains.GT.0)THEN
         CALL HO_Decay_pp_psipsi_dps2(weight_br)
         IF(weight_br.LE.0d0)THEN
            pp_psipsi_DPS2_fxn=0d0
            RETURN
         ENDIF
         CALL cuts_Decay_pp_psipsi_dps2(icut)
         IF(icut.EQ.0)THEN
            pp_psipsi_DPS2_fxn=0d0
            RETURN
         ENDIF
         wdps=wdps*weight_br
      ENDIF

      ! symmetry factor 1/2 has been taken into the matrix element square
      pp_psipsi_DPS2_fxn=wdps/dps_sigmaeff

      IF(reweight_scale)THEN
         CALL pp_psipsi_dps2_reweight_xsec_scale(wsf)
      ENDIF
      IF(reweight_pdf)THEN
         CALL pp_psipsi_dps2_reweight_xsec_pdf(wsf)
      ENDIF
      IF(reweight_npdf)THEN
         CALL pp_psipsi_dps2_reweight_xsec_npdf(wsf)
      ENDIF
      IF(reweight_ref)THEN
          CALL pp_psipsi_dps2_reweight_xsec_ref(wsf)
      ENDIF

      IF(lunwei2.AND.lwmax.GT.0)THEN
         w1=pp_psipsi_DPS2_fxn*wgt ! multiply VEGAS weight
         CALL unwei_procedure_pp_psipsi_dps2(w1,nwri,nwmax,nwarn)
      ENDIF

      IF(plot_output)THEN
         w1=pp_psipsi_DPS2_fxn*wgt
         CALL outfun_pp_psipsi_dps2(w1)
      ENDIF
      nnn=nnn+1
      IF(recmax.LT.pp_psipsi_DPS2_fxn)recmax=pp_psipsi_DPS2_fxn
      IF(recmin.GT.pp_psipsi_DPS2_fxn)recmin=pp_psipsi_DPS2_fxn
      IF(MOD(nnn,nprint).EQ.0)THEN
         PRINT *,"max=",recmax
         PRINT *,"min=",recmin
         IF(lunwei2.AND.lwmax.GT.1)THEN
            PRINT *,"      n_event,    n_pass,    n_total"
            PRINT *,nwri,nnn,nnntot
         ELSE
            PRINT *, "      n_pass,     n_total"
            PRINT *,nnn,nnntot
         ENDIF
      ENDIF
    END FUNCTION pp_psipsi_DPS2_fxn

    SUBROUTINE strf_pdf_pp_psipsi_dps2(wsf)
      USE CTEQ6PDF
      USE Structf_PDFs
      IMPLICIT NONE
      INTEGER::ipp=1  ! ipp=1 ppbar ; ipp=2 pp
      INTEGER::ih=1 ! ih=1 no photon PDF, ih=2, photon from proton/anti-proton, ih=3 phton from electron/positron
      REAL(KIND(1d0)),INTENT(OUT)::wsf
      INTEGER::init=0
      LOGICAL::use_cteq6_f90=.TRUE.
      REAL(KIND=DBL),DIMENSION(-7:7)::pdflist
      SAVE init,ipp,use_cteq6_f90
      REAL(KIND(1d0))::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
                ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct
      REAL(KIND(1d0))::glu3_ct,glu4_ct,u3_ct,u4_ct,d3_ct,d4_ct,s3_ct,s4_ct,c3_ct,c4_ct,b3_ct,b4_ct,&
                ub3_ct,ub4_ct,db3_ct,db4_ct,sb3_ct,sb4_ct,cb3_ct,cb4_ct,bb3_ct,bb4_ct
      IF(COLL_TYPE.LE.2)THEN
         IF(iPDFSUP1.EQ.iPDFSUP2)THEN
            INCLUDE "../lhapdf/call_strf_lhapdf"
         ELSE
            INCLUDE "../lhapdf/call_strf_mlhapdf"
         ENDIF
      ELSE
         WRITE(*,*)"ERROR: Cannot be here in strf_pdf_pp_psipsi_dps2"
         WRITE(*,*)"COLL_TYPE=",COLL_TYPE
         STOP
      ENDIF
      IF(init.EQ.0)THEN
         SELECT CASE(iPDFSUP1)
         CASE(10000)
            CALL SetCtq6f90(1)
            pdlabel='cteq6_m'
            nloop=2
            alphaQCD2=0.118d0
            use_cteq6_f90=.TRUE.
         CASE(10041)
            CALL SetCtq6f90(3)
            pdlabel='cteq6_l'
            nloop=2
            alphaQCD2=0.118d0
            use_cteq6_f90=.TRUE.
         CASE(10042)
            CALL SetCtq6f90(4)
            pdlabel='cteq6l1'
            nloop=1
            alphaQCD2=0.130d0
            use_cteq6_f90=.TRUE.
         CASE(921000)
            ! GS09 dPDF
            nloop=1
            pdlabel='gs09pdf'
            alphaQCD2=0.1184d0
            use_cteq6_f90=.FALSE.
            ! CALL GSALPS(Q) to run alpha_S, which is not used here
         CASE DEFAULT
            CALL pdfset_internal
            use_cteq6_f90=.FALSE.
         END SELECT
         IF(COLL_TYPE.EQ.1)THEN
            ipp=2
         ELSE
            ipp=1
         ENDIF
         init=1
      ENDIF

      CALL pp_psipsi_DPS2_qcdscale(scale)
      scale=scale*muF_over_ref
      IF(reweight_scale)THEN
         IF(reweight_Fscale_phase.EQ.1)THEN
            scale=scale*rw_Fscale_up
         ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
            scale=scale*rw_Fscale_down
         ENDIF
      ENDIF

      IF(use_cteq6_f90)THEN
         glu1_ct = xBj1*Ctq6Pdf_f90(0,xBj1,scale)
         glu2_ct = xBj2*Ctq6Pdf_f90(0,xBj2,scale)
         u1_ct   = xBj1*Ctq6Pdf_f90(1,xBj1,scale)
         u2_ct   = xBj2*Ctq6Pdf_f90(1,xBj2,scale)
         d1_ct   = xBj1*Ctq6Pdf_f90(2,xBj1,scale)
         d2_ct   = xBj2*Ctq6Pdf_f90(2,xBj2,scale)
         s1_ct   = xBj1*Ctq6Pdf_f90(3,xBj1,scale)
         s2_ct   = xBj2*Ctq6Pdf_f90(3,xBj2,scale)
         c1_ct   = xBj1*Ctq6Pdf_f90(4,xBj1,scale)
         c2_ct   = xBj2*Ctq6Pdf_f90(4,xBj2,scale)
         b1_ct   = xBj1*Ctq6Pdf_f90(5,xBj1,scale)
         b2_ct   = xBj2*Ctq6Pdf_f90(5,xBj2,scale)
         ub1_ct  = xBj1*Ctq6Pdf_f90(-1,xBj1,scale)
         ub2_ct  = xBj2*Ctq6Pdf_f90(-1,xBj2,scale)
         db1_ct  = xBj1*Ctq6Pdf_f90(-2,xBj1,scale)
         db2_ct  = xBj2*Ctq6Pdf_f90(-2,xBj2,scale)
         sb1_ct  = xBj1*Ctq6Pdf_f90(-3,xBj1,scale)
         sb2_ct  = xBj2*Ctq6Pdf_f90(-3,xBj2,scale)
         cb1_ct  = xBj1*Ctq6Pdf_f90(-4,xBj1,scale)
         cb2_ct  = xBj2*Ctq6Pdf_f90(-4,xBj2,scale)
         bb1_ct  = xBj1*Ctq6Pdf_f90(-5,xBj1,scale)
         bb2_ct  = xBj2*Ctq6Pdf_f90(-5,xBj2,scale)
         glu3_ct = xBj1p*Ctq6Pdf_f90(0,xBj1p,scale)
         glu4_ct = xBj2p*Ctq6Pdf_f90(0,xBj2p,scale)
         u3_ct   = xBj1p*Ctq6Pdf_f90(1,xBj1p,scale)
         u4_ct   = xBj2p*Ctq6Pdf_f90(1,xBj2p,scale)
         d3_ct   = xBj1p*Ctq6Pdf_f90(2,xBj1p,scale)
         d4_ct   = xBj2p*Ctq6Pdf_f90(2,xBj2p,scale)
         s3_ct   = xBj1p*Ctq6Pdf_f90(3,xBj1p,scale)
         s4_ct   = xBj2p*Ctq6Pdf_f90(3,xBj2p,scale)
         c3_ct   = xBj1p*Ctq6Pdf_f90(4,xBj1p,scale)
         c4_ct   = xBj2p*Ctq6Pdf_f90(4,xBj2p,scale)
         b3_ct   = xBj1p*Ctq6Pdf_f90(5,xBj1p,scale)
         b4_ct   = xBj2p*Ctq6Pdf_f90(5,xBj2p,scale)
         ub3_ct  = xBj1p*Ctq6Pdf_f90(-1,xBj1p,scale)
         ub4_ct  = xBj2p*Ctq6Pdf_f90(-1,xBj2p,scale)
         db3_ct  = xBj1p*Ctq6Pdf_f90(-2,xBj1p,scale)
         db4_ct  = xBj2p*Ctq6Pdf_f90(-2,xBj2p,scale)
         sb3_ct  = xBj1p*Ctq6Pdf_f90(-3,xBj1p,scale)
         sb4_ct  = xBj2p*Ctq6Pdf_f90(-3,xBj2p,scale)
         cb3_ct  = xBj1p*Ctq6Pdf_f90(-4,xBj1p,scale)
         cb4_ct  = xBj2p*Ctq6Pdf_f90(-4,xBj2p,scale)
         bb3_ct  = xBj1p*Ctq6Pdf_f90(-5,xBj1p,scale)
         bb4_ct  = xBj2p*Ctq6Pdf_f90(-5,xBj2p,scale)
      ELSEIF(iPDFSUP1.EQ.921000)THEN
         ! GS09 dPDF
         CALL GS09(xBj1,xBj1p,scale,0,0,glu1_ct)
         glu1_ct=xBj1*xBj1p*glu1_ct
         glu3_ct=1d0
         CALL GS09(xBj2,xBj2p,scale,0,0,glu2_ct)
         glu2_ct=xBj2*xBj2p*glu2_ct
         glu4_ct=1d0
         ! to include quark-gluon, quark-quark channels if they are needed
      ELSE
         CALL fdist(ih,xBj1,scale,pdflist(-7:7))
         glu1_ct = xBj1*pdflist(0)
         u1_ct   = xBj1*pdflist(2)
         d1_ct   = xBj1*pdflist(1)
         s1_ct   = xBj1*pdflist(3)
         c1_ct   = xBj1*pdflist(4)
         b1_ct   = xBj1*pdflist(5)
         ub1_ct  = xBj1*pdflist(-2)
         db1_ct  = xBj1*pdflist(-1)
         sb1_ct  = xBj1*pdflist(-3)
         cb1_ct  = xBj1*pdflist(-4)
         bb1_ct  = xBj1*pdflist(-5)
         CALL fdist(ih,xBj2,scale,pdflist(-7:7))
         glu2_ct = xBj2*pdflist(0)
         u2_ct   = xBj2*pdflist(2)
         d2_ct   = xBj2*pdflist(1)
         s2_ct   = xBj2*pdflist(3)
         c2_ct   = xBj2*pdflist(4)
         b2_ct   = xBj2*pdflist(5)
         ub2_ct  = xBj2*pdflist(-2)
         db2_ct  = xBj2*pdflist(-1)
         sb2_ct  = xBj2*pdflist(-3)
         cb2_ct  = xBj2*pdflist(-4)
         bb2_ct  = xBj2*pdflist(-5)
         CALL fdist(ih,xBj1p,scale,pdflist(-7:7))
         glu3_ct = xBj1p*pdflist(0)
         u3_ct   = xBj1p*pdflist(2)
         d3_ct   = xBj1p*pdflist(1)
         s3_ct   = xBj1p*pdflist(3)
         c3_ct   = xBj1p*pdflist(4)
         b3_ct   = xBj1p*pdflist(5)
         ub3_ct  = xBj1p*pdflist(-2)
         db3_ct  = xBj1p*pdflist(-1)
         sb3_ct  = xBj1p*pdflist(-3)
         cb3_ct  = xBj1p*pdflist(-4)
         bb3_ct  = xBj1p*pdflist(-5)
         CALL fdist(ih,xBj2p,scale,pdflist(-7:7))
         glu4_ct = xBj2p*pdflist(0)
         u4_ct   = xBj2p*pdflist(2)
         d4_ct   = xBj2p*pdflist(1)
         s4_ct   = xBj2p*pdflist(3)
         c4_ct   = xBj2p*pdflist(4)
         b4_ct   = xBj2p*pdflist(5)
         ub4_ct  = xBj2p*pdflist(-2)
         db4_ct  = xBj2p*pdflist(-1)
         sb4_ct  = xBj2p*pdflist(-3)
         cb4_ct  = xBj2p*pdflist(-4)
         bb4_ct  = xBj2p*pdflist(-5)
      ENDIF

      ! recover it
      IF(reweight_scale)THEN
         IF(reweight_Fscale_phase.EQ.1)THEN
            scale=scale/rw_Fscale_up
         ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
            scale=scale/rw_Fscale_down
         ENDIF
      ENDIF

      IF(dps2_channel.EQ.1.OR.dps2_channel.EQ.2)THEN
         wsf=glu1_ct*glu2_ct*glu3_ct*glu4_ct*wjac/xBj1/xBj2/xBj1p/xBj2p
      ELSE
         wsf=0d0
      ENDIF
      IF(init.EQ.0)init=1
    END SUBROUTINE strf_pdf_pp_psipsi_dps2

    SUBROUTINE readcuts_pp_psipsi_dps2
      IMPLICIT NONE
      CHARACTER(len=24)::file
      LOGICAL::lexist
      INTEGER::iounit,flag=0,i,i1,j,j1
      REAL(KIND(1d0))::ptq,ptcharm,ptconia,ptbonia,etaq,ycq,ycqlow,etaconia,ycconia,ycconialow,ycbonia,ycbonialow
      REAL(KIND(1d0))::cutoff,xFcq,xFcqlow,xFcconia,xFcconialow,xFcbonia,xFcbonialow,etabonia
      REAL(KIND(1d0))::gbeamq,drqq,gqq,maxptq,maxptcharm,maxptconia,maxptbonia
      REAL(KIND(1d0))::ptbottom,maxptbottom,etacharm,yccharm,yccharmlow,xFCcharm,xFccharmlow
      REAL(KIND(1d0))::etabottom,ycbottom,ycbottomlow,xFcbottom,xFcbottomlow
      ! open default input file
      INQUIRE(FILE=TRIM(input_dir)//"default.inp",EXIST=lexist)
      IF(.NOT.lexist)THEN
         PRINT *,"Warning: the file default.inp does not exist ! STOP !"
         STOP
      ENDIF
      INQUIRE(FILE=TRIM(input_dir)//"default.inp",OPENED=lexist)
      IF(lexist)THEN
         INQUIRE(FILE=TRIM(input_dir)//"default.inp",NUMBER=iounit)
         IF(iounit.NE.udefault)THEN
            PRINT *,"WARNING: the default.inp has been linked with another unit ! Close and reopen !"
            CLOSE(UNIT=iounit)
            OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
         ENDIF
      ELSE
         OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
      ENDIF
      ! open user's input file
      IF(TRIM(Input_File)/="default.inp")THEN
         INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),EXIST=lexist)
         IF(.NOT.lexist)THEN
            PRINT *,"Warning: the file "//TRIM(Input_File)//" does not exist ! STOP !"
            STOP
         ENDIF
         INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),OPENED=lexist)
         IF(lexist)THEN
            INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),NUMBER=iounit)
            IF(iounit.NE.uinput)THEN
               PRINT *,"WARNING: the "//TRIM(Input_File)//" has been linked with another unit ! Close and reopen !"
               CLOSE(UNIT=iounit)
               OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
            ENDIF
         ELSE
            OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
         ENDIF
      ELSE
         flag=1
      ENDIF
      cutoff=readvalue_r("cutoffp",flag)
      PRINT *,"WARNING CUTOFF SET:",cutoff
      ptc(3:20)=cutoff
      maxptc(3:20)=-1d0
      drc(3:20,3:20)=0
      etac(3:20)=20
      yycut(3:20)=1d9
      IF(absrap)THEN
         yycutlow(3:20)=0d0
      ELSE
         yycutlow(3:20)=-1d9
      ENDIF
      xFcut(3:20)=1d0
      xFcutlow(3:20)=1d0
      xFcutflag=.FALSE.
      ec(3:20)=cutoff
      c1(3:20)=1d0
      c2(3:20)=1d0
      cc(3:20,3:20)=1d0
      gmas(3:20,3:20)=cutoff
      gbeammass(1:2,3:20)=0d0
      y1cup=30d0
      y1clow=0d0
      y1cup=readvalue_r("maxy1c",flag)
      y1clow=readvalue_r("miny1c",flag)
      ! minimum quark pt
      ptq=readvalue_r("minptq",flag)
      ! maximum quark pt
      maxptq=readvalue_r("maxptq",flag)
      ! minimum charm pt
      ptcharm=readvalue_r("minptc",flag)
      ! maximum charm pt
      maxptcharm=readvalue_r("maxptc",flag)
      ! minimum charmonia pt
      ptconia=readvalue_r("minptconia",flag)
      ! maximum charmonia pt
      maxptconia=readvalue_r("maxptconia",flag)
      ! minimum bottom pt
      ptbottom=readvalue_r("minptb",flag)
      ! maximum bottom pt
      maxptbottom=readvalue_r("maxptb",flag)
      ! minimum bottonia pt
      ptbonia=readvalue_r("minptbonia",flag)
      ! maximum bottonia pt
      maxptbonia=readvalue_r("maxptbonia",flag)
      ! maximum rapidity quark 
      etaq=readvalue_r("maxrapq",flag)
      ! maximum y rapidity quark
      ycq=readvalue_r("maxyrapq",flag)
      ! minimum y rapidity quark
      ycqlow=readvalue_r("minyrapq",flag)
      ! maximum Feynman parameter xF
      xFcq=readvalue_r("maxxFq",flag)
      ! minimum Feynman parameter xF
      xFcqlow=readvalue_r("minxFq",flag)
      ! maximum rapidity charmonium
      etaconia=readvalue_r("maxrapconia",flag)
      ! maximum y rapidity charmonium
      ycconia=readvalue_r("maxyrapconia",flag)
      ! minimum y rapidity charmonium
      ycconialow=readvalue_r("minyrapconia",flag)
      ! maximum Feynman parameter xF
      xFcconia=readvalue_r("maxxFconia",flag)
      ! minimum Feynman parameter xF
      xFcconialow=readvalue_r("minxFconia",flag)
      ! maximum rapidity bottomonia
      etabonia=readvalue_r("maxrapbonia",flag)
      ! maximum y rapidity bottomonia
      ycbonia=readvalue_r("maxyrapbonia",flag)
      ! minimum y rapidity bottomonia
      ycbonialow=readvalue_r("minyrapbonia",flag)
      ! maximum Feynman parameter xF
      xFcbonia=readvalue_r("maxxFbonia",flag)
      ! minimum Feynman parameter xF
      xFcbonialow=readvalue_r("minxFbonia",flag)
      ! maximum rapidity charm
      etacharm=readvalue_r("maxrapc",flag)
      ! maximum y rapidity charm
      yccharm=readvalue_r("maxyrapc",flag)
      ! minimum y rapidity charm
      yccharmlow=readvalue_r("minyrapc",flag)
      ! maximum Feynman parameter xF
      xFccharm=readvalue_r("maxxFc",flag)
      ! minimum Feynman parameter xF
      xFccharmlow=readvalue_r("minxFc",flag)
      ! maximum rapidity bottom
      etabottom=readvalue_r("maxrapb",flag)
      ! maximum y rapidity bottom
      ycbottom=readvalue_r("maxyrapb",flag)
      ! minimum y rapidity bottom
      ycbottomlow=readvalue_r("minyrapb",flag)
      ! maximum Feynman parameter xF
      xFcbottom=readvalue_r("maxxFb",flag)
      ! minimum Feynman parameter xF
      xFcbottomlow=readvalue_r("minxFb",flag)
      ! minimum DR quark with quark
      drqq=readvalue_r("mindrqq",flag)
      ! minimum mass quark with quark
      gqq=readvalue_r("minmqqp",flag)
      ! minimum mass u,d,s quarks and gluon  with partonic beam
      gbeamq=readvalue_r("minmqbeam",flag)
      CLOSE(UNIT=udefault)
      CLOSE(UNIT=uinput)
      DO i=5,nhad
         i1=iflh(i)
         IF(iflh(i).EQ.35)i1=0
         IF(i1.EQ.0)THEN
            ptc(i)=ptq
            IF(maxptq.GE.0d0)maxptc(i)=maxptq
            etac(i)=etaq
            yycut(i)=ycq
            yycutlow(i)=ycqlow
            xFcut(i)=xFcq
            xFcutlow(i)=xFcqlow
         ELSEIF(charmquark(i1).OR.opencharmmeson(i1).OR.opencharmbaryon(i1))THEN
            ! charm and open charm meson/baryon 
            ptc(i)=ptcharm
            IF(maxptcharm.GE.0d0)maxptc(i)=maxptcharm
            etac(i)=etacharm
            yycut(i)=yccharm
            yycutlow(i)=yccharmlow
            xFcut(i)=xFccharm
            xFcutlow(i)=xFccharmlow
         ELSEIF(bottomquark(i1).OR.openbottommeson(i1).OR.openbottombaryon(i1))THEN
            ! bottom and open bottom meson/baryon
            ptc(i)=ptbottom
            IF(maxptbottom.GE.0d0)maxptc(i)=maxptbottom
            etac(i)=etabottom
            yycut(i)=ycbottom
            yycutlow(i)=ycbottomlow
            xFcut(i)=xFcbottom
            xFcutlow(i)=xFcbottomlow
         ELSEIF(i1.GE.440000.AND.i1.LE.449999)THEN
            ptc(i)=ptconia
            IF(maxptconia.GE.0d0)maxptc(i)=maxptconia
            etac(i)=etaconia
            yycut(i)=ycconia
            yycutlow(i)=ycconialow
            xFcut(i)=xFcconia
            xFcutlow(i)=xFcconialow
         ELSE
            ptc(i)=ptbonia
            IF(maxptbonia.GE.0d0)maxptc(i)=maxptbonia
            etac(i)=etabonia
            yycut(i)=ycbonia
            yycutlow(i)=ycbonialow
            xFcut(i)=xFcbonia
            xFcutlow(i)=xFcbonialow
         ENDIF
      ENDDO
      DO i=5,nhad-1
         i1=iflh(i)
         IF(i1.EQ.35)i1=0
         DO j=i+1,nhad
            j1=iflh(j)
            IF(j1.EQ.35)j1=0
            IF(i1.EQ.0.AND.j1.EQ.0)THEN
               drc(i,j)=drqq
               gmas(i,j)=MAX(gqq,gmas(i,j))
            ENDIF
         ENDDO
      ENDDO
      DO i=5,nhad-1
         DO j=i+1,nhad
            gmas(i,j)=MAX(gmas(i,j),DSQRT(2*ptc(i)*ptc(j)*(1-COS(drc(i,j)))))
         ENDDO
      ENDDO
      DO i=6,nhad
         DO j=5,i-1
            drc(i,j)=drc(j,i)
            gmas(i,j)=gmas(j,i)
         ENDDO
      ENDDO
      WRITE(*,*)'---------------------------------------------------'
      WRITE(*,*)'    the cuts for p p > psi(Upsilon) psi(Upsilon) + X '
      WRITE(*,*)'    with double parton scattering cross talk (DPS2) '
      DO i=5,nhad
         WRITE(*,*)'pt     of  ',i,'   particle   ',ptc(i)
         IF(maxptc(i).GE.0d0)THEN
            WRITE(*,*)'max pt     of  ',i,'   particle   ',maxptc(i)
            IF(maxptc(i).LE.ptc(i))THEN
               WRITE(*,*)"ERROR: One of the final state ",i," was cut off by pt cut"
               STOP
            ENDIF
         ELSE
            WRITE(*,*)'no max pt cut of  ',i,'   particle  '
         ENDIF
         WRITE(*,*)'energy of  ',i,'   particle   ',ec(i)
         WRITE(*,*)'rapidity of  ',i,'   particle   ',etac(i)
         WRITE(*,*)'max y rapidity of ',i,'   particle   ',yycut(i)
         WRITE(*,*)'min y rapidity of ',i,'   particle   ',yycutlow(i)
         IF(yycut(i).LE.yycutlow(i))THEN
            WRITE(*,*)"ERROR: One of the final state ",i," was cut off by y rapidity cut"
            STOP
         ENDIF
         WRITE(*,*)'max Feynman parameter xF of ',i,' particle ',xFcut(i)
         IF(xFcut(i).LT.1d0)xFcutflag=.TRUE.
         WRITE(*,*)'min Feynman parameter xF of ',i,' particle ',xFcutlow(i)
         IF(xFcutlow(i).GT.-1d0)xFcutflag=.TRUE.
      ENDDO
      WRITE(*,*)'The maxrapidity of the first particle',y1cup
      WRITE(*,*)'The minrapidity of the first particle',y1clow
      DO i=5,nhad-1
         DO j=i+1,nhad
            WRITE(*,*)'DR     ',i,'  with  ',j,drc(i,j)
            WRITE(*,*)'mass of ',i,'  with  ',j,gmas(i,j)
         ENDDO
      ENDDO
      WRITE(*,*)'---------------------------------------------------'
    END SUBROUTINE readcuts_pp_psipsi_dps2

    FUNCTION charmquark(i)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::i
      LOGICAL::charmquark
      IF(ABS(i).EQ.7)THEN
         charmquark=.TRUE.
      ELSE
         charmquark=.FALSE.
      ENDIF
    END FUNCTION charmquark

    FUNCTION bottomquark(i)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::i
      LOGICAL::bottomquark
      IF(ABS(i).EQ.12)THEN
         bottomquark=.TRUE.
      ELSE
         bottomquark=.FALSE.
      ENDIF
    END FUNCTION bottomquark

    FUNCTION opencharmmeson(i)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::i
      LOGICAL::opencharmmeson
      SELECT CASE(ABS(i))
         CASE(411,421,10411,10421,413,423,10413,&
              10423,20413,20423,415,425,431,10431,&
              433,10433,20433,435)
            opencharmmeson=.TRUE.
         CASE DEFAULT
            opencharmmeson=.FALSE.
      END SELECT
    END FUNCTION opencharmmeson

    FUNCTION opencharmbaryon(i)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::i
      LOGICAL::opencharmbaryon
      SELECT CASE(ABS(i))
         CASE(4122,4222,4212,4112,4224,&
              4214,4114,4232,4132,4322,&
              4312,4324,4314,4332,4334,&
              4412,4422,4414,4424,4432,&
              4434,4444)
            opencharmbaryon=.TRUE.
         CASE DEFAULT
            opencharmbaryon=.FALSE.
      END SELECT
    END FUNCTION opencharmbaryon

    FUNCTION openbottommeson(i)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::i
      LOGICAL::openbottommeson
      SELECT CASE(ABS(i))
         CASE(511,521,10511,10521,513,523,&
              10513,10523,20513,20523,515,&
              525,531,10531,533,10533,20533,535)
            openbottommeson=.TRUE.
         CASE DEFAULT
            openbottommeson=.FALSE.
      END SELECT
    END FUNCTION openbottommeson

    FUNCTION openbottombaryon(i)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::i
      LOGICAL::openbottombaryon
      SELECT CASE(ABS(i))
         CASE(5122,5112,5212,5222,5114,&
              5214,5224,5132,5232,5312,&
              5322,5314,5324,5332,5334,&
              5142,5242,5412,5422,5414,&
              5424,5342,5432,5434,5442,&
              5444,5512,5522,5514,5524,&
              5532,5534,5542,5544,5554)
            openbottombaryon=.TRUE.
         CASE DEFAULT
            openbottombaryon=.FALSE.
      END SELECT
    END FUNCTION openbottombaryon

    SUBROUTINE Cuts_pp_psipsi_dps2(icut)
      IMPLICIT NONE
      INTEGER,INTENT(OUT)::icut
      INTEGER::l,l1,l2,flag
      REAL(KIND(1d0))::s,d1,d2,dr,pt,eta,aaa,bbb,ptcut
      REAL(KIND(1d0)),DIMENSION(4)::ponia,pboo2
      REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
      REAL(KIND(1d0))::e,q
      icut=0
      ! invariant mass cuts
      DO l1=5,nhad-1
         DO l2=l1+1,nhad
            s=2*scalar_product(dps_hadron_pmom(l1,1:4),dps_hadron_pmom(l2,1:4))&
                 +scalar_product(dps_hadron_pmom(l1,1:4),dps_hadron_pmom(l1,1:4))&
                 +scalar_product(dps_hadron_pmom(l2,1:4),dps_hadron_pmom(l2,1:4))
            IF(s.LT.gmas(l1,l2)**2)RETURN
         ENDDO
      ENDDO
      flag=0
      DO l=5,nhad
         pt=SQRT(dps_hadron_pmom(l,1)**2+dps_hadron_pmom(l,2)**2)
         IF(pt.LT.ptc(l))THEN
            flag=1
            EXIT
         ENDIF
         IF(maxptc(l).GE.0d0)THEN
            IF(pt.GT.maxptc(l))THEN
               flag=1
               EXIT
            ENDIF
         ENDIF
         eta=prapidity(dps_hadron_pmom(l,1:4))
         IF(ABS(eta).GT.etac(l))THEN
            flag=1
            EXIT
         ENDIF
         eta=rapidity(dps_hadron_pmom(l,1:4))
         IF(absrap)eta=ABS(eta)
         IF(eta.GT.yycut(l).OR.eta.LT.yycutlow(l))THEN
            flag=1
            EXIT
         ENDIF
         ! special for the first particle , which can be used to calculate the y distribution  
         IF(l.EQ.5)THEN
            IF(eta.GT.y1cup.OR.eta.LT.y1clow)THEN
               flag=1
               EXIT
            ENDIF
         ENDIF
      ENDDO
      IF(flag.EQ.0)THEN
         DO l1=5,nhad-1
            DO l2=l1+1,nhad
               d1=prapidity(dps_hadron_pmom(l1,1:4))-prapidity(dps_hadron_pmom(l2,1:4))
               d2=ph4(dps_hadron_pmom(l1,1),dps_hadron_pmom(l1,2),dps_hadron_pmom(l1,3))&
                    -ph4(dps_hadron_pmom(l2,1),dps_hadron_pmom(l2,2),dps_hadron_pmom(l2,3))
               d2=MIN(DABS(d2),2*pi-DABS(d2))
               IF(d2/pi.GT.1d0)WRITE(*,*)d2/pi
               dr=SQRT(d1**2+d2**2)
               IF(dr.LT.drc(l1,l2))THEN
                  flag=1
                  EXIT
               ENDIF
            ENDDO
            IF(flag.EQ.1)EXIT
         ENDDO
         IF(flag.EQ.0)icut=1
      ENDIF
      IF(xFcutflag.AND.icut.EQ.1.AND.flag.EQ.0)THEN
         q=ehat
         e=q/SQRT(xp1*xp2)
         IF(.NOT.labeqcoll)THEN
            IF(.NOT.fixtarget)THEN
               pboo2(4)=(ebeam(1)+ebeam(2))
               pboo2(3)=-(ebeam(1)-ebeam(2))
            ELSE
               IF(.NOT.fixtargetrev)THEN
                  pboo2(4)=(ebeam(1)+ebeam(2))
                  pboo2(3)=-ebeam(1)
               ELSE
                  pboo2(4)=(ebeam(1)+ebeam(2))
                  pboo2(3)=ebeam(2)
               ENDIF
            ENDIF
            pboo2(1:2)=0
            ! boost from the lab frame to the collision frame 
            DO l=5,nhad
               CALL boostl(e,pboo2,dps_hadron_pmom(l,1:4))
            ENDDO
         ENDIF
         DO l=5,nhad
            eta=xFeynman(dps_hadron_pmom(l,1:4),e)
            IF(eta.GT.xFcut(l).OR.eta.LT.xFcutlow(l))THEN
               icut=0
               EXIT
            ENDIF
         ENDDO
         IF(.NOT.labeqcoll)THEN
            pboo2(3)=-pboo2(3)
            ! boost back to the lab frame 
            DO l=5,nhad
               CALL boostl(e,pboo2,dps_hadron_pmom(l,1:4))
            ENDDO
         ENDIF
      ENDIF
    END SUBROUTINE Cuts_pp_psipsi_dps2

    SUBROUTINE HO_Decay_pp_psipsi_dps2(wgtbr)
      IMPLICIT NONE
      INCLUDE "stdhep_pp_psipsi_dps2.inc"
      INTEGER::i,j,k,kk,m,ndecay
      REAL(KIND(1d0)),INTENT(OUT)::wgtbr
      REAL(KIND(1d0))::br,r
      REAL(KIND(1d0)),DIMENSION(MAX_DecayChain)::braccum
      wgtbr=1d0
      ndecay=0
      NEVHEP=1
      NHEP=nhad
      DO i=1,nhad
         ISTHEP(i)=0
         IDHEP(i)=pdgt(iflh(i))
         IF(i.GT.4.AND.i.LE.nhad-1)THEN
            ISHEP(i)=1
            JMOHEP(1,i)=1
            JMOHEP(2,i)=2
            JDAHEP(1,i)=0
            JDAHEP(2,i)=0
         ELSEIF(i.EQ.nhad)THEN
            ISHEP(i)=1
            JMOHEP(1,i)=3
            JMOHEP(2,i)=4
            JDAHEP(1,i)=0
            JDAHEP(2,i)=0
         ELSEIF(i.LE.2)THEN
            ISHEP(i)=-1
            JMOHEP(1,i)=0
            JMOHEP(2,i)=0
            JDAHEP(1,i)=5
            JDAHEP(2,i)=6
         ELSE
            ISHEP(i)=-1
            JMOHEP(1,i)=0
            JMOHEP(2,i)=0
            JDAHEP(1,i)=7
            JDAHEP(2,i)=7
         ENDIF
         PHEP(1:5,i)=dps_hadron_pmom(i,1:5)
         VHEP(1:4,i)=0d0
      ENDDO
      DO i=1,nhad
         j=iflh2DecayChains(i,0)
         IF(j.GT.0)THEN
            br=0d0
            braccum(1:MAX_DecayChain)=0d0
            DO k=1,j
               m=iflh2DecayChains(i,k)
               br=br+DecayBR(m)
               braccum(k)=br
            ENDDO
            ! randomly select the decay process
            IF(j.EQ.1)THEN
               kk=1
            ELSE
               ndecay=ndecay+1
               r=Decayran(ndecay)*br
               DO k=1,j
                  IF(braccum(k).GT.r)THEN
                     kk=k
                     EXIT
                  ELSEIF(k.EQ.j)THEN
                     kk=j
                     EXIT
                  ENDIF
               ENDDO
            ENDIF
            m=iflh2DecayChains(i,kk)
            CALL HO_One_Decay_pp_psipsi_dps2(i,m)
            wgtbr=wgtbr*br
         ENDIF
      ENDDO
      RETURN
    END SUBROUTINE HO_Decay_pp_psipsi_dps2

    SUBROUTINE HO_One_Decay_pp_psipsi_dps2(imoth,idecay)
      USE HOVll
      USE Helac_ranmar_mod
      IMPLICIT NONE
      INTEGER,INTENT(IN)::imoth,idecay
      INTEGER,PARAMETER::available_ndecay=1
      CHARACTER(len=20),DIMENSION(available_ndecay)::available_decay
      INTEGER::i
      INTEGER::lavail
      REAL(KIND(1d0)),DIMENSION(3)::svec
      REAL(KIND(1d0)),DIMENSION(0:3)::PM,PD1,PD2
      REAL(KIND(1d0))::probT
      INCLUDE "stdhep_pp_psipsi_dps2.inc"
      CALL HO_judge_avail_decay(imoth,idecay,lavail)
      IF(lavail.GT.0)THEN
         SELECT CASE(lavail)
            CASE(1)
               ! 3S11 > l+ l-
               IF(.NOT.MCoHelicity)THEN
                  rr=rand()
                  IF(rr.LT.1d0/3d0)THEN
                     IF(imoth.EQ.5)THEN
                        psi1_hel=1
                     ELSE
                        psi2_hel=1
                     ENDIF
                  ELSEIF(rr.LT.2d0/3d0)THEN
                     IF(imoth.EQ.5)THEN
                        psi1_hel=-1
                     ELSE
                        psi2_hel=-1
                     ENDIF
                  ELSE
                     IF(imoth.EQ.5)THEN
                        psi1_hel=0
                     ELSE
                        psi2_hel=0
                     ENDIF
                  ENDIF
               ENDIF
               PM(0)=dps_hadron_pmom(imoth,4)
               PM(1:3)=dps_hadron_pmom(imoth,1:3)
               svec(1:3)=PM(1:3)
               JMOHEP(1,NHEP+1:NHEP+2)=imoth
               JMOHEP(2,NHEP+1:NHEP+2)=0
               IF(imoth.EQ.5)THEN
                  IF(ABS(psi1_hel).GE.1)THEN
                     CALL HO_Vll11(PM,svec,PD1,PD2)
                     IPOLHEP(JMOHEP(1,NHEP+1))=psi1_hel
                  ELSE
                     CALL HO_Vll00(PM,svec,PD1,PD2)
                     IPOLHEP(JMOHEP(1,NHEP+1))=psi1_hel
                  ENDIF
               ELSE
                  IF(ABS(psi2_hel).GE.1)THEN
                     CALL HO_Vll11(PM,svec,PD1,PD2)
                     IPOLHEP(JMOHEP(1,NHEP+1))=psi2_hel
                  ELSE
                     CALL HO_Vll00(PM,svec,PD1,PD2)
                     IPOLHEP(JMOHEP(1,NHEP+1))=psi2_hel
                  ENDIF
               ENDIF
               ISTHEP(imoth)=1
               ISHEP(NHEP+1)=1
               ISHEP(NHEP+2)=1
               ISTHEP(NHEP+1)=0
               ISTHEP(NHEP+2)=0
               IDHEP(NHEP+1)=pdgt(DecayChains(idecay,1))
               IDHEP(NHEP+2)=pdgt(DecayChains(idecay,2))
               JDAHEP(1,imoth)=NHEP+1
               JDAHEP(2,imoth)=NHEP+2
               PHEP(5,NHEP+1:NHEP+2)=0d0
               PHEP(1:3,NHEP+1)=PD1(1:3)
               PHEP(1:3,NHEP+2)=PD2(1:3)
               PHEP(4,NHEP+1)=PD1(0)
               PHEP(4,NHEP+2)=PD2(0)
               VHEP(1:4,NHEP+1:NHEP+2)=0d0
               IPOLHEP(NHEP+1)=99 ! decay products will not decay anymore
               IPOLHEP(NHEP+2)=99
               ICOLHEP(1:2,NHEP+1:NHEP+2)=0
               NHEP=NHEP+2
            END SELECT
         ELSE
            CALL HO_avail_decays(available_ndecay,available_decay)
            PRINT *,"Only the following decay processes are available in HELAC-Onia"
            DO i=1,available_ndecay
               PRINT *,available_decay(i)
            ENDDO
            STOP
         ENDIF
         RETURN
   END SUBROUTINE HO_One_Decay_pp_psipsi_dps2

   SUBROUTINE pp_psipsi_dps2_hadronmom
      IMPLICIT NONE
      dps_hadron_pmom(1,1:3)=dps_p_born(1,1:3)
      dps_hadron_pmom(1,4)=dps_p_born(1,0)
      dps_hadron_pmom(1,5)=0d0
      dps_hadron_pmom(2,1:3)=dps_p_born(2,1:3)
      dps_hadron_pmom(2,4)=dps_p_born(2,0)
      dps_hadron_pmom(2,5)=0d0
      dps_hadron_pmom(3,1:3)=dps_p_born(3,1:3)
      dps_hadron_pmom(3,4)=dps_p_born(3,0)
      dps_hadron_pmom(3,5)=0d0
      dps_hadron_pmom(4,1:3)=dps_p_born(4,1:3)
      dps_hadron_pmom(4,4)=dps_p_born(4,0)
      dps_hadron_pmom(4,5)=0d0
      dps_hadron_pmom(5,1:3)=dps_p_born(5,1:3)
      dps_hadron_pmom(5,4)=dps_p_born(5,0)
      dps_hadron_pmom(5,5)=2d0*MC
      dps_hadron_pmom(6,1:3)=dps_p_born(6,1:3)
      dps_hadron_pmom(6,4)=dps_p_born(6,0)
      dps_hadron_pmom(6,5)=2d0*MC
      RETURN
    END SUBROUTINE pp_psipsi_dps2_hadronmom

    SUBROUTINE cuts_Decay_pp_psipsi_dps2(icut)
      ! only cut on the decay particles                                                                
      IMPLICIT NONE
      INTEGER,INTENT(OUT)::icut
      INTEGER::i,kk
      REAL(KIND(1d0))::eta,pt,c
      REAL(KIND(1d0))::ptminmuon
      INTEGER::flag
      INTEGER::muon4psiATLAS,nmuonpass1,nmuonpass2
      INCLUDE "stdhep_pp_psipsi_dps2.inc"
      icut=0
      flag=0
      muon4psiATLAS=0
      nmuonpass1=0
      nmuonpass2=0
      DO i=1,NHEP
         IF(ISHEP(i).EQ.-1)CYCLE ! only cut on the final state
         IF(ISTHEP(i).EQ.1)CYCLE ! exclude the mother particles, which have been cutted before
         IF(JMOHEP(1,i).LE.0.OR.JMOHEP(1,i).GT.NHEP)CYCLE
         IF(ISTHEP(JMOHEP(1,i)).NE.1.OR.ISHEP(JMOHEP(1,i)).EQ.-1)CYCLE
         ! cut is only applied on the decay particles
         IF(lepton_pdg(IDHEP(i)))THEN
            ! cut on the leptons
            pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
            IF(pt.LT.ho_dptcl)THEN
               flag=1
               EXIT
            ENDIF
            eta=prapidity(PHEP(1:4,i))
            IF(ABS(eta).GT.ho_detacl)THEN
               flag=2
               EXIT
            ENDIF
            eta=rapidity(PHEP(1:4,i))
            IF(absrap)eta=ABS(eta)
            IF(eta.GT.ho_dycl.OR.eta.LT.ho_dycllow)THEN
               flag=3
               EXIT
            ENDIF
            IF(PHEP(4,i).LT.ho_decl)THEN
               flag=4
               EXIT
            ENDIF
            c=PHEP(3,i)/PHEP(4,i)
            IF(ABS(c).GT.ho_dcl)THEN
               flag=5
               EXIT
            ENDIF
            ! special cutoffs
            IF(literature_cutoffs.EQ.14062380)THEN
               ! DZero (arXiv:1406.2380) special cutoffs
               eta=prapidity(PHEP(1:4,i))
               IF(ABS(eta).LT.1.35d0)THEN
                  pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
                  IF(pt.LE.2d0)THEN
                     flag=6
                     EXIT
                  ENDIF
               ELSEIF(ABS(eta).LT.2d0.AND.ABS(eta).GT.1.35d0)THEN
                  IF(PHEP(4,i).LE.4d0)THEN
                     flag=7
                     EXIT
                  ENDIF
               ELSE
                  flag=8
                  EXIT
               ENDIF
            ELSEIF(literature_cutoffs.EQ.14060000)THEN
               ! ATLAS condition, speical cutoffs
               ! there is no arXiv number now
               ! At least one of the Jpsi must have two muons with pT>4 GeV each
               ! muon pT>2.5 GeV and muon |eta|<2.3
               eta=prapidity(PHEP(1:4,i))
               IF(ABS(eta).GE.2.3d0)THEN
                  flag=9
                  EXIT
               ENDIF
               pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
               IF(pt.LE.2.5d0)THEN
                  flag=10
                  EXIT
               ENDIF
               IF(IDHEP(JMOHEP(1,i)).EQ.443.AND.muon4psiATLAS.LT.2)THEN
                  IF(pt.GT.4d0)THEN
                     muon4psiATLAS=muon4psiATLAS+1
                  ELSE
                     muon4psiATLAS=muon4psiATLAS-1
                  ENDIF
               ENDIF
               IF(muon4psiATLAS.EQ.-2)muon4psiATLAS=0
            ELSEIF(literature_cutoffs.EQ.14070000)THEN
               ! CMS condition (from Junquan Tao for psi+psi)
               eta=prapidity(PHEP(1:4,i))
               IF(ABS(eta).LT.1.2d0)THEN
                  pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
                  IF(pt.LE.3.5d0)THEN
                     flag=12
                     EXIT
                  ENDIF
               ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.1.6d0)THEN
                  ptminmuon=3.5d0-(ABS(eta)-1.2d0)*1.5d0/0.4d0
                  pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
                  IF(pt.LE.ptminmuon)THEN
                     flag=13
                     EXIT
                  ENDIF
               ELSEIF(ABS(eta).GT.1.6d0.AND.ABS(eta).LT.2.4d0)THEN
                  pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
                  IF(pt.LE.2.0d0)THEN
                     flag=14
                     EXIT
                  ENDIF
               ELSE
                  flag=15
                  EXIT
               ENDIF
            ELSEIF(literature_cutoffs.EQ.15090000)THEN
               ! the fidicuial region for CMS from
               ! Ben Weinert
               ! follow http://arxiv.org/pdf/1406.0484
               ! 3 out of 4 muons have
               ! pT(mu) >3.5 GeV/c  if |eta(mu)|<1.2
               ! pT(mu) >3.5 --> 2.0 GeV/c if 1.2< |eta(mu)|<1.6 
               ! pT(mu) >2.0 GeV/c  if 1.6<|eta(mu)|<2.4
               ! The other muon has: 
               ! pT(mu) >3.0 GeV/c  if |eta(mu)|<1.2
               ! p(mu) >3.0 GeV/c  if 1.2<|eta(mu)|<2.4
               ! The J/psi cuts F.V.:
               ! pT(J/psi) > 6.5 GeV if |y(J/psi)|<1.2
               ! pT(J/psi) > 6.5 --> 4.5 GeV if   1.2<|y(J/psi)|<1.43
               ! pT(J/psi) > 4.5 GeV if   1.43<|y(J/psi)|<2.2
               IF(IDHEP(JMOHEP(1,i)).EQ.443)THEN
                  eta=prapidity(PHEP(1:4,i))
                  pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
                  ptminmuon=3.5d0-(ABS(eta)-1.2d0)*1.5d0/0.4d0
                  IF(ABS(eta).LT.1.2d0.AND.pt.GT.3.5d0)THEN
                     nmuonpass1=nmuonpass1+1
                  ELSEIF(ABS(eta).GT.1.6d0.AND.ABS(eta).LT.2.4d0&
                       .AND.pt.GT.2.0d0)THEN
                     nmuonpass1=nmuonpass1+1
                  ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.1.6d0&
                       .AND.pt.GT.ptminmuon)THEN
                     nmuonpass1=nmuonpass1+1
                  ELSEIF(ABS(eta).LT.1.2d0.AND.pt.GT.3.0d0)THEN
                     nmuonpass2=nmuonpass2+1
                  ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.2.4d0)THEN
                     pt=SQRT(pt**2+PHEP(3,i)**2) ! it is p
                     IF(pt.GT.3d0)THEN
                        nmuonpass2=nmuonpass2+1
                     ENDIF
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
      ENDDO
      IF(flag.EQ.0.AND.literature_cutoffs.EQ.14060000)THEN
         ! ATLAS condition, speical cutoffs
         ! there is no arXiv number now
         ! At least one of the Jpsi must have two muons with pT>4 GeV each
         IF(muon4psiATLAS.LT.2)THEN
            flag=11
         ENDIF
      ELSEIF(flag.EQ.0.AND.literature_cutoffs.EQ.15090000)THEN
         IF(nmuonpass1.LT.3)THEN
            flag=12
         ELSEIF(nmuonpass1.EQ.3.AND.nmuonpass2.LT.1)THEN
            flag=13
         ENDIF
      ENDIF
      IF(flag.EQ.0)THEN
         icut=1
      ENDIF
      RETURN
    END SUBROUTINE cuts_Decay_pp_psipsi_dps2

    SUBROUTINE unwei_procedure_pp_psipsi_dps2(w1,nwri,nwmax,nwarn)
      IMPLICIT NONE
      REAL(KIND(1d0)),INTENT(IN)::w1
      INTEGER,INTENT(INOUT)::nwri,nwmax,nwarn
      REAL(KIND(1d0)),DIMENSION(1)::ranr
      REAL(KIND=DBL)::vtime,vspin,scale1,scalup,xwgtup,px,py,pz,p0,pmass,umax,umax1
      INTEGER::init=0,i,j,iij
      INTEGER::idup,idprup,istup,imothup1,imothup2,icol1,icol2
      LOGICAL::llwri
      SAVE init,umax,umax1
      IF(init.EQ.0)THEN
         umax=0d0
         umax1=0d0
         init=1
      ENDIF
      IF(lwmax.EQ.1)THEN
         IF(umax.LT.w1)THEN
            umax=w1
         ENDIF
         nwmax=nwmax+1
         umax1=umax
      ENDIF
      IF(lwmax.EQ.2)THEN
         IF(w1.GT.umax1)THEN
            umax1=w1
            WRITE(*,*)'WARNING:umax1,umax',umax1,umax
         ENDIF
         llwri=.FALSE.
         CALL RANDA(1,ranr)
         IF(umax*ranr(1).LT.w1)llwri=.TRUE.
         IF(umax.LT.w1)nwarn=nwarn+1
         IF(llwri)THEN
            nwri=nwri+1
            IF(NDecayChains.GT.0)THEN
               CALL unwei_writer_Decay_pp_psipsi_dps2
               Nevents=nwri
               RETURN
            ENDIF
            idprup=89 ! id for the process 
            xwgtup=1 !w1*10**3 !1
            CALL pp_psipsi_dps2_qcdscale(scalup)
            scalup=muR_over_ref*scalup
            WRITE(nunit3)nhad,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
            DO i=1,nhad
               IF(opencharmmeson(iflh(i)).OR.openbottommeson(iflh(i))&
                    .OR.opencharmbaryon(iflh(i)).OR.openbottombaryon(iflh(i)))THEN
                  idup=iflh(i)
               ELSE
                  idup=pdgt(iflh(i))
               ENDIF
               IF(i.LE.4)THEN
                  istup=-1
               ELSE
                  istup=1
               ENDIF
               imothup1=0
               imothup2=0
               IF(i.EQ.5)THEN
                  imothup1=1
                  imothup2=2
               ELSEIF(i.EQ.6)THEN
                  imothup1=3
                  imothup2=4
               ENDIF
               IF(i.LE.4)THEN
                  icol1=icol_un(i,1)+100
                  IF(icol1.EQ.100)icol1=0
                  icol2=icol_un(i,2)+100
                  IF(icol2.EQ.100)icol2=0
               ELSE
                  icol1=icol_un(i,2)+100
                  IF(icol1.EQ.100)icol1=0
                  icol2=icol_un(i,1)+100
                  IF(icol2.EQ.100)icol2=0
               ENDIF
               px=dps_hadron_pmom(i,1)
               py=dps_hadron_pmom(i,2)
               pz=dps_hadron_pmom(i,3)
               p0=dps_hadron_pmom(i,4)
               pmass=dps_hadron_pmom(i,5)
               vtime=0
               vspin=9

               WRITE(nunit3)idup,istup,imothup1,imothup2,icol1,icol2&
                    ,px,py,pz,p0,pmass,vtime,vspin
            ENDDO
            IF(reweight_scale.OR.reweight_pdf.OR.reweight_npdf.OR.reweight_ref)THEN
               iij=0
               IF(reweight_scale)THEN
                  DO i=1,3
                     DO j=1,3
                        iij=iij+1
                        rwgt_values(iij)=wgtxsecmu(i,j)*XWGTUP
                     ENDDO
                  ENDDO
               ENDIF
               IF(reweight_pdf)THEN
                  IF(ho_npdf.GT.0)THEN
                     DO i=0,ho_npdf
                        iij=iij+1
                        IF(i.EQ.0)THEN
                           rwgt_values(iij)=XWGTUP
                        ELSE
                           rwgt_values(iij)=XWGTUP*wgtxsecpdf(i)
                        ENDIF
                     ENDDO
                  ENDIF
                  IF(ho_npdf2.GT.0)THEN
                     DO i=0,ho_npdf2
                        iij=iij+1
                        IF(i.EQ.0)THEN
                           rwgt_values(iij)=XWGTUP
                        ELSE
                           rwgt_values(iij)=XWGTUP*wgtxsecpdf(ho_npdf+i)
                        ENDIF
                     ENDDO
                  ENDIF
               ENDIF
               IF(reweight_npdf)THEN
                  DO i=0,ho_nnpdf
                     iij=iij+1
                     IF(i.EQ.0)THEN
                        rwgt_values(iij)=XWGTUP
                     ELSE
                        rwgt_values(iij)=XWGTUP*wgtxsecnpdf(i)
                     ENDIF
                  ENDDO
               ENDIF
               IF(reweight_ref)THEN
                  DO i=0,ho_nref
                     iij=iij+1
                     IF(i.EQ.0)THEN
                        rwgt_values(iij)=XWGTUP
                     ELSE
                        rwgt_values(iij)=XWGTUP*wgtxsecref(i)
                     ENDIF
                  ENDDO
               ENDIF
               IF(iij.NE.tot_nrwgt)THEN
                  WRITE(*,*)"ERROR:inconsistence for the reweigts #0 !"
                  WRITE(*,*)"tot_nrwgt=",tot_nrwgt
                  WRITE(*,*)"couting nrwgt=",iij
                  STOP
               ENDIF
               WRITE(nunit30)(rwgt_values(i),i=1,tot_nrwgt)
            ENDIF
         ENDIF
      ENDIF
      Nevents=nwri
    END SUBROUTINE unwei_procedure_pp_psipsi_dps2

    SUBROUTINE unwei_writer_Decay_pp_psipsi_dps2
      IMPLICIT NONE
      INCLUDE "stdhep_pp_psipsi_dps2.inc"
      INTEGER::icol1,icol2,idup,idprup,istup,imothup1,imothup2
      REAL(KIND(1d0))::px,py,pz,p0,pmass,scalup,vtime,vspin,xwgtup
      INTEGER::i,j,iij
      idprup = 89
      xwgtup=1
      CALL pp_psipsi_dps2_qcdscale(scalup)
      scalup=muR_over_ref*scalup
      WRITE(nunit3)NHEP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
      DO i=1,NHEP
         idup=IDHEP(i)
         istup=ISHEP(i)
         IF(ISTHEP(i).EQ.1.AND.ISHEP(i).EQ.1)THEN
            istup=2
         ENDIF
         imothup1=JMOHEP(1,i)
         imothup2=JMOHEP(2,i)
         IF(i.GT.nhad)THEN
            ! no hadronic decay
            icol1=0
            icol2=0
         ELSE
            IF(istup.LT.0)THEN
               icol1=icol_un(i,1)+100
               IF(icol1.EQ.100)icol1=0
               icol2=icol_un(i,2)+100
               IF(icol2.EQ.100)icol2=0
            ELSE
               icol1=icol_un(i,2)+100
               IF(icol1.EQ.100)icol1=0
               icol2=icol_un(i,1)+100
               IF(icol2.EQ.100)icol2=0
            ENDIF
         ENDIF
         px=PHEP(1,i)
         py=PHEP(2,i)
         pz=PHEP(3,i)
         p0=PHEP(4,i)
         pmass=PHEP(5,i)
         vtime=0
         vspin=9
         WRITE(nunit3)idup,istup,imothup1,imothup2,icol1,icol2,&
              px,py,pz,p0,pmass,vtime,vspin
      ENDDO
      IF(reweight_scale.OR.reweight_pdf.OR.reweight_npdf.OR.reweight_ref)THEN
         iij=0
         IF(reweight_scale)THEN
            DO i=1,3
               DO j=1,3
                  iij=iij+1
                  rwgt_values(iij)=wgtxsecmu(i,j)*XWGTUP
               ENDDO
            ENDDO
         ENDIF
         IF(reweight_pdf)THEN
            IF(ho_npdf.GT.0)THEN
               DO i=0,ho_npdf
                  iij=iij+1
                  IF(i.EQ.0)THEN
                     rwgt_values(iij)=XWGTUP
                  ELSE
                     rwgt_values(iij)=XWGTUP*wgtxsecpdf(i)
                  ENDIF
               ENDDO
            ENDIF
            IF(ho_npdf2.GT.0)THEN
               DO i=0,ho_npdf2
                  iij=iij+1
                  IF(i.EQ.0)THEN
                     rwgt_values(iij)=XWGTUP
                  ELSE
                     rwgt_values(iij)=XWGTUP*wgtxsecpdf(ho_npdf+i)
                  ENDIF
               ENDDO
            ENDIF
         ENDIF
         IF(reweight_npdf)THEN
            DO i=0,ho_nnpdf
               iij=iij+1
               IF(i.EQ.0)THEN
                  rwgt_values(iij)=XWGTUP
               ELSE
                  rwgt_values(iij)=XWGTUP*wgtxsecnpdf(i)
               ENDIF
            ENDDO
         ENDIF
         IF(reweight_ref)THEN
            DO i=0,ho_nref
               iij=iij+1
               IF(i.EQ.0)THEN
                  rwgt_values(iij)=XWGTUP
               ELSE
                  rwgt_values(iij)=XWGTUP*wgtxsecref(i)
               ENDIF
            ENDDO
         ENDIF
         IF(iij.NE.tot_nrwgt)THEN
            WRITE(*,*)"ERROR:inconsistence for the reweigts #1 !"
            WRITE(*,*)"tot_nrwgt=",tot_nrwgt
            WRITE(*,*)"couting nrwgt=",iij
            STOP
         ENDIF
         WRITE(nunit30)(rwgt_values(i),i=1,tot_nrwgt)
      ENDIF
      RETURN
    END SUBROUTINE unwei_writer_Decay_pp_psipsi_dps2

    SUBROUTINE Generate_lhe_pp_psipsi_dps2(n1,nevent,icase)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::n1,nevent,icase
      CHARACTER(len=24),PARAMETER::tmp_dir="./tmp/",output_dir="./output/"
      INTEGER::i,nunit4,nunit5,nunit3,nunit30
      INTEGER::istop,k,jj
      INTEGER,DIMENSION(:),ALLOCATABLE::rwgt_ids
      REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::rwgt_vals
      REAL(KIND(1d0)),DIMENSION(3)::Rscaleupdown,Fscaleupdown
      REAL(KIND(1d0))::p0,px,py,pz,SPINUP,EBMUP1,EBMUP2,XSECUP1,XSECUP2,XERRUP1,XMAXUP1,&
           XWGTUP,VTIMUP,SCALUP,PM0,AQEDUP,AQCDUP,XWGTUP2
      INTEGER::IDBMUP1,IDBMUP2,IDWTUP,NPRUP,IDPRUP,NUP,IDUP,ISTUP,IMOTHUP1,IMOTHUP2,&
           ICOLUP1,ICOLUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,LPRUP1
      INTEGER::irwgt=0,irwgt2
      REAL(KIND(1d0))::xxwgt_old
      INCLUDE '../../../src/pdfreweight_common.inc'
      INCLUDE '../../../src/pdf2reweight_common.inc'
      INCLUDE '../../../src/npdfreweight_common.inc'
      INCLUDE "../../../src/ref_reweight_common.inc"
      INCLUDE '../../../src/scalereweight_common.inc'
      nunit3=30
      CLOSE(nunit3)
      OPEN(nunit3,FILE=TRIM(tmp_dir)//'even_pp_psipsi_dps2.out',FORM='unformatted')
      IF(scale_reweight_common.OR.pdf_reweight_common.OR.pdf2_reweight_common.OR.npdf_reweight_common.OR.ref_reweight_common)THEN
         nunit30=300
         CLOSE(nunit30)
         OPEN(nunit30,FILE=TRIM(tmp_dir)//'even_rwgt_pp_psipsi_dps2.out',FORM='unformatted')
      ENDIF
      nunit4=31
      CLOSE(nunit4)
      OPEN(nunit4,FILE=TRIM(tmp_dir)//'sample_pp_psipsi_dps2.init')
      nunit5=32
      CLOSE(nunit5)
      OPEN(nunit5,FILE=TRIM(output_dir)//'sample_pp_psipsi_dps2.lhe')
      WRITE(nunit5,'(A)') '<LesHouchesEvents version="1.0">'
      WRITE(nunit5,'(A)') '<!--'
      WRITE(nunit5,'(A)') 'File generated with HELAC-ONIA '
      WRITE(nunit5,'(A)') '-->'
      IF(scale_reweight_common.OR.pdf_reweight_common.OR.pdf2_reweight_common.OR.npdf_reweight_common.OR.ref_reweight_common)THEN
         irwgt=0
         IF(scale_reweight_common)THEN
            irwgt=irwgt+9
         ENDIF
         IF(pdf_reweight_common)THEN
            irwgt=irwgt+pdf_set_max_common-pdf_set_min_common+2
         ENDIF
         IF(pdf2_reweight_common)THEN
            irwgt=irwgt+pdf2_set_max_common-pdf2_set_min_common+2
         ENDIF
         IF(npdf_reweight_common)THEN
            irwgt=irwgt+npdf_set_max_common-npdf_set_min_common+2
         ENDIF
         IF(ref_reweight_common)THEN
            irwgt=irwgt+ref_set_max_common-ref_set_min_common+2
         ENDIF
         IF(ALLOCATED(rwgt_ids))THEN
            DEALLOCATE(rwgt_ids)
         ENDIF
         ALLOCATE(rwgt_ids(irwgt))
         IF(ALLOCATED(rwgt_vals))THEN
            DEALLOCATE(rwgt_vals)
         ENDIF
         ALLOCATE(rwgt_vals(irwgt))

         WRITE(nunit5,'(A)') '  <header>'
         WRITE(nunit5,'(A)') '  <initrwgt>'
         irwgt2=0
         IF(scale_reweight_common)THEN
            WRITE(nunit5,'(A)') "    <weightgroup type='scale_variation' combine='envelope'>"
            Rscaleupdown(1)=1d0
            Rscaleupdown(2)=rw_RScale_up_common
            Rscaleupdown(3)=rw_RScale_down_common
            Fscaleupdown(1)=1d0
            Fscaleupdown(2)=rw_FScale_up_common
            Fscaleupdown(3)=rw_FScale_down_common
            k=1000
            DO i=1,3
               DO jj=1,3
                  k=k+1
                  irwgt2=irwgt2+1
                  rwgt_ids(irwgt2)=k
                  WRITE(nunit5,6100)k,Rscaleupdown(i),Fscaleupdown(jj)
               ENDDO
            ENDDO
            WRITE(nunit5,'(A)') "    </weightgroup>"
         ENDIF
         IF(pdf_reweight_common)THEN
            WRITE(nunit5,'(A)') "    <weightgroup type='PDF_variation' combine='lhapdf'>"
            k=1999
            DO i=pdf_set_min_common-1,pdf_set_max_common
               k=k+1
               irwgt2=irwgt2+1
               rwgt_ids(irwgt2)=k
               WRITE(nunit5,6200)k,i
            ENDDO
            WRITE(nunit5,'(A)') "    </weightgroup>"
         ENDIF
         IF(pdf2_reweight_common)THEN
            WRITE(nunit5,'(A)') "    <weightgroup type='PDF2_variation' combine='lhapdf'>"
            k=4999
            DO i=pdf2_set_min_common-1,pdf2_set_max_common
               k=k+1
               irwgt2=irwgt2+1
               rwgt_ids(irwgt2)=k
               WRITE(nunit5,6700)k,i
            ENDDO
            WRITE(nunit5,'(A)') "    </weightgroup>"
         ENDIF
         IF(npdf_reweight_common)THEN
            WRITE(nunit5,'(A)') "    <weightgroup type='nPDF_variation' combine='lhapdf'>"
            k=5999
            IF(npdf_set_min_common.NE.1001)THEN
               DO i=npdf_set_min_common-1,npdf_set_max_common
                  k=k+1
                  irwgt2=irwgt2+1
                  rwgt_ids(irwgt2)=k
                  WRITE(nunit5,6500)k,i
               ENDDO
            ELSE
               READ(nunit4,*)IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
               REWIND(nunit4)
               DO i=npdf_set_min_common-1,npdf_set_max_common
                  k=k+1
                  irwgt2=irwgt2+1
                  rwgt_ids(irwgt2)=k
                  WRITE(nunit5,6500)k,i-1000+IPDFSUP1
               ENDDO
            ENDIF
            WRITE(nunit5,'(A)') "    </weightgroup>"
         ENDIF
         IF(ref_reweight_common)THEN
            WRITE(nunit5,'(A)') "    <weightgroup type='reference' combine='none'>"
            k=8999
            DO i=ref_set_min_common-1,ref_set_max_common
               k=k+1
               irwgt2=irwgt2+1
               rwgt_ids(irwgt2)=k
               WRITE(nunit5,6600)k,i
            ENDDO
            WRITE(nunit5,'(A)') "    </weightgroup>"
         ENDIF
         WRITE(nunit5,'(A)') '  </initrwgt>'
         WRITE(nunit5,'(A)') '  </header>'
         IF(irwgt2.NE.irwgt)THEN
            WRITE(*,*)"ERROR:inconsistece of the number of reweights"
            WRITE(*,*)"irwgt=",irwgt
            WRITE(*,*)"irwgt2=",irwgt2
            STOP
         ENDIF
      ENDIF
      WRITE(nunit5,'(A)') '<init>'
      READ(nunit4,*)IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
      READ(nunit4,*)XSECUP1,XERRUP1,XMAXUP1,LPRUP1
      WRITE(nunit5,5000)IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
      WRITE(nunit5,5100)XSECUP1,XERRUP1,XMAXUP1,LPRUP1
      WRITE(nunit5,'(A)') '</init>'
      istop=1
      k=0
      XWGTUP2=XSECUP1/nevent
      DO WHILE(istop.EQ.1)
         k=k+1
         READ(nunit3,END=100) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
         IF(icase.EQ.1)XWGTUP=XWGTUP2
         WRITE(nunit5,'(A)') '<event>'
         WRITE(nunit5,5200) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
         DO i=1,NUP
            READ(nunit3)IDUP,ISTUP,iMOTHUP1,iMOTHUP2,ICOLUP1,ICOLUP2,px,py,pz,p0,pm0,VTIMUP,SPINUP
            WRITE(nunit5,5300)IDUP,ISTUP,iMOTHUP1,iMOTHUP2,ICOLUP1,ICOLUP2,px,py,pz,p0,pm0,VTIMUP,SPINUP
         ENDDO
         IF(irwgt.GT.0.AND.(scale_reweight_common.OR.pdf_reweight_common.OR.pdf2_reweight_common&
              .OR.npdf_reweight_common.OR.ref_reweight_common))THEN
           ! filling the rwgt
            WRITE(nunit5,'(A)') '  <rwgt>'
            READ(nunit30)(rwgt_vals(i),i=1,irwgt)
            IF(icase.EQ.1)THEN
               xxwgt_old=rwgt_vals(1)
               IF(xxwgt_old.EQ.0d0)THEN
                  xxwgt_old=1d0
               ENDIF
               DO i=1,irwgt
                  rwgt_vals(i)=rwgt_vals(i)*XWGTUP2/xxwgt_old
               ENDDO
            ENDIF
            DO i=1,irwgt
               WRITE(nunit5,6300)rwgt_ids(i),rwgt_vals(i)
            ENDDO
            WRITE(nunit5,'(A)') '  </rwgt>'
         ENDIF
         WRITE(nunit5,'(A)') '</event>'
      ENDDO
100   CONTINUE
      IF(icase.EQ.1.AND.k.NE.nevent+1)THEN
         WRITE(*,*)"WARNING:mismatching of the unweighted lhe events number ",k-1,nevent
      ENDIF
      WRITE(nunit5,'(A)') '</LesHouchesEvents>'
      CLOSE(nunit3,STATUS='delete')
      CLOSE(nunit4,STATUS='delete')
      IF(scale_reweight_common.OR.pdf_reweight_common.OR.pdf2_reweight_common.OR.npdf_reweight_common.OR.ref_reweight_common)THEN
         CLOSE(nunit30,STATUS='delete')
      ENDIF
5200  FORMAT(1P,2I6,4E14.6)
5300  FORMAT(1P,I8,5I5,5E18.10,E14.6,E12.4)
5000  FORMAT(1P,2I8,2E14.6,6I8)
5100  FORMAT(1P,3E20.10,I6)
      CLOSE(nunit5,STATUS='keep')
6100  FORMAT(6x,"<weight id='",I4,"'>",1x,&
           "muR=",E11.5,1x,"muF=",E11.5,1x,'</weight>')
6200  FORMAT(6x,"<weight id='",I4,"'>",1x,&
           "pdfset=",I6,1x,"</weight>")
6300  FORMAT(4x,"<wgt id='",I4,"'>",1x,&
           E11.5,1x,"</wgt>")
6500  FORMAT(6x,"<weight id='",I4,"'>",1x,&
           "npdfset=",I6,1x,"</weight>")
6600  FORMAT(6x,"<weight id='",I4,"'>",1x,&
           "reference=",I6,1x,"</weight>")
6700  FORMAT(6x,"<weight id='",I4,"'>",1x,&
           "pdf2set=",I6,1x,"</weight>")
      RETURN
    END SUBROUTINE Generate_lhe_pp_psipsi_dps2

    SUBROUTINE UPDATE_AS()
      IMPLICIT NONE
      REAL(KIND(1d0))::scale
      REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
      IF(irun.NE.0)THEN
         CALL pp_psipsi_DPS2_qcdscale(scale)
         scale=scale*muR_over_ref
         aqcdup=ALPHAS_dps(scale)
         GStrong=DSQRT(aqcdup*4d0*pi)
      ENDIF
      RETURN
    END SUBROUTINE UPDATE_AS
    
    FUNCTION alphas_dps(scale)
      IMPLICIT NONE
      REAL(KIND(1d0)),INTENT(IN)::scale
      REAL(KIND(1d0))::alphas_dps
      REAL(KIND(1d0)),EXTERNAL::GSALPS
      IF(iPDFSUP1.EQ.921000)THEN
         ! GS09 dPDF
         alphas_dps=GSALPS(scale)
      ELSE
         alphas_dps=ALPHAS(scale)
      ENDIF
      RETURN
    END FUNCTION alphas_dps
    
    SUBROUTINE pp_psipsi_dps2_reweight_xsec_scale(wsf0)
      IMPLICIT NONE
      REAL(KIND(1d0)),INTENT(IN)::wsf0
      REAL(KIND(1d0))::alphasc=1d0,alphasu=1d0,alphasd=1d0
      REAL(KIND(1d0)),DIMENSION(3)::R_alphas,R_pdf
      REAL(KIND(1d0))::wsfw
      INTEGER::i,j
      IF(.NOT.reweight_scale)THEN
         WRITE(*,*)"ERROR:Please set reweight_scale to be T first !"
         STOP
      ENDIF
      ! reweighting for alpha_s
      IF(alphas_power.EQ.0)THEN
         alphasc=1d0
         alphasu=1d0
         alphasd=1d0
      ELSE
         CALL pp_psipsi_dps2_qcdscale(scale)
         scale=scale*muR_over_ref
         alphasc=ALPHAS_DPS(scale)
         alphasu=ALPHAS_DPS(scale*rw_Rscale_up)
         alphasd=ALPHAS_DPS(scale*rw_Rscale_down)
      ENDIF
      R_alphas(1)=1d0
      R_alphas(2)=(alphasu/alphasc)**alphas_power
      R_alphas(3)=(alphasd/alphasc)**alphas_power
      R_pdf(1)=1d0
      IF(istruc.EQ.1)THEN
         reweight_Fscale_phase=1 ! 1: multiply central scale * rw_Fscale_up
         CALL strf_pdf_pp_psipsi_dps2(wsfw)
         R_pdf(2)=wsfw/wsf0
         reweight_Fscale_phase=-1 ! -1: mutliply central scale * rw_Fscale_down
         CALL strf_pdf_pp_psipsi_dps2(wsfw)
         R_pdf(3)=wsfw/wsf0
         ! recover it
         reweight_Fscale_phase=0
      ELSE
         R_pdf(2:3)=1d0
      ENDIF
      wgtxsecmu(1:3,1:3)=1d0
      DO i=1,3
         wgtxsecmu(i,1:3)=R_alphas(i)
         DO j=1,3
            wgtxsecmu(i,j)=wgtxsecmu(i,j)*R_pdf(j)
         ENDDO
      END DO
      RETURN
    END SUBROUTINE pp_psipsi_dps2_reweight_xsec_scale

    SUBROUTINE pp_psipsi_dps2_reweight_xsec_pdf(wsf0)
      IMPLICIT NONE
      INTEGER::init=0,i,k,kk
      REAL(KIND(1d0)),INTENT(IN)::wsf0
      REAL(KIND(1d0))::wsfw
      SAVE init
      LOGICAL::lexist
      IF(.NOT.reweight_pdf)THEN
         WRITE(*,*)"ERROR:Please set reweight_pdf to be T first !"
         STOP
      ENDIF
      IF(init.EQ.0)THEN
         IF(MOD(ho_npdf,2).NE.0)THEN
            WRITE(*,*)'The number of error sets must be even',ho_npdf
            STOP
         ENDIF
         IF(MOD(ho_npdf2,2).NE.0)THEN
            WRITE(*,*)'The number of error sets for beam 2 must be even',ho_npdf2
            STOP
         ENDIF
         IF(ALLOCATED(wgtxsecpdf))THEN
            DEALLOCATE(wgtxsecpdf)
         ENDIF
         ALLOCATE(wgtxsecpdf(ho_npdf+ho_npdf2))
         IF(ho_npdf.GT.0)THEN
            IF(ALLOCATED(idpdf))THEN
               DEALLOCATE(idpdf)
            ENDIF
            ALLOCATE(idpdf(0:ho_npdf))
            idpdf(0)=iPDFSUP1
            idpdf(1)=ipdf_set_min
            IF(ipdf_set_max-ipdf_set_min+1.NE.ho_npdf)THEN
               WRITE(*,*)'Incorrect the number of error pdf',ho_npdf,ipdf_set_min,ipdf_set_max
               STOP
            ENDIF
            DO i=2,ho_npdf
               idpdf(i)=idpdf(1)+i-1
            ENDDO
            WRITE(*,*) 'Doing PDF reweight:'
            WRITE(*,*) 'Central set id: ',idpdf(0)
            WRITE(*,*) 'Min error set id: ',idpdf(1)
            WRITE(*,*) 'Max error set id: ',idpdf(ho_npdf)
         ENDIF
         IF(ho_npdf2.GT.0)THEN
            IF(ALLOCATED(idpdf2))THEN
               DEALLOCATE(idpdf2)
            ENDIF
            ALLOCATE(idpdf2(0:ho_npdf2))
            idpdf2(0)=iPDFSUP2
            idpdf2(1)=ipdf2_set_min
            IF(ipdf2_set_max-ipdf2_set_min+1.NE.ho_npdf2)THEN
               WRITE(*,*)'Incorrect the number of error pdf2',ho_npdf2,ipdf2_set_min,ipdf2_set_max
               STOP
            ENDIF
            DO i=2,ho_npdf2
               idpdf2(i)=idpdf2(1)+i-1
            ENDDO
            WRITE(*,*) 'Doing PDF Beam 2 reweight:'
            WRITE(*,*) 'Central set id: ',idpdf2(0)
            WRITE(*,*) 'Min error set id: ',idpdf2(1)
            WRITE(*,*) 'Max error set id: ',idpdf2(ho_npdf2)
         ENDIF
         init=1
      ENDIF
      IF(.NOT.multipdfloading)THEN
         DO i=1,ho_npdf
            INCLUDE "../../../input/lhapdf/call_initpdf"
            IF(istruc.EQ.1)THEN
               CALL strf_pdf_pp_psipsi_dps2(wsfw)
            ELSE
               WRITE(*,*)"ERROR: do not know the meaning of istruc with reweighting PDF"
               STOP
            ENDIF
            wgtxsecpdf(i)=wsfw/wsf0
         ENDDO
      ELSE
         IF(.NOT.beams_pdf_correlation)THEN
            DO i=1,ho_npdf
               INCLUDE "../../../input/lhapdf/call_initmpdf1"
               CALL strf_pdf_pp_psipsi_dps2(wsfw)
               wgtxsecpdf(i)=wsfw/wsf0
            ENDDO
            INCLUDE "../../../input/lhapdf/call_initmpdf10"
            DO i=1,ho_npdf2
               INCLUDE "../../../input/lhapdf/call_initmpdf2"
               CALL strf_pdf_pp_psipsi_dps2(wsfw)
               wgtxsecpdf(i+ho_npdf)=wsfw/wsf0
            ENDDO
            INCLUDE "../../../input/lhapdf/call_initmpdf20"
         ELSE
             ! it is correlated for two beams
            DO i=1,ho_npdf
               INCLUDE "../../../input/lhapdf/call_initmpdf1"
               INCLUDE "../../../input/lhapdf/call_initmpdf2"
               CALL strf_pdf_pp_psipsi_dps2(wsfw)
               wgtxsecpdf(i)=wsfw/wsf0
            ENDDO
            INCLUDE "../../../input/lhapdf/call_initmpdf10"
            INCLUDE "../../../input/lhapdf/call_initmpdf20"
         ENDIF
         RETURN
      ENDIF
      ! recover it
      INCLUDE "../../../input/lhapdf/call_initpdf0"
      RETURN
    END SUBROUTINE pp_psipsi_dps2_reweight_xsec_pdf

    SUBROUTINE pp_psipsi_dps2_reweight_xsec_npdf(wsf0)
      IMPLICIT NONE
      INTEGER::init=0,i,k,kk
      INTEGER,DIMENSION(2)::icase
      REAL(KIND(1d0)),INTENT(IN)::wsf0
      REAL(KIND(1d0))::wsfw
      SAVE init
      INTEGER::icheck=0
      SAVE icheck
      LOGICAL::lexist
      IF(.NOT.reweight_npdf)THEN
         WRITE(*,*)"ERROR:Please set reweight_npdf to be T first !"
         STOP
      ENDIF
    IF(init.EQ.0)THEN
       IF(MOD(ho_nnpdf,2).NE.0)THEN
          WRITE(*,*)'The number of error sets must be even',ho_nnpdf
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecnpdf))THEN
          DEALLOCATE(wgtxsecnpdf)
       ENDIF
       ALLOCATE(wgtxsecnpdf(ho_nnpdf))
       IF(ALLOCATED(idnpdf))THEN
          DEALLOCATE(idnpdf)
       ENDIF
       ALLOCATE(idnpdf(0:ho_nnpdf))
       IF(nPDF_id.NE.1000)THEN
          idnpdf(0)=nPDF_id
          idnpdf(1)=inpdf_set_min
       ELSE
          idnpdf(0)=iPDFSUP1
          idnpdf(1)=inpdf_set_min-1000+iPDFSUP1
       ENDIF
       IF(inpdf_set_max-inpdf_set_min+1.NE.ho_nnpdf)THEN
          WRITE(*,*)'Incorrect the number of error npdf',ho_nnpdf,inpdf_set_min,inpdf_set_max
          STOP
       ENDIF
       DO i=2,ho_nnpdf
          idnpdf(i)=idnpdf(1)+i-1
       ENDDO
       WRITE(*,*) 'Doing nPDF reweight:'
       WRITE(*,*) 'Central set id: ',idnpdf(0)
       WRITE(*,*) 'Min error set id: ',idnpdf(1)
       WRITE(*,*) 'Max error set id: ',idnpdf(ho_nnpdf)
       init=1
    ENDIF
    DO i=1,ho_nnpdf
       use_neutron_rand=.TRUE.
       INCLUDE "../../../input/lhapdf/call_initnpdfi"
       INCLUDE "../../../input/lhapdf/call_initnpdfi_lhapdf6"
       IF(istruc.EQ.1)THEN
          CALL strf_pdf_pp_psipsi_dps2(wsfw)
       ELSE
          WRITE(*,*)"ERROR: cannot understand the value of istruc within pp_psipsi_dps2_reweigt_xsec_npdf"
          STOP
       ENDIF
       wgtxsecnpdf(i)=wsfw/wsf0
    ENDDO
    ! recover it
    use_neutron_rand=.FALSE.
    INCLUDE "../../../input/lhapdf/call_initnpdf"
    INCLUDE "../../../input/lhapdf/call_strf_lhanpdf_0"
    RETURN
  END SUBROUTINE pp_psipsi_dps2_reweight_xsec_npdf

  SUBROUTINE pp_psipsi_dps2_reweight_xsec_ref(wsf0)
    IMPLICIT NONE
    INTEGER::init=0,i
    REAL(KIND(1d0)),INTENT(IN)::wsf0
    REAL(KIND(1d0))::wsfw
    SAVE init
    IF(.NOT.reweight_ref)THEN
       WRITE(*,*)"ERROR:Please set reweight_ref to be T first !"
       STOP
    ENDIF
    IF(init.EQ.0)THEN
       IF(ho_nref.NE.1.AND.ho_nref.NE.3.AND.ho_nref.NE.15)THEN
          WRITE(*,*)'Incorrect the number of references #1:',ho_nref
          STOP
       ENDIF
       IF(ALLOCATED(wgtxsecref))THEN
          DEALLOCATE(wgtxsecref)
       ENDIF
       ALLOCATE(wgtxsecref(ho_nref))
       IF(ALLOCATED(idref))THEN
          DEALLOCATE(idref)
       ENDIF
       ALLOCATE(idref(0:ho_nref))
       idref(0)=0
       idref(1)=iref_set_max
       IF(iref_set_max-iref_set_min+1.NE.ho_nref)THEN
          WRITE(*,*)'Incorrect the number of references #2:',ho_nref,iref_set_min,iref_set_max
          STOP
       ENDIF
       DO i=2,ho_nref
          idref(i)=idref(1)+i-1
       ENDDO
       WRITE(*,*) 'Doing reference reweight'
       init=1
    END IF
    ! reference: pp collisions
    use_neutron_rand=.TRUE.
    INCLUDE "../../../input/lhapdf/call_initnpdf"
    ! i/p j/p k/p l/p
    PureProton11=.TRUE.
    PureProton12=.TRUE.
    PureProton21=.TRUE.
    PureProton22=.TRUE.
    IF(istruc.EQ.1)THEN
       CALL strf_pdf_pp_psipsi_dps2(wsfw)
    ELSE
       WRITE(*,*)"Error: unknow the value of istruc in pp_psipsi_dps2_reweight_xsec_ref # 1"
       STOP
    ENDIF
    wgtxsecref(1)=wsfw/wsf0
    IF(ho_nref.LE.1)THEN
       use_neutron_rand=.FALSE.
       PureProton11=.FALSE.
       PureProton12=.FALSE.
       PureProton21=.FALSE.
       PureProton22=.FALSE.
       RETURN
    ENDIF
    IF(lnuclearPDF.AND.rnuclearA_beam1.NE.0d0)THEN
       ! Ap collisions
       ! i/A j/p k/p l/p
       PureProton11=.FALSE.
       PureProton12=.TRUE.
       CALL strf_pdf_pp_psipsi_dps2(wsfw)
       wgtxsecref(2)=wsfw/wsf0
       ! i/p j/A k/p l/p
       PureProton11=.TRUE.
       PureProton12=.FALSE.
       CALL strf_pdf_pp_psipsi_dps2(wsfw)
       wgtxsecref(3)=wsfw/wsf0
    ELSEIF(lnuclearPDF.AND.rnuclearA_beam2.NE.0d0)THEN
       ! pA collisions
       PureProton21=.FALSE.
       PureProton22=.TRUE.
       CALL strf_pdf_pp_psipsi_dps2(wsfw)
       wgtxsecref(2)=wsfw/wsf0
       PureProton21=.TRUE.
       PureProton22=.FALSE.
       CALL strf_pdf_pp_psipsi_dps2(wsfw)
       wgtxsecref(3)=wsfw/wsf0
    ENDIF
    IF(ho_nref.LE.3)THEN
       use_neutron_rand=.FALSE.
       PureProton11=.FALSE.
       PureProton12=.FALSE.
       PureProton21=.FALSE.
       PureProton22=.FALSE.
       RETURN
    ENDIF
    IF(istruc.EQ.2)THEN
       WRITE(*,*)"Error: istruc=2 cannot acess here ! Check ho_nref"
       WRITE(*,*)"ho_nref=",ho_nref
       STOP
    ENDIF
    IF(COLL_TYPE.GT.2)THEN
       WRITE(*,*)"Error: COLL_TYPE>2 cannot acess here ! Check ho_nref"
       WRITE(*,*)"ho_nref=",ho_nref
       STOP
    ENDIF
    ! i/A j/A k/p l/p
    PureProton11=.FALSE.
    PureProton12=.FALSE.
    PureProton21=.TRUE.
    PureProton22=.TRUE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(4)=wsfw/wsf0
    ! i/p j/p k/B l/p
    PureProton11=.TRUE.
    PureProton12=.TRUE.
    PureProton21=.FALSE.
    PureProton22=.TRUE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(5)=wsfw/wsf0
    ! i/A j/p k/B l/p
    PureProton11=.FALSE.
    PureProton12=.TRUE.
    PureProton21=.FALSE.
    PureProton22=.TRUE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(6)=wsfw/wsf0
    ! i/p j/A k/B l/p
    PureProton11=.TRUE.
    PureProton12=.FALSE.
    PureProton21=.FALSE.
    PureProton22=.TRUE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(7)=wsfw/wsf0
    ! i/A j/A k/B l/p
    PureProton11=.FALSE.
    PureProton12=.FALSE.
    PureProton21=.FALSE.
    PureProton22=.TRUE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(8)=wsfw/wsf0
    ! i/p j/p k/p l/B
    PureProton11=.TRUE.
    PureProton12=.TRUE.
    PureProton21=.TRUE.
    PureProton22=.FALSE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(9)=wsfw/wsf0
    ! i/A j/p k/p l/B
    PureProton11=.FALSE.
    PureProton12=.TRUE.
    PureProton21=.TRUE.
    PureProton22=.FALSE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(10)=wsfw/wsf0
    ! i/p j/A k/p l/B
    PureProton11=.TRUE.
    PureProton12=.FALSE.
    PureProton21=.TRUE.
    PureProton22=.FALSE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(11)=wsfw/wsf0
    ! i/A j/A k/p l/B
    PureProton11=.FALSE.
    PureProton12=.FALSE.
    PureProton21=.TRUE.
    PureProton22=.FALSE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(12)=wsfw/wsf0
    ! i/p j/p k/B l/B
    PureProton11=.TRUE.
    PureProton12=.TRUE.
    PureProton21=.FALSE.
    PureProton22=.FALSE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(13)=wsfw/wsf0
    ! i/A j/p k/B l/B
    PureProton11=.FALSE.
    PureProton12=.TRUE.
    PureProton21=.FALSE.
    PureProton22=.FALSE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(14)=wsfw/wsf0
    ! i/p j/A k/B l/B
    PureProton11=.TRUE.
    PureProton12=.FALSE.
    PureProton21=.FALSE.
    PureProton22=.FALSE.
    CALL strf_pdf_pp_psipsi_dps2(wsfw)
    wgtxsecref(15)=wsfw/wsf0

    use_neutron_rand=.FALSE.
    PureProton11=.FALSE.
    PureProton12=.FALSE.
    PureProton21=.FALSE.
    PureProton22=.FALSE.
    RETURN
  END SUBROUTINE pp_psipsi_dps2_reweight_xsec_ref

  SUBROUTINE gBeamKtGaussFactor(ktavg2,ktx,kty,gkt)
    ! eq.(11) in 1710.01684
    IMPLICIT NONE
    ! ktavg2 =  <kt**2>
    REAL(KIND(1d0)),INTENT(IN)::ktavg2,ktx,kty
    REAL(KIND(1d0)),INTENT(OUT)::gkt
    REAL(KIND(1d0)),PARAMETER::PIPIPI=3.14159265358979323846264338328d0
    REAL(KIND(1d0))::kt2
    kt2=ktx**2+kty**2
    ! it is unity when integration over dktx*dkty
    gkt=1d0/PIPIPI/ktavg2*DEXP(-kt2/ktavg2)
    RETURN
  END SUBROUTINE gBeamKtGaussFactor

END MODULE pp_psipsi_DPS2
