MODULE pp_psipsi_DPS2_setscale
  USE Helac_Global
  USE pp_psipsi_dps2_global
  IMPLICIT NONE
CONTAINS      
  SUBROUTINE pp_psipsi_DPS2_qcdscale(scale1)
    REAL(KIND=DBL),INTENT(OUT)::scale1
    REAL(KIND=DBL)::px,py,ptw2,mas
    INTEGER::ij
    SELECT CASE(nscheme)
    CASE(0)
       ! fixed scheme
       scale1=fschemevalue
    CASE(1)
       ! Sqrt(pt1**2+m1**2)
       px=dps_hadron_pmom(5,1)
       py=dps_hadron_pmom(5,2)
       ptw2=px**2+py**2
       mas=2d0*MC
       scale1=DSQRT(mas**2+ptw2)
    CASE(2)
       ! Sqrt(pt1**2+sum(mi,i=3,n)**2) in Jpsi ccbar by F.Maltoni
       mas=4d0*MC
       px=dps_hadron_pmom(5,1)
       py=dps_hadron_pmom(5,2)
       ptw2=px**2+py**2
       scale1=DSQRT(mas**2+ptw2)
    CASE(3)
       ! HT/4
       mas=0d0
       DO ij=5,nhad
          mas=mas+DSQRT(dps_hadron_pmom(ij,5)**2+dps_hadron_pmom(ij,1)**2+&
               dps_hadron_pmom(ij,2)**2)
       ENDDO
       scale1=mas/4d0
    CASE(4,-1)
       ! HT/2
       mas=0d0
       DO ij=5,nhad
          mas=mas+DSQRT(dps_hadron_pmom(ij,5)**2+dps_hadron_pmom(ij,1)**2+&
               dps_hadron_pmom(ij,2)**2)
       ENDDO
       scale1=mas/2d0
    END SELECT
    scale1=MAX(scale1,1d0)
    scale1=scale1*scalefactor

  END SUBROUTINE pp_psipsi_DPS2_qcdscale

END MODULE Pp_psipsi_DPS2_setscale
