MODULE pp_psipsipsi_DPS_ME
  USE pp_psipsipsi_dps_global
  USE Helac_Global
  IMPLICIT NONE
CONTAINS
  ! Eq.(4) in arXiv:1105.4186
  SUBROUTINE crystalball_gg_psiX(ipsi,wme)
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(OUT)::wme
    INTEGER,INTENT(IN)::ipsi
    REAL(KIND(1d0))::KK,pt
    INTEGER::init=0
    INTEGER::nn=2
    REAL(KIND(1d0))::ptavg=4.5d0
    REAL(KIND(1d0))::shat
    SAVE init
    IF(init.EQ.0)THEN
       icol_un(1,1)=1
       icol_un(8,2)=1
       icol_un(8,1)=2
       icol_un(2,2)=2
       icol_un(2,1)=3
       icol_un(1,2)=3
       icol_un(7,1)=0
       icol_un(7,2)=0
       icol_un(3,1)=4
       icol_un(10,2)=4
       icol_un(10,1)=5
       icol_un(4,2)=5
       icol_un(4,1)=6
       icol_un(3,2)=6
       icol_un(9,1)=0
       icol_un(9,2)=0
       icol_un(5,1)=7
       icol_un(12,2)=7
       icol_un(12,1)=8
       icol_un(6,2)=8
       icol_un(6,1)=9
       icol_un(5,2)=9
       icol_un(11,1)=0
       icol_un(11,2)=0
       AQEDUP=1d0/137d0
       AQCDUP=0.118d0
       init=1
    ENDIF
    IF(ipsi.EQ.0)THEN
       KK=dps_lam(1)**2*dps_kapa(1)/mpsi(1)**2
       nn=dps_n(1)
       ptavg=dps_ptavg(1)
       pt=DSQRT(cb_pmom(3,1)**2+cb_pmom(3,2)**2)
       shat=(cb_pmom(1,1)+cb_pmom(2,1))**2&
            +(cb_pmom(1,2)+cb_pmom(2,2))**2&
            +(cb_pmom(1,3)+cb_pmom(2,3))**2
       shat=(cb_pmom(1,4)+cb_pmom(2,4))**2-shat
       IF(pt.LE.ptavg)THEN
          wme=KK*shat*DEXP(-dps_kapa(1)*pt**2/mpsi(1)**2)
       ELSE
          wme=KK*shat*DEXP(-dps_kapa(1)*ptavg**2/mpsi(1)**2)&
               *1d0/(1d0+dps_kapa(1)/nn*(pt**2-ptavg**2)/mpsi(1)**2)**nn
       ENDIF
    ELSE
       KK=dps_lam(ipsi-1)**2*dps_kapa(ipsi-1)/mpsi(ipsi-1)**2
       nn=dps_n(ipsi-1)
       ptavg=dps_ptavg(ipsi-1)
       pt=DSQRT(dps_pmom(ipsi,3,1)**2+dps_pmom(ipsi,3,2)**2)
       shat=(dps_pmom(ipsi,1,1)+dps_pmom(ipsi,2,1))**2&
            +(dps_pmom(ipsi,1,2)+dps_pmom(ipsi,2,2))**2&
            +(dps_pmom(ipsi,1,3)+dps_pmom(ipsi,2,3))**2
       shat=(dps_pmom(ipsi,1,4)+dps_pmom(ipsi,2,4))**2-shat
       IF(pt.LE.ptavg)THEN
          wme=KK*shat*DEXP(-dps_kapa(ipsi-1)*pt**2/mpsi(ipsi-1)**2)
       ELSE
          wme=KK*shat*DEXP(-dps_kapa(ipsi-1)*ptavg**2/mpsi(ipsi-1)**2)&
               *1d0/(1d0+dps_kapa(ipsi-1)/nn*(pt**2-ptavg**2)/mpsi(ipsi-1)**2)**nn
       ENDIF
    ENDIF
    RETURN
  END SUBROUTINE crystalball_gg_psiX
  
END MODULE pp_psipsipsi_DPS_ME
