!*******************************************************
!  ---------------------------------------------------------------------
!     The stdhep event common
!  ---------------------------------------------------------------------
! This is the "official" event common of the HEP community for MC events.
! It is the same with EvtGen
!  NEVHEP_DPS      = event number
!  NHEP_DPS        = number of particles ("lines")
!  ISTHEP_DPS(N)   = stability code; 0 if stable, 1 if decays.
!  IDHEP_DPS(I)    = particle ID code; see PDG '92, III.73
!  JMOHEP_DPS(1,I) = line number of mother particle
!  JMOHEP_DPS(2,I) = line number of last mother particle, if formed by string
!  JDAHEP_DPS(1,I) = line number of 1st daughter particle
!  JDAHEP_DPS(2,I) = line number of last daughter particle - MUST BE CONSECUTIVE!
!  ISHEP_DPS(I)    = -1 if initial state, 1 if final state
!  PHEP_DPS(5,I)   = px,py,pz,E,m of particle
!  VHEP_DPS(4,I)   = x,y,z,L of production vertex

INTEGER,PARAMETER::nmxhep_dps=4000  ! maximum number of particles
REAL(KIND(1d0)),DIMENSION(5,nmxhep_dps)::phep_dps ! four-momentum, mass [GeV]
REAL(KIND(1d0)),DIMENSION(4,nmxhep_dps)::vhep_dps ! vertex [mm]
INTEGER::nevhep_dps ! serial number
INTEGER::nhep_dps ! number of particles
INTEGER,DIMENSION(nmxhep_dps)::isthep_dps ! status code
INTEGER,DIMENSION(nmxhep_dps)::idhep_dps ! particle ident KF
INTEGER,DIMENSION(2,nmxhep_dps)::jmohep_dps ! parent particles
INTEGER,DIMENSION(2,nmxhep_dps)::jdahep_dps ! children particles
INTEGER,DIMENSION(nmxhep_dps)::ISHEP_DPS  ! initial or final states
INTEGER,DIMENSION(nmxhep_dps)::IPOLHEP_DPS ! polarization, if 99 means polarized summed
INTEGER,DIMENSION(2,nmxhep_dps)::ICOLHEP_DPS ! color
COMMON/hepevt_pp_psipsipsi_dps/nevhep_dps,nhep_dps,isthep_dps,idhep_dps,jmohep_dps,jdahep_dps,&
	ishep_dps,phep_dps,vhep_dps,IPOLHEP_DPS,ICOLHEP_DPS

!$$$      INTEGER NMXHEP,NEVHEP,NHEP,ISTHEP,IDHEP,JMOHEP,JDAHEP
!$$$      REAL    PHEP,VHEP
!$$$      PARAMETER (NMXHEP=2000)
!$$$      COMMON/STDHEP/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
!$$$     *JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
!$$$      SAVE /STDHEP/
