MODULE plot_user
!============================================================
!
! PLOT FILE FOR USER
!
!============================================================
  USE Helac_Global
  USE Kinetic_Func ! provides kinematic functions
  IMPLICIT NONE
  INTEGER::nwgt_analysis
  INTEGER::num_plots=23
  INTEGER,PARAMETER::n_width=1,n_height=1
CONTAINS
  SUBROUTINE plot_begin(nwgt,max_weight,weights_info)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::nwgt,max_weight
    !INTEGER,PARAMETER::num_plots=1
    CHARACTER(len=*),DIMENSION(max_weight),INTENT(IN)::weights_info
    INTEGER::i,kk,l
!    character*5 cc(2)
!      data cc/'     ',' Born'/
    INCLUDE '../hbook/dbookf90.inc'
    INCLUDE '../hbook/histogram_common90.inc'
    top_yes=topdrawer_output
    gnu_yes=gnuplot_output
    root_yes=root_output
    hwu_yes=hwufile_output
    CALL HISTOGRAM_INIT(nwgt,weights_info)
    nwgt_analysis=nwgt
    IF(emep_ISR_shower.EQ.1)num_plots=num_plots+2
    IF(nwgt_analysis*16.GT.nplots/4)THEN
       WRITE(*,*) 'error in plot_begin: '//&
            'too many histograms, increase NPLOTS to',&
            nwgt_analysis*num_plots*4 ! 4 is internal in dbook,each plot has 4 histogram to estimate error
       STOP
    ENDIF
    ! bookup is defined in analysis/hbook/dbook.f
    ! NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE
    !
    ! enlarge num_plots at the begining
    !
    ! NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE
    l=0
    CALL histogram_book(l+ 1,'total rate    ',&
         5,0.5d0,5.5d0,.FALSE.)
    CALL histogram_book(l+ 2,'y(l+)  ',&
         100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+ 3,'y(l-)  ',&
         100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+ 4,'y(l+l-)',&
         100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+ 5,'pT(l+) ',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 6,'PT(l-) ',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 7,'M(l+l-)',&
         100,0d0,100d0,.TRUE.)
    CALL histogram_book(l+ 8,'M(l+l-) zoom ',&
         100,0d0,10d0,.TRUE.)
    CALL histogram_book(l+ 9,'y(l+) with 4<M<5',&
         100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+10,'y(l+) with 5<M<6',&
         100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+11,'y(l+) with 6<M<7',&
         100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+12,'y(l+) with 7<M<8',&
         100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+13,'y(l+) with M>10.5',&
         100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+14,'y(l-) with 4<M<5',&
          100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+15,'y(l-) with 5<M<6',&
          100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+16,'y(l-) with 6<M<7',&
          100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+17,'y(l-) with 7<M<8',&
          100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+18,'y(l-) with M>10.5',&
          100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+19,'y(l+l-) with 4<M<5',&
          100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+20,'y(l+l-) with 5<M<6',&
          100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+21,'y(l+l-) with 6<M<7',&
          100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+22,'y(l+l-) with 7<M<8',&
          100,-5d0,5d0,.TRUE.)
    CALL histogram_book(l+23,'y(l+l-) with M>10.5',&
          100,-5d0,5d0,.TRUE.)
    
    CALL HISTOGRAM_BOOK_FINISH
    RETURN
  END SUBROUTINE plot_begin

  SUBROUTINE plot_end(xnorm)
    USE Helac_Global
    IMPLICIT NONE
    CHARACTER(len=14)::ytit
    REAL(KIND(1d0)),INTENT(IN)::xnorm
    INTEGER::i
    INTEGER::kk,l
    INCLUDE '../hbook/dbookf90.inc'
    CHARACTER(len=400)::psfile,rootfile
    IF(topdrawer_output.OR.gnuplot_output.OR.root_output)THEN
       CALL mclear
       CALL mclear_3d
       DO i=1,NPLOTS
          CALL mopera(i,'+',i,i,xnorm,0.d0)
          CALL mfinal(i)
          CALL mopera_3d(i,'+',i,i,xnorm,0.d0)
          CALL mfinal_3d(i)
       ENDDO
    ENDIF
    ytit='sigma per bin '
    IF(topdrawer_output)THEN
       CALL open_topdrawer_file
       CALL HISTOGRAM_END(1,ytit,' ',' ')
       CALL close_topdrawer_file
    ENDIF
    IF(gnuplot_output)THEN
       CALL open_gnuplot_file
       psfile=TRIM(process(2:10*nhad+1))//".ps"
       CALL HISTOGRAM_END(2,ytit,psfile,' ')
       CALL close_gnuplot_file
    ENDIF
    IF(root_output)THEN
       CALL open_root_file
       rootfile=TRIM(process(2:10*nhad+1))//".root"
       CALL HISTOGRAM_END(3,ytit,' ',rootfile)
       ! wirte the end of the .C file for root
       WRITE (96, 100)
100    FORMAT(/1X,&
            ' hohisto -> cd();',/1X,&
            ' if (histos -> GetEntries() > 0 ) then {',/1X,&
            '  histos->Write();',/1X,&
            '  hohisto -> Close();',/1X,&
            ' }',/1X,'}')
       CALL close_root_file
    ENDIF
    IF(hwufile_output)THEN
       CALL HISTOGRAM_END(4,ytit,' ',' ')
       CALL HwU_write_file(xnorm)
    ENDIF
    RETURN                
  END SUBROUTINE plot_end

  SUBROUTINE plot_fill(wgts)
    USE Helac_Global
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(20,4)::p
    REAL(KIND(1d0)),DIMENSION(20,4)::phad
    REAL(KIND(1d0)),DIMENSION(4)::pboo,pini
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    REAL(KIND(1d0))::wgt,var,q,e
    REAL(KIND(1d0))::exp1,exp2
    INTEGER::i,kk,l
    REAL(KIND(1d0))::www,ylp,ylm,ylplm,pTlp,pTlm,Mlplm
    IF(wgts(1).EQ.0d0)RETURN
    ! WARNING*WARNING*WARNING*WARNING*WARNING*WARNING*WARNING
    !
    ! phegas_pmom is the partonic momenta,i.e. if there is a final QQ~
    ! bound state, the hadronic momenta is pQ+pQ~
    !
    ! WARNING*WARNING*WARNING*WARNING*WARNING*WARNING*WARNING
    DO i=1,n
       p(i,1:4)=phegas_pmom(i,1:4)
    ENDDO
    kk=1
    DO i=1,nhad
       IF(ABS(iflh(i)).GT.100)THEN
          phad(i,1:4)=p(kk,1:4)+p(kk+1,1:4)
          kk=kk+2
       ELSE
          phad(i,1:4)=p(kk,1:4)
          kk=kk+1
       ENDIF
    ENDDO
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! DEFINE OBSERVABLES
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    var=1.0d0 ! total cross section
    ylp=rapidity(phad(3,1:4))
    ylm=rapidity(phad(4,1:4))
    pTlp=DSQRT(phad(3,1)**2+phad(3,2)**2)
    pTlm=DSQRT(phad(4,1)**2+phad(4,2)**2)
    pini(1:4)=phad(3,1:4)+phad(4,1:4) ! (px,py,pz,E)
    ylplm=rapidity(pini)
    !IF(ylplm.LT.-2.8d0.OR.ylplm.GT.0.2d0)RETURN
    Mlplm=DSQRT(DABS(pini(4)**2-pini(1)**2-pini(2)**2-pini(3)**2))
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! START TO FILL HISTOGRAM
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    l=0    
    CALL HISTOGRAM_fill(l+1,var,wgts)
    CALL HISTOGRAM_fill(l+2,ylp,wgts)
    CALL HISTOGRAM_fill(l+3,ylm,wgts)
    CALL HISTOGRAM_fill(l+4,ylplm,wgts)
    CALL HISTOGRAM_fill(l+5,pTlp,wgts)
    CALL HISTOGRAM_fill(l+6,pTlm,wgts)
    CALL HISTOGRAM_fill(l+7,Mlplm,wgts)
    CALL HISTOGRAM_fill(l+8,Mlplm,wgts)
    IF(Mlplm.GT.4d0.AND.Mlplm.LT.5d0)THEN
       CALL HISTOGRAM_fill(l+9,ylp,wgts)
       CALL HISTOGRAM_fill(l+14,ylm,wgts)
       CALL HISTOGRAM_fill(l+19,ylplm,wgts)
    ENDIF
    IF(Mlplm.GT.5d0.AND.Mlplm.LT.6d0)THEN
       CALL HISTOGRAM_fill(l+10,ylp,wgts)
       CALL HISTOGRAM_fill(l+15,ylm,wgts)
       CALL HISTOGRAM_fill(l+20,ylplm,wgts)
    ENDIF
    IF(Mlplm.GT.6d0.AND.Mlplm.LT.7d0)THEN
       CALL HISTOGRAM_fill(l+11,ylp,wgts)
       CALL HISTOGRAM_fill(l+16,ylm,wgts)
       CALL HISTOGRAM_fill(l+21,ylplm,wgts)
    ENDIF
    IF(Mlplm.GT.7d0.AND.Mlplm.LT.8d0)THEN
       CALL HISTOGRAM_fill(l+12,ylp,wgts)
       CALL HISTOGRAM_fill(l+17,ylm,wgts)
       CALL HISTOGRAM_fill(l+22,ylplm,wgts)
    ENDIF
    IF(Mlplm.GT.10.5D0)THEN
       CALL HISTOGRAM_fill(l+13,ylp,wgts)
       CALL HISTOGRAM_fill(l+18,ylm,wgts)
       CALL HISTOGRAM_fill(l+23,ylplm,wgts)
    ENDIF
    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    RETURN      
  END SUBROUTINE plot_fill

  SUBROUTINE HwU_write_file(xnorm)
    USE Helac_Global
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::xnorm
    OPEN(unit=599,file=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.HwU',&
         status='unknown')
    !xnorm=1d0
    CALL HwU_output(599,xnorm)
    CLOSE(599)
    RETURN
  END SUBROUTINE HwU_write_file

  SUBROUTINE open_topdrawer_file
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    !common/cuseitmax/useitmax                                                  
    OPEN(unit=99,FILE=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.top',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_topdrawer_file

  SUBROUTINE close_topdrawer_file
    IMPLICIT NONE
    CLOSE(99)
    RETURN
  END SUBROUTINE close_topdrawer_file

  SUBROUTINE open_gnuplot_file
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=97,FILE=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.gnu',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_gnuplot_file

  SUBROUTINE close_gnuplot_file
    IMPLICIT NONE
    CLOSE(97)
    RETURN
  END SUBROUTINE close_gnuplot_file

  SUBROUTINE open_root_file
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=96,FILE=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.C',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_root_file

  SUBROUTINE close_root_file
    IMPLICIT NONE
    CLOSE(96)
    RETURN
  END SUBROUTINE close_root_file

  SUBROUTINE plot_fill_Decay(wgts)
    USE Decay_interface
    USE QEDPS_interface
    USE Helac_Func_1
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    INCLUDE "../../decay/stdhep.inc"
    REAL(KIND(1d0))::var,costhl,Q
    INTEGER::i,m
    REAL(KIND(1d0)),DIMENSION(1:4)::Pl,PV,PBOO
    RETURN
  END SUBROUTINE plot_fill_Decay

  SUBROUTINE plot_fill_QEDPS(wgts)
    USE QEDPS_interface
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    ! QEDPS parameters                                                      
    REAL(KIND(1d0)),DIMENSION(10,1000)::PLPTN
    INTEGER,DIMENSION(10,1000)::NLPTN
    INTEGER::NPTCL
    COMMON/QPLIST/PLPTN,NLPTN,NPTCL
    REAL(KIND(1d0)),DIMENSION(4)::pini
    REAL(KIND(1d0))::wgt,var,frache
    REAL(KIND(1d0))::exp1,exp2
    INTEGER::i,kk,l,nphoton
    REAL(KIND(1d0))::www,yftot
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! 
    ! DEFINE OBSERVABLES
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    var=1.0d0 ! total cross section
    pini(1:4)=PLPTN(4:7,1)+PLPTN(4:7,2)
    yftot=rapidity(pini)
    nphoton=0
    DO i=1,NPTCL
       IF(NLPTN(1,i).EQ.22)THEN
          nphoton=nphoton+1
       ENDIF
    ENDDO
    frache=MIN(Q2OUT_QEDPS/Q2MAX_QEDPS,1d0)
    frache=DSQRT(frache)
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! START TO FILL HISTOGRAM
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    l=0
    CALL HISTOGRAM_fill(l+1,var,wgts)
    CALL HISTOGRAM_fill(l+2,yftot,wgts)
    CALL HISTOGRAM_fill(l+3,DBLE(nphoton),wgts)
    CALL HISTOGRAM_fill(l+4,frache,wgts)
    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    RETURN
  END SUBROUTINE plot_fill_QEDPS
END MODULE plot_user
