MODULE plot_user
!============================================================
!
! PLOT FILE FOR USER
! p p > psi + n jet in 0.0<y<4.5
!
!============================================================
  USE Helac_Global
  USE Kinetic_Func ! provides kinematic functions
  IMPLICIT NONE
  INTEGER::nwgt_analysis
  INTEGER::num_plots=98
  INTEGER,PARAMETER::n_width=1,n_height=1
CONTAINS
  SUBROUTINE plot_begin(nwgt,max_weight,weights_info)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::nwgt,max_weight
    !INTEGER,PARAMETER::num_plots=1
    CHARACTER(len=*),DIMENSION(max_weight),INTENT(IN)::weights_info
    INTEGER::i,jj,kk,l
    CHARACTER(len=2),DIMENSION(4)::frames=(/'HX','CS','GJ','PX'/)
    CHARACTER(len=4),DIMENSION(4)::minjpt=(/'zj01','zj02','zj03','zj04'/)
    CHARACTER(len=5),DIMENSION(3)::maxjeta=(/'etaj5','etaj4','etaj3'/)
    CHARACTER(len=22)::ptcut
    CHARACTER(len=9)::ratiocut
    REAL(KIND(1d0))::ptmin,ptmax
!    character*5 cc(2)
!      data cc/'     ',' Born'/
    INCLUDE '../hbook/dbookf90.inc'
    INCLUDE '../hbook/histogram_common90.inc'
    top_yes=topdrawer_output
    gnu_yes=gnuplot_output
    root_yes=root_output
    hwu_yes=hwufile_output
    CALL HISTOGRAM_INIT(nwgt,weights_info)
    nwgt_analysis=nwgt
    IF(emep_ISR_shower.EQ.1)THEN
       WRITE(*,*)"Please change a plot_user.f90 !!"
       STOP
    ENDIF
    IF(nwgt_analysis*16.GT.nplots/4)THEN
       WRITE(*,*) 'error in plot_begin: '//&
            'too many histograms, increase NPLOTS to',&
            nwgt_analysis*num_plots*4 ! 4 is internal in dbook,each plot has 4 histogram to estimate error
       STOP
    ENDIF
    l=0
    ! bookup is defined in analysis/hbook/dbook.f
    ! NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE
    !
    ! enlarge num_plots at the begining
    !
    ! NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE
    CALL HISTOGRAM_book(l+ 1,'total rate    ',&
         5,0.5d0,5.5d0,.FALSE.)
    CALL HISTOGRAM_book(l+ 2,'pt of psi in 0.0<y<0.75 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+ 3,'pt of psi in 0.0<y<0.25 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+ 4,'pt of psi in 0.25<y<0.50 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+ 5,'pt of psi in 0.50<y<0.75 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+ 6,'pt of psi in 0.75<y<1.0 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+ 7,'pt of psi in 1.0<y<1.25 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+ 8,'pt of psi in 1.25<y<1.5 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+ 9,'pt of psi in 1.5<y<1.75 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+10,'pt of psi in 1.75<y<2.0 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+11,'pt of psi in 2.0<y<2.25 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+12,'pt of psi in 2.25<y<2.5 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+13,'pt of psi in 2.5<y<2.75 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+14,'pt of psi in 0.0<y<2.4  ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+15,'pt of psi in 2.0<y<4.5  ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+16,'pt of psi in 2.0<y<2.5  ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+17,'pt of psi in 2.5<y<3.0  ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+18,'pt of psi in 3.0<y<3.5  ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+19,'pt of psi in 3.5<y<4.0  ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+20,'pt of psi in 4.0<y<4.5  ',&
         100,5d0,105d0,.TRUE.)
    DO i=1,4
       DO jj=1,3
          CALL HISTOGRAM_book(l+20+(i-1)*3+jj,'pt of psi in 0.0<y<0.75 '&
               //minjpt(i)//' '//maxjeta(jj),&
               100,5d0,105d0,.TRUE.)
       ENDDO
    ENDDO
    CALL HISTOGRAM_book(l+33,'costh of lepton in 10.0<pt<105.0, |y|<2.4 ',&
         100,-1d0,1d0,.TRUE.)
    DO i=1,4
       DO kk=1,16
          IF(kk.LE.10)THEN
             ptmin=(kk-1)*1d0+10d0
             ptmax=kk*1d0+10d0
          ELSE
             ptmin=(kk-11)*5d0+20d0
             ptmax=(kk-10)*5d0+20d0
          ENDIF
          WRITE(ptcut,10203)ptmin,ptmax
          CALL HISTOGRAM_book(l+33+kk+(i-1)*16,'costh of lepton in |y|<2.4 '//&
               ptcut//' '//frames(i),100,-1d0,1d0,.TRUE.)
       ENDDO
    ENDDO
    ! the following is the implementation of the cuts by LHCb
    ! arXiv:1701.05116: jpsi in jet
    CALL HISTOGRAM_book(l+98,'z(J/psi) in LHCb (1701.05116)',100,0d0,1d0,.TRUE.)

    CALL HISTOGRAM_BOOK_FINISH

10203 FORMAT(E9.3,"<pt<",E9.3)
10204 FORMAT(E9.3)
    RETURN
  END SUBROUTINE plot_begin

  SUBROUTINE plot_end(xnorm)
    USE Helac_Global
    IMPLICIT NONE
    CHARACTER(len=14)::ytit
    REAL(KIND(1d0)),INTENT(IN)::xnorm
    INTEGER::i
    INTEGER::kk,l
    INCLUDE '../hbook/dbookf90.inc'
    CHARACTER(len=400)::psfile,rootfile
    !IF(topdrawer_output)CALL open_topdrawer_file
    !IF(gnuplot_output)CALL open_gnuplot_file
    !IF(root_output)CALL open_root_file
    IF(topdrawer_output.OR.gnuplot_output.OR.root_output)THEN
       CALL mclear
       DO i=1,NPLOTS
          CALL mopera(i,'+',i,i,xnorm,0.d0)
          CALL mfinal(i)
       ENDDO
    ENDIF
    ytit='sigma per bin '
    IF(topdrawer_output)THEN
       CALL open_topdrawer_file
       CALL HISTOGRAM_END(1,ytit,' ',' ')
       CALL close_topdrawer_file
    ENDIF
    IF(gnuplot_output)THEN
       CALL open_gnuplot_file
       psfile=TRIM(process(2:10*nhad+1))//".ps"
       CALL HISTOGRAM_END(2,ytit,psfile,' ')
       CALL close_gnuplot_file
    ENDIF
    IF(root_output)THEN
       CALL open_root_file
       rootfile=TRIM(process(2:10*nhad+1))//".root"
       CALL HISTOGRAM_END(3,ytit,' ',rootfile)
       ! wirte the end of the .C file for root
       WRITE (96, 100)
100    FORMAT(/1X,&
            ' hohisto -> cd();',/1X,&
            ' if (histos -> GetEntries() > 0 ) then {',/1X,&
            '  histos->Write();',/1X,&
            '  hohisto -> Close();',/1X,&
            ' }',/1X,'}')
       CALL close_root_file
    ENDIF
    IF(hwufile_output)THEN
       CALL HISTOGRAM_END(4,ytit,' ',' ')
       CALL HwU_write_file(xnorm)
    ENDIF
    RETURN                
  END SUBROUTINE plot_end

  SUBROUTINE plot_fill(wgts)
    USE Helac_Global
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(20,4)::p
    REAL(KIND(1d0)),DIMENSION(20,4)::phad
    REAL(KIND(1d0)),DIMENSION(4)::pboo,pini
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    REAL(KIND(1d0))::wgt,var,q,e
    REAL(KIND(1d0))::exp1,exp2
    REAL(KIND(1d0)),DIMENSION(4)::pqq
    REAL(KIND(1d0)),DIMENSION(4)::AMOM,BMOM,ATMOM,BTMOM
    REAL(KIND(1d0))::AP,BP,alphaz,betaz
    REAL(KIND(1d0)),DIMENSION(4)::ZMOM,ZMOM2,pproton1,pproton2
    REAL(KIND(1d0))::ppp1,ppp2
    INTEGER::i,kk,l,j
    REAL(KIND(1d0))::www,yy,pt,etaeta,pt_psijet
    INTEGER::n_track,n_jet,n_track2,n_jet2
    REAL(KIND(1d0)),DIMENSION(4,20)::p_track,p_track2
    REAL(KIND(1d0)),DIMENSION(4,20)::p_jet
    INTEGER,DIMENSION(20)::jetvec
    LOGICAL::y00_075,y00_025,y025_050,y050_075,y075_100,y100_125
    LOGICAL::y125_150,y150_175,y175_200,y200_225,y225_250,y250_275
    LOGICAL::y00_240,y200_450,y200_250,y250_300,y300_350,y350_400
    LOGICAL::y400_450,eta200_450,pass_LHCb_psi_cut
    REAL(KIND(1d0))::sijmin,sij,mQ,costh,costh_cs,costh_gj,costh_px
    REAL(KIND(1d0))::ptmin,ptmax,stot,zpsi
    REAL(KIND(1d0)),DIMENSION(4)::costh_array
    REAL(KIND(1d0)),DIMENSION(4)::xplponium,xplmonium,xplponium2,pboost
    REAL(KIND(1d0)),DIMENSION(4)::pt_jet_min
    REAL(KIND(1d0)),DIMENSION(4),PARAMETER::zpt_jet_min=(/0.1d0,0.2d0,0.3d0,0.4d0/)
    REAL(KIND(1d0)),DIMENSION(3),PARAMETER::eta_jet_max=(/5d0,4d0,3d0/)
    LOGICAL::ptcut_costh_10_105
    LOGICAL,DIMENSION(16)::ptcut_costh
    INTEGER::NJET
    REAL(KIND(1d0)),DIMENSION(5,4)::PJET
    REAL(KIND(1d0))::ptj1,ptj2
    REAL(KIND(1d0)),DIMENSION(4)::p_psijj
    IF(wgts(1).EQ.0d0)RETURN
    IF(NDecayChains.GT.0)THEN
       CALL plot_fill_Decay(wgts)
       RETURN
    ENDIF
    ! WARNING*WARNING*WARNING*WARNING*WARNING*WARNING*WARNING
    !
    ! phegas_pmom is the partonic momenta,i.e. if there is a final QQ~
    ! bound state, the hadronic momenta is pQ+pQ~
    !
    ! WARNING*WARNING*WARNING*WARNING*WARNING*WARNING*WARNING
    DO i=1,n
       p(i,1:4)=phegas_pmom(i,1:4)
    ENDDO
    kk=1
    DO i=1,nhad
       IF(ABS(iflh(i)).GT.100)THEN
          phad(i,1:4)=p(kk,1:4)+p(kk+1,1:4)
          kk=kk+2
       ELSE
          phad(i,1:4)=p(kk,1:4)
          kk=kk+1
       ENDIF
    ENDDO
    NJET=0
    DO i=3,nhad
       IF(ABS(iflh(i)).EQ.3.OR.ABS(iflh(i)).EQ.4.OR.&
            ABS(iflh(i)).EQ.8.OR.ABS(iflh(i)).EQ.35)THEN
          NJET=NJET+1
          IF(NJET.GT.5)THEN
             WRITE(*,*)"ERROR:Found too many parton in the final states (>5)!"
             STOP
          ENDIF
          PJET(NJET,1:4)=phad(i,1:4)
       ENDIF
    ENDDO
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! DEFINE OBSERVABLES
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    var=1.0d0 ! total cross section
    pt=DSQRT(phad(3,1)**2+phad(3,2)**2)
    DO i=1,4
       pt_jet_min(i)=zpt_jet_min(i)*pt
    ENDDO
    mQ=DSQRT(phad(3,4)**2-phad(3,1)**2-phad(3,2)**2-phad(3,3)**2)
    yy=rapidity(phad(3,1:4))
    etaeta=prapidity(phad(3,1:4))
    y00_075=DABS(yy).LT.0.75d0
    y00_025=DABS(yy).LT.0.25d0
    y025_050=DABS(yy).GE.0.25d0.AND.DABS(yy).LT.0.5d0
    y050_075=DABS(yy).GE.0.5d0.AND.DABS(yy).LT.0.75d0
    y075_100=DABS(yy).GE.0.75d0.AND.DABS(yy).LT.1d0
    y100_125=DABS(yy).GE.1d0.AND.DABS(yy).LT.1.25d0
    y125_150=DABS(yy).GE.1.25d0.AND.DABS(yy).LT.1.5d0
    y150_175=DABS(yy).GE.1.5d0.AND.DABS(yy).LT.1.75d0
    y175_200=DABS(yy).GE.1.75d0.AND.DABS(yy).LT.2d0
    y200_225=DABS(yy).GE.2d0.AND.DABS(yy).LT.2.25d0
    y225_250=DABS(yy).GE.2.25d0.AND.DABS(yy).LT.2.5d0
    y250_275=DABS(yy).GE.2.5d0.AND.DABS(yy).LT.2.75d0
    y00_240=DABS(yy).LT.2.4d0
    y200_450=DABS(yy).GE.2d0.AND.DABS(yy).LT.4.5d0
    y200_250=DABS(yy).GE.2d0.AND.DABS(yy).LT.2.5d0
    y250_300=DABS(yy).GE.2.5d0.AND.DABS(yy).LT.3d0
    y300_350=DABS(yy).GE.3d0.AND.DABS(yy).LT.3.5d0
    y350_400=DABS(yy).GE.3.5d0.AND.DABS(yy).LT.4d0
    y400_450=DABS(yy).GE.4d0.AND.DABS(yy).LT.4.5d0
    eta200_450=etaeta.GE.2d0.AND.etaeta.LT.4.5d0
    n_track=0
    n_jet=0
    p_track(1:4,1:20)=0d0
    DO i=3,nhad
       IF(is_a_jet_ana(iflh(i)))THEN
          n_track=n_track+1
          p_track(1:4,n_track)=phad(i,1:4)
       ENDIF
    ENDDO
    ! always put J/psi at the last
    n_track2=n_track+1
    n_jet2=0
    p_track2(1:4,1:20)=0d0
    p_track2(1:4,1:n_track)=p_track(1:4,1:n_track)
    p_track2(1:4,n_track2)=phad(3,1:4)
    ! no spin correlation here as there are no decay
    ! in the decay_user.inp
    CALL psi_ll_kin(phad(3,1:4),mQ,xplponium,xplmonium)
    ptmin=DSQRT(xplponium(1)**2+xplponium(2)**2)
    pass_LHCb_psi_cut=ptmin.GT.0.5d0
    ptmin=DSQRT(xplmonium(1)**2+xplmonium(2)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.0.5d0
    ptmin=DSQRT(xplponium(1)**2+xplponium(2)**2+xplponium(3)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.5d0
    ptmin=DSQRT(xplmonium(1)**2+xplmonium(2)**2+xplmonium(3)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.5d0
    ptmin=prapidity(xplponium(1:4))
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.2d0.AND.ptmin.LT.4.5d0
    ptmin=prapidity(xplmonium(1:4))
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.2d0.AND.ptmin.LT.4.5d0
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.eta200_450
    ! in the helicity frame
    pboost(4)=phad(3,4)
    pboost(1:3)=-phad(3,1:3)
    CALL boost(mQ,pboost,xplponium(1:4),xplponium2(1:4))
    ! Eq.(21) in hep-ph/9709376
    AMOM(1:2)=0d0
    AMOM(3)=ebeam(1)-ebeam(2)
    AMOM(4)=ebeam(1)+ebeam(2)
    AP=AMOM(4)*phad(3,4)-AMOM(1)*phad(3,1)&
         -AMOM(2)*phad(3,2)-AMOM(3)*phad(3,3)
    BMOM(1:2)=0d0
    BMOM(3)=ebeam(1)+ebeam(2)
    BMOM(4)=ebeam(1)-ebeam(2)
    stot=AMOM(4)**2-AMOM(3)**2
    BP=BMOM(4)*phad(3,4)-BMOM(1)*phad(3,1)&
         -BMOM(2)*phad(3,2)-BMOM(3)*phad(3,3)
    ATMOM(1:4)=AMOM(1:4)-AP/mQ**2*phad(3,1:4)
    BTMOM(1:4)=BMOM(1:4)-BP/mQ**2*phad(3,1:4)
    ! helicity frame
    ! Eq.(23) in hep-ph/9709376
    alphaz=-mQ/DSQRT(DABS(AP**2-mQ**2*stot))
    betaz=0d0
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(mQ,pboost,ZMOM(1:4),ZMOM2(1:4))
    costh=cosij(ZMOM2(1:3),xplponium2(1:3))
    costh_array(1)=costh
    ! Collins-Soper frame
    ! Eq.(32) in hep-ph/9709376
    alphaz=-BP/DSQRT(DABS(stot*(AP**2-BP**2)))
    betaz=AP/DSQRT(DABS(stot*(AP**2-BP**2)))
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(mQ,pboost,ZMOM(1:4),ZMOM2(1:4))
    costh_cs=cosij(ZMOM2(1:3),xplponium2(1:3))
    costh_array(2)=costh_cs
    ! Gottfried-Jackson frame
    ! Eq.(26) in hep-ph/9709376
    alphaz=mQ/(AP+BP)
    betaz=alphaz
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(mQ,pboost,ZMOM(1:4),ZMOM2(1:4))
    costh_gj=cosij(ZMOM2(1:3),xplponium2(1:3))
    costh_array(3)=costh_gj
    ! Perpendicular helicity frame
    ! it is perpendicular to CS frame
    ! which is defined in arXiv:0810.4506 and arXiv:0812.3727
    pproton1(1:2)=0d0
    pproton1(4)=ebeam(1)
    pproton1(3)=ebeam(1)
    CALL boost(mQ,pboost,pproton1(1:4),ZMOM(1:4))
    ppp1=DSQRT(ZMOM(1)**2+ZMOM(2)**2+ZMOM(3)**2)
    pproton2(1:2)=0d0
    pproton2(4)=ebeam(2)
    pproton2(3)=-ebeam(2)
    CALL boost(mQ,pboost,pproton2(1:4),ZMOM2(1:4))
    ppp2=DSQRT(ZMOM2(1)**2+ZMOM2(2)**2+ZMOM2(3)**2)
    ZMOM2(1:3)=ZMOM(1:3)/ppp1+ZMOM2(1:3)/ppp2
    costh_px=cosij(ZMOM2(1:3),xplponium2(1:3))
    costh_array(4)=costh_px

    ptcut_costh_10_105=pt.GT.10d0.AND.pt.LT.105d0
    DO i=1,16
       IF(i.LE.10)THEN
          ptmin=(i-1)*1d0+10d0
          ptmax=i*1d0+10d0
       ELSE
          ptmin=(i-11)*5d0+20d0
          ptmax=(i-10)*5d0+20d0
       ENDIF
       ptcut_costh(i)=pt.GE.ptmin.AND.pt.LT.ptmax
    ENDDO
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! START TO FILL HISTOGRAM
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    l=0
    CALL HISTOGRAM_fill(l+1,var,wgts)
    IF(y00_075)CALL HISTOGRAM_fill(l+2,pt,wgts)
    IF(y00_025)CALL HISTOGRAM_fill(l+3,pt,wgts)
    IF(y025_050)CALL HISTOGRAM_fill(l+4,pt,wgts)
    IF(y050_075)CALL HISTOGRAM_fill(l+5,pt,wgts)
    IF(y075_100)CALL HISTOGRAM_fill(l+6,pt,wgts)
    IF(y100_125)CALL HISTOGRAM_fill(l+7,pt,wgts)
    IF(y125_150)CALL HISTOGRAM_fill(l+8,pt,wgts)
    IF(y150_175)CALL HISTOGRAM_fill(l+9,pt,wgts)
    IF(y175_200)CALL HISTOGRAM_fill(l+10,pt,wgts)
    IF(y200_225)CALL HISTOGRAM_fill(l+11,pt,wgts)
    IF(y225_250)CALL HISTOGRAM_fill(l+12,pt,wgts)
    IF(y250_275)CALL HISTOGRAM_fill(l+13,pt,wgts)
    IF(y00_240)CALL HISTOGRAM_fill(l+14,pt,wgts)
    IF(y200_450)CALL HISTOGRAM_fill(l+15,pt,wgts)
    IF(y200_250)CALL HISTOGRAM_fill(l+16,pt,wgts)
    IF(y250_300)CALL HISTOGRAM_fill(l+17,pt,wgts)
    IF(y300_350)CALL HISTOGRAM_fill(l+18,pt,wgts)
    IF(y350_400)CALL HISTOGRAM_fill(l+19,pt,wgts)
    IF(y400_450)CALL HISTOGRAM_fill(l+20,pt,wgts)
    IF(n_track.GT.0.AND.y00_075)THEN
       DO i=1,4
          DO j=1,3
             CALL fastjetppgenkt_etamax(p_track,n_track,jet_radius,&
                  pt_jet_min(i),eta_jet_max(j),&
                  DBLE(jetalg),p_jet,n_jet,jetvec)
             IF(n_jet.GE.min_n_jet.AND.(max_n_jet.LT.0.OR.n_jet.LE.max_n_jet))THEN
                CALL HISTOGRAM_fill(l+20+(i-1)*3+j,pt,wgts)
             ENDIF
          ENDDO
       ENDDO
    ENDIF
    IF(ptcut_costh_10_105.AND.y00_240)CALL HISTOGRAM_fill(l+33,costh,wgts)
    DO i=1,4
       DO j=1,16
          IF(ptcut_costh(j).AND.y00_240)CALL HISTOGRAM_fill(l+33+j+(i-1)*16,&
               costh_array(i),wgts)
       ENDDO
    ENDDO
    
    ! get LHCb cut in Jpsi in jet study: arXiv:1701.05116
    ! jet: R=0.5, anti-kt, pT(jet) > 20GeV, 2.5d0<eta(jet)<4d0
    ! J/psi: 2.0<eta(J/psi)<4.5, pT(muon) > 0.5d0, p(muon) > 5 GeV, 2.0<eta(muon)<4.5
    IF(pass_LHCb_psi_cut)THEN
       CALL fastjetppgenkt_etamax(p_track2,n_track2,0.5d0,&
            20d0,4d0,-1d0,p_jet,n_jet2,jetvec)
       IF(n_jet2.GT.0)THEN
          ! the last track is J/psi
          ! if there is one jet related to J/psi
          IF(jetvec(n_track2).NE.0)THEN
             j=jetvec(n_track2)
             etaeta=prapidity(p_jet(1:4,j))
             IF(etaeta.GT.2.5d0.AND.etaeta.LT.4d0)THEN
                ! now it passes the cuts of LHCb for J/psi-jet
                pt_psijet=DSQRT(p_jet(1,j)**2+p_jet(2,j)**2)
                IF(pt_psijet.LT.19.99d0)THEN
                   WRITE(*,*)"ERROR: It seems to pick a wrong jet"
                   STOP
                ENDIF
                zpsi=pt/pt_psijet
                IF(zpsi.GT.1.001d0)THEN
                   WRITE(*,*)"ERROR: It seems to pick a wrong psi-jet"
                   STOP
                ENDIF
                CALL HISTOGRAM_fill(l+98,zpsi,wgts)
             ENDIF
          ENDIF
       ENDIF
    ENDIF

    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    RETURN      
  END SUBROUTINE plot_fill

  SUBROUTINE HwU_write_file(xnorm)
    USE Helac_Global
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::xnorm
    OPEN(unit=599,file=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.HwU',&
         status='unknown')
    !xnorm=1d0
    CALL HwU_output(599,xnorm)
    CLOSE(599)
    RETURN
  END SUBROUTINE HwU_write_file

  SUBROUTINE open_topdrawer_file
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    !common/cuseitmax/useitmax
    OPEN(unit=99,FILE=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.top',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_topdrawer_file

  SUBROUTINE close_topdrawer_file
    IMPLICIT NONE
    CLOSE(99)
    RETURN
  END SUBROUTINE close_topdrawer_file

  SUBROUTINE open_gnuplot_file
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=97,FILE=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.gnu',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_gnuplot_file

  SUBROUTINE close_gnuplot_file
    IMPLICIT NONE
    CLOSE(97)
    RETURN
  END SUBROUTINE close_gnuplot_file

  SUBROUTINE open_root_file
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=96,FILE=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.C',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_root_file

  SUBROUTINE close_root_file
    IMPLICIT NONE
    CLOSE(96)
    RETURN
  END SUBROUTINE close_root_file

  SUBROUTINE plot_fill_Decay(wgts)
    USE Decay_interface
    USE QEDPS_interface
    USE Helac_Func_1
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    INCLUDE "../../decay/stdhep.inc"
    REAL(KIND(1d0))::var,costhl,Q,www
    INTEGER::i,m,l,kk,j,i_lep
    REAL(KIND(1d0)),DIMENSION(4)::Plp,Plm,PV,PBOO,pqq
    REAL(KIND(1d0))::yy,pt,mQ,etaeta,pt_psijet
    LOGICAL::y00_075,y00_025,y025_050,y050_075,y075_100,y100_125
    LOGICAL::y125_150,y150_175,y175_200,y200_225,y225_250,y250_275
    LOGICAL::y00_240,y200_450,y200_250,y250_300,y300_350,y350_400
    LOGICAL::y400_450,eta200_450,pass_LHCb_psi_cut
    REAL(KIND(1d0))::sijmin,sij
    INTEGER::n_track,n_jet,n_track2,n_jet2
    REAL(KIND(1d0)),DIMENSION(4,NMXHEP)::p_track,p_track2
    REAL(KIND(1d0)),DIMENSION(4,NMXHEP)::p_jet
    INTEGER,DIMENSION(NMXHEP)::jetvec
    LOGICAL::ptcut_costh_10_105
    LOGICAL,DIMENSION(16)::ptcut_costh
    REAL(KIND(1d0))::ptmin,ptmax,stot,costh_cs,costh_gj,costh_px,zpsi
    REAL(KIND(1d0)),DIMENSION(4)::costh_array
    REAL(KIND(1d0)),DIMENSION(4)::pt_jet_min
    REAL(KIND(1d0)),DIMENSION(4),PARAMETER::zpt_jet_min=(/0.1d0,0.2d0,0.3d0,0.4d0/)
    REAL(KIND(1d0)),DIMENSION(3),PARAMETER::eta_jet_max=(/5d0,4d0,3d0/)
    REAL(KIND(1d0)),DIMENSION(4)::AMOM,BMOM,ATMOM,BTMOM
    REAL(KIND(1d0))::AP,BP,alphaz,betaz
    REAL(KIND(1d0)),DIMENSION(4)::ZMOM,ZMOM2,pproton1,pproton2
    REAL(KIND(1d0))::ppp1,ppp2
    INTEGER::NJET
    REAL(KIND(1d0)),DIMENSION(5,4)::PJET
    REAL(KIND(1d0))::ptj1,ptj2
    REAL(KIND(1d0)),DIMENSION(4)::p_psijj
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! DEFINE OBSERVABLES
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    var=1.0d0 ! total cross section
    ! select the first two decayed stable lepton
    i_lep=0
    DO i=1,NHEP
       IF(ISHEP(i).EQ.-1)CYCLE
       IF(ISTHEP(i).EQ.1)CYCLE
       IF(JMOHEP(1,i).LE.0.OR.JMOHEP(1,i).GT.NHEP)CYCLE
       IF(ISTHEP(JMOHEP(1,i)).NE.1.OR.ISHEP(JMOHEP(1,i)).EQ.-1)CYCLE
       IF(.NOT.lepton_pdg(IDHEP(i)))CYCLE
       IF(IDHEP(i).GT.0)THEN
          Plm(1:4)=PHEP(1:4,i)
          i_lep=i_lep+1
       ELSE
          Plp(1:4)=PHEP(1:4,i)
          i_lep=i_lep+1
       ENDIF
       IF(i_lep.EQ.1)THEN
          m=JMOHEP(1,i)
          PV(1:4)=PHEP(1:4,m)
       ELSEIF(i_lep.EQ.2)THEN
          EXIT
       ENDIF
    ENDDO
    IF(i_lep.NE.2)THEN
       WRITE(*,*)"ERROR: do not find the two leptons"
       STOP
    ENDIF
    ! select the final massless partons
    NJET=0
    DO i=1,NHEP
       IF(ISHEP(i).EQ.-1)CYCLE
       IF(ISTHEP(i).EQ.1)CYCLE
       IF(ABS(IDHEP(i)).EQ.2.OR.ABS(IDHEP(i)).EQ.1.OR.&
            ABS(IDHEP(i)).EQ.3.OR.ABS(IDHEP(i)).EQ.21)THEN
          NJET=NJET+1
          IF(NJET.GT.5)THEN
             WRITE(*,*)"ERROR #2:Found too many parton in the final states (>5)!"
             STOP
          ENDIF
          PJET(NJET,1:4)=PHEP(1:4,i)
       ENDIF
    ENDDO
    Q=scalar_product(PV,PV)
    IF(Q.LT.0d0)THEN
       PRINT *,"Q<0 in plot_fill_Decay !"
       STOP
    ENDIF
    Q=DSQRT(Q)
    mQ=Q
    yy=rapidity(PV(1:4))
    etaeta=prapidity(PV(1:4))
    pt=DSQRT(PV(1)**2+PV(2)**2)
    DO i=1,4
       pt_jet_min(i)=zpt_jet_min(i)*pt
    ENDDO
    y00_075=DABS(yy).LT.0.75d0
    y00_025=DABS(yy).LT.0.25d0
    y025_050=DABS(yy).GE.0.25d0.AND.DABS(yy).LT.0.5d0
    y050_075=DABS(yy).GE.0.5d0.AND.DABS(yy).LT.0.75d0
    y075_100=DABS(yy).GE.0.75d0.AND.DABS(yy).LT.1d0
    y100_125=DABS(yy).GE.1d0.AND.DABS(yy).LT.1.25d0
    y125_150=DABS(yy).GE.1.25d0.AND.DABS(yy).LT.1.5d0
    y150_175=DABS(yy).GE.1.5d0.AND.DABS(yy).LT.1.75d0
    y175_200=DABS(yy).GE.1.75d0.AND.DABS(yy).LT.2d0
    y200_225=DABS(yy).GE.2d0.AND.DABS(yy).LT.2.25d0
    y225_250=DABS(yy).GE.2.25d0.AND.DABS(yy).LT.2.5d0
    y250_275=DABS(yy).GE.2.5d0.AND.DABS(yy).LT.2.75d0
    y00_240=DABS(yy).LT.2.4d0
    y200_450=DABS(yy).GE.2d0.AND.DABS(yy).LT.4.5d0
    y200_250=DABS(yy).GE.2d0.AND.DABS(yy).LT.2.5d0
    y250_300=DABS(yy).GE.2.5d0.AND.DABS(yy).LT.3d0
    y300_350=DABS(yy).GE.3d0.AND.DABS(yy).LT.3.5d0
    y350_400=DABS(yy).GE.3.5d0.AND.DABS(yy).LT.4d0
    y400_450=DABS(yy).GE.4d0.AND.DABS(yy).LT.4.5d0
    eta200_450=etaeta.GE.2d0.AND.etaeta.LT.4.5d0
    n_track=0
    n_jet=0
    p_track(1:4,1:NHEP)=0d0
    DO i=1,NHEP
       IF(ISTHEP(i).EQ.1)CYCLE
       IF(ISHEP(i).NE.1)CYCLE
       IF(lepton_pdg(IDHEP(i)))CYCLE
       IF(is_a_jet_ana_PDG(IDHEP(i)))THEN
          n_track=n_track+1
          p_track(1:4,n_track)=PHEP(1:4,i)
       ENDIF
    ENDDO
    ! always put J/psi at the end
    n_track2=n_track+1
    n_jet2=0
    p_track2(1:4,1:NHEP)=0d0
    p_track2(1:4,1:n_track)=p_track(1:4,1:n_track)
    p_track2(1:4,n_track2)=PV(1:4)
    ! take into account the cut of LHCb for J/psi in jet study
    ptmin=DSQRT(Plp(1)**2+Plp(2)**2)
    pass_LHCb_psi_cut=ptmin.GT.0.5d0
    ptmin=DSQRT(Plm(1)**2+Plm(2)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.0.5d0
    ptmin=DSQRT(Plp(1)**2+Plp(2)**2+Plp(3)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.5d0
    ptmin=DSQRT(Plm(1)**2+Plm(2)**2+Plm(3)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.5d0
    ptmin=prapidity(Plp(1:4))
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.2d0.AND.ptmin.LT.4.5d0
    ptmin=prapidity(Plm(1:4))
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.2d0.AND.ptmin.LT.4.5d0
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.eta200_450

    ! for the lepton costh distributions
    PBOO(1:3)=-PV(1:3)
    PBOO(4)=PV(4)
    CALL BOOSTL(Q,PBOO,Plp) ! boost to the rest frame of V
    ! Eq.(21) in hep-ph/9709376
    AMOM(1:2)=0d0
    AMOM(3)=ebeam(1)-ebeam(2)
    AMOM(4)=ebeam(1)+ebeam(2)
    AP=AMOM(4)*PV(4)-AMOM(1)*PV(1)&
         -AMOM(2)*PV(2)-AMOM(3)*PV(3)
    BMOM(1:2)=0d0
    BMOM(3)=ebeam(1)+ebeam(2)
    BMOM(4)=ebeam(1)-ebeam(2)
    stot=AMOM(4)**2-AMOM(3)**2
    BP=BMOM(4)*PV(4)-BMOM(1)*PV(1)&
         -BMOM(2)*PV(2)-BMOM(3)*PV(3)
    ATMOM(1:4)=AMOM(1:4)-AP/Q**2*PV(1:4)
    BTMOM(1:4)=BMOM(1:4)-BP/Q**2*PV(1:4)
    ! helicity frame
    ! Eq.(23) in hep-ph/9709376
    alphaz=-Q/DSQRT(DABS(AP**2-Q**2*stot))
    betaz=0d0
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(Q,PBOO,ZMOM(1:4),ZMOM2(1:4))
    costhl=cosij(ZMOM2(1:3),Plp(1:3))
    costh_array(1)=costhl
    ! Collins-Soper frame 
    ! Eq.(32) in hep-ph/9709376
    alphaz=-BP/DSQRT(DABS(stot*(AP**2-BP**2)))
    betaz=AP/DSQRT(DABS(stot*(AP**2-BP**2)))
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(Q,PBOO,ZMOM(1:4),ZMOM2(1:4))
    costh_cs=cosij(ZMOM2(1:3),Plp(1:3))
    costh_array(2)=costh_cs
    ! Gottfried-Jackson frame
    ! Eq.(26) in hep-ph/9709376
    alphaz=Q/(AP+BP)
    betaz=alphaz
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(Q,PBOO,ZMOM(1:4),ZMOM2(1:4))
    costh_gj=cosij(ZMOM2(1:3),Plp(1:3))
    costh_array(3)=costh_gj
    ! Perpendicular helicity frame
    ! it is perpendicular to CS frame
    ! which is defined in arXiv:0810.4506 and arXiv:0812.3727 
    pproton1(1:2)=0d0
    pproton1(4)=ebeam(1)
    pproton1(3)=ebeam(1)
    CALL boost(Q,PBOO,pproton1(1:4),ZMOM(1:4))
    ppp1=DSQRT(ZMOM(1)**2+ZMOM(2)**2+ZMOM(3)**2)
    pproton2(1:2)=0d0
    pproton2(4)=ebeam(2)
    pproton2(3)=-ebeam(2)
    CALL boost(Q,PBOO,pproton2(1:4),ZMOM2(1:4))
    ppp2=DSQRT(ZMOM2(1)**2+ZMOM2(2)**2+ZMOM2(3)**2)
    ZMOM2(1:3)=ZMOM(1:3)/ppp1+ZMOM2(1:3)/ppp2
    costh_px=cosij(ZMOM2(1:3),Plp(1:3))
    costh_array(4)=costh_px

    ptcut_costh_10_105=pt.GT.10d0.AND.pt.LT.105d0
    DO i=1,16
       IF(i.LE.10)THEN
          ptmin=(i-1)*1d0+10d0
          ptmax=i*1d0+10d0
       ELSE
          ptmin=(i-11)*5d0+20d0
          ptmax=(i-10)*5d0+20d0
       ENDIF
       ptcut_costh(i)=pt.GE.ptmin.AND.pt.LT.ptmax
    ENDDO
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! START TO FILL HISTOGRAM
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    l=0
    CALL HISTOGRAM_fill(l+1,var,wgts)
    IF(y00_075)CALL HISTOGRAM_fill(l+2,pt,wgts)
    IF(y00_025)CALL HISTOGRAM_fill(l+3,pt,wgts)
    IF(y025_050)CALL HISTOGRAM_fill(l+4,pt,wgts)
    IF(y050_075)CALL HISTOGRAM_fill(l+5,pt,wgts)
    IF(y075_100)CALL HISTOGRAM_fill(l+6,pt,wgts)
    IF(y100_125)CALL HISTOGRAM_fill(l+7,pt,wgts)
    IF(y125_150)CALL HISTOGRAM_fill(l+8,pt,wgts)
    IF(y150_175)CALL HISTOGRAM_fill(l+9,pt,wgts)
    IF(y175_200)CALL HISTOGRAM_fill(l+10,pt,wgts)
    IF(y200_225)CALL HISTOGRAM_fill(l+11,pt,wgts)
    IF(y225_250)CALL HISTOGRAM_fill(l+12,pt,wgts)
    IF(y250_275)CALL HISTOGRAM_fill(l+13,pt,wgts)
    IF(y00_240)CALL HISTOGRAM_fill(l+14,pt,wgts)
    IF(y200_450)CALL HISTOGRAM_fill(l+15,pt,wgts)
    IF(y200_250)CALL HISTOGRAM_fill(l+16,pt,wgts)
    IF(y250_300)CALL HISTOGRAM_fill(l+17,pt,wgts)
    IF(y300_350)CALL HISTOGRAM_fill(l+18,pt,wgts)
    IF(y350_400)CALL HISTOGRAM_fill(l+19,pt,wgts)
    IF(y400_450)CALL HISTOGRAM_fill(l+20,pt,wgts)
    IF(n_track.GT.0.AND.y00_075)THEN
       DO i=1,4
          DO j=1,3
             CALL fastjetppgenkt_etamax(p_track,n_track,jet_radius,&
                  pt_jet_min(i),eta_jet_max(j),&
                  DBLE(jetalg),p_jet,n_jet,jetvec)
             IF(n_jet.GE.min_n_jet.AND.(max_n_jet.LT.0.OR.n_jet.LE.max_n_jet))THEN
                CALL HISTOGRAM_fill(l+20+(i-1)*3+j,pt,wgts)
             ENDIF
          ENDDO
       ENDDO
    ENDIF
    IF(ptcut_costh_10_105.AND.y00_240)CALL HISTOGRAM_fill(l+33,costhl,wgts)
    DO i=1,4
       DO j=1,16
          IF(ptcut_costh(j).AND.y00_240)CALL HISTOGRAM_fill(l+33+j+(i-1)*16,&
               costh_array(i),wgts)
       ENDDO
    ENDDO
    
    ! get LHCb cut in Jpsi in jet study: arXiv:1701.05116
    ! jet: R=0.5, anti-kt, pT(jet) > 20GeV, 2.5d0<eta(jet)<4d0
    ! J/psi: 2.0<eta(J/psi)<4.5, pT(muon) > 0.5d0, p(muon) > 5 GeV, 2.0<eta(muon)<4.5
    IF(pass_LHCb_psi_cut)THEN
       CALL fastjetppgenkt_etamax(p_track2,n_track2,0.5d0,&
            20d0,4d0,-1d0,p_jet,n_jet2,jetvec)
       IF(n_jet2.GT.0)THEN
          ! the last track is J/psi
          ! if there is one jet related to J/psi
          IF(jetvec(n_track2).NE.0)THEN
             j=jetvec(n_track2)
             etaeta=prapidity(p_jet(1:4,j))
             IF(etaeta.GT.2.5d0.AND.etaeta.LT.4d0)THEN
                ! now it passes the cuts of LHCb for J/psi-jet
                pt_psijet=DSQRT(p_jet(1,j)**2+p_jet(2,j)**2)
                IF(pt_psijet.LT.19.99d0)THEN
                   WRITE(*,*)"ERROR: It seems to pick a wrong jet"
                   STOP
                ENDIF
                zpsi=pt/pt_psijet
                IF(zpsi.GT.1.001d0)THEN
                   WRITE(*,*)"ERROR: It seems to pick a wrong psi-jet"
                   STOP
                ENDIF
                CALL HISTOGRAM_fill(l+98,zpsi,wgts)
             ENDIF
          ENDIF
       ENDIF
    ENDIF


    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    RETURN
  END SUBROUTINE plot_fill_Decay

  SUBROUTINE plot_fill_QEDPS(wgts)
    USE QEDPS_interface
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    ! QEDPS parameters                                                      
    REAL(KIND(1d0)),DIMENSION(10,1000)::PLPTN
    INTEGER,DIMENSION(10,1000)::NLPTN
    INTEGER::NPTCL
    COMMON/QPLIST/PLPTN,NLPTN,NPTCL
    REAL(KIND(1d0)),DIMENSION(4)::pini
    REAL(KIND(1d0))::wgt,var,frache
    REAL(KIND(1d0))::exp1,exp2
    INTEGER::i,kk,l,nphoton
    REAL(KIND(1d0))::www,yftot
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! 
    ! DEFINE OBSERVABLES
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    var=1.0d0 ! total cross section
    pini(1:4)=PLPTN(4:7,1)+PLPTN(4:7,2)
    yftot=rapidity(pini)
    nphoton=0
    DO i=1,NPTCL
       IF(NLPTN(1,i).EQ.22)THEN
          nphoton=nphoton+1
       ENDIF
    ENDDO
    frache=MIN(Q2OUT_QEDPS/Q2MAX_QEDPS,1d0)
    frache=DSQRT(frache)
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! START TO FILL HISTOGRAM
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    l=0
    CALL HISTOGRAM_fill(l+1,var,wgts)
    CALL HISTOGRAM_fill(l+2,yftot,wgts)
    CALL HISTOGRAM_fill(l+3,DBLE(nphoton),wgts)
    CALL HISTOGRAM_fill(l+4,frache,wgts)

    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    RETURN
  END SUBROUTINE plot_fill_QEDPS

  SUBROUTINE psi_ll_kin(ppsi,mpsi,plp,plm)
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(4),INTENT(IN)::ppsi
    REAL(KIND(1d0)),INTENT(IN)::mpsi
    REAL(KIND(1d0)),DIMENSION(4),INTENT(OUT)::plp,plm
    REAL(KIND(1d0)),DIMENSION(4)::plpres,plmres
    REAL(KIND(1d0)),PARAMETER::pipi=3.14159265358979323846264338328d0
    REAL(KIND(1d0))::p0,phi,costh,sinth
    costh=2d0*(rand()-0.5d0)
    sinth=DSQRT(ABS(1d0-costh**2))
    phi=rand()*2d0*pipi
    p0=mpsi/2d0
    plpres(3)=p0*costh
    plpres(4)=p0
    plpres(1)=p0*sinth*DCOS(phi)
    plpres(2)=p0*sinth*DSIN(phi)
    plmres(4)=p0
    plmres(1:3)=-plpres(1:3)
    CALL boost(mpsi,ppsi,plpres,plp)
    CALL boost(mpsi,ppsi,plmres,plm)
    RETURN
  END SUBROUTINE psi_ll_kin

  FUNCTION is_a_jet_ana(ifh)
    IMPLICIT NONE
    LOGICAL::is_a_jet_ana
    INTEGER,INTENT(IN)::ifh
    INTEGER::iff,init=0
    SAVE init
    LOGICAL,DIMENSION(12)::is_fermion_a_jet
    SAVE is_fermion_a_jet
    IF(ABS(ifh).GT.12.AND.ABS(ifh).NE.35)THEN
       is_a_jet_ana=.FALSE.
       RETURN
    ENDIF
    IF(ifh.EQ.35)THEN
       is_a_jet_ana=.TRUE.
       RETURN
    ENDIF
    iff=ABS(ifh)
    IF(MOD(iff,4).NE.0.AND.MOD(iff,4).NE.3)THEN
       is_a_jet_ana=.FALSE.
       RETURN
    ENDIF
    IF(init.EQ.0)THEN
       is_fermion_a_jet(1:12)=.FALSE.
       IF(jet_n_flavour.GE.1)is_fermion_a_jet(4)=.TRUE.
       IF(jet_n_flavour.GE.2)is_fermion_a_jet(3)=.TRUE.
       IF(jet_n_flavour.GE.3)is_fermion_a_jet(8)=.TRUE.
       IF(jet_n_flavour.GE.4)is_fermion_a_jet(7)=.TRUE.
       IF(jet_n_flavour.GE.5)is_fermion_a_jet(12)=.TRUE.
       IF(jet_n_flavour.GE.6)is_fermion_a_jet(11)=.TRUE.
       init=1
    ENDIF
    is_a_jet_ana=is_fermion_a_jet(iff)
    RETURN
  END FUNCTION is_a_jet_ana

  FUNCTION is_a_jet_ana_PDG(pdg)
    IMPLICIT NONE
    LOGICAL::is_a_jet_ana_PDG
    INTEGER,INTENT(IN)::pdg
    INTEGER::iff,init=0
    SAVE init
    LOGICAL,DIMENSION(6)::is_fermion_a_jet
    SAVE is_fermion_a_jet
    IF(ABS(pdg).GT.6.AND.ABS(pdg).NE.21)THEN
       is_a_jet_ana_PDG=.FALSE.
       RETURN
    ENDIF
    IF(pdg.EQ.21)THEN
       is_a_jet_ana_PDG=.TRUE.
       RETURN
    ENDIF
    IF(init.EQ.0)THEN
       is_fermion_a_jet(1:6)=.FALSE.
       IF(jet_n_flavour.GE.1)is_fermion_a_jet(1)=.TRUE.
       IF(jet_n_flavour.GE.2)is_fermion_a_jet(2)=.TRUE.
       IF(jet_n_flavour.GE.3)is_fermion_a_jet(3)=.TRUE.
       IF(jet_n_flavour.GE.4)is_fermion_a_jet(4)=.TRUE.
       IF(jet_n_flavour.GE.5)is_fermion_a_jet(5)=.TRUE.
       IF(jet_n_flavour.GE.6)is_fermion_a_jet(6)=.TRUE.
       init=1
    ENDIF
    is_a_jet_ana_PDG=is_fermion_a_jet(ABS(pdg))
    RETURN
  END FUNCTION is_a_jet_ana_PDG
  
END MODULE plot_user
