MODULE plot_user
!============================================================
!
! PLOT FILE FOR USER
! p p > psi + n jet in 0.0<y<4.5
!
!============================================================
  USE Helac_Global
  USE Kinetic_Func ! provides kinematic functions
  IMPLICIT NONE
  INTEGER::nwgt_analysis
  INTEGER::num_plots=200
  INTEGER,PARAMETER::n_width=1,n_height=1
  ! stop cuts for analysis
  INTEGER::stop_min_n_jet_ana,stop_max_n_jet_ana,stop_jetalg_ana
  INTEGER::stop_n_frag_gluon_ana,stop_n_frag_quark_ana
  REAL(KIND(1d0))::stop_maxrapjet_ana,stop_jet_radius_ana,stop_minptjet_ana
  REAL(KIND(1d0))::stop_zcut_ana,stop_beta_ana,stop_zsoftcut_ana
  REAL(KIND(1d0))::stop_zasymcut_ana,stop_jet_dyn_radius_ana
CONTAINS
  SUBROUTINE plot_begin(nwgt,max_weight,weights_info)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::nwgt,max_weight
    !INTEGER,PARAMETER::num_plots=1
    CHARACTER(len=*),DIMENSION(max_weight),INTENT(IN)::weights_info
    INTEGER::i,jj,kk,l,ll
    CHARACTER(len=2),DIMENSION(4)::frames=(/'HX','CS','GJ','PX'/)
    CHARACTER(len=4),DIMENSION(2)::minjpt=(/'ptj3','ptj6'/)
    CHARACTER(len=7),DIMENSION(3)::minzasymcut=(/'zasym01','zasym06','zasym07'/)
    CHARACTER(len=22)::ptcut
    CHARACTER(len=9)::ratiocut
    REAL(KIND(1d0))::ptmin,ptmax
!    character*5 cc(2)
!      data cc/'     ',' Born'/
    INCLUDE '../hbook/dbookf90.inc'
    INCLUDE '../hbook/histogram_common90.inc'
    top_yes=topdrawer_output
    gnu_yes=gnuplot_output
    root_yes=root_output
    hwu_yes=hwufile_output
    CALL HISTOGRAM_INIT(nwgt,weights_info)
    nwgt_analysis=nwgt
    IF(emep_ISR_shower.EQ.1)THEN
       WRITE(*,*)"Please change a plot_user.f90 !!"
       STOP
    ENDIF
    IF(nwgt_analysis*16.GT.nplots/4)THEN
       WRITE(*,*) 'error in plot_begin: '//&
            'too many histograms, increase NPLOTS to',&
            nwgt_analysis*num_plots*4 ! 4 is internal in dbook,each plot has 4 histogram to estimate error
       STOP
    ENDIF
    l=0
    ! bookup is defined in analysis/hbook/dbook.f
    ! NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE
    !
    ! enlarge num_plots at the begining
    ! enlarge max_plots in ../hbook/HwU.inc
    !
    ! NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE**NOTE
    DO i=1,2
       ! pt cut on the jet, stop_minptjet
       DO jj=1,3
          ! zasymcut on the jet, stop_zasymcut
          l=(jj-1)*31+(i-1)*3*31
          CALL HISTOGRAM_book(l+ 1,'total rate  '//minjpt(i)//' '//minzasymcut(jj),&
               5,0.5d0,5.5d0,.FALSE.)
          CALL HISTOGRAM_book(l+ 2,'pt of psi in 0.0<y<0.75 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+ 3,'pt of psi in 0.75<y<1.5 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+ 4,'pt of psi in 1.5<y<2.0 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+ 5,'pt of psi in 2.0<y<4.5 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+ 6,'pt of psi in 2.5<y<4.0 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+ 7,'pt of psi in 0.0<y<2.4 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+ 8,'pt of psi in 0.0<y<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          ! spin density matrix elements
          ! helicity frame
          CALL HISTOGRAM_book(l+ 9,'3S1/3PJ8 (sz,00), pt of psi in |y|<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+10,'3S1/3PJ8 (sz,11), pt of psi in |y|<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+11,'3S1/3PJ8 (sz,-1-1), pt of psi in |y|<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+12,'3P11 (Jz,00), pt of psi in |y|<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+13,'3P11 (Jz,11), pt of psi in |y|<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+14,'3P11 (Jz,-1-1), pt of psi in |y|<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+15,'3P21 (Jz,00), pt of psi in |y|<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+16,'3P21 (Jz,11), pt of psi in |y|<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+17,'3P21 (Jz,-1-1), pt of psi in |y|<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+18,'3P21 (Jz,22), pt of psi in |y|<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+19,'3P21 (Jz,-2-2), pt of psi in |y|<0.6 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+20,'3S1/3PJ8 (sz,00), pt of psi in 0.6<|y|<1.2 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+21,'3S1/3PJ8 (sz,11), pt of psi in 0.6<|y|<1.2 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+22,'3S1/3PJ8 (sz,-1-1), pt of psi in 0.6<|y|<1.2 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+23,'3P11 (Jz,00), pt of psi in 0.6<|y|<1.2 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+24,'3P11 (Jz,11), pt of psi in 0.6<|y|<1.2 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+25,'3P11 (Jz,-1-1), pt of psi in 0.6<|y|<1.2 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+26,'3P21 (Jz,00), pt of psi in 0.6<|y|<1.2 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+27,'3P21 (Jz,11), pt of psi in 0.6<|y|<1.2 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+28,'3P21 (Jz,-1-1), pt of psi in 0.6<|y|<1.2 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+29,'3P21 (Jz,22), pt of psi in 0.6<|y|<1.2 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          CALL HISTOGRAM_book(l+30,'3P21 (Jz,-2-2), pt of psi in 0.6<|y|<1.2 '//minjpt(i)//' '//minzasymcut(jj),&
               100,5d0,105d0,.TRUE.)
          ! the following is the implementation of the cuts by LHCb
          ! arXiv:1701.05116: jpsi in jet                                                                         
          CALL HISTOGRAM_book(l+31,'z(J/psi) in LHCb (1701.05116) '//minjpt(i)//' '//minzasymcut(jj),&
               100,0d0,1d0,.TRUE.)
       END DO
    ENDDO
    l=0
    CALL HISTOGRAM_book(l+187,'pt of psi in 0.50<y<0.75 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+188,'pt of psi in 0.75<y<1.0 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+189,'pt of psi in 1.0<y<1.25 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+190,'pt of psi in 1.25<y<1.5 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+191,'pt of psi in 1.5<y<1.75 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+192,'pt of psi in 1.75<y<2.0 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+193,'pt of psi in 2.0<y<2.25 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+194,'pt of psi in 2.25<y<2.5 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+195,'pt of psi in 2.5<y<2.75 ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+196,'pt of psi in 2.0<y<2.5  ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+197,'pt of psi in 2.5<y<3.0  ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+198,'pt of psi in 3.0<y<3.5  ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+199,'pt of psi in 3.5<y<4.0  ',&
         100,5d0,105d0,.TRUE.)
    CALL HISTOGRAM_book(l+200,'pt of psi in 4.0<y<4.5  ',&
         100,5d0,105d0,.TRUE.)
    
    CALL HISTOGRAM_BOOK_FINISH

10203 FORMAT(E9.3,"<pt<",E9.3)
10204 FORMAT(E9.3)
    RETURN
  END SUBROUTINE plot_begin

  SUBROUTINE plot_end(xnorm)
    USE Helac_Global
    IMPLICIT NONE
    CHARACTER(len=14)::ytit
    REAL(KIND(1d0)),INTENT(IN)::xnorm
    INTEGER::i
    INTEGER::kk,l
    INCLUDE '../hbook/dbookf90.inc'
    CHARACTER(len=400)::psfile,rootfile
    !IF(topdrawer_output)CALL open_topdrawer_file
    !IF(gnuplot_output)CALL open_gnuplot_file
    !IF(root_output)CALL open_root_file
    IF(topdrawer_output.OR.gnuplot_output.OR.root_output)THEN
       CALL mclear
       DO i=1,NPLOTS
          CALL mopera(i,'+',i,i,xnorm,0.d0)
          CALL mfinal(i)
       ENDDO
    ENDIF
    ytit='sigma per bin '
    IF(topdrawer_output)THEN
       CALL open_topdrawer_file
       CALL HISTOGRAM_END(1,ytit,' ',' ')
       CALL close_topdrawer_file
    ENDIF
    IF(gnuplot_output)THEN
       CALL open_gnuplot_file
       psfile=TRIM(process(2:10*nhad+1))//".ps"
       CALL HISTOGRAM_END(2,ytit,psfile,' ')
       CALL close_gnuplot_file
    ENDIF
    IF(root_output)THEN
       CALL open_root_file
       rootfile=TRIM(process(2:10*nhad+1))//".root"
       CALL HISTOGRAM_END(3,ytit,' ',rootfile)
       ! wirte the end of the .C file for root
       WRITE (96, 100)
100    FORMAT(/1X,&
            ' hohisto -> cd();',/1X,&
            ' if (histos -> GetEntries() > 0 ) then {',/1X,&
            '  histos->Write();',/1X,&
            '  hohisto -> Close();',/1X,&
            ' }',/1X,'}')
       CALL close_root_file
    ENDIF
    IF(hwufile_output)THEN
       CALL HISTOGRAM_END(4,ytit,' ',' ')
       CALL HwU_write_file(xnorm)
    ENDIF
    RETURN                
  END SUBROUTINE plot_end

  SUBROUTINE plot_fill(wgts)
    USE Helac_Global
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(20,4)::p
    REAL(KIND(1d0)),DIMENSION(20,4)::phad
    REAL(KIND(1d0)),DIMENSION(4)::pboo,pini
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    REAL(KIND(1d0))::wgt,var,q,e
    REAL(KIND(1d0))::exp1,exp2
    REAL(KIND(1d0)),DIMENSION(4)::pqq
    REAL(KIND(1d0)),DIMENSION(4)::AMOM,BMOM,ATMOM,BTMOM
    REAL(KIND(1d0))::AP,BP,alphaz,betaz
    REAL(KIND(1d0)),DIMENSION(4)::ZMOM,ZMOM2,pproton1,pproton2
    REAL(KIND(1d0))::ppp1,ppp2
    INTEGER::i,kk,l,j,jj
    REAL(KIND(1d0))::www,yy,pt,etaeta,pt_psijet
    INTEGER::n_track,n_jet,n_track2,n_jet2
    REAL(KIND(1d0)),DIMENSION(4,20)::p_track,p_track2
    REAL(KIND(1d0)),DIMENSION(4,20)::p_jet
    INTEGER,DIMENSION(20)::jetvec
    LOGICAL::y00_075,y00_025,y025_050,y050_075,y075_100,y100_125
    LOGICAL::y125_150,y150_175,y175_200,y200_225,y225_250,y250_275
    LOGICAL::y00_240,y200_450,y200_250,y250_300,y300_350,y350_400
    LOGICAL::y400_450,eta200_450,pass_LHCb_psi_cut
    LOGICAL::y075_150,y150_200,y250_400,y00_060,y060_120
    REAL(KIND(1d0))::sijmin,sij,mQ,costh,costh_cs,costh_gj,costh_px
    REAL(KIND(1d0))::ptmin,ptmax,stot,zpsi
    REAL(KIND(1d0)),DIMENSION(4)::costh_array
    REAL(KIND(1d0)),DIMENSION(4)::xplponium,xplmonium,xplponium2,pboost
    REAL(KIND(1d0)),DIMENSION(4),PARAMETER::pt_jet_min=(/3d0,4d0,5d0,6d0/)
    REAL(KIND(1d0)),DIMENSION(3),PARAMETER::eta_jet_max=(/5d0,4d0,3d0/)
    LOGICAL::ptcut_costh_10_105
    LOGICAL,DIMENSION(16)::ptcut_costh
    INTEGER::NJET
    REAL(KIND(1d0)),DIMENSION(20,4)::PJET
    REAL(KIND(1d0))::ptj1,ptj2
    REAL(KIND(1d0)),DIMENSION(4)::p_psijj
    INTEGER,DIMENSION(3)::index2
    INTEGER::fockstate,imoth,isign,JzJz
    INTEGER,DIMENSION(2)::histo_index
    REAL(KIND(1d0))::rrr
    LOGICAL,DIMENSION(2,3)::pass_stop_cuts
    INTEGER,DIMENSION(20)::pid_track
    REAL(KIND(1d0)),DIMENSION(2)::new_stop_minptjet
    REAL(KIND(1d0)),DIMENSION(3)::new_stop_zasymcut
    IF(wgts(1).EQ.0d0)RETURN
    IF(NDecayChains.GT.0)THEN
       CALL plot_fill_Decay(wgts)
       RETURN
    ENDIF
    ! WARNING*WARNING*WARNING*WARNING*WARNING*WARNING*WARNING
    !
    ! phegas_pmom is the partonic momenta,i.e. if there is a final QQ~
    ! bound state, the hadronic momenta is pQ+pQ~
    ! 
    ! WARNING*WARNING*WARNING*WARNING*WARNING*WARNING*WARNING
    DO i=1,n
       p(i,1:4)=phegas_pmom(i,1:4)
    ENDDO
    new_stop_minptjet(1)=3d0
    new_stop_zasymcut(1)=0.1d0
    new_stop_minptjet(2)=6d0
    new_stop_zasymcut(2)=0.6d0
    new_stop_zasymcut(3)=0.7d0
    kk=1
    DO i=1,nhad
       IF(ABS(iflh(i)).GT.100)THEN
          phad(i,1:4)=p(kk,1:4)+p(kk+1,1:4)
          ! get the last fock state
          IF(calc_LDME_RG_CT)THEN
             fockstate=iflh_CT(i)
          ELSE
             fockstate=iflh(i)
          ENDIF
          imoth=i
          kk=kk+2
       ELSE
          phad(i,1:4)=p(kk,1:4)
          kk=kk+1
       ENDIF
    ENDDO
    !NJET=0
    !DO i=3,nhad
    !   IF(ABS(iflh(i)).EQ.3.OR.ABS(iflh(i)).EQ.4.OR.&
    !        ABS(iflh(i)).EQ.8.OR.ABS(iflh(i)).EQ.35)THEN
    !      NJET=NJET+1
    !      PJET(NJET,1:4)=phad(i,1:4)
    !   ENDIF
    !ENDDO
    ! get spin density matrix for each Fock state
    histo_index(1:2)=0
    IF(fockstate.EQ.443011.OR.fockstate.EQ.443018.OR. &
         fockstate.EQ.553011.OR.fockstate.EQ.553018.OR.&
         fockstate.EQ.443108.OR.fockstate.EQ.553108.OR.&
         fockstate.EQ.443118.OR.fockstate.EQ.553118.OR.&
         fockstate.EQ.443128.OR.fockstate.EQ.553128)THEN
       ! 3S1/3PJ8
       IF(MCoHelicity)THEN
          CALL Qeveryhel_ana(index2,ipol(imoth),imoth)
       ELSE
          index2(1:2)=0
          rrr=rand()
          IF(rrr.LT.1d0/3d0)THEN
             index2(3)=1
          ELSEIF(rrr.LT.2d0/3d0)THEN
             index2(3)=2
          ELSE
             index2(3)=3
          ENDIF
       ENDIF
       IF(index2(3).EQ.1)THEN
          ! (sz,11)
          histo_index(1)=10
       ELSEIF(index2(3).EQ.2)THEN
          ! (sz,-1-1)
          histo_index(1)=11
       ELSEIF(index2(3).EQ.3)THEN
          ! (sz,00)
          histo_index(1)=9
       ENDIF
       histo_index(2)=histo_index(1)+11
    ELSEIF(fockstate.EQ.443111.OR.fockstate.EQ.553111)THEN
       ! 3P11
       IF(MCoHelicity)THEN
          CALL Qeveryhel_ana(index2,ipol(imoth),imoth)
       ENDIF
       IF(MCoHelicity)THEN
          IF(calc_LDME_RG_CT)THEN
             ! use Eq.(29) in arXiv:1209.4610
             isign=MOD(2*index2(3)-3,3)
             isign=-isign
             CALL GetJz_ana(isign,1,JzJz)
             isign=JzJz
          ELSE
             isign=MOD(2*index2(3)-3,3)
             isign=-isign
             isign=isign-MOD(2*index2(2)-3,3)
          ENDIF
       ELSE
          rrr=rand()
          isign=FLOOR(3d0*rrr)-1
       ENDIF
       IF(isign.EQ.1)THEN
          ! (Jz,11)
          histo_index(1)=13
       ELSEIF(isign.EQ.-1)THEN
          ! (Jz,-1-1)
          histo_index(1)=14
       ELSEIF(isign.EQ.0)THEN
          ! (Jz,00)
          histo_index(1)=12
       ENDIF
       histo_index(2)=histo_index(1)+11
    ELSEIF(fockstate.EQ.443121.OR.fockstate.EQ.553121)THEN
       ! 3P21
       IF(MCoHelicity)THEN
          CALL Qeveryhel_ana(index2,ipol(imoth),imoth)
       ENDIF
       IF(MCoHelicity)THEN
          IF(calc_LDME_RG_CT)THEN
             ! use Eq.(29) in arXiv:1209.4610
             isign=MOD(2*index2(3)-3,3)
             isign=-isign
             CALL GetJz_ana(isign,2,JzJz)
             isign=JzJz
          ELSE
             isign=MOD(2*index2(3)-3,3)
             isign=-isign
             isign=isign-MOD(2*index2(2)-3,3)
          ENDIF
       ELSE
          rrr=rand()
          isign=FLOOR(5d0*rrr)-2
       ENDIF
       IF(isign.EQ.2)THEN
          ! (Jz,22)
          histo_index(1)=18
       ELSEIF(isign.EQ.-2)THEN
          ! (Jz,-2-2)
          histo_index(1)=19
       ELSEIF(isign.EQ.1)THEN
          ! (Jz,11)
          histo_index(1)=16
       ELSEIF(isign.EQ.-1)THEN
          ! (Jz,-1-1)
          histo_index(1)=17
       ELSEIF(isign.EQ.0)THEN
          ! (Jz,00)
          histo_index(1)=15
       ENDIF
       histo_index(2)=histo_index(1)+11
    ENDIF
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! DEFINE OBSERVABLES
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    var=1.0d0 ! total cross section
    pt=DSQRT(phad(3,1)**2+phad(3,2)**2)
    mQ=DSQRT(phad(3,4)**2-phad(3,1)**2-phad(3,2)**2-phad(3,3)**2)
    yy=rapidity(phad(3,1:4))
    etaeta=prapidity(phad(3,1:4))
    y00_075=DABS(yy).LT.0.75d0
    y00_060=DABS(yy).LT.0.6d0
    y060_120=DABS(yy).GE.0.6d0.AND.DABS(yy).LT.1.2d0
    y00_025=DABS(yy).LT.0.25d0
    y025_050=DABS(yy).GE.0.25d0.AND.DABS(yy).LT.0.5d0
    y050_075=DABS(yy).GE.0.5d0.AND.DABS(yy).LT.0.75d0
    y075_100=DABS(yy).GE.0.75d0.AND.DABS(yy).LT.1d0
    y075_150=DABS(yy).GE.0.75d0.AND.DABS(yy).LT.1.5d0
    y150_200=DABS(yy).GE.1.5d0.AND.DABS(yy).LT.2.0d0
    y100_125=DABS(yy).GE.1d0.AND.DABS(yy).LT.1.25d0
    y125_150=DABS(yy).GE.1.25d0.AND.DABS(yy).LT.1.5d0
    y150_175=DABS(yy).GE.1.5d0.AND.DABS(yy).LT.1.75d0
    y175_200=DABS(yy).GE.1.75d0.AND.DABS(yy).LT.2d0
    y200_225=DABS(yy).GE.2d0.AND.DABS(yy).LT.2.25d0
    y225_250=DABS(yy).GE.2.25d0.AND.DABS(yy).LT.2.5d0
    y250_275=DABS(yy).GE.2.5d0.AND.DABS(yy).LT.2.75d0
    y00_240=DABS(yy).LT.2.4d0
    y200_450=DABS(yy).GE.2d0.AND.DABS(yy).LT.4.5d0
    y250_400=DABS(yy).GE.2.5d0.AND.DABS(yy).LT.4d0
    y200_250=DABS(yy).GE.2d0.AND.DABS(yy).LT.2.5d0
    y250_300=DABS(yy).GE.2.5d0.AND.DABS(yy).LT.3d0
    y300_350=DABS(yy).GE.3d0.AND.DABS(yy).LT.3.5d0
    y350_400=DABS(yy).GE.3.5d0.AND.DABS(yy).LT.4d0
    y400_450=DABS(yy).GE.4d0.AND.DABS(yy).LT.4.5d0
    eta200_450=etaeta.GE.2d0.AND.etaeta.LT.4.5d0
    n_track=0
    n_jet=0
    p_track(1:4,1:20)=0d0
    DO i=3,nhad
       IF(is_a_jet_ana(iflh(i)))THEN
          n_track=n_track+1
          p_track(1:4,n_track)=phad(i,1:4)
          pid_track(n_track)=pdgt_ana(iflh(i))
       ENDIF
    ENDDO
    ! always put J/psi at the last
    n_track2=n_track+1
    n_jet2=0
    p_track2(1:4,1:20)=0d0
    p_track2(1:4,1:n_track)=p_track(1:4,1:n_track)
    p_track2(1:4,n_track2)=phad(3,1:4)
    pid_track(n_track2)=iflh(3)
    pass_stop_cuts(1:2,1:3)=.TRUE.
    IF(use_stop_cut)THEN
       ! check the stop cuts
       stop_min_n_jet_ana=stop_min_n_jet
       stop_max_n_jet_ana=stop_max_n_jet
       stop_jetalg_ana=stop_jetalg
       stop_n_frag_gluon_ana=stop_n_frag_gluon
       stop_n_frag_quark_ana=stop_n_frag_quark
       stop_maxrapjet_ana=stop_maxrapjet
       stop_jet_radius_ana=stop_jet_radius
       stop_jet_dyn_radius_ana=stop_jet_dyn_radius
       stop_minptjet_ana=stop_minptjet
       stop_zcut_ana=stop_zcut
       stop_beta_ana=stop_beta
       stop_zsoftcut_ana=stop_zsoftcut
       stop_zasymcut_ana=stop_zasymcut
       DO i=1,2
          stop_minptjet_ana=new_stop_minptjet(i)
          DO jj=1,3
             IF(i.EQ.1.AND.jj.EQ.1)THEN
                pass_stop_cuts(i,jj)=.TRUE.
             ELSE
                stop_zasymcut_ana=new_stop_zasymcut(jj)
                CALL check_stop_cuts(n_track2,p_track2,pid_track,pass_stop_cuts(i,jj))
             ENDIF
          ENDDO
       ENDDO
    ENDIF
    ! no spin correlation here as there are no decay
    ! in the decay_user.inp
    CALL psi_ll_kin(phad(3,1:4),mQ,xplponium,xplmonium)
    ptmin=DSQRT(xplponium(1)**2+xplponium(2)**2)
    pass_LHCb_psi_cut=ptmin.GT.0.5d0
    ptmin=DSQRT(xplmonium(1)**2+xplmonium(2)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.0.5d0
    ptmin=DSQRT(xplponium(1)**2+xplponium(2)**2+xplponium(3)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.5d0
    ptmin=DSQRT(xplmonium(1)**2+xplmonium(2)**2+xplmonium(3)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.5d0
    ptmin=prapidity(xplponium(1:4))
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.2d0.AND.ptmin.LT.4.5d0
    ptmin=prapidity(xplmonium(1:4))
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.2d0.AND.ptmin.LT.4.5d0
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.eta200_450
    ! in the helicity frame
    pboost(4)=phad(3,4)
    pboost(1:3)=-phad(3,1:3)
    CALL boost(mQ,pboost,xplponium(1:4),xplponium2(1:4))
    ! Eq.(21) in hep-ph/9709376
    AMOM(1:2)=0d0
    AMOM(3)=ebeam(1)-ebeam(2)
    AMOM(4)=ebeam(1)+ebeam(2)
    AP=AMOM(4)*phad(3,4)-AMOM(1)*phad(3,1)&
         -AMOM(2)*phad(3,2)-AMOM(3)*phad(3,3)
    BMOM(1:2)=0d0
    BMOM(3)=ebeam(1)+ebeam(2)
    BMOM(4)=ebeam(1)-ebeam(2)
    stot=AMOM(4)**2-AMOM(3)**2
    BP=BMOM(4)*phad(3,4)-BMOM(1)*phad(3,1)&
         -BMOM(2)*phad(3,2)-BMOM(3)*phad(3,3)
    ATMOM(1:4)=AMOM(1:4)-AP/mQ**2*phad(3,1:4)
    BTMOM(1:4)=BMOM(1:4)-BP/mQ**2*phad(3,1:4)
    ! helicity frame
    ! Eq.(23) in hep-ph/9709376
    alphaz=-mQ/DSQRT(DABS(AP**2-mQ**2*stot))
    betaz=0d0
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(mQ,pboost,ZMOM(1:4),ZMOM2(1:4))
    costh=cosij(ZMOM2(1:3),xplponium2(1:3))
    costh_array(1)=costh
    ! Collins-Soper frame
    ! Eq.(32) in hep-ph/9709376
    alphaz=-BP/DSQRT(DABS(stot*(AP**2-BP**2)))
    betaz=AP/DSQRT(DABS(stot*(AP**2-BP**2)))
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(mQ,pboost,ZMOM(1:4),ZMOM2(1:4))
    costh_cs=cosij(ZMOM2(1:3),xplponium2(1:3))
    costh_array(2)=costh_cs
    ! Gottfried-Jackson frame
    ! Eq.(26) in hep-ph/9709376
    alphaz=mQ/(AP+BP)
    betaz=alphaz
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(mQ,pboost,ZMOM(1:4),ZMOM2(1:4))
    costh_gj=cosij(ZMOM2(1:3),xplponium2(1:3))
    costh_array(3)=costh_gj
    ! Perpendicular helicity frame
    ! it is perpendicular to CS frame
    ! which is defined in arXiv:0810.4506 and arXiv:0812.3727
    pproton1(1:2)=0d0
    pproton1(4)=ebeam(1)
    pproton1(3)=ebeam(1)
    CALL boost(mQ,pboost,pproton1(1:4),ZMOM(1:4))
    ppp1=DSQRT(ZMOM(1)**2+ZMOM(2)**2+ZMOM(3)**2)
    pproton2(1:2)=0d0
    pproton2(4)=ebeam(2)
    pproton2(3)=-ebeam(2)
    CALL boost(mQ,pboost,pproton2(1:4),ZMOM2(1:4))
    ppp2=DSQRT(ZMOM2(1)**2+ZMOM2(2)**2+ZMOM2(3)**2)
    ZMOM2(1:3)=ZMOM(1:3)/ppp1+ZMOM2(1:3)/ppp2
    costh_px=cosij(ZMOM2(1:3),xplponium2(1:3))
    costh_array(4)=costh_px

    ! get LHCb cut in Jpsi in jet study: arXiv:1701.05116
    ! jet: R=0.5, anti-kt, pT(jet) > 20GeV, 2.5d0<eta(jet)<4d0
    ! J/psi: 2.0<eta(J/psi)<4.5, pT(muon) > 0.5d0, p(muon) > 5 GeV, 2.0<eta(muon)<4.5
    zpsi=-1d0
    IF(pass_LHCb_psi_cut)THEN
       CALL fastjetppgenkt_etamax(p_track2,n_track2,0.5d0,&
            20d0,4d0,-1d0,p_jet,n_jet2,jetvec)
       IF(n_jet2.GT.0)THEN
          ! the last track is J/psi                                                                        
          ! if there is one jet related to J/psi                                                           
          IF(jetvec(n_track2).NE.0)THEN
             j=jetvec(n_track2)
             etaeta=prapidity(p_jet(1:4,j))
             IF(etaeta.GT.2.5d0.AND.etaeta.LT.4d0)THEN
                ! now it passes the cuts of LHCb for J/psi-jet                                             
                pt_psijet=DSQRT(p_jet(1,j)**2+p_jet(2,j)**2)
                IF(pt_psijet.LT.19.99d0)THEN
                   WRITE(*,*)"ERROR: It seems to pick a wrong jet"
                   STOP
                ENDIF
                zpsi=pt/pt_psijet
                IF(zpsi.GT.1.001d0)THEN
                   WRITE(*,*)"ERROR: It seems to pick a wrong psi-jet"
                   STOP
                ELSEIF(zpsi.GE.1d0)THEN
                   zpsi=0.9999d0
                ENDIF
             ENDIF
          ENDIF
       ENDIF
    ENDIF
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! START TO FILL HISTOGRAM
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    l=0
    DO i=1,2
       DO jj=1,3
          IF(.NOT.pass_stop_cuts(i,jj))CYCLE
          l=(jj-1)*31+(i-1)*3*31
          CALL HISTOGRAM_fill(l+1,var,wgts)
          IF(y00_075)CALL HISTOGRAM_fill(l+2,pt,wgts)
          IF(y075_150)CALL HISTOGRAM_fill(l+3,pt,wgts)
          IF(y150_200)CALL HISTOGRAM_fill(l+4,pt,wgts)
          IF(y200_450)CALL HISTOGRAM_fill(l+5,pt,wgts)
          IF(y250_400)CALL HISTOGRAM_fill(l+6,pt,wgts)
          IF(y00_240)CALL HISTOGRAM_fill(l+7,pt,wgts)
          IF(y00_060)CALL HISTOGRAM_fill(l+8,pt,wgts)
          ! spin density matrix elements
          IF(histo_index(1).GE.9.AND.y00_060)CALL HISTOGRAM_fill(l+histo_index(1),pt,wgts)
          IF(histo_index(2).GE.20.AND.y060_120)CALL HISTOGRAM_fill(l+histo_index(2),pt,wgts)
          IF(zpsi.GE.0d0)CALL HISTOGRAM_fill(l+31,zpsi,wgts)
       ENDDO
    ENDDO
    l=0
    IF(y050_075)CALL HISTOGRAM_fill(l+187,pt,wgts)
    IF(y075_100)CALL HISTOGRAM_fill(l+188,pt,wgts)
    IF(y100_125)CALL HISTOGRAM_fill(l+189,pt,wgts)
    IF(y125_150)CALL HISTOGRAM_fill(l+190,pt,wgts)
    IF(y150_175)CALL HISTOGRAM_fill(l+191,pt,wgts)
    IF(y175_200)CALL HISTOGRAM_fill(l+192,pt,wgts)
    IF(y200_225)CALL HISTOGRAM_fill(l+193,pt,wgts)
    IF(y225_250)CALL HISTOGRAM_fill(l+194,pt,wgts)
    IF(y250_275)CALL HISTOGRAM_fill(l+195,pt,wgts)
    IF(y200_250)CALL HISTOGRAM_fill(l+196,pt,wgts)
    IF(y250_300)CALL HISTOGRAM_fill(l+197,pt,wgts)
    IF(y300_350)CALL HISTOGRAM_fill(l+198,pt,wgts)
    IF(y350_400)CALL HISTOGRAM_fill(l+199,pt,wgts)
    IF(y400_450)CALL HISTOGRAM_fill(l+200,pt,wgts)
    
    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    RETURN      
  END SUBROUTINE plot_fill

  SUBROUTINE HwU_write_file(xnorm)
    USE Helac_Global
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::xnorm
    OPEN(unit=599,file=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.HwU',&
         status='unknown')
    !xnorm=1d0
    CALL HwU_output(599,xnorm)
    CLOSE(599)
    RETURN
  END SUBROUTINE HwU_write_file

  SUBROUTINE open_topdrawer_file
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    !common/cuseitmax/useitmax
    OPEN(unit=99,FILE=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.top',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_topdrawer_file

  SUBROUTINE close_topdrawer_file
    IMPLICIT NONE
    CLOSE(99)
    RETURN
  END SUBROUTINE close_topdrawer_file

  SUBROUTINE open_gnuplot_file
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=97,FILE=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.gnu',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_gnuplot_file

  SUBROUTINE close_gnuplot_file
    IMPLICIT NONE
    CLOSE(97)
    RETURN
  END SUBROUTINE close_gnuplot_file

  SUBROUTINE open_root_file
    USE Helac_Global
    IMPLICIT NONE
    LOGICAL::useitmax
    OPEN(unit=96,FILE=TRIM(output_dir)//TRIM(process(2:10*nhad+1))//'.C',&
         status='unknown')
    useitmax=.FALSE.
  END SUBROUTINE open_root_file

  SUBROUTINE close_root_file
    IMPLICIT NONE
    CLOSE(96)
    RETURN
  END SUBROUTINE close_root_file

  SUBROUTINE plot_fill_Decay(wgts)
    USE Decay_interface
    USE QEDPS_interface
    USE Helac_Func_1
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    INCLUDE "../../decay/stdhep.inc"
    REAL(KIND(1d0))::var,costhl,Q,www
    INTEGER::i,m,l,kk,j,jj,i_lep,i_photon
    REAL(KIND(1d0)),DIMENSION(4)::Plp,Plm,Pla,PV,POnia,PBOO,pqq
    REAL(KIND(1d0))::yy,pt,mQ,etaeta,pt_psijet
    LOGICAL::y00_075,y00_025,y025_050,y050_075,y075_100,y100_125
    LOGICAL::y125_150,y150_175,y175_200,y200_225,y225_250,y250_275
    LOGICAL::y00_240,y200_450,y200_250,y250_300,y300_350,y350_400
    LOGICAL::y400_450,eta200_450,pass_LHCb_psi_cut
    LOGICAL::y075_150,y150_200,y250_400,y00_060,y060_120
    REAL(KIND(1d0))::sijmin,sij
    INTEGER::n_track,n_jet,n_track2,n_jet2
    REAL(KIND(1d0)),DIMENSION(4,NMXHEP)::p_track,p_track2
    REAL(KIND(1d0)),DIMENSION(4,NMXHEP)::p_jet
    INTEGER,DIMENSION(NMXHEP)::jetvec
    LOGICAL::ptcut_costh_10_105
    LOGICAL,DIMENSION(16)::ptcut_costh
    REAL(KIND(1d0))::ptmin,ptmax,stot,costh_cs,costh_gj,costh_px,zpsi
    REAL(KIND(1d0)),DIMENSION(4)::costh_array
    REAL(KIND(1d0)),DIMENSION(4),PARAMETER::pt_jet_min=(/3d0,4d0,5d0,6d0/)
    REAL(KIND(1d0)),DIMENSION(3),PARAMETER::eta_jet_max=(/5d0,4d0,3d0/)
    REAL(KIND(1d0)),DIMENSION(4)::AMOM,BMOM,ATMOM,BTMOM
    REAL(KIND(1d0))::AP,BP,alphaz,betaz
    REAL(KIND(1d0)),DIMENSION(4)::ZMOM,ZMOM2,pproton1,pproton2
    REAL(KIND(1d0))::ppp1,ppp2
    INTEGER::NJET
    REAL(KIND(1d0)),DIMENSION(5,4)::PJET
    REAL(KIND(1d0))::ptj1,ptj2
    REAL(KIND(1d0)),DIMENSION(4)::p_psijj
    INTEGER,DIMENSION(3)::index2
    INTEGER::fockstate,imoth,isign,JzJz
    REAL(KIND(1d0))::rrr
    INTEGER,DIMENSION(2)::histo_index
    LOGICAL,DIMENSION(2,3)::pass_stop_cuts
    INTEGER,DIMENSION(20)::pid_track
    REAL(KIND(1d0)),DIMENSION(2)::new_stop_minptjet
    REAL(KIND(1d0)),DIMENSION(3)::new_stop_zasymcut
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! DEFINE OBSERVABLES
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    new_stop_minptjet(1)=3d0
    new_stop_zasymcut(1)=0.1d0
    new_stop_minptjet(2)=6d0
    new_stop_zasymcut(2)=0.6d0
    new_stop_zasymcut(3)=0.7d0
    var=1.0d0 ! total cross section
    ! select the first two decayed stable lepton
    i_lep=0
    i_photon=0
    DO i=1,NHEP
       IF(ISHEP(i).EQ.-1)CYCLE
       IF(ISTHEP(i).EQ.1)CYCLE
       IF(JMOHEP(1,i).LE.0.OR.JMOHEP(1,i).GT.NHEP)CYCLE
       IF(ISTHEP(JMOHEP(1,i)).NE.1.OR.ISHEP(JMOHEP(1,i)).EQ.-1)CYCLE
       IF(.NOT.lepton_pdg(IDHEP(i)).AND.IDHEP(i).NE.22)CYCLE
       IF(IDHEP(i).EQ.22)THEN
          Pla(1:4)=PHEP(1:4,i)
          i_photon=i_photon+1
       ELSEIF(IDHEP(i).GT.0)THEN
          Plm(1:4)=PHEP(1:4,i)
          i_lep=i_lep+1
       ELSE
          Plp(1:4)=PHEP(1:4,i)
          i_lep=i_lep+1
       ENDIF
       IF(i_lep.EQ.1.AND.IDHEP(i).NE.22)THEN
          m=JMOHEP(1,i)
          PV(1:4)=PHEP(1:4,m)
       !ELSEIF(i_lep.EQ.2)THEN
       !   EXIT
       ENDIF
       IF(IDHEP(i).EQ.22)THEN
          m=JMOHEP(1,i)
          POnia(1:4)=PHEP(1:4,m)
       ENDIF
    ENDDO
    IF(i_lep.NE.2)THEN
       WRITE(*,*)"ERROR: do not find the two leptons"
       STOP
    ENDIF
    IF(i_photon.GT.1)THEN
       WRITE(*,*)"ERROR: found too many photon"
       STOP
    ELSEIF(i_photon.EQ.0)THEN
       POnia(1:4)=PV(1:4)
    ENDIF
    ! get the last fock state for spin density matrix element
    DO i=1,nhad
       IF(ABS(iflh(i)).GT.100)THEN
          IF(calc_LDME_RG_CT)THEN
             fockstate=iflh_CT(i)
          ELSE
             fockstate=iflh(i)
          ENDIF
          imoth=i
       ENDIF
    ENDDO
    ! get spin density matrix for each Fock state
    histo_index(1:2)=0
    IF(fockstate.EQ.443011.OR.fockstate.EQ.443018.OR. &
         fockstate.EQ.553011.OR.fockstate.EQ.553018.OR.&
         fockstate.EQ.443108.OR.fockstate.EQ.553108.OR.&
         fockstate.EQ.443118.OR.fockstate.EQ.553118.OR.&
         fockstate.EQ.443128.OR.fockstate.EQ.553128)THEN
       ! 3S1/3PJ8
       IF(MCoHelicity)THEN
          CALL Qeveryhel_ana(index2,ipol(imoth),imoth)
       ELSE
          index2(1:2)=0
          rrr=rand()
          IF(rrr.LT.1d0/3d0)THEN
             index2(3)=1
          ELSEIF(rrr.LT.2d0/3d0)THEN
             index2(3)=2
          ELSE
             index2(3)=3
          ENDIF
       ENDIF
       IF(index2(3).EQ.1)THEN
          ! (sz,11)
          histo_index(1)=10
       ELSEIF(index2(3).EQ.2)THEN
          ! (sz,-1-1)
          histo_index(1)=11
       ELSEIF(index2(3).EQ.3)THEN
          ! (sz,00)
          histo_index(1)=9
       ENDIF
       histo_index(2)=histo_index(1)+11
    ELSEIF(fockstate.EQ.443111.OR.fockstate.EQ.553111)THEN
       ! 3P11
       IF(MCoHelicity)THEN
          CALL Qeveryhel_ana(index2,ipol(imoth),imoth)
       ENDIF
       IF(MCoHelicity)THEN
          IF(calc_LDME_RG_CT)THEN
             ! use Eq.(29) in arXiv:1209.4610
             isign=MOD(2*index2(3)-3,3)
             isign=-isign
             CALL GetJz_ana(isign,1,JzJz)
             isign=JzJz
          ELSE
             isign=MOD(2*index2(3)-3,3)
             isign=-isign
             isign=isign-MOD(2*index2(2)-3,3)
          ENDIF
       ELSE
          rrr=rand()
          isign=FLOOR(3d0*rrr)-1
       ENDIF
       IF(isign.EQ.1)THEN
          ! (Jz,11)
          histo_index(1)=13
       ELSEIF(isign.EQ.-1)THEN
          ! (Jz,-1-1)
          histo_index(1)=14
       ELSEIF(isign.EQ.0)THEN
          ! (Jz,00)
          histo_index(1)=12
       ENDIF
       histo_index(2)=histo_index(1)+11
    ELSEIF(fockstate.EQ.443121.OR.fockstate.EQ.553121)THEN
       ! 3P21
       IF(MCoHelicity)THEN
          CALL Qeveryhel_ana(index2,ipol(imoth),imoth)
       ENDIF
       IF(MCoHelicity)THEN
          IF(calc_LDME_RG_CT)THEN
             ! use Eq.(29) in arXiv:1209.4610
             isign=MOD(2*index2(3)-3,3)
             isign=-isign
             CALL GetJz_ana(isign,2,JzJz)
             isign=JzJz
          ELSE
             isign=MOD(2*index2(3)-3,3)
             isign=-isign
             isign=isign-MOD(2*index2(2)-3,3)
          ENDIF
       ELSE
          rrr=rand()
          isign=FLOOR(5d0*rrr)-2
       ENDIF
       IF(isign.EQ.2)THEN
          ! (Jz,22)
          histo_index(1)=18
       ELSEIF(isign.EQ.-2)THEN
          ! (Jz,-2-2)
          histo_index(1)=19
       ELSEIF(isign.EQ.1)THEN
          ! (Jz,11)
          histo_index(1)=16
       ELSEIF(isign.EQ.-1)THEN
          ! (Jz,-1-1)
          histo_index(1)=17
       ELSEIF(isign.EQ.0)THEN
          ! (Jz,00)
          histo_index(1)=15
       ENDIF
       histo_index(2)=histo_index(1)+11
    ENDIF
    ! select the final massless partons
    NJET=0
    DO i=1,NHEP
       IF(ISHEP(i).EQ.-1)CYCLE
       IF(ISTHEP(i).EQ.1)CYCLE
       IF(ABS(IDHEP(i)).EQ.2.OR.ABS(IDHEP(i)).EQ.1.OR.&
            ABS(IDHEP(i)).EQ.3.OR.ABS(IDHEP(i)).EQ.21)THEN
          NJET=NJET+1
          IF(NJET.GT.5)THEN
             WRITE(*,*)"ERROR #2:Found too many parton in the final states (>5)!"
             STOP
          ENDIF
          PJET(NJET,1:4)=PHEP(1:4,i)
       ENDIF
    ENDDO
    Q=scalar_product(POnia,POnia)
    IF(Q.LT.0d0)THEN
       PRINT *,"Q<0 in plot_fill_Decay !"
       STOP
    ENDIF
    Q=DSQRT(Q)
    mQ=Q
    yy=rapidity(POnia(1:4))
    etaeta=prapidity(POnia(1:4))
    pt=DSQRT(POnia(1)**2+POnia(2)**2)
    y00_075=DABS(yy).LT.0.75d0
    y00_060=DABS(yy).LT.0.6d0
    y060_120=DABS(yy).GE.0.6d0.AND.DABS(yy).LT.1.2d0
    y00_025=DABS(yy).LT.0.25d0
    y025_050=DABS(yy).GE.0.25d0.AND.DABS(yy).LT.0.5d0
    y050_075=DABS(yy).GE.0.5d0.AND.DABS(yy).LT.0.75d0
    y075_100=DABS(yy).GE.0.75d0.AND.DABS(yy).LT.1d0
    y075_150=DABS(yy).GE.0.75d0.AND.DABS(yy).LT.1.5d0
    y150_200=DABS(yy).GE.1.5d0.AND.DABS(yy).LT.2.0d0
    y100_125=DABS(yy).GE.1d0.AND.DABS(yy).LT.1.25d0
    y125_150=DABS(yy).GE.1.25d0.AND.DABS(yy).LT.1.5d0
    y150_175=DABS(yy).GE.1.5d0.AND.DABS(yy).LT.1.75d0
    y175_200=DABS(yy).GE.1.75d0.AND.DABS(yy).LT.2d0
    y200_225=DABS(yy).GE.2d0.AND.DABS(yy).LT.2.25d0
    y225_250=DABS(yy).GE.2.25d0.AND.DABS(yy).LT.2.5d0
    y250_275=DABS(yy).GE.2.5d0.AND.DABS(yy).LT.2.75d0
    y00_240=DABS(yy).LT.2.4d0
    y200_450=DABS(yy).GE.2d0.AND.DABS(yy).LT.4.5d0
    y250_400=DABS(yy).GE.2.5d0.AND.DABS(yy).LT.4d0
    y200_250=DABS(yy).GE.2d0.AND.DABS(yy).LT.2.5d0
    y250_300=DABS(yy).GE.2.5d0.AND.DABS(yy).LT.3d0
    y300_350=DABS(yy).GE.3d0.AND.DABS(yy).LT.3.5d0
    y350_400=DABS(yy).GE.3.5d0.AND.DABS(yy).LT.4d0
    y400_450=DABS(yy).GE.4d0.AND.DABS(yy).LT.4.5d0
    eta200_450=etaeta.GE.2d0.AND.etaeta.LT.4.5d0
    n_track=0
    n_jet=0
    p_track(1:4,1:NHEP)=0d0
    DO i=1,NHEP
       IF(ISTHEP(i).EQ.1)CYCLE
       IF(ISHEP(i).NE.1)CYCLE
       IF(lepton_pdg(IDHEP(i)))CYCLE
       IF(is_a_jet_ana_PDG(IDHEP(i)))THEN
          n_track=n_track+1
          p_track(1:4,n_track)=PHEP(1:4,i)
          pid_track(n_track)=IDHEP(i)
       ENDIF
    ENDDO
    ! always put J/psi/onia at the end
    n_track2=n_track+1
    n_jet2=0
    p_track2(1:4,1:NHEP)=0d0
    p_track2(1:4,1:n_track)=p_track(1:4,1:n_track)
    p_track2(1:4,n_track2)=POnia(1:4)
    pid_track(n_track2)=421
    ! check the stop cuts
    pass_stop_cuts(1:2,1:3)=.TRUE.
    IF(use_stop_cut)THEN
       stop_min_n_jet_ana=stop_min_n_jet
       stop_max_n_jet_ana=stop_max_n_jet
       stop_jetalg_ana=stop_jetalg
       stop_n_frag_gluon_ana=stop_n_frag_gluon
       stop_n_frag_quark_ana=stop_n_frag_quark
       stop_maxrapjet_ana=stop_maxrapjet
       stop_jet_radius_ana=stop_jet_radius
       stop_minptjet_ana=stop_minptjet
       stop_zcut_ana=stop_zcut
       stop_beta_ana=stop_beta
       stop_zsoftcut_ana=stop_zsoftcut
       stop_zasymcut_ana=stop_zasymcut
       DO i=1,2
          stop_minptjet_ana=new_stop_minptjet(i)
          DO jj=1,3
             IF(i.EQ.1.AND.jj.EQ.1)THEN
                pass_stop_cuts(i,jj)=.TRUE.
             ELSE
                stop_zasymcut_ana=new_stop_zasymcut(jj)
                CALL check_stop_cuts(n_track2,p_track2,pid_track,pass_stop_cuts(i,jj))
             ENDIF
          ENDDO
       ENDDO
    ENDIF
    ! take into account the cut of LHCb for J/psi in jet study
    ptmin=DSQRT(Plp(1)**2+Plp(2)**2)
    pass_LHCb_psi_cut=ptmin.GT.0.5d0
    ptmin=DSQRT(Plm(1)**2+Plm(2)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.0.5d0
    ptmin=DSQRT(Plp(1)**2+Plp(2)**2+Plp(3)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.5d0
    ptmin=DSQRT(Plm(1)**2+Plm(2)**2+Plm(3)**2)
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.5d0
    ptmin=prapidity(Plp(1:4))
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.2d0.AND.ptmin.LT.4.5d0
    ptmin=prapidity(Plm(1:4))
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.ptmin.GT.2d0.AND.ptmin.LT.4.5d0
    pass_LHCb_psi_cut=pass_LHCb_psi_cut.AND.eta200_450

    ! for the lepton costh distributions
    PBOO(1:3)=-PV(1:3)
    PBOO(4)=PV(4)
    CALL BOOSTL(Q,PBOO,Plp) ! boost to the rest frame of V
    ! Eq.(21) in hep-ph/9709376
    AMOM(1:2)=0d0
    AMOM(3)=ebeam(1)-ebeam(2)
    AMOM(4)=ebeam(1)+ebeam(2)
    AP=AMOM(4)*PV(4)-AMOM(1)*PV(1)&
         -AMOM(2)*PV(2)-AMOM(3)*PV(3)
    BMOM(1:2)=0d0
    BMOM(3)=ebeam(1)+ebeam(2)
    BMOM(4)=ebeam(1)-ebeam(2)
    stot=AMOM(4)**2-AMOM(3)**2
    BP=BMOM(4)*PV(4)-BMOM(1)*PV(1)&
         -BMOM(2)*PV(2)-BMOM(3)*PV(3)
    ATMOM(1:4)=AMOM(1:4)-AP/Q**2*PV(1:4)
    BTMOM(1:4)=BMOM(1:4)-BP/Q**2*PV(1:4)
    ! helicity frame
    ! Eq.(23) in hep-ph/9709376
    alphaz=-Q/DSQRT(DABS(AP**2-Q**2*stot))
    betaz=0d0
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(Q,PBOO,ZMOM(1:4),ZMOM2(1:4))
    costhl=cosij(ZMOM2(1:3),Plp(1:3))
    costh_array(1)=costhl
    ! Collins-Soper frame 
    ! Eq.(32) in hep-ph/9709376
    alphaz=-BP/DSQRT(DABS(stot*(AP**2-BP**2)))
    betaz=AP/DSQRT(DABS(stot*(AP**2-BP**2)))
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(Q,PBOO,ZMOM(1:4),ZMOM2(1:4))
    costh_cs=cosij(ZMOM2(1:3),Plp(1:3))
    costh_array(2)=costh_cs
    ! Gottfried-Jackson frame
    ! Eq.(26) in hep-ph/9709376
    alphaz=Q/(AP+BP)
    betaz=alphaz
    ZMOM(1:4)=alphaz*ATMOM(1:4)+betaz*BTMOM(1:4)
    CALL boost(Q,PBOO,ZMOM(1:4),ZMOM2(1:4))
    costh_gj=cosij(ZMOM2(1:3),Plp(1:3))
    costh_array(3)=costh_gj
    ! Perpendicular helicity frame
    ! it is perpendicular to CS frame
    ! which is defined in arXiv:0810.4506 and arXiv:0812.3727 
    pproton1(1:2)=0d0
    pproton1(4)=ebeam(1)
    pproton1(3)=ebeam(1)
    CALL boost(Q,PBOO,pproton1(1:4),ZMOM(1:4))
    ppp1=DSQRT(ZMOM(1)**2+ZMOM(2)**2+ZMOM(3)**2)
    pproton2(1:2)=0d0
    pproton2(4)=ebeam(2)
    pproton2(3)=-ebeam(2)
    CALL boost(Q,PBOO,pproton2(1:4),ZMOM2(1:4))
    ppp2=DSQRT(ZMOM2(1)**2+ZMOM2(2)**2+ZMOM2(3)**2)
    ZMOM2(1:3)=ZMOM(1:3)/ppp1+ZMOM2(1:3)/ppp2
    costh_px=cosij(ZMOM2(1:3),Plp(1:3))
    costh_array(4)=costh_px

    ! get LHCb cut in Jpsi in jet study: arXiv:1701.05116
    ! jet: R=0.5, anti-kt, pT(jet) > 20GeV, 2.5d0<eta(jet)<4d0
    ! J/psi: 2.0<eta(J/psi)<4.5, pT(muon) > 0.5d0, p(muon) > 5 GeV, 2.0<eta(muon)<4.5
    zpsi=-1d0
    IF(pass_LHCb_psi_cut)THEN
       CALL fastjetppgenkt_etamax(p_track2,n_track2,0.5d0,&
            20d0,4d0,-1d0,p_jet,n_jet2,jetvec)
       IF(n_jet2.GT.0)THEN
          ! the last track is J/psi
          ! if there is one jet related to J/psi
          IF(jetvec(n_track2).NE.0)THEN
             j=jetvec(n_track2)
             etaeta=prapidity(p_jet(1:4,j))
             IF(etaeta.GT.2.5d0.AND.etaeta.LT.4d0)THEN
                ! now it passes the cuts of LHCb for J/psi-jet
                pt_psijet=DSQRT(p_jet(1,j)**2+p_jet(2,j)**2)
                IF(pt_psijet.LT.19.99d0)THEN
                   WRITE(*,*)"ERROR: It seems to pick a wrong jet"
                   STOP
                ENDIF
                ! zpsi=pt/pt_psijet
                zpsi=DSQRT(PV(1)**2+PV(2)**2)/pt_psijet
                IF(zpsi.GT.1.001d0.AND.i_photon.EQ.0)THEN
                   WRITE(*,*)"ERROR: It seems to pick a wrong psi-jet"
                   STOP
                ELSEIF(zpsi.GE.1d0)THEN
                   zpsi=0.9999d0
                ENDIF
             ENDIF
          ENDIF
       ENDIF
    ENDIF
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! START TO FILL HISTOGRAM
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    l=0
    DO i=1,2
       DO jj=1,3
          IF(.NOT.pass_stop_cuts(i,jj))CYCLE
          l=(jj-1)*31+(i-1)*3*31
          CALL HISTOGRAM_fill(l+1,var,wgts)
          IF(y00_075)CALL HISTOGRAM_fill(l+2,pt,wgts)
          IF(y075_150)CALL HISTOGRAM_fill(l+3,pt,wgts)
          IF(y150_200)CALL HISTOGRAM_fill(l+4,pt,wgts)
          IF(y200_450)CALL HISTOGRAM_fill(l+5,pt,wgts)
          IF(y250_400)CALL HISTOGRAM_fill(l+6,pt,wgts)
          IF(y00_240)CALL HISTOGRAM_fill(l+7,pt,wgts)
          IF(y00_060)CALL HISTOGRAM_fill(l+8,pt,wgts)
          ! spin density matrix elements
          IF(histo_index(1).GE.9.AND.y00_060)CALL HISTOGRAM_fill(l+histo_index(1),pt,wgts)
          IF(histo_index(2).GE.20.AND.y060_120)CALL HISTOGRAM_fill(l+histo_index(2),pt,wgts)
          IF(zpsi.GE.0d0)CALL HISTOGRAM_fill(l+31,zpsi,wgts)
       ENDDO
    ENDDO
    l=0
    IF(y050_075)CALL HISTOGRAM_fill(l+187,pt,wgts)
    IF(y075_100)CALL HISTOGRAM_fill(l+188,pt,wgts)
    IF(y100_125)CALL HISTOGRAM_fill(l+189,pt,wgts)
    IF(y125_150)CALL HISTOGRAM_fill(l+190,pt,wgts)
    IF(y150_175)CALL HISTOGRAM_fill(l+191,pt,wgts)
    IF(y175_200)CALL HISTOGRAM_fill(l+192,pt,wgts)
    IF(y200_225)CALL HISTOGRAM_fill(l+193,pt,wgts)
    IF(y225_250)CALL HISTOGRAM_fill(l+194,pt,wgts)
    IF(y250_275)CALL HISTOGRAM_fill(l+195,pt,wgts)
    IF(y200_250)CALL HISTOGRAM_fill(l+196,pt,wgts)
    IF(y250_300)CALL HISTOGRAM_fill(l+197,pt,wgts)
    IF(y300_350)CALL HISTOGRAM_fill(l+198,pt,wgts)
    IF(y350_400)CALL HISTOGRAM_fill(l+199,pt,wgts)
    IF(y400_450)CALL HISTOGRAM_fill(l+200,pt,wgts)
    

    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    RETURN
  END SUBROUTINE plot_fill_Decay

  SUBROUTINE plot_fill_QEDPS(wgts)
    USE QEDPS_interface
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(:),INTENT(IN)::wgts
    ! QEDPS parameters                                                      
    REAL(KIND(1d0)),DIMENSION(10,1000)::PLPTN
    INTEGER,DIMENSION(10,1000)::NLPTN
    INTEGER::NPTCL
    COMMON/QPLIST/PLPTN,NLPTN,NPTCL
    REAL(KIND(1d0)),DIMENSION(4)::pini
    REAL(KIND(1d0))::wgt,var,frache
    REAL(KIND(1d0))::exp1,exp2
    INTEGER::i,kk,l,nphoton
    REAL(KIND(1d0))::www,yftot
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! 
    ! DEFINE OBSERVABLES
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    var=1.0d0 ! total cross section
    pini(1:4)=PLPTN(4:7,1)+PLPTN(4:7,2)
    yftot=rapidity(pini)
    nphoton=0
    DO i=1,NPTCL
       IF(NLPTN(1,i).EQ.22)THEN
          nphoton=nphoton+1
       ENDIF
    ENDDO
    frache=MIN(Q2OUT_QEDPS/Q2MAX_QEDPS,1d0)
    frache=DSQRT(frache)
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! START TO FILL HISTOGRAM
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    l=0
    CALL HISTOGRAM_fill(l+1,var,wgts)
    CALL HISTOGRAM_fill(l+2,yftot,wgts)
    CALL HISTOGRAM_fill(l+3,DBLE(nphoton),wgts)
    CALL HISTOGRAM_fill(l+4,frache,wgts)

    IF(hwufile_output)THEN
       call HwU_add_points
    ENDIF
    RETURN
  END SUBROUTINE plot_fill_QEDPS

  SUBROUTINE psi_ll_kin(ppsi,mpsi,plp,plm)
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(4),INTENT(IN)::ppsi
    REAL(KIND(1d0)),INTENT(IN)::mpsi
    REAL(KIND(1d0)),DIMENSION(4),INTENT(OUT)::plp,plm
    REAL(KIND(1d0)),DIMENSION(4)::plpres,plmres
    REAL(KIND(1d0)),PARAMETER::pipi=3.14159265358979323846264338328d0
    REAL(KIND(1d0))::p0,phi,costh,sinth
    costh=2d0*(rand()-0.5d0)
    sinth=DSQRT(ABS(1d0-costh**2))
    phi=rand()*2d0*pipi
    p0=mpsi/2d0
    plpres(3)=p0*costh
    plpres(4)=p0
    plpres(1)=p0*sinth*DCOS(phi)
    plpres(2)=p0*sinth*DSIN(phi)
    plmres(4)=p0
    plmres(1:3)=-plpres(1:3)
    CALL boost(mpsi,ppsi,plpres,plp)
    CALL boost(mpsi,ppsi,plmres,plm)
    RETURN
  END SUBROUTINE psi_ll_kin

  FUNCTION is_a_jet_ana(ifh)
    IMPLICIT NONE
    LOGICAL::is_a_jet_ana
    INTEGER,INTENT(IN)::ifh
    INTEGER::iff,init=0
    SAVE init
    LOGICAL,DIMENSION(12)::is_fermion_a_jet
    SAVE is_fermion_a_jet
    IF(ABS(ifh).GT.12.AND.ABS(ifh).NE.35)THEN
       is_a_jet_ana=.FALSE.
       RETURN
    ENDIF
    IF(ifh.EQ.35)THEN
       is_a_jet_ana=.TRUE.
       RETURN
    ENDIF
    iff=ABS(ifh)
    IF(MOD(iff,4).NE.0.AND.MOD(iff,4).NE.3)THEN
       is_a_jet_ana=.FALSE.
       RETURN
    ENDIF
    IF(init.EQ.0)THEN
       is_fermion_a_jet(1:12)=.FALSE.
       IF(jet_n_flavour.GE.1)is_fermion_a_jet(4)=.TRUE.
       IF(jet_n_flavour.GE.2)is_fermion_a_jet(3)=.TRUE.
       IF(jet_n_flavour.GE.3)is_fermion_a_jet(8)=.TRUE.
       IF(jet_n_flavour.GE.4)is_fermion_a_jet(7)=.TRUE.
       IF(jet_n_flavour.GE.5)is_fermion_a_jet(12)=.TRUE.
       IF(jet_n_flavour.GE.6)is_fermion_a_jet(11)=.TRUE.
       init=1
    ENDIF
    is_a_jet_ana=is_fermion_a_jet(iff)
    RETURN
  END FUNCTION is_a_jet_ana

  FUNCTION is_a_jet_ana_PDG(pdg)
    IMPLICIT NONE
    LOGICAL::is_a_jet_ana_PDG
    INTEGER,INTENT(IN)::pdg
    INTEGER::iff,init=0
    SAVE init
    LOGICAL,DIMENSION(6)::is_fermion_a_jet
    SAVE is_fermion_a_jet
    IF(ABS(pdg).GT.6.AND.ABS(pdg).NE.21)THEN
       is_a_jet_ana_PDG=.FALSE.
       RETURN
    ENDIF
    IF(pdg.EQ.21)THEN
       is_a_jet_ana_PDG=.TRUE.
       RETURN
    ENDIF
    IF(init.EQ.0)THEN
       is_fermion_a_jet(1:6)=.FALSE.
       IF(jet_n_flavour.GE.1)is_fermion_a_jet(1)=.TRUE.
       IF(jet_n_flavour.GE.2)is_fermion_a_jet(2)=.TRUE.
       IF(jet_n_flavour.GE.3)is_fermion_a_jet(3)=.TRUE.
       IF(jet_n_flavour.GE.4)is_fermion_a_jet(4)=.TRUE.
       IF(jet_n_flavour.GE.5)is_fermion_a_jet(5)=.TRUE.
       IF(jet_n_flavour.GE.6)is_fermion_a_jet(6)=.TRUE.
       init=1
    ENDIF
    is_a_jet_ana_PDG=is_fermion_a_jet(ABS(pdg))
    RETURN
  END FUNCTION is_a_jet_ana_PDG

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                  !
! The following are just copies of functions in    !
! Helac_Func_1.f                                   !
!                                                  !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  FUNCTION SubInteger_ana(int,n1,n2)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::int,n1,n2
    INTEGER::nmax,nmin,mod11,int2
    INTEGER::SubInteger_ana
    int2=ABS(int)
    nmax=MAX(n1,n2)
    nmin=MIN(n1,n2)
    IF(int2.LT.10**(nmin-1))THEN
       SubInteger_ana=0
       RETURN
    ELSEIF(nmin.GT.0)THEN
       mod11=MOD(int2,10**nmax)
       SubInteger_ana=mod11/10**(nmin-1)
       RETURN
    ELSE
       PRINT *,"Error in SubInteger_ana ! STOP!"
       STOP
    ENDIF
  END FUNCTION SubInteger_ana

  FUNCTION QN3PJF_ana(kk)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::kk
    LOGICAL::QN3PJF_ana
    QN3PJF_ana=.FALSE.
    IF(kk.GT.nhad.OR.kk.LE.0)RETURN
    IF(SubInteger_ana(iflh(kk),3,4).NE.31)RETURN
    QN3PJF_ana=.TRUE.
    RETURN
  END FUNCTION QN3PJF_ANA

  FUNCTION QN1P1F_ana(kk)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::kk
    LOGICAL::QN1P1F_ana
    QN1P1F_ana=.FALSE.
    IF(kk.GT.nhad.OR.kk.LE.0)RETURN
    IF(SubInteger_ana(iflh(kk),3,4).NE.11)RETURN
    QN1P1F_ana=.TRUE.
    RETURN
  END FUNCTION QN1P1F_ANA

  FUNCTION QN3S1F_ana(kk)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::kk
    LOGICAL::QN3S1F_ana
    QN3S1F_ana=.FALSE.
    IF(kk.GT.nhad.OR.kk.LE.0)RETURN
    IF(SubInteger_ana(iflh(kk),3,4).NE.30)RETURN
    QN3S1F_ana=.TRUE.
    RETURN
  END FUNCTION QN3S1F_ANA

  FUNCTION QN1S0F_ana(kk)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::kk
    LOGICAL::QN1S0F_ana
    QN1S0F_ana=.FALSE.
    IF(kk.GT.nhad.OR.kk.LE.0)RETURN
    IF(SubInteger_ana(iflh(kk),3,4).NE.10)RETURN
    QN1S0F_ana=.TRUE.
    RETURN
  END FUNCTION QN1S0F_ANA

  ! for every number, it generates the helicity for (U_lamda,eps(L_z),eps(S_z))
  !*********************************************************
  !     ipol(k)=helicity,ipol(k)=2:rigth-handed            *
  !                      ipol(k)=1:left-handed             *
  !                      ipol(k)=3:long.                   *
  !*********************************************************
  SUBROUTINE Qeveryhel_ana(ihela,num,kk)  !num=ipol(kk)
    IMPLICIT NONE
    INTEGER,DIMENSION(3),INTENT(OUT)::ihela
    INTEGER,INTENT(IN)::num,kk
    INTEGER::ii1,jj1,kk1
    IF(kk.GT.nhad.OR.kk.LE.2)THEN
       PRINT *,"Error 1 in Qeveryhel_ana ! STOP !"
       STOP
    ENDIF
    IF(ABS(iflh(kk)).LE.100)THEN
       PRINT *,"Error 2 in Qeveryhel_ana ! STOP !"
       STOP
    ENDIF
    IF(iranhel.EQ.3)THEN
       ihela(1)=num
       ihela(2:3)=0
       RETURN
    ENDIF
    IF(QN1S0F_ana(kk))THEN
       ihela(1)=num
       ihela(2:3)=0
       RETURN
    ENDIF
    IF(QN3S1F_ana(kk))THEN
       ihela(2)=0
       ii1=MOD(num-1,2)
       jj1=(num-1)/2
       ihela(1)=ii1+1
       ihela(3)=jj1+1
       RETURN
    ENDIF
    IF(QN1P1F_ana(kk))THEN
       IF(iranhel.EQ.2)THEN
          ihela(1)=num
          ihela(2:3)=0
          RETURN
       ELSE
          ihela(3)=0
          ii1=MOD(num-1,2)
          jj1=(num-1)/2
          ihela(1)=ii1+1
          ihela(2)=jj1+1
          RETURN
       ENDIF
    ENDIF
    IF(QN3PJF_ana(kk))THEN
       IF(iranhel.EQ.2)THEN
          ihela(2)=0
          ii1=MOD(num-1,2)
          jj1=(num-1)/2
          ihela(1)=ii1+1
          ihela(3)=jj1+1
          RETURN
       ELSE
          ii1=MOD(num-1,2)
          jj1=MOD((num-1)/2,3)
          kk1=(num-1)/6
          ihela(1)=ii1+1
          ihela(2)=jj1+1
          ihela(3)=kk1+1
          RETURN
       ENDIF
    ENDIF
    ihela(1:3)=0
    RETURN
  END SUBROUTINE Qeveryhel_ana

  SUBROUTINE check_stop_cuts(n_track,p_track,pid_track,passcuts)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::n_track
    REAL(KIND(1d0)),DIMENSION(4,20),INTENT(IN)::p_track
    INTEGER,DIMENSION(20),INTENT(IN)::pid_track
    LOGICAL,INTENT(OUT)::passcuts
    INTEGER::ioniumjet,n_oniumjet_track,n_oniumjet_gluon,n_oniumjet_quark
    INTEGER,DIMENSION(-6:6)::n_oniumjet_quarkflavor
    INTEGER::n_oniumjet_gluonandqqbar,n_oniumjet_nonpairquark
    REAL(KIND(1d0)),DIMENSION(4,20)::p_oniumjet_track
    INTEGER::n_jet,n_onium
    REAL(KIND(1d0)),DIMENSION(4,20)::p_jet
    INTEGER,DIMENSION(20)::jetvec
    REAL(KIND(1d0))::pt1_oniumjet,pt2_oniumjet,z12,z1,d1,d2,dr,pi
    REAL(KIND(1d0))::ptjet_min,ptjet_max,ptjet,RRstop,ptonium,monium
    INTEGER::i,l
    passcuts=.TRUE.
    pi=DACOS(-1d0)
    n_onium=1
    ! make sure the last track is the onium
    IF(stop_jet_dyn_radius_ana.GT.0d0)THEN
       monium=p_track(4,n_track)**2-p_track(1,n_track)**2&
            -p_track(2,n_track)**2-p_track(3,n_track)**2
       monium=DSQRT(monium)
       ptonium=p_track(1,n_track)**2+p_track(2,n_track)**2
       ptonium=DSQRT(ptonium)
       RRstop=MAX(stop_jet_radius_ana,stop_jet_dyn_radius_ana*monium/ptonium)
    ELSE
       RRstop=stop_jet_radius_ana
    ENDIF
    IF(stop_maxrapjet_ana.GT.0d0)THEN
       CALL fastjetppgenkt_etamax(p_track,n_track,RRstop,stop_minptjet_ana,stop_maxrapjet_ana,&
            DBLE(stop_jetalg_ana),p_jet,n_jet,jetvec)
    ELSE
       CALL fastjetppgenkt(p_track,n_track,RRstop,stop_minptjet_ana,DBLE(stop_jetalg_ana),&
            p_jet,n_jet,jetvec)
    ENDIF
    IF(n_jet.LT.stop_min_n_jet_ana)THEN
       passcuts=.FALSE.
       RETURN
    ELSEIF(stop_max_n_jet_ana.GE.0.AND.n_jet.GT.stop_max_n_jet_ana)THEN
       passcuts=.FALSE.
       RETURN
    ENDIF
    ioniumjet=jetvec(n_track)
    IF(ioniumjet.LE.0)THEN
       passcuts=.FALSE.
       RETURN
    ENDIF
    n_oniumjet_track=0
    p_oniumjet_track(1:4,1:20)=0d0
    n_oniumjet_gluon=0
    n_oniumjet_quark=0
    n_oniumjet_quarkflavor(-6:6)=0
    DO i=1,n_track
       IF(jetvec(i).EQ.ioniumjet.AND.is_a_jet_ana_PDG(pid_track(i)))THEN
          n_oniumjet_track=n_oniumjet_track+1
          p_oniumjet_track(1:4,n_oniumjet_track)=p_track(1:4,i)
          IF(pid_track(i).EQ.21)THEN
             n_oniumjet_gluon=n_oniumjet_gluon+1
          ELSEIF(ABS(pid_track(i)).LE.6)THEN
             n_oniumjet_quark=n_oniumjet_quark+1
             n_oniumjet_quarkflavor(pid_track(i))=&
                          n_oniumjet_quarkflavor(pid_track(i))+1
          ENDIF
       ENDIF
    ENDDO
    n_oniumjet_gluonandqqbar=n_oniumjet_gluon
    n_oniumjet_nonpairquark=0
    DO i=1,6
       n_oniumjet_gluonandqqbar=n_oniumjet_gluonandqqbar+&
            MIN(n_oniumjet_quarkflavor(-i),n_oniumjet_quarkflavor(i))
       n_oniumjet_nonpairquark=n_oniumjet_nonpairquark+&
            ABS(n_oniumjet_quarkflavor(-i)-n_oniumjet_quarkflavor(i))
    ENDDO
    ! I do not know the flavours of the stop_n_frag_quark_ana
    ! choose the way to maximize n_oniumjet_gluonandqqbar
    ! subtract the ones needed by stop_n_frag_quark_ana
    IF(n_oniumjet_nonpairquark.LT.stop_n_frag_quark_ana)THEN
       n_oniumjet_gluonandqqbar=n_oniumjet_gluonandqqbar&
            -(stop_n_frag_quark_ana-n_oniumjet_nonpairquark+1)/2
    ENDIF
    IF(n_oniumjet_track.LT.(stop_n_frag_gluon_ana+stop_n_frag_quark_ana).OR.&
         n_oniumjet_gluonandqqbar.LT.stop_n_frag_gluon_ana.OR.&
         n_oniumjet_quark.LT.stop_n_frag_quark_ana)THEN
       passcuts=.FALSE.
       RETURN
    ELSE
       IF(n_oniumjet_track.GE.2)THEN
          ! check the soft drop cut
          DO i=1,n_oniumjet_track-1
             pt1_oniumjet=DSQRT(p_oniumjet_track(1,i)**2+p_oniumjet_track(2,i)**2)
             DO l=i+1,n_oniumjet_track
                pt2_oniumjet=DSQRT(p_oniumjet_track(1,l)**2+p_oniumjet_track(2,l)**2)
                z12=MIN(pt1_oniumjet,pt2_oniumjet)/MAX((pt1_oniumjet+pt2_oniumjet),1D-99)
                d1=prapidity(p_oniumjet_track(1:4,i))&
                     -prapidity(p_oniumjet_track(1:4,l))
                d2=ph4(p_oniumjet_track(1,i),p_oniumjet_track(2,i),p_oniumjet_track(3,i))&
                     -ph4(p_oniumjet_track(1,l),p_oniumjet_track(2,l),p_oniumjet_track(3,l))
                d2=MIN(DABS(d2),2*pi-DABS(d2))
                IF(d2/pi.GT.1.d0)WRITE(*,*)d2/pi
                dr=DSQRT(d1**2+d2**2)
                IF(z12.LE.stop_zcut_ana*(dr/RRstop)**stop_beta_ana)THEN
                   passcuts=.FALSE.
                   RETURN
                ENDIF
             ENDDO
          ENDDO
       ENDIF
       ! n_track-n_onium=i+k+o
       ! assume there is only one onium and one onium jet
       ! stop_min_n_jet-1 is the minimal number of parton jets
       ! If there are extra o radiations, the condition is to require
       ! i+k+o-m=n_track-n_onium-n_oniumjet_track
       IF(stop_min_n_jet_ana-1.LT.(n_track-n_onium-n_oniumjet_track))THEN
          IF(n_jet-1.LT.(n_track-n_onium-n_oniumjet_track))THEN
             passcuts=.FALSE.
             RETURN
          ENDIF
          IF(n_jet-1.GE.2.AND.stop_zasymcut_ana.GT.0d0)THEN
             ! apply the asymmetric cut                                                                                                               
             ptjet_min=-1d0
             ptjet_max=-1d0
             DO i=1,n_jet
                IF(i.EQ.ioniumjet)CYCLE
                ptjet=DSQRT(p_jet(1,i)**2+p_jet(2,i)**2)
                IF(ptjet_min.LT.0d0.OR.ptjet_min.GT.ptjet)THEN
                   ptjet_min=ptjet
                ENDIF
                IF(ptjet_max.LT.0d0.OR.ptjet_max.LT.ptjet)THEN
                   ptjet_max=ptjet
                ENDIF
             ENDDO
             IF(ptjet_min/ptjet_max.LE.stop_zasymcut_ana)THEN
                passcuts=.FALSE.
                RETURN
             ENDIF
          ENDIF
       ENDIF
       ! to pass the soft cut for 3S1[8]
       ! k=stop_n_frag_gluon+stop_n_frag_quark
       IF(n_oniumjet_track.GT.0.AND.(stop_n_frag_gluon_ana+stop_n_frag_quark_ana).EQ.0)THEN
          DO i=1,n_oniumjet_track
             ! Take energy fraction
             z1=p_oniumjet_track(4,i)/p_jet(4,ioniumjet)
             ! zsoftcut is divided by the number of partons inside the onium jet
             IF(z1.LE.stop_zsoftcut_ana/DBLE(n_oniumjet_track))THEN
                passcuts=.FALSE.
                RETURN
             ENDIF
          ENDDO
       ENDIF
    ENDIF
    RETURN
  END SUBROUTINE check_stop_cuts

  FUNCTION pdgt_ana(ifif)
    ! from HELAC-Onia notation to PDG notation
    INTEGER,INTENT(IN)::ifif
    INTEGER::pdgt_ana,init=0,ifac
    INTEGER,DIMENSION(-50:50)::ipdt
    SAVE ipdt,init,ifac
    IF(init.EQ.0)THEN
       ipdt( 1)= 12
       ipdt(-1)=-12
       ipdt( 5)= 14
       ipdt(-5)=-14
       ipdt( 9)= 16
       ipdt(-9)=-16
       ipdt( 2)= 11
       ipdt(-2)=-11
       ipdt( 6)= 13
       ipdt(-6)=-13
       ipdt( 10)= 15
       ipdt(-10)=-15
       ipdt( 3)= 2
       ipdt(-3)=-2
       ipdt( 4)= 1
       ipdt(-4)=-1
       ipdt( 7)= 4
       ipdt(-7)=-4
       ipdt( 8)= 3
       ipdt(-8)=-3
       ipdt( 11)= 6
       ipdt(-11)=-6
       ipdt( 12)= 5
       ipdt(-12)=-5
       ipdt(35)=21
       ipdt(31)=22
       ipdt(32)=23
       ipdt(33)=24
       ipdt(34)=-24
       ipdt(41)=25
       init=1
    ENDIF
    IF(ABS(ifif).LT.100)THEN
       pdgt_ana=ipdt(ifif)
       RETURN
    ENDIF
    ifac=1
    IF(ifif.LT.0)ifac=-1
    SELECT CASE(ABS(ifif))
       ! J/psi
    CASE(443011)
       pdgt_ana=443
       ! etac
    CASE(441001)
       pdgt_ana=441
       ! hc
    CASE(441111)
       pdgt_ana=10443
       ! chic0
    CASE(443101)
       pdgt_ana=10441
       ! chic1
    CASE(443111)
       pdgt_ana=20443
       ! chic2
    CASE(443121)
       pdgt_ana=445
       ! upsilon
    CASE(553011)
       pdgt_ana=553
       ! etab
    CASE(551001)
       pdgt_ana=551
       ! hb
    CASE(551111)
       pdgt_ana=10553
       ! chib0
    CASE(553101)
       pdgt_ana=10551
       ! chib1
    CASE(553111)
       pdgt_ana=20553
       ! chib2
    CASE(553121)
       pdgt_ana=555
       ! Bc*+-
    CASE(453011)
       pdgt_ana=543*ifac
       ! Bc+-
    CASE(451001)
       pdgt_ana=541*ifac
       ! Bc2*+-
    CASE(453121)
       pdgt_ana=545*ifac
       ! Bc0*+-
    CASE(453101)
       pdgt_ana=10541*ifac
       ! Bc1(H)+-
    CASE(453111)
       pdgt_ana=20543*ifac
       ! ccbar(3P0(8))
    CASE(443108)
       pdgt_ana=9910441
       ! bbbar(3P0(8))
    CASE(553108)
       pdgt_ana=9910551
       ! bbbar(3S1(8))
    CASE(553018)
       pdgt_ana=9900553
       ! bbbar(1S0(8))
    CASE(551008)
       pdgt_ana=9900551
       ! ccbar(3S1(8))
    CASE(443018)
       pdgt_ana=9900443
       ! ccbar(1S0(8))
    CASE(441008)
       pdgt_ana=9900441
    CASE DEFAULT
       pdgt_ana=ifif
    END SELECT
    RETURN
  END FUNCTION pdgt_ana

  SUBROUTINE GetJz_ana(sz,JJ,Jz)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::sz,JJ
    INTEGER,INTENT(OUT)::Jz
    REAL(KIND(1d0))::rrr
    ! use Eq.(29) in arXiv:1209.4610
    IF(ABS(sz).GT.1)THEN
       WRITE(*,*)"ERROR: invalid sz (0,+-1) !"
       STOP
    ENDIF
    rrr=rand()
    IF(JJ.EQ.1)THEN
       IF(sz.EQ.-1)THEN
          IF(rrr.GT.0.5d0)THEN
             Jz=0
          ELSE
             Jz=-1
          ENDIF
       ELSEIF(sz.EQ.1)THEN
          IF(rrr.GT.0.5d0)THEN
             Jz=1
          ELSE
             Jz=0
          ENDIF
       ELSEIF(sz.EQ.0)THEN
          IF(rrr.GT.0.5d0)THEN
             Jz=1
          ELSE
             Jz=-1
          ENDIF
       ENDIF
    ELSEIF(JJ.EQ.2)THEN
       IF(sz.EQ.-1)THEN
          IF(rrr.LT.0.6d0)THEN
             Jz=-2
          ELSEIF(rrr.GT.0.6d0.AND.rrr.LT.0.9d0)THEN
             Jz=-1
          ELSE
             Jz=0
          ENDIF
       ELSEIF(sz.EQ.1)THEN
          IF(rrr.LT.0.6d0)THEN
             Jz=2
          ELSEIF(rrr.GT.0.6d0.AND.rrr.LT.0.9d0)THEN
             Jz=1
          ELSE
             Jz=0
          ENDIF
       ELSE
          IF(rrr.LT.0.3d0)THEN
             Jz=-1
          ELSEIF(rrr.GT.0.3d0.AND.rrr.LT.0.7d0)THEN
             Jz=0
          ELSE
             Jz=1
          ENDIF
       ENDIF
    ELSE
       WRITE(*,*)"ERROR: invalid J (1 or 2) !"
       STOP
    ENDIF
    RETURN
  END SUBROUTINE GetJz_ana
END MODULE plot_user
