################################################################################
#
# Basic objects defined for HELAC-Onia
#
################################################################################
"""Basic objects defined for HELAC-Onia
"""
from __future__ import division

import cmath
import copy
import os

try:
    import readline
    GNU_SPLITTING = ('GNU' in readline.__doc__)
except:
    GNU_SPLITTING = True

pjoin = os.path.join


class SubProcess(object):
    """A class to represent a subprocess in HELAC-Onia."""

    #subprocess=[]
    #subprocess_CT=None

    def __init__(self,subproc=[],subproc_CT=None):
        self.subprocess=subproc
        self.subprocess_CT=subproc_CT
            

    def __eq__(self, other):
        """Object with same subprocess and subprocess_CT are identical."""

        try:
            return (self.subprocess == other.subprocess and self.subprocess_CT == other.subprocess_CT)
        except Exception:
            return (self.subprocess == other and self.subprocess_CT == None)

class SubProcesses(list):
    """A list of SubProcess."""

    def is_valid_element(self, obj):
        """Test if object obj is a valid SubProcess for the list."""
        
        return isinstance(obj, SubProcess)


if __name__ == '__main__':
    haha=SubProcesses([])
    print haha
    hehe=SubProcess(subproc=[35,35,443011,35])
    haha.append(hehe)
    hoho=SubProcess(subproc=[35,35,443011,35],subproc_CT=[35,35,443018,35])
    print hehe == hoho
    tete=SubProcess(subproc=[35,35,443011,35],subproc_CT=None)
    print hehe == tete
