MODULE FragInfo
  USE Helac_Global
  USE Frag_Global
  IMPLICIT NONE
CONTAINS
  SUBROUTINE ReadFragInfo
    IMPLICIT NONE
    LOGICAL::lexist,needed,valid
    INTEGER::iounit,iostate
    CHARACTER(100)::ctmp
    INTEGER::k,i,jjj,lll,kkk
    INTEGER::iType
    INTEGER,DIMENSION(0:MAX_FragH)::frag
    INTEGER::udecay=331127
    INQUIRE(FILE=TRIM(input_dir)//"fragment_user.inp",EXIST=lexist)
    IF(.NOT.lexist)THEN
       PRINT *,"ERROR: the file fragment_user.inp does not exist ! STOP !"
       STOP
    ENDIF
    INQUIRE(FILE=TRIM(input_dir)//"fragment_user.inp",OPENED=lexist)
    IF(lexist)THEN
       INQUIRE(FILE=TRIM(input_dir)//"fragment_user.inp",NUMBER=iounit)
       IF(iounit.NE.udecay)THEN
          PRINT *,"WARNING: the fragment_user.inp has been linked with another unit ! Close and reopen !"
          CLOSE(UNIT=iounit)
          OPEN(UNIT=udecay,FILE=TRIM(input_dir)//"fragment_user.inp")
       ENDIF
    ELSE
       OPEN(UNIT=udecay,FILE=TRIM(input_dir)//"fragment_user.inp")
    ENDIF
    iostate=0
    jjj=0
    kkk=0
    FragChains(1:MAX_FragChain,-1:MAX_FragH)=0
    FragType(1:MAX_FragChain)=-1
    iflh2FragChains(1:20,0:MAX_FragChain)=0
    NFragChains=0
    DO WHILE(iostate.NE.-1.AND.iostate.LE.0)
       READ(udecay,"(A)",IOSTAT=iostate)ctmp
       IF(iostate.LT.0)EXIT
       IF(ctmp(1:1)=="#")CYCLE
       IF(ctmp(1:14)=="Fragment Chain")THEN
          READ(udecay,*,IOSTAT=iostate)k,itype
          IF(.NOT.(iostate.NE.-1.AND.iostate.LE.0))THEN
             PRINT *,"ERROR:Wrong format (number,type) in fragment_user.inp"
             STOP
          ENDIF
          IF(k.GT.MAX_FragH)THEN
             PRINT *,"ERROR:Exceeds the maximal fragemented hadron in HELAC-Onia"
             STOP
          ENDIF
          IF(itype.LT.1.OR.itype.GT.2)THEN
             PRINT *,"ERROR:Only two types are supported in fragmentation"
             STOP
          ENDIF
          READ(udecay,*,IOSTAT=iostate)(frag(i),i=0,k)
          IF(.NOT.(iostate.NE.-1.AND.iostate.LE.0))THEN
             PRINT *,"ERROR:Wrong format (fragment chain) in fragment_user.inp"
             STOP
          ENDIF
          ! only select the needed ones
          needed=.FALSE.
          valid=.FALSE.
          IF(itype.EQ.1)THEN
             DO i=3,nhad
                ! select the parton ones only
                IF(ABS(iflh(i)).GT.12.AND.ABS(iflh(i)).NE.35.AND.&
                     ABS(iflh(i)).NE.31)CYCLE
                valid=.TRUE.
                IF(frag(0).EQ.iflh(i))THEN
                   needed=.TRUE.
                   lll=iflh2FragChains(i,0)
                   iflh2FragChains(i,0)=lll+1
                   iflh2FragChains(i,lll+1)=jjj+1
                ENDIF
             ENDDO
          ELSE
             ! type 2
             IF(frag(0).GT.nhad-2.OR.frag(0).LT.1)CYCLE
             ! select the parton ones only
             i=frag(0)+2
             IF(ABS(iflh(i)).GT.12.AND.ABS(iflh(i)).NE.35.AND.&
                  ABS(iflh(i)).NE.31)CYCLE
             valid=.TRUE.
             needed=.TRUE.
             lll=iflh2FragChains(i,0)
             iflh2FragChains(i,0)=lll+1
             iflh2FragChains(i,lll+1)=jjj+1
          ENDIF
          IF(needed)kkk=kkk+1
          IF(valid)THEN
             jjj=jjj+1
             IF(jjj.GT.MAX_FragChain)THEN
                PRINT *,"ERROR:Find too many fragment chains !"
                STOP
             ENDIF
             FragType(jjj)=itype
             FragChains(jjj,0:k)=frag(0:k)
             IF(itype.EQ.2)THEN
                i=frag(0)+2
                FragChains(jjj,0)=iflh(i)
             ENDIF
             FragChains(jjj,-1)=k
          ENDIF
       ENDIF
    END DO
    NFragChains=kkk
    AllNFragChains=jjj ! the valid ones
    NFragIflh=0
    DO i=1,nhad
       jjj=iflh2FragChains(i,0)
       IF(jjj.GT.1)NFragIflh=NFragIflh+1
    ENDDO
    CLOSE(UNIT=udecay)
    RETURN
  END SUBROUTINE ReadFragInfo
  
END MODULE FragInfo
