MODULE Frag_interface
  USE Helac_Global
  USE Frag_Global
  USE Helac_Func_1
  USE Kinetic_Func
  USE QEDPS_interface
  USE Constants
  USE Helac_ranmar_mod
  USE FFKretzer_interface
  IMPLICIT NONE
  ! cut on the fragmented hadrons
  REAL(KIND(1d0))::ho_fptcpi0,ho_fptcpipm,ho_fptck0,ho_fptckpm,ho_fptcp,ho_fptcn
  REAL(KIND(1d0))::ho_fycpi0low,ho_fycpi0,ho_fetacpi0
  REAL(KIND(1d0))::ho_fycpipmlow,ho_fycpipm,ho_fetacpipm
  REAL(KIND(1d0))::ho_fyck0low,ho_fyck0,ho_fetack0
  REAL(KIND(1d0))::ho_fyckpmlow,ho_fyckpm,ho_fetackpm
  REAL(KIND(1d0))::ho_fycplow,ho_fycp,ho_fetacp
  REAL(KIND(1d0))::ho_fycnlow,ho_fycn,ho_fetacn
  ! special parameter for FF package provided by Stefan Kretzer
  ! See http://www.pv.infn.it/~radici/FFdatabase/
  INTEGER::FFKretzer_Order=0,FFKretzer_Set=2
  INTEGER::ho_colmax=0
  SAVE
CONTAINS
  SUBROUTINE HO_Frag(wgtbr)
    IMPLICIT NONE
    INCLUDE "stdhep.inc"
    INTEGER::i,j,k,kk,m,nfrag
    REAL(KIND(1d0)),INTENT(OUT)::wgtbr
    REAL(KIND(1d0))::br,r,z
    REAL(KIND(1d0)),DIMENSION(MAX_FragChain)::braccum
    ! QEDPS parameters
    REAL(KIND(1d0)),DIMENSION(10,1000)::PLPTN
    INTEGER,DIMENSION(10,1000)::NLPTN
    INTEGER::NPTCL
    COMMON/QPLIST/PLPTN,NLPTN,NPTCL
    INTEGER,DIMENSION(2,1000)::children
    INTEGER,DIMENSION(1000)::imoth,mother
    INTEGER::i1max,i2max
    ho_colmax=0
    wgtbr=1d0
    nfrag=0
    IF(emep_ISR_shower.EQ.1)THEN
       NEVHEP=1
       NHEP=NPTCL-1
       imoth(1:1000)=0
       mother(1:1000)=0
       children(1:2,1:1000)=0
       imoth(1)=1
       imoth(2)=2
       i1max=1
       i2max=2
       DO i=1,NVPH_QEDPS-1 ! only from parton shower
          IF(NLPTN(6,i).EQ.-1)THEN
             IF(NLPTN(3,i).EQ.2.AND.NLPTN(4,i).NE.0)THEN
                children(1,i)=NLPTN(4,i)+i
                children(2,i)=children(1,i)+1
             ENDIF
             IF(NLPTN(2,i).NE.0)THEN
                mother(i)=i-NLPTN(2,i)
                mother(i+1)=mother(i)
                imoth(i)=imoth(mother(i))
                imoth(i+1)=imoth(mother(i))
                IF(imoth(i).EQ.1.AND.i.GT.i1max)i1max=i
                IF(imoth(i).EQ.2.AND.i.GT.i2max)i2max=i
             ENDIF
          ENDIF
       ENDDO
       DO i=1,NPTCL
          IF(i.EQ.NVPH_QEDPS)CYCLE
          IF(i.LT.NVPH_QEDPS)THEN
             ISTHEP(i)=0
             IDHEP(i)=NLPTN(1,i)
             ISHEP(i)=NLPTN(6,i)
             IF(imoth(i).EQ.1)THEN
                JMOHEP(1,i)=mother(i)
                JMOHEP(2,i)=0
             ELSEIF(imoth(i).EQ.2)THEN
                JMOHEP(1,i)=0
                JMOHEP(2,i)=mother(i)
             ELSE
                JMOHEP(1,i)=0
                JMOHEP(2,i)=0
             ENDIF
             JDAHEP(1,i)=children(1,i)
             JDAHEP(2,i)=children(2,i)
             PHEP(1:4,i)=PLPTN(4:7,i)
             IF(ABS(NLPTN(1,i)).EQ.11)THEN
                PHEP(5,i)=amel
             ELSE
                PHEP(5,i)=0d0
             ENDIF
             VHEP(1:4,i)=0d0
             IPOLHEP(i)=99
             ICOLHEP(1:2,i)=0
          ELSE
             ISTHEP(i-1)=0
             IDHEP(i-1)=NLPTN(1,i)
             ISHEP(i-1)=NLPTN(6,i)
             JMOHEP(1,i-1)=i1max
             JMOHEP(2,i-1)=i2max
             JDAHEP(1:2,i-1)=0
             PHEP(1:4,i-1)=PLPTN(4:7,i)
             PHEP(5,i-1)=parmas(iflh(i-NVPH_QEDPS+2))
             VHEP(1:4,i-1)=0d0
             IPOLHEP(i-1)=99
             IF(ho_colmax.LT.icol_un(i-NVPH_QEDPS+2,2))ho_colmax=icol_un(i-NVPH_QEDPS+2,2)
             ICOLHEP(1,i-1)=icol_un(i-NVPH_QEDPS+2,2)+100
             IF(ICOLHEP(1,i-1).EQ.100)ICOLHEP(1,i-1)=0
             IF(ho_colmax.LT.icol_un(i-NVPH_QEDPS+2,1))ho_colmax=icol_un(i-NVPH_QEDPS+2,1)
             ICOLHEP(2,i-1)=icol_un(i-NVPH_QEDPS+2,1)+100
             IF(ICOLHEP(2,i-1).EQ.100)ICOLHEP(2,i-1)=0
          ENDIF
       ENDDO
       JDAHEP(1,i1max)=NVPH_QEDPS
       JDAHEP(2,i1max)=NPTCL-1
       JDAHEP(1,i2max)=NVPH_QEDPS
       JDAHEP(2,i2max)=NPTCL-1
    ELSE
       CALL partonmom2hadronmom
       NEVHEP=1
       NHEP=nhad
       DO i=1,nhad
          ISTHEP(i)=0
          IDHEP(i)=pdgt(iflh(i))
          IF(i.GT.2.AND.i.LE.nhad)THEN
             ISHEP(i)=1
             JMOHEP(1,i)=1
             JMOHEP(2,i)=2
             JDAHEP(1,i)=0
             JDAHEP(2,i)=0
             IF(ho_colmax.LT.icol_un(i,2))ho_colmax=icol_un(i,2)
             ICOLHEP(1,i)=icol_un(i,2)+100
             IF(ICOLHEP(1,i).EQ.100)ICOLHEP(1,i)=0
             IF(ho_colmax.LT.icol_un(i,1))ho_colmax=icol_un(i,1)
             ICOLHEP(2,i)=icol_un(i,1)+100
             IF(ICOLHEP(2,i).EQ.100)ICOLHEP(2,i)=0
          ELSE
             ISHEP(i)=-1
             JMOHEP(1,i)=0
             JMOHEP(2,i)=0
             JDAHEP(1,i)=3
             JDAHEP(2,i)=nhad
             IF(ho_colmax.LT.icol_un(i,1))ho_colmax=icol_un(i,1)
             ICOLHEP(1,i)=icol_un(i,1)+100
             IF(ICOLHEP(1,i).EQ.100)ICOLHEP(1,i)=0
             IF(ho_colmax.LT.icol_un(i,2))ho_colmax=icol_un(i,2)
             ICOLHEP(2,i)=icol_un(i,2)+100
             IF(ICOLHEP(2,i).EQ.100)ICOLHEP(2,i)=0
          ENDIF
          PHEP(1:5,i)=hadron_pmom(i,1:5)
          VHEP(1:4,i)=0d0
          IPOLHEP(i)=99
       ENDDO
    ENDIF
    ! first frag
    DO i=3,nhad
       j=iflh2FragChains(i,0)
       IF(j.GT.0)THEN
          br=0d0
          braccum(1:MAX_FragChain)=0d0
          nfrag=nfrag+1
          z=Fragran(nfrag)
          DO k=1,j
             m=iflh2FragChains(i,k)
             br=br+FragFunction(i,m,z)
             braccum(k)=br
          ENDDO
          ! randomly select the decay process
          IF(j.EQ.1)THEN
             kk=1
          ELSE
             nfrag=nfrag+1
             r=Fragran(nfrag)*br
             DO k=1,j
                IF(braccum(k).GT.r)THEN
                   kk=k
                   EXIT
                ELSEIF(k.EQ.j)THEN
                   kk=j
                   EXIT
                ENDIF
             ENDDO
          ENDIF
          m=iflh2FragChains(i,kk)
          CALL HO_assign_chosenfrag(i,m,z)
          wgtbr=wgtbr*br
       ENDIF
    ENDDO
    RETURN
  END SUBROUTINE HO_Frag

  SUBROUTINE HO_assign_chosenfrag(imoth,ifrag,z)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::imoth,ifrag
    REAL(KIND(1d0)),INTENT(IN)::z
    INTEGER::i,isign
    INTEGER::lavail
    REAL(KIND(1d0)),DIMENSION(0:3)::PM,PD1,PD2
    INCLUDE "stdhep.inc"
    ! QEDPS parameters
    REAL(KIND(1d0)),DIMENSION(10,1000)::PLPTN
    INTEGER,DIMENSION(10,1000)::NLPTN
    INTEGER::NPTCL
    COMMON/QPLIST/PLPTN,NLPTN,NPTCL
    CALL HO_judge_avail_frag(imoth,ifrag,lavail)
    IF(lavail.GT.0)THEN
       SELECT CASE(lavail)
       CASE(1)
          ! q/g > pion,kaon,proton,neutron via FF provided by Stefan Kretzer
          IF(emep_ISR_shower.EQ.1)THEN
             ! isr in e-e+ collisions
             PM(0)=PLPTN(7,imoth-2+NVPH_QEDPS)
             PM(1:3)=PLPTN(4:6,imoth-2+NVPH_QEDPS)
          ELSE
             PM(0)=hadron_pmom(imoth,4)
             PM(1:3)=hadron_pmom(imoth,1:3)
          ENDIF
          PD1(0)=z*PM(0)
          PD1(1:3)=z*PM(1:3)
          IF(emep_ISR_shower.EQ.1)THEN
             JMOHEP(1,NHEP+1)=imoth+NVPH_QEDPS-3
          ELSE
             JMOHEP(1,NHEP+1)=imoth
          ENDIF
          JMOHEP(2,NHEP+1)=0
          ISTHEP(imoth)=1
          ISHEP(NHEP+1)=1
          ISTHEP(NHEP+1)=0
          IDHEP(NHEP+1)=FragChains(ifrag,1)
          JDAHEP(1,imoth)=NHEP+1
          PHEP(5,NHEP+1)=0d0
          PHEP(1:3,NHEP+1)=PD1(1:3)
          PHEP(4,NHEP+1)=PD1(0)
          VHEP(1:4,NHEP+1)=0d0
          IPOLHEP(NHEP+1)=99
          ICOLHEP(1:2,NHEP+1)=0
          NHEP=NHEP+1
       END SELECT
    ENDIF
    RETURN
  END SUBROUTINE HO_assign_chosenfrag

  FUNCTION FragFunction(imoth,ifrag,z)
    IMPLICIT NONE
    REAL(KIND(1d0))::FragFunction
    INTEGER,INTENT(IN)::imoth,ifrag
    REAL(KIND(1d0)),INTENT(IN)::z
    INTEGER,PARAMETER::available_nfrag=1
    CHARACTER(len=20),DIMENSION(available_nfrag)::available_frag
    INTEGER::i,isign
    INTEGER::lavail
    REAL(KIND(1d0)),DIMENSION(0:3)::PM
    REAL(KIND(1d0))::scale
    INCLUDE "stdhep.inc"
    ! QEDPS parameters
    REAL(KIND(1d0)),DIMENSION(10,1000)::PLPTN
    INTEGER,DIMENSION(10,1000)::NLPTN
    INTEGER::NPTCL
    COMMON/QPLIST/PLPTN,NLPTN,NPTCL

    CALL HO_judge_avail_frag(imoth,ifrag,lavail)
    IF(lavail.GT.0)THEN
       SELECT CASE(lavail)
       CASE(1)
          ! q/g > pion,kaon,proton,neutron via FF provided by Stefan Kretzer
          IF(emep_ISR_shower.EQ.1)THEN
             ! isr in e-e+ collisions 
             PM(0)=PLPTN(7,imoth-2+NVPH_QEDPS)
             PM(1:3)=PLPTN(4:6,imoth-2+NVPH_QEDPS)
          ELSE
             PM(0)=hadron_pmom(imoth,4)
             PM(1:3)=hadron_pmom(imoth,1:3)
          ENDIF
          ! take the parton energy to be the scale
          scale=PM(0)
          FragFunction=CallFFKretzer(z,scale,pdgt(FragChains(ifrag,0)),&
               FragChains(ifrag,1),FFKretzer_Order,FFKretzer_Set)
       END SELECT
    ELSE
       CALL HO_avail_frags(available_nfrag,available_frag)
       PRINT *,"Only the following fragment processes are available in HELAC-Onia"
       DO i=1,available_nfrag
          PRINT *,available_frag(i)
       ENDDO
       STOP
    ENDIF
    RETURN
  END SUBROUTINE FragFunction

  SUBROUTINE HO_avail_frag(nnn,char_frag)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::nnn
    CHARACTER(len=20),DIMENSION(nnn),INTENT(OUT)::char_frag
    IF(nnn.LE.0)RETURN
    char_frag(1)="q/g > pion,kaon,proton,neutron"
    RETURN
  END SUBROUTINE HO_avail_frag

  SUBROUTINE HO_judge_avail_frag(imoth,ifrag,lavail)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::imoth,ifrag
    INTEGER,INTENT(OUT)::lavail
    INTEGER::ll
    LOGICAL::lquark,lgluon
    lavail=0
    lquark=MOD(ABS(iflh(imoth)),4).EQ.0.OR.MOD(ABS(iflh(imoth)),4).EQ.4
    lgluon=iflh(imoth).EQ.35
    IF(lquark.OR.lgluon)THEN
       ll=FragChains(ifrag,-1)
       IF(ll.NE.1)RETURN
       IF(ABS(FragChains(ifrag,1)).NE.111.AND.ABS(FragChains(ifrag,1)).NE.211&
            .AND.ABS(FragChains(ifrag,1)).NE.311&
            .AND.ABS(FragChains(ifrag,1)).NE.321&
            .AND.ABS(FragChains(ifrag,1)).NE.2212&
            .AND.ABS(FragChains(ifrag,1)).NE.2112)RETURN
       lavail=1
       RETURN
    ENDIF
    RETURN
  END SUBROUTINE HO_judge_avail_frag

  SUBROUTINE partonmom2hadronmom
    IMPLICIT NONE
    INTEGER::i,j
    REAL(KIND(1d0)),DIMENSION(20,4)::p
    REAL(KIND(1d0)),DIMENSION(4)::pboo
    REAL(KIND(1d0))::exp1,exp2
    REAL(KIND(1d0))::m1,m2,q,e
    DO i=1,n
       p(i,1:4)=phegas_pmom(i,1:4)
    ENDDO
    j=1
    DO i=1,nhad
       IF(ABS(iflh(i)).GT.100)THEN
          m1=phegas_pmom(j,5)
          m2=phegas_pmom(j+1,5)
          hadron_pmom(i,1:4)=p(j,1:4)+p(j+1,1:4)
          hadron_pmom(i,5)=m1+m2
          j=j+2
       ELSE
          hadron_pmom(i,1:4)=p(j,1:4)
          hadron_pmom(i,5)=phegas_pmom(j,5)
          j=j+1
       ENDIF
    ENDDO
    RETURN
  END SUBROUTINE partonmom2hadronmom

  SUBROUTINE unwei_writer_Frag
    USE setscale
    IMPLICIT NONE
    INCLUDE "stdhep.inc"
    REAL(KIND(1d0))::scale1
    INTEGER::icol1,icol2,idup,idprup,istup,imothup1,imothup2
    REAL(KIND(1d0))::px,py,pz,p0,pmass,scalup,vtime,vspin,xwgtup
    INTEGER::i
    idprup = 81
    xwgtup=1
    CALL qcdscale(scale1)
    scalup=scale1
    WRITE(nunit3)NHEP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
    DO i=1,NHEP
       idup=IDHEP(i)
       istup=ISHEP(i)
       imothup1=JMOHEP(1,i)
       imothup2=JMOHEP(2,i)
       IF(emep_ISR_shower.EQ.1)THEN
          IF(i.LT.NVPH_QEDPS)THEN
             icol1=0
             icol2=0
          ELSE
             IF(i-NVPH_QEDPS+3.GT.nhad)THEN
                icol1=ICOLHEP(1,i)
                icol2=ICOLHEP(2,i)
             ELSE
                icol1=icol_un(i-NVPH_QEDPS+3,2)+100
                IF(icol1.EQ.100)icol1=0
                icol2=icol_un(i-NVPH_QEDPS+3,1)+100
                IF(icol2.EQ.100)icol2=0
             ENDIF
          ENDIF
       ELSE
          IF(i.GT.nhad)THEN
             icol1=ICOLHEP(1,i)
             icol2=ICOLHEP(2,i)
          ELSE
             IF(istup.LT.0)THEN
                icol1=icol_un(i,1)+100
                IF(icol1.EQ.100)icol1=0
                icol2=icol_un(i,2)+100
                IF(icol2.EQ.100)icol2=0
             ELSE
                icol1=icol_un(i,2)+100
                IF(icol1.EQ.100)icol1=0
                icol2=icol_un(i,1)+100
                IF(icol2.EQ.100)icol2=0
             ENDIF
          ENDIF
       ENDIF
       px=PHEP(1,i)
       py=PHEP(2,i)
       pz=PHEP(3,i)
       p0=PHEP(4,i)
       pmass=PHEP(5,i)
       vtime=0
       vspin=9
       WRITE(nunit3)idup,istup,imothup1,imothup2,icol1,icol2,&
            px,py,pz,p0,pmass,vtime,vspin
    ENDDO
  END SUBROUTINE unwei_writer_Frag

  SUBROUTINE readcuts_Frag
    IMPLICIT NONE
    CHARACTER(len=24)::file
    LOGICAL::lexist
    INTEGER::iounit,flag=0
    INQUIRE(FILE=TRIM(input_dir)//"fragment_card_default.inp",EXIST=lexist)
    IF(.NOT.lexist)THEN
       PRINT *,"Warning: the file fragment_card_default.inp does not exist ! STOP !"
       STOP
    ENDIF
    INQUIRE(FILE=TRIM(input_dir)//"fragment_card_default.inp",OPENED=lexist)
    IF(lexist)THEN
       INQUIRE(FILE=TRIM(input_dir)//"fragment_card_default.inp",NUMBER=iounit)
       CLOSE(UNIT=iounit)
    ENDIF
    OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"fragment_card_default.inp")
    ! open user's input file 
    IF(TRIM(Input_File)/="fragment_card_default.inp")THEN
       INQUIRE(FILE=TRIM(input_dir)//"fragment_card_user.inp",EXIST=lexist)
       IF(.NOT.lexist)THEN
          PRINT *,"Warning: the file fragment_card_user.inp does not exist ! STOP !"
          STOP
       ENDIF
       INQUIRE(FILE=TRIM(input_dir)//"fragment_card_user.inp",OPENED=lexist)
       IF(lexist)THEN
          INQUIRE(FILE=TRIM(input_dir)//"fragment_card_user.inp",NUMBER=iounit)
          CLOSE(UNIT=iounit)
       ENDIF
       OPEN(UNIT=uinput,FILE=TRIM(input_dir)//"fragment_card_user.inp")
    ELSE
       flag=1
    ENDIF
    ! pi0 cutoffs
    ho_fptcpi0=0d0
    ho_fycpi0=1d9
    IF(absrap)THEN
       ho_fycpi0low=0d0
    ELSE
       ho_fycpi0low=-1d9
    ENDIF
    ho_fetacpi0=1d9
    ho_fptcpi0=readvalue_r("fragment_minptpi0",flag)
    ho_fycpi0=readvalue_r("fragment_maxycpi0",flag)
    ho_fycpi0low=readvalue_r("fragment_minycpi0",flag)
    ho_fetacpi0=readvalue_r("fragment_maxrappi0",flag)
    ! pi+- cutoffs
    ho_fptcpipm=0d0
    ho_fycpipm=1d9
    IF(absrap)THEN
       ho_fycpipmlow=0d0
    ELSE
       ho_fycpipmlow=-1d9
    ENDIF
    ho_fetacpipm=1d9
    ho_fptcpipm=readvalue_r("fragment_minptpipm",flag)
    ho_fycpipm=readvalue_r("fragment_maxycpipm",flag)
    ho_fycpipmlow=readvalue_r("fragment_minycpipm",flag)
    ho_fetacpipm=readvalue_r("fragment_maxrappipm",flag)
    ! K0 or (anti-)K0
    ho_fptcK0=0d0
    ho_fycK0=1d9
    IF(absrap)THEN
       ho_fycK0low=0d0
    ELSE
       ho_fycK0low=-1d9
    ENDIF
    ho_fetacK0=1d9
    ho_fptcK0=readvalue_r("fragment_minptK0",flag)
    ho_fycK0=readvalue_r("fragment_maxycK0",flag)
    ho_fycK0low=readvalue_r("fragment_minycK0",flag)
    ho_fetacK0=readvalue_r("fragment_maxrapK0",flag)
    ! K+-
    ho_fptcKpm=0d0
    ho_fycKpm=1d9
    IF(absrap)THEN
       ho_fycKpmlow=0d0
    ELSE
       ho_fycKpmlow=-1d9
    ENDIF
    ho_fetacKpm=1d9
    ho_fptcKpm=readvalue_r("fragment_minptKpm",flag)
    ho_fycKpm=readvalue_r("fragment_maxycKpm",flag)
    ho_fycKpmlow=readvalue_r("fragment_minycKpm",flag)
    ho_fetacKpm=readvalue_r("fragment_maxrapKpm",flag)
    ! (anti-)proton
    ho_fptcp=0d0
    ho_fycp=1d9
    IF(absrap)THEN
       ho_fycplow=0d0
    ELSE
       ho_fycplow=-1d9
    ENDIF
    ho_fetacp=1d9
    ho_fptcp=readvalue_r("fragment_minptp",flag)
    ho_fycp=readvalue_r("fragment_maxycp",flag)
    ho_fycplow=readvalue_r("fragment_minycp",flag)
    ho_fetacp=readvalue_r("fragment_maxrapp",flag)
    ! (anti-)neutron
    ho_fptcn=0d0
    ho_fycn=1d9
    IF(absrap)THEN
       ho_fycnlow=0d0
    ELSE
       ho_fycnlow=-1d9
    ENDIF
    ho_fetacn=1d9
    ho_fptcn=readvalue_r("fragment_minptn",flag)
    ho_fycn=readvalue_r("fragment_maxycn",flag)
    ho_fycnlow=readvalue_r("fragment_minycn",flag)
    ho_fetacn=readvalue_r("fragment_maxrapn",flag)
    ! read the special argument for FF package provided by Stefan Kretzer
    FFKretzer_Order=readvalue_r("FFKretzer_Order",flag)
    FFKretzer_Set=readvalue_r("FFKretzer_Set",flag)
    CLOSE(UNIT=udefault)
    CLOSE(UNIT=uinput)
    WRITE(*,*)'---------------------------------------------------'
    WRITE(*,*)'        the fragment cuts        '
    WRITE(*,*)"pt  of  pi0   ",ho_fptcpi0
    WRITE(*,*)"max pesudo rapidity of pi0  ",ho_fetacpi0
    WRITE(*,*)"max y rapidity of pi0 ",ho_fycpi0
    WRITE(*,*)"min y rapidity of pi0 ",ho_dycpi0low
    WRITE(*,*)"pt  of  pi+-   ",ho_fptcpipm
    WRITE(*,*)"max pesudo rapidity of pi+-  ",ho_fetacpipm
    WRITE(*,*)"max y rapidity of pi+- ",ho_fycpipm
    WRITE(*,*)"min y rapidity of pi+- ",ho_dycpipmlow
    WRITE(*,*)"pt  of  (anti-)K0   ",ho_fptcK0
    WRITE(*,*)"max pesudo rapidity of (anti-)K0  ",ho_fetacK0
    WRITE(*,*)"max y rapidity of (anti-)K0 ",ho_fycK0
    WRITE(*,*)"min y rapidity of (anti-)K0 ",ho_dycK0low
    WRITE(*,*)"pt  of  K+-   ",ho_fptcKpm
    WRITE(*,*)"max pesudo rapidity of K+-  ",ho_fetacKpm
    WRITE(*,*)"max y rapidity of K+- ",ho_fycKpm
    WRITE(*,*)"min y rapidity of K+- ",ho_dycKpmlow
    WRITE(*,*)"pt  of  (anti-)proton   ",ho_fptcp
    WRITE(*,*)"max pesudo rapidity of (anti-)proton  ",ho_fetacp
    WRITE(*,*)"max y rapidity of (anti-)proton ",ho_fycp
    WRITE(*,*)"min y rapidity of (anti-)proton ",ho_dycplow
    WRITE(*,*)"pt  of  (anti-)neutron   ",ho_fptcn
    WRITE(*,*)"max pesudo rapidity of (anti-)neutron  ",ho_fetacn
    WRITE(*,*)"max y rapidity of (anti-)neutron ",ho_fycn
    WRITE(*,*)"min y rapidity of (anti-)neutron ",ho_dycnlow
    WRITE(*,*)'---------------------------------------------------'
    IF(literature_cutoffs.NE.0)THEN
       WRITE(*,*)"impose the special cutoffs in literature arXiv:",literature_cutoffs
    ENDIF
    RETURN
  END SUBROUTINE readcuts_Frag


  SUBROUTINE cuts_Frag(icut)
    ! only cut on the fragmentation particles
    IMPLICIT NONE
    INTEGER,INTENT(OUT)::icut
    INTEGER::i,kk
    REAL(KIND(1d0))::eta,pt,c
    REAL(KIND(1d0))::ptc,yc,yclow,etac
    iNTEGER::flag
    INCLUDE "stdhep.inc"
    icut=0
    flag=0
    DO i=1,NHEP
       IF(ISHEP(i).EQ.-1)CYCLE ! only cut on the final state
       IF(ISTHEP(i).EQ.1)CYCLE ! exclude the mother particles, which have been cutted before
       IF(JMOHEP(1,i).LE.0.OR.JMOHEP(1,i).GT.NHEP)CYCLE
       IF(ISTHEP(JMOHEP(1,i)).NE.1.OR.ISHEP(JMOHEP(1,i)).EQ.-1)CYCLE
       ! cut is only applied on the fragment particles
       IF(ABS(IDHEP(i)).EQ.111)THEN
          ! cut on the pi0
          ptc=ho_fptcpi0
          yc=ho_fycpi0
          yclow=ho_fycpi0low
          etac=ho_fetacpi0
       ELSEIF(ABS(IDHEP(i)).EQ.211)THEN
          ! cut on the pi+-
          ptc=ho_fptcpipm
          yc=ho_fycpipm
          yclow=ho_fycpipmlow
          etac=ho_fetacpipm
       ELSEIF(ABS(IDHEP(i)).EQ.311)THEN
          ! cut on (anti-)K0
          ptc=ho_fptcK0
          yc=ho_fycK0
          yclow=ho_fycK0low
          etac=ho_fetacK0
       ELSEIF(ABS(IDHEP(i)).EQ.321)THEN
          ! cut on K+-
          ptc=ho_fptcKpm
          yc=ho_fycKpm
          yclow=ho_fycKpmlow
          etac=ho_fetacKpm
       ELSEIF(ABS(IDHEP(i)).EQ.2212)THEN
          ! cut on (anti-)proton
          ptc=ho_fptcp
          yc=ho_fycp
          yclow=ho_fycplow
          etac=ho_fetacp
       ELSEIF(ABS(IDHEP(i)).EQ.2112)THEN
          ! cut on (anti-)neutron
          ptc=ho_fptcn
          yc=ho_fycn
          yclow=ho_fycnlow
          etac=ho_fetacn
       ELSE
          CYCLE
       ENDIF          
       pt=SQRT(PHEP(1,i)**2+PHEP(2,i)**2)
       IF(pt.LT.ptc)THEN
          flag=1
          EXIT
       ENDIF
       eta=prapidity(PHEP(1:4,i))
       IF(ABS(eta).GT.etac)THEN
          flag=2
          EXIT
       ENDIF
       eta=rapidity(PHEP(1:4,i))
       IF(absrap)eta=ABS(eta)
       IF(eta.GT.yc.OR.eta.LT.yclow)THEN
          flag=3
          EXIT
       ENDIF
       ! special cutoffs
    ENDDO
    IF(flag.EQ.0)THEN
       icut=1
    ENDIF
    RETURN
  END SUBROUTINE cuts_Frag
END MODULE Frag_interface
