MODULE FF_DGLAP_GLOBAL
  IMPLICIT NONE
! pQCD ORDER 1:LO, 2:NLO
INTEGER::FF_DGLAP_IORDER=2
! DLAM (Scale parameter in QCD)
! e.g. 0.220 GeV (LO), 0.323 GeV (NLO) in HKNS07
REAL(KIND(1d0))::FF_DGLAP_DLAM=0.323d0
! Heavy-quark mass threshold
! HQTHRE= m_c, m_b = 1.43, 4.3 GeV in HKNS07
REAL(KIND(1d0))::FF_DGLAP_mc_HQTHRE=1.43d0,FF_DGLAP_mb_HQTHRE=4.3d0
! Q2 range for making grid files
! Q02 -> Q2max (note: not the Q2 evolution range)
REAL(KIND(1d0))::FF_DGLAP_Q2min=1.D0,FF_DGLAP_Q2max=1558.D+5
! minimum of x
REAL(KIND(1d0))::FF_DGLAP_XMIN=1.D-2
! NT: # of t-steps for Q^2 dependence
! NX: # of x-steps for xD(x)
! NGLI: # of steps for Gauss-Legendre integral
INTEGER::FF_DGLAP_NT=580,FF_DGLAP_NX=160,FF_DGLAP_NGLI=32
! NF at the initial scale Q02=Q2min
INTEGER::FF_DGLAP_NF=3
END MODULE FF_DGLAP_GLOBAL
