MODULE fragfun_onia_ini
  IMPLICIT NONE
CONTAINS

  FUNCTION ff_g_3S11gg_ini(z,mu0,mpsi,R02,imeth)
    ! Eqs.(9-15) in hep-ph/9303205
    USE interpolation
    USE MC_VEGAS3
    USE ff_common
    !USE FF_DGLAP
    IMPLICIT NONE
    REAL(KIND(1d0))::ff_g_3S11gg_ini
    REAL(KIND(1d0)),INTENT(IN)::z,mu0,mpsi,R02
    ! imeth = 1, using the original exper
    ! imeth = 2, using the interpolation of grid
    INTEGER,INTENT(IN)::imeth
    REAL(KIND(1d0))::alp,res,sd,chi2a
    INTEGER::ii
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
    REAL(KIND(1d0))::zval,alp_save,mpsi_save,R02_save
    COMMON/zvalue/zval
    SAVE alp_save,mpsi_save,R02_save
    INTEGER::init=0
    SAVE init
    REAL(KIND(1d0)),DIMENSION(:,:),ALLOCATABLE::grid
    INTEGER::Ngrid
    SAVE grid,Ngrid
    REAL(KIND(1d0))::ALP2PI
    IF(z.LE.0d0.OR.z.GE.1d0)THEN
       ff_g_3S11gg_ini=0d0
       RETURN
    ENDIF
    CALL GETALP(DLOG(mu0**2),1,ALP2PI)
    alp=ALP2PI*2d0*pi
    !PRINT *, mu0,alp
    !alp=ALPHAS(mu0)
    ! PRINT *, alp
    ! Eqs.(9-15) in hep-ph/9303205
    IF(imeth.EQ.1)THEN
       DO ii=1,2
          XL(ii)=0d0
          XU(ii)=1d0
       ENDDO
       ITMX=1
       NCALL=20000
       zval=z
       NPRN=-1
       CALL VEGAS3(2,integrand_g_3S11gg,res,sd,chi2a)
       ff_g_3S11gg_ini=res*5d0/144d0/pi**2*alp**3*R02/mpsi**3
    ELSE
       IF(init.EQ.0)THEN
          OPEN(UNIT=2033,FILE="./grid/FF_3S11/ff_g_3S11gg_ini.grid",&
               STATUS="OLD")
          READ(2033,*)Ngrid
          IF(ALLOCATED(grid))THEN
             DEALLOCATE(grid)
          ENDIF
          ALLOCATE(grid(Ngrid,2))
          DO ii=1,Ngrid
             READ(2033,*)grid(ii,1),grid(ii,2)
          ENDDO
          CLOSE(UNIT=2033)
          !alp_save=ALPHAS(3.0d0)
          alp_save=0.25863577662972259d0
          mpsi_save=3.1d0
          R02_save=0.81d0
          init=1
       ENDIF
       CALL SPLINE_INTERPOLATE(grid(1:Ngrid,1),grid(1:Ngrid,2),Ngrid,&
            z,res)
       ff_g_3S11gg_ini=res*(alp/alp_save)**3*(R02/R02_save)*(mpsi_save/mpsi)**3
    ENDIF
    RETURN
  END FUNCTION ff_g_3S11gg_ini

  FUNCTION integrand_g_3S11gg(x,wgt)
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(2),INTENT(IN)::x
    REAL(KIND(1d0)),INTENT(IN)::wgt
    REAL(KIND(1d0))::integrand_g_3S11gg
    INTEGER::i
    REAL(KIND(1d0))::r,y,ymin,ymax
    REAL(KIND(1d0))::z
    COMMON/zvalue/z
    REAL(KIND(1d0))::jac
    r=z*x(1)
    ymin=(r+z**2)/2d0/z
    ymax=(1d0+r)/2d0
    y=(ymax-ymin)*x(2)+ymin
    jac=z*(ymax-ymin)
    integrand_g_3S11gg=0d0
    DO i=0,2
       integrand_g_3S11gg=integrand_g_3S11gg+&
            fun_fg_g_3S11gg(i,r,y)*z**i
    ENDDO
    integrand_g_3S11gg=integrand_g_3S11gg*jac
    RETURN
  END FUNCTION integrand_g_3S11gg
  
  FUNCTION fun_fg_g_3S11gg(i,r,y)
    IMPLICIT NONE
    REAL(KIND(1d0))::fun_fg_g_3S11gg
    INTEGER,INTENT(IN)::i ! i=0-2, f[0]+g[0],f[1]+g[1],f[2]+g[2]
    REAL(KIND(1d0)),INTENT(IN)::r,y
    REAL(KIND(1d0))::tiny=1d-6,sr,ff,gg
    sr=DSQRT(r)
    SELECT CASE(i)
    CASE(0)
       IF(DABS(sr-y).GT.tiny)THEN
          ff=r**2*(1 + r)*&
               (3 + 12*r + 13*r**2) - &
               16*r**2*(1 + r)*(1 + 3*r)*&
               y - 2*r*&
               (3 - 9*r - 21*r**2 + &
               7*r**3)*y**2 + &
               8*r*(4 + 3*r + 3*r**2)* &
               y**3 - &
               4*r*(9 - 3*r - 4*r**2)* &
               y**4 - &
               16*(1 + 3*r + 3*r**2)* &
               y**5 + 8*(6 + 7*r)*y**6 - &
               32*y**7
          ff=ff/(1-y)**2/(y-r)**2&
               /(y**2-r)**2
          gg=(1 - r)*r**3* &
               (3 + 24*r + 13*r**2) - &
               4*r**3*(7 - 3*r - 12*r**2)* &
               y - 2*r**3* &
               (17 + 22*r - 7*r**2)*y**2 &
               + 4*r**2* &
               (13 + 5*r - 6*r**2)*y**3 &
               - 8*r* &
               (1 + 2*r + 5*r**2 + &
               2*r**3)*y**4 - &
               8*r*(3 - 11*r - 6*r**2)* &
               y**5 + &
               8*(1 - 2*r - 5*r**2)*y**6
          gg=gg/(1-y)**2/(y-r)**2&
               /(y**2-r)**2
          gg=gg*((1 + r - 2*y)*&
               DLOG((-r + y + &
               DSqrt(-r + y**2))/&
               (-r + y - &
               DSqrt(-r + y**2))))/&
               (2D0*(-r + y)*&
               DSqrt(-r + y**2))
          fun_fg_g_3S11gg=ff+gg
       ELSE
          fun_fg_g_3S11gg=(8*(-23 + 65*DSqrt(r) - &
               90*r + 60*r**1.5D0))/ &
               (15D0*(-1 + DSqrt(r))**3*r)
       ENDIF
    CASE(1)
       IF(DABS(sr-y).GT.tiny)THEN
          ff=-2*r*(1 + 5*r + 19*r**2 + &
               7*r**3)*y + &
               96*r**2*(1 + r)*y**2 + &
               8*(1 - 5*r - 22*r**2 - &
               2*r**3)*y**3 + &
               16*r*(7 + 3*r)*y**4 - &
               8*(5 + 7*r)*y**5 + 32*y**6
          ff=ff/(1-y)**2/(y-r)**2&
               /(y**2-r)**2
          gg=-2*(1 - r)*r**2*(1 + r)* &
               (1 + 7*r)*y + &
               8*(1 - 4*r)*r**2*(1 + 3*r)* &
               y**2 + &
               4*r*(1 + 10*r + 57*r**2 + &
               4*r**3)*y**3 - &
               8*r*(1 + 29*r + 6*r**2)* &
               y**4 - &
               8*(1 - 8*r - 5*r**2)*y**5
          gg=gg/(1-y)**2/(y-r)**2&
               /(y**2-r)**2
          gg=gg*((1 + r - 2*y)*&
               DLOG((-r + y + &
               DSqrt(-r + y**2))/&
               (-r + y - &
               DSqrt(-r + y**2))))/&
               (2D0*(-r + y)*&
               DSqrt(-r + y**2))
          fun_fg_g_3S11gg=ff+gg
       ELSE
          fun_fg_g_3S11gg=(-16*(-3 + 5*DSqrt(r) - &
               15*r + 25*r**1.5D0))/ &
               (15D0*(-1 + DSqrt(r))**3* &
               r**1.5D0)
       ENDIF
    CASE(2)
       IF(DABS(sr-y).GT.tiny)THEN
          ff=r*(1 + 5*r + 19*r**2 + &
               7*r**3) - &
               48*r**2*(1 + r)*y - &
               4*(1 - 5*r - 22*r**2 - &
               2*r**3)*y**2 - &
               8*r*(7 + 3*r)*y**3 + &
               4*(5 + 7*r)*y**4 - 16*y**5
          ff=ff/(1-y)**2/(y-r)**2&
               /(y**2-r)**2
          gg=(1 - r)*r**2*(1 + r)* &
               (1 + 7*r) - &
               4*(1 - 4*r)*r**2*(1 + 3*r)* &
               y - 2*r* &
               (1 + 10*r + 57*r**2 + &
               4*r**3)*y**2 + &
               4*r*(1 + 29*r + 6*r**2)* &
               y**3 + &
               4*(1 - 8*r - 5*r**2)*y**4
          gg=gg/(1-y)**2/(y-r)**2&
               /(y**2-r)**2
          gg=gg*((1 + r - 2*y)*&
               DLOG((-r + y + &
               DSqrt(-r + y**2))/&
               (-r + y - &
               DSqrt(-r + y**2))))/&
               (2D0*(-r + y)*&
               DSqrt(-r + y**2))
          fun_fg_g_3S11gg=ff+gg
       ELSE
          fun_fg_g_3S11gg=(8*(-3 + 5*DSqrt(r) - &
               15*r + 25*r**1.5D0))/ &
               (15D0*(-1 + DSqrt(r))**3* &
               r**2)
       ENDIF
    CASE DEFAULT
       WRITE(*,*)"ERROR:Unknown i=",i
       STOP
    END SELECT
    RETURN
  END FUNCTION fun_fg_g_3S11gg

  FUNCTION ff_c_3S11c_ini(z,mu0,mpsi,R02)
    ! Eq.(16) in hep-ph/9302307
    USE ff_common
    IMPLICIT NONE
    REAL(KIND(1d0))::ff_c_3S11c_ini
    REAL(KIND(1d0)),INTENT(IN)::z,mu0,mpsi,R02
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
    REAL(KIND(1d0))::alp,ALP2PI
    IF(z.LE.0d0.OR.z.GE.1d0)THEN
       ff_c_3S11c_ini=0d0
       RETURN
    ENDIF
    CALL GETALP(DLOG(mu0**2),1,ALP2PI)
    alp=ALP2PI*2d0*pi
    ff_c_3S11c_ini=64d0/27d0/pi*alp**2*R02/mpsi**3
    ff_c_3S11c_ini=ff_c_3S11c_ini*z*(1d0-z)**2/(2d0-z)**6
    ff_c_3S11c_ini=ff_c_3S11c_ini*(16d0-32d0*z+72d0*z**2&
         -32d0*z**3+5d0*z**4)
    RETURN
  END FUNCTION ff_c_3S11c_ini

  FUNCTION ff_c_1S01c_ini(z,mu0,metac,R02)
    ! Eq.(20) in hep-ph/9302307
    USE ff_common
    IMPLICIT NONE
    REAL(KIND(1d0))::ff_c_1S01c_ini
    REAL(KIND(1d0)),INTENT(IN)::z,mu0,metac,R02
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
    REAL(KIND(1d0))::alp,ALP2PI
    IF(z.LE.0d0.OR.z.GE.1d0)THEN
       ff_c_1S01c_ini=0d0
       RETURN
    ENDIF
    CALL GETALP(DLOG(mu0**2),1,ALP2PI)
    alp=ALP2PI*2d0*pi
    ff_c_1S01c_ini=64d0/81d0/pi*alp**2*R02/metac**3
    ff_c_1S01c_ini=ff_c_1S01c_ini*z*(1d0-z)**2/(2d0-z)**6
    ff_c_1S01c_ini=ff_c_1S01c_ini*(48d0+8d0*z**2&
         -8d0*z**3+3d0*z**4)
    RETURN
  END FUNCTION ff_c_1S01c_ini

  FUNCTION ff_g_1S01g_ini(z,mu0,metac,R02)
    ! Eq.(7) in hep-ph/9303205
    USE ff_common
    IMPLICIT NONE
    REAL(KIND(1d0))::ff_g_1S01g_ini
    REAL(KIND(1d0)),INTENT(IN)::z,mu0,metac,R02
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
    REAL(KIND(1d0))::alp,ALP2PI
    IF(z.LE.0d0.OR.z.GE.1d0)THEN
       ff_g_1S01g_ini=0d0
       RETURN
    ENDIF
    CALL GETALP(DLOG(mu0**2),1,ALP2PI)
    alp=ALP2PI*2d0*pi
    ff_g_1S01g_ini=1d0/3d0/pi*alp**2*R02/metac**3
    ff_g_1S01g_ini=ff_g_1S01g_ini*(3d0*z-2d0*z**2+&
         2d0*(1d0-z)*DLOG(1d0-z))
    RETURN
  END FUNCTION ff_g_1S01g_ini

  FUNCTION ff_g_1S08g_ini(z,mu0,mpsi,LDME1S08)
    ! Eq.(A11) of arXiv:1406.2295
    ! check Eq.(C13) of arXiv:1311.7078
    USE ff_common
    IMPLICIT NONE
    REAL(KIND(1d0))::ff_g_1S08g_ini
    REAL(KIND(1d0)),INTENT(IN)::z,mu0,mpsi,LDME1S08
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
    REAL(KIND(1d0))::alp,ALP2PI
    REAL(KIND(1d0))::metac
    IF(z.LE.0d0.OR.z.GE.1d0)THEN
       ff_g_1S08g_ini=0d0
       RETURN
    ENDIF
    metac=mpsi
    CALL GETALP(DLOG(mu0**2),1,ALP2PI)
    alp=ALP2PI*2d0*pi
    ff_g_1S08g_ini=5d0/12d0*alp**2*LDME1S08/metac**3
    ff_g_1S08g_ini=ff_g_1S08g_ini*(3d0*z-2d0*z**2+&
         2d0*(1d0-z)*DLOG(1d0-z))
    RETURN
  END FUNCTION ff_g_1S08g_ini

  FUNCTION ff_g_3PJ8g_ini(z,mu0,mpsi,LDME3P08)
    ! 3PJ8 J=0,1,2 are summed over
    ! Eq.(A12) of arXiv:1406.2295
    USE ff_common
    IMPLICIT NONE
    REAL(KIND(1d0))::ff_g_3PJ8g_ini
    REAL(KIND(1d0)),INTENT(IN)::z,mu0,mpsi,LDME3P08
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
    REAL(KIND(1d0))::alp,ALP2PI
    IF(z.LE.0d0.OR.z.GE.1d0)THEN
       ff_g_3PJ8g_ini=0d0
       RETURN
    ENDIF
    CALL GETALP(DLOG(mu0**2),1,ALP2PI)
    alp=ALP2PI*2d0*pi
    ff_g_3PJ8g_ini=5d0/12d0*alp**2*LDME3P08*32d0/mpsi**5
    ! 1/(1-z) should be changed to 1d0/6d0*delta(1-z)+1/(1-z)_+
    ! see Eq.(A14) in arXiv:1406.2295
    ff_g_3PJ8g_ini=ff_g_3PJ8g_ini*((13d0-7d0*z)/4d0*DLOG(1d0-z)&
         -(1d0-2d0*z)*(8d0-5d0*z)/8d0+1d0/(1d0-z))
  END FUNCTION ff_g_3PJ8g_ini

  FUNCTION ff_g_3S18_ini(z,mu0,mpsi,LDME3S18)
    ! Eq.(A9) of arXiv:1406.2295
    USE ff_common
    IMPLICIT NONE
    REAL(KIND(1d0))::ff_g_3S18_ini
    REAL(KIND(1d0)),INTENT(IN)::z,mu0,mpsi,LDME3S18
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
    REAL(KIND(1d0))::alp,ALP2PI
    IF(z.LE.0d0.OR.z.GE.1d0)THEN
       ff_g_3S18_ini=0d0
       RETURN
    ENDIF
    CALL GETALP(DLOG(mu0**2),1,ALP2PI)
    alp=ALP2PI*2d0*pi
    ! the following should be a delta function delta(1-z)
    ! see Eq.(A14) in arXiv:1406.2295 
    ff_g_3S18_ini=1d0/3d0*pi*alp*LDME3S18/mpsi**3*0d0
  END FUNCTION ff_g_3S18_ini
END MODULE fragfun_onia_ini
