PROGRAM TEST
  USE fragfun_onia
  USE FF_INIT
  USE FF_DGLAP
  USE FF_DGLAP_GLOBAL
  IMPLICIT NONE
  INTEGER,PARAMETER::NSTEP=200
  CHARACTER(len=1)::Q2PROG_END
  CHARACTER(len=9)::Q2_OUT
  CHARACTER(len=26)::FNAME
  REAL(KIND(1d0)),DIMENSION(-5:5)::FF
  REAL(KIND(1d0)),DIMENSION(600)::Z
  REAL(KIND(1d0))::XMIN
  COMMON /XMIN/XMIN
  REAL(KIND(1d0))::Q2,DLMIN,ZLSTEP,DLOGZ
  INTEGER::I

  !FF_SET=2
  !FF_DGLAP_IORDER=1
  !FF_DGLAP_DLAM=0.22d0
  !FF_DGLAP_mc_HQTHRE=4.5d0
  !FF_DGLAP_mb_HQTHRE=1d9
  !FF_DGLAP_Q2min=3D0**2
  !FF_DGLAP_Q2max=500D0**2
  !FF_DGLAP_XMIN=1D-2
  !CALL FF_DGLAP_EVOL() ! Making arrary of FF(XMIN:1.D0, Q2_ini:Q2_max)
  
200 WRITE(*,fmt='(a)') "Q^2= "
  READ(*,*) Q2
      
  WRITE(Q2_OUT,'(1PE9.3)') Q2
  FNAME='Q2='//Q2_OUT//'_GeV2_f90.dat'
  OPEN(unit=2322,file=FNAME,FORM='formatted')

  XMIN=1D-2
  DLMIN=DLOG10(XMIN)
  ZLSTEP=(DLOG10(1.D0)-DLMIN)/DBLE(NSTEP)
  DO I=1,NSTEP+1
     DLOGZ=DBLE(I-1)*ZLSTEP+DLMIN
     Z(I)=10.D0**(DLOGZ)
  END DO

  ! FOR pi^+, FF(I), I= 0:g, 1:d, 2:u, 3:s, 4:c, 5:b
  DO I=1,NSTEP

     CALL GETFF_1S01(Q2,Z(I),FF,1) ! Getting FF(Z,Q^2)
     !CALL GETFF(Q2,Z(I),FF)
     
     WRITE(2322,1010) Z(I), Z(I)*FF(0), & 
          Z(I)*FF(2), & 
          Z(I)*FF(1), &
          Z(I)*FF(3), &
          Z(I)*FF(4), &
          Z(I)*FF(5)
  END DO
      
  WRITE(*,fmt='(a)') & 
       "Do you finish the FF Q2 evolution ? (y/n) "     
  READ(*,*) Q2PROG_END
  IF((Q2PROG_END(1:1).EQ.'n').OR.(Q2PROG_END(1:1).EQ.'N')) GOTO 200
  
1010 FORMAT(1X,9(1PE16.7))
  CLOSE(2322)
END PROGRAM TEST
