PROGRAM test_DPS_AB
  USE nucleus_transverse_profile
  USE OpticalGlauber_Geometry
  IMPLICIT NONE
  REAL(KIND(1d0)),DIMENSION(2)::Rval_list,Aval_list,aaVal_list,wVal_list
  REAL(KIND(1d0))::db,bval,Rval,Aval,Zval,aaVal,wVal,r0,mg
  INTEGER::I,nsteps
  REAL(KIND(1d0))::TAVal,TnAValHS,TnAValD
  nuclear_dir="./"
  CALL GetNuclearInfo('Pb208  ',Aval,Zval,Rval,aaval,wval)
  r0=0.529d0
  mg=1d0/0.13d0
  nsteps=1000
  db=3d0*Rval/DBLE(nsteps)
  OPEN(UNIT=2056,FILE='TnAhat_TAhat_WS_Pb208_sigmaeff15.dat')
  DO I=0,nsteps
     bval=db*I
     TAVal=TAhat_WoodsSaxon(bval,0d0,Rval,wval,aaval,Aval,1)
     TnAvalHS=TnAhat_WoodsSaxon_hardsphere(bval,0d0,Rval,wval,aaval,Aval,r0)
     TnAvalD=TnAhat_WoodsSaxon_dipole(bval,0d0,Rval,wval,aaval,Aval,mg)
     WRITE(2056,*)bval,TAval,TnAvalHS,TnAvalD
  ENDDO
  CLOSE(UNIT=2056)

  OPEN(UNIT=2056,FILE='TnAhat_TAhat_HS_Pb208_sigmaeff15.dat')
  DO I=0,nsteps
     bval=db*I
     TAVal=TAhat_hardsphere(bval,0d0,Rval)
     TnAvalHS=TnAhat_HardSphere_hardsphere(bval,0d0,Rval,r0)
     TnAvalD=TnAhat_HardSphere_dipole(bval,0d0,Rval,mg)
     WRITE(2056,*)bval,TAval,TnAvalHS,TnAvalD
  ENDDO
  CLOSE(UNIT=2056)
  
END PROGRAM test_DPS_AB
