PROGRAM test_Glauber
  USE OpticalGlauber_Geometry
  IMPLICIT NONE
  INTEGER::N,I
  REAL(KIND(1d0))::Nw,dNw,epsbar,Dval,mu,sigma,energy
  REAL(KIND(1d0))::sigma_inel,db,bval,Rval,Aval,Zval,aaVal,wVal
  REAL(KIND(1d0)),DIMENSION(2)::Rval_list,Aval_list,aaVal_list,wVal_list
  INTEGER::nsteps,nc,nb
  REAL(KIND(1d0)),DIMENSION(20,2)::cbins,bbins
  REAL(KIND(1d0)),DIMENSION(20,20)::wmat
  REAL(KIND(1d0)),DIMENSION(0:20)::rerere
  REAL(KIND(1d0))::npart_hs,npart_ws, ncoll_hs, ncoll_ws,bmin,bmax
  REAL(KIND(1d0)),DIMENSION(2)::R_common,w_common,aa_common,A_common
  REAL(KIND(1d0))::sigmainel_common
  COMMON/SigmaInel_WoodsSaxon/R_common,w_common,aa_common,A_common,sigmainel_common
  nuclear_dir="./"
  CALL GetCentralityImpactB(nc,nb,cbins,bbins,wmat)
  CALL CalculateTAhatTBhat_WoodsSaxon_centrality('Au197  ','Au197  ',nb,bbins(1:nb,1:2),rerere(0:nb))
  DO i=1,nc
     PRINT *, cbins(i,1),cbins(i,2),rerere(i)
  ENDDO
  RETURN
  CALL GetCentralityImpactB(nc,nb,cbins,bbins,wmat)
  CALL GetNuclearInfo('Au197  ',Aval,Zval,Rval,aaval,wval)
  Rval_list(1:2)=Rval
  Aval_list(1:2)=Aval
  aaVal_list(1:2)=aaVal
  wVal_list(1:2)=wVal
  energy=200d0
  sigma=sigma_inelastic(energy) ! in unit of mb
  OPEN(UNIT=2056,FILE='Npart_Ncoll_avg.dat')
  DO i=1,nb
     bmin=bbins(i,1)
     bmax=bbins(i,2)
     npart_ws=Npart_avg_WoodsSaxon(bmin,bmax,Rval_list,wval_list,aaval_list,Aval_list,sigma)
     ncoll_ws=Ncoll_avg_WoodsSaxon(bmin,bmax,Rval_list,wval_list,aaval_list,Aval_list,sigma)
     WRITE(2056,*)cbins(i,1),cbins(i,2),bbins(i,1),bbins(i,2),npart_ws,ncoll_ws
  ENDDO
  CLOSE(UNIT=2056)
  RETURN
  nsteps=100
  energy=200d0 ! in unit of GeV
  CALL GetNuclearInfo('Au197  ',Aval,Zval,Rval,aaval,wval)
  sigmainel_common=sigma_inelastic(energy) ! in unit of mb
  sigmainel_common=sigmainel_common*1D-1 ! from mb to fm^2
  ! two beams are same
  R_common(1:2)=Rval
  A_common(1:2)=Aval
  aa_common(1:2)=aaVal
  w_common(1:2)=wVal
  db=20d0/DBLE(nsteps)
  OPEN(UNIT=2056,FILE='dsigmadb.dat')
  DO I=0,nsteps
     bval=db*I
     sigma=SigmaInelAB_fxn_WoodsSaxon(bval) ! in unit of fm
     ! 1mb/fm = 0.1 fm, 1barn/fm = 1e2 fm, 1fm=1e-2 barn/fm
     sigma=sigma*1d-2 ! from fm to barn/fm
     WRITE(2056,*)bval,sigma
  ENDDO
  CLOSE(UNIT=2056)
  RETURN
  nsteps=1000
  db=4D0/DBLE(nsteps)
  OPEN(UNIT=2056,FILE='sigmainel.dat')
  DO I=0,nsteps
     energy=10D0**(db*I+1D0)
     sigma_inel=sigma_inelastic(energy)
     WRITE(2056,*)energy,sigma_inel
  ENDDO
  CLOSE(UNIT=2056)
  RETURN
  nsteps=1000
  sigma_inel=31.5d0 ! 31.5 mb (7 to 60 GeV)
  Rval=6.62d0 ! in unit of fm
  Aval=207d0 !  in unit of 1, nuclear A number
  aaVal=0.546d0 ! skin thickness, in unit of fm
  wVal=0d0 ! in unit of fm
  Rval_list(1:2)=Rval
  Aval_list(1:2)=Aval
  aaVal_list(1:2)=aaVal
  wVal_list(1:2)=wVal
  db=15d0/DBLE(nsteps)
  OPEN(UNIT=2056,FILE='Ncoll_Npart_test.dat')
  DO I=0,nsteps
     bval=db*I
     npart_hs=Npart_hardsphere(bval,0d0,Rval_list,Aval_list, sigma_inel)
     npart_ws=Npart_WoodsSaxon(bval,0d0,Rval_list,wVal_list,aaVal_list,Aval_list,sigma_inel)
     ncoll_hs=Ncoll_hardsphere(bval,0d0,Rval_list,Aval_list,sigma_inel)
     ncoll_ws=Ncoll_WoodsSaxon(bval,0d0,Rval_list,wval_list,aaVal_list,Aval_list,sigma_inel)
     WRITE(2056,*)bval, npart_hs, npart_ws, ncoll_hs, ncoll_ws
  ENDDO
  CLOSE(UNIT=2056)
END PROGRAM test_Glauber
