PROGRAM test_PhotonFlux
  USE ElasticPhotonPhotonFlux
  USE OpticalGlauber_Geometry
  USE Helac_Global
  USE photon_PDFs
  IMPLICIT NONE
  INTEGER::I
  REAL(KIND(1d0))::x1,x2
  REAL(KIND(1d0))::flux0,flux1,flux2,flux3,flux4,flux5,flux6,flux7,flux8,flux9
  REAL(KIND(1d0))::gamma1,gamma2
  REAL(KIND(1d0)),PARAMETER::mproton=0.938272081d0 ! the mass of proton (GeV) 
  REAL(KIND(1d0)),PARAMETER::mN=0.9315d0 ! average nucleaon mass in nuclei (GeV)
  REAL(KIND(1d0)),PARAMETER::mchic=3.55d0
  REAL(KIND(1d0))::cmsenergy,tau,dy,ychic,ymin,ymax
  INTEGER::nybin
  REAL(KIND(1d0))::mass0,mass1,mass2,mass3,mass4,mass5,mass6,mass7,mass8,mass9
  REAL(KIND(1d0))::dM
  REAL(KIND(1d0))::width0,width1,width2,width3,width4,width5,width6,width7,width8,width9
  INTEGER::J0,J1,J2,J3,J4,J5,J6,J7,J8,J9
  REAL(KIND(1d0))::br0,br1,br2,br3,br4,br5,br6,br7,br8,br9,q2max
  REAL(KIND(1d0)),PARAMETER::convfac=3.8938573d5 ! from GeV-2 to nb
  REAL(KIND(1d0)),PARAMETER::FOURPI2=39.4784176043574344753379639995d0
  REAL(KIND(1d0)),PARAMETER::pipipi=3.14159265358979323846264338328d0
  REAL(KIND(1d0))::Nphoton,bb,bb2,gagam
  INTEGER::nsteps
  REAL(KIND(1d0)),EXTERNAL::ZEROJP
  REAL(KIND(1d0)),DIMENSION(2)::RR2,w2,aa2,A2
  REAL(KIND(1d0))::sigmaNN
  !USE_CHARGEFORMFACTOR4PHOTON=.FALSE. ! use charge form factor for photon density
  !alphaem_elasticphoton=0.0072992700729927005d0
  !ebeam(1)=1.89d0
  !ebeam(2)=1.89d0
  !dM=4d0*ebeam(1)*ebeam(2)
  !sigmaNN=e2eLL_electron(5d-1,103.78d0**2,1,1d0)
  !x1=5d-2
  !mass0=DSQRT(x1*dM)
  !sigmaNN=LeeLL_ISR_EMEP(mass0,1,1d0)
  !PRINT *, sigmaNN
  !sigmaNN=e2eLL_electron(x1,dM,1,2d0)
  !PRINT *, sigmaNN
  !RETURN
  !nuclear_dir="./"
  !sigmaNN_inelastic_eval=1 ! use DdE parameterisation (2011.14909)
  !nuclearA_beam1=208
  !nuclearA_beam2=208
  !nuclearZ_beam1=82
  !nuclearZ_beam2=82
  !ebeam(1)=2760d0
  !ebeam(2)=2760d0
  !sigmaNN=PhotonPhotonFlux_AB_WoodsSaxon_eval(1D-3,2D-3,.FALSE.)
  !PRINT *, sigmaNN
  !RETURN
  !RR2(1:2)=6.6239999999999997d0
  !w2(1:2)=0d0
  !aa2(1:2)=0.54900000000000004d0
  !A2(1:2)=208d0
  !sigmaNN=6.8108263162010649 ! in unit of fm^2
  !OPEN(UNIT=1033,FILE="/Users/huasheng/Physics/FLibatM/spin/grids/PNOHAD_PbPb.dat")
  !nsteps=200
  !DO i=0,nsteps
  !   bb=DBLE(i)/DBLE(nsteps)*30d0
  !   bb2=PNOHAD_AB_WoodsSaxon(bb,0d0,RR2,w2,aa2,A2,sigmaNN)
  !   WRITE(1033,*)bb,bb2
  !ENDDO
  !CLOSE(UNIT=1033)
  !RETURN
  !OPEN(UNIT=1033,FILE="/Users/huasheng/Physics/FLibatM/spin/grids/photonnumberdensity_proton_4.dat")
  !nsteps=200
  !DO i=0,nsteps
  !   bb=DBLE(i)/DBLE(nsteps)*30d0
  !   bb2=bb/0.1973d0 ! from fm to GeV-1
  !   !Nphoton=PhotonNumberDensity_ChargeFormFactor_proton(bb2,1d2,2675.13d0)
  !   Nphoton=PhotonNumberDensity_ChargeFormFactor_proton(bb2,2d1,106.579d0)
  !   Nphoton=Nphoton/137.0d0/0.1973d0**2
  !   WRITE(1033,*)bb,Nphoton
  !ENDDO
  !CLOSE(UNIT=1033)
  !RETURN
  !OPEN(UNIT=1033,FILE="/Users/huasheng/Physics/FLibatM/spin/grids/photonnumberdensity_WS_5.dat")
  !OPEN(UNIT=1034,FILE="/Users/huasheng/Physics/FLibatM/spin/grids/photonnumberdensity_WS_6.dat")
  !nsteps=200
  !DO i=0,nsteps
  !   bb=DBLE(i)/DBLE(nsteps)*30d0
  !   bb2=bb/0.1973d0 ! from fm to GeV-1
  !   Nphoton=PhotonNumberDensity_ChargeFormFactor_WS(bb2,2181.6d0,2962.96d0,&
  !        33.5732d0,0d0,2.78256d0,3d0,0.7d0,1,1)
     !Nphoton=PhotonNumberDensity_ChargeFormFactor_WS(bb2,1d2,2694.58d0,&                                                                                                    
     !     33.5732d0,0d0,2.78256d0,5d0,0.7d0,1,-1)
     !Nphoton=PhotonNumberDensity_ChargeFormFactor_WS(bb2,2d1,106.579d0,&
     !     33.5732d0,0d0,2.78256d0,5d0,0.7d0,1,-1)
  !   Nphoton=Nphoton*82d0**2/137.0d0/0.1973d0**2
  !   WRITE(1033,*)bb,Nphoton
  !   Nphoton=PhotonNumberDensity_ChargeFormFactor_WS(bb2,1.44418d-3,2962.96d0,&
  !        33.5732d0,0d0,2.78256d0,3d0,0.7d0,1,1)
  !   Nphoton=Nphoton*82d0**2/137.0d0/0.1973d0**2
  !   WRITE(1034,*)bb,Nphoton
  !ENDDO
  !CLOSE(UNIT=1033)
  !CLOSE(UNIT=1034)
  !RETURN
  !alphaem_elasticphoton=0.0072992700729927005d0
  !nuclearA_beam1=0
  !nuclearA_beam2=0
  !nuclearZ_beam1=0
  !nuclearZ_beam2=0
  ! BES III (see 1912.05983)
  !ebeam(1)=1.89d0
  !ebeam(2)=1.89d0
  ! SuperKEKB (see Table 1 in 1809.01958)
  !ebeam(1)=4d0 ! e+
  !ebeam(2)=7.007d0 ! e-
  ! FCC-ee
  !ebeam(1)=45.6d0
  !ebeam(2)=45.6d0
  ! fake pp 14 TeV (using epa_proton, need to change dLgammagammadW_EMEP)
  !ebeam(1)=7000d0
  !ebeam(2)=7000d0
  ! fake pp 100 TeV (using epa_proton, need to change dLgammagammadW_EMEP)
  !ebeam(1)=50000d0
  !ebeam(2)=50000d0
  !q2max=1d0 ! 1 GeV^2
  !mass0=3.553696d0   ! tau onium
  !mass1=2.9839d0 ! etac(1S)
  !mass2=3.6375d0 ! etac(2S)
  !mass3=3.41471d0 ! chi_c0
  !mass4=3.55617d0 ! chi_c2
  !mass5=9.3987d0  ! etab(1S)
  !mass6=9.999d0   ! etab(2S)
  !mass7=9.85944d0 ! chi_b0
  !mass8=9.91221d0 ! chi_b2
  !mass9=125.25d0     ! Higgs
  ! e+e-
  !flux0=dLgammagammadW_EMEP(mass0,q2max)
  !flux1=dLgammagammadW_EMEP(mass1,q2max)
  !flux2=dLgammagammadW_EMEP(mass2,q2max)
  !flux3=dLgammagammadW_EMEP(mass3,q2max)
  !flux4=dLgammagammadW_EMEP(mass4,q2max)
  !flux5=dLgammagammadW_EMEP(mass5,q2max)
  !flux6=dLgammagammadW_EMEP(mass6,q2max)
  !flux7=dLgammagammadW_EMEP(mass7,q2max)
  !flux8=dLgammagammadW_EMEP(mass8,q2max)
  !flux9=dLgammagammadW_EMEP(mass9,q2max)

  !PRINT *, "tauonium     etac(1S)     etac(2S)     chic0     chic2      etab(1S)        etab(2S)        chib0       chib2       H"
  !PRINT *, "dL/dW [GeV-1]"
  !PRINT *, flux0,flux1,flux2,flux3,flux4,flux5,flux6

  ! total width [GeV]
  !width0=2.28d-11 ! tau onium
  !width1=0.032d0  ! etac(1S)
  !width2=0.0113d0 ! etac(2S)
  !width3=0.0108d0 ! chi_c0
  !width4=0.00197d0 ! chi_c2
  !width5=0.010d0 ! etab(1S) (large uncertainty from pdg)
  !width6=0.005d0  ! etab(2S) from rescaling of etab(1S)
  !width7=0.00260d0 ! chi_b0 (from 1802.04938)
  !width8=0.000180d0 ! chi_b2 (from 1802.04938)
  ! from https://twiki.cern.ch/twiki/bin/view/LHCPhysics/CERNYellowReportPageBR
  !width9=4.115d-3 ! Higgs
  ! branching fraction to diphoton
  !br0=0.801d0 ! tau onium
  !br1=1.58d-4 ! etac(1S)
  !br2=1.9d-4 ! etac(2S)
  !br3=2.04d-4 ! chi_c0
  !br4=2.85d-4 ! chi_c2
  !br5=4.8d-5    ! etab(1S) from 1707.05758
  !br6=4.8d-5    ! etab(2S) from rescaling of etab(1S)
  !br7=5.8d-5    ! chi_b0 (from 1802.04938)
  !br8=5.2d-5    ! chi_b2 (from 1802.04938)
  !br9=2.270d-3 !Higgs
  ! spin
  !J0=0
  !J1=0
  !J2=0
  !J3=0
  !J4=2
  !J5=0
  !J6=0
  !J7=0
  !J8=2
  !J9=0
  ! cross sections [nb]
  !flux0=FOURPI2*DBLE(2*J0+1)*br0**2*width0/mass0**2*convfac*flux0
  !flux1=FOURPI2*DBLE(2*J1+1)*br1**2*width1/mass1**2*convfac*flux1
  !flux2=FOURPI2*DBLE(2*J2+1)*br2**2*width2/mass2**2*convfac*flux2
  !flux3=FOURPI2*DBLE(2*J3+1)*br3**2*width3/mass3**2*convfac*flux3
  !flux4=FOURPI2*DBLE(2*J4+1)*br4**2*width4/mass4**2*convfac*flux4
  !flux5=FOURPI2*DBLE(2*J5+1)*br5**2*width5/mass5**2*convfac*flux5
  !flux6=FOURPI2*DBLE(2*J6+1)*br6**2*width6/mass6**2*convfac*flux6
  !flux7=FOURPI2*DBLE(2*J7+1)*br7**2*width7/mass7**2*convfac*flux7
  !flux8=FOURPI2*DBLE(2*J8+1)*br8**2*width8/mass8**2*convfac*flux8
  !flux9=FOURPI2*DBLE(2*J9+1)*br9**2*width9/mass9**2*convfac*flux9

  !PRINT *, "cross section*Br [nb]"
  !PRINT *, flux0,flux1,flux2,flux3,flux4,flux5,flux6,flux7,flux8,flux9
  !PRINT *, "cross section [nb]"
  !PRINT *, flux0/br0,flux1/br1,flux2/br2,flux3/br3,flux4/br4,flux5/br5,flux6/br6,flux7/br7,flux8/br8,flux9/br9

  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/EMEP3.8GeV_dLdW_M_Q2MAX1GeV2.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/EMEP10.6GeV_dLdW_M_Q2MAX1GeV2.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/EMEP90GeV_dLdW_M_Q2MAX1GeV2.dat")
  !dM=0.2d0
  !DO I=5,450
  !dM=0.1d0
  !DO I=1,105
  !dM=0.1d0
  !DO I=1,37
  !   mass1=dM*DBLE(I)
  !   flux1=dLgammagammadW_EMEP(mass1,q2max)
  !   WRITE(20344,*)mass1,flux1
  !ENDDO
  !CLOSE(UNIT=20344)

  !RETURN
  !USE_CHARGEFORMFACTOR4PHOTON=.TRUE. ! use charge form factor for photon density
  alphaem_elasticphoton=0.0072992700729927005d0
  nuclear_dir="./"
  sigmaNN_inelastic_eval=1 ! use DdE parameterisation (2011.14909)
  ! PbPb 39.4 TeV
  !nuclearA_beam1=208
  !nuclearA_beam2=208
  !nuclearZ_beam1=82
  !nuclearZ_beam2=82
  !ebeam(1)=19700d0
  !ebeam(2)=19700d0
  ! OO
  !nuclearA_beam1=16
  !nuclearA_beam2=16
  !nuclearZ_beam1=8
  !nuclearZ_beam2=8
  !ebeam(1)=3500d0
  !ebeam(2)=3500d0
  ! CaCa
  !nuclearA_beam1=40
  !nuclearA_beam2=40
  !nuclearZ_beam1=20
  !nuclearZ_beam2=20
  !ebeam(1)=3500d0
  !ebeam(2)=3500d0
  ! ArAr
  !nuclearA_beam1=40
  !nuclearA_beam2=40
  !nuclearZ_beam1=18
  !nuclearZ_beam2=18
  !ebeam(1)=3150d0
  !ebeam(2)=3150d0
  ! KrKr
  !nuclearA_beam1=78
  !nuclearA_beam2=78
  !nuclearZ_beam1=36
  !nuclearZ_beam2=36
  !ebeam(1)=3230d0
  !ebeam(2)=3230d0
  ! XeXe
  !nuclearA_beam1=129
  !nuclearA_beam2=129
  !nuclearZ_beam1=54
  !nuclearZ_beam2=54
  !ebeam(1)=2930d0
  !ebeam(2)=2930d0
  ! PbPb 5.52 TeV
  !nuclearA_beam1=208
  !nuclearA_beam2=208
  !nuclearZ_beam1=82
  !nuclearZ_beam2=82
  !ebeam(1)=2760d0
  !ebeam(2)=2760d0
  ! pPb 8.8 TeV
  !nuclearA_beam1=0
  !nuclearA_beam2=208
  !nuclearZ_beam1=0
  !nuclearZ_beam2=82
  !ebeam(1)=7000d0
  !ebeam(2)=2760d0
  ! pPb 62.8 TeV
  !nuclearA_beam1=0
  !nuclearA_beam2=208
  !nuclearZ_beam1=0
  !nuclearZ_beam2=82
  !ebeam(1)=50000d0
  !ebeam(2)=19700d0
  ! pp 14 TeV
  nuclearA_beam1=0
  nuclearA_beam2=0
  nuclearZ_beam1=0
  nuclearZ_beam2=0
  ebeam(1)=7000d0
  ebeam(2)=7000d0
  ! pp 100 TeV
  !nuclearA_beam1=0
  !nuclearA_beam2=0
  !nuclearZ_beam1=0
  !nuclearZ_beam2=0
  !ebeam(1)=50000d0
  !ebeam(2)=50000d0
  mass0=3.553696d0   ! tau onium
  mass1=2.9839d0 ! etac(1S)
  mass2=3.6375d0 ! etac(2S)
  mass3=3.41471d0 ! chi_c0
  mass4=3.55617d0 ! chi_c2
  mass5=9.3987d0  ! etab(1S)
  mass6=9.999d0   ! etab(2S)
  mass7=9.85944d0 ! chi_b0
  mass8=9.91221d0 ! chi_b2
  mass9=125.25d0     ! Higgs
  ! PbPb, XeXe, KrKr, ArAr, CaCa, OO
  !flux0=dLgammagammadW_UPC(mass0,3,1)
  !flux1=dLgammagammadW_UPC(mass1,3,1)
  !flux2=dLgammagammadW_UPC(mass2,3,1)
  !flux3=dLgammagammadW_UPC(mass3,3,1)
  !flux4=dLgammagammadW_UPC(mass4,3,1)
  !flux5=dLgammagammadW_UPC(mass5,3,1)
  !flux6=dLgammagammadW_UPC(mass6,3,1)
  !flux7=dLgammagammadW_UPC(mass7,3,1)
  !flux8=dLgammagammadW_UPC(mass8,3,1)
  !flux9=dLgammagammadW_UPC(mass9,3,1)
  ! pPb
  !flux0=dLgammagammadW_UPC(mass0,2,1)
  !flux1=dLgammagammadW_UPC(mass1,2,1)
  !flux2=dLgammagammadW_UPC(mass2,2,1)
  !flux3=dLgammagammadW_UPC(mass3,2,1)
  !flux4=dLgammagammadW_UPC(mass4,2,1)
  !flux5=dLgammagammadW_UPC(mass5,2,1)
  !flux6=dLgammagammadW_UPC(mass6,2,1)
  !flux7=dLgammagammadW_UPC(mass7,2,1)
  !flux8=dLgammagammadW_UPC(mass8,2,1)
  !flux9=dLgammagammadW_UPC(mass9,2,1)
  ! pp
  flux0=dLgammagammadW_UPC(mass0,1,1)
  flux1=dLgammagammadW_UPC(mass1,1,1)
  flux2=dLgammagammadW_UPC(mass2,1,1)
  flux3=dLgammagammadW_UPC(mass3,1,1)
  flux4=dLgammagammadW_UPC(mass4,1,1)
  flux5=dLgammagammadW_UPC(mass5,1,1)
  flux6=dLgammagammadW_UPC(mass6,1,1)
  flux7=dLgammagammadW_UPC(mass7,1,1)
  flux8=dLgammagammadW_UPC(mass8,1,1)
  flux9=dLgammagammadW_UPC(mass9,1,1)
  ! pp, PNOHAD=1 (only work for EDFF)
  !flux0=dLgammagammadW_UPC(mass0,1,0)
  !flux1=dLgammagammadW_UPC(mass1,1,0)
  !flux2=dLgammagammadW_UPC(mass2,1,0)
  !flux3=dLgammagammadW_UPC(mass3,1,0)
  !flux4=dLgammagammadW_UPC(mass4,1,0)
  !flux5=dLgammagammadW_UPC(mass5,1,0)
  !flux6=dLgammagammadW_UPC(mass6,1,0)
  !flux7=dLgammagammadW_UPC(mass7,1,0)
  !flux8=dLgammagammadW_UPC(mass8,1,0)
  !flux9=dLgammagammadW_UPC(mass9,1,0)

  PRINT *, "tauonium     etac(1S)     etac(2S)     chic0     chic2      etab(1S)    etab(2S)       chib0        chib2        H"
  PRINT *, "dL/dW [GeV-1]"
  PRINT *, flux0,flux1,flux2,flux3,flux4,flux5,flux6,flux7,flux8,flux9

  ! total width [GeV]
  width0=2.28d-11 ! tau onium
  width1=0.032d0  ! etac(1S)
  width2=0.0113d0 ! etac(2S)
  width3=0.0108d0 ! chi_c0
  width4=0.00197d0 ! chi_c2
  width5=0.010d0 ! etab(1S)
  width6=0.005d0  ! etab(2S) from rescaling of etab(1S)
  width7=0.00260d0 ! chi_b0 (from 1802.04938)
  width8=0.000180d0 ! chi_b2 (from 1802.04938)
  ! from https://twiki.cern.ch/twiki/bin/view/LHCPhysics/CERNYellowReportPageBR
  width9=4.115d-3 ! Higgs
  ! branching fraction to diphoton
  br0=0.801d0 ! tau onium
  br1=1.58d-4 ! etac(1S)
  br2=1.9d-4 ! etac(2S)
  br3=2.04d-4 ! chi_c0
  br4=2.85d-4 ! chi_c2
  br5=4.8d-5    ! etab(1S)
  br6=4.8d-5    ! etab(2S) from rescaling of etab(1S)
  br7=5.8d-5    ! chi_b0 (from 1802.04938)
  br8=5.2d-5    ! chi_b2 (from 1802.04938)
  br9=2.270d-3 !Higgs
  ! spin
  J0=0
  J1=0
  J2=0
  J3=0
  J4=2
  J5=0
  J6=0
  J7=0
  J8=2
  J9=0

  ! cross sections [nb]
  flux0=FOURPI2*DBLE(2*J0+1)*br0**2*width0/mass0**2*convfac*flux0
  flux1=FOURPI2*DBLE(2*J1+1)*br1**2*width1/mass1**2*convfac*flux1
  flux2=FOURPI2*DBLE(2*J2+1)*br2**2*width2/mass2**2*convfac*flux2
  flux3=FOURPI2*DBLE(2*J3+1)*br3**2*width3/mass3**2*convfac*flux3
  flux4=FOURPI2*DBLE(2*J4+1)*br4**2*width4/mass4**2*convfac*flux4
  flux5=FOURPI2*DBLE(2*J5+1)*br5**2*width5/mass5**2*convfac*flux5
  flux6=FOURPI2*DBLE(2*J6+1)*br6**2*width6/mass6**2*convfac*flux6
  flux7=FOURPI2*DBLE(2*J7+1)*br7**2*width7/mass7**2*convfac*flux7
  flux8=FOURPI2*DBLE(2*J8+1)*br8**2*width8/mass8**2*convfac*flux8
  flux9=FOURPI2*DBLE(2*J9+1)*br9**2*width9/mass9**2*convfac*flux9

  PRINT *, "cross section*Br [nb]"
  PRINT *, flux0,flux1,flux2,flux3,flux4,flux5,flux6,flux7,flux8,flux9
  PRINT *, "cross section [nb]"
  PRINT *, flux0/br0,flux1/br1,flux2/br2,flux3/br3,flux4/br4,&
       flux5/br5,flux6/br6,flux7/br7,flux8/br8,flux9/br9

  !RETURN

  ! for axion mass scan
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pp14TeV_AxionXS_M_CFF.dat")
  OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pp14TeV_AxionXS_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pPb8.8TeV_AxionXS_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pPb8.8TeV_AxionXS_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/PbPb5.5TeV_AxionXS_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/PbPb5.5TeV_AxionXS_M.dat")
  J1=0
  br1=1d0
  gagam=1d-4 ! in unit of GeV-1
  ! for pp
  dM=1d0
  DO I=1, 10000
  ! for others
  !dM=0.2d0
  !DO I=5,1000
     mass1=dM*DBLE(I)
     width1=gagam**2*mass1**3/(64d0*pipipi)
  !   ! PbPb, XeXe, KrKr, ArAr, CaCa, OO
  !   !flux1=dLgammagammadW_UPC(mass1,3,1)
  !   ! pPb
  !   !flux1=dLgammagammadW_UPC(mass1,2,1)
     ! pp
     flux1=dLgammagammadW_UPC(mass1,1,1)
     flux1=FOURPI2*DBLE(2*J1+1)*br1**2*width1/mass1**2*convfac*flux1
     WRITE(20344,*)mass1,flux1
  ENDDO
  CLOSE(UNIT=20344)

  ! for graviton mass scan
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pp14TeV_GravitonXS_M_CFF.dat")
  OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pp14TeV_GravitonXS_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pPb8.8TeV_GravitonXS_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pPb8.8TeV_GravitonXS_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/PbPb5.5TeV_GravitonXS_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/PbPb5.5TeV_GravitonXS_M.dat")
  J1=2
  br1=1d0
  gagam=1d-3 ! in unit of GeV-1 (this is kappa/Lambda)
  dM=1d0
  DO I=1,10000
  ! for others
  !DO I=1,2000
     mass1=dM*DBLE(I)
     width1=gagam**2*mass1**3/(80d0*pipipi)
     ! PbPb, XeXe, KrKr, ArAr, CaCa, OO
     !flux1=dLgammagammadW_UPC(mass1,3,1)
     ! pPb
     !flux1=dLgammagammadW_UPC(mass1,2,1)
     ! pp
     flux1=dLgammagammadW_UPC(mass1,1,1)
     flux1=FOURPI2*DBLE(2*J1+1)*br1**2*width1/mass1**2*convfac*flux1
     WRITE(20344,*)mass1,flux1
  ENDDO
  CLOSE(UNIT=20344)

  RETURN

  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/PbPb5.5TeV_dLdW_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/PbPb5.5TeV_dLdW_M_PNOHAD1.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/PbPb5.5TeV_dLdW_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/XeXe5.86TeV_dLdW_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/XeXe5.86TeV_dLdW_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/KrKr6.46TeV_dLdW_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/KrKr6.46TeV_dLdW_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/ArAr6.3TeV_dLdW_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/ArAr6.3TeV_dLdW_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/CaCa7TeV_dLdW_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/CaCa7TeV_dLdW_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/OO7TeV_dLdW_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/OO7TeV_dLdW_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/PbPb39.4TeV_dLdW_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/PbPb39.4TeV_dLdW_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pPb62.8TeV_dLdW_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pPb62.8TeV_dLdW_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pPb8.8TeV_dLdW_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pPb8.8TeV_dLdW_M_PNOHAD1.dat") 
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pPb8.8TeV_dLdW_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pp14TeV_dLdW_M.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pp14TeV_dLdW_M_PNOHAD1.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pp14TeV_dLdW_M_CFF.dat")
  !OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pp100TeV_dLdW_M.dat")
  OPEN(UNIT=20344,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/pp100TeV_dLdW_M_CFF.dat") 
  dM=0.2d0
  DO I=5,1000
     mass1=dM*DBLE(I)
     ! PbPb,XeXe, KrKr, ArAr, CaCa, OO
     !flux1=dLgammagammadW_UPC(mass1,3,1)
     ! PbPb,XeXe, KrKr, ArAr, CaCa, OO with P_{NOHAD}=1
     !flux1=dLgammagammadW_UPC(mass1,3,0)
     ! PbPb,XeXe, KrKr, ArAr, CaCa, OO with Charge Form Factor
     !USE_CHARGEFORMFACTOR4PHOTON=.TRUE.
     !flux1=dLgammagammadW_UPC(mass1,3,1)
     ! pPb
     !flux1=dLgammagammadW_UPC(mass1,2,1)
     ! pPb with P_{NOHAD}=1
     !flux1=dLgammagammadW_UPC(mass1,2,0)
     ! pPb with Charge Form Factor
     !USE_CHARGEFORMFACTOR4PHOTON=.TRUE.
     !flux1=dLgammagammadW_UPC(mass1,2,1)
     ! pp
     !flux1=dLgammagammadW_UPC(mass1,1,1)
     ! pp with P_{NOHAD}=1
     !flux1=dLgammagammadW_UPC(mass1,1,0)
     ! pp with Charge Form Factor
     USE_CHARGEFORMFACTOR4PHOTON=.TRUE.
     flux1=dLgammagammadW_UPC(mass1,1,1)
     WRITE(20344,*)mass1,flux1
  ENDDO
  CLOSE(UNIT=20344)

  RETURN
  alphaem_elasticphoton=0.0072992701d0
  nuclear_dir="./"

  nuclearA_beam1=208
  nuclearA_beam2=208
  nuclearZ_beam1=82
  nuclearZ_beam2=82
  ebeam(1)=2510d0
  ebeam(2)=2510d0
  gamma1=ebeam(1)/mN
  gamma2=ebeam(2)/mN
  cmsenergy=2d0*DSQRT(ebeam(1)*ebeam(2))
  OPEN(UNIT=30244,FILE="/Users/huasheng/Physics/Plots/Test_Centrality/data_UPC_PhotonFlux/PbPb5TeV_PhotonFlux_Ychic.dat")
  tau=mchic**2/cmsenergy**2
  ymin=0.5d0*DLOG(tau)
  ymax=-ymin
  nybin=100
  dy=(ymax-ymin)/DBLE(nybin)
  WRITE(30244,*)"# Two photon in Pb+Pb UPCs at 5.02 TeV (PbPb->chic_c PbPb)"
  WRITE(30244,*)"# Y(chi_c) WoodsSaxon  HardSphere PNOHAD=1   PNOHAD=1(DdE)"
  DO I=0,nybin
     ychic=dy*I+ymin
     x1=DSQRT(tau)*DEXP(ychic)
     x2=DSQRT(tau)*DEXP(-ychic)
     flux1=PhotonPhotonFlux_AB_WoodsSaxon(x1,x2)
     flux2=PhotonPhotonFlux_AB_hardsphere(x1,x2)
     flux4=epa_ion(x1,82)
     flux4=flux4*epa_ion(x2,82)
     flux5=PhotonFlux_nucleus_nob(x1,gamma1,82d0,6.624d0)
     flux5=flux5*PhotonFlux_nucleus_nob(x2,gamma2,82d0,6.624d0)
     WRITE(30244,*)ychic, flux1, flux2, flux5, flux4
  ENDDO
  CLOSE(UNIT=30244)
  RETURN

  

  x1=0.5d0
  x1=0.1d0
  x2=3.5d-2
  flux1=PhotonPhotonFlux_AB_WoodsSaxon(x1,x2)
  flux2=PhotonPhotonFlux_AB_WoodsSaxon_eval(x1,x2)
  flux3=PhotonPhotonFlux_AB_hardsphere_eval(x1,x2)
  flux4=epa_ion(x1,82)
  flux4=flux4*epa_ion(x2,82)
  flux5=PhotonFlux_nucleus_nob(x1,gamma1,82d0,6.624d0)
  flux5=flux5*PhotonFlux_nucleus_nob(x2,gamma2,82d0,6.624d0)
  PRINT *, x1,x2,flux1,flux2,flux3,flux4,flux5

  x1=3.55d-4
  x2=2.47d-2
  flux1=PhotonPhotonFlux_AB_WoodsSaxon(x1,x2)
  flux2=PhotonPhotonFlux_AB_WoodsSaxon_eval(x1,x2)
  flux3=PhotonPhotonFlux_AB_hardsphere_eval(x1,x2)
  flux4=epa_ion(x1,82)
  flux4=flux4*epa_ion(x2,82)
  flux5=PhotonFlux_nucleus_nob(x1,gamma1,82d0,6.624d0)
  flux5=flux5*PhotonFlux_nucleus_nob(x2,gamma2,82d0,6.624d0)
  PRINT *, x1,x2,flux1,flux2,flux3,flux4,flux5

  RETURN
  nuclearA_beam1=0
  nuclearA_beam2=208
  nuclearZ_beam1=0
  nuclearZ_beam2=82
  ebeam(1)=2510d0
  ebeam(2)=2510d0
  gamma1=ebeam(1)/mproton
  gamma2=ebeam(2)/mN
  x1=0.5d0
  x2=3.5d-2
  flux1=PhotonPhotonFlux_pA_WoodsSaxon(x1,x2)
  flux2=PhotonPhotonFlux_pA_WoodsSaxon_eval(x1,x2)
  flux3=PhotonPhotonFlux_pA_hardsphere_eval(x1,x2)
  flux4=epa_ion(x1,1)
  flux4=flux4*epa_ion(x2,82)
  flux5=PhotonFlux_proton_nob(x1,gamma1)
  flux5=flux5*PhotonFlux_nucleus_nob(x2,gamma2,82d0,6.624d0)
  PRINT *, x1,x2,flux1,flux2,flux3,flux4,flux5

  x1=3.55d-4
  x2=2.47d-2
  flux1=PhotonPhotonFlux_pA_WoodsSaxon(x1,x2)
  flux2=PhotonPhotonFlux_pA_WoodsSaxon_eval(x1,x2)
  flux3=PhotonPhotonFlux_pA_hardsphere_eval(x1,x2)
  flux4=epa_ion(x1,1)
  flux4=flux4*epa_ion(x2,82)
  flux5=PhotonFlux_proton_nob(x1,gamma1)
  flux5=flux5*PhotonFlux_nucleus_nob(x2,gamma2,82d0,6.624d0)
  PRINT *, x1,x2,flux1,flux2,flux3,flux4,flux5
  
  RETURN
  nuclearA_beam1=0
  nuclearA_beam2=0
  nuclearZ_beam1=0
  nuclearZ_beam2=0
  ebeam(1)=6500d0
  ebeam(2)=6500d0
  !ebeam(1)=200d0
  !ebeam(2)=200d0
  gamma1=ebeam(1)/mproton
  gamma2=ebeam(2)/mproton
  x1=0.5d0
  x2=3.5d-2
  flux1=PhotonPhotonFlux_pp(x1,x2)
  flux2=PhotonPhotonFlux_pp_eval(x1,x2)
  flux3=epa_proton(x1,1D0)
  flux3=flux3*epa_proton(x2,1D0)
  flux4=epa_ion(x1,1)
  flux4=flux4*epa_ion(x2,1)
  flux5=PhotonFlux_proton_nob(x1,gamma1)
  flux5=flux5*PhotonFlux_proton_nob(x2,gamma2)
  PRINT *, x1,x2,flux1,flux2,flux3,flux4,flux5
  x1=3.55d-4
  x2=2.47d-2
  flux1=PhotonPhotonFlux_pp(x1,x2)
  flux2=PhotonPhotonFlux_pp_eval(x1,x2)
  flux3=epa_proton(x1,1D0)
  flux3=flux3*epa_proton(x2,1D0)
  flux4=epa_ion(x1,1)
  flux4=flux4*epa_ion(x2,1)
  flux5=PhotonFlux_proton_nob(x1,gamma1)
  flux5=flux5*PhotonFlux_proton_nob(x2,gamma2)
  PRINT *, x1,x2,flux1,flux2,flux3,flux4,flux5
END PROGRAM test_PhotonFlux
