PROGRAM test
  USE nucleon_transverse_profile
  USE integrate_overlappingF
  IMPLICIT NONE
  REAL(KIND(1d0))::r0,beta,r01,r02
  REAL(KIND(1d0))::mg,Fval,vx,vy

  r0=1.25d0
  mg=1d0/r0
  beta=0.5d0
  r01=1.25d0
  r02=0.25d0

  vx=0.13d0
  vy=0d0

  print *, "vx=",vx,"vy=",vy

  print *, 'hard sphere'
  Fval=OverlappingF_hardsphere(vx,vy,r0)
  print *, 'F=',Fval
  Fval=integrate_F_hardsphere(vx,vy,r0)
  print *, 'F2=',Fval
  Fval=sigmaeffpp_hardsphere(r0)
  print *, 'sigma=',Fval
  Fval=integrate_sigmaeffpp_hardsphere(r0)
  print *, 'sigma2=',Fval

  print *, 'gaussian'
  Fval=OverlappingF_gaussian(vx,vy,r0)
  print *, 'F=',Fval
  Fval=integrate_F_gaussian(vx,vy,r0)
  print *, 'F2=',Fval
  Fval=sigmaeffpp_gaussian(r0)
  print *, 'sigma=',Fval
  Fval=integrate_sigmaeffpp_gaussian(r0)
  print *, 'sigma2=',Fval

  print *, 'double gaussian'
  Fval=OverlappingF_doublegaussian(vx,vy,beta,r01,r02)
  print *, 'F=',Fval
  Fval=integrate_F_doublegaussian(vx,vy,beta,r01,r02)
  print *, 'F2=',Fval
  Fval=sigmaeffpp_doublegaussian(beta,r01,r02)
  print *, 'sigma=',Fval
  Fval=integrate_sigmaeffpp_doublegaussian(beta,r01,r02)
  print *, 'sigma2=',Fval

  print *, 'top hat'
  Fval=OverlappingF_tophat(vx,vy,r0)
  print *, 'F=',Fval
  Fval=integrate_F_tophat(vx,vy,r0)
  print *, 'F2=',Fval
  Fval=sigmaeffpp_tophat(r0)
  print *, 'sigma=',Fval
  Fval=integrate_sigmaeffpp_tophat(r0)
  print *, 'sigma2=',Fval

  print *, 'dipole'
  Fval=OverlappingF_dipole(vx,vy,mg)
  print *, "F=",Fval
  Fval=integrate_F_dipole(vx,vy,mg)
  print *, 'F2=',Fval
  Fval=sigmaeffpp_dipole(mg)
  print *, 'sigma=',Fval
  Fval=integrate_sigmaeffpp_dipole(mg)
  print *, 'sigma2=',Fval

  print *, 'exponential'
  Fval=OverlappingF_exponential(vx,vy,r0)
  print *, "F=",Fval
  Fval=integrate_F_exponential(vx,vy,r0)
  print *, 'F2=',Fval
  Fval=sigmaeffpp_exponential(r0)
  print *, 'sigma=',Fval
  Fval=integrate_sigmaeffpp_exponential(r0)
  print *, 'sigma2=',Fval
  

  !REAL*8 X, Y, BESSK
  !INTEGER N, i

  !N=5           !number of integer orders
  !X=1.2097d0    !real argument

   !print *,' '
   !print *,' X =', X
   !print *,' '

   !do i=0, N-1
   !  Y=BESSK(i,X)
   !  print *,' N =', i
   !  print *,' Y =', Y
   !  print *,' '
   !end do
END PROGRAM test
