MODULE AnomalousDimensions
  ! This is an obsolte file
  ! It has been replaced by subroutines in qcd_setup.f90
  USE Helac_Func_1
  IMPLICIT NONE
  REAL(KIND(1d0)),PARAMETER::CF=4d0/3d0,CA=3d0,TF=0.5d0
CONTAINS
  FUNCTION quark_Gamma_cusp(mu,nq,iord)
    ! cusp anomalous dimension expansion in Eq.(49) in arXiv:10074005
    ! cusp anomalous dimension from Eq.(B3) in arXiv:1007.4005
    ! 4-loop cusp anomalous dimension, the Pade approximants are used 
    ! as in Eq.(95) in hep-ph/0607228.
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::mu
    INTEGER,INTENT(IN)::nq ! number of light quarks
    INTEGER,INTENT(IN)::iord ! iord: 0, LO, 1, NLO, ... (up to 3)
    REAL(KIND(1d0))::quark_Gamma_cusp
    REAL(KIND(1d0))::gamma0,aso4pi
    REAL(KIND(1d0)),DIMENSION(0:6)::gamma1,gamma2,gamma3
    SAVE gamma0,gamma1,gamma2,gamma3
    INTEGER::init=0,i
    SAVE init
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
    REAL(KIND(1d0)),PARAMETER::zeta3=1.2020569031595942854d0
    ! Gamma(as)=Sum(gamma[n-1]*(as/4/pi)**n,{n,1,Infinity})
    IF(init.EQ.0)THEN
       gamma0=4d0*CF
       DO i=0,6
          gamma1(i)=gamma0*((67d0/9d0-pi**2/3d0)*CA-20d0/9d0*TF*i)
          gamma2(i)=gamma0*(CA**2*(245d0/6d0-134d0*pi**2/27d0+&
               22d0*zeta3/3d0+11d0*pi**4/45d0)+CA*i*TF*(40d0*pi**2/27d0&
               -56d0*zeta3/3d0-418d0/27d0)+CF*i*TF*(16d0*zeta3-55d0/3d0)&
               -16d0*i**2*TF**2/27d0)
          IF(i.LT.3.OR.i.GT.5)THEN
             gamma3(i)=0d0
          ELSEIF(i.EQ.3)THEN
             gamma3(i)=7849d0
          ELSEIF(i.EQ.4)THEN
             gamma3(i)=4313d0
          ELSEIF(i.EQ.5)THEN
             gamma3(i)=1553d0
          ENDIF
       ENDDO
       init=1
    ENDIF
    aso4pi=ALPHAS(mu)/4d0/pi
    quark_Gamma_cusp=gamma0*aso4pi
    IF(iord.LE.0)RETURN
    IF(nq.GT.6.OR.nq.LT.0)THEN
       WRITE(*,*)"ERROR:number of light quark nq is not valid:",nq
       STOP
    ENDIF
    quark_Gamma_cusp=quark_Gamma_cusp+gamma1(nq)*aso4pi**2
    IF(iord.LE.1)RETURN
    quark_Gamma_cusp=quark_Gamma_cusp+gamma2(nq)*aso4pi**3
    IF(iord.LE.2)RETURN
    quark_Gamma_cusp=quark_Gamma_cusp+gamma3(nq)*aso4pi**4
    RETURN
  END FUNCTION quark_Gamma_cusp

  FUNCTION gluon_Gamma_cusp(mu,nq,iord)
    ! cusp anomalous dimension expansion in Eq.(49) in arXiv:10074005
    ! Casimir scaling of Eq.(82) in arXiv:0903.1126 for gluon
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::mu
    INTEGER,INTENT(IN)::nq ! number of light quarks
    INTEGER,INTENT(IN)::iord ! iord: 0, LO, 1, NLO, ... (up to 3)
    REAL(KIND(1d0))::gluon_Gamma_cusp
    gluon_Gamma_cusp=quark_Gamma_cusp(mu,nq,iord)*CA/CF
    RETURN
  END FUNCTION gluon_Gamma_cusp

  FUNCTION quark_gamma_normal(mu,nq,iord)
    ! cusp anomalous dimension expansion in Eq.(49) in arXiv:10074005
    ! normal anomalous dimension from Eq.(B4) in arXiv : 1007.4005.
    ! Eq.(A4) ,(A5) in arXiv:0903.1126, valid only in CDR.
    IMPLICIT NONE
    REAL(KIND(1d0)),INTENT(IN)::mu
    INTEGER,INTENT(IN)::nq
    INTEGER,INTENT(IN)::iord ! up to two-loop
    REAL(KIND(1d0))::quark_gamma_normal
    REAL(KIND(1d0))::gamma0,aso4pi
    REAL(KIND(1d0)),DIMENSION(0:6)::gamma1,gamma2,gamma3
    SAVE gamma0,gamma1,gamma2,gamma3
    INTEGER::init=0,i
    SAVE init
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
    REAL(KIND(1d0)),PARAMETER::zeta3=1.2020569031595942854d0
    REAL(KIND(1d0)),PARAMETER::zeta5=1.0369277551433699263d0
    IF(init.EQ.0)THEN
       gamma0=-3d0*CF
       DO i=0,6
          gamma1(i)=CF**2*(-3d0/2d0+2d0*pi**2-24d0*zeta3)+&
               CF*CA*(-961d0/54d0-11d0*pi**2/6d0+26d0*zeta3)+&
               CF*TF*i*(130d0/27d0+2d0*pi**2/3d0)
          gamma2(i)=CA*CF*i*TF*(-23.755829903978054D0+(2594D0*pi**2)/243D0+& 
               (22D0*pi**4)/45D0-(1928D0*zeta3)/27D0)+CF*i**2*TF**2*&
               (13.262002743484224D0-(40D0*pi**2)/27D0-(32D0*zeta3)/27D0)+&
               CF**2*i*TF*(109.37037037037037D0-(26D0*pi**2)/9D0-&
               (28D0*pi**4)/27D0+(512D0*zeta3)/9D0)+CA**2*CF*&
               (-47.7863511659808D0-(7163D0*pi**2)/486D0-(83D0*pi**4)/90D0+& 
               (3526D0*zeta3)/9D0-(44D0*pi**2*zeta3)/9D0-136D0*zeta5)+& 
               CA*CF**2*(-37.75D0+(205D0*pi**2)/9D0+(247D0*pi**4)/135D0-& 
               (844D0*zeta3)/3D0-(8D0*pi**2*zeta3)/3D0-120D0*zeta5)+& 
               CF**3*(-14.5D0-3D0*pi**2-(8D0*pi**4)/5D0-68D0*zeta3+& 
               (16D0*pi**2*zeta3)/3D0+240D0*zeta5)
       ENDDO
       init=1
    ENDIF
    aso4pi=ALPHAS(mu)/4d0/pi
    quark_gamma_normal=gamma0*aso4pi
    IF(iord.LE.0)RETURN
    IF(nq.GT.6.OR.nq.LT.0)THEN
       WRITE(*,*)"ERROR:number of light quark nq is not valid #2:",nq
       STOP
    ENDIF
    quark_gamma_normal=quark_gamma_normal+gamma1(nq)*aso4pi**2
    IF(iord.LE.1)RETURN
    quark_gamma_normal=quark_gamma_normal+gamma2(nq)*aso4pi**3
    RETURN
  END FUNCTION quark_gamma_normal

  FUNCTION gluon_gamma_normal(mu,nq,iord)
    IMPLICIT NONE
    ! cusp anomalous dimension expansion in Eq.(49) in arXiv:10074005
    ! normal anomalous dimension from Eq.(B4) in arXiv : 1007.4005.
    ! Eq.(A4) ,(A5) in arXiv:0903.1126, valid only in CDR.
    REAL(KIND(1d0)),INTENT(IN)::mu
    INTEGER,INTENT(IN)::nq
    INTEGER,INTENT(IN)::iord ! up to two-loop
    REAL(KIND(1d0))::gluon_gamma_normal
    REAL(KIND(1d0))::aso4pi
    REAL(KIND(1d0)),DIMENSION(0:6)::gamma0,gamma1,gamma2,gamma3
    SAVE gamma0,gamma1,gamma2,gamma3
    INTEGER::init=0,i
    SAVE init
    REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
    REAL(KIND(1d0)),PARAMETER::zeta3=1.2020569031595942854d0
    REAL(KIND(1d0)),PARAMETER::zeta5=1.0369277551433699263d0
    IF(init.EQ.0)THEN
       DO i=0,6
          gamma0(i)=-11d0/3d0*CA+4d0/3d0*TF*i
          gamma1(i)=4D0*CF*i*TF+CA*i*(9.481481481481481D0-&
               (2D0*pi**2)/9D0)*TF+CA**2*(-25.62962962962963D0+&
               (11D0*pi**2)/18D0+2D0*zeta3)
          gamma2(i)=-2D0*CF**2*i*TF-(44D0*CF*i**2*TF**2)/9D0+&
               CA*CF*i*TF*(90.14814814814815D0-(2D0*pi**2)/3D0-& 
               (8D0*pi**4)/45D0-(304D0*zeta3)/9D0)+CA*i**2*TF**2*&
               (-0.7379972565157751D0+(40D0*pi**2)/81D0-&
               (224D0*zeta3)/27D0)+CA**2*i*TF*(42.13305898491084D0-& 
               (1198D0*pi**2)/243D0+(82D0*pi**4)/135D0+& 
               (712D0*zeta3)/27D0)+CA**3*(-133.31412894375856D0+& 
               (13837D0*pi**2)/1215D0+(122D0*zeta3)/3D0-&
               (20D0*pi**2*zeta3)/9D0-16D0*zeta5)
       ENDDO
       init=1
    ENDIF
    aso4pi=ALPHAS(mu)/4d0/pi
    IF(iord.LE.0)RETURN
    IF(nq.GT.6.OR.nq.LT.0)THEN
       WRITE(*,*)"ERROR:number of light quark nq is not valid #3:",nq
       STOP
    ENDIF
    gluon_gamma_normal=gamma0*aso4pi
    IF(iord.LE.0)RETURN
    gluon_gamma_normal=gluon_gamma_normal+gamma1(nq)*aso4pi**2
    IF(iord.LE.1)RETURN
    gluon_gamma_normal=gluon_gamma_normal+gamma2(nq)*aso4pi**3
    RETURN
  END FUNCTION gluon_gamma_normal
END MODULE AnomalousDimensions
