PROGRAM test
  USE qcd_constants
  USE qcd_setup
  USE qcd_coupling
  IMPLICIT NONE
  REAL(KIND(1d0)),PARAMETER::MZ=91.1876d0
  REAL(KIND(1d0))::ALPHA,LAMBDA
  REAL(KIND(1d0)),DIMENSION(6),PARAMETER::Q_THR_default=(/1d-10,1d-10,0.15d0,&
       1.5d0,4.7d0,173.3d0 /)
  TYPE(as_framework)::as_frame
  TYPE(as_container)::as_box
  INTEGER::i
  REAL(KIND(1d0))::tBefore,tAfter,Q
  CALL CPU_time(tBefore)
  CALL ALPHAS_LAMBDA_INIT(as_frame, 0.1184d0, MZ, Q_THR_default(4:6), 2, 1D0)
  CALL CPU_time(tAfter)
  PRINT *, "Initial time 1:",tAfter-tBefore
  CALL CPU_time(tBefore)
  DO i=10000, 1, -1
     Q=1.3d0+DBLE(i-1)*0.5d0
     ALPHA=ALPHAS_FROM_LAMBDA(Q, 5, as_frame%Q_THR)
  ENDDO
  CALL CPU_time(tAfter)
  PRINT *, "As evalute time 1:",tAfter-tBefore
  PRINT *, ALPHA
  PRINT *, LAMBDA_5L(1:6)
  CALL CPU_time(tBefore)
  CALL as_run_init(as_box,0.1184d0,MZ,5,no_fix_nf,Q_THR_default(4:6),2,1D0)
  CALL CPU_time(tAfter)
  PRINT*, "Initial time 2:",tAfter-tBefore
  CALL CPU_time(tBefore)
  DO i=10000, 1, -1
     Q=1.3d0+DBLE(i-1)*0.5d0
     ALPHA=as_value(as_box, Q)
  ENDDO
  CALL CPU_time(tAfter)
  PRINT*, "As evalute time 2:",tAfter-tBefore
  PRINT *, ALPHA
  RETURN
  LAMBDA_3L(5)=LAMBDA_FROM_ALPHAS(0.118d0,MZ,3,5)
  PRINT *, LAMBDA_3L(5)
  ALPHA=ALPHAS_FROM_LAMBDA(4.7D0,3)
  PRINT *, ALPHA
  ALPHA=ALPHAS_FROM_LAMBDA(MZ,1)
  PRINT *, ALPHA
  LAMBDA=LAMBDA_FROM_ALPHAS(ALPHA,MZ,1,5)
  PRINT *, LAMBDA
  ALPHA=ALPHAS_FROM_LAMBDA(MZ,2)
  PRINT *, ALPHA
  LAMBDA=LAMBDA_FROM_ALPHAS(ALPHA,MZ,2,5)
  PRINT *, LAMBDA
  ALPHA=ALPHAS_FROM_LAMBDA(MZ,3)
  PRINT *, ALPHA
  LAMBDA=LAMBDA_FROM_ALPHAS(ALPHA,MZ,3,5)
  PRINT *, LAMBDA
  ALPHA=ALPHAS_FROM_LAMBDA(MZ,4)
  PRINT *, ALPHA
  LAMBDA=LAMBDA_FROM_ALPHAS(ALPHA,MZ,4,5)
  PRINT *, LAMBDA
  ALPHA=ALPHAS_FROM_LAMBDA(MZ,5)
  PRINT *, ALPHA
  LAMBDA=LAMBDA_FROM_ALPHAS(ALPHA,MZ,5,5)
  PRINT *, LAMBDA
  !CALL SET_QCD_GAMMA_MASS(3)
  !PRINT *, "gammam0=",gammam0
  !PRINT *, "gammam1=",gammam1
  !PRINT *, "gammam2=",gammam2
  !PRINT *, "gammam3=",gammam3
  !CALL SET_QCD_as_decoupling(4)
  !CALL SET_QCD_as_decoupling(4,.TRUE.)
  !PRINT *, "MSbar:"
  !PRINT *, "zeta_11=",zeta_alphas_inv_MSbar_11
  !PRINT *, "zeta_22=",zeta_alphas_inv_MSbar_22
  !PRINT *, "zeta_21=",zeta_alphas_inv_MSbar_21
  !PRINT *, "zeta_20=",zeta_alphas_inv_MSbar_20
  !PRINT *, "zeta_33=",zeta_alphas_inv_MSbar_33
  !PRINT *, "zeta_32=",zeta_alphas_inv_MSbar_32
  !PRINT *, "zeta_31=",zeta_alphas_inv_MSbar_31
  !PRINT *, "zeta_30=",zeta_alphas_inv_MSbar_30
  !PRINT *, "zeta_44=",zeta_alphas_inv_MSbar_44
  !PRINT *, "zeta_43=",zeta_alphas_inv_MSbar_43
  !PRINT *, "zeta_42=",zeta_alphas_inv_MSbar_42
  !PRINT *, "zeta_41=",zeta_alphas_inv_MSbar_41
  !PRINT *, "zeta_40=",zeta_alphas_inv_MSbar_40
  !PRINT *, "OS:"
  !PRINT *, "zeta_11=",zeta_alphas_inv_OS_11
  !PRINT *, "zeta_22=",zeta_alphas_inv_OS_22
  !PRINT *, "zeta_21=",zeta_alphas_inv_OS_21
  !PRINT *, "zeta_20=",zeta_alphas_inv_OS_20
  !PRINT *, "zeta_33=",zeta_alphas_inv_OS_33
  !PRINT *, "zeta_32=",zeta_alphas_inv_OS_32
  !PRINT *, "zeta_31=",zeta_alphas_inv_OS_31
  !PRINT *, "zeta_30=",zeta_alphas_inv_OS_30
  !PRINT *, "zeta_44=",zeta_alphas_inv_OS_44
  !PRINT *, "zeta_43=",zeta_alphas_inv_OS_43
  !PRINT *, "zeta_42=",zeta_alphas_inv_OS_42
  !PRINT *, "zeta_41=",zeta_alphas_inv_OS_41
  !PRINT *, "zeta_40=",zeta_alphas_inv_OS_40
  !PRINT *, "SI:"
  !PRINT *, "zeta_11=",zeta_alphas_inv_SI_11
  !PRINT *, "zeta_22=",zeta_alphas_inv_SI_22
  !PRINT *, "zeta_21=",zeta_alphas_inv_SI_21
  !PRINT *, "zeta_20=",zeta_alphas_inv_SI_20
  !PRINT *, "zeta_33=",zeta_alphas_inv_SI_33
  !PRINT *, "zeta_32=",zeta_alphas_inv_SI_32
  !PRINT *, "zeta_31=",zeta_alphas_inv_SI_31
  !PRINT *, "zeta_30=",zeta_alphas_inv_SI_30
  !PRINT *, "zeta_44=",zeta_alphas_inv_SI_44
  !PRINT *, "zeta_43=",zeta_alphas_inv_SI_43
  !PRINT *, "zeta_42=",zeta_alphas_inv_SI_42
  !PRINT *, "zeta_41=",zeta_alphas_inv_SI_41
  !PRINT *, "zeta_40=",zeta_alphas_inv_SI_40
  RETURN
END PROGRAM test


