MODULE Cuts_Module
USE Helac_Global
USE Kinetic_Func
USE  Constants
IMPLICIT NONE
CONTAINS
SUBROUTINE readcuts_HC
IMPLICIT NONE
CHARACTER(len=24)::file
REAL(KIND(1d0))::cutoff,pi
INTEGER::i,j,i1,j1,l,k
REAL(KIND(1d0))::r
REAL(KIND(1d0))::ptl,ptq,ptbottom,pttop,ptg,etal,etaq,etabottom,etatop,etag,&
                drll,drlq,drqq,drgx,gqq,gll,glq,ggx,drqb,gqb,drbb,gbb,ptmiss,ptcharm,&
                etacharm,etabonia,etaconia,etaBconia,ptconia,ptbonia,ptBconia
REAL(KIND(1d0))::maxptl,maxptq,maxptbottom,maxpttop,maxptcharm,maxptg
REAL(KIND(1d0))::maxptconia,maxptbonia,maxptBconia
REAL(KIND(1d0))::ycl,ycq,ycbottom,yctop,ycg,yccharm,ycbonia,ycconia,ycBconia,&
                 ycllow,ycqlow,ycbottomlow,yctoplow,ycglow,yccharmlow,ycbonialow,ycconialow,ycBconialow
REAL(KIND(1d0))::xFcl,xFcq,xFcbottom,xFctop,xFcg,xFccharm,xFcbonia,xFcconia,xFcBconia,&
     xFcllow,xFcqlow,xFcbottomlow,xFctoplow,xFcglow,xFccharmlow,xFcbonialow,xFcconialow,xFcBconialow
REAL(KIND(1d0))::gbeamq
INTEGER::iounit,flag=0
LOGICAL::lexist
! open default input file
INQUIRE(FILE=TRIM(input_dir)//"default.inp",EXIST=lexist)
IF(.NOT.lexist)THEN
   PRINT *,"Warning: the file default.inp does not exist ! STOP !"
   STOP
ENDIF
INQUIRE(FILE=TRIM(input_dir)//"default.inp",OPENED=lexist)
IF(lexist)THEN
    INQUIRE(FILE=TRIM(input_dir)//"default.inp",NUMBER=iounit)
	IF(iounit.NE.udefault)THEN
		PRINT *,"WARNING: the default.inp has been linked with another unit ! Close and reopen !"
		CLOSE(UNIT=iounit)
		OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
	ENDIF
ELSE
	OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
ENDIF
! open user's input file
IF(TRIM(Input_File)/="default.inp")THEN
    INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),EXIST=lexist)
	IF(.NOT.lexist)THEN
		PRINT *,"Warning: the file "//TRIM(Input_File)//" does not exist ! STOP !"
		STOP
	ENDIF
	INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),OPENED=lexist)
	IF(lexist)THEN
		INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),NUMBER=iounit)
		IF(iounit.NE.uinput)THEN
			PRINT *,"WARNING: the "//TRIM(Input_File)//" has been linked with another unit ! Close and reopen !"
			CLOSE(UNIT=iounit)
			OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
		ENDIF
	ELSE
		OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
	ENDIF
ELSE
    flag=1
ENDIF

cutoff=readvalue_r("cutoffp",flag)

PRINT *,"WARNING CUTOFF SET:",cutoff
ptc(3:20)=cutoff
maxptc(3:20)=-1d0
drc(3:20,3:20)=0
etac(3:20)=20
yycut(3:20)=1d9
IF(absrap)THEN
   yycutlow(3:20)=0d0
ELSE
   yycutlow(3:20)=-1d9
ENDIF
xFcut(3:20)=1d0
xFcutlow(3:20)=-1d0
xFcutflag=.FALSE.
ec(3:20)=cutoff
c1(3:20)=1d0
c2(3:20)=1d0
cc(3:20,3:20)=1d0
gmas(3:20,3:20)=cutoff
gbeammass(1:2,3:20)=0d0
gmasmax(3:20,3:20)=-1d0
pi=DACOS(-1d0)
y1cup=30d0
y1clow=0d0
! maxrapidity for the first final particle
y1cup=readvalue_r("maxy1c",flag)
! minrapidity for the first final particle
y1clow=readvalue_r("miny1c",flag)
! minimum lepton pt
ptl=readvalue_r("minptl",flag)
! maximum lepton pt
maxptl=readvalue_r("maxptl",flag)
!PRINT *,'ptl',ptl
! minimum quark pt
ptq=readvalue_r("minptq",flag)
! maximum quark pt
maxptq=readvalue_r("maxptq",flag)
! minimum charm pt
ptcharm=readvalue_r("minptc",flag)
! maximum charm pt
maxptcharm=readvalue_r("maxptc",flag)
!PRINT *,'ptq',ptq
! minimum bottom pt
ptbottom=readvalue_r("minptb",flag)
! maximum bottom pt
maxptbottom=readvalue_r("maxptb",flag)
!PRINT *,'ptbottom',ptbottom
! minimum top pt
pttop=readvalue_r("minptt",flag)
! maximum top pt
maxpttop=readvalue_r("maxptt",flag)
!PRINT *,'pttop',pttop
! minimum photon pt
ptg=readvalue_r("minptp",flag)
! maximum photon pt
maxptg=readvalue_r("maxptp",flag)
! minimum charmonia pt
ptconia=readvalue_r("minptconia",flag)
! maximum charmonia pt
maxptconia=readvalue_r("maxptconia",flag)
! minimum bottomonia pt
ptbonia=readvalue_r("minptbonia",flag)
! maximum bottomonia pt
maxptbonia=readvalue_r("maxptbonia",flag)
! minimum Bc pt
ptBconia=readvalue_r("minptBconia",flag)
! maximum Bc pt
maxptBconia=readvalue_r("maxptBconia",flag)
!PRINT *,'ptg',ptg
! maximum rapidity lepton
etal=readvalue_r("maxrapl",flag)
! maximum y rapidity lepton
ycl=readvalue_r("maxyrapl",flag)
! minimum y rapidity lepton
ycllow=readvalue_r("minyrapl",flag)
! maximum Feynman parameter xF
xFcl=readvalue_r("maxxFl",flag)
! minimum Feynman parameter xF
xFcllow=readvalue_r("minxFl",flag)
!PRINT *,'etal',etal
! maximum rapidity quark 
etaq=readvalue_r("maxrapq",flag)
! maximum y rapidity quark
ycq=readvalue_r("maxyrapq",flag)
! minimum y rapidity quark
ycqlow=readvalue_r("minyrapq",flag)
! maximum Feynman parameter xF
xFcq=readvalue_r("maxxFq",flag)
! minimum Feynman parameter xF
xFcqlow=readvalue_r("minxFq",flag)
! maximum rapidity charm
etacharm=readvalue_r("maxrapc",flag)
! maximum y rapidity charm
yccharm=readvalue_r("maxyrapc",flag)
! minimum y rapidity charm
yccharmlow=readvalue_r("minyrapc",flag)
! maximum Feynman parameter xF
xFccharm=readvalue_r("maxxFc",flag)
! minimum Feynman parameter xF
xFccharmlow=readvalue_r("minxFc",flag)
!PRINT *,'etaq',etaq
! maximum rapidity bottom 
etabottom=readvalue_r("maxrapb",flag)
! maximum y rapidity bottom
ycbottom=readvalue_r("maxyrapb",flag)
! minimum y rapidity bottom
ycbottomlow=readvalue_r("minyrapb",flag)
! maximum Feynman parameter xF
xFcbottom=readvalue_r("maxxFb",flag)
! minimum Feynman parameter xF
xFcbottomlow=readvalue_r("minxFb",flag)
!PRINT *,'etabottom',etabottom
! maximum rapidity top 
etatop=readvalue_r("maxrapt",flag)
! maximum y rapidity top
yctop=readvalue_r("maxyrapt",flag)
! minimum y rapidity top
yctoplow=readvalue_r("minyrapt",flag)
! maximum Feynman parameter xF
xFctop=readvalue_r("maxxFt",flag)
! minimum Feynman parameter xF
xFctoplow=readvalue_r("minxFt",flag)
!PRINT *,'etatop',etatop
! maximum rapidity photon
etag=readvalue_r("maxrapp",flag)
! maximum y rapidity photon
ycg=readvalue_r("maxyrapp",flag)
! minimum y rapidity photon
ycglow=readvalue_r("minyrapp",flag)
! maximum Feynman parameter xF
xFcg=readvalue_r("maxxFp",flag)
! minimum Feynman parameter xF
xFcglow=readvalue_r("minxFp",flag)
! maximum rapidity charmonium
etaconia=readvalue_r("maxrapconia",flag)
! maximum y rapidity charmonium
ycconia=readvalue_r("maxyrapconia",flag)
! minimum y rapidity charmonium
ycconialow=readvalue_r("minyrapconia",flag)
! maximum Feynman parameter xF
xFcconia=readvalue_r("maxxFconia",flag)
! minimum Feynman parameter xF
xFcconialow=readvalue_r("minxFconia",flag)
! maximum rapidity bottomnium
etabonia=readvalue_r("maxrapbonia",flag)
! maximum y rapidity bottomnium
ycbonia=readvalue_r("maxyrapbonia",flag)
! minimum y rapidity bottomnium
ycbonialow=readvalue_r("minyrapbonia",flag)
! maximum Feynman parameter xF 
xFcbonia=readvalue_r("maxxFbonia",flag)
! minimum Feynman parameter xF 
xFcbonialow=readvalue_r("minxFbonia",flag)
! maximum rapidity Bc
etaBconia=readvalue_r("maxrapBconia",flag)
! maximum y rapidity Bc
ycBconia=readvalue_r("maxyrapBconia",flag)
! minimum y rapidity Bc
ycBconialow=readvalue_r("minyrapBconia",flag)
! maximum Feynman parameter xF
xFcBconia=readvalue_r("maxxFBconia",flag)
! minimum Feynman parameter xF
xFcBconialow=readvalue_r("minxFBconia",flag)
!PRINT *,'etag',etag
! minimum DR lepton with lepton
drll=readvalue_r("mindrll",flag)
! minimum mass lepton with lepton
gll=readvalue_r('minmll',flag)
!PRINT *,'drll',drll
! minimum DR lepton with quark
drlq=readvalue_r("mindrlq",flag)
! minimum mass lepton with quark
glq=readvalue_r('minmlq',flag)
!PRINT *,'drlq',drlq
! minimum DR quark with quark
drqq=readvalue_r("mindrqq",flag)
!PRINT *,'drqq',drqq
! minimum DR photon with fermion
drgx=readvalue_r("mindrpf",flag)
! minimum mass photon with fermion
ggx=readvalue_r("minmpf",flag)
!PRINT *,'drgx',drgx
! minimum mass quark with quark
gqq=readvalue_r("minmqqp",flag)
!PRINT *,'gqq',gqq
! minimum DR quark with b-quark
drqb=readvalue_r("mindrqb",flag)
!PRINT *,'drqb',drqb
! minimum mass quark with b-quark
gqb=readvalue_r("minmqb",flag)
!PRINT *,'gqb',gqb
! minimum DR b-quark with b-quark
drbb=readvalue_r("mindrbb",flag)
!PRINT *,'drbb',drbb
! minimum mass b-quark with b-quark
gbb=readvalue_r("minmbb",flag)
! minimum mass u,d,s quarks and gluon  with partonic beam
gbeamq=readvalue_r("minmqbeam",flag)
!PRINT *,'gbb',gbb
! minimum missing transverse momentum
ptmiss=readvalue_r("minptmiss",flag)
!PRINT *,'ptmiss',ptmiss
! special cuts for e-p collisions
Q2min_ep=readvalue_r("Q2min_ep",flag)
Q2max_ep=readvalue_r("Q2max_ep",flag)
!END SUBROUTINE readcuts_HC
CLOSE(UNIT=udefault)
CLOSE(UNIT=uinput)

!SUBROUTINE Auto_HC_Cuts
!IMPLICIT NONE
!INTEGER::i,j,i1,j1,l,k
!REAL(KIND(1d0))::r
DO i=3,n
   IF(ifl(i).LT.13)THEN
       i1=IABS(MOD(ifl(i),4))
   ELSE
       i1=ifl(i)
   ENDIF
   IF(i1.EQ.35)i1=0
!- charm quarks
   IF(IABS(ifl(i)).EQ.7)i1=7
!- bottom quarks
   IF(IABS(ifl(i)).EQ.12)i1=12
!- top quarks
   IF(IABS(ifl(i)).EQ.11)i1=11
!       goto 111
! -------
! special for mc4lhc 2003
![
!       if(ifl(i).eq.11)i1=-1
!       if(ifl(i).eq.-11)i1=-1
!       if(ifl(i).eq.12)i1=-1
!       if(ifl(i).eq.-12)i1=-1
!]
! 111    continue
!   photons
    IF(i1.EQ.31)THEN
        ptc(i)=ptg
        IF(maxptg.GE.0d0)maxptc(i)=maxptg
        etac(i)=etag
        yycut(i)=ycg
        yycutlow(i)=ycglow
        xFcut(i)=xFcg
        xFcutlow(i)=xFcglow
    ENDIF
!   neutrinos
    IF(i1.EQ.1)THEN
        ptmissc=ptmiss
    ENDIF
!   ch. leptons
    IF(i1.EQ.2)THEN
!      if(i1.le.2)then
        ptc(i)=ptl
        IF(maxptl.GE.0d0)maxptc(i)=maxptl
        etac(i)=etal
        yycut(i)=ycl
        yycutlow(i)=ycllow
        xFcut(i)=xFcl
        xFcutlow(i)=xFcllow
    ENDIF
!   quarks
    IF(i1.EQ.3.OR.i1.EQ.0)THEN
        ptc(i)=ptq
        IF(maxptq.GE.0d0)maxptc(i)=maxptq
        etac(i)=etaq
        yycut(i)=ycq
        yycutlow(i)=ycqlow
        xFcut(i)=xFcq
        xFcutlow(i)=xFcqlow
        gbeammass(1,i)=gbeamq
        gbeammass(2,i)=gbeamq
    ENDIF
!  charm
    IF(i1.EQ.7)THEN
!	ptc(i)=ptcharm
        IF(parton2hadrontype(i).EQ.0)THEN
           ! open charm
           ptc(i)=ptcharm
           IF(maxptcharm.GE.0d0)maxptc(i)=maxptcharm
           etac(i)=etacharm
           yycut(i)=yccharm
           yycutlow(i)=yccharmlow
           xFcut(i)=xFccharm
           xFcutlow(i)=xFccharmlow
        ELSEIF(parton2hadrontype(i).EQ.1)THEN
           ! charmonium
           ptc(i)=ptconia/2d0
           IF(maxptconia.GE.0d0)maxptc(i)=maxptconia/2d0
           etac(i)=etaconia
           yycut(i)=ycconia
           yycutlow(i)=ycconialow
           xFcut(i)=xFcconia
           xFcutlow(i)=xFcconialow
        ELSEIF(parton2hadrontype(i).EQ.3)THEN
           ! Bc
           ptc(i)=ptBconia*rcm/(rcm+rbm)
           IF(maxptBconia.GE.0d0)maxptc(i)=maxptBconia*rcm/(rcm+rbm)
           etac(i)=etaBconia
           yycut(i)=ycBconia
           yycutlow(i)=ycBconialow
           xFcut(i)=xFcBconia
           xFcutlow(i)=xFcBconialow
        ELSE
           PRINT *,"Wrong with the hadron type for parton ",i
           STOP
        ENDIF
    ENDIF
!  bottom 
    IF(i1.EQ.12)THEN
!        ptc(i)=ptbottom
        IF(parton2hadrontype(i).EQ.0)THEN
           ! open bottom
           ptc(i)=ptbottom
           IF(maxptbottom.GE.0d0)maxptc(i)=maxptbottom
           etac(i)=etabottom
           yycut(i)=ycbottom
           yycutlow(i)=ycbottomlow
           xFcut(i)=xFcbottom
           xFcutlow(i)=xFcbottomlow
        ELSEIF(parton2hadrontype(i).EQ.2)THEN
           ! bottonium
           ptc(i)=ptbonia/2d0
           IF(maxptbonia.GE.0d0)maxptc(i)=maxptbonia/2d0
           etac(i)=etabonia
           yycut(i)=ycbonia
           yycutlow(i)=ycbonialow
           xFcut(i)=xFcbonia
           xFcutlow(i)=xFcbonialow
        ELSEIF(parton2hadrontype(i).EQ.3)THEN
           ! Bc
           ptc(i)=ptBconia*rbm/(rcm+rbm)
           IF(maxptBconia.GE.0d0)maxptc(i)=maxptBconia*rbm/(rcm+rbm)
           etac(i)=etaBconia
           yycut(i)=ycBconia
           yycutlow(i)=ycBconialow
           xFcut(i)=xFcBconia
           xFcutlow(i)=xFcBconialow
        ELSE
           PRINT *, "Wrong with the hadron type for parton ",i
           STOP
        ENDIF
    ENDIF
!   top
    IF(i1.EQ.11)THEN
        ptc(i)=pttop
        IF(maxpttop.GE.0d0)maxptc(i)=maxpttop
        etac(i)=etatop
        yycut(i)=yctop
        yycutlow(i)=yctoplow
        xFcut(i)=xFctop
        xFcutlow(i)=xFctoplow
    ENDIF
ENDDO
    
DO i=3,n-1
    IF(ifl(i).LT.13)THEN
        i1=IABS(MOD(ifl(i),4))
    ELSE
        i1=ifl(i)
    ENDIF
    IF(i1.EQ.35)i1=0
!- bottom quarks                                           
    IF(IABS(ifl(i)).EQ.12)i1=12
!- top quarks                                                                                                               
    IF(IABS(ifl(i)).EQ.11)i1=11
!- quarkonium
    IF(parton2hadrontype(i).NE.0)i1=1
!        goto 222
! -------
! special for mc4lhc 2003
![
!       if(ifl(i).eq.11)i1=-1
!       if(ifl(i).eq.-11)i1=-1
!       if(ifl(i).eq.12)i1=-1
!       if(ifl(i).eq.-12)i1=-1
!]

! 222    continue
    DO j=i+1,n
       IF(ifl(j).LT.13)THEN
          j1=IABS(MOD(ifl(j),4))
       ELSE
          j1=ifl(j)
       ENDIF
       IF(j1.EQ.35)j1=0
!- bottom quarks                                                 
                                           
       IF(IABS(ifl(j)).EQ.12)j1=12
!- top quarks                                                         
                                            
       IF(IABS(ifl(j)).EQ.11)j1=11
!- quarkonium
       IF(parton2hadrontype(j).NE.0)j1=1
!         goto 333

! -------
! special for mc4lhc 2003
![
!       if(ifl(j).eq.11)j1=-1
!       if(ifl(j).eq.-11)j1=-1
!       if(ifl(j).eq.12)j1=-1
!       if(ifl(j).eq.-12)j1=-1
!]
! 333    continue
!  n-n
        IF(i1.EQ.1.OR.j1.EQ.1)THEN
!  l-q
        ELSEIF(i1.EQ.2.AND.(j1.EQ.3.OR.j1.EQ.0.OR.j1.EQ.12))THEN
             drc(i,j)=drlq
             gmas(i,j)=MAX(glq,gmas(i,j))
!  l-l
        ELSEIF(i1.EQ.2.AND.j1.EQ.2)THEN
             drc(i,j)=drll
             gmas(i,j)=MAX(gll,gmas(i,j))
!  q-l
        ELSEIF(j1.EQ.2.AND.(i1.EQ.3.OR.i1.EQ.0.OR.i1.EQ.12))THEN
             drc(i,j)=drlq
             gmas(i,j)=MAX(glq,gmas(i,j))
!  g-x  photon-charged
        ELSEIF(i1.EQ.31.AND.j1.NE.1)THEN
             drc(i,j)=drgx
             gmas(i,j)=MAX(ggx,gmas(i,j))
!  x-g  charged-photon
        ELSEIF(j1.EQ.31.AND.i1.NE.1)THEN
             drc(i,j)=drgx
             gmas(i,j)=MAX(ggx,gmas(i,j))
!  q-q
        ELSEIF((i1.EQ.3.OR.i1.EQ.0).AND.(j1.EQ.3.OR.j1.EQ.0))THEN
             drc(i,j)=drqq
             gmas(i,j)=MAX(gqq,gmas(i,j))
!  q-b
        ELSEIF((i1.EQ.3.OR.i1.EQ.0).AND.(j1.EQ.12))THEN
             drc(i,j)=drqb
             gmas(i,j)=MAX(gqb,gmas(i,j))
!  b-q
        ELSEIF((j1.EQ.3.OR.j1.EQ.0).AND.(i1.EQ.12))THEN
             drc(i,j)=drqb
             gmas(i,j)=MAX(gqb,gmas(i,j))
!  b-b
        ELSEIF((i1.EQ.12).AND.(j1.EQ.12))THEN
             drc(i,j)=drbb
             gmas(i,j)=MAX(gbb,gmas(i,j))
        ENDIF
    ENDDO
ENDDO
 
DO i=3,n
    IF(ptc(i).GT.0)THEN
         ec(i)=MAX(ec(i),ptc(i))
    ELSE
         ec(i)=MAX(ec(i),parmas(ifl(i)))
    ENDIF
    r=EXP(2*etac(i))
    c1(i)=(r-1)/(r+1)
    c2(i)=c1(i)
ENDDO
   
!      do i=3,n-1
!       do j=i+1,n
!        cc(i,j)=cos(drc(i,j))
!       enddo
!      enddo

DO i=3,n-1
    DO j=i+1,n
        gmas(i,j)=MAX(gmas(i,j),DSQRT( 2*ptc(i)*ptc(j)*(1-COS(drc(i,j))) ) )
    ENDDO
ENDDO

DO l=4,20
    DO k=3,l-1
        drc(l,k)= drc(k,l)
        cc(l,k)=  cc(k,l)
        gmas(l,k)=  gmas(k,l)
    ENDDO
ENDDO
  
WRITE(*,*)'---------------------------------------------------'
WRITE(*,*)'        the cuts        '
DO i=3,n
    WRITE(*,*)'pt     of  ',i,'   particle   ',ptc(i)
    IF(maxptc(i).GE.0d0)THEN
       WRITE(*,*)'max pt of  ',i,'   particle   ',maxptc(i)
       IF(maxptc(i).LE.ptc(i))THEN
          WRITE(*,*)"ERROR: One final state ",i," was cut off by pt cut"
          STOP
       ENDIF
    ELSE
       WRITE(*,*)'no max pt cut of  ',i,'   particle   '
    ENDIF
    WRITE(*,*)'energy of  ',i,'   particle   ',ec(i)
ENDDO
DO i=3,n
    WRITE(*,*)'rapidity of  ',i,'   particle   ',etac(i)
ENDDO
DO i=3,n
   WRITE(*,*)'max y rapidity of ',i,'   particle   ',yycut(i)
   WRITE(*,*)'min y rapidity of ',i,'   particle   ',yycutlow(i)
   IF(yycut(i).LE.yycutlow(i))THEN
      WRITE(*,*)"ERROR:One final state ",i," was cut off by y rapidity"
      STOP
   ENDIF
   WRITE(*,*)'max Feynman parameter xF of ',i,' particle ',xFcut(i)
   IF(xFcut(i).LT.1d0)xFcutflag=.TRUE.
   WRITE(*,*)'min Feynman parameter xF of ',i,' particle ',xFcutlow(i)
   IF(xFcutlow(i).GT.-1d0)xFcutflag=.TRUE.
   IF(xFcut(i).LE.xFcutlow(i))THEN
      WRITE(*,*)"ERROR:One final state ",i," was cut off by xF "
      STOP
   ENDIF
ENDDO
WRITE(*,*)'The maxrapidity of the first particle',y1cup
WRITE(*,*)'The minrapidity of the first particle',y1clow
DO i=3,n
    WRITE(*,*)'cos-beam1 of ',i,'   particle   ',c1(i)
ENDDO
DO i=3,n
    WRITE(*,*)'cos-beam2 of ',i,'   particle   ',c2(i)
ENDDO

DO i=3,n-1
    DO j=i+1,n
       IF(i.NE.j)THEN
          WRITE(*,*)'DR     ',i,'  with  ',j,drc(i,j)
          WRITE(*,*)'cos of ',i,'  with  ',j,cc(i,j)
       ENDIF
    ENDDO
ENDDO

DO i=3,n-1
    DO j=i+1,n
       IF(i.NE.j)WRITE(*,*)'mass of ',i,'  with  ',j,gmas(i,j)
    ENDDO
ENDDO
WRITE(*,*)'minimum missing transverse momentum',ptmissc
DO i=1,2
   DO j=3,n
      WRITE(*,*)'mass of partonic beam ',i,' with final ',j,gbeammass(i,j)
   ENDDO
ENDDO
IF(min_n_jet.GT.-1)THEN
   WRITE(*,*)'minumum jet pt',minptjet
   IF(maxptjet.GE.0d0)THEN
      WRITE(*,*)'maximum jet pt',maxptjet
   ENDIF
   IF(min_n_jet.GT.0.AND.maxptjet.LE.minptjet.AND.maxptjet.GE.0d0)THEN
      WRITE(*,*)'ERROR: all events will be cutted away because of jet pt cut'
      STOP
   ENDIF
   IF(maxrapjet.GT.0d0)THEN
      WRITE(*,*)'maximum jet (pesudo)rapidity',maxrapjet
   ELSEIF(min_n_jet.GT.0)THEN
      WRITE(*,*)'ERROR: all events will be cutted away because of jet rap cut'
      STOP
   ENDIF
   WRITE(*,*)'minumum number of jet',min_n_jet
   IF(max_n_jet.GT.-1)THEN
      WRITE(*,*)'maximum number of jet',max_n_jet
      IF(max_n_jet.LT.min_n_jet)THEN
         WRITE(*,*)'ERROR: all events will be cutted away because of jet number cut'
         STOP
      ENDIF
   ENDIF
ENDIF
IF(use_stop_cut.AND.stop_min_n_jet.GT.-1)THEN
   WRITE(*,*)'minumum jet pt in stop cut',stop_minptjet
   IF(stop_maxrapjet.GT.0d0)THEN
      WRITE(*,*)'maximum jet (pesudo)rapidity in stop cut',stop_maxrapjet
   ELSEIF(stop_min_n_jet.GT.0)THEN
      WRITE(*,*)'ERROR: all events will be cutted away because of jet rap cut in stop cut'
      STOP
   ENDIF
   WRITE(*,*)'minumum number of jet in stop cut',stop_min_n_jet
   IF(stop_max_n_jet.GT.-1)THEN
      WRITE(*,*)'maximum number of jet in stop cut',stop_max_n_jet
      IF(stop_max_n_jet.LT.stop_min_n_jet)THEN
         WRITE(*,*)'ERROR: all events will be cutted away because of jet number cut in stop cut'
         STOP
      ENDIF
   ENDIF
ENDIF
IF(use_twocutoff_slicing)THEN
   WRITE(*,*)"Two cutoff phase space slicing cuts:"
   DO i=3,n
      IF(ifl(i).EQ.35)THEN
         WRITE(*,*)'energy over sqrt(s12)/2 of ',i,'   particle(gluon) in initial partonic cms > ',twocutoff_slicing_ds
      ENDIF
   ENDDO
   twocutoff_stcuts(1:20,1:20)=.FALSE.
   DO j=1,2
      DO i=3,n
         twocutoff_stcuts(j,i)=QCD_initial_splitting_allowed(ifl(j),ifl(i))
         twocutoff_stcuts(i,j)=twocutoff_stcuts(j,i)
         IF(twocutoff_stcuts(j,i))THEN
            WRITE(*,*)'-tij of ',j,'  with  ',i,'   particles over s12 > ',twocutoff_slicing_dc
         ENDIF
      ENDDO
   ENDDO
   DO j=3,n-1
      DO i=j+1,n
         twocutoff_stcuts(j,i)=QCD_final_splitting_allowed(ifl(j),ifl(i))
         twocutoff_stcuts(i,j)=twocutoff_stcuts(j,i)
         IF(twocutoff_stcuts(j,i))THEN
            WRITE(*,*)'sij of ',j,'  with  ',i,'   particle over s12 > ',twocutoff_slicing_dc
         ENDIF
      ENDDO
   ENDDO
ENDIF
IF(COLL_TYPE.GE.4.AND.COLL_TYPE.LE.7)THEN
   WRITE(*,*)"The cuts for the DIS mode:"
   IF(Q2max_ep.GT.0d0)THEN
      WRITE(*,*)"-t13<",Q2max_ep
   ENDIF
   IF(Q2min_ep.GT.0d0)THEN
      WRITE(*,*)"-t13>",Q2min_ep
      IF(Q2max_ep.GT.0d0.AND.Q2min_ep.GE.Q2max_ep)THEN
         WRITE(*,*)"Error: All events will be cutted away by Q2max_ep and Q2min_ep"
         STOP
      ENDIF
   ELSEIF(Q2min_ep.EQ.0d0)THEN
      WRITE(*,*)"-t13>me**2*x**2/(1-x)"
   ENDIF
   WRITE(*,*)"End of cuts for the DIS mode"
ENDIF
WRITE(*,*)'---------------------------------------------------'
!END SUBROUTINE Auto_HC_Cuts
END SUBROUTINE readcuts_HC

SUBROUTINE readcuts_ehc
  IMPLICIT NONE
  ! temporarly reusing hadron-hadron collider
  CALL readcuts_HC
  
END SUBROUTINE readcuts_ehc


SUBROUTINE cuts_HC(icut)
IMPLICIT NONE
REAL(KIND=DBL),DIMENSION(20,4)::p
REAL(KIND=DBL),DIMENSION(4)::pboo,ponia,pboo2
REAL(KIND=DBL)::pi,q,e,pt,eta,d1,d2,dr,pmiss_E,pmiss_x,pmiss_y,pmiss_z,pt_miss,s,t
REAL(KIND=DBL)::exp1,exp2,aaa,bbb,ptcut
INTEGER,INTENT(OUT)::icut
INTEGER::i,l,flag,l1,l2,i_nu,i1
REAL(KIND=DBL),DIMENSION(4,20)::p_track
INTEGER,DIMENSION(20)::pid_track
INTEGER,DIMENSION(10)::onium_index
INTEGER::n_track,n_jet,n_jet_wcuts,n_onium,ioniumjet
REAL(KIND=DBL),DIMENSION(4,20)::p_oniumjet_track
INTEGER::n_oniumjet_track,n_oniumjet_gluon,n_oniumjet_quark
INTEGER,DIMENSION(-6:6)::n_oniumjet_quarkflavor
INTEGER::n_oniumjet_gluonandqqbar,n_oniumjet_nonpairquark
REAL(KIND=DBL)::pt1_oniumjet,pt2_oniumjet,z12,z1
REAL(KIND=DBL),DIMENSION(4,20)::p_jet,p_jet_wcuts
REAL(KIND=DBL)::ptjet,ptjet_min,ptjet_max,RRstop,monium,ptonium,s12,Egcut
INTEGER,DIMENSION(20)::jetvec
REAL(KIND=DBL),DIMENSION(4)::Qphoton
REAL(KIND=DBL)::Q2,Q2min,xgamma
REAL(KIND=DBL),PARAMETER::mass_e=0.511d-3 ! electron mass in GeV
LOGICAL::mcuts
!    -----
!     special for mc4lhc
!    -----
pi=DACOS(-1d0)
IF(Momenta_Frame.EQ.2)THEN
   CALL cmstolab()
ELSEIF(Momenta_Frame.EQ.3.AND..NOT.labeqcoll)THEN
   CALL collisiontolab()
ENDIF
DO i=1,n
   p(i,1:4)=phegas_pmom(i,1:4)
ENDDO
icut=0
! invariant mass cuts
DO l1=3,n-1
   DO l2=l1+1,n
      IF(l1.EQ.l2.OR.Quarkonium3(l1).EQ.Quarkonium3(l2).AND.Quarkonium3(l1).NE.0)CYCLE
      s=2*scalar_product(phegas_pmom(l1,1:4),phegas_pmom(l2,1:4))&
         +scalar_product(phegas_pmom(l1,1:4),phegas_pmom(l1,1:4))&
         +scalar_product(phegas_pmom(l2,1:4),phegas_pmom(l2,1:4))
      IF(s.LT.gmas(l1,l2)**2)RETURN
   ENDDO
ENDDO
! special for the beam cuts for NLO* or NNLO*
DO l1=1,2
   DO l2=3,n
      t=scalar_product(phegas_pmom(l1,1:4),phegas_pmom(l1,1:4))&
           +scalar_product(phegas_pmom(l2,1:4),phegas_pmom(l2,1:4))&
           -2*scalar_product(phegas_pmom(l1,1:4),phegas_pmom(l2,1:4))
      IF(DABS(t).LT.gbeammass(l1,l2)**2)RETURN
   ENDDO
ENDDO
!IF(.NOT.(istruc.EQ.1.OR.istruc.EQ.2.OR..NOT.labeqcoll).OR.(imode.EQ.0.AND.NDecayChains.EQ.0))THEN ! why imode.EQ.0 ? because it has been boosted into lab frame when imode.NE.0 or with decay chains (spin correlations)
!IF(Momenta_Frame.EQ.2)THEN
!   ! collider lab frame:
!   ! xp1(ebeam(1),0,0,ebeam(1)), xp2(ebeam(2),0,0,-ebeam(2))
!   ! fixed target (fake) lab frame (note it is not the true lab frame of fixed target but close to):
!   ! beam1 = (beam(1)+FT_M/2,0,0,beam(1)+FT_M/2)
!   ! beam2 = (FT_M/2,0,0,-FT_M/2), FT_M=beam(2)
!   ! xp1(ebeam(1)+FT_M/2,0,0,ebeam(1)+FT_M/2), xp2(FT_M/2,0,0,-FT_M/2)
!   ! collision frame:
!   ! xp1(Sqrt(S)/2,0,0,Sqrt(S)/2); xp2(Sqrt(S)/2,0,0,-Sqrt(S)/2)
!   ! Sqrt(s)=SQRT(xp1*xp2)*Sqrt(S)
!   ! ehat=Sqrt(s);e=Sqrt(S)
!   q=ehat
!   e=q/SQRT(xp1*xp2)
!   exp1=ebeam(1)*xp1
!   exp2=ebeam(2)*xp2
!   IF(fixtarget)THEN
!      IF(.NOT.fixtargetrev)THEN
!         exp1=exp1+FT_M*xp1/2d0
!         exp2=exp2/2d0
!      ELSE
!         exp1=exp1/2d0
!         exp2=exp2+FT_M*xp2/2d0
!      ENDIF
!   ENDIF
!   pboo(4)=(exp1+exp2)
!   pboo(3)=(exp1-exp2)
!   pboo(1:2)=0
!! boost to the lab frame
!   DO i=1,n
!      CALL boostl(q,pboo,p(i,1:4))
!   ENDDO
!ENDIF
flag=0
DO l=3,n
   pt=SQRT(p(l,1)**2+p(l,2)**2)
   IF(pt.LT.ptc(l).AND.nhad.GT.3)THEN
      flag=1
      EXIT
   ENDIF
   IF(maxptc(l).GE.0d0.AND.nhad.GT.3)THEN
      IF(pt.GT.maxptc(l))THEN
         flag=1
         EXIT
      ENDIF
   ENDIF
   eta=prapidity(p(l,1:4))
   IF(ABS(eta).GT.etac(l).AND.nhad.GT.3)THEN 
      flag=1
      EXIT
   ENDIF
   eta=rapidity(p(l,1:4))
   IF(absrap)eta=ABS(eta)
   IF(eta.GT.yycut(l).OR.eta.LT.yycutlow(l))THEN
      flag=1
      EXIT
   ENDIF
   ! special for the first particle , which can be used to calculate the y distribution
   IF(l.EQ.3)THEN
      !		eta=rapidity(p(l,1:4))
      IF(eta.GT.y1cup.OR.eta.LT.y1clow)THEN
         flag=1
         EXIT
      ENDIF
   ENDIF
ENDDO

IF(flag.EQ.0)THEN
   DO l1=3,n
      DO l2=3,n
         IF(l1.EQ.l2.OR.Quarkonium3(l1).EQ.Quarkonium3(l2).AND.Quarkonium3(l1).NE.0)CYCLE
         d1=prapidity(p(l1,1:4))-prapidity(p(l2,1:4))
         d2=ph4(p(l1,1),p(l1,2),p(l1,3))-ph4(p(l2,1),p(l2,2),p(l2,3))
         d2=MIN(DABS(d2),2*pi-DABS(d2))
         IF(d2/pi.GT.1.d0)WRITE(*,*)d2/pi
         dr=SQRT(d1**2+d2**2)
         IF(dr.LT.drc(l1,l2))THEN 
            flag=1
            EXIT
         ENDIF
      ENDDO
      IF(flag.EQ.1)EXIT
   ENDDO
   IF(flag.EQ.0)THEN
      i_nu=0
      pmiss_E=0.d0
      pmiss_x=0.d0
      pmiss_y=0.d0
      pmiss_z=0.d0
      DO l=3,n
         IF(ifl(l).LT.13)THEN
            i1=IABS(MOD(ifl(l),4))
         ENDIF
         IF(i1.EQ.1)THEN        !neutrino found
            i_nu=1
            pmiss_E = pmiss_E + p(l,4)
            pmiss_x = pmiss_x + p(l,1)
            pmiss_y = pmiss_y + p(l,2)
            pmiss_z = pmiss_z + p(l,3)
         ENDIF
      ENDDO
      pt_miss=SQRT((pmiss_x)**2+(pmiss_y)**2)
      IF(i_nu.NE.1.OR.pt_miss.GE.ptmissc.OR.nhad.EQ.3)THEN
         icut=1
      ENDIF
   ENDIF
ENDIF

! special for the beam cuts for NLO* or NNLO*
! special cutoffs in the literature
IF(icut.EQ.1.AND.flag.EQ.0)THEN
   IF(literature_cutoffs.EQ.14060484.OR.literature_cutoffs.EQ.15090000)THEN
      l1=3
      DO l=3,nhad
         IF(iflh(l).GT.440001.AND.iflh(l).LT.449999)THEN
            ! charmonia
            ponia(1:4)=p(l1,1:4)+p(l1+1,1:4)
            eta=rapidity(ponia(1:4))
            IF(ABS(eta).LT.1.2d0)THEN
               pt=SQRT(ponia(1)**2+ponia(2)**2)
               IF(pt.LE.6.5d0)THEN
                  icut=0
                  EXIT
               ENDIF
            ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.1.43d0)THEN
               pt=SQRT(ponia(1)**2+ponia(2)**2)
               aaa=-8.695652173913045d0
               bbb=16.934782608695656d0
               ptcut=aaa*ABS(eta)+bbb
               IF(pt.LE.ptcut)THEN
                  icut=0
                  EXIT
               ENDIF
            ELSEIF(ABS(eta).GT.1.43d0.AND.ABS(eta).LT.2.2d0)THEN
               pt=SQRT(ponia(1)**2+ponia(2)**2)
               IF(pt.LE.4.5d0)THEN
                  icut=0
                  EXIT
               ENDIF
            ELSE
               icut=0
               EXIT
            ENDIF
            l1=l1+2
         ELSEIF(ABS(iflh(l)).GT.100)THEN
            l1=l1+2
         ELSE
            l1=l1+1
         ENDIF
      ENDDO
   ELSEIF(literature_cutoffs.GE.160700001.AND.literature_cutoffs.LE.160700100)THEN
      ! special for the LHCb cutoff
      ! it is asked to compare with arXiv:1606.06767
      l1=3
      ponia(1:4)=0d0
      DO l=3,min(nhad,4)
         IF(ABS(iflh(l)).GT.100)THEN
            ! quarkonium
            ponia(1:4)=ponia(1:4)+p(l1,1:4)+p(l1+1,1:4)
            l1=l1+2
         ELSE
            ponia(1:4)=ponia(1:4)+p(l1,1:4)
            l1=l1+1
         ENDIF
      ENDDO
      pt=SQRT(ponia(1)**2+ponia(2)**2)
      aaa=DBLE(literature_cutoffs-160700000)
      IF(pt.LT.aaa)THEN
         icut=0
      ENDIF
   ENDIF
ENDIF

! special cut
mcuts=.FALSE.
s=2*scalar_product(p(3,1:4),p(4,1:4))&
     +scalar_product(p(3,1:4),p(3,1:4))&
     +scalar_product(p(4,1:4),p(4,1:4))
IF(s.GE.1d6)THEN
   mcuts=.TRUE.
ENDIF

IF(.NOT.mcuts)THEN
   icut=0
   RETURN
ENDIF

! 1000 continue

!     ---
!     boost from lab to the collision frame for xF cut
!     ---
IF(xFcutflag.AND.icut.EQ.1.AND.flag.EQ.0)THEN
   q=ehat
   e=q/SQRT(xp1*xp2)
   IF(.NOT.labeqcoll)THEN
      ! collider lab frame:
      ! xp1(ebeam(1),0,0,ebeam(1)), xp2(ebeam(2),0,0,-ebeam(2))
      ! fixed target (fake) lab frame (note it is not the true lab frame of fixed target but close to):
      ! beam1 = (beam(1)+FT_M/2,0,0,beam(1)+FT_M/2)
      ! beam2 = (FT_M/2,0,0,-FT_M/2),FT_M=beam(2)
      ! xp1(ebeam(1)+FT_M/2,0,0,ebeam(1)+FT_M/2), xp2(FT_M/2,0,0,-FT_M/2)
      ! collision frame:
      ! xp1(Sqrt(S)/2,0,0,Sqrt(S)/2); xp2(Sqrt(S)/2,0,0,-Sqrt(S)/2)
      ! Sqrt(s)=SQRT(xp1*xp2)*Sqrt(S)
      ! ehat=Sqrt(s);e=Sqrt(S)
      IF(.NOT.fixtarget)THEN
         pboo2(4)=(ebeam(1)+ebeam(2))
         pboo2(3)=-(ebeam(1)-ebeam(2))
      ELSE
         IF(.NOT.fixtargetrev)THEN
            pboo2(4)=(ebeam(1)+ebeam(2))
            pboo2(3)=-ebeam(1)
         ELSE
            pboo2(4)=(ebeam(1)+ebeam(2))
            pboo2(3)=ebeam(2)
         ENDIF
      ENDIF
      pboo2(1:2)=0
      ! boost from the lab frame to the collision frame
      DO i=1,n
         CALL boostl(e,pboo2,p(i,1:4))
      ENDDO
   ENDIF
   DO l=3,n
      eta=xFeynman(p(l,1:4),e)
      IF(eta.GT.xFcut(l).OR.eta.LT.xFcutlow(l))THEN
         icut=0
         EXIT
      ENDIF
   ENDDO
   IF(.NOT.labeqcoll)THEN
      pboo2(3)=-pboo2(3)
      ! boost back to the lab frame
      DO i=1,n
         CALL boostl(e,pboo2,p(i,1:4))
      ENDDO
   ENDIF
ENDIF

! jet related cuts
IF(min_n_jet.GE.0.AND.icut.EQ.1.AND.flag.EQ.0)THEN
   ! in fastjet, the momentum is in the form of
   ! (px,py,pz,E)
   n_track=0
   n_jet=0
   p_track(1:4,1:20)=0d0
   l1=3
   DO i=3,nhad
      IF(is_a_jet(iflh(i)))THEN
         n_track=n_track+1
         p_track(1:4,n_track)=p(l1,1:4)
      ENDIF
      IF(ABS(iflh(i)).GT.100)THEN
         l1=l1+2
      ELSE
         l1=l1+1
      ENDIF
   ENDDO
   IF(min_n_jet.GT.0.AND.n_track.LT.min_n_jet)THEN
      WRITE(*,*)"ERROR: all events are cutted away by number of jet cuts #1"
      STOP
   ENDIF
   IF(n_track.GT.0)THEN
      IF(maxrapjet.GT.0d0)THEN
         CALL fastjetppgenkt_etamax(p_track,n_track,jet_radius,minptjet,maxrapjet,&
              DBLE(jetalg),p_jet,n_jet,jetvec)
      ELSE
         CALL fastjetppgenkt(p_track,n_track,jet_radius,minptjet,DBLE(jetalg),&
              p_jet,n_jet,jetvec)
      ENDIF
      IF(maxptjet.GE.0d0.AND.n_jet.GE.1)THEN
         ! check the max jet pt cut
         n_jet_wcuts=0
         DO i=1,n_jet
            IF(DSQRT(p_jet(1,i)**2+p_jet(2,i)**2).LE.maxptjet)THEN
               n_jet_wcuts=n_jet_wcuts+1
               p_jet_wcuts(1:4,n_jet_wcuts)=p_jet(1:4,i)
            ENDIF
         ENDDO
         IF(n_jet_wcuts.LT.min_n_jet)THEN
            icut=0
         ELSEIF(max_n_jet.GE.0.AND.n_jet_wcuts.GT.max_n_jet)THEN
            icut=0
         ENDIF
      ELSE
         IF(n_jet.LT.min_n_jet)THEN
            icut=0
         ELSEIF(max_n_jet.GE.0.AND.n_jet.GT.max_n_jet)THEN
            icut=0
         ENDIF
      ENDIF
   ENDIF
ENDIF

! STOP cut, see arXiv:1809.02369
IF(use_stop_cut.AND.icut.EQ.1.AND.flag.EQ.0)THEN
   ! the current implementation is limited to one onium case
   ! in fastjet, the momentum is in the form of
   ! (px,py,pz,E)
   n_track=0
   n_jet=0
   p_track(1:4,1:20)=0d0
   pid_track(1:20)=-999
   onium_index(1:10)=0
   n_onium=0
   l1=3
   DO i=3,nhad
      IF(is_a_jet(iflh(i)).OR.is_an_onium(iflh(i)))THEN
         n_track=n_track+1
         IF(is_an_onium(iflh(i)))THEN
            p_track(1:4,n_track)=p(l1,1:4)+p(l1+1,1:4)
            n_onium=n_onium+1
            onium_index(n_onium)=n_track
         ELSE
            p_track(1:4,n_track)=p(l1,1:4)
         ENDIF
         pid_track(n_track)=iflh(i)
      ENDIF
      IF(ABS(iflh(i)).GT.100)THEN
         l1=l1+2
      ELSE
         l1=l1+1
      ENDIF
   ENDDO
   IF(n_onium.GT.1)THEN
      WRITE(*,*)"ERROR: not implemented STOP cuts for multiple-onium"
      STOP
   ENDIF
   IF(n_track.LT.stop_min_n_jet)THEN
      WRITE(*,*)"ERROR: all events are cutted away by minimal number of jet STOP cuts #1"
      STOP
   ENDIF
   IF(n_onium.GT.0.AND.n_track.GT.0)THEN
      IF(stop_jet_dyn_radius.GT.0d0)THEN
         ! only applies to the first onium
         monium=p_track(4,onium_index(1))**2-p_track(1,onium_index(1))**2&
              -p_track(2,onium_index(1))**2-p_track(3,onium_index(1))**2
         monium=DSQRT(monium)
         ptonium=p_track(1,onium_index(1))**2+p_track(2,onium_index(1))**2
         ptonium=DSQRT(ptonium)
         RRstop=MAX(stop_jet_radius,stop_jet_dyn_radius*monium/ptonium)
      ELSE
         RRstop=stop_jet_radius
      ENDIF
      IF(stop_maxrapjet.GT.0d0)THEN
         CALL fastjetppgenkt_etamax(p_track,n_track,RRstop,stop_minptjet,stop_maxrapjet,&
              DBLE(stop_jetalg),p_jet,n_jet,jetvec)
      ELSE
         CALL fastjetppgenkt(p_track,n_track,RRstop,stop_minptjet,DBLE(stop_jetalg),&
              p_jet,n_jet,jetvec)
      ENDIF
      IF(n_jet.LT.stop_min_n_jet)THEN
         icut=0
      ELSEIF(stop_max_n_jet.GE.0.AND.n_jet.GT.stop_max_n_jet)THEN
         icut=0
      ENDIF
      ! take care of one onium only
      IF(icut.EQ.1)THEN
         ioniumjet=jetvec(onium_index(1))
         IF(ioniumjet.LE.0)THEN
            icut=0 ! there is no onium jet passing the cuts
         ELSE
            n_oniumjet_track=0
            p_oniumjet_track(1:4,1:20)=0d0
            n_oniumjet_gluon=0
            n_oniumjet_quark=0
            n_oniumjet_quarkflavor(-6:6)=0
            DO i=1,n_track
               IF(jetvec(i).EQ.ioniumjet.AND.is_a_jet(pid_track(i)))THEN
                  n_oniumjet_track=n_oniumjet_track+1
                  p_oniumjet_track(1:4,n_oniumjet_track)=p_track(1:4,i)
                  IF(pid_track(i).EQ.35)THEN
                     n_oniumjet_gluon=n_oniumjet_gluon+1
                  ELSEIF(ABS(pid_track(i)).LE.12)THEN
                     n_oniumjet_quark=n_oniumjet_quark+1
                     n_oniumjet_quarkflavor(fermionPDG(pid_track(i)))=&
                          n_oniumjet_quarkflavor(fermionPDG(pid_track(i)))+1
                  ENDIF
               ENDIF
            ENDDO
            n_oniumjet_gluonandqqbar=n_oniumjet_gluon
            n_oniumjet_nonpairquark=0
            DO i=1,6
               n_oniumjet_gluonandqqbar=n_oniumjet_gluonandqqbar+&
                    MIN(n_oniumjet_quarkflavor(-i),n_oniumjet_quarkflavor(i))
               n_oniumjet_nonpairquark=n_oniumjet_nonpairquark+&
                    ABS(n_oniumjet_quarkflavor(-i)-n_oniumjet_quarkflavor(i))
            ENDDO
            ! I do not know the flavours of the stop_n_frag_quark
            ! choose the way to maximize n_oniumjet_gluonandqqbar
            ! subtract the ones needed by stop_n_frag_quark
            IF(n_oniumjet_nonpairquark.LT.stop_n_frag_quark)THEN
               n_oniumjet_gluonandqqbar=n_oniumjet_gluonandqqbar&
                    -(stop_n_frag_quark-n_oniumjet_nonpairquark+1)/2
            ENDIF
            IF(n_oniumjet_track.LT.(stop_n_frag_gluon+stop_n_frag_quark).OR.&
                 n_oniumjet_gluonandqqbar.LT.stop_n_frag_gluon.OR.&
                 n_oniumjet_quark.LT.stop_n_frag_quark)THEN
               icut=0
            ELSE
               IF(n_oniumjet_track.GE.2)THEN
                  ! check the soft drop cut
                  DO i=1,n_oniumjet_track-1
                     pt1_oniumjet=DSQRT(p_oniumjet_track(1,i)**2+p_oniumjet_track(2,i)**2)
                     DO l=i+1,n_oniumjet_track
                        pt2_oniumjet=DSQRT(p_oniumjet_track(1,l)**2+p_oniumjet_track(2,l)**2)
                        z12=MIN(pt1_oniumjet,pt2_oniumjet)/MAX((pt1_oniumjet+pt2_oniumjet),1D-99)
                        d1=prapidity(p_oniumjet_track(1:4,i))&
                             -prapidity(p_oniumjet_track(1:4,l))
                        d2=ph4(p_oniumjet_track(1,i),p_oniumjet_track(2,i),p_oniumjet_track(3,i))&
                             -ph4(p_oniumjet_track(1,l),p_oniumjet_track(2,l),p_oniumjet_track(3,l))
                        d2=MIN(DABS(d2),2*pi-DABS(d2))
                        IF(d2/pi.GT.1.d0)WRITE(*,*)d2/pi
                        dr=DSQRT(d1**2+d2**2)
                        IF(z12.LE.stop_zcut*(dr/RRstop)**stop_beta)THEN
                           icut=0
                           EXIT
                        ENDIF
                     ENDDO
                     IF(icut.EQ.0)EXIT
                  ENDDO
               ENDIF
               ! n_track-n_onium=i+k+o
               ! assume there is only one onium and one onium jet
               ! stop_min_n_jet-1 is the minimal number of parton jets
               ! If there are extra o radiations, the condition is to require
               ! i+k+o-m=n_track-n_onium-n_oniumjet_track
               IF(icut.EQ.1)THEN
                  IF(stop_min_n_jet-1.LT.(n_track-n_onium-n_oniumjet_track))THEN
                     IF(n_jet-1.LT.(n_track-n_onium-n_oniumjet_track))THEN
                        icut=0
                     ENDIF
                     IF(icut.EQ.1.AND.n_jet-1.GE.2.AND.stop_zasymcut.GT.0d0)THEN
                        ! apply the asymmetric cut
                        ptjet_min=-1d0
                        ptjet_max=-1d0
                        DO i=1,n_jet
                           IF(i.EQ.ioniumjet)CYCLE
                           ptjet=DSQRT(p_jet(1,i)**2+p_jet(2,i)**2)
                           IF(ptjet_min.LT.0d0.OR.ptjet_min.GT.ptjet)THEN
                              ptjet_min=ptjet
                           ENDIF
                           IF(ptjet_max.LT.0d0.OR.ptjet_max.LT.ptjet)THEN
                              ptjet_max=ptjet
                           ENDIF
                        ENDDO
                        IF(ptjet_min/ptjet_max.LE.stop_zasymcut)THEN
                           icut=0
                        ENDIF
                     ENDIF
                  ENDIF
               ENDIF
               ! to pass the soft cut for 3S1[8]
               ! k=stop_n_frag_gluon+stop_n_frag_quark
               IF(icut.EQ.1)THEN
                  IF(n_oniumjet_track.GT.0.AND.(stop_n_frag_gluon+stop_n_frag_quark).EQ.0)THEN
                     DO i=1,n_oniumjet_track
                        ! Take energy fraction
                        z1=p_oniumjet_track(4,i)/p_jet(4,ioniumjet)
                        ! zsoftcut is divided by the number of partons inside the onium jet
                        IF(z1.LE.stop_zsoftcut/DBLE(n_oniumjet_track))THEN
                           icut=0
                           EXIT
                        ENDIF
                     ENDDO
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
      ENDIF
   ENDIF
ENDIF

! apply the two cutoff phase space slicing for the hard non-collinear part
! in NLO QCD correction (see hep-ph/0102128)
IF(use_twocutoff_slicing.AND.icut.EQ.1.AND.flag.EQ.0)THEN
   ! apply the collinear cuts
   s12=ehat**2*twocutoff_slicing_dc
   DO l1=3,n-1
      DO l2=l1+1,n
         IF(.NOT.twocutoff_stcuts(l1,l2))CYCLE
         s=2d0*scalar_product(phegas_pmom(l1,1:4),phegas_pmom(l2,1:4))&
              +scalar_product(phegas_pmom(l1,1:4),phegas_pmom(l1,1:4))&
              +scalar_product(phegas_pmom(l2,1:4),phegas_pmom(l2,1:4))
         IF(s.LT.s12)THEN
            icut=0
            EXIT
         ENDIF
      ENDDO
      IF(icut.EQ.0)EXIT
   ENDDO
   IF(icut.EQ.1)THEN
      DO l1=1,2
         DO l2=3,n
            IF(.NOT.twocutoff_stcuts(l1,l2))CYCLE
            t=scalar_product(phegas_pmom(l1,1:4),phegas_pmom(l1,1:4))&
                 +scalar_product(phegas_pmom(l2,1:4),phegas_pmom(l2,1:4))&
                 -2D0*scalar_product(phegas_pmom(l1,1:4),phegas_pmom(l2,1:4))
            IF(DABS(t).LT.s12)THEN
               icut=0
               EXIT
            ENDIF
         ENDDO
         IF(icut.EQ.0)EXIT
      ENDDO
      IF(icut.EQ.1)THEN
         Egcut=ehat/2d0*twocutoff_slicing_ds
         ! first boost back to cms (=partonic cms)
         ! the following have never been defined before
         q=ehat
         e=q/SQRT(xp1*xp2)
         exp1=ebeam(1)*xp1
         exp2=ebeam(2)*xp2
         IF(fixtarget)THEN
            IF(.NOT.fixtargetrev)THEN
               exp1=exp1+FT_M*xp1/2d0
               exp2=exp2/2d0
            ELSE
               exp1=exp1/2d0
               exp2=exp2+FT_M*xp2/2d0
            ENDIF
         ENDIF
         pboo(4)=(exp1+exp2)
         pboo(3)=(exp1-exp2)
         pboo(1:2)=0
         pboo(3)=-pboo(3)
         DO i=1,n
            CALL boostl(q,pboo,p(i,1:4))
         ENDDO
         DO l1=3,n
            IF(ifl(l1).NE.35)CYCLE
            IF(p(l1,4).LT.Egcut)THEN
               icut=0
               EXIT
            ENDIF
         ENDDO
         ! boost back to lab frame
         pboo(3)=-pboo(3)
         DO i=1,n
            CALL boostl(q,pboo,p(i,1:4))
         ENDDO
      ENDIF
   ENDIF
ENDIF


! special cuts for the DIS mode
IF(COLL_TYPE.GE.4.AND.COLL_TYPE.LE.7.AND.icut.EQ.1.AND.flag.EQ.0)THEN
   Qphoton(1:4)=p(1,1:4)-p(3,1:4)
   Q2=Qphoton(1)**2+Qphoton(2)**2+Qphoton(3)**2-Qphoton(4)**2
   IF(Q2max_ep.GT.0d0.AND.Q2.GT.Q2max_ep)THEN
      icut=0
   ENDIF
   IF(icut.EQ.1.AND.Q2min_ep.GE.0d0)THEN
      IF(Q2min_ep.GT.0d0)THEN
         Q2min=Q2min_ep
      ELSE
         xgamma=(Qphoton(4)+Qphoton(3))/(2d0*ebeam(1))
         ! use the Weizsacker-Williams approximation
         ! see eq.(3) in arXiv:2009.08264
         Q2min=mass_e**2*xgamma**2/(1d0-xgamma)
      ENDIF
      IF(Q2.LT.Q2min)THEN
         icut=0
      ENDIF
   ENDIF
ENDIF

!     ---
!     boost to the cms
!     ---
!IF(.NOT.(istruc.EQ.1.OR.istruc.EQ.2.OR..NOT.labeqcoll).OR.(imode.EQ.0.AND.NDecayChains.EQ.0))THEN ! why imode=0? because it has been boosted into lab frame when imode.NE.0 or withdecay chains (spin correlations)
IF(Momenta_Frame.EQ.2)THEN
   CALL labtocms()
ELSEIF(Momenta_Frame.EQ.3.AND..NOT.labeqcoll)THEN
   CALL labtocollision()
ENDIF
END SUBROUTINE cuts_HC

FUNCTION is_a_jet(ifh)
  IMPLICIT NONE
  LOGICAL::is_a_jet
  INTEGER,INTENT(IN)::ifh
  INTEGER::iff,init=0
  SAVE init
  LOGICAL,DIMENSION(12)::is_fermion_a_jet
  SAVE is_fermion_a_jet
  IF(ABS(ifh).GT.12.AND.ABS(ifh).NE.35)THEN
     is_a_jet=.FALSE.
     RETURN
  ENDIF
  IF(ifh.EQ.35)THEN
     is_a_jet=.TRUE.
     RETURN
  ENDIF
  iff=ABS(ifh)
  IF(MOD(iff,4).NE.0.AND.MOD(iff,4).NE.3)THEN
     is_a_jet=.FALSE.
     RETURN
  ENDIF
  IF(init.EQ.0)THEN
     is_fermion_a_jet(1:12)=.FALSE.
     IF(jet_n_flavour.GE.1)is_fermion_a_jet(4)=.TRUE.
     IF(jet_n_flavour.GE.2)is_fermion_a_jet(3)=.TRUE.
     IF(jet_n_flavour.GE.3)is_fermion_a_jet(8)=.TRUE.
     IF(jet_n_flavour.GE.4)is_fermion_a_jet(7)=.TRUE.
     IF(jet_n_flavour.GE.5)is_fermion_a_jet(12)=.TRUE.
     IF(jet_n_flavour.GE.6)is_fermion_a_jet(11)=.TRUE.
     init=1
  ENDIF
  is_a_jet=is_fermion_a_jet(iff)
  RETURN
END FUNCTION is_a_jet

FUNCTION is_an_onium(ifh)
  IMPLICIT NONE
  LOGICAL::is_an_onium
  INTEGER,INTENT(IN)::ifh
  is_an_onium=.FALSE.
  IF(ABS(ifh).GT.440000.AND.ABS(ifh).LE.449999)THEN
     is_an_onium=.TRUE.
     RETURN
  ENDIF
  IF(ABS(ifh).GT.550000.AND.ABS(ifh).LE.559999)THEN
     is_an_onium=.TRUE.
     RETURN
  ENDIF
  IF(ABS(ifh).GT.450000.AND.ABS(ifh).LE.459999)THEN
     is_an_onium=.TRUE.
     RETURN
  ENDIF
  RETURN
END FUNCTION is_an_onium

SUBROUTINE cuts_ehc(icut)
  IMPLICIT NONE
  INTEGER,INTENT(INOUT)::icut
  ! tempolarly using the hadron-hadron collider case cuts
  CALL cuts_HC(icut)
END SUBROUTINE cuts_ehc

SUBROUTINE readcuts_epem
IMPLICIT NONE
CHARACTER(len=24)::file
REAL(KIND(1d0))::cutoff,pi
INTEGER::i,j,i1,j1,l,k
REAL(KIND(1d0))::r
REAL(KIND(1d0))::el,eq,eg,cl,cq,cg,cll,clq,cqq,cgx,gqq,gll,gqqmax,gllmax,ptmiss
INTEGER,PARAMETER::udefault=45138,uinput=45139
INTEGER::iounit,flag=0
LOGICAL::lexist
! open default input file
INQUIRE(FILE=TRIM(input_dir)//"default.inp",EXIST=lexist)
IF(.NOT.lexist)THEN
	PRINT *,"Warning: the file default.inp does not exist ! STOP !"
	STOP
ENDIF
INQUIRE(FILE=TRIM(input_dir)//"default.inp",OPENED=lexist)
IF(lexist)THEN
    INQUIRE(FILE=TRIM(input_dir)//"default.inp",NUMBER=iounit)
	IF(iounit.NE.udefault)THEN
		PRINT *,"WARNING: the default.inp has been linked with another unit ! Close and reopen !"
		CLOSE(UNIT=iounit)
		OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
	ENDIF
ELSE
	OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
ENDIF
! open user's input file
IF(TRIM(Input_File)/="default.inp")THEN
    INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),EXIST=lexist)
	IF(.NOT.lexist)THEN
		PRINT *,"Warning: the file "//TRIM(Input_File)//" does not exist ! STOP !"
		STOP
	ENDIF
	INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),OPENED=lexist)
	IF(lexist)THEN
		INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),NUMBER=iounit)
		IF(iounit.NE.uinput)THEN
			PRINT *,"WARNING: the "//TRIM(Input_File)//" has been linked with another unit ! Close and reopen !"
			CLOSE(UNIT=iounit)
			OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
		ENDIF
	ELSE
		OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
	ENDIF
ELSE
    flag=1
ENDIF

cutoff=readvalue_r("cutoffe",flag)

PRINT *,'WARNING: CUTOFF SET AT',cutoff
ec(3:20)=0
c1(3:20)=1
c2(3:20)=1
cc(3:20,3:20)=1
gmas(3:20,3:20)=cutoff
gmasmax(3:20,3:20)=-1d0
pi=DACOS(-1.d0)

! minimum lepton energy
el=readvalue_r("minenl",flag)
! minimum quark  energy
eq=readvalue_r("minenq",flag)
! minimum photon energy
eg=readvalue_r("minenp",flag)
! maximum cos lepton with beam
cl=COS(readvalue_r("minanglb",flag)/180.d0*pi)
! maximum cos quark with beam
cq=COS(readvalue_r("minangqb",flag)/180.d0*pi)
! maximum cos photon with beam
cg=COS(readvalue_r("minangpb",flag)/180.d0*pi)
! maximum cos lepton with lepton
cll=COS(readvalue_r("minangll",flag)/180.d0*pi)
! maximum cos lepton with quark
clq=COS(readvalue_r("minanglq",flag)/180.d0*pi)
! maximum cos quark with quark
cqq=COS(readvalue_r("minangqq",flag)/180.d0*pi)
! maximum cos photon with fermions
cgx=COS(readvalue_r("minangpf",flag)/180.d0*pi)
! minimum mass quark with quark
gqq=readvalue_r("minmqqe",flag)
! minimum mass lepton with lepton (same flavour)
gll=readvalue_r("minmlle",flag)
! maximum mass quark with quark (-1 no cuts)
gqqmax=readvalue_r("maxmqqe",flag)
! maximum mass lepton with lepton (same flavour)
gllmax=readvalue_r("maxmlle",flag)
! minimum missing transverse momentum
ptmiss=readvalue_r("minptmiss",flag)

!END SUBROUTINE readcuts_epem
CLOSE(UNIT=udefault)
CLOSE(UNIT=uinput)

!SUBROUTINE Auto_epem_cuts
!IMPLICIT NONE
!INTEGER::i,i1,j,j1,l,k
DO i=3,n
   IF(ifl(i).LT.13)THEN
      i1=IABS(MOD(ifl(i),4))
   ELSE
      i1=ifl(i)
   ENDIF
   IF(i1.EQ.35)i1=0
   ec(i)=parmas(ifl(i))
!   photons
   IF(i1.EQ.31)THEN
        ec(i)=eg
        c1(i)=cg
        c2(i)=cg
    ENDIF
!   neutrinos
    IF(i1.EQ.1)THEN
        ptmissc=ptmiss
    ENDIF
!   ch. leptons
    IF(i1.EQ.2)THEN
        ec(i)=MAX(el,ec(i))
        c1(i)=cl
        c2(i)=cl
    ENDIF
!   quarks
    IF(i1.EQ.3.OR.i1.EQ.0)THEN
        ec(i)=MAX(eq,ec(i))
        c1(i)=cq
        c2(i)=cq
    ENDIF
ENDDO
    
DO i=3,n-1
    IF(ifl(i).LT.13)THEN
        i1=IABS(MOD(ifl(i),4))
    ELSE
        i1=ifl(i)
    ENDIF
    IF(i1.EQ.35)i1=0
    DO j=i+1,n
       IF(ifl(j).LT.13)THEN
           j1=IABS(MOD(ifl(j),4))
       ELSE
           j1=ifl(j)
       ENDIF
       IF(j1.EQ.35)j1=0
!  n-n
       IF(i1.EQ.1.OR.j1.EQ.1)THEN
!  l-q
       ELSEIF(i1.EQ.2.AND.(j1.EQ.3.OR.j1.EQ.0))THEN
           cc(i,j)=clq
!  l-l
       ELSEIF(i1.EQ.2.AND.j1.EQ.2)THEN
           cc(i,j)=cll
           IF(ifl(i)+ifl(j).EQ.0)THEN
              gmas(i,j)=gll
              gmasmax(i,j)=gllmax
           ENDIF
!  q-l
       ELSEIF(j1.EQ.2.AND.(i1.EQ.3.OR.i1.EQ.0))THEN
           cc(i,j)=clq
!  g-x  photon-charged
       ELSEIF(i1.EQ.31.AND.j1.NE.1)THEN
           cc(i,j)=cgx
!  x-g  charged-photon
       ELSEIF(j1.EQ.31.AND.i1.NE.1)THEN
           cc(i,j)=cgx
!  q-q
       ELSEIF((i1.EQ.3.OR.i1.EQ.0).AND.(j1.EQ.3.OR.j1.EQ.0))THEN
           cc(i,j)=cqq
           gmas(i,j)=gqq
           gmasmax(i,j)=gqqmax
!
       ENDIF
   ENDDO
ENDDO

DO l=4,20
   DO k=3,l-1
       gmas(l,k)=gmas(k,l)
       cc(l,k)=  cc(k,l)
       gmasmax(l,k)=gmasmax(k,l)
   ENDDO
ENDDO

WRITE(*,*)'---------------------------------------------------'
WRITE(*,*)'        the cuts        '
DO i=3,n
   WRITE(*,*)'energy of  ',i,ifl(i),'   particle   ',ec(i)
ENDDO
DO i=3,n
   WRITE(*,*)'cos-beam1 of ',i,ifl(i),'   particle   ',c1(i)
ENDDO
DO i=3,n
   WRITE(*,*)'cos-beam2 of ',i,ifl(i),'   particle   ',c2(i)
ENDDO

DO i=3,n-1
   DO j=i+1,n
      IF(i.NE.j)WRITE(*,*)'cos of ',i,ifl(i),'  with  ',j,ifl(j),'  ',cc(i,j)
   ENDDO
ENDDO

DO i=3,n-1
   DO j=i+1,n
      IF(gmasmax(i,j).GE.0d0.AND.gmasmax(i,j).LE.gmas(i,j))THEN
         WRITE(*,*)"Error: All events have been cutted away by the mass of ",i,ifl(i),'  with  ',j,ifl(j)
         STOP
      ENDIF
      IF(i.NE.j)WRITE(*,*)'minimum mass of ',i,ifl(i),'  with  ',j,ifl(j),'  ',gmas(i,j)
      IF(i.NE.j.AND.gmasmax(i,j).GE.0d0)WRITE(*,*)'maximum mass of ',i,ifl(i),'  with  ',j,ifl(j),'  ',gmasmax(i,j)
   ENDDO
ENDDO
WRITE(*,*)'minimum missing transverse momentum',ptmissc
WRITE(*,*)'---------------------------------------------------'

!END SUBROUTINE Auto_epem_cuts
END SUBROUTINE readcuts_epem
      
SUBROUTINE cuts_epem(icut)
IMPLICIT NONE
INTEGER,INTENT(OUT)::icut
REAL(KIND=DBL),DIMENSION(20,4)::p
INTEGER::l,l1,l2,i_nu,i1
REAL(KIND=DBL)::c,s,pmiss_E,pmiss_x,pmiss_y,pmiss_z,pt_miss
REAL(KIND=DBL),DIMENSION(4)::pboo
REAL(KIND=DBL)::exp1,exp2,q
INTEGER::i
IF(Momenta_Frame.EQ.2)THEN
   CALL cmstolab()
ELSEIF(Momenta_Frame.EQ.3.AND..NOT.labeqcoll)THEN
   CALL collisiontolab()
ENDIF
DO i=1,n
   p(i,1:4)=phegas_pmom(i,1:4)
ENDDO
! boost to lab frame when the collision frame is not equal to it 
!IF((.NOT.labeqcoll).AND.imode.EQ.0.AND.NDecayChains.EQ.0)THEN ! why imode.EQ.0 ? because it has been boosted into lab frame when imode.NE.0 or with decay chains (spin correlations)
!IF(.NOT.Need_Boost)THEN
!   q=ehat
!   exp1=ebeam(1)
!   exp2=ebeam(2)
!   pboo(4)=(exp1+exp2)
!   pboo(3)=(exp1-exp2)
!   pboo(1:2)=0
!! boost to the lab frame
!   DO i=1,n
!      CALL boostl(q,pboo,p(i,1:4))
!   ENDDO
!ENDIF
icut=0
DO l=3,n 
   IF(p(l,4).LT.ec(l))RETURN
   c=p(l,3)/p(l,4)
   IF( c.GT.c1(l))RETURN
   IF(-c.GT.c2(l))RETURN
ENDDO
       
DO l1=3,n
   DO l2=3,n
      IF(l1.EQ.l2.OR.Quarkonium3(l1).EQ.Quarkonium3(l2).AND.Quarkonium3(l1).NE.0)CYCLE
      IF(cosij(p(l1,1:3),p(l2,1:3)).GT.cc(l1,l2))RETURN
      s=2*scalar_product(p(l1,1:4),p(l2,1:4))&
         +scalar_product(p(l1,1:4),p(l1,1:4))&
         +scalar_product(p(l2,1:4),p(l2,1:4))
      IF(s.LT.gmas(l1,l2)**2)RETURN
      IF(gmasmax(l1,l2).GE.0d0.AND.s.GT.gmasmax(l1,l2)**2)RETURN
   ENDDO
ENDDO

i_nu=0
pmiss_E=0.d0
pmiss_x=0.d0
pmiss_y=0.d0
pmiss_z=0.d0
DO l=3,n
   IF(ifl(l).LT.13)THEN
      i1=IABS(MOD(ifl(l),4))
   ENDIF
   IF(i1.EQ.1)THEN       !neutrino found
      i_nu=1
      pmiss_E = pmiss_E + p(l,4)
      pmiss_x = pmiss_x + p(l,1)
      pmiss_y = pmiss_y + p(l,2)
      pmiss_z = pmiss_z + p(l,3)
   ENDIF
ENDDO
pt_miss=DSQRT((pmiss_x)**2+(pmiss_y)**2)
IF(i_nu.EQ.1 .AND. pt_miss.LT.ptmissc.OR.nhad.EQ.3)RETURN
icut=1
!IF((.NOT.labeqcoll).AND.imode.EQ.0.AND.NDecayChains.EQ.0)THEN ! why imode=0? because it has been boosted into lab frame when imode.NE.0 or with decay chains (spin correlations)
IF(Momenta_Frame.EQ.2)THEN
   CALL labtocms()
ELSEIF(Momenta_Frame.EQ.3.AND..NOT.labeqcoll)THEN
   CALL labtocollision()
ENDIF
!IF(.NOT.Need_Boost)THEN
!   pboo(3)=-pboo(3)
!   DO i=1,n
!      CALL boostl(q,pboo,p(i,1:4))
!   ENDDO
!ENDIF
END SUBROUTINE cuts_epem

FUNCTION fermionPDG(ifif)
  ! from HELAC-Onia notation to PDG notation for fermions
  IMPLICIT NONE
  INTEGER,INTENT(IN)::ifif
  INTEGER::fermionPDG,init=0,ifac
  INTEGER,DIMENSION(-12:12)::ipdt
  SAVE ipdt,init,ifac
  IF(init.EQ.0)THEN
     ipdt( 1)= 12
     ipdt(-1)=-12
     ipdt( 5)= 14
     ipdt(-5)=-14
     ipdt( 9)= 16
     ipdt(-9)=-16
     ipdt( 2)= 11
     ipdt(-2)=-11
     ipdt( 6)= 13
     ipdt(-6)=-13
     ipdt( 10)= 15
     ipdt(-10)=-15
     ipdt( 3)= 2
     ipdt(-3)=-2
     ipdt( 4)= 1
     ipdt(-4)=-1
     ipdt( 7)= 4
     ipdt(-7)=-4
     ipdt( 8)= 3
     ipdt(-8)=-3
     ipdt( 11)= 6
     ipdt(-11)=-6
     ipdt( 12)= 5
     ipdt(-12)=-5
     init=1
  ENDIF
  IF(ABS(ifif).LT.12)THEN
     fermionPDG=ipdt(ifif)
     RETURN
  ELSE
     WRITE(*,*)"ERROR: fermionPDG does not allow for ",ifif
     WRITE(*,*)"ERROR: generalize fermionPDG first !!"
     STOP
  ENDIF
END FUNCTION fermionPDG

FUNCTION QCD_initial_splitting_allowed(pdg1,pdg2)
  ! pdg1 -> pdg2
  IMPLICIT NONE
  LOGICAL::QCD_initial_splitting_allowed
  INTEGER,INTENT(IN)::pdg1,pdg2
  QCD_initial_splitting_allowed=.TRUE.
  ! g -> g
  IF(pdg1.EQ.35.AND.pdg2.EQ.35)RETURN
  ! g -> q
  IF(pdg1.EQ.35.AND.parmas(pdg2).EQ.0d0.AND.IABS(pdg2).LE.12&
       .AND.(MOD(IABS(pdg2),4).EQ.3.OR.MOD(IABS(pdg2),4).EQ.0))RETURN
  ! q -> g
  IF(pdg2.EQ.35.AND.parmas(pdg1).EQ.0d0.AND.IABS(pdg1).LE.12&
       .AND.(MOD(IABS(pdg1),4).EQ.3.OR.MOD(IABS(pdg1),4).EQ.0))RETURN
  ! q -> q
  IF(pdg1.EQ.pdg2.AND.parmas(pdg2).EQ.0d0.AND.IABS(pdg2).LE.12&
       .AND.(MOD(IABS(pdg2),4).EQ.3.OR.MOD(IABS(pdg2),4).EQ.0))RETURN
  QCD_initial_splitting_allowed=.FALSE.
  RETURN
END FUNCTION QCD_initial_splitting_allowed

FUNCTION QCD_final_splitting_allowed(pdg1,pdg2)
  ! pdg0 -> pdg1 pdg2
  IMPLICIT NONE
  LOGICAL::QCD_final_splitting_allowed
  INTEGER,INTENT(IN)::pdg1,pdg2
  QCD_final_splitting_allowed=.TRUE.
  ! g -> g g
  IF(pdg1.EQ.35.AND.pdg2.EQ.35)RETURN
  ! q -> g q
  IF(pdg1.EQ.35.AND.parmas(pdg2).EQ.0d0.AND.IABS(pdg2).LE.12&
       .AND.(MOD(IABS(pdg2),4).EQ.3.OR.MOD(IABS(pdg2),4).EQ.0))RETURN
  ! q -> q g
  IF(pdg2.EQ.35.AND.parmas(pdg1).EQ.0d0.AND.IABS(pdg1).LE.12&
       .AND.(MOD(IABS(pdg1),4).EQ.3.OR.MOD(IABS(pdg1),4).EQ.0))RETURN
  ! g -> q -q
  IF(pdg1.EQ.-pdg2.AND.parmas(pdg2).EQ.0d0.AND.IABS(pdg2).LE.12&
       .AND.(MOD(IABS(pdg2),4).EQ.3.OR.MOD(IABS(pdg2),4).EQ.0))RETURN
  QCD_final_splitting_allowed=.FALSE.
  RETURN
END FUNCTION QCD_final_splitting_allowed
END MODULE Cuts_Module
