MODULE FO_plot
  ! Wrapper routines for the fixed order analyses
  USE HELAC_Global
  USE plot_user
  USE Helac_Func_1
  IMPLICIT NONE
  INTEGER::max_weight=1 ! max_weight=maxscales*maxscales+maxpdfs+1
  SAVE
  !LOGICAL::do_rwgt_scale = .FALSE. ! now don't do reweight for scales
  !LOGICAL::do_rwgt_pdf = .FALSE. ! now don't do reweight for pdf
  !INTEGER::numscales=3
  !REAL(KIND(1d0))::rw_Fscale_up=1d0,rw_Fscale_down=1d0
  !REAL(KIND(1d0))::rw_Rscale_up=1d0,rw_Rscale_down=1d0
  !INTEGER::pdf_set_max,pdf_set_min,npdfs=1
  !INTERFACE outfun
  !   MODULE PROCEDURE outfun_c
  !   MODULE PROCEDURE outfun_u
  !END INTERFACE outfun
CONTAINS
  SUBROUTINE initplot
    IMPLICIT NONE
!    include 'run.inc'
!    include 'reweight0.inc'
    INTEGER::nwgt
    !INTEGER,PARAMETER::max_weight=3 ! max_weight=maxscales*maxscales+maxpdfs+1
    CHARACTER(len=15),DIMENSION(:),ALLOCATABLE::weights_info
    INTEGER::i
    IF(PDF_Hessian2MC.AND.Way_Hessian2MC.EQ.1)THEN
       IF(reweight_npdf)THEN
          ! it must be the nuclear PDF
          max_weight=1+ho_nscale+ho_nmuNRQCD+ho_npdf+N_MCPDFs+ho_nref
       ELSEIF(reweight_pdf)THEN
          ! it must be the proton PDF
          max_weight=1+ho_nscale+ho_nmuNRQCD+N_MCPDFs+ho_nnpdf+ho_nref
       ELSE
          WRITE(*,*)"ERROR: no reweighting for both PDF and nPDF but using Hessian to MC"
          STOP
       ENDIF
    ELSE
       max_weight=1+ho_nscale+ho_nmuNRQCD+ho_npdf+ho_npdf2+ho_nnpdf+ho_nref
    ENDIF
    IF(ALLOCATED(weights_info))THEN
       DEALLOCATE(weights_info)
    ENDIF
    ALLOCATE(weights_info(max_weight))
    nwgt=1
    weights_info(nwgt)="central value  "
    IF(reweight_scale)THEN
       nwgt=nwgt+ho_nscale
       IF(ho_nscale.NE.8)THEN
          WRITE(*,*) 'ERROR #1 in initplot:',ho_nscale
          STOP
       ENDIF
       WRITE(weights_info(nwgt-7),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",1.0,"muF=",rw_Fscale_up
       WRITE(weights_info(nwgt-6),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",1.0,"muF=",rw_Fscale_down
       WRITE(weights_info(nwgt-5),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_up,"muF=",1d0
       WRITE(weights_info(nwgt-4),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_up,"muF=",rw_Fscale_up
       WRITE(weights_info(nwgt-3),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_up,"muF=",rw_Fscale_down
       WRITE(weights_info(nwgt-2),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_down,"muF=",1d0
       WRITE(weights_info(nwgt-1),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_down,"muF=",rw_Fscale_up
       WRITE(weights_info(nwgt  ),'(a4,f3.1,x,a4,f3.1)')&
            "muR=",rw_Rscale_down,"muF=",rw_Fscale_down
    END IF
    IF(reweight_muNRQCD)THEN
       nwgt=nwgt+ho_nmuNRQCD
       IF(ho_nmuNRQCD.NE.2)THEN
          WRITE(*,*) 'ERROR #1 in initplot:',ho_nmuNRQCD
          STOP
       ENDIF
       WRITE(weights_info(nwgt-1),'(a8,f3.1,a2)')&
            "muNRQCD=",rw_muNRQCD_up,'  '
       WRITE(weights_info(nwgt  ),'(a8,f3.1,a2)')&
            "muNRQCD=",rw_muNRQCD_down,'  '
    ENDIF
    IF(reweight_pdf)THEN
       IF(PDF_Hessian2MC.AND.Way_Hessian2MC.EQ.1)THEN
          DO i=1,N_MCPDFs
             WRITE(weights_info(nwgt+i),'(a4,i10,a1)')&
                  'PDF=',900000000+i,' '
          ENDDO
          nwgt=nwgt+N_MCPDFs
       ELSE
          DO i=1,ho_npdf
             WRITE(weights_info(nwgt+i),'(a4,i8,a3)')&
                  'PDF=',ipdf_set_min-1+i,'   '
          ENDDO
          nwgt=nwgt+ho_npdf
          IF(ho_npdf2.GT.0)THEN
             DO i=1,ho_npdf2
                WRITE(weights_info(nwgt+i),'(a5,i8,a2)')&
                     'PDF2=',ipdf2_set_min-1+i,'  '
             ENDDO
             nwgt=nwgt+ho_npdf2
          ENDIF
       ENDIF
    ENDIF
    IF(reweight_npdf)THEN
       IF(PDF_Hessian2MC.AND.Way_Hessian2MC.EQ.1)THEN
          DO i=1,N_MCPDFs
             WRITE(weights_info(nwgt+i),'(a5,i9,a1)')&
                     'NPDF=',900000000+i,' '
          ENDDO
          nwgt=nwgt+N_MCPDFs
       ELSE
          IF(nPDF_id.EQ.1000)THEN
             DO i=1,ho_nnpdf
                WRITE(weights_info(nwgt+i),'(a5,i8,a2)')&
                     'NPDF=',inpdf_set_min+i-1-1000+iPDFSUP1,'  '
             ENDDO
          ELSE
             DO i=1,ho_nnpdf
                WRITE(weights_info(nwgt+i),'(a5,i8,a2)')&
                     'NPDF=',inpdf_set_min-1+i,'  '
             ENDDO
          ENDIF
          nwgt=nwgt+ho_nnpdf
       ENDIF
    ENDIF
    IF(reweight_ref)THEN
       DO i=1,ho_nref
          WRITE(weights_info(nwgt+i),'(a4,i8,a3)')&
               'REF=',iref_set_min-1+i,'   '
       ENDDO
       nwgt=nwgt+ho_nref
    ENDIF
    ! output plot files
    CALL plot_begin(nwgt,max_weight,weights_info)
    RETURN
  END SUBROUTINE initplot


  SUBROUTINE plotout
    USE MC_VEGAS
  ! output of plot files
    IMPLICIT NONE
    LOGICAL::usexinteg=.FALSE.,mint=.FALSE. ! I have not implemented MINT
!    common/cusexinteg/usexinteg,mint
    !INTEGER::itmax=1,ncall
!    common/citmax/itmax,ncall
    LOGICAL::useitmax=.TRUE.
!    common/cuseitmax/useitmax
    REAL(KIND(1d0))::xnorm

    IF(usexinteg.AND..NOT.mint.AND.gener.EQ.3)THEN
       xnorm=1.d0/float(itmx)
    ELSEIF(mint)THEN
       xnorm=1.d0/float(ntotps)
    ELSEIF(gener.NE.3)THEN ! not vegas
       xnorm=1.d0/float(ntotps)
    ELSE
       xnorm=1d0
    ENDIF
    IF(useitmax.AND.gener.EQ.3)xnorm=xnorm/float(itmx) ! use vegas with itmax
    ! output plot files
    CALL plot_end(xnorm)
    RETURN                
  END SUBROUTINE plotout


  SUBROUTINE outfun(www)
    IMPLICIT NONE
    !include 'run.inc'
    !include 'genps.inc'
    !include 'reweight.inc'
    !include 'reweightNLO.inc'
    REAL(KIND(1d0)),INTENT(IN)::www
    INTEGER::i,j
    !REAL(KIND(1d0)),DIMENSION(3)::xd=(/0d0,0d0,1d0/)
    !INTEGER,PARAMETER::maxflow=999
    INTEGER::nwgt
    REAL(KIND(1d0))::alphasc,alphasu,alphasd
    REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::wgts !,wgtden
    INTEGER::init=0
    SAVE init,wgts
    ! it is necessary for using Phegas
    IF(www.EQ.0d0)RETURN
    IF(init.EQ.0)THEN
       IF(PDF_Hessian2MC.AND.Way_Hessian2MC.EQ.1)THEN
          IF(reweight_npdf)THEN
             max_weight=1+ho_nscale+ho_nmuNRQCD+ho_npdf+N_MCPDFs+ho_nref
          ELSEIF(reweight_pdf)THEN
             max_weight=1+ho_nscale+ho_nmuNRQCD+N_MCPDFs+ho_nnpdf+ho_nref
          ELSE
             WRITE(*,*)"ERROR: no reweighting for both PDF and nPDF but using Hessian to MC"
             STOP
          ENDIF
       ELSE
          max_weight=1+ho_nscale+ho_nmuNRQCD+ho_npdf+ho_npdf2+ho_nnpdf+ho_nref
       ENDIF
       IF(ALLOCATED(wgts))THEN
          DEALLOCATE(wgts)
       ENDIF
       ALLOCATE(wgts(max_weight))
       init=1
    ENDIF
    nwgt=1
    wgts(1)=www
    IF(reweight_scale)THEN
       DO i=1,3
          DO j=1,3
             IF(i.EQ.1.AND.j.EQ.1)CYCLE
             nwgt=nwgt+1
             wgts(nwgt)=www*wgtxsecmu(i,j)
          ENDDO
       ENDDO
    ENDIF
    IF(reweight_muNRQCD)THEN
       DO i=2,3
          nwgt=nwgt+1
          wgts(nwgt)=www*wgtxsecmuNRQCD(i)
       ENDDO
    ENDIF
    IF(reweight_pdf)THEN
       IF(PDF_Hessian2MC.AND.Way_Hessian2MC.EQ.1)THEN
          DO i=1,N_MCPDFs
             nwgt=nwgt+1
             wgts(nwgt)=www*wgtxsecpdf(i)
          ENDDO
       ELSE
          DO i=1,ho_npdf+ho_npdf2
             nwgt=nwgt+1
             wgts(nwgt)=www*wgtxsecpdf(i)
          ENDDO
       ENDIF
    ENDIF
    IF(reweight_npdf)THEN
       IF(PDF_Hessian2MC.AND.Way_Hessian2MC.EQ.1)THEN
          DO i=1,N_MCPDFs
             nwgt=nwgt+1
             wgts(nwgt)=www*wgtxsecnpdf(i)
          ENDDO
       ELSE
          DO i=1,ho_nnpdf
             nwgt=nwgt+1
             wgts(nwgt)=www*wgtxsecnpdf(i)
          ENDDO
       ENDIF
    ENDIF
    IF(reweight_ref)THEN
       DO i=1,ho_nref
          nwgt=nwgt+1
          wgts(nwgt)=www*wgtxsecref(i)
       ENDDO
    ENDIF
    ! output plot file
    CALL plot_fill(wgts)
    RETURN
  END SUBROUTINE outfun
  
END MODULE FO_plot
