MODULE Helac_Global
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This file includes the global variables in the helac-onia
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
IMPLICIT NONE
SAVE
INTEGER,PARAMETER::SGL=SELECTED_REAL_KIND(p=6)
INTEGER,PARAMETER::DBL=SELECTED_REAL_KIND(p=13)
!REAL(KIND=DBL),PARAMETER::pi=3.1415926535897932385d0
! vertex  common_coup.h
COMPLEX(KIND=DBL),DIMENSION(31:35,31:35,31:35),PUBLIC::zgv3
COMPLEX(KIND=DBL),DIMENSION(31:36,31:36,31:36),PUBLIC::zgvvx
COMPLEX(KIND=DBL),DIMENSION(31:35,31:35,31:35,31:35),PUBLIC::zgv4
COMPLEX(KIND=DBL),DIMENSION(31:35,-12:-1,1:12),PUBLIC::zgvffl
COMPLEX(KIND=DBL),DIMENSION(31:35,-12:-1,1:12),PUBLIC::zgvffr
COMPLEX(KIND=DBL),DIMENSION(31:35,31:35,41:44),PUBLIC::zgvvs
COMPLEX(KIND=DBL),DIMENSION(41:44,31:35,31:35),PUBLIC::zgsvv
COMPLEX(KIND=DBL),DIMENSION(31:35,41:44,41:44),PUBLIC::zgvss
COMPLEX(KIND=DBL),DIMENSION(41:44,41:44,31:35),PUBLIC::zgssv
COMPLEX(KIND=DBL),DIMENSION(31:35,31:35,41:44,41:44),PUBLIC::zgvvss
COMPLEX(KIND=DBL),DIMENSION(41:44,41:44,31:35,31:35),PUBLIC::zgssvv
COMPLEX(KIND=DBL),DIMENSION(41:44,-12:-1,1:12),PUBLIC::zgsffl
COMPLEX(KIND=DBL),DIMENSION(41:44,-12:-1,1:12),PUBLIC::zgsffr
COMPLEX(KIND=DBL),DIMENSION(41:45,41:45,41:45),PUBLIC::zgs3
COMPLEX(KIND=DBL),DIMENSION(41:44,41:44,41:44,41:44),PUBLIC::zgs4
! masses & widths   common_masses.h
REAL(KIND=DBL),DIMENSION(-12:44),PUBLIC::parmas,parwid
! flags: iflag=0 sum over all helicity configurations
!              1 specific helicity configuration
!        iunitary=0  Feynman gauge
!                 1  unitary gauge
!        ihiggs=0    not inclusion the higgs particle as an intermediate state
!               1    inclusion the higgs particle as an intermediate state
!        iwidth=0    fixed scheme for the introduction of the width of W and Z
!               1    complex scheme for the introduction of the width of W and Z
! common_flags.h
INTEGER,PUBLIC::iflag,iunitary,ihiggs,iwidth
! common_print.h
INTEGER,PUBLIC::nunit1=6,nunit2,nunit3,nunit30
! common_strf.h
REAL(KIND=DBL),PUBLIC::wjac,xp1,xp2,scale,ehat
INTEGER,PUBLIC::istruc,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2  ! istruc=1 need pdfs
INTEGER,PUBLIC::beam_alphas=1 ! when there are two different PDFs, decide to use which one
                                                         ! istruc=0 don't need pdfs, such as e+e-
INTEGER,PARAMETER::photon_ePDF_id=-999,photon_pPDF_id=-1000
REAL(KIND=DBL),DIMENSION(2),PUBLIC::ebeam           ! beam energy, so that the lab frame don't have to in collision c.m.
LOGICAL,PUBLIC::absrap=.TRUE.,labeqcoll=.TRUE.
!common_lha.h
REAL(KIND=DBL),PUBLIC::aqedup=-1d0,aqcdup=-1d0
!common_qcdrun.h
INTEGER::irun
LOGICAL::onlyqcd,withqcd
LOGICAL::useMCFMrun=.TRUE. ! use the MCFM alpha_s running (new)
LOGICAL::uselhapdf=.FALSE. ! use the LHAPDF (new)
LOGICAL::lhapdfwrapinit=.FALSE. ! a tag for using lhapdfwrap, which forbid it before calling LHAPDF but after alphasPDF
LOGICAL::mlhapdfwrapinit=.FALSE. ! a tag for using mlhapdfwrap, which forbid it before calling LHAPDF but after alphasPDF 
CHARACTER(len=150)::LHAPath="" ! the path of the LHAPDF
LOGICAL::reweight_pdf=.FALSE. ! use reweighting to estimate pdf uncertainty
INTEGER::ipdf_set_min=21101   ! the first of the error pdf sets
INTEGER::ipdf_set_max=21140   ! the last of the error pdf sets
INTEGER::ipdf2_set_min=-1     ! the first of the error pdf sets for beam 2
INTEGER::ipdf2_set_max=-1     ! the first of the error pdf sets for beam 2
LOGICAL::multipdfloading=.FALSE. ! a flag to see whether we need multiple PDF loading
LOGICAL::beams_pdf_correlation=.FALSE. ! whether need to take full correlation between two beam PDFs
LOGICAL::reweight_npdf=.FALSE. ! use reweighting to estimate npdf uncertainty
INTEGER::inpdf_set_min=402    ! the first of the error npdf sets
INTEGER::inpdf_set_max=431    !  the last of the error npdf sets
INTEGER::isave_nPDF_LHAPDF6=0  ! a global variable for saving the nPDF
LOGICAL::reweight_ref=.FALSE. ! use reweighting to calculate the references
INTEGER::iref_set_min=1       ! the first of the ref set
INTEGER::iref_set_max=1       ! the last of the ref set
LOGICAL::reweight_scale=.FALSE. ! use reweighting to estimate scale uncertainty
REAL(KIND=DBL)::rw_Rscale_down=0.5d0   ! lower bound for ren scale variations
REAL(KIND=DBL)::rw_Rscale_up=2.0d0     ! upper bound for ren scale variations
REAL(KIND=DBL)::rw_Fscale_down=0.5d0   ! lower bound for fac scale variations
REAL(KIND=DBL)::rw_Fscale_up=2.0d0     ! upper bound for fac scale variations 
LOGICAL::reweight_scale_phase=.FALSE.
INTEGER::alphas_power=0,ho_nscale=0,ho_npdf=0,ho_npdf2=0,ho_nnpdf=0,ho_nref=0,ho_nmuNRQCD=0
INTEGER::n_alphas_power_fail=0
INTEGER,PARAMETER::n_alphas_power_max=4,n_alphas_power_fail_max=2
INTEGER::tot_nrwgt=0
REAL(KIND=DBL),DIMENSION(:),ALLOCATABLE::rwgt_values
REAL(KIND=DBL),DIMENSION(3,3)::wgtxsecmu
REAL(KIND=DBL),DIMENSION(3)::wgtxsecmuNRQCD
INTEGER::reweight_Fscale_phase=0
REAL(KIND=DBL),DIMENSION(:),ALLOCATABLE::wgtxsecpdf
INTEGER,DIMENSION(:),ALLOCATABLE::idpdf
INTEGER,DIMENSION(:),ALLOCATABLE::idpdf2
REAL(KIND=DBL),DIMENSION(:),ALLOCATABLE::wgtxsecnpdf
INTEGER,DIMENSION(:),ALLOCATABLE::idnpdf
REAL(KIND=DBL),DIMENSION(:),ALLOCATABLE::wgtxsecref
INTEGER,DIMENSION(:),ALLOCATABLE::idref
! constants.h
REAL(KIND=DBL),PUBLIC::gfermi=1.16639d-5 ! Fermi coupling constant in GeV^(-2)
REAL(KIND=DBL),PUBLIC::rzm=91.188d0      ! the mass of Z in GeV
REAL(KIND=DBL),PUBLIC::rwm=80.419d0      ! the mass of W in GeV
REAL(KIND=DBL),PUBLIC::rzw=2.446d0       ! the width of Z in GeV
REAL(KIND=DBL),PUBLIC::rww=2.048d0       ! the width of W in GeV
REAL(KIND=DBL),PUBLIC::alphaQCD2=0.118d0  ! alphas(mZ)=0.118
REAL(KIND=DBL),PUBLIC::rhm=130.0d0       ! the mass of Higgs in GeV
REAL(KIND=DBL),PUBLIC::rhw=4.291d-3      ! the width of Higgs in GeV
REAL(KIND=DBL),PUBLIC::relm=0d0           ! the mass of electon in GeV
REAL(KIND=DBL),PUBLIC::rum=0d0           ! the mass of u quark in GeV
REAL(KIND=DBL),PUBLIC::rdm=0d0           ! the mass of d quark in GeV
REAL(KIND=DBL),PUBLIC::rsm=0d0           ! the mass of s quark in GeV
REAL(KIND=DBL),PUBLIC::rmum=0.1134289257d0 ! the mass of muon in GeV
REAL(KIND=DBL),PUBLIC::rtaum=1.777d0     ! the mass of tau in GeV
REAL(KIND=DBL),PUBLIC::rcm=1.5d0           ! the mass of Charm quark in GeV
REAL(KIND=DBL),PUBLIC::rbm=4.5d0           ! the mass of Beauty quark in GeV
REAL(KIND=DBL),PUBLIC::rtm=174.3d0       ! the mass of Top quark in GeV
REAL(KIND=DBL),PUBLIC::rtw=1.6d0         ! the width of Top quark in GeV
REAL(KIND=DBL),PUBLIC::alphaem=1d0/137d0     ! alpha_em
INTEGER,PUBLIC::nloop=1           ! running of alphaQCD with order (new added one)
CHARACTER(len=7),PUBLIC::pdlabel="cteq6l1" ! pdf label (new added one) 
! common_int.h
INTEGER,PUBLIC::n,nhad                            ! number of parton/hadron particles involved
INTEGER,DIMENSION(20),PUBLIC::io,ioh,&                ! =1 incoming =-1 outgoing
                              ifl,iflh            ! flavor for partons and hadrons
INTEGER,DIMENSION(20),PUBLIC::iflh_CT,iflh_BU,RG_CT_type ! flavor for those in process.inp when calc_LDME_RG_CT=T
                                         ! while iflh(_BU) is flavor for those in process_RG.inp when calc_LDME_RG_CT=T
                                         ! if calc_LDME_RG_CT=F, iflh_CT(iflh_BU) and process_RG.inp will not be used
                                         ! and only iflh and process.inp will be used (the normal way)
! common_feyn.h
!REAL(KIND=DBL),DIMENSION(20,5),PUBLIC::pmom
INTEGER,PUBLIC,PARAMETER::ISMAX=50000
INTEGER,PUBLIC::ng=0
INTEGER,DIMENSION(ISMAX,11,8),PUBLIC::is
! helicity and colors common_helc.h
INTEGER,DIMENSION(20),PUBLIC::ipol                !ipol(k)=2:rigth-handed 
                                                  !ipol(k)=1:left-handed 
                                                  !ipol(k)=3:long
INTEGER,DIMENSION(20,2),PUBLIC::icol
! common_new.h
REAL(KIND=DBL),PUBLIC::avhel,&                    ! average over helicity
                       avcol,&                    ! average over color
					   symet                      ! symmetry factors         
INTEGER,PUBLIC::ncc                               ! the number of color configurations
INTEGER,PUBLIC::nhc                               ! the number of helicity configurations
INTEGER,PUBLIC::nphyhc                            ! the number of physical helicity configurations
INTEGER,PUBLIC::imc,iranhel                       ! iranhel=0,we use the specific helicity
                                                  ! iranhel=1, use random helicity in Helac_pan1
												  ! iranhel=2, use random helicity for eps(L_z) too
												  ! iranhel=3, use random helicity for Lz and Sz
												  ! similar for imc in Helac_master_f (color selection)
REAL(KIND=DBL),PUBLIC::repeat                     ! repeat=0 run both phase of Helac_Phegas
                                                  ! repeat=1 run only the first phase
												  ! repeat=2 run only the second phase
! common_unweight.h
LOGICAL,PUBLIC::lwri   
! common_unw.h         
INTEGER,DIMENSION(20,2),PUBLIC::icol_un
! common_onep.h
LOGICAL,PUBLIC::onep                         ! onep=.TRUE. the user supply the phase space point
CHARACTER(100)::momfile='Mom'      ! if onep=.TRUE. the name of the input file of the momenta
CHARACTER(100)::momout='Momout'               ! name of output file if onep=.TRUE.
! parameter_NCOL.h
INTEGER,PARAMETER,PUBLIC::NCOL=3                  ! SUNN=3
! nguess.h
! enlarge the following number to have higher-multiplity process
! 1500 -> 5500
INTEGER,PARAMETER,PUBLIC::ngues=5500
! common_mom.h
!zq(1:n,1)=(p0+pz,pz);zq(1:n,2)=(p0-pz,pt);zq(1:n,3)=(px,py);
!zq(1:n,4)=(px,-py);zq(1:n,5)=(m,p)
! zQq is the momenta for hadron array
COMPLEX(KIND=DBL),DIMENSION(20,5),PUBLIC::zq   !,zQq
!common_phegas_mom.h
REAL(KIND=DBL),DIMENSION(20,5),PUBLIC::phegas_pmom
REAL(KIND=DBL),DIMENSION(20,5),PUBLIC::hadron_pmom
! common_norm.h
REAL(KIND=DBL),PUBLIC::wrest
! common_warn.h
INTEGER,DIMENSION(25),PUBLIC::iwarning,iwonders
! common_psp.h
INTEGER,PUBLIC::i_psp
! common_debug.h
INTEGER,PUBLIC::idebug=0  ! idebug=1 input some information on the screen
                        ! in Subroutine Helac_optimize in Main_Program.f90
! common_cuts.h various cut parameters
REAL(KIND=DBL),DIMENSION(3:20),PUBLIC::ec,c1,c2
REAL(KIND=DBL),DIMENSION(3:20,3:20),PUBLIC::cc,gmas,gmasmax
REAL(KIND=DBL),DIMENSION(3:20),PUBLIC::ptc,etac,yycut,yycutlow,xFcut,xFcutlow,maxptc
LOGICAL::xFcutflag=.FALSE.
REAL(KIND=DBL),DIMENSION(3:20,3:20),PUBLIC::drc
REAL(KIND=DBL),PUBLIC::ptmissc
! special for NLO* and NNLO* in pp(bar) collisions
REAL(KIND=DBL),DIMENSION(1:2,3:20),PUBLIC::gbeammass
! jet related cuts
REAL(KIND=DBL),PUBLIC::minptjet,maxptjet,maxrapjet,jet_radius
INTEGER,PUBLIC::jetalg,max_n_jet,min_n_jet,jet_n_flavour
! STOP cuts
LOGICAL,PUBLIC::use_stop_cut=.FALSE.
INTEGER,PUBLIC::stop_min_n_jet,stop_max_n_jet,stop_jetalg
INTEGER,PUBLIC::stop_n_frag_gluon,stop_n_frag_quark
REAL(KIND=DBL),PUBLIC::stop_maxrapjet,stop_jet_radius,stop_minptjet,stop_jet_dyn_radius
REAL(KIND=DBL),PUBLIC::stop_zcut,stop_beta,stop_zsoftcut
REAL(KIND=DBL),PUBLIC::stop_zasymcut
! two cutoff phase space slicing cuts
LOGICAL,PUBLIC::use_twocutoff_slicing=.FALSE.
REAL(KIND=DBL),PUBLIC::twocutoff_slicing_ds=1d-3
REAL(KIND=DBL),PUBLIC::twocutoff_slicing_dc=1d-6
LOGICAL,DIMENSION(20,20),PUBLIC::twocutoff_stcuts
! cuts for ep collisions
REAL(KIND=DBL),PUBLIC::Q2max_ep,Q2min_ep
! matrix element stability check: this is necessary for two cutoff phase space slicing
LOGICAL,PUBLIC::me_stability_check=.FALSE.
REAL(KIND=DBL),PUBLIC::me_stability_threshold=-1d0
! QCD colour factors
INTEGER, PARAMETER,PUBLIC:: QCD_nf_default = 5
REAL(KIND=DBL),PARAMETER,PUBLIC:: QCD_CA=3d0
REAL(KIND=DBL),PARAMETER,PUBLIC:: QCD_CF=4d0/3d0
REAL(KIND=DBL),PARAMETER,PUBLIC:: QCD_TF=0.5d0
REAL(KIND=DBL),PARAMETER,PUBLIC:: QCD_nfTF_default = QCD_nf_default*QCD_TF
REAL(KIND=DBL),PUBLIC:: QCD_nfTF = QCD_nfTF_default
INTEGER,PUBLIC:: QCD_nf = QCD_nf_default
INTEGER,PUBLIC:: QCD_nf_up = QCD_nf_default/2
INTEGER,PUBLIC:: QCD_nf_down = (QCD_nf_default+1)/2
REAL(KIND=DBL),PUBLIC:: QCD_rnf = DBLE(QCD_nf_default)
! beta functions in terms of as/2/pi expansion
! should be evaluated by routine HO_GET_QCD_BETA
REAL(KIND=DBL),PUBLIC:: QCD_beta0, QCD_beta1, QCD_beta2, QCD_beta3, QCD_beta4
! Input filename
CHARACTER(len=20),PARAMETER::Input_File="user.inp"
CHARACTER(len=24),PARAMETER::input_dir="./input/"
CHARACTER(len=24),PARAMETER::tmp_dir="./tmp/"
CHARACTER(len=24),PARAMETER::output_dir="./output/"
CHARACTER(len=24),PARAMETER::decay_dir="./decay/"
! some keywords
LOGICAL::ktrw=.FALSE.
INTEGER::COLL_TYPE=1  ! colpar   1=pp  2=ppbar  3=epem 4=ep-p 5=em-p 6=ep-pbar 7=em-pbar
                      !          8=gamma(from e)p 9=gamma(from e)pbar 10=gamma(from p elastic)p 11=gamma(from p elastic)pbar
                      !          12=gamma(from e)gamma(from e), 13=gamma(from e)gamma(from p elastic), 
                      !          14=gamma(from p elastic)gamma(from p elastic)
                      !          15=resolved photon(from e) p, 16=resolved photon(from e) pbar
                      !          17=direct photon p, 18=direct photon pbar
                      !          19=resolved photon p, 20=resolved photon pbar
INTEGER::CONSTNUM=0   ! 0 use the default constants value, 1 use the user defined
INTEGER::MaxAdapt=15   ! the value for maxadap_adapt in Adapt.f90
CHARACTER(len=20)::histo_file="hi_file",error_file='err_file'
LOGICAL::SUMMATIONQ=.FALSE.
INTEGER::GLOBALINIT_Phegas=0,GLOBALINIT_Bookin=0,GLOBALINIT_Sethel=0,&
         GLOBALINIT_master=0,GLOBALINIT_optimize=0,GLOBALINIT_feyn=0,GLOBALINIT_average=0,&
		 GLOBALINIT_checkgluons=0,GLOBALINIT_id=0,GLOBALINIT_id2=0,GLOBALINIT_id3=0,&
		 GLOBALINIT_unwei=0,GLOBALINIT_redo=0,GLOBALINIT_setmin=0,GLOBALINIT_setmax=0,&
		 GLOBALINIT_gen_x=0,GLOBALINIT_adapt_gen=0,GLOBALINIT_physicalpol=0,GLOBALINIT_mader=0,&
		 GLOBALINIT_ls2j=0,GLOBALINIT_physicalpol2=0,GLOBALINIT_idoctet=0
! appendix A of Phys.Rev.D  57 (1998)  4258
! 1: Recoil(Helicity) frame  2:Collins-Soper frame  3: Gottfried-Jackson frame  4: Target frame
INTEGER::PolarFrame=1       ! Polarization frames
INTEGER,DIMENSION(10,3)::Quarkonium
INTEGER,DIMENSION(20)::Quarkonium2,Quarkonium3   ! hadron and parton
REAL(KIND=DBL),DIMENSION(20)::Qhelran          ! the random number for Quarkonium when iranhel=2
REAL(KIND=DBL),DIMENSION(20)::Decayran
                                                 ! i.e.r(eps(L_z))
REAL(KIND=DBL),DIMENSION(20)::QSzran           ! the random number for Quarkonium when iranhel=3
                                                ! i.e. r(eps(S_z))
! the Pt for the first hadron
REAL(KIND=DBL)::PTFirst=3d0
LOGICAL::dSigmadPTQ=.FALSE.
INTEGER::Pwavenum=0                               ! the number of P wave
INTEGER,DIMENSION(10)::Pwave                     ! returns the number of hadron in p wave array
INTEGER,DIMENSION(20)::PwaveQ                    ! returns the number of p wave in hadron array
! used in helicity selection of Helac_iniqq in Helac_pan1.f90
!INTEGER::rannum
! Color Singlet Long Distance Matrix Elements
! Long Distance Matrix Element <O(3S1[1])>=|R(0)|^2/4/Pi
! in JHEP 02 (2008) 102  <O(3S1[1])>=(2J+1)*2Nc*|R(0)|^2/4/Pi,
! i.e. LDME****1=<O(2S+1)LJ[1]>/2Nc/(2J+1)
! For p-wave <O(3P0[1])>=<O(3P1[1])>=<O(3P2[1])>=3*|R'(0)|^2/4/Pi
! Charmonium System
REAL(KIND=DBL),PUBLIC::LDME441001=0.0644578d0,LDME443011=0.0644578d0,&
LDME441111=0.0179049d0,LDME443101=0.0179049d0,LDME443111=0.0179049d0,&
LDME443121=0.0179049d0
! Bottonium System
REAL(KIND=DBL),PUBLIC::LDME553011=0.515556d0,LDME551001=0.515556d0,&
LDME551111=0.515556d0,LDME553101=0.515556d0,LDME553111=0.515556d0,&
LDME553121=0.515556d0
! Bc System
REAL(KIND=DBL),PUBLIC::LDME453011=0.122667d0,LDME451001=0.122667d0,&
LDME451111=0.0478333d0,LDME453101=0.0478333d0,LDME453111=0.0478333d0,&
LDME453121=0.0478333d0
! Color Octet(3*3bar) Long Distance Matrix Elements
! in JHEP 02 (2008) 102 LDME****8=<O((2S+1)LJ[8])>/(Nc^2-1)/(2J+1)
! Charmonium System
REAL(KIND=DBL),PUBLIC::LDME441008=0.0095d0,LDME443018=0.00265d0,&
LDME441118=0.134287d-2,LDME443108=0.134287d-2,LDME443118=0.134287d-2,&
LDME443128=0.134287d-2
! Bottonium System
REAL(KIND=DBL),PUBLIC::LDME551008=0.386667d-2,LDME553018=0.386667d-2,&
LDME551118=0.386667d-2,LDME553108=0.386667d-2,LDME553118=0.386667d-2,&
LDME553128=0.386667d-2
! Bc System
REAL(KIND=DBL),PUBLIC::LDME451008=0.920004d-3,LDME453018=0.920004d-3,&
LDME451118=0.35875d-3,LDME453108=0.35875d-3,LDME453118=0.35875d-3,&
LDME453128=0.35875d-3
REAL(KIND=DBL),PUBLIC::LDMEwt
! whether to calculate LDME subtraction counterterm via RG in NRQCD
LOGICAL,PUBLIC::calc_LDME_RG_CT
! the rapidity (not pesudo) cut for the first final particle
REAL(KIND=DBL),PUBLIC::y1cup,y1clow
! the rapidity (not pesudo) cut for the second final particle
!REAL(KIND=DBL),PUBLIC::y2cup,y2clow
! The scale scheme
INTEGER,PUBLIC::nscheme=0
! The scale value in fixed scheme (nscheme=0)
REAL(KIND=DBL),PUBLIC::fschemevalue=12.8d0,scalefactor=1d0
REAL(KIND=DBL),PUBLIC::muR_over_ref=1d0,muF_over_ref=1d0,muNRQCD=1.5d0
LOGICAL,PUBLIC::LDME_RG_RUN  ! whether to perform RG running of LDMEs
LOGICAL,PUBLIC::muNRQCD_eq_QMass ! if LDME_RG_RUN=T, the central muNRQCD scale takes 
                                 ! heavy quark mass when muNRQCD_eq_QMass = T 
                                 ! or the value of muNRQCD whenmuNRQCD_eq_QMass = F
INTEGER,DIMENSION(2),PUBLIC::LDMES_powers=(/0,0/) ! powers for 1 (LDMEcc1S01), 2 (LDMEbb1S01)
REAL(KIND=DBL),DIMENSION(2),PUBLIC::onia_muNRQCD0,LDMES_MQ
REAL(KIND=DBL),DIMENSION(2),PUBLIC::LDMES_central,LDMES_up,LDMES_down
LOGICAL,PUBLIC::reweight_muNRQCD=.FALSE. ! reweight to obtain the NRQCD scale dependence
REAL(KIND=DBL)::rw_muNRQCD_down=0.5d0   ! lower bound for NRQCD scale variations
REAL(KIND=DBL)::rw_muNRQCD_up=2.0d0     ! upper bound for NRQCD scale variations
! scale for the elastic photon from beams,alphaem value for the WW structure function (<0 same as hard process)
REAL(KIND=DBL),PUBLIC::scale_elasticphoton=2d0,alphaem_elasticphoton=-1d0
LOGICAL,PUBLIC::exp3pjQ
INTEGER,PUBLIC::imode,iLSJ,ihel1,ihel2
INTEGER,PUBLIC::Num3pj
INTEGER,DIMENSION(10),PUBLIC::Pwave3pj     ! returns the number of hadron in 3pj wave array
INTEGER,DIMENSION(20),PUBLIC::Pwave3pjQ    ! returns the number of 3pj wave in hadron array
INTEGER,DIMENSION(10),PUBLIC::JNum3pj      ! returns J number in 3pj wave array
INTEGER,PUBLIC::PhyPolNum=0,SDPart=0,iqnum
LOGICAL,PUBLIC::FirstHelicityQ=.TRUE.,qsumQ=.FALSE.
INTEGER,PUBLIC::gener
INTEGER,DIMENSION(20),PUBLIC::hadron2parton  ! return the first parton index in hadron array
INTEGER,DIMENSION(20),PUBLIC::parton2hadron  ! return the  hadron index in parton array
INTEGER,DIMENSION(20),PUBLIC::parton2hadrontype ! return whether the parton i is charmonium (1), bottonium (2), Bc(3), no (0)
INTEGER,PUBLIC::octetmsinglet=0 ! the integer for choosing whether the nonet component or singlet component in octet
LOGICAL,PUBLIC::octetQ=.FALSE.
INTEGER,PUBLIC::octetnum
INTEGER,DIMENSION(10),PUBLIC::octetlist
! kt-measure
INTEGER,PUBLIC::ktmeasure=1 ! 1: ordinary ktmeasure 2: ktmeasure in SHERPA or MG
REAL(KIND=DBL),PUBLIC::RR=1d0 ! parameter R or D
! a flag for whether only measure speed or not
LOGICAL,PUBLIC::measurespeed
! number of lhe events
INTEGER,PUBLIC::Nevents=0
INTEGER,PUBLIC::ntotps=0
! str for the process
CHARACTER(len=400)::process
! plot flags
LOGICAL::plot_output=.FALSE.
LOGICAL::topdrawer_output=.FALSE.
LOGICAL::gnuplot_output=.FALSE.
LOGICAL::root_output=.FALSE.
LOGICAL::hwufile_output=.FALSE.
! shower variables
! emep_ISR_shower=0 or 1
! 0 is no shower
! 1 is QEDPS
INTEGER::emep_ISR_shower=0
REAL(KIND(1d0))::Q2OUT_QEDPS,Q2MAX_QEDPS
! Decay informations
INTEGER,PARAMETER::MAX_DecayChain=99
INTEGER,DIMENSION(MAX_DecayChain,-1:5)::DecayChains ! decay chains
INTEGER::NDecayChains ! number of decay chains in the process
INTEGER::AllNDecayChains ! total number of decay chains
REAL(KIND(1d0)),DIMENSION(MAX_DecayChain)::DecayBR ! branching ratios
INTEGER,DIMENSION(20,0:MAX_DecayChain)::iflh2DecayChains ! iflh -> DecayChains
INTEGER,DIMENSION(100,0:MAX_DecayChain)::JMO2DecayChains  ! for the second and later decays
INTEGER::NDecayIflh
LOGICAL::MCoHelicity=.FALSE.
REAL(KIND(1d0))::RMCoH,weight_br=1d0
! special cuts
INTEGER::literature_cutoffs
! fixed-target or not
LOGICAL::fixtarget=.FALSE.,fixtargetrev=.FALSE.
REAL(KIND(1d0))::FT_M,FT_E1
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! FOLLOWING IS THE VARIABLES FOR NUCLEAR EFFECTS IN PA OR AA COLLISIONS  !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! nuclear PDF variables
! 1: EPS08, 2: EPS09, 3: EPS09LO, 4: EPS09NLO, 5: EKS98
! 301-331: EPS09LO,n, 401-431: EPS09NLO,n
INTEGER::nPDF_id=0
! if it is True, it will only take into account the proton PDF (i.e. no nuclear effect)
LOGICAL::PureProton1=.FALSE.,PureProton2=.FALSE.
! 0 means it is proton, otherwise it is A of the nuclear
INTEGER::nuclearA_beam1=0,nuclearA_beam2=0
REAL(KIND(1d0))::rnuclearA_beam1=0d0,rnuclearA_beam2=0d0
INTEGER::nuclearZ_beam1=0,nuclearZ_beam2=0
REAL(KIND(1d0))::rnuclearZ_beam1=0d0,rnuclearZ_beam2=0d0
REAL(KIND(1d0))::randbeam1=1d0,randbeam2=1d0
LOGICAL::lnuclearPDF=.FALSE.
CHARACTER(len=20)::nuclearPDF_param='EPS09NLO'
LOGICAL::dPN=.TRUE.
LOGICAL::use_neutron_rand=.FALSE.
REAL(KIND(1d0)),DIMENSION(2)::neutron_rand=(/0D0,0D0/)
LOGICAL::fermion_motion=.FALSE.
REAL(KIND(1d0)),PARAMETER::mass_nucleon=0.94d0
REAL(KIND(1d0))::pmax_fermion_motion=0.26d0
REAL(KIND(1d0))::beam_energy_FT=0d0 ! it works for fermion_motion=.TRUE.
INTEGER::jetquenching_method=0
INTEGER::jetquenching_variable=1
REAL(KIND(1d0))::jetquenching_qhat=0.25d0
REAL(KIND(1d0))::jetquenching_t0=1d0
REAL(KIND(1d0))::medium_length=5d0
INTEGER::wc_estimate=1
REAL(KIND(1d0))::wc_wgt=1d0
REAL(KIND(1d0))::string_tension=1d0
INTEGER::xrand_quenching=0
INTEGER::fqnum=3
REAL(KIND=DBL),DIMENSION(20,5),PUBLIC::nuclear_parton_pmom
REAL(KIND=DBL),DIMENSION(20,5),PUBLIC::nuclear_hadron_pmom
REAL(KIND=DBL),DIMENSION(4)::nuclear_loss_pmom
LOGICAL::jetquenchingQ=.FALSE.
REAL(KIND(1d0))::jetquenching_as=0.5d0
REAL(KIND(1d0))::nuclear_xp1,nuclear_xp2
LOGICAL,DIMENSION(20)::jetquenching_fs
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! END OF NUCLEAR EFFECTS                                                    !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Variables for converting Hessian PDF to MC PDF                            !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
LOGICAL::PDF_Hessian2MC=.FALSE.
INTEGER::N_MCPDFs=1000
INTEGER::Way_Hessian2MC=1 ! 1: normal way; 2: using python code to transfer (only for pA)
REAL(KIND(1d0)),DIMENSION(:,:),ALLOCATABLE::PDF_Rki ! the matrix of the random number to generate replicas
!INTEGER::PDFID
REAL(KIND(1d0)),DIMENSION(:,:,:),ALLOCATABLE::Hessian_PDFs ! Hessian PDFs
REAL(KIND(1d0)),DIMENSION(:,:,:),ALLOCATABLE::MC_PDFs ! MC PDFs
LOGICAL::SAVE_HessianPDFs_ONLY=.FALSE.
LOGICAL::REPLACE_HessianByMC=.FALSE.
INTEGER::SAVE_HessianPDF_Index=-1
INTEGER::Use_MCPDF_Index=-1
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! End of variables for converting Hessian PDF to MC PDF                     !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
INTEGER::gridpack=0
! UPC related (in coltype=14)
! this is for photon-photon flux in UPCs
INTEGER::UPC_photon_flux_type=1
! Resolved photon PDFs (in coltype=15,16)
INTEGER::Resolved_photon_type=1
! electron/positron structure function accounting for ISR (in coltype=21)
INTEGER::emep_ISR_PDF_type=1
! BOOST condition
LOGICAL::Force_Boost_To_Lab=.TRUE.
! Momenta_Frame: 1 (lab frame), 2 (partonic cms), 3 (collision frame)
INTEGER::Momenta_Frame=1
END MODULE Helac_Global
