SUBROUTINE strf_mlhapdf(wsf)
! a subroutine for multiple lhapdf loading
USE Helac_Global
USE setscale
INTEGER::ipp=1  ! ipp=1 ppbar ; ipp=2 pp
INTEGER::ih=1   ! ih=1 no photon PDF,ih=2, photon from proton/anti-proton,ih=3 photon from electron/positron 
REAL(KIND=DBL),INTENT(OUT)::wsf          
CHARACTER(len=20),DIMENSION(20)::parm
REAL(KIND=DBL),DIMENSION(20)::val
REAL(KIND=DBL),DIMENSION(-7:7)::pdflist
LOGICAL::neutronQ=.FALSE.
INTEGER::init=0,ijij      
SAVE init,ipp,ih
REAL(KIND=DBL)::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
                ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct
INCLUDE "../input/lhapdf/call_initmpdf" ! simply to judge whether it is LHAPDF6 (only allowed way)
IF(init.EQ.0)THEN
   IF(.NOT.mlhapdfwrapinit)THEN
      CALL mlhapdfwrap
      mlhapdfwrapinit=.TRUE.
   ENDIF
   IF(Coll_Type.EQ.1)THEN
      ipp=2
   ELSE
      ipp=1
   ENDIF
   init=1
ENDIF

CALL qcdscale(scale)
scale=scale*muF_over_ref
IF(reweight_scale)THEN
   IF(reweight_Fscale_phase.EQ.1)THEN
      scale=scale*rw_Fscale_up
   ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
      scale=scale*rw_Fscale_down
   ENDIF
ENDIF


CALL pftopdglhaM(iPDFSUP1,ih,xp1,scale,pdflist(-7:7))
glu1_ct = xp1*pdflist(0)
u1_ct   = xp1*pdflist(2)
d1_ct   = xp1*pdflist(1)
s1_ct   = xp1*pdflist(3)
c1_ct   = xp1*pdflist(4)
b1_ct   = xp1*pdflist(5)
ub1_ct  = xp1*pdflist(-2)
db1_ct  = xp1*pdflist(-1)
sb1_ct  = xp1*pdflist(-3)
cb1_ct  = xp1*pdflist(-4)
bb1_ct  = xp1*pdflist(-5)

CALL pftopdglhaM(iPDFSUP2,ih,xp2,scale,pdflist(-7:7))
glu2_ct = xp2*pdflist(0)
u2_ct   = xp2*pdflist(2)
d2_ct   = xp2*pdflist(1)
s2_ct   = xp2*pdflist(3)
c2_ct   = xp2*pdflist(4)
b2_ct   = xp2*pdflist(5)
ub2_ct  = xp2*pdflist(-2)
db2_ct  = xp2*pdflist(-1)
sb2_ct  = xp2*pdflist(-3)
cb2_ct  = xp2*pdflist(-4)
bb2_ct  = xp2*pdflist(-5)

! recover it
IF(reweight_scale)THEN
   IF(reweight_Fscale_phase.EQ.1)THEN
      scale=scale/rw_Fscale_up
   ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
      scale=scale/rw_Fscale_down
   ENDIF
ENDIF

sf_ct=1
IF(qsumQ)THEN
	IF(ifl(1).EQ.35)THEN
		sf_ct=sf_ct*glu1_ct
	ELSEIF(ABS(ifl(1)).LE.12.AND.(MOD(ABS(ifl(1)),4).EQ.0.OR.MOD(ABS(ifl(1)),4).EQ.3) &
	.AND.ifl(2).EQ.35)THEN
		IF(onlyqcd)THEN
			SELECT CASE(iqnum)
			CASE(1)
				sf_ct=sf_ct*(u1_ct+ub1_ct)
			CASE(2)
				sf_ct=sf_ct*(u1_ct+ub1_ct+d1_ct+db1_ct)
			CASE(3)
				sf_ct=sf_ct*(u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct)
			CASE(4)
				sf_ct=sf_ct*(c1_ct+cb1_ct+u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct)
			CASE DEFAULT
				sf_ct=sf_ct*(b1_ct+bb1_ct+c1_ct+cb1_ct+u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct)
			END SELECT
		ELSE
			IF(MOD(ABS(ifl(1)),4).EQ.3)THEN
				SELECT CASE(iqnum)
				CASE(1,2,3)
					sf_ct=sf_ct*(u1_ct+ub1_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(u1_ct+ub1_ct+c1_ct+cb1_ct)
				END SELECT
			ELSEIF(MOD(ABS(ifl(1)),4).EQ.0)THEN
				SELECT CASE(iqnum)
				CASE(1)
					sf_ct=sf_ct
				CASE(2)
					sf_ct=sf_ct*(d1_ct+db1_ct)
				CASE(3,4)
					sf_ct=sf_ct*(d1_ct+db1_ct+s1_ct+sb1_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(d1_ct+db1_ct+s1_ct+sb1_ct+b1_ct+bb1_ct)
				END SELECT
			ENDIF
		ENDIF
	ENDIF

	IF(ifl(2).EQ.35)THEN
		sf_ct=sf_ct*glu2_ct
	ELSEIF(ABS(ifl(2)).LE.12.AND.(MOD(ABS(ifl(2)),4).EQ.0.OR.MOD(ABS(ifl(2)),4).EQ.3) &
	.AND.ifl(1).EQ.35)THEN
		IF(onlyqcd)THEN
			SELECT CASE(iqnum)
			CASE(1)
				sf_ct=sf_ct*(u2_ct+ub2_ct)
			CASE(2)
				sf_ct=sf_ct*(u2_ct+ub2_ct+d2_ct+db2_ct)
			CASE(3)
				sf_ct=sf_ct*(u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct)
			CASE(4)
				sf_ct=sf_ct*(c2_ct+cb2_ct+u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct)
			CASE DEFAULT
				sf_ct=sf_ct*(b2_ct+bb2_ct+c2_ct+cb2_ct+u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct)
			END SELECT
		ELSE
			IF(MOD(ABS(ifl(2)),4).EQ.3)THEN
				SELECT CASE(iqnum)
				CASE(1,2,3)
					sf_ct=sf_ct*(u2_ct+ub2_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(u2_ct+ub2_ct+c2_ct+cb2_ct)
				END SELECT
			ELSEIF(MOD(ABS(ifl(2)),4).EQ.0)THEN
				SELECT CASE(iqnum)
				CASE(1)
					sf_ct=sf_ct
				CASE(2)
					sf_ct=sf_ct*(d2_ct+db2_ct)
				CASE(3,4)
					sf_ct=sf_ct*(d2_ct+db2_ct+s2_ct+sb2_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(d2_ct+db2_ct+s2_ct+sb2_ct+b2_ct+bb2_ct)
				END SELECT
			ENDIF
		ENDIF
	ENDIF

	IF(ifl(1)+ifl(2).EQ.0.AND.(MOD(ABS(ifl(1)),4).EQ.0.OR.MOD(ABS(ifl(1)),4).EQ.3)&
      .AND.ABS(ifl(1)).LE.12)THEN
                IF(sf_ct.NE.1d0)THEN
                   WRITE(*,*)"ERROR 1 in Structf_MLHAPDFs.f90"
                   STOP
                ENDIF
		IF(onlyqcd)THEN
			SELECT CASE(iqnum)
			CASE(1)
				sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct)
			CASE(2)
				sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct+d1_ct*db2_ct+d2_ct*db1_ct)
			CASE(3)
				sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct+d1_ct*db2_ct+d2_ct*db1_ct&
				+s1_ct*sb2_ct+s2_ct*sb1_ct)
			CASE(4)
				sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct+d1_ct*db2_ct+d2_ct*db1_ct&
				+s1_ct*sb2_ct+s2_ct*sb1_ct+c1_ct*cb2_ct+cb1_ct*c2_ct)
			CASE DEFAULT
				sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct+d1_ct*db2_ct+d2_ct*db1_ct&
				+s1_ct*sb2_ct+s2_ct*sb1_ct+c1_ct*cb2_ct+cb1_ct*c2_ct+b1_ct*bb2_ct+bb1_ct*b2_ct)
			END SELECT
		ELSE
			IF(MOD(ABS(ifl(1)),4).EQ.3)THEN
				SELECT CASE(iqnum)
				CASE(1,2,3)
					sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct+c1_ct*cb2_ct+c2_ct*cb1_ct)
				END SELECT
			ELSEIF(MOD(ABS(ifl(1)),4).EQ.0)THEN
				SELECT CASE(iqnum)
				CASE(1)
					sf_ct=sf_ct
				CASE(2)
					sf_ct=sf_ct*(d1_ct*db2_ct+d2_ct*db1_ct)
				CASE(3,4)
					sf_ct=sf_ct*(s1_ct*sb2_ct+sb1_ct*s2_ct+d1_ct*db2_ct+d2_ct*db1_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(s1_ct*sb2_ct+sb1_ct*s2_ct+d1_ct*db2_ct+d2_ct*db1_ct&
					+b1_ct*bb2_ct+b2_ct*bb1_ct)
				END SELECT
			ENDIF
		ENDIF
        ELSEIF(ifl(1)-ifl(2).EQ.0.AND.(MOD(ABS(ifl(1)),4).EQ.0.OR.MOD(ABS(ifl(1)),4).EQ.3)&
             .AND.onlyqcd.AND.ABS(ifl(1)).LE.12)THEN
                IF(sf_ct.NE.1d0)THEN
                   WRITE(*,*)"ERROR 2 in Structf_MLHAPDFs.f90"
                   STOP
                ENDIF
           ! q q > q q in QCD
           SELECT CASE(iqnum)
           CASE(1)
              sf_ct=sf_ct*(u1_ct*u2_ct+ub1_ct*ub2_ct) ! u u + u~ u~
           CASE(2)
              sf_ct=sf_ct*(u1_ct*u2_ct+ub1_ct*ub2_ct+d1_ct*d2_ct+db2_ct*db1_ct) ! u u, d d,u~ u~, d~ d~
           CASE(3)
              sf_ct=sf_ct*(u1_ct*u2_ct+ub1_ct*ub2_ct+d1_ct*d2_ct+db2_ct*db1_ct&
                   +s1_ct*s2_ct+sb2_ct*sb1_ct) ! u u, d d, s s, u~ u~, d~ d~, s~ s~
           CASE(4)
              sf_ct=sf_ct*(u1_ct*u2_ct+ub1_ct*ub2_ct+d1_ct*d2_ct+db2_ct*db1_ct&
                   +s1_ct*s2_ct+sb2_ct*sb1_ct+c1_ct*c2_ct+cb1_ct*cb2_ct)
           CASE DEFAULT
              sf_ct=sf_ct*(u1_ct*u2_ct+ub1_ct*ub2_ct+d1_ct*d2_ct+db2_ct*db1_ct&
                   +s1_ct*s2_ct+sb2_ct*sb1_ct+c1_ct*c2_ct+cb1_ct*cb2_ct+b1_ct*b2_ct+bb1_ct*bb2_ct)
           END SELECT
        ELSEIF((MOD(ABS(ifl(1)),4).EQ.0.OR.MOD(ABS(ifl(1)),4).EQ.3).AND.onlyqcd.AND.iqnum.GT.1&
             .AND.ABS(ifl(1)).LE.12.AND.ABS(ifl(2)).LE.12&
             .AND.(MOD(ABS(ifl(2)),4).EQ.0.OR.MOD(ABS(ifl(2)),4).EQ.3))THEN
                IF(sf_ct.NE.1d0)THEN
                   WRITE(*,*)"ERROR 3 in Structf_MLHAPDFs.f90"
                   STOP
                ENDIF
           ! q q' > q q' in QCD
           SELECT CASE(iqnum)
           CASE(2)
              sf_ct=sf_ct*((u1_ct+ub1_ct)*(d2_ct+db2_ct)+(d1_ct+db1_ct)*(u2_ct+ub2_ct))
           CASE(3)
              sf_ct=sf_ct*((u1_ct+ub1_ct)*(d2_ct+db2_ct+s2_ct+sb2_ct)&
                   +(d1_ct+db1_ct)*(u2_ct+ub2_ct+s2_ct+sb2_ct)&
                   +(s1_ct+sb1_ct)*(u2_ct+ub2_ct+d2_ct+db2_ct))
           CASE(4)
              sf_ct=sf_ct*((u1_ct+ub1_ct)*(d2_ct+db2_ct+s2_ct+sb2_ct+c2_ct+cb2_ct)&
                   +(d1_ct+db1_ct)*(u2_ct+ub2_ct+s2_ct+sb2_ct+c2_ct+cb2_ct)&
                   +(s1_ct+sb1_ct)*(u2_ct+ub2_ct+d2_ct+db2_ct+c2_ct+cb2_ct)&
                   +(c1_ct+cb1_ct)*(u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct))
           CASE DEFAULT
              sf_ct=sf_ct*((u1_ct+ub1_ct)*(d2_ct+db2_ct+s2_ct+sb2_ct+c2_ct+cb2_ct+b2_ct+bb2_ct)&
                   +(d1_ct+db1_ct)*(u2_ct+ub2_ct+s2_ct+sb2_ct+c2_ct+cb2_ct+b2_ct+bb2_ct)&
                   +(s1_ct+sb1_ct)*(u2_ct+ub2_ct+d2_ct+db2_ct+c2_ct+cb2_ct+b2_ct+bb2_ct)&
                   +(c1_ct+cb1_ct)*(u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct+b2_ct+bb2_ct)&
                   +(b1_ct+bb1_ct)*(u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct+c2_ct+cb2_ct))
           END SELECT
	ELSEIF(ifl(1).NE.35.AND.ifl(2).NE.35)THEN
		PRINT *,"Please choose quarksumQ=.FALSE."
		STOP
	ENDIF

ELSE      
	IF(ipp.EQ.1)THEN
	! ppbar
		SELECT CASE(ifl(1))  
		CASE(3)
			sf_ct=sf_ct*u1_ct
		CASE(-3) 
			sf_ct=sf_ct*ub1_ct
		CASE(4)  
			sf_ct=sf_ct*d1_ct
		CASE(-4) 
			sf_ct=sf_ct*db1_ct
		CASE(7)  
			sf_ct=sf_ct*c1_ct
		CASE(-7) 
			sf_ct=sf_ct*cb1_ct
		CASE(8)  
			sf_ct=sf_ct*s1_ct
		CASE(-8) 
			sf_ct=sf_ct*sb1_ct
		CASE(12) 
			sf_ct=sf_ct*b1_ct
		CASE(-12)
			sf_ct=sf_ct*bb1_ct
		CASE(35) 
			sf_ct=sf_ct*glu1_ct
		END SELECT

		SELECT CASE(ifl(2))
		CASE(3)
			sf_ct=sf_ct*ub2_ct
		CASE(-3) 
			sf_ct=sf_ct*u2_ct
		CASE(4)  
			sf_ct=sf_ct*db2_ct
		CASE(-4) 
			sf_ct=sf_ct*d2_ct
		CASE(7)  
			sf_ct=sf_ct*cb2_ct
		CASE(-7) 
			sf_ct=sf_ct*c2_ct
		CASE(8)  
			sf_ct=sf_ct*sb2_ct
		CASE(-8) 
			sf_ct=sf_ct*s2_ct
		CASE(12) 
			sf_ct=sf_ct*bb2_ct
		CASE(-12)
			sf_ct=sf_ct*b2_ct
		CASE(35) 
			sf_ct=sf_ct*glu2_ct
		END SELECT
	ELSEIF(ipp.EQ.2)THEN
! pp
		SELECT CASE(ifl(1))
		CASE(3)  
			sf_ct=sf_ct*u1_ct
		CASE(-3) 
			sf_ct=sf_ct*ub1_ct
		CASE(4)  
			sf_ct=sf_ct*d1_ct
		CASE(-4) 
			sf_ct=sf_ct*db1_ct
		CASE(7)  
			sf_ct=sf_ct*c1_ct
		CASE(-7) 
			sf_ct=sf_ct*cb1_ct
		CASE(8)  
			sf_ct=sf_ct*s1_ct
		CASE(-8) 
			sf_ct=sf_ct*sb1_ct
		CASE(12) 
			sf_ct=sf_ct*b1_ct
		CASE(-12)
			sf_ct=sf_ct*bb1_ct
		CASE(35) 
			sf_ct=sf_ct*glu1_ct
		END SELECT

		SELECT CASE(ifl(2))
		CASE(3)  
			sf_ct=sf_ct*u2_ct
		CASE(-3) 
			sf_ct=sf_ct*ub2_ct
		CASE(4)  
			sf_ct=sf_ct*d2_ct
		CASE(-4) 
			sf_ct=sf_ct*db2_ct
		CASE(7)  
			sf_ct=sf_ct*c2_ct
		CASE(-7) 
			sf_ct=sf_ct*cb2_ct
		CASE(8)  
			sf_ct=sf_ct*s2_ct
		CASE(-8) 
			sf_ct=sf_ct*sb2_ct
		CASE(12) 
			sf_ct=sf_ct*b2_ct
		CASE(-12)
			sf_ct=sf_ct*bb2_ct
		CASE(35) 
			sf_ct=sf_ct*glu2_ct
		END SELECT
	ENDIF
ENDIF

wsf=wjac*sf_ct/xp1/xp2
IF(init.EQ.0)init=1
       
END SUBROUTINE strf_mlhapdf

SUBROUTINE mlhapdfwrap
  USE Helac_Global
  IMPLICIT NONE
  REAL(KIND(1d0)),PARAMETER::zmass=91.188d0
  INTEGER::nloop_temp
  CHARACTER(len=100)::PDFName
  REAL(KIND(1d0)),EXTERNAL::alphasPDFM ! the lhapdf internal function
  ! initialize the pdf set
  CALL FindPDFPathM(LHAPath)
  CALL SetPDFPath(LHAPath) ! Location of the LHAPDF library of PDFs
  ! they are defined in share/lhapdf/PDFsets.index
  CALL GetLHAPDFName(iPDFSUP1,LHAPath,PDFName)
  CALL InitPDFsetM(iPDFSUP1,TRIM(LHAPath)//'/'//TRIM(PDFName))
  CALL GetOrderAsM(iPDFSUP1,nloop) ! the order of running alpha_S, 0:LO,1:NLO etc
  nloop_temp=nloop
  IF(iPDFSUP1.NE.iPDFSUP2)THEN
     CALL GetLHAPDFName(iPDFSUP2,LHAPath,PDFName)
     CALL InitPDFsetM(iPDFSUP2,TRIM(LHAPath)//'/'//TRIM(PDFName))
     CALL GetOrderAsM(iPDFSUP2,nloop)
     IF(nloop.NE.nloop_temp)THEN
        WRITE(*,*)"WARNING: Do not match the order of alpha_s running "
        PRINT *, iPDFSUP1,iPDFSUP2,nloop_temp,nloop
        !STOP
     ENDIF
  ENDIF
  nloop=nloop+1 ! nloop=1:LO; nloop=2:NLO
  IF(beam_alphas.EQ.1)THEN
     alphaQCD2=alphasPDFM(iPDFSUP1,zmass) ! internal function of LHAPDF
  ELSE
     alphaQCD2=alphasPDFM(iPDFSUP2,zmass)
  ENDIF
  RETURN
END SUBROUTINE mlhapdfwrap

SUBROUTINE GetLHAPDFName(nset,LHAPath,PDFName)
  IMPLICIT NONE
  INTEGER,INTENT(IN)::nset
  CHARACTER(len=*),INTENT(IN)::LHAPath
  CHARACTER(len=*),INTENT(OUT)::PDFName
  LOGICAL::exists
  INTEGER::iostate,iset,iversion
  CHARACTER(100)::ctmp
  INQUIRE(File=TRIM(LHAPath)//"/pdfsets.index",exist=exists)
  IF(.NOT.exists)THEN
     WRITE(*,*)"ERROR: Cannot find the file "//TRIM(LHAPath)//"/pdfsets.index"
     STOP
  ENDIF
  iostate=0
  OPEN(UNIT=50321,File=TRIM(LHAPath)//"/pdfsets.index")
  DO WHILE(iostate.NE.-1.AND.iostate.LE.0)
     READ(50321,*,IOSTAT=iostate)iset,PDFName,iversion
     IF(iset.EQ.nset)THEN
        CLOSE(50321)
        RETURN
     ENDIF
  ENDDO
  CLOSE(50321)
  PRINT *, "ERROR: Cannot find the PDF with index=",nset
  STOP
END SUBROUTINE GetLHAPDFName

SUBROUTINE FindPDFPathM(LHAPath)
!********************************************************************
! generic subroutine to open the table files in the right directories
!********************************************************************
  IMPLICIT NONE
  CHARACTER(len=150),INTENT(INOUT)::LHAPath
  CHARACTER(len=3)::up='../'
  LOGICAL::exists
  INTEGER::i
  ! try in the LHAPath first
  INQUIRE(File=LHAPath,exist=exists)
  IF(exists)RETURN
  !first try in the current directory                                                              
  LHAPath='PDFsets'
  INQUIRE(File=LHAPath, exist=exists)
  IF(exists)RETURN
  ! then try one directory up                                                                       
  LHAPath=up//LHAPath
  INQUIRE(File=LHAPath, exist=exists)
  IF(exists)RETURN
  ! finally try in the lib directory                                                                
  LHAPath='lib/PDFsets'
  INQUIRE(File=LHAPath, exist=exists)
  IF(exists)RETURN
  DO i=1,6
     LHAPath=up//LHAPath
     INQUIRE(File=LHAPath, exist=exists)
     IF(exists)RETURN
  ENDDO
  PRINT *,'ERROR:Could not find PDFsets directory in LHAPDF, quitting'
  STOP

  RETURN
END SUBROUTINE FindPDFPathM

SUBROUTINE pftopdglhaM(nset,ih,x,q,pdf)
!***************************************************************************
!     Wrapper for calling the pdf from lhapdf
!***************************************************************************
  IMPLICIT NONE
  REAL(KIND(1d0)),INTENT(IN)::x,q
  REAL(KIND(1d0)),DIMENSION(-7:7),INTENT(OUT)::pdf
  REAL(KIND(1d0)),DIMENSION(-6:6)::f ! momentum density x*PDF
  INTEGER,INTENT(IN)::IH,nset
  INTEGER::I
  REAL(KIND(1d0))::photon
  LOGICAL,EXTERNAL::has_photon ! the lhapdf internal function

  IF(ABS(ih).EQ.1)THEN
     pdf(-7)=0d0
     IF(has_photon())THEN
        CALL evolvePDFphotonM(nset,x, q, f, photon)
        pdf(7)= photon
     ELSE
        pdf(7) = 0d0
        CALL evolvePDFM(nset, x, q, f)
     ENDIF
     DO i=-6,6
        pdf(i)=f(i)/x
     ENDDO
  ELSE
     WRITE(*,*) 'beam type is not supported in lhadpf'
     DO i=-7,7
        pdf(i)=0d0
     ENDDO
  ENDIF

  RETURN
END SUBROUTINE pftopdglhaM
