MODULE nuclearAZ
  IMPLICIT NONE
CONTAINS
  SUBROUTINE GetNuclearZ(NuclearA,NuclearZ)
    IMPLICIT NONE
    INTEGER,INTENT(IN)::NuclearA
    INTEGER,INTENT(OUT)::NuclearZ
    SELECT CASE(NuclearA)
    CASE(1)
       ! H
       NuclearZ=1
    CASE(4)
       ! He
       NuclearZ=2
    CASE(6)
       ! Li
       NuclearZ=3
    CASE(9)
       ! Be
       NuclearZ=4
    CASE(10)
       ! B
       NuclearZ=5
    CASE(12)
       ! C
       NuclearZ=6
    CASE(14)
       ! N
       NuclearZ=7
    CASE(16)
       ! O
       NuclearZ=8
    CASE(19)
       ! F
       NuclearZ=9
    CASE(20)
       ! Ne
       NuclearZ=10
    CASE(23)
       ! Na
       NuclearZ=11
    CASE(24)
       ! Mg
       NuclearZ=12
    CASE(27)
       ! Al
       NuclearZ=13
    CASE(28)
       ! Si
       NuclearZ=14
    CASE(31)
       ! P
       NuclearZ=15
    CASE(32)
       ! S
       NuclearZ=16
    CASE(35)
       ! Cl
       NuclearZ=17
    CASE(38)
       ! Ar
       NuclearZ=18
    CASE(39)
       ! K
       NuclearZ=19
    CASE(40)
       ! Ca
       NuclearZ=20
    CASE(45)
       ! Sc
       NuclearZ=21
    CASE(48)
       ! Ti
       NuclearZ=22
    CASE(51)
       ! V
       NuclearZ=23
    CASE(52)
       ! Cr
       NuclearZ=24
    CASE(55)
       ! Mn
       NuclearZ=25
    CASE(56)
       ! Fe
       NuclearZ=26
    CASE(58)
       ! Co
       NuclearZ=27
    CASE(59)
       ! Ni
       NuclearZ=28
    CASE(64)
       ! Cu
       NuclearZ=29
    CASE(65)
       ! Zn
       NuclearZ=30
    CASE(70)
       ! Ga
       NuclearZ=31
    CASE(73)
       ! Ge
       NuclearZ=32
    CASE(75)
       ! As
       NuclearZ=33
    CASE(79)
       ! Se
       NuclearZ=34
    CASE(80)
       ! Br
       NuclearZ=35
    CASE(84)
       ! Kr
       NuclearZ=36
    CASE(85)
       ! Rb
       NuclearZ=37
    CASE(88)
       ! Sr
       NuclearZ=38
    CASE(89)
       ! Y
       NuclearZ=39
    CASE(91)
       ! Zr
       NuclearZ=40
    CASE(93)
       ! Nb
       NuclearZ=41
    CASE(96)
       ! Mo
       NuclearZ=42
    CASE(98)
       ! Te
       NuclearZ=43
    CASE(101)
       ! Ru
       NuclearZ=44
    CASE(103)
       ! Rh
       NuclearZ=45
    CASE(106)
       ! Pd
       NuclearZ=46
    CASE(108)
       ! Ag
       NuclearZ=47
    CASE(112)
       ! Cd
       NuclearZ=48
    CASE(115)
       ! In
       NuclearZ=49
    CASE(117)
       ! Sn
       NuclearZ=50
    CASE(122)
       ! Sb
       NuclearZ=51
    CASE(128)
       ! Te
       NuclearZ=52
    CASE(127)
       ! I
       NuclearZ=53
    CASE(131)
       ! Xe
       NuclearZ=54
    CASE(133)
       ! Cs
       NuclearZ=55
    CASE(137)
       ! Ba
       NuclearZ=56
       ! negelecting the La-Lu
    CASE(178)
       ! Hf
       NuclearZ=72
    CASE(181)
       ! Ta
       NuclearZ=73
    CASE(184)
       ! W
       NuclearZ=74
    CASE(186)
       ! Ke
       NuclearZ=75
    CASE(190)
       ! Os
       NuclearZ=76
    CASE(192)
       ! Ir
       NuclearZ=77
    CASE(195)
       ! Pt
       NuclearZ=78
    CASE(197)
       ! Au
       NuclearZ=79
    CASE(201)
       ! Hg
       NuclearZ=80
    CASE(204)
       ! Tl
       NuclearZ=81
    CASE(208)
       ! Pb
       NuclearZ=82
    CASE(209)
       ! Bi
       NuclearZ=83
    CASE(210)
       ! Po
       NuclearZ=84
    CASE(211)
       ! At
       NuclearZ=85
    CASE(222)
       ! Rn
       NuclearZ=86
    CASE(223)
       ! Fr
       NuclearZ=87
    CASE(226)
       ! Ra
       NuclearZ=88
       ! negelecting Ac-Lr
    CASE(261)
       ! Rf
       NuclearZ=104
    CASE(262)
       ! Db
       NuclearZ=105
    CASE(266)
       ! Sg
       NuclearZ=106
    CASE(238)
       ! U
       NuclearZ=92
    CASE DEFAULT
       WRITE(*,*)"ERROR:Unknown the A of nuclear = ",NuclearA
       STOP
    END SELECT
    RETURN
  END SUBROUTINE GetNuclearZ
END MODULE nuclearAZ
