MODULE Helac_TMD
USE Helac_Global
USE Global_TMD
USE Helac_Func_1
USE Helac_pan1
USE Helac_Feynman
USE Projectors
USE Decay_interface
!USE Helac_master
IMPLICIT NONE
REAL(KIND(1d0)),DIMENSION(:,:),ALLOCATABLE,PUBLIC::tmd_rmatrix
COMPLEX(KIND(1d0)),DIMENSION(:),ALLOCATABLE,PUBLIC::tmd_zamp
INTEGER,DIMENSION(:,:,:),ALLOCATABLE,PUBLIC::tmd_jcol
COMPLEX(KIND(1d0)),DIMENSION(:,:),ALLOCATABLE,PUBLIC::tmdhelcol
COMPLEX(KIND(1d0)),DIMENSION(:,:),ALLOCATABLE,PUBLIC::tmdhelcol2
INTEGER::tmd_num
SAVE tmd_rmatrix,tmd_zamp,tmd_jcol
SAVE tmd_num
CONTAINS

SUBROUTINE Helac_ggTMD_F(Fhat)
IMPLICIT NONE
! 5 functions defined in Eq.(12) of arXiv:1702.00305
READ(KIND(1d0)),DIMENSION(5),INTENT(OUT)::Fhat
LOGICAL::lmode
INTEGER::k,ihel,istop,inegl,k1,k2,k_1,k_un,i,istat,inum,icut
REAL(KIND(1d0))::w1,beta0,beta1,wnc,r,alpha
COMPLEX(KIND(1d0))::CGfactor
INTEGER::initinit=0
SAVE initinit
IF(initinit.EQ.0)THEN
   WRITE(*,*)'NCC=',ncc,' imc=',imc
   IF(ALLOCATED(tmdhelcol))THEN
      DEALLOCATE(tmdhelcol)
   ENDIF
   CALL Gethelnum(tmd_num)
   ALLOCATE(tmdhelcol(tmd_num,ncc),STAT=istat)
   IF(ihel1.NE.ihel2)THEN
      IF(ALLOCATED(tmdhelcol2))DEALLOCATE(tmdhelcol2)
      ALLOCATE(tmdhelcol2(tmd_num,ncc),STAT=istat)
   ENDIF
   IF(istat.NE.0)WRITE(*,*)istat,&
        'warning: allocation(1) is not working properly in Helac_ggTMD_F'
ENDIF
IF(repeat.EQ.2.AND.initinit.EQ.0)THEN
   IF(ALLOCATED(tmd_zamp))THEN
      DEALLOCATE(tmd_zamp)
   ENDIF
   IF(ALLOCATED(tmd_rmatrix))THEN
      DEALLOCATE(tmd_rmatrix)
   ENDIF
   IF(ALLOCATED(tmd_jcol))THEN
      DEALLOCATE(tmd_jcol)
   ENDIF
   ALLOCATE(tmd_zamp(ncc),tmd_rmatrix(ncc,ncc),tmd_jcol(ncc,nhad,0:2),STAT=istat)
   IF(istat.NE.0)WRITE(*,*)istat,&
        'warning: allocation(2) is not working properly in Helac_ggTMD_F'
   READ(21,*)avhel,avcol,symet
   READ(21,*)tmd_rmatrix
   DO k=1,ncc
      READ(21,*)tmd_jcol(k,1:nhad,0:2)
   ENDDO
ENDIF
tmdhelcol(1:tmd_num,1:ncc)=DCMPLX(0d0)
IF(ihel1.NE.ihel2)tmdhelcol2(1:tmd_num,1:ncc)=DCMPLX(0d0)
ihel=0
istop=0
weight_br=1d0
IF((gener.NE.3.OR.iranhel.EQ.0).AND.(.NOT.reweight_scale_phase))THEN
   ! when gener.EQ.0 and iranhel.EQ.1 or 2 or 3
   ! it is important to keep Qhelran and QSzran
   ! to compute the alpha_s power
   Qhelran(1:20)=-1
   QSzran(1:20)=-1
   PhyPolNum=0
ENDIF
IF(.NOT.MCoHelicity)THEN
   IF(NDecayChains.GT.0)THEN
      CALL HO_Decay(weight_br)
      IF(weight_br.LE.0d0)THEN
         smel2=dnou(0)
         initinit=1
         RETURN
      ENDIF
      IF(.NOT.reweight_scale_phase)THEN
         CALL cuts_Decay(icut)
         IF(icut.EQ.0)THEN
            smel2=dnou(0)
            initinit=1
            RETURN
         ENDIF
      ENDIF
   ENDIF
   initinit=1
   DO WHILE(istop.EQ.0)
      inegl=0
      CALL Helac_sethel(iflag,istop,ihel,inegl)  ! get every helicity configuration
      GLOBALINIT_Sethel=1
      inegl=1
      CALL Helac_iniqq()   ! initilization and random helicity selection 
      ! for the external legs in Helac_pan1.f90
      IF(.NOT.exp3pjQ.OR.Num3pj.EQ.0)THEN
         IF(imode.EQ.0)THEN
            CALL PhysicalPol(inum)
            GLOBALINIT_physicalpol=1
            CGfactor=1
         ELSEIF(imode.EQ.1)THEN
            CALL PhysicalPol2(inum,CGfactor)
            GLOBALINIT_physicalpol2=1
         ENDIF
      ELSE
         CALL ls2j(inum,CGfactor)
         GLOBALINIT_ls2j=1
      ENDIF
      IF(imc.EQ.0)THEN
         DO k=1,ncc
            CALL Helac_nextq(k)
            CALL Helac_ampq(k,tmd_zamp(k))     ! get the amplitudes
            tmd_zamp(k)=tmd_zamp(k)*CGfactor
            IF(imode.EQ.1.AND..NOT.FirstHelicityQ)THEN
               tmdhelcol2(inum,k)=tmdhelcol2(inum,k)+tmd_zamp(k)
            ELSE
               tmdhelcol(inum,k)=tmdhelcol(inum,k)+tmd_zamp(k)
            ENDIF
            IF(onep)THEN 
               WRITE(100,*)'the ',k,'-th color cnfg out of ',ncc
               IF(ncc.GT.1)WRITE(100,*)'the     color',tmd_jcol(k,1:nhad,1)
               IF(ncc.GT.1)WRITE(100,*)'the anticolor',tmd_jcol(k,1:nhad,2)
               IF(iranhel.EQ.0)WRITE(100,*)'the helicity',ipol(1:n)
               WRITE(100,*)'the amplitude',tmd_zamp(k)
            ENDIF
         ENDDO
         ! color matrix rmatrix is positive definited
         w1=dnou(0)
         DO k1=1,ncc
            DO k2=k1,ncc
               IF(k2.EQ.k1)w1=w1+DREAL(tmd_zamp(k1)*DCONJG(tmd_zamp(k2)))*tmd_rmatrix(k1,k2)!matrix elements
               IF(k2.GT.k1)w1=w1+2*DREAL(tmd_zamp(k1)*DCONJG(tmd_zamp(k2)))*tmd_rmatrix(k1,k2) 
            ENDDO
         ENDDO
      ELSE
         ! color random selection,with Leading Colour Approximation
         k_1=INT(Helac_rnmy(0)*ncc)+1
         CALL Helac_nextq(k_1)
         CALL Helac_ampq(k_1,tmd_zamp(k_1))
         tmd_zamp(k_1)=tmd_zamp(k_1)*CGfactor
         tmdhelcol(inum,k_1)=tmdhelcol(inum,k_1)+tmd_zamp(k_1)*DSQRT(DBLE(ncc))

         w1=DREAL(tmd_zamp(k_1)*DCONJG(tmd_zamp(k_1)))*tmd_rmatrix(k_1,k_1)
         w1=w1*ncc
      ENDIF
      
      IF(w1.EQ.dnou(0))inegl=2             ! delete this helicity configuration
      IF(init.EQ.0)CALL Helac_sethel(iflag,istop,ihel,inegl) ! delete this helicity configuration
      IF(init.EQ.0)THEN
         WRITE(nunit1,*)' '
         WRITE(nunit1,*)'polarization states for external legs'
         WRITE(nunit1,*)(ipol(i),i=1,nhad)
         WRITE(nunit1,*)'weighting w1='
         WRITE(nunit1,*)w1
         WRITE(nunit1,*)' '
      ENDIF
   ENDDO
ELSE
   initinit=1
   IF(init.EQ.0)THEN
      istop=0
      DO WHILE(istop.EQ.0)
         inegl=0
         CALL Helac_sethel2(iflag,istop,ihel,inegl,0)
         inegl=1
         CALL Helac_iniqq()
         IF(imc.EQ.0)THEN
            DO k=1,ncc
               CALL Helac_nextq(k)
               CALL Helac_ampq(k,tmd_zamp(k))
            ENDDO
            w1=dnou(0)
            DO k1=1,ncc
               DO k2=k1,ncc
                  IF(k2.EQ.k1)w1=w1+DREAL(tmd_zamp(k1)*DCONJG(tmd_zamp(k2)))*tmd_rmatrix(k1,k2)            
                  IF(k2.GT.k1)w1=w1+2*DREAL(tmd_zamp(k1)*DCONJG(tmd_zamp(k2)))*tmd_rmatrix(k1,k2)
               ENDDO
            ENDDO
         ELSE
            k_1=INT(Helac_rnmy(0)*ncc)+1
            CALL Helac_nextq(k_1)
            CALL Helac_ampq(k_1,tmd_zamp(k_1))
            w1=DREAL(tmd_zamp(k_1)*DCONJG(tmd_zamp(k_1)))*tmd_rmatrix(k_1,k_1)
            w1=w1*ncc
         ENDIF
         IF(w1.EQ.dnou(0))inegl=2
         IF(init.EQ.0)CALL Helac_sethel2(iflag,istop,ihel,inegl,0)
         WRITE(nunit1,*)' '
         WRITE(nunit1,*)'polarization states for external legs'
         WRITE(nunit1,*)(ipol(i),i=1,nhad)
         WRITE(nunit1,*)'weighting w1='
         WRITE(nunit1,*)w1
         WRITE(nunit1,*)' '
      ENDDO
      WRITE(*,*)'THE NONVANISHING HELICITY CFGS',nhc,nphyhc
   ENDIF
   istop=0
   ihel=0
   weight_br=1d0
   DO WHILE(istop.EQ.0)
      inegl=0
      CALL Helac_sethel2(iflag,istop,ihel,inegl,1)
      inegl=1
      IF(ihel.EQ.1.AND.NDecayChains.GT.0)THEN
         CALL HO_Decay(weight_br)
         IF(weight_br.LE.0d0)THEN
            smel2=dnou(0)
            init=init+1
            RETURN
         ENDIF
         IF(.NOT.reweight_scale_phase)THEN
            CALL cuts_Decay(icut)
            IF(icut.EQ.0)THEN
               smel2=dnou(0)
               init=init+1
               RETURN
            ENDIF
         ENDIF
      ENDIF
      CALL Helac_iniqq()
      IF(.NOT.exp3pjQ.OR.Num3pj.EQ.0)THEN
         CALL PhysicalPol(inum)
         CGfactor=1
      ELSE
         PRINT *,"ERROR:iranhel=4 or decay processes cannot have explicit 3PJ"
         STOP
         CALL ls2j(inum,CGfactor)
         GLOBALINIT_ls2j=1
      ENDIF
      IF(imc.EQ.0)THEN
         DO k=1,ncc
            CALL Helac_nextq(k)
            CALL Helac_ampq(k,tmd_zamp(k))     ! get the amplitudes
            tmd_zamp(k)=tmd_zamp(k)*CGfactor*DSQRT(DBLE(nphyhc))
            tmdhelcol(inum,k)=tmdhelcol(inum,k)+tmd_zamp(k)
         ENDDO
      ELSE
         k_1=INT(Helac_rnmy(0)*ncc)+1
         CALL Helac_nextq(k_1)
         CALL Helac_ampq(k_1,tmd_zamp(k_1))
         tmd_zamp(k_1)=tmd_zamp(k_1)*CGfactor*DSQRT(DBLE(nphyhc))*DSQRT(DBLE(ncc))
         tmdhelcol(inum,k_1)=tmdhelcol(inum,k_1)+tmd_zamp(k_1)
      ENDIF
   ENDDO
ENDIF
! sigma
smel2=dnou(0)
tmd_zamp(1:ncc)=0
IF(imode.EQ.0.OR.(imode.EQ.1.AND.ihel1.EQ.ihel2))THEN
   DO i=1,tmd_num
      DO k1=1,ncc
         DO k2=k1,ncc
            IF(k1.EQ.k2)smel2=smel2+DREAL(tmdhelcol(i,k1)*DCONJG(tmdhelcol(i,k2)))*tmd_rmatrix(k1,k2)
            IF(k2.GT.k1)smel2=smel2+&
                 2d0*DREAL(tmdhelcol(i,k1)*DCONJG(tmdhelcol(i,k2)))*tmd_rmatrix(k1,k2)
         ENDDO
         tmd_zamp(k1)=tmd_zamp(k1)+tmdhelcol(i,k1)*DCONJG(tmdhelcol(i,k1))
      ENDDO
   ENDDO
ELSEIF(imode.EQ.1.AND.ihel1.NE.ihel2)THEN
   DO i=1,tmd_num
      DO k1=1,ncc
         DO k2=1,ncc
            smel2=smel2+DREAL(tmdhelcol(i,k1)*DCONJG(tmdhelcol2(i,k2)))*tmd_rmatrix(k1,k2)
         ENDDO
         tmd_zamp(k1)=tmd_zamp(k1)+tmdhelcol(i,k1)*DCONJG(tmdhelcol(i,k1))
      ENDDO
   ENDDO
   IF(SDPart.GT.0)THEN
      smel2=MAX(0d0,smel2)
   ELSEIF(SDPart.LT.0)THEN
      smel2=MAX(0d0,-smel2)
   ENDIF
ENDIF
! unweight over color
! random color selection
beta0=0d0
k_un=1
r=Helac_rnmy(0)      ! choose some color configuration
wnc=0d0
DO k=1,ncc
   IF(jcol(k,1,0).EQ.1)wnc=wnc+DREAL(tmd_zamp(k)) ! no U(1) external gluon
ENDDO
DO k=1,ncc
   alpha=DREAL(tmd_zamp(k))/wnc
   IF(jcol(k,1,0).EQ.0)alpha=0
   beta1=beta0+alpha
   IF(r.GT.beta0.AND.r.LT.beta1)THEN
      k_un=k
      EXIT          ! goto 1
   ENDIF
   beta0=beta1
ENDDO
icol_un(1:nhad,1:2)=tmd_jcol(k_un,1:nhad,1:2)  ! 1

!     end of polariazation sum if any
IF(init.EQ.0.AND..NOT.MCoHelicity)WRITE(*,*)'THE NONVANISHING HELICITY CFGS',nhc
!     *****************************************************
!
!WRITE(*,*)smel2,avhel,avcol,symet  ! Debug
smel2=smel2*avhel*avcol*symet
!WRITE(*,*)'total',smel2   ! Debug
!
!     *****************************************************
IF(onep)THEN
   WRITE(100,*)'total amplitude squared = ',smel2
   WRITE(100,*)'----------------------------------------'
ENDIF

init=init+1 
IF(onep)init=0
END SUBROUTINE Helac_ggTMD_F
        
END MODULE Helac_TMD
