      subroutine call_gg_sloopmatrix(pborn, virt_wgts, stable)
      use pp_oniumjet_NLO_Global
      implicit none
      double precision pborn(0:3,nexternal-1)
      double precision virt_wgts(3)
      logical stable
      double precision pborn_backup(0:3,nexternal-1)
      double precision MC_backup,MC2_backup,MUR_backup
      double precision MC3_backup, MC4_backup, LDME1S01_backup
      double precision virt_wgts_1(3),virt_wgts_2(3)
      integer i,j
      double precision denom,diff,ratio
      real*16 mp_virt_wgts_1(3),mp_virt_wgts_2(3)
      real*16 MP_MC_backup,MP_MC2_backup,MP_MUR_backup
      real*16 MP_MC3_backup, MP_MC4_backup, MP_LDME1S01_backup
      real*16 mp_pborn_backup(0:3,nexternal-1)
      real*16 mp_denom,mp_diff,mp_ratio
      ! calling the original loop matrix
      call gg_sloopmatrix(pborn, virt_wgts_1)
      IF(virt_wgts_1(1).EQ.zero)THEN
         virt_wgts(1:3)=virt_wgts_1(1:3)
         stable=.TRUE.
         RETURN
      ENDIF
      ! start to rescaling the dimensional quantities by 100
      ! first backup them
      MC_backup=MC
      MC2_backup=MC2
      MC3_backup=MC3
      MC4_backup=MC4
      MUR_backup=MUR
      LDME1S01_backup=LDME1S01
      ! second rescalig
      do i=0,3
         do j=1,nexternal-1
            pborn_backup(i,j)=pborn(i,j)*mass_rescaling
         enddo
      enddo
      MC=MC*mass_rescaling
      MC2=MC2*mass_rescaling**2
      MC3=MC3*mass_rescaling**3
      MC4=MC4*mass_rescaling**4
      MUR=MUR*mass_rescaling
      LDME1S01=LDME1S01*mass_rescaling**3
      call gg_sloopmatrix(pborn_backup, virt_wgts_2)
      ! recover
      MC=MC_backup
      MC2=MC2_backup
      MC3=MC3_backup
      MC4=MC4_backup
      MUR=MUR_backup
      LDME1S01=LDME1S01_backup
      denom=MAX(DABS(virt_wgts_1(1)),DABS(virt_wgts_2(1)))
      denom=MAX(denom,DABS(virt_wgts_1(2)))
      denom=MAX(denom,DABS(virt_wgts_1(3)))
      denom=MAX(denom,DABS(virt_wgts_2(2)))
      denom=MAX(denom,DABS(virt_wgts_2(3)))
      diff=DABS(virt_wgts_1(1)-virt_wgts_2(1))
      diff=MAX(diff,DABS(virt_wgts_1(2)-virt_wgts_2(2)))
      diff=MAX(diff,DABS(virt_wgts_1(3)-virt_wgts_2(3)))
      ratio=DABS(virt_wgts_1(1))/MAX(DABS(virt_wgts_1(2)),
     $     DABS(virt_wgts_1(3)))
      if(diff/denom.GT.stable_threshold.OR.
     $     ratio.GT.stable_unbounded)then
         if(quadrupole_precision)THEN
            if(force_update_mp_phasespace)then
               CALL SET_MP_PS(ponium_born,mp_ponium_born)
               force_update_mp_phasespace=.false.
            endif
            ! try to use the quadrupole precision
            call mp_gg_sloopmatrix(mp_ponium_born, mp_virt_wgts_1)
            ! start to rescaling the dimensional quantities by 100
            ! first backup them
            MP_MC_backup=MP_MC
            MP_MC2_backup=MP_MC2
            MP_MC3_backup=MP_MC3
            MP_MC4_backup=MP_MC4
            MP_MUR_backup=MP_MUR
            MP_LDME1S01_backup=MP_LDME1S01
            ! second rescalig
            do i=0,3
               do j=1,nexternal-1
                  mp_pborn_backup(i,j)=mp_ponium_born(i,j)
     $                 *mp_mass_rescaling
               enddo
            enddo
            MP_MC=MP_MC*mp_mass_rescaling
            MP_MC2=MP_MC2*mp_mass_rescaling**2
            MP_MC3=MP_MC3*mp_mass_rescaling**3
            MP_MC4=MP_MC4*mp_mass_rescaling**4
            MP_MUR=MP_MUR*mp_mass_rescaling
            MP_LDME1S01=MP_LDME1S01*mp_mass_rescaling**3
            call mp_gg_sloopmatrix(mp_pborn_backup, mp_virt_wgts_2)
            ! recover
            MP_MC=MP_MC_backup
            MP_MC2=MP_MC2_backup
            MP_MC3=MP_MC3_backup
            MP_MC4=MP_MC4_backup
            MP_MUR=MP_MUR_backup
            MP_LDME1S01=MP_LDME1S01_backup
            mp_denom=MAX(ABS(mp_virt_wgts_1(1)),ABS(mp_virt_wgts_2(1)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_1(2)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_1(3)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_2(2)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_2(3)))
            mp_diff=ABS(mp_virt_wgts_1(1)-mp_virt_wgts_2(1))
            mp_diff=MAX(mp_diff,
     $           ABS(mp_virt_wgts_1(2)-mp_virt_wgts_2(2)))
            mp_diff=MAX(mp_diff,
     $           ABS(mp_virt_wgts_1(3)-mp_virt_wgts_2(3)))
            mp_ratio=ABS(mp_virt_wgts_1(1))/MAX(ABS(mp_virt_wgts_1(2)),
     $           ABS(mp_virt_wgts_1(3)))
            if(real(mp_diff/mp_denom,kind=8).GT.stable_threshold.OR.
     $           real(mp_ratio,kind=8).GT.stable_unbounded)then
               stable=.false.
               IF(unstable_ps.LT.MAX_WRITE_UPS)THEN
                  WRITE(20456,*)"Warning:find an unstable"//
     $                 " phase space point"
                  WRITE(20456,*)"gg loop ME2 finite=",virt_wgts_1(1),
     $                 virt_wgts_2(1), mp_virt_wgts_1(1),
     $                 mp_virt_wgts_2(1)
                  WRITE(20456,*)"gg loop ME2 1eps=",virt_wgts_1(2),
     $                 virt_wgts_2(2),mp_virt_wgts_1(2), 
     $                 mp_virt_wgts_2(2)
                  WRITE(20456,*)"gg loop ME2 2eps=",virt_wgts_1(3),
     $                 virt_wgts_2(3),mp_virt_wgts_1(3), 
     $                 mp_virt_wgts_2(3)
                  WRITE(20456,*)"======Unstable Phase Space Point"//
     $                 "=========="
                  DO i=1,nexternal-1
                     WRITE(20456,*)i,pborn(0:3,i)
                  ENDDO
                  WRITE(20456,*)"================================="//
     $                 "========="
               ENDIF
               virt_wgts(1)=zero
               virt_wgts(2)=zero
               virt_wgts(3)=zero
            else
               stable=.true.
               ! let us use the quadrupole precision one
               virt_wgts(1)=mp_virt_wgts_1(1)
               virt_wgts(2)=mp_virt_wgts_1(2)
               virt_wgts(3)=mp_virt_wgts_1(3)
            endif
         else
            ! do not use quadrupole precision
            stable=.false.
            IF(unstable_ps.LT.MAX_WRITE_UPS)THEN
               WRITE(20456,*)"Warning:find an unstable"//
     $              " phase space point"
               WRITE(20456,*)"gg loop ME2 finite=",virt_wgts_1(1),
     $              virt_wgts_2(1)
               WRITE(20456,*)"gg loop ME2 1eps=",virt_wgts_1(2),
     $              virt_wgts_2(2)
               WRITE(20456,*)"gg loop ME2 2eps=",virt_wgts_1(3),
     $              virt_wgts_2(3)
               WRITE(20456,*)"======Unstable Phase Space Point"//
     $              "=========="
               DO i=1,nexternal-1
                  WRITE(20456,*)i,pborn(0:3,i)
               ENDDO
               WRITE(20456,*)"================================="//
     $              "========="
            ENDIF
            virt_wgts(1)=zero
            virt_wgts(2)=zero
            virt_wgts(3)=zero
         endif
      else
         stable=.true.
         virt_wgts(1)=virt_wgts_1(1)
         virt_wgts(2)=virt_wgts_1(2)
         virt_wgts(3)=virt_wgts_1(3)
      endif
      return
      end

      subroutine call_gq_sloopmatrix(pborn, virt_wgts, stable)
      use pp_oniumjet_NLO_Global
      implicit none
      double precision pborn(0:3,nexternal-1)
      double precision virt_wgts(3)
      logical stable
      double precision pborn_backup(0:3,nexternal-1)
      double precision MC_backup,MC2_backup,MUR_backup
      double precision MC3_backup, MC4_backup, LDME1S01_backup
      double precision virt_wgts_1(3),virt_wgts_2(3)
      integer i,j
      double precision denom,diff,ratio
      real*16 mp_virt_wgts_1(3),mp_virt_wgts_2(3)
      real*16 MP_MC_backup,MP_MC2_backup,MP_MUR_backup
      real*16 MP_MC3_backup, MP_MC4_backup, MP_LDME1S01_backup
      real*16 mp_pborn_backup(0:3,nexternal-1)
      real*16 mp_denom,mp_diff,mp_ratio
      ! calling the original loop matrix
      call gq_sloopmatrix(pborn, virt_wgts_1)
      IF(virt_wgts_1(1).EQ.zero)THEN
         virt_wgts(1:3)=virt_wgts_1(1:3)
         stable=.TRUE.
         RETURN
      ENDIF
      ! start to rescaling the dimensional quantities by 100
      ! first backup them
      MC_backup=MC
      MC2_backup=MC2
      MC3_backup=MC3
      MC4_backup=MC4
      MUR_backup=MUR
      LDME1S01_backup=LDME1S01
      ! second rescalig
      do i=0,3
         do j=1,nexternal-1
            pborn_backup(i,j)=pborn(i,j)*mass_rescaling
         enddo
      enddo
      MC=MC*mass_rescaling
      MC2=MC2*mass_rescaling**2
      MC3=MC3*mass_rescaling**3
      MC4=MC4*mass_rescaling**4
      MUR=MUR*mass_rescaling
      LDME1S01=LDME1S01*mass_rescaling**3
      call gq_sloopmatrix(pborn_backup, virt_wgts_2)
      ! recover
      MC=MC_backup
      MC2=MC2_backup
      MC3=MC3_backup
      MC4=MC4_backup
      MUR=MUR_backup
      LDME1S01=LDME1S01_backup
      denom=MAX(DABS(virt_wgts_1(1)),DABS(virt_wgts_2(1)))
      denom=MAX(denom,DABS(virt_wgts_1(2)))
      denom=MAX(denom,DABS(virt_wgts_1(3)))
      denom=MAX(denom,DABS(virt_wgts_2(2)))
      denom=MAX(denom,DABS(virt_wgts_2(3)))
      diff=DABS(virt_wgts_1(1)-virt_wgts_2(1))
      diff=MAX(diff,DABS(virt_wgts_1(2)-virt_wgts_2(2)))
      diff=MAX(diff,DABS(virt_wgts_1(3)-virt_wgts_2(3)))
      ratio=DABS(virt_wgts_1(1))/MAX(DABS(virt_wgts_1(2)),
     $     DABS(virt_wgts_1(3)))
      if(diff/denom.GT.stable_threshold.OR.
     $     ratio.GT.stable_unbounded)then
         if(quadrupole_precision)THEN
            if(force_update_mp_phasespace)then
               CALL SET_MP_PS(ponium_born,mp_ponium_born)
               force_update_mp_phasespace=.false.
            endif
            ! try to use the quadrupole precision
            call mp_gq_sloopmatrix(mp_ponium_born, mp_virt_wgts_1)
            ! start to rescaling the dimensional quantities by 100
            ! first backup them
            MP_MC_backup=MP_MC
            MP_MC2_backup=MP_MC2
            MP_MC3_backup=MP_MC3
            MP_MC4_backup=MP_MC4
            MP_MUR_backup=MP_MUR
            MP_LDME1S01_backup=MP_LDME1S01
            ! second rescalig
            do i=0,3
               do j=1,nexternal-1
                  mp_pborn_backup(i,j)=mp_ponium_born(i,j)
     $                 *mp_mass_rescaling
               enddo
            enddo
            MP_MC=MP_MC*mp_mass_rescaling
            MP_MC2=MP_MC2*mp_mass_rescaling**2
            MP_MC3=MP_MC3*mp_mass_rescaling**3
            MP_MC4=MP_MC4*mp_mass_rescaling**4
            MP_MUR=MP_MUR*mp_mass_rescaling
            MP_LDME1S01=MP_LDME1S01*mp_mass_rescaling**3
            call mp_gq_sloopmatrix(mp_pborn_backup, mp_virt_wgts_2)
            ! recover
            MP_MC=MP_MC_backup
            MP_MC2=MP_MC2_backup
            MP_MC3=MP_MC3_backup
            MP_MC4=MP_MC4_backup
            MP_MUR=MP_MUR_backup
            MP_LDME1S01=MP_LDME1S01_backup
            mp_denom=MAX(ABS(mp_virt_wgts_1(1)),ABS(mp_virt_wgts_2(1)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_1(2)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_1(3)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_2(2)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_2(3)))
            mp_diff=ABS(mp_virt_wgts_1(1)-mp_virt_wgts_2(1))
            mp_diff=MAX(mp_diff,
     $           ABS(mp_virt_wgts_1(2)-mp_virt_wgts_2(2)))
            mp_diff=MAX(mp_diff,
     $           ABS(mp_virt_wgts_1(3)-mp_virt_wgts_2(3)))
            mp_ratio=ABS(mp_virt_wgts_1(1))/MAX(ABS(mp_virt_wgts_1(2)),
     $           ABS(mp_virt_wgts_1(3)))
            if(real(mp_diff/mp_denom,kind=8).GT.stable_threshold.OR.
     $           real(mp_ratio,kind=8).GT.stable_unbounded)then
               stable=.false.
               IF(unstable_ps.LT.MAX_WRITE_UPS)THEN
                  WRITE(20456,*)"Warning:find an unstable phase"//
     $                 " space point"
                  WRITE(20456,*)"gq loop ME2 finite=",virt_wgts_1(1),
     $                 virt_wgts_2(1), mp_virt_wgts_1(1), 
     $                 mp_virt_wgts_2(1)
                  WRITE(20456,*)"gq loop ME2 1eps=",virt_wgts_1(2),
     $                 virt_wgts_2(2), mp_virt_wgts_1(2), 
     $                 mp_virt_wgts_2(2)
                  WRITE(20456,*)"gq loop ME2 2eps=",virt_wgts_1(3),
     $                 virt_wgts_2(3), mp_virt_wgts_1(3), 
     $                 mp_virt_wgts_2(3)
                  WRITE(20456,*)"======Unstable Phase Space Point"//
     $                 "=========="
                  DO i=1,nexternal-1
                     WRITE(20456,*)i,pborn(0:3,i)
                  ENDDO
                  WRITE(20456,*)"================================="//
     $                 "========="
               ENDIF
               virt_wgts(1)=zero
               virt_wgts(2)=zero
               virt_wgts(3)=zero
            else
               stable=.true.
               ! let us use the quadrupole precision one
               virt_wgts(1)=mp_virt_wgts_1(1)
               virt_wgts(2)=mp_virt_wgts_1(2)
               virt_wgts(3)=mp_virt_wgts_1(3)
            endif
         else
            ! we do not use the quadrupole precision
            stable=.false.
            IF(unstable_ps.LT.MAX_WRITE_UPS)THEN
               WRITE(20456,*)"Warning:find an unstable phase"//
     $              " space point"
               WRITE(20456,*)"gq loop ME2 finite=",virt_wgts_1(1),
     $              virt_wgts_2(1)
               WRITE(20456,*)"gq loop ME2 1eps=",virt_wgts_1(2),
     $              virt_wgts_2(2)
               WRITE(20456,*)"gq loop ME2 2eps=",virt_wgts_1(3),
     $              virt_wgts_2(3)
               WRITE(20456,*)"======Unstable Phase Space Point"//
     $              "=========="
               DO i=1,nexternal-1
                  WRITE(20456,*)i,pborn(0:3,i)
               ENDDO
               WRITE(20456,*)"================================="//
     $              "========="
            ENDIF
            virt_wgts(1)=zero
            virt_wgts(2)=zero
            virt_wgts(3)=zero
         endif
      else
         stable=.true.
         virt_wgts(1)=virt_wgts_1(1)
         virt_wgts(2)=virt_wgts_1(2)
         virt_wgts(3)=virt_wgts_1(3)
      endif
      return
      end

      subroutine call_qg_sloopmatrix(pborn, virt_wgts, stable)
      use pp_oniumjet_NLO_Global
      implicit none
      double precision pborn(0:3,nexternal-1)
      double precision virt_wgts(3)
      logical stable
      double precision pborn_backup(0:3,nexternal-1)
      double precision MC_backup,MC2_backup,MUR_backup
      double precision MC3_backup, MC4_backup, LDME1S01_backup
      double precision virt_wgts_1(3),virt_wgts_2(3)
      integer i,j
      double precision denom,diff,ratio
      real*16 mp_virt_wgts_1(3),mp_virt_wgts_2(3)
      real*16 MP_MC_backup,MP_MC2_backup,MP_MUR_backup
      real*16 MP_MC3_backup, MP_MC4_backup, MP_LDME1S01_backup
      real*16 mp_pborn_backup(0:3,nexternal-1)
      real*16 mp_denom,mp_diff,mp_ratio
      ! calling the original loop matrix
      call qg_sloopmatrix(pborn, virt_wgts_1)
      IF(virt_wgts_1(1).EQ.zero)THEN
         virt_wgts(1:3)=virt_wgts_1(1:3)
         stable=.TRUE.
         RETURN
      ENDIF
      ! start to rescaling the dimensional quantities by 100
      ! first backup them
      MC_backup=MC
      MC2_backup=MC2
      MC3_backup=MC3
      MC4_backup=MC4
      MUR_backup=MUR
      LDME1S01_backup=LDME1S01
      ! second rescalig
      do i=0,3
         do j=1,nexternal-1
            pborn_backup(i,j)=pborn(i,j)*mass_rescaling
         enddo
      enddo
      MC=MC*mass_rescaling
      MC2=MC2*mass_rescaling**2
      MC3=MC3*mass_rescaling**3
      MC4=MC4*mass_rescaling**4
      MUR=MUR*mass_rescaling
      LDME1S01=LDME1S01*mass_rescaling**3
      call qg_sloopmatrix(pborn_backup, virt_wgts_2)
      ! recover
      MC=MC_backup
      MC2=MC2_backup
      MC3=MC3_backup
      MC4=MC4_backup
      MUR=MUR_backup
      LDME1S01=LDME1S01_backup
      denom=MAX(DABS(virt_wgts_1(1)),DABS(virt_wgts_2(1)))
      denom=MAX(denom,DABS(virt_wgts_1(2)))
      denom=MAX(denom,DABS(virt_wgts_1(3)))
      denom=MAX(denom,DABS(virt_wgts_2(2)))
      denom=MAX(denom,DABS(virt_wgts_2(3)))
      diff=DABS(virt_wgts_1(1)-virt_wgts_2(1))
      diff=MAX(diff,DABS(virt_wgts_1(2)-virt_wgts_2(2)))
      diff=MAX(diff,DABS(virt_wgts_1(3)-virt_wgts_2(3)))
      ratio=DABS(virt_wgts_1(1))/MAX(DABS(virt_wgts_1(2)),
     $     DABS(virt_wgts_1(3)))
      if(diff/denom.GT.stable_threshold.OR.
     $     ratio.GT.stable_unbounded)then
         if(quadrupole_precision)THEN
            if(force_update_mp_phasespace)then
               CALL SET_MP_PS(ponium_born,mp_ponium_born)
               force_update_mp_phasespace=.false.
            endif
            ! try to use the quadrupole precision
            call mp_qg_sloopmatrix(mp_ponium_born, mp_virt_wgts_1)
            ! start to rescaling the dimensional quantities by 100
            ! first backup them
            MP_MC_backup=MP_MC
            MP_MC2_backup=MP_MC2
            MP_MC3_backup=MP_MC3
            MP_MC4_backup=MP_MC4
            MP_MUR_backup=MP_MUR
            MP_LDME1S01_backup=MP_LDME1S01
            ! second rescalig
            do i=0,3
               do j=1,nexternal-1
                  mp_pborn_backup(i,j)=mp_ponium_born(i,j)
     $                 *mp_mass_rescaling
               enddo
            enddo
            MP_MC=MP_MC*mp_mass_rescaling
            MP_MC2=MP_MC2*mp_mass_rescaling**2
            MP_MC3=MP_MC3*mp_mass_rescaling**3
            MP_MC4=MP_MC4*mp_mass_rescaling**4
            MP_MUR=MP_MUR*mp_mass_rescaling
            MP_LDME1S01=MP_LDME1S01*mp_mass_rescaling**3
            call mp_qg_sloopmatrix(mp_pborn_backup, mp_virt_wgts_2)
            ! recover
            MP_MC=MP_MC_backup
            MP_MC2=MP_MC2_backup
            MP_MC3=MP_MC3_backup
            MP_MC4=MP_MC4_backup
            MP_MUR=MP_MUR_backup
            MP_LDME1S01=MP_LDME1S01_backup
            mp_denom=MAX(ABS(mp_virt_wgts_1(1)),ABS(mp_virt_wgts_2(1)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_1(2)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_1(3)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_2(2)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_2(3)))
            mp_diff=ABS(mp_virt_wgts_1(1)-mp_virt_wgts_2(1))
            mp_diff=MAX(mp_diff,
     $           ABS(mp_virt_wgts_1(2)-mp_virt_wgts_2(2)))
            mp_diff=MAX(mp_diff,
     $           ABS(mp_virt_wgts_1(3)-mp_virt_wgts_2(3)))
            mp_ratio=ABS(mp_virt_wgts_1(1))/MAX(ABS(mp_virt_wgts_1(2)),
     $           ABS(mp_virt_wgts_1(3)))
            if(real(mp_diff/mp_denom,kind=8).GT.stable_threshold.OR.
     $           real(mp_ratio,kind=8).GT.stable_unbounded)then
               stable=.false.
               IF(unstable_ps.LT.MAX_WRITE_UPS)THEN
                  WRITE(20456,*)"Warning:find an unstable phase"//
     $                 " space point"
                  WRITE(20456,*)"qg loop ME2 finite=",virt_wgts_1(1),
     $                 virt_wgts_2(1),mp_virt_wgts_1(1),
     $                 mp_virt_wgts_2(1)
                  WRITE(20456,*)"qg loop ME2 1eps=",virt_wgts_1(2),
     $                 virt_wgts_2(2),mp_virt_wgts_1(2),
     $                 mp_virt_wgts_2(2)
                  WRITE(20456,*)"qg loop ME2 2eps=",virt_wgts_1(3),
     $                 virt_wgts_2(3),mp_virt_wgts_1(3),
     $                 mp_virt_wgts_2(3)
                  WRITE(20456,*)"======Unstable Phase Space Point"//
     $                 "=========="
                  DO i=1,nexternal-1
                     WRITE(20456,*)i,pborn(0:3,i)
                  ENDDO
                  WRITE(20456,*)"================================="//
     $                 "========="
               ENDIF
               virt_wgts(1)=zero
               virt_wgts(2)=zero
               virt_wgts(3)=zero
            else
               stable=.true.
               ! let us use the quadrupole precision one
               virt_wgts(1)=mp_virt_wgts_1(1)
               virt_wgts(2)=mp_virt_wgts_1(2)
               virt_wgts(3)=mp_virt_wgts_1(3)
            endif
         else
            ! we do not use the quadruple precision
            stable=.false.
            IF(unstable_ps.LT.MAX_WRITE_UPS)THEN
               WRITE(20456,*)"Warning:find an unstable phase"//
     $              " space point"
               WRITE(20456,*)"qg loop ME2 finite=",virt_wgts_1(1),
     $              virt_wgts_2(1)
               WRITE(20456,*)"qg loop ME2 1eps=",virt_wgts_1(2),
     $              virt_wgts_2(2)
               WRITE(20456,*)"qg loop ME2 2eps=",virt_wgts_1(3),
     $              virt_wgts_2(3)
               WRITE(20456,*)"======Unstable Phase Space Point"//
     $              "=========="
               DO i=1,nexternal-1
                  WRITE(20456,*)i,pborn(0:3,i)
               ENDDO
               WRITE(20456,*)"================================="//
     $              "========="
            ENDIF
            virt_wgts(1)=zero
            virt_wgts(2)=zero
            virt_wgts(3)=zero
         endif
      else
         stable=.true.
         virt_wgts(1)=virt_wgts_1(1)
         virt_wgts(2)=virt_wgts_1(2)
         virt_wgts(3)=virt_wgts_1(3)
      endif
      return
      end

      subroutine call_qq_sloopmatrix(pborn, virt_wgts, stable)
      use pp_oniumjet_NLO_Global
      implicit none
      double precision pborn(0:3,nexternal-1)
      double precision virt_wgts(3)
      logical stable
      double precision pborn_backup(0:3,nexternal-1)
      double precision MC_backup,MC2_backup,MUR_backup
      double precision MC3_backup, MC4_backup, LDME1S01_backup
      double precision virt_wgts_1(3),virt_wgts_2(3)
      integer i,j
      double precision denom,diff,ratio
      real*16 mp_virt_wgts_1(3),mp_virt_wgts_2(3)
      real*16 MP_MC_backup,MP_MC2_backup,MP_MUR_backup
      real*16 MP_MC3_backup, MP_MC4_backup, MP_LDME1S01_backup
      real*16 mp_pborn_backup(0:3,nexternal-1)
      real*16 mp_denom,mp_diff,mp_ratio
      ! calling the original loop matrix
      call qq_sloopmatrix(pborn, virt_wgts_1)
      IF(virt_wgts_1(1).EQ.zero)THEN
         virt_wgts(1:3)=virt_wgts_1(1:3)
         stable=.TRUE.
         RETURN
      ENDIF
      ! start to rescaling the dimensional quantities by 100
      ! first backup them
      MC_backup=MC
      MC2_backup=MC2
      MC3_backup=MC3
      MC4_backup=MC4
      MUR_backup=MUR
      LDME1S01_backup=LDME1S01
      ! second rescalig
      do i=0,3
         do j=1,nexternal-1
            pborn_backup(i,j)=pborn(i,j)*mass_rescaling
         enddo
      enddo
      MC=MC*mass_rescaling
      MC2=MC2*mass_rescaling**2
      MC3=MC3*mass_rescaling**3
      MC4=MC4*mass_rescaling**4
      MUR=MUR*mass_rescaling
      LDME1S01=LDME1S01*mass_rescaling**3
      call qq_sloopmatrix(pborn_backup, virt_wgts_2)
      ! recover
      MC=MC_backup
      MC2=MC2_backup
      MC3=MC3_backup
      MC4=MC4_backup
      MUR=MUR_backup
      LDME1S01=LDME1S01_backup
      denom=MAX(DABS(virt_wgts_1(1)),DABS(virt_wgts_2(1)))
      denom=MAX(denom,DABS(virt_wgts_1(2)))
      denom=MAX(denom,DABS(virt_wgts_1(3)))
      denom=MAX(denom,DABS(virt_wgts_2(2)))
      denom=MAX(denom,DABS(virt_wgts_2(3)))
      diff=DABS(virt_wgts_1(1)-virt_wgts_2(1))
      diff=MAX(diff,DABS(virt_wgts_1(2)-virt_wgts_2(2)))
      diff=MAX(diff,DABS(virt_wgts_1(3)-virt_wgts_2(3)))
      ratio=DABS(virt_wgts_1(1))/MAX(DABS(virt_wgts_1(2)),
     $     DABS(virt_wgts_1(3)))
      if(diff/denom.GT.stable_threshold.OR.
     $     ratio.GT.stable_unbounded)then
         if(quadrupole_precision)THEN
            if(force_update_mp_phasespace)then
               CALL SET_MP_PS(ponium_born,mp_ponium_born)
               force_update_mp_phasespace=.false.
            endif
            ! try to use the quadrupole precision
            call mp_qq_sloopmatrix(mp_ponium_born, mp_virt_wgts_1)
            ! start to rescaling the dimensional quantities by 100
            ! first backup them
            MP_MC_backup=MP_MC
            MP_MC2_backup=MP_MC2
            MP_MC3_backup=MP_MC3
            MP_MC4_backup=MP_MC4
            MP_MUR_backup=MP_MUR
            MP_LDME1S01_backup=MP_LDME1S01
            ! second rescalig
            do i=0,3
               do j=1,nexternal-1
                  mp_pborn_backup(i,j)=mp_ponium_born(i,j)
     $                 *mp_mass_rescaling
               enddo
            enddo
            MP_MC=MP_MC*mp_mass_rescaling
            MP_MC2=MP_MC2*mp_mass_rescaling**2
            MP_MC3=MP_MC3*mp_mass_rescaling**3
            MP_MC4=MP_MC4*mp_mass_rescaling**4
            MP_MUR=MP_MUR*mp_mass_rescaling
            MP_LDME1S01=MP_LDME1S01*mp_mass_rescaling**3
            call mp_qq_sloopmatrix(mp_pborn_backup, mp_virt_wgts_2)
            ! recover
            MP_MC=MP_MC_backup
            MP_MC2=MP_MC2_backup
            MP_MC3=MP_MC3_backup
            MP_MC4=MP_MC4_backup
            MP_MUR=MP_MUR_backup
            MP_LDME1S01=MP_LDME1S01_backup
            mp_denom=MAX(ABS(mp_virt_wgts_1(1)),ABS(mp_virt_wgts_2(1)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_1(2)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_1(3)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_2(2)))
            mp_denom=MAX(mp_denom,ABS(mp_virt_wgts_2(3)))
            mp_diff=ABS(mp_virt_wgts_1(1)-mp_virt_wgts_2(1))
            mp_diff=MAX(mp_diff,
     $           ABS(mp_virt_wgts_1(2)-mp_virt_wgts_2(2)))
            mp_diff=MAX(mp_diff,
     $           ABS(mp_virt_wgts_1(3)-mp_virt_wgts_2(3)))
            mp_ratio=ABS(mp_virt_wgts_1(1))/MAX(ABS(mp_virt_wgts_1(2)),
     $           ABS(mp_virt_wgts_1(3)))
            if(real(mp_diff/mp_denom,kind=8).GT.stable_threshold.OR.
     $           real(mp_ratio,kind=8).GT.stable_unbounded)then
               stable=.false.
               IF(unstable_ps.LT.MAX_WRITE_UPS)THEN
                  WRITE(20456,*)"Warning:find an unstable phase"//
     $                 " space point"
                  WRITE(20456,*)"qq loop ME2 finite=",virt_wgts_1(1),
     $                 virt_wgts_2(1), mp_virt_wgts_1(1),
     $                 mp_virt_wgts_2(1)
                  WRITE(20456,*)"qq loop ME2 1eps=",virt_wgts_1(2),
     $                 virt_wgts_2(2), mp_virt_wgts_1(2),
     $                 mp_virt_wgts_2(2)
                  WRITE(20456,*)"qq loop ME2 2eps=",virt_wgts_1(3),
     $                 virt_wgts_2(3), mp_virt_wgts_1(3),
     $                 mp_virt_wgts_2(3)
                  WRITE(20456,*)"======Unstable Phase Space Point"//
     $                 "=========="
                  DO i=1,nexternal-1
                     WRITE(20456,*)i,pborn(0:3,i)
                  ENDDO
                  WRITE(20456,*)"================================="//
     $                 "========="
               ENDIF
               virt_wgts(1)=zero
               virt_wgts(2)=zero
               virt_wgts(3)=zero
            else
               stable=.true.
               ! let us use the quadrupole precision one
               virt_wgts(1)=mp_virt_wgts_1(1)
               virt_wgts(2)=mp_virt_wgts_1(2)
               virt_wgts(3)=mp_virt_wgts_1(3)
            endif
         else
            ! we do not use the quadrupole precision
            stable=.false.
            IF(unstable_ps.LT.MAX_WRITE_UPS)THEN
               WRITE(20456,*)"Warning:find an unstable phase"//
     $              " space point"
               WRITE(20456,*)"qq loop ME2 finite=",virt_wgts_1(1),
     $              virt_wgts_2(1)
               WRITE(20456,*)"qq loop ME2 1eps=",virt_wgts_1(2),
     $              virt_wgts_2(2)
               WRITE(20456,*)"qq loop ME2 2eps=",virt_wgts_1(3),
     $              virt_wgts_2(3)
               WRITE(20456,*)"======Unstable Phase Space Point"//
     $              "=========="
               DO i=1,nexternal-1
                  WRITE(20456,*)i,pborn(0:3,i)
               ENDDO
               WRITE(20456,*)"================================="//
     $              "========="
            ENDIF
            virt_wgts(1)=zero
            virt_wgts(2)=zero
            virt_wgts(3)=zero
         endif
      else
         stable=.true.
         virt_wgts(1)=virt_wgts_1(1)
         virt_wgts(2)=virt_wgts_1(2)
         virt_wgts(3)=virt_wgts_1(3)
      endif
      return
      end

      subroutine sloopmatrix(pborn, virt_wgts)
      ! the underlying born here is g g > eta_c
      ! this is just used for the test purpose 
      use Func_PSI_2
      use pp_oniumjet_NLO_Global
      implicit none
      integer NDIM,NLOG,NLI
      parameter (NDIM=0)
      parameter (NLOG=3)
      parameter (NLI=0)
      double precision virt_wgts(3)
      double precision pborn(0:3,nexternal-2)
      double precision rmu
      double complex loopba(NDIM)
      double complex logs(NLOG)
      double complex li2s(NLI)
      integer i
      rmu=MUR**2/MC2
      logs(1)=log2(16D0)
      logs(2)=log2(-(1D0/rmu))
      logs(3)=log2(rmu)
      virt_wgts(3)=-(G**6*LDME1S01*MC2)/(192D0*MC3*PI2)
      virt_wgts(2)=        (G**6*LDME1S01*MC2*
     -    (-1D0 + logs(1) + 2D0*logs(2)))/
     -  (384D0*MC3*PI2)
      virt_wgts(1)=        (G**6*LDME1S01*
     -    (-(logtwo*MC2)/(96D0*PI2) -
     -      (logtwo**2*MC2)/(96D0*PI2) +
     -      (MC2*(46D0 + 13D0*PI2))/(6912D0*PI2) +
     -      (MC2*logs(3))/(192D0*PI2) +
     -      (logtwo*MC2*logs(3))/(96D0*PI2) -
     -      (MC2*logs(3)**2)/(384D0*PI2)))/MC3
      return
      end

      subroutine gg_sloopmatrix(pborn, virt_wgts)
      use Func_PSI_2
      use pp_oniumjet_NLO_Global
      implicit none
      integer NDIM,NLOG,NLI
      parameter (NDIM=21)
      parameter (NLOG=13)
      parameter (NLI=15)
      double precision virt_wgts(3)
      double precision pborn(0:3,nexternal-1)
      double precision ponia(0:3)
      double precision shat,that
      double precision rs,rt,rmu
      double precision rs2,rs3,rs4,rs5,rs6,rs7,rs8,rs9,rs10
      double precision rs11,rs12,rs13,rs14,rs15,rs16,rs17,rs18,rs19
      double precision rt2,rt3,rt4,rt5,rt6,rt7,rt8,rt9,rt10
      double precision rt11,rt12,rt13,rt14,rt15,rt16,rt17
      double precision sumdot2
      double complex loopba(NDIM)
      double complex logs(NLOG)
      double complex li2s(NLI)
      integer i
      double complex const1,const2,const3,const4,const5,const6,const7
      ! i/288
      parameter (const1=(0d0,3.472222222222222222222222222222222222d-3))
      ! i/1152
      parameter (const2=(0d0,8.680555555555555555555555555555555556d-4))
      ! i/648
      parameter (const3=(0d0,1.543209876543209876543209876543209877d-3))
      ! i/5184
      parameter (const4=(0d0,1.929012345679012345679012345679012346d-4))
      ! i/2304
      parameter (const5=(0d0,4.340277777777777777777777777777777778d-4))
      ! i/256
      parameter (const6=(0d0,0.00390625d0))
      ! i/576
      parameter (const7=(0d0,1.736111111111111111111111111111111111d-3))
      !MUR=MU_R
      ponia(0:3)=pborn(0:3,3)+pborn(0:3,4)
      shat=sumdot2(pborn(0:3,1),pborn(0:3,2),1d0)
      that=sumdot2(pborn(0:3,1),ponia(0:3),-1d0)
      rmu=MUR**2/MC2
      rs=shat/MC2
      IF(stability_check.AND.stable_rsmax.GE.0d0
     $     .AND.rs.GT.stable_rsmax)THEN
         virt_wgts(1:3)=zero
         RETURN
      ENDIF
      rt=that/MC2
      rs2=rs**2
      rs3=rs2*rs
      rs4=rs3*rs
      rs5=rs4*rs
      rs6=rs5*rs
      rs7=rs6*rs
      rs8=rs7*rs
      rs9=rs8*rs
      rs10=rs9*rs
      rs11=rs10*rs
      rs12=rs11*rs
      rs13=rs12*rs
      rs14=rs13*rs
      rs15=rs14*rs
      rs16=rs15*rs
      rs17=rs16*rs
      rs18=rs17*rs
      rs19=rs18*rs
      rt2=rt**2
      rt3=rt2*rt
      rt4=rt3*rt
      rt5=rt4*rt
      rt6=rt5*rt
      rt7=rt6*rt
      rt8=rt7*rt
      rt9=rt8*rt
      rt10=rt9*rt
      rt11=rt10*rt
      rt12=rt11*rt
      rt13=rt12*rt
      rt14=rt13*rt
      rt15=rt14*rt
      rt16=rt15*rt
      rt17=rt16*rt
      logs(1)=log2(rmu)
      logs(2)=log2(rs)
      logs(3)=log2(-FOUR + rs)
      logs(4)=log2(DSQRT(rs) - DSQRT(-FOUR + rs))
      logs(5)=log2(DSQRT(rs) + DSQRT(-FOUR + rs))
      logs(6)=log2(DSQRT(FOUR - rt) - DSQRT(-rt))
      logs(7)=log2(DSQRT(FOUR - rt) + DSQRT(-rt))
      logs(8)=log2(FOUR - rt)
      logs(9)=log2(-rt)
      logs(10)=log2(rs + rt)
      logs(11)=log2(-FOUR + rs + rt)
      logs(12)=log2(DSQRT(rs + rt) - DSQRT(-FOUR + rs + rt))
      logs(13)=log2(DSQRT(rs + rt) + DSQRT(-FOUR + rs + rt))
      li2s(1)=li2((-FOUR + rs)/rs)
      li2s(2)=li2((rs - rt)/(-FOUR + rs))
      li2s(3)=li2((-FOUR + rt)/rt)
      li2s(4)=li2((-rs + rt)/(-FOUR + rt))
      li2s(5)=li2((rs + rt)/(-FOUR + rs + rt))
      li2s(6)=li2((rs - TWO)/(-FOUR + rs))
      li2s(7)=li2((rt - TWO)/(-FOUR + rt))
      li2s(8)=li2((rs + rt - TWO)/(rs + rt))
      li2s(9)=li2((rs - TWO)/TWO)
      li2s(10)=li2((rt - TWO)/TWO)
      li2s(11)=li2((-rs - rt + TWO)/TWO)
      li2s(12)=li2((-FOUR + rt + rs*TWO)/(-FOUR + rs))
      li2s(13)=li2((-FOUR + rt + rs*TWO)/(rs + rt))
      li2s(14)=li2((-FOUR + rs + rt*TWO)/(-FOUR + rt))
      li2s(15)=li2((-FOUR + rs + rt*TWO)/(rs + rt))
      call gg_loopbasis(MC,shat,that,MUR,loopba)
      virt_wgts(3)=        (3D0*G**8*LDME1S01*
     -    (rs2 + rs*(-4D0 + rt) + (-4D0 + rt)*rt)**
     -     2D0*(rs4 + 2D0*rs3*(-4D0 + rt) + 
     -      3D0*rs2*(-4D0 + rt)**2 + 
     -      2D0*rs*(-4D0 + rt)**3 + 
     -      (16D0 - 4D0*rt + rt2)**2))/
     -  (32D0*MC3*PI2*(-4D0 + rs)**2*rs*(-4D0 + rt)**2*
     -    rt*(-4D0 + rs + rt)*(rs + rt)**2)
      virt_wgts(2)=        (G**8*LDME1S01*
     -    (rs2 + rs*(-4D0 + rt) + (-4D0 + rt)*rt)**
     -     2D0*(3840D0 - 512D0*rnlq - 1920D0*rs + 
     -      256D0*rnlq*rs + 720D0*rs2 - 
     -      96D0*rnlq*rs2 - 120D0*rs3 + 
     -      16D0*rnlq*rs3 + 15D0*rs4 - 
     -      2D0*rnlq*rs4 - 1920D0*rt + 256D0*rnlq*rt + 
     -      2016D0*rs*rt - 192D0*rnlq*rs*rt - 
     -      504D0*rs2*rt + 48D0*rnlq*rs2*rt + 
     -      30D0*rs3*rt - 4D0*rnlq*rs3*rt + 
     -      720D0*rt2 - 96D0*rnlq*rt2 - 
     -      504D0*rs*rt2 + 48D0*rnlq*rs*rt2 + 
     -      45D0*rs2*rt2 - 6D0*rnlq*rs2*rt2 - 
     -      120D0*rt3 + 16D0*rnlq*rt3 + 
     -      30D0*rs*rt3 - 4D0*rnlq*rs*rt3 + 
     -      15D0*rt4 - 2D0*rnlq*rt4 + 
     -      18D0*(rs4 + 2D0*rs3*(-4D0 + rt) + 
     -         3D0*rs2*(-4D0 + rt)**2 + 
     -         2D0*rs*(-4D0 + rt)**3 + 
     -         (16D0 - 4D0*rt + rt2)**2)*logs(1) - 
     -      6D0*(rs4 + 2D0*rs3*(-4D0 + rt) + 
     -         3D0*rs2*(-4D0 + rt)**2 + 
     -         2D0*rs*(-4D0 + rt)**3 + 
     -         (16D0 - 4D0*rt + rt2)**2)*logs(2) - 
     -      6D0*(rs4 + 2D0*rs3*(-4D0 + rt) + 
     -         3D0*rs2*(-4D0 + rt)**2 + 
     -         2D0*rs*(-4D0 + rt)**3 + 
     -         (16D0 - 4D0*rt + rt2)**2)*logs(9) - 
     -      6D0*(rs4 + 2D0*rs3*(-4D0 + rt) + 
     -         3D0*rs2*(-4D0 + rt)**2 + 
     -         2D0*rs*(-4D0 + rt)**3 + 
     -         (16D0 - 4D0*rt + rt2)**2)*logs(11)))/
     -  (192.0D0*MC3*PI2*(-4D0 + rs)**2*rs*
     -    (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -    (rs + rt)**2)
      virt_wgts(1)=        (G**8*LDME1S01*
     -    (-(logtwo**2*
     -          (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -            rt2)*
     -          (16384 - 12288D0*rs + 5888D0*rs2 - 
     -            1920D0*rs3 + 560D0*rs4 - 
     -            96D0*rs5 + 8*rs6 - 12288D0*rt - 
     -            5632D0*rs*rt + 6272D0*rs2*rt - 
     -            3168D0*rs3*rt + 1016*rs4*rt - 
     -            192D0*rs5*rt + 18D0*rs6*rt + 
     -            5888D0*rt2 + 6272D0*rs*rt2 - 
     -            6816*rs2*rt2 + 
     -            3064D0*rs3*rt2 - 
     -            609D0*rs4*rt2 + 
     -            54D0*rs5*rt2 - 1920D0*rt3 - 
     -            3168D0*rs*rt3 + 
     -            3064D0*rs2*rt3 - 
     -            898D0*rs3*rt3 + 
     -            90D0*rs4*rt3 + 560D0*rt4 + 
     -            1016*rs*rt4 - 
     -            609D0*rs2*rt4 + 
     -            90D0*rs3*rt4 - 96D0*rt5 - 
     -            192D0*rs*rt5 + 54D0*rs2*rt5 + 
     -            8*rt6 + 18D0*rs*rt6))/
     -       (512.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) + 
     -      (logtwo*(-4D0*rs + rs2 - 4D0*rt + 
     -           rs*rt + rt2)*
     -         (12582912D0*rs4 - 37748736D0*rs5 + 
     -           48758784D0*rs6 - 
     -           35389440D0*rs7 + 
     -           15777792D0*rs8 - 4423680D0*rs9 + 
     -           761856D0*rs10 - 73728D0*rs11 + 
     -           3072D0*rs12 - 
     -           134217728D0*rs2*rt + 
     -           478150656D0*rs3*rt - 
     -           802160640D0*rs4*rt + 
     -           827850752D0*rs5*rt - 
     -           573571072D0*rs6*rt + 
     -           274595840D0*rs7*rt - 
     -           90976256D0*rs8*rt + 
     -           20480000D0*rs9*rt - 
     -           2996224D0*rs10*rt + 
     -           258048D0*rs11*rt - 
     -           9984D0*rs12*rt - 
     -           134217728D0*rs*rt2 + 
     -           864026624D0*rs2*rt2 - 
     -           2.117074944d9*rs3*rt2 + 
     -           2.9097984d9*rs4*rt2 - 
     -           2.59162112d9*rs5*rt2 + 
     -           1.595162624d9*rs6*rt2 - 
     -           697401344D0*rs7*rt2 + 
     -           218194944D0*rs8*rt2 - 
     -           48620544D0*rs9*rt2 + 
     -           7625984D0*rs10*rt2 - 
     -           835328D0*rs11*rt2 + 
     -           65312D0*rs12*rt2 - 
     -           3808D0*rs13*rt2 + 
     -           136D0*rs14*rt2 + 
     -           478150656D0*rs*rt3 - 
     -           2.117074944d9*rs2*rt3 + 
     -           4.210556928d9*rs3*rt3 - 
     -           5.038276608d9*rs4*rt3 + 
     -           4.069261312d9*rs5*rt3 - 
     -           2.339639296d9*rs6*rt3 + 
     -           978931712D0*rs7*rt3 - 
     -           299437568D0*rs8*rt3 + 
     -           66649856D0*rs9*rt3 - 
     -           10723584D0*rs10*rt3 + 
     -           1246400D0*rs11*rt3 - 
     -           105008D0*rs12*rt3 + 
     -           6104D0*rs13*rt3 - 
     -           184D0*rs14*rt3 + 
     -           12582912D0*rt4 - 
     -           802160640D0*rs*rt4 + 
     -           2.9097984d9*rs2*rt4 - 
     -           5.038276608d9*rs3*rt4 + 
     -           5.451087872d9*rs4*rt4 - 
     -           4.094619648d9*rs5*rt4 + 
     -           2.230249472d9*rs6*rt4 - 
     -           890916864D0*rs7*rt4 + 
     -           259732288D0*rs8*rt4 - 
     -           54626656D0*rs9*rt4 + 
     -           8186424D0*rs10*rt4 - 
     -           863856D0*rs11*rt4 + 
     -           62522D0*rs12*rt4 - 
     -           2800D0*rs13*rt4 + 
     -           54D0*rs14*rt4 - 
     -           37748736D0*rt5 + 
     -           827850752D0*rs*rt5 - 
     -           2.59162112d9*rs2*rt5 + 
     -           4.069261312d9*rs3*rt5 - 
     -           4.094619648d9*rs4*rt5 + 
     -           2.89748992d9*rs5*rt5 - 
     -           1.485479424d9*rs6*rt5 + 
     -           551372288D0*rs7*rt5 - 
     -           146214496D0*rs8*rt5 + 
     -           27208440D0*rs9*rt5 - 
     -           3476920D0*rs10*rt5 + 
     -           295196D0*rs11*rt5 - 
     -           15385D0*rs12*rt5 + 
     -           378D0*rs13*rt5 + 
     -           48758784D0*rt6 - 
     -           573571072D0*rs*rt6 + 
     -           1.595162624d9*rs2*rt6 - 
     -           2.339639296d9*rs3*rt6 + 
     -           2.230249472d9*rs4*rt6 - 
     -           1.485479424d9*rs5*rt6 + 
     -           701685120D0*rs6*rt6 - 
     -           232914752D0*rs7*rt6 + 
     -           53314408D0*rs8*rt6 - 
     -           8196360D0*rs9*rt6 + 
     -           812166D0*rs10*rt6 - 
     -           47702D0*rs11*rt6 + 
     -           1296D0*rs12*rt6 - 
     -           35389440D0*rt7 + 
     -           274595840D0*rs*rt7 - 
     -           697401344D0*rs2*rt7 + 
     -           978931712D0*rs3*rt7 - 
     -           890916864D0*rs4*rt7 + 
     -           551372288D0*rs5*rt7 - 
     -           232914752D0*rs6*rt7 + 
     -           66218384D0*rs7*rt7 - 
     -           12342208D0*rs8*rt7 + 
     -           1441436D0*rs9*rt7 - 
     -           96320D0*rs10*rt7 + 
     -           2862D0*rs11*rt7 + 
     -           15777792D0*rt8 - 
     -           90976256D0*rs*rt8 + 
     -           218194944D0*rs2*rt8 - 
     -           299437568D0*rs3*rt8 + 
     -           259732288D0*rs4*rt8 - 
     -           146214496D0*rs5*rt8 + 
     -           53314408D0*rs6*rt8 - 
     -           12342208D0*rs7*rt8 + 
     -           1735824D0*rs8*rt8 - 
     -           134969D0*rs9*rt8 + 
     -           4482D0*rs10*rt8 - 
     -           4423680D0*rt9 + 
     -           20480000D0*rs*rt9 - 
     -           48620544D0*rs2*rt9 + 
     -           66649856D0*rs3*rt9 - 
     -           54626656D0*rs4*rt9 + 
     -           27208440D0*rs5*rt9 - 
     -           8196360D0*rs6*rt9 + 
     -           1441436D0*rs7*rt9 - 
     -           134969D0*rs8*rt9 + 
     -           5184D0*rs9*rt9 + 
     -           761856D0*rt10 - 
     -           2996224D0*rs*rt10 + 
     -           7625984D0*rs2*rt10 - 
     -           10723584D0*rs3*rt10 + 
     -           8186424D0*rs4*rt10 - 
     -           3476920D0*rs5*rt10 + 
     -           812166D0*rs6*rt10 - 
     -           96320D0*rs7*rt10 + 
     -           4482D0*rs8*rt10 - 
     -           73728D0*rt11 + 
     -           258048D0*rs*rt11 - 
     -           835328D0*rs2*rt11 + 
     -           1246400D0*rs3*rt11 - 
     -           863856D0*rs4*rt11 + 
     -           295196D0*rs5*rt11 - 
     -           47702D0*rs6*rt11 + 
     -           2862D0*rs7*rt11 + 
     -           3072D0*rt12 - 9984D0*rs*rt12 + 
     -           65312D0*rs2*rt12 - 
     -           105008D0*rs3*rt12 + 
     -           62522D0*rs4*rt12 - 
     -           15385D0*rs5*rt12 + 
     -           1296D0*rs6*rt12 - 
     -           3808D0*rs2*rt13 + 
     -           6104D0*rs3*rt13 - 
     -           2800D0*rs4*rt13 + 
     -           378D0*rs5*rt13 + 
     -           136D0*rs2*rt14 - 
     -           184D0*rs3*rt14 + 
     -           54D0*rs4*rt14))/
     -       (288.0D0*PI2*(-4D0 + rs)**3*(-2D0 + rs)**2*
     -         rs2*(-4D0 + rt)**3*(-2D0 + rt)**2*
     -         rt2*(-4D0 + rs + rt)**2*
     -         (-2D0 + rs + rt)**2*(rs + rt)**3) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (6.18475290624D11*rs6 - 
     -           1.468878815232D12*rs7 + 
     -           1.4495514624D12*rs8 - 
     -           7.4893492224D11*rs9 + 
     -           1.96897406976D11*rs10 - 
     -           9.965666304d9*rs11 - 
     -           9.890168832d9*rs12 + 
     -           3.3030144d9*rs13 - 
     -           495452160D0*rs14 + 
     -           37748736D0*rs15 - 
     -           1179648D0*rs16 - 
     -           1.7592186044416D13*PI2*rs2*
     -            rt + 
     -           6.2672162783232D13*PI2*rs3*
     -            rt - 
     -           9.9505802313728D13*PI2*rs4*
     -            rt - 
     -           8.76173328384D12*rs5*rt + 
     -           6.18475290624D11*rnlq*rs5*rt + 
     -           9.1663192031232D13*PI2*rs5*
     -            rt + 
     -           2.2406844383232D13*rs6*rt - 
     -           1.597727834112D12*rnlq*rs6*rt - 
     -           5.2772263165952D13*PI2*rs6*
     -            rt - 
     -           2.5975962206208D13*rs7*rt + 
     -           1.832877293568D12*rnlq*rs7*rt + 
     -           1.825428209664D13*PI2*rs7*rt + 
     -           1.8166101049344D13*rs8*rt - 
     -           1.234534662144D12*rnlq*rs8*rt - 
     -           2.449909743616D12*PI2*rs8*rt - 
     -           8.437194817536D12*rs9*rt + 
     -           5.3653536768D11*rnlq*rs9*rt - 
     -           9.74848524288D11*PI2*rs9*rt + 
     -           2.590116937728D12*rs10*rt - 
     -           1.497366528D11*rnlq*rs10*rt + 
     -           6.47011237888D11*PI2*rs10*rt - 
     -           4.34160795648D11*rs11*rt + 
     -           2.1177040896D10*rnlq*rs11*rt - 
     -           1.66487130112D11*PI2*rs11*rt - 
     -           2.027421696D10*rs12*rt + 
     -           2.286944256d9*rnlq*rs12*rt + 
     -           1.4153285632D10*PI2*rs12*rt + 
     -           3.4648621056D10*rs13*rt - 
     -           2.108424192d9*rnlq*rs13*rt + 
     -           4.57555968d9*PI2*rs13*rt - 
     -           1.0450108416D10*rs14*rt + 
     -           592773120D0*rnlq*rs14*rt - 
     -           1.889820672d9*PI2*rs14*rt + 
     -           1.802108928d9*rs15*rt - 
     -           99876864D0*rnlq*rs15*rt + 
     -           332750848D0*PI2*rs15*rt - 
     -           193228800D0*rs16*rt + 
     -           10641408D0*rnlq*rs16*rt - 
     -           32770048D0*PI2*rs16*rt + 
     -           12054528D0*rs17*rt - 
     -           663552D0*rnlq*rs17*rt + 
     -           1716224D0*PI2*rs17*rt - 
     -           334848D0*rs18*rt + 
     -           18432D0*rnlq*rs18*rt - 
     -           31744D0*PI2*rs18*rt - 
     -           512D0*PI2*rs19*rt - 
     -           3.5184372088832D13*PI2*rs*
     -            rt2 + 
     -           1.72623325560832D14*PI2*rs2*
     -            rt2 - 
     -           3.57203840073728D14*PI2*rs3*
     -            rt2 - 
     -           4.0613210750976D13*rs4*rt2 + 
     -           2.473901162496D12*rnlq*rs4*
     -            rt2 + 
     -           4.1944650612736D14*PI2*rs4*
     -            rt2 + 
     -           1.26826089283584D14*rs5*
     -            rt2 - 
     -           7.679401525248D12*rnlq*rs5*
     -            rt2 - 
     -           3.09506080768D14*PI2*rs5*
     -            rt2 - 
     -           1.74661287542784D14*rs6*
     -            rt2 + 
     -           1.0488310136832D13*rnlq*rs6*
     -            rt2 + 
     -           1.4542222393344D14*PI2*rs6*
     -            rt2 + 
     -           1.41154905489408D14*rs7*
     -            rt2 - 
     -           8.378407452672D12*rnlq*rs7*
     -            rt2 - 
     -           3.844230610944D13*PI2*rs7*
     -            rt2 - 
     -           7.4241798045696D13*rs8*rt2 + 
     -           4.337984077824D12*rnlq*rs8*
     -            rt2 + 
     -           6.96145412096D11*PI2*rs8*
     -            rt2 + 
     -           2.59660972032D13*rs9*rt2 - 
     -           1.48528693248D12*rnlq*rs9*
     -            rt2 + 
     -           3.880767193088D12*PI2*rs9*
     -            rt2 - 
     -           5.506823356416D12*rs10*rt2 + 
     -           3.04242229248D11*rnlq*rs10*
     -            rt2 - 
     -           1.6322265088D12*PI2*rs10*
     -            rt2 + 
     -           2.82275610624D11*rs11*rt2 - 
     -           1.2054429696D10*rnlq*rs11*
     -            rt2 + 
     -           3.0490361856D11*PI2*rs11*
     -            rt2 + 
     -           2.56084279296D11*rs12*rt2 - 
     -           1.5270150144D10*rnlq*rs12*
     -            rt2 - 
     -           1.02350848d9*PI2*rs12*rt2 - 
     -           1.04445444096D11*rs13*rt2 + 
     -           5.937168384d9*rnlq*rs13*rt2 - 
     -           1.4559821824D10*PI2*rs13*
     -            rt2 + 
     -           2.218696704D10*rs14*rt2 - 
     -           1.2324864d9*rnlq*rs14*rt2 + 
     -           3.971115008d9*PI2*rs14*rt2 - 
     -           2.989031424d9*rs15*rt2 + 
     -           163184640D0*rnlq*rs15*rt2 - 
     -           562479104D0*PI2*rs15*rt2 + 
     -           255040512D0*rs16*rt2 - 
     -           13719552D0*rnlq*rs16*rt2 + 
     -           46391808D0*PI2*rs16*rt2 - 
     -           12496896D0*rs17*rt2 + 
     -           663552D0*rnlq*rs17*rt2 - 
     -           2098176D0*PI2*rs17*rt2 + 
     -           263424D0*rs18*rt2 - 
     -           13824D0*rnlq*rs18*rt2 + 
     -           39680D0*PI2*rs18*rt2 + 
     -           1.06652627894272D14*PI2*rs*
     -            rt3 - 
     -           4.09293203439616D14*PI2*rs2*
     -            rt3 - 
     -           6.2466004353024D13*rs3*rt3 + 
     -           3.710851743744D12*rnlq*rs3*
     -            rt3 + 
     -           6.97210631094272D14*PI2*rs3*
     -            rt3 + 
     -           2.55352985616384D14*rs4*
     -            rt3 - 
     -           1.4894946582528D13*rnlq*rs4*
     -            rt3 - 
     -           6.90338683420672D14*PI2*rs4*
     -            rt3 - 
     -           4.35673966313472D14*rs5*
     -            rt3 + 
     -           2.5135222358016D13*rnlq*rs5*
     -            rt3 + 
     -           4.3103285149696D14*PI2*rs5*
     -            rt3 + 
     -           4.21918528241664D14*rs6*
     -            rt3 - 
     -           2.42195890176D13*rnlq*rs6*
     -            rt3 - 
     -           1.66231776690176D14*PI2*rs6*
     -            rt3 - 
     -           2.60743505117184D14*rs7*
     -            rt3 + 
     -           1.4967424155648D13*rnlq*rs7*
     -            rt3 + 
     -           2.9789339516928D13*PI2*rs7*
     -            rt3 + 
     -           1.0703956082688D14*rs8*rt3 - 
     -           6.162455986176D12*rnlq*rs8*
     -            rt3 + 
     -           5.858282962944D12*PI2*rs8*
     -            rt3 - 
     -           2.806530441216D13*rs9*rt3 + 
     -           1.618263146496D12*rnlq*rs9*
     -            rt3 - 
     -           5.532253421568D12*PI2*rs9*
     -            rt3 + 
     -           3.383535599616D12*rs10*rt3 - 
     -           1.9199950848D11*rnlq*rs10*
     -            rt3 + 
     -           1.637136072704D12*PI2*rs10*
     -            rt3 + 
     -           6.4170098688D11*rs11*rt3 - 
     -           3.8978715648D10*rnlq*rs11*
     -            rt3 - 
     -           1.89967040512D11*PI2*rs11*
     -            rt3 - 
     -           4.28345524224D11*rs12*rt3 + 
     -           2.5071255552D10*rnlq*rs12*
     -            rt3 - 
     -           3.0097825792D10*PI2*rs12*
     -            rt3 + 
     -           1.1067334656D11*rs13*rt3 - 
     -           6.3393792d9*rnlq*rs13*rt3 + 
     -           1.6563116032D10*PI2*rs13*
     -            rt3 - 
     -           1.753018368D10*rs14*rt3 + 
     -           979869696d0*rnlq*rs14*rt3 - 
     -           3.226318848d9*PI2*rs14*rt3 + 
     -           1.774239744d9*rs15*rt3 - 
     -           96534528D0*rnlq*rs15*rt3 + 
     -           354274304D0*PI2*rs15*rt3 - 
     -           107700480D0*rs16*rt3 + 
     -           5697024D0*rnlq*rs16*rt3 - 
     -           22660608D0*PI2*rs16*rt3 + 
     -           3234816D0*rs17*rt3 - 
     -           165888D0*rnlq*rs17*rt3 + 
     -           776832D0*PI2*rs17*rt3 - 
     -           24000D0*rs18*rt3 + 
     -           1152D0*rnlq*rs18*rt3 - 
     -           11712D0*PI2*rs18*rt3 + 
     -           96D0*PI2*rs19*rt3 - 
     -           1.43623706378240D14*PI2*rs*
     -            rt4 - 
     -           4.0613210750976D13*rs2*rt4 + 
     -           2.473901162496D12*rnlq*rs2*
     -            rt4 + 
     -           4.82565345509376D14*PI2*rs2*
     -            rt4 + 
     -           2.49889787215872D14*rs3*
     -            rt4 - 
     -           1.4585708937216D13*rnlq*rs3*
     -            rt4 - 
     -           7.21558800695296D14*PI2*rs3*
     -            rt4 - 
     -           5.64513321517056D14*rs4*
     -            rt4 + 
     -           3.227667922944D13*rnlq*rs4*
     -            rt4 + 
     -           6.23536909582336D14*PI2*rs4*
     -            rt4 + 
     -           6.8095498518528D14*rs5*rt4 - 
     -           3.8699802820608D13*rnlq*rs5*
     -            rt4 - 
     -           3.3257575940096D14*PI2*rs5*
     -            rt4 - 
     -           5.06521196691456D14*rs6*
     -            rt4 + 
     -           2.8958213013504D13*rnlq*rs6*
     -            rt4 + 
     -           1.01769476571136D14*PI2*rs6*
     -            rt4 + 
     -           2.46516308508672D14*rs7*
     -            rt4 - 
     -           1.4308884873216D13*rnlq*rs7*
     -            rt4 - 
     -           7.464804155392D12*PI2*rs7*
     -            rt4 - 
     -           7.792245080064D13*rs8*rt4 + 
     -           4.615802191872D12*rnlq*rs8*
     -            rt4 - 
     -           8.117398536192D12*PI2*rs8*
     -            rt4 + 
     -           1.35814447104D13*rs9*rt4 - 
     -           8.22456877056D11*rnlq*rs9*
     -            rt4 + 
     -           3.95596136448D12*PI2*rs9*
     -            rt4 + 
     -           3.6532912128D11*rs10*rt4 - 
     -           2.0150747136D10*rnlq*rs10*
     -            rt4 - 
     -           8.10825908224D11*PI2*rs10*
     -            rt4 - 
     -           9.87255865344D11*rs11*rt4 + 
     -           5.9422015488D10*rnlq*rs11*
     -            rt4 + 
     -           2.3173595136D10*PI2*rs11*
     -            rt4 + 
     -           3.12561942528D11*rs12*rt4 - 
     -           1.8633179136D10*rnlq*rs12*
     -            rt4 + 
     -           3.1245740032D10*PI2*rs12*
     -            rt4 - 
     -           5.6073486336D10*rs13*rt4 + 
     -           3.266543616d9*rnlq*rs13*rt4 - 
     -           8.764602368d9*PI2*rs13*rt4 + 
     -           6.20663808d9*rs14*rt4 - 
     -           350140416D0*rnlq*rs14*rt4 + 
     -           1.188954112d9*PI2*rs14*rt4 - 
     -           386592768D0*rs15*rt4 + 
     -           20963328D0*rnlq*rs15*rt4 - 
     -           88625408D0*PI2*rs15*rt4 + 
     -           8069184D0*rs16*rt4 - 
     -           405888D0*rnlq*rs16*rt4 + 
     -           3224640D0*PI2*rs16*rt4 + 
     -           376704D0*rs17*rt4 - 
     -           20736D0*rnlq*rs17*rt4 - 
     -           23488D0*PI2*rs17*rt4 - 
     -           16464D0*rs18*rt4 + 
     -           864D0*rnlq*rs18*rt4 - 
     -           1168D0*PI2*rs18*rt4 + 
     -           16D0*PI2*rs19*rt4 - 
     -           8.76173328384D12*rs*rt5 + 
     -           6.18475290624D11*rnlq*rs*rt5 + 
     -           1.14306259615744D14*PI2*rs*
     -            rt5 + 
     -           1.188632199168D14*rs2*rt5 - 
     -           7.21554505728D12*rnlq*rs2*
     -            rt5 - 
     -           3.46548026212352D14*PI2*rs2*
     -            rt5 - 
     -           4.049080418304D14*rs3*rt5 + 
     -           2.3408645505024D13*rnlq*rs3*
     -            rt5 + 
     -           4.62826615341056D14*PI2*rs3*
     -            rt5 + 
     -           6.48745146384384D14*rs4*
     -            rt5 - 
     -           3.6914438602752D13*rnlq*rs4*
     -            rt5 - 
     -           3.5062015852544D14*PI2*rs4*
     -            rt5 - 
     -           6.02371377856512D14*rs5*
     -            rt5 + 
     -           3.4447382544384D13*rnlq*rs5*
     -            rt5 + 
     -           1.571995779072D14*PI2*rs5*
     -            rt5 + 
     -           3.54026319249408D14*rs6*
     -            rt5 - 
     -           2.0666225000448D13*rnlq*rs6*
     -            rt5 - 
     -           3.4649277464576D13*PI2*rs6*
     -            rt5 - 
     -           1.34122781540352D14*rs7*
     -            rt5 + 
     -           8.079575875584D12*rnlq*rs7*
     -            rt5 - 
     -           3.240447442944D12*PI2*rs7*
     -            rt5 + 
     -           2.9884579577856D13*rs8*rt5 - 
     -           1.874866470912D12*rnlq*rs8*
     -            rt5 + 
     -           4.903089471488D12*PI2*rs8*
     -            rt5 - 
     -           1.517553451008D12*rs9*rt5 + 
     -           1.10642331648D11*rnlq*rs9*
     -            rt5 - 
     -           1.53767624704D12*PI2*rs9*
     -            rt5 - 
     -           1.463893229568D12*rs10*rt5 + 
     -           8.8625774592D10*rnlq*rs10*
     -            rt5 + 
     -           1.82054518784D11*PI2*rs10*
     -            rt5 + 
     -           5.79118841856D11*rs11*rt5 - 
     -           3.5741270016D10*rnlq*rs11*
     -            rt5 + 
     -           2.4349523968D10*PI2*rs11*
     -            rt5 - 
     -           1.13930010624D11*rs12*rt5 + 
     -           6.94831104d9*rnlq*rs12*rt5 - 
     -           1.2503775744D10*PI2*rs12*
     -            rt5 + 
     -           1.2661211136D10*rs13*rt5 - 
     -           752059392d0*rnlq*rs13*rt5 + 
     -           1.935248512d9*PI2*rs13*rt5 - 
     -           577479168D0*rs14*rt5 + 
     -           33186048D0*rnlq*rs14*rt5 - 
     -           119580448D0*PI2*rs14*rt5 - 
     -           33839616D0*rs15*rt5 + 
     -           1864704D0*rnlq*rs15*rt5 - 
     -           2543264D0*PI2*rs15*rt5 + 
     -           5743104D0*rs16*rt5 - 
     -           306624D0*rnlq*rs16*rt5 + 
     -           772824D0*PI2*rs16*rt5 - 
     -           249264D0*rs17*rt5 + 
     -           12960D0*rnlq*rs17*rt5 - 
     -           37512D0*PI2*rs17*rt5 + 
     -           2808D0*rs18*rt5 - 
     -           144D0*rnlq*rs18*rt5 + 
     -           536D0*PI2*rs18*rt5 + 
     -           6.18475290624D11*rt6 + 
     -           2.0061792239616D13*rs*rt6 - 
     -           1.443109011456D12*rnlq*rs*rt6 - 
     -           5.9745142571008D13*PI2*rs*
     -            rt6 - 
     -           1.50547193659392D14*rs2*
     -            rt6 + 
     -           9.08385583104D12*rnlq*rs2*
     -            rt6 + 
     -           1.64257803010048D14*PI2*rs2*
     -            rt6 + 
     -           3.6435683966976D14*rs3*rt6 - 
     -           2.0989505175552D13*rnlq*rs3*
     -            rt6 - 
     -           1.95344306536448D14*PI2*rs3*
     -            rt6 - 
     -           4.49814542155776D14*rs4*
     -            rt6 + 
     -           2.5784500617216D13*rnlq*rs4*
     -            rt6 + 
     -           1.27727705260032D14*PI2*rs4*
     -            rt6 + 
     -           3.30063773958144D14*rs5*
     -            rt6 - 
     -           1.9293932617728D13*rnlq*rs5*
     -            rt6 - 
     -           4.5847093968896D13*PI2*rs5*
     -            rt6 - 
     -           1.51280966172672D14*rs6*
     -            rt6 + 
     -           9.17237661696D12*rnlq*rs6*
     -            rt6 + 
     -           5.238615965696D12*PI2*rs6*
     -            rt6 + 
     -           4.1141617557504D13*rs7*rt6 - 
     -           2.626569633792D12*rnlq*rs7*
     -            rt6 + 
     -           2.924097830912D12*PI2*rs7*
     -            rt6 - 
     -           4.004327718912D12*rs8*rt6 + 
     -           2.90369568768D11*rnlq*rs8*
     -            rt6 - 
     -           1.540782292992D12*PI2*rs8*
     -            rt6 - 
     -           1.581559185408D12*rs9*rt6 + 
     -           9.267511296D10*rnlq*rs9*rt6 + 
     -           2.88410763264D11*PI2*rs9*
     -            rt6 + 
     -           7.817822208D11*rs10*rt6 - 
     -           4.9118380032D10*rnlq*rs10*
     -            rt6 + 
     -           492736512D0*PI2*rs10*rt6 - 
     -           1.61625993216D11*rs11*rt6 + 
     -           1.022042112D10*rnlq*rs11*
     -            rt6 - 
     -           9.84763904d9*PI2*rs11*rt6 + 
     -           1.5510371328D10*rs12*rt6 - 
     -           973458432d0*rnlq*rs12*rt6 + 
     -           1.250031488d9*PI2*rs12*rt6 + 
     -           346929408D0*rs13*rt6 - 
     -           17665536D0*rnlq*rs13*rt6 + 
     -           138124352D0*PI2*rs13*rt6 - 
     -           275299392D0*rs14*rt6 + 
     -           15464640D0*rnlq*rs14*rt6 - 
     -           52715912D0*PI2*rs14*rt6 + 
     -           31050240D0*rs15*rt6 - 
     -           1689600D0*rnlq*rs15*rt6 + 
     -           5750736D0*PI2*rs15*rt6 - 
     -           1500288D0*rs16*rt6 + 
     -           78960D0*rnlq*rs16*rt6 - 
     -           280494D0*PI2*rs16*rt6 + 
     -           25272D0*rs17*rt6 - 
     -           1296D0*rnlq*rs17*rt6 + 
     -           5028D0*PI2*rs17*rt6 - 
     -           1.314259992576D12*rt7 - 
     -           2.0593294442496D13*rs*rt7 + 
     -           1.472100040704D12*rnlq*rs*rt7 + 
     -           2.1060237918208D13*PI2*rs*
     -            rt7 + 
     -           1.10012097626112D14*rs2*
     -            rt7 - 
     -           6.565662818304D12*rnlq*rs2*
     -            rt7 - 
     -           5.1808009453568D13*PI2*rs2*
     -            rt7 - 
     -           2.04943021572096D14*rs3*
     -            rt7 + 
     -           1.1814649724928D13*rnlq*rs3*
     -            rt7 + 
     -           5.3495478616064D13*PI2*rs3*
     -            rt7 + 
     -           1.99248549249024D14*rs4*
     -            rt7 - 
     -           1.1604615757824D13*rnlq*rs4*
     -            rt7 - 
     -           2.8635392114688D13*PI2*rs4*
     -            rt7 - 
     -           1.13235915177984D14*rs5*
     -            rt7 + 
     -           6.833313939456D12*rnlq*rs5*
     -            rt7 + 
     -           6.988297142272D12*PI2*rs5*
     -            rt7 + 
     -           3.6852071399424D13*rs6*rt7 - 
     -           2.353369448448D12*rnlq*rs6*
     -            rt7 + 
     -           5.4878928896D11*PI2*rs6*
     -            rt7 - 
     -           4.489416278016D12*rs7*rt7 + 
     -           3.29178415104D11*rnlq*rs7*
     -            rt7 - 
     -           8.5070053376D11*PI2*rs7*
     -            rt7 - 
     -           1.543311458304D12*rs8*rt7 + 
     -           8.6887366656D10*rnlq*rs8*
     -            rt7 + 
     -           1.96858707968D11*PI2*rs8*
     -            rt7 + 
     -           8.61857906688D11*rs9*rt7 - 
     -           5.4194159616D10*rnlq*rs9*
     -            rt7 + 
     -           3.158272d9*PI2*rs9*rt7 - 
     -           1.7658058752D11*rs10*rt7 + 
     -           1.134065664D10*rnlq*rs10*
     -            rt7 - 
     -           7.750409728d9*PI2*rs10*rt7 + 
     -           1.0018747392D10*rs11*rt7 - 
     -           655835136D0*rnlq*rs11*rt7 - 
     -           160135936D0*PI2*rs11*rt7 + 
     -           3.329792256d9*rs12*rt7 - 
     -           200476416D0*rnlq*rs12*rt7 + 
     -           686025056D0*PI2*rs12*rt7 - 
     -           888146112D0*rs13*rt7 + 
     -           52137792D0*rnlq*rs13*rt7 - 
     -           168485272D0*PI2*rs13*rt7 + 
     -           97809408D0*rs14*rt7 - 
     -           5523456D0*rnlq*rs14*rt7 + 
     -           18929120D0*PI2*rs14*rt7 - 
     -           5255616D0*rs15*rt7 + 
     -           284928D0*rnlq*rs15*rt7 - 
     -           1042888D0*PI2*rs15*rt7 + 
     -           108936D0*rs16*rt7 - 
     -           5688D0*rnlq*rs16*rt7 + 
     -           22537D0*PI2*rs16*rt7 + 
     -           1.120986464256D12*rt8 + 
     -           1.265538957312D13*rs*rt8 - 
     -           8.66509651968D11*rnlq*rs*rt8 - 
     -           4.672320438272D12*PI2*rs*rt8 - 
     -           5.1280298901504D13*rs2*rt8 + 
     -           3.005202038784D12*rnlq*rs2*
     -            rt8 + 
     -           9.709989920768D12*PI2*rs2*
     -            rt8 + 
     -           7.436425494528D13*rs3*rt8 - 
     -           4.2932895744D12*rnlq*rs3*
     -            rt8 - 
     -           7.754907385856D12*PI2*rs3*
     -            rt8 - 
     -           5.4870203695104D13*rs4*rt8 + 
     -           3.25526224896D12*rnlq*rs4*
     -            rt8 + 
     -           2.436238934016D12*PI2*rs4*
     -            rt8 + 
     -           2.105621348352D13*rs5*rt8 - 
     -           1.320488534016D12*rnlq*rs5*
     -            rt8 + 
     -           2.90421997568D11*PI2*rs5*
     -            rt8 - 
     -           2.26245476352D12*rs6*rt8 + 
     -           1.70743824384D11*rnlq*rs6*
     -            rt8 - 
     -           4.17113899008D11*PI2*rs6*
     -            rt8 - 
     -           1.66458359808D12*rs7*rt8 + 
     -           9.658957824D10*rnlq*rs7*rt8 + 
     -           6.5330151424D10*PI2*rs7*
     -            rt8 + 
     -           8.73283584D11*rs8*rt8 - 
     -           5.4931685376D10*rnlq*rs8*
     -            rt8 + 
     -           3.259527168D10*PI2*rs8*rt8 - 
     -           1.71428425728D11*rs9*rt8 + 
     -           1.0998792192D10*rnlq*rs9*
     -            rt8 - 
     -           1.4443138048D10*PI2*rs9*
     -            rt8 + 
     -           445059072D0*rs10*rt8 - 
     -           18957312D0*rnlq*rs10*rt8 + 
     -           678814848D0*PI2*rs10*rt8 + 
     -           7.505978112d9*rs11*rt8 - 
     -           474835968D0*rnlq*rs11*rt8 + 
     -           882746752D0*PI2*rs11*rt8 - 
     -           1.801469952d9*rs12*rt8 + 
     -           110305344D0*rnlq*rs12*rt8 - 
     -           269987560D0*PI2*rs12*rt8 + 
     -           209166720D0*rs13*rt8 - 
     -           12315072D0*rnlq*rs13*rt8 + 
     -           35749992D0*PI2*rs13*rt8 - 
     -           12447648D0*rs14*rt8 + 
     -           702096D0*rnlq*rs14*rt8 - 
     -           2304250D0*PI2*rs14*rt8 + 
     -           298656D0*rs15*rt8 - 
     -           16128D0*rnlq*rs15*rt8 + 
     -           58804D0*PI2*rs15*rt8 - 
     -           4.68688306176D11*rt9 - 
     -           5.086113693696D12*rs*rt9 + 
     -           3.19907954688D11*rnlq*rs*rt9 + 
     -           3.74979166208D11*PI2*rs*rt9 + 
     -           1.5255321182208D13*rs2*rt9 - 
     -           8.68120264704D11*rnlq*rs2*
     -            rt9 - 
     -           2.44167213056D11*PI2*rs2*
     -            rt9 - 
     -           1.596576497664D13*rs3*rt9 + 
     -           9.16262486016D11*rnlq*rs3*
     -            rt9 - 
     -           5.5549362176D11*PI2*rs3*
     -            rt9 + 
     -           6.880219889664D12*rs4*rt9 - 
     -           4.1320710144D11*rnlq*rs4*
     -            rt9 + 
     -           8.58419232768D11*PI2*rs4*
     -            rt9 + 
     -           3.51138742272D11*rs5*rt9 - 
     -           1.3865582592D10*rnlq*rs5*
     -            rt9 - 
     -           4.70883729408D11*PI2*rs5*
     -            rt9 - 
     -           1.767784513536D12*rs6*rt9 + 
     -           1.07700486144D11*rnlq*rs6*
     -            rt9 + 
     -           8.1971683328D10*PI2*rs6*
     -            rt9 + 
     -           8.4110180352D11*rs7*rt9 - 
     -           5.3215543296D10*rnlq*rs7*
     -            rt9 + 
     -           3.3015887872D10*PI2*rs7*
     -            rt9 - 
     -           1.685720064D11*rs8*rt9 + 
     -           1.0814410752D10*rnlq*rs8*
     -            rt9 - 
     -           2.0968867328D10*PI2*rs8*
     -            rt9 - 
     -           3.182644224d9*rs9*rt9 + 
     -           232667136D0*rnlq*rs9*rt9 + 
     -           3.910976768d9*PI2*rs9*rt9 + 
     -           1.0158118656D10*rs10*rt9 - 
     -           656312064D0*rnlq*rs10*rt9 + 
     -           209038048D0*PI2*rs10*rt9 - 
     -           2.579940672d9*rs11*rt9 + 
     -           162286656D0*rnlq*rs11*rt9 - 
     -           223423896D0*PI2*rs11*rt9 + 
     -           326373888D0*rs12*rt9 - 
     -           19862400D0*rnlq*rs12*rt9 + 
     -           40487840D0*PI2*rs12*rt9 - 
     -           21497280D0*rs13*rt9 + 
     -           1258992D0*rnlq*rs13*rt9 - 
     -           3209910D0*PI2*rs13*rt9 + 
     -           581976D0*rs14*rt9 - 
     -           32688D0*rnlq*rs14*rt9 + 
     -           97304D0*PI2*rs14*rt9 + 
     -           7.9725330432D10*rt10 + 
     -           1.26936416256D12*rs*rt10 - 
     -           6.9759664128D10*rnlq*rs*rt10 + 
     -           1.59140282368D11*PI2*rs*rt10 - 
     -           2.340522295296D12*rs2*rt10 + 
     -           1.24646326272D11*rnlq*rs2*
     -            rt10 - 
     -           5.1512868864D11*PI2*rs2*
     -            rt10 + 
     -           7.6880019456D11*rs3*rt10 - 
     -           3.8994444288D10*rnlq*rs3*
     -            rt10 + 
     -           6.70016208896D11*PI2*rs3*
     -            rt10 + 
     -           1.239500193792D12*rs4*rt10 - 
     -           7.5452645376D10*rnlq*rs4*
     -            rt10 - 
     -           4.45714038784D11*PI2*rs4*
     -            rt10 - 
     -           1.46744082432D12*rs5*rt10 + 
     -           9.0197065728D10*rnlq*rs5*
     -            rt10 + 
     -           1.44931078144D11*PI2*rs5*
     -            rt10 + 
     -           7.05809399808D11*rs6*rt10 - 
     -           4.4349702144D10*rnlq*rs6*
     -            rt10 - 
     -           3.806468096d9*PI2*rs6*rt10 - 
     -           1.6175069184D11*rs7*rt10 + 
     -           1.0316365824D10*rnlq*rs7*
     -            rt10 - 
     -           1.5059766272D10*PI2*rs7*
     -            rt10 + 
     -           2.447204352d9*rs8*rt10 - 
     -           150518784D0*rnlq*rs8*rt10 + 
     -           5.611746944d9*PI2*rs8*rt10 + 
     -           9.251192832d9*rs9*rt10 - 
     -           593405952D0*rnlq*rs9*rt10 - 
     -           771074624D0*PI2*rs9*rt10 - 
     -           2.72575008d9*rs10*rt10 + 
     -           172117824D0*rnlq*rs10*rt10 - 
     -           32466264D0*PI2*rs10*rt10 + 
     -           385323264D0*rs11*rt10 - 
     -           23779392D0*rnlq*rs11*rt10 + 
     -           23820600D0*PI2*rs11*rt10 - 
     -           28202688D0*rs12*rt10 + 
     -           1690608D0*rnlq*rs12*rt10 - 
     -           2736798D0*PI2*rs12*rt10 + 
     -           852264D0*rs13*rt10 - 
     -           49392D0*rnlq*rs13*rt10 + 
     -           104060D0*PI2*rs13*rt10 + 
     -           9.965666304d9*rt11 - 
     -           1.14328338432D11*rs*rt11 + 
     -           3.737124864d9*rnlq*rs*rt11 - 
     -           8.1081663488D10*PI2*rs*rt11 - 
     -           1.94314764288D11*rs2*rt11 + 
     -           1.3812891648D10*rnlq*rs2*
     -            rt11 + 
     -           2.05477511168D11*PI2*rs2*
     -            rt11 + 
     -           7.63332132864D11*rs3*rt11 - 
     -           4.5713719296D10*rnlq*rs3*
     -            rt11 - 
     -           2.1648408576D11*PI2*rs3*
     -            rt11 - 
     -           8.37806063616D11*rs4*rt11 + 
     -           5.0303533056D10*rnlq*rs4*
     -            rt11 + 
     -           1.16348116992D11*PI2*rs4*
     -            rt11 + 
     -           4.59072602112D11*rs5*rt11 - 
     -           2.8047507456D10*rnlq*rs5*
     -            rt11 - 
     -           2.76205568D10*PI2*rs5*rt11 - 
     -           1.29953353728D11*rs6*rt11 + 
     -           8.068313088d9*rnlq*rs6*rt11 - 
     -           2.8683904d9*PI2*rs6*rt11 + 
     -           9.987572736d9*rs7*rt11 - 
     -           631848960D0*rnlq*rs7*rt11 + 
     -           3.867584256d9*PI2*rs7*rt11 + 
     -           5.613092352d9*rs8*rt11 - 
     -           348506880D0*rnlq*rs8*rt11 - 
     -           1.102191456d9*PI2*rs8*rt11 - 
     -           2.143636992d9*rs9*rt11 + 
     -           132644160D0*rnlq*rs9*rt11 + 
     -           134492888D0*PI2*rs9*rt11 + 
     -           348870912D0*rs10*rt11 - 
     -           21321600D0*rnlq*rs10*rt11 - 
     -           1837280D0*PI2*rs10*rt11 - 
     -           28653408D0*rs11*rt11 + 
     -           1719408D0*rnlq*rs11*rt11 - 
     -           1049102D0*PI2*rs11*rt11 + 
     -           964944D0*rs12*rt11 - 
     -           56592D0*rnlq*rs12*rt11 + 
     -           66090D0*PI2*rs12*rt11 - 
     -           7.398752256d9*rt12 - 
     -           4.638375936D10*rs*rt12 + 
     -           3.221225472d9*rnlq*rs*rt12 + 
     -           2.18693632D10*PI2*rs*rt12 + 
     -           2.12574142464D11*rs2*rt12 - 
     -           1.2388663296D10*rnlq*rs2*
     -            rt12 - 
     -           4.9865785344D10*PI2*rs2*
     -            rt12 - 
     -           3.01533560832D11*rs3*rt12 + 
     -           1.7460363264D10*rnlq*rs3*
     -            rt12 + 
     -           4.6157725696D10*PI2*rs3*
     -            rt12 + 
     -           2.1019680768D11*rs4*rt12 - 
     -           1.232510976D10*rnlq*rs4*
     -            rt12 - 
     -           2.0713744384D10*PI2*rs4*
     -            rt12 - 
     -           7.7302345728D10*rs5*rt12 + 
     -           4.59472896d9*rnlq*rs5*rt12 + 
     -           3.16942848d9*PI2*rs5*rt12 + 
     -           1.1504535552D10*rs6*rt12 - 
     -           693457920D0*rnlq*rs6*rt12 + 
     -           1.179570048d9*PI2*rs6*rt12 + 
     -           1.949092608d9*rs7*rt12 - 
     -           115074048D0*rnlq*rs7*rt12 - 
     -           718723328D0*PI2*rs7*rt12 - 
     -           1.230644928d9*rs8*rt12 + 
     -           73297728D0*rnlq*rs8*rt12 + 
     -           159053000D0*PI2*rs8*rt12 + 
     -           240832128D0*rs9*rt12 - 
     -           14277696D0*rnlq*rs9*rt12 - 
     -           16245672D0*PI2*rs9*rt12 - 
     -           22578432D0*rs10*rt12 + 
     -           1325808D0*rnlq*rs10*rt12 + 
     -           529298D0*PI2*rs10*rt12 + 
     -           852264D0*rs11*rt12 - 
     -           49392D0*rnlq*rs11*rt12 + 
     -           11292D0*PI2*rs11*rt12 + 
     -           1.453326336d9*rt13 + 
     -           2.2226927616D10*rs*rt13 - 
     -           1.303117824d9*rnlq*rs*rt13 - 
     -           4.301553664d9*PI2*rs*rt13 - 
     -           5.9964063744D10*rs2*rt13 + 
     -           3.367108608d9*rnlq*rs2*rt13 + 
     -           8.849833984d9*PI2*rs2*rt13 + 
     -           6.1401317376D10*rs3*rt13 - 
     -           3.45858048d9*rnlq*rs3*rt13 - 
     -           7.096711168d9*PI2*rs3*rt13 - 
     -           3.1192621056D10*rs4*rt13 + 
     -           1.770110976d9*rnlq*rs4*rt13 + 
     -           2.50504192d9*PI2*rs4*rt13 + 
     -           7.353996288d9*rs5*rt13 - 
     -           420013056D0*rnlq*rs5*rt13 - 
     -           88450944D0*PI2*rs5*rt13 + 
     -           57760512D0*rs6*rt13 - 
     -           3015168D0*rnlq*rs6*rt13 - 
     -           245075136D0*PI2*rs6*rt13 - 
     -           487605312D0*rs7*rt13 + 
     -           27785664D0*rnlq*rs7*rt13 + 
     -           90911256D0*PI2*rs7*rt13 + 
     -           123542016D0*rs8*rt13 - 
     -           7025088D0*rnlq*rs8*rt13 - 
     -           14574872D0*PI2*rs8*rt13 - 
     -           13580928D0*rs9*rt13 + 
     -           768336D0*rnlq*rs9*rt13 + 
     -           1033718D0*PI2*rs9*rt13 + 
     -           581976D0*rs10*rt13 - 
     -           32688D0*rnlq*rs10*rt13 - 
     -           22176D0*PI2*rs10*rt13 - 
     -           132120576D0*rt14 - 
     -           4.769513472d9*rs*rt14 + 
     -           266993664D0*rnlq*rs*rt14 + 
     -           641499136D0*PI2*rs*rt14 + 
     -           9.808478208d9*rs2*rt14 - 
     -           538902528D0*rnlq*rs2*rt14 - 
     -           1.1522048d9*PI2*rs2*rt14 - 
     -           7.726596096d9*rs3*rt14 + 
     -           423346176D0*rnlq*rs3*rt14 + 
     -           760666112D0*PI2*rs3*rt14 + 
     -           2.791028736d9*rs4*rt14 - 
     -           152580096D0*rnlq*rs4*rt14 - 
     -           180386816D0*PI2*rs4*rt14 - 
     -           290639616D0*rs5*rt14 + 
     -           15717888D0*rnlq*rs5*rt14 - 
     -           31777152D0*PI2*rs5*rt14 - 
     -           116489472D0*rs6*rt14 + 
     -           6414336D0*rnlq*rs6*rt14 + 
     -           29042368D0*PI2*rs6*rt14 + 
     -           44732928D0*rs7*rt14 - 
     -           2443200D0*rnlq*rs7*rt14 - 
     -           6892360D0*PI2*rs7*rt14 - 
     -           6014496D0*rs8*rt14 + 
     -           326688D0*rnlq*rs8*rt14 + 
     -           701124D0*PI2*rs8*rt14 + 
     -           298656D0*rs9*rt14 - 
     -           16128D0*rnlq*rs9*rt14 - 
     -           24272D0*PI2*rs9*rt14 + 
     -           4718592D0*rt15 + 
     -           600293376D0*rs*rt15 - 
     -           33128448D0*rnlq*rs*rt15 - 
     -           68001792D0*PI2*rs*rt15 - 
     -           987439104D0*rs2*rt15 + 
     -           53428224D0*rnlq*rs2*rt15 + 
     -           102203392D0*PI2*rs2*rt15 + 
     -           589848576D0*rs3*rt15 - 
     -           31494144D0*rnlq*rs3*rt15 - 
     -           51313152D0*PI2*rs3*rt15 - 
     -           132395520D0*rs4*rt15 + 
     -           6951936D0*rnlq*rs4*rt15 + 
     -           4705536D0*PI2*rs4*rt15 - 
     -           9851328D0*rs5*rt15 + 
     -           553344D0*rnlq*rs5*rt15 + 
     -           4694368D0*PI2*rs5*rt15 + 
     -           10387776D0*rs6*rt15 - 
     -           552192D0*rnlq*rs6*rt15 - 
     -           1845152D0*PI2*rs6*rt15 - 
     -           1834944D0*rs7*rt15 + 
     -           96528D0*rnlq*rs7*rt15 + 
     -           261038D0*PI2*rs7*rt15 + 
     -           108936D0*rs8*rt15 - 
     -           5688D0*rnlq*rs8*rt15 - 
     -           12251D0*PI2*rs8*rt15 - 
     -           42860544D0*rs*rt16 + 
     -           2359296D0*rnlq*rs*rt16 + 
     -           4440064D0*PI2*rs*rt16 + 
     -           56487936D0*rs2*rt16 - 
     -           3022848D0*rnlq*rs2*rt16 - 
     -           5353472D0*PI2*rs2*rt16 - 
     -           23998464D0*rs3*rt16 + 
     -           1253376D0*rnlq*rs3*rt16 + 
     -           1777664D0*PI2*rs3*rt16 + 
     -           1895424D0*rs4*rt16 - 
     -           92160D0*rnlq*rs4*rt16 + 
     -           214784D0*PI2*rs4*rt16 + 
     -           1262976D0*rs5*rt16 - 
     -           66816D0*rnlq*rs5*rt16 - 
     -           251072D0*PI2*rs5*rt16 - 
     -           339120D0*rs6*rt16 + 
     -           17568D0*rnlq*rs6*rt16 + 
     -           51968D0*PI2*rs6*rt16 + 
     -           25272D0*rs7*rt16 - 
     -           1296D0*rnlq*rs7*rt16 - 
     -           3248D0*PI2*rs7*rt16 + 
     -           1339392D0*rs*rt17 - 
     -           73728D0*rnlq*rs*rt17 - 
     -           131072D0*PI2*rs*rt17 - 
     -           1388544D0*rs2*rt17 + 
     -           73728D0*rnlq*rs2*rt17 + 
     -           120832D0*PI2*rs2*rt17 + 
     -           359424D0*rs3*rt17 - 
     -           18432D0*rnlq*rs3*rt17 - 
     -           17664D0*PI2*rs3*rt17 + 
     -           41856D0*rs4*rt17 - 
     -           2304D0*rnlq*rs4*rt17 - 
     -           12032D0*PI2*rs4*rt17 - 
     -           27696D0*rs5*rt17 + 
     -           1440D0*rnlq*rs5*rt17 + 
     -           4240D0*PI2*rs5*rt17 + 
     -           2808D0*rs6*rt17 - 
     -           144D0*rnlq*rs6*rt17 - 
     -           360D0*PI2*rs6*rt17))/
     -       (13824.0D0*PI2*(-4D0 + rs)**5*(-2D0 + rs)*
     -         rs2*(4D0 + rs)*(-4D0 + rt)**4*
     -         (-2D0 + rt)*rt2*(4D0 + rt)*
     -         (-8D0 + rs + rt)*(-4D0 + rs + rt)**2*
     -         (-2D0 + rs + rt)*(rs + rt)**5) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (256D0 - 128D0*rs + 48D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           96D0*rs*rt - 24D0*rs2*rt + 
     -           2D0*rs3*rt + 48D0*rt2 - 
     -           24D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         li2s(1))/
     -       (64.0D0*PI2*(-4D0 + rs)*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (1048576D0 - 393216D0*rs + 
     -           98304D0*rs2 - 16384D0*rs3 + 
     -           12288D0*rs4 - 3072D0*rs5 + 
     -           256D0*rs6 - 917504D0*rt + 
     -           294912D0*rs*rt - 20480D0*rs2*rt - 
     -           6144D0*rs3*rt - 256D0*rs4*rt - 
     -           1024D0*rs5*rt + 448D0*rs6*rt - 
     -           64D0*rs7*rt + 4D0*rs8*rt + 
     -           458752D0*rt2 - 139264D0*rs*rt2 - 
     -           30720D0*rs2*rt2 + 
     -           18944D0*rs3*rt2 - 
     -           5504D0*rs4*rt2 + 
     -           960D0*rs5*rt2 - 
     -           32D0*rs6*rt2 - 8D0*rs7*rt2 + 
     -           rs8*rt2 - 102400D0*rt3 - 
     -           4096D0*rs*rt3 + 
     -           20736D0*rs2*rt3 - 
     -           6912D0*rs3*rt3 + 
     -           896D0*rs4*rt3 + 
     -           192D0*rs5*rt3 - 
     -           56D0*rs6*rt3 + 4D0*rs7*rt3 + 
     -           4096D0*rt4 + 9728D0*rs*rt4 - 
     -           4352D0*rs2*rt4 + 
     -           512D0*rs3*rt4 + 
     -           312D0*rs4*rt4 - 
     -           104D0*rs5*rt4 + 
     -           8D0*rs6*rt4 + 3072D0*rt5 - 
     -           1920D0*rs*rt5 + 
     -           304D0*rs2*rt5 + 
     -           200D0*rs3*rt5 - 
     -           99D0*rs4*rt5 + 
     -           10D0*rs5*rt5 - 768D0*rt6 + 
     -           96D0*rs*rt6 - 16D0*rs2*rt6 - 
     -           46D0*rs3*rt6 + 8D0*rs4*rt6 + 
     -           48D0*rt7 - 32D0*rs*rt7 - 
     -           3D0*rs2*rt7 + 4D0*rs3*rt7 + 
     -           4D0*rs*rt8 + rs2*rt8)*li2s(2)
     -         )/
     -       (128.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(4D0 + rt)*
     -         (-8D0 + rs + rt)*(-4D0 + rs + rt)*
     -         (rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (256D0 - 128D0*rs + 48D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           96D0*rs*rt - 24D0*rs2*rt + 
     -           2D0*rs3*rt + 48D0*rt2 - 
     -           24D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         li2s(3))/
     -       (64.0D0*PI2*(-4D0 + rs)*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (1048576D0 - 917504D0*rs + 
     -           458752D0*rs2 - 102400D0*rs3 + 
     -           4096D0*rs4 + 3072D0*rs5 - 
     -           768D0*rs6 + 48D0*rs7 - 
     -           393216D0*rt + 294912D0*rs*rt - 
     -           139264D0*rs2*rt - 
     -           4096D0*rs3*rt + 9728D0*rs4*rt - 
     -           1920D0*rs5*rt + 96D0*rs6*rt - 
     -           32D0*rs7*rt + 4D0*rs8*rt + 
     -           98304D0*rt2 - 20480D0*rs*rt2 - 
     -           30720D0*rs2*rt2 + 
     -           20736D0*rs3*rt2 - 
     -           4352D0*rs4*rt2 + 
     -           304D0*rs5*rt2 - 
     -           16D0*rs6*rt2 - 3D0*rs7*rt2 + 
     -           rs8*rt2 - 16384D0*rt3 - 
     -           6144D0*rs*rt3 + 
     -           18944D0*rs2*rt3 - 
     -           6912D0*rs3*rt3 + 
     -           512D0*rs4*rt3 + 
     -           200D0*rs5*rt3 - 
     -           46D0*rs6*rt3 + 4D0*rs7*rt3 + 
     -           12288D0*rt4 - 256D0*rs*rt4 - 
     -           5504D0*rs2*rt4 + 
     -           896D0*rs3*rt4 + 
     -           312D0*rs4*rt4 - 
     -           99D0*rs5*rt4 + 8D0*rs6*rt4 - 
     -           3072D0*rt5 - 1024D0*rs*rt5 + 
     -           960D0*rs2*rt5 + 
     -           192D0*rs3*rt5 - 
     -           104D0*rs4*rt5 + 
     -           10D0*rs5*rt5 + 256D0*rt6 + 
     -           448D0*rs*rt6 - 32D0*rs2*rt6 - 
     -           56D0*rs3*rt6 + 8D0*rs4*rt6 - 
     -           64D0*rs*rt7 - 8D0*rs2*rt7 + 
     -           4D0*rs3*rt7 + 4D0*rs*rt8 + 
     -           rs2*rt8)*li2s(4))/
     -       (128.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(4D0 + rt)*
     -         (-8D0 + rs + rt)*(-4D0 + rs + rt)*
     -         (rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (256D0 - 128D0*rs + 48D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           96D0*rs*rt - 24D0*rs2*rt + 
     -           2D0*rs3*rt + 48D0*rt2 - 
     -           24D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         li2s(5))/
     -       (64.0D0*PI2*(-4D0 + rs)*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (2048D0*rs - 3584D0*rs2 + 
     -           1920D0*rs3 - 672D0*rs4 + 
     -           112D0*rs5 - 8D0*rs6 - 2048D0*rt - 
     -           768D0*rs*rt + 2752D0*rs2*rt - 
     -           1872D0*rs3*rt + 524D0*rs4*rt - 
     -           60D0*rs5*rt + 2D0*rs6*rt + 
     -           1792D0*rt2 - 64D0*rs*rt2 - 
     -           1312D0*rs2*rt2 + 
     -           724D0*rs3*rt2 - 
     -           125D0*rs4*rt2 + 
     -           6D0*rs5*rt2 - 1152D0*rt3 + 
     -           288D0*rs*rt3 + 360D0*rs2*rt3 - 
     -           130D0*rs3*rt3 + 
     -           10D0*rs4*rt3 + 464D0*rt4 - 
     -           80D0*rs*rt4 - 65D0*rs2*rt4 + 
     -           10D0*rs3*rt4 - 96D0*rt5 + 
     -           6D0*rs2*rt5 + 8D0*rt6 + 
     -           2D0*rs*rt6)*li2s(6))/
     -       (256.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-2048D0*rs + 1792D0*rs2 - 
     -           1152D0*rs3 + 464D0*rs4 - 
     -           96D0*rs5 + 8D0*rs6 + 2048D0*rt - 
     -           768D0*rs*rt - 64D0*rs2*rt + 
     -           288D0*rs3*rt - 80D0*rs4*rt + 
     -           2D0*rs6*rt - 3584D0*rt2 + 
     -           2752D0*rs*rt2 - 
     -           1312D0*rs2*rt2 + 
     -           360D0*rs3*rt2 - 
     -           65D0*rs4*rt2 + 6D0*rs5*rt2 + 
     -           1920D0*rt3 - 1872D0*rs*rt3 + 
     -           724D0*rs2*rt3 - 
     -           130D0*rs3*rt3 + 
     -           10D0*rs4*rt3 - 672D0*rt4 + 
     -           524D0*rs*rt4 - 125D0*rs2*rt4 + 
     -           10D0*rs3*rt4 + 112D0*rt5 - 
     -           60D0*rs*rt5 + 6D0*rs2*rt5 - 
     -           8D0*rt6 + 2D0*rs*rt6)*li2s(7))/
     -       (256.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-16384D0 + 12288D0*rs - 4096D0*rs2 + 
     -           1152D0*rs3 - 352D0*rs4 + 
     -           80D0*rs5 - 8D0*rs6 + 12288D0*rt - 
     -           9216D0*rs*rt + 3328D0*rs2*rt - 
     -           880D0*rs3*rt + 204D0*rs4*rt - 
     -           36D0*rs5*rt + 2D0*rs6*rt - 
     -           4096D0*rt2 + 3328D0*rs*rt2 - 
     -           1312D0*rs2*rt2 + 
     -           332D0*rs3*rt2 - 
     -           65D0*rs4*rt2 + 6D0*rs5*rt2 + 
     -           1152D0*rt3 - 880D0*rs*rt3 + 
     -           332D0*rs2*rt3 - 
     -           90D0*rs3*rt3 + 
     -           10D0*rs4*rt3 - 352D0*rt4 + 
     -           204D0*rs*rt4 - 65D0*rs2*rt4 + 
     -           10D0*rs3*rt4 + 80D0*rt5 - 
     -           36D0*rs*rt5 + 6D0*rs2*rt5 - 
     -           8D0*rt6 + 2D0*rs*rt6)*li2s(8))/
     -       (256.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (26214400D0*rs3 - 44302336D0*rs4 + 
     -           34144256D0*rs5 - 
     -           16334848D0*rs6 + 5992448D0*rs7 - 
     -           2341888D0*rs8 + 889600D0*rs9 - 
     -           209856D0*rs10 + 22848D0*rs11 - 
     -           720D0*rs12 - 167772160D0*rs*rt + 
     -           275775488D0*rs2*rt - 
     -           187957248D0*rs3*rt + 
     -           56492032D0*rs4*rt + 
     -           2932736D0*rs5*rt - 
     -           9846784D0*rs6*rt + 
     -           3961856D0*rs7*rt - 
     -           98816D0*rs8*rt - 
     -           418240D0*rs9*rt + 
     -           113744D0*rs10*rt - 
     -           10064D0*rs11*rt + 
     -           316D0*rs12*rt + 
     -           167772160D0*rt2 - 
     -           181403648D0*rs*rt2 + 
     -           84148224D0*rs2*rt2 - 
     -           50855936D0*rs3*rt2 + 
     -           49545216D0*rs4*rt2 - 
     -           33284096D0*rs5*rt2 + 
     -           15669248D0*rs6*rt2 - 
     -           5111808D0*rs7*rt2 + 
     -           752640D0*rs8*rt2 + 
     -           34096D0*rs9*rt2 - 
     -           15036D0*rs10*rt2 + 
     -           608D0*rs11*rt2 - 
     -           120586240D0*rt3 + 
     -           136577024D0*rs*rt3 - 
     -           70123520D0*rs2*rt3 + 
     -           36274176D0*rs3*rt3 - 
     -           24481792D0*rs4*rt3 + 
     -           13297664D0*rs5*rt3 - 
     -           6044416D0*rs6*rt3 + 
     -           1927296D0*rs7*rt3 - 
     -           268736D0*rs8*rt3 + 
     -           5652D0*rs9*rt3 + 
     -           353D0*rs10*rt3 + 
     -           15728640D0*rt4 + 
     -           8192000D0*rs*rt4 - 
     -           26755072D0*rs2*rt4 + 
     -           15331328D0*rs3*rt4 - 
     -           3296256D0*rs4*rt4 - 
     -           395520D0*rs5*rt4 + 
     -           879680D0*rs6*rt4 - 
     -           316784D0*rs7*rt4 + 
     -           29852D0*rs8*rt4 - 
     -           92D0*rs9*rt4 + 
     -           11927552D0*rt5 - 
     -           29671424D0*rs*rt5 + 
     -           28786688D0*rs2*rt5 - 
     -           14406656D0*rs3*rt5 + 
     -           4576256D0*rs4*rt5 - 
     -           887616D0*rs5*rt5 - 
     -           5952D0*rs6*rt5 + 
     -           22612D0*rs7*rt5 - 
     -           714D0*rs8*rt5 - 
     -           6356992D0*rt6 + 
     -           11812864D0*rs*rt6 - 
     -           9728000D0*rs2*rt6 + 
     -           4398080D0*rs3*rt6 - 
     -           1296640D0*rs4*rt6 + 
     -           216384D0*rs5*rt6 - 
     -           6128D0*rs6*rt6 - 
     -           756D0*rs7*rt6 + 
     -           1462272D0*rt7 - 
     -           2320384D0*rs*rt7 + 
     -           1679104D0*rs2*rt7 - 
     -           663040D0*rs3*rt7 + 
     -           162416D0*rs4*rt7 - 
     -           17272D0*rs5*rt7 - 
     -           27D0*rs6*rt7 - 172032D0*rt8 + 
     -           231424D0*rs*rt8 - 
     -           145920D0*rs2*rt8 + 
     -           47744D0*rs3*rt8 - 
     -           8256D0*rs4*rt8 + 
     -           240D0*rs5*rt8 + 8192D0*rt9 - 
     -           9216D0*rs*rt9 + 
     -           4992D0*rs2*rt9 - 
     -           1216D0*rs3*rt9 + 72D0*rs4*rt9
     -           )*li2s(9))/
     -       (2304.0D0*PI2*(-4D0 + rs)**5*rs*(4D0 + rs)*
     -         (rs - rt)*(-4D0 + rt)**2*rt*
     -         (-4D0 + rs + rt)**2*(rs + rt)**2*
     -         (-4D0 + 2D0*rs + rt)) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (41943040D0*rs2 - 32243712D0*rs3 + 
     -           7077888D0*rs4 + 884736D0*rs5 - 
     -           737280D0*rs6 + 128000D0*rs7 + 
     -           2048D0*rs8 - 3072D0*rs9 + 
     -           256D0*rs10 - 41943040D0*rs*rt - 
     -           32505856D0*rs2*rt + 
     -           27066368D0*rs3*rt + 
     -           1900544D0*rs4*rt - 
     -           6725632D0*rs5*rt + 
     -           2924544D0*rs6*rt - 
     -           652032D0*rs7*rt + 
     -           80384D0*rs8*rt - 5120D0*rs9*rt + 
     -           128D0*rs10*rt + 
     -           60555264D0*rs*rt2 + 
     -           7602176D0*rs2*rt2 - 
     -           8339456D0*rs3*rt2 - 
     -           8429568D0*rs4*rt2 + 
     -           7483392D0*rs5*rt2 - 
     -           2563072D0*rs6*rt2 + 
     -           453376D0*rs7*rt2 - 
     -           39168D0*rs8*rt2 + 
     -           1088D0*rs9*rt2 + 
     -           16D0*rs10*rt2 + 
     -           4194304D0*rt3 - 
     -           32833536D0*rs*rt3 - 
     -           7831552D0*rs2*rt3 + 
     -           4829184D0*rs3*rt3 + 
     -           4073472D0*rs4*rt3 - 
     -           3069440D0*rs5*rt3 + 
     -           815616D0*rs6*rt3 - 
     -           95168D0*rs7*rt3 + 
     -           3232D0*rs8*rt3 + 
     -           112D0*rs9*rt3 - 
     -           7864320D0*rt4 + 
     -           5586944D0*rs*rt4 + 
     -           11608064D0*rs2*rt4 - 
     -           5836800D0*rs3*rt4 + 
     -           241152D0*rs4*rt4 + 
     -           383744D0*rs5*rt4 - 
     -           87360D0*rs6*rt4 + 
     -           4796D0*rs7*rt4 + 
     -           184D0*rs8*rt4 + 
     -           5505024D0*rt5 + 
     -           3813376D0*rs*rt5 - 
     -           8300544D0*rs2*rt5 + 
     -           3610624D0*rs3*rt5 - 
     -           627712D0*rs4*rt5 + 
     -           29056D0*rs5*rt5 + 
     -           2496D0*rs6*rt5 - 
     -           89D0*rs7*rt5 - 2523136D0*rt6 - 
     -           2315264D0*rs*rt6 + 
     -           2840064D0*rs2*rt6 - 
     -           1005632D0*rs3*rt6 + 
     -           143520D0*rs4*rt6 - 
     -           4728D0*rs5*rt6 - 
     -           380D0*rs6*rt6 + 
     -           1245184D0*rt7 + 
     -           108800D0*rs*rt7 - 
     -           374400D0*rs2*rt7 + 
     -           121072D0*rs3*rt7 - 
     -           11256D0*rs4*rt7 - 
     -           56D0*rs5*rt7 - 501760D0*rt8 + 
     -           201152D0*rs*rt8 - 
     -           8224D0*rs2*rt8 - 
     -           6572D0*rs3*rt8 + 
     -           502D0*rs4*rt8 + 113664D0*rt9 - 
     -           55152D0*rs*rt9 + 
     -           5240D0*rs2*rt9 + 
     -           281D0*rs3*rt9 - 12160D0*rt10 + 
     -           5704D0*rs*rt10 - 
     -           322D0*rs2*rt10 + 448D0*rt11 - 
     -           248D0*rs*rt11)*li2s(10))/
     -       (2304.0D0*PI2*(-4D0 + rs)**2*rs*(rs - rt)*
     -         (-4D0 + rt)**4*rt*(4D0 + rt)*
     -         (-4D0 + rs + rt)**2*(rs + rt)**2*
     -         (-4D0 + rs + 2D0*rt)) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-536870912D0*rs + 
     -           1.375731712d9*rs2 - 
     -           1.564475392d9*rs3 + 
     -           1.034944512d9*rs4 - 
     -           440532992D0*rs5 + 
     -           126779392D0*rs6 - 
     -           25346048D0*rs7 + 3563520D0*rs8 - 
     -           348672D0*rs9 + 22144D0*rs10 - 
     -           704D0*rs11 - 1.073741824d9*rt + 
     -           3.791650816d9*rs*rt - 
     -           5.553258496d9*rs2*rt + 
     -           4.558159872d9*rs3*rt - 
     -           2.353528832d9*rs4*rt + 
     -           810549248D0*rs5*rt - 
     -           193177600D0*rs6*rt + 
     -           32695040D0*rs7*rt - 
     -           3970432D0*rs8*rt + 
     -           334000D0*rs9*rt - 
     -           16728D0*rs10*rt + 
     -           312D0*rs11*rt + 
     -           2.449473536d9*rt2 - 
     -           6.538919936d9*rs*rt2 + 
     -           7.584874496d9*rs2*rt2 - 
     -           5.044174848d9*rs3*rt2 + 
     -           2.141257728d9*rs4*rt2 - 
     -           615548928D0*rs5*rt2 + 
     -           124834816D0*rs6*rt2 - 
     -           18279168D0*rs7*rt2 + 
     -           1888384D0*rs8*rt2 - 
     -           120592D0*rs9*rt2 + 
     -           3278D0*rs10*rt2 - 
     -           2.5165824d9*rt3 + 
     -           5.619318784d9*rs*rt3 - 
     -           5.451153408d9*rs2*rt3 + 
     -           3.034349568d9*rs3*rt3 - 
     -           1.085591552d9*rs4*rt3 + 
     -           266814720D0*rs5*rt3 - 
     -           46810624D0*rs6*rt3 + 
     -           5786336D0*rs7*rt3 - 
     -           445664D0*rs8*rt3 + 
     -           15145D0*rs9*rt3 + 
     -           1.547173888d9*rt4 - 
     -           2.958688256d9*rs*rt4 + 
     -           2.44465664d9*rs2*rt4 - 
     -           1.160105984d9*rs3*rt4 + 
     -           356847616D0*rs4*rt4 - 
     -           75821440D0*rs5*rt4 + 
     -           11149312D0*rs6*rt4 - 
     -           1014864D0*rs7*rt4 + 
     -           41118D0*rs8*rt4 - 
     -           636616704D0*rt5 + 
     -           1.052606464d9*rs*rt5 - 
     -           750168064D0*rs2*rt5 + 
     -           307977472D0*rs3*rt5 - 
     -           81840000D0*rs4*rt5 + 
     -           14476640D0*rs5*rt5 - 
     -           1553096D0*rs6*rt5 + 
     -           73759D0*rs7*rt5 + 
     -           185729024D0*rt6 - 
     -           267364352D0*rs*rt6 + 
     -           165678080D0*rs2*rt6 - 
     -           58691072D0*rs3*rt6 + 
     -           12907520D0*rs4*rt6 - 
     -           1656072D0*rs5*rt6 + 
     -           92344D0*rs6*rt6 - 
     -           39559168D0*rt7 + 
     -           49617664D0*rs*rt7 - 
     -           26456320D0*rs2*rt7 + 
     -           7713376D0*rs3*rt7 - 
     -           1227088D0*rs4*rt7 + 
     -           81919D0*rs5*rt7 + 
     -           6156288D0*rt8 - 
     -           6608768D0*rs*rt8 + 
     -           2882432D0*rs2*rt8 - 
     -           607360D0*rs3*rt8 + 
     -           50510D0*rs4*rt8 - 
     -           671744D0*rt9 + 585392D0*rs*rt9 - 
     -           184496D0*rs2*rt9 + 
     -           20457D0*rs3*rt9 + 
     -           45952D0*rt10 - 28952D0*rs*rt10 + 
     -           4846D0*rs2*rt10 - 
     -           1472D0*rt11 + 504D0*rs*rt11)*
     -         li2s(11))/
     -       (2304.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-8D0 + rs + rt)*
     -         (-4D0 + rs + rt)*(rs + rt)**5*
     -         (-4D0 + 2D0*rs + rt)*(-4D0 + rs + 2D0*rt)) 
     -       - ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-524288D0*rs + 458752D0*rs2 - 
     -           163840D0*rs3 + 21504D0*rs4 + 
     -           9472D0*rs5 - 4032D0*rs6 + 
     -           592D0*rs7 - 32D0*rs8 + 
     -           524288D0*rt + 131072D0*rs*rt - 
     -           344064D0*rs2*rt + 
     -           159744D0*rs3*rt - 
     -           11520D0*rs4*rt - 7680D0*rs5*rt + 
     -           1808D0*rs6*rt - 96D0*rs7*rt - 
     -           4D0*rs8*rt - 327680D0*rt2 - 
     -           49152D0*rs*rt2 + 
     -           186368D0*rs2*rt2 - 
     -           48128D0*rs3*rt2 - 
     -           4672D0*rs4*rt2 + 
     -           2320D0*rs5*rt2 - 
     -           4D0*rs6*rt2 - 37D0*rs7*rt2 + 
     -           rs8*rt2 + 98304D0*rt3 + 
     -           45056D0*rs*rt3 - 
     -           39936D0*rs2*rt3 - 
     -           2048D0*rs3*rt3 + 
     -           2640D0*rs4*rt3 + 
     -           80D0*rs5*rt3 - 
     -           89D0*rs6*rt3 + 4D0*rs7*rt3 - 
     -           11264D0*rt4 - 9472D0*rs*rt4 - 
     -           2112D0*rs2*rt4 + 
     -           3152D0*rs3*rt4 - 
     -           88D0*rs4*rt4 - 
     -           114D0*rs5*rt4 + 
     -           8D0*rs6*rt4 - 768D0*rt5 - 
     -           512D0*rs*rt5 + 
     -           2448D0*rs2*rt5 - 
     -           368D0*rs3*rt5 - 
     -           82D0*rs4*rt5 + 
     -           10D0*rs5*rt5 + 576D0*rt6 + 
     -           656D0*rs*rt6 - 324D0*rs2*rt6 - 
     -           25D0*rs3*rt6 + 8D0*rs4*rt6 - 
     -           48D0*rt7 - 96D0*rs*rt7 + 
     -           3D0*rs2*rt7 + 4D0*rs3*rt7 + 
     -           4D0*rs*rt8 + rs2*rt8)*
     -         li2s(12))/
     -       (128.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(4D0 + rt)*
     -         (-8D0 + rs + rt)*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (1048576D0 - 917504D0*rs + 
     -           196608D0*rs2 - 4096D0*rs3 - 
     -           4096D0*rs4 + 3072D0*rs5 - 
     -           1792D0*rs6 + 432D0*rs7 - 
     -           32D0*rs8 - 393216D0*rt + 
     -           294912D0*rs*rt - 40960D0*rs2*rt + 
     -           12288D0*rs3*rt - 2560D0*rs4*rt + 
     -           128D0*rs5*rt + 352D0*rs6*rt - 
     -           32D0*rs7*rt - 4D0*rs8*rt + 
     -           98304D0*rt2 - 20480D0*rs*rt2 + 
     -           10240D0*rs2*rt2 - 
     -           9984D0*rs3*rt2 + 
     -           3328D0*rs4*rt2 - 
     -           336D0*rs5*rt2 + 
     -           80D0*rs6*rt2 - 
     -           27D0*rs7*rt2 + rs8*rt2 - 
     -           16384D0*rt3 - 6144D0*rs*rt3 + 
     -           512D0*rs2*rt3 + 
     -           1280D0*rs3*rt3 + 
     -           72D0*rs5*rt3 - 
     -           54D0*rs6*rt3 + 4D0*rs7*rt3 + 
     -           12288D0*rt4 - 256D0*rs*rt4 - 
     -           2944D0*rs2*rt4 + 
     -           1536D0*rs3*rt4 - 
     -           168D0*rs4*rt4 - 
     -           59D0*rs5*rt4 + 8D0*rs6*rt4 - 
     -           3072D0*rt5 - 1024D0*rs*rt5 + 
     -           1600D0*rs2*rt5 - 
     -           384D0*rs3*rt5 - 
     -           32D0*rs4*rt5 + 
     -           10D0*rs5*rt5 + 256D0*rt6 + 
     -           448D0*rs*rt6 - 256D0*rs2*rt6 + 
     -           8D0*rs4*rt6 - 64D0*rs*rt7 + 
     -           8D0*rs2*rt7 + 4D0*rs3*rt7 + 
     -           4D0*rs*rt8 + rs2*rt8)*
     -         li2s(13))/
     -       (128.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(4D0 + rt)*
     -         (-8D0 + rs + rt)*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (524288D0*rs - 327680D0*rs2 + 
     -           98304D0*rs3 - 11264D0*rs4 - 
     -           768D0*rs5 + 576D0*rs6 - 
     -           48D0*rs7 - 524288D0*rt + 
     -           131072D0*rs*rt - 49152D0*rs2*rt + 
     -           45056D0*rs3*rt - 9472D0*rs4*rt - 
     -           512D0*rs5*rt + 656D0*rs6*rt - 
     -           96D0*rs7*rt + 4D0*rs8*rt + 
     -           458752D0*rt2 - 344064D0*rs*rt2 + 
     -           186368D0*rs2*rt2 - 
     -           39936D0*rs3*rt2 - 
     -           2112D0*rs4*rt2 + 
     -           2448D0*rs5*rt2 - 
     -           324D0*rs6*rt2 + 
     -           3D0*rs7*rt2 + rs8*rt2 - 
     -           163840D0*rt3 + 159744D0*rs*rt3 - 
     -           48128D0*rs2*rt3 - 
     -           2048D0*rs3*rt3 + 
     -           3152D0*rs4*rt3 - 
     -           368D0*rs5*rt3 - 
     -           25D0*rs6*rt3 + 4D0*rs7*rt3 + 
     -           21504D0*rt4 - 11520D0*rs*rt4 - 
     -           4672D0*rs2*rt4 + 
     -           2640D0*rs3*rt4 - 
     -           88D0*rs4*rt4 - 
     -           82D0*rs5*rt4 + 8D0*rs6*rt4 + 
     -           9472D0*rt5 - 7680D0*rs*rt5 + 
     -           2320D0*rs2*rt5 + 
     -           80D0*rs3*rt5 - 
     -           114D0*rs4*rt5 + 
     -           10D0*rs5*rt5 - 4032D0*rt6 + 
     -           1808D0*rs*rt6 - 4D0*rs2*rt6 - 
     -           89D0*rs3*rt6 + 8D0*rs4*rt6 + 
     -           592D0*rt7 - 96D0*rs*rt7 - 
     -           37D0*rs2*rt7 + 4D0*rs3*rt7 - 
     -           32D0*rt8 - 4D0*rs*rt8 + 
     -           rs2*rt8)*li2s(14))/
     -       (128.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(4D0 + rt)*
     -         (-8D0 + rs + rt)*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (1048576D0 - 393216D0*rs + 
     -           98304D0*rs2 - 16384D0*rs3 + 
     -           12288D0*rs4 - 3072D0*rs5 + 
     -           256D0*rs6 - 917504D0*rt + 
     -           294912D0*rs*rt - 20480D0*rs2*rt - 
     -           6144D0*rs3*rt - 256D0*rs4*rt - 
     -           1024D0*rs5*rt + 448D0*rs6*rt - 
     -           64D0*rs7*rt + 4D0*rs8*rt + 
     -           196608D0*rt2 - 40960D0*rs*rt2 + 
     -           10240D0*rs2*rt2 + 
     -           512D0*rs3*rt2 - 
     -           2944D0*rs4*rt2 + 
     -           1600D0*rs5*rt2 - 
     -           256D0*rs6*rt2 + 
     -           8D0*rs7*rt2 + rs8*rt2 - 
     -           4096D0*rt3 + 12288D0*rs*rt3 - 
     -           9984D0*rs2*rt3 + 
     -           1280D0*rs3*rt3 + 
     -           1536D0*rs4*rt3 - 
     -           384D0*rs5*rt3 + 
     -           4D0*rs7*rt3 - 4096D0*rt4 - 
     -           2560D0*rs*rt4 + 
     -           3328D0*rs2*rt4 - 
     -           168D0*rs4*rt4 - 
     -           32D0*rs5*rt4 + 8D0*rs6*rt4 + 
     -           3072D0*rt5 + 128D0*rs*rt5 - 
     -           336D0*rs2*rt5 + 
     -           72D0*rs3*rt5 - 
     -           59D0*rs4*rt5 + 
     -           10D0*rs5*rt5 - 1792D0*rt6 + 
     -           352D0*rs*rt6 + 80D0*rs2*rt6 - 
     -           54D0*rs3*rt6 + 8D0*rs4*rt6 + 
     -           432D0*rt7 - 32D0*rs*rt7 - 
     -           27D0*rs2*rt7 + 4D0*rs3*rt7 - 
     -           32D0*rt8 - 4D0*rs*rt8 + 
     -           rs2*rt8)*li2s(15))/
     -       (128.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(4D0 + rt)*
     -         (-8D0 + rs + rt)*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      (3D0*(-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -            rt2)**2*
     -         (16D0 - 4D0*rs + rs2 - 4D0*rt + 
     -            rs*rt + rt2)**2*logs(1))/
     -       (32.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) + 
     -      (3D0*(-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -            rt2)**2*
     -         (256D0 - 128D0*rs + 48D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           96D0*rs*rt - 24D0*rs2*rt + 
     -           2D0*rs3*rt + 48D0*rt2 - 
     -           24D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         logs(1)**2)/
     -       (64.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      (logtwo*(-4D0*rs + rs2 - 4D0*rt + 
     -           rs*rt + rt2)*
     -         (256D0 - 128D0*rs + 32D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           80D0*rs*rt - 20D0*rs2*rt + 
     -           2D0*rs3*rt + 48D0*rt2 - 
     -           20D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         logs(2))/
     -       (64.0D0*PI2*(-4D0 + rs)**2*(-4D0 + rt)**2*
     -         (rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-16384D0*rs + 20480D0*rs2 - 
     -           12288D0*rs3 + 4608D0*rs4 - 
     -           1152D0*rs5 + 192D0*rs6 - 
     -           20D0*rs7 + rs8 - 16384D0*rt + 
     -           28672D0*rs*rt - 22528D0*rs2*rt + 
     -           10752D0*rs3*rt - 3328D0*rs4*rt + 
     -           640D0*rs5*rt - 68D0*rs6*rt + 
     -           3D0*rs7*rt + 12288D0*rt2 - 
     -           17408D0*rs*rt2 + 
     -           11520D0*rs2*rt2 - 
     -           4736D0*rs3*rt2 + 
     -           1184D0*rs4*rt2 - 
     -           156D0*rs5*rt2 + 
     -           8D0*rs6*rt2 - 5120D0*rt3 + 
     -           5888D0*rs*rt3 - 
     -           3328D0*rs2*rt3 + 
     -           1152D0*rs3*rt3 - 
     -           204D0*rs4*rt3 + 
     -           13D0*rs5*rt3 + 1280D0*rt4 - 
     -           1216D0*rs*rt4 + 
     -           592D0*rs2*rt4 - 
     -           156D0*rs3*rt4 + 
     -           14D0*rs4*rt4 - 192D0*rt5 + 
     -           144D0*rs*rt5 - 60D0*rs2*rt5 + 
     -           9D0*rs3*rt5 + 16D0*rt6 - 
     -           8D0*rs*rt6 + 3D0*rs2*rt6)*
     -         logs(2))/
     -       (32.0D0*PI2*(-4D0 + rs)**4*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -            rt2)**2*
     -         (256D0 - 128D0*rs + 48D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           96D0*rs*rt - 24D0*rs2*rt + 
     -           2D0*rs3*rt + 48D0*rt2 - 
     -           24D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         logs(1)*logs(2))/
     -       (32.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-1024D0 + 768D0*rs - 320D0*rs2 + 
     -           80D0*rs3 - 12D0*rs4 + rs5 + 
     -           512D0*rt - 512D0*rs*rt + 
     -           208D0*rs2*rt - 36D0*rs3*rt + 
     -           2D0*rs4*rt - 192D0*rt2 + 
     -           144D0*rs*rt2 - 40D0*rs2*rt2 + 
     -           3D0*rs3*rt2 + 32D0*rt3 - 
     -           16D0*rs*rt3 + 2D0*rs2*rt3 - 
     -           4D0*rt4 + rs*rt4)*logs(2)**2)/
     -       (256.0D0*PI2*(-4D0 + rs)**2*rs*(-4D0 + rt)*
     -         rt*(-4D0 + rs + rt)*(rs + rt)) + 
     -      (logtwo*(-4D0*rs + rs2 - 4D0*rt + 
     -           rs*rt + rt2)*
     -         (-458752D0*rs + 401408D0*rs2 - 
     -           186368D0*rs3 + 52736D0*rs4 - 
     -           9088D0*rs5 + 832D0*rs6 - 
     -           32D0*rs7 + 458752D0*rt - 
     -           8192D0*rs*rt - 154624D0*rs2*rt + 
     -           96000D0*rs3*rt - 
     -           28480D0*rs4*rt + 4528D0*rs5*rt - 
     -           416D0*rs6*rt + 16D0*rs7*rt - 
     -           212992D0*rt2 + 69632D0*rs*rt2 + 
     -           6400D0*rs2*rt2 - 
     -           12416D0*rs3*rt2 + 
     -           1072D0*rs4*rt2 + 
     -           392D0*rs5*rt2 - 
     -           92D0*rs6*rt2 + 6D0*rs7*rt2 + 
     -           54272D0*rt3 - 40704D0*rs*rt3 + 
     -           10624D0*rs2*rt3 - 
     -           5664D0*rs3*rt3 + 
     -           2356D0*rs4*rt3 - 
     -           391D0*rs5*rt3 + 
     -           24D0*rs6*rt3 - 3840D0*rt4 + 
     -           1024D0*rs*rt4 - 
     -           3392D0*rs2*rt4 + 
     -           2880D0*rs3*rt4 - 
     -           657D0*rs4*rt4 + 
     -           48D0*rs5*rt4 - 5184D0*rt5 + 
     -           2640D0*rs*rt5 + 
     -           996D0*rs2*rt5 - 
     -           573D0*rs3*rt5 + 
     -           60D0*rs4*rt5 + 2224D0*rt6 - 
     -           560D0*rs*rt6 - 223D0*rs2*rt6 + 
     -           48D0*rs3*rt6 - 384D0*rt7 + 
     -           24D0*rs2*rt7 + 24D0*rt8 + 
     -           6D0*rs*rt8)*logs(3))/
     -       (256.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(4D0 + rt)*
     -         (-8D0 + rs + rt)*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (262144D0*rs2 - 622592D0*rs3 + 
     -           630784D0*rs4 - 358400D0*rs5 + 
     -           125440D0*rs6 - 27392D0*rs7 + 
     -           3456D0*rs8 - 192D0*rs9 + 
     -           262144D0*rs*rt - 786432D0*rs2*rt + 
     -           1026048D0*rs3*rt - 
     -           707584D0*rs4*rt + 
     -           264448D0*rs5*rt - 
     -           45952D0*rs6*rt - 952D0*rs7*rt + 
     -           1812D0*rs8*rt - 280D0*rs9*rt + 
     -           14D0*rs10*rt + 524288D0*rt2 - 
     -           1540096D0*rs*rt2 + 
     -           1683456D0*rs2*rt2 - 
     -           954368D0*rs3*rt2 + 
     -           290432D0*rs4*rt2 - 
     -           23712D0*rs5*rt2 - 
     -           16104D0*rs6*rt2 + 
     -           6314D0*rs7*rt2 - 
     -           925D0*rs8*rt2 + 
     -           49D0*rs9*rt2 - 458752D0*rt3 + 
     -           1116160D0*rs*rt3 - 
     -           1001984D0*rs2*rt3 + 
     -           441088D0*rs3*rt3 - 
     -           91392D0*rs4*rt3 - 
     -           2408D0*rs5*rt3 + 
     -           6090D0*rs6*rt3 - 
     -           1273D0*rs7*rt3 + 
     -           85D0*rs8*rt3 + 180224D0*rt4 - 
     -           357888D0*rs*rt4 + 
     -           277248D0*rs2*rt4 - 
     -           110560D0*rs3*rt4 + 
     -           22544D0*rs4*rt4 - 
     -           668D0*rs5*rt4 - 
     -           606D0*rs6*rt4 + 
     -           74D0*rs7*rt4 - 36864D0*rt5 + 
     -           50560D0*rs*rt5 - 
     -           30880D0*rs2*rt5 + 
     -           11832D0*rs3*rt5 - 
     -           2662D0*rs4*rt5 + 
     -           163D0*rs5*rt5 + 
     -           21D0*rs6*rt5 + 3072D0*rt6 + 
     -           736D0*rs*rt6 - 976D0*rs2*rt6 - 
     -           446D0*rs3*rt6 + 
     -           269D0*rs4*rt6 - 
     -           21D0*rs5*rt6 - 896D0*rs*rt7 + 
     -           352D0*rs2*rt7 + 
     -           64D0*rs3*rt7 - 
     -           24D0*rs4*rt7 + 56D0*rs*rt8 - 
     -           8D0*rs2*rt8 - 6D0*rs3*rt8)*
     -         logs(3))/
     -       (288.0D0*PI2*(-4D0 + rs)**3*(-2D0 + rs)**2*
     -         rs*(rs - rt)*(-4D0 + rt)**2*rt*
     -         (-4D0 + rs + rt)*(rs + rt)**2*
     -         (-4D0 + 2D0*rs + rt)) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (524288D0 - 786432D0*rs + 
     -           565248D0*rs2 - 251904D0*rs3 + 
     -           77824D0*rs4 - 14720D0*rs5 + 
     -           1504D0*rs6 - 64D0*rs7 + 
     -           253952D0*rs*rt - 287744D0*rs2*rt + 
     -           156928D0*rs3*rt - 
     -           44992D0*rs4*rt + 6608D0*rs5*rt - 
     -           448D0*rs6*rt + 8D0*rs7*rt - 
     -           16384D0*rt2 - 81920D0*rs*rt2 + 
     -           95488D0*rs2*rt2 - 
     -           39040D0*rs3*rt2 + 
     -           4560D0*rs4*rt2 + 
     -           456D0*rs5*rt2 - 
     -           126D0*rs6*rt2 + 
     -           6D0*rs7*rt2 + 11264D0*rt3 + 
     -           6912D0*rs*rt3 - 
     -           8320D0*rs2*rt3 - 
     -           3360D0*rs3*rt3 + 
     -           2684D0*rs4*rt3 - 
     -           465D0*rs5*rt3 + 
     -           24D0*rs6*rt3 - 1280D0*rt4 + 
     -           512D0*rs*rt4 - 
     -           4832D0*rs2*rt4 + 
     -           3632D0*rs3*rt4 - 
     -           765D0*rs4*rt4 + 
     -           48D0*rs5*rt4 - 1472D0*rt5 - 
     -           528D0*rs*rt5 + 
     -           2076D0*rs2*rt5 - 
     -           703D0*rs3*rt5 + 
     -           60D0*rs4*rt5 + 720D0*rt6 + 
     -           224D0*rs*rt6 - 341D0*rs2*rt6 + 
     -           48D0*rs3*rt6 - 128D0*rt7 - 
     -           64D0*rs*rt7 + 24D0*rs2*rt7 + 
     -           8D0*rt8 + 6D0*rs*rt8)*logs(3)**2)
     -        /(512.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(4D0 + rt)*
     -         (-8D0 + rs + rt)*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((MC2*rs - 
     -           DSQRT(MC4*(-4D0 + rs)*rs))*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-2048D0*rs3 + 1280D0*rs4 - 
     -           384D0*rs5 + 48D0*rs6 + 
     -           3072D0*rs*rt - 5632D0*rs2*rt + 
     -           5376D0*rs3*rt - 2912D0*rs4*rt + 
     -           708D0*rs5*rt - 68D0*rs6*rt + 
     -           2D0*rs7*rt + 3072D0*rt2 - 
     -           3072D0*rs*rt2 + 
     -           5184D0*rs2*rt2 - 
     -           5040D0*rs3*rt2 + 
     -           2032D0*rs4*rt2 - 
     -           313D0*rs5*rt2 + 
     -           16D0*rs6*rt2 - 1536D0*rt3 + 
     -           768D0*rs*rt3 - 
     -           2560D0*rs2*rt3 + 
     -           2128D0*rs3*rt3 - 
     -           538D0*rs4*rt3 + 
     -           40D0*rs5*rt3 + 192D0*rt4 - 
     -           48D0*rs*rt4 + 788D0*rs2*rt4 - 
     -           429D0*rs3*rt4 + 
     -           50D0*rs4*rt4 - 
     -           144D0*rs2*rt5 + 
     -           36D0*rs3*rt5 + 12D0*rs2*rt6)*
     -         logs(4))/
     -       (144.0D0*MC2*PI2*(-4D0 + rs)**3*rs3*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((MC2*rs + 
     -           DSQRT(MC4*(-4D0 + rs)*rs))*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-2048D0*rs3 + 1280D0*rs4 - 
     -           384D0*rs5 + 48D0*rs6 + 
     -           3072D0*rs*rt - 5632D0*rs2*rt + 
     -           5376D0*rs3*rt - 2912D0*rs4*rt + 
     -           708D0*rs5*rt - 68D0*rs6*rt + 
     -           2D0*rs7*rt + 3072D0*rt2 - 
     -           3072D0*rs*rt2 + 
     -           5184D0*rs2*rt2 - 
     -           5040D0*rs3*rt2 + 
     -           2032D0*rs4*rt2 - 
     -           313D0*rs5*rt2 + 
     -           16D0*rs6*rt2 - 1536D0*rt3 + 
     -           768D0*rs*rt3 - 
     -           2560D0*rs2*rt3 + 
     -           2128D0*rs3*rt3 - 
     -           538D0*rs4*rt3 + 
     -           40D0*rs5*rt3 + 192D0*rt4 - 
     -           48D0*rs*rt4 + 788D0*rs2*rt4 - 
     -           429D0*rs3*rt4 + 
     -           50D0*rs4*rt4 - 
     -           144D0*rs2*rt5 + 
     -           36D0*rs3*rt5 + 12D0*rs2*rt6)*
     -         logs(5))/
     -       (144.0D0*MC2*PI2*(-4D0 + rs)**3*rs3*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (3072D0*rs2 - 1536D0*rs3 + 
     -           192D0*rs4 + 3072D0*rs*rt - 
     -           3072D0*rs2*rt + 768D0*rs3*rt - 
     -           48D0*rs4*rt - 5632D0*rs*rt2 + 
     -           5184D0*rs2*rt2 - 
     -           2560D0*rs3*rt2 + 
     -           788D0*rs4*rt2 - 
     -           144D0*rs5*rt2 + 
     -           12D0*rs6*rt2 - 2048D0*rt3 + 
     -           5376D0*rs*rt3 - 
     -           5040D0*rs2*rt3 + 
     -           2128D0*rs3*rt3 - 
     -           429D0*rs4*rt3 + 
     -           36D0*rs5*rt3 + 1280D0*rt4 - 
     -           2912D0*rs*rt4 + 
     -           2032D0*rs2*rt4 - 
     -           538D0*rs3*rt4 + 
     -           50D0*rs4*rt4 - 384D0*rt5 + 
     -           708D0*rs*rt5 - 313D0*rs2*rt5 + 
     -           40D0*rs3*rt5 + 48D0*rt6 - 
     -           68D0*rs*rt6 + 16D0*rs2*rt6 + 
     -           2D0*rs*rt7)*
     -         (MC2*rt + 
     -           DSQRT(MC4*(-4D0 + rt)*rt))*logs(6)
     -         )/
     -       (144.0D0*MC2*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**3*rt3*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (3072D0*rs2 - 1536D0*rs3 + 
     -           192D0*rs4 + 3072D0*rs*rt - 
     -           3072D0*rs2*rt + 768D0*rs3*rt - 
     -           48D0*rs4*rt - 5632D0*rs*rt2 + 
     -           5184D0*rs2*rt2 - 
     -           2560D0*rs3*rt2 + 
     -           788D0*rs4*rt2 - 
     -           144D0*rs5*rt2 + 
     -           12D0*rs6*rt2 - 2048D0*rt3 + 
     -           5376D0*rs*rt3 - 
     -           5040D0*rs2*rt3 + 
     -           2128D0*rs3*rt3 - 
     -           429D0*rs4*rt3 + 
     -           36D0*rs5*rt3 + 1280D0*rt4 - 
     -           2912D0*rs*rt4 + 
     -           2032D0*rs2*rt4 - 
     -           538D0*rs3*rt4 + 
     -           50D0*rs4*rt4 - 384D0*rt5 + 
     -           708D0*rs*rt5 - 313D0*rs2*rt5 + 
     -           40D0*rs3*rt5 + 48D0*rt6 - 
     -           68D0*rs*rt6 + 16D0*rs2*rt6 + 
     -           2D0*rs*rt7)*
     -         (MC2*rt - 
     -           DSQRT(MC4*(-4D0 + rt)*rt))*logs(7)
     -         )/
     -       (144.0D0*MC2*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**3*rt3*(-4D0 + rs + rt)*
     -         (rs + rt)**2) + 
     -      (logtwo*(-4D0*rs + rs2 - 4D0*rt + 
     -           rs*rt + rt2)*
     -         (458752D0*rs - 212992D0*rs2 + 
     -           54272D0*rs3 - 3840D0*rs4 - 
     -           5184D0*rs5 + 2224D0*rs6 - 
     -           384D0*rs7 + 24D0*rs8 - 
     -           458752D0*rt - 8192D0*rs*rt + 
     -           69632D0*rs2*rt - 
     -           40704D0*rs3*rt + 1024D0*rs4*rt + 
     -           2640D0*rs5*rt - 560D0*rs6*rt + 
     -           6D0*rs8*rt + 401408D0*rt2 - 
     -           154624D0*rs*rt2 + 
     -           6400D0*rs2*rt2 + 
     -           10624D0*rs3*rt2 - 
     -           3392D0*rs4*rt2 + 
     -           996D0*rs5*rt2 - 
     -           223D0*rs6*rt2 + 
     -           24D0*rs7*rt2 - 186368D0*rt3 + 
     -           96000D0*rs*rt3 - 
     -           12416D0*rs2*rt3 - 
     -           5664D0*rs3*rt3 + 
     -           2880D0*rs4*rt3 - 
     -           573D0*rs5*rt3 + 
     -           48D0*rs6*rt3 + 52736D0*rt4 - 
     -           28480D0*rs*rt4 + 
     -           1072D0*rs2*rt4 + 
     -           2356D0*rs3*rt4 - 
     -           657D0*rs4*rt4 + 
     -           60D0*rs5*rt4 - 9088D0*rt5 + 
     -           4528D0*rs*rt5 + 
     -           392D0*rs2*rt5 - 
     -           391D0*rs3*rt5 + 
     -           48D0*rs4*rt5 + 832D0*rt6 - 
     -           416D0*rs*rt6 - 92D0*rs2*rt6 + 
     -           24D0*rs3*rt6 - 32D0*rt7 + 
     -           16D0*rs*rt7 + 6D0*rs2*rt7)*
     -         logs(8))/
     -       (256.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(-8D0 + rs + rt)*
     -         (-4D0 + rs + rt)*(rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-524288D0*rs2 + 458752D0*rs3 - 
     -           180224D0*rs4 + 36864D0*rs5 - 
     -           3072D0*rs6 - 262144D0*rs*rt + 
     -           1540096D0*rs2*rt - 
     -           1116160D0*rs3*rt + 
     -           357888D0*rs4*rt - 
     -           50560D0*rs5*rt - 736D0*rs6*rt + 
     -           896D0*rs7*rt - 56D0*rs8*rt - 
     -           262144D0*rt2 + 786432D0*rs*rt2 - 
     -           1683456D0*rs2*rt2 + 
     -           1001984D0*rs3*rt2 - 
     -           277248D0*rs4*rt2 + 
     -           30880D0*rs5*rt2 + 
     -           976D0*rs6*rt2 - 
     -           352D0*rs7*rt2 + 
     -           8D0*rs8*rt2 + 622592D0*rt3 - 
     -           1026048D0*rs*rt3 + 
     -           954368D0*rs2*rt3 - 
     -           441088D0*rs3*rt3 + 
     -           110560D0*rs4*rt3 - 
     -           11832D0*rs5*rt3 + 
     -           446D0*rs6*rt3 - 
     -           64D0*rs7*rt3 + 6D0*rs8*rt3 - 
     -           630784D0*rt4 + 707584D0*rs*rt4 - 
     -           290432D0*rs2*rt4 + 
     -           91392D0*rs3*rt4 - 
     -           22544D0*rs4*rt4 + 
     -           2662D0*rs5*rt4 - 
     -           269D0*rs6*rt4 + 
     -           24D0*rs7*rt4 + 358400D0*rt5 - 
     -           264448D0*rs*rt5 + 
     -           23712D0*rs2*rt5 + 
     -           2408D0*rs3*rt5 + 
     -           668D0*rs4*rt5 - 
     -           163D0*rs5*rt5 + 
     -           21D0*rs6*rt5 - 125440D0*rt6 + 
     -           45952D0*rs*rt6 + 
     -           16104D0*rs2*rt6 - 
     -           6090D0*rs3*rt6 + 
     -           606D0*rs4*rt6 - 
     -           21D0*rs5*rt6 + 27392D0*rt7 + 
     -           952D0*rs*rt7 - 
     -           6314D0*rs2*rt7 + 
     -           1273D0*rs3*rt7 - 
     -           74D0*rs4*rt7 - 3456D0*rt8 - 
     -           1812D0*rs*rt8 + 
     -           925D0*rs2*rt8 - 
     -           85D0*rs3*rt8 + 192D0*rt9 + 
     -           280D0*rs*rt9 - 49D0*rs2*rt9 - 
     -           14D0*rs*rt10)*logs(8))/
     -       (288.0D0*PI2*(-4D0 + rs)**2*rs*(rs - rt)*
     -         (-4D0 + rt)**3*(-2D0 + rt)**2*rt*
     -         (-4D0 + rs + rt)*(rs + rt)**2*
     -         (-4D0 + rs + 2D0*rt)) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-4096D0 + 1024D0*rs - 16D0*rs4 + 
     -           4D0*rs5 + 3072D0*rt - 
     -           128D0*rs2*rt + 48D0*rs3*rt - 
     -           4D0*rs4*rt + rs5*rt - 
     -           1280D0*rt2 - 64D0*rs*rt2 + 
     -           96D0*rs2*rt2 - 
     -           24D0*rs3*rt2 + 2D0*rs4*rt2 + 
     -           320D0*rt3 + 64D0*rs*rt3 - 
     -           24D0*rs2*rt3 + 3D0*rs3*rt3 - 
     -           48D0*rt4 - 12D0*rs*rt4 + 
     -           2D0*rs2*rt4 + 4D0*rt5 + 
     -           rs*rt5)*logs(2)*logs(8))/
     -       (128.0D0*PI2*(-4D0 + rs)**2*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (8192D0*rs - 3072D0*rs2 + 
     -           256D0*rs3 + 576D0*rs4 - 
     -           144D0*rs5 + 16D0*rs6 + 8192D0*rt - 
     -           18432D0*rs*rt + 7424D0*rs2*rt - 
     -           128D0*rs3*rt - 240D0*rs4*rt + 
     -           32D0*rs5*rt + 4D0*rs6*rt - 
     -           3072D0*rt2 + 7424D0*rs*rt2 - 
     -           640D0*rs2*rt2 - 
     -           256D0*rs3*rt2 + 
     -           44D0*rs4*rt2 + 9D0*rs5*rt2 + 
     -           256D0*rt3 - 128D0*rs*rt3 - 
     -           256D0*rs2*rt3 + 
     -           24D0*rs3*rt3 + 
     -           11D0*rs4*rt3 + 576D0*rt4 - 
     -           240D0*rs*rt4 + 44D0*rs2*rt4 + 
     -           11D0*rs3*rt4 - 144D0*rt5 + 
     -           32D0*rs*rt5 + 9D0*rs2*rt5 + 
     -           16D0*rt6 + 4D0*rs*rt6)*logs(3)*
     -         logs(8))/
     -       (128.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(4D0 + rt)*
     -         (-4D0 + rs + rt)*(rs + rt)) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (524288D0 - 16384D0*rs2 + 
     -           11264D0*rs3 - 1280D0*rs4 - 
     -           1472D0*rs5 + 720D0*rs6 - 
     -           128D0*rs7 + 8D0*rs8 - 
     -           786432D0*rt + 253952D0*rs*rt - 
     -           81920D0*rs2*rt + 6912D0*rs3*rt + 
     -           512D0*rs4*rt - 528D0*rs5*rt + 
     -           224D0*rs6*rt - 64D0*rs7*rt + 
     -           6D0*rs8*rt + 565248D0*rt2 - 
     -           287744D0*rs*rt2 + 
     -           95488D0*rs2*rt2 - 
     -           8320D0*rs3*rt2 - 
     -           4832D0*rs4*rt2 + 
     -           2076D0*rs5*rt2 - 
     -           341D0*rs6*rt2 + 
     -           24D0*rs7*rt2 - 251904D0*rt3 + 
     -           156928D0*rs*rt3 - 
     -           39040D0*rs2*rt3 - 
     -           3360D0*rs3*rt3 + 
     -           3632D0*rs4*rt3 - 
     -           703D0*rs5*rt3 + 
     -           48D0*rs6*rt3 + 77824D0*rt4 - 
     -           44992D0*rs*rt4 + 
     -           4560D0*rs2*rt4 + 
     -           2684D0*rs3*rt4 - 
     -           765D0*rs4*rt4 + 
     -           60D0*rs5*rt4 - 14720D0*rt5 + 
     -           6608D0*rs*rt5 + 
     -           456D0*rs2*rt5 - 
     -           465D0*rs3*rt5 + 
     -           48D0*rs4*rt5 + 1504D0*rt6 - 
     -           448D0*rs*rt6 - 126D0*rs2*rt6 + 
     -           24D0*rs3*rt6 - 64D0*rt7 + 
     -           8D0*rs*rt7 + 6D0*rs2*rt7)*
     -         logs(8)**2)/
     -       (512.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(-8D0 + rs + rt)*
     -         (-4D0 + rs + rt)*(rs + rt)**2) - 
     -      (logtwo*(-4D0*rs + rs2 - 4D0*rt + 
     -           rs*rt + rt2)*
     -         (256D0 - 128D0*rs + 48D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           80D0*rs*rt - 20D0*rs2*rt + 
     -           2D0*rs3*rt + 32D0*rt2 - 
     -           20D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         logs(9))/
     -       (64.0D0*PI2*(-4D0 + rs)**2*(-4D0 + rt)**2*
     -         (rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-16384D0*rs + 12288D0*rs2 - 
     -           5120D0*rs3 + 1280D0*rs4 - 
     -           192D0*rs5 + 16D0*rs6 - 
     -           16384D0*rt + 28672D0*rs*rt - 
     -           17408D0*rs2*rt + 5888D0*rs3*rt - 
     -           1216D0*rs4*rt + 144D0*rs5*rt - 
     -           8D0*rs6*rt + 20480D0*rt2 - 
     -           22528D0*rs*rt2 + 
     -           11520D0*rs2*rt2 - 
     -           3328D0*rs3*rt2 + 
     -           592D0*rs4*rt2 - 
     -           60D0*rs5*rt2 + 3D0*rs6*rt2 - 
     -           12288D0*rt3 + 10752D0*rs*rt3 - 
     -           4736D0*rs2*rt3 + 
     -           1152D0*rs3*rt3 - 
     -           156D0*rs4*rt3 + 
     -           9D0*rs5*rt3 + 4608D0*rt4 - 
     -           3328D0*rs*rt4 + 
     -           1184D0*rs2*rt4 - 
     -           204D0*rs3*rt4 + 
     -           14D0*rs4*rt4 - 1152D0*rt5 + 
     -           640D0*rs*rt5 - 156D0*rs2*rt5 + 
     -           13D0*rs3*rt5 + 192D0*rt6 - 
     -           68D0*rs*rt6 + 8D0*rs2*rt6 - 
     -           20D0*rt7 + 3D0*rs*rt7 + rt8)*
     -         logs(9))/
     -       (32.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**4*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -            rt2)**2*
     -         (256D0 - 128D0*rs + 48D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           96D0*rs*rt - 24D0*rs2*rt + 
     -           2D0*rs3*rt + 48D0*rt2 - 
     -           24D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         logs(1)*logs(9))/
     -       (32.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (256D0 - 128D0*rs + 48D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           96D0*rs*rt - 24D0*rs2*rt + 
     -           2D0*rs3*rt + 48D0*rt2 - 
     -           24D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         logs(2)*logs(9))/
     -       (128.0D0*PI2*(-4D0 + rs)*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-4096D0 + 3072D0*rs - 1280D0*rs2 + 
     -           320D0*rs3 - 48D0*rs4 + 4D0*rs5 + 
     -           1024D0*rt - 64D0*rs2*rt + 
     -           64D0*rs3*rt - 12D0*rs4*rt + 
     -           rs5*rt - 128D0*rs*rt2 + 
     -           96D0*rs2*rt2 - 
     -           24D0*rs3*rt2 + 2D0*rs4*rt2 + 
     -           48D0*rs*rt3 - 24D0*rs2*rt3 + 
     -           3D0*rs3*rt3 - 16D0*rt4 - 
     -           4D0*rs*rt4 + 2D0*rs2*rt4 + 
     -           4D0*rt5 + rs*rt5)*logs(3)*
     -         logs(9))/
     -       (128.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*(4D0 + rt)*
     -         (-4D0 + rs + rt)*(rs + rt)) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-1024D0 + 512D0*rs - 192D0*rs2 + 
     -           32D0*rs3 - 4D0*rs4 + 768D0*rt - 
     -           512D0*rs*rt + 144D0*rs2*rt - 
     -           16D0*rs3*rt + rs4*rt - 
     -           320D0*rt2 + 208D0*rs*rt2 - 
     -           40D0*rs2*rt2 + 2D0*rs3*rt2 + 
     -           80D0*rt3 - 36D0*rs*rt3 + 
     -           3D0*rs2*rt3 - 12D0*rt4 + 
     -           2D0*rs*rt4 + rt5)*logs(9)**2)/
     -       (256.0D0*PI2*(-4D0 + rs)*rs*(-4D0 + rt)**2*
     -         rt*(-4D0 + rs + rt)*(rs + rt)) + 
     -      (logtwo*(-4D0*rs + rs2 - 4D0*rt + 
     -           rs*rt + rt2)*
     -         (262144D0 - 131072D0*rs + 
     -           81920D0*rs2 - 18432D0*rs3 + 
     -           1024D0*rs4 + 128D0*rs5 + 
     -           64D0*rs6 - 32D0*rs7 - 
     -           131072D0*rt - 65536D0*rs*rt + 
     -           36864D0*rs2*rt - 
     -           20224D0*rs3*rt + 2560D0*rs4*rt + 
     -           304D0*rs5*rt - 256D0*rs6*rt + 
     -           16D0*rs7*rt + 81920D0*rt2 + 
     -           36864D0*rs*rt2 - 
     -           53760D0*rs2*rt2 + 
     -           12416D0*rs3*rt2 + 
     -           288D0*rs4*rt2 - 
     -           664D0*rs5*rt2 + 
     -           36D0*rs6*rt2 + 6D0*rs7*rt2 - 
     -           18432D0*rt3 - 20224D0*rs*rt3 + 
     -           12416D0*rs2*rt3 - 
     -           416D0*rs3*rt3 - 
     -           896D0*rs4*rt3 + 
     -           65D0*rs5*rt3 + 
     -           18D0*rs6*rt3 + 1024D0*rt4 + 
     -           2560D0*rs*rt4 + 
     -           288D0*rs2*rt4 - 
     -           896D0*rs3*rt4 + 
     -           42D0*rs4*rt4 + 
     -           30D0*rs5*rt4 + 128D0*rt5 + 
     -           304D0*rs*rt5 - 664D0*rs2*rt5 + 
     -           65D0*rs3*rt5 + 
     -           30D0*rs4*rt5 + 64D0*rt6 - 
     -           256D0*rs*rt6 + 36D0*rs2*rt6 + 
     -           18D0*rs3*rt6 - 32D0*rt7 + 
     -           16D0*rs*rt7 + 6D0*rs2*rt7)*
     -         logs(10))/
     -       (256.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(4D0 + rt)*
     -         (-4D0 + rs + rt)*(rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-262144D0*rs2 + 622592D0*rs3 - 
     -           630784D0*rs4 + 358400D0*rs5 - 
     -           125440D0*rs6 + 27392D0*rs7 - 
     -           3456D0*rs8 + 192D0*rs9 - 
     -           524288D0*rs*rt + 
     -           1736704D0*rs2*rt - 
     -           2285568D0*rs3*rt + 
     -           1598976D0*rs4*rt - 
     -           669568D0*rs5*rt + 
     -           178272D0*rs6*rt - 
     -           30920D0*rs7*rt + 3540D0*rs8*rt - 
     -           280D0*rs9*rt + 14D0*rs10*rt - 
     -           262144D0*rt2 + 
     -           1736704D0*rs*rt2 - 
     -           3383296D0*rs2*rt2 + 
     -           3137024D0*rs3*rt2 - 
     -           1625472D0*rs4*rt2 + 
     -           517760D0*rs5*rt2 - 
     -           109960D0*rs6*rt2 + 
     -           16470D0*rs7*rt2 - 
     -           1681D0*rs8*rt2 + 
     -           91D0*rs9*rt2 + 622592D0*rt3 - 
     -           2285568D0*rs*rt3 + 
     -           3137024D0*rs2*rt3 - 
     -           2171904D0*rs3*rt3 + 
     -           867168D0*rs4*rt3 - 
     -           224640D0*rs5*rt3 + 
     -           40824D0*rs6*rt3 - 
     -           4815D0*rs7*rt3 + 
     -           274D0*rs8*rt3 - 630784D0*rt4 + 
     -           1598976D0*rs*rt4 - 
     -           1625472D0*rs2*rt4 + 
     -           867168D0*rs3*rt4 - 
     -           284576D0*rs4*rt4 + 
     -           63470D0*rs5*rt4 - 
     -           8691D0*rs6*rt4 + 
     -           522D0*rs7*rt4 + 358400D0*rt5 - 
     -           669568D0*rs*rt5 + 
     -           517760D0*rs2*rt5 - 
     -           224640D0*rs3*rt5 + 
     -           63470D0*rs4*rt5 - 
     -           10554D0*rs5*rt5 + 
     -           707D0*rs6*rt5 - 125440D0*rt6 + 
     -           178272D0*rs*rt6 - 
     -           109960D0*rs2*rt6 + 
     -           40824D0*rs3*rt6 - 
     -           8691D0*rs4*rt6 + 
     -           707D0*rs5*rt6 + 27392D0*rt7 - 
     -           30920D0*rs*rt7 + 
     -           16470D0*rs2*rt7 - 
     -           4815D0*rs3*rt7 + 
     -           522D0*rs4*rt7 - 3456D0*rt8 + 
     -           3540D0*rs*rt8 - 
     -           1681D0*rs2*rt8 + 
     -           274D0*rs3*rt8 + 192D0*rt9 - 
     -           280D0*rs*rt9 + 91D0*rs2*rt9 + 
     -           14D0*rs*rt10)*logs(10))/
     -       (288.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (-2D0 + rs + rt)**2*(rs + rt)**3*
     -         (-4D0 + 2D0*rs + rt)*(-4D0 + rs + 2D0*rt)) 
     -       + ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-1024D0*rs + 256D0*rs2 - 4D0*rs5 + 
     -           rs6 + 1024D0*rt - 256D0*rs*rt + 
     -           192D0*rs2*rt - 32D0*rs3*rt + 
     -           3D0*rs5*rt - 512D0*rt2 + 
     -           384D0*rs*rt2 - 96D0*rs2*rt2 + 
     -           4D0*rs3*rt2 + 5D0*rs4*rt2 + 
     -           192D0*rt3 - 96D0*rs*rt3 + 
     -           16D0*rs2*rt3 + 5D0*rs3*rt3 - 
     -           32D0*rt4 + 12D0*rs*rt4 + 
     -           3D0*rs2*rt4 + 4D0*rt5 + 
     -           rs*rt5)*logs(2)*logs(10))/
     -       (128.0D0*PI2*(-4D0 + rs)**2*(4D0 + rs)*
     -         (-4D0 + rt)*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (65536D0 - 24576D0*rs + 6144D0*rs2 - 
     -           1024D0*rs3 + 768D0*rs4 - 
     -           192D0*rs5 + 16D0*rs6 - 
     -           57344D0*rt + 10240D0*rs*rt + 
     -           3840D0*rs2*rt - 1920D0*rs3*rt + 
     -           112D0*rs4*rt + 4D0*rs6*rt + 
     -           24576D0*rt2 - 2048D0*rs*rt2 - 
     -           3328D0*rs2*rt2 + 
     -           1184D0*rs3*rt2 - 
     -           120D0*rs4*rt2 + 
     -           12D0*rs5*rt2 - 6912D0*rt3 - 
     -           128D0*rs*rt3 + 
     -           1152D0*rs2*rt3 - 
     -           264D0*rs3*rt3 + 
     -           23D0*rs4*rt3 + 1536D0*rt4 + 
     -           160D0*rs*rt4 - 176D0*rs2*rt4 + 
     -           26D0*rs3*rt4 - 240D0*rt5 - 
     -           32D0*rs*rt5 + 15D0*rs2*rt5 + 
     -           16D0*rt6 + 4D0*rs*rt6)*logs(3)*
     -         logs(10))/
     -       (128.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)*rt*(-8D0 + rs + rt)*
     -         (-4D0 + rs + rt)*(rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (65536D0 - 57344D0*rs + 24576D0*rs2 - 
     -           6912D0*rs3 + 1536D0*rs4 - 
     -           240D0*rs5 + 16D0*rs6 - 
     -           24576D0*rt + 10240D0*rs*rt - 
     -           2048D0*rs2*rt - 128D0*rs3*rt + 
     -           160D0*rs4*rt - 32D0*rs5*rt + 
     -           4D0*rs6*rt + 6144D0*rt2 + 
     -           3840D0*rs*rt2 - 
     -           3328D0*rs2*rt2 + 
     -           1152D0*rs3*rt2 - 
     -           176D0*rs4*rt2 + 
     -           15D0*rs5*rt2 - 1024D0*rt3 - 
     -           1920D0*rs*rt3 + 
     -           1184D0*rs2*rt3 - 
     -           264D0*rs3*rt3 + 
     -           26D0*rs4*rt3 + 768D0*rt4 + 
     -           112D0*rs*rt4 - 120D0*rs2*rt4 + 
     -           23D0*rs3*rt4 - 192D0*rt5 + 
     -           12D0*rs2*rt5 + 16D0*rt6 + 
     -           4D0*rs*rt6)*logs(8)*logs(10))/
     -       (128.0D0*PI2*(-4D0 + rs)*rs*(-4D0 + rt)**2*
     -         rt*(4D0 + rt)*(-8D0 + rs + rt)*
     -         (-4D0 + rs + rt)*(rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (1024D0*rs - 512D0*rs2 + 192D0*rs3 - 
     -           32D0*rs4 + 4D0*rs5 - 1024D0*rt - 
     -           256D0*rs*rt + 384D0*rs2*rt - 
     -           96D0*rs3*rt + 12D0*rs4*rt + 
     -           rs5*rt + 256D0*rt2 + 
     -           192D0*rs*rt2 - 96D0*rs2*rt2 + 
     -           16D0*rs3*rt2 + 3D0*rs4*rt2 - 
     -           32D0*rs*rt3 + 4D0*rs2*rt3 + 
     -           5D0*rs3*rt3 + 5D0*rs2*rt4 - 
     -           4D0*rt5 + 3D0*rs*rt5 + rt6)*
     -         logs(9)*logs(10))/
     -       (128.0D0*PI2*(-4D0 + rs)*rs*(-4D0 + rt)**2*
     -         (4D0 + rt)*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-262144D0 + 131072D0*rs + 
     -           8192D0*rs2 - 10240D0*rs3 - 
     -           1024D0*rs4 - 128D0*rs5 + 
     -           288D0*rs6 - 64D0*rs7 + 
     -           131072D0*rt - 81920D0*rs*rt + 
     -           12288D0*rs2*rt - 
     -           11520D0*rs3*rt + 1792D0*rs4*rt + 
     -           272D0*rs5*rt - 224D0*rs6*rt + 
     -           8D0*rs7*rt + 8192D0*rt2 + 
     -           12288D0*rs*rt2 - 
     -           30208D0*rs2*rt2 + 
     -           7808D0*rs3*rt2 + 
     -           160D0*rs4*rt2 - 
     -           552D0*rs5*rt2 + 
     -           14D0*rs6*rt2 + 6D0*rs7*rt2 - 
     -           10240D0*rt3 - 11520D0*rs*rt3 + 
     -           7808D0*rs2*rt3 - 
     -           416D0*rs3*rt3 - 
     -           784D0*rs4*rt3 + 
     -           27D0*rs5*rt3 + 
     -           18D0*rs6*rt3 - 1024D0*rt4 + 
     -           1792D0*rs*rt4 + 
     -           160D0*rs2*rt4 - 
     -           784D0*rs3*rt4 + 
     -           10D0*rs4*rt4 + 
     -           30D0*rs5*rt4 - 128D0*rt5 + 
     -           272D0*rs*rt5 - 552D0*rs2*rt5 + 
     -           27D0*rs3*rt5 + 
     -           30D0*rs4*rt5 + 288D0*rt6 - 
     -           224D0*rs*rt6 + 14D0*rs2*rt6 + 
     -           18D0*rs3*rt6 - 64D0*rt7 + 
     -           8D0*rs*rt7 + 6D0*rs2*rt7)*
     -         logs(10)**2)/
     -       (512.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)*
     -         (-4D0 + rt)**2*rt*(4D0 + rt)*
     -         (-4D0 + rs + rt)*(rs + rt)**2) - 
     -      (logtwo*(-4D0*rs + rs2 - 4D0*rt + 
     -           rs*rt + rt2)*
     -         (32D0*rs2 - 8D0*rs3 + rs4 + 
     -           48D0*rs*rt - 20D0*rs2*rt + 
     -           2D0*rs3*rt + 32D0*rt2 - 
     -           20D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         logs(11))/
     -       (64.0D0*PI2*(-4D0 + rs)**2*(-4D0 + rt)**2*
     -         (rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-1024D0*rs3 + 768D0*rs4 - 
     -           320D0*rs5 + 80D0*rs6 - 
     -           12D0*rs7 + rs8 - 
     -           3072D0*rs2*rt + 3328D0*rs3*rt - 
     -           1728D0*rs4*rt + 464D0*rs5*rt - 
     -           68D0*rs6*rt + 5D0*rs7*rt - 
     -           3072D0*rs*rt2 + 
     -           4608D0*rs2*rt2 - 
     -           3200D0*rs3*rt2 + 
     -           1104D0*rs4*rt2 - 
     -           192D0*rs5*rt2 + 
     -           15D0*rs6*rt2 - 1024D0*rt3 + 
     -           3328D0*rs*rt3 - 
     -           3200D0*rs2*rt3 + 
     -           1408D0*rs3*rt3 - 
     -           304D0*rs4*rt3 + 
     -           28D0*rs5*rt3 + 768D0*rt4 - 
     -           1728D0*rs*rt4 + 
     -           1104D0*rs2*rt4 - 
     -           304D0*rs3*rt4 + 
     -           34D0*rs4*rt4 - 320D0*rt5 + 
     -           464D0*rs*rt5 - 192D0*rs2*rt5 + 
     -           28D0*rs3*rt5 + 80D0*rt6 - 
     -           68D0*rs*rt6 + 15D0*rs2*rt6 - 
     -           12D0*rt7 + 5D0*rs*rt7 + rt8)*
     -         logs(11))/
     -       (32.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**4) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -            rt2)**2*
     -         (256D0 - 128D0*rs + 48D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           96D0*rs*rt - 24D0*rs2*rt + 
     -           2D0*rs3*rt + 48D0*rt2 - 
     -           24D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         logs(1)*logs(11))/
     -       (32.0D0*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)*
     -         (rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (256D0 - 128D0*rs + 48D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           96D0*rs*rt - 24D0*rs2*rt + 
     -           2D0*rs3*rt + 48D0*rt2 - 
     -           24D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         logs(2)*logs(11))/
     -       (128.0D0*PI2*(-4D0 + rs)*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-2048D0*rs + 1536D0*rs2 - 
     -           640D0*rs3 + 160D0*rs4 - 
     -           20D0*rs5 + rs6 + 2048D0*rt - 
     -           512D0*rs*rt - 192D0*rs2*rt + 
     -           192D0*rs3*rt - 40D0*rs4*rt + 
     -           3D0*rs5*rt - 1024D0*rt2 + 
     -           448D0*rs*rt2 + 48D0*rs2*rt2 - 
     -           44D0*rs3*rt2 + 5D0*rs4*rt2 + 
     -           384D0*rt3 - 112D0*rs*rt3 - 
     -           16D0*rs2*rt3 + 5D0*rs3*rt3 - 
     -           64D0*rt4 + 4D0*rs*rt4 + 
     -           3D0*rs2*rt4 + 4D0*rt5 + 
     -           rs*rt5)*logs(3)*logs(11))/
     -       (128.0D0*PI2*(-4D0 + rs)**2*rs*(-4D0 + rt)*
     -         rt*(-8D0 + rs + rt)*(rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (2048D0*rs - 1024D0*rs2 + 
     -           384D0*rs3 - 64D0*rs4 + 4D0*rs5 - 
     -           2048D0*rt - 512D0*rs*rt + 
     -           448D0*rs2*rt - 112D0*rs3*rt + 
     -           4D0*rs4*rt + rs5*rt + 
     -           1536D0*rt2 - 192D0*rs*rt2 + 
     -           48D0*rs2*rt2 - 
     -           16D0*rs3*rt2 + 3D0*rs4*rt2 - 
     -           640D0*rt3 + 192D0*rs*rt3 - 
     -           44D0*rs2*rt3 + 5D0*rs3*rt3 + 
     -           160D0*rt4 - 40D0*rs*rt4 + 
     -           5D0*rs2*rt4 - 20D0*rt5 + 
     -           3D0*rs*rt5 + rt6)*logs(8)*
     -         logs(11))/
     -       (128.0D0*PI2*(-4D0 + rs)*rs*(-4D0 + rt)**2*
     -         rt*(-8D0 + rs + rt)*(rs + rt)**2) - 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (256D0 - 128D0*rs + 48D0*rs2 - 
     -           8D0*rs3 + rs4 - 128D0*rt + 
     -           96D0*rs*rt - 24D0*rs2*rt + 
     -           2D0*rs3*rt + 48D0*rt2 - 
     -           24D0*rs*rt2 + 3D0*rs2*rt2 - 
     -           8D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         logs(9)*logs(11))/
     -       (128.0D0*PI2*(-4D0 + rs)*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (256D0*rs - 128D0*rs2 + 48D0*rs3 - 
     -           8D0*rs4 + rs5 + 256D0*rt - 
     -           320D0*rs*rt + 176D0*rs2*rt - 
     -           36D0*rs3*rt + 3D0*rs4*rt - 
     -           128D0*rt2 + 176D0*rs*rt2 - 
     -           56D0*rs2*rt2 + 5D0*rs3*rt2 + 
     -           48D0*rt3 - 36D0*rs*rt3 + 
     -           5D0*rs2*rt3 - 8D0*rt4 + 
     -           3D0*rs*rt4 + rt5)*logs(11)**2)/
     -       (256.0D0*PI2*(-4D0 + rs)*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)**2) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (32768D0*rs - 36864D0*rs2 + 
     -           18432D0*rs3 - 5120D0*rs4 + 
     -           768D0*rs5 - 48D0*rs6 + 
     -           32768D0*rt - 57344D0*rs*rt + 
     -           40960D0*rs2*rt - 
     -           17536D0*rs3*rt + 4432D0*rs4*rt - 
     -           540D0*rs5*rt + 12D0*rs6*rt + 
     -           2D0*rs7*rt - 36864D0*rt2 + 
     -           40960D0*rs*rt2 - 
     -           22784D0*rs2*rt2 + 
     -           7920D0*rs3*rt2 - 
     -           1592D0*rs4*rt2 + 
     -           143D0*rs5*rt2 - 
     -           2D0*rs6*rt2 + 18432D0*rt3 - 
     -           17536D0*rs*rt3 + 
     -           7920D0*rs2*rt3 - 
     -           2008D0*rs3*rt3 + 
     -           273D0*rs4*rt3 - 
     -           14D0*rs5*rt3 - 5120D0*rt4 + 
     -           4432D0*rs*rt4 - 
     -           1592D0*rs2*rt4 + 
     -           273D0*rs3*rt4 - 
     -           20D0*rs4*rt4 + 768D0*rt5 - 
     -           540D0*rs*rt5 + 143D0*rs2*rt5 - 
     -           14D0*rs3*rt5 - 48D0*rt6 + 
     -           12D0*rs*rt6 - 2D0*rs2*rt6 + 
     -           2D0*rs*rt7)*
     -         (-4D0*MC2 + MC2*rs + MC2*rt - 
     -           DSQRT(MC4*
     -             (-4D0*rs + rs2 - 4D0*rt + 
     -               2D0*rs*rt + rt2)))*logs(12))/
     -       (144.0D0*MC2*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)**3*
     -         (rs + rt)**3) + 
     -      ((-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (32768D0*rs - 36864D0*rs2 + 
     -           18432D0*rs3 - 5120D0*rs4 + 
     -           768D0*rs5 - 48D0*rs6 + 
     -           32768D0*rt - 57344D0*rs*rt + 
     -           40960D0*rs2*rt - 
     -           17536D0*rs3*rt + 4432D0*rs4*rt - 
     -           540D0*rs5*rt + 12D0*rs6*rt + 
     -           2D0*rs7*rt - 36864D0*rt2 + 
     -           40960D0*rs*rt2 - 
     -           22784D0*rs2*rt2 + 
     -           7920D0*rs3*rt2 - 
     -           1592D0*rs4*rt2 + 
     -           143D0*rs5*rt2 - 
     -           2D0*rs6*rt2 + 18432D0*rt3 - 
     -           17536D0*rs*rt3 + 
     -           7920D0*rs2*rt3 - 
     -           2008D0*rs3*rt3 + 
     -           273D0*rs4*rt3 - 
     -           14D0*rs5*rt3 - 5120D0*rt4 + 
     -           4432D0*rs*rt4 - 
     -           1592D0*rs2*rt4 + 
     -           273D0*rs3*rt4 - 
     -           20D0*rs4*rt4 + 768D0*rt5 - 
     -           540D0*rs*rt5 + 143D0*rs2*rt5 - 
     -           14D0*rs3*rt5 - 48D0*rt6 + 
     -           12D0*rs*rt6 - 2D0*rs2*rt6 + 
     -           2D0*rs*rt7)*
     -         (-4D0*MC2 + MC2*rs + MC2*rt + 
     -           DSQRT(MC4*
     -             (-4D0*rs + rs2 - 4D0*rt + 
     -               2D0*rs*rt + rt2)))*logs(13))/
     -       (144.0D0*MC2*PI2*(-4D0 + rs)**2*rs*
     -         (-4D0 + rt)**2*rt*(-4D0 + rs + rt)**3*
     -         (rs + rt)**3) - 
     -      (const1*MC2*
     -         (12D0 + 3D0*rs + 4D0*rs2)*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*loopba(1))/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt)*
     -         (rs + rt)) + 
     -      (const1*MC2*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (88D0 - 35D0*rs + 4D0*rs2 - 35D0*rt + 
     -           8D0*rs*rt + 4D0*rt2)*loopba(2))/
     -       (PI4*(-4D0 + rs)*(-4D0 + rt)*
     -         (-4D0 + rs + rt)*(rs + rt)) - 
     -      (const1*MC2*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*(12D0 + 3D0*rt + 4D0*rt2)*
     -         loopba(3))/
     -       (PI4*(-4D0 + rs)*(-4D0 + rt)*rt*
     -         (rs + rt)) - 
     -      (const2*MC2*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (73728D0*rs - 163840D0*rs2 + 
     -           148992D0*rs3 - 55552D0*rs4 + 
     -           3680D0*rs5 + 2048D0*rs6 - 
     -           318D0*rs7 + rs8 - 65536D0*rt - 
     -           14336D0*rs*rt + 141824D0*rs2*rt - 
     -           134144D0*rs3*rt + 
     -           45888D0*rs4*rt - 3512D0*rs5*rt - 
     -           398D0*rs6*rt - 5D0*rs7*rt + 
     -           49152D0*rt2 + 2048D0*rs*rt2 - 
     -           63488D0*rs2*rt2 + 
     -           52480D0*rs3*rt2 - 
     -           12928D0*rs4*rt2 + 
     -           232D0*rs5*rt2 + 
     -           68D0*rs6*rt2 - 12288D0*rt3 - 
     -           3840D0*rs*rt3 + 
     -           12992D0*rs2*rt3 - 
     -           7408D0*rs3*rt3 + 
     -           548D0*rs4*rt3 + 
     -           142D0*rs5*rt3 + 1024D0*rt4 + 
     -           2048D0*rs*rt4 - 
     -           1664D0*rs2*rt4 + 
     -           416D0*rs3*rt4 + 
     -           60D0*rs4*rt4 - 256D0*rs*rt5 + 
     -           96D0*rs2*rt5)*loopba(4))/
     -       (PI4*(-4D0 + rs)**4*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)**2*(rs + rt)) - 
     -      (const1*MC2*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (32768D0*rs - 47104D0*rs2 + 
     -           28160D0*rs3 - 8704D0*rs4 + 
     -           1408D0*rs5 - 96D0*rs6 + 
     -           65536D0*rt - 120832D0*rs*rt + 
     -           88576D0*rs2*rt - 
     -           33344D0*rs3*rt + 6528D0*rs4*rt - 
     -           572D0*rs5*rt + 10D0*rs6*rt - 
     -           75776D0*rt2 + 98048D0*rs*rt2 - 
     -           50752D0*rs2*rt2 + 
     -           12736D0*rs3*rt2 - 
     -           1448D0*rs4*rt2 + 
     -           49D0*rs5*rt2 + 39680D0*rt3 - 
     -           38656D0*rs*rt3 + 
     -           14064D0*rs2*rt3 - 
     -           2188D0*rs3*rt3 + 
     -           115D0*rs4*rt3 - 12160D0*rt4 + 
     -           8752D0*rs*rt4 - 
     -           2096D0*rs2*rt4 + 
     -           165D0*rs3*rt4 + 2304D0*rt5 - 
     -           1132D0*rs*rt5 + 
     -           143D0*rs2*rt5 - 252D0*rt6 + 
     -           66D0*rs*rt6 + 12D0*rt7)*loopba(5)
     -         )/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)**4) - 
     -      (const1*MC2*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (1024D0*rs2 - 1024D0*rs3 + 
     -           448D0*rs4 - 96D0*rs5 + 8D0*rs6 + 
     -           4096D0*rs*rt - 1280D0*rs2*rt - 
     -           384D0*rs3*rt + 256D0*rs4*rt - 
     -           48D0*rs5*rt + 2D0*rs6*rt + 
     -           7168D0*rt2 - 8448D0*rs*rt2 + 
     -           1088D0*rs2*rt2 + 
     -           736D0*rs3*rt2 - 
     -           236D0*rs4*rt2 + 
     -           19D0*rs5*rt2 - 5632D0*rt3 + 
     -           4032D0*rs*rt3 - 
     -           224D0*rs2*rt3 - 
     -           220D0*rs3*rt3 + 
     -           32D0*rs4*rt3 + 1792D0*rt4 - 
     -           960D0*rs*rt4 + 80D0*rs2*rt4 + 
     -           10D0*rs3*rt4 - 352D0*rt5 + 
     -           172D0*rs*rt5 - 19D0*rs2*rt5 + 
     -           52D0*rt6 - 17D0*rs*rt6 - 4D0*rt7)
     -          *loopba(6))/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt)**3*rt*
     -         (-4D0 + rs + rt)**2*(rs + rt)) - 
     -      (const5*MC2*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (655360D0 - 1040384D0*rs + 
     -           897024D0*rs2 - 507392D0*rs3 + 
     -           170240D0*rs4 - 27168D0*rs5 + 
     -           944D0*rs6 + 94D0*rs7 + 7D0*rs8 - 
     -           442368D0*rt + 960512D0*rs*rt - 
     -           941568D0*rs2*rt + 
     -           513024D0*rs3*rt - 
     -           152320D0*rs4*rt + 
     -           21192D0*rs5*rt - 1222D0*rs6*rt + 
     -           69D0*rs7*rt + 204800D0*rt2 - 
     -           466944D0*rs*rt2 + 
     -           406528D0*rs2*rt2 - 
     -           184320D0*rs3*rt2 + 
     -           40928D0*rs4*rt2 - 
     -           3360D0*rs5*rt2 + 
     -           76D0*rs6*rt2 - 70656D0*rt3 + 
     -           125696D0*rs*rt3 - 
     -           83008D0*rs2*rt3 + 
     -           27184D0*rs3*rt3 - 
     -           3304D0*rs4*rt3 + 
     -           10D0*rs5*rt3 + 14336D0*rt4 - 
     -           19712D0*rs*rt4 + 
     -           9152D0*rs2*rt4 - 
     -           1808D0*rs3*rt4 + 
     -           36D0*rs4*rt4 - 1280D0*rt5 + 
     -           1408D0*rs*rt5 - 
     -           432D0*rs2*rt5 + 32D0*rs3*rt5)
     -          *loopba(7))/
     -       (PI4*(-4D0 + rs)**4*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)**2*(rs + rt)) + 
     -      (const6*MC2*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (65536D0 - 65536D0*rs + 24576D0*rs2 - 
     -           4096D0*rs3 + 512D0*rs4 - 
     -           256D0*rs5 + 96D0*rs6 - 
     -           16D0*rs7 + rs8 - 32768D0*rt + 
     -           12288D0*rs*rt + 5120D0*rs2*rt - 
     -           4096D0*rs3*rt + 1024D0*rs4*rt - 
     -           80D0*rs5*rt - 12D0*rs6*rt + 
     -           2D0*rs7*rt + 12288D0*rt2 + 
     -           1024D0*rs*rt2 - 
     -           4864D0*rs2*rt2 + 
     -           1920D0*rs3*rt2 - 
     -           304D0*rs4*rt2 + 
     -           4D0*rs5*rt2 + 3D0*rs6*rt2 - 
     -           2048D0*rt3 - 1536D0*rs*rt3 + 
     -           1280D0*rs2*rt3 - 
     -           320D0*rs3*rt3 + 
     -           24D0*rs4*rt3 + 2D0*rs5*rt3 + 
     -           256D0*rt4 + 256D0*rs*rt4 - 
     -           96D0*rs2*rt4 + 
     -           16D0*rs3*rt4 + rs4*rt4)*
     -         loopba(8))/
     -       (PI4*(-4D0 + rs)**4*(4D0 + rs)*(-4D0 + rt)*
     -         rt*(-4D0 + rs + rt)*(rs + rt)) - 
     -      (const7*MC2*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-32768D0*rs + 47104D0*rs2 - 
     -           27008D0*rs3 + 8272D0*rs4 - 
     -           1332D0*rs5 + 88D0*rs6 + 
     -           2D0*rs7 - 65536D0*rt + 
     -           120832D0*rs*rt - 85120D0*rs2*rt + 
     -           31616D0*rs3*rt - 6148D0*rs4*rt + 
     -           559D0*rs5*rt - 10D0*rs6*rt + 
     -           75776D0*rt2 - 94592D0*rs*rt2 + 
     -           48160D0*rs2*rt2 - 
     -           11976D0*rs3*rt2 + 
     -           1456D0*rs4*rt2 - 
     -           69D0*rs5*rt2 - 38528D0*rt3 + 
     -           36928D0*rs*rt3 - 
     -           13304D0*rs2*rt3 + 
     -           2214D0*rs3*rt3 - 
     -           161D0*rs4*rt3 + 11728D0*rt4 - 
     -           8372D0*rs*rt4 + 
     -           2104D0*rs2*rt4 - 
     -           211D0*rs3*rt4 - 2228D0*rt5 + 
     -           1119D0*rs*rt5 - 
     -           163D0*rs2*rt5 + 244D0*rt6 - 
     -           66D0*rs*rt6 - 10D0*rt7)*loopba(9)
     -         )/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)**4) - 
     -      (const6*MC2*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (512D0*rs4 - 256D0*rs5 + 
     -           96D0*rs6 - 16D0*rs7 + rs8 - 
     -           256D0*rs4*rt + 272D0*rs5*rt - 
     -           68D0*rs6*rt + 6D0*rs7*rt + 
     -           416D0*rs4*rt2 - 
     -           148D0*rs5*rt2 + 
     -           17D0*rs6*rt2 + 
     -           480D0*rs3*rt3 - 
     -           216D0*rs4*rt3 + 
     -           30D0*rs5*rt3 + 512D0*rt4 - 
     -           256D0*rs*rt4 + 416D0*rs2*rt4 - 
     -           216D0*rs3*rt4 + 
     -           36D0*rs4*rt4 - 256D0*rt5 + 
     -           272D0*rs*rt5 - 148D0*rs2*rt5 + 
     -           30D0*rs3*rt5 + 96D0*rt6 - 
     -           68D0*rs*rt6 + 17D0*rs2*rt6 - 
     -           16D0*rt7 + 6D0*rs*rt7 + rt8)*
     -         loopba(10))/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt)*rt*
     -         (-8D0 + rs + rt)*(rs + rt)**4) + 
     -      (const7*MC2*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (40960D0 - 31744D0*rs + 16896D0*rs2 - 
     -           6208D0*rs3 + 1408D0*rs4 - 
     -           176D0*rs5 + 8D0*rs6 - 50176D0*rt + 
     -           55296D0*rs*rt - 26368D0*rs2*rt + 
     -           5936D0*rs3*rt - 608D0*rs4*rt + 
     -           4D0*rs5*rt + 2D0*rs6*rt + 
     -           40448D0*rt2 - 45632D0*rs*rt2 + 
     -           16256D0*rs2*rt2 - 
     -           2060D0*rs3*rt2 + 
     -           16D0*rs4*rt2 + 
     -           11D0*rs5*rt2 - 19712D0*rt3 + 
     -           18416D0*rs*rt3 - 
     -           4672D0*rs2*rt3 + 
     -           317D0*rs3*rt3 + 
     -           8D0*rs4*rt3 + 5440D0*rt4 - 
     -           4016D0*rs*rt4 + 
     -           718D0*rs2*rt4 - 
     -           28D0*rs3*rt4 - 908D0*rt5 + 
     -           513D0*rs*rt5 - 55D0*rs2*rt5 + 
     -           100D0*rt6 - 33D0*rs*rt6 - 6D0*rt7
     -           )*loopba(11))/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt)**3*rt*
     -         (-4D0 + rs + rt)**2*(rs + rt)) + 
     -      (const6*MC2*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (65536D0 - 32768D0*rs + 12288D0*rs2 - 
     -           2048D0*rs3 + 256D0*rs4 - 
     -           65536D0*rt + 12288D0*rs*rt + 
     -           1024D0*rs2*rt - 1536D0*rs3*rt + 
     -           256D0*rs4*rt + 24576D0*rt2 + 
     -           5120D0*rs*rt2 - 
     -           4864D0*rs2*rt2 + 
     -           1280D0*rs3*rt2 - 
     -           96D0*rs4*rt2 - 4096D0*rt3 - 
     -           4096D0*rs*rt3 + 
     -           1920D0*rs2*rt3 - 
     -           320D0*rs3*rt3 + 
     -           16D0*rs4*rt3 + 512D0*rt4 + 
     -           1024D0*rs*rt4 - 
     -           304D0*rs2*rt4 + 
     -           24D0*rs3*rt4 + rs4*rt4 - 
     -           256D0*rt5 - 80D0*rs*rt5 + 
     -           4D0*rs2*rt5 + 2D0*rs3*rt5 + 
     -           96D0*rt6 - 12D0*rs*rt6 + 
     -           3D0*rs2*rt6 - 16D0*rt7 + 
     -           2D0*rs*rt7 + rt8)*loopba(12))/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt)**4*
     -         (4D0 + rt)*(-4D0 + rs + rt)*(rs + rt)) 
     -       - (const1*MC4*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-4096D0 + 4608D0*rs - 2048D0*rs2 + 
     -           480D0*rs3 - 48D0*rs4 + 4608D0*rt - 
     -           4352D0*rs*rt + 1632D0*rs2*rt - 
     -           272D0*rs3*rt + 16D0*rs4*rt - 
     -           2304D0*rt2 + 1600D0*rs*rt2 - 
     -           408D0*rs2*rt2 + 
     -           30D0*rs3*rt2 + rs4*rt2 + 
     -           512D0*rt3 - 256D0*rs*rt3 + 
     -           24D0*rs2*rt3 + 2D0*rs3*rt3 - 
     -           72D0*rt4 + 14D0*rs*rt4 + 
     -           rs2*rt4 + 4D0*rt5)*loopba(13)
     -         )/
     -       (PI4*(-4D0 + rs)**2*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)**2) - 
     -      (const1*MC4*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-16384D0 + 22528D0*rs - 10752D0*rs2 + 
     -           2048D0*rs3 - 96D0*rs4 - 
     -           24D0*rs5 + 4D0*rs6 + 14336D0*rt - 
     -           16384D0*rs*rt + 6144D0*rs2*rt - 
     -           832D0*rs3*rt + 10D0*rs5*rt - 
     -           5632D0*rt2 + 4736D0*rs*rt2 - 
     -           1152D0*rs2*rt2 + 
     -           56D0*rs3*rt2 + 
     -           10D0*rs4*rt2 - rs5*rt2 + 
     -           1152D0*rt3 - 576D0*rs*rt3 + 
     -           16D0*rs2*rt3 + 
     -           18D0*rs3*rt3 - rs4*rt3 - 
     -           96D0*rt4 + 18D0*rs2*rt4 - 
     -           2D0*rs3*rt4 + 4D0*rs*rt5 - 
     -           rs2*rt5)*loopba(14))/
     -       (PI4*(-4D0 + rs)**2*rs*(-4D0 + rt)**2*
     -         (-4D0 + rs + rt)**2*(rs + rt)) + 
     -      (const1*MC4*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (1024D0*rs - 896D0*rs2 + 160D0*rs3 - 
     -           16D0*rs4 + 1024D0*rt - 
     -           1536D0*rs*rt + 640D0*rs2*rt - 
     -           80D0*rs3*rt - 896D0*rt2 + 
     -           768D0*rs*rt2 - 192D0*rs2*rt2 + 
     -           6D0*rs3*rt2 + rs4*rt2 + 
     -           288D0*rt3 - 176D0*rs*rt3 + 
     -           18D0*rs2*rt3 + 2D0*rs3*rt3 - 
     -           48D0*rt4 + 16D0*rs*rt4 + 
     -           rs2*rt4)*loopba(15))/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt)**2*rt*
     -         (rs + rt)**2) - 
     -      (const2*MC4*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (8192D0 - 11776D0*rs + 5952D0*rs2 - 
     -           1952D0*rs3 + 364D0*rs4 - 
     -           32D0*rs5 + 2D0*rs6 - 9728D0*rt + 
     -           11136D0*rs*rt - 5920D0*rs2*rt + 
     -           1692D0*rs3*rt - 235D0*rs4*rt + 
     -           14D0*rs5*rt + 5184D0*rt2 - 
     -           5536D0*rs*rt2 + 
     -           2400D0*rs2*rt2 - 
     -           445D0*rs3*rt2 + 
     -           30D0*rs4*rt2 - 1696D0*rt3 + 
     -           1428D0*rs*rt3 - 
     -           371D0*rs2*rt3 + 
     -           30D0*rs3*rt3 + 324D0*rt4 - 
     -           155D0*rs*rt4 + 16D0*rs2*rt4 - 
     -           26D0*rt5 + 4D0*rs*rt5)*loopba(16)
     -         )/
     -       (PI4*(-4D0 + rs)**2*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)**2) - 
     -      (const2*MC4*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (8192D0*rs - 7168D0*rs2 + 
     -           2816D0*rs3 - 576D0*rs4 + 
     -           48D0*rs5 - 8192D0*rt + 
     -           6144D0*rs*rt - 832D0*rs2*rt - 
     -           544D0*rs3*rt + 212D0*rs4*rt - 
     -           30D0*rs5*rt + 2D0*rs6*rt + 
     -           5120D0*rt2 - 3648D0*rs*rt2 + 
     -           448D0*rs2*rt2 + 
     -           160D0*rs3*rt2 - 
     -           57D0*rs4*rt2 + 6D0*rs5*rt2 - 
     -           1536D0*rt3 + 352D0*rs*rt3 + 
     -           208D0*rs2*rt3 - 
     -           74D0*rs3*rt3 + 6D0*rs4*rt3 + 
     -           192D0*rt4 + 148D0*rs*rt4 - 
     -           89D0*rs2*rt4 + 
     -           10D0*rs3*rt4 - 26D0*rs*rt5 + 
     -           6D0*rs2*rt5)*loopba(17))/
     -       (PI4*(-4D0 + rs)**2*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)**2*(rs + rt)) + 
     -      (const2*MC4*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-2560D0*rs + 1088D0*rs2 - 
     -           160D0*rs3 + 12D0*rs4 - 
     -           16D0*rs5 + 2D0*rs6 - 2048D0*rt + 
     -           2368D0*rs*rt - 448D0*rs2*rt - 
     -           48D0*rs3*rt + 21D0*rs4*rt + 
     -           1280D0*rt2 - 672D0*rs*rt2 - 
     -           32D0*rs2*rt2 + 
     -           78D0*rs3*rt2 - 8D0*rs4*rt2 - 
     -           384D0*rt3 + 84D0*rs*rt3 + 
     -           59D0*rs2*rt3 - 
     -           10D0*rs3*rt3 + 48D0*rt4 + 
     -           18D0*rs*rt4 - 6D0*rs2*rt4 - 
     -           2D0*rs*rt5)*loopba(18))/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt)*rt*
     -         (-4D0 + rs + rt)*(rs + rt)**2) - 
     -      (const2*MC4*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (4096D0*rs - 2560D0*rs2 + 
     -           512D0*rs3 - 32D0*rs4 + 6656D0*rt - 
     -           6592D0*rs*rt + 2352D0*rs2*rt - 
     -           280D0*rs3*rt - 4672D0*rt2 + 
     -           3152D0*rs*rt2 - 
     -           648D0*rs2*rt2 + 
     -           6D0*rs3*rt2 + 4D0*rs4*rt2 + 
     -           1312D0*rt3 - 644D0*rs*rt3 + 
     -           15D0*rs2*rt3 + 
     -           10D0*rs3*rt3 - 204D0*rt4 + 
     -           35D0*rs*rt4 + 10D0*rs2*rt4 + 
     -           16D0*rt5 + 2D0*rs*rt5 - 2D0*rt6)*
     -         loopba(19))/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt)**2*rt*
     -         (rs + rt)**2) - 
     -      (const2*MC4*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-16384D0 + 9472D0*rs + 320D0*rs2 - 
     -           1200D0*rs3 + 300D0*rs4 - 
     -           26D0*rs5 + 7424D0*rt - 
     -           2624D0*rs*rt - 1024D0*rs2*rt + 
     -           596D0*rs3*rt - 97D0*rs4*rt + 
     -           4D0*rs5*rt - 384D0*rt2 - 
     -           544D0*rs*rt2 + 456D0*rs2*rt2 - 
     -           98D0*rs3*rt2 + 8D0*rs4*rt2 - 
     -           464D0*rt3 + 408D0*rs*rt3 - 
     -           97D0*rs2*rt3 + 6D0*rs3*rt3 + 
     -           120D0*rt4 - 70D0*rs*rt4 + 
     -           8D0*rs2*rt4 - 8D0*rt5 + 
     -           4D0*rs*rt5)*loopba(20))/
     -       (PI4*(-4D0 + rs)**2*(-4D0 + rt)**2*
     -         (-4D0 + rs + rt)**2*(rs + rt)) - 
     -      (const2*MC4*
     -         (-4D0*rs + rs2 - 4D0*rt + rs*rt + 
     -           rt2)*
     -         (-8192D0 + 9216D0*rs - 3072D0*rs2 + 
     -           448D0*rs3 - 32D0*rs4 + 6656D0*rt - 
     -           6336D0*rs*rt + 1120D0*rs2*rt + 
     -           20D0*rs3*rt - 18D0*rs4*rt - 
     -           2240D0*rt2 + 896D0*rs*rt2 + 
     -           304D0*rs2*rt2 - 
     -           105D0*rs3*rt2 + 
     -           6D0*rs4*rt2 - 32D0*rt3 + 
     -           400D0*rs*rt3 - 186D0*rs2*rt3 + 
     -           18D0*rs3*rt3 + 172D0*rt4 - 
     -           139D0*rs*rt4 + 22D0*rs2*rt4 - 
     -           32D0*rt5 + 12D0*rs*rt5 + 2D0*rt6)
     -          *loopba(21))/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt)**2*rt*
     -         (-4D0 + rs + rt)*(rs + rt))))/MC3
      return
      end

      subroutine gq_sloopmatrix(pborn, virt_wgts)
      use Func_PSI_2
      use pp_oniumjet_NLO_Global
      implicit none
      integer NDIM,NLOG,NLI
      parameter (NDIM=4)
      parameter (NLOG=9)
      parameter (NLI=15)
      double precision virt_wgts(3)
      double precision pborn(0:3,nexternal-1)
      double precision ponia(0:3)
      double precision shat,that
      double precision rs,rt,rmu
      double precision rs2,rs3,rs4
      double precision rt2,rt3,rt4,rt5,rt6,rt7
      double precision sumdot2
      double complex loopba(NDIM)
      double complex logs(NLOG)
      double complex li2s(NLI)
      integer i
      double complex const2,const3,const4
      ! i/1152
      parameter (const2=(0d0,8.680555555555555555555555555555555556d-4))
      ! i/648
      parameter (const3=(0d0,1.543209876543209876543209876543209877d-3))
      ! i/5184
      parameter (const4=(0d0,1.929012345679012345679012345679012346d-4))
      ponia(0:3)=pborn(0:3,3)+pborn(0:3,4)
      shat=sumdot2(pborn(0:3,1),pborn(0:3,2),1d0)
      that=sumdot2(pborn(0:3,1),ponia(0:3),-1d0)
      rmu=MUR**2/MC2
      rs=shat/MC2
      IF(stability_check.AND.stable_rsmax.GE.0d0
     $     .AND.rs.GT.stable_rsmax)THEN
         virt_wgts(1:3)=zero
         RETURN
      ENDIF
      rt=that/MC2
      rs2=rs**2
      rs3=rs2*rs
      rs4=rs3*rs
      rt2=rt**2
      rt3=rt2*rt
      rt4=rt3*rt
      rt5=rt4*rt
      rt6=rt5*rt
      rt7=rt6*rt
      logs(1)=log2(rmu)
      logs(2)=log2(rs)
      logs(3)=log2(-FOUR + rs)
      logs(4)=log2(DSQRT(FOUR - rt) - DSQRT(-rt))
      logs(5)=log2(DSQRT(FOUR - rt) + DSQRT(-rt))
      logs(6)=log2(FOUR - rt)
      logs(7)=log2(-rt)
      logs(8)=log2(rs + rt)
      logs(9)=log2(-FOUR + rs + rt)
      li2s(1)=li2((-FOUR + rs)/rs)
      li2s(2)=li2((rs - rt)/(-FOUR + rs))
      li2s(3)=li2((-FOUR + rt)/rt)
      li2s(4)=li2((-rs + rt)/(-FOUR + rt))
      li2s(5)=li2((rs + rt)/(-FOUR + rs + rt))
      li2s(6)=li2((rs - TWO)/(-FOUR + rs))
      li2s(7)=li2((rt - TWO)/(-FOUR + rt))
      li2s(8)=li2((rs + rt - TWO)/(rs + rt))
      li2s(9)=li2((rs - TWO)/TWO)
      li2s(10)=li2((rt - TWO)/TWO)
      li2s(11)=li2((-rs - rt + TWO)/TWO)
      li2s(12)=li2((-FOUR + rt + rs*TWO)/(-FOUR + rs))
      li2s(13)=li2((-FOUR + rt + rs*TWO)/(rs + rt))
      li2s(14)=li2((-FOUR + rs + rt*TWO)/(-FOUR + rt))
      li2s(15)=li2((-FOUR + rs + rt*TWO)/(rs + rt))
      call gq_loopbasis(MC,shat,that,MUR,loopba)
      virt_wgts(3)=        (17D0*G**8*LDME1S01*
     -    (2D0*rs2 + 2D0*rs*(-4D0 + rt) + 
     -      (-4D0 + rt)**2))/
     -  (1296.0D0*MC3*PI2*(-4D0 + rt)**2*rt)
      virt_wgts(2)=        -(G**8*LDME1S01*
     -     (176D0 + 32D0*rnlq + 184D0*rs - 16D0*rnlq*rs - 
     -       46D0*rs2 + 4D0*rnlq*rs2 - 88D0*rt - 
     -       16D0*rnlq*rt - 46D0*rs*rt + 4D0*rnlq*rs*rt + 
     -       11D0*rt2 + 2D0*rnlq*rt2 - 
     -       34D0*(2D0*rs2 + 2D0*rs*(-4D0 + rt) + 
     -          (-4D0 + rt)**2)*logs(1) + 
     -       18D0*(2D0*rs2 + 2D0*rs*(-4D0 + rt) + 
     -          (-4D0 + rt)**2)*logs(2) - 
     -       32D0*logs(7) + 16D0*rs*logs(7) - 
     -       4D0*rs2*logs(7) + 16D0*rt*logs(7) - 
     -       4D0*rs*rt*logs(7) - 2D0*rt2*logs(7) + 
     -       288D0*logs(9) - 144D0*rs*logs(9) + 
     -       36D0*rs2*logs(9) - 144D0*rt*logs(9) + 
     -       36D0*rs*rt*logs(9) + 18D0*rt2*logs(9)))
     -   /(2592.0D0*MC3*PI2*(-4D0 + rt)**2*rt)
      virt_wgts(1)=        (G**8*LDME1S01*
     -    (-(logtwo**2*
     -          (832D0 - 416D0*rs + 104D0*rs2 - 
     -            128D0*rt - 32D0*rs*rt + 
     -            34D0*rs2*rt - 52D0*rt2 + 
     -            34D0*rs*rt2 + 17D0*rt3))/
     -       (3456.0D0*PI2*(-4D0 + rt)**2*rt) + 
     -      (logtwo*(16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*
     -         (-256D0 + 256D0*rs - 64D0*rs2 + 
     -           320D0*rt - 256D0*rs*rt + 
     -           48D0*rs2*rt + 320D0*rt2 - 
     -           256D0*rs*rt2 + 76D0*rs2*rt2 - 
     -           772D0*rt3 + 492D0*rs*rt3 - 
     -           104D0*rs2*rt3 + 460D0*rt4 - 
     -           220D0*rs*rt4 + 29D0*rs2*rt4 - 
     -           97D0*rt5 + 29D0*rs*rt5 + 4D0*rt6)
     -         )/
     -       (648.0D0*PI2*(-2D0 + rs)*(-4D0 + rt)**3*
     -         (-2D0 + rt)**2*rt2*(-2D0 + rs + rt)) 
     -       - (-98304D0 + 49152D0*rs - 12288D0*rs2 + 
     -         1028096D0*rt - 65536D0*rnlq*rt + 
     -         115200D0*PI2*rt - 431104D0*rs*rt + 
     -         26624D0*rnlq*rs*rt - 
     -         57600D0*PI2*rs*rt + 
     -         104704D0*rs2*rt - 
     -         6656D0*rnlq*rs2*rt + 
     -         9984D0*PI2*rs2*rt - 978944D0*rt2 + 
     -         65536D0*rnlq*rt2 - 
     -         121088D0*PI2*rt2 + 
     -         311040D0*rs*rt2 - 
     -         19968D0*rnlq*rs*rt2 + 
     -         47680D0*PI2*rs*rt2 - 
     -         51584D0*rs2*rt2 + 
     -         3328D0*rnlq*rs2*rt2 - 
     -         5248D0*PI2*rs2*rt2 + 
     -         241664D0*rt3 - 16384D0*rnlq*rt3 + 
     -         25600D0*PI2*rt3 - 25408D0*rs*rt3 + 
     -         1664D0*rnlq*rs*rt3 - 
     -         3472D0*PI2*rs*rt3 - 
     -         6544D0*rs2*rt3 + 
     -         416D0*rnlq*rs2*rt3 - 
     -         288D0*PI2*rs2*rt3 + 
     -         30976D0*rt4 - 2048D0*rnlq*rt4 + 
     -         9664D0*PI2*rt4 - 19632D0*rs*rt4 + 
     -         1248D0*rnlq*rs*rt4 - 
     -         4596D0*PI2*rs*rt4 + 
     -         3272D0*rs2*rt4 - 
     -         208D0*rnlq*rs2*rt4 + 
     -         168D0*PI2*rs2*rt4 - 
     -         19120D0*rt5 + 1280D0*rnlq*rt5 - 
     -         3938D0*PI2*rt5 + 3272D0*rs*rt5 - 
     -         208D0*rnlq*rs*rt5 + 
     -         766D0*PI2*rs*rt5 + 
     -         20D0*PI2*rs2*rt5 + 1912D0*rt6 - 
     -         128D0*rnlq*rt6 + 301D0*PI2*rt6 + 
     -         20D0*PI2*rs*rt6 + 10D0*PI2*rt7)/
     -       (31104.0D0*PI2*(-4D0 + rt)**3*(-2D0 + rt)*
     -         rt2*(4D0 + rt)) + 
     -      ((16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*li2s(1))/
     -       (648.0D0*PI2*(-4D0 + rt)*rt) - 
     -      ((64D0 - 32D0*rs + 8D0*rs2 + 32D0*rt - 
     -           16D0*rs*rt + 2D0*rs2*rt - 
     -           8D0*rt2 + 2D0*rs*rt2 + rt3)*
     -         li2s(2))/
     -       (576.0D0*PI2*(-4D0 + rt)**2*(4D0 + rt)) + 
     -      ((16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*li2s(3))/
     -       (288.0D0*PI2*(-4D0 + rt)*rt) - 
     -      ((-128D0 + 64D0*rs + 32D0*rt + 8D0*rs2*rt + 
     -           24D0*rt2 - 12D0*rs*rt2 + 
     -           2D0*rs2*rt2 - 10D0*rt3 + 
     -           2D0*rs*rt3 + rt4)*li2s(4))/
     -       (576.0D0*PI2*(-4D0 + rt)**2*rt*(4D0 + rt)) 
     -       + ((16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*li2s(5))/
     -       (648.0D0*PI2*(-4D0 + rt)*rt) + 
     -      ((-368D0 + 184D0*rs - 32D0*rs2 + 328D0*rt - 
     -           114D0*rs*rt + 8D0*rs2*rt - 
     -           57D0*rt2 + 8D0*rs*rt2 + 4D0*rt3)*
     -         li2s(6))/
     -       (5184.0D0*PI2*(-4D0 + rt)**2*rt) + 
     -      ((4D0 + rt)*
     -         (16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*li2s(7))/
     -       (576.0D0*PI2*(-4D0 + rt)**2*rt) + 
     -      ((-144D0 + 72D0*rs - 32D0*rs2 + 72D0*rt - 
     -           14D0*rs*rt + 8D0*rs2*rt - 
     -           7D0*rt2 + 8D0*rs*rt2 + 4D0*rt3)*
     -         li2s(8))/
     -       (5184.0D0*PI2*(-4D0 + rt)**2*rt) + 
     -      ((80D0 - 40D0*rs - 112D0*rt + 46D0*rs*rt + 
     -           5D0*rt2)*li2s(9))/
     -       (5184.0D0*PI2*(-4D0 + rt)**2*rt) - 
     -      ((512D0 - 256D0*rs + 64D0*rs2 - 416D0*rt + 
     -           288D0*rs*rt - 56D0*rs2*rt + 
     -           256D0*rt2 - 92D0*rs*rt2 + 
     -           9D0*rs2*rt2 - 46D0*rt3 + 
     -           9D0*rs*rt3)*li2s(10))/
     -       (648.0D0*PI2*(-4D0 + rt)**3*rt*(4D0 + rt)) 
     -       - ((80D0 - 40D0*rs - 112D0*rt + 46D0*rs*rt + 
     -           41D0*rt2)*li2s(11))/
     -       (5184.0D0*PI2*(-4D0 + rt)**2*rt) + 
     -      ((2944D0 - 1472D0*rs + 256D0*rs2 - 
     -           1312D0*rt + 256D0*rs*rt + 
     -           72D0*rs2*rt + 88D0*rt2 + 
     -           20D0*rs*rt2 + 2D0*rs2*rt2 + 
     -           10D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         li2s(12))/
     -       (5184.0D0*PI2*(-4D0 + rt)**2*rt*(4D0 + rt)) 
     -       + ((1152D0 - 576D0*rs + 256D0*rs2 + 
     -           288D0*rt - 320D0*rs*rt + 
     -           72D0*rs2*rt - 376D0*rt2 + 
     -           108D0*rs*rt2 + 2D0*rs2*rt2 + 
     -           54D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         li2s(13))/
     -       (5184.0D0*PI2*(-4D0 + rt)**2*rt*(4D0 + rt)) 
     -       - ((128D0 - 64D0*rs + 96D0*rt - 64D0*rs*rt + 
     -           8D0*rs2*rt - 56D0*rt2 + 
     -           12D0*rs*rt2 + 2D0*rs2*rt2 + 
     -           2D0*rt3 + 2D0*rs*rt3 + rt4)*
     -         li2s(14))/
     -       (576.0D0*PI2*(-4D0 + rt)**2*rt*(4D0 + rt)) 
     -       - ((64D0 - 32D0*rs + 8D0*rs2 - 32D0*rt + 
     -           16D0*rs*rt + 2D0*rs2*rt + 
     -           8D0*rt2 + 2D0*rs*rt2 + rt3)*
     -         li2s(15))/
     -       (576.0D0*PI2*(-4D0 + rt)**2*(4D0 + rt)) + 
     -      ((-880D0 + 32D0*rnlq + 304D0*rs - 
     -           16D0*rnlq*rs - 76D0*rs2 + 
     -           4D0*rnlq*rs2 + 440D0*rt - 
     -           16D0*rnlq*rt - 76D0*rs*rt + 
     -           4D0*rnlq*rs*rt - 55D0*rt2 + 
     -           2D0*rnlq*rt2)*logs(1))/
     -       (1296.0D0*PI2*(-4D0 + rt)**2*rt) + 
     -      (17D0*(16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*logs(1)**2)/
     -       (2592.0D0*PI2*(-4D0 + rt)**2*rt) - 
     -      (logtwo*(20D0*rs2 + 36D0*rt - 
     -           16D0*rs*rt + 4D0*rs2*rt - 
     -           17D0*rt2 + 4D0*rs*rt2 + 2D0*rt3)*
     -         logs(2))/
     -       (1296.0D0*PI2*(-4D0 + rt)**2*rt) + 
     -      ((-576D0 + 288D0*rs - 72D0*rs2 + 
     -           9D0*rs3 + 352D0*rt - 124D0*rs*rt + 
     -           9D0*rs2*rt - 68D0*rt2 + 
     -           13D0*rs*rt2 + 4D0*rt3)*logs(2))/
     -       (648.0D0*PI2*(-4D0 + rs)*(-4D0 + rt)**2*rt) 
     -       - ((16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*logs(1)*logs(2))
     -        /(144.0D0*PI2*(-4D0 + rt)**2*rt) + 
     -      ((-8D0 + 4D0*rs + 4D0*rs2 - 5D0*rt + 
     -           4D0*rs*rt + 2D0*rt2)*logs(2)**2)/
     -       (5184.0D0*PI2*(-4D0 + rt)*rt) - 
     -      ((-1024D0*rs + 800D0*rs2 - 208D0*rs3 + 
     -           18D0*rs4 + 736D0*rt + 128D0*rs*rt - 
     -           228D0*rs2*rt + 34D0*rs3*rt - 
     -           496D0*rt2 + 128D0*rs*rt2 + 
     -           7D0*rs2*rt2 + 110D0*rt3 - 
     -           24D0*rs*rt3 - 8D0*rt4)*logs(3))/
     -       (1296.0D0*PI2*(-2D0 + rs)*(rs - rt)*
     -         (-4D0 + rt)**2*(-4D0 + 2D0*rs + rt)) + 
     -      (logtwo*(832D0 - 416D0*rs + 64D0*rs2 - 
     -           16D0*rt - 80D0*rs*rt + 48D0*rs2*rt + 
     -           148D0*rt2 - 58D0*rs*rt2 + 
     -           8D0*rs2*rt2 - 29D0*rt3 + 
     -           8D0*rs*rt3 + 4D0*rt4)*logs(3))/
     -       (1728.0D0*PI2*(-4D0 + rt)**2*rt*(4D0 + rt)) 
     -       - ((-320D0 + 160D0*rs - 32D0*rs2 + 
     -           464D0*rt - 176D0*rs*rt + 
     -           24D0*rs2*rt + 124D0*rt2 - 
     -           70D0*rs*rt2 + 8D0*rs2*rt2 - 
     -           35D0*rt3 + 8D0*rs*rt3 + 4D0*rt4)*
     -         logs(3)**2)/
     -       (3456.0D0*PI2*(-4D0 + rt)**2*rt*(4D0 + rt)) 
     -       - ((16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*
     -         (-8D0 - 2D0*rt + 13D0*rt2)*
     -         (MC2*rt + 
     -           DSQRT(MC4*(-4D0 + rt)*rt))*logs(4)
     -         )/
     -       (648.0D0*MC2*PI2*(-4D0 + rt)**3*rt3) 
     -       - ((16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*
     -         (-8D0 - 2D0*rt + 13D0*rt2)*
     -         (MC2*rt - 
     -           DSQRT(MC4*(-4D0 + rt)*rt))*logs(5)
     -         )/
     -       (648.0D0*MC2*PI2*(-4D0 + rt)**3*rt3) 
     -       + (logtwo*(4D0 + rt)*
     -         (16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*logs(6))/
     -       (192.0D0*PI2*(-4D0 + rt)**2*rt) - 
     -      ((8192D0*rs - 3840D0*rs2 + 896D0*rs3 - 
     -           112D0*rs4 - 5888D0*rt - 
     -           9472D0*rs*rt + 3008D0*rs2*rt - 
     -           352D0*rs3*rt + 16D0*rs4*rt + 
     -           8128D0*rt2 + 4544D0*rs*rt2 - 
     -           720D0*rs2*rt2 - 
     -           64D0*rs3*rt2 + 
     -           12D0*rs4*rt2 - 3984D0*rt3 - 
     -           1440D0*rs*rt3 + 
     -           112D0*rs2*rt3 + 
     -           24D0*rs3*rt3 + 788D0*rt4 + 
     -           336D0*rs*rt4 - 24D0*rs2*rt4 - 
     -           40D0*rt5 - 36D0*rs*rt5 - 3D0*rt6)
     -          *logs(6))/
     -       (1296.0D0*PI2*(rs - rt)*(-4D0 + rt)**3*
     -         (-2D0 + rt)**2*(-4D0 + rs + 2D0*rt)) + 
     -      ((8D0*rs2 + 16D0*rt - 8D0*rs*rt + 
     -           2D0*rs2*rt - 8D0*rt2 + 
     -           2D0*rs*rt2 + rt3)*logs(2)*
     -         logs(6))/(576.0D0*PI2*(-4D0 + rt)**2*rt)
     -        - ((192D0 - 96D0*rs + 16D0*rs2 - 
     -           80D0*rt + 16D0*rs*rt + 4D0*rs2*rt + 
     -           4D0*rt2 + 2D0*rs*rt2 + rt3)*
     -         logs(3)*logs(6))/
     -       (288.0D0*PI2*(-4D0 + rt)**2*rt*(4D0 + rt)) 
     -       - ((4D0 + 3D0*rt)*
     -         (16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*logs(6)**2)/
     -       (1152.0D0*PI2*(-4D0 + rt)**2*rt) - 
     -      (logtwo*(16D0 - 8D0*rs + 2D0*rs2 - 4D0*rt + 
     -           2D0*rs*rt + rt2)*logs(7))/
     -       (288.0D0*PI2*(-4D0 + rt)**2) - 
     -      ((-4864D0 + 512D0*rnlq + 2560D0*rs - 
     -           256D0*rnlq*rs - 640D0*rs2 + 
     -           64D0*rnlq*rs2 + 4864D0*rt - 
     -           512D0*rnlq*rt - 1920D0*rs*rt + 
     -           192D0*rnlq*rs*rt + 320D0*rs2*rt - 
     -           32D0*rnlq*rs2*rt - 2112D0*rt2 + 
     -           192D0*rnlq*rt2 + 624D0*rs*rt2 - 
     -           48D0*rnlq*rs*rt2 - 
     -           76D0*rs2*rt2 + 
     -           4D0*rnlq*rs2*rt2 + 448D0*rt3 - 
     -           32D0*rnlq*rt3 - 76D0*rs*rt3 + 
     -           4D0*rnlq*rs*rt3 - 37D0*rt4 + 
     -           2D0*rnlq*rt4)*logs(7))/
     -       (1296.0D0*PI2*(-4D0 + rt)**4*rt) + 
     -      ((16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*logs(1)*logs(7))
     -        /(1296.0D0*PI2*(-4D0 + rt)**2*rt) - 
     -      ((16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*logs(2)*logs(7))
     -        /(576.0D0*PI2*(-4D0 + rt)*rt) + 
     -      ((64D0 - 32D0*rs + 8D0*rs2 + 32D0*rt - 
     -           16D0*rs*rt + 2D0*rs2*rt - 
     -           8D0*rt2 + 2D0*rs*rt2 + rt3)*
     -         logs(3)*logs(7))/
     -       (576.0D0*PI2*(-4D0 + rt)**2*(4D0 + rt)) + 
     -      ((-1216D0 + 608D0*rs - 152D0*rs2 + 
     -           752D0*rt - 224D0*rs*rt + 
     -           18D0*rs2*rt - 184D0*rt2 + 
     -           18D0*rs*rt2 + 9D0*rt3)*logs(7)**2
     -         )/(10368.0D0*PI2*(-4D0 + rt)**2*rt) + 
     -      (logtwo*(192D0 - 96D0*rs + 64D0*rs2 + 
     -           336D0*rt - 176D0*rs*rt + 
     -           48D0*rs2*rt - 196D0*rt2 + 
     -           90D0*rs*rt2 + 8D0*rs2*rt2 + 
     -           45D0*rt3 + 8D0*rs*rt3 + 4D0*rt4)*
     -         logs(8))/
     -       (1728.0D0*PI2*(-4D0 + rt)**2*rt*(4D0 + rt)) 
     -       + ((32D0*rs2 - 80D0*rs3 + 18D0*rs4 - 
     -           224D0*rt + 128D0*rs*rt - 
     -           60D0*rs2*rt + 38D0*rs3*rt + 
     -           224D0*rt2 - 64D0*rs*rt2 + 
     -           13D0*rs2*rt2 - 70D0*rt3 + 
     -           8D0*rs*rt3 + 7D0*rt4)*logs(8))/
     -       (1296.0D0*PI2*(-4D0 + rt)**2*
     -         (-2D0 + rs + rt)*(-4D0 + 2D0*rs + rt)*
     -         (-4D0 + rs + 2D0*rt)) - 
     -      ((2D0*rs2 + 2D0*rs*rt + rt2)*logs(2)*
     -         logs(8))/(5184.0D0*PI2*(-4D0 + rt)*rt) 
     -       - ((64D0 - 32D0*rs + 16D0*rs2 + 16D0*rt - 
     -           16D0*rs*rt + 4D0*rs2*rt - 
     -           20D0*rt2 + 6D0*rs*rt2 + 3D0*rt3)*
     -         logs(6)*logs(8))/
     -       (288.0D0*PI2*(-4D0 + rt)**2*rt*(4D0 + rt)) 
     -       + ((64D0 - 32D0*rs + 8D0*rs2 - 32D0*rt + 
     -           16D0*rs*rt + 2D0*rs2*rt + 
     -           8D0*rt2 + 2D0*rs*rt2 + rt3)*
     -         logs(7)*logs(8))/
     -       (576.0D0*PI2*(-4D0 + rt)**2*(4D0 + rt)) - 
     -      ((-192D0 + 96D0*rs - 32D0*rs2 + 240D0*rt - 
     -           80D0*rs*rt + 24D0*rs2*rt - 
     -           76D0*rt2 + 54D0*rs*rt2 + 
     -           8D0*rs2*rt2 + 27D0*rt3 + 
     -           8D0*rs*rt3 + 4D0*rt4)*logs(8)**2)
     -        /(3456.0D0*PI2*(-4D0 + rt)**2*rt*
     -         (4D0 + rt)) - 
     -      (logtwo*(320D0 - 160D0*rs + 20D0*rs2 - 
     -           124D0*rt + 24D0*rs*rt + 4D0*rs2*rt + 
     -           3D0*rt2 + 4D0*rs*rt2 + 2D0*rt3)*
     -         logs(9))/
     -       (1296.0D0*PI2*(-4D0 + rt)**2*rt) + 
     -      ((144D0*rs - 36D0*rs2 + 9D0*rs3 + 
     -           144D0*rt - 124D0*rs*rt + 
     -           18D0*rs2*rt - 72D0*rt2 + 
     -           22D0*rs*rt2 + 9D0*rt3)*logs(9))/
     -       (648.0D0*PI2*(-4D0 + rt)**2*rt*(rs + rt)) 
     -       - ((16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*logs(1)*logs(9))
     -        /(144.0D0*PI2*(-4D0 + rt)**2*rt) + 
     -      ((16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*logs(2)*logs(9))
     -        /(5184.0D0*PI2*(-4D0 + rt)*rt) - 
     -      ((32D0 - 16D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*logs(3)*logs(9))
     -        /(5184.0D0*PI2*(-4D0 + rt)*rt) + 
     -      ((128D0 - 64D0*rs + 8D0*rs2 - 48D0*rt + 
     -           8D0*rs*rt + 2D0*rs2*rt + 
     -           2D0*rs*rt2 + rt3)*logs(6)*
     -         logs(9))/(576.0D0*PI2*(-4D0 + rt)**2*rt)
     -        - ((16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*logs(7)*logs(9))
     -        /(576.0D0*PI2*(-4D0 + rt)*rt) + 
     -      ((72D0 - 36D0*rs + 4D0*rs2 - 25D0*rt + 
     -           4D0*rs*rt + 2D0*rt2)*logs(9)**2)/
     -       (5184.0D0*PI2*(-4D0 + rt)*rt) + 
     -      (const4*MC2*
     -         (64D0*rs2 - 32D0*rs3 + 4D0*rs4 + 
     -           144D0*rt - 136D0*rs*rt + 
     -           9D0*rs2*rt + 4D0*rs3*rt - 
     -           32D0*rt2 + 16D0*rs*rt2 + 
     -           2D0*rs2*rt2)*loopba(1))/
     -       (PI4*(-4D0 + rs)*(-4D0 + rt)*rt) - 
     -      (const4*MC2*
     -         (64D0*rs2 - 32D0*rs3 + 4D0*rs4 - 
     -           39D0*rs2*rt + 12D0*rs3*rt - 
     -           14D0*rs*rt2 + 14D0*rs2*rt2 - 
     -           7D0*rt3 + 8D0*rs*rt3 + 2D0*rt4)*
     -         loopba(2))/
     -       (PI4*(-4D0 + rt)*rt*(rs + rt)) - 
     -      (const3*MC2*
     -         (-5D0 + 2D0*rt)*
     -         (16D0 - 8D0*rs + 2D0*rs2 - 8D0*rt + 
     -           2D0*rs*rt + rt2)*loopba(3))/
     -       (PI4*(-4D0 + rt)**2*rt) + 
     -      (const2*MC2*
     -         (4096D0 - 2048D0*rs + 512D0*rs2 + 
     -           1024D0*rt - 1536D0*rs*rt + 
     -           512D0*rs2*rt - 2304D0*rt2 + 
     -           1280D0*rs*rt2 - 
     -           192D0*rs2*rt2 + 896D0*rt3 - 
     -           320D0*rs*rt3 + 32D0*rs2*rt3 - 
     -           144D0*rt4 + 24D0*rs*rt4 + 
     -           2D0*rs2*rt4 + 4D0*rt5 + 
     -           2D0*rs*rt5 + rt6)*loopba(4))/
     -       (PI4*(-4D0 + rt)**4*(4D0 + rt))))/MC3
      return
      end

      subroutine qg_sloopmatrix(pborn, virt_wgts)
      use pp_oniumjet_NLO_Global
      implicit none
      double precision virt_wgts(3)
      double precision pborn(0:3,nexternal-1)
      double precision pborn2(0:3,nexternal-1)
      integer i,j
      do i=0,3
         pborn2(i,1)=pborn(i,2)
         pborn2(i,2)=pborn(i,1)
         do j=3,nexternal-1
            pborn2(i,j)=pborn(i,j)
         enddo
      enddo
      call gq_sloopmatrix(pborn2, virt_wgts)
      return
      end

      subroutine qq_sloopmatrix(pborn, virt_wgts)
      use Func_PSI_2
      use pp_oniumjet_NLO_Global
      implicit none
      integer NDIM,NLOG,NLI
      parameter (NDIM=5)
      parameter (NLOG=9)
      parameter (NLI=15)
      double precision virt_wgts(3)
      double precision pborn(0:3,nexternal-1)
      double precision ponia(0:3)
      double precision shat,that
      double precision rs,rt,rmu
      double precision rs2,rs3,rs4,rs5,rs6,rs7,rs8
      double precision rt2,rt3,rt4
      double precision sumdot2
      double complex loopba(NDIM)
      double complex logs(NLOG)
      double complex li2s(NLI)
      integer i
      double complex const1,const2,const3,const4
      ! i/486
      parameter (const1=(0d0,0.0020576131687242798353909465020576D0))
      ! i/972
      parameter (const2=(0d0,0.0010288065843621399176954732510288D0))
      ! i/432
      parameter (const3=(0d0,0.0023148148148148148148148148148148D0))
      ! i/1944
      parameter (const4=(0d0,5.1440329218106995884773662551440329D-4))
      ponia(0:3)=pborn(0:3,3)+pborn(0:3,4)
      shat=sumdot2(pborn(0:3,1),pborn(0:3,2),1d0)
      that=sumdot2(pborn(0:3,1),ponia(0:3),-1d0)
      rmu=MUR**2/MC2
      rs=shat/MC2
      IF(stability_check.AND.stable_rsmax.GE.0d0
     $     .AND.rs.GT.stable_rsmax)THEN
         virt_wgts(1:3)=zero
         RETURN
      ENDIF
      rt=that/MC2
      rs2=rs**2
      rs3=rs2*rs
      rs4=rs3*rs
      rs5=rs4*rs
      rs6=rs5*rs
      rs7=rs6*rs
      rs8=rs7*rs
      rt2=rt**2
      rt3=rt2*rt
      rt4=rt3*rt
      logs(1)=log2(rmu)
      logs(2)=log2(rs)
      logs(3)=log2(-FOUR + rs)
      logs(4)=log2(DSQRT(rs) - DSQRT(-FOUR + rs))
      logs(5)=log2(DSQRT(rs) + DSQRT(-FOUR + rs))
      logs(6)=log2(FOUR - rt)
      logs(7)=log2(-rt)
      logs(8)=log2(rs + rt)
      logs(9)=log2(-FOUR + rs + rt)
      li2s(1)=li2((-FOUR + rs)/rs)
      li2s(2)=li2((rs - rt)/(-FOUR + rs))
      li2s(3)=li2((-FOUR + rt)/rt)
      li2s(4)=li2((-rs + rt)/(-FOUR + rt))
      li2s(5)=li2((rs + rt)/(-FOUR + rs + rt))
      li2s(6)=li2((rs - TWO)/(-FOUR + rs))
      li2s(7)=li2((rt - TWO)/(-FOUR + rt))
      li2s(8)=li2((rs + rt - TWO)/(rs + rt))
      li2s(9)=li2((rs - TWO)/TWO)
      li2s(10)=li2((rt - TWO)/TWO)
      li2s(11)=li2((-rs - rt + TWO)/TWO)
      li2s(12)=li2((-FOUR + rt + rs*TWO)/(-FOUR + rs))
      li2s(13)=li2((-FOUR + rt + rs*TWO)/(rs + rt))
      li2s(14)=li2((-FOUR + rs + rt*TWO)/(-FOUR + rt))
      li2s(15)=li2((-FOUR + rs + rt*TWO)/(rs + rt))
      call qq_loopbasis(MC,shat,that,MUR,loopba)
      virt_wgts(3)=        (-17D0*G**8*LDME1S01*
     -    (rs2 + 2D0*rs*(-4D0 + rt) + 
     -      2D0*(8D0 - 4D0*rt + rt2)))/
     -  (486.0D0*MC3*PI2*(-4D0 + rs)**2*rs)
      virt_wgts(2)=        (G**8*LDME1S01*
     -    (720D0 + 32D0*rnlq - 360D0*rs - 16D0*rnlq*rs + 
     -      45D0*rs2 + 2D0*rnlq*rs2 - 88D0*rt - 
     -      16D0*rnlq*rt + 22D0*rs*rt + 4D0*rnlq*rs*rt + 
     -      22D0*rt2 + 4D0*rnlq*rt2 - 
     -      34D0*(rs2 + 2D0*rs*(-4D0 + rt) + 
     -         2D0*(8D0 - 4D0*rt + rt2))*logs(1) - 
     -      2D0*(rs2 + 2D0*rs*(-4D0 + rt) + 
     -         2D0*(8D0 - 4D0*rt + rt2))*logs(2) + 
     -      18D0*(rs2 + 2D0*rs*(-4D0 + rt) + 
     -         2D0*(8D0 - 4D0*rt + rt2))*logs(7) + 
     -      18D0*(rs2 + 2D0*rs*(-4D0 + rt) + 
     -         2D0*(8D0 - 4D0*rt + rt2))*logs(9)))/
     -  (972.0D0*MC3*PI2*(-4D0 + rs)**2*rs)
      virt_wgts(1)=        (G**8*LDME1S01*
     -    ((logtwo**2*
     -         (832D0 - 128D0*rs - 52D0*rs2 + 
     -           17D0*rs3 - 416D0*rt - 32D0*rs*rt + 
     -           34D0*rs2*rt + 104D0*rt2 + 
     -           34D0*rs*rt2))/
     -       (1296.0D0*PI2*(-4D0 + rs)**2*rs) - 
     -      (logtwo*(16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*
     -         (-256D0 + 320D0*rs + 320D0*rs2 - 
     -           772D0*rs3 + 460D0*rs4 - 
     -           97D0*rs5 + 4D0*rs6 + 256D0*rt - 
     -           256D0*rs*rt - 256D0*rs2*rt + 
     -           492D0*rs3*rt - 220D0*rs4*rt + 
     -           29D0*rs5*rt - 64D0*rt2 + 
     -           48D0*rs*rt2 + 76D0*rs2*rt2 - 
     -           104D0*rs3*rt2 + 29D0*rs4*rt2)
     -         )/
     -       (243.0D0*PI2*(-4D0 + rs)**3*(-2D0 + rs)**2*
     -         rs2*(-2D0 + rt)*(-2D0 + rs + rt)) - 
     -      (-98304D0 + 985088D0*rs - 77824D0*rnlq*rs - 
     -         86016D0*PI2*rs - 1151488D0*rs2 + 
     -         97280D0*rnlq*rs2 + 
     -         99072D0*PI2*rs2 + 452608D0*rs3 - 
     -         38912D0*rnlq*rs3 - 
     -         29952D0*PI2*rs3 - 27328D0*rs4 + 
     -         2432D0*rnlq*rs4 - 4688D0*PI2*rs4 - 
     -         25016D0*rs5 + 2128D0*rnlq*rs5 + 
     -         4040D0*PI2*rs5 + 6230D0*rs6 - 
     -         532D0*rnlq*rs6 - 612D0*PI2*rs6 - 
     -         445D0*rs7 + 38D0*rnlq*rs7 - 
     -         8D0*PI2*rs7 + 5D0*PI2*rs8 + 
     -         73728D0*rt - 754176D0*rs*rt + 
     -         52224D0*rnlq*rs*rt + 
     -         64512D0*PI2*rs*rt + 
     -         717312D0*rs2*rt - 
     -         52224D0*rnlq*rs2*rt - 
     -         55232D0*PI2*rs2*rt - 
     -         177024D0*rs3*rt + 
     -         13056D0*rnlq*rs3*rt + 
     -         5024D0*PI2*rs3*rt - 
     -         22704D0*rs4*rt + 
     -         1632D0*rnlq*rs4*rt + 
     -         6324D0*PI2*rs4*rt + 
     -         14010D0*rs5*rt - 
     -         1020D0*rnlq*rs5*rt - 
     -         1676D0*PI2*rs5*rt - 
     -         1401D0*rs6*rt + 102D0*rnlq*rs6*rt + 
     -         35D0*PI2*rs6*rt + 
     -         15D0*PI2*rs7*rt - 24576D0*rt2 + 
     -         250880D0*rs*rt2 - 
     -         16384D0*rnlq*rs*rt2 - 
     -         21504D0*PI2*rs*rt2 - 
     -         182016D0*rs2*rt2 + 
     -         12288D0*rnlq*rs2*rt2 + 
     -         12544D0*PI2*rs2*rt2 + 
     -         14912D0*rs3*rt2 - 
     -         1024D0*rnlq*rs3*rt2 + 
     -         1952D0*PI2*rs3*rt2 + 
     -         11472D0*rs4*rt2 - 
     -         768D0*rnlq*rs4*rt2 - 
     -         1752D0*PI2*rs4*rt2 - 
     -         1912D0*rs5*rt2 + 
     -         128D0*rnlq*rs5*rt2 + 
     -         124D0*PI2*rs5*rt2 + 
     -         20D0*PI2*rs6*rt2 + 3072D0*rt3 - 
     -         30592D0*rs*rt3 + 
     -         2048D0*rnlq*rs*rt3 + 
     -         2688D0*PI2*rs*rt3 + 
     -         15104D0*rs2*rt3 - 
     -         1024D0*rnlq*rs2*rt3 - 
     -         896D0*PI2*rs2*rt3 + 
     -         1912D0*rs3*rt3 - 
     -         128D0*rnlq*rs3*rt3 - 
     -         468D0*PI2*rs3*rt3 - 
     -         956D0*rs4*rt3 + 
     -         64D0*rnlq*rs4*rt3 + 
     -         102D0*PI2*rs4*rt3 + 
     -         10D0*PI2*rs5*rt3)/
     -       (2916.0D0*PI2*(-4D0 + rs)**3*(-2D0 + rs)*
     -         rs2*(4D0 + rs)*(-4D0 + rs + rt)) - 
     -      ((16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*li2s(1))/
     -       (108.0D0*PI2*(-4D0 + rs)*rs) + 
     -      ((-128D0 + 32D0*rs + 24D0*rs2 - 
     -           10D0*rs3 + rs4 + 64D0*rt - 
     -           12D0*rs2*rt + 2D0*rs3*rt + 
     -           8D0*rs*rt2 + 2D0*rs2*rt2)*
     -         li2s(2))/
     -       (216.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)) 
     -       - ((16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*li2s(3))/
     -       (243.0D0*PI2*(-4D0 + rs)*rs) + 
     -      ((64D0 + 32D0*rs - 8D0*rs2 + rs3 - 
     -           32D0*rt - 16D0*rs*rt + 2D0*rs2*rt + 
     -           8D0*rt2 + 2D0*rs*rt2)*li2s(4))/
     -       (216.0D0*PI2*(-4D0 + rs)**2*(4D0 + rs)) - 
     -      ((16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*li2s(5))/
     -       (243.0D0*PI2*(-4D0 + rs)*rs) - 
     -      ((4D0 + rs)*
     -         (16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*li2s(6))/
     -       (216.0D0*PI2*(-4D0 + rs)**2*rs) - 
     -      ((-368D0 + 328D0*rs - 57D0*rs2 + 
     -           4D0*rs3 + 184D0*rt - 114D0*rs*rt + 
     -           8D0*rs2*rt - 32D0*rt2 + 
     -           8D0*rs*rt2)*li2s(7))/
     -       (1944.0D0*PI2*(-4D0 + rs)**2*rs) - 
     -      ((-144D0 + 72D0*rs - 7D0*rs2 + 4D0*rs3 + 
     -           72D0*rt - 14D0*rs*rt + 8D0*rs2*rt - 
     -           32D0*rt2 + 8D0*rs*rt2)*li2s(8))/
     -       (1944.0D0*PI2*(-4D0 + rs)**2*rs) + 
     -      ((-4096D0 + 2944D0*rs - 2048D0*rs2 + 
     -           856D0*rs3 - 156D0*rs4 + 
     -           4D0*rs5 + 3072D0*rt - 2528D0*rs*rt + 
     -           1504D0*rs2*rt - 430D0*rs3*rt + 
     -           35D0*rs4*rt - 1024D0*rt2 + 
     -           768D0*rs*rt2 - 368D0*rs2*rt2 + 
     -           60D0*rs3*rt2 + 128D0*rt3 - 
     -           64D0*rs*rt3 + 30D0*rs2*rt3)*
     -         li2s(9))/
     -       (486.0D0*PI2*(-4D0 + rs)**3*rs*(4D0 + rs)*
     -         (-4D0 + rs + rt)) - 
     -      ((80D0 - 112D0*rs + 5D0*rs2 - 40D0*rt + 
     -           46D0*rs*rt)*li2s(10))/
     -       (1944.0D0*PI2*(-4D0 + rs)**2*rs) + 
     -      ((80D0 - 112D0*rs + 41D0*rs2 - 40D0*rt + 
     -           46D0*rs*rt)*li2s(11))/
     -       (1944.0D0*PI2*(-4D0 + rs)**2*rs) + 
     -      ((128D0 + 96D0*rs - 56D0*rs2 + 2D0*rs3 + 
     -           rs4 - 64D0*rt - 64D0*rs*rt + 
     -           12D0*rs2*rt + 2D0*rs3*rt + 
     -           8D0*rs*rt2 + 2D0*rs2*rt2)*
     -         li2s(12))/
     -       (216.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)) 
     -       + ((64D0 - 32D0*rs + 8D0*rs2 + rs3 - 
     -           32D0*rt + 16D0*rs*rt + 2D0*rs2*rt + 
     -           8D0*rt2 + 2D0*rs*rt2)*li2s(13))/
     -       (216.0D0*PI2*(-4D0 + rs)**2*(4D0 + rs)) - 
     -      ((2944D0 - 1312D0*rs + 88D0*rs2 + 
     -           10D0*rs3 + rs4 - 1472D0*rt + 
     -           256D0*rs*rt + 20D0*rs2*rt + 
     -           2D0*rs3*rt + 256D0*rt2 + 
     -           72D0*rs*rt2 + 2D0*rs2*rt2)*
     -         li2s(14))/
     -       (1944.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)) 
     -       - ((1152D0 + 288D0*rs - 376D0*rs2 + 
     -           54D0*rs3 + rs4 - 576D0*rt - 
     -           320D0*rs*rt + 108D0*rs2*rt + 
     -           2D0*rs3*rt + 256D0*rt2 + 
     -           72D0*rs*rt2 + 2D0*rs2*rt2)*
     -         li2s(15))/
     -       (1944.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)) 
     -       - ((-576D0 + 16D0*rnlq + 288D0*rs - 
     -           8D0*rnlq*rs - 36D0*rs2 + 
     -           rnlq*rs2 + 220D0*rt - 8D0*rnlq*rt - 
     -           55D0*rs*rt + 2D0*rnlq*rs*rt - 
     -           55D0*rt2 + 2D0*rnlq*rt2)*logs(1))/
     -       (243.0D0*PI2*(-4D0 + rs)**2*rs) - 
     -      (17D0*(16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(1)**2)/
     -       (972.0D0*PI2*(-4D0 + rs)**2*rs) + 
     -      (logtwo*(16D0 - 4D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(2))/
     -       (108.0D0*PI2*(-4D0 + rs)**2) + 
     -      ((-2304D0 + 256D0*rnlq + 2304D0*rs - 
     -           256D0*rnlq*rs - 1008D0*rs2 + 
     -           96D0*rnlq*rs2 + 216D0*rs3 - 
     -           16D0*rnlq*rs3 - 18D0*rs4 + 
     -           rnlq*rs4 + 1216D0*rt - 
     -           128D0*rnlq*rt - 912D0*rs*rt + 
     -           96D0*rnlq*rs*rt + 300D0*rs2*rt - 
     -           24D0*rnlq*rs2*rt - 37D0*rs3*rt + 
     -           2D0*rnlq*rs3*rt - 304D0*rt2 + 
     -           32D0*rnlq*rt2 + 152D0*rs*rt2 - 
     -           16D0*rnlq*rs*rt2 - 
     -           37D0*rs2*rt2 + 
     -           2D0*rnlq*rs2*rt2)*logs(2))/
     -       (243.0D0*PI2*(-4D0 + rs)**4*rs) - 
     -      ((16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(1)*
     -         logs(2))/(486.0D0*PI2*(-4D0 + rs)**2*rs)
     -        - ((-1216D0 + 752D0*rs - 184D0*rs2 + 
     -           9D0*rs3 + 608D0*rt - 224D0*rs*rt + 
     -           18D0*rs2*rt - 152D0*rt2 + 
     -           18D0*rs*rt2)*logs(2)**2)/
     -       (3888.0D0*PI2*(-4D0 + rs)**2*rs) - 
     -      (logtwo*(4D0 + rs)*
     -         (16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(3))/
     -       (72.0D0*PI2*(-4D0 + rs)**2*rs) + 
     -      ((5888D0*rs - 8128D0*rs2 + 3984D0*rs3 - 
     -           788D0*rs4 + 40D0*rs5 + 3D0*rs6 - 
     -           8192D0*rt + 9472D0*rs*rt - 
     -           4544D0*rs2*rt + 1440D0*rs3*rt - 
     -           336D0*rs4*rt + 36D0*rs5*rt + 
     -           3840D0*rt2 - 3008D0*rs*rt2 + 
     -           720D0*rs2*rt2 - 
     -           112D0*rs3*rt2 + 
     -           24D0*rs4*rt2 - 896D0*rt3 + 
     -           352D0*rs*rt3 + 64D0*rs2*rt3 - 
     -           24D0*rs3*rt3 + 112D0*rt4 - 
     -           16D0*rs*rt4 - 12D0*rs2*rt4)*
     -         logs(3))/
     -       (486.0D0*PI2*(-4D0 + rs)**3*(-2D0 + rs)**2*
     -         (rs - rt)*(-4D0 + 2D0*rs + rt)) + 
     -      ((4D0 + 3D0*rs)*
     -         (16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(3)**2)/
     -       (432.0D0*PI2*(-4D0 + rs)**2*rs) + 
     -      ((-8D0 - 2D0*rs + 13D0*rs2)*
     -         (MC2*rs - 
     -           DSQRT(MC4*(-4D0 + rs)*rs))*
     -         (16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(4))/
     -       (243.0D0*MC2*PI2*(-4D0 + rs)**3*rs3) 
     -       + ((-8D0 - 2D0*rs + 13D0*rs2)*
     -         (MC2*rs + 
     -           DSQRT(MC4*(-4D0 + rs)*rs))*
     -         (16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(5))/
     -       (243.0D0*MC2*PI2*(-4D0 + rs)**3*rs3) 
     -       - (logtwo*
     -         (832D0 - 16D0*rs + 148D0*rs2 - 
     -           29D0*rs3 + 4D0*rs4 - 416D0*rt - 
     -           80D0*rs*rt - 58D0*rs2*rt + 
     -           8D0*rs3*rt + 64D0*rt2 + 
     -           48D0*rs*rt2 + 8D0*rs2*rt2)*
     -         logs(6))/
     -       (648.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)) 
     -       + ((-736D0*rs + 496D0*rs2 - 
     -           110D0*rs3 + 8D0*rs4 + 1024D0*rt - 
     -           128D0*rs*rt - 128D0*rs2*rt + 
     -           24D0*rs3*rt - 800D0*rt2 + 
     -           228D0*rs*rt2 - 7D0*rs2*rt2 + 
     -           208D0*rt3 - 34D0*rs*rt3 - 
     -           18D0*rt4)*logs(6))/
     -       (486.0D0*PI2*(-4D0 + rs)**2*(rs - rt)*
     -         (-2D0 + rt)*(-4D0 + rs + 2*rt)) - 
     -      ((64D0 + 32D0*rs - 8D0*rs2 + rs3 - 
     -           32D0*rt - 16D0*rs*rt + 2D0*rs2*rt + 
     -           8D0*rt2 + 2D0*rs*rt2)*logs(2)*
     -         logs(6))/
     -       (216.0D0*PI2*(-4D0 + rs)**2*(4D0 + rs)) + 
     -      ((192D0 - 80D0*rs + 4D0*rs2 + rs3 - 
     -           96D0*rt + 16D0*rs*rt + 2D0*rs2*rt + 
     -           16D0*rt2 + 4D0*rs*rt2)*logs(3)*
     -         logs(6))/
     -       (108.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)) 
     -       + ((-320D0 + 464D0*rs + 124D0*rs2 - 
     -           35D0*rs3 + 4D0*rs4 + 160D0*rt - 
     -           176D0*rs*rt - 70D0*rs2*rt + 
     -           8D0*rs3*rt - 32D0*rt2 + 
     -           24D0*rs*rt2 + 8D0*rs2*rt2)*
     -         logs(6)**2)/
     -       (1296.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)) 
     -       + (logtwo*
     -         (36D0*rs - 17D0*rs2 + 2D0*rs3 - 
     -           16D0*rs*rt + 4D0*rs2*rt + 
     -           20D0*rt2 + 4D0*rs*rt2)*logs(7))/
     -       (486.0D0*PI2*(-4D0 + rs)**2*rs) - 
     -      ((-1728D0 + 992D0*rs - 172D0*rs2 + 
     -           8D0*rs3 + 1008D0*rt - 392D0*rs*rt + 
     -           35D0*rs2*rt - 288D0*rt2 + 
     -           36D0*rs*rt2 + 36D0*rt3)*logs(7))/
     -       (486.0D0*PI2*(-4D0 + rs)**2*rs*(-4D0 + rt)) 
     -       + ((16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(1)*
     -         logs(7))/(54.0D0*PI2*(-4D0 + rs)**2*rs) 
     -       + ((16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(2)*
     -         logs(7))/(216.0D0*PI2*(-4D0 + rs)*rs) - 
     -      ((16D0*rs - 8D0*rs2 + rs3 - 8D0*rs*rt + 
     -           2D0*rs2*rt + 8D0*rt2 + 2D0*rs*rt2
     -           )*logs(3)*logs(7))/
     -       (216.0D0*PI2*(-4D0 + rs)**2*rs) - 
     -      ((-8D0 - 5D0*rs + 2D0*rs2 + 4D0*rt + 
     -           4D0*rs*rt + 4D0*rt2)*logs(7)**2)/
     -       (1944.0D0*PI2*(-4D0 + rs)*rs) - 
     -      (logtwo*(192D0 + 336D0*rs - 196D0*rs2 + 
     -           45D0*rs3 + 4D0*rs4 - 96D0*rt - 
     -           176D0*rs*rt + 90D0*rs2*rt + 
     -           8D0*rs3*rt + 64D0*rt2 + 
     -           48D0*rs*rt2 + 8D0*rs2*rt2)*
     -         logs(8))/
     -       (648.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)) 
     -       - ((-224D0*rs + 224D0*rs2 - 70D0*rs3 + 
     -           7D0*rs4 + 128D0*rs*rt - 
     -           64D0*rs2*rt + 8D0*rs3*rt + 
     -           32D0*rt2 - 60D0*rs*rt2 + 
     -           13D0*rs2*rt2 - 80D0*rt3 + 
     -           38D0*rs*rt3 + 18D0*rt4)*logs(8))/
     -       (486.0D0*PI2*(-4D0 + rs)**2*
     -         (-2D0 + rs + rt)*(-4D0 + 2D0*rs + rt)*
     -         (-4D0 + rs + 2D0*rt)) - 
     -      ((64D0 - 32D0*rs + 8D0*rs2 + rs3 - 
     -           32D0*rt + 16D0*rs*rt + 2D0*rs2*rt + 
     -           8D0*rt2 + 2D0*rs*rt2)*logs(2)*
     -         logs(8))/
     -       (216.0D0*PI2*(-4D0 + rs)**2*(4D0 + rs)) + 
     -      ((64D0 + 16D0*rs - 20D0*rs2 + 3D0*rs3 - 
     -           32D0*rt - 16D0*rs*rt + 6D0*rs2*rt + 
     -           16D0*rt2 + 4D0*rs*rt2)*logs(3)*
     -         logs(8))/
     -       (108.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)) 
     -       + ((rs2 + 2D0*rs*rt + 2D0*rt2)*
     -         logs(7)*logs(8))/
     -       (1944.0D0*PI2*(-4D0 + rs)*rs) + 
     -      ((-192D0 + 240D0*rs - 76D0*rs2 + 
     -           27D0*rs3 + 4D0*rs4 + 96D0*rt - 
     -           80D0*rs*rt + 54D0*rs2*rt + 
     -           8D0*rs3*rt - 32D0*rt2 + 
     -           24D0*rs*rt2 + 8D0*rs2*rt2)*
     -         logs(8)**2)/
     -       (1296.0D0*PI2*(-4D0 + rs)**2*rs*(4D0 + rs)) 
     -       + (logtwo*
     -         (320D0 - 124D0*rs + 3D0*rs2 + 
     -           2D0*rs3 - 160D0*rt + 24D0*rs*rt + 
     -           4D0*rs2*rt + 20D0*rt2 + 
     -           4D0*rs*rt2)*logs(9))/
     -       (486.0D0*PI2*(-4D0 + rs)**2*rs) - 
     -      ((432D0*rs - 216D0*rs2 + 27D0*rs3 + 
     -           432D0*rt - 392D0*rs*rt + 
     -           71D0*rs2*rt - 144D0*rt2 + 
     -           72D0*rs*rt2 + 36D0*rt3)*logs(9))/
     -       (486.0D0*PI2*(-4D0 + rs)**2*rs*(rs + rt)) 
     -       + ((16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(1)*
     -         logs(9))/(54.0D0*PI2*(-4D0 + rs)**2*rs) 
     -       + ((16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(2)*
     -         logs(9))/(216.0D0*PI2*(-4D0 + rs)*rs) - 
     -      ((128D0 - 48D0*rs + rs3 - 64D0*rt + 
     -           8D0*rs*rt + 2D0*rs2*rt + 8D0*rt2 + 
     -           2D0*rs*rt2)*logs(3)*logs(9))/
     -       (216.0D0*PI2*(-4D0 + rs)**2*rs) + 
     -      ((32D0 - 8D0*rs + rs2 - 16D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(6)*
     -         logs(9))/(1944.0D0*PI2*(-4D0 + rs)*rs) 
     -       - ((16D0 - 8D0*rs + rs2 - 8D0*rt + 
     -           2D0*rs*rt + 2D0*rt2)*logs(7)*
     -         logs(9))/(1944.0D0*PI2*(-4D0 + rs)*rs) 
     -       - ((72D0 - 25D0*rs + 2D0*rs2 - 36D0*rt + 
     -           4D0*rs*rt + 4D0*rt2)*logs(9)**2)/
     -       (1944.0D0*PI2*(-4D0 + rs)*rs) - 
     -      (const1*MC2*
     -         (-352D0 + 296D0*rs - 80D0*rs2 + 
     -           4D0*rs3 + 280D0*rt - 150D0*rs*rt + 
     -           17D0*rs2*rt - 96D0*rt2 + 
     -           24D0*rs*rt2 + 12D0*rt3)*loopba(1)
     -         )/(PI4*(-4D0 + rs)**2*(-4D0 + rs + rt))
     -        + (const2*MC2*
     -         (1280D0 - 1824D0*rs + 920D0*rs2 - 
     -           196D0*rs3 + 12D0*rs4 - 960D0*rt + 
     -           1144D0*rs*rt - 402D0*rs2*rt + 
     -           41D0*rs3*rt + 320D0*rt2 - 
     -           304D0*rs*rt2 + 56D0*rs2*rt2 - 
     -           40D0*rt3 + 28D0*rs*rt3)*loopba(2)
     -         )/
     -       (PI4*(-4D0 + rs)**2*rs*(-4D0 + rs + rt)) 
     -       - (const3*MC2*
     -         (4096D0 + 1024D0*rs - 2304D0*rs2 + 
     -           896D0*rs3 - 144D0*rs4 + 
     -           4D0*rs5 + rs6 - 2048D0*rt - 
     -           1536D0*rs*rt + 1280D0*rs2*rt - 
     -           320D0*rs3*rt + 24D0*rs4*rt + 
     -           2D0*rs5*rt + 512D0*rt2 + 
     -           512D0*rs*rt2 - 192D0*rs2*rt2 + 
     -           32D0*rs3*rt2 + 2D0*rs4*rt2)*
     -         loopba(3))/
     -       (PI4*(-4D0 + rs)**4*(4D0 + rs)) + 
     -      (const4*MC2*
     -         (-7D0*rs3 + 2D0*rs4 - 
     -           14D0*rs2*rt + 8D0*rs3*rt + 
     -           64D0*rt2 - 39D0*rs*rt2 + 
     -           14D0*rs2*rt2 - 32D0*rt3 + 
     -           12D0*rs*rt3 + 4D0*rt4)*loopba(4))
     -        /(PI4*(-4D0 + rs)*rs*(rs + rt)) - 
     -      (const4*MC2*
     -         (144D0*rs - 32D0*rs2 - 136D0*rs*rt + 
     -           16D0*rs2*rt + 64D0*rt2 + 
     -           9D0*rs*rt2 + 2D0*rs2*rt2 - 
     -           32D0*rt3 + 4D0*rs*rt3 + 4D0*rt4)*
     -         loopba(5))/
     -       (PI4*(-4D0 + rs)*rs*(-4D0 + rt))))/MC3
      return
      end

      double precision function sumdot2(p1,p2,coef)
      implicit none
      double precision p1(0:3),p2(0:3)
      double precision psum(0:3)
      double precision coef
      integer i
      do i=0,3
      psum(i)=p1(i)+coef*p2(i)
      enddo
      sumdot2=psum(0)**2
      do i=1,3
      sumdot2=sumdot2-psum(i)**2
      enddo
      end
