MODULE pp_psipsipsi_DPS
  ! Keep in mind that it is
  ! DPS(3 onium)=SPS(2 onium)+SPS(1 onium)
  USE Helac_Global
  USE pp_psipsipsi_dps_global
  USE Helac_master
  USE Helac_Func_1
  USE Kinetic_Func
  USE MC_VEGAS
  USE Constants
  USE Decay_interface
  USE pp_psipsipsi_DPS_ME
  USE plot_pp_psipsipsi_dps
  USE pp_psipsipsi_DPS_DecayInfo
  USE DecayInfo
  USE Func_PSI
  USE Helac_SM_FeynRule
  USE Helac_histo
  USE setscale
  IMPLICIT NONE
  INTEGER::nprint
  INTEGER::varnum,nunwei
  INTEGER::lnum,snum
  LOGICAL::lunwei2
  REAL(KIND(1d0))::EBMUP1,EBMUP2
  INTEGER::NPRUP=0,lwmax
  INTEGER,PARAMETER::maxprint=8
  SAVE
CONTAINS
  SUBROUTINE calc_pp_psipsipsi_DPS
    IMPLICIT NONE
    CHARACTER(len=10),DIMENSION(20)::char
    INTEGER::i,i1,j1,k1,s1x
    INTEGER::nh,innum,outnum
    REAL(KIND(1d0))::w0,ptp,pqp,wme
    INTEGER::ioerror,icase=0
    LOGICAL::lunwei=.FALSE.,lhewgt=.FALSE.
    REAL(KIND(1d0)),DIMENSION(3)::rslt
    INTEGER::itmxn,ncalln
    REAL(KIND(1d0)),DIMENSION(4)::pmomtemp
    LOGICAL::lexist
    SAVE lunwei,lhewgt,icase
    WRITE(*,*)'                     THE BEGINNING OF HELAC-Onia'
    WRITE(*,*)'    AddOn Process: '
    WRITE(*,*)'    Double Patron Scattering for p p > psi(Upsilon) psi(Upsilon) psi(Upsilon) + X '
    WRITE(*,*)'======================================================================='
    WRITE(*,*)'======================================================================='
    WRITE(*,*)' '
    CALL ReadElem_integer('colpar',Coll_Type)
    IF(Coll_Type.LE.0.OR.Coll_Type.GT.2)THEN
       WRITE(*,*)"ERROR: Coll_Type is only allowed with either 1 or 2"
       STOP
    ENDIF
    CALL ReadElem_logic('unwgt',lunwei)
    CALL ReadElem_logic('lhewgtup',lhewgt)
    CALL ReadElem_logic('topdrawer_output',topdrawer_output)
    CALL ReadElem_logic('gnuplot_output',gnuplot_output)
    CALL ReadElem_logic('root_output',root_output)
    CALL ReadElem_logic('hwu_output',hwufile_output)
    plot_output=topdrawer_output.OR.gnuplot_output.OR.root_output.OR.hwufile_output
    CALL ReadElem_integer('literature',literature_cutoffs)
    CALL ReadElem_logic('fixtarget',fixtarget)
    IF(fixtarget.AND.Coll_Type.EQ.3)THEN
       WRITE(*,*)"ERROR: Cannot treat fixed-target experiment in e+e- collisions"
       STOP
    ENDIF
    IF(lunwei.AND.lhewgt)icase=1
    CALL ReadElem_logic("useMCFMrun",useMCFMrun)
    CALL ReadElem_logic('lhapdf',uselhapdf)
    INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdf_data",EXIST=lexist)
    IF(lexist)THEN
       OPEN(UNIT=30333,FILE=TRIM(input_dir)//"paths/lhapdf_data")
       READ(30333,'(A)')LHAPath
       CLOSE(UNIT=30333)
    ELSE
       INQUIRE(FILE=TRIM(input_dir)//"paths/lhapdfpath",EXIST=lexist)
       IF(lexist)THEN
          OPEN(UNIT=30333,FILE=TRIM(input_dir)//"paths/lhapdfpath")
          READ(30333,'(A)')LHAPath
          CLOSE(UNIT=30333)
          i=LEN_TRIM(LHAPath)
          LHAPath=LHAPath(1:i-13)
       ENDIF
    ENDIF
    uselhapdf=uselhapdf.AND.lexist
    WRITE(*,*)'Use LHAPDF ?',uselhapdf
    CALL ReadElem_logic("absoluterap",absrap)
    ! some necesarry initialization
    OPEN(UNIT=12321,FILE="./input/states.inp")
    READ(12321,*)dps_istate(1),dps_istate(2)
    CLOSE(UNIT=12321)
    IF((dps_istate(1).LT.1.OR.dps_istate(1).GT.8).OR.&
         (dps_istate(2).LT.1.OR.dps_istate(2).GT.5))THEN
       WRITE(*,*)"ERROR:Unknown the states = ",dps_istate(1),dps_istate(2)
       WRITE(*,*)"INFO:Please set first number: 1-4 [p p > cc~(3s11) cc~(3s11)+X] or 5-8[p p > bb~(3s11) bb~(3s11)+X] in states.inp"
       WRITE(*,*)"INFO:Please set second number: 1(J/psi) or 2(psi(2S)) or 3-4 (Y(1S-3S) in states.inp"
       STOP
    ENDIF
    DO i=1,1
       IF(dps_istate(i+1).EQ.1)THEN
          mpsi(i)=mjpsi
          OPEN(UNIT=12321,FILE="./input/crystalball_jpsi.inp")
          OPEN(UNIT=12322,FILE="./input/polarization_jpsi.inp")
       ELSEIF(dps_istate(i+1).EQ.2)THEN
          mpsi(i)=mpsi2s
          OPEN(UNIT=12321,FILE="./input/crystalball_psi2s.inp")
          OPEN(UNIT=12322,FILE="./input/polarization_psi2s.inp")
       ELSEIF(dps_istate(i+1).EQ.3)THEN
          mpsi(i)=mY1S
          OPEN(UNIT=12321,FILE="./input/crystalball_Y1S.inp")
          OPEN(UNIT=12322,FILE="./input/polarization_Y1S.inp")
       ELSEIF(dps_istate(i+1).EQ.4)THEN
          mpsi(i)=mY2S
          OPEN(UNIT=12321,FILE="./input/crystalball_Y2S.inp")
          OPEN(UNIT=12322,FILE="./input/polarization_Y2S.inp")
       ELSE
          mpsi(i)=mY3S
          OPEN(UNIT=12321,FILE="./input/crystalball_Y3S.inp")
          OPEN(UNIT=12322,FILE="./input/polarization_Y3S.inp")
       ENDIF
       READ(12321,*)dps_n(i),dps_ptavg(i),dps_kapa(i),dps_lam(i)
       READ(12322,*)dps_lambdath(i)
       CLOSE(UNIT=12321)
       CLOSE(UNIT=12322)
    ENDDO
    OPEN(UNIT=12321,FILE="./input/includeqq.inp")
    READ(12321,*)dps_includeqq
    CLOSE(UNIT=12321)
    OPEN(UNIT=12321,FILE="./input/integration.inp")
    READ(12321,*)integration_DPS
    CLOSE(UNIT=12321)
    OPEN(UNIT=12321,FILE="./input/sigma_eff.inp")
    READ(12321,*)dps_sigmaeff
    CLOSE(UNIT=12321)
    ! convert mb to nb
    dps_sigmaeff=dps_sigmaeff*1d6
    ! try to read the normal HELAC-Onia variables
    repeat=0
    CALL ReadElem_integer('ranhel',iranhel)
    WRITE(*,*)' '
    WRITE(*,*)'repeat value=  ',repeat,'  ranhel value=  ',iranhel
    CALL ReadElem_logic('exp3pjQ',exp3pjQ)
    CALL ReadElem_logic('OctetQ',octetQ)
    imode=0
    WRITE(*,*)' '
    WRITE(*,*)'modes=',imode
    CALL ReadElem_integer('gridpack',gridpack)
    reweight_pdf=.FALSE.
    reweight_npdf=.FALSE.
    reweight_ref=.FALSE.
    CALL ReadElem_logic('quarksumQ',qsumQ)
    WRITE(*,*)'Sum quark ?',qsumQ
    IF(qsumQ)THEN
       CALL ReadElem_integer('iqnum',iqnum)
       WRITE(*,*)'number of flavor in initial state:',iqnum
    ENDIF
    WRITE(*,*)' '
    WRITE(*,*)'------------------------------------------------------------------------'
    WRITE(*,*)' '
    IF(dps_istate(1).EQ.1)THEN
       ! g g > cc~(3s11) cc~(3s11)
       nhad=4
       iflh(1)=35
       iflh(2)=35
       iflh(3)=443011
       iflh(4)=443011
    ELSEIF(dps_istate(1).EQ.2)THEN
       ! g g > cc~(3s11) cc~(3s11) g
       nhad=5
       iflh(1)=35
       iflh(2)=35
       iflh(3)=443011
       iflh(4)=443011
       iflh(5)=35
    ELSEIF(dps_istate(1).EQ.3)THEN
       ! g q > cc~(3s11) cc~(3s11) q
       nhad=5
       iflh(1)=35
       iflh(2)=3
       iflh(3)=443011
       iflh(4)=443011
       iflh(5)=3
    ELSEIF(dps_istate(1).EQ.4)THEN
       ! q g > cc~(3s11) cc~(3s11) q
       nhad=5
       iflh(1)=3
       iflh(2)=35
       iflh(3)=443011
       iflh(4)=443011
       iflh(5)=3
    ELSEIF(dps_istate(1).EQ.5)THEN
       ! g g > bb~(3s11) bb~(3s11)
       nhad=4
       iflh(1)=35
       iflh(2)=35
       iflh(3)=553011
       iflh(4)=553011
    ELSEIF(dps_istate(1).EQ.6)THEN
       ! g g > bb~(3s11) bb~(3s11) g
       nhad=5
       iflh(1)=35
       iflh(2)=35
       iflh(3)=553011
       iflh(4)=553011
       iflh(5)=35
    ELSEIF(dps_istate(1).EQ.7)THEN
       ! g q > bb~(3s11) bb~(3s11) q
       nhad=5
       iflh(1)=35
       iflh(2)=3
       iflh(3)=553011
       iflh(4)=553011
       iflh(5)=3
    ELSEIF(dps_istate(1).EQ.8)THEN
       ! q g > bb~(3s11) bb~(3s11) q
       nhad=5
       iflh(1)=3
       iflh(2)=35
       iflh(3)=553011
       iflh(4)=553011
       iflh(5)=3
    ENDIF
    WRITE(*,*)(iflh(i),i=1,nhad)
    INCLUDE 'iflh_to_ifl.inc'
    WRITE(*,*)' '
    WRITE(*,*)'The SPS(2 onium) process at the parton level is'
    WRITE(*,*)(ifl(i),i=1,n)
    WRITE(*,*)' '
    ! end of read the normal HELAC-Onia variables
    iflh_dps(1)=iflh(1)
    iflh_dps(2)=iflh(2)
    iflh_dps(3)=35
    iflh_dps(4)=35
    DO i=3,nhad
       iflh_dps(2+i)=iflh(i)
    ENDDO
    IF(dps_istate(2).LE.2)THEN
       iflh_dps(5+(nhad-2))=443011
    ELSE
       iflh_dps(5+(nhad-2))=553011
    ENDIF
    iflh_dps(6+(nhad-2))=35
    nhad_dps=nhad+4
    CALL pp_psipsipsi_DPS_ReadDecayInfo
    CALL ReadDecayInfo
    ! start of read the normal HELAC-Onia variables 2
    MCoHelicity=.FALSE.
    IF(iranhel.EQ.4)THEN
       iranhel=0
       MCoHelicity=.TRUE.
    ELSEIF(NDecayChains_DPS.GT.0)THEN
       WRITE(*,*)"WARNING:You are not setting iranhel = 4 when you want to decay final state"
       WRITE(*,*)"WARNING:It will use the zero polarized decay !"
    ENDIF
    IF(exp3pjQ.AND.Num3pj.GE.1.AND.iranhel.GE.2)THEN
       PRINT *,"Please set ranhel < 2 !"
       STOP
    ELSEIF(QN3S1F(Quarkonium(1,1)).AND.imode.EQ.1.AND.iranhel.GE.3)THEN
       PRINT *,"Please set ranhel < 3 !"
       STOP
    ELSEIF(QN1P1F(Quarkonium(1,1)).AND.imode.EQ.1.AND.iranhel.GE.2)THEN
       PRINT *,"Please set ranhel < 2 !"
       STOP
    ELSEIF(QN3PJF(Quarkonium(1,1)).AND.imode.EQ.1.AND.iLSJ.EQ.0.AND.iranhel.GE.2)THEN
       PRINT *,"Please set ranhel < 2 !"
       STOP
    ELSEIF(QN3PJF(Quarkonium(1,1)).AND.imode.EQ.1.AND.iLSJ.EQ.1.AND.iranhel.GE.3)THEN
       PRINT *,"Please set ranhel < 3 !"
       STOP
    ELSEIF(QN1S0F(Quarkonium(1,1)).AND.imode.EQ.1)THEN
       IF(ihel1.NE.0.OR.ihel2.NE.0)THEN
          PRINT *,"Please set SDME1=0 and SDME2=0 !"
          STOP
       ENDIF
       imode=0
    ENDIF
    WRITE(*,*)'-------------------------------------------------------------------------'
    WRITE(*,*)' '
    WRITE(*,*)' FLAGS '
    WRITE(*,*)' '
    WRITE(*,*)'iflag: 0 sum over all the helicity confs, 1 choose the specific helicity conf '
    CALL ReadElem_integer('iflag',iflag)
    WRITE(*,*)'iflag value = ', iflag
    WRITE(*,*)' '
    WRITE(*,*)"iunitary: 1 use unitary gauge, 0 use 't Hooft-Feynman gauge "
    CALL ReadElem_integer('gauge',iunitary)
    WRITE(*,*)'iunitary value = ',iunitary
    WRITE(*,*)' '
    WRITE(*,*)'ihiggs: include(1) or not(0) the higgs as an intermediate state '
    CALL ReadElem_integer('ihiggs',ihiggs)
    WRITE(*,*)'ihiggs value = ',ihiggs
    WRITE(*,*)' '
    WRITE(*,*)'iwidth: use(1) or not(0) the complex mass scheme for W and Z '
    CALL ReadElem_integer('widsch',iwidth)
    WRITE(*,*)'iwidth value = ',iwidth
    CALL Helac_FeynRule_SM()    ! choose the feynman rules
    IF(reweight_scale)THEN
       tot_nrwgt=tot_nrwgt+ho_nscale+1
    ENDIF
    IF(reweight_scale)THEN
       IF(ALLOCATED(rwgt_values))THEN
          DEALLOCATE(rwgt_values)
       ENDIF
       ALLOCATE(rwgt_values(tot_nrwgt))
    ENDIF
    DO i=1,n
       IF(i.LE.2)THEN
          io(i)=1 ! the first two are incoming particles
       ELSE
          io(i)=-1 ! the rest are outgoing particles
       ENDIF
    ENDDO
    DO i=1,nhad
       IF(i.LE.2)THEN
          ioh(i)=1 ! the first two are incoming particles
       ELSE
          ioh(i)=-1 ! the rest are outgoing particles
       ENDIF
    ENDDO
    INCLUDE 'getLDMEs.inc'
    WRITE(process,*)(TRIM(char(i)),i=1,nhad)
    WRITE(*,*)' '
    WRITE(*,*)'The SPS(2 onium) process we are calculating is: ',TRIM(process(2:10*nhad+1))
    WRITE(*,*)' '
    ! end of read the normal HELAC-Onia variables 2
    IF(nunit1.NE.6)THEN
       OPEN(UNIT=nunit1,FILE=TRIM(output_dir)//"RESULT_pp_psipsipsi_dps.out")
    ENDIF
    nunit2=32
    CLOSE(nunit2)
    OPEN(nunit2,FILE=TRIM(output_dir)//'kine_pp_psipsipsi_dps.out')
    nunit3=30
    CLOSE(nunit3)
    OPEN(nunit3,FILE=TRIM(tmp_dir)//'even_pp_psipsipsi_dps.out',FORM='unformatted')
    nunit30=300
    CLOSE(nunit30)
    OPEN(nunit30,FILE=TRIM(tmp_dir)//'even_rwgt_pp_psipsipsi_dps.out',FORM='unformatted')
    ! for LHA
    CLOSE(200)
    OPEN(200,FILE=TRIM(tmp_dir)//'sample_pp_psipsipsi_dps.init')
    IF(integration_DPS.EQ.1)THEN
       ! for integration_DPS to be 1
       CLOSE(700)
       OPEN(700,FILE=TRIM(tmp_dir)//'sample_pp_psiX_cb_dps.init')
       CLOSE(701)
       OPEN(701,FILE=TRIM(tmp_dir)//'even_pp_psiX_cb_dps.out',FORM='unformatted')
    ENDIF
    ! Scale scheme
    CALL ReadElem_integer('Scale',nscheme)
    CALL ReadElem_real('FScaleValue',fschemevalue)
    CALL ReadELem_real('ScaleFactor',scalefactor)
    CALL ReadElem_real('muR_over_ref',muR_over_ref)
    CALL ReadElem_real('muF_over_ref',muF_over_ref)
    IF(repeat.EQ.0)THEN
       WRITE(*,*)' '
       CALL Helac_mtime()
       WRITE(*,*)' '
       GLOBALINIT_average=0
       GLOBALINIT_checkgluons=0
       GLOBALINIT_id=0
       GLOBALINIT_id2=0
       GLOBALINIT_id3=0
       GLOBALINIT_redo=0
       CALL Helac_init()
    ENDIF
    nh=0
    WRITE(16,*)ifl(1:n)
    DO i=1,nh
       CALL Helac_histo3(i)
    ENDDO
    CALL Helac_histo3(199)
    gener=3
    ! start of phase space integration
    CALL ReadElem_integer("itmax",itmxn)
    CALL ReadElem_integer("nmc",ncalln)
    IF(integration_DPS.EQ.1)THEN
       CALL pp_psiX_CB_VEGAS(rslt,1,10000000)
       CLOSE(700)
       CLOSE(701)
       CALL Get_unweightevents_pp_psiX_cb_DPS(4,Nevents,icase)
    ENDIF
    WRITE(*,*)' '
    CALL Helac_mtime()
    WRITE(*,*)' '
    CALL pp_psipsipsi_DPS_VEGAS(rslt,itmxn,ncalln)
    WRITE(nunit1,*)"sigma(nb)                   sd"
    WRITE(nunit1,*)rslt(1),rslt(2)
    WRITE(*,*)' '
    CALL Helac_mtime()
    CLOSE(nunit2)
    CLOSE(nunit3)
    CLOSE(21)
    CLOSE(200)
    IF(lunwei)CALL Generate_lhe_pp_psipsipsi_dps(nhad,Nevents,icase)
  END SUBROUTINE calc_pp_psipsipsi_DPS

  SUBROUTINE pp_psiX_CB_VEGAS(rslt,itmxn,ncalln)
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(3),INTENT(OUT)::rslt
    INTEGER,INTENT(IN),OPTIONAL::itmxn,ncalln
    REAL(KIND(1d0))::vfes,sd,chi2a
    INTEGER::ncalm,nc,ii
    CHARACTER(len=4),DIMENSION(20)::chchar
    INTEGER::iday0,ihr0,imin0,isec0,i100th0,iday1,ihr1,imin1,isec1,i100th1,iyr0,iyr1,imon0,imon1
    INTEGER::IDBMUP1,IDBMUP2,IDWTUP
    INCLUDE "../../../src/RANDA_init.inc"
    lwmax=0
    NPRN=-1
    varnum=3
    varnum=varnum+1
    DO ii=1,varnum
       XL(ii)=0.0d0
       XU(ii)=1.0d0
    ENDDO
    IF(PRESENT(itmxn))THEN
       ITMX=itmxn
    ELSE
       ITMX=5
    ENDIF
    ITMX=1
    IF(PRESENT(ncalln))THEN
       ncalm=ncalln
    ELSE
       ncalm=5000
    ENDIF
    chchar(1)="40K"
    chchar(2)="80K"
    chchar(3)="160K"
    chchar(4)="320K"
    chchar(5)="640K"
    chchar(6)="1M"
    chchar(7)="2M"
    chchar(8)="4M"
    chchar(9)="8M"
    chchar(10)="16M"
    chchar(11)='32M'
    chchar(12)='64M'
    chchar(13)='120M'
    chchar(14)='240M'
    chchar(15)='480M'
    chchar(16)='960M'
    chchar(17)='2G'
    chchar(18)='4G'
    chchar(19)='8G'
    chchar(20)='16G'
    nprint=10000
    NCALL=20000
    CALL VEGAS(varnum,pp_psiX_cb_VEGAS_fxn,vfes,sd,chi2a)
    DO ii=2,10
       CALL VEGAS(varnum,pp_psiX_cb_VEGAS_fxn,vfes,sd,chi2a,1)
    ENDDO
    ii=1
    DO
       nc=2*NCALL
       IF(nc.GT.ncalm)EXIT
       IF(2*nc.GT.ncalm.AND.lwmax.EQ.0)THEN
          lwmax=1
       ENDIF
       NCALL=nc
       IF(NCALL/maxprint.GT.nprint)nprint=NCALL/maxprint
       CALL VEGAS(varnum,pp_psiX_cb_VEGAS_fxn,vfes,sd,chi2a,1)
       ii=ii+1
    ENDDO
    IF(lwmax.EQ.1)THEN
       lwmax=2
       NCALL=nc/2
       CALL VEGAS(varnum,pp_psiX_cb_VEGAS_fxn,vfes,sd,chi2a,1)
       WRITE(*,*)"Preintegration on second partonic scattering:"
       WRITE(*,*)vfes,"+\-",sd
       WRITE(*,*)"precision:",sd/vfes
    ENDIF
    SELECT CASE(COLL_TYPE)
    CASE(1)
       IDBMUP1=2212
       IDBMUP2=2212
    CASE(2)
       IDBMUP1=2212
       IDBMUP2=-2212
    CASE DEFAULT
       IDBMUP1=11
       IDBMUP2=-11
    END SELECT
    IDWTUP=3
    NPRUP=NPRUP+1
    WRITE(700,7100) IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,&
         iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
    WRITE(700,7200) vfes*10d0**3,sd*10d0**3,1d0, 820
    rslt(1)=vfes
    rslt(2)=sd
    rslt(3)=chi2a
    PRINT *,"number of events for second partonic scattering is",Nevents
    RETURN
7100 FORMAT(1P,2I8,2E14.6,6I8)
7200 FORMAT(1P,3E20.10,I6)
  END SUBROUTINE pp_psiX_CB_VEGAS

  FUNCTION pp_psiX_cb_VEGAS_fxn(x,wgt)
      REAL(KIND(1d0)),DIMENSION(varnum),INTENT(IN)::x
      REAL(KIND(1d0)),INTENT(IN)::wgt
      REAL(KIND(1d0))::pp_psiX_cb_VEGAS_fxn
      REAL(KIND(1d0))::y1,y2,phi,w1
      REAL(KIND(1d0)),DIMENSION(4)::pmom
      REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
      INTEGER::init=0,nwarn,nwmax,nwri,nwri_tot,icut,nnn=0,nnntot=0,&
           pdfnumpdf,ivarnum
      SAVE init,nwarn,nwmax,nwri,nwri_tot,nnn,nnntot,pdfnumpdf,ivarnum
      REAL(KIND(1d0))::sqs,sq,pt1c,maxpt1c,y1cup,y1clow,ycollcm,ycollcm_save,mt1,mt2,pt
      SAVE sqs,sq,pt1c,maxpt1c,y1cup,y1clow,ycollcm,ycollcm_save
      REAL(KIND(1d0))::wdps,wsf,wme,wgtbr,temp1,temp2,temp21,temp3,temp4
      REAL(KIND(1d0))::exp1,exp2,Jpt2,Jy1,Jy2,xp11,xp21,scale1,scale2
      REAL(KIND(1d0))::recmax=0,recmin=0
      SAVE temp1
      REAL(KIND(1d0))::sqrtsmin,sqrtsmax,sqs_prob,Jsqs,EpEp,DY1,DY2
      REAL(KIND(1d0))::sqrtsmin_save,sqrtsmax_save
      SAVE sqrtsmin_save,sqrtsmax_save
      INTEGER::ioffset,j
      IF(init.EQ.0)THEN
         wjac=1
         nwmax=0
         nwarn=0
         nwri=0
         CALL ReadElem_integer('unwevt',nwri_tot)
         CALL ReadElem_real('energy_beam1',sqs)
         ebeam(1)=ABS(sqs)
         CALL ReadElem_real('energy_beam2',sqs)
         ebeam(2)=ABS(sqs)
         IF(ABS(ebeam(1)-ebeam(2))/MAX(ebeam(1)+ebeam(2),1d-17).LT.1d-8)THEN
            absrap=absrap
            labeqcoll=.TRUE.
         ELSE
            absrap=.FALSE.
            labeqcoll=.FALSE.
         ENDIF
         sqs=2d0*DSQRT(ebeam(1)*ebeam(2)) ! we always neglect the mass of initial states
         IF(fixtarget)sqs=sqs/DSQRT(2d0)
         EBMUP1=ebeam(1)
         EBMUP2=ebeam(2)
         IF(.NOT.fixtarget)THEN
            ycollcm=DLOG(ABS(ebeam(1))/ABS(ebeam(2)))/2d0
         ELSE
            IF(ABS(ebeam(1)).GT.ABS(ebeam(2)))THEN
               fixtargetrev=.FALSE.
               ycollcm=DLOG(1d0+2d0*ABS(ebeam(1))/ABS(ebeam(2)))/2d0
               FT_M=ebeam(2)
               FT_E1=ebeam(1)
               sqs=DSQRT(sqs**2+FT_M**2)
            ELSE
               fixtargetrev=.TRUE.
               ycollcm=-DLOG(1d0+2d0*ABS(ebeam(2))/ABS(ebeam(1)))/2d0
               FT_M=ebeam(1)
               FT_E1=ebeam(2)
               sqs=DSQRT(sqs**2+FT_M**2)
            ENDIF
         ENDIF
         IF(fixtarget)THEN
            ! for fixed target, I used the fake lab frame (note it is not the true lab frame of fixed target but close to)
            IF(.NOT.fixtargetrev)THEN
               ! beam1 = (beam(1)+FT_M/2,0,0,beam(1)+FT_M/2)
               ! beam2 = (FT_M/2,0,0,-FT_M/2), FT_M=beam(2)
               EBMUP1=ebeam(1)+FT_M/2d0
               EBMUP2=ebeam(2)/2d0
            ELSE
               ! beam1 = (FT_M/2,0,0,FT_M/2),FT_M=beam(1)
               ! beam2 = (beam(2)+FT_M/2,0,0,-beam(2)-FT_M/2)
               EBMUP1=ebeam(1)/2d0
               EBMUP2=ebeam(2)+FT_M/2d0
            ENDIF
         ENDIF
         ycollcm_save=ycollcm
         CALL ReadElem_real('minpt1c',pt1c)
         CALL ReadElem_real('maxpt1c',maxpt1c)
         IF(maxpt1c.LT.0d0)THEN
            maxpt1c=-1d0
         ELSE
            IF(maxpt1c.LE.pt1c)THEN
               WRITE(*,*)"ERROR: the first final state was cut off by a pt cut ( pt1c, maxpt1c )"
               STOP
            ENDIF
         ENDIF
         CALL ReadElem_real('maxy1c',y1cup)
         CALL ReadElem_real('miny1c',y1clow)
         CALL ReadElem_integer('pdf',pdfnumpdf)
         IF(pdfnumpdf.EQ.921000)THEN
            WRITE(*,*)"ERROR: GS09 dPDF is not allowed to use when integration mode = 1"
            STOP
         ENDIF
         ptc(3:20)=0
         maxptc(3:20)=-1d0
         drc(3:20,3:20)=0
         etac(3:20)=20
         ec(3:20)=0
         c1(3:20)=1
         c2(3:20)=1
         cc(3:20,3:20)=1
         yycut(3:20)=1d9
         IF(absrap)THEN
            yycutlow(3:20)=0d0
         ELSE
            yycutlow(3:20)=-1d9
         ENDIF
         xFcut(3:20)=1d0
         xFcutlow(3:20)=-1d0
         gmas(3:20,3:20)=0
         gbeammass(1:2,3:20)=0
         parmas(0)=0
         parwid(0)=-1
         iPDFSUP1=pdfnumpdf
         IF(pdfnumpdf.EQ.0.OR.COLL_TYPE.EQ.3)THEN
            istruc=0
         ELSE
            istruc=1
         ENDIF
         IF(istruc.EQ.1)THEN
            iPDFGUP1=0
            iPDFGUP2=0
            iPDFSUP1=pdfnumpdf
            iPDFSUP2=pdfnumpdf
         ELSE
            iPDFGUP1=-1
            iPDFGUP2=-1
            iPDFSUP1=-1
            iPDFSUP2=-1
            reweight_pdf=.FALSE.
            reweight_npdf=.FALSE.
            reweight_ref=.FALSE.
            ho_npdf=0
            ho_nnpdf=0
            ho_nref=0
         ENDIF
         xp1=1
         xp2=1
         IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
            CALL readcuts_pp_psiX_cb_DPS
            y1cup=MIN(y1cup,yycut(3))
            y1clow=MAX(y1clow,yycutlow(3))
            IF(absrap)y1cup=ABS(y1cup)
            IF(absrap)y1clow=ABS(y1clow)
         ENDIF
         sq=sqs*sqs
         temp1=(sq-mpsi(1)**2)/(2d0*sqs)
         IF(maxpt1c.GE.0d0)THEN
            temp1=MIN(temp1,maxpt1c)
         ENDIF
         ivarnum=3
         ivarnum=ivarnum+1
         init=1
      ENDIF
      nnntot=nnntot+1
      wdps=1d0
      ioffset=0
      pt=(temp1-pt1c)*x(3+ioffset)+pt1c
      mt1=DSQRT(pt**2+mpsi(1)**2)
      mt2=pt
      IF(absrap)THEN
         temp2=MIN(ACosh_p((sq+mpsi(1)**2)/(2d0*sqs*mt1)),y1cup)
         IF(temp2.LT.y1clow)THEN
            pp_psiX_cb_VEGAS_fxn=0d0
            RETURN
         ENDIF
         y1=(2d0*x(1+ioffset)-1d0)*(temp2-y1clow)+SIGN(1d0,x(1+ioffset)-0.5d0)*y1clow
      ELSE
         temp2=MIN(ACosh_p((sq+mpsi(1)**2)/(2d0*sqs*mt1)),y1cup-ycollcm)
         temp21=MAX(-ACosh_p((sq+mpsi(1)**2)/(2d0*sqs*mt1)),y1clow-ycollcm)
         IF(temp2.LT.temp21)THEN
            pp_psiX_cb_VEGAS_fxn=0d0
            RETURN
         ENDIF
         y1=(temp2-temp21)*x(1+ioffset)+temp21 ! in collision frame
      ENDIF
      temp3=DLOG((-DEXP(-y1)*mt1+sqs)/mt2)
      temp4=temp3+DLOG((-DEXP(y1)*mt1+sqs)/mt2)
      y2=-temp3+temp4*x(2+ioffset) ! in collision frame                                                                    
      Jpt2=2d0*pt*(temp1-pt1c)
      IF(absrap)THEN
         Jy1=2d0*(temp2-y1clow)
      ELSE
         Jy1=temp2-temp21
      ENDIF
      Jy2=temp4
      IF(ycollcm.EQ.0d0)THEN
         xp1=(DEXP(y1)*mt1+DEXP(y2)*mt2)/sqs
         xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/sqs
      ELSE
         IF(.NOT.fixtarget)THEN
            xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2)/(2d0*ebeam(1))
            xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/(2d0*ebeam(2))
         ELSE
            IF(.NOT.fixtargetrev)THEN
               xp1=(DSINH(y1)*mt1 + DSINH(y2)*mt2)/(ebeam(1))
               xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/(ebeam(2))
            ELSE
               xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2)/(ebeam(1))
               xp2=(DSINH(-y1)*mt1+DSINH(-y2)*mt2)/(ebeam(2))
            ENDIF
         ENDIF
      ENDIF
      IF(xp1.GT.1d0.OR.xp1.LT.0d0)THEN
         WRITE(*,*)"ERROR: 0<xp1<1"
         STOP
      ENDIF
      IF(xp2.GT.1d0.OR.xp2.LT.0d0)THEN
         WRITE(*,*)"ERROR: 0<xp2<1"
         STOP
      ENDIF
      ehat=DSQRT(xp1*xp2*sq)
      wdps=wdps*xp1*xp2*Jpt2*Jy1*Jy2*3.8937966d5/(16d0*pi*ehat**4)
      exp1=xp1*ebeam(1)
      exp2=xp2*ebeam(2)
      IF(fixtarget)THEN
         IF(.NOT.fixtargetrev)THEN
            exp1=exp1+FT_M*xp1/2d0
            exp2=exp2/2d0
         ELSE
            exp1=exp1/2d0
            exp2=exp2+FT_M*xp2/2d0
         ENDIF
      ENDIF
      ! Generate the momenta of external legs
      cb_pmom(1,1:2)=0
      cb_pmom(1,3)=xp1*sqs/2d0
      cb_pmom(1,4)=xp1*sqs/2d0
      cb_pmom(2,1:2)=0
      cb_pmom(2,3)=-xp2*sqs/2d0
      cb_pmom(2,4)=xp2*sqs/2d0
      phi=2*pi*x(4+ioffset)
      cb_pmom(3,1)=pt*DCOS(phi)
      cb_pmom(3,2)=pt*DSIN(phi)
      cb_pmom(3,3)=mt1*DSINH(y1)
      cb_pmom(3,4)=mt1*DCOSH(y1)
      cb_pmom(4,1)=-pt*DCOS(phi)
      cb_pmom(4,2)=-pt*DSIN(phi)
      cb_pmom(4,3)=mt2*DSINH(y2)
      cb_pmom(4,4)=mt2*DCOSH(y2)
      Momenta_Frame=1
      ! boost from collision frame to lab frame
      IF(.NOT.fixtarget)THEN
         pmom(3)=ebeam(1)-ebeam(2)
         pmom(4)=ebeam(1)+ebeam(2)
      ELSE
         IF(.NOT.fixtargetrev)THEN
            pmom(3)=ebeam(1)
            pmom(4)=ebeam(1)+ebeam(2)
         ELSE
            pmom(3)=-ebeam(2)
            pmom(4)=ebeam(1)+ebeam(2)
         ENDIF
      ENDIF
      pmom(1:2)=0
      IF(.NOT.labeqcoll)THEN
         DO j=1,4
            CALL Boostl(sqs,pmom,cb_pmom(j,1:4))
         ENDDO
      ENDIF
      CALL strf_pdf_pp_psiX_cb_DPS(wsf)
      wdps=wdps*wsf
      IF(wdps.LE.0d0)THEN
         pp_psiX_cb_VEGAS_fxn=0d0
         RETURN
      ENDIF
      CALL pp_psiX_cb_DPS_hadronmom
      icut=1
      CALL Cuts_pp_psiX_cb_DPS(icut)
      IF(icut.EQ.0)THEN
         pp_psiX_cb_VEGAS_fxn=0d0
         RETURN
      ENDIF
      CALL crystalball_gg_psiX(0,wme)
      wdps=wdps*wme
      IF(wdps.LE.0d0)THEN
         pp_psiX_cb_VEGAS_fxn=0d0
         RETURN
      ENDIF
      pp_psiX_cb_VEGAS_fxn=wdps
      IF(lwmax.GT.0)THEN
         w1=pp_psiX_cb_VEGAS_fxn*wgt ! multiply VEGAS weight                                                                     
         CALL unwei_procedure_pp_psiX_cb_DPS(w1,nwri,nwmax,nwarn)
      ENDIF
      nnn=nnn+1
    END FUNCTION pp_psiX_cb_VEGAS_fxn

  SUBROUTINE pp_psipsipsi_DPS_VEGAS(rslt,itmxn,ncalln)
    IMPLICIT NONE
    REAL(KIND(1d0)),DIMENSION(3),INTENT(OUT)::rslt
    INTEGER,INTENT(IN),OPTIONAL::itmxn,ncalln
    REAL(KIND(1d0))::vfes,sd,chi2a
    INTEGER::ncalm,nc,ii,varnum2
    CHARACTER(len=4),DIMENSION(20)::chchar
    INTEGER::iday0,ihr0,imin0,isec0,i100th0,iday1,ihr1,imin1,isec1,i100th1,iyr0,iyr1,imon0,imon1
    INTEGER::IDBMUP1,IDBMUP2,IDWTUP
    LOGICAL::ptQ
    INTEGER::ND_check,NDIM_check
    LOGICAL::lexist
    INCLUDE "../../../src/RANDA_init.inc"
    ptQ=.FALSE.
    CALL ReadElem_logic('unwgt',lunwei2)
    CALL ReadElem_integer('preunw',nunwei)
    lwmax=0
    NPRN=-1
    varnum2=3
    IF(lunwei2.OR..TRUE.)varnum2=varnum2+1
    IF(.NOT.MCoHelicity)THEN
       IF(iranhel.EQ.0)THEN
          varnum=3*(nhad-3)
          IF(lunwei2.OR..TRUE.)varnum=varnum+1
          lnum=0
          snum=0
       ELSEIF(iranhel.EQ.1)THEN
          varnum=3*(nhad-3)
          IF(lunwei2.OR..TRUE.)varnum=varnum+1
          lnum=0
          snum=0
          DO ii=1,nhad
             IF(ABS(iflh(ii)).LT.40)THEN
                varnum=varnum+1
                lnum=lnum+1
             ENDIF
          ENDDO
       ELSEIF(iranhel.EQ.2)THEN
          varnum=3*(nhad-3)
          IF(lunwei2.OR..TRUE.)varnum=varnum+1
          lnum=0
          snum=0
          DO ii=1,nhad
             IF(ABS(iflh(ii)).LT.40)THEN
                varnum=varnum+1
                lnum=lnum+1
             ENDIF
             IF(QN1P1F(ii).OR.QN3PJF(ii))THEN
                varnum=varnum+1
                lnum=lnum+1
             ENDIF
          ENDDO
       ELSEIF(iranhel.EQ.3)THEN
          varnum=3*(nhad-3)
          IF(lunwei2.OR..TRUE.)varnum=varnum+1
          DO ii=1,nhad
             IF(ABS(iflh(ii)).LT.40)THEN
                varnum=varnum+1
                lnum=lnum+1
             ENDIF
             IF(QN1P1F(ii))THEN
                varnum=varnum+1
                lnum=lnum+1
             ENDIF
             IF(QN3S1F(ii))THEN
                varnum=varnum+1
                snum=snum+1
             ENDIF
             IF(QN3PJF(ii))THEN
                varnum=varnum+2
                lnum=lnum+1
                snum=snum+1
             ENDIF
          ENDDO
       ENDIF
       IF(NDecayChains_DPS.GT.0)THEN
          varnum=varnum+NDecayIflh_DPS
       ENDIF
    ELSE
       varnum=3*(nhad-3)
       IF(lunwei2.OR..TRUE.)varnum=varnum+1 ! the trivial phi should be used
       lnum=0
       snum=0
       varnum=varnum+1+NDecayIflh_DPS
    ENDIF
    ! add the second SPS = SPS(1 onium)
    IF(integration_DPS.NE.1)THEN
       varnum=varnum+varnum2
    ENDIF
    DO ii=1,varnum
       XL(ii)=0.0d0
       XU(ii)=1.0d0
    ENDDO
    IF(PRESENT(itmxn))THEN
       ITMX=itmxn
    ELSE
       ITMX=5
    ENDIF
    ITMX=1
    IF(PRESENT(ncalln))THEN
       ncalm=ncalln
    ELSE
       ncalm=5000
    ENDIF
    chchar(1)="40K"
    chchar(2)="80K"
    chchar(3)="160K"
    chchar(4)="320K"
    chchar(5)="640K"
    chchar(6)="1M"
    chchar(7)="2M"
    chchar(8)="4M"
    chchar(9)="8M"
    chchar(10)="16M"
    chchar(11)='32M'
    chchar(12)='64M'
    chchar(13)='120M'
    chchar(14)='240M'
    chchar(15)='480M'
    chchar(16)='960M'
    chchar(17)='2G'
    chchar(18)='4G'
    chchar(19)='8G'
    chchar(20)='16G'
    nprint=10000
    NCALL=20000
    CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
    vegas_grid_stage=gridpack
    IF(vegas_grid_stage.EQ.2)THEN
       ! check the grid file first
       INCLUDE "../../../src/check_vegas_grid.inc"
    ENDIF
    IF(vegas_grid_stage.LE.1)THEN
       IF(nhad.EQ.4)THEN
          CALL VEGAS(varnum,pp_psipsipsi_DPS_fxn,vfes,sd,chi2a)
       ELSE
          CALL VEGAS(varnum,pp_psipsipsiX_DPS_fxn,vfes,sd,chi2a)
       ENDIF
       WRITE(*,*)' '
       WRITE(*,*)"====================NCALL=20K==========================="
       WRITE(*,*)" "
       CALL Helac_mtime()
       WRITE(*,*)" "
       ii=1
       WRITE(*,*)"ITERATION ",ii,":"
       WRITE(*,*)vfes,"+\-",sd
       WRITE(*,*)"precision:",sd/vfes
       DO ii=2,10
          IF(plot_output)CALL initplot_pp_psipsipsi_DPS
          IF(nhad.EQ.4)THEN
             CALL VEGAS(varnum,pp_psipsipsi_DPS_fxn,vfes,sd,chi2a,1)
          ELSE
             CALL VEGAS(varnum,pp_psipsipsiX_DPS_fxn,vfes,sd,chi2a,1)
          ENDIF
          IF(plot_output)CALL plotout_pp_psipsipsi_DPS
          WRITE(*,*)"ITERATION ",ii,":"
          WRITE(*,*)vfes,"+\-",sd
          WRITE(*,*)"precision:",sd/vfes
       ENDDO
       CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
       iday1=iday1-iday0
       ihr1=ihr1-ihr0
       imin1=imin1-imin0
       isec1=isec1-isec0
       i100th1=i100th1-i100th0
       CALL Vegas_speed(10*NCALL,iday1,ihr1,imin1,isec1,i100th1)
       WRITE(*,*)' '
       WRITE(*,*)' '
    ENDIF
    IF(vegas_grid_stage.LE.1)THEN
       ii=1
       DO
          nc=2*NCALL
          IF(nc.GT.ncalm)EXIT
          IF(2*nc.GT.ncalm.AND.lunwei2.AND.lwmax.EQ.0)THEN
             lwmax=1
          ENDIF
          NCALL=nc
          IF(NCALL/maxprint.GT.nprint)nprint=NCALL/maxprint
          CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
          WRITE(*,*)"====================NCALL="//chchar(ii)//"==========================="
          WRITE(*,*)" "
          CALL Helac_mtime()
          WRITE(*,*)" "
          IF(plot_output)CALL initplot_pp_psipsipsi_DPS
          IF(nhad.EQ.4)THEN
             CALL VEGAS(varnum,pp_psipsipsi_DPS_fxn,vfes,sd,chi2a,1)
          ELSE
             CALL VEGAS(varnum,pp_psipsipsiX_DPS_fxn,vfes,sd,chi2a,1)
          ENDIF
          IF(plot_output)CALL plotout_pp_psipsipsi_DPS
          WRITE(*,*)vfes,"+\-",sd
          WRITE(*,*)"precision:",sd/vfes
          CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
          iday1=iday1-iday0
          ihr1=ihr1-ihr0
          imin1=imin1-imin0
          isec1=isec1-isec0
          i100th1=i100th1-i100th0
          CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
          WRITE(*,*)" "
          ii=ii+1
       ENDDO
    ELSEIF(vegas_grid_stage.EQ.2)THEN
       ii=1
       DO
          nc=2*NCALL
          IF(nc.GT.ncalm)EXIT
          NCALL=nc
          ii=ii+1
       ENDDO
       nc=nc/2
       IF(lunwei2.AND.lwmax.EQ.0)THEN
          lwmax=1
       ENDIF
       NCALL=nc
       IF(NCALL/maxprint.GT.nprint)nprint=NCALL/maxprint
       CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
       WRITE(*,*)"====================NCALL="//chchar(ii)//"==========================="
       WRITE(*,*)" "
       CALL Helac_mtime()
       WRITE(*,*)" "
       IF(plot_output)CALL initplot_pp_psipsipsi_DPS
       IF(nhad.EQ.4)THEN
          CALL VEGAS(varnum,pp_psipsipsi_DPS_fxn,vfes,sd,chi2a,1)
       ELSE
          CALL VEGAS(varnum,pp_psipsipsiX_DPS_fxn,vfes,sd,chi2a,1)
       ENDIF
       IF(plot_output)CALL plotout_pp_psipsipsi_DPS
       WRITE(*,*)vfes,"+\-",sd
       WRITE(*,*)"precision:",sd/vfes
       CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
       iday1=iday1-iday0
       ihr1=ihr1-ihr0
       imin1=imin1-imin0
       isec1=isec1-isec0
       i100th1=i100th1-i100th0
       CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
       WRITE(*,*)" "
       vegas_grid_stage=0
       nc=nc*2
    ENDIF
    IF(lunwei2.AND.lwmax.EQ.1)THEN
       lwmax=2
       WRITE(*,*)"START UNWEIGHTING"
       NCALL=nc/2
       CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
       WRITE(*,*)"====================NCALL="//chchar(ii-1)//"==========================="
       WRITE(*,*)" "
       CALL Helac_mtime()
       WRITE(*,*)" "
       IF(plot_output)CALL initplot_pp_psipsipsi_DPS
       IF(nhad.EQ.4)THEN
          CALL VEGAS(varnum,pp_psipsipsi_DPS_fxn,vfes,sd,chi2a,1)
       ELSE
          CALL VEGAS(varnum,pp_psipsipsiX_DPS_fxn,vfes,sd,chi2a,1)
       ENDIF
       IF(plot_output)CALL plotout_pp_psipsipsi_DPS
       WRITE(*,*)vfes,"+\-",sd
       WRITE(*,*)"precision:",sd/vfes
       CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
       iday1=iday1-iday0
       ihr1=ihr1-ihr0
       imin1=imin1-imin0
       isec1=isec1-isec0
       i100th1=i100th1-i100th0
       CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
       WRITE(*,*)" "
    ENDIF
    SELECT CASE(COLL_TYPE)
    CASE(1)
       IDBMUP1=2212
       IDBMUP2=2212
    CASE(2)
       IDBMUP1=2212
       IDBMUP2=-2212
    CASE DEFAULT
       IDBMUP1=11
       IDBMUP2=-11
    END SELECT
    IF(lunwei2)THEN
       IDWTUP=3
    ELSE
       IDWTUP=1
    ENDIF
    NPRUP=NPRUP+1
    WRITE(200,5100) IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,&
         iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
    WRITE(200,5200) vfes*10d0**3,sd*10d0**3,1d0, 90
    rslt(1)=vfes
    rslt(2)=sd
    rslt(3)=chi2a
    IF(lunwei2)PRINT *,"number of events",Nevents
    RETURN
5100 FORMAT(1P,2I8,2E14.6,6I8)
5200 FORMAT(1P,3E20.10,I6)
  END SUBROUTINE pp_psipsipsi_DPS_VEGAS

  FUNCTION pp_psipsipsi_DPS_fxn(x,wgt)
      REAL(KIND(1d0)),DIMENSION(varnum),INTENT(IN)::x
      REAL(KIND(1d0)),INTENT(IN)::wgt
      REAL(KIND(1d0))::pp_psipsipsi_DPS_fxn
      REAL(KIND(1d0))::y1,y2,phi,w1
      REAL(KIND(1d0)),DIMENSION(4)::pmom
      INTEGER::kk
      REAL(KIND(1d0))::m1r,m2r,m12,m22
      REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::lr,sr
      REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
      INTEGER::init=0,nwarn,nwmax,nwri,nwri_tot,icut,nnn=0,nnntot=0,&
           pdfnumpdf,ivarnum
      SAVE init,nwarn,nwmax,nwri,nwri_tot,nnn,nnntot,pdfnumpdf,ivarnum
      SAVE lr,sr,m1r,m2r,m12,m22
      REAL(KIND(1d0))::sqs,sq,pt1c,maxpt1c,y1cup,y1clow,ycollcm,mt1,mt2,pt
      SAVE sqs,sq,pt1c,maxpt1c,y1cup,y1clow,ycollcm
      REAL(KIND(1d0))::wdps,wsf,wme,wgtbr,temp1,temp2,temp21,temp3,temp4
      REAL(KIND(1d0))::exp1,exp2,Jpt2,Jy1,Jy2,xp11,xp21,scale1,scale2
      REAL(KIND(1d0))::recmax=0,recmin=0
      REAL(KIND(1d0))::temp1_save
      REAL(KIND(1d0))::pqp,ptp
      SAVE temp1,recmax,recmin,temp1_save
      INTEGER::ipip,ioffset,j,i_pick
      REAL(KIND(1d0))::acc_xp1,acc_xp2,wme0
      REAL(KIND(1d0))::xp1_1st,xp2_1st,wsf_1st,scale_dpdf,alps1,alps2
      REAL(KIND(1d0))::scale_as_1st
      REAL(KIND(1d0)),EXTERNAL::GSALPS
      IF(init.EQ.0)THEN
         wjac=1
         nwmax=0
         nwarn=0
         nwri=0
         CALL ReadElem_integer('unwevt',nwri_tot)
         CALL ReadElem_real('energy_beam1',sqs)
         ebeam(1)=ABS(sqs)
         CALL ReadElem_real('energy_beam2',sqs)
         ebeam(2)=ABS(sqs)
         IF(ABS(ebeam(1)-ebeam(2))/MAX(ebeam(1)+ebeam(2),1d-17).LT.1d-8)THEN
            absrap=absrap
            labeqcoll=.TRUE.
         ELSE
            absrap=.FALSE.
            labeqcoll=.FALSE.
         ENDIF
         sqs=2d0*DSQRT(ebeam(1)*ebeam(2)) ! we always neglect the mass of initial states
         IF(fixtarget)sqs=sqs/DSQRT(2d0)
         EBMUP1=ebeam(1)
         EBMUP2=ebeam(2)
         IF(.NOT.fixtarget)THEN
            ycollcm=DLOG(ABS(ebeam(1))/ABS(ebeam(2)))/2d0
         ELSE
            IF(ABS(ebeam(1)).GT.ABS(ebeam(2)))THEN
               fixtargetrev=.FALSE.
               ycollcm=DLOG(1d0+2d0*ABS(ebeam(1))/ABS(ebeam(2)))/2d0
               FT_M=ebeam(2)
               FT_E1=ebeam(1)
               sqs=DSQRT(sqs**2+FT_M**2)
            ELSE
               fixtargetrev=.TRUE.
               ycollcm=-DLOG(1d0+2d0*ABS(ebeam(2))/ABS(ebeam(1)))/2d0
               FT_M=ebeam(1)
               FT_E1=ebeam(2)
               sqs=DSQRT(sqs**2+FT_M**2)
            ENDIF
         ENDIF
         IF(fixtarget)THEN
            ! for fixed target, I used the fake lab frame (note it is not the true lab frame of fixed target but close to)
            IF(.NOT.fixtargetrev)THEN
               ! beam1 = (beam(1)+FT_M/2,0,0,beam(1)+FT_M/2)
               ! beam2 = (FT_M/2,0,0,-FT_M/2), FT_M=beam(2)
               EBMUP1=ebeam(1)+FT_M/2d0
               EBMUP2=ebeam(2)/2d0
            ELSE
               ! beam1 = (FT_M/2,0,0,FT_M/2),FT_M=beam(1)
               ! beam2 = (beam(2)+FT_M/2,0,0,-beam(2)-FT_M/2)
               EBMUP1=ebeam(1)/2d0
               EBMUP2=ebeam(2)+FT_M/2d0
            ENDIF
         ENDIF
         CALL ReadElem_real('minpt1c',pt1c)
         CALL ReadElem_real('maxpt1c',maxpt1c)
         IF(maxpt1c.LT.0d0)THEN
            maxpt1c=-1d0
         ELSE
            IF(maxpt1c.LE.pt1c)THEN
               WRITE(*,*)"ERROR: the first final state was cut off by pt cut (pt1c,maxpt1c)"
               STOP
            ENDIF
         ENDIF
         CALL ReadElem_real('maxy1c',y1cup)
         CALL ReadElem_real('miny1c',y1clow)
         CALL ReadElem_integer('pdf',pdfnumpdf)
         ptc(3:20)=0
         maxptc(3:20)=-1d0
         drc(3:20,3:20)=0
         etac(3:20)=20
         ec(3:20)=0
         c1(3:20)=1
         c2(3:20)=1
         cc(3:20,3:20)=1
         yycut(3:20)=1d9
         IF(absrap)THEN
            yycutlow(3:20)=0d0
         ELSE
            yycutlow(3:20)=-1d9
         ENDIF
         xFcut(3:20)=1d0
         xFcutlow(3:20)=-1d0
         gmas(3:20,3:20)=0
         gbeammass(1:2,3:20)=0
         
         parmas(0)=0
         parwid(0)=-1
         iPDFSUP1=pdfnumpdf
         IF(pdfnumpdf.EQ.0.OR.COLL_TYPE.EQ.3)THEN
            istruc=0
         ELSE
            istruc=1
         ENDIF
         IF(istruc.EQ.1)THEN
            iPDFGUP1=0
            iPDFGUP2=0
            iPDFSUP1=pdfnumpdf
            iPDFSUP2=pdfnumpdf
         ELSE
            iPDFGUP1=-1
            iPDFGUP2=-1
            iPDFSUP1=-1
            iPDFSUP2=-1
         ENDIF
         xp1=1
         xp2=1
         IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
            CALL readcuts_pp_psipsipsi_dps
            y1cup=MIN(y1cup,yycut(3))
            y1clow=MAX(y1clow,yycutlow(3))
            IF(absrap)y1cup=ABS(y1cup)
            IF(absrap)y1clow=ABS(y1clow)
         ENDIF
         IF(NDecayChains_DPS.GT.0)CALL readcuts_Decay
         IF(lnum.NE.0)THEN
            ALLOCATE(lr(lnum))
         ENDIF
         IF(snum.NE.0)THEN
            ALLOCATE(sr(snum))
         ENDIF
         kk=3
         IF(ABS(iflh(3)).GT.100)THEN
            m1r=parmas(ifl(kk))+parmas(ifl(kk+1))
            kk=kk+2
         ELSE
            m1r=parmas(ifl(kk))
            kk=kk+1
         ENDIF
         IF(ABS(iflh(4)).GT.100)THEN
            m2r=parmas(ifl(kk))+parmas(ifl(kk+1))
            kk=kk+2
         ELSE
            m2r=parmas(ifl(kk))
            kk=kk+1
         ENDIF
         sq=sqs*sqs
         m12=m1r*m1r
         m22=m2r*m2r
         temp1_save=DSQRT(lamda_func(sq,m12,m22))/(2d0*sqs)
         IF(maxpt1c.GE.0d0)THEN
            temp1_save=MIN(temp1_save,maxpt1c)
         ENDIF
         ivarnum=3
         IF(lunwei2.OR..TRUE.)ivarnum=ivarnum+1
         init=1
      ENDIF
      nnntot=nnntot+1
      wdps=1d0
      acc_xp1=0d0
      acc_xp2=0d0
      DO ipip=1,2
         ! the ipip-th SPS
         IF(ipip.EQ.1)THEN
            temp1=temp1_save
         ELSEIF(integration_DPS.NE.1)THEN
            temp1=(sq-mpsi(ipip-1)**2)/(2d0*sqs) 
            IF(maxpt1c.GE.0d0)THEN
               temp1=MIN(temp1,maxpt1c)
            ENDIF
         ENDIF
         IF(ipip.EQ.1.OR.integration_DPS.NE.1)THEN
            ioffset=ivarnum*(ipip-1)
            pt=(temp1-pt1c)*x(3+ioffset)+pt1c
         ENDIF
         IF(ipip.EQ.1)THEN
            mt1=DSQRT(pt*pt+m1r*m1r)
            mt2=DSQRT(pt*pt+m2r*m2r)
         ELSEIF(integration_DPS.NE.1)THEN
            mt1=DSQRT(pt**2+mpsi(ipip-1)**2)
            mt2=pt
         ENDIF
         IF(ipip.EQ.1.OR.integration_DPS.NE.1)THEN
         IF(absrap)THEN
            IF(ipip.EQ.1)THEN
               temp2=MIN(ACosh_p((sq+m12-m22)/(2d0*sqs*mt1)),y1cup)
            ELSE
               temp2=MIN(ACosh_p((sq+mpsi(ipip-1)**2)/(2d0*sqs*mt1)),y1cup)
            ENDIF
            IF(temp2.LT.y1clow)THEN
               pp_psipsipsi_DPS_fxn=0d0
               RETURN
            ENDIF
            y1=(2d0*x(1+ioffset)-1d0)*(temp2-y1clow)+SIGN(1d0,x(1+ioffset)-0.5d0)*y1clow
         ELSE
            IF(ipip.EQ.1)THEN
               temp2=MIN(ACosh_p((sq+m12-m22)/(2d0*sqs*mt1)),y1cup-ycollcm)
               temp21=MAX(-ACosh_p((sq+m12-m22)/(2d0*sqs*mt1)),y1clow-ycollcm)
            ELSE
               temp2=MIN(ACosh_p((sq+mpsi(ipip-1)**2)/(2d0*sqs*mt1)),y1cup-ycollcm)
               temp21=MAX(-ACosh_p((sq+mpsi(ipip-1)**2)/(2d0*sqs*mt1)),y1clow-ycollcm)
            ENDIF
            IF(temp2.LT.temp21)THEN
               pp_psipsipsi_DPS_fxn=0d0
               RETURN
            ENDIF
            y1=(temp2-temp21)*x(1+ioffset)+temp21 ! in collision frame
         ENDIF
         temp3=DLOG((-DEXP(-y1)*mt1+sqs)/mt2)
         temp4=temp3+DLOG((-DEXP(y1)*mt1+sqs)/mt2)
         y2=-temp3+temp4*x(2+ioffset) ! in collision frame
         Jpt2=2d0*pt*(temp1-pt1c)
         IF(absrap)THEN
            Jy1=2d0*(temp2-y1clow)
         ELSE
            Jy1=temp2-temp21
         ENDIF
         Jy2=temp4
         ELSE
            ! randomly picking up an unweighted event
            i_pick=Nevent_pp_psiX_CB*rand()+1
            y1=rapidity(pmom_pp_psiX_CB(i_pick,3,1:4))
            y2=rapidity(pmom_pp_psiX_CB(i_pick,4,1:4))
            mt1=DSQRT(pmom_pp_psiX_CB(i_pick,3,1)**2+pmom_pp_psiX_CB(i_pick,3,2)**2+mpsi(ipip-1)**2)
            mt2=DSQRT(pmom_pp_psiX_CB(i_pick,4,1)**2+pmom_pp_psiX_CB(i_pick,4,2)**2)
         ENDIF
         ! The substitution of original variations
         IF(ipip.GE.2)THEN
            IF((DEXP(y1)*mt1+DEXP(y2)*mt2)/sqs+acc_xp1.GE.1d0)THEN
               pp_psipsipsi_DPS_fxn=0d0
               RETURN
            ENDIF
            IF((DEXP(-y1)*mt1+DEXP(-y2)*mt2)/sqs+acc_xp2.GE.1d0)THEN
               pp_psipsipsi_DPS_fxn=0d0
               RETURN
            ENDIF
         ENDIF
         IF(ycollcm.EQ.0d0)THEN
            xp1=(DEXP(y1)*mt1+DEXP(y2)*mt2)/sqs
            xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/sqs
         ELSE
            IF(.NOT.fixtarget)THEN
               xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2)/(2d0*ebeam(1))
               xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/(2d0*ebeam(2))
            ELSE
               IF(.NOT.fixtargetrev)THEN
                  xp1=(DSINH(y1)*mt1 + DSINH(y2)*mt2)/(ebeam(1))
                  xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/(ebeam(2))
               ELSE
                  xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2)/(ebeam(1))
                  xp2=(DSINH(-y1)*mt1+DSINH(-y2)*mt2)/(ebeam(2))
               ENDIF
            ENDIF
         ENDIF
         acc_xp1=acc_xp1+xp1
         acc_xp2=acc_xp2+xp2
         ehat=DSQRT(xp1*xp2*sq)
         IF(ipip.EQ.1.OR.integration_DPS.NE.1)THEN
            wdps=wdps*xp1*xp2*Jpt2*Jy1*Jy2*3.8937966d5/(16d0*pi*ehat**4)
         ELSE
            wdps=wdps*sigma_pp_psiX_CB
         ENDIF
         exp1=xp1*ebeam(1)
         exp2=xp2*ebeam(2)
         IF(fixtarget)THEN
            IF(.NOT.fixtargetrev)THEN
               exp1=exp1+FT_M*xp1/2d0
               exp2=exp2/2d0
            ELSE
               exp2=exp2+FT_M*xp2/2d0
               exp1=exp1/2d0
            ENDIF
         ENDIF
         ! Generate the momenta of external legs
         dps_pmom(ipip,1,1:2)=0
         dps_pmom(ipip,1,3)=xp1*sqs/2d0
         dps_pmom(ipip,1,4)=xp1*sqs/2d0
         dps_pmom(ipip,2,1:2)=0
         dps_pmom(ipip,2,3)=-xp2*sqs/2d0
         dps_pmom(ipip,2,4)=xp2*sqs/2d0
         IF(ipip.EQ.1)THEN
            Phegas_pmom(1,1:2)=0
            Phegas_pmom(1,3)=xp1*sqs/2d0
            Phegas_pmom(1,4)=xp1*sqs/2d0
            Phegas_pmom(1:2,5)=0
            Phegas_pmom(2,1:2)=0
            Phegas_pmom(2,3)=-xp2*sqs/2d0
            Phegas_pmom(2,4)=xp2*sqs/2d0
         ENDIF
         IF(ipip.EQ.1.OR.integration_DPS.NE.1)THEN
         ! we choose phi=0
         IF(lunwei2.OR..TRUE.)THEN
            phi=2*pi*x(4+ioffset)
         ELSE
            phi=0d0
         ENDIF
         dps_pmom(ipip,3,1)=pt*DCOS(phi)
         dps_pmom(ipip,3,2)=pt*DSIN(phi)
         dps_pmom(ipip,3,3)=mt1*DSINH(y1)
         dps_pmom(ipip,3,4)=mt1*DCOSH(y1)
         dps_pmom(ipip,4,1)=-pt*DCOS(phi)
         dps_pmom(ipip,4,2)=-pt*DSIN(phi)
         dps_pmom(ipip,4,3)=mt2*DSINH(y2)
         dps_pmom(ipip,4,4)=mt2*DCOSH(y2)
         ELSE
            dps_pmom(ipip,3,1)=pmom_pp_psiX_CB(i_pick,3,1)
            dps_pmom(ipip,3,2)=pmom_pp_psiX_CB(i_pick,3,2)
            dps_pmom(ipip,3,3)=pmom_pp_psiX_CB(i_pick,3,3)
            dps_pmom(ipip,3,4)=pmom_pp_psiX_CB(i_pick,3,4)
            dps_pmom(ipip,4,1)=pmom_pp_psiX_CB(i_pick,4,1)
            dps_pmom(ipip,4,2)=pmom_pp_psiX_CB(i_pick,4,2)
            dps_pmom(ipip,4,3)=pmom_pp_psiX_CB(i_pick,4,3)
            dps_pmom(ipip,4,4)=pmom_pp_psiX_CB(i_pick,4,4)
         ENDIF
         IF(ipip.EQ.1)THEN
            kk=3
            pmom(1)=pt*DCOS(phi)
            pmom(2)=pt*DSIN(phi)
            pmom(3)=mt1*DSINH(y1)
            pmom(4)=mt1*DCOSH(y1)
            IF(ABS(iflh(3)).GT.100)THEN
               Phegas_pmom(kk,1:4)=parmas(ifl(kk))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
               Phegas_pmom(kk,5)=parmas(ifl(kk))
               Phegas_pmom(kk+1,1:4)=parmas(ifl(kk+1))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
               Phegas_pmom(kk+1,5)=parmas(ifl(kk+1))
               kk=kk+2
            ELSE
               Phegas_pmom(kk,1:4)=pmom(1:4)
               Phegas_pmom(kk,5)=parmas(ifl(kk))
               kk=kk+1
            ENDIF
            pmom(1)=-pt*DCOS(phi)
            pmom(2)=-pt*DSIN(phi)
            pmom(3)=mt2*DSINH(y2)
            pmom(4)=mt2*DCOSH(y2)
            IF(ABS(iflh(4)).GT.100)THEN
               Phegas_pmom(kk,1:4)=parmas(ifl(kk))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
               Phegas_pmom(kk,5)=parmas(ifl(kk))
               Phegas_pmom(kk+1,1:4)=parmas(ifl(kk+1))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
               Phegas_pmom(kk+1,5)=parmas(ifl(kk+1))
               kk=kk+2
            ELSE
               Phegas_pmom(kk,1:4)=pmom(1:4)
               Phegas_pmom(kk,5)=parmas(ifl(kk))
               kk=kk+1
            ENDIF
         ENDIF
         ! force to lab frame
         Momenta_Frame=1
         IF(ipip.EQ.1)THEN
            !IF(imode.EQ.0.AND.NDecayChains_DPS.EQ.0)THEN
            IF(Momenta_Frame.EQ.2)THEN
               ! boost from collision frame to cms
               pmom(3)=-(xp1-xp2)*sqs/2d0
               pmom(4)=(xp1+xp2)*sqs/2d0
               pmom(1:2)=0
            ELSE
               ! boost from collision frame to lab frame in polarization
               IF(.NOT.fixtarget)THEN
                  pmom(3)=ebeam(1)-ebeam(2)
                  pmom(4)=ebeam(1)+ebeam(2)
               ELSE
                  IF(.NOT.fixtargetrev)THEN
                     pmom(3)=ebeam(1)
                     pmom(4)=ebeam(1)+ebeam(2)
                  ELSE
                     pmom(3)=-ebeam(2)
                     pmom(4)=ebeam(1)+ebeam(2)
                  ENDIF
               ENDIF
               pmom(1:2)=0
            ENDIF
            DO j=1,n
               !IF(imode.EQ.0.AND.NDecayChains_DPS.EQ.0)THEN
               IF(Momenta_Frame.EQ.2)THEN
                  CALL Boostl(ehat,pmom,Phegas_pmom(j,1:4))
                  ! the following is necessary for dijet production
                  IF(j.LE.2)THEN
                     IF(DABS(Phegas_pmom(j,3)).NE.Phegas_pmom(j,4))THEN
                        Phegas_pmom(j,4)=DABS(Phegas_pmom(j,3))
                     ENDIF
                  ENDIF
               ELSEIF(Momenta_Frame.EQ.1.AND..NOT.labeqcoll)THEN
                  CALL Boostl(sqs,pmom,Phegas_pmom(j,1:4))
               ENDIF
               ptp=DSQRT(Phegas_pmom(j,1)**2+Phegas_pmom(j,2)**2)
               pqp=DSQRT(ptp**2+Phegas_pmom(j,3)**2)
               zq(j,1)= DCMPLX(Phegas_pmom(j,4)+Phegas_pmom(j,3),Phegas_pmom(j,3))
               zq(j,2)= DCMPLX(Phegas_pmom(j,4)-Phegas_pmom(j,3),ptp)
               zq(j,3)= DCMPLX(Phegas_pmom(j,1), Phegas_pmom(j,2))
               zq(j,4)= DCMPLX(Phegas_pmom(j,1),-Phegas_pmom(j,2))
               zq(j,5)= DCMPLX(parmas(ifl(j)),pqp )
            ENDDO
         ENDIF
         ! boost from collision frame to lab frame
         IF(.NOT.fixtarget)THEN
            pmom(3)=ebeam(1)-ebeam(2)
            pmom(4)=ebeam(1)+ebeam(2)
         ELSE
            IF(.NOT.fixtargetrev)THEN
               pmom(3)=ebeam(1)
               pmom(4)=ebeam(1)+ebeam(2)
            ELSE
               pmom(3)=-ebeam(2)
               pmom(4)=ebeam(1)+ebeam(2)
            ENDIF
         ENDIF
         pmom(1:2)=0
         IF(.NOT.labeqcoll)THEN
            DO j=1,4
               CALL Boostl(sqs,pmom,dps_pmom(ipip,j,1:4))
            ENDDO
         ENDIF
         IF(pdfnumpdf.EQ.921000)THEN
            ! GS 09 dPDF
            IF(ipip.EQ.1)THEN
               xp11=xp1
               xp21=xp2
               xp1_1st=xp1
               xp2_1st=xp2
               CALL qcdscale(scale1)
               scale1=scale1*muF_over_ref
               scale_as_1st=scale1*muR_over_ref
               !scale1=dps_pmom(ipip,3,1)**2+dps_pmom(ipip,3,2)**2+mpsi(ipip)**2
               !scale1=DSQRT(scale1)
            ELSE
               scale2=dps_pmom(ipip,3,1)**2+dps_pmom(ipip,3,2)**2+mpsi(ipip-1)**2
               scale2=DSQRT(scale2)
               scale_dpdf=DSQRT(scale1*scale2)
               CALL GS09(xp11,xp1,scale_dpdf,0,0,wsf)
               wdps=wdps*wsf
               CALL GS09(xp21,xp2,scale_dpdf,0,0,wsf)
               wdps=wdps*wsf
               ! CALL GSALPS(Q) to run alpha_S, which is not used here
            ENDIF
         ELSE
            IF(ipip.EQ.1.OR.integration_DPS.NE.1)THEN
               CALL strf_pdf_pp_psipsipsi_dps(ipip,wsf)
            ENDIF
            IF(ipip.EQ.1)THEN
               xp1_1st=xp1
               xp2_1st=xp2
               wsf_1st=wsf
            ENDIF
            IF(ipip.EQ.1.OR.integration_DPS.NE.1)THEN
               wdps=wdps*wsf
            ENDIF
         ENDIF
      ENDDO
      IF(wdps.LE.0d0)THEN
         pp_psipsipsi_DPS_fxn=0d0
         RETURN
      ENDIF
      CALL pp_psipsipsi_dps_hadronmom
      icut=1
      CALL Cuts_pp_psipsipsi_dps(icut)
      IF(icut.EQ.0)THEN
         pp_psipsipsi_DPS_fxn=0d0
         RETURN
      ENDIF
      IF(irun.EQ.1)CALL Helac_FeynRule_SM() ! reload the Feynman Rules
      ! set the random number for random helicity method
      ! one has two partonic scatterings
      IF(integration_DPS.NE.1)THEN
         kk=2*ivarnum+1
      ELSE
         kk=ivarnum+1
      ENDIF
      IF(.NOT.MCoHelicity)THEN
         DO j=1,lnum
            lr(j)=2*pi*x(kk)
            kk=kk+1
         ENDDO
         DO j=1,snum
            sr(j)=2*pi*x(kk)
            kk=kk+1
         ENDDO
         CALL SetRandom(lr,sr)
         IF(NDecayChains_DPS.GT.0)THEN
            DO j=kk,varnum
               Decayran(j-kk+1)=x(j)
            ENDDO
         ENDIF
      ELSE
         RMCoH=x(kk)
         DO j=kk+1,varnum
            Decayran(j-kk)=x(j)
         ENDDO
      ENDIF
      xp1=xp1_1st
      xp2=xp2_1st
      DO ipip=1,2
         IF(ipip.EQ.1)THEN
            CALL Helac_master_f(wme)
            GLOBALINIT_master=1
            IF((reweight_scale.OR.pdfnumpdf.EQ.92100).AND.nnn.LE.1)THEN
               reweight_scale_phase=.TRUE.
               CALL Helac_FeynRule_SM()
               CALL Helac_master_f(wme0)
               IF(nnn.EQ.0)THEN
                  alphas_power=NINT(DLOG10(wme/wme0))
                  IF(ABS(DLOG10(wme/wme0)-DBLE(alphas_power)).GT.0.05d0)THEN
                     WRITE(*,*)"ERROR:Reweighting scale/dPDF cannot be used for mixed order processes !"
                     STOP
                  ENDIF
               ELSE
                  IF(NINT(DLOG10(wme/wme0)).NE.alphas_power)THEN
                     WRITE(*,*)"WARNING:The process is a mixed order process.Reweighting scale/dPDF may be wrong !"
                  ENDIF
               ENDIF
               reweight_scale_phase=.FALSE.
            ENDIF
            IF(pdfnumpdf.EQ.92100.AND.alphas_power.GT.0)THEN
               ! use the internal GSALPS(Q) provided by GS 09 dPDF
               alps1=GSALPS(scale_as_1st)
               alps2=ALPHAS(scale_as_1st)
               wme=wme*(alps1/alps2)**alphas_power
            ENDIF
         ELSEIF(integration_DPS.NE.1)THEN
            CALL crystalball_gg_psiX(ipip,wme)
         ENDIF
         IF(ipip.EQ.1.OR.integration_DPS.NE.1)THEN
            wdps=wdps*wme
         ENDIF
         IF(wdps.LE.0d0)THEN
            pp_psipsipsi_DPS_fxn=0d0
            RETURN
         ENDIF
      ENDDO
      IF(NDecayChains_DPS.GT.0)THEN
         CALL HO_Decay_pp_psipsipsi_dps(weight_br)
         IF(weight_br.LE.0d0)THEN
            pp_psipsipsi_DPS_fxn=0d0
            RETURN
         ENDIF
         CALL cuts_Decay_pp_psipsipsi_dps(icut)
         IF(icut.EQ.0)THEN
            pp_psipsipsi_DPS_fxn=0d0
            RETURN
         ENDIF
         wdps=wdps*weight_br
      ENDIF
      IF(reweight_scale)THEN
         xp1=xp1_1st
         xp2=xp2_1st
         CALL pp_psipsipsi_DPS_reweight_xsec_scale(wsf_1st)
      ENDIF
      pp_psipsipsi_DPS_fxn=wdps*LDMEwt/dps_sigmaeff
      IF(lunwei2.AND.lwmax.GT.0)THEN
         w1=pp_psipsipsi_DPS_fxn*wgt ! multiply VEGAS weight
         CALL unwei_procedure_pp_psipsipsi_dps(w1,nwri,nwmax,nwarn)
      ENDIF
      IF(plot_output)THEN
         w1=pp_psipsipsi_DPS_fxn*wgt
         CALL outfun_pp_psipsipsi_dps(w1)
      ENDIF
      nnn=nnn+1
      IF(recmax.LT.pp_psipsipsi_DPS_fxn)recmax=pp_psipsipsi_DPS_fxn
      IF(recmin.GT.pp_psipsipsi_DPS_fxn)recmin=pp_psipsipsi_DPS_fxn
      IF(MOD(nnn,nprint).EQ.0)THEN
         PRINT *,"max=",recmax
         PRINT *,"min=",recmin
         IF(lunwei2.AND.lwmax.GT.1)THEN
            PRINT *,"      n_event,    n_pass,    n_total"
            PRINT *,nwri,nnn,nnntot
         ELSE
            PRINT *, "      n_pass,     n_total"
            PRINT *,nnn,nnntot
         ENDIF
      ENDIF
    END FUNCTION pp_psipsipsi_DPS_fxn

    FUNCTION pp_psipsipsiX_DPS_fxn(x,wgt)
      REAL(KIND(1d0)),DIMENSION(varnum),INTENT(IN)::x
      REAL(KIND(1d0)),INTENT(IN)::wgt
      REAL(KIND(1d0))::pp_psipsipsiX_DPS_fxn,sqs,sq
      REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::mr,ptcut,ymincut,ymaxcut
      REAL(KIND(1d0)),DIMENSION(nhad,1:4)::phadmom
      REAL(KIND(1d0))::pt0,pti,phi,phi0,y0,yi,yn,Q,mi,mres,jac,jactemp,mtot,pt1,pt12,mti
      REAL(KIND(1d0))::rlogmax,rlogmin,w1,wr,wdps
      LOGICAL::lflag=.TRUE.
      INTEGER::init=0,kk,kk2,ii,j,icut,istat,nnn=0,nnntot=0,pdfnumpdf,nwri,nwri_tot,nwarn,nwmax
      REAL(KIND(1d0)),DIMENSION(4)::pmom
      REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::lr,sr
      REAL(KIND(1d0))::ptp,pqp,wme,wme0,wgtbr,wsf,y1cup,y1clow,pt1c,maxpt1c,recmax=0,recmin=0
      REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
      INTEGER::iquark,iii,kiki,i_pick
      REAL(KIND(1d0))::exp1,exp2,ycollcm
      SAVE init,sqs,sq,y1cup,y1clow,pt1c,maxpt1c,lr,sr,pt1,pt12,mr,mtot,nnntot,ycollcm
      SAVE nnn,recmax,recmin,ptcut,ymincut,ymaxcut,nwri,nwri_tot,nwarn,nwmax
      REAL(KIND(1d0))::xp11,xp21,scale1,scale2
      REAL(KIND(1d0))::pt,y1,y2,mt1,mt2,m12,m22
      REAL(KIND(1d0))::temp1,temp2,temp21,temp3,temp4,Jpt2,Jy1,Jy2
      INTEGER::ipip,ioffset
      REAL(KIND(1d0))::acc_xp1,acc_xp2,wsf0
      REAL(KIND(1d0))::xp1_1st,xp2_1st,wsf_1st,scale_dpdf,alps1,alps2
      REAL(KIND(1d0))::scale_as_1st
      REAL(KIND(1d0)),EXTERNAL::GSALPS
      IF(init.EQ.0)THEN
         wjac=1
         nwmax=0
         nwarn=0
         nwri=0
         CALL ReadElem_integer('unwevt',nwri_tot)
         CALL ReadElem_real('energy_beam1',sqs)
         ebeam(1)=ABS(sqs)
         CALL ReadElem_real('energy_beam2',sqs)
         ebeam(2)=ABS(sqs)
         IF(ABS(ebeam(1)-ebeam(2))/MAX(ebeam(1)+ebeam(2),1d-17).LT.1d-8)THEN
            absrap=absrap
            labeqcoll=.TRUE.
         ELSE
            absrap=.FALSE.
            labeqcoll=.FALSE.
         ENDIF
         sqs=2d0*DSQRT(ebeam(1)*ebeam(2)) ! we always neglect the mass of initial states
         IF(fixtarget)sqs=sqs/DSQRT(2d0)
         EBMUP1=ebeam(1)
         EBMUP2=ebeam(2)
         IF(.NOT.fixtarget)THEN
            ycollcm=DLOG(ABS(ebeam(1))/ABS(ebeam(2)))/2d0
         ELSE
            IF(ABS(ebeam(1)).GT.ABS(ebeam(2)))THEN
               fixtargetrev=.FALSE.
               ycollcm=DLOG(1d0+2d0*ABS(ebeam(1))/ABS(ebeam(2)))/2d0
               FT_M=ebeam(2)
               FT_E1=ebeam(1)
               sqs=DSQRT(sqs**2+FT_M**2)
            ELSE
               fixtargetrev=.TRUE.
               ycollcm=-DLOG(1d0+2d0*ABS(ebeam(2))/ABS(ebeam(1)))/2d0
               FT_M=ebeam(1)
               FT_E1=ebeam(2)
               sqs=DSQRT(sqs**2+FT_M**2)
            ENDIF
         ENDIF
         CALL ReadElem_real('minpt1c',pt1c)
!         CALL ReadElem_real('maxpt1c',maxpt1c)
!         IF(maxpt1c.LT.0d0)THEN
!            maxpt1c=-1d0
!         ELSE
!            IF(maxpt1c.LE.pt1c)THEN
!               WRITE(*,*)"ERROR: the first final state was cut off by pt cut (pt1c,maxpt1c)"
!               STOP
!            ENDIF
!         ENDIF
         CALL ReadElem_real('maxy1c',y1cup)
         CALL ReadElem_real('miny1c',y1clow)
         CALL ReadElem_integer('pdf',pdfnumpdf)
         ptc(3:20)=0
         maxptc(3:20)=-1d0
         drc(3:20,3:20)=0
         etac(3:20)=20
         ec(3:20)=0
         c1(3:20)=1
         c2(3:20)=1
         cc(3:20,3:20)=1
         yycut(3:20)=1d9
         IF(absrap)THEN
            yycutlow(3:20)=0d0
         ELSE
            yycutlow(3:20)=-1d9
         ENDIF
         xFcut(3:20)=1d0
         xFcutlow(3:20)=-1d0
         gmas(3:20,3:20)=0
         gbeammass(1:2,3:20)=0
         
         parmas(0)=0
         parwid(0)=-1
         iPDFSUP1=pdfnumpdf
         IF(pdfnumpdf.EQ.0.OR.COLL_TYPE.EQ.3)THEN
            istruc=0
         ELSE
            istruc=1
         ENDIF
         IF(istruc.EQ.1)THEN
            iPDFGUP1=0
            iPDFGUP2=0
            iPDFSUP1=pdfnumpdf
            iPDFSUP2=pdfnumpdf
         ELSE
            iPDFGUP1=-1
            iPDFGUP2=-1
            iPDFSUP1=-1
            iPDFSUP2=-1
         ENDIF
         xp1=1
         xp2=1
         IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
            CALL readcuts_pp_psipsipsi_dps
            y1cup=MIN(y1cup,yycut(3))
            y1clow=MAX(y1clow,yycutlow(3))
            IF(absrap)y1cup=ABS(y1cup)
            IF(absrap)y1clow=ABS(y1clow)
         ENDIF
         IF(NDecayChains_DPS.GT.0)CALL readcuts_Decay
         istat=0
         IF(lnum.NE.0)THEN
            ALLOCATE(lr(lnum),STAT=istat)
         ENDIF
         IF(snum.NE.0)THEN
            ALLOCATE(sr(snum),STAT=istat)
         ENDIF
         ALLOCATE(mr(nhad),STAT=istat)
         ALLOCATE(ptcut(nhad),STAT=istat)
         ALLOCATE(ymincut(nhad),STAT=istat)
         ALLOCATE(ymaxcut(nhad),STAT=istat)
         IF(istat.NE.0)THEN
            PRINT *,"Wrong in allocation of array in pp_psipsipsiX_DPS_fxn !STOP !"
            STOP
         ENDIF
         kk=3
         mtot=0d0
         mr(1)=0d0
         mr(2)=0d0
         ptcut(1:2)=0d0
         ymincut(1:2)=0d0
         ymaxcut(1:2)=0d0
         DO ii=3,nhad
            IF(ABS(iflh(ii)).GT.100)THEN
               mr(ii)=parmas(ifl(kk))+parmas(ifl(kk+1))
               IF(absrap)THEN
                  ymincut(ii)=yycutlow(kk)
                  ymaxcut(ii)=yycut(kk)
               ELSE
                  ymincut(ii)=yycutlow(kk)-ycollcm
                  ymaxcut(ii)=yycut(kk)-ycollcm
               ENDIF
               ptcut(ii)=ptc(kk)+ptc(kk+1)
               kk=kk+2
            ELSE
               mr(ii)=parmas(ifl(kk))
               IF(absrap)THEN
                  ymincut(ii)=yycutlow(kk)
                  ymaxcut(ii)=yycut(kk)
               ELSE
                  ymincut(ii)=yycutlow(kk)-ycollcm
                  ymaxcut(ii)=yycut(kk)-ycollcm
               ENDIF
               ptcut(ii)=ptc(kk)
               kk=kk+1
            ENDIF
            IF(ymincut(ii).GT.ymaxcut(ii))THEN
               WRITE(*,*)"All events are cutted off !"
               WRITE(*,*)"k, ycmin, ycmax"
               WRITE(*,*)ii,ymincut(ii),ymaxcut(ii)
               WRITE(*,*)"BYE !"
               STOP
            ENDIF
            mtot=mtot+mr(ii)
         ENDDO
         IF(COLL_TYPE.NE.3.AND.(istruc.EQ.1.OR.istruc.EQ.2))THEN
            ptcut(3)=MAX(ptcut(3),pt1c)
            IF(absrap)THEN
               ymincut(3)=MAX(y1clow,ymincut(3))
               ymaxcut(3)=MIN(y1cup,ymaxcut(3))
            ELSE
               ymincut(3)=MAX(y1clow-ycollcm,ymincut(3))
               ymaxcut(3)=MIN(y1cup-ycollcm,ymaxcut(3))
            ENDIF
         ENDIF
         IF(ymincut(3).GE.ymaxcut(3))THEN
            WRITE(*,*)"All events are cutted off !"
            WRITE(*,*)"k, ycmin, ycmax"
            WRITE(*,*)3,ymincut(3),ymaxcut(3)
            WRITE(*,*)"BYE !"
            STOP
         ENDIF
         sq=sqs*sqs
         init=1
      ENDIF
      nnntot=nnntot+1
      wdps=1d0
      kk=1
      acc_xp1=0d0
      acc_xp2=0d0
      DO ipip=1,2
         ! the ipip-th SPS
         IF(ipip.EQ.1)THEN
            jac=1d0
            phadmom(1,1:2)=0
            phadmom(1,3)=sqs/2d0
            phadmom(1,4)=sqs/2d0
            phadmom(2,1:2)=0
            phadmom(2,3)=-sqs/2d0
            phadmom(2,4)=sqs/2d0
            pmom(1:4)=phadmom(1,1:4)+phadmom(2,1:4)
            rlogmax=sqs
            rlogmin=sqs
            mres=mtot
            DO ii=3,nhad-1
               Q=scalarproduction2(pmom(1:4))
               mi=mr(ii)
               mres=mres-mi
               phi0=ph42(pmom)
               pt0=transverse2(pmom)
               y0=rapidity2(pmom)
               ! generate phi
               IF(ii.EQ.3)THEN
                  phi=2D0*pi*x(kk)
                  kk=kk+1
                  jactemp=2d0*pi
                  lflag=.TRUE.
               ELSEIF(ii.EQ.nhad-1)THEN
                  CALL generate_phi_DPS(1,Q,mi,mres,phi0,pt0,x(kk),phi,jactemp,lflag)
                  kk=kk+1
               ELSE
                  CALL generate_phi_DPS(1,Q,mi,mres,phi0,pt0,x(kk),phi,jactemp,lflag)
                  kk=kk+1
               ENDIF
               IF(.NOT.lflag)THEN
                  pp_psipsipsiX_DPS_fxn=0d0
                  RETURN
               ENDIF
               jac=jac*jactemp
               ! generate pt
               CALL generate_pt_DPS(Q,mi,mres,phi0,phi,pt0,x(kk),ptcut(ii),pti,jactemp,lflag)
               kk=kk+1
               IF(.NOT.lflag)THEN
                  pp_psipsipsiX_DPS_fxn=0d0
                  RETURN
               ENDIF
               jac=jac*jactemp*2d0*pti ! from d pti^2 -> d pti
               ! generate yi
               CALL generate_yi_DPS(Q,mi,mres,phi0,phi,pt0,pti,y0,x(kk),ymaxcut(ii),ymincut(ii),&
                    yi,jactemp,lflag)
               kk=kk+1
               IF(.NOT.lflag)THEN
                  pp_psipsipsiX_DPS_fxn=0d0
                  RETURN
               ENDIF
               jac=jac*jactemp
               ! momentum assignment
               mti=DSQRT(mi**2+pti**2)
               phadmom(ii,4)=mti*DCOSH(yi)
               phadmom(ii,3)=mti*DSINH(yi)
               phadmom(ii,1)=pti*DCOS(phi)
               phadmom(ii,2)=pti*DSIN(phi)
               pmom(1:4)=pmom(1:4)-phadmom(ii,1:4)
               rlogmax=rlogmax-mti*DEXP(yi)
               rlogmin=rlogmin-mti*DEXP(-yi)
               IF(.NOT.fixtarget)THEN
                  acc_xp1=acc_xp1+DEXP(yi)*mti
                  acc_xp2=acc_xp2+DEXP(-yi)*mti
               ELSE
                  IF(.NOT.fixtargetrev)THEN
                     acc_xp1=acc_xp1+DSINH(yi)*mti
                     acc_xp2=acc_xp2+DEXP(-yi)*mti
                  ELSE
                     acc_xp1=acc_xp1+DEXP(yi)*mti
                     acc_xp2=acc_xp2+DSINH(-yi)*mti
                  ENDIF
               ENDIF
            ENDDO
            ! generate yn
            IF(rlogmax.LE.0d0.OR.rlogmin.LE.0d0)THEN
               pp_psipsipsiX_DPS_fxn=0d0
               RETURN
            ENDIF
            pti=transverse2(pmom)
            mi=mr(nhad)
            mti=DSQRT(pti**2+mi**2)
            rlogmax=DLOG(rlogmax/mti)
            rlogmin=-DLOG(rlogmin/mti)
            CALL generate_yn_DPS(rlogmax,rlogmin,x(kk),ymaxcut(nhad),ymincut(nhad),yn,jactemp,lflag)
            kk=kk+1
            IF(.NOT.lflag)THEN
               pp_psipsipsiX_DPS_fxn=0d0
               RETURN
            ENDIF
            jac=jac*jactemp
            IF(ycollcm.EQ.0d0)THEN
               acc_xp1=acc_xp1+DEXP(yn)*mti
               acc_xp2=acc_xp2+DEXP(-yn)*mti
               acc_xp1=acc_xp1/sqs
               acc_xp2=acc_xp2/sqs
            ELSE
               IF(.NOT.fixtarget)THEN
                  acc_xp1=acc_xp1+DEXP(yn)*mti
                  acc_xp2=acc_xp2+DEXP(-yn)*mti
                  acc_xp1=acc_xp1/(2d0*ebeam(1))
                  acc_xp2=acc_xp2/(2d0*ebeam(2))
               ELSE
                  IF(.NOT.fixtargetrev)THEN
                     acc_xp1=acc_xp1+DSINH(yn)*mti
                     acc_xp2=acc_xp2+DEXP(-yn)*mti
                  ELSE
                     acc_xp1=acc_xp1+DEXP(yn)*mti
                     acc_xp2=acc_xp2+DSINH(-yn)*mti
                  ENDIF
                  acc_xp1=acc_xp1/(ebeam(1))
                  acc_xp2=acc_xp2/(ebeam(2))
               ENDIF
            ENDIF
            IF(acc_xp1.GT.1d0.OR.acc_xp1.LE.0d0.OR.&
                 acc_xp2.GT.1d0.OR.acc_xp2.LE.0d0)THEN
               pp_psipsipsiX_DPS_fxn=0d0
               RETURN
            ENDIF
            xp1=acc_xp1
            xp2=acc_xp2
            ehat=DSQRT(xp1*xp2*sq)
            IF(fixtarget)THEN
               IF(.NOT.fixtargetrev)THEN
                  exp1=exp1+FT_M*xp1/2d0
                  exp2=exp2/2d0
               ELSE
                  exp2=exp2+FT_M*xp2/2d0
                  exp1=exp1/2d0
               ENDIF
            ENDIF
            ! generate the momenta of external legs
            ! initial states
            Phegas_pmom(1,1:2)=0
            Phegas_pmom(1,3)=xp1*sqs/2d0
            Phegas_pmom(1,4)=xp1*sqs/2d0
            Phegas_pmom(1:2,5)=0
            Phegas_pmom(2,1:2)=0
            Phegas_pmom(2,3)=-xp2*sqs/2d0
            Phegas_pmom(2,4)=xp2*sqs/2d0
            ! final states
            kk2=3
            phadmom(nhad,1:4)=Phegas_pmom(1,1:4)+Phegas_pmom(2,1:4)
            DO ii=3,nhad-1
               pmom(1)=phadmom(ii,1)
               pmom(2)=phadmom(ii,2)
               pmom(3)=phadmom(ii,3)
               pmom(4)=phadmom(ii,4)
               phadmom(nhad,1)=phadmom(nhad,1)-phadmom(ii,1)
               phadmom(nhad,2)=phadmom(nhad,2)-phadmom(ii,2)
               phadmom(nhad,3)=phadmom(nhad,3)-phadmom(ii,3)
               phadmom(nhad,4)=phadmom(nhad,4)-phadmom(ii,4)
               IF(ABS(iflh(ii)).GT.100)THEN
                  Phegas_pmom(kk2,1:4)=parmas(ifl(kk2))/(parmas(ifl(kk2))+parmas(ifl(kk2+1)))*pmom(1:4)
                  Phegas_pmom(kk2,5)=parmas(ifl(kk2))
                  Phegas_pmom(kk2+1,1:4)=parmas(ifl(kk2+1))/(parmas(ifl(kk2))+parmas(ifl(kk2+1)))*pmom(1:4)
                  Phegas_pmom(kk2+1,5)=parmas(ifl(kk2+1))
                  kk2=kk2+2
               ELSE
                  Phegas_pmom(kk2,1:4)=pmom(1:4)
                  Phegas_pmom(kk2,5)=parmas(ifl(kk2))
                  kk2=kk2+1
               ENDIF
            ENDDO
            ! assign the dps_pmom (final state only)
            DO ii=3,nhad
               dps_pmom(ipip,ii,1)=phadmom(ii,1)
               dps_pmom(ipip,ii,2)=phadmom(ii,2)
               dps_pmom(ipip,ii,3)=phadmom(ii,3)
               dps_pmom(ipip,ii,4)=phadmom(ii,4)
            ENDDO
            ! for the nhad-th particle
            pmom(1)=phadmom(nhad,1)
            pmom(2)=phadmom(nhad,2)
            pmom(3)=phadmom(nhad,3)
            pmom(4)=phadmom(nhad,4)
            IF(ABS(iflh(nhad)).GT.100)THEN
               Phegas_pmom(kk2,1:4)=parmas(ifl(kk2))/(parmas(ifl(kk2))+parmas(ifl(kk2+1)))*pmom(1:4)
               Phegas_pmom(kk2,5)=parmas(ifl(kk2))
               Phegas_pmom(kk2+1,1:4)=parmas(ifl(kk2+1))/(parmas(ifl(kk2))+parmas(ifl(kk2+1)))*pmom(1:4)
               Phegas_pmom(kk2+1,5)=parmas(ifl(kk2+1))
               kk2=kk2+2
            ELSE
               Phegas_pmom(kk2,1:4)=pmom(1:4)
               Phegas_pmom(kk2,5)=parmas(ifl(kk2))
               kk2=kk2+1
            ENDIF
            IF(NDecayChains_DPS.EQ.0)THEN
               ! boost from collision frame to cms
               pmom(3)=-(xp1-xp2)*sqs/2d0
               pmom(4)=(xp1+xp2)*sqs/2d0
               pmom(1:2)=0
            ELSE
               ! boost from collision frame to lab frame in polarisation
               IF(.NOT.fixtarget)THEN
                  pmom(3)=ebeam(1)-ebeam(2)
                  pmom(4)=ebeam(1)+ebeam(2)
               ELSE
                  IF(.NOT.fixtargetrev)THEN
                     pmom(3)=ebeam(1)
                     pmom(4)=ebeam(1)+ebeam(2)
                  ELSE
                     pmom(3)=-ebeam(2)
                     pmom(4)=ebeam(1)+ebeam(2)
                  ENDIF
               ENDIF
               pmom(1:2)=0
            ENDIF
            DO j=1,n
               !IF(NDecayChains_DPS.EQ.0)THEN
               IF(Momenta_Frame.EQ.2)THEN
                  CALL Boostl(ehat,pmom,Phegas_pmom(j,1:4))
               ELSEIF(Momenta_Frame.EQ.1.AND..NOT.labeqcoll)THEN
                  CALL Boostl(sqs,pmom,Phegas_pmom(j,1:4))
               ENDIF
               ptp=DSQRT(Phegas_pmom(j,1)**2+Phegas_pmom(j,2)**2)
               pqp=DSQRT(ptp**2+Phegas_pmom(j,3)**2)
               zq(j,1)= DCMPLX(Phegas_pmom(j,4)+Phegas_pmom(j,3),Phegas_pmom(j,3))
               zq(j,2)= DCMPLX(Phegas_pmom(j,4)-Phegas_pmom(j,3),ptp)
               zq(j,3)= DCMPLX(Phegas_pmom(j,1), Phegas_pmom(j,2))
               zq(j,4)= DCMPLX(Phegas_pmom(j,1),-Phegas_pmom(j,2))
               zq(j,5)= DCMPLX(parmas(ifl(j)),pqp )
            ENDDO
            wdps=wdps/(4d0*(4d0*pi)**(2*nhad-7)*(2D0*pi)**(nhad-3)*ehat**4)&
                 *xp1*xp2*Jac*3.8937966d5 ! 3.8938573d5
         ELSE
            ioffset=kk-1
            IF(integration_DPS.NE.1)THEN
            temp1=(sq-mpsi(ipip-1)**2)/(2d0*sqs)
            pt=(temp1-pt1c)*x(3+ioffset)+pt1c
            mt1=DSQRT(pt**2+mpsi(ipip-1)**2)
            mt2=pt
            IF(absrap)THEN
               temp2=MIN(ACosh_p((sq+mpsi(ipip-1)**2)/(2d0*sqs*mt1)),y1cup)
               IF(temp2.LT.y1clow)THEN
                  pp_psipsipsiX_DPS_fxn=0d0
                  RETURN
               ENDIF
               y1=(2d0*x(1+ioffset)-1d0)*(temp2-y1clow)+SIGN(1d0,x(1+ioffset)-0.5d0)*y1clow
            ELSE
               temp2=MIN(ACosh_p((sq+mpsi(ipip-1)**2)/(2d0*sqs*mt1)),y1cup-ycollcm)
               temp21=MAX(-ACosh_p((sq+mpsi(ipip-1)**2)/(2d0*sqs*mt1)),y1clow-ycollcm)
               IF(temp2.LT.temp21)THEN
                  pp_psipsipsiX_DPS_fxn=0d0
                  RETURN
               ENDIF
               y1=(temp2-temp21)*x(1+ioffset)+temp21 ! in collision frame
            ENDIF
            temp3=DLOG((-DEXP(-y1)*mt1+sqs)/mt2)
            temp4=temp3+DLOG((-DEXP(y1)*mt1+sqs)/mt2)
            y2=-temp3+temp4*x(2+ioffset) ! in collision frame
            Jpt2=2d0*pt*(temp1-pt1c)
            IF(absrap)THEN
               Jy1=2d0*(temp2-y1clow)
            ELSE
               Jy1=temp2-temp21
            ENDIF
            Jy2=temp4
            ELSE
               ! randomly picking up an unweighted event
               i_pick=Nevent_pp_psiX_CB*rand()+1
               y1=rapidity(pmom_pp_psiX_CB(i_pick,3,1:4))
               y2=rapidity(pmom_pp_psiX_CB(i_pick,4,1:4))
               mt1=DSQRT(pmom_pp_psiX_CB(i_pick,3,1)**2+pmom_pp_psiX_CB(i_pick,3,2)**2+mpsi(ipip-1)**2)
               mt2=DSQRT(pmom_pp_psiX_CB(i_pick,4,1)**2+pmom_pp_psiX_CB(i_pick,4,2)**2)
            ENDIF
            IF((DEXP(y1)*mt1+DEXP(y2)*mt2)/sqs+acc_xp1.GE.1d0)THEN
               pp_psipsipsiX_DPS_fxn=0d0
               RETURN
            ENDIF
            IF((DEXP(-y1)*mt1+DEXP(-y2)*mt2)/sqs+acc_xp2.GE.1d0)THEN
               pp_psipsipsiX_DPS_fxn=0d0
               RETURN
            ENDIF
            IF(ycollcm.EQ.0d0)THEN
               xp1=(DEXP(y1)*mt1+DEXP(y2)*mt2)/sqs
               xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/sqs
            ELSE
               IF(.NOT.fixtarget)THEN
                  xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2)/(2d0*ebeam(1))
                  xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/(2d0*ebeam(2))
               ELSE
                  IF(.NOT.fixtargetrev)THEN
                     xp1=(DSINH(y1)*mt1 + DSINH(y2)*mt2)/(ebeam(1))
                     xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/(ebeam(2))
                  ELSE
                     xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2)/(ebeam(1))
                     xp2=(DSINH(-y1)*mt1+DSINH(-y2)*mt2)/(ebeam(2))
                  ENDIF
               ENDIF
            ENDIF
            acc_xp1=acc_xp1+xp1
            acc_xp2=acc_xp2+xp2
            ehat=DSQRT(xp1*xp2*sq)
            IF(integration_DPS.NE.1)THEN
               wdps=wdps*xp1*xp2*Jpt2*Jy1*Jy2*3.8937966d5/(16d0*pi*ehat**4)
            ELSE
               wdps=wdps*sigma_pp_psiX_CB
            ENDIF
            exp1=xp1*ebeam(1)
            exp2=xp2*ebeam(2)
            IF(fixtarget)THEN
               IF(.NOT.fixtargetrev)THEN
                  exp1=exp1+FT_M*xp1/2d0
                  exp2=exp2/2d0
               ELSE
                  exp2=exp2+FT_M*xp2/2d0
                  exp1=exp1/2d0
               ENDIF
            ENDIF
            IF(integration_DPS.NE.1)THEN
               phi=2D0*pi*x(4+ioffset)
               ! assign the dps_pmom (final state only)
               dps_pmom(ipip,3,1)=pt*DCOS(phi)
               dps_pmom(ipip,3,2)=pt*DSIN(phi)
               dps_pmom(ipip,3,3)=mt1*DSINH(y1)
               dps_pmom(ipip,3,4)=mt1*DCOSH(y1)
               dps_pmom(ipip,4,1)=-pt*DCOS(phi)
               dps_pmom(ipip,4,2)=-pt*DSIN(phi)
               dps_pmom(ipip,4,3)=mt2*DSINH(y2)
               dps_pmom(ipip,4,4)=mt2*DCOSH(y2)
            ELSE
               dps_pmom(ipip,3,1)=pmom_pp_psiX_CB(i_pick,3,1)
               dps_pmom(ipip,3,2)=pmom_pp_psiX_CB(i_pick,3,2)
               dps_pmom(ipip,3,3)=pmom_pp_psiX_CB(i_pick,3,3)
               dps_pmom(ipip,3,4)=pmom_pp_psiX_CB(i_pick,3,4)
               dps_pmom(ipip,4,1)=pmom_pp_psiX_CB(i_pick,4,1)
               dps_pmom(ipip,4,2)=pmom_pp_psiX_CB(i_pick,4,2)
               dps_pmom(ipip,4,3)=pmom_pp_psiX_CB(i_pick,4,3)
               dps_pmom(ipip,4,4)=pmom_pp_psiX_CB(i_pick,4,4)
            ENDIF
         ENDIF
         ! assign the dps_pmom (initial state only)
         dps_pmom(ipip,1,1:2)=0
         dps_pmom(ipip,1,3)=xp1*sqs/2d0
         dps_pmom(ipip,1,4)=xp1*sqs/2d0
         dps_pmom(ipip,2,1:2)=0
         dps_pmom(ipip,2,3)=-xp2*sqs/2d0
         dps_pmom(ipip,2,4)=xp2*sqs/2d0
         Momenta_Frame=1
         ! boost from collision frame to lab frame
         IF(.NOT.fixtarget)THEN
            pmom(3)=ebeam(1)-ebeam(2)
            pmom(4)=ebeam(1)+ebeam(2)
         ELSE
            IF(.NOT.fixtargetrev)THEN
               pmom(3)=ebeam(1)
               pmom(4)=ebeam(1)+ebeam(2)
            ELSE
               pmom(3)=-ebeam(2)
               pmom(4)=ebeam(1)+ebeam(2)
            ENDIF
         ENDIF
         pmom(1:2)=0
         IF(.NOT.labeqcoll)THEN
            IF(ipip.EQ.1)THEN
               DO j=1,nhad
                  CALL Boostl(sqs,pmom,dps_pmom(ipip,j,1:4))
               ENDDO
            ELSE
               DO j=1,4
                  CALL Boostl(sqs,pmom,dps_pmom(ipip,j,1:4))
               ENDDO
            ENDIF
         ENDIF
         IF(pdfnumpdf.EQ.921000)THEN
            ! GS 09 dPDF
            IF(ipip.EQ.1)THEN
               xp11=xp1
               xp21=xp2
               xp1_1st=xp1
               xp2_1st=xp2
               CALL qcdscale(scale1)
               scale1=scale1*muF_over_ref
               scale_as_1st=scale1*muR_over_ref
            ELSE
               scale2=dps_pmom(ipip,3,1)**2+dps_pmom(ipip,3,2)**2+mpsi(ipip-1)**2
               scale2=DSQRT(scale2)
               scale_dpdf=DSQRT(scale1*scale2)
               IF(dps_istate(1).NE.4.AND.dps_istate(1).NE.8)THEN
                  CALL GS09(xp11,xp1,scale_dpdf,0,0,wsf)
               ELSEIF(dps_istate(1).EQ.4)THEN
                  wsf=0d0
                  DO j=1,3
                     CALL GS09(xp11,xp1,scale_dpdf,j,0,wsf0)
                     wsf=wsf+wsf0
                     CALL GS09(xp11,xp1,scale_dpdf,-j,0,wsf0)
                     wsf=wsf+wsf0
                  ENDDO
               ELSEIF(dps_istate(1).EQ.8)THEN
                  wsf=0d0
                  DO j=1,4
                     CALL GS09(xp11,xp1,scale_dpdf,j,0,wsf0)
                     wsf=wsf+wsf0
                     CALL GS09(xp11,xp1,scale_dpdf,-j,0,wsf0)
                     wsf=wsf+wsf0
                  ENDDO
               ENDIF
               wdps=wdps*wsf
               IF(dps_istate(1).NE.3.OR.dps_istate(1).NE.7)THEN
                  CALL GS09(xp21,xp2,scale_dpdf,0,0,wsf)
               ELSEIF(dps_istate(1).EQ.3)THEN
                  wsf=0d0
                  DO j=1,3
                     CALL GS09(xp21,xp2,scale_dpdf,j,0,wsf0)
                     wsf=wsf+wsf0
                     CALL GS09(xp21,xp2,scale_dpdf,-j,0,wsf0)
                     wsf=wsf+wsf0
                  ENDDO
               ELSEIF(dps_istate(1).EQ.7)THEN
                  wsf=0d0
                  DO j=1,4
                     CALL GS09(xp21,xp2,scale_dpdf,j,0,wsf0)
                     wsf=wsf+wsf0
                     CALL GS09(xp21,xp2,scale_dpdf,-j,0,wsf0)
                     wsf=wsf+wsf0
                  ENDDO
               ENDIF
               wdps=wdps*wsf
               ! CALL GSALPS(Q) to run alpha_S, which is not used here
            ENDIF
         ELSE
            IF(ipip.EQ.1.OR.integration_DPS.NE.1)THEN
               CALL strf_pdf_pp_psipsipsi_dps(ipip,wsf)
            ENDIF
            IF(ipip.EQ.1)THEN
               xp1_1st=xp1
               xp2_1st=xp2
               wsf_1st=wsf
            ENDIF
            IF(ipip.EQ.1.OR.integration_DPS.NE.1)THEN
               wdps=wdps*wsf
            ENDIF
         ENDIF
      ENDDO
      IF(wdps.LE.0d0)THEN
         pp_psipsipsiX_DPS_fxn=0d0
         RETURN
      ENDIF
      CALL pp_psipsipsi_dps_hadronmom
      icut=1
      CALL Cuts_pp_psipsipsi_dps(icut)
      IF(icut.EQ.0)THEN
         pp_psipsipsiX_DPS_fxn=0d0
         RETURN
      ENDIF
      IF(irun.EQ.1)CALL Helac_FeynRule_SM() ! reload the Feynman Rules
      ! set the random number for random helicity method
      ! one has two partonic scatterings
      IF(integration_DPS.NE.1)THEN
         kk=ioffset+4+1
      ELSE
         kk=ioffset+1
      ENDIF
      IF(.NOT.MCoHelicity)THEN
         DO j=1,lnum
            lr(j)=2D0*pi*x(kk)
            kk=kk+1
         ENDDO
         DO j=1,snum
            sr(j)=2D0*pi*x(kk)
            kk=kk+1
         ENDDO
         CALL SetRandom(lr,sr)
         IF(NDecayChains_DPS.GT.0)THEN
            DO j=kk,varnum
               Decayran(j-kk+1)=x(j)
            ENDDO
         ENDIF
      ELSE
         RMCoH=x(kk)
         DO j=kk+1,varnum
            Decayran(j-kk)=x(j)
         ENDDO
      ENDIF
      xp1=xp1_1st
      xp2=xp2_1st
      DO ipip=1,2
         IF(ipip.EQ.1)THEN
            CALL Helac_master_f(wme)
            GLOBALINIT_master=1
            IF((reweight_scale.OR.pdfnumpdf.EQ.92100).AND.nnn.LE.1)THEN
               reweight_scale_phase=.TRUE.
               CALL Helac_FeynRule_SM()
               CALL Helac_master_f(wme0)
               IF(nnn.EQ.0)THEN
                  alphas_power=NINT(DLOG10(wme/wme0))
                  IF(ABS(DLOG10(wme/wme0)-DBLE(alphas_power)).GT.0.05d0)THEN
                     WRITE(*,*)"ERROR:Reweighting scale/dPDF cannot be used for mixed order processes !"
                     STOP
                  ENDIF
               ELSE
                  IF(NINT(DLOG10(wme/wme0)).NE.alphas_power)THEN
                     WRITE(*,*)"WARNING:The process is a mixed order process.Reweighting scale/dPDF may be wrong !"
                  ENDIF
               ENDIF
               reweight_scale_phase=.FALSE.
            ENDIF
            IF(pdfnumpdf.EQ.92100.AND.alphas_power.GT.0)THEN
               ! use the internal GSALPS(Q) provided by GS 09 dPDF
               alps1=GSALPS(scale_as_1st)
               alps2=ALPHAS(scale_as_1st)
               wme=wme*(alps1/alps2)**alphas_power
            ENDIF
         ELSEIF(integration_DPS.NE.1)THEN
            CALL crystalball_gg_psiX(ipip,wme)
         ENDIF
         IF(ipip.EQ.1.OR.integration_DPS.NE.1)THEN
            wdps=wdps*wme
         ENDIF
         IF(wdps.LE.0d0)THEN
            pp_psipsipsiX_DPS_fxn=0d0
            RETURN
         ENDIF
      ENDDO
      IF(NDecayChains_DPS.GT.0)THEN
         CALL HO_Decay_pp_psipsipsi_dps(weight_br)
         IF(weight_br.LE.0d0)THEN
            pp_psipsipsiX_DPS_fxn=0d0
            RETURN
         ENDIF
         CALL cuts_Decay_pp_psipsipsi_dps(icut)
         IF(icut.EQ.0)THEN
            pp_psipsipsiX_DPS_fxn=0d0
            RETURN
         ENDIF
         wdps=wdps*weight_br
      ENDIF
      IF(reweight_scale)THEN
         xp1=xp1_1st
         xp2=xp2_1st
         CALL pp_psipsipsi_DPS_reweight_xsec_scale(wsf_1st)
      ENDIF
      pp_psipsipsiX_DPS_fxn=wdps*LDMEwt/dps_sigmaeff
      IF(lunwei2.AND.lwmax.GT.0)THEN
         w1=pp_psipsipsiX_DPS_fxn*wgt ! multiply VEGAS weight
         CALL unwei_procedure_pp_psipsipsi_dps(w1,nwri,nwmax,nwarn)
      ENDIF
      IF(plot_output)THEN
         w1=pp_psipsipsiX_DPS_fxn*wgt
         CALL outfun_pp_psipsipsi_dps(w1)
      ENDIF
      nnn=nnn+1
      IF(recmax.LT.pp_psipsipsiX_DPS_fxn)recmax=pp_psipsipsiX_DPS_fxn
      IF(recmin.GT.pp_psipsipsiX_DPS_fxn)recmin=pp_psipsipsiX_DPS_fxn
      IF(MOD(nnn,nprint).EQ.0)THEN
         PRINT *,"max=",recmax
         PRINT *,"min=",recmin
         IF(lunwei2.AND.lwmax.GT.1)THEN
            PRINT *,"      n_event,    n_pass,    n_total"
            PRINT *,nwri,nnn,nnntot
         ELSE
            PRINT *, "      n_pass,     n_total"
            PRINT *,nnn,nnntot
         ENDIF
      ENDIF
    END FUNCTION pp_psipsipsiX_DPS_fxn

    SUBROUTINE pp_psipsipsi_DPS_reweight_xsec_scale(wsf0)
      IMPLICIT NONE
      REAL(KIND(1d0)),INTENT(IN)::wsf0
      REAL(KIND(1d0))::alphasc=1d0,alphasu=1d0,alphasd=1d0
      REAL(KIND(1d0)),DIMENSION(3)::R_alphas,R_pdf
      REAL(KIND(1d0))::wsfw
      INTEGER::i,j
      REAL(KIND(1d0)),EXTERNAL::GSALPS
      IF(.NOT.reweight_scale)THEN
         WRITE(*,*)"ERROR:Please set reweight_scale to be T first !"
         STOP
      ENDIF
      ! reweighting for alpha_s
      IF(alphas_power.EQ.0)THEN
         alphasc=1d0
         alphasu=1d0
         alphasd=1d0
      ELSE
         CALL qcdscale(scale)
         scale=scale*muR_over_ref
         IF(iPDFSUP1.NE.921000)THEN
            alphasc=ALPHAS(scale)
            alphasu=ALPHAS(scale*rw_Rscale_up)
            alphasd=ALPHAS(scale*rw_Rscale_down)
         ELSE
            ! use GS09 dPDF
            ! then use GSALPS(Q)
            alphasc=GSALPS(scale)
            alphasu=GSALPS(scale*rw_Rscale_up)
            alphasd=GSALPS(scale*rw_Rscale_down)
         ENDIF
      ENDIF
      R_alphas(1)=1d0
      R_alphas(2)=(alphasu/alphasc)**alphas_power
      R_alphas(3)=(alphasd/alphasc)**alphas_power
      R_pdf(1)=1d0
      IF(istruc.EQ.1.AND.iPDFSUP1.NE.921000)THEN
         ! exclude the GS 09 dPDF
         reweight_Fscale_phase=1 ! 1: multiply central scale * rw_Fscale_up
         CALL strf_pdf_pp_psipsipsi_dps(1,wsfw)
         R_pdf(2)=wsfw/wsf0
         reweight_Fscale_phase=-1 ! -1: mutliply central scale * rw_Fscale_down
         CALL strf_pdf_pp_psipsipsi_dps(1,wsfw)
         R_pdf(3)=wsfw/wsf0
         ! recover it 
         reweight_Fscale_phase=0
      ELSE
         R_pdf(2:3)=1d0
      ENDIF
      wgtxsecmu(1:3,1:3)=1d0
      DO i=1,3
         wgtxsecmu(i,1:3)=R_alphas(i)
         DO j=1,3
            wgtxsecmu(i,j)=wgtxsecmu(i,j)*R_pdf(j)
         ENDDO
      END DO
      RETURN
    END SUBROUTINE pp_psipsipsi_DPS_reweight_xsec_scale

    SUBROUTINE strf_pdf_pp_psiX_cb_DPS(wsf)
      USE CTEQ6PDF
      USE Structf_PDFs
      IMPLICIT NONE
      INTEGER::ipp=1
      INTEGER::ih=1 ! ih=1 no photon PDF, ih=2, photon from proton/anti-proton, ih=3 phton from electron/positron
      REAL(KIND(1d0)),INTENT(OUT)::wsf
      INTEGER::init=0
      LOGICAL::use_cteq6_f90=.TRUE.
      REAL(KIND=DBL),DIMENSION(-7:7)::pdflist
      SAVE init,ipp,use_cteq6_f90
      REAL(KIND(1d0))::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
                ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct
      INCLUDE "../lhapdf/call_strf_cb_lhapdf"
      IF(init.EQ.0)THEN
         SELECT CASE(iPDFSUP1)
         CASE(10000)
            CALL SetCtq6f90(1)
            pdlabel='cteq6_m'
            nloop=2
            alphaQCD2=0.118d0
            use_cteq6_f90=.TRUE.
         CASE(10041)
            CALL SetCtq6f90(3)
            pdlabel='cteq6_l'
            nloop=2
            alphaQCD2=0.118d0
            use_cteq6_f90=.TRUE.
         CASE(10042)
            CALL SetCtq6f90(4)
            pdlabel='cteq6l1'
            nloop=1
            alphaQCD2=0.130d0
            use_cteq6_f90=.TRUE.
         CASE DEFAULT
            CALL pdfset_internal
            use_cteq6_f90=.FALSE.
         END SELECT
         IF(COLL_TYPE.EQ.1)THEN
            ipp=2
         ELSE
            ipp=1
         ENDIF
         init=1
      ENDIF

      scale=cb_pmom(3,1)**2+cb_pmom(3,2)**2+mpsi(1)**2
      scale=DSQRT(scale)
      IF(use_cteq6_f90)THEN
         glu1_ct = xp1*Ctq6Pdf_f90(0,xp1,scale)
         glu2_ct = xp2*Ctq6Pdf_f90(0,xp2,scale)
         u1_ct   = xp1*Ctq6Pdf_f90(1,xp1,scale)
         u2_ct   = xp2*Ctq6Pdf_f90(1,xp2,scale)
         d1_ct   = xp1*Ctq6Pdf_f90(2,xp1,scale)
         d2_ct   = xp2*Ctq6Pdf_f90(2,xp2,scale)
         s1_ct   = xp1*Ctq6Pdf_f90(3,xp1,scale)
         s2_ct   = xp2*Ctq6Pdf_f90(3,xp2,scale)
         c1_ct   = xp1*Ctq6Pdf_f90(4,xp1,scale)
         c2_ct   = xp2*Ctq6Pdf_f90(4,xp2,scale)
         b1_ct   = xp1*Ctq6Pdf_f90(5,xp1,scale)
         b2_ct   = xp2*Ctq6Pdf_f90(5,xp2,scale)
         ub1_ct  = xp1*Ctq6Pdf_f90(-1,xp1,scale)
         ub2_ct  = xp2*Ctq6Pdf_f90(-1,xp2,scale)
         db1_ct  = xp1*Ctq6Pdf_f90(-2,xp1,scale)
         db2_ct  = xp2*Ctq6Pdf_f90(-2,xp2,scale)
         sb1_ct  = xp1*Ctq6Pdf_f90(-3,xp1,scale)
         sb2_ct  = xp2*Ctq6Pdf_f90(-3,xp2,scale)
         cb1_ct  = xp1*Ctq6Pdf_f90(-4,xp1,scale)
         cb2_ct  = xp2*Ctq6Pdf_f90(-4,xp2,scale)
         bb1_ct  = xp1*Ctq6Pdf_f90(-5,xp1,scale)
         bb2_ct  = xp2*Ctq6Pdf_f90(-5,xp2,scale)
      ELSE
         CALL fdist(ih,xp1,scale,pdflist(-7:7))
         glu1_ct = xp1*pdflist(0)
         u1_ct   = xp1*pdflist(2)
         d1_ct   = xp1*pdflist(1)
         s1_ct   = xp1*pdflist(3)
         c1_ct   = xp1*pdflist(4)
         b1_ct   = xp1*pdflist(5)
         ub1_ct  = xp1*pdflist(-2)
         db1_ct  = xp1*pdflist(-1)
         sb1_ct  = xp1*pdflist(-3)
         cb1_ct  = xp1*pdflist(-4)
         bb1_ct  = xp1*pdflist(-5)
         CALL fdist(ih,xp2,scale,pdflist(-7:7))
         glu2_ct = xp2*pdflist(0)
         u2_ct   = xp2*pdflist(2)
         d2_ct   = xp2*pdflist(1)
         s2_ct   = xp2*pdflist(3)
         c2_ct   = xp2*pdflist(4)
         b2_ct   = xp2*pdflist(5)
         ub2_ct  = xp2*pdflist(-2)
         db2_ct  = xp2*pdflist(-1)
         sb2_ct  = xp2*pdflist(-3)
         cb2_ct  = xp2*pdflist(-4)
         bb2_ct  = xp2*pdflist(-5)
      ENDIF
      wsf=glu1_ct*glu2_ct*wjac/xp1/xp2
      IF(dps_includeqq)THEN
         wsf=wsf+(u1_ct*ub2_ct+d1_ct*db2_ct+s1_ct*sb2_ct+c1_ct*cb2_ct+&
              ub1_ct*u2_ct+db1_ct*d2_ct+sb1_ct*s2_ct+cb1_ct*c2_ct)*wjac/xp1/xp2
      ENDIF
      IF(init.EQ.0)init=1
    END SUBROUTINE strf_pdf_pp_psiX_cb_DPS

    SUBROUTINE strf_pdf_pp_psipsipsi_dps(ipip,wsf)
      USE CTEQ6PDF
      USE Structf_PDFs
      IMPLICIT NONE
      INTEGER::ipp=1
      INTEGER::ih=1 ! ih=1 no photon PDF, ih=2, photon from proton/anti-proton, ih=3 phton from electron/positron
      REAL(KIND(1d0)),INTENT(OUT)::wsf
      INTEGER,INTENT(IN)::ipip
      INTEGER::init=0
      LOGICAL::use_cteq6_f90=.TRUE.
      REAL(KIND=DBL),DIMENSION(-7:7)::pdflist
      SAVE init,ipp,use_cteq6_f90
      REAL(KIND(1d0))::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
                ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct
      INCLUDE "../lhapdf/call_strf_lhapdf"
      IF(init.EQ.0)THEN
         SELECT CASE(iPDFSUP1)
         CASE(10000)
            CALL SetCtq6f90(1)
            pdlabel='cteq6_m'
            nloop=2
            alphaQCD2=0.118d0
            use_cteq6_f90=.TRUE.
         CASE(10041)
            CALL SetCtq6f90(3)
            pdlabel='cteq6_l'
            nloop=2
            alphaQCD2=0.118d0
            use_cteq6_f90=.TRUE.
         CASE(10042)
            CALL SetCtq6f90(4)
            pdlabel='cteq6l1'
            nloop=1
            alphaQCD2=0.130d0
            use_cteq6_f90=.TRUE.
         CASE DEFAULT
            CALL pdfset_internal
            use_cteq6_f90=.FALSE.
         END SELECT
         IF(COLL_TYPE.EQ.1)THEN
            ipp=2
         ELSE
            ipp=1
         ENDIF
         init=1
      ENDIF

      IF(ipip.EQ.1)THEN
         CALL qcdscale(scale)
         scale=scale*muF_over_ref
         IF(reweight_scale)THEN
            IF(reweight_Fscale_phase.EQ.1)THEN
               scale=scale*rw_Fscale_up
            ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
               scale=scale*rw_Fscale_down
            ENDIF
         ENDIF
      ELSE
         scale=dps_pmom(ipip,3,1)**2+dps_pmom(ipip,3,2)**2+mpsi(ipip-1)**2
         scale=DSQRT(scale)
      ENDIF

      IF(use_cteq6_f90)THEN
         glu1_ct = xp1*Ctq6Pdf_f90(0,xp1,scale)
         glu2_ct = xp2*Ctq6Pdf_f90(0,xp2,scale)
         u1_ct   = xp1*Ctq6Pdf_f90(1,xp1,scale)
         u2_ct   = xp2*Ctq6Pdf_f90(1,xp2,scale)
         d1_ct   = xp1*Ctq6Pdf_f90(2,xp1,scale)
         d2_ct   = xp2*Ctq6Pdf_f90(2,xp2,scale)
         s1_ct   = xp1*Ctq6Pdf_f90(3,xp1,scale)
         s2_ct   = xp2*Ctq6Pdf_f90(3,xp2,scale)
         c1_ct   = xp1*Ctq6Pdf_f90(4,xp1,scale)
         c2_ct   = xp2*Ctq6Pdf_f90(4,xp2,scale)
         b1_ct   = xp1*Ctq6Pdf_f90(5,xp1,scale)
         b2_ct   = xp2*Ctq6Pdf_f90(5,xp2,scale)
         ub1_ct  = xp1*Ctq6Pdf_f90(-1,xp1,scale)
         ub2_ct  = xp2*Ctq6Pdf_f90(-1,xp2,scale)
         db1_ct  = xp1*Ctq6Pdf_f90(-2,xp1,scale)
         db2_ct  = xp2*Ctq6Pdf_f90(-2,xp2,scale)
         sb1_ct  = xp1*Ctq6Pdf_f90(-3,xp1,scale)
         sb2_ct  = xp2*Ctq6Pdf_f90(-3,xp2,scale)
         cb1_ct  = xp1*Ctq6Pdf_f90(-4,xp1,scale)
         cb2_ct  = xp2*Ctq6Pdf_f90(-4,xp2,scale)
         bb1_ct  = xp1*Ctq6Pdf_f90(-5,xp1,scale)
         bb2_ct  = xp2*Ctq6Pdf_f90(-5,xp2,scale)
      ELSE
         CALL fdist(ih,xp1,scale,pdflist(-7:7))
         glu1_ct = xp1*pdflist(0)
         u1_ct   = xp1*pdflist(2)
         d1_ct   = xp1*pdflist(1)
         s1_ct   = xp1*pdflist(3)
         c1_ct   = xp1*pdflist(4)
         b1_ct   = xp1*pdflist(5)
         ub1_ct  = xp1*pdflist(-2)
         db1_ct  = xp1*pdflist(-1)
         sb1_ct  = xp1*pdflist(-3)
         cb1_ct  = xp1*pdflist(-4)
         bb1_ct  = xp1*pdflist(-5)
         CALL fdist(ih,xp2,scale,pdflist(-7:7))
         glu2_ct = xp2*pdflist(0)
         u2_ct   = xp2*pdflist(2)
         d2_ct   = xp2*pdflist(1)
         s2_ct   = xp2*pdflist(3)
         c2_ct   = xp2*pdflist(4)
         b2_ct   = xp2*pdflist(5)
         ub2_ct  = xp2*pdflist(-2)
         db2_ct  = xp2*pdflist(-1)
         sb2_ct  = xp2*pdflist(-3)
         cb2_ct  = xp2*pdflist(-4)
         bb2_ct  = xp2*pdflist(-5)
      ENDIF
      ! recover it
      IF(reweight_scale)THEN
         IF(reweight_Fscale_phase.EQ.1)THEN
            scale=scale/rw_Fscale_up
         ELSEIF(reweight_Fscale_phase.EQ.-1)THEN
            scale=scale/rw_Fscale_down
         ENDIF
      ENDIF
      IF(ipip.EQ.1)THEN
         IF(dps_istate(1).EQ.1.OR.dps_istate(1).EQ.2.OR.&
              dps_istate(1).EQ.5.OR.dps_istate(1).EQ.6)THEN
            wsf=glu1_ct*glu2_ct*wjac/xp1/xp2
         ELSEIF(dps_istate(1).EQ.3)THEN
            wsf=glu1_ct*(u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct)*wjac/xp1/xp2
         ELSEIF(dps_istate(1).EQ.4)THEN
            wsf=glu2_ct*(u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct)*wjac/xp1/xp2
         ELSEIF(dps_istate(1).EQ.7)THEN
            wsf=glu1_ct*(u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct+c2_ct+cb2_ct)*wjac/xp1/xp2
         ELSEIF(dps_istate(1).EQ.8)THEN
            wsf=glu2_ct*(u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct+c1_ct+cb1_ct)*wjac/xp1/xp2
         ENDIF
      ELSE
         wsf=glu1_ct*glu2_ct*wjac/xp1/xp2
      ENDIF
      IF(dps_includeqq.AND.ipip.GT.1)THEN
         wsf=wsf+(u1_ct*ub2_ct+d1_ct*db2_ct+s1_ct*sb2_ct+c1_ct*cb2_ct+&
              ub1_ct*u2_ct+db1_ct*d2_ct+sb1_ct*s2_ct+cb1_ct*c2_ct)*wjac/xp1/xp2
      ENDIF
      IF(init.EQ.0)init=1
    END SUBROUTINE strf_pdf_pp_psipsipsi_dps

    SUBROUTINE readcuts_pp_psiX_cb_DPS
      IMPLICIT NONE
      CHARACTER(len=24)::file
      LOGICAL::lexist
      INTEGER::iounit,flag=0,i,i1,j,j1
      REAL(KIND(1d0))::ptq,ptcharm,ptconia,etaq,ycq,ycqlow,etaconia,ycconia,ycconialow
      REAL(KIND(1d0))::cutoff,ptbonia,etabonia,ycbonia,ycbonialow
      REAL(KIND(1d0))::xFcq,xFcqlow,xFcconia,xFcconialow,xFcbonia,xFcbonialow
      REAL(KIND(1d0))::gbeamq,drqq,gqq,maxptq,maxptcharm,maxptconia,maxptbonia
      ! open default input file
      INQUIRE(FILE=TRIM(input_dir)//"default.inp",EXIST=lexist)
      IF(.NOT.lexist)THEN
         PRINT *,"Warning: the file default.inp does not exist ! STOP !"
         STOP
      ENDIF
      INQUIRE(FILE=TRIM(input_dir)//"default.inp",OPENED=lexist)
      IF(lexist)THEN
         INQUIRE(FILE=TRIM(input_dir)//"default.inp",NUMBER=iounit)
         IF(iounit.NE.udefault)THEN
            PRINT *,"WARNING: the default.inp has been linked with another unit ! Close and reopen !"
            CLOSE(UNIT=iounit)
            OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
         ENDIF
      ELSE
         OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
      ENDIF
      ! open user's input file
      IF(TRIM(Input_File)/="default.inp")THEN
         INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),EXIST=lexist)
         IF(.NOT.lexist)THEN
            PRINT *,"Warning: the file "//TRIM(Input_File)//" does not exist ! STOP !"
            STOP
         ENDIF
         INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),OPENED=lexist)
         IF(lexist)THEN
            INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),NUMBER=iounit)
            IF(iounit.NE.uinput)THEN
               PRINT *,"WARNING: the "//TRIM(Input_File)//" has been linked with another unit ! Close and reopen !"
               CLOSE(UNIT=iounit)
               OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
            ENDIF
         ELSE
            OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
         ENDIF
      ELSE
         flag=1
      ENDIF
      cutoff=readvalue_r("cutoffp",flag)
      ptc(3:20)=cutoff
      maxptc(3:20)=-1d0
      drc(3:20,3:20)=0
      etac(3:20)=20
      yycut(3:20)=1d9
      IF(absrap)THEN
         yycutlow(3:20)=0d0
      ELSE
         yycutlow(3:20)=-1d9
      ENDIF
      xFcut(3:20)=1d0
      xFcutlow(3:20)=-1d0
      xFcutflag=.FALSE.
      ec(3:20)=cutoff
      c1(3:20)=1d0
      c2(3:20)=1d0
      cc(3:20,3:20)=1d0
      gmas(3:20,3:20)=cutoff
      gbeammass(1:2,3:20)=0d0
      y1cup=30d0
      y1clow=0d0
      y1cup=readvalue_r("maxy1c",flag)
      y1clow=readvalue_r("miny1c",flag)
      ! minimum quark pt
      ptq=readvalue_r("minptq",flag)
      ! maximum quark pt
      maxptq=readvalue_r("maxptq",flag)
      ! minimum charm pt
      ptcharm=readvalue_r("minptc",flag)
      ! maximum charm pt
      maxptcharm=readvalue_r("maxptc",flag)
      ! minimum charmonia pt
      ptconia=readvalue_r("minptconia",flag)
      ! maximum charmonia pt
      maxptconia=readvalue_r("maxptconia",flag)
      ! minimum bottomonia pt
      ptbonia=readvalue_r("minptbonia",flag)
      ! maximum bottomonia pt
      maxptbonia=readvalue_r("maxptbonia",flag)
      ! maximum rapidity quark
      etaq=readvalue_r("maxrapq",flag)
      ! maximum y rapidity quark
      ycq=readvalue_r("maxyrapq",flag)
      ! minimum y rapidity quark
      ycqlow=readvalue_r("minyrapq",flag)
      ! maximum Feynman parameter xF
      xFcq=readvalue_r("maxxFq",flag)
      ! minimum Feynman parameter xF
      xFcqlow=readvalue_r("minxFq",flag)
      ! maximum rapidity charmonium
      etaconia=readvalue_r("maxrapconia",flag)
      ! maximum y rapidity charmonium
      ycconia=readvalue_r("maxyrapconia",flag)
      ! minimum y rapidity charmonium
      ycconialow=readvalue_r("minyrapconia",flag)
      ! maximum Feynman parameter xF
      xFcconia=readvalue_r("maxxFconia",flag)
      ! minimum Feynman parameter xF
      xFcconialow=readvalue_r("minxFconia",flag)
      ! maxmimum rapidity bottomonia
      etabonia=readvalue_r("maxrapbonia",flag)
      ! maximum y rapidity bottomonia
      ycbonia=readvalue_r("maxyrapbonia",flag)
      ! minimum y rapidity bottomonia
      ycbonialow=readvalue_r("minyrapbonia",flag)
      ! maximum Feynman parameter xF
      xFcbonia=readvalue_r("maxxFbonia",flag)
      ! minimum Feynman parameter xF
      xFcbonialow=readvalue_r("minxFbonia",flag)
      ! minimum DR quark with quark
      drqq=readvalue_r("mindrqq",flag)
      ! minimum mass quark with quark
      gqq=readvalue_r("minmqqp",flag)
      ! minimum mass u,d,s quarks and gluon  with partonic beam
      gbeamq=readvalue_r("minmqbeam",flag)
      CLOSE(UNIT=udefault)
      CLOSE(UNIT=uinput)
      ! gluon as 2nd final particle
      ptc(4)=ptq
      IF(maxptq.GE.0d0)maxptc(4)=maxptq
      etac(4)=etaq
      yycut(4)=ycq
      yycutlow(4)=ycqlow
      xFcut(4)=xFcq
      xFcutlow(4)=xFcqlow
      ! quarkonium as 1st final particle
      IF(iflh_dps(5+(nhad-2)).GE.440000.AND.iflh_dps(5+(nhad-2)).LE.449999)THEN
         ptc(3)=ptconia
         IF(maxptconia.GE.0d0)maxptc(3)=maxptconia
         etac(3)=etaconia
         yycut(3)=ycconia
         yycutlow(3)=ycconialow
         xFcut(3)=xFcconia
         xFcutlow(3)=xFcconialow
      ELSE
         ptc(3)=ptbonia
         IF(maxptbonia.GE.0d0)maxptc(3)=maxptbonia
         etac(3)=etabonia
         yycut(3)=ycbonia
         yycutlow(3)=ycbonialow
         xFcut(3)=xFcbonia
         xFcutlow(3)=xFcbonialow
      ENDIF
      RETURN
    END SUBROUTINE readcuts_pp_psiX_cb_DPS

    SUBROUTINE Cuts_pp_psiX_cb_DPS(icut)
      IMPLICIT NONE
      INTEGER,INTENT(OUT)::icut
      INTEGER::l,l1,l2,flag
      REAL(KIND(1d0))::s,d1,d2,dr,pt,eta,aaa,bbb,ptcut
      REAL(KIND(1d0)),DIMENSION(4)::ponia,pboo2
      REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
      REAL(KIND(1d0))::e,q
      icut=0
      flag=0
      DO l=3,4
         pt=SQRT(cb_hadron_pmom(l,1)**2+cb_hadron_pmom(l,2)**2)
         IF(pt.LT.ptc(l))THEN
            flag=1
            EXIT
         ENDIF
         IF(maxptc(l).GE.0d0)THEN
            IF(pt.GT.maxptc(l))THEN
               flag=1
               EXIT
            ENDIF
         ENDIF
         eta=prapidity(cb_hadron_pmom(l,1:4))
         IF(ABS(eta).GT.etac(l))THEN
            flag=1
            EXIT
         ENDIF
         eta=rapidity(cb_hadron_pmom(l,1:4))
         IF(absrap)eta=ABS(eta)
         IF(eta.GT.yycut(l).OR.eta.LT.yycutlow(l))THEN
            flag=1
            EXIT
         ENDIF
         ! special for the first particle , which can be used to calculate the y distribution
         IF(l.EQ.3)THEN
            IF(eta.GT.y1cup.OR.eta.LT.y1clow)THEN
               flag=1
               EXIT
            ENDIF
         ENDIF
      ENDDO
      IF(flag.EQ.0)icut=1
      ! treat xF cut
      ! it shoule be done in the collision frame
      IF(xFcutflag.AND.icut.EQ.1.AND.flag.EQ.0)THEN
         q=ehat
         e=q/SQRT(xp1*xp2)
         IF(.NOT.labeqcoll)THEN
            IF(.NOT.fixtarget)THEN
               pboo2(4)=(ebeam(1)+ebeam(2))
               pboo2(3)=-(ebeam(1)-ebeam(2))
            ELSE
               IF(.NOT.fixtargetrev)THEN
                  pboo2(4)=(ebeam(1)+ebeam(2))
                  pboo2(3)=-ebeam(1)
               ELSE
                  pboo2(4)=(ebeam(1)+ebeam(2))
                  pboo2(3)=ebeam(2)
               ENDIF
            ENDIF
            pboo2(1:2)=0
            ! boost from the lab frame to the collision frame                                                              
            DO l=3,4
               CALL boostl(e,pboo2,cb_hadron_pmom(l,1:4))
            ENDDO
         ENDIF
         DO l=3,4
            eta=xFeynman(cb_hadron_pmom(l,1:4),e)
            IF(eta.GT.xFcut(l).OR.eta.LT.xFcutlow(l))THEN
               icut=0
               EXIT
            ENDIF
         ENDDO
         IF(.NOT.labeqcoll)THEN
            pboo2(3)=-pboo2(3)
            ! boost back to the lab frame                                                                                  
            DO l=3,4
               CALL boostl(e,pboo2,cb_hadron_pmom(l,1:4))
            ENDDO
         ENDIF
      ENDIF
      RETURN
    END SUBROUTINE Cuts_pp_psiX_cb_DPS

    SUBROUTINE readcuts_pp_psipsipsi_dps
      IMPLICIT NONE
      CHARACTER(len=24)::file
      LOGICAL::lexist
      INTEGER::iounit,flag=0,i,i1,j,j1
      REAL(KIND(1d0))::ptq,ptcharm,ptconia,ptbonia,etaq,ycq,ycqlow,etaconia,ycconia,ycconialow,ycbonia,ycbonialow
      REAL(KIND(1d0))::cutoff,xFcq,xFcqlow,xFcconia,xFcconialow,xFcbonia,xFcbonialow,etabonia
      REAL(KIND(1d0))::gbeamq,drqq,gqq,maxptq,maxptcharm,maxptconia,maxptbonia
      ! open default input file
      INQUIRE(FILE=TRIM(input_dir)//"default.inp",EXIST=lexist)
      IF(.NOT.lexist)THEN
         PRINT *,"Warning: the file default.inp does not exist ! STOP !"
         STOP
      ENDIF
      INQUIRE(FILE=TRIM(input_dir)//"default.inp",OPENED=lexist)
      IF(lexist)THEN
         INQUIRE(FILE=TRIM(input_dir)//"default.inp",NUMBER=iounit)
         IF(iounit.NE.udefault)THEN
            PRINT *,"WARNING: the default.inp has been linked with another unit ! Close and reopen !"
            CLOSE(UNIT=iounit)
            OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
         ENDIF
      ELSE
         OPEN(UNIT=udefault,FILE=TRIM(input_dir)//"default.inp")
      ENDIF
      ! open user's input file
      IF(TRIM(Input_File)/="default.inp")THEN
         INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),EXIST=lexist)
         IF(.NOT.lexist)THEN
            PRINT *,"Warning: the file "//TRIM(Input_File)//" does not exist ! STOP !"
            STOP
         ENDIF
         INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),OPENED=lexist)
         IF(lexist)THEN
            INQUIRE(FILE=TRIM(input_dir)//TRIM(Input_File),NUMBER=iounit)
            IF(iounit.NE.uinput)THEN
               PRINT *,"WARNING: the "//TRIM(Input_File)//" has been linked with another unit ! Close and reopen !"
               CLOSE(UNIT=iounit)
               OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
            ENDIF
         ELSE
            OPEN(UNIT=uinput,FILE=TRIM(input_dir)//TRIM(Input_File))
         ENDIF
      ELSE
         flag=1
      ENDIF
      cutoff=readvalue_r("cutoffp",flag)
      PRINT *,"WARNING CUTOFF SET:",cutoff
      ptc(3:20)=cutoff
      maxptc(3:20)=-1d0
      drc(3:20,3:20)=0
      etac(3:20)=20
      yycut(3:20)=1d9
      IF(absrap)THEN
         yycutlow(3:20)=0d0
      ELSE
         yycutlow(3:20)=-1d9
      ENDIF
      xFcut(3:20)=1d0
      xFcutlow(3:20)=1d0
      xFcutflag=.FALSE.
      ec(3:20)=cutoff
      c1(3:20)=1d0
      c2(3:20)=1d0
      cc(3:20,3:20)=1d0
      gmas(3:20,3:20)=cutoff
      gbeammass(1:2,3:20)=0d0
      y1cup=30d0
      y1clow=0d0
      y1cup=readvalue_r("maxy1c",flag)
      y1clow=readvalue_r("miny1c",flag)
      ! minimum quark pt
      ptq=readvalue_r("minptq",flag)
      ! maximum quark pt
      maxptq=readvalue_r("maxptq",flag)
      ! minimum charm pt
      ptcharm=readvalue_r("minptc",flag)
      ! maximum charm pt
      maxptcharm=readvalue_r("maxptc",flag)
      ! minimum charmonia pt
      ptconia=readvalue_r("minptconia",flag)
      ! maximum charmonia pt
      maxptconia=readvalue_r("maxptconia",flag)
      ! minimum bottonia pt
      ptbonia=readvalue_r("minptbonia",flag)
      ! maximum bottonia pt
      maxptbonia=readvalue_r("maxptbonia",flag)
      ! maximum rapidity quark 
      etaq=readvalue_r("maxrapq",flag)
      ! maximum y rapidity quark
      ycq=readvalue_r("maxyrapq",flag)
      ! minimum y rapidity quark
      ycqlow=readvalue_r("minyrapq",flag)
      ! maximum Feynman parameter xF
      xFcq=readvalue_r("maxxFq",flag)
      ! minimum Feynman parameter xF
      xFcqlow=readvalue_r("minxFq",flag)
      ! maximum rapidity charmonium
      etaconia=readvalue_r("maxrapconia",flag)
      ! maximum y rapidity charmonium
      ycconia=readvalue_r("maxyrapconia",flag)
      ! minimum y rapidity charmonium
      ycconialow=readvalue_r("minyrapconia",flag)
      ! maximum Feynman parameter xF
      xFcconia=readvalue_r("maxxFconia",flag)
      ! minimum Feynman parameter xF
      xFcconialow=readvalue_r("minxFconia",flag)
      ! maximum rapidity bottomonia
      etabonia=readvalue_r("maxrapbonia",flag)
      ! maximum y rapidity bottomonia
      ycbonia=readvalue_r("maxyrapbonia",flag)
      ! minimum y rapidity bottomonia
      ycbonialow=readvalue_r("minyrapbonia",flag)
      ! maximum Feynman parameter xF
      xFcbonia=readvalue_r("maxxFbonia",flag)
      ! minimum Feynman parameter xF
      xFcbonialow=readvalue_r("minxFbonia",flag)
      ! minimum DR quark with quark
      drqq=readvalue_r("mindrqq",flag)
      ! minimum mass quark with quark
      gqq=readvalue_r("minmqqp",flag)
      ! minimum mass u,d,s quarks and gluon  with partonic beam
      gbeamq=readvalue_r("minmqbeam",flag)
      CLOSE(UNIT=udefault)
      CLOSE(UNIT=uinput)
      DO i=5,nhad_dps
         i1=iflh_dps(i)
         IF(ABS(iflh_dps(i)).LT.13)i1=0
         IF(iflh_dps(i).EQ.35)i1=0
         IF(i1.EQ.0)THEN
            ! gluons or quarks
            ptc(i)=ptq
            IF(maxptq.GE.0d0)maxptc(i)=maxptq
            etac(i)=etaq
            yycut(i)=ycq
            yycutlow(i)=ycqlow
            xFcut(i)=xFcq
            xFcutlow(i)=xFcqlow
            IF(i.LE.nhad+2)THEN
               gbeammass(1,i)=gbeamq
               gbeammass(2,i)=gbeamq
            ENDIF
         ELSEIF(i1.GE.440000.AND.i1.LE.449999)THEN
            ptc(i)=ptconia
            IF(maxptconia.GE.0d0)maxptc(i)=maxptconia
            etac(i)=etaconia
            yycut(i)=ycconia
            yycutlow(i)=ycconialow
            xFcut(i)=xFcconia
            xFcutlow(i)=xFcconialow
         ELSE
            ptc(i)=ptbonia
            IF(maxptbonia.GE.0d0)maxptc(i)=maxptbonia
            etac(i)=etabonia
            yycut(i)=ycbonia
            yycutlow(i)=ycbonialow
            xFcut(i)=xFcbonia
            xFcutlow(i)=xFcbonialow
         ENDIF
      ENDDO
      DO i=5,nhad_dps-1
         i1=iflh_dps(i)
         IF(ABS(iflh_dps(i)).LT.13)i1=0
         IF(i1.EQ.35)i1=0
         DO j=i+1,nhad_dps
            j1=iflh_dps(j)
            IF(j1.EQ.35.OR.ABS(j1).LT.13)j1=0
            IF(i1.EQ.0.AND.j1.EQ.0)THEN
               drc(i,j)=drqq
               gmas(i,j)=MAX(gqq,gmas(i,j))
            ENDIF
         ENDDO
      ENDDO
      DO i=5,nhad_dps-1
         DO j=i+1,nhad_dps
            gmas(i,j)=MAX(gmas(i,j),DSQRT(2*ptc(i)*ptc(j)*(1-COS(drc(i,j)))))
         ENDDO
      ENDDO
      DO i=6,nhad_dps
         DO j=5,i-1
            drc(i,j)=drc(j,i)
            gmas(i,j)=gmas(j,i)
         ENDDO
      ENDDO
      WRITE(*,*)'---------------------------------------------------'
      WRITE(*,*)'    the cuts for p p > psi(Upsilon) psi(Upsilon) psi(Upsilon) + X '
      WRITE(*,*)'    with double parton scattering (DPS) '
      DO i=5,nhad_dps
         WRITE(*,*)'pt     of  ',i,'   particle   ',ptc(i)
         IF(maxptc(i).GE.0d0)THEN
            WRITE(*,*)'max pt     of  ',i,'   particle   ',maxptc(i)
            IF(maxptc(i).LE.ptc(i))THEN
               WRITE(*,*)"ERROR: One of the final state ",i," was cut off by pt cut"
               STOP
            ENDIF
         ELSE
            WRITE(*,*)'no max pt cut of  ',i,'   particle  '
         ENDIF
         WRITE(*,*)'energy of  ',i,'   particle   ',ec(i)
         WRITE(*,*)'rapidity of  ',i,'   particle   ',etac(i)
         WRITE(*,*)'max y rapidity of ',i,'   particle   ',yycut(i)
         WRITE(*,*)'min y rapidity of ',i,'   particle   ',yycutlow(i)
         IF(yycut(i).LE.yycutlow(i))THEN
            WRITE(*,*)"ERROR: One of the final state ",i," was cut off by y rapidity cut"
            STOP
         ENDIF
         WRITE(*,*)'max Feynman parameter xF of ',i,' particle ',xFcut(i)
         IF(xFcut(i).LT.1d0)xFcutflag=.TRUE.
         WRITE(*,*)'min Feynman parameter xF of ',i,' particle ',xFcutlow(i)
         IF(xFcutlow(i).GT.-1d0)xFcutflag=.TRUE.
      ENDDO
      WRITE(*,*)'The maxrapidity of the first particle',y1cup
      WRITE(*,*)'The minrapidity of the first particle',y1clow
      DO i=5,nhad_dps-1
         DO j=i+1,nhad_dps
            WRITE(*,*)'DR     ',i,'  with  ',j,drc(i,j)
            WRITE(*,*)'mass of ',i,'  with  ',j,gmas(i,j)
         ENDDO
      ENDDO
      DO i=1,2
         DO j=5,nhad+2
            WRITE(*,*)'mass of partonic beam ',i,' with final ',j,gbeammass(i,j)
         ENDDO
      ENDDO
      WRITE(*,*)'---------------------------------------------------'
    END SUBROUTINE readcuts_pp_psipsipsi_dps

    SUBROUTINE Cuts_pp_psipsipsi_dps(icut)
      IMPLICIT NONE
      INTEGER,INTENT(OUT)::icut
      INTEGER::l,l1,l2,flag
      REAL(KIND(1d0))::s,t,d1,d2,dr,pt,eta,aaa,bbb,ptcut
      REAL(KIND(1d0)),DIMENSION(4)::ponia,pboo2
      REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932384626433832795d0
      REAL(KIND(1d0))::e,q
      icut=0
      ! invariant mass cuts
      DO l1=5,nhad_dps-1
         DO l2=l1+1,nhad_dps
            s=2D0*scalar_product(dps_hadron_pmom(l1,1:4),dps_hadron_pmom(l2,1:4))&
                 +scalar_product(dps_hadron_pmom(l1,1:4),dps_hadron_pmom(l1,1:4))&
                 +scalar_product(dps_hadron_pmom(l2,1:4),dps_hadron_pmom(l2,1:4))
            IF(s.LT.gmas(l1,l2)**2)RETURN
         ENDDO
      ENDDO
      ! special for the beam cuts for NLO*
      DO l1=1,2
         DO l2=5,nhad+2
            t=scalar_product(dps_hadron_pmom(l1,1:4),dps_hadron_pmom(l1,1:4))&
                 +scalar_product(dps_hadron_pmom(l2,1:4),dps_hadron_pmom(l2,1:4))&
                 -2D0*scalar_product(dps_hadron_pmom(l1,1:4),dps_hadron_pmom(l2,1:4))
            IF(DABS(t).LT.gbeammass(l1,l2)**2)RETURN
         ENDDO
      ENDDO
      flag=0
      DO l=5,nhad_dps
         pt=SQRT(dps_hadron_pmom(l,1)**2+dps_hadron_pmom(l,2)**2)
         IF(pt.LT.ptc(l))THEN
            flag=1
            EXIT
         ENDIF
         IF(maxptc(l).GE.0d0)THEN
            IF(pt.GT.maxptc(l))THEN
               flag=1
               EXIT
            ENDIF
         ENDIF
         eta=prapidity(dps_hadron_pmom(l,1:4))
         IF(ABS(eta).GT.etac(l))THEN
            flag=1
            EXIT
         ENDIF
         eta=rapidity(dps_hadron_pmom(l,1:4))
         IF(absrap)eta=ABS(eta)
         IF(eta.GT.yycut(l).OR.eta.LT.yycutlow(l))THEN
            flag=1
            EXIT
         ENDIF
         ! special for the first particle , which can be used to calculate the y distribution  
         IF(l.EQ.5.OR.l.EQ.nhad+3)THEN
            IF(eta.GT.y1cup.OR.eta.LT.y1clow)THEN
               flag=1
               EXIT
            ENDIF
         ENDIF
      ENDDO
      IF(flag.EQ.0)THEN
         DO l1=5,nhad_dps-1
            DO l2=l1+1,nhad_dps
               d1=prapidity(dps_hadron_pmom(l1,1:4))-prapidity(dps_hadron_pmom(l2,1:4))
               d2=ph4(dps_hadron_pmom(l1,1),dps_hadron_pmom(l1,2),dps_hadron_pmom(l1,3))&
                    -ph4(dps_hadron_pmom(l2,1),dps_hadron_pmom(l2,2),dps_hadron_pmom(l2,3))
               d2=MIN(DABS(d2),2*pi-DABS(d2))
               IF(d2/pi.GT.1d0)WRITE(*,*)d2/pi
               dr=SQRT(d1**2+d2**2)
               IF(dr.LT.drc(l1,l2))THEN
                  flag=1
                  EXIT
               ENDIF
            ENDDO
            IF(flag.EQ.1)EXIT
         ENDDO
         IF(flag.EQ.0)icut=1
      ENDIF
      ! special cutoffs in the literature
      IF(icut.EQ.1.AND.flag.EQ.0)THEN
         IF(literature_cutoffs.EQ.14060484.OR.literature_cutoffs.EQ.15090000)THEN
            DO l=5,nhad_dps
               IF(iflh_dps(l).GT.440001.AND.iflh_dps(l).LT.449999)THEN
                  ! charmonia
                  ponia(1:4)=dps_hadron_pmom(l,1:4)
                  eta=rapidity(ponia(1:4))
                  IF(ABS(eta).LT.1.2d0)THEN
                     pt=SQRT(ponia(1)**2+ponia(2)**2)
                     IF(pt.LE.6.5d0)THEN
                        icut=0
                        EXIT
                     ENDIF
                  ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.1.43d0)THEN
                     pt=SQRT(ponia(1)**2+ponia(2)**2)
                     aaa=-8.695652173913045d0
                     bbb=16.934782608695656d0
                     ptcut=aaa*ABS(eta)+bbb
                     IF(pt.LE.ptcut)THEN
                        icut=0
                        EXIT
                     ENDIF
                  ELSEIF(ABS(eta).GT.1.43d0.AND.ABS(eta).LT.2.2d0)THEN
                     pt=SQRT(ponia(1)**2+ponia(2)**2)
                     IF(pt.LE.4.5d0)THEN
                        icut=0
                        EXIT
                     ENDIF
                  ELSE
                     icut=0
                     EXIT
                  ENDIF
               ENDIF
            ENDDO
         ENDIF
      ENDIF
      IF(xFcutflag.AND.icut.EQ.1.AND.flag.EQ.0)THEN
         q=ehat
         e=q/SQRT(xp1*xp2)
         IF(.NOT.labeqcoll)THEN
            IF(.NOT.fixtarget)THEN
               pboo2(4)=(ebeam(1)+ebeam(2))
               pboo2(3)=-(ebeam(1)-ebeam(2))
            ELSE
               IF(.NOT.fixtargetrev)THEN
                  pboo2(4)=(ebeam(1)+ebeam(2))
                  pboo2(3)=-ebeam(1)
               ELSE
                  pboo2(4)=(ebeam(1)+ebeam(2))
                  pboo2(3)=ebeam(2)
               ENDIF
            ENDIF
            pboo2(1:2)=0
            ! boost from the lab frame to the collision frame 
            DO l=5,nhad_dps
               CALL boostl(e,pboo2,dps_hadron_pmom(l,1:4))
            ENDDO
         ENDIF
         DO l=5,nhad_dps
            eta=xFeynman(dps_hadron_pmom(l,1:4),e)
            IF(eta.GT.xFcut(l).OR.eta.LT.xFcutlow(l))THEN
               icut=0
               EXIT
            ENDIF
         ENDDO
         IF(.NOT.labeqcoll)THEN
            pboo2(3)=-pboo2(3)
            ! boost back to the lab frame 
            DO l=5,nhad_dps
               CALL boostl(e,pboo2,dps_hadron_pmom(l,1:4))
            ENDDO
         ENDIF
      ENDIF
    END SUBROUTINE Cuts_pp_psipsipsi_dps

    SUBROUTINE HO_Decay_pp_psipsipsi_dps(wgtbr)
      IMPLICIT NONE
      INCLUDE "stdhep_pp_psipsipsi_dps.inc"
      INTEGER::i,j,k,kk,m,ndecay
      REAL(KIND(1d0)),INTENT(OUT)::wgtbr
      REAL(KIND(1d0))::br,r
      REAL(KIND(1d0)),DIMENSION(MAX_DecayChain_DPS)::braccum
      INTEGER::ipip
      wgtbr=1d0
      ndecay=0
      NEVHEP_DPS=1
      NHEP_DPS=nhad_dps
      DO i=1,nhad_dps
         ISTHEP_DPS(i)=0
         IDHEP_DPS(i)=pdgt(iflh_dps(i))
         IF(i.GT.4.AND.i.LE.nhad+2)THEN
            ISHEP_DPS(i)=1
            JMOHEP_DPS(1,i)=1
            JMOHEP_DPS(2,i)=2
            JDAHEP_DPS(1,i)=0
            JDAHEP_DPS(2,i)=0
         ELSEIF(i.GT.nhad+2.AND.i.LE.nhad_dps)THEN
            ISHEP_DPS(i)=1
            JMOHEP_DPS(1,i)=3
            JMOHEP_DPS(2,i)=4
            JDAHEP_DPS(1,i)=0
            JDAHEP_DPS(2,i)=0
         ELSEIF(i.GT.2)THEN
            ISHEP_DPS(i)=-1
            JMOHEP_DPS(1,i)=0
            JMOHEP_DPS(2,i)=0
            JDAHEP_DPS(1,i)=7
            JDAHEP_DPS(2,i)=8
         ELSE
            ISHEP_DPS(i)=-1
            JMOHEP_DPS(1,i)=0
            JMOHEP_DPS(2,i)=0
            JDAHEP_DPS(1,i)=5
            JDAHEP_DPS(2,i)=6
         ENDIF
         PHEP_DPS(1:5,i)=dps_hadron_pmom(i,1:5)
         VHEP_DPS(1:4,i)=0d0
         IPOLHEP_DPS(i)=99
         ICOLHEP_DPS(1:2,i)=0
      ENDDO
      ipip=0
      dps_decay_index=0
      DO i=1,nhad_dps
         j=iflh2DecayChains_DPS(i,0)
         IF(ABS(iflh_dps(i)).GT.100)THEN
            ipip=ipip+1
            dps_decay_index=ipip
         ENDIF
         IF(j.GT.0)THEN
            br=0d0
            braccum(1:MAX_DecayChain_DPS)=0d0
            DO k=1,j
               m=iflh2DecayChains_DPS(i,k)
               br=br+DecayBR_DPS(m)
               braccum(k)=br
            ENDDO
            ! randomly select the decay process
            IF(j.EQ.1)THEN
               kk=1
            ELSE
               ndecay=ndecay+1
               r=Decayran(ndecay)*br
               DO k=1,j
                  IF(braccum(k).GT.r)THEN
                     kk=k
                     EXIT
                  ELSEIF(k.EQ.j)THEN
                     kk=j
                     EXIT
                  ENDIF
               ENDDO
            ENDIF
            m=iflh2DecayChains_DPS(i,kk)
            CALL HO_One_Decay_pp_psipsipsi_dps(i,m)
            wgtbr=wgtbr*br
         ENDIF
         IF(dps_decay_index.GT.3)THEN
            WRITE(*,*)"ERROR:too many psi (>3)"
            STOP
         ELSEIF(dps_decay_index.GT.0)THEN
            dps_decay_index=0
         ENDIF
      ENDDO
      RETURN
    END SUBROUTINE HO_Decay_pp_psipsipsi_dps

    SUBROUTINE convert_iflh_dps_to_iflh(i_dps,i)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::i_dps
      INTEGER,INTENT(OUT)::i
      IF(i_dps.LE.2)THEN
         i=i_dps
      ELSEIF(i_dps.GT.4.AND.i_dps.LE.nhad+2)THEN
         i=i_dps-2
      ELSE
         i=0
      ENDIF
      RETURN
    END SUBROUTINE convert_iflh_dps_to_iflh

    SUBROUTINE HO_One_Decay_pp_psipsipsi_dps(imoth,idecay)
      USE HOVll
      USE Helac_ranmar_mod
      IMPLICIT NONE
      INTEGER,INTENT(IN)::imoth,idecay
      INTEGER,PARAMETER::available_ndecay=1
      INTEGER::imoth2,nnhep
      CHARACTER(len=20),DIMENSION(available_ndecay)::available_decay
      INTEGER::i
      INTEGER::lavail
      REAL(KIND(1d0)),DIMENSION(3)::svec
      REAL(KIND(1d0)),DIMENSION(0:3)::PM,PD1,PD2
      REAL(KIND(1d0))::probT
      INCLUDE "stdhep_pp_psipsipsi_dps.inc"
      INCLUDE "../../../decay/stdhep.inc"
      CALL pp_psipsipsi_dps_HO_judge_avail_decay(imoth,idecay,lavail)
      IF(lavail.GT.0)THEN
         SELECT CASE(lavail)
            CASE(1)
               ! 3S11 > l+ l-
               IF(dps_decay_index.LT.1.OR.dps_decay_index.GT.3)THEN
                  WRITE(*,*)"ERROR:unknow which psi to decay"
                  STOP
               ENDIF
               IF(dps_decay_index.LE.2)THEN
                  CALL convert_iflh_dps_to_iflh(imoth,imoth2)
                  IF(imoth2.EQ.0)THEN
                     WRITE(*,*)"ERROR: cannot find the mother particle in pQCD"
                     STOP
                  ENDIF
                  nnhep=nhad+NHEP_DPS-nhad_dps
                  ! it has been calculated by pQCD
                  ISTHEP_DPS(imoth)=1
                  ISHEP_DPS(NHEP_DPS+1)=1
                  ISHEP_DPS(NHEP_DPS+2)=1
                  ISTHEP_DPS(NHEP_DPS+1)=0
                  ISTHEP_DPS(NHEP_DPS+2)=0
                  IDHEP_DPS(NHEP_DPS+1)=pdgt(DecayChains_DPS(idecay,1))
                  IDHEP_DPS(NHEP_DPS+2)=pdgt(DecayChains_DPS(idecay,2))
                  JMOHEP_DPS(1,NHEP_DPS+1:NHEP_DPS+2)=imoth
                  JMOHEP_DPS(2,NHEP_DPS+1:NHEP_DPS+2)=0
                  JDAHEP_DPS(1,imoth)=NHEP_DPS+1 ! update the mother
                  JDAHEP_DPS(2,imoth)=NHEP_DPS+2 ! update the mother
                  PHEP_DPS(5,NHEP_DPS+1:NHEP_DPS+2)=0d0
                  PHEP_DPS(1:3,NHEP_DPS+1)=PHEP(1:3,nnhep+1)
                  PHEP_DPS(1:3,NHEP_DPS+2)=PHEP(1:3,nnhep+2)
                  PHEP_DPS(4,NHEP_DPS+1)=PHEP(4,nnhep+1)
                  PHEP_DPS(4,NHEP_DPS+2)=PHEP(4,nnhep+2)
                  VHEP_DPS(1:4,NHEP_DPS+1:NHEP_DPS+2)=0d0
                  IPOLHEP_DPS(NHEP_DPS+1)=99 ! decay products will not decay anymore
                  IPOLHEP_DPS(NHEP_DPS+2)=99
                  ICOLHEP_DPS(1:2,NHEP_DPS+1:NHEP_DPS+2)=0
                  IPOLHEP_DPS(JMOHEP_DPS(1,NHEP_DPS+1))=IPOLHEP(JMOHEP(1,nnhep+1)) ! update the polarization of mother
                  NHEP_DPS=NHEP_DPS+2
               ELSE
                  PM(0)=dps_hadron_pmom(imoth,4)
                  PM(1:3)=dps_hadron_pmom(imoth,1:3)
                  svec(1:3)=PM(1:3)
                  ! unpolarized in any frame
                  IF(dps_lambdath(dps_decay_index-2).EQ.0d0)THEN
                     CALL HO_Vll_unpolarized(PM,PD1,PD2)
                  ELSEIF(dps_lambdath(dps_decay_index-2).GE.1d0)THEN
                     CALL HO_Vll11(PM,svec,PD1,PD2)
                  ELSEIF(dps_lambdath(dps_decay_index-2).LE.-1d0)THEN
                     CALL HO_Vll00(PM,svec,PD1,PD2)
                  ELSE
                     probT=2d0*(1d0+dps_lambdath(dps_decay_index-2))/&
                          (3d0+dps_lambdath(dps_decay_index-2))
                     IF(Helac_rnmy(0).LT.probT)THEN
                        CALL HO_Vll11(PM,svec,PD1,PD2)
                     ELSE
                        CALL HO_Vll00(PM,svec,PD1,PD2)
                     ENDIF
                  ENDIF
                  ISTHEP_DPS(imoth)=1
                  ISHEP_DPS(NHEP_DPS+1)=1
                  ISHEP_DPS(NHEP_DPS+2)=1
                  ISTHEP_DPS(NHEP_DPS+1)=0
                  ISTHEP_DPS(NHEP_DPS+2)=0
                  IDHEP_DPS(NHEP_DPS+1)=pdgt(DecayChains_DPS(idecay,1))
                  IDHEP_DPS(NHEP_DPS+2)=pdgt(DecayChains_DPS(idecay,2))
                  JMOHEP_DPS(1,NHEP_DPS+1:NHEP_DPS+2)=imoth
                  JMOHEP_DPS(2,NHEP_DPS+1:NHEP_DPS+2)=0
                  JDAHEP_DPS(1,imoth)=NHEP_DPS+1
                  JDAHEP_DPS(2,imoth)=NHEP_DPS+2
                  PHEP_DPS(5,NHEP_DPS+1:NHEP_DPS+2)=0d0
                  PHEP_DPS(1:3,NHEP_DPS+1)=PD1(1:3)
                  PHEP_DPS(1:3,NHEP_DPS+2)=PD2(1:3)
                  PHEP_DPS(4,NHEP_DPS+1)=PD1(0)
                  PHEP_DPS(4,NHEP_DPS+2)=PD2(0)
                  NHEP_DPS=NHEP_DPS+2
               ENDIF
            END SELECT
         ELSE
            CALL HO_avail_decays(available_ndecay,available_decay)
            PRINT *,"Only the following decay processes are available in HELAC-Onia"
            DO i=1,available_ndecay
               PRINT *,available_decay(i)
            ENDDO
            STOP
         ENDIF
         RETURN
    END SUBROUTINE HO_One_Decay_pp_psipsipsi_dps

    SUBROUTINE pp_psipsipsi_dps_HO_judge_avail_decay(imoth,idecay,lavail)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::imoth,idecay
      INTEGER,INTENT(OUT)::lavail
      INTEGER::ll,sum,i,f1,f2
      lavail=0
      IF(iflh_dps(imoth).EQ.443011.OR.iflh_dps(imoth).EQ.553011.OR.&
           iflh_dps(imoth).EQ.443018.OR.iflh_dps(imoth).EQ.553018)THEN
         ! 3S11 or 3S18 > l+ l-
         ll=DecayChains_DPS(idecay,-1)
         IF(ll.NE.2)RETURN
         sum=0
         DO i=1,ll
            sum=sum+DecayChains_DPS(idecay,i)
         ENDDO
         IF(sum.NE.0)RETURN
         IF(ABS(DecayChains_DPS(idecay,1)).NE.2.AND.ABS(DecayChains_DPS(idecay,1)).NE.6)RETURN
         lavail=1
         RETURN
      ELSEIF(iflh_dps(imoth).EQ.441008.OR.iflh_dps(imoth).EQ.551008)THEN
         ! 1S08 > l+ l-
         ll=DecayChains_DPS(idecay,-1)
         IF(ll.NE.2)RETURN
         sum=0
         DO i=1,ll
            sum=sum+DecayChains_DPS(idecay,i)
         ENDDO
         IF(sum.NE.0)RETURN
         IF(ABS(DecayChains_DPS(idecay,1)).NE.2.AND.ABS(DecayChains_DPS(idecay,1)).NE.6)RETURN
         lavail=7
         RETURN
      ELSEIF(iflh_dps(imoth).EQ.443108.OR.iflh_dps(imoth).EQ.553108.OR.&
           iflh_dps(imoth).EQ.443118.OR.iflh_dps(imoth).EQ.553118.OR.&
           iflh_dps(imoth).EQ.443128.OR.iflh_dps(imoth).EQ.553128)THEN
         ! 3PJ8 > l+ l-
         ll=DecayChains_DPS(idecay,-1)
         IF(ll.NE.2)RETURN
         sum=0
         DO i=1,ll
            sum=sum+DecayChains_DPS(idecay,i)
         ENDDO
         IF(sum.NE.0)RETURN
         IF(ABS(DecayChains_DPS(idecay,1)).NE.2.AND.ABS(DecayChains_DPS(idecay,1)).NE.6)RETURN
         lavail=9
         RETURN
      ELSEIF(iflh_dps(imoth).EQ.33.OR.iflh_dps(imoth).EQ.34)THEN
         ! W+- > f1 f2
         ll=DecayChains_DPS(idecay,-1)
         IF(ll.NE.2)RETURN
         f1=DecayChains_DPS(idecay,1)
         ! only include light fermions
         IF(ABS(f1).GT.12.OR.ABS(f1).EQ.11)RETURN
         f2=DecayChains_DPS(idecay,2)
         IF(ABS(f2).GT.12.OR.ABS(f2).EQ.11)RETURN
         IF(f1*f2.GT.0)RETURN
         i=MOD(ABS(f1),4)
         IF(MOD(ABS(f2),4)+i.NE.3)RETURN
         IF(i.EQ.1.OR.i.EQ.2)THEN
            ! leptonic decay
            IF(ABS(ABS(f1)-ABS(f2)).NE.1)RETURN ! no generation mixing
            ! charge conservation
            IF(f1.GT.0)THEN
               IF(i.EQ.1.AND.iflh_dps(imoth).NE.33)RETURN
               IF(i.EQ.2.AND.iflh_dps(imoth).NE.34)RETURN
            ELSE
               IF(i.EQ.1.AND.iflh_dps(imoth).NE.34)RETURN
               IF(i.EQ.2.AND.iflh_dps(imoth).NE.33)RETURN
            ENDIF
         ELSE
            ! hadronic decay
            ! charge conservation
            IF(f1.GT.0)THEN
               IF(i.EQ.3.AND.iflh_dps(imoth).NE.33)RETURN
               IF(i.EQ.0.AND.iflh_dps(imoth).NE.34)RETURN
            ELSE
               IF(i.EQ.3.AND.iflh_dps(imoth).NE.34)RETURN
               IF(i.EQ.0.AND.iflh_dps(imoth).NE.33)RETURN
            ENDIF
         ENDIF
         lavail=2
         RETURN
      ELSEIF(iflh_dps(imoth).EQ.32)THEN
         ! Z > f f~
         ll=DecayChains_DPS(idecay,-1)
         IF(ll.NE.2)RETURN
         f1=DecayChains_DPS(idecay,1)
         ! only include light fermions
         IF(ABS(f1).GT.12.OR.ABS(f1).EQ.11)RETURN
         f2=DecayChains_DPS(idecay,2)
         IF(ABS(f2).GT.12.OR.ABS(f2).EQ.11)RETURN
         IF(f1+f2.NE.0)RETURN
         lavail=3
         RETURN
      ELSEIF(ABS(iflh_dps(imoth)).EQ.11)THEN
         ! t > b W+ or t~ > b~ W-
         ll=DecayChains_DPS(idecay,-1)
         IF(ll.NE.2)RETURN
         f1=DecayChains_DPS(idecay,1)
         IF(ABS(f1).NE.12.OR.f1.NE.33.OR.f1.NE.34)RETURN
         f2=DecayChains_DPS(idecay,2)
         IF(ABS(f2).NE.12.OR.f2.NE.33.OR.f2.NE.34)RETURN
         IF(ABS(f1).EQ.12.AND.(f2.NE.33.OR.f2.NE.34))RETURN
         IF(ABS(f2).EQ.12.AND.(f1.NE.33.OR.f1.NE.34))RETURN
         IF(f1*f2*iflh_dps(imoth).LT.0)RETURN
         IF(iflh_dps(imoth).GT.0)THEN
            IF(f1.NE.33.AND.f2.NE.33)RETURN
            IF(f1.NE.12.AND.f2.NE.12)RETURN
         ELSE
            IF(f1.NE.34.AND.f2.NE.34)RETURN
            IF(f1.NE.-12.AND.f2.NE.-12)RETURN
         ENDIF
         lavail=4
         RETURN
      ELSEIF(iflh_dps(imoth).EQ.443101.OR.iflh_dps(imoth).EQ.553101)THEN
         ! chi0 > psi a
         ll=DecayChains_DPS(idecay,-1)
         IF(ll.NE.2)RETURN
         f1=DecayChains_DPS(idecay,1)
         f2=DecayChains_DPS(idecay,2)
         IF(f1.NE.31.AND.f2.NE.31)RETURN
         IF(iflh_dps(imoth).EQ.443101.AND.f1.NE.443011.AND.f2.NE.443011)RETURN
         IF(iflh_dps(imoth).EQ.553101.AND.f1.NE.553011.AND.f2.NE.553011)RETURN
         lavail=8
         RETURN
      ELSEIF(iflh_dps(imoth).EQ.443111.OR.iflh_dps(imoth).EQ.553111)THEN
         ! chi1 > psi a
         ll=DecayChains_DPS(idecay,-1)
         IF(ll.NE.2)RETURN
         f1=DecayChains_DPS(idecay,1)
         f2=DecayChains_DPS(idecay,2)
         IF(f1.NE.31.AND.f2.NE.31)RETURN
         IF(iflh_dps(imoth).EQ.443111.AND.f1.NE.443011.AND.f2.NE.443011)RETURN
         IF(iflh_dps(imoth).EQ.553111.AND.f1.NE.553011.AND.f2.NE.553011)RETURN
         lavail=5
         RETURN
      ELSEIF(iflh_dps(imoth).EQ.443121.OR.iflh_dps(imoth).EQ.553121)THEN
         ! chi2 > psi a
         ll=DecayChains_DPS(idecay,-1)
         IF(ll.NE.2)RETURN
         f1=DecayChains_DPS(idecay,1)
         f2=DecayChains_DPS(idecay,2)
         IF(f1.NE.31.AND.f2.NE.31)RETURN
         IF(iflh_dps(imoth).EQ.443121.AND.f1.NE.443011.AND.f2.NE.443011)RETURN
         IF(iflh_dps(imoth).EQ.553121.AND.f1.NE.553011.AND.f2.NE.553011)RETURN
         lavail=6
         RETURN
      ENDIF
      RETURN
    END SUBROUTINE pp_psipsipsi_dps_HO_judge_avail_decay

    SUBROUTINE pp_psiX_cb_DPS_hadronmom
      IMPLICIT NONE
      cb_hadron_pmom(1,1:4)=cb_pmom(1,1:4)
      cb_hadron_pmom(1,5)=0d0
      cb_hadron_pmom(2,1:4)=cb_pmom(2,1:4)
      cb_hadron_pmom(2,5)=0d0
      cb_hadron_pmom(3,1:4)=cb_pmom(3,1:4)
      cb_hadron_pmom(3,5)=mpsi(1)
      cb_hadron_pmom(4,1:4)=cb_pmom(4,1:4)
      cb_hadron_pmom(4,5)=0d0
      RETURN
    END SUBROUTINE pp_psiX_cb_DPS_hadronmom

    SUBROUTINE pp_psipsipsi_dps_hadronmom
      IMPLICIT NONE
      INTEGER::ii,kk
      dps_hadron_pmom(1,1:4)=dps_pmom(1,1,1:4)
      dps_hadron_pmom(1,5)=0d0
      dps_hadron_pmom(2,1:4)=dps_pmom(1,2,1:4)
      dps_hadron_pmom(2,5)=0d0
      dps_hadron_pmom(3,1:4)=dps_pmom(2,1,1:4)
      dps_hadron_pmom(3,5)=0d0
      dps_hadron_pmom(4,1:4)=dps_pmom(2,2,1:4)
      dps_hadron_pmom(4,5)=0d0
      DO ii=3,nhad
         dps_hadron_pmom(2+ii,1:4)=dps_pmom(1,ii,1:4)
         dps_hadron_pmom(2+ii,5)=DSQRT(DABS(dps_pmom(1,ii,4)**2-dps_pmom(1,ii,1)**2&
              -dps_pmom(1,ii,2)**2-dps_pmom(1,ii,3)**2))
      ENDDO
      kk=nhad+2
      dps_hadron_pmom(kk+1,1:4)=dps_pmom(2,3,1:4)
      dps_hadron_pmom(kk+1,5)=mpsi(1)
      dps_hadron_pmom(kk+2,1:4)=dps_pmom(2,4,1:4)
      dps_hadron_pmom(kk+2,5)=0d0
      RETURN
    END SUBROUTINE pp_psipsipsi_dps_hadronmom

    SUBROUTINE cuts_Decay_pp_psipsipsi_dps(icut)
      ! only cut on the decay particles
      IMPLICIT NONE
      INTEGER,INTENT(OUT)::icut
      INTEGER::i,kk
      REAL(KIND(1d0))::eta,pt,c
      REAL(KIND(1d0))::ptminmuon
      INTEGER::flag
      INTEGER::muon4psiATLAS,nmuonpass1,nmuonpass2
      INCLUDE "stdhep_pp_psipsipsi_dps.inc"
      icut=0
      flag=0
      muon4psiATLAS=0
      nmuonpass1=0
      nmuonpass2=0
      DO i=1,NHEP_DPS
         IF(ISHEP_DPS(i).EQ.-1)CYCLE ! only cut on the final state
         IF(ISTHEP_DPS(i).EQ.1)CYCLE ! exclude the mother particles, which have been cutted before
         IF(JMOHEP_DPS(1,i).LE.0.OR.JMOHEP_DPS(1,i).GT.NHEP_DPS)CYCLE
         IF(ISTHEP_DPS(JMOHEP_DPS(1,i)).NE.1.OR.ISHEP_DPS(JMOHEP_DPS(1,i)).EQ.-1)CYCLE
         ! cut is only applied on the decay particles
         IF(lepton_pdg(IDHEP_DPS(i)))THEN
            ! cut on the leptons
            pt=SQRT(PHEP_DPS(1,i)**2+PHEP_DPS(2,i)**2)
            IF(pt.LT.ho_dptcl)THEN
               flag=1
               EXIT
            ENDIF
            eta=prapidity(PHEP_DPS(1:4,i))
            IF(ABS(eta).GT.ho_detacl)THEN
               flag=2
               EXIT
            ENDIF
            eta=rapidity(PHEP_DPS(1:4,i))
            IF(absrap)eta=ABS(eta)
            IF(eta.GT.ho_dycl.OR.eta.LT.ho_dycllow)THEN
               flag=3
               EXIT
            ENDIF
            IF(PHEP_DPS(4,i).LT.ho_decl)THEN
               flag=4
               EXIT
            ENDIF
            c=PHEP_DPS(3,i)/PHEP_DPS(4,i)
            IF(ABS(c).GT.ho_dcl)THEN
               flag=5
               EXIT
            ENDIF
            ! special cutoffs
            IF(literature_cutoffs.EQ.14062380)THEN
               ! DZero (arXiv:1406.2380) special cutoffs
               eta=prapidity(PHEP_DPS(1:4,i))
               IF(ABS(eta).LT.1.35d0)THEN
                  pt=SQRT(PHEP_DPS(1,i)**2+PHEP_DPS(2,i)**2)
                  IF(pt.LE.2d0)THEN
                     flag=6
                     EXIT
                  ENDIF
               ELSEIF(ABS(eta).LT.2d0.AND.ABS(eta).GT.1.35d0)THEN
                  IF(PHEP_DPS(4,i).LE.4d0)THEN
                     flag=7
                     EXIT
                  ENDIF
               ELSE
                  flag=8
                  EXIT
               ENDIF
            ELSEIF(literature_cutoffs.EQ.14060000)THEN
               ! ATLAS condition, speical cutoffs
               ! there is no arXiv number now
               ! At least one of the Jpsi must have two muons with pT>4 GeV each
               ! muon pT>2.5 GeV and muon |eta|<2.3
               eta=prapidity(PHEP_DPS(1:4,i))
               IF(ABS(eta).GE.2.3d0)THEN
                  flag=9
                  EXIT
               ENDIF
               pt=SQRT(PHEP_DPS(1,i)**2+PHEP_DPS(2,i)**2)
               IF(pt.LE.2.5d0)THEN
                  flag=10
                  EXIT
               ENDIF
               IF(IDHEP_DPS(JMOHEP_DPS(1,i)).EQ.443.AND.muon4psiATLAS.LT.2)THEN
                  IF(pt.GT.4d0)THEN
                     muon4psiATLAS=muon4psiATLAS+1
                  ELSE
                     muon4psiATLAS=muon4psiATLAS-1
                  ENDIF
               ENDIF
               IF(muon4psiATLAS.EQ.-2)muon4psiATLAS=0
            ELSEIF(literature_cutoffs.EQ.14070000)THEN
               ! CMS condition (from Junquan Tao for psi+psi)
               eta=prapidity(PHEP_DPS(1:4,i))
               IF(ABS(eta).LT.1.2d0)THEN
                  pt=SQRT(PHEP_DPS(1,i)**2+PHEP_DPS(2,i)**2)
                  IF(pt.LE.3.5d0)THEN
                     flag=12
                     EXIT
                  ENDIF
               ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.1.6d0)THEN
                  ptminmuon=3.5d0-(ABS(eta)-1.2d0)*1.5d0/0.4d0
                  pt=SQRT(PHEP_DPS(1,i)**2+PHEP_DPS(2,i)**2)
                  IF(pt.LE.ptminmuon)THEN
                     flag=13
                     EXIT
                  ENDIF
               ELSEIF(ABS(eta).GT.1.6d0.AND.ABS(eta).LT.2.4d0)THEN
                  pt=SQRT(PHEP_DPS(1,i)**2+PHEP_DPS(2,i)**2)
                  IF(pt.LE.2.0d0)THEN
                     flag=14
                     EXIT
                  ENDIF
               ELSE
                  flag=15
                  EXIT
               ENDIF
            ELSEIF(literature_cutoffs.EQ.15090000)THEN
               ! the fidicuial region for CMS from
               ! Ben Weinert
               ! follow http://arxiv.org/pdf/1406.0484
               ! 3 out of 4 muons have
               ! pT(mu) >3.5 GeV/c  if |eta(mu)|<1.2
               ! pT(mu) >3.5 --> 2.0 GeV/c if 1.2< |eta(mu)|<1.6 
               ! pT(mu) >2.0 GeV/c  if 1.6<|eta(mu)|<2.4
               ! The other muon has: 
               ! pT(mu) >3.0 GeV/c  if |eta(mu)|<1.2
               ! p(mu) >3.0 GeV/c  if 1.2<|eta(mu)|<2.4
               ! The J/psi cuts F.V.:
               ! pT(J/psi) > 6.5 GeV if |y(J/psi)|<1.2
               ! pT(J/psi) > 6.5 --> 4.5 GeV if   1.2<|y(J/psi)|<1.43
               ! pT(J/psi) > 4.5 GeV if   1.43<|y(J/psi)|<2.2
               IF(IDHEP_DPS(JMOHEP_DPS(1,i)).EQ.443)THEN
                  eta=prapidity(PHEP_DPS(1:4,i))
                  pt=SQRT(PHEP_DPS(1,i)**2+PHEP_DPS(2,i)**2)
                  ptminmuon=3.5d0-(ABS(eta)-1.2d0)*1.5d0/0.4d0
                  IF(ABS(eta).LT.1.2d0.AND.pt.GT.3.5d0)THEN
                     nmuonpass1=nmuonpass1+1
                  ELSEIF(ABS(eta).GT.1.6d0.AND.ABS(eta).LT.2.4d0&
                       .AND.pt.GT.2.0d0)THEN
                     nmuonpass1=nmuonpass1+1
                  ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.1.6d0&
                       .AND.pt.GT.ptminmuon)THEN
                     nmuonpass1=nmuonpass1+1
                  ELSEIF(ABS(eta).LT.1.2d0.AND.pt.GT.3.0d0)THEN
                     nmuonpass2=nmuonpass2+1
                  ELSEIF(ABS(eta).GT.1.2d0.AND.ABS(eta).LT.2.4d0)THEN
                     pt=SQRT(pt**2+PHEP_DPS(3,i)**2) ! it is p
                     IF(pt.GT.3d0)THEN
                        nmuonpass2=nmuonpass2+1
                     ENDIF
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
      ENDDO
      IF(flag.EQ.0.AND.literature_cutoffs.EQ.14060000)THEN
         ! ATLAS condition, speical cutoffs
         ! there is no arXiv number now
         ! At least one of the Jpsi must have two muons with pT>4 GeV each
         IF(muon4psiATLAS.LT.2)THEN
            flag=11
         ENDIF
      ELSEIF(flag.EQ.0.AND.literature_cutoffs.EQ.15090000)THEN
         IF(nmuonpass1.LT.3)THEN
            flag=12
         ELSEIF(nmuonpass1.EQ.3.AND.nmuonpass2.LT.1)THEN
            flag=13
         ENDIF
      ENDIF
      IF(flag.EQ.0)THEN
         icut=1
      ENDIF
      RETURN
    END SUBROUTINE cuts_Decay_pp_psipsipsi_dps

    SUBROUTINE unwei_procedure_pp_psiX_cb_DPS(w1,nwri,nwmax,nwarn)
      IMPLICIT NONE
      REAL(KIND(1d0)),INTENT(IN)::w1
      INTEGER,INTENT(INOUT)::nwri,nwmax,nwarn
      REAL(KIND(1d0)),DIMENSION(1)::ranr
      REAL(KIND=DBL)::vtime,vspin,scale1,scalup,xwgtup,px,py,pz,p0,pmass,umax,umax1
      INTEGER::init=0,i
      INTEGER::idup,idprup,istup,imothup1,imothup2,icol1,icol2
      LOGICAL::llwri
      SAVE init,umax,umax1
      IF(init.EQ.0)THEN
         umax=0d0
         umax1=0d0
         init=1
      ENDIF
      IF(lwmax.EQ.1)THEN
         IF(umax.LT.w1)THEN
            umax=w1
         ENDIF
         nwmax=nwmax+1
         umax1=umax
      ENDIF
      IF(lwmax.EQ.2)THEN
         IF(w1.GT.umax1)THEN
            umax1=w1
            WRITE(*,*)'WARNING:umax1,umax',umax1,umax
         ENDIF
         llwri=.FALSE.
         CALL RANDA(1,ranr)
         IF(umax*ranr(1).LT.w1)llwri=.TRUE.
         IF(umax.LT.w1)nwarn=nwarn+1
         IF(llwri)THEN
            nwri=nwri+1
            idprup=820 ! id for the process                                                                                 
            xwgtup=1 !w1*10**3 !1                                                                                          
            scalup=cb_pmom(3,1)**2+cb_pmom(3,2)**2+mpsi(1)**2
            scalup=DSQRT(scalup)
            WRITE(701)4,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
            DO i=1,4
               IF(i.NE.3)THEN
                  idup=pdgt(35)
               ELSE
                  idup=pdgt(iflh_dps(5+(nhad-2)))
               ENDIF
               IF(i.LE.2)THEN
                  istup=-1
               ELSE
                  istup=1
               ENDIF
               imothup1=0
               imothup2=0
               IF(i.EQ.3.OR.i.EQ.4)THEN
                  imothup1=1
                  imothup2=2
               ENDIF
               IF(i.LE.2)THEN
                  icol1=icol_un(i,1)+100
                  IF(icol1.EQ.100)icol1=0
                  icol2=icol_un(i,2)+100
                  IF(icol2.EQ.100)icol2=0
               ELSE
                  icol1=icol_un(i,2)+100
                  IF(icol1.EQ.100)icol1=0
                  icol2=icol_un(i,1)+100
                  IF(icol2.EQ.100)icol2=0
               ENDIF
               px=cb_hadron_pmom(i,1)
               py=cb_hadron_pmom(i,2)
               pz=cb_hadron_pmom(i,3)
               p0=cb_hadron_pmom(i,4)
               pmass=cb_hadron_pmom(i,5)
               vtime=0
               vspin=9

               WRITE(701)idup,istup,imothup1,imothup2,icol1,icol2&
                    ,px,py,pz,p0,pmass,vtime,vspin
            ENDDO
         ENDIF
      ENDIF
      Nevents=nwri
    END SUBROUTINE unwei_procedure_pp_psiX_cb_DPS

    SUBROUTINE unwei_procedure_pp_psipsipsi_dps(w1,nwri,nwmax,nwarn)
      IMPLICIT NONE
      REAL(KIND(1d0)),INTENT(IN)::w1
      INTEGER,INTENT(INOUT)::nwri,nwmax,nwarn
      REAL(KIND(1d0)),DIMENSION(1)::ranr
      REAL(KIND=DBL)::vtime,vspin,scale1,scalup,xwgtup,px,py,pz,p0,pmass,umax,umax1
      INTEGER::init=0,i,j,iij
      INTEGER::idup,idprup,istup,imothup1,imothup2,icol1,icol2
      LOGICAL::llwri
      SAVE init,umax,umax1
      IF(init.EQ.0)THEN
         umax=0d0
         umax1=0d0
         init=1
      ENDIF
      IF(lwmax.EQ.1)THEN
         IF(umax.LT.w1)THEN
            umax=w1
         ENDIF
         nwmax=nwmax+1
         umax1=umax
      ENDIF
      IF(lwmax.EQ.2)THEN
         IF(w1.GT.umax1)THEN
            umax1=w1
            WRITE(*,*)'WARNING:umax1,umax',umax1,umax
         ENDIF
         llwri=.FALSE.
         CALL RANDA(1,ranr)
         IF(umax*ranr(1).LT.w1)llwri=.TRUE.
         IF(umax.LT.w1)nwarn=nwarn+1
         IF(llwri)THEN
            nwri=nwri+1
            IF(NDecayChains_DPS.GT.0)THEN
               CALL unwei_writer_Decay_pp_psipsipsi_dps
               Nevents=nwri
               RETURN
            ENDIF
            idprup=90 ! id for the process 
            xwgtup=1 !w1*10**3 !1  
            scalup=dps_pmom(2,3,1)**2+dps_pmom(2,3,2)**2+mpsi(1)**2
            scalup=DSQRT(scalup)
            WRITE(nunit3)nhad_dps,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
            DO i=1,nhad_dps
               idup=pdgt(iflh_dps(i))
               IF(i.LE.4)THEN
                  istup=-1
               ELSE
                  istup=1
               ENDIF
               imothup1=0
               imothup2=0
               IF(i.GT.4.AND.i.LE.nhad+2)THEN
                  imothup1=1
                  imothup2=2
               ELSEIF(i.GT.nhad+2.AND.i.LE.nhad+4)THEN
                  imothup1=3
                  imothup2=4
               ENDIF
               IF(i.LE.4)THEN
                  icol1=icol_un(i,1)+100
                  IF(icol1.EQ.100)icol1=0
                  icol2=icol_un(i,2)+100
                  IF(icol2.EQ.100)icol2=0
               ELSE
                  icol1=icol_un(i,2)+100
                  IF(icol1.EQ.100)icol1=0
                  icol2=icol_un(i,1)+100
                  IF(icol2.EQ.100)icol2=0
               ENDIF
               px=dps_hadron_pmom(i,1)
               py=dps_hadron_pmom(i,2)
               pz=dps_hadron_pmom(i,3)
               p0=dps_hadron_pmom(i,4)
               pmass=dps_hadron_pmom(i,5)
               vtime=0
               vspin=9

               WRITE(nunit3)idup,istup,imothup1,imothup2,icol1,icol2&
                    ,px,py,pz,p0,pmass,vtime,vspin
            ENDDO
            IF(reweight_scale)THEN
               iij=0
               DO i=1,3
                  DO j=1,3
                     iij=iij+1
                     rwgt_values(iij)=wgtxsecmu(i,j)*XWGTUP
                  ENDDO
               ENDDO
               IF(iij.NE.tot_nrwgt)THEN
                  WRITE(*,*)"ERROR:inconsistence for the reweigts #0 !"
                  WRITE(*,*)"tot_nrwgt=",tot_nrwgt
                  WRITE(*,*)"couting nrwgt=",iij
                  STOP
               ENDIF
               WRITE(nunit30)(rwgt_values(i),i=1,tot_nrwgt)
            ENDIF
         ENDIF
      ENDIF
      Nevents=nwri
    END SUBROUTINE unwei_procedure_pp_psipsipsi_dps

    SUBROUTINE unwei_writer_Decay_pp_psipsipsi_dps
      IMPLICIT NONE
      INCLUDE "stdhep_pp_psipsipsi_dps.inc"
      INTEGER::icol1,icol2,idup,idprup,istup,imothup1,imothup2
      REAL(KIND(1d0))::px,py,pz,p0,pmass,scalup,vtime,vspin,xwgtup
      INTEGER::i,j,iij
      idprup = 90
      xwgtup=1
      scalup=dps_pmom(2,3,1)**2+dps_pmom(2,3,2)**2+mpsi(1)**2
      scalup=DSQRT(scalup)
      WRITE(nunit3)NHEP_DPS,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
      DO i=1,NHEP_DPS
         idup=IDHEP_DPS(i)
         istup=ISHEP_DPS(i)
         IF(ISTHEP_DPS(i).EQ.1.AND.ISHEP_DPS(i).EQ.1)THEN
            istup=2
         ENDIF
         imothup1=JMOHEP_DPS(1,i)
         imothup2=JMOHEP_DPS(2,i)
         IF(i.GT.nhad_dps)THEN
            ! no hadronic decay
            icol1=0
            icol2=0
         ELSE
            IF(istup.LT.0)THEN
               icol1=icol_un(i,1)+100
               IF(icol1.EQ.100)icol1=0
               icol2=icol_un(i,2)+100
               IF(icol2.EQ.100)icol2=0
            ELSE
               icol1=icol_un(i,2)+100
               IF(icol1.EQ.100)icol1=0
               icol2=icol_un(i,1)+100
               IF(icol2.EQ.100)icol2=0
            ENDIF
         ENDIF
         px=PHEP_DPS(1,i)
         py=PHEP_DPS(2,i)
         pz=PHEP_DPS(3,i)
         p0=PHEP_DPS(4,i)
         pmass=PHEP_DPS(5,i)
         vtime=0
         vspin=9
         WRITE(nunit3)idup,istup,imothup1,imothup2,icol1,icol2,&
              px,py,pz,p0,pmass,vtime,vspin
      ENDDO
      IF(reweight_scale)THEN
         iij=0
         DO i=1,3
            DO j=1,3
               iij=iij+1
               rwgt_values(iij)=wgtxsecmu(i,j)*XWGTUP
            ENDDO
         ENDDO
         IF(iij.NE.tot_nrwgt)THEN
            WRITE(*,*)"ERROR:inconsistence for the reweigts #1 !"
            WRITE(*,*)"tot_nrwgt=",tot_nrwgt
            WRITE(*,*)"couting nrwgt=",iij
            STOP
         ENDIF
         WRITE(nunit30)(rwgt_values(i),i=1,tot_nrwgt)
      ENDIF
    END SUBROUTINE unwei_writer_Decay_pp_psipsipsi_dps

    SUBROUTINE Get_unweightevents_pp_psiX_cb_DPS(n1,nevent,icase)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::n1,nevent,icase
      CHARACTER(len=24),PARAMETER::tmp_dir="./tmp/",output_dir="./output/"
      INTEGER::i,nunit4,nunit5,nunit3
      INTEGER::istop,k
      REAL(KIND(1d0))::p0,px,py,pz,SPINUP,EBMUP1,EBMUP2,XSECUP1,XSECUP2,XERRUP1,XMAXUP1,&
           XWGTUP,VTIMUP,SCALUP,PM0,AQEDUP,AQCDUP,XWGTUP2
      INTEGER::IDBMUP1,IDBMUP2,IDWTUP,NPRUP,IDPRUP,NUP,IDUP,ISTUP,IMOTHUP1,IMOTHUP2,&
           ICOLUP1,ICOLUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,LPRUP1
      CLOSE(701)
      OPEN(701,FILE=TRIM(tmp_dir)//'even_pp_psiX_cb_dps.out',FORM='unformatted')
      CLOSE(700)
      OPEN(700,FILE=TRIM(tmp_dir)//'sample_pp_psiX_cb_dps.init')
      READ(700,*)IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
      READ(700,*)XSECUP1,XERRUP1,XMAXUP1,LPRUP1
      Nevent_pp_psiX_CB=nevent
      ALLOCATE(pmom_pp_psiX_CB(nevent,4,4))
      sigma_pp_psiX_CB=XSECUP1/1d3 ! from pb to nb
      istop=1
      k=0
      DO WHILE(istop.EQ.1)
         k=k+1
         READ(701,END=188) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
         IF(k.GT.nevent)THEN
            WRITE(*,*)"ERROR: the number of unweighted events nevent is wrong !"
            STOP
         ENDIF
         DO i=1,NUP
            READ(701)IDUP,ISTUP,iMOTHUP1,iMOTHUP2,ICOLUP1,ICOLUP2,px,py,pz,p0,pm0,VTIMUP,SPINUP
            pmom_pp_psiX_CB(k,i,1)=px
            pmom_pp_psiX_CB(k,i,2)=py
            pmom_pp_psiX_CB(k,i,3)=pz
            pmom_pp_psiX_CB(k,i,4)=p0
         ENDDO
      ENDDO
188   CONTINUE
      CLOSE(701,STATUS='delete')
      CLOSE(700,STATUS='delete')
8200  FORMAT(1P,2I6,4E14.6)
8300  FORMAT(1P,I8,5I5,5E18.10,E14.6,E12.4)
8000  FORMAT(1P,2I8,2E14.6,6I8)
8100  FORMAT(1P,3E20.10,I6)
    END SUBROUTINE Get_unweightevents_pp_psiX_cb_DPS

    SUBROUTINE Generate_lhe_pp_psipsipsi_dps(n1,nevent,icase)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::n1,nevent,icase
      CHARACTER(len=24),PARAMETER::tmp_dir="./tmp/",output_dir="./output/"
      INTEGER::i,jj,nunit4,nunit5,nunit3,nunit30
      INTEGER,DIMENSION(:),ALLOCATABLE::rwgt_ids
      REAL(KIND(1d0)),DIMENSION(:),ALLOCATABLE::rwgt_vals
      REAL(KIND(1d0)),DIMENSION(3)::Rscaleupdown,Fscaleupdown
      INTEGER::istop,k
      REAL(KIND(1d0))::p0,px,py,pz,SPINUP,EBMUP1,EBMUP2,XSECUP1,XSECUP2,XERRUP1,XMAXUP1,&
           XWGTUP,VTIMUP,SCALUP,PM0,AQEDUP,AQCDUP,XWGTUP2
      INTEGER::IDBMUP1,IDBMUP2,IDWTUP,NPRUP,IDPRUP,NUP,IDUP,ISTUP,IMOTHUP1,IMOTHUP2,&
           ICOLUP1,ICOLUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,LPRUP1
      INTEGER::ipip,used_lhever
      INTEGER::irwgt=0,irwgt2
      REAL(KIND(1d0))::xxwgt_old
      used_lhever=3
      nunit3=30
      CLOSE(nunit3)
      OPEN(nunit3,FILE=TRIM(tmp_dir)//'even_pp_psipsipsi_dps.out',FORM='unformatted')
      IF(reweight_scale)THEN
         nunit30=300
         CLOSE(nunit30)
         OPEN(nunit30,FILE=TRIM(tmp_dir)//'even_rwgt_pp_psipsipsi_dps.out',FORM='unformatted')
      ENDIF
      nunit4=31
      CLOSE(nunit4)
      OPEN(nunit4,FILE=TRIM(tmp_dir)//'sample_pp_psipsipsi_dps.init')
      nunit5=32
      CLOSE(nunit5)
      OPEN(nunit5,FILE=TRIM(output_dir)//'sample_pp_psipsipsi_dps.lhe')
      WRITE(nunit5,'(A)') '<LesHouchesEvents version="3.0">'
      WRITE(nunit5,'(A)') '<!--'
      WRITE(nunit5,'(A)') 'File generated with HELAC-ONIA '
      WRITE(nunit5,'(A)') '-->'
      IF(reweight_scale)THEN
         irwgt=0
         irwgt=irwgt+9
         IF(ALLOCATED(rwgt_ids))THEN
            DEALLOCATE(rwgt_ids)
         ENDIF
         ALLOCATE(rwgt_ids(irwgt))
         IF(ALLOCATED(rwgt_vals))THEN
            DEALLOCATE(rwgt_vals)
         ENDIF
         ALLOCATE(rwgt_vals(irwgt))
         WRITE(nunit5,'(A)') '  <header>'
         WRITE(nunit5,'(A)') '  <initrwgt>'
         irwgt2=0
         WRITE(nunit5,'(A)') "    <weightgroup type='scale_variation' combine='envelope'>"
         Rscaleupdown(1)=1d0
         Rscaleupdown(2)=rw_RScale_up
         Rscaleupdown(3)=rw_RScale_down
         Fscaleupdown(1)=1d0
         Fscaleupdown(2)=rw_FScale_up
         Fscaleupdown(3)=rw_FScale_down
         k=1000
         DO i=1,3
            DO jj=1,3
               k=k+1
               irwgt2=irwgt2+1
               rwgt_ids(irwgt2)=k
               WRITE(nunit5,6100)k,Rscaleupdown(i),Fscaleupdown(jj)
            ENDDO
         ENDDO
         WRITE(nunit5,'(A)') "    </weightgroup>"
         WRITE(nunit5,'(A)') '  </initrwgt>'
         WRITE(nunit5,'(A)') '  </header>'
         IF(irwgt2.NE.irwgt)THEN
            WRITE(*,*)"ERROR:inconsistece of the number of reweights"
            WRITE(*,*)"irwgt=",irwgt
            WRITE(*,*)"irwgt2=",irwgt2
            STOP
         ENDIF
      ENDIF
      WRITE(nunit5,'(A)') '<init>'
      READ(nunit4,*)IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
      READ(nunit4,*)XSECUP1,XERRUP1,XMAXUP1,LPRUP1
      WRITE(nunit5,5000)IDBMUP1,IDBMUP2,EBMUP1,EBMUP2,iPDFGUP1,iPDFGUP2,iPDFSUP1,iPDFSUP2,IDWTUP,NPRUP
      WRITE(nunit5,5100)XSECUP1,XERRUP1,XMAXUP1,LPRUP1
      WRITE(nunit5,'(A)') '</init>'
      istop=1
      k=0
      XWGTUP2=XSECUP1/nevent
      DO WHILE(istop.EQ.1)
         k=k+1
         READ(nunit3,END=100) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
         IF(icase.EQ.1)XWGTUP=XWGTUP2
         WRITE(nunit5,'(A)') '<event>'
         WRITE(nunit5,5200) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
         ipip=1
         DO i=1,NUP
            READ(nunit3)IDUP,ISTUP,iMOTHUP1,iMOTHUP2,ICOLUP1,ICOLUP2,px,py,pz,p0,pm0,VTIMUP,SPINUP
            IF(IDUP.EQ.443.OR.IDUP.EQ.553)THEN
               IF(ipip.GT.3)THEN
                  WRITE(*,*)"ERROR:Too many psi(Upsilon) found (>3) !"
                  STOP
               ENDIF
               IF(ipip.GT.2)THEN
                  IF(dps_istate(2).EQ.2)THEN
                     IDUP=100443 ! psi(2S)
                  ELSEIF(dps_istate(2).EQ.4)THEN
                     IDUP=100553 ! Y(2S)
                  ELSEIF(dps_istate(2).EQ.5)THEN
                     IDUP=200553 ! Y(3S)
                  ENDIF
               ENDIF
               ipip=ipip+1
            ENDIF
            WRITE(nunit5,5300)IDUP,ISTUP,iMOTHUP1,iMOTHUP2,ICOLUP1,ICOLUP2,px,py,pz,p0,pm0,VTIMUP,SPINUP
         ENDDO
         IF(irwgt.GT.0.AND.reweight_scale)THEN
            ! filling the rwgt
            WRITE(nunit5,'(A)') '  <rwgt>'
            READ(nunit30)(rwgt_vals(i),i=1,irwgt)
            IF(icase.EQ.1)THEN
               xxwgt_old=rwgt_vals(1)
               IF(xxwgt_old.EQ.0d0)THEN
                  xxwgt_old=1d0
               ENDIF
               DO i=1,irwgt
                  rwgt_vals(i)=rwgt_vals(i)*XWGTUP2/xxwgt_old
               ENDDO
            ENDIF
            DO i=1,irwgt
               WRITE(nunit5,6300)rwgt_ids(i),rwgt_vals(i)
            ENDDO
            WRITE(nunit5,'(A)') '  </rwgt>'
         ENDIF
         WRITE(nunit5,'(A)') '</event>'
      ENDDO
100   CONTINUE
      IF(icase.EQ.1.AND.k.NE.nevent+1)THEN
         WRITE(*,*)"WARNING:mismatching of the unweighted lhe events number ",k-1,nevent
      ENDIF
      WRITE(nunit5,'(A)') '</LesHouchesEvents>'
      CLOSE(nunit3,STATUS='delete')
      CLOSE(nunit4,STATUS='delete')
5200  FORMAT(1P,2I6,4E14.6)
5300  FORMAT(1P,I8,5I5,5E18.10,E14.6,E12.4)
5000  FORMAT(1P,2I8,2E14.6,6I8)
5100  FORMAT(1P,3E20.10,I6)
      CLOSE(nunit5,STATUS='keep')
6100  FORMAT(6x,"<weight id='",I4,"'>",1x,&
           "muR=",E11.5,1x,"muF=",E11.5,1x,'</weight>')
6300  FORMAT(4x,"<wgt id='",I4,"'>",1x,&
           E11.5,1x,"</wgt>")
    END SUBROUTINE Generate_lhe_pp_psipsipsi_dps

    SUBROUTINE generate_phi_DPS(itype,Q,mi,mres,phi0,pt,xr,phi,wgt,lflag)
      IMPLICIT NONE
      INTEGER,INTENT(IN)::itype
      REAL(KIND(1d0)),INTENT(IN)::Q,pt,mi,mres,phi0,xr
      REAL(KIND(1d0)),INTENT(OUT)::phi,wgt
      LOGICAL,INTENT(OUT)::lflag
      REAL(KIND(1d0)),PARAMETER::pi=3.141592653589793d0
      REAL(KIND(1d0))::cosphimin,acos1,acos2
      lflag=.TRUE.
      IF(Q-mi-mres.LT.0d0)THEN
         lflag=.FALSE.
         wgt=0d0
         phi=0d0
         RETURN
      ENDIF
      IF(itype.EQ.0)THEN
         ! i<n-1, Q -> ki+Q2, mres<Q2<(Q-mi)
         IF(mi*pt.LE.0d0)THEN
            wgt=2*pi
            phi=wgt*xr
         ELSE
            cosphimin=((Q-mi)**2-mres**2)*Q/(2d0*mi*pt**2)
            IF(cosphimin.GT.2d0)THEN
               wgt=2*pi
               phi=wgt*xr
            ELSE
               cosphimin=1d0-cosphimin
               wgt=DACOS(cosphimin)
               phi=wgt*(2d0*xr-1d0)+phi0
               wgt=2d0*wgt
            ENDIF
         ENDIF
      ELSEIF(itype.EQ.1)THEN
         ! i=n-1, Q -> kn-1+kn, mres =mn
         IF(pt*mi.LE.0d0)THEN
            wgt=2*pi
            phi=wgt*xr
         ELSE
            cosphimin=DMAX1(-lamda_func(Q**2+pt**2,mi**2,mres**2+pt**2)/(4d0*mi**2*pt**2),0d0)
            cosphimin=DSQRT(cosphimin)
            acos1=DACOS(cosphimin)
            acos2=DACOS(-cosphimin)
            phi=unit_step(0.5d0-xr)*(4d0*acos1*xr-acos1)&
                 +unit_step(xr-0.5d0)*(2d0*(pi-acos2)*(2d0*xr-1d0)+acos2)+phi0
            wgt=unit_step(0.5d0-xr)*(4d0*acos1)&
                 +unit_step(xr-0.5d0)*(4d0*(pi-acos2))
         ENDIF
      ELSE
         WRITE(*,*)"Wrong itype(0 or 1) in generate_phi_DPS ",itype
         STOP
      ENDIF
      RETURN
    END SUBROUTINE generate_phi_DPS

    SUBROUTINE generate_pt_DPS(Q,mi,mres,phi0,phi,pt,xr,ptc,pti,wgt,lflag)
      IMPLICIT NONE
      REAL(KIND(1d0)),INTENT(IN)::Q,pt,mi,mres,phi0,phi,xr,ptc ! ptc is the pt cut
      REAL(KIND(1d0)),INTENT(OUT)::pti,wgt
      LOGICAL,INTENT(OUT)::lflag
      REAL(KIND(1d0))::a,b,c,cosphi,delta,ptmax,ptmin
      lflag=.TRUE.
      cosphi=DCOS(phi-phi0)
      a=4d0*(Q**2+pt**2-cosphi**2*pt**2)
      b=-4d0*cosphi*pt*(Q**2+mi**2-mres**2)
      c=-lamda_func(Q**2+pt**2,mi**2,mres**2+pt**2)
      delta=b**2-4d0*a*c
      IF(delta.LT.0d0)THEN
         lflag=.FALSE.
         pti=0d0
         wgt=0d0
         RETURN
      ENDIF
      ptmax=(-b+DSQRT(delta))/(2d0*a)
      ptmin=DMAX1((-b-DSQRT(delta))/(2d0*a),0d0)
      ptmin=DMAX1(ptmin,ptc) ! cut impose
      IF(ptmax.LT.ptmin)THEN
         lflag=.FALSE.
         pti=0d0
         wgt=0d0
         RETURN
      ENDIF
      wgt=ptmax-ptmin
      pti=wgt*xr+ptmin
      RETURN
    END SUBROUTINE generate_pt_DPS

    SUBROUTINE generate_yi_DPS(Q,mi,mres,phi0,phi,pt,pti,y0,xr,ycmax,ycmin,&
         yi,wgt,lflag)
      ! generate yi for i<=n-1, Q -> ki+Q2, mres<Q2<(Q-mi) and Q2=mn**2
      IMPLICIT NONE
      REAL(KIND(1d0)),INTENT(IN)::Q,mi,mres,phi0,phi,pt,pti,y0,xr,ycmax,ycmin
      REAL(KIND(1d0)),INTENT(OUT)::yi,wgt
      LOGICAL,INTENT(OUT)::lflag
      REAL(KIND(1d0))::lh,mti,ymin,ymax,ypmin,ypmax,ymmin,ymmax
      lflag=.TRUE.
      mti=DSQRT(mi**2+pti**2)
      IF(mti.LE.0d0)THEN
         lflag=.FALSE.
         yi=0d0
         wgt=0d0
         RETURN
      ENDIF
      lh=Q**2+mi**2-mres**2+2d0*pt*pti*DCOS(phi-phi0)
      lh=lh/(2d0*DSQRT(Q**2+pt**2)*mti)
      IF(lh.LT.1d0)THEN
         lflag=.FALSE.
         yi=0d0
         wgt=0d0
         RETURN
      ENDIF
      ymin=ACosh_p(lh)
      ymax=ymin+y0
      ymin=-ymin+y0
      IF(absrap)THEN
         IF(ymax.LE.0d0)THEN
            ! MAX(ymin,-ABS(ycmax))<yi<MIN(ymax,-ABS(ycmin))
            ymmin=DMAX1(ymin,-ABS(ycmax))
            ymmax=DMIN1(ymax,-ABS(ycmin))
            IF(ymmax.LT.ymmin)THEN
               lflag=.FALSE.
               yi=0d0
               wgt=0d0
               RETURN
            ENDIF
            wgt=ymmax-ymmin
            yi=wgt*xr+ymmin
         ELSEIF(ymin.GE.0d0)THEN
            ! MAX(ymin,ABS(ycmin))<yi<MIN(ymax,ABS(ycmax))
            ypmin=DMAX1(ymin,ABS(ycmin))
            ypmax=DMIN1(ymax,ABS(ycmax))
            IF(ypmax.LT.ypmin)THEN
               lflag=.FALSE.
               yi=0d0
               wgt=0d0
               RETURN
            ENDIF
            wgt=ypmax-ypmin
            yi=wgt*xr+ypmin
         ELSE ! ymin<0,ymax>0
            ! MAX(ymin,-ABS(ycmax))<yi<MIN(0d0,-ABS(ycmin)) or
            ! MAX(0d0,ABS(ycmin))<yi<MIN(ymax,ABS(ycmax))
            ypmin=DMAX1(0d0,ABS(ycmin))
            ypmax=DMIN1(ymax,ABS(ycmax))
            ymmin=DMAX1(ymin,-ABS(ycmax))
            ymmax=DMIN1(0d0,-ABS(ycmin))
            IF(ymmax.LT.ymmin.AND.ypmax.LT.ypmin)THEN
               lflag=.FALSE.
               yi=0d0
               wgt=0d0
               RETURN
            ENDIF
            IF(ymmax.LT.ymmin)THEN
               wgt=ypmax-ypmin
               yi=wgt*xr+ypmin
            ELSEIF(ypmax.LT.ypmin)THEN
               wgt=ymmax-ymmin
               yi=wgt*xr+ymmin
            ELSE
               yi=unit_step(0.5d0-xr)*(2d0*xr*(ymmax-ymmin)+ymmin)&
                    +unit_step(xr-0.5d0)*((2d0*xr-1d0)*(ypmax-ypmin)+ypmin)
               wgt=unit_step(0.5d0-xr)*2d0*(ymmax-ymmin)&
                    +unit_step(xr-0.5d0)*2d0*(ypmax-ypmin)
            ENDIF
         ENDIF
      ELSE
         ymax=MIN(ymax,ycmax)
         ymin=MAX(ymin,ycmin)
         IF(ymax.LT.ymin)THEN
            lflag=.FALSE.
            yi=0d0
            wgt=0d0
            RETURN
         ENDIF
         wgt=ymax-ymin
         yi=wgt*xr+ymin
      ENDIF
      RETURN
    END SUBROUTINE GENERATE_YI_DPS

    SUBROUTINE generate_yn_DPS(rlogmax,rlogmin,xr,ycmax,ycmin,yn,wgt,lflag)
      ! generate yn for Q -> kn-1,kn within rlogmin<yn<rlogmax
      IMPLICIT NONE
      REAL(KIND(1d0)),INTENT(IN)::rlogmax,rlogmin,xr,ycmax,ycmin ! ycmax,ycmin is the cut of yn
      REAL(KIND(1d0)),INTENT(OUT)::yn,wgt
      LOGICAL,INTENT(OUT)::lflag
      REAL(KIND(1d0))::ypmin,ypmax,ymmin,ymmax
      lflag=.TRUE.
      IF(rlogmax.LT.rlogmin.OR.ycmax.LT.ycmin)THEN
         lflag=.FALSE.
         yn=0d0
         wgt=0d0
         RETURN
      ENDIF
      IF(absrap)THEN
         IF(rlogmax.LE.0d0)THEN
            ! MAX(rlogmin,-ABS(ycmax))<yn<MIN(rlogmax,-ABS(ycmin))
            ymmin=DMAX1(rlogmin,-ABS(ycmax))
            ymmax=DMIN1(rlogmax,-ABS(ycmin))
            IF(ymmax.LT.ymmin)THEN
               lflag=.FALSE.
               yn=0d0
               wgt=0d0
               RETURN
            ENDIF
            wgt=ymmax-ymmin
            yn=wgt*xr+ymmin
         ELSEIF(rlogmin.GE.0d0)THEN
            ! MAX(rlogmin,ABS(ycmin))<yn<MIN(rlogmax,ABS(ycmax))
            ypmin=DMAX1(rlogmin,ABS(ycmin))
            ypmax=DMIN1(rlogmax,ABS(ycmax))
            IF(ypmax.LT.ypmin)THEN
               lflag=.FALSE.
               yn=0d0
               wgt=0d0
               RETURN
            ENDIF
            wgt=ypmax-ypmin
            yn=wgt*xr+ypmin
         ELSE ! rlogmin<0 and rlogmax > 0
            ! MAX(rlogmin,-ABS(ycmax))<yn<MIN(0d0,-ABS(ycmin)) or
            ! MAX(0d0,ABS(ycmin))<yn<MIN(rlogmax,ABS(ycmax))
            ypmin=DMAX1(ABS(ycmin),0d0)
            ypmax=DMIN1(rlogmax,ABS(ycmax))
            ymmin=DMAX1(rlogmin,-ABS(ycmax))
            ymmax=DMIN1(0d0,-ABS(ycmin))
            IF(ymmax.LT.ymmin.AND.ypmax.LT.ypmin)THEN
               lflag=.FALSE.
               yn=0d0
               wgt=0d0
               RETURN
            ENDIF
            IF(ymmax.LT.ymmin)THEN
               wgt=ypmax-ypmin
               yn=wgt*xr+ypmin
            ELSEIF(ypmax.LT.ypmin)THEN
               wgt=ymmax-ymmin
               yn=wgt*xr+ymmin
            ELSE
               yn=unit_step(0.5d0-xr)*(2d0*xr*(ymmax-ymmin)+ymmin)&
                    +unit_step(xr-0.5d0)*((2d0*xr-1d0)*(ypmax-ypmin)+ypmin)
               wgt=unit_step(0.5d0-xr)*2d0*(ymmax-ymmin)&
                    +unit_step(xr-0.5d0)*2d0*(ypmax-ypmin)
            ENDIF
         ENDIF
      ELSE
         ypmin=DMAX1(rlogmin,ycmin)
         ypmax=DMIN1(rlogmax,ycmax)
         IF(ypmin.GT.ypmax)THEN
            lflag=.FALSE.
            yn=0d0
            wgt=0d0
            RETURN
         ENDIF
         wgt=ypmax-ypmin
         yn=wgt*xr+ypmin
      ENDIF
      RETURN
    END SUBROUTINE generate_yn_DPS
END MODULE pp_psipsipsi_DPS
